#ifdef GET_RISCVVIntrinsicsTable_DECL
const RISCVVIntrinsicInfo *getRISCVVIntrinsicInfo(unsigned IntrinsicID);
#endif

#ifdef GET_RISCVVIntrinsicsTable_IMPL
constexpr RISCVVIntrinsicInfo RISCVVIntrinsicsTable[] = {
  { Intrinsic::riscv_vaadd, 0x2 }, // 0
  { Intrinsic::riscv_vaadd_mask, 0x3 }, // 1
  { Intrinsic::riscv_vaaddu, 0x2 }, // 2
  { Intrinsic::riscv_vaaddu_mask, 0x3 }, // 3
  { Intrinsic::riscv_vadc, 0x2 }, // 4
  { Intrinsic::riscv_vadd, 0x2 }, // 5
  { Intrinsic::riscv_vadd_mask, 0x3 }, // 6
  { Intrinsic::riscv_vamoadd, 0x0 }, // 7
  { Intrinsic::riscv_vamoadd_mask, 0x0 }, // 8
  { Intrinsic::riscv_vamoand, 0x0 }, // 9
  { Intrinsic::riscv_vamoand_mask, 0x0 }, // 10
  { Intrinsic::riscv_vamomax, 0x0 }, // 11
  { Intrinsic::riscv_vamomax_mask, 0x0 }, // 12
  { Intrinsic::riscv_vamomaxu, 0x0 }, // 13
  { Intrinsic::riscv_vamomaxu_mask, 0x0 }, // 14
  { Intrinsic::riscv_vamomin, 0x0 }, // 15
  { Intrinsic::riscv_vamomin_mask, 0x0 }, // 16
  { Intrinsic::riscv_vamominu, 0x0 }, // 17
  { Intrinsic::riscv_vamominu_mask, 0x0 }, // 18
  { Intrinsic::riscv_vamoor, 0x0 }, // 19
  { Intrinsic::riscv_vamoor_mask, 0x0 }, // 20
  { Intrinsic::riscv_vamoswap, 0x0 }, // 21
  { Intrinsic::riscv_vamoswap_mask, 0x0 }, // 22
  { Intrinsic::riscv_vamoxor, 0x0 }, // 23
  { Intrinsic::riscv_vamoxor_mask, 0x0 }, // 24
  { Intrinsic::riscv_vand, 0x2 }, // 25
  { Intrinsic::riscv_vand_mask, 0x3 }, // 26
  { Intrinsic::riscv_vasub, 0x2 }, // 27
  { Intrinsic::riscv_vasub_mask, 0x3 }, // 28
  { Intrinsic::riscv_vasubu, 0x2 }, // 29
  { Intrinsic::riscv_vasubu_mask, 0x3 }, // 30
  { Intrinsic::riscv_vcompress, 0x0 }, // 31
  { Intrinsic::riscv_vdiv, 0x2 }, // 32
  { Intrinsic::riscv_vdiv_mask, 0x3 }, // 33
  { Intrinsic::riscv_vdivu, 0x2 }, // 34
  { Intrinsic::riscv_vdivu_mask, 0x3 }, // 35
  { Intrinsic::riscv_vfadd, 0x2 }, // 36
  { Intrinsic::riscv_vfadd_mask, 0x3 }, // 37
  { Intrinsic::riscv_vfclass, 0x0 }, // 38
  { Intrinsic::riscv_vfclass_mask, 0x0 }, // 39
  { Intrinsic::riscv_vfcvt_f_x_v, 0x0 }, // 40
  { Intrinsic::riscv_vfcvt_f_x_v_mask, 0x0 }, // 41
  { Intrinsic::riscv_vfcvt_f_xu_v, 0x0 }, // 42
  { Intrinsic::riscv_vfcvt_f_xu_v_mask, 0x0 }, // 43
  { Intrinsic::riscv_vfcvt_rtz_x_f_v, 0x0 }, // 44
  { Intrinsic::riscv_vfcvt_rtz_x_f_v_mask, 0x0 }, // 45
  { Intrinsic::riscv_vfcvt_rtz_xu_f_v, 0x0 }, // 46
  { Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask, 0x0 }, // 47
  { Intrinsic::riscv_vfcvt_x_f_v, 0x0 }, // 48
  { Intrinsic::riscv_vfcvt_x_f_v_mask, 0x0 }, // 49
  { Intrinsic::riscv_vfcvt_xu_f_v, 0x0 }, // 50
  { Intrinsic::riscv_vfcvt_xu_f_v_mask, 0x0 }, // 51
  { Intrinsic::riscv_vfdiv, 0x2 }, // 52
  { Intrinsic::riscv_vfdiv_mask, 0x3 }, // 53
  { Intrinsic::riscv_vfirst, 0x0 }, // 54
  { Intrinsic::riscv_vfirst_mask, 0x0 }, // 55
  { Intrinsic::riscv_vfmacc, 0x2 }, // 56
  { Intrinsic::riscv_vfmacc_mask, 0x2 }, // 57
  { Intrinsic::riscv_vfmadd, 0x2 }, // 58
  { Intrinsic::riscv_vfmadd_mask, 0x2 }, // 59
  { Intrinsic::riscv_vfmax, 0x2 }, // 60
  { Intrinsic::riscv_vfmax_mask, 0x3 }, // 61
  { Intrinsic::riscv_vfmerge, 0x2 }, // 62
  { Intrinsic::riscv_vfmin, 0x2 }, // 63
  { Intrinsic::riscv_vfmin_mask, 0x3 }, // 64
  { Intrinsic::riscv_vfmsac, 0x2 }, // 65
  { Intrinsic::riscv_vfmsac_mask, 0x2 }, // 66
  { Intrinsic::riscv_vfmsub, 0x2 }, // 67
  { Intrinsic::riscv_vfmsub_mask, 0x2 }, // 68
  { Intrinsic::riscv_vfmul, 0x2 }, // 69
  { Intrinsic::riscv_vfmul_mask, 0x3 }, // 70
  { Intrinsic::riscv_vfmv_f_s, 0x0 }, // 71
  { Intrinsic::riscv_vfmv_s_f, 0x0 }, // 72
  { Intrinsic::riscv_vfmv_v_f, 0x0 }, // 73
  { Intrinsic::riscv_vfncvt_f_f_w, 0x0 }, // 74
  { Intrinsic::riscv_vfncvt_f_f_w_mask, 0x0 }, // 75
  { Intrinsic::riscv_vfncvt_f_x_w, 0x0 }, // 76
  { Intrinsic::riscv_vfncvt_f_x_w_mask, 0x0 }, // 77
  { Intrinsic::riscv_vfncvt_f_xu_w, 0x0 }, // 78
  { Intrinsic::riscv_vfncvt_f_xu_w_mask, 0x0 }, // 79
  { Intrinsic::riscv_vfncvt_rod_f_f_w, 0x0 }, // 80
  { Intrinsic::riscv_vfncvt_rod_f_f_w_mask, 0x0 }, // 81
  { Intrinsic::riscv_vfncvt_rtz_x_f_w, 0x0 }, // 82
  { Intrinsic::riscv_vfncvt_rtz_x_f_w_mask, 0x0 }, // 83
  { Intrinsic::riscv_vfncvt_rtz_xu_f_w, 0x0 }, // 84
  { Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask, 0x0 }, // 85
  { Intrinsic::riscv_vfncvt_x_f_w, 0x0 }, // 86
  { Intrinsic::riscv_vfncvt_x_f_w_mask, 0x0 }, // 87
  { Intrinsic::riscv_vfncvt_xu_f_w, 0x0 }, // 88
  { Intrinsic::riscv_vfncvt_xu_f_w_mask, 0x0 }, // 89
  { Intrinsic::riscv_vfnmacc, 0x2 }, // 90
  { Intrinsic::riscv_vfnmacc_mask, 0x2 }, // 91
  { Intrinsic::riscv_vfnmadd, 0x2 }, // 92
  { Intrinsic::riscv_vfnmadd_mask, 0x2 }, // 93
  { Intrinsic::riscv_vfnmsac, 0x2 }, // 94
  { Intrinsic::riscv_vfnmsac_mask, 0x2 }, // 95
  { Intrinsic::riscv_vfnmsub, 0x2 }, // 96
  { Intrinsic::riscv_vfnmsub_mask, 0x2 }, // 97
  { Intrinsic::riscv_vfrdiv, 0x2 }, // 98
  { Intrinsic::riscv_vfrdiv_mask, 0x3 }, // 99
  { Intrinsic::riscv_vfrec7, 0x0 }, // 100
  { Intrinsic::riscv_vfrec7_mask, 0x0 }, // 101
  { Intrinsic::riscv_vfredmax, 0x0 }, // 102
  { Intrinsic::riscv_vfredmax_mask, 0x0 }, // 103
  { Intrinsic::riscv_vfredmin, 0x0 }, // 104
  { Intrinsic::riscv_vfredmin_mask, 0x0 }, // 105
  { Intrinsic::riscv_vfredosum, 0x0 }, // 106
  { Intrinsic::riscv_vfredosum_mask, 0x0 }, // 107
  { Intrinsic::riscv_vfredsum, 0x0 }, // 108
  { Intrinsic::riscv_vfredsum_mask, 0x0 }, // 109
  { Intrinsic::riscv_vfrsqrt7, 0x0 }, // 110
  { Intrinsic::riscv_vfrsqrt7_mask, 0x0 }, // 111
  { Intrinsic::riscv_vfrsub, 0x2 }, // 112
  { Intrinsic::riscv_vfrsub_mask, 0x3 }, // 113
  { Intrinsic::riscv_vfsgnj, 0x2 }, // 114
  { Intrinsic::riscv_vfsgnj_mask, 0x3 }, // 115
  { Intrinsic::riscv_vfsgnjn, 0x2 }, // 116
  { Intrinsic::riscv_vfsgnjn_mask, 0x3 }, // 117
  { Intrinsic::riscv_vfsgnjx, 0x2 }, // 118
  { Intrinsic::riscv_vfsgnjx_mask, 0x3 }, // 119
  { Intrinsic::riscv_vfslide1down, 0x2 }, // 120
  { Intrinsic::riscv_vfslide1down_mask, 0x3 }, // 121
  { Intrinsic::riscv_vfslide1up, 0x2 }, // 122
  { Intrinsic::riscv_vfslide1up_mask, 0x3 }, // 123
  { Intrinsic::riscv_vfsqrt, 0x0 }, // 124
  { Intrinsic::riscv_vfsqrt_mask, 0x0 }, // 125
  { Intrinsic::riscv_vfsub, 0x2 }, // 126
  { Intrinsic::riscv_vfsub_mask, 0x3 }, // 127
  { Intrinsic::riscv_vfwadd, 0x2 }, // 128
  { Intrinsic::riscv_vfwadd_mask, 0x3 }, // 129
  { Intrinsic::riscv_vfwadd_w, 0x2 }, // 130
  { Intrinsic::riscv_vfwadd_w_mask, 0x3 }, // 131
  { Intrinsic::riscv_vfwcvt_f_f_v, 0x0 }, // 132
  { Intrinsic::riscv_vfwcvt_f_f_v_mask, 0x0 }, // 133
  { Intrinsic::riscv_vfwcvt_f_x_v, 0x0 }, // 134
  { Intrinsic::riscv_vfwcvt_f_x_v_mask, 0x0 }, // 135
  { Intrinsic::riscv_vfwcvt_f_xu_v, 0x0 }, // 136
  { Intrinsic::riscv_vfwcvt_f_xu_v_mask, 0x0 }, // 137
  { Intrinsic::riscv_vfwcvt_rtz_x_f_v, 0x0 }, // 138
  { Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask, 0x0 }, // 139
  { Intrinsic::riscv_vfwcvt_rtz_xu_f_v, 0x0 }, // 140
  { Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask, 0x0 }, // 141
  { Intrinsic::riscv_vfwcvt_x_f_v, 0x0 }, // 142
  { Intrinsic::riscv_vfwcvt_x_f_v_mask, 0x0 }, // 143
  { Intrinsic::riscv_vfwcvt_xu_f_v, 0x0 }, // 144
  { Intrinsic::riscv_vfwcvt_xu_f_v_mask, 0x0 }, // 145
  { Intrinsic::riscv_vfwmacc, 0x2 }, // 146
  { Intrinsic::riscv_vfwmacc_mask, 0x2 }, // 147
  { Intrinsic::riscv_vfwmsac, 0x2 }, // 148
  { Intrinsic::riscv_vfwmsac_mask, 0x2 }, // 149
  { Intrinsic::riscv_vfwmul, 0x2 }, // 150
  { Intrinsic::riscv_vfwmul_mask, 0x3 }, // 151
  { Intrinsic::riscv_vfwnmacc, 0x2 }, // 152
  { Intrinsic::riscv_vfwnmacc_mask, 0x2 }, // 153
  { Intrinsic::riscv_vfwnmsac, 0x2 }, // 154
  { Intrinsic::riscv_vfwnmsac_mask, 0x2 }, // 155
  { Intrinsic::riscv_vfwredosum, 0x0 }, // 156
  { Intrinsic::riscv_vfwredosum_mask, 0x0 }, // 157
  { Intrinsic::riscv_vfwredsum, 0x0 }, // 158
  { Intrinsic::riscv_vfwredsum_mask, 0x0 }, // 159
  { Intrinsic::riscv_vfwsub, 0x2 }, // 160
  { Intrinsic::riscv_vfwsub_mask, 0x3 }, // 161
  { Intrinsic::riscv_vfwsub_w, 0x2 }, // 162
  { Intrinsic::riscv_vfwsub_w_mask, 0x3 }, // 163
  { Intrinsic::riscv_vid, 0x0 }, // 164
  { Intrinsic::riscv_vid_mask, 0x0 }, // 165
  { Intrinsic::riscv_viota, 0x0 }, // 166
  { Intrinsic::riscv_viota_mask, 0x0 }, // 167
  { Intrinsic::riscv_vle, 0x0 }, // 168
  { Intrinsic::riscv_vle_mask, 0x0 }, // 169
  { Intrinsic::riscv_vle1, 0x0 }, // 170
  { Intrinsic::riscv_vleff, 0x0 }, // 171
  { Intrinsic::riscv_vleff_mask, 0x0 }, // 172
  { Intrinsic::riscv_vloxei, 0x0 }, // 173
  { Intrinsic::riscv_vloxei_mask, 0x0 }, // 174
  { Intrinsic::riscv_vloxseg2, 0x0 }, // 175
  { Intrinsic::riscv_vloxseg2_mask, 0x0 }, // 176
  { Intrinsic::riscv_vloxseg3, 0x0 }, // 177
  { Intrinsic::riscv_vloxseg3_mask, 0x0 }, // 178
  { Intrinsic::riscv_vloxseg4, 0x0 }, // 179
  { Intrinsic::riscv_vloxseg4_mask, 0x0 }, // 180
  { Intrinsic::riscv_vloxseg5, 0x0 }, // 181
  { Intrinsic::riscv_vloxseg5_mask, 0x0 }, // 182
  { Intrinsic::riscv_vloxseg6, 0x0 }, // 183
  { Intrinsic::riscv_vloxseg6_mask, 0x0 }, // 184
  { Intrinsic::riscv_vloxseg7, 0x0 }, // 185
  { Intrinsic::riscv_vloxseg7_mask, 0x0 }, // 186
  { Intrinsic::riscv_vloxseg8, 0x0 }, // 187
  { Intrinsic::riscv_vloxseg8_mask, 0x0 }, // 188
  { Intrinsic::riscv_vlse, 0x0 }, // 189
  { Intrinsic::riscv_vlse_mask, 0x0 }, // 190
  { Intrinsic::riscv_vlseg2, 0x0 }, // 191
  { Intrinsic::riscv_vlseg2_mask, 0x0 }, // 192
  { Intrinsic::riscv_vlseg2ff, 0x0 }, // 193
  { Intrinsic::riscv_vlseg2ff_mask, 0x0 }, // 194
  { Intrinsic::riscv_vlseg3, 0x0 }, // 195
  { Intrinsic::riscv_vlseg3_mask, 0x0 }, // 196
  { Intrinsic::riscv_vlseg3ff, 0x0 }, // 197
  { Intrinsic::riscv_vlseg3ff_mask, 0x0 }, // 198
  { Intrinsic::riscv_vlseg4, 0x0 }, // 199
  { Intrinsic::riscv_vlseg4_mask, 0x0 }, // 200
  { Intrinsic::riscv_vlseg4ff, 0x0 }, // 201
  { Intrinsic::riscv_vlseg4ff_mask, 0x0 }, // 202
  { Intrinsic::riscv_vlseg5, 0x0 }, // 203
  { Intrinsic::riscv_vlseg5_mask, 0x0 }, // 204
  { Intrinsic::riscv_vlseg5ff, 0x0 }, // 205
  { Intrinsic::riscv_vlseg5ff_mask, 0x0 }, // 206
  { Intrinsic::riscv_vlseg6, 0x0 }, // 207
  { Intrinsic::riscv_vlseg6_mask, 0x0 }, // 208
  { Intrinsic::riscv_vlseg6ff, 0x0 }, // 209
  { Intrinsic::riscv_vlseg6ff_mask, 0x0 }, // 210
  { Intrinsic::riscv_vlseg7, 0x0 }, // 211
  { Intrinsic::riscv_vlseg7_mask, 0x0 }, // 212
  { Intrinsic::riscv_vlseg7ff, 0x0 }, // 213
  { Intrinsic::riscv_vlseg7ff_mask, 0x0 }, // 214
  { Intrinsic::riscv_vlseg8, 0x0 }, // 215
  { Intrinsic::riscv_vlseg8_mask, 0x0 }, // 216
  { Intrinsic::riscv_vlseg8ff, 0x0 }, // 217
  { Intrinsic::riscv_vlseg8ff_mask, 0x0 }, // 218
  { Intrinsic::riscv_vlsseg2, 0x0 }, // 219
  { Intrinsic::riscv_vlsseg2_mask, 0x0 }, // 220
  { Intrinsic::riscv_vlsseg3, 0x0 }, // 221
  { Intrinsic::riscv_vlsseg3_mask, 0x0 }, // 222
  { Intrinsic::riscv_vlsseg4, 0x0 }, // 223
  { Intrinsic::riscv_vlsseg4_mask, 0x0 }, // 224
  { Intrinsic::riscv_vlsseg5, 0x0 }, // 225
  { Intrinsic::riscv_vlsseg5_mask, 0x0 }, // 226
  { Intrinsic::riscv_vlsseg6, 0x0 }, // 227
  { Intrinsic::riscv_vlsseg6_mask, 0x0 }, // 228
  { Intrinsic::riscv_vlsseg7, 0x0 }, // 229
  { Intrinsic::riscv_vlsseg7_mask, 0x0 }, // 230
  { Intrinsic::riscv_vlsseg8, 0x0 }, // 231
  { Intrinsic::riscv_vlsseg8_mask, 0x0 }, // 232
  { Intrinsic::riscv_vluxei, 0x0 }, // 233
  { Intrinsic::riscv_vluxei_mask, 0x0 }, // 234
  { Intrinsic::riscv_vluxseg2, 0x0 }, // 235
  { Intrinsic::riscv_vluxseg2_mask, 0x0 }, // 236
  { Intrinsic::riscv_vluxseg3, 0x0 }, // 237
  { Intrinsic::riscv_vluxseg3_mask, 0x0 }, // 238
  { Intrinsic::riscv_vluxseg4, 0x0 }, // 239
  { Intrinsic::riscv_vluxseg4_mask, 0x0 }, // 240
  { Intrinsic::riscv_vluxseg5, 0x0 }, // 241
  { Intrinsic::riscv_vluxseg5_mask, 0x0 }, // 242
  { Intrinsic::riscv_vluxseg6, 0x0 }, // 243
  { Intrinsic::riscv_vluxseg6_mask, 0x0 }, // 244
  { Intrinsic::riscv_vluxseg7, 0x0 }, // 245
  { Intrinsic::riscv_vluxseg7_mask, 0x0 }, // 246
  { Intrinsic::riscv_vluxseg8, 0x0 }, // 247
  { Intrinsic::riscv_vluxseg8_mask, 0x0 }, // 248
  { Intrinsic::riscv_vmacc, 0x2 }, // 249
  { Intrinsic::riscv_vmacc_mask, 0x2 }, // 250
  { Intrinsic::riscv_vmadc, 0x2 }, // 251
  { Intrinsic::riscv_vmadc_carry_in, 0x2 }, // 252
  { Intrinsic::riscv_vmadd, 0x2 }, // 253
  { Intrinsic::riscv_vmadd_mask, 0x2 }, // 254
  { Intrinsic::riscv_vmand, 0x0 }, // 255
  { Intrinsic::riscv_vmandnot, 0x0 }, // 256
  { Intrinsic::riscv_vmax, 0x2 }, // 257
  { Intrinsic::riscv_vmax_mask, 0x3 }, // 258
  { Intrinsic::riscv_vmaxu, 0x2 }, // 259
  { Intrinsic::riscv_vmaxu_mask, 0x3 }, // 260
  { Intrinsic::riscv_vmclr, 0x0 }, // 261
  { Intrinsic::riscv_vmerge, 0x2 }, // 262
  { Intrinsic::riscv_vmfeq, 0x2 }, // 263
  { Intrinsic::riscv_vmfeq_mask, 0x3 }, // 264
  { Intrinsic::riscv_vmfge, 0x2 }, // 265
  { Intrinsic::riscv_vmfge_mask, 0x3 }, // 266
  { Intrinsic::riscv_vmfgt, 0x2 }, // 267
  { Intrinsic::riscv_vmfgt_mask, 0x3 }, // 268
  { Intrinsic::riscv_vmfle, 0x2 }, // 269
  { Intrinsic::riscv_vmfle_mask, 0x3 }, // 270
  { Intrinsic::riscv_vmflt, 0x2 }, // 271
  { Intrinsic::riscv_vmflt_mask, 0x3 }, // 272
  { Intrinsic::riscv_vmfne, 0x2 }, // 273
  { Intrinsic::riscv_vmfne_mask, 0x3 }, // 274
  { Intrinsic::riscv_vmin, 0x2 }, // 275
  { Intrinsic::riscv_vmin_mask, 0x3 }, // 276
  { Intrinsic::riscv_vminu, 0x2 }, // 277
  { Intrinsic::riscv_vminu_mask, 0x3 }, // 278
  { Intrinsic::riscv_vmnand, 0x0 }, // 279
  { Intrinsic::riscv_vmnor, 0x0 }, // 280
  { Intrinsic::riscv_vmor, 0x0 }, // 281
  { Intrinsic::riscv_vmornot, 0x0 }, // 282
  { Intrinsic::riscv_vmsbc, 0x2 }, // 283
  { Intrinsic::riscv_vmsbc_borrow_in, 0x2 }, // 284
  { Intrinsic::riscv_vmsbf, 0x0 }, // 285
  { Intrinsic::riscv_vmsbf_mask, 0x0 }, // 286
  { Intrinsic::riscv_vmseq, 0x2 }, // 287
  { Intrinsic::riscv_vmseq_mask, 0x3 }, // 288
  { Intrinsic::riscv_vmset, 0x0 }, // 289
  { Intrinsic::riscv_vmsgt, 0x2 }, // 290
  { Intrinsic::riscv_vmsgt_mask, 0x3 }, // 291
  { Intrinsic::riscv_vmsgtu, 0x2 }, // 292
  { Intrinsic::riscv_vmsgtu_mask, 0x3 }, // 293
  { Intrinsic::riscv_vmsif, 0x0 }, // 294
  { Intrinsic::riscv_vmsif_mask, 0x0 }, // 295
  { Intrinsic::riscv_vmsle, 0x2 }, // 296
  { Intrinsic::riscv_vmsle_mask, 0x3 }, // 297
  { Intrinsic::riscv_vmsleu, 0x2 }, // 298
  { Intrinsic::riscv_vmsleu_mask, 0x3 }, // 299
  { Intrinsic::riscv_vmslt, 0x2 }, // 300
  { Intrinsic::riscv_vmslt_mask, 0x3 }, // 301
  { Intrinsic::riscv_vmsltu, 0x2 }, // 302
  { Intrinsic::riscv_vmsltu_mask, 0x3 }, // 303
  { Intrinsic::riscv_vmsne, 0x2 }, // 304
  { Intrinsic::riscv_vmsne_mask, 0x3 }, // 305
  { Intrinsic::riscv_vmsof, 0x0 }, // 306
  { Intrinsic::riscv_vmsof_mask, 0x0 }, // 307
  { Intrinsic::riscv_vmul, 0x2 }, // 308
  { Intrinsic::riscv_vmul_mask, 0x3 }, // 309
  { Intrinsic::riscv_vmulh, 0x2 }, // 310
  { Intrinsic::riscv_vmulh_mask, 0x3 }, // 311
  { Intrinsic::riscv_vmulhsu, 0x2 }, // 312
  { Intrinsic::riscv_vmulhsu_mask, 0x3 }, // 313
  { Intrinsic::riscv_vmulhu, 0x2 }, // 314
  { Intrinsic::riscv_vmulhu_mask, 0x3 }, // 315
  { Intrinsic::riscv_vmv_s_x, 0x2 }, // 316
  { Intrinsic::riscv_vmv_v_v, 0x0 }, // 317
  { Intrinsic::riscv_vmv_v_x, 0x1 }, // 318
  { Intrinsic::riscv_vmv_x_s, 0x0 }, // 319
  { Intrinsic::riscv_vmxnor, 0x0 }, // 320
  { Intrinsic::riscv_vmxor, 0x0 }, // 321
  { Intrinsic::riscv_vnclip, 0x2 }, // 322
  { Intrinsic::riscv_vnclip_mask, 0x3 }, // 323
  { Intrinsic::riscv_vnclipu, 0x2 }, // 324
  { Intrinsic::riscv_vnclipu_mask, 0x3 }, // 325
  { Intrinsic::riscv_vnmsac, 0x2 }, // 326
  { Intrinsic::riscv_vnmsac_mask, 0x2 }, // 327
  { Intrinsic::riscv_vnmsub, 0x2 }, // 328
  { Intrinsic::riscv_vnmsub_mask, 0x2 }, // 329
  { Intrinsic::riscv_vnsra, 0x2 }, // 330
  { Intrinsic::riscv_vnsra_mask, 0x3 }, // 331
  { Intrinsic::riscv_vnsrl, 0x2 }, // 332
  { Intrinsic::riscv_vnsrl_mask, 0x3 }, // 333
  { Intrinsic::riscv_vor, 0x2 }, // 334
  { Intrinsic::riscv_vor_mask, 0x3 }, // 335
  { Intrinsic::riscv_vpopc, 0x0 }, // 336
  { Intrinsic::riscv_vpopc_mask, 0x0 }, // 337
  { Intrinsic::riscv_vredand, 0x0 }, // 338
  { Intrinsic::riscv_vredand_mask, 0x0 }, // 339
  { Intrinsic::riscv_vredmax, 0x0 }, // 340
  { Intrinsic::riscv_vredmax_mask, 0x0 }, // 341
  { Intrinsic::riscv_vredmaxu, 0x0 }, // 342
  { Intrinsic::riscv_vredmaxu_mask, 0x0 }, // 343
  { Intrinsic::riscv_vredmin, 0x0 }, // 344
  { Intrinsic::riscv_vredmin_mask, 0x0 }, // 345
  { Intrinsic::riscv_vredminu, 0x0 }, // 346
  { Intrinsic::riscv_vredminu_mask, 0x0 }, // 347
  { Intrinsic::riscv_vredor, 0x0 }, // 348
  { Intrinsic::riscv_vredor_mask, 0x0 }, // 349
  { Intrinsic::riscv_vredsum, 0x0 }, // 350
  { Intrinsic::riscv_vredsum_mask, 0x0 }, // 351
  { Intrinsic::riscv_vredxor, 0x0 }, // 352
  { Intrinsic::riscv_vredxor_mask, 0x0 }, // 353
  { Intrinsic::riscv_vrem, 0x2 }, // 354
  { Intrinsic::riscv_vrem_mask, 0x3 }, // 355
  { Intrinsic::riscv_vremu, 0x2 }, // 356
  { Intrinsic::riscv_vremu_mask, 0x3 }, // 357
  { Intrinsic::riscv_vrgather, 0x2 }, // 358
  { Intrinsic::riscv_vrgather_mask, 0x3 }, // 359
  { Intrinsic::riscv_vrgatherei16, 0x2 }, // 360
  { Intrinsic::riscv_vrgatherei16_mask, 0x3 }, // 361
  { Intrinsic::riscv_vrsub, 0x2 }, // 362
  { Intrinsic::riscv_vrsub_mask, 0x3 }, // 363
  { Intrinsic::riscv_vsadd, 0x2 }, // 364
  { Intrinsic::riscv_vsadd_mask, 0x3 }, // 365
  { Intrinsic::riscv_vsaddu, 0x2 }, // 366
  { Intrinsic::riscv_vsaddu_mask, 0x3 }, // 367
  { Intrinsic::riscv_vsbc, 0x2 }, // 368
  { Intrinsic::riscv_vse, 0x0 }, // 369
  { Intrinsic::riscv_vse_mask, 0x0 }, // 370
  { Intrinsic::riscv_vse1, 0x0 }, // 371
  { Intrinsic::riscv_vsext, 0x0 }, // 372
  { Intrinsic::riscv_vsext_mask, 0x0 }, // 373
  { Intrinsic::riscv_vslide1down, 0x2 }, // 374
  { Intrinsic::riscv_vslide1down_mask, 0x3 }, // 375
  { Intrinsic::riscv_vslide1up, 0x2 }, // 376
  { Intrinsic::riscv_vslide1up_mask, 0x3 }, // 377
  { Intrinsic::riscv_vslidedown, 0x0 }, // 378
  { Intrinsic::riscv_vslidedown_mask, 0x0 }, // 379
  { Intrinsic::riscv_vslideup, 0x0 }, // 380
  { Intrinsic::riscv_vslideup_mask, 0x0 }, // 381
  { Intrinsic::riscv_vsll, 0x2 }, // 382
  { Intrinsic::riscv_vsll_mask, 0x3 }, // 383
  { Intrinsic::riscv_vsmul, 0x2 }, // 384
  { Intrinsic::riscv_vsmul_mask, 0x3 }, // 385
  { Intrinsic::riscv_vsoxei, 0x0 }, // 386
  { Intrinsic::riscv_vsoxei_mask, 0x0 }, // 387
  { Intrinsic::riscv_vsoxseg2, 0x0 }, // 388
  { Intrinsic::riscv_vsoxseg2_mask, 0x0 }, // 389
  { Intrinsic::riscv_vsoxseg3, 0x0 }, // 390
  { Intrinsic::riscv_vsoxseg3_mask, 0x0 }, // 391
  { Intrinsic::riscv_vsoxseg4, 0x0 }, // 392
  { Intrinsic::riscv_vsoxseg4_mask, 0x0 }, // 393
  { Intrinsic::riscv_vsoxseg5, 0x0 }, // 394
  { Intrinsic::riscv_vsoxseg5_mask, 0x0 }, // 395
  { Intrinsic::riscv_vsoxseg6, 0x0 }, // 396
  { Intrinsic::riscv_vsoxseg6_mask, 0x0 }, // 397
  { Intrinsic::riscv_vsoxseg7, 0x0 }, // 398
  { Intrinsic::riscv_vsoxseg7_mask, 0x0 }, // 399
  { Intrinsic::riscv_vsoxseg8, 0x0 }, // 400
  { Intrinsic::riscv_vsoxseg8_mask, 0x0 }, // 401
  { Intrinsic::riscv_vsra, 0x2 }, // 402
  { Intrinsic::riscv_vsra_mask, 0x3 }, // 403
  { Intrinsic::riscv_vsrl, 0x2 }, // 404
  { Intrinsic::riscv_vsrl_mask, 0x3 }, // 405
  { Intrinsic::riscv_vsse, 0x0 }, // 406
  { Intrinsic::riscv_vsse_mask, 0x0 }, // 407
  { Intrinsic::riscv_vsseg2, 0x0 }, // 408
  { Intrinsic::riscv_vsseg2_mask, 0x0 }, // 409
  { Intrinsic::riscv_vsseg3, 0x0 }, // 410
  { Intrinsic::riscv_vsseg3_mask, 0x0 }, // 411
  { Intrinsic::riscv_vsseg4, 0x0 }, // 412
  { Intrinsic::riscv_vsseg4_mask, 0x0 }, // 413
  { Intrinsic::riscv_vsseg5, 0x0 }, // 414
  { Intrinsic::riscv_vsseg5_mask, 0x0 }, // 415
  { Intrinsic::riscv_vsseg6, 0x0 }, // 416
  { Intrinsic::riscv_vsseg6_mask, 0x0 }, // 417
  { Intrinsic::riscv_vsseg7, 0x0 }, // 418
  { Intrinsic::riscv_vsseg7_mask, 0x0 }, // 419
  { Intrinsic::riscv_vsseg8, 0x0 }, // 420
  { Intrinsic::riscv_vsseg8_mask, 0x0 }, // 421
  { Intrinsic::riscv_vssra, 0x2 }, // 422
  { Intrinsic::riscv_vssra_mask, 0x3 }, // 423
  { Intrinsic::riscv_vssrl, 0x2 }, // 424
  { Intrinsic::riscv_vssrl_mask, 0x3 }, // 425
  { Intrinsic::riscv_vssseg2, 0x0 }, // 426
  { Intrinsic::riscv_vssseg2_mask, 0x0 }, // 427
  { Intrinsic::riscv_vssseg3, 0x0 }, // 428
  { Intrinsic::riscv_vssseg3_mask, 0x0 }, // 429
  { Intrinsic::riscv_vssseg4, 0x0 }, // 430
  { Intrinsic::riscv_vssseg4_mask, 0x0 }, // 431
  { Intrinsic::riscv_vssseg5, 0x0 }, // 432
  { Intrinsic::riscv_vssseg5_mask, 0x0 }, // 433
  { Intrinsic::riscv_vssseg6, 0x0 }, // 434
  { Intrinsic::riscv_vssseg6_mask, 0x0 }, // 435
  { Intrinsic::riscv_vssseg7, 0x0 }, // 436
  { Intrinsic::riscv_vssseg7_mask, 0x0 }, // 437
  { Intrinsic::riscv_vssseg8, 0x0 }, // 438
  { Intrinsic::riscv_vssseg8_mask, 0x0 }, // 439
  { Intrinsic::riscv_vssub, 0x2 }, // 440
  { Intrinsic::riscv_vssub_mask, 0x3 }, // 441
  { Intrinsic::riscv_vssubu, 0x2 }, // 442
  { Intrinsic::riscv_vssubu_mask, 0x3 }, // 443
  { Intrinsic::riscv_vsub, 0x2 }, // 444
  { Intrinsic::riscv_vsub_mask, 0x3 }, // 445
  { Intrinsic::riscv_vsuxei, 0x0 }, // 446
  { Intrinsic::riscv_vsuxei_mask, 0x0 }, // 447
  { Intrinsic::riscv_vsuxseg2, 0x0 }, // 448
  { Intrinsic::riscv_vsuxseg2_mask, 0x0 }, // 449
  { Intrinsic::riscv_vsuxseg3, 0x0 }, // 450
  { Intrinsic::riscv_vsuxseg3_mask, 0x0 }, // 451
  { Intrinsic::riscv_vsuxseg4, 0x0 }, // 452
  { Intrinsic::riscv_vsuxseg4_mask, 0x0 }, // 453
  { Intrinsic::riscv_vsuxseg5, 0x0 }, // 454
  { Intrinsic::riscv_vsuxseg5_mask, 0x0 }, // 455
  { Intrinsic::riscv_vsuxseg6, 0x0 }, // 456
  { Intrinsic::riscv_vsuxseg6_mask, 0x0 }, // 457
  { Intrinsic::riscv_vsuxseg7, 0x0 }, // 458
  { Intrinsic::riscv_vsuxseg7_mask, 0x0 }, // 459
  { Intrinsic::riscv_vsuxseg8, 0x0 }, // 460
  { Intrinsic::riscv_vsuxseg8_mask, 0x0 }, // 461
  { Intrinsic::riscv_vwadd, 0x2 }, // 462
  { Intrinsic::riscv_vwadd_mask, 0x3 }, // 463
  { Intrinsic::riscv_vwadd_w, 0x2 }, // 464
  { Intrinsic::riscv_vwadd_w_mask, 0x3 }, // 465
  { Intrinsic::riscv_vwaddu, 0x2 }, // 466
  { Intrinsic::riscv_vwaddu_mask, 0x3 }, // 467
  { Intrinsic::riscv_vwaddu_w, 0x2 }, // 468
  { Intrinsic::riscv_vwaddu_w_mask, 0x3 }, // 469
  { Intrinsic::riscv_vwmacc, 0x2 }, // 470
  { Intrinsic::riscv_vwmacc_mask, 0x2 }, // 471
  { Intrinsic::riscv_vwmaccsu, 0x2 }, // 472
  { Intrinsic::riscv_vwmaccsu_mask, 0x2 }, // 473
  { Intrinsic::riscv_vwmaccu, 0x2 }, // 474
  { Intrinsic::riscv_vwmaccu_mask, 0x2 }, // 475
  { Intrinsic::riscv_vwmaccus, 0x2 }, // 476
  { Intrinsic::riscv_vwmaccus_mask, 0x2 }, // 477
  { Intrinsic::riscv_vwmul, 0x2 }, // 478
  { Intrinsic::riscv_vwmul_mask, 0x3 }, // 479
  { Intrinsic::riscv_vwmulsu, 0x2 }, // 480
  { Intrinsic::riscv_vwmulsu_mask, 0x3 }, // 481
  { Intrinsic::riscv_vwmulu, 0x2 }, // 482
  { Intrinsic::riscv_vwmulu_mask, 0x3 }, // 483
  { Intrinsic::riscv_vwredsum, 0x0 }, // 484
  { Intrinsic::riscv_vwredsum_mask, 0x0 }, // 485
  { Intrinsic::riscv_vwredsumu, 0x0 }, // 486
  { Intrinsic::riscv_vwredsumu_mask, 0x0 }, // 487
  { Intrinsic::riscv_vwsub, 0x2 }, // 488
  { Intrinsic::riscv_vwsub_mask, 0x3 }, // 489
  { Intrinsic::riscv_vwsub_w, 0x2 }, // 490
  { Intrinsic::riscv_vwsub_w_mask, 0x3 }, // 491
  { Intrinsic::riscv_vwsubu, 0x2 }, // 492
  { Intrinsic::riscv_vwsubu_mask, 0x3 }, // 493
  { Intrinsic::riscv_vwsubu_w, 0x2 }, // 494
  { Intrinsic::riscv_vwsubu_w_mask, 0x3 }, // 495
  { Intrinsic::riscv_vxor, 0x2 }, // 496
  { Intrinsic::riscv_vxor_mask, 0x3 }, // 497
  { Intrinsic::riscv_vzext, 0x0 }, // 498
  { Intrinsic::riscv_vzext_mask, 0x0 }, // 499
 };

const RISCVVIntrinsicInfo *getRISCVVIntrinsicInfo(unsigned IntrinsicID) {
  struct KeyType {
    unsigned IntrinsicID;
  };
  KeyType Key = {IntrinsicID};
  auto Table = makeArrayRef(RISCVVIntrinsicsTable);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const RISCVVIntrinsicInfo &LHS, const KeyType &RHS) {
      if (LHS.IntrinsicID < RHS.IntrinsicID)
        return true;
      if (LHS.IntrinsicID > RHS.IntrinsicID)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.IntrinsicID != Idx->IntrinsicID)
    return nullptr;
  return &*Idx;
}
#endif

#ifdef GET_RISCVVPseudosTable_DECL
const PseudoInfo *getPseudoInfo(unsigned Pseudo);
#endif

#ifdef GET_RISCVVPseudosTable_IMPL
constexpr PseudoInfo RISCVVPseudosTable[] = {
  { PseudoVAADDU_VV_M1, VAADDU_VV }, // 0
  { PseudoVAADDU_VV_M1_MASK, VAADDU_VV }, // 1
  { PseudoVAADDU_VV_M2, VAADDU_VV }, // 2
  { PseudoVAADDU_VV_M2_MASK, VAADDU_VV }, // 3
  { PseudoVAADDU_VV_M4, VAADDU_VV }, // 4
  { PseudoVAADDU_VV_M4_MASK, VAADDU_VV }, // 5
  { PseudoVAADDU_VV_M8, VAADDU_VV }, // 6
  { PseudoVAADDU_VV_M8_MASK, VAADDU_VV }, // 7
  { PseudoVAADDU_VV_MF2, VAADDU_VV }, // 8
  { PseudoVAADDU_VV_MF2_MASK, VAADDU_VV }, // 9
  { PseudoVAADDU_VV_MF4, VAADDU_VV }, // 10
  { PseudoVAADDU_VV_MF4_MASK, VAADDU_VV }, // 11
  { PseudoVAADDU_VV_MF8, VAADDU_VV }, // 12
  { PseudoVAADDU_VV_MF8_MASK, VAADDU_VV }, // 13
  { PseudoVAADDU_VX_M1, VAADDU_VX }, // 14
  { PseudoVAADDU_VX_M1_MASK, VAADDU_VX }, // 15
  { PseudoVAADDU_VX_M2, VAADDU_VX }, // 16
  { PseudoVAADDU_VX_M2_MASK, VAADDU_VX }, // 17
  { PseudoVAADDU_VX_M4, VAADDU_VX }, // 18
  { PseudoVAADDU_VX_M4_MASK, VAADDU_VX }, // 19
  { PseudoVAADDU_VX_M8, VAADDU_VX }, // 20
  { PseudoVAADDU_VX_M8_MASK, VAADDU_VX }, // 21
  { PseudoVAADDU_VX_MF2, VAADDU_VX }, // 22
  { PseudoVAADDU_VX_MF2_MASK, VAADDU_VX }, // 23
  { PseudoVAADDU_VX_MF4, VAADDU_VX }, // 24
  { PseudoVAADDU_VX_MF4_MASK, VAADDU_VX }, // 25
  { PseudoVAADDU_VX_MF8, VAADDU_VX }, // 26
  { PseudoVAADDU_VX_MF8_MASK, VAADDU_VX }, // 27
  { PseudoVAADD_VV_M1, VAADD_VV }, // 28
  { PseudoVAADD_VV_M1_MASK, VAADD_VV }, // 29
  { PseudoVAADD_VV_M2, VAADD_VV }, // 30
  { PseudoVAADD_VV_M2_MASK, VAADD_VV }, // 31
  { PseudoVAADD_VV_M4, VAADD_VV }, // 32
  { PseudoVAADD_VV_M4_MASK, VAADD_VV }, // 33
  { PseudoVAADD_VV_M8, VAADD_VV }, // 34
  { PseudoVAADD_VV_M8_MASK, VAADD_VV }, // 35
  { PseudoVAADD_VV_MF2, VAADD_VV }, // 36
  { PseudoVAADD_VV_MF2_MASK, VAADD_VV }, // 37
  { PseudoVAADD_VV_MF4, VAADD_VV }, // 38
  { PseudoVAADD_VV_MF4_MASK, VAADD_VV }, // 39
  { PseudoVAADD_VV_MF8, VAADD_VV }, // 40
  { PseudoVAADD_VV_MF8_MASK, VAADD_VV }, // 41
  { PseudoVAADD_VX_M1, VAADD_VX }, // 42
  { PseudoVAADD_VX_M1_MASK, VAADD_VX }, // 43
  { PseudoVAADD_VX_M2, VAADD_VX }, // 44
  { PseudoVAADD_VX_M2_MASK, VAADD_VX }, // 45
  { PseudoVAADD_VX_M4, VAADD_VX }, // 46
  { PseudoVAADD_VX_M4_MASK, VAADD_VX }, // 47
  { PseudoVAADD_VX_M8, VAADD_VX }, // 48
  { PseudoVAADD_VX_M8_MASK, VAADD_VX }, // 49
  { PseudoVAADD_VX_MF2, VAADD_VX }, // 50
  { PseudoVAADD_VX_MF2_MASK, VAADD_VX }, // 51
  { PseudoVAADD_VX_MF4, VAADD_VX }, // 52
  { PseudoVAADD_VX_MF4_MASK, VAADD_VX }, // 53
  { PseudoVAADD_VX_MF8, VAADD_VX }, // 54
  { PseudoVAADD_VX_MF8_MASK, VAADD_VX }, // 55
  { PseudoVADC_VIM_M1, VADC_VIM }, // 56
  { PseudoVADC_VIM_M2, VADC_VIM }, // 57
  { PseudoVADC_VIM_M4, VADC_VIM }, // 58
  { PseudoVADC_VIM_M8, VADC_VIM }, // 59
  { PseudoVADC_VIM_MF2, VADC_VIM }, // 60
  { PseudoVADC_VIM_MF4, VADC_VIM }, // 61
  { PseudoVADC_VIM_MF8, VADC_VIM }, // 62
  { PseudoVADC_VVM_M1, VADC_VVM }, // 63
  { PseudoVADC_VVM_M2, VADC_VVM }, // 64
  { PseudoVADC_VVM_M4, VADC_VVM }, // 65
  { PseudoVADC_VVM_M8, VADC_VVM }, // 66
  { PseudoVADC_VVM_MF2, VADC_VVM }, // 67
  { PseudoVADC_VVM_MF4, VADC_VVM }, // 68
  { PseudoVADC_VVM_MF8, VADC_VVM }, // 69
  { PseudoVADC_VXM_M1, VADC_VXM }, // 70
  { PseudoVADC_VXM_M2, VADC_VXM }, // 71
  { PseudoVADC_VXM_M4, VADC_VXM }, // 72
  { PseudoVADC_VXM_M8, VADC_VXM }, // 73
  { PseudoVADC_VXM_MF2, VADC_VXM }, // 74
  { PseudoVADC_VXM_MF4, VADC_VXM }, // 75
  { PseudoVADC_VXM_MF8, VADC_VXM }, // 76
  { PseudoVADD_VI_M1, VADD_VI }, // 77
  { PseudoVADD_VI_M1_MASK, VADD_VI }, // 78
  { PseudoVADD_VI_M2, VADD_VI }, // 79
  { PseudoVADD_VI_M2_MASK, VADD_VI }, // 80
  { PseudoVADD_VI_M4, VADD_VI }, // 81
  { PseudoVADD_VI_M4_MASK, VADD_VI }, // 82
  { PseudoVADD_VI_M8, VADD_VI }, // 83
  { PseudoVADD_VI_M8_MASK, VADD_VI }, // 84
  { PseudoVADD_VI_MF2, VADD_VI }, // 85
  { PseudoVADD_VI_MF2_MASK, VADD_VI }, // 86
  { PseudoVADD_VI_MF4, VADD_VI }, // 87
  { PseudoVADD_VI_MF4_MASK, VADD_VI }, // 88
  { PseudoVADD_VI_MF8, VADD_VI }, // 89
  { PseudoVADD_VI_MF8_MASK, VADD_VI }, // 90
  { PseudoVADD_VV_M1, VADD_VV }, // 91
  { PseudoVADD_VV_M1_MASK, VADD_VV }, // 92
  { PseudoVADD_VV_M2, VADD_VV }, // 93
  { PseudoVADD_VV_M2_MASK, VADD_VV }, // 94
  { PseudoVADD_VV_M4, VADD_VV }, // 95
  { PseudoVADD_VV_M4_MASK, VADD_VV }, // 96
  { PseudoVADD_VV_M8, VADD_VV }, // 97
  { PseudoVADD_VV_M8_MASK, VADD_VV }, // 98
  { PseudoVADD_VV_MF2, VADD_VV }, // 99
  { PseudoVADD_VV_MF2_MASK, VADD_VV }, // 100
  { PseudoVADD_VV_MF4, VADD_VV }, // 101
  { PseudoVADD_VV_MF4_MASK, VADD_VV }, // 102
  { PseudoVADD_VV_MF8, VADD_VV }, // 103
  { PseudoVADD_VV_MF8_MASK, VADD_VV }, // 104
  { PseudoVADD_VX_M1, VADD_VX }, // 105
  { PseudoVADD_VX_M1_MASK, VADD_VX }, // 106
  { PseudoVADD_VX_M2, VADD_VX }, // 107
  { PseudoVADD_VX_M2_MASK, VADD_VX }, // 108
  { PseudoVADD_VX_M4, VADD_VX }, // 109
  { PseudoVADD_VX_M4_MASK, VADD_VX }, // 110
  { PseudoVADD_VX_M8, VADD_VX }, // 111
  { PseudoVADD_VX_M8_MASK, VADD_VX }, // 112
  { PseudoVADD_VX_MF2, VADD_VX }, // 113
  { PseudoVADD_VX_MF2_MASK, VADD_VX }, // 114
  { PseudoVADD_VX_MF4, VADD_VX }, // 115
  { PseudoVADD_VX_MF4_MASK, VADD_VX }, // 116
  { PseudoVADD_VX_MF8, VADD_VX }, // 117
  { PseudoVADD_VX_MF8_MASK, VADD_VX }, // 118
  { PseudoVAMOADDEI16_WD_M1_MF2, VAMOADDEI16_WD }, // 119
  { PseudoVAMOADDEI16_WD_M1_MF2_MASK, VAMOADDEI16_WD }, // 120
  { PseudoVAMOADDEI16_WD_M1_MF4, VAMOADDEI16_WD }, // 121
  { PseudoVAMOADDEI16_WD_M1_MF4_MASK, VAMOADDEI16_WD }, // 122
  { PseudoVAMOADDEI16_WD_M2_M1, VAMOADDEI16_WD }, // 123
  { PseudoVAMOADDEI16_WD_M2_M1_MASK, VAMOADDEI16_WD }, // 124
  { PseudoVAMOADDEI16_WD_M2_MF2, VAMOADDEI16_WD }, // 125
  { PseudoVAMOADDEI16_WD_M2_MF2_MASK, VAMOADDEI16_WD }, // 126
  { PseudoVAMOADDEI16_WD_M4_M1, VAMOADDEI16_WD }, // 127
  { PseudoVAMOADDEI16_WD_M4_M1_MASK, VAMOADDEI16_WD }, // 128
  { PseudoVAMOADDEI16_WD_M4_M2, VAMOADDEI16_WD }, // 129
  { PseudoVAMOADDEI16_WD_M4_M2_MASK, VAMOADDEI16_WD }, // 130
  { PseudoVAMOADDEI16_WD_M8_M2, VAMOADDEI16_WD }, // 131
  { PseudoVAMOADDEI16_WD_M8_M2_MASK, VAMOADDEI16_WD }, // 132
  { PseudoVAMOADDEI16_WD_M8_M4, VAMOADDEI16_WD }, // 133
  { PseudoVAMOADDEI16_WD_M8_M4_MASK, VAMOADDEI16_WD }, // 134
  { PseudoVAMOADDEI16_WD_MF2_MF4, VAMOADDEI16_WD }, // 135
  { PseudoVAMOADDEI16_WD_MF2_MF4_MASK, VAMOADDEI16_WD }, // 136
  { PseudoVAMOADDEI32_WD_M1_M1, VAMOADDEI32_WD }, // 137
  { PseudoVAMOADDEI32_WD_M1_M1_MASK, VAMOADDEI32_WD }, // 138
  { PseudoVAMOADDEI32_WD_M1_MF2, VAMOADDEI32_WD }, // 139
  { PseudoVAMOADDEI32_WD_M1_MF2_MASK, VAMOADDEI32_WD }, // 140
  { PseudoVAMOADDEI32_WD_M2_M1, VAMOADDEI32_WD }, // 141
  { PseudoVAMOADDEI32_WD_M2_M1_MASK, VAMOADDEI32_WD }, // 142
  { PseudoVAMOADDEI32_WD_M2_M2, VAMOADDEI32_WD }, // 143
  { PseudoVAMOADDEI32_WD_M2_M2_MASK, VAMOADDEI32_WD }, // 144
  { PseudoVAMOADDEI32_WD_M4_M2, VAMOADDEI32_WD }, // 145
  { PseudoVAMOADDEI32_WD_M4_M2_MASK, VAMOADDEI32_WD }, // 146
  { PseudoVAMOADDEI32_WD_M4_M4, VAMOADDEI32_WD }, // 147
  { PseudoVAMOADDEI32_WD_M4_M4_MASK, VAMOADDEI32_WD }, // 148
  { PseudoVAMOADDEI32_WD_M8_M4, VAMOADDEI32_WD }, // 149
  { PseudoVAMOADDEI32_WD_M8_M4_MASK, VAMOADDEI32_WD }, // 150
  { PseudoVAMOADDEI32_WD_M8_M8, VAMOADDEI32_WD }, // 151
  { PseudoVAMOADDEI32_WD_M8_M8_MASK, VAMOADDEI32_WD }, // 152
  { PseudoVAMOADDEI32_WD_MF2_MF2, VAMOADDEI32_WD }, // 153
  { PseudoVAMOADDEI32_WD_MF2_MF2_MASK, VAMOADDEI32_WD }, // 154
  { PseudoVAMOADDEI64_WD_M1_M1, VAMOADDEI64_WD }, // 155
  { PseudoVAMOADDEI64_WD_M1_M1_MASK, VAMOADDEI64_WD }, // 156
  { PseudoVAMOADDEI64_WD_M1_M2, VAMOADDEI64_WD }, // 157
  { PseudoVAMOADDEI64_WD_M1_M2_MASK, VAMOADDEI64_WD }, // 158
  { PseudoVAMOADDEI64_WD_M2_M2, VAMOADDEI64_WD }, // 159
  { PseudoVAMOADDEI64_WD_M2_M2_MASK, VAMOADDEI64_WD }, // 160
  { PseudoVAMOADDEI64_WD_M2_M4, VAMOADDEI64_WD }, // 161
  { PseudoVAMOADDEI64_WD_M2_M4_MASK, VAMOADDEI64_WD }, // 162
  { PseudoVAMOADDEI64_WD_M4_M4, VAMOADDEI64_WD }, // 163
  { PseudoVAMOADDEI64_WD_M4_M4_MASK, VAMOADDEI64_WD }, // 164
  { PseudoVAMOADDEI64_WD_M4_M8, VAMOADDEI64_WD }, // 165
  { PseudoVAMOADDEI64_WD_M4_M8_MASK, VAMOADDEI64_WD }, // 166
  { PseudoVAMOADDEI64_WD_M8_M8, VAMOADDEI64_WD }, // 167
  { PseudoVAMOADDEI64_WD_M8_M8_MASK, VAMOADDEI64_WD }, // 168
  { PseudoVAMOADDEI64_WD_MF2_M1, VAMOADDEI64_WD }, // 169
  { PseudoVAMOADDEI64_WD_MF2_M1_MASK, VAMOADDEI64_WD }, // 170
  { PseudoVAMOADDEI8_WD_M1_MF4, VAMOADDEI8_WD }, // 171
  { PseudoVAMOADDEI8_WD_M1_MF4_MASK, VAMOADDEI8_WD }, // 172
  { PseudoVAMOADDEI8_WD_M1_MF8, VAMOADDEI8_WD }, // 173
  { PseudoVAMOADDEI8_WD_M1_MF8_MASK, VAMOADDEI8_WD }, // 174
  { PseudoVAMOADDEI8_WD_M2_MF2, VAMOADDEI8_WD }, // 175
  { PseudoVAMOADDEI8_WD_M2_MF2_MASK, VAMOADDEI8_WD }, // 176
  { PseudoVAMOADDEI8_WD_M2_MF4, VAMOADDEI8_WD }, // 177
  { PseudoVAMOADDEI8_WD_M2_MF4_MASK, VAMOADDEI8_WD }, // 178
  { PseudoVAMOADDEI8_WD_M4_M1, VAMOADDEI8_WD }, // 179
  { PseudoVAMOADDEI8_WD_M4_M1_MASK, VAMOADDEI8_WD }, // 180
  { PseudoVAMOADDEI8_WD_M4_MF2, VAMOADDEI8_WD }, // 181
  { PseudoVAMOADDEI8_WD_M4_MF2_MASK, VAMOADDEI8_WD }, // 182
  { PseudoVAMOADDEI8_WD_M8_M1, VAMOADDEI8_WD }, // 183
  { PseudoVAMOADDEI8_WD_M8_M1_MASK, VAMOADDEI8_WD }, // 184
  { PseudoVAMOADDEI8_WD_M8_M2, VAMOADDEI8_WD }, // 185
  { PseudoVAMOADDEI8_WD_M8_M2_MASK, VAMOADDEI8_WD }, // 186
  { PseudoVAMOADDEI8_WD_MF2_MF8, VAMOADDEI8_WD }, // 187
  { PseudoVAMOADDEI8_WD_MF2_MF8_MASK, VAMOADDEI8_WD }, // 188
  { PseudoVAMOANDEI16_WD_M1_MF2, VAMOANDEI16_WD }, // 189
  { PseudoVAMOANDEI16_WD_M1_MF2_MASK, VAMOANDEI16_WD }, // 190
  { PseudoVAMOANDEI16_WD_M1_MF4, VAMOANDEI16_WD }, // 191
  { PseudoVAMOANDEI16_WD_M1_MF4_MASK, VAMOANDEI16_WD }, // 192
  { PseudoVAMOANDEI16_WD_M2_M1, VAMOANDEI16_WD }, // 193
  { PseudoVAMOANDEI16_WD_M2_M1_MASK, VAMOANDEI16_WD }, // 194
  { PseudoVAMOANDEI16_WD_M2_MF2, VAMOANDEI16_WD }, // 195
  { PseudoVAMOANDEI16_WD_M2_MF2_MASK, VAMOANDEI16_WD }, // 196
  { PseudoVAMOANDEI16_WD_M4_M1, VAMOANDEI16_WD }, // 197
  { PseudoVAMOANDEI16_WD_M4_M1_MASK, VAMOANDEI16_WD }, // 198
  { PseudoVAMOANDEI16_WD_M4_M2, VAMOANDEI16_WD }, // 199
  { PseudoVAMOANDEI16_WD_M4_M2_MASK, VAMOANDEI16_WD }, // 200
  { PseudoVAMOANDEI16_WD_M8_M2, VAMOANDEI16_WD }, // 201
  { PseudoVAMOANDEI16_WD_M8_M2_MASK, VAMOANDEI16_WD }, // 202
  { PseudoVAMOANDEI16_WD_M8_M4, VAMOANDEI16_WD }, // 203
  { PseudoVAMOANDEI16_WD_M8_M4_MASK, VAMOANDEI16_WD }, // 204
  { PseudoVAMOANDEI16_WD_MF2_MF4, VAMOANDEI16_WD }, // 205
  { PseudoVAMOANDEI16_WD_MF2_MF4_MASK, VAMOANDEI16_WD }, // 206
  { PseudoVAMOANDEI32_WD_M1_M1, VAMOANDEI32_WD }, // 207
  { PseudoVAMOANDEI32_WD_M1_M1_MASK, VAMOANDEI32_WD }, // 208
  { PseudoVAMOANDEI32_WD_M1_MF2, VAMOANDEI32_WD }, // 209
  { PseudoVAMOANDEI32_WD_M1_MF2_MASK, VAMOANDEI32_WD }, // 210
  { PseudoVAMOANDEI32_WD_M2_M1, VAMOANDEI32_WD }, // 211
  { PseudoVAMOANDEI32_WD_M2_M1_MASK, VAMOANDEI32_WD }, // 212
  { PseudoVAMOANDEI32_WD_M2_M2, VAMOANDEI32_WD }, // 213
  { PseudoVAMOANDEI32_WD_M2_M2_MASK, VAMOANDEI32_WD }, // 214
  { PseudoVAMOANDEI32_WD_M4_M2, VAMOANDEI32_WD }, // 215
  { PseudoVAMOANDEI32_WD_M4_M2_MASK, VAMOANDEI32_WD }, // 216
  { PseudoVAMOANDEI32_WD_M4_M4, VAMOANDEI32_WD }, // 217
  { PseudoVAMOANDEI32_WD_M4_M4_MASK, VAMOANDEI32_WD }, // 218
  { PseudoVAMOANDEI32_WD_M8_M4, VAMOANDEI32_WD }, // 219
  { PseudoVAMOANDEI32_WD_M8_M4_MASK, VAMOANDEI32_WD }, // 220
  { PseudoVAMOANDEI32_WD_M8_M8, VAMOANDEI32_WD }, // 221
  { PseudoVAMOANDEI32_WD_M8_M8_MASK, VAMOANDEI32_WD }, // 222
  { PseudoVAMOANDEI32_WD_MF2_MF2, VAMOANDEI32_WD }, // 223
  { PseudoVAMOANDEI32_WD_MF2_MF2_MASK, VAMOANDEI32_WD }, // 224
  { PseudoVAMOANDEI64_WD_M1_M1, VAMOANDEI64_WD }, // 225
  { PseudoVAMOANDEI64_WD_M1_M1_MASK, VAMOANDEI64_WD }, // 226
  { PseudoVAMOANDEI64_WD_M1_M2, VAMOANDEI64_WD }, // 227
  { PseudoVAMOANDEI64_WD_M1_M2_MASK, VAMOANDEI64_WD }, // 228
  { PseudoVAMOANDEI64_WD_M2_M2, VAMOANDEI64_WD }, // 229
  { PseudoVAMOANDEI64_WD_M2_M2_MASK, VAMOANDEI64_WD }, // 230
  { PseudoVAMOANDEI64_WD_M2_M4, VAMOANDEI64_WD }, // 231
  { PseudoVAMOANDEI64_WD_M2_M4_MASK, VAMOANDEI64_WD }, // 232
  { PseudoVAMOANDEI64_WD_M4_M4, VAMOANDEI64_WD }, // 233
  { PseudoVAMOANDEI64_WD_M4_M4_MASK, VAMOANDEI64_WD }, // 234
  { PseudoVAMOANDEI64_WD_M4_M8, VAMOANDEI64_WD }, // 235
  { PseudoVAMOANDEI64_WD_M4_M8_MASK, VAMOANDEI64_WD }, // 236
  { PseudoVAMOANDEI64_WD_M8_M8, VAMOANDEI64_WD }, // 237
  { PseudoVAMOANDEI64_WD_M8_M8_MASK, VAMOANDEI64_WD }, // 238
  { PseudoVAMOANDEI64_WD_MF2_M1, VAMOANDEI64_WD }, // 239
  { PseudoVAMOANDEI64_WD_MF2_M1_MASK, VAMOANDEI64_WD }, // 240
  { PseudoVAMOANDEI8_WD_M1_MF4, VAMOANDEI8_WD }, // 241
  { PseudoVAMOANDEI8_WD_M1_MF4_MASK, VAMOANDEI8_WD }, // 242
  { PseudoVAMOANDEI8_WD_M1_MF8, VAMOANDEI8_WD }, // 243
  { PseudoVAMOANDEI8_WD_M1_MF8_MASK, VAMOANDEI8_WD }, // 244
  { PseudoVAMOANDEI8_WD_M2_MF2, VAMOANDEI8_WD }, // 245
  { PseudoVAMOANDEI8_WD_M2_MF2_MASK, VAMOANDEI8_WD }, // 246
  { PseudoVAMOANDEI8_WD_M2_MF4, VAMOANDEI8_WD }, // 247
  { PseudoVAMOANDEI8_WD_M2_MF4_MASK, VAMOANDEI8_WD }, // 248
  { PseudoVAMOANDEI8_WD_M4_M1, VAMOANDEI8_WD }, // 249
  { PseudoVAMOANDEI8_WD_M4_M1_MASK, VAMOANDEI8_WD }, // 250
  { PseudoVAMOANDEI8_WD_M4_MF2, VAMOANDEI8_WD }, // 251
  { PseudoVAMOANDEI8_WD_M4_MF2_MASK, VAMOANDEI8_WD }, // 252
  { PseudoVAMOANDEI8_WD_M8_M1, VAMOANDEI8_WD }, // 253
  { PseudoVAMOANDEI8_WD_M8_M1_MASK, VAMOANDEI8_WD }, // 254
  { PseudoVAMOANDEI8_WD_M8_M2, VAMOANDEI8_WD }, // 255
  { PseudoVAMOANDEI8_WD_M8_M2_MASK, VAMOANDEI8_WD }, // 256
  { PseudoVAMOANDEI8_WD_MF2_MF8, VAMOANDEI8_WD }, // 257
  { PseudoVAMOANDEI8_WD_MF2_MF8_MASK, VAMOANDEI8_WD }, // 258
  { PseudoVAMOMAXEI16_WD_M1_MF2, VAMOMAXEI16_WD }, // 259
  { PseudoVAMOMAXEI16_WD_M1_MF2_MASK, VAMOMAXEI16_WD }, // 260
  { PseudoVAMOMAXEI16_WD_M1_MF4, VAMOMAXEI16_WD }, // 261
  { PseudoVAMOMAXEI16_WD_M1_MF4_MASK, VAMOMAXEI16_WD }, // 262
  { PseudoVAMOMAXEI16_WD_M2_M1, VAMOMAXEI16_WD }, // 263
  { PseudoVAMOMAXEI16_WD_M2_M1_MASK, VAMOMAXEI16_WD }, // 264
  { PseudoVAMOMAXEI16_WD_M2_MF2, VAMOMAXEI16_WD }, // 265
  { PseudoVAMOMAXEI16_WD_M2_MF2_MASK, VAMOMAXEI16_WD }, // 266
  { PseudoVAMOMAXEI16_WD_M4_M1, VAMOMAXEI16_WD }, // 267
  { PseudoVAMOMAXEI16_WD_M4_M1_MASK, VAMOMAXEI16_WD }, // 268
  { PseudoVAMOMAXEI16_WD_M4_M2, VAMOMAXEI16_WD }, // 269
  { PseudoVAMOMAXEI16_WD_M4_M2_MASK, VAMOMAXEI16_WD }, // 270
  { PseudoVAMOMAXEI16_WD_M8_M2, VAMOMAXEI16_WD }, // 271
  { PseudoVAMOMAXEI16_WD_M8_M2_MASK, VAMOMAXEI16_WD }, // 272
  { PseudoVAMOMAXEI16_WD_M8_M4, VAMOMAXEI16_WD }, // 273
  { PseudoVAMOMAXEI16_WD_M8_M4_MASK, VAMOMAXEI16_WD }, // 274
  { PseudoVAMOMAXEI16_WD_MF2_MF4, VAMOMAXEI16_WD }, // 275
  { PseudoVAMOMAXEI16_WD_MF2_MF4_MASK, VAMOMAXEI16_WD }, // 276
  { PseudoVAMOMAXEI32_WD_M1_M1, VAMOMAXEI32_WD }, // 277
  { PseudoVAMOMAXEI32_WD_M1_M1_MASK, VAMOMAXEI32_WD }, // 278
  { PseudoVAMOMAXEI32_WD_M1_MF2, VAMOMAXEI32_WD }, // 279
  { PseudoVAMOMAXEI32_WD_M1_MF2_MASK, VAMOMAXEI32_WD }, // 280
  { PseudoVAMOMAXEI32_WD_M2_M1, VAMOMAXEI32_WD }, // 281
  { PseudoVAMOMAXEI32_WD_M2_M1_MASK, VAMOMAXEI32_WD }, // 282
  { PseudoVAMOMAXEI32_WD_M2_M2, VAMOMAXEI32_WD }, // 283
  { PseudoVAMOMAXEI32_WD_M2_M2_MASK, VAMOMAXEI32_WD }, // 284
  { PseudoVAMOMAXEI32_WD_M4_M2, VAMOMAXEI32_WD }, // 285
  { PseudoVAMOMAXEI32_WD_M4_M2_MASK, VAMOMAXEI32_WD }, // 286
  { PseudoVAMOMAXEI32_WD_M4_M4, VAMOMAXEI32_WD }, // 287
  { PseudoVAMOMAXEI32_WD_M4_M4_MASK, VAMOMAXEI32_WD }, // 288
  { PseudoVAMOMAXEI32_WD_M8_M4, VAMOMAXEI32_WD }, // 289
  { PseudoVAMOMAXEI32_WD_M8_M4_MASK, VAMOMAXEI32_WD }, // 290
  { PseudoVAMOMAXEI32_WD_M8_M8, VAMOMAXEI32_WD }, // 291
  { PseudoVAMOMAXEI32_WD_M8_M8_MASK, VAMOMAXEI32_WD }, // 292
  { PseudoVAMOMAXEI32_WD_MF2_MF2, VAMOMAXEI32_WD }, // 293
  { PseudoVAMOMAXEI32_WD_MF2_MF2_MASK, VAMOMAXEI32_WD }, // 294
  { PseudoVAMOMAXEI64_WD_M1_M1, VAMOMAXEI64_WD }, // 295
  { PseudoVAMOMAXEI64_WD_M1_M1_MASK, VAMOMAXEI64_WD }, // 296
  { PseudoVAMOMAXEI64_WD_M1_M2, VAMOMAXEI64_WD }, // 297
  { PseudoVAMOMAXEI64_WD_M1_M2_MASK, VAMOMAXEI64_WD }, // 298
  { PseudoVAMOMAXEI64_WD_M2_M2, VAMOMAXEI64_WD }, // 299
  { PseudoVAMOMAXEI64_WD_M2_M2_MASK, VAMOMAXEI64_WD }, // 300
  { PseudoVAMOMAXEI64_WD_M2_M4, VAMOMAXEI64_WD }, // 301
  { PseudoVAMOMAXEI64_WD_M2_M4_MASK, VAMOMAXEI64_WD }, // 302
  { PseudoVAMOMAXEI64_WD_M4_M4, VAMOMAXEI64_WD }, // 303
  { PseudoVAMOMAXEI64_WD_M4_M4_MASK, VAMOMAXEI64_WD }, // 304
  { PseudoVAMOMAXEI64_WD_M4_M8, VAMOMAXEI64_WD }, // 305
  { PseudoVAMOMAXEI64_WD_M4_M8_MASK, VAMOMAXEI64_WD }, // 306
  { PseudoVAMOMAXEI64_WD_M8_M8, VAMOMAXEI64_WD }, // 307
  { PseudoVAMOMAXEI64_WD_M8_M8_MASK, VAMOMAXEI64_WD }, // 308
  { PseudoVAMOMAXEI64_WD_MF2_M1, VAMOMAXEI64_WD }, // 309
  { PseudoVAMOMAXEI64_WD_MF2_M1_MASK, VAMOMAXEI64_WD }, // 310
  { PseudoVAMOMAXEI8_WD_M1_MF4, VAMOMAXEI8_WD }, // 311
  { PseudoVAMOMAXEI8_WD_M1_MF4_MASK, VAMOMAXEI8_WD }, // 312
  { PseudoVAMOMAXEI8_WD_M1_MF8, VAMOMAXEI8_WD }, // 313
  { PseudoVAMOMAXEI8_WD_M1_MF8_MASK, VAMOMAXEI8_WD }, // 314
  { PseudoVAMOMAXEI8_WD_M2_MF2, VAMOMAXEI8_WD }, // 315
  { PseudoVAMOMAXEI8_WD_M2_MF2_MASK, VAMOMAXEI8_WD }, // 316
  { PseudoVAMOMAXEI8_WD_M2_MF4, VAMOMAXEI8_WD }, // 317
  { PseudoVAMOMAXEI8_WD_M2_MF4_MASK, VAMOMAXEI8_WD }, // 318
  { PseudoVAMOMAXEI8_WD_M4_M1, VAMOMAXEI8_WD }, // 319
  { PseudoVAMOMAXEI8_WD_M4_M1_MASK, VAMOMAXEI8_WD }, // 320
  { PseudoVAMOMAXEI8_WD_M4_MF2, VAMOMAXEI8_WD }, // 321
  { PseudoVAMOMAXEI8_WD_M4_MF2_MASK, VAMOMAXEI8_WD }, // 322
  { PseudoVAMOMAXEI8_WD_M8_M1, VAMOMAXEI8_WD }, // 323
  { PseudoVAMOMAXEI8_WD_M8_M1_MASK, VAMOMAXEI8_WD }, // 324
  { PseudoVAMOMAXEI8_WD_M8_M2, VAMOMAXEI8_WD }, // 325
  { PseudoVAMOMAXEI8_WD_M8_M2_MASK, VAMOMAXEI8_WD }, // 326
  { PseudoVAMOMAXEI8_WD_MF2_MF8, VAMOMAXEI8_WD }, // 327
  { PseudoVAMOMAXEI8_WD_MF2_MF8_MASK, VAMOMAXEI8_WD }, // 328
  { PseudoVAMOMAXUEI16_WD_M1_MF2, VAMOMAXUEI16_WD }, // 329
  { PseudoVAMOMAXUEI16_WD_M1_MF2_MASK, VAMOMAXUEI16_WD }, // 330
  { PseudoVAMOMAXUEI16_WD_M1_MF4, VAMOMAXUEI16_WD }, // 331
  { PseudoVAMOMAXUEI16_WD_M1_MF4_MASK, VAMOMAXUEI16_WD }, // 332
  { PseudoVAMOMAXUEI16_WD_M2_M1, VAMOMAXUEI16_WD }, // 333
  { PseudoVAMOMAXUEI16_WD_M2_M1_MASK, VAMOMAXUEI16_WD }, // 334
  { PseudoVAMOMAXUEI16_WD_M2_MF2, VAMOMAXUEI16_WD }, // 335
  { PseudoVAMOMAXUEI16_WD_M2_MF2_MASK, VAMOMAXUEI16_WD }, // 336
  { PseudoVAMOMAXUEI16_WD_M4_M1, VAMOMAXUEI16_WD }, // 337
  { PseudoVAMOMAXUEI16_WD_M4_M1_MASK, VAMOMAXUEI16_WD }, // 338
  { PseudoVAMOMAXUEI16_WD_M4_M2, VAMOMAXUEI16_WD }, // 339
  { PseudoVAMOMAXUEI16_WD_M4_M2_MASK, VAMOMAXUEI16_WD }, // 340
  { PseudoVAMOMAXUEI16_WD_M8_M2, VAMOMAXUEI16_WD }, // 341
  { PseudoVAMOMAXUEI16_WD_M8_M2_MASK, VAMOMAXUEI16_WD }, // 342
  { PseudoVAMOMAXUEI16_WD_M8_M4, VAMOMAXUEI16_WD }, // 343
  { PseudoVAMOMAXUEI16_WD_M8_M4_MASK, VAMOMAXUEI16_WD }, // 344
  { PseudoVAMOMAXUEI16_WD_MF2_MF4, VAMOMAXUEI16_WD }, // 345
  { PseudoVAMOMAXUEI16_WD_MF2_MF4_MASK, VAMOMAXUEI16_WD }, // 346
  { PseudoVAMOMAXUEI32_WD_M1_M1, VAMOMAXUEI32_WD }, // 347
  { PseudoVAMOMAXUEI32_WD_M1_M1_MASK, VAMOMAXUEI32_WD }, // 348
  { PseudoVAMOMAXUEI32_WD_M1_MF2, VAMOMAXUEI32_WD }, // 349
  { PseudoVAMOMAXUEI32_WD_M1_MF2_MASK, VAMOMAXUEI32_WD }, // 350
  { PseudoVAMOMAXUEI32_WD_M2_M1, VAMOMAXUEI32_WD }, // 351
  { PseudoVAMOMAXUEI32_WD_M2_M1_MASK, VAMOMAXUEI32_WD }, // 352
  { PseudoVAMOMAXUEI32_WD_M2_M2, VAMOMAXUEI32_WD }, // 353
  { PseudoVAMOMAXUEI32_WD_M2_M2_MASK, VAMOMAXUEI32_WD }, // 354
  { PseudoVAMOMAXUEI32_WD_M4_M2, VAMOMAXUEI32_WD }, // 355
  { PseudoVAMOMAXUEI32_WD_M4_M2_MASK, VAMOMAXUEI32_WD }, // 356
  { PseudoVAMOMAXUEI32_WD_M4_M4, VAMOMAXUEI32_WD }, // 357
  { PseudoVAMOMAXUEI32_WD_M4_M4_MASK, VAMOMAXUEI32_WD }, // 358
  { PseudoVAMOMAXUEI32_WD_M8_M4, VAMOMAXUEI32_WD }, // 359
  { PseudoVAMOMAXUEI32_WD_M8_M4_MASK, VAMOMAXUEI32_WD }, // 360
  { PseudoVAMOMAXUEI32_WD_M8_M8, VAMOMAXUEI32_WD }, // 361
  { PseudoVAMOMAXUEI32_WD_M8_M8_MASK, VAMOMAXUEI32_WD }, // 362
  { PseudoVAMOMAXUEI32_WD_MF2_MF2, VAMOMAXUEI32_WD }, // 363
  { PseudoVAMOMAXUEI32_WD_MF2_MF2_MASK, VAMOMAXUEI32_WD }, // 364
  { PseudoVAMOMAXUEI64_WD_M1_M1, VAMOMAXUEI64_WD }, // 365
  { PseudoVAMOMAXUEI64_WD_M1_M1_MASK, VAMOMAXUEI64_WD }, // 366
  { PseudoVAMOMAXUEI64_WD_M1_M2, VAMOMAXUEI64_WD }, // 367
  { PseudoVAMOMAXUEI64_WD_M1_M2_MASK, VAMOMAXUEI64_WD }, // 368
  { PseudoVAMOMAXUEI64_WD_M2_M2, VAMOMAXUEI64_WD }, // 369
  { PseudoVAMOMAXUEI64_WD_M2_M2_MASK, VAMOMAXUEI64_WD }, // 370
  { PseudoVAMOMAXUEI64_WD_M2_M4, VAMOMAXUEI64_WD }, // 371
  { PseudoVAMOMAXUEI64_WD_M2_M4_MASK, VAMOMAXUEI64_WD }, // 372
  { PseudoVAMOMAXUEI64_WD_M4_M4, VAMOMAXUEI64_WD }, // 373
  { PseudoVAMOMAXUEI64_WD_M4_M4_MASK, VAMOMAXUEI64_WD }, // 374
  { PseudoVAMOMAXUEI64_WD_M4_M8, VAMOMAXUEI64_WD }, // 375
  { PseudoVAMOMAXUEI64_WD_M4_M8_MASK, VAMOMAXUEI64_WD }, // 376
  { PseudoVAMOMAXUEI64_WD_M8_M8, VAMOMAXUEI64_WD }, // 377
  { PseudoVAMOMAXUEI64_WD_M8_M8_MASK, VAMOMAXUEI64_WD }, // 378
  { PseudoVAMOMAXUEI64_WD_MF2_M1, VAMOMAXUEI64_WD }, // 379
  { PseudoVAMOMAXUEI64_WD_MF2_M1_MASK, VAMOMAXUEI64_WD }, // 380
  { PseudoVAMOMAXUEI8_WD_M1_MF4, VAMOMAXUEI8_WD }, // 381
  { PseudoVAMOMAXUEI8_WD_M1_MF4_MASK, VAMOMAXUEI8_WD }, // 382
  { PseudoVAMOMAXUEI8_WD_M1_MF8, VAMOMAXUEI8_WD }, // 383
  { PseudoVAMOMAXUEI8_WD_M1_MF8_MASK, VAMOMAXUEI8_WD }, // 384
  { PseudoVAMOMAXUEI8_WD_M2_MF2, VAMOMAXUEI8_WD }, // 385
  { PseudoVAMOMAXUEI8_WD_M2_MF2_MASK, VAMOMAXUEI8_WD }, // 386
  { PseudoVAMOMAXUEI8_WD_M2_MF4, VAMOMAXUEI8_WD }, // 387
  { PseudoVAMOMAXUEI8_WD_M2_MF4_MASK, VAMOMAXUEI8_WD }, // 388
  { PseudoVAMOMAXUEI8_WD_M4_M1, VAMOMAXUEI8_WD }, // 389
  { PseudoVAMOMAXUEI8_WD_M4_M1_MASK, VAMOMAXUEI8_WD }, // 390
  { PseudoVAMOMAXUEI8_WD_M4_MF2, VAMOMAXUEI8_WD }, // 391
  { PseudoVAMOMAXUEI8_WD_M4_MF2_MASK, VAMOMAXUEI8_WD }, // 392
  { PseudoVAMOMAXUEI8_WD_M8_M1, VAMOMAXUEI8_WD }, // 393
  { PseudoVAMOMAXUEI8_WD_M8_M1_MASK, VAMOMAXUEI8_WD }, // 394
  { PseudoVAMOMAXUEI8_WD_M8_M2, VAMOMAXUEI8_WD }, // 395
  { PseudoVAMOMAXUEI8_WD_M8_M2_MASK, VAMOMAXUEI8_WD }, // 396
  { PseudoVAMOMAXUEI8_WD_MF2_MF8, VAMOMAXUEI8_WD }, // 397
  { PseudoVAMOMAXUEI8_WD_MF2_MF8_MASK, VAMOMAXUEI8_WD }, // 398
  { PseudoVAMOMINEI16_WD_M1_MF2, VAMOMINEI16_WD }, // 399
  { PseudoVAMOMINEI16_WD_M1_MF2_MASK, VAMOMINEI16_WD }, // 400
  { PseudoVAMOMINEI16_WD_M1_MF4, VAMOMINEI16_WD }, // 401
  { PseudoVAMOMINEI16_WD_M1_MF4_MASK, VAMOMINEI16_WD }, // 402
  { PseudoVAMOMINEI16_WD_M2_M1, VAMOMINEI16_WD }, // 403
  { PseudoVAMOMINEI16_WD_M2_M1_MASK, VAMOMINEI16_WD }, // 404
  { PseudoVAMOMINEI16_WD_M2_MF2, VAMOMINEI16_WD }, // 405
  { PseudoVAMOMINEI16_WD_M2_MF2_MASK, VAMOMINEI16_WD }, // 406
  { PseudoVAMOMINEI16_WD_M4_M1, VAMOMINEI16_WD }, // 407
  { PseudoVAMOMINEI16_WD_M4_M1_MASK, VAMOMINEI16_WD }, // 408
  { PseudoVAMOMINEI16_WD_M4_M2, VAMOMINEI16_WD }, // 409
  { PseudoVAMOMINEI16_WD_M4_M2_MASK, VAMOMINEI16_WD }, // 410
  { PseudoVAMOMINEI16_WD_M8_M2, VAMOMINEI16_WD }, // 411
  { PseudoVAMOMINEI16_WD_M8_M2_MASK, VAMOMINEI16_WD }, // 412
  { PseudoVAMOMINEI16_WD_M8_M4, VAMOMINEI16_WD }, // 413
  { PseudoVAMOMINEI16_WD_M8_M4_MASK, VAMOMINEI16_WD }, // 414
  { PseudoVAMOMINEI16_WD_MF2_MF4, VAMOMINEI16_WD }, // 415
  { PseudoVAMOMINEI16_WD_MF2_MF4_MASK, VAMOMINEI16_WD }, // 416
  { PseudoVAMOMINEI32_WD_M1_M1, VAMOMINEI32_WD }, // 417
  { PseudoVAMOMINEI32_WD_M1_M1_MASK, VAMOMINEI32_WD }, // 418
  { PseudoVAMOMINEI32_WD_M1_MF2, VAMOMINEI32_WD }, // 419
  { PseudoVAMOMINEI32_WD_M1_MF2_MASK, VAMOMINEI32_WD }, // 420
  { PseudoVAMOMINEI32_WD_M2_M1, VAMOMINEI32_WD }, // 421
  { PseudoVAMOMINEI32_WD_M2_M1_MASK, VAMOMINEI32_WD }, // 422
  { PseudoVAMOMINEI32_WD_M2_M2, VAMOMINEI32_WD }, // 423
  { PseudoVAMOMINEI32_WD_M2_M2_MASK, VAMOMINEI32_WD }, // 424
  { PseudoVAMOMINEI32_WD_M4_M2, VAMOMINEI32_WD }, // 425
  { PseudoVAMOMINEI32_WD_M4_M2_MASK, VAMOMINEI32_WD }, // 426
  { PseudoVAMOMINEI32_WD_M4_M4, VAMOMINEI32_WD }, // 427
  { PseudoVAMOMINEI32_WD_M4_M4_MASK, VAMOMINEI32_WD }, // 428
  { PseudoVAMOMINEI32_WD_M8_M4, VAMOMINEI32_WD }, // 429
  { PseudoVAMOMINEI32_WD_M8_M4_MASK, VAMOMINEI32_WD }, // 430
  { PseudoVAMOMINEI32_WD_M8_M8, VAMOMINEI32_WD }, // 431
  { PseudoVAMOMINEI32_WD_M8_M8_MASK, VAMOMINEI32_WD }, // 432
  { PseudoVAMOMINEI32_WD_MF2_MF2, VAMOMINEI32_WD }, // 433
  { PseudoVAMOMINEI32_WD_MF2_MF2_MASK, VAMOMINEI32_WD }, // 434
  { PseudoVAMOMINEI64_WD_M1_M1, VAMOMINEI64_WD }, // 435
  { PseudoVAMOMINEI64_WD_M1_M1_MASK, VAMOMINEI64_WD }, // 436
  { PseudoVAMOMINEI64_WD_M1_M2, VAMOMINEI64_WD }, // 437
  { PseudoVAMOMINEI64_WD_M1_M2_MASK, VAMOMINEI64_WD }, // 438
  { PseudoVAMOMINEI64_WD_M2_M2, VAMOMINEI64_WD }, // 439
  { PseudoVAMOMINEI64_WD_M2_M2_MASK, VAMOMINEI64_WD }, // 440
  { PseudoVAMOMINEI64_WD_M2_M4, VAMOMINEI64_WD }, // 441
  { PseudoVAMOMINEI64_WD_M2_M4_MASK, VAMOMINEI64_WD }, // 442
  { PseudoVAMOMINEI64_WD_M4_M4, VAMOMINEI64_WD }, // 443
  { PseudoVAMOMINEI64_WD_M4_M4_MASK, VAMOMINEI64_WD }, // 444
  { PseudoVAMOMINEI64_WD_M4_M8, VAMOMINEI64_WD }, // 445
  { PseudoVAMOMINEI64_WD_M4_M8_MASK, VAMOMINEI64_WD }, // 446
  { PseudoVAMOMINEI64_WD_M8_M8, VAMOMINEI64_WD }, // 447
  { PseudoVAMOMINEI64_WD_M8_M8_MASK, VAMOMINEI64_WD }, // 448
  { PseudoVAMOMINEI64_WD_MF2_M1, VAMOMINEI64_WD }, // 449
  { PseudoVAMOMINEI64_WD_MF2_M1_MASK, VAMOMINEI64_WD }, // 450
  { PseudoVAMOMINEI8_WD_M1_MF4, VAMOMINEI8_WD }, // 451
  { PseudoVAMOMINEI8_WD_M1_MF4_MASK, VAMOMINEI8_WD }, // 452
  { PseudoVAMOMINEI8_WD_M1_MF8, VAMOMINEI8_WD }, // 453
  { PseudoVAMOMINEI8_WD_M1_MF8_MASK, VAMOMINEI8_WD }, // 454
  { PseudoVAMOMINEI8_WD_M2_MF2, VAMOMINEI8_WD }, // 455
  { PseudoVAMOMINEI8_WD_M2_MF2_MASK, VAMOMINEI8_WD }, // 456
  { PseudoVAMOMINEI8_WD_M2_MF4, VAMOMINEI8_WD }, // 457
  { PseudoVAMOMINEI8_WD_M2_MF4_MASK, VAMOMINEI8_WD }, // 458
  { PseudoVAMOMINEI8_WD_M4_M1, VAMOMINEI8_WD }, // 459
  { PseudoVAMOMINEI8_WD_M4_M1_MASK, VAMOMINEI8_WD }, // 460
  { PseudoVAMOMINEI8_WD_M4_MF2, VAMOMINEI8_WD }, // 461
  { PseudoVAMOMINEI8_WD_M4_MF2_MASK, VAMOMINEI8_WD }, // 462
  { PseudoVAMOMINEI8_WD_M8_M1, VAMOMINEI8_WD }, // 463
  { PseudoVAMOMINEI8_WD_M8_M1_MASK, VAMOMINEI8_WD }, // 464
  { PseudoVAMOMINEI8_WD_M8_M2, VAMOMINEI8_WD }, // 465
  { PseudoVAMOMINEI8_WD_M8_M2_MASK, VAMOMINEI8_WD }, // 466
  { PseudoVAMOMINEI8_WD_MF2_MF8, VAMOMINEI8_WD }, // 467
  { PseudoVAMOMINEI8_WD_MF2_MF8_MASK, VAMOMINEI8_WD }, // 468
  { PseudoVAMOMINUEI16_WD_M1_MF2, VAMOMINUEI16_WD }, // 469
  { PseudoVAMOMINUEI16_WD_M1_MF2_MASK, VAMOMINUEI16_WD }, // 470
  { PseudoVAMOMINUEI16_WD_M1_MF4, VAMOMINUEI16_WD }, // 471
  { PseudoVAMOMINUEI16_WD_M1_MF4_MASK, VAMOMINUEI16_WD }, // 472
  { PseudoVAMOMINUEI16_WD_M2_M1, VAMOMINUEI16_WD }, // 473
  { PseudoVAMOMINUEI16_WD_M2_M1_MASK, VAMOMINUEI16_WD }, // 474
  { PseudoVAMOMINUEI16_WD_M2_MF2, VAMOMINUEI16_WD }, // 475
  { PseudoVAMOMINUEI16_WD_M2_MF2_MASK, VAMOMINUEI16_WD }, // 476
  { PseudoVAMOMINUEI16_WD_M4_M1, VAMOMINUEI16_WD }, // 477
  { PseudoVAMOMINUEI16_WD_M4_M1_MASK, VAMOMINUEI16_WD }, // 478
  { PseudoVAMOMINUEI16_WD_M4_M2, VAMOMINUEI16_WD }, // 479
  { PseudoVAMOMINUEI16_WD_M4_M2_MASK, VAMOMINUEI16_WD }, // 480
  { PseudoVAMOMINUEI16_WD_M8_M2, VAMOMINUEI16_WD }, // 481
  { PseudoVAMOMINUEI16_WD_M8_M2_MASK, VAMOMINUEI16_WD }, // 482
  { PseudoVAMOMINUEI16_WD_M8_M4, VAMOMINUEI16_WD }, // 483
  { PseudoVAMOMINUEI16_WD_M8_M4_MASK, VAMOMINUEI16_WD }, // 484
  { PseudoVAMOMINUEI16_WD_MF2_MF4, VAMOMINUEI16_WD }, // 485
  { PseudoVAMOMINUEI16_WD_MF2_MF4_MASK, VAMOMINUEI16_WD }, // 486
  { PseudoVAMOMINUEI32_WD_M1_M1, VAMOMINUEI32_WD }, // 487
  { PseudoVAMOMINUEI32_WD_M1_M1_MASK, VAMOMINUEI32_WD }, // 488
  { PseudoVAMOMINUEI32_WD_M1_MF2, VAMOMINUEI32_WD }, // 489
  { PseudoVAMOMINUEI32_WD_M1_MF2_MASK, VAMOMINUEI32_WD }, // 490
  { PseudoVAMOMINUEI32_WD_M2_M1, VAMOMINUEI32_WD }, // 491
  { PseudoVAMOMINUEI32_WD_M2_M1_MASK, VAMOMINUEI32_WD }, // 492
  { PseudoVAMOMINUEI32_WD_M2_M2, VAMOMINUEI32_WD }, // 493
  { PseudoVAMOMINUEI32_WD_M2_M2_MASK, VAMOMINUEI32_WD }, // 494
  { PseudoVAMOMINUEI32_WD_M4_M2, VAMOMINUEI32_WD }, // 495
  { PseudoVAMOMINUEI32_WD_M4_M2_MASK, VAMOMINUEI32_WD }, // 496
  { PseudoVAMOMINUEI32_WD_M4_M4, VAMOMINUEI32_WD }, // 497
  { PseudoVAMOMINUEI32_WD_M4_M4_MASK, VAMOMINUEI32_WD }, // 498
  { PseudoVAMOMINUEI32_WD_M8_M4, VAMOMINUEI32_WD }, // 499
  { PseudoVAMOMINUEI32_WD_M8_M4_MASK, VAMOMINUEI32_WD }, // 500
  { PseudoVAMOMINUEI32_WD_M8_M8, VAMOMINUEI32_WD }, // 501
  { PseudoVAMOMINUEI32_WD_M8_M8_MASK, VAMOMINUEI32_WD }, // 502
  { PseudoVAMOMINUEI32_WD_MF2_MF2, VAMOMINUEI32_WD }, // 503
  { PseudoVAMOMINUEI32_WD_MF2_MF2_MASK, VAMOMINUEI32_WD }, // 504
  { PseudoVAMOMINUEI64_WD_M1_M1, VAMOMINUEI64_WD }, // 505
  { PseudoVAMOMINUEI64_WD_M1_M1_MASK, VAMOMINUEI64_WD }, // 506
  { PseudoVAMOMINUEI64_WD_M1_M2, VAMOMINUEI64_WD }, // 507
  { PseudoVAMOMINUEI64_WD_M1_M2_MASK, VAMOMINUEI64_WD }, // 508
  { PseudoVAMOMINUEI64_WD_M2_M2, VAMOMINUEI64_WD }, // 509
  { PseudoVAMOMINUEI64_WD_M2_M2_MASK, VAMOMINUEI64_WD }, // 510
  { PseudoVAMOMINUEI64_WD_M2_M4, VAMOMINUEI64_WD }, // 511
  { PseudoVAMOMINUEI64_WD_M2_M4_MASK, VAMOMINUEI64_WD }, // 512
  { PseudoVAMOMINUEI64_WD_M4_M4, VAMOMINUEI64_WD }, // 513
  { PseudoVAMOMINUEI64_WD_M4_M4_MASK, VAMOMINUEI64_WD }, // 514
  { PseudoVAMOMINUEI64_WD_M4_M8, VAMOMINUEI64_WD }, // 515
  { PseudoVAMOMINUEI64_WD_M4_M8_MASK, VAMOMINUEI64_WD }, // 516
  { PseudoVAMOMINUEI64_WD_M8_M8, VAMOMINUEI64_WD }, // 517
  { PseudoVAMOMINUEI64_WD_M8_M8_MASK, VAMOMINUEI64_WD }, // 518
  { PseudoVAMOMINUEI64_WD_MF2_M1, VAMOMINUEI64_WD }, // 519
  { PseudoVAMOMINUEI64_WD_MF2_M1_MASK, VAMOMINUEI64_WD }, // 520
  { PseudoVAMOMINUEI8_WD_M1_MF4, VAMOMINUEI8_WD }, // 521
  { PseudoVAMOMINUEI8_WD_M1_MF4_MASK, VAMOMINUEI8_WD }, // 522
  { PseudoVAMOMINUEI8_WD_M1_MF8, VAMOMINUEI8_WD }, // 523
  { PseudoVAMOMINUEI8_WD_M1_MF8_MASK, VAMOMINUEI8_WD }, // 524
  { PseudoVAMOMINUEI8_WD_M2_MF2, VAMOMINUEI8_WD }, // 525
  { PseudoVAMOMINUEI8_WD_M2_MF2_MASK, VAMOMINUEI8_WD }, // 526
  { PseudoVAMOMINUEI8_WD_M2_MF4, VAMOMINUEI8_WD }, // 527
  { PseudoVAMOMINUEI8_WD_M2_MF4_MASK, VAMOMINUEI8_WD }, // 528
  { PseudoVAMOMINUEI8_WD_M4_M1, VAMOMINUEI8_WD }, // 529
  { PseudoVAMOMINUEI8_WD_M4_M1_MASK, VAMOMINUEI8_WD }, // 530
  { PseudoVAMOMINUEI8_WD_M4_MF2, VAMOMINUEI8_WD }, // 531
  { PseudoVAMOMINUEI8_WD_M4_MF2_MASK, VAMOMINUEI8_WD }, // 532
  { PseudoVAMOMINUEI8_WD_M8_M1, VAMOMINUEI8_WD }, // 533
  { PseudoVAMOMINUEI8_WD_M8_M1_MASK, VAMOMINUEI8_WD }, // 534
  { PseudoVAMOMINUEI8_WD_M8_M2, VAMOMINUEI8_WD }, // 535
  { PseudoVAMOMINUEI8_WD_M8_M2_MASK, VAMOMINUEI8_WD }, // 536
  { PseudoVAMOMINUEI8_WD_MF2_MF8, VAMOMINUEI8_WD }, // 537
  { PseudoVAMOMINUEI8_WD_MF2_MF8_MASK, VAMOMINUEI8_WD }, // 538
  { PseudoVAMOOREI16_WD_M1_MF2, VAMOOREI16_WD }, // 539
  { PseudoVAMOOREI16_WD_M1_MF2_MASK, VAMOOREI16_WD }, // 540
  { PseudoVAMOOREI16_WD_M1_MF4, VAMOOREI16_WD }, // 541
  { PseudoVAMOOREI16_WD_M1_MF4_MASK, VAMOOREI16_WD }, // 542
  { PseudoVAMOOREI16_WD_M2_M1, VAMOOREI16_WD }, // 543
  { PseudoVAMOOREI16_WD_M2_M1_MASK, VAMOOREI16_WD }, // 544
  { PseudoVAMOOREI16_WD_M2_MF2, VAMOOREI16_WD }, // 545
  { PseudoVAMOOREI16_WD_M2_MF2_MASK, VAMOOREI16_WD }, // 546
  { PseudoVAMOOREI16_WD_M4_M1, VAMOOREI16_WD }, // 547
  { PseudoVAMOOREI16_WD_M4_M1_MASK, VAMOOREI16_WD }, // 548
  { PseudoVAMOOREI16_WD_M4_M2, VAMOOREI16_WD }, // 549
  { PseudoVAMOOREI16_WD_M4_M2_MASK, VAMOOREI16_WD }, // 550
  { PseudoVAMOOREI16_WD_M8_M2, VAMOOREI16_WD }, // 551
  { PseudoVAMOOREI16_WD_M8_M2_MASK, VAMOOREI16_WD }, // 552
  { PseudoVAMOOREI16_WD_M8_M4, VAMOOREI16_WD }, // 553
  { PseudoVAMOOREI16_WD_M8_M4_MASK, VAMOOREI16_WD }, // 554
  { PseudoVAMOOREI16_WD_MF2_MF4, VAMOOREI16_WD }, // 555
  { PseudoVAMOOREI16_WD_MF2_MF4_MASK, VAMOOREI16_WD }, // 556
  { PseudoVAMOOREI32_WD_M1_M1, VAMOOREI32_WD }, // 557
  { PseudoVAMOOREI32_WD_M1_M1_MASK, VAMOOREI32_WD }, // 558
  { PseudoVAMOOREI32_WD_M1_MF2, VAMOOREI32_WD }, // 559
  { PseudoVAMOOREI32_WD_M1_MF2_MASK, VAMOOREI32_WD }, // 560
  { PseudoVAMOOREI32_WD_M2_M1, VAMOOREI32_WD }, // 561
  { PseudoVAMOOREI32_WD_M2_M1_MASK, VAMOOREI32_WD }, // 562
  { PseudoVAMOOREI32_WD_M2_M2, VAMOOREI32_WD }, // 563
  { PseudoVAMOOREI32_WD_M2_M2_MASK, VAMOOREI32_WD }, // 564
  { PseudoVAMOOREI32_WD_M4_M2, VAMOOREI32_WD }, // 565
  { PseudoVAMOOREI32_WD_M4_M2_MASK, VAMOOREI32_WD }, // 566
  { PseudoVAMOOREI32_WD_M4_M4, VAMOOREI32_WD }, // 567
  { PseudoVAMOOREI32_WD_M4_M4_MASK, VAMOOREI32_WD }, // 568
  { PseudoVAMOOREI32_WD_M8_M4, VAMOOREI32_WD }, // 569
  { PseudoVAMOOREI32_WD_M8_M4_MASK, VAMOOREI32_WD }, // 570
  { PseudoVAMOOREI32_WD_M8_M8, VAMOOREI32_WD }, // 571
  { PseudoVAMOOREI32_WD_M8_M8_MASK, VAMOOREI32_WD }, // 572
  { PseudoVAMOOREI32_WD_MF2_MF2, VAMOOREI32_WD }, // 573
  { PseudoVAMOOREI32_WD_MF2_MF2_MASK, VAMOOREI32_WD }, // 574
  { PseudoVAMOOREI64_WD_M1_M1, VAMOOREI64_WD }, // 575
  { PseudoVAMOOREI64_WD_M1_M1_MASK, VAMOOREI64_WD }, // 576
  { PseudoVAMOOREI64_WD_M1_M2, VAMOOREI64_WD }, // 577
  { PseudoVAMOOREI64_WD_M1_M2_MASK, VAMOOREI64_WD }, // 578
  { PseudoVAMOOREI64_WD_M2_M2, VAMOOREI64_WD }, // 579
  { PseudoVAMOOREI64_WD_M2_M2_MASK, VAMOOREI64_WD }, // 580
  { PseudoVAMOOREI64_WD_M2_M4, VAMOOREI64_WD }, // 581
  { PseudoVAMOOREI64_WD_M2_M4_MASK, VAMOOREI64_WD }, // 582
  { PseudoVAMOOREI64_WD_M4_M4, VAMOOREI64_WD }, // 583
  { PseudoVAMOOREI64_WD_M4_M4_MASK, VAMOOREI64_WD }, // 584
  { PseudoVAMOOREI64_WD_M4_M8, VAMOOREI64_WD }, // 585
  { PseudoVAMOOREI64_WD_M4_M8_MASK, VAMOOREI64_WD }, // 586
  { PseudoVAMOOREI64_WD_M8_M8, VAMOOREI64_WD }, // 587
  { PseudoVAMOOREI64_WD_M8_M8_MASK, VAMOOREI64_WD }, // 588
  { PseudoVAMOOREI64_WD_MF2_M1, VAMOOREI64_WD }, // 589
  { PseudoVAMOOREI64_WD_MF2_M1_MASK, VAMOOREI64_WD }, // 590
  { PseudoVAMOOREI8_WD_M1_MF4, VAMOOREI8_WD }, // 591
  { PseudoVAMOOREI8_WD_M1_MF4_MASK, VAMOOREI8_WD }, // 592
  { PseudoVAMOOREI8_WD_M1_MF8, VAMOOREI8_WD }, // 593
  { PseudoVAMOOREI8_WD_M1_MF8_MASK, VAMOOREI8_WD }, // 594
  { PseudoVAMOOREI8_WD_M2_MF2, VAMOOREI8_WD }, // 595
  { PseudoVAMOOREI8_WD_M2_MF2_MASK, VAMOOREI8_WD }, // 596
  { PseudoVAMOOREI8_WD_M2_MF4, VAMOOREI8_WD }, // 597
  { PseudoVAMOOREI8_WD_M2_MF4_MASK, VAMOOREI8_WD }, // 598
  { PseudoVAMOOREI8_WD_M4_M1, VAMOOREI8_WD }, // 599
  { PseudoVAMOOREI8_WD_M4_M1_MASK, VAMOOREI8_WD }, // 600
  { PseudoVAMOOREI8_WD_M4_MF2, VAMOOREI8_WD }, // 601
  { PseudoVAMOOREI8_WD_M4_MF2_MASK, VAMOOREI8_WD }, // 602
  { PseudoVAMOOREI8_WD_M8_M1, VAMOOREI8_WD }, // 603
  { PseudoVAMOOREI8_WD_M8_M1_MASK, VAMOOREI8_WD }, // 604
  { PseudoVAMOOREI8_WD_M8_M2, VAMOOREI8_WD }, // 605
  { PseudoVAMOOREI8_WD_M8_M2_MASK, VAMOOREI8_WD }, // 606
  { PseudoVAMOOREI8_WD_MF2_MF8, VAMOOREI8_WD }, // 607
  { PseudoVAMOOREI8_WD_MF2_MF8_MASK, VAMOOREI8_WD }, // 608
  { PseudoVAMOSWAPEI16_WD_M1_MF2, VAMOSWAPEI16_WD }, // 609
  { PseudoVAMOSWAPEI16_WD_M1_MF2_MASK, VAMOSWAPEI16_WD }, // 610
  { PseudoVAMOSWAPEI16_WD_M1_MF4, VAMOSWAPEI16_WD }, // 611
  { PseudoVAMOSWAPEI16_WD_M1_MF4_MASK, VAMOSWAPEI16_WD }, // 612
  { PseudoVAMOSWAPEI16_WD_M2_M1, VAMOSWAPEI16_WD }, // 613
  { PseudoVAMOSWAPEI16_WD_M2_M1_MASK, VAMOSWAPEI16_WD }, // 614
  { PseudoVAMOSWAPEI16_WD_M2_MF2, VAMOSWAPEI16_WD }, // 615
  { PseudoVAMOSWAPEI16_WD_M2_MF2_MASK, VAMOSWAPEI16_WD }, // 616
  { PseudoVAMOSWAPEI16_WD_M4_M1, VAMOSWAPEI16_WD }, // 617
  { PseudoVAMOSWAPEI16_WD_M4_M1_MASK, VAMOSWAPEI16_WD }, // 618
  { PseudoVAMOSWAPEI16_WD_M4_M2, VAMOSWAPEI16_WD }, // 619
  { PseudoVAMOSWAPEI16_WD_M4_M2_MASK, VAMOSWAPEI16_WD }, // 620
  { PseudoVAMOSWAPEI16_WD_M8_M2, VAMOSWAPEI16_WD }, // 621
  { PseudoVAMOSWAPEI16_WD_M8_M2_MASK, VAMOSWAPEI16_WD }, // 622
  { PseudoVAMOSWAPEI16_WD_M8_M4, VAMOSWAPEI16_WD }, // 623
  { PseudoVAMOSWAPEI16_WD_M8_M4_MASK, VAMOSWAPEI16_WD }, // 624
  { PseudoVAMOSWAPEI16_WD_MF2_MF4, VAMOSWAPEI16_WD }, // 625
  { PseudoVAMOSWAPEI16_WD_MF2_MF4_MASK, VAMOSWAPEI16_WD }, // 626
  { PseudoVAMOSWAPEI32_WD_M1_M1, VAMOSWAPEI32_WD }, // 627
  { PseudoVAMOSWAPEI32_WD_M1_M1_MASK, VAMOSWAPEI32_WD }, // 628
  { PseudoVAMOSWAPEI32_WD_M1_MF2, VAMOSWAPEI32_WD }, // 629
  { PseudoVAMOSWAPEI32_WD_M1_MF2_MASK, VAMOSWAPEI32_WD }, // 630
  { PseudoVAMOSWAPEI32_WD_M2_M1, VAMOSWAPEI32_WD }, // 631
  { PseudoVAMOSWAPEI32_WD_M2_M1_MASK, VAMOSWAPEI32_WD }, // 632
  { PseudoVAMOSWAPEI32_WD_M2_M2, VAMOSWAPEI32_WD }, // 633
  { PseudoVAMOSWAPEI32_WD_M2_M2_MASK, VAMOSWAPEI32_WD }, // 634
  { PseudoVAMOSWAPEI32_WD_M4_M2, VAMOSWAPEI32_WD }, // 635
  { PseudoVAMOSWAPEI32_WD_M4_M2_MASK, VAMOSWAPEI32_WD }, // 636
  { PseudoVAMOSWAPEI32_WD_M4_M4, VAMOSWAPEI32_WD }, // 637
  { PseudoVAMOSWAPEI32_WD_M4_M4_MASK, VAMOSWAPEI32_WD }, // 638
  { PseudoVAMOSWAPEI32_WD_M8_M4, VAMOSWAPEI32_WD }, // 639
  { PseudoVAMOSWAPEI32_WD_M8_M4_MASK, VAMOSWAPEI32_WD }, // 640
  { PseudoVAMOSWAPEI32_WD_M8_M8, VAMOSWAPEI32_WD }, // 641
  { PseudoVAMOSWAPEI32_WD_M8_M8_MASK, VAMOSWAPEI32_WD }, // 642
  { PseudoVAMOSWAPEI32_WD_MF2_MF2, VAMOSWAPEI32_WD }, // 643
  { PseudoVAMOSWAPEI32_WD_MF2_MF2_MASK, VAMOSWAPEI32_WD }, // 644
  { PseudoVAMOSWAPEI64_WD_M1_M1, VAMOSWAPEI64_WD }, // 645
  { PseudoVAMOSWAPEI64_WD_M1_M1_MASK, VAMOSWAPEI64_WD }, // 646
  { PseudoVAMOSWAPEI64_WD_M1_M2, VAMOSWAPEI64_WD }, // 647
  { PseudoVAMOSWAPEI64_WD_M1_M2_MASK, VAMOSWAPEI64_WD }, // 648
  { PseudoVAMOSWAPEI64_WD_M2_M2, VAMOSWAPEI64_WD }, // 649
  { PseudoVAMOSWAPEI64_WD_M2_M2_MASK, VAMOSWAPEI64_WD }, // 650
  { PseudoVAMOSWAPEI64_WD_M2_M4, VAMOSWAPEI64_WD }, // 651
  { PseudoVAMOSWAPEI64_WD_M2_M4_MASK, VAMOSWAPEI64_WD }, // 652
  { PseudoVAMOSWAPEI64_WD_M4_M4, VAMOSWAPEI64_WD }, // 653
  { PseudoVAMOSWAPEI64_WD_M4_M4_MASK, VAMOSWAPEI64_WD }, // 654
  { PseudoVAMOSWAPEI64_WD_M4_M8, VAMOSWAPEI64_WD }, // 655
  { PseudoVAMOSWAPEI64_WD_M4_M8_MASK, VAMOSWAPEI64_WD }, // 656
  { PseudoVAMOSWAPEI64_WD_M8_M8, VAMOSWAPEI64_WD }, // 657
  { PseudoVAMOSWAPEI64_WD_M8_M8_MASK, VAMOSWAPEI64_WD }, // 658
  { PseudoVAMOSWAPEI64_WD_MF2_M1, VAMOSWAPEI64_WD }, // 659
  { PseudoVAMOSWAPEI64_WD_MF2_M1_MASK, VAMOSWAPEI64_WD }, // 660
  { PseudoVAMOSWAPEI8_WD_M1_MF4, VAMOSWAPEI8_WD }, // 661
  { PseudoVAMOSWAPEI8_WD_M1_MF4_MASK, VAMOSWAPEI8_WD }, // 662
  { PseudoVAMOSWAPEI8_WD_M1_MF8, VAMOSWAPEI8_WD }, // 663
  { PseudoVAMOSWAPEI8_WD_M1_MF8_MASK, VAMOSWAPEI8_WD }, // 664
  { PseudoVAMOSWAPEI8_WD_M2_MF2, VAMOSWAPEI8_WD }, // 665
  { PseudoVAMOSWAPEI8_WD_M2_MF2_MASK, VAMOSWAPEI8_WD }, // 666
  { PseudoVAMOSWAPEI8_WD_M2_MF4, VAMOSWAPEI8_WD }, // 667
  { PseudoVAMOSWAPEI8_WD_M2_MF4_MASK, VAMOSWAPEI8_WD }, // 668
  { PseudoVAMOSWAPEI8_WD_M4_M1, VAMOSWAPEI8_WD }, // 669
  { PseudoVAMOSWAPEI8_WD_M4_M1_MASK, VAMOSWAPEI8_WD }, // 670
  { PseudoVAMOSWAPEI8_WD_M4_MF2, VAMOSWAPEI8_WD }, // 671
  { PseudoVAMOSWAPEI8_WD_M4_MF2_MASK, VAMOSWAPEI8_WD }, // 672
  { PseudoVAMOSWAPEI8_WD_M8_M1, VAMOSWAPEI8_WD }, // 673
  { PseudoVAMOSWAPEI8_WD_M8_M1_MASK, VAMOSWAPEI8_WD }, // 674
  { PseudoVAMOSWAPEI8_WD_M8_M2, VAMOSWAPEI8_WD }, // 675
  { PseudoVAMOSWAPEI8_WD_M8_M2_MASK, VAMOSWAPEI8_WD }, // 676
  { PseudoVAMOSWAPEI8_WD_MF2_MF8, VAMOSWAPEI8_WD }, // 677
  { PseudoVAMOSWAPEI8_WD_MF2_MF8_MASK, VAMOSWAPEI8_WD }, // 678
  { PseudoVAMOXOREI16_WD_M1_MF2, VAMOXOREI16_WD }, // 679
  { PseudoVAMOXOREI16_WD_M1_MF2_MASK, VAMOXOREI16_WD }, // 680
  { PseudoVAMOXOREI16_WD_M1_MF4, VAMOXOREI16_WD }, // 681
  { PseudoVAMOXOREI16_WD_M1_MF4_MASK, VAMOXOREI16_WD }, // 682
  { PseudoVAMOXOREI16_WD_M2_M1, VAMOXOREI16_WD }, // 683
  { PseudoVAMOXOREI16_WD_M2_M1_MASK, VAMOXOREI16_WD }, // 684
  { PseudoVAMOXOREI16_WD_M2_MF2, VAMOXOREI16_WD }, // 685
  { PseudoVAMOXOREI16_WD_M2_MF2_MASK, VAMOXOREI16_WD }, // 686
  { PseudoVAMOXOREI16_WD_M4_M1, VAMOXOREI16_WD }, // 687
  { PseudoVAMOXOREI16_WD_M4_M1_MASK, VAMOXOREI16_WD }, // 688
  { PseudoVAMOXOREI16_WD_M4_M2, VAMOXOREI16_WD }, // 689
  { PseudoVAMOXOREI16_WD_M4_M2_MASK, VAMOXOREI16_WD }, // 690
  { PseudoVAMOXOREI16_WD_M8_M2, VAMOXOREI16_WD }, // 691
  { PseudoVAMOXOREI16_WD_M8_M2_MASK, VAMOXOREI16_WD }, // 692
  { PseudoVAMOXOREI16_WD_M8_M4, VAMOXOREI16_WD }, // 693
  { PseudoVAMOXOREI16_WD_M8_M4_MASK, VAMOXOREI16_WD }, // 694
  { PseudoVAMOXOREI16_WD_MF2_MF4, VAMOXOREI16_WD }, // 695
  { PseudoVAMOXOREI16_WD_MF2_MF4_MASK, VAMOXOREI16_WD }, // 696
  { PseudoVAMOXOREI32_WD_M1_M1, VAMOXOREI32_WD }, // 697
  { PseudoVAMOXOREI32_WD_M1_M1_MASK, VAMOXOREI32_WD }, // 698
  { PseudoVAMOXOREI32_WD_M1_MF2, VAMOXOREI32_WD }, // 699
  { PseudoVAMOXOREI32_WD_M1_MF2_MASK, VAMOXOREI32_WD }, // 700
  { PseudoVAMOXOREI32_WD_M2_M1, VAMOXOREI32_WD }, // 701
  { PseudoVAMOXOREI32_WD_M2_M1_MASK, VAMOXOREI32_WD }, // 702
  { PseudoVAMOXOREI32_WD_M2_M2, VAMOXOREI32_WD }, // 703
  { PseudoVAMOXOREI32_WD_M2_M2_MASK, VAMOXOREI32_WD }, // 704
  { PseudoVAMOXOREI32_WD_M4_M2, VAMOXOREI32_WD }, // 705
  { PseudoVAMOXOREI32_WD_M4_M2_MASK, VAMOXOREI32_WD }, // 706
  { PseudoVAMOXOREI32_WD_M4_M4, VAMOXOREI32_WD }, // 707
  { PseudoVAMOXOREI32_WD_M4_M4_MASK, VAMOXOREI32_WD }, // 708
  { PseudoVAMOXOREI32_WD_M8_M4, VAMOXOREI32_WD }, // 709
  { PseudoVAMOXOREI32_WD_M8_M4_MASK, VAMOXOREI32_WD }, // 710
  { PseudoVAMOXOREI32_WD_M8_M8, VAMOXOREI32_WD }, // 711
  { PseudoVAMOXOREI32_WD_M8_M8_MASK, VAMOXOREI32_WD }, // 712
  { PseudoVAMOXOREI32_WD_MF2_MF2, VAMOXOREI32_WD }, // 713
  { PseudoVAMOXOREI32_WD_MF2_MF2_MASK, VAMOXOREI32_WD }, // 714
  { PseudoVAMOXOREI64_WD_M1_M1, VAMOXOREI64_WD }, // 715
  { PseudoVAMOXOREI64_WD_M1_M1_MASK, VAMOXOREI64_WD }, // 716
  { PseudoVAMOXOREI64_WD_M1_M2, VAMOXOREI64_WD }, // 717
  { PseudoVAMOXOREI64_WD_M1_M2_MASK, VAMOXOREI64_WD }, // 718
  { PseudoVAMOXOREI64_WD_M2_M2, VAMOXOREI64_WD }, // 719
  { PseudoVAMOXOREI64_WD_M2_M2_MASK, VAMOXOREI64_WD }, // 720
  { PseudoVAMOXOREI64_WD_M2_M4, VAMOXOREI64_WD }, // 721
  { PseudoVAMOXOREI64_WD_M2_M4_MASK, VAMOXOREI64_WD }, // 722
  { PseudoVAMOXOREI64_WD_M4_M4, VAMOXOREI64_WD }, // 723
  { PseudoVAMOXOREI64_WD_M4_M4_MASK, VAMOXOREI64_WD }, // 724
  { PseudoVAMOXOREI64_WD_M4_M8, VAMOXOREI64_WD }, // 725
  { PseudoVAMOXOREI64_WD_M4_M8_MASK, VAMOXOREI64_WD }, // 726
  { PseudoVAMOXOREI64_WD_M8_M8, VAMOXOREI64_WD }, // 727
  { PseudoVAMOXOREI64_WD_M8_M8_MASK, VAMOXOREI64_WD }, // 728
  { PseudoVAMOXOREI64_WD_MF2_M1, VAMOXOREI64_WD }, // 729
  { PseudoVAMOXOREI64_WD_MF2_M1_MASK, VAMOXOREI64_WD }, // 730
  { PseudoVAMOXOREI8_WD_M1_MF4, VAMOXOREI8_WD }, // 731
  { PseudoVAMOXOREI8_WD_M1_MF4_MASK, VAMOXOREI8_WD }, // 732
  { PseudoVAMOXOREI8_WD_M1_MF8, VAMOXOREI8_WD }, // 733
  { PseudoVAMOXOREI8_WD_M1_MF8_MASK, VAMOXOREI8_WD }, // 734
  { PseudoVAMOXOREI8_WD_M2_MF2, VAMOXOREI8_WD }, // 735
  { PseudoVAMOXOREI8_WD_M2_MF2_MASK, VAMOXOREI8_WD }, // 736
  { PseudoVAMOXOREI8_WD_M2_MF4, VAMOXOREI8_WD }, // 737
  { PseudoVAMOXOREI8_WD_M2_MF4_MASK, VAMOXOREI8_WD }, // 738
  { PseudoVAMOXOREI8_WD_M4_M1, VAMOXOREI8_WD }, // 739
  { PseudoVAMOXOREI8_WD_M4_M1_MASK, VAMOXOREI8_WD }, // 740
  { PseudoVAMOXOREI8_WD_M4_MF2, VAMOXOREI8_WD }, // 741
  { PseudoVAMOXOREI8_WD_M4_MF2_MASK, VAMOXOREI8_WD }, // 742
  { PseudoVAMOXOREI8_WD_M8_M1, VAMOXOREI8_WD }, // 743
  { PseudoVAMOXOREI8_WD_M8_M1_MASK, VAMOXOREI8_WD }, // 744
  { PseudoVAMOXOREI8_WD_M8_M2, VAMOXOREI8_WD }, // 745
  { PseudoVAMOXOREI8_WD_M8_M2_MASK, VAMOXOREI8_WD }, // 746
  { PseudoVAMOXOREI8_WD_MF2_MF8, VAMOXOREI8_WD }, // 747
  { PseudoVAMOXOREI8_WD_MF2_MF8_MASK, VAMOXOREI8_WD }, // 748
  { PseudoVAND_VI_M1, VAND_VI }, // 749
  { PseudoVAND_VI_M1_MASK, VAND_VI }, // 750
  { PseudoVAND_VI_M2, VAND_VI }, // 751
  { PseudoVAND_VI_M2_MASK, VAND_VI }, // 752
  { PseudoVAND_VI_M4, VAND_VI }, // 753
  { PseudoVAND_VI_M4_MASK, VAND_VI }, // 754
  { PseudoVAND_VI_M8, VAND_VI }, // 755
  { PseudoVAND_VI_M8_MASK, VAND_VI }, // 756
  { PseudoVAND_VI_MF2, VAND_VI }, // 757
  { PseudoVAND_VI_MF2_MASK, VAND_VI }, // 758
  { PseudoVAND_VI_MF4, VAND_VI }, // 759
  { PseudoVAND_VI_MF4_MASK, VAND_VI }, // 760
  { PseudoVAND_VI_MF8, VAND_VI }, // 761
  { PseudoVAND_VI_MF8_MASK, VAND_VI }, // 762
  { PseudoVAND_VV_M1, VAND_VV }, // 763
  { PseudoVAND_VV_M1_MASK, VAND_VV }, // 764
  { PseudoVAND_VV_M2, VAND_VV }, // 765
  { PseudoVAND_VV_M2_MASK, VAND_VV }, // 766
  { PseudoVAND_VV_M4, VAND_VV }, // 767
  { PseudoVAND_VV_M4_MASK, VAND_VV }, // 768
  { PseudoVAND_VV_M8, VAND_VV }, // 769
  { PseudoVAND_VV_M8_MASK, VAND_VV }, // 770
  { PseudoVAND_VV_MF2, VAND_VV }, // 771
  { PseudoVAND_VV_MF2_MASK, VAND_VV }, // 772
  { PseudoVAND_VV_MF4, VAND_VV }, // 773
  { PseudoVAND_VV_MF4_MASK, VAND_VV }, // 774
  { PseudoVAND_VV_MF8, VAND_VV }, // 775
  { PseudoVAND_VV_MF8_MASK, VAND_VV }, // 776
  { PseudoVAND_VX_M1, VAND_VX }, // 777
  { PseudoVAND_VX_M1_MASK, VAND_VX }, // 778
  { PseudoVAND_VX_M2, VAND_VX }, // 779
  { PseudoVAND_VX_M2_MASK, VAND_VX }, // 780
  { PseudoVAND_VX_M4, VAND_VX }, // 781
  { PseudoVAND_VX_M4_MASK, VAND_VX }, // 782
  { PseudoVAND_VX_M8, VAND_VX }, // 783
  { PseudoVAND_VX_M8_MASK, VAND_VX }, // 784
  { PseudoVAND_VX_MF2, VAND_VX }, // 785
  { PseudoVAND_VX_MF2_MASK, VAND_VX }, // 786
  { PseudoVAND_VX_MF4, VAND_VX }, // 787
  { PseudoVAND_VX_MF4_MASK, VAND_VX }, // 788
  { PseudoVAND_VX_MF8, VAND_VX }, // 789
  { PseudoVAND_VX_MF8_MASK, VAND_VX }, // 790
  { PseudoVASUBU_VV_M1, VASUBU_VV }, // 791
  { PseudoVASUBU_VV_M1_MASK, VASUBU_VV }, // 792
  { PseudoVASUBU_VV_M2, VASUBU_VV }, // 793
  { PseudoVASUBU_VV_M2_MASK, VASUBU_VV }, // 794
  { PseudoVASUBU_VV_M4, VASUBU_VV }, // 795
  { PseudoVASUBU_VV_M4_MASK, VASUBU_VV }, // 796
  { PseudoVASUBU_VV_M8, VASUBU_VV }, // 797
  { PseudoVASUBU_VV_M8_MASK, VASUBU_VV }, // 798
  { PseudoVASUBU_VV_MF2, VASUBU_VV }, // 799
  { PseudoVASUBU_VV_MF2_MASK, VASUBU_VV }, // 800
  { PseudoVASUBU_VV_MF4, VASUBU_VV }, // 801
  { PseudoVASUBU_VV_MF4_MASK, VASUBU_VV }, // 802
  { PseudoVASUBU_VV_MF8, VASUBU_VV }, // 803
  { PseudoVASUBU_VV_MF8_MASK, VASUBU_VV }, // 804
  { PseudoVASUBU_VX_M1, VASUBU_VX }, // 805
  { PseudoVASUBU_VX_M1_MASK, VASUBU_VX }, // 806
  { PseudoVASUBU_VX_M2, VASUBU_VX }, // 807
  { PseudoVASUBU_VX_M2_MASK, VASUBU_VX }, // 808
  { PseudoVASUBU_VX_M4, VASUBU_VX }, // 809
  { PseudoVASUBU_VX_M4_MASK, VASUBU_VX }, // 810
  { PseudoVASUBU_VX_M8, VASUBU_VX }, // 811
  { PseudoVASUBU_VX_M8_MASK, VASUBU_VX }, // 812
  { PseudoVASUBU_VX_MF2, VASUBU_VX }, // 813
  { PseudoVASUBU_VX_MF2_MASK, VASUBU_VX }, // 814
  { PseudoVASUBU_VX_MF4, VASUBU_VX }, // 815
  { PseudoVASUBU_VX_MF4_MASK, VASUBU_VX }, // 816
  { PseudoVASUBU_VX_MF8, VASUBU_VX }, // 817
  { PseudoVASUBU_VX_MF8_MASK, VASUBU_VX }, // 818
  { PseudoVASUB_VV_M1, VASUB_VV }, // 819
  { PseudoVASUB_VV_M1_MASK, VASUB_VV }, // 820
  { PseudoVASUB_VV_M2, VASUB_VV }, // 821
  { PseudoVASUB_VV_M2_MASK, VASUB_VV }, // 822
  { PseudoVASUB_VV_M4, VASUB_VV }, // 823
  { PseudoVASUB_VV_M4_MASK, VASUB_VV }, // 824
  { PseudoVASUB_VV_M8, VASUB_VV }, // 825
  { PseudoVASUB_VV_M8_MASK, VASUB_VV }, // 826
  { PseudoVASUB_VV_MF2, VASUB_VV }, // 827
  { PseudoVASUB_VV_MF2_MASK, VASUB_VV }, // 828
  { PseudoVASUB_VV_MF4, VASUB_VV }, // 829
  { PseudoVASUB_VV_MF4_MASK, VASUB_VV }, // 830
  { PseudoVASUB_VV_MF8, VASUB_VV }, // 831
  { PseudoVASUB_VV_MF8_MASK, VASUB_VV }, // 832
  { PseudoVASUB_VX_M1, VASUB_VX }, // 833
  { PseudoVASUB_VX_M1_MASK, VASUB_VX }, // 834
  { PseudoVASUB_VX_M2, VASUB_VX }, // 835
  { PseudoVASUB_VX_M2_MASK, VASUB_VX }, // 836
  { PseudoVASUB_VX_M4, VASUB_VX }, // 837
  { PseudoVASUB_VX_M4_MASK, VASUB_VX }, // 838
  { PseudoVASUB_VX_M8, VASUB_VX }, // 839
  { PseudoVASUB_VX_M8_MASK, VASUB_VX }, // 840
  { PseudoVASUB_VX_MF2, VASUB_VX }, // 841
  { PseudoVASUB_VX_MF2_MASK, VASUB_VX }, // 842
  { PseudoVASUB_VX_MF4, VASUB_VX }, // 843
  { PseudoVASUB_VX_MF4_MASK, VASUB_VX }, // 844
  { PseudoVASUB_VX_MF8, VASUB_VX }, // 845
  { PseudoVASUB_VX_MF8_MASK, VASUB_VX }, // 846
  { PseudoVCOMPRESS_VM_M1, VCOMPRESS_VM }, // 847
  { PseudoVCOMPRESS_VM_M2, VCOMPRESS_VM }, // 848
  { PseudoVCOMPRESS_VM_M4, VCOMPRESS_VM }, // 849
  { PseudoVCOMPRESS_VM_M8, VCOMPRESS_VM }, // 850
  { PseudoVCOMPRESS_VM_MF2, VCOMPRESS_VM }, // 851
  { PseudoVCOMPRESS_VM_MF4, VCOMPRESS_VM }, // 852
  { PseudoVCOMPRESS_VM_MF8, VCOMPRESS_VM }, // 853
  { PseudoVDIVU_VV_M1, VDIVU_VV }, // 854
  { PseudoVDIVU_VV_M1_MASK, VDIVU_VV }, // 855
  { PseudoVDIVU_VV_M2, VDIVU_VV }, // 856
  { PseudoVDIVU_VV_M2_MASK, VDIVU_VV }, // 857
  { PseudoVDIVU_VV_M4, VDIVU_VV }, // 858
  { PseudoVDIVU_VV_M4_MASK, VDIVU_VV }, // 859
  { PseudoVDIVU_VV_M8, VDIVU_VV }, // 860
  { PseudoVDIVU_VV_M8_MASK, VDIVU_VV }, // 861
  { PseudoVDIVU_VV_MF2, VDIVU_VV }, // 862
  { PseudoVDIVU_VV_MF2_MASK, VDIVU_VV }, // 863
  { PseudoVDIVU_VV_MF4, VDIVU_VV }, // 864
  { PseudoVDIVU_VV_MF4_MASK, VDIVU_VV }, // 865
  { PseudoVDIVU_VV_MF8, VDIVU_VV }, // 866
  { PseudoVDIVU_VV_MF8_MASK, VDIVU_VV }, // 867
  { PseudoVDIVU_VX_M1, VDIVU_VX }, // 868
  { PseudoVDIVU_VX_M1_MASK, VDIVU_VX }, // 869
  { PseudoVDIVU_VX_M2, VDIVU_VX }, // 870
  { PseudoVDIVU_VX_M2_MASK, VDIVU_VX }, // 871
  { PseudoVDIVU_VX_M4, VDIVU_VX }, // 872
  { PseudoVDIVU_VX_M4_MASK, VDIVU_VX }, // 873
  { PseudoVDIVU_VX_M8, VDIVU_VX }, // 874
  { PseudoVDIVU_VX_M8_MASK, VDIVU_VX }, // 875
  { PseudoVDIVU_VX_MF2, VDIVU_VX }, // 876
  { PseudoVDIVU_VX_MF2_MASK, VDIVU_VX }, // 877
  { PseudoVDIVU_VX_MF4, VDIVU_VX }, // 878
  { PseudoVDIVU_VX_MF4_MASK, VDIVU_VX }, // 879
  { PseudoVDIVU_VX_MF8, VDIVU_VX }, // 880
  { PseudoVDIVU_VX_MF8_MASK, VDIVU_VX }, // 881
  { PseudoVDIV_VV_M1, VDIV_VV }, // 882
  { PseudoVDIV_VV_M1_MASK, VDIV_VV }, // 883
  { PseudoVDIV_VV_M2, VDIV_VV }, // 884
  { PseudoVDIV_VV_M2_MASK, VDIV_VV }, // 885
  { PseudoVDIV_VV_M4, VDIV_VV }, // 886
  { PseudoVDIV_VV_M4_MASK, VDIV_VV }, // 887
  { PseudoVDIV_VV_M8, VDIV_VV }, // 888
  { PseudoVDIV_VV_M8_MASK, VDIV_VV }, // 889
  { PseudoVDIV_VV_MF2, VDIV_VV }, // 890
  { PseudoVDIV_VV_MF2_MASK, VDIV_VV }, // 891
  { PseudoVDIV_VV_MF4, VDIV_VV }, // 892
  { PseudoVDIV_VV_MF4_MASK, VDIV_VV }, // 893
  { PseudoVDIV_VV_MF8, VDIV_VV }, // 894
  { PseudoVDIV_VV_MF8_MASK, VDIV_VV }, // 895
  { PseudoVDIV_VX_M1, VDIV_VX }, // 896
  { PseudoVDIV_VX_M1_MASK, VDIV_VX }, // 897
  { PseudoVDIV_VX_M2, VDIV_VX }, // 898
  { PseudoVDIV_VX_M2_MASK, VDIV_VX }, // 899
  { PseudoVDIV_VX_M4, VDIV_VX }, // 900
  { PseudoVDIV_VX_M4_MASK, VDIV_VX }, // 901
  { PseudoVDIV_VX_M8, VDIV_VX }, // 902
  { PseudoVDIV_VX_M8_MASK, VDIV_VX }, // 903
  { PseudoVDIV_VX_MF2, VDIV_VX }, // 904
  { PseudoVDIV_VX_MF2_MASK, VDIV_VX }, // 905
  { PseudoVDIV_VX_MF4, VDIV_VX }, // 906
  { PseudoVDIV_VX_MF4_MASK, VDIV_VX }, // 907
  { PseudoVDIV_VX_MF8, VDIV_VX }, // 908
  { PseudoVDIV_VX_MF8_MASK, VDIV_VX }, // 909
  { PseudoVFADD_VF16_M1, VFADD_VF }, // 910
  { PseudoVFADD_VF16_M1_MASK, VFADD_VF }, // 911
  { PseudoVFADD_VF16_M2, VFADD_VF }, // 912
  { PseudoVFADD_VF16_M2_MASK, VFADD_VF }, // 913
  { PseudoVFADD_VF16_M4, VFADD_VF }, // 914
  { PseudoVFADD_VF16_M4_MASK, VFADD_VF }, // 915
  { PseudoVFADD_VF16_M8, VFADD_VF }, // 916
  { PseudoVFADD_VF16_M8_MASK, VFADD_VF }, // 917
  { PseudoVFADD_VF16_MF2, VFADD_VF }, // 918
  { PseudoVFADD_VF16_MF2_MASK, VFADD_VF }, // 919
  { PseudoVFADD_VF16_MF4, VFADD_VF }, // 920
  { PseudoVFADD_VF16_MF4_MASK, VFADD_VF }, // 921
  { PseudoVFADD_VF16_MF8, VFADD_VF }, // 922
  { PseudoVFADD_VF16_MF8_MASK, VFADD_VF }, // 923
  { PseudoVFADD_VF32_M1, VFADD_VF }, // 924
  { PseudoVFADD_VF32_M1_MASK, VFADD_VF }, // 925
  { PseudoVFADD_VF32_M2, VFADD_VF }, // 926
  { PseudoVFADD_VF32_M2_MASK, VFADD_VF }, // 927
  { PseudoVFADD_VF32_M4, VFADD_VF }, // 928
  { PseudoVFADD_VF32_M4_MASK, VFADD_VF }, // 929
  { PseudoVFADD_VF32_M8, VFADD_VF }, // 930
  { PseudoVFADD_VF32_M8_MASK, VFADD_VF }, // 931
  { PseudoVFADD_VF32_MF2, VFADD_VF }, // 932
  { PseudoVFADD_VF32_MF2_MASK, VFADD_VF }, // 933
  { PseudoVFADD_VF32_MF4, VFADD_VF }, // 934
  { PseudoVFADD_VF32_MF4_MASK, VFADD_VF }, // 935
  { PseudoVFADD_VF32_MF8, VFADD_VF }, // 936
  { PseudoVFADD_VF32_MF8_MASK, VFADD_VF }, // 937
  { PseudoVFADD_VF64_M1, VFADD_VF }, // 938
  { PseudoVFADD_VF64_M1_MASK, VFADD_VF }, // 939
  { PseudoVFADD_VF64_M2, VFADD_VF }, // 940
  { PseudoVFADD_VF64_M2_MASK, VFADD_VF }, // 941
  { PseudoVFADD_VF64_M4, VFADD_VF }, // 942
  { PseudoVFADD_VF64_M4_MASK, VFADD_VF }, // 943
  { PseudoVFADD_VF64_M8, VFADD_VF }, // 944
  { PseudoVFADD_VF64_M8_MASK, VFADD_VF }, // 945
  { PseudoVFADD_VF64_MF2, VFADD_VF }, // 946
  { PseudoVFADD_VF64_MF2_MASK, VFADD_VF }, // 947
  { PseudoVFADD_VF64_MF4, VFADD_VF }, // 948
  { PseudoVFADD_VF64_MF4_MASK, VFADD_VF }, // 949
  { PseudoVFADD_VF64_MF8, VFADD_VF }, // 950
  { PseudoVFADD_VF64_MF8_MASK, VFADD_VF }, // 951
  { PseudoVFADD_VV_M1, VFADD_VV }, // 952
  { PseudoVFADD_VV_M1_MASK, VFADD_VV }, // 953
  { PseudoVFADD_VV_M2, VFADD_VV }, // 954
  { PseudoVFADD_VV_M2_MASK, VFADD_VV }, // 955
  { PseudoVFADD_VV_M4, VFADD_VV }, // 956
  { PseudoVFADD_VV_M4_MASK, VFADD_VV }, // 957
  { PseudoVFADD_VV_M8, VFADD_VV }, // 958
  { PseudoVFADD_VV_M8_MASK, VFADD_VV }, // 959
  { PseudoVFADD_VV_MF2, VFADD_VV }, // 960
  { PseudoVFADD_VV_MF2_MASK, VFADD_VV }, // 961
  { PseudoVFADD_VV_MF4, VFADD_VV }, // 962
  { PseudoVFADD_VV_MF4_MASK, VFADD_VV }, // 963
  { PseudoVFADD_VV_MF8, VFADD_VV }, // 964
  { PseudoVFADD_VV_MF8_MASK, VFADD_VV }, // 965
  { PseudoVFCLASS_V_M1, VFCLASS_V }, // 966
  { PseudoVFCLASS_V_M1_MASK, VFCLASS_V }, // 967
  { PseudoVFCLASS_V_M2, VFCLASS_V }, // 968
  { PseudoVFCLASS_V_M2_MASK, VFCLASS_V }, // 969
  { PseudoVFCLASS_V_M4, VFCLASS_V }, // 970
  { PseudoVFCLASS_V_M4_MASK, VFCLASS_V }, // 971
  { PseudoVFCLASS_V_M8, VFCLASS_V }, // 972
  { PseudoVFCLASS_V_M8_MASK, VFCLASS_V }, // 973
  { PseudoVFCLASS_V_MF2, VFCLASS_V }, // 974
  { PseudoVFCLASS_V_MF2_MASK, VFCLASS_V }, // 975
  { PseudoVFCLASS_V_MF4, VFCLASS_V }, // 976
  { PseudoVFCLASS_V_MF4_MASK, VFCLASS_V }, // 977
  { PseudoVFCLASS_V_MF8, VFCLASS_V }, // 978
  { PseudoVFCLASS_V_MF8_MASK, VFCLASS_V }, // 979
  { PseudoVFCVT_F_XU_V_M1, VFCVT_F_XU_V }, // 980
  { PseudoVFCVT_F_XU_V_M1_MASK, VFCVT_F_XU_V }, // 981
  { PseudoVFCVT_F_XU_V_M2, VFCVT_F_XU_V }, // 982
  { PseudoVFCVT_F_XU_V_M2_MASK, VFCVT_F_XU_V }, // 983
  { PseudoVFCVT_F_XU_V_M4, VFCVT_F_XU_V }, // 984
  { PseudoVFCVT_F_XU_V_M4_MASK, VFCVT_F_XU_V }, // 985
  { PseudoVFCVT_F_XU_V_M8, VFCVT_F_XU_V }, // 986
  { PseudoVFCVT_F_XU_V_M8_MASK, VFCVT_F_XU_V }, // 987
  { PseudoVFCVT_F_XU_V_MF2, VFCVT_F_XU_V }, // 988
  { PseudoVFCVT_F_XU_V_MF2_MASK, VFCVT_F_XU_V }, // 989
  { PseudoVFCVT_F_XU_V_MF4, VFCVT_F_XU_V }, // 990
  { PseudoVFCVT_F_XU_V_MF4_MASK, VFCVT_F_XU_V }, // 991
  { PseudoVFCVT_F_XU_V_MF8, VFCVT_F_XU_V }, // 992
  { PseudoVFCVT_F_XU_V_MF8_MASK, VFCVT_F_XU_V }, // 993
  { PseudoVFCVT_F_X_V_M1, VFCVT_F_X_V }, // 994
  { PseudoVFCVT_F_X_V_M1_MASK, VFCVT_F_X_V }, // 995
  { PseudoVFCVT_F_X_V_M2, VFCVT_F_X_V }, // 996
  { PseudoVFCVT_F_X_V_M2_MASK, VFCVT_F_X_V }, // 997
  { PseudoVFCVT_F_X_V_M4, VFCVT_F_X_V }, // 998
  { PseudoVFCVT_F_X_V_M4_MASK, VFCVT_F_X_V }, // 999
  { PseudoVFCVT_F_X_V_M8, VFCVT_F_X_V }, // 1000
  { PseudoVFCVT_F_X_V_M8_MASK, VFCVT_F_X_V }, // 1001
  { PseudoVFCVT_F_X_V_MF2, VFCVT_F_X_V }, // 1002
  { PseudoVFCVT_F_X_V_MF2_MASK, VFCVT_F_X_V }, // 1003
  { PseudoVFCVT_F_X_V_MF4, VFCVT_F_X_V }, // 1004
  { PseudoVFCVT_F_X_V_MF4_MASK, VFCVT_F_X_V }, // 1005
  { PseudoVFCVT_F_X_V_MF8, VFCVT_F_X_V }, // 1006
  { PseudoVFCVT_F_X_V_MF8_MASK, VFCVT_F_X_V }, // 1007
  { PseudoVFCVT_RTZ_XU_F_V_M1, VFCVT_RTZ_XU_F_V }, // 1008
  { PseudoVFCVT_RTZ_XU_F_V_M1_MASK, VFCVT_RTZ_XU_F_V }, // 1009
  { PseudoVFCVT_RTZ_XU_F_V_M2, VFCVT_RTZ_XU_F_V }, // 1010
  { PseudoVFCVT_RTZ_XU_F_V_M2_MASK, VFCVT_RTZ_XU_F_V }, // 1011
  { PseudoVFCVT_RTZ_XU_F_V_M4, VFCVT_RTZ_XU_F_V }, // 1012
  { PseudoVFCVT_RTZ_XU_F_V_M4_MASK, VFCVT_RTZ_XU_F_V }, // 1013
  { PseudoVFCVT_RTZ_XU_F_V_M8, VFCVT_RTZ_XU_F_V }, // 1014
  { PseudoVFCVT_RTZ_XU_F_V_M8_MASK, VFCVT_RTZ_XU_F_V }, // 1015
  { PseudoVFCVT_RTZ_XU_F_V_MF2, VFCVT_RTZ_XU_F_V }, // 1016
  { PseudoVFCVT_RTZ_XU_F_V_MF2_MASK, VFCVT_RTZ_XU_F_V }, // 1017
  { PseudoVFCVT_RTZ_XU_F_V_MF4, VFCVT_RTZ_XU_F_V }, // 1018
  { PseudoVFCVT_RTZ_XU_F_V_MF4_MASK, VFCVT_RTZ_XU_F_V }, // 1019
  { PseudoVFCVT_RTZ_XU_F_V_MF8, VFCVT_RTZ_XU_F_V }, // 1020
  { PseudoVFCVT_RTZ_XU_F_V_MF8_MASK, VFCVT_RTZ_XU_F_V }, // 1021
  { PseudoVFCVT_RTZ_X_F_V_M1, VFCVT_RTZ_X_F_V }, // 1022
  { PseudoVFCVT_RTZ_X_F_V_M1_MASK, VFCVT_RTZ_X_F_V }, // 1023
  { PseudoVFCVT_RTZ_X_F_V_M2, VFCVT_RTZ_X_F_V }, // 1024
  { PseudoVFCVT_RTZ_X_F_V_M2_MASK, VFCVT_RTZ_X_F_V }, // 1025
  { PseudoVFCVT_RTZ_X_F_V_M4, VFCVT_RTZ_X_F_V }, // 1026
  { PseudoVFCVT_RTZ_X_F_V_M4_MASK, VFCVT_RTZ_X_F_V }, // 1027
  { PseudoVFCVT_RTZ_X_F_V_M8, VFCVT_RTZ_X_F_V }, // 1028
  { PseudoVFCVT_RTZ_X_F_V_M8_MASK, VFCVT_RTZ_X_F_V }, // 1029
  { PseudoVFCVT_RTZ_X_F_V_MF2, VFCVT_RTZ_X_F_V }, // 1030
  { PseudoVFCVT_RTZ_X_F_V_MF2_MASK, VFCVT_RTZ_X_F_V }, // 1031
  { PseudoVFCVT_RTZ_X_F_V_MF4, VFCVT_RTZ_X_F_V }, // 1032
  { PseudoVFCVT_RTZ_X_F_V_MF4_MASK, VFCVT_RTZ_X_F_V }, // 1033
  { PseudoVFCVT_RTZ_X_F_V_MF8, VFCVT_RTZ_X_F_V }, // 1034
  { PseudoVFCVT_RTZ_X_F_V_MF8_MASK, VFCVT_RTZ_X_F_V }, // 1035
  { PseudoVFCVT_XU_F_V_M1, VFCVT_XU_F_V }, // 1036
  { PseudoVFCVT_XU_F_V_M1_MASK, VFCVT_XU_F_V }, // 1037
  { PseudoVFCVT_XU_F_V_M2, VFCVT_XU_F_V }, // 1038
  { PseudoVFCVT_XU_F_V_M2_MASK, VFCVT_XU_F_V }, // 1039
  { PseudoVFCVT_XU_F_V_M4, VFCVT_XU_F_V }, // 1040
  { PseudoVFCVT_XU_F_V_M4_MASK, VFCVT_XU_F_V }, // 1041
  { PseudoVFCVT_XU_F_V_M8, VFCVT_XU_F_V }, // 1042
  { PseudoVFCVT_XU_F_V_M8_MASK, VFCVT_XU_F_V }, // 1043
  { PseudoVFCVT_XU_F_V_MF2, VFCVT_XU_F_V }, // 1044
  { PseudoVFCVT_XU_F_V_MF2_MASK, VFCVT_XU_F_V }, // 1045
  { PseudoVFCVT_XU_F_V_MF4, VFCVT_XU_F_V }, // 1046
  { PseudoVFCVT_XU_F_V_MF4_MASK, VFCVT_XU_F_V }, // 1047
  { PseudoVFCVT_XU_F_V_MF8, VFCVT_XU_F_V }, // 1048
  { PseudoVFCVT_XU_F_V_MF8_MASK, VFCVT_XU_F_V }, // 1049
  { PseudoVFCVT_X_F_V_M1, VFCVT_X_F_V }, // 1050
  { PseudoVFCVT_X_F_V_M1_MASK, VFCVT_X_F_V }, // 1051
  { PseudoVFCVT_X_F_V_M2, VFCVT_X_F_V }, // 1052
  { PseudoVFCVT_X_F_V_M2_MASK, VFCVT_X_F_V }, // 1053
  { PseudoVFCVT_X_F_V_M4, VFCVT_X_F_V }, // 1054
  { PseudoVFCVT_X_F_V_M4_MASK, VFCVT_X_F_V }, // 1055
  { PseudoVFCVT_X_F_V_M8, VFCVT_X_F_V }, // 1056
  { PseudoVFCVT_X_F_V_M8_MASK, VFCVT_X_F_V }, // 1057
  { PseudoVFCVT_X_F_V_MF2, VFCVT_X_F_V }, // 1058
  { PseudoVFCVT_X_F_V_MF2_MASK, VFCVT_X_F_V }, // 1059
  { PseudoVFCVT_X_F_V_MF4, VFCVT_X_F_V }, // 1060
  { PseudoVFCVT_X_F_V_MF4_MASK, VFCVT_X_F_V }, // 1061
  { PseudoVFCVT_X_F_V_MF8, VFCVT_X_F_V }, // 1062
  { PseudoVFCVT_X_F_V_MF8_MASK, VFCVT_X_F_V }, // 1063
  { PseudoVFDIV_VF16_M1, VFDIV_VF }, // 1064
  { PseudoVFDIV_VF16_M1_MASK, VFDIV_VF }, // 1065
  { PseudoVFDIV_VF16_M2, VFDIV_VF }, // 1066
  { PseudoVFDIV_VF16_M2_MASK, VFDIV_VF }, // 1067
  { PseudoVFDIV_VF16_M4, VFDIV_VF }, // 1068
  { PseudoVFDIV_VF16_M4_MASK, VFDIV_VF }, // 1069
  { PseudoVFDIV_VF16_M8, VFDIV_VF }, // 1070
  { PseudoVFDIV_VF16_M8_MASK, VFDIV_VF }, // 1071
  { PseudoVFDIV_VF16_MF2, VFDIV_VF }, // 1072
  { PseudoVFDIV_VF16_MF2_MASK, VFDIV_VF }, // 1073
  { PseudoVFDIV_VF16_MF4, VFDIV_VF }, // 1074
  { PseudoVFDIV_VF16_MF4_MASK, VFDIV_VF }, // 1075
  { PseudoVFDIV_VF16_MF8, VFDIV_VF }, // 1076
  { PseudoVFDIV_VF16_MF8_MASK, VFDIV_VF }, // 1077
  { PseudoVFDIV_VF32_M1, VFDIV_VF }, // 1078
  { PseudoVFDIV_VF32_M1_MASK, VFDIV_VF }, // 1079
  { PseudoVFDIV_VF32_M2, VFDIV_VF }, // 1080
  { PseudoVFDIV_VF32_M2_MASK, VFDIV_VF }, // 1081
  { PseudoVFDIV_VF32_M4, VFDIV_VF }, // 1082
  { PseudoVFDIV_VF32_M4_MASK, VFDIV_VF }, // 1083
  { PseudoVFDIV_VF32_M8, VFDIV_VF }, // 1084
  { PseudoVFDIV_VF32_M8_MASK, VFDIV_VF }, // 1085
  { PseudoVFDIV_VF32_MF2, VFDIV_VF }, // 1086
  { PseudoVFDIV_VF32_MF2_MASK, VFDIV_VF }, // 1087
  { PseudoVFDIV_VF32_MF4, VFDIV_VF }, // 1088
  { PseudoVFDIV_VF32_MF4_MASK, VFDIV_VF }, // 1089
  { PseudoVFDIV_VF32_MF8, VFDIV_VF }, // 1090
  { PseudoVFDIV_VF32_MF8_MASK, VFDIV_VF }, // 1091
  { PseudoVFDIV_VF64_M1, VFDIV_VF }, // 1092
  { PseudoVFDIV_VF64_M1_MASK, VFDIV_VF }, // 1093
  { PseudoVFDIV_VF64_M2, VFDIV_VF }, // 1094
  { PseudoVFDIV_VF64_M2_MASK, VFDIV_VF }, // 1095
  { PseudoVFDIV_VF64_M4, VFDIV_VF }, // 1096
  { PseudoVFDIV_VF64_M4_MASK, VFDIV_VF }, // 1097
  { PseudoVFDIV_VF64_M8, VFDIV_VF }, // 1098
  { PseudoVFDIV_VF64_M8_MASK, VFDIV_VF }, // 1099
  { PseudoVFDIV_VF64_MF2, VFDIV_VF }, // 1100
  { PseudoVFDIV_VF64_MF2_MASK, VFDIV_VF }, // 1101
  { PseudoVFDIV_VF64_MF4, VFDIV_VF }, // 1102
  { PseudoVFDIV_VF64_MF4_MASK, VFDIV_VF }, // 1103
  { PseudoVFDIV_VF64_MF8, VFDIV_VF }, // 1104
  { PseudoVFDIV_VF64_MF8_MASK, VFDIV_VF }, // 1105
  { PseudoVFDIV_VV_M1, VFDIV_VV }, // 1106
  { PseudoVFDIV_VV_M1_MASK, VFDIV_VV }, // 1107
  { PseudoVFDIV_VV_M2, VFDIV_VV }, // 1108
  { PseudoVFDIV_VV_M2_MASK, VFDIV_VV }, // 1109
  { PseudoVFDIV_VV_M4, VFDIV_VV }, // 1110
  { PseudoVFDIV_VV_M4_MASK, VFDIV_VV }, // 1111
  { PseudoVFDIV_VV_M8, VFDIV_VV }, // 1112
  { PseudoVFDIV_VV_M8_MASK, VFDIV_VV }, // 1113
  { PseudoVFDIV_VV_MF2, VFDIV_VV }, // 1114
  { PseudoVFDIV_VV_MF2_MASK, VFDIV_VV }, // 1115
  { PseudoVFDIV_VV_MF4, VFDIV_VV }, // 1116
  { PseudoVFDIV_VV_MF4_MASK, VFDIV_VV }, // 1117
  { PseudoVFDIV_VV_MF8, VFDIV_VV }, // 1118
  { PseudoVFDIV_VV_MF8_MASK, VFDIV_VV }, // 1119
  { PseudoVFIRST_M_B1, VFIRST_M }, // 1120
  { PseudoVFIRST_M_B16, VFIRST_M }, // 1121
  { PseudoVFIRST_M_B16_MASK, VFIRST_M }, // 1122
  { PseudoVFIRST_M_B1_MASK, VFIRST_M }, // 1123
  { PseudoVFIRST_M_B2, VFIRST_M }, // 1124
  { PseudoVFIRST_M_B2_MASK, VFIRST_M }, // 1125
  { PseudoVFIRST_M_B32, VFIRST_M }, // 1126
  { PseudoVFIRST_M_B32_MASK, VFIRST_M }, // 1127
  { PseudoVFIRST_M_B4, VFIRST_M }, // 1128
  { PseudoVFIRST_M_B4_MASK, VFIRST_M }, // 1129
  { PseudoVFIRST_M_B64, VFIRST_M }, // 1130
  { PseudoVFIRST_M_B64_MASK, VFIRST_M }, // 1131
  { PseudoVFIRST_M_B8, VFIRST_M }, // 1132
  { PseudoVFIRST_M_B8_MASK, VFIRST_M }, // 1133
  { PseudoVFMACC_VF16_M1, VFMACC_VF }, // 1134
  { PseudoVFMACC_VF16_M1_MASK, VFMACC_VF }, // 1135
  { PseudoVFMACC_VF16_M2, VFMACC_VF }, // 1136
  { PseudoVFMACC_VF16_M2_MASK, VFMACC_VF }, // 1137
  { PseudoVFMACC_VF16_M4, VFMACC_VF }, // 1138
  { PseudoVFMACC_VF16_M4_MASK, VFMACC_VF }, // 1139
  { PseudoVFMACC_VF16_M8, VFMACC_VF }, // 1140
  { PseudoVFMACC_VF16_M8_MASK, VFMACC_VF }, // 1141
  { PseudoVFMACC_VF16_MF2, VFMACC_VF }, // 1142
  { PseudoVFMACC_VF16_MF2_MASK, VFMACC_VF }, // 1143
  { PseudoVFMACC_VF16_MF4, VFMACC_VF }, // 1144
  { PseudoVFMACC_VF16_MF4_MASK, VFMACC_VF }, // 1145
  { PseudoVFMACC_VF16_MF8, VFMACC_VF }, // 1146
  { PseudoVFMACC_VF16_MF8_MASK, VFMACC_VF }, // 1147
  { PseudoVFMACC_VF32_M1, VFMACC_VF }, // 1148
  { PseudoVFMACC_VF32_M1_MASK, VFMACC_VF }, // 1149
  { PseudoVFMACC_VF32_M2, VFMACC_VF }, // 1150
  { PseudoVFMACC_VF32_M2_MASK, VFMACC_VF }, // 1151
  { PseudoVFMACC_VF32_M4, VFMACC_VF }, // 1152
  { PseudoVFMACC_VF32_M4_MASK, VFMACC_VF }, // 1153
  { PseudoVFMACC_VF32_M8, VFMACC_VF }, // 1154
  { PseudoVFMACC_VF32_M8_MASK, VFMACC_VF }, // 1155
  { PseudoVFMACC_VF32_MF2, VFMACC_VF }, // 1156
  { PseudoVFMACC_VF32_MF2_MASK, VFMACC_VF }, // 1157
  { PseudoVFMACC_VF32_MF4, VFMACC_VF }, // 1158
  { PseudoVFMACC_VF32_MF4_MASK, VFMACC_VF }, // 1159
  { PseudoVFMACC_VF32_MF8, VFMACC_VF }, // 1160
  { PseudoVFMACC_VF32_MF8_MASK, VFMACC_VF }, // 1161
  { PseudoVFMACC_VF64_M1, VFMACC_VF }, // 1162
  { PseudoVFMACC_VF64_M1_MASK, VFMACC_VF }, // 1163
  { PseudoVFMACC_VF64_M2, VFMACC_VF }, // 1164
  { PseudoVFMACC_VF64_M2_MASK, VFMACC_VF }, // 1165
  { PseudoVFMACC_VF64_M4, VFMACC_VF }, // 1166
  { PseudoVFMACC_VF64_M4_MASK, VFMACC_VF }, // 1167
  { PseudoVFMACC_VF64_M8, VFMACC_VF }, // 1168
  { PseudoVFMACC_VF64_M8_MASK, VFMACC_VF }, // 1169
  { PseudoVFMACC_VF64_MF2, VFMACC_VF }, // 1170
  { PseudoVFMACC_VF64_MF2_MASK, VFMACC_VF }, // 1171
  { PseudoVFMACC_VF64_MF4, VFMACC_VF }, // 1172
  { PseudoVFMACC_VF64_MF4_MASK, VFMACC_VF }, // 1173
  { PseudoVFMACC_VF64_MF8, VFMACC_VF }, // 1174
  { PseudoVFMACC_VF64_MF8_MASK, VFMACC_VF }, // 1175
  { PseudoVFMACC_VV_M1, VFMACC_VV }, // 1176
  { PseudoVFMACC_VV_M1_MASK, VFMACC_VV }, // 1177
  { PseudoVFMACC_VV_M2, VFMACC_VV }, // 1178
  { PseudoVFMACC_VV_M2_MASK, VFMACC_VV }, // 1179
  { PseudoVFMACC_VV_M4, VFMACC_VV }, // 1180
  { PseudoVFMACC_VV_M4_MASK, VFMACC_VV }, // 1181
  { PseudoVFMACC_VV_M8, VFMACC_VV }, // 1182
  { PseudoVFMACC_VV_M8_MASK, VFMACC_VV }, // 1183
  { PseudoVFMACC_VV_MF2, VFMACC_VV }, // 1184
  { PseudoVFMACC_VV_MF2_MASK, VFMACC_VV }, // 1185
  { PseudoVFMACC_VV_MF4, VFMACC_VV }, // 1186
  { PseudoVFMACC_VV_MF4_MASK, VFMACC_VV }, // 1187
  { PseudoVFMACC_VV_MF8, VFMACC_VV }, // 1188
  { PseudoVFMACC_VV_MF8_MASK, VFMACC_VV }, // 1189
  { PseudoVFMADD_VF16_M1, VFMADD_VF }, // 1190
  { PseudoVFMADD_VF16_M1_MASK, VFMADD_VF }, // 1191
  { PseudoVFMADD_VF16_M2, VFMADD_VF }, // 1192
  { PseudoVFMADD_VF16_M2_MASK, VFMADD_VF }, // 1193
  { PseudoVFMADD_VF16_M4, VFMADD_VF }, // 1194
  { PseudoVFMADD_VF16_M4_MASK, VFMADD_VF }, // 1195
  { PseudoVFMADD_VF16_M8, VFMADD_VF }, // 1196
  { PseudoVFMADD_VF16_M8_MASK, VFMADD_VF }, // 1197
  { PseudoVFMADD_VF16_MF2, VFMADD_VF }, // 1198
  { PseudoVFMADD_VF16_MF2_MASK, VFMADD_VF }, // 1199
  { PseudoVFMADD_VF16_MF4, VFMADD_VF }, // 1200
  { PseudoVFMADD_VF16_MF4_MASK, VFMADD_VF }, // 1201
  { PseudoVFMADD_VF16_MF8, VFMADD_VF }, // 1202
  { PseudoVFMADD_VF16_MF8_MASK, VFMADD_VF }, // 1203
  { PseudoVFMADD_VF32_M1, VFMADD_VF }, // 1204
  { PseudoVFMADD_VF32_M1_MASK, VFMADD_VF }, // 1205
  { PseudoVFMADD_VF32_M2, VFMADD_VF }, // 1206
  { PseudoVFMADD_VF32_M2_MASK, VFMADD_VF }, // 1207
  { PseudoVFMADD_VF32_M4, VFMADD_VF }, // 1208
  { PseudoVFMADD_VF32_M4_MASK, VFMADD_VF }, // 1209
  { PseudoVFMADD_VF32_M8, VFMADD_VF }, // 1210
  { PseudoVFMADD_VF32_M8_MASK, VFMADD_VF }, // 1211
  { PseudoVFMADD_VF32_MF2, VFMADD_VF }, // 1212
  { PseudoVFMADD_VF32_MF2_MASK, VFMADD_VF }, // 1213
  { PseudoVFMADD_VF32_MF4, VFMADD_VF }, // 1214
  { PseudoVFMADD_VF32_MF4_MASK, VFMADD_VF }, // 1215
  { PseudoVFMADD_VF32_MF8, VFMADD_VF }, // 1216
  { PseudoVFMADD_VF32_MF8_MASK, VFMADD_VF }, // 1217
  { PseudoVFMADD_VF64_M1, VFMADD_VF }, // 1218
  { PseudoVFMADD_VF64_M1_MASK, VFMADD_VF }, // 1219
  { PseudoVFMADD_VF64_M2, VFMADD_VF }, // 1220
  { PseudoVFMADD_VF64_M2_MASK, VFMADD_VF }, // 1221
  { PseudoVFMADD_VF64_M4, VFMADD_VF }, // 1222
  { PseudoVFMADD_VF64_M4_MASK, VFMADD_VF }, // 1223
  { PseudoVFMADD_VF64_M8, VFMADD_VF }, // 1224
  { PseudoVFMADD_VF64_M8_MASK, VFMADD_VF }, // 1225
  { PseudoVFMADD_VF64_MF2, VFMADD_VF }, // 1226
  { PseudoVFMADD_VF64_MF2_MASK, VFMADD_VF }, // 1227
  { PseudoVFMADD_VF64_MF4, VFMADD_VF }, // 1228
  { PseudoVFMADD_VF64_MF4_MASK, VFMADD_VF }, // 1229
  { PseudoVFMADD_VF64_MF8, VFMADD_VF }, // 1230
  { PseudoVFMADD_VF64_MF8_MASK, VFMADD_VF }, // 1231
  { PseudoVFMADD_VV_M1, VFMADD_VV }, // 1232
  { PseudoVFMADD_VV_M1_MASK, VFMADD_VV }, // 1233
  { PseudoVFMADD_VV_M2, VFMADD_VV }, // 1234
  { PseudoVFMADD_VV_M2_MASK, VFMADD_VV }, // 1235
  { PseudoVFMADD_VV_M4, VFMADD_VV }, // 1236
  { PseudoVFMADD_VV_M4_MASK, VFMADD_VV }, // 1237
  { PseudoVFMADD_VV_M8, VFMADD_VV }, // 1238
  { PseudoVFMADD_VV_M8_MASK, VFMADD_VV }, // 1239
  { PseudoVFMADD_VV_MF2, VFMADD_VV }, // 1240
  { PseudoVFMADD_VV_MF2_MASK, VFMADD_VV }, // 1241
  { PseudoVFMADD_VV_MF4, VFMADD_VV }, // 1242
  { PseudoVFMADD_VV_MF4_MASK, VFMADD_VV }, // 1243
  { PseudoVFMADD_VV_MF8, VFMADD_VV }, // 1244
  { PseudoVFMADD_VV_MF8_MASK, VFMADD_VV }, // 1245
  { PseudoVFMAX_VF16_M1, VFMAX_VF }, // 1246
  { PseudoVFMAX_VF16_M1_MASK, VFMAX_VF }, // 1247
  { PseudoVFMAX_VF16_M2, VFMAX_VF }, // 1248
  { PseudoVFMAX_VF16_M2_MASK, VFMAX_VF }, // 1249
  { PseudoVFMAX_VF16_M4, VFMAX_VF }, // 1250
  { PseudoVFMAX_VF16_M4_MASK, VFMAX_VF }, // 1251
  { PseudoVFMAX_VF16_M8, VFMAX_VF }, // 1252
  { PseudoVFMAX_VF16_M8_MASK, VFMAX_VF }, // 1253
  { PseudoVFMAX_VF16_MF2, VFMAX_VF }, // 1254
  { PseudoVFMAX_VF16_MF2_MASK, VFMAX_VF }, // 1255
  { PseudoVFMAX_VF16_MF4, VFMAX_VF }, // 1256
  { PseudoVFMAX_VF16_MF4_MASK, VFMAX_VF }, // 1257
  { PseudoVFMAX_VF16_MF8, VFMAX_VF }, // 1258
  { PseudoVFMAX_VF16_MF8_MASK, VFMAX_VF }, // 1259
  { PseudoVFMAX_VF32_M1, VFMAX_VF }, // 1260
  { PseudoVFMAX_VF32_M1_MASK, VFMAX_VF }, // 1261
  { PseudoVFMAX_VF32_M2, VFMAX_VF }, // 1262
  { PseudoVFMAX_VF32_M2_MASK, VFMAX_VF }, // 1263
  { PseudoVFMAX_VF32_M4, VFMAX_VF }, // 1264
  { PseudoVFMAX_VF32_M4_MASK, VFMAX_VF }, // 1265
  { PseudoVFMAX_VF32_M8, VFMAX_VF }, // 1266
  { PseudoVFMAX_VF32_M8_MASK, VFMAX_VF }, // 1267
  { PseudoVFMAX_VF32_MF2, VFMAX_VF }, // 1268
  { PseudoVFMAX_VF32_MF2_MASK, VFMAX_VF }, // 1269
  { PseudoVFMAX_VF32_MF4, VFMAX_VF }, // 1270
  { PseudoVFMAX_VF32_MF4_MASK, VFMAX_VF }, // 1271
  { PseudoVFMAX_VF32_MF8, VFMAX_VF }, // 1272
  { PseudoVFMAX_VF32_MF8_MASK, VFMAX_VF }, // 1273
  { PseudoVFMAX_VF64_M1, VFMAX_VF }, // 1274
  { PseudoVFMAX_VF64_M1_MASK, VFMAX_VF }, // 1275
  { PseudoVFMAX_VF64_M2, VFMAX_VF }, // 1276
  { PseudoVFMAX_VF64_M2_MASK, VFMAX_VF }, // 1277
  { PseudoVFMAX_VF64_M4, VFMAX_VF }, // 1278
  { PseudoVFMAX_VF64_M4_MASK, VFMAX_VF }, // 1279
  { PseudoVFMAX_VF64_M8, VFMAX_VF }, // 1280
  { PseudoVFMAX_VF64_M8_MASK, VFMAX_VF }, // 1281
  { PseudoVFMAX_VF64_MF2, VFMAX_VF }, // 1282
  { PseudoVFMAX_VF64_MF2_MASK, VFMAX_VF }, // 1283
  { PseudoVFMAX_VF64_MF4, VFMAX_VF }, // 1284
  { PseudoVFMAX_VF64_MF4_MASK, VFMAX_VF }, // 1285
  { PseudoVFMAX_VF64_MF8, VFMAX_VF }, // 1286
  { PseudoVFMAX_VF64_MF8_MASK, VFMAX_VF }, // 1287
  { PseudoVFMAX_VV_M1, VFMAX_VV }, // 1288
  { PseudoVFMAX_VV_M1_MASK, VFMAX_VV }, // 1289
  { PseudoVFMAX_VV_M2, VFMAX_VV }, // 1290
  { PseudoVFMAX_VV_M2_MASK, VFMAX_VV }, // 1291
  { PseudoVFMAX_VV_M4, VFMAX_VV }, // 1292
  { PseudoVFMAX_VV_M4_MASK, VFMAX_VV }, // 1293
  { PseudoVFMAX_VV_M8, VFMAX_VV }, // 1294
  { PseudoVFMAX_VV_M8_MASK, VFMAX_VV }, // 1295
  { PseudoVFMAX_VV_MF2, VFMAX_VV }, // 1296
  { PseudoVFMAX_VV_MF2_MASK, VFMAX_VV }, // 1297
  { PseudoVFMAX_VV_MF4, VFMAX_VV }, // 1298
  { PseudoVFMAX_VV_MF4_MASK, VFMAX_VV }, // 1299
  { PseudoVFMAX_VV_MF8, VFMAX_VV }, // 1300
  { PseudoVFMAX_VV_MF8_MASK, VFMAX_VV }, // 1301
  { PseudoVFMERGE_VF16M_M1, VFMERGE_VFM }, // 1302
  { PseudoVFMERGE_VF16M_M2, VFMERGE_VFM }, // 1303
  { PseudoVFMERGE_VF16M_M4, VFMERGE_VFM }, // 1304
  { PseudoVFMERGE_VF16M_M8, VFMERGE_VFM }, // 1305
  { PseudoVFMERGE_VF16M_MF2, VFMERGE_VFM }, // 1306
  { PseudoVFMERGE_VF16M_MF4, VFMERGE_VFM }, // 1307
  { PseudoVFMERGE_VF16M_MF8, VFMERGE_VFM }, // 1308
  { PseudoVFMERGE_VF32M_M1, VFMERGE_VFM }, // 1309
  { PseudoVFMERGE_VF32M_M2, VFMERGE_VFM }, // 1310
  { PseudoVFMERGE_VF32M_M4, VFMERGE_VFM }, // 1311
  { PseudoVFMERGE_VF32M_M8, VFMERGE_VFM }, // 1312
  { PseudoVFMERGE_VF32M_MF2, VFMERGE_VFM }, // 1313
  { PseudoVFMERGE_VF32M_MF4, VFMERGE_VFM }, // 1314
  { PseudoVFMERGE_VF32M_MF8, VFMERGE_VFM }, // 1315
  { PseudoVFMERGE_VF64M_M1, VFMERGE_VFM }, // 1316
  { PseudoVFMERGE_VF64M_M2, VFMERGE_VFM }, // 1317
  { PseudoVFMERGE_VF64M_M4, VFMERGE_VFM }, // 1318
  { PseudoVFMERGE_VF64M_M8, VFMERGE_VFM }, // 1319
  { PseudoVFMERGE_VF64M_MF2, VFMERGE_VFM }, // 1320
  { PseudoVFMERGE_VF64M_MF4, VFMERGE_VFM }, // 1321
  { PseudoVFMERGE_VF64M_MF8, VFMERGE_VFM }, // 1322
  { PseudoVFMIN_VF16_M1, VFMIN_VF }, // 1323
  { PseudoVFMIN_VF16_M1_MASK, VFMIN_VF }, // 1324
  { PseudoVFMIN_VF16_M2, VFMIN_VF }, // 1325
  { PseudoVFMIN_VF16_M2_MASK, VFMIN_VF }, // 1326
  { PseudoVFMIN_VF16_M4, VFMIN_VF }, // 1327
  { PseudoVFMIN_VF16_M4_MASK, VFMIN_VF }, // 1328
  { PseudoVFMIN_VF16_M8, VFMIN_VF }, // 1329
  { PseudoVFMIN_VF16_M8_MASK, VFMIN_VF }, // 1330
  { PseudoVFMIN_VF16_MF2, VFMIN_VF }, // 1331
  { PseudoVFMIN_VF16_MF2_MASK, VFMIN_VF }, // 1332
  { PseudoVFMIN_VF16_MF4, VFMIN_VF }, // 1333
  { PseudoVFMIN_VF16_MF4_MASK, VFMIN_VF }, // 1334
  { PseudoVFMIN_VF16_MF8, VFMIN_VF }, // 1335
  { PseudoVFMIN_VF16_MF8_MASK, VFMIN_VF }, // 1336
  { PseudoVFMIN_VF32_M1, VFMIN_VF }, // 1337
  { PseudoVFMIN_VF32_M1_MASK, VFMIN_VF }, // 1338
  { PseudoVFMIN_VF32_M2, VFMIN_VF }, // 1339
  { PseudoVFMIN_VF32_M2_MASK, VFMIN_VF }, // 1340
  { PseudoVFMIN_VF32_M4, VFMIN_VF }, // 1341
  { PseudoVFMIN_VF32_M4_MASK, VFMIN_VF }, // 1342
  { PseudoVFMIN_VF32_M8, VFMIN_VF }, // 1343
  { PseudoVFMIN_VF32_M8_MASK, VFMIN_VF }, // 1344
  { PseudoVFMIN_VF32_MF2, VFMIN_VF }, // 1345
  { PseudoVFMIN_VF32_MF2_MASK, VFMIN_VF }, // 1346
  { PseudoVFMIN_VF32_MF4, VFMIN_VF }, // 1347
  { PseudoVFMIN_VF32_MF4_MASK, VFMIN_VF }, // 1348
  { PseudoVFMIN_VF32_MF8, VFMIN_VF }, // 1349
  { PseudoVFMIN_VF32_MF8_MASK, VFMIN_VF }, // 1350
  { PseudoVFMIN_VF64_M1, VFMIN_VF }, // 1351
  { PseudoVFMIN_VF64_M1_MASK, VFMIN_VF }, // 1352
  { PseudoVFMIN_VF64_M2, VFMIN_VF }, // 1353
  { PseudoVFMIN_VF64_M2_MASK, VFMIN_VF }, // 1354
  { PseudoVFMIN_VF64_M4, VFMIN_VF }, // 1355
  { PseudoVFMIN_VF64_M4_MASK, VFMIN_VF }, // 1356
  { PseudoVFMIN_VF64_M8, VFMIN_VF }, // 1357
  { PseudoVFMIN_VF64_M8_MASK, VFMIN_VF }, // 1358
  { PseudoVFMIN_VF64_MF2, VFMIN_VF }, // 1359
  { PseudoVFMIN_VF64_MF2_MASK, VFMIN_VF }, // 1360
  { PseudoVFMIN_VF64_MF4, VFMIN_VF }, // 1361
  { PseudoVFMIN_VF64_MF4_MASK, VFMIN_VF }, // 1362
  { PseudoVFMIN_VF64_MF8, VFMIN_VF }, // 1363
  { PseudoVFMIN_VF64_MF8_MASK, VFMIN_VF }, // 1364
  { PseudoVFMIN_VV_M1, VFMIN_VV }, // 1365
  { PseudoVFMIN_VV_M1_MASK, VFMIN_VV }, // 1366
  { PseudoVFMIN_VV_M2, VFMIN_VV }, // 1367
  { PseudoVFMIN_VV_M2_MASK, VFMIN_VV }, // 1368
  { PseudoVFMIN_VV_M4, VFMIN_VV }, // 1369
  { PseudoVFMIN_VV_M4_MASK, VFMIN_VV }, // 1370
  { PseudoVFMIN_VV_M8, VFMIN_VV }, // 1371
  { PseudoVFMIN_VV_M8_MASK, VFMIN_VV }, // 1372
  { PseudoVFMIN_VV_MF2, VFMIN_VV }, // 1373
  { PseudoVFMIN_VV_MF2_MASK, VFMIN_VV }, // 1374
  { PseudoVFMIN_VV_MF4, VFMIN_VV }, // 1375
  { PseudoVFMIN_VV_MF4_MASK, VFMIN_VV }, // 1376
  { PseudoVFMIN_VV_MF8, VFMIN_VV }, // 1377
  { PseudoVFMIN_VV_MF8_MASK, VFMIN_VV }, // 1378
  { PseudoVFMSAC_VF16_M1, VFMSAC_VF }, // 1379
  { PseudoVFMSAC_VF16_M1_MASK, VFMSAC_VF }, // 1380
  { PseudoVFMSAC_VF16_M2, VFMSAC_VF }, // 1381
  { PseudoVFMSAC_VF16_M2_MASK, VFMSAC_VF }, // 1382
  { PseudoVFMSAC_VF16_M4, VFMSAC_VF }, // 1383
  { PseudoVFMSAC_VF16_M4_MASK, VFMSAC_VF }, // 1384
  { PseudoVFMSAC_VF16_M8, VFMSAC_VF }, // 1385
  { PseudoVFMSAC_VF16_M8_MASK, VFMSAC_VF }, // 1386
  { PseudoVFMSAC_VF16_MF2, VFMSAC_VF }, // 1387
  { PseudoVFMSAC_VF16_MF2_MASK, VFMSAC_VF }, // 1388
  { PseudoVFMSAC_VF16_MF4, VFMSAC_VF }, // 1389
  { PseudoVFMSAC_VF16_MF4_MASK, VFMSAC_VF }, // 1390
  { PseudoVFMSAC_VF16_MF8, VFMSAC_VF }, // 1391
  { PseudoVFMSAC_VF16_MF8_MASK, VFMSAC_VF }, // 1392
  { PseudoVFMSAC_VF32_M1, VFMSAC_VF }, // 1393
  { PseudoVFMSAC_VF32_M1_MASK, VFMSAC_VF }, // 1394
  { PseudoVFMSAC_VF32_M2, VFMSAC_VF }, // 1395
  { PseudoVFMSAC_VF32_M2_MASK, VFMSAC_VF }, // 1396
  { PseudoVFMSAC_VF32_M4, VFMSAC_VF }, // 1397
  { PseudoVFMSAC_VF32_M4_MASK, VFMSAC_VF }, // 1398
  { PseudoVFMSAC_VF32_M8, VFMSAC_VF }, // 1399
  { PseudoVFMSAC_VF32_M8_MASK, VFMSAC_VF }, // 1400
  { PseudoVFMSAC_VF32_MF2, VFMSAC_VF }, // 1401
  { PseudoVFMSAC_VF32_MF2_MASK, VFMSAC_VF }, // 1402
  { PseudoVFMSAC_VF32_MF4, VFMSAC_VF }, // 1403
  { PseudoVFMSAC_VF32_MF4_MASK, VFMSAC_VF }, // 1404
  { PseudoVFMSAC_VF32_MF8, VFMSAC_VF }, // 1405
  { PseudoVFMSAC_VF32_MF8_MASK, VFMSAC_VF }, // 1406
  { PseudoVFMSAC_VF64_M1, VFMSAC_VF }, // 1407
  { PseudoVFMSAC_VF64_M1_MASK, VFMSAC_VF }, // 1408
  { PseudoVFMSAC_VF64_M2, VFMSAC_VF }, // 1409
  { PseudoVFMSAC_VF64_M2_MASK, VFMSAC_VF }, // 1410
  { PseudoVFMSAC_VF64_M4, VFMSAC_VF }, // 1411
  { PseudoVFMSAC_VF64_M4_MASK, VFMSAC_VF }, // 1412
  { PseudoVFMSAC_VF64_M8, VFMSAC_VF }, // 1413
  { PseudoVFMSAC_VF64_M8_MASK, VFMSAC_VF }, // 1414
  { PseudoVFMSAC_VF64_MF2, VFMSAC_VF }, // 1415
  { PseudoVFMSAC_VF64_MF2_MASK, VFMSAC_VF }, // 1416
  { PseudoVFMSAC_VF64_MF4, VFMSAC_VF }, // 1417
  { PseudoVFMSAC_VF64_MF4_MASK, VFMSAC_VF }, // 1418
  { PseudoVFMSAC_VF64_MF8, VFMSAC_VF }, // 1419
  { PseudoVFMSAC_VF64_MF8_MASK, VFMSAC_VF }, // 1420
  { PseudoVFMSAC_VV_M1, VFMSAC_VV }, // 1421
  { PseudoVFMSAC_VV_M1_MASK, VFMSAC_VV }, // 1422
  { PseudoVFMSAC_VV_M2, VFMSAC_VV }, // 1423
  { PseudoVFMSAC_VV_M2_MASK, VFMSAC_VV }, // 1424
  { PseudoVFMSAC_VV_M4, VFMSAC_VV }, // 1425
  { PseudoVFMSAC_VV_M4_MASK, VFMSAC_VV }, // 1426
  { PseudoVFMSAC_VV_M8, VFMSAC_VV }, // 1427
  { PseudoVFMSAC_VV_M8_MASK, VFMSAC_VV }, // 1428
  { PseudoVFMSAC_VV_MF2, VFMSAC_VV }, // 1429
  { PseudoVFMSAC_VV_MF2_MASK, VFMSAC_VV }, // 1430
  { PseudoVFMSAC_VV_MF4, VFMSAC_VV }, // 1431
  { PseudoVFMSAC_VV_MF4_MASK, VFMSAC_VV }, // 1432
  { PseudoVFMSAC_VV_MF8, VFMSAC_VV }, // 1433
  { PseudoVFMSAC_VV_MF8_MASK, VFMSAC_VV }, // 1434
  { PseudoVFMSUB_VF16_M1, VFMSUB_VF }, // 1435
  { PseudoVFMSUB_VF16_M1_MASK, VFMSUB_VF }, // 1436
  { PseudoVFMSUB_VF16_M2, VFMSUB_VF }, // 1437
  { PseudoVFMSUB_VF16_M2_MASK, VFMSUB_VF }, // 1438
  { PseudoVFMSUB_VF16_M4, VFMSUB_VF }, // 1439
  { PseudoVFMSUB_VF16_M4_MASK, VFMSUB_VF }, // 1440
  { PseudoVFMSUB_VF16_M8, VFMSUB_VF }, // 1441
  { PseudoVFMSUB_VF16_M8_MASK, VFMSUB_VF }, // 1442
  { PseudoVFMSUB_VF16_MF2, VFMSUB_VF }, // 1443
  { PseudoVFMSUB_VF16_MF2_MASK, VFMSUB_VF }, // 1444
  { PseudoVFMSUB_VF16_MF4, VFMSUB_VF }, // 1445
  { PseudoVFMSUB_VF16_MF4_MASK, VFMSUB_VF }, // 1446
  { PseudoVFMSUB_VF16_MF8, VFMSUB_VF }, // 1447
  { PseudoVFMSUB_VF16_MF8_MASK, VFMSUB_VF }, // 1448
  { PseudoVFMSUB_VF32_M1, VFMSUB_VF }, // 1449
  { PseudoVFMSUB_VF32_M1_MASK, VFMSUB_VF }, // 1450
  { PseudoVFMSUB_VF32_M2, VFMSUB_VF }, // 1451
  { PseudoVFMSUB_VF32_M2_MASK, VFMSUB_VF }, // 1452
  { PseudoVFMSUB_VF32_M4, VFMSUB_VF }, // 1453
  { PseudoVFMSUB_VF32_M4_MASK, VFMSUB_VF }, // 1454
  { PseudoVFMSUB_VF32_M8, VFMSUB_VF }, // 1455
  { PseudoVFMSUB_VF32_M8_MASK, VFMSUB_VF }, // 1456
  { PseudoVFMSUB_VF32_MF2, VFMSUB_VF }, // 1457
  { PseudoVFMSUB_VF32_MF2_MASK, VFMSUB_VF }, // 1458
  { PseudoVFMSUB_VF32_MF4, VFMSUB_VF }, // 1459
  { PseudoVFMSUB_VF32_MF4_MASK, VFMSUB_VF }, // 1460
  { PseudoVFMSUB_VF32_MF8, VFMSUB_VF }, // 1461
  { PseudoVFMSUB_VF32_MF8_MASK, VFMSUB_VF }, // 1462
  { PseudoVFMSUB_VF64_M1, VFMSUB_VF }, // 1463
  { PseudoVFMSUB_VF64_M1_MASK, VFMSUB_VF }, // 1464
  { PseudoVFMSUB_VF64_M2, VFMSUB_VF }, // 1465
  { PseudoVFMSUB_VF64_M2_MASK, VFMSUB_VF }, // 1466
  { PseudoVFMSUB_VF64_M4, VFMSUB_VF }, // 1467
  { PseudoVFMSUB_VF64_M4_MASK, VFMSUB_VF }, // 1468
  { PseudoVFMSUB_VF64_M8, VFMSUB_VF }, // 1469
  { PseudoVFMSUB_VF64_M8_MASK, VFMSUB_VF }, // 1470
  { PseudoVFMSUB_VF64_MF2, VFMSUB_VF }, // 1471
  { PseudoVFMSUB_VF64_MF2_MASK, VFMSUB_VF }, // 1472
  { PseudoVFMSUB_VF64_MF4, VFMSUB_VF }, // 1473
  { PseudoVFMSUB_VF64_MF4_MASK, VFMSUB_VF }, // 1474
  { PseudoVFMSUB_VF64_MF8, VFMSUB_VF }, // 1475
  { PseudoVFMSUB_VF64_MF8_MASK, VFMSUB_VF }, // 1476
  { PseudoVFMSUB_VV_M1, VFMSUB_VV }, // 1477
  { PseudoVFMSUB_VV_M1_MASK, VFMSUB_VV }, // 1478
  { PseudoVFMSUB_VV_M2, VFMSUB_VV }, // 1479
  { PseudoVFMSUB_VV_M2_MASK, VFMSUB_VV }, // 1480
  { PseudoVFMSUB_VV_M4, VFMSUB_VV }, // 1481
  { PseudoVFMSUB_VV_M4_MASK, VFMSUB_VV }, // 1482
  { PseudoVFMSUB_VV_M8, VFMSUB_VV }, // 1483
  { PseudoVFMSUB_VV_M8_MASK, VFMSUB_VV }, // 1484
  { PseudoVFMSUB_VV_MF2, VFMSUB_VV }, // 1485
  { PseudoVFMSUB_VV_MF2_MASK, VFMSUB_VV }, // 1486
  { PseudoVFMSUB_VV_MF4, VFMSUB_VV }, // 1487
  { PseudoVFMSUB_VV_MF4_MASK, VFMSUB_VV }, // 1488
  { PseudoVFMSUB_VV_MF8, VFMSUB_VV }, // 1489
  { PseudoVFMSUB_VV_MF8_MASK, VFMSUB_VV }, // 1490
  { PseudoVFMUL_VF16_M1, VFMUL_VF }, // 1491
  { PseudoVFMUL_VF16_M1_MASK, VFMUL_VF }, // 1492
  { PseudoVFMUL_VF16_M2, VFMUL_VF }, // 1493
  { PseudoVFMUL_VF16_M2_MASK, VFMUL_VF }, // 1494
  { PseudoVFMUL_VF16_M4, VFMUL_VF }, // 1495
  { PseudoVFMUL_VF16_M4_MASK, VFMUL_VF }, // 1496
  { PseudoVFMUL_VF16_M8, VFMUL_VF }, // 1497
  { PseudoVFMUL_VF16_M8_MASK, VFMUL_VF }, // 1498
  { PseudoVFMUL_VF16_MF2, VFMUL_VF }, // 1499
  { PseudoVFMUL_VF16_MF2_MASK, VFMUL_VF }, // 1500
  { PseudoVFMUL_VF16_MF4, VFMUL_VF }, // 1501
  { PseudoVFMUL_VF16_MF4_MASK, VFMUL_VF }, // 1502
  { PseudoVFMUL_VF16_MF8, VFMUL_VF }, // 1503
  { PseudoVFMUL_VF16_MF8_MASK, VFMUL_VF }, // 1504
  { PseudoVFMUL_VF32_M1, VFMUL_VF }, // 1505
  { PseudoVFMUL_VF32_M1_MASK, VFMUL_VF }, // 1506
  { PseudoVFMUL_VF32_M2, VFMUL_VF }, // 1507
  { PseudoVFMUL_VF32_M2_MASK, VFMUL_VF }, // 1508
  { PseudoVFMUL_VF32_M4, VFMUL_VF }, // 1509
  { PseudoVFMUL_VF32_M4_MASK, VFMUL_VF }, // 1510
  { PseudoVFMUL_VF32_M8, VFMUL_VF }, // 1511
  { PseudoVFMUL_VF32_M8_MASK, VFMUL_VF }, // 1512
  { PseudoVFMUL_VF32_MF2, VFMUL_VF }, // 1513
  { PseudoVFMUL_VF32_MF2_MASK, VFMUL_VF }, // 1514
  { PseudoVFMUL_VF32_MF4, VFMUL_VF }, // 1515
  { PseudoVFMUL_VF32_MF4_MASK, VFMUL_VF }, // 1516
  { PseudoVFMUL_VF32_MF8, VFMUL_VF }, // 1517
  { PseudoVFMUL_VF32_MF8_MASK, VFMUL_VF }, // 1518
  { PseudoVFMUL_VF64_M1, VFMUL_VF }, // 1519
  { PseudoVFMUL_VF64_M1_MASK, VFMUL_VF }, // 1520
  { PseudoVFMUL_VF64_M2, VFMUL_VF }, // 1521
  { PseudoVFMUL_VF64_M2_MASK, VFMUL_VF }, // 1522
  { PseudoVFMUL_VF64_M4, VFMUL_VF }, // 1523
  { PseudoVFMUL_VF64_M4_MASK, VFMUL_VF }, // 1524
  { PseudoVFMUL_VF64_M8, VFMUL_VF }, // 1525
  { PseudoVFMUL_VF64_M8_MASK, VFMUL_VF }, // 1526
  { PseudoVFMUL_VF64_MF2, VFMUL_VF }, // 1527
  { PseudoVFMUL_VF64_MF2_MASK, VFMUL_VF }, // 1528
  { PseudoVFMUL_VF64_MF4, VFMUL_VF }, // 1529
  { PseudoVFMUL_VF64_MF4_MASK, VFMUL_VF }, // 1530
  { PseudoVFMUL_VF64_MF8, VFMUL_VF }, // 1531
  { PseudoVFMUL_VF64_MF8_MASK, VFMUL_VF }, // 1532
  { PseudoVFMUL_VV_M1, VFMUL_VV }, // 1533
  { PseudoVFMUL_VV_M1_MASK, VFMUL_VV }, // 1534
  { PseudoVFMUL_VV_M2, VFMUL_VV }, // 1535
  { PseudoVFMUL_VV_M2_MASK, VFMUL_VV }, // 1536
  { PseudoVFMUL_VV_M4, VFMUL_VV }, // 1537
  { PseudoVFMUL_VV_M4_MASK, VFMUL_VV }, // 1538
  { PseudoVFMUL_VV_M8, VFMUL_VV }, // 1539
  { PseudoVFMUL_VV_M8_MASK, VFMUL_VV }, // 1540
  { PseudoVFMUL_VV_MF2, VFMUL_VV }, // 1541
  { PseudoVFMUL_VV_MF2_MASK, VFMUL_VV }, // 1542
  { PseudoVFMUL_VV_MF4, VFMUL_VV }, // 1543
  { PseudoVFMUL_VV_MF4_MASK, VFMUL_VV }, // 1544
  { PseudoVFMUL_VV_MF8, VFMUL_VV }, // 1545
  { PseudoVFMUL_VV_MF8_MASK, VFMUL_VV }, // 1546
  { PseudoVFMV_F16_S_M1, VFMV_F_S }, // 1547
  { PseudoVFMV_F16_S_M2, VFMV_F_S }, // 1548
  { PseudoVFMV_F16_S_M4, VFMV_F_S }, // 1549
  { PseudoVFMV_F16_S_M8, VFMV_F_S }, // 1550
  { PseudoVFMV_F16_S_MF2, VFMV_F_S }, // 1551
  { PseudoVFMV_F16_S_MF4, VFMV_F_S }, // 1552
  { PseudoVFMV_F16_S_MF8, VFMV_F_S }, // 1553
  { PseudoVFMV_F32_S_M1, VFMV_F_S }, // 1554
  { PseudoVFMV_F32_S_M2, VFMV_F_S }, // 1555
  { PseudoVFMV_F32_S_M4, VFMV_F_S }, // 1556
  { PseudoVFMV_F32_S_M8, VFMV_F_S }, // 1557
  { PseudoVFMV_F32_S_MF2, VFMV_F_S }, // 1558
  { PseudoVFMV_F32_S_MF4, VFMV_F_S }, // 1559
  { PseudoVFMV_F32_S_MF8, VFMV_F_S }, // 1560
  { PseudoVFMV_F64_S_M1, VFMV_F_S }, // 1561
  { PseudoVFMV_F64_S_M2, VFMV_F_S }, // 1562
  { PseudoVFMV_F64_S_M4, VFMV_F_S }, // 1563
  { PseudoVFMV_F64_S_M8, VFMV_F_S }, // 1564
  { PseudoVFMV_F64_S_MF2, VFMV_F_S }, // 1565
  { PseudoVFMV_F64_S_MF4, VFMV_F_S }, // 1566
  { PseudoVFMV_F64_S_MF8, VFMV_F_S }, // 1567
  { PseudoVFMV_S_F16_M1, VFMV_S_F }, // 1568
  { PseudoVFMV_S_F16_M2, VFMV_S_F }, // 1569
  { PseudoVFMV_S_F16_M4, VFMV_S_F }, // 1570
  { PseudoVFMV_S_F16_M8, VFMV_S_F }, // 1571
  { PseudoVFMV_S_F16_MF2, VFMV_S_F }, // 1572
  { PseudoVFMV_S_F16_MF4, VFMV_S_F }, // 1573
  { PseudoVFMV_S_F16_MF8, VFMV_S_F }, // 1574
  { PseudoVFMV_S_F32_M1, VFMV_S_F }, // 1575
  { PseudoVFMV_S_F32_M2, VFMV_S_F }, // 1576
  { PseudoVFMV_S_F32_M4, VFMV_S_F }, // 1577
  { PseudoVFMV_S_F32_M8, VFMV_S_F }, // 1578
  { PseudoVFMV_S_F32_MF2, VFMV_S_F }, // 1579
  { PseudoVFMV_S_F32_MF4, VFMV_S_F }, // 1580
  { PseudoVFMV_S_F32_MF8, VFMV_S_F }, // 1581
  { PseudoVFMV_S_F64_M1, VFMV_S_F }, // 1582
  { PseudoVFMV_S_F64_M2, VFMV_S_F }, // 1583
  { PseudoVFMV_S_F64_M4, VFMV_S_F }, // 1584
  { PseudoVFMV_S_F64_M8, VFMV_S_F }, // 1585
  { PseudoVFMV_S_F64_MF2, VFMV_S_F }, // 1586
  { PseudoVFMV_S_F64_MF4, VFMV_S_F }, // 1587
  { PseudoVFMV_S_F64_MF8, VFMV_S_F }, // 1588
  { PseudoVFMV_V_F16_M1, VFMV_V_F }, // 1589
  { PseudoVFMV_V_F16_M2, VFMV_V_F }, // 1590
  { PseudoVFMV_V_F16_M4, VFMV_V_F }, // 1591
  { PseudoVFMV_V_F16_M8, VFMV_V_F }, // 1592
  { PseudoVFMV_V_F16_MF2, VFMV_V_F }, // 1593
  { PseudoVFMV_V_F16_MF4, VFMV_V_F }, // 1594
  { PseudoVFMV_V_F16_MF8, VFMV_V_F }, // 1595
  { PseudoVFMV_V_F32_M1, VFMV_V_F }, // 1596
  { PseudoVFMV_V_F32_M2, VFMV_V_F }, // 1597
  { PseudoVFMV_V_F32_M4, VFMV_V_F }, // 1598
  { PseudoVFMV_V_F32_M8, VFMV_V_F }, // 1599
  { PseudoVFMV_V_F32_MF2, VFMV_V_F }, // 1600
  { PseudoVFMV_V_F32_MF4, VFMV_V_F }, // 1601
  { PseudoVFMV_V_F32_MF8, VFMV_V_F }, // 1602
  { PseudoVFMV_V_F64_M1, VFMV_V_F }, // 1603
  { PseudoVFMV_V_F64_M2, VFMV_V_F }, // 1604
  { PseudoVFMV_V_F64_M4, VFMV_V_F }, // 1605
  { PseudoVFMV_V_F64_M8, VFMV_V_F }, // 1606
  { PseudoVFMV_V_F64_MF2, VFMV_V_F }, // 1607
  { PseudoVFMV_V_F64_MF4, VFMV_V_F }, // 1608
  { PseudoVFMV_V_F64_MF8, VFMV_V_F }, // 1609
  { PseudoVFNCVT_F_F_W_M1, VFNCVT_F_F_W }, // 1610
  { PseudoVFNCVT_F_F_W_M1_MASK, VFNCVT_F_F_W }, // 1611
  { PseudoVFNCVT_F_F_W_M2, VFNCVT_F_F_W }, // 1612
  { PseudoVFNCVT_F_F_W_M2_MASK, VFNCVT_F_F_W }, // 1613
  { PseudoVFNCVT_F_F_W_M4, VFNCVT_F_F_W }, // 1614
  { PseudoVFNCVT_F_F_W_M4_MASK, VFNCVT_F_F_W }, // 1615
  { PseudoVFNCVT_F_F_W_MF2, VFNCVT_F_F_W }, // 1616
  { PseudoVFNCVT_F_F_W_MF2_MASK, VFNCVT_F_F_W }, // 1617
  { PseudoVFNCVT_F_F_W_MF4, VFNCVT_F_F_W }, // 1618
  { PseudoVFNCVT_F_F_W_MF4_MASK, VFNCVT_F_F_W }, // 1619
  { PseudoVFNCVT_F_F_W_MF8, VFNCVT_F_F_W }, // 1620
  { PseudoVFNCVT_F_F_W_MF8_MASK, VFNCVT_F_F_W }, // 1621
  { PseudoVFNCVT_F_XU_W_M1, VFNCVT_F_XU_W }, // 1622
  { PseudoVFNCVT_F_XU_W_M1_MASK, VFNCVT_F_XU_W }, // 1623
  { PseudoVFNCVT_F_XU_W_M2, VFNCVT_F_XU_W }, // 1624
  { PseudoVFNCVT_F_XU_W_M2_MASK, VFNCVT_F_XU_W }, // 1625
  { PseudoVFNCVT_F_XU_W_M4, VFNCVT_F_XU_W }, // 1626
  { PseudoVFNCVT_F_XU_W_M4_MASK, VFNCVT_F_XU_W }, // 1627
  { PseudoVFNCVT_F_XU_W_MF2, VFNCVT_F_XU_W }, // 1628
  { PseudoVFNCVT_F_XU_W_MF2_MASK, VFNCVT_F_XU_W }, // 1629
  { PseudoVFNCVT_F_XU_W_MF4, VFNCVT_F_XU_W }, // 1630
  { PseudoVFNCVT_F_XU_W_MF4_MASK, VFNCVT_F_XU_W }, // 1631
  { PseudoVFNCVT_F_XU_W_MF8, VFNCVT_F_XU_W }, // 1632
  { PseudoVFNCVT_F_XU_W_MF8_MASK, VFNCVT_F_XU_W }, // 1633
  { PseudoVFNCVT_F_X_W_M1, VFNCVT_F_X_W }, // 1634
  { PseudoVFNCVT_F_X_W_M1_MASK, VFNCVT_F_X_W }, // 1635
  { PseudoVFNCVT_F_X_W_M2, VFNCVT_F_X_W }, // 1636
  { PseudoVFNCVT_F_X_W_M2_MASK, VFNCVT_F_X_W }, // 1637
  { PseudoVFNCVT_F_X_W_M4, VFNCVT_F_X_W }, // 1638
  { PseudoVFNCVT_F_X_W_M4_MASK, VFNCVT_F_X_W }, // 1639
  { PseudoVFNCVT_F_X_W_MF2, VFNCVT_F_X_W }, // 1640
  { PseudoVFNCVT_F_X_W_MF2_MASK, VFNCVT_F_X_W }, // 1641
  { PseudoVFNCVT_F_X_W_MF4, VFNCVT_F_X_W }, // 1642
  { PseudoVFNCVT_F_X_W_MF4_MASK, VFNCVT_F_X_W }, // 1643
  { PseudoVFNCVT_F_X_W_MF8, VFNCVT_F_X_W }, // 1644
  { PseudoVFNCVT_F_X_W_MF8_MASK, VFNCVT_F_X_W }, // 1645
  { PseudoVFNCVT_ROD_F_F_W_M1, VFNCVT_ROD_F_F_W }, // 1646
  { PseudoVFNCVT_ROD_F_F_W_M1_MASK, VFNCVT_ROD_F_F_W }, // 1647
  { PseudoVFNCVT_ROD_F_F_W_M2, VFNCVT_ROD_F_F_W }, // 1648
  { PseudoVFNCVT_ROD_F_F_W_M2_MASK, VFNCVT_ROD_F_F_W }, // 1649
  { PseudoVFNCVT_ROD_F_F_W_M4, VFNCVT_ROD_F_F_W }, // 1650
  { PseudoVFNCVT_ROD_F_F_W_M4_MASK, VFNCVT_ROD_F_F_W }, // 1651
  { PseudoVFNCVT_ROD_F_F_W_MF2, VFNCVT_ROD_F_F_W }, // 1652
  { PseudoVFNCVT_ROD_F_F_W_MF2_MASK, VFNCVT_ROD_F_F_W }, // 1653
  { PseudoVFNCVT_ROD_F_F_W_MF4, VFNCVT_ROD_F_F_W }, // 1654
  { PseudoVFNCVT_ROD_F_F_W_MF4_MASK, VFNCVT_ROD_F_F_W }, // 1655
  { PseudoVFNCVT_ROD_F_F_W_MF8, VFNCVT_ROD_F_F_W }, // 1656
  { PseudoVFNCVT_ROD_F_F_W_MF8_MASK, VFNCVT_ROD_F_F_W }, // 1657
  { PseudoVFNCVT_RTZ_XU_F_W_M1, VFNCVT_RTZ_XU_F_W }, // 1658
  { PseudoVFNCVT_RTZ_XU_F_W_M1_MASK, VFNCVT_RTZ_XU_F_W }, // 1659
  { PseudoVFNCVT_RTZ_XU_F_W_M2, VFNCVT_RTZ_XU_F_W }, // 1660
  { PseudoVFNCVT_RTZ_XU_F_W_M2_MASK, VFNCVT_RTZ_XU_F_W }, // 1661
  { PseudoVFNCVT_RTZ_XU_F_W_M4, VFNCVT_RTZ_XU_F_W }, // 1662
  { PseudoVFNCVT_RTZ_XU_F_W_M4_MASK, VFNCVT_RTZ_XU_F_W }, // 1663
  { PseudoVFNCVT_RTZ_XU_F_W_MF2, VFNCVT_RTZ_XU_F_W }, // 1664
  { PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK, VFNCVT_RTZ_XU_F_W }, // 1665
  { PseudoVFNCVT_RTZ_XU_F_W_MF4, VFNCVT_RTZ_XU_F_W }, // 1666
  { PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK, VFNCVT_RTZ_XU_F_W }, // 1667
  { PseudoVFNCVT_RTZ_XU_F_W_MF8, VFNCVT_RTZ_XU_F_W }, // 1668
  { PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK, VFNCVT_RTZ_XU_F_W }, // 1669
  { PseudoVFNCVT_RTZ_X_F_W_M1, VFNCVT_RTZ_X_F_W }, // 1670
  { PseudoVFNCVT_RTZ_X_F_W_M1_MASK, VFNCVT_RTZ_X_F_W }, // 1671
  { PseudoVFNCVT_RTZ_X_F_W_M2, VFNCVT_RTZ_X_F_W }, // 1672
  { PseudoVFNCVT_RTZ_X_F_W_M2_MASK, VFNCVT_RTZ_X_F_W }, // 1673
  { PseudoVFNCVT_RTZ_X_F_W_M4, VFNCVT_RTZ_X_F_W }, // 1674
  { PseudoVFNCVT_RTZ_X_F_W_M4_MASK, VFNCVT_RTZ_X_F_W }, // 1675
  { PseudoVFNCVT_RTZ_X_F_W_MF2, VFNCVT_RTZ_X_F_W }, // 1676
  { PseudoVFNCVT_RTZ_X_F_W_MF2_MASK, VFNCVT_RTZ_X_F_W }, // 1677
  { PseudoVFNCVT_RTZ_X_F_W_MF4, VFNCVT_RTZ_X_F_W }, // 1678
  { PseudoVFNCVT_RTZ_X_F_W_MF4_MASK, VFNCVT_RTZ_X_F_W }, // 1679
  { PseudoVFNCVT_RTZ_X_F_W_MF8, VFNCVT_RTZ_X_F_W }, // 1680
  { PseudoVFNCVT_RTZ_X_F_W_MF8_MASK, VFNCVT_RTZ_X_F_W }, // 1681
  { PseudoVFNCVT_XU_F_W_M1, VFNCVT_XU_F_W }, // 1682
  { PseudoVFNCVT_XU_F_W_M1_MASK, VFNCVT_XU_F_W }, // 1683
  { PseudoVFNCVT_XU_F_W_M2, VFNCVT_XU_F_W }, // 1684
  { PseudoVFNCVT_XU_F_W_M2_MASK, VFNCVT_XU_F_W }, // 1685
  { PseudoVFNCVT_XU_F_W_M4, VFNCVT_XU_F_W }, // 1686
  { PseudoVFNCVT_XU_F_W_M4_MASK, VFNCVT_XU_F_W }, // 1687
  { PseudoVFNCVT_XU_F_W_MF2, VFNCVT_XU_F_W }, // 1688
  { PseudoVFNCVT_XU_F_W_MF2_MASK, VFNCVT_XU_F_W }, // 1689
  { PseudoVFNCVT_XU_F_W_MF4, VFNCVT_XU_F_W }, // 1690
  { PseudoVFNCVT_XU_F_W_MF4_MASK, VFNCVT_XU_F_W }, // 1691
  { PseudoVFNCVT_XU_F_W_MF8, VFNCVT_XU_F_W }, // 1692
  { PseudoVFNCVT_XU_F_W_MF8_MASK, VFNCVT_XU_F_W }, // 1693
  { PseudoVFNCVT_X_F_W_M1, VFNCVT_X_F_W }, // 1694
  { PseudoVFNCVT_X_F_W_M1_MASK, VFNCVT_X_F_W }, // 1695
  { PseudoVFNCVT_X_F_W_M2, VFNCVT_X_F_W }, // 1696
  { PseudoVFNCVT_X_F_W_M2_MASK, VFNCVT_X_F_W }, // 1697
  { PseudoVFNCVT_X_F_W_M4, VFNCVT_X_F_W }, // 1698
  { PseudoVFNCVT_X_F_W_M4_MASK, VFNCVT_X_F_W }, // 1699
  { PseudoVFNCVT_X_F_W_MF2, VFNCVT_X_F_W }, // 1700
  { PseudoVFNCVT_X_F_W_MF2_MASK, VFNCVT_X_F_W }, // 1701
  { PseudoVFNCVT_X_F_W_MF4, VFNCVT_X_F_W }, // 1702
  { PseudoVFNCVT_X_F_W_MF4_MASK, VFNCVT_X_F_W }, // 1703
  { PseudoVFNCVT_X_F_W_MF8, VFNCVT_X_F_W }, // 1704
  { PseudoVFNCVT_X_F_W_MF8_MASK, VFNCVT_X_F_W }, // 1705
  { PseudoVFNMACC_VF16_M1, VFNMACC_VF }, // 1706
  { PseudoVFNMACC_VF16_M1_MASK, VFNMACC_VF }, // 1707
  { PseudoVFNMACC_VF16_M2, VFNMACC_VF }, // 1708
  { PseudoVFNMACC_VF16_M2_MASK, VFNMACC_VF }, // 1709
  { PseudoVFNMACC_VF16_M4, VFNMACC_VF }, // 1710
  { PseudoVFNMACC_VF16_M4_MASK, VFNMACC_VF }, // 1711
  { PseudoVFNMACC_VF16_M8, VFNMACC_VF }, // 1712
  { PseudoVFNMACC_VF16_M8_MASK, VFNMACC_VF }, // 1713
  { PseudoVFNMACC_VF16_MF2, VFNMACC_VF }, // 1714
  { PseudoVFNMACC_VF16_MF2_MASK, VFNMACC_VF }, // 1715
  { PseudoVFNMACC_VF16_MF4, VFNMACC_VF }, // 1716
  { PseudoVFNMACC_VF16_MF4_MASK, VFNMACC_VF }, // 1717
  { PseudoVFNMACC_VF16_MF8, VFNMACC_VF }, // 1718
  { PseudoVFNMACC_VF16_MF8_MASK, VFNMACC_VF }, // 1719
  { PseudoVFNMACC_VF32_M1, VFNMACC_VF }, // 1720
  { PseudoVFNMACC_VF32_M1_MASK, VFNMACC_VF }, // 1721
  { PseudoVFNMACC_VF32_M2, VFNMACC_VF }, // 1722
  { PseudoVFNMACC_VF32_M2_MASK, VFNMACC_VF }, // 1723
  { PseudoVFNMACC_VF32_M4, VFNMACC_VF }, // 1724
  { PseudoVFNMACC_VF32_M4_MASK, VFNMACC_VF }, // 1725
  { PseudoVFNMACC_VF32_M8, VFNMACC_VF }, // 1726
  { PseudoVFNMACC_VF32_M8_MASK, VFNMACC_VF }, // 1727
  { PseudoVFNMACC_VF32_MF2, VFNMACC_VF }, // 1728
  { PseudoVFNMACC_VF32_MF2_MASK, VFNMACC_VF }, // 1729
  { PseudoVFNMACC_VF32_MF4, VFNMACC_VF }, // 1730
  { PseudoVFNMACC_VF32_MF4_MASK, VFNMACC_VF }, // 1731
  { PseudoVFNMACC_VF32_MF8, VFNMACC_VF }, // 1732
  { PseudoVFNMACC_VF32_MF8_MASK, VFNMACC_VF }, // 1733
  { PseudoVFNMACC_VF64_M1, VFNMACC_VF }, // 1734
  { PseudoVFNMACC_VF64_M1_MASK, VFNMACC_VF }, // 1735
  { PseudoVFNMACC_VF64_M2, VFNMACC_VF }, // 1736
  { PseudoVFNMACC_VF64_M2_MASK, VFNMACC_VF }, // 1737
  { PseudoVFNMACC_VF64_M4, VFNMACC_VF }, // 1738
  { PseudoVFNMACC_VF64_M4_MASK, VFNMACC_VF }, // 1739
  { PseudoVFNMACC_VF64_M8, VFNMACC_VF }, // 1740
  { PseudoVFNMACC_VF64_M8_MASK, VFNMACC_VF }, // 1741
  { PseudoVFNMACC_VF64_MF2, VFNMACC_VF }, // 1742
  { PseudoVFNMACC_VF64_MF2_MASK, VFNMACC_VF }, // 1743
  { PseudoVFNMACC_VF64_MF4, VFNMACC_VF }, // 1744
  { PseudoVFNMACC_VF64_MF4_MASK, VFNMACC_VF }, // 1745
  { PseudoVFNMACC_VF64_MF8, VFNMACC_VF }, // 1746
  { PseudoVFNMACC_VF64_MF8_MASK, VFNMACC_VF }, // 1747
  { PseudoVFNMACC_VV_M1, VFNMACC_VV }, // 1748
  { PseudoVFNMACC_VV_M1_MASK, VFNMACC_VV }, // 1749
  { PseudoVFNMACC_VV_M2, VFNMACC_VV }, // 1750
  { PseudoVFNMACC_VV_M2_MASK, VFNMACC_VV }, // 1751
  { PseudoVFNMACC_VV_M4, VFNMACC_VV }, // 1752
  { PseudoVFNMACC_VV_M4_MASK, VFNMACC_VV }, // 1753
  { PseudoVFNMACC_VV_M8, VFNMACC_VV }, // 1754
  { PseudoVFNMACC_VV_M8_MASK, VFNMACC_VV }, // 1755
  { PseudoVFNMACC_VV_MF2, VFNMACC_VV }, // 1756
  { PseudoVFNMACC_VV_MF2_MASK, VFNMACC_VV }, // 1757
  { PseudoVFNMACC_VV_MF4, VFNMACC_VV }, // 1758
  { PseudoVFNMACC_VV_MF4_MASK, VFNMACC_VV }, // 1759
  { PseudoVFNMACC_VV_MF8, VFNMACC_VV }, // 1760
  { PseudoVFNMACC_VV_MF8_MASK, VFNMACC_VV }, // 1761
  { PseudoVFNMADD_VF16_M1, VFNMADD_VF }, // 1762
  { PseudoVFNMADD_VF16_M1_MASK, VFNMADD_VF }, // 1763
  { PseudoVFNMADD_VF16_M2, VFNMADD_VF }, // 1764
  { PseudoVFNMADD_VF16_M2_MASK, VFNMADD_VF }, // 1765
  { PseudoVFNMADD_VF16_M4, VFNMADD_VF }, // 1766
  { PseudoVFNMADD_VF16_M4_MASK, VFNMADD_VF }, // 1767
  { PseudoVFNMADD_VF16_M8, VFNMADD_VF }, // 1768
  { PseudoVFNMADD_VF16_M8_MASK, VFNMADD_VF }, // 1769
  { PseudoVFNMADD_VF16_MF2, VFNMADD_VF }, // 1770
  { PseudoVFNMADD_VF16_MF2_MASK, VFNMADD_VF }, // 1771
  { PseudoVFNMADD_VF16_MF4, VFNMADD_VF }, // 1772
  { PseudoVFNMADD_VF16_MF4_MASK, VFNMADD_VF }, // 1773
  { PseudoVFNMADD_VF16_MF8, VFNMADD_VF }, // 1774
  { PseudoVFNMADD_VF16_MF8_MASK, VFNMADD_VF }, // 1775
  { PseudoVFNMADD_VF32_M1, VFNMADD_VF }, // 1776
  { PseudoVFNMADD_VF32_M1_MASK, VFNMADD_VF }, // 1777
  { PseudoVFNMADD_VF32_M2, VFNMADD_VF }, // 1778
  { PseudoVFNMADD_VF32_M2_MASK, VFNMADD_VF }, // 1779
  { PseudoVFNMADD_VF32_M4, VFNMADD_VF }, // 1780
  { PseudoVFNMADD_VF32_M4_MASK, VFNMADD_VF }, // 1781
  { PseudoVFNMADD_VF32_M8, VFNMADD_VF }, // 1782
  { PseudoVFNMADD_VF32_M8_MASK, VFNMADD_VF }, // 1783
  { PseudoVFNMADD_VF32_MF2, VFNMADD_VF }, // 1784
  { PseudoVFNMADD_VF32_MF2_MASK, VFNMADD_VF }, // 1785
  { PseudoVFNMADD_VF32_MF4, VFNMADD_VF }, // 1786
  { PseudoVFNMADD_VF32_MF4_MASK, VFNMADD_VF }, // 1787
  { PseudoVFNMADD_VF32_MF8, VFNMADD_VF }, // 1788
  { PseudoVFNMADD_VF32_MF8_MASK, VFNMADD_VF }, // 1789
  { PseudoVFNMADD_VF64_M1, VFNMADD_VF }, // 1790
  { PseudoVFNMADD_VF64_M1_MASK, VFNMADD_VF }, // 1791
  { PseudoVFNMADD_VF64_M2, VFNMADD_VF }, // 1792
  { PseudoVFNMADD_VF64_M2_MASK, VFNMADD_VF }, // 1793
  { PseudoVFNMADD_VF64_M4, VFNMADD_VF }, // 1794
  { PseudoVFNMADD_VF64_M4_MASK, VFNMADD_VF }, // 1795
  { PseudoVFNMADD_VF64_M8, VFNMADD_VF }, // 1796
  { PseudoVFNMADD_VF64_M8_MASK, VFNMADD_VF }, // 1797
  { PseudoVFNMADD_VF64_MF2, VFNMADD_VF }, // 1798
  { PseudoVFNMADD_VF64_MF2_MASK, VFNMADD_VF }, // 1799
  { PseudoVFNMADD_VF64_MF4, VFNMADD_VF }, // 1800
  { PseudoVFNMADD_VF64_MF4_MASK, VFNMADD_VF }, // 1801
  { PseudoVFNMADD_VF64_MF8, VFNMADD_VF }, // 1802
  { PseudoVFNMADD_VF64_MF8_MASK, VFNMADD_VF }, // 1803
  { PseudoVFNMADD_VV_M1, VFNMADD_VV }, // 1804
  { PseudoVFNMADD_VV_M1_MASK, VFNMADD_VV }, // 1805
  { PseudoVFNMADD_VV_M2, VFNMADD_VV }, // 1806
  { PseudoVFNMADD_VV_M2_MASK, VFNMADD_VV }, // 1807
  { PseudoVFNMADD_VV_M4, VFNMADD_VV }, // 1808
  { PseudoVFNMADD_VV_M4_MASK, VFNMADD_VV }, // 1809
  { PseudoVFNMADD_VV_M8, VFNMADD_VV }, // 1810
  { PseudoVFNMADD_VV_M8_MASK, VFNMADD_VV }, // 1811
  { PseudoVFNMADD_VV_MF2, VFNMADD_VV }, // 1812
  { PseudoVFNMADD_VV_MF2_MASK, VFNMADD_VV }, // 1813
  { PseudoVFNMADD_VV_MF4, VFNMADD_VV }, // 1814
  { PseudoVFNMADD_VV_MF4_MASK, VFNMADD_VV }, // 1815
  { PseudoVFNMADD_VV_MF8, VFNMADD_VV }, // 1816
  { PseudoVFNMADD_VV_MF8_MASK, VFNMADD_VV }, // 1817
  { PseudoVFNMSAC_VF16_M1, VFNMSAC_VF }, // 1818
  { PseudoVFNMSAC_VF16_M1_MASK, VFNMSAC_VF }, // 1819
  { PseudoVFNMSAC_VF16_M2, VFNMSAC_VF }, // 1820
  { PseudoVFNMSAC_VF16_M2_MASK, VFNMSAC_VF }, // 1821
  { PseudoVFNMSAC_VF16_M4, VFNMSAC_VF }, // 1822
  { PseudoVFNMSAC_VF16_M4_MASK, VFNMSAC_VF }, // 1823
  { PseudoVFNMSAC_VF16_M8, VFNMSAC_VF }, // 1824
  { PseudoVFNMSAC_VF16_M8_MASK, VFNMSAC_VF }, // 1825
  { PseudoVFNMSAC_VF16_MF2, VFNMSAC_VF }, // 1826
  { PseudoVFNMSAC_VF16_MF2_MASK, VFNMSAC_VF }, // 1827
  { PseudoVFNMSAC_VF16_MF4, VFNMSAC_VF }, // 1828
  { PseudoVFNMSAC_VF16_MF4_MASK, VFNMSAC_VF }, // 1829
  { PseudoVFNMSAC_VF16_MF8, VFNMSAC_VF }, // 1830
  { PseudoVFNMSAC_VF16_MF8_MASK, VFNMSAC_VF }, // 1831
  { PseudoVFNMSAC_VF32_M1, VFNMSAC_VF }, // 1832
  { PseudoVFNMSAC_VF32_M1_MASK, VFNMSAC_VF }, // 1833
  { PseudoVFNMSAC_VF32_M2, VFNMSAC_VF }, // 1834
  { PseudoVFNMSAC_VF32_M2_MASK, VFNMSAC_VF }, // 1835
  { PseudoVFNMSAC_VF32_M4, VFNMSAC_VF }, // 1836
  { PseudoVFNMSAC_VF32_M4_MASK, VFNMSAC_VF }, // 1837
  { PseudoVFNMSAC_VF32_M8, VFNMSAC_VF }, // 1838
  { PseudoVFNMSAC_VF32_M8_MASK, VFNMSAC_VF }, // 1839
  { PseudoVFNMSAC_VF32_MF2, VFNMSAC_VF }, // 1840
  { PseudoVFNMSAC_VF32_MF2_MASK, VFNMSAC_VF }, // 1841
  { PseudoVFNMSAC_VF32_MF4, VFNMSAC_VF }, // 1842
  { PseudoVFNMSAC_VF32_MF4_MASK, VFNMSAC_VF }, // 1843
  { PseudoVFNMSAC_VF32_MF8, VFNMSAC_VF }, // 1844
  { PseudoVFNMSAC_VF32_MF8_MASK, VFNMSAC_VF }, // 1845
  { PseudoVFNMSAC_VF64_M1, VFNMSAC_VF }, // 1846
  { PseudoVFNMSAC_VF64_M1_MASK, VFNMSAC_VF }, // 1847
  { PseudoVFNMSAC_VF64_M2, VFNMSAC_VF }, // 1848
  { PseudoVFNMSAC_VF64_M2_MASK, VFNMSAC_VF }, // 1849
  { PseudoVFNMSAC_VF64_M4, VFNMSAC_VF }, // 1850
  { PseudoVFNMSAC_VF64_M4_MASK, VFNMSAC_VF }, // 1851
  { PseudoVFNMSAC_VF64_M8, VFNMSAC_VF }, // 1852
  { PseudoVFNMSAC_VF64_M8_MASK, VFNMSAC_VF }, // 1853
  { PseudoVFNMSAC_VF64_MF2, VFNMSAC_VF }, // 1854
  { PseudoVFNMSAC_VF64_MF2_MASK, VFNMSAC_VF }, // 1855
  { PseudoVFNMSAC_VF64_MF4, VFNMSAC_VF }, // 1856
  { PseudoVFNMSAC_VF64_MF4_MASK, VFNMSAC_VF }, // 1857
  { PseudoVFNMSAC_VF64_MF8, VFNMSAC_VF }, // 1858
  { PseudoVFNMSAC_VF64_MF8_MASK, VFNMSAC_VF }, // 1859
  { PseudoVFNMSAC_VV_M1, VFNMSAC_VV }, // 1860
  { PseudoVFNMSAC_VV_M1_MASK, VFNMSAC_VV }, // 1861
  { PseudoVFNMSAC_VV_M2, VFNMSAC_VV }, // 1862
  { PseudoVFNMSAC_VV_M2_MASK, VFNMSAC_VV }, // 1863
  { PseudoVFNMSAC_VV_M4, VFNMSAC_VV }, // 1864
  { PseudoVFNMSAC_VV_M4_MASK, VFNMSAC_VV }, // 1865
  { PseudoVFNMSAC_VV_M8, VFNMSAC_VV }, // 1866
  { PseudoVFNMSAC_VV_M8_MASK, VFNMSAC_VV }, // 1867
  { PseudoVFNMSAC_VV_MF2, VFNMSAC_VV }, // 1868
  { PseudoVFNMSAC_VV_MF2_MASK, VFNMSAC_VV }, // 1869
  { PseudoVFNMSAC_VV_MF4, VFNMSAC_VV }, // 1870
  { PseudoVFNMSAC_VV_MF4_MASK, VFNMSAC_VV }, // 1871
  { PseudoVFNMSAC_VV_MF8, VFNMSAC_VV }, // 1872
  { PseudoVFNMSAC_VV_MF8_MASK, VFNMSAC_VV }, // 1873
  { PseudoVFNMSUB_VF16_M1, VFNMSUB_VF }, // 1874
  { PseudoVFNMSUB_VF16_M1_MASK, VFNMSUB_VF }, // 1875
  { PseudoVFNMSUB_VF16_M2, VFNMSUB_VF }, // 1876
  { PseudoVFNMSUB_VF16_M2_MASK, VFNMSUB_VF }, // 1877
  { PseudoVFNMSUB_VF16_M4, VFNMSUB_VF }, // 1878
  { PseudoVFNMSUB_VF16_M4_MASK, VFNMSUB_VF }, // 1879
  { PseudoVFNMSUB_VF16_M8, VFNMSUB_VF }, // 1880
  { PseudoVFNMSUB_VF16_M8_MASK, VFNMSUB_VF }, // 1881
  { PseudoVFNMSUB_VF16_MF2, VFNMSUB_VF }, // 1882
  { PseudoVFNMSUB_VF16_MF2_MASK, VFNMSUB_VF }, // 1883
  { PseudoVFNMSUB_VF16_MF4, VFNMSUB_VF }, // 1884
  { PseudoVFNMSUB_VF16_MF4_MASK, VFNMSUB_VF }, // 1885
  { PseudoVFNMSUB_VF16_MF8, VFNMSUB_VF }, // 1886
  { PseudoVFNMSUB_VF16_MF8_MASK, VFNMSUB_VF }, // 1887
  { PseudoVFNMSUB_VF32_M1, VFNMSUB_VF }, // 1888
  { PseudoVFNMSUB_VF32_M1_MASK, VFNMSUB_VF }, // 1889
  { PseudoVFNMSUB_VF32_M2, VFNMSUB_VF }, // 1890
  { PseudoVFNMSUB_VF32_M2_MASK, VFNMSUB_VF }, // 1891
  { PseudoVFNMSUB_VF32_M4, VFNMSUB_VF }, // 1892
  { PseudoVFNMSUB_VF32_M4_MASK, VFNMSUB_VF }, // 1893
  { PseudoVFNMSUB_VF32_M8, VFNMSUB_VF }, // 1894
  { PseudoVFNMSUB_VF32_M8_MASK, VFNMSUB_VF }, // 1895
  { PseudoVFNMSUB_VF32_MF2, VFNMSUB_VF }, // 1896
  { PseudoVFNMSUB_VF32_MF2_MASK, VFNMSUB_VF }, // 1897
  { PseudoVFNMSUB_VF32_MF4, VFNMSUB_VF }, // 1898
  { PseudoVFNMSUB_VF32_MF4_MASK, VFNMSUB_VF }, // 1899
  { PseudoVFNMSUB_VF32_MF8, VFNMSUB_VF }, // 1900
  { PseudoVFNMSUB_VF32_MF8_MASK, VFNMSUB_VF }, // 1901
  { PseudoVFNMSUB_VF64_M1, VFNMSUB_VF }, // 1902
  { PseudoVFNMSUB_VF64_M1_MASK, VFNMSUB_VF }, // 1903
  { PseudoVFNMSUB_VF64_M2, VFNMSUB_VF }, // 1904
  { PseudoVFNMSUB_VF64_M2_MASK, VFNMSUB_VF }, // 1905
  { PseudoVFNMSUB_VF64_M4, VFNMSUB_VF }, // 1906
  { PseudoVFNMSUB_VF64_M4_MASK, VFNMSUB_VF }, // 1907
  { PseudoVFNMSUB_VF64_M8, VFNMSUB_VF }, // 1908
  { PseudoVFNMSUB_VF64_M8_MASK, VFNMSUB_VF }, // 1909
  { PseudoVFNMSUB_VF64_MF2, VFNMSUB_VF }, // 1910
  { PseudoVFNMSUB_VF64_MF2_MASK, VFNMSUB_VF }, // 1911
  { PseudoVFNMSUB_VF64_MF4, VFNMSUB_VF }, // 1912
  { PseudoVFNMSUB_VF64_MF4_MASK, VFNMSUB_VF }, // 1913
  { PseudoVFNMSUB_VF64_MF8, VFNMSUB_VF }, // 1914
  { PseudoVFNMSUB_VF64_MF8_MASK, VFNMSUB_VF }, // 1915
  { PseudoVFNMSUB_VV_M1, VFNMSUB_VV }, // 1916
  { PseudoVFNMSUB_VV_M1_MASK, VFNMSUB_VV }, // 1917
  { PseudoVFNMSUB_VV_M2, VFNMSUB_VV }, // 1918
  { PseudoVFNMSUB_VV_M2_MASK, VFNMSUB_VV }, // 1919
  { PseudoVFNMSUB_VV_M4, VFNMSUB_VV }, // 1920
  { PseudoVFNMSUB_VV_M4_MASK, VFNMSUB_VV }, // 1921
  { PseudoVFNMSUB_VV_M8, VFNMSUB_VV }, // 1922
  { PseudoVFNMSUB_VV_M8_MASK, VFNMSUB_VV }, // 1923
  { PseudoVFNMSUB_VV_MF2, VFNMSUB_VV }, // 1924
  { PseudoVFNMSUB_VV_MF2_MASK, VFNMSUB_VV }, // 1925
  { PseudoVFNMSUB_VV_MF4, VFNMSUB_VV }, // 1926
  { PseudoVFNMSUB_VV_MF4_MASK, VFNMSUB_VV }, // 1927
  { PseudoVFNMSUB_VV_MF8, VFNMSUB_VV }, // 1928
  { PseudoVFNMSUB_VV_MF8_MASK, VFNMSUB_VV }, // 1929
  { PseudoVFRDIV_VF16_M1, VFRDIV_VF }, // 1930
  { PseudoVFRDIV_VF16_M1_MASK, VFRDIV_VF }, // 1931
  { PseudoVFRDIV_VF16_M2, VFRDIV_VF }, // 1932
  { PseudoVFRDIV_VF16_M2_MASK, VFRDIV_VF }, // 1933
  { PseudoVFRDIV_VF16_M4, VFRDIV_VF }, // 1934
  { PseudoVFRDIV_VF16_M4_MASK, VFRDIV_VF }, // 1935
  { PseudoVFRDIV_VF16_M8, VFRDIV_VF }, // 1936
  { PseudoVFRDIV_VF16_M8_MASK, VFRDIV_VF }, // 1937
  { PseudoVFRDIV_VF16_MF2, VFRDIV_VF }, // 1938
  { PseudoVFRDIV_VF16_MF2_MASK, VFRDIV_VF }, // 1939
  { PseudoVFRDIV_VF16_MF4, VFRDIV_VF }, // 1940
  { PseudoVFRDIV_VF16_MF4_MASK, VFRDIV_VF }, // 1941
  { PseudoVFRDIV_VF16_MF8, VFRDIV_VF }, // 1942
  { PseudoVFRDIV_VF16_MF8_MASK, VFRDIV_VF }, // 1943
  { PseudoVFRDIV_VF32_M1, VFRDIV_VF }, // 1944
  { PseudoVFRDIV_VF32_M1_MASK, VFRDIV_VF }, // 1945
  { PseudoVFRDIV_VF32_M2, VFRDIV_VF }, // 1946
  { PseudoVFRDIV_VF32_M2_MASK, VFRDIV_VF }, // 1947
  { PseudoVFRDIV_VF32_M4, VFRDIV_VF }, // 1948
  { PseudoVFRDIV_VF32_M4_MASK, VFRDIV_VF }, // 1949
  { PseudoVFRDIV_VF32_M8, VFRDIV_VF }, // 1950
  { PseudoVFRDIV_VF32_M8_MASK, VFRDIV_VF }, // 1951
  { PseudoVFRDIV_VF32_MF2, VFRDIV_VF }, // 1952
  { PseudoVFRDIV_VF32_MF2_MASK, VFRDIV_VF }, // 1953
  { PseudoVFRDIV_VF32_MF4, VFRDIV_VF }, // 1954
  { PseudoVFRDIV_VF32_MF4_MASK, VFRDIV_VF }, // 1955
  { PseudoVFRDIV_VF32_MF8, VFRDIV_VF }, // 1956
  { PseudoVFRDIV_VF32_MF8_MASK, VFRDIV_VF }, // 1957
  { PseudoVFRDIV_VF64_M1, VFRDIV_VF }, // 1958
  { PseudoVFRDIV_VF64_M1_MASK, VFRDIV_VF }, // 1959
  { PseudoVFRDIV_VF64_M2, VFRDIV_VF }, // 1960
  { PseudoVFRDIV_VF64_M2_MASK, VFRDIV_VF }, // 1961
  { PseudoVFRDIV_VF64_M4, VFRDIV_VF }, // 1962
  { PseudoVFRDIV_VF64_M4_MASK, VFRDIV_VF }, // 1963
  { PseudoVFRDIV_VF64_M8, VFRDIV_VF }, // 1964
  { PseudoVFRDIV_VF64_M8_MASK, VFRDIV_VF }, // 1965
  { PseudoVFRDIV_VF64_MF2, VFRDIV_VF }, // 1966
  { PseudoVFRDIV_VF64_MF2_MASK, VFRDIV_VF }, // 1967
  { PseudoVFRDIV_VF64_MF4, VFRDIV_VF }, // 1968
  { PseudoVFRDIV_VF64_MF4_MASK, VFRDIV_VF }, // 1969
  { PseudoVFRDIV_VF64_MF8, VFRDIV_VF }, // 1970
  { PseudoVFRDIV_VF64_MF8_MASK, VFRDIV_VF }, // 1971
  { PseudoVFREC7_V_M1, VFREC7_V }, // 1972
  { PseudoVFREC7_V_M1_MASK, VFREC7_V }, // 1973
  { PseudoVFREC7_V_M2, VFREC7_V }, // 1974
  { PseudoVFREC7_V_M2_MASK, VFREC7_V }, // 1975
  { PseudoVFREC7_V_M4, VFREC7_V }, // 1976
  { PseudoVFREC7_V_M4_MASK, VFREC7_V }, // 1977
  { PseudoVFREC7_V_M8, VFREC7_V }, // 1978
  { PseudoVFREC7_V_M8_MASK, VFREC7_V }, // 1979
  { PseudoVFREC7_V_MF2, VFREC7_V }, // 1980
  { PseudoVFREC7_V_MF2_MASK, VFREC7_V }, // 1981
  { PseudoVFREC7_V_MF4, VFREC7_V }, // 1982
  { PseudoVFREC7_V_MF4_MASK, VFREC7_V }, // 1983
  { PseudoVFREC7_V_MF8, VFREC7_V }, // 1984
  { PseudoVFREC7_V_MF8_MASK, VFREC7_V }, // 1985
  { PseudoVFREDMAX_VS_M1, VFREDMAX_VS }, // 1986
  { PseudoVFREDMAX_VS_M1_MASK, VFREDMAX_VS }, // 1987
  { PseudoVFREDMAX_VS_M2, VFREDMAX_VS }, // 1988
  { PseudoVFREDMAX_VS_M2_MASK, VFREDMAX_VS }, // 1989
  { PseudoVFREDMAX_VS_M4, VFREDMAX_VS }, // 1990
  { PseudoVFREDMAX_VS_M4_MASK, VFREDMAX_VS }, // 1991
  { PseudoVFREDMAX_VS_M8, VFREDMAX_VS }, // 1992
  { PseudoVFREDMAX_VS_M8_MASK, VFREDMAX_VS }, // 1993
  { PseudoVFREDMAX_VS_MF2, VFREDMAX_VS }, // 1994
  { PseudoVFREDMAX_VS_MF2_MASK, VFREDMAX_VS }, // 1995
  { PseudoVFREDMAX_VS_MF4, VFREDMAX_VS }, // 1996
  { PseudoVFREDMAX_VS_MF4_MASK, VFREDMAX_VS }, // 1997
  { PseudoVFREDMAX_VS_MF8, VFREDMAX_VS }, // 1998
  { PseudoVFREDMAX_VS_MF8_MASK, VFREDMAX_VS }, // 1999
  { PseudoVFREDMIN_VS_M1, VFREDMIN_VS }, // 2000
  { PseudoVFREDMIN_VS_M1_MASK, VFREDMIN_VS }, // 2001
  { PseudoVFREDMIN_VS_M2, VFREDMIN_VS }, // 2002
  { PseudoVFREDMIN_VS_M2_MASK, VFREDMIN_VS }, // 2003
  { PseudoVFREDMIN_VS_M4, VFREDMIN_VS }, // 2004
  { PseudoVFREDMIN_VS_M4_MASK, VFREDMIN_VS }, // 2005
  { PseudoVFREDMIN_VS_M8, VFREDMIN_VS }, // 2006
  { PseudoVFREDMIN_VS_M8_MASK, VFREDMIN_VS }, // 2007
  { PseudoVFREDMIN_VS_MF2, VFREDMIN_VS }, // 2008
  { PseudoVFREDMIN_VS_MF2_MASK, VFREDMIN_VS }, // 2009
  { PseudoVFREDMIN_VS_MF4, VFREDMIN_VS }, // 2010
  { PseudoVFREDMIN_VS_MF4_MASK, VFREDMIN_VS }, // 2011
  { PseudoVFREDMIN_VS_MF8, VFREDMIN_VS }, // 2012
  { PseudoVFREDMIN_VS_MF8_MASK, VFREDMIN_VS }, // 2013
  { PseudoVFREDOSUM_VS_M1, VFREDOSUM_VS }, // 2014
  { PseudoVFREDOSUM_VS_M1_MASK, VFREDOSUM_VS }, // 2015
  { PseudoVFREDOSUM_VS_M2, VFREDOSUM_VS }, // 2016
  { PseudoVFREDOSUM_VS_M2_MASK, VFREDOSUM_VS }, // 2017
  { PseudoVFREDOSUM_VS_M4, VFREDOSUM_VS }, // 2018
  { PseudoVFREDOSUM_VS_M4_MASK, VFREDOSUM_VS }, // 2019
  { PseudoVFREDOSUM_VS_M8, VFREDOSUM_VS }, // 2020
  { PseudoVFREDOSUM_VS_M8_MASK, VFREDOSUM_VS }, // 2021
  { PseudoVFREDOSUM_VS_MF2, VFREDOSUM_VS }, // 2022
  { PseudoVFREDOSUM_VS_MF2_MASK, VFREDOSUM_VS }, // 2023
  { PseudoVFREDOSUM_VS_MF4, VFREDOSUM_VS }, // 2024
  { PseudoVFREDOSUM_VS_MF4_MASK, VFREDOSUM_VS }, // 2025
  { PseudoVFREDOSUM_VS_MF8, VFREDOSUM_VS }, // 2026
  { PseudoVFREDOSUM_VS_MF8_MASK, VFREDOSUM_VS }, // 2027
  { PseudoVFREDSUM_VS_M1, VFREDSUM_VS }, // 2028
  { PseudoVFREDSUM_VS_M1_MASK, VFREDSUM_VS }, // 2029
  { PseudoVFREDSUM_VS_M2, VFREDSUM_VS }, // 2030
  { PseudoVFREDSUM_VS_M2_MASK, VFREDSUM_VS }, // 2031
  { PseudoVFREDSUM_VS_M4, VFREDSUM_VS }, // 2032
  { PseudoVFREDSUM_VS_M4_MASK, VFREDSUM_VS }, // 2033
  { PseudoVFREDSUM_VS_M8, VFREDSUM_VS }, // 2034
  { PseudoVFREDSUM_VS_M8_MASK, VFREDSUM_VS }, // 2035
  { PseudoVFREDSUM_VS_MF2, VFREDSUM_VS }, // 2036
  { PseudoVFREDSUM_VS_MF2_MASK, VFREDSUM_VS }, // 2037
  { PseudoVFREDSUM_VS_MF4, VFREDSUM_VS }, // 2038
  { PseudoVFREDSUM_VS_MF4_MASK, VFREDSUM_VS }, // 2039
  { PseudoVFREDSUM_VS_MF8, VFREDSUM_VS }, // 2040
  { PseudoVFREDSUM_VS_MF8_MASK, VFREDSUM_VS }, // 2041
  { PseudoVFRSQRT7_V_M1, VFRSQRT7_V }, // 2042
  { PseudoVFRSQRT7_V_M1_MASK, VFRSQRT7_V }, // 2043
  { PseudoVFRSQRT7_V_M2, VFRSQRT7_V }, // 2044
  { PseudoVFRSQRT7_V_M2_MASK, VFRSQRT7_V }, // 2045
  { PseudoVFRSQRT7_V_M4, VFRSQRT7_V }, // 2046
  { PseudoVFRSQRT7_V_M4_MASK, VFRSQRT7_V }, // 2047
  { PseudoVFRSQRT7_V_M8, VFRSQRT7_V }, // 2048
  { PseudoVFRSQRT7_V_M8_MASK, VFRSQRT7_V }, // 2049
  { PseudoVFRSQRT7_V_MF2, VFRSQRT7_V }, // 2050
  { PseudoVFRSQRT7_V_MF2_MASK, VFRSQRT7_V }, // 2051
  { PseudoVFRSQRT7_V_MF4, VFRSQRT7_V }, // 2052
  { PseudoVFRSQRT7_V_MF4_MASK, VFRSQRT7_V }, // 2053
  { PseudoVFRSQRT7_V_MF8, VFRSQRT7_V }, // 2054
  { PseudoVFRSQRT7_V_MF8_MASK, VFRSQRT7_V }, // 2055
  { PseudoVFRSUB_VF16_M1, VFRSUB_VF }, // 2056
  { PseudoVFRSUB_VF16_M1_MASK, VFRSUB_VF }, // 2057
  { PseudoVFRSUB_VF16_M2, VFRSUB_VF }, // 2058
  { PseudoVFRSUB_VF16_M2_MASK, VFRSUB_VF }, // 2059
  { PseudoVFRSUB_VF16_M4, VFRSUB_VF }, // 2060
  { PseudoVFRSUB_VF16_M4_MASK, VFRSUB_VF }, // 2061
  { PseudoVFRSUB_VF16_M8, VFRSUB_VF }, // 2062
  { PseudoVFRSUB_VF16_M8_MASK, VFRSUB_VF }, // 2063
  { PseudoVFRSUB_VF16_MF2, VFRSUB_VF }, // 2064
  { PseudoVFRSUB_VF16_MF2_MASK, VFRSUB_VF }, // 2065
  { PseudoVFRSUB_VF16_MF4, VFRSUB_VF }, // 2066
  { PseudoVFRSUB_VF16_MF4_MASK, VFRSUB_VF }, // 2067
  { PseudoVFRSUB_VF16_MF8, VFRSUB_VF }, // 2068
  { PseudoVFRSUB_VF16_MF8_MASK, VFRSUB_VF }, // 2069
  { PseudoVFRSUB_VF32_M1, VFRSUB_VF }, // 2070
  { PseudoVFRSUB_VF32_M1_MASK, VFRSUB_VF }, // 2071
  { PseudoVFRSUB_VF32_M2, VFRSUB_VF }, // 2072
  { PseudoVFRSUB_VF32_M2_MASK, VFRSUB_VF }, // 2073
  { PseudoVFRSUB_VF32_M4, VFRSUB_VF }, // 2074
  { PseudoVFRSUB_VF32_M4_MASK, VFRSUB_VF }, // 2075
  { PseudoVFRSUB_VF32_M8, VFRSUB_VF }, // 2076
  { PseudoVFRSUB_VF32_M8_MASK, VFRSUB_VF }, // 2077
  { PseudoVFRSUB_VF32_MF2, VFRSUB_VF }, // 2078
  { PseudoVFRSUB_VF32_MF2_MASK, VFRSUB_VF }, // 2079
  { PseudoVFRSUB_VF32_MF4, VFRSUB_VF }, // 2080
  { PseudoVFRSUB_VF32_MF4_MASK, VFRSUB_VF }, // 2081
  { PseudoVFRSUB_VF32_MF8, VFRSUB_VF }, // 2082
  { PseudoVFRSUB_VF32_MF8_MASK, VFRSUB_VF }, // 2083
  { PseudoVFRSUB_VF64_M1, VFRSUB_VF }, // 2084
  { PseudoVFRSUB_VF64_M1_MASK, VFRSUB_VF }, // 2085
  { PseudoVFRSUB_VF64_M2, VFRSUB_VF }, // 2086
  { PseudoVFRSUB_VF64_M2_MASK, VFRSUB_VF }, // 2087
  { PseudoVFRSUB_VF64_M4, VFRSUB_VF }, // 2088
  { PseudoVFRSUB_VF64_M4_MASK, VFRSUB_VF }, // 2089
  { PseudoVFRSUB_VF64_M8, VFRSUB_VF }, // 2090
  { PseudoVFRSUB_VF64_M8_MASK, VFRSUB_VF }, // 2091
  { PseudoVFRSUB_VF64_MF2, VFRSUB_VF }, // 2092
  { PseudoVFRSUB_VF64_MF2_MASK, VFRSUB_VF }, // 2093
  { PseudoVFRSUB_VF64_MF4, VFRSUB_VF }, // 2094
  { PseudoVFRSUB_VF64_MF4_MASK, VFRSUB_VF }, // 2095
  { PseudoVFRSUB_VF64_MF8, VFRSUB_VF }, // 2096
  { PseudoVFRSUB_VF64_MF8_MASK, VFRSUB_VF }, // 2097
  { PseudoVFSGNJN_VF16_M1, VFSGNJN_VF }, // 2098
  { PseudoVFSGNJN_VF16_M1_MASK, VFSGNJN_VF }, // 2099
  { PseudoVFSGNJN_VF16_M2, VFSGNJN_VF }, // 2100
  { PseudoVFSGNJN_VF16_M2_MASK, VFSGNJN_VF }, // 2101
  { PseudoVFSGNJN_VF16_M4, VFSGNJN_VF }, // 2102
  { PseudoVFSGNJN_VF16_M4_MASK, VFSGNJN_VF }, // 2103
  { PseudoVFSGNJN_VF16_M8, VFSGNJN_VF }, // 2104
  { PseudoVFSGNJN_VF16_M8_MASK, VFSGNJN_VF }, // 2105
  { PseudoVFSGNJN_VF16_MF2, VFSGNJN_VF }, // 2106
  { PseudoVFSGNJN_VF16_MF2_MASK, VFSGNJN_VF }, // 2107
  { PseudoVFSGNJN_VF16_MF4, VFSGNJN_VF }, // 2108
  { PseudoVFSGNJN_VF16_MF4_MASK, VFSGNJN_VF }, // 2109
  { PseudoVFSGNJN_VF16_MF8, VFSGNJN_VF }, // 2110
  { PseudoVFSGNJN_VF16_MF8_MASK, VFSGNJN_VF }, // 2111
  { PseudoVFSGNJN_VF32_M1, VFSGNJN_VF }, // 2112
  { PseudoVFSGNJN_VF32_M1_MASK, VFSGNJN_VF }, // 2113
  { PseudoVFSGNJN_VF32_M2, VFSGNJN_VF }, // 2114
  { PseudoVFSGNJN_VF32_M2_MASK, VFSGNJN_VF }, // 2115
  { PseudoVFSGNJN_VF32_M4, VFSGNJN_VF }, // 2116
  { PseudoVFSGNJN_VF32_M4_MASK, VFSGNJN_VF }, // 2117
  { PseudoVFSGNJN_VF32_M8, VFSGNJN_VF }, // 2118
  { PseudoVFSGNJN_VF32_M8_MASK, VFSGNJN_VF }, // 2119
  { PseudoVFSGNJN_VF32_MF2, VFSGNJN_VF }, // 2120
  { PseudoVFSGNJN_VF32_MF2_MASK, VFSGNJN_VF }, // 2121
  { PseudoVFSGNJN_VF32_MF4, VFSGNJN_VF }, // 2122
  { PseudoVFSGNJN_VF32_MF4_MASK, VFSGNJN_VF }, // 2123
  { PseudoVFSGNJN_VF32_MF8, VFSGNJN_VF }, // 2124
  { PseudoVFSGNJN_VF32_MF8_MASK, VFSGNJN_VF }, // 2125
  { PseudoVFSGNJN_VF64_M1, VFSGNJN_VF }, // 2126
  { PseudoVFSGNJN_VF64_M1_MASK, VFSGNJN_VF }, // 2127
  { PseudoVFSGNJN_VF64_M2, VFSGNJN_VF }, // 2128
  { PseudoVFSGNJN_VF64_M2_MASK, VFSGNJN_VF }, // 2129
  { PseudoVFSGNJN_VF64_M4, VFSGNJN_VF }, // 2130
  { PseudoVFSGNJN_VF64_M4_MASK, VFSGNJN_VF }, // 2131
  { PseudoVFSGNJN_VF64_M8, VFSGNJN_VF }, // 2132
  { PseudoVFSGNJN_VF64_M8_MASK, VFSGNJN_VF }, // 2133
  { PseudoVFSGNJN_VF64_MF2, VFSGNJN_VF }, // 2134
  { PseudoVFSGNJN_VF64_MF2_MASK, VFSGNJN_VF }, // 2135
  { PseudoVFSGNJN_VF64_MF4, VFSGNJN_VF }, // 2136
  { PseudoVFSGNJN_VF64_MF4_MASK, VFSGNJN_VF }, // 2137
  { PseudoVFSGNJN_VF64_MF8, VFSGNJN_VF }, // 2138
  { PseudoVFSGNJN_VF64_MF8_MASK, VFSGNJN_VF }, // 2139
  { PseudoVFSGNJN_VV_M1, VFSGNJN_VV }, // 2140
  { PseudoVFSGNJN_VV_M1_MASK, VFSGNJN_VV }, // 2141
  { PseudoVFSGNJN_VV_M2, VFSGNJN_VV }, // 2142
  { PseudoVFSGNJN_VV_M2_MASK, VFSGNJN_VV }, // 2143
  { PseudoVFSGNJN_VV_M4, VFSGNJN_VV }, // 2144
  { PseudoVFSGNJN_VV_M4_MASK, VFSGNJN_VV }, // 2145
  { PseudoVFSGNJN_VV_M8, VFSGNJN_VV }, // 2146
  { PseudoVFSGNJN_VV_M8_MASK, VFSGNJN_VV }, // 2147
  { PseudoVFSGNJN_VV_MF2, VFSGNJN_VV }, // 2148
  { PseudoVFSGNJN_VV_MF2_MASK, VFSGNJN_VV }, // 2149
  { PseudoVFSGNJN_VV_MF4, VFSGNJN_VV }, // 2150
  { PseudoVFSGNJN_VV_MF4_MASK, VFSGNJN_VV }, // 2151
  { PseudoVFSGNJN_VV_MF8, VFSGNJN_VV }, // 2152
  { PseudoVFSGNJN_VV_MF8_MASK, VFSGNJN_VV }, // 2153
  { PseudoVFSGNJX_VF16_M1, VFSGNJX_VF }, // 2154
  { PseudoVFSGNJX_VF16_M1_MASK, VFSGNJX_VF }, // 2155
  { PseudoVFSGNJX_VF16_M2, VFSGNJX_VF }, // 2156
  { PseudoVFSGNJX_VF16_M2_MASK, VFSGNJX_VF }, // 2157
  { PseudoVFSGNJX_VF16_M4, VFSGNJX_VF }, // 2158
  { PseudoVFSGNJX_VF16_M4_MASK, VFSGNJX_VF }, // 2159
  { PseudoVFSGNJX_VF16_M8, VFSGNJX_VF }, // 2160
  { PseudoVFSGNJX_VF16_M8_MASK, VFSGNJX_VF }, // 2161
  { PseudoVFSGNJX_VF16_MF2, VFSGNJX_VF }, // 2162
  { PseudoVFSGNJX_VF16_MF2_MASK, VFSGNJX_VF }, // 2163
  { PseudoVFSGNJX_VF16_MF4, VFSGNJX_VF }, // 2164
  { PseudoVFSGNJX_VF16_MF4_MASK, VFSGNJX_VF }, // 2165
  { PseudoVFSGNJX_VF16_MF8, VFSGNJX_VF }, // 2166
  { PseudoVFSGNJX_VF16_MF8_MASK, VFSGNJX_VF }, // 2167
  { PseudoVFSGNJX_VF32_M1, VFSGNJX_VF }, // 2168
  { PseudoVFSGNJX_VF32_M1_MASK, VFSGNJX_VF }, // 2169
  { PseudoVFSGNJX_VF32_M2, VFSGNJX_VF }, // 2170
  { PseudoVFSGNJX_VF32_M2_MASK, VFSGNJX_VF }, // 2171
  { PseudoVFSGNJX_VF32_M4, VFSGNJX_VF }, // 2172
  { PseudoVFSGNJX_VF32_M4_MASK, VFSGNJX_VF }, // 2173
  { PseudoVFSGNJX_VF32_M8, VFSGNJX_VF }, // 2174
  { PseudoVFSGNJX_VF32_M8_MASK, VFSGNJX_VF }, // 2175
  { PseudoVFSGNJX_VF32_MF2, VFSGNJX_VF }, // 2176
  { PseudoVFSGNJX_VF32_MF2_MASK, VFSGNJX_VF }, // 2177
  { PseudoVFSGNJX_VF32_MF4, VFSGNJX_VF }, // 2178
  { PseudoVFSGNJX_VF32_MF4_MASK, VFSGNJX_VF }, // 2179
  { PseudoVFSGNJX_VF32_MF8, VFSGNJX_VF }, // 2180
  { PseudoVFSGNJX_VF32_MF8_MASK, VFSGNJX_VF }, // 2181
  { PseudoVFSGNJX_VF64_M1, VFSGNJX_VF }, // 2182
  { PseudoVFSGNJX_VF64_M1_MASK, VFSGNJX_VF }, // 2183
  { PseudoVFSGNJX_VF64_M2, VFSGNJX_VF }, // 2184
  { PseudoVFSGNJX_VF64_M2_MASK, VFSGNJX_VF }, // 2185
  { PseudoVFSGNJX_VF64_M4, VFSGNJX_VF }, // 2186
  { PseudoVFSGNJX_VF64_M4_MASK, VFSGNJX_VF }, // 2187
  { PseudoVFSGNJX_VF64_M8, VFSGNJX_VF }, // 2188
  { PseudoVFSGNJX_VF64_M8_MASK, VFSGNJX_VF }, // 2189
  { PseudoVFSGNJX_VF64_MF2, VFSGNJX_VF }, // 2190
  { PseudoVFSGNJX_VF64_MF2_MASK, VFSGNJX_VF }, // 2191
  { PseudoVFSGNJX_VF64_MF4, VFSGNJX_VF }, // 2192
  { PseudoVFSGNJX_VF64_MF4_MASK, VFSGNJX_VF }, // 2193
  { PseudoVFSGNJX_VF64_MF8, VFSGNJX_VF }, // 2194
  { PseudoVFSGNJX_VF64_MF8_MASK, VFSGNJX_VF }, // 2195
  { PseudoVFSGNJX_VV_M1, VFSGNJX_VV }, // 2196
  { PseudoVFSGNJX_VV_M1_MASK, VFSGNJX_VV }, // 2197
  { PseudoVFSGNJX_VV_M2, VFSGNJX_VV }, // 2198
  { PseudoVFSGNJX_VV_M2_MASK, VFSGNJX_VV }, // 2199
  { PseudoVFSGNJX_VV_M4, VFSGNJX_VV }, // 2200
  { PseudoVFSGNJX_VV_M4_MASK, VFSGNJX_VV }, // 2201
  { PseudoVFSGNJX_VV_M8, VFSGNJX_VV }, // 2202
  { PseudoVFSGNJX_VV_M8_MASK, VFSGNJX_VV }, // 2203
  { PseudoVFSGNJX_VV_MF2, VFSGNJX_VV }, // 2204
  { PseudoVFSGNJX_VV_MF2_MASK, VFSGNJX_VV }, // 2205
  { PseudoVFSGNJX_VV_MF4, VFSGNJX_VV }, // 2206
  { PseudoVFSGNJX_VV_MF4_MASK, VFSGNJX_VV }, // 2207
  { PseudoVFSGNJX_VV_MF8, VFSGNJX_VV }, // 2208
  { PseudoVFSGNJX_VV_MF8_MASK, VFSGNJX_VV }, // 2209
  { PseudoVFSGNJ_VF16_M1, VFSGNJ_VF }, // 2210
  { PseudoVFSGNJ_VF16_M1_MASK, VFSGNJ_VF }, // 2211
  { PseudoVFSGNJ_VF16_M2, VFSGNJ_VF }, // 2212
  { PseudoVFSGNJ_VF16_M2_MASK, VFSGNJ_VF }, // 2213
  { PseudoVFSGNJ_VF16_M4, VFSGNJ_VF }, // 2214
  { PseudoVFSGNJ_VF16_M4_MASK, VFSGNJ_VF }, // 2215
  { PseudoVFSGNJ_VF16_M8, VFSGNJ_VF }, // 2216
  { PseudoVFSGNJ_VF16_M8_MASK, VFSGNJ_VF }, // 2217
  { PseudoVFSGNJ_VF16_MF2, VFSGNJ_VF }, // 2218
  { PseudoVFSGNJ_VF16_MF2_MASK, VFSGNJ_VF }, // 2219
  { PseudoVFSGNJ_VF16_MF4, VFSGNJ_VF }, // 2220
  { PseudoVFSGNJ_VF16_MF4_MASK, VFSGNJ_VF }, // 2221
  { PseudoVFSGNJ_VF16_MF8, VFSGNJ_VF }, // 2222
  { PseudoVFSGNJ_VF16_MF8_MASK, VFSGNJ_VF }, // 2223
  { PseudoVFSGNJ_VF32_M1, VFSGNJ_VF }, // 2224
  { PseudoVFSGNJ_VF32_M1_MASK, VFSGNJ_VF }, // 2225
  { PseudoVFSGNJ_VF32_M2, VFSGNJ_VF }, // 2226
  { PseudoVFSGNJ_VF32_M2_MASK, VFSGNJ_VF }, // 2227
  { PseudoVFSGNJ_VF32_M4, VFSGNJ_VF }, // 2228
  { PseudoVFSGNJ_VF32_M4_MASK, VFSGNJ_VF }, // 2229
  { PseudoVFSGNJ_VF32_M8, VFSGNJ_VF }, // 2230
  { PseudoVFSGNJ_VF32_M8_MASK, VFSGNJ_VF }, // 2231
  { PseudoVFSGNJ_VF32_MF2, VFSGNJ_VF }, // 2232
  { PseudoVFSGNJ_VF32_MF2_MASK, VFSGNJ_VF }, // 2233
  { PseudoVFSGNJ_VF32_MF4, VFSGNJ_VF }, // 2234
  { PseudoVFSGNJ_VF32_MF4_MASK, VFSGNJ_VF }, // 2235
  { PseudoVFSGNJ_VF32_MF8, VFSGNJ_VF }, // 2236
  { PseudoVFSGNJ_VF32_MF8_MASK, VFSGNJ_VF }, // 2237
  { PseudoVFSGNJ_VF64_M1, VFSGNJ_VF }, // 2238
  { PseudoVFSGNJ_VF64_M1_MASK, VFSGNJ_VF }, // 2239
  { PseudoVFSGNJ_VF64_M2, VFSGNJ_VF }, // 2240
  { PseudoVFSGNJ_VF64_M2_MASK, VFSGNJ_VF }, // 2241
  { PseudoVFSGNJ_VF64_M4, VFSGNJ_VF }, // 2242
  { PseudoVFSGNJ_VF64_M4_MASK, VFSGNJ_VF }, // 2243
  { PseudoVFSGNJ_VF64_M8, VFSGNJ_VF }, // 2244
  { PseudoVFSGNJ_VF64_M8_MASK, VFSGNJ_VF }, // 2245
  { PseudoVFSGNJ_VF64_MF2, VFSGNJ_VF }, // 2246
  { PseudoVFSGNJ_VF64_MF2_MASK, VFSGNJ_VF }, // 2247
  { PseudoVFSGNJ_VF64_MF4, VFSGNJ_VF }, // 2248
  { PseudoVFSGNJ_VF64_MF4_MASK, VFSGNJ_VF }, // 2249
  { PseudoVFSGNJ_VF64_MF8, VFSGNJ_VF }, // 2250
  { PseudoVFSGNJ_VF64_MF8_MASK, VFSGNJ_VF }, // 2251
  { PseudoVFSGNJ_VV_M1, VFSGNJ_VV }, // 2252
  { PseudoVFSGNJ_VV_M1_MASK, VFSGNJ_VV }, // 2253
  { PseudoVFSGNJ_VV_M2, VFSGNJ_VV }, // 2254
  { PseudoVFSGNJ_VV_M2_MASK, VFSGNJ_VV }, // 2255
  { PseudoVFSGNJ_VV_M4, VFSGNJ_VV }, // 2256
  { PseudoVFSGNJ_VV_M4_MASK, VFSGNJ_VV }, // 2257
  { PseudoVFSGNJ_VV_M8, VFSGNJ_VV }, // 2258
  { PseudoVFSGNJ_VV_M8_MASK, VFSGNJ_VV }, // 2259
  { PseudoVFSGNJ_VV_MF2, VFSGNJ_VV }, // 2260
  { PseudoVFSGNJ_VV_MF2_MASK, VFSGNJ_VV }, // 2261
  { PseudoVFSGNJ_VV_MF4, VFSGNJ_VV }, // 2262
  { PseudoVFSGNJ_VV_MF4_MASK, VFSGNJ_VV }, // 2263
  { PseudoVFSGNJ_VV_MF8, VFSGNJ_VV }, // 2264
  { PseudoVFSGNJ_VV_MF8_MASK, VFSGNJ_VV }, // 2265
  { PseudoVFSLIDE1DOWN_VF16_M1, VFSLIDE1DOWN_VF }, // 2266
  { PseudoVFSLIDE1DOWN_VF16_M1_MASK, VFSLIDE1DOWN_VF }, // 2267
  { PseudoVFSLIDE1DOWN_VF16_M2, VFSLIDE1DOWN_VF }, // 2268
  { PseudoVFSLIDE1DOWN_VF16_M2_MASK, VFSLIDE1DOWN_VF }, // 2269
  { PseudoVFSLIDE1DOWN_VF16_M4, VFSLIDE1DOWN_VF }, // 2270
  { PseudoVFSLIDE1DOWN_VF16_M4_MASK, VFSLIDE1DOWN_VF }, // 2271
  { PseudoVFSLIDE1DOWN_VF16_M8, VFSLIDE1DOWN_VF }, // 2272
  { PseudoVFSLIDE1DOWN_VF16_M8_MASK, VFSLIDE1DOWN_VF }, // 2273
  { PseudoVFSLIDE1DOWN_VF16_MF2, VFSLIDE1DOWN_VF }, // 2274
  { PseudoVFSLIDE1DOWN_VF16_MF2_MASK, VFSLIDE1DOWN_VF }, // 2275
  { PseudoVFSLIDE1DOWN_VF16_MF4, VFSLIDE1DOWN_VF }, // 2276
  { PseudoVFSLIDE1DOWN_VF16_MF4_MASK, VFSLIDE1DOWN_VF }, // 2277
  { PseudoVFSLIDE1DOWN_VF16_MF8, VFSLIDE1DOWN_VF }, // 2278
  { PseudoVFSLIDE1DOWN_VF16_MF8_MASK, VFSLIDE1DOWN_VF }, // 2279
  { PseudoVFSLIDE1DOWN_VF32_M1, VFSLIDE1DOWN_VF }, // 2280
  { PseudoVFSLIDE1DOWN_VF32_M1_MASK, VFSLIDE1DOWN_VF }, // 2281
  { PseudoVFSLIDE1DOWN_VF32_M2, VFSLIDE1DOWN_VF }, // 2282
  { PseudoVFSLIDE1DOWN_VF32_M2_MASK, VFSLIDE1DOWN_VF }, // 2283
  { PseudoVFSLIDE1DOWN_VF32_M4, VFSLIDE1DOWN_VF }, // 2284
  { PseudoVFSLIDE1DOWN_VF32_M4_MASK, VFSLIDE1DOWN_VF }, // 2285
  { PseudoVFSLIDE1DOWN_VF32_M8, VFSLIDE1DOWN_VF }, // 2286
  { PseudoVFSLIDE1DOWN_VF32_M8_MASK, VFSLIDE1DOWN_VF }, // 2287
  { PseudoVFSLIDE1DOWN_VF32_MF2, VFSLIDE1DOWN_VF }, // 2288
  { PseudoVFSLIDE1DOWN_VF32_MF2_MASK, VFSLIDE1DOWN_VF }, // 2289
  { PseudoVFSLIDE1DOWN_VF32_MF4, VFSLIDE1DOWN_VF }, // 2290
  { PseudoVFSLIDE1DOWN_VF32_MF4_MASK, VFSLIDE1DOWN_VF }, // 2291
  { PseudoVFSLIDE1DOWN_VF32_MF8, VFSLIDE1DOWN_VF }, // 2292
  { PseudoVFSLIDE1DOWN_VF32_MF8_MASK, VFSLIDE1DOWN_VF }, // 2293
  { PseudoVFSLIDE1DOWN_VF64_M1, VFSLIDE1DOWN_VF }, // 2294
  { PseudoVFSLIDE1DOWN_VF64_M1_MASK, VFSLIDE1DOWN_VF }, // 2295
  { PseudoVFSLIDE1DOWN_VF64_M2, VFSLIDE1DOWN_VF }, // 2296
  { PseudoVFSLIDE1DOWN_VF64_M2_MASK, VFSLIDE1DOWN_VF }, // 2297
  { PseudoVFSLIDE1DOWN_VF64_M4, VFSLIDE1DOWN_VF }, // 2298
  { PseudoVFSLIDE1DOWN_VF64_M4_MASK, VFSLIDE1DOWN_VF }, // 2299
  { PseudoVFSLIDE1DOWN_VF64_M8, VFSLIDE1DOWN_VF }, // 2300
  { PseudoVFSLIDE1DOWN_VF64_M8_MASK, VFSLIDE1DOWN_VF }, // 2301
  { PseudoVFSLIDE1DOWN_VF64_MF2, VFSLIDE1DOWN_VF }, // 2302
  { PseudoVFSLIDE1DOWN_VF64_MF2_MASK, VFSLIDE1DOWN_VF }, // 2303
  { PseudoVFSLIDE1DOWN_VF64_MF4, VFSLIDE1DOWN_VF }, // 2304
  { PseudoVFSLIDE1DOWN_VF64_MF4_MASK, VFSLIDE1DOWN_VF }, // 2305
  { PseudoVFSLIDE1DOWN_VF64_MF8, VFSLIDE1DOWN_VF }, // 2306
  { PseudoVFSLIDE1DOWN_VF64_MF8_MASK, VFSLIDE1DOWN_VF }, // 2307
  { PseudoVFSLIDE1UP_VF16_M1, VFSLIDE1UP_VF }, // 2308
  { PseudoVFSLIDE1UP_VF16_M1_MASK, VFSLIDE1UP_VF }, // 2309
  { PseudoVFSLIDE1UP_VF16_M2, VFSLIDE1UP_VF }, // 2310
  { PseudoVFSLIDE1UP_VF16_M2_MASK, VFSLIDE1UP_VF }, // 2311
  { PseudoVFSLIDE1UP_VF16_M4, VFSLIDE1UP_VF }, // 2312
  { PseudoVFSLIDE1UP_VF16_M4_MASK, VFSLIDE1UP_VF }, // 2313
  { PseudoVFSLIDE1UP_VF16_M8, VFSLIDE1UP_VF }, // 2314
  { PseudoVFSLIDE1UP_VF16_M8_MASK, VFSLIDE1UP_VF }, // 2315
  { PseudoVFSLIDE1UP_VF16_MF2, VFSLIDE1UP_VF }, // 2316
  { PseudoVFSLIDE1UP_VF16_MF2_MASK, VFSLIDE1UP_VF }, // 2317
  { PseudoVFSLIDE1UP_VF16_MF4, VFSLIDE1UP_VF }, // 2318
  { PseudoVFSLIDE1UP_VF16_MF4_MASK, VFSLIDE1UP_VF }, // 2319
  { PseudoVFSLIDE1UP_VF16_MF8, VFSLIDE1UP_VF }, // 2320
  { PseudoVFSLIDE1UP_VF16_MF8_MASK, VFSLIDE1UP_VF }, // 2321
  { PseudoVFSLIDE1UP_VF32_M1, VFSLIDE1UP_VF }, // 2322
  { PseudoVFSLIDE1UP_VF32_M1_MASK, VFSLIDE1UP_VF }, // 2323
  { PseudoVFSLIDE1UP_VF32_M2, VFSLIDE1UP_VF }, // 2324
  { PseudoVFSLIDE1UP_VF32_M2_MASK, VFSLIDE1UP_VF }, // 2325
  { PseudoVFSLIDE1UP_VF32_M4, VFSLIDE1UP_VF }, // 2326
  { PseudoVFSLIDE1UP_VF32_M4_MASK, VFSLIDE1UP_VF }, // 2327
  { PseudoVFSLIDE1UP_VF32_M8, VFSLIDE1UP_VF }, // 2328
  { PseudoVFSLIDE1UP_VF32_M8_MASK, VFSLIDE1UP_VF }, // 2329
  { PseudoVFSLIDE1UP_VF32_MF2, VFSLIDE1UP_VF }, // 2330
  { PseudoVFSLIDE1UP_VF32_MF2_MASK, VFSLIDE1UP_VF }, // 2331
  { PseudoVFSLIDE1UP_VF32_MF4, VFSLIDE1UP_VF }, // 2332
  { PseudoVFSLIDE1UP_VF32_MF4_MASK, VFSLIDE1UP_VF }, // 2333
  { PseudoVFSLIDE1UP_VF32_MF8, VFSLIDE1UP_VF }, // 2334
  { PseudoVFSLIDE1UP_VF32_MF8_MASK, VFSLIDE1UP_VF }, // 2335
  { PseudoVFSLIDE1UP_VF64_M1, VFSLIDE1UP_VF }, // 2336
  { PseudoVFSLIDE1UP_VF64_M1_MASK, VFSLIDE1UP_VF }, // 2337
  { PseudoVFSLIDE1UP_VF64_M2, VFSLIDE1UP_VF }, // 2338
  { PseudoVFSLIDE1UP_VF64_M2_MASK, VFSLIDE1UP_VF }, // 2339
  { PseudoVFSLIDE1UP_VF64_M4, VFSLIDE1UP_VF }, // 2340
  { PseudoVFSLIDE1UP_VF64_M4_MASK, VFSLIDE1UP_VF }, // 2341
  { PseudoVFSLIDE1UP_VF64_M8, VFSLIDE1UP_VF }, // 2342
  { PseudoVFSLIDE1UP_VF64_M8_MASK, VFSLIDE1UP_VF }, // 2343
  { PseudoVFSLIDE1UP_VF64_MF2, VFSLIDE1UP_VF }, // 2344
  { PseudoVFSLIDE1UP_VF64_MF2_MASK, VFSLIDE1UP_VF }, // 2345
  { PseudoVFSLIDE1UP_VF64_MF4, VFSLIDE1UP_VF }, // 2346
  { PseudoVFSLIDE1UP_VF64_MF4_MASK, VFSLIDE1UP_VF }, // 2347
  { PseudoVFSLIDE1UP_VF64_MF8, VFSLIDE1UP_VF }, // 2348
  { PseudoVFSLIDE1UP_VF64_MF8_MASK, VFSLIDE1UP_VF }, // 2349
  { PseudoVFSQRT_V_M1, VFSQRT_V }, // 2350
  { PseudoVFSQRT_V_M1_MASK, VFSQRT_V }, // 2351
  { PseudoVFSQRT_V_M2, VFSQRT_V }, // 2352
  { PseudoVFSQRT_V_M2_MASK, VFSQRT_V }, // 2353
  { PseudoVFSQRT_V_M4, VFSQRT_V }, // 2354
  { PseudoVFSQRT_V_M4_MASK, VFSQRT_V }, // 2355
  { PseudoVFSQRT_V_M8, VFSQRT_V }, // 2356
  { PseudoVFSQRT_V_M8_MASK, VFSQRT_V }, // 2357
  { PseudoVFSQRT_V_MF2, VFSQRT_V }, // 2358
  { PseudoVFSQRT_V_MF2_MASK, VFSQRT_V }, // 2359
  { PseudoVFSQRT_V_MF4, VFSQRT_V }, // 2360
  { PseudoVFSQRT_V_MF4_MASK, VFSQRT_V }, // 2361
  { PseudoVFSQRT_V_MF8, VFSQRT_V }, // 2362
  { PseudoVFSQRT_V_MF8_MASK, VFSQRT_V }, // 2363
  { PseudoVFSUB_VF16_M1, VFSUB_VF }, // 2364
  { PseudoVFSUB_VF16_M1_MASK, VFSUB_VF }, // 2365
  { PseudoVFSUB_VF16_M2, VFSUB_VF }, // 2366
  { PseudoVFSUB_VF16_M2_MASK, VFSUB_VF }, // 2367
  { PseudoVFSUB_VF16_M4, VFSUB_VF }, // 2368
  { PseudoVFSUB_VF16_M4_MASK, VFSUB_VF }, // 2369
  { PseudoVFSUB_VF16_M8, VFSUB_VF }, // 2370
  { PseudoVFSUB_VF16_M8_MASK, VFSUB_VF }, // 2371
  { PseudoVFSUB_VF16_MF2, VFSUB_VF }, // 2372
  { PseudoVFSUB_VF16_MF2_MASK, VFSUB_VF }, // 2373
  { PseudoVFSUB_VF16_MF4, VFSUB_VF }, // 2374
  { PseudoVFSUB_VF16_MF4_MASK, VFSUB_VF }, // 2375
  { PseudoVFSUB_VF16_MF8, VFSUB_VF }, // 2376
  { PseudoVFSUB_VF16_MF8_MASK, VFSUB_VF }, // 2377
  { PseudoVFSUB_VF32_M1, VFSUB_VF }, // 2378
  { PseudoVFSUB_VF32_M1_MASK, VFSUB_VF }, // 2379
  { PseudoVFSUB_VF32_M2, VFSUB_VF }, // 2380
  { PseudoVFSUB_VF32_M2_MASK, VFSUB_VF }, // 2381
  { PseudoVFSUB_VF32_M4, VFSUB_VF }, // 2382
  { PseudoVFSUB_VF32_M4_MASK, VFSUB_VF }, // 2383
  { PseudoVFSUB_VF32_M8, VFSUB_VF }, // 2384
  { PseudoVFSUB_VF32_M8_MASK, VFSUB_VF }, // 2385
  { PseudoVFSUB_VF32_MF2, VFSUB_VF }, // 2386
  { PseudoVFSUB_VF32_MF2_MASK, VFSUB_VF }, // 2387
  { PseudoVFSUB_VF32_MF4, VFSUB_VF }, // 2388
  { PseudoVFSUB_VF32_MF4_MASK, VFSUB_VF }, // 2389
  { PseudoVFSUB_VF32_MF8, VFSUB_VF }, // 2390
  { PseudoVFSUB_VF32_MF8_MASK, VFSUB_VF }, // 2391
  { PseudoVFSUB_VF64_M1, VFSUB_VF }, // 2392
  { PseudoVFSUB_VF64_M1_MASK, VFSUB_VF }, // 2393
  { PseudoVFSUB_VF64_M2, VFSUB_VF }, // 2394
  { PseudoVFSUB_VF64_M2_MASK, VFSUB_VF }, // 2395
  { PseudoVFSUB_VF64_M4, VFSUB_VF }, // 2396
  { PseudoVFSUB_VF64_M4_MASK, VFSUB_VF }, // 2397
  { PseudoVFSUB_VF64_M8, VFSUB_VF }, // 2398
  { PseudoVFSUB_VF64_M8_MASK, VFSUB_VF }, // 2399
  { PseudoVFSUB_VF64_MF2, VFSUB_VF }, // 2400
  { PseudoVFSUB_VF64_MF2_MASK, VFSUB_VF }, // 2401
  { PseudoVFSUB_VF64_MF4, VFSUB_VF }, // 2402
  { PseudoVFSUB_VF64_MF4_MASK, VFSUB_VF }, // 2403
  { PseudoVFSUB_VF64_MF8, VFSUB_VF }, // 2404
  { PseudoVFSUB_VF64_MF8_MASK, VFSUB_VF }, // 2405
  { PseudoVFSUB_VV_M1, VFSUB_VV }, // 2406
  { PseudoVFSUB_VV_M1_MASK, VFSUB_VV }, // 2407
  { PseudoVFSUB_VV_M2, VFSUB_VV }, // 2408
  { PseudoVFSUB_VV_M2_MASK, VFSUB_VV }, // 2409
  { PseudoVFSUB_VV_M4, VFSUB_VV }, // 2410
  { PseudoVFSUB_VV_M4_MASK, VFSUB_VV }, // 2411
  { PseudoVFSUB_VV_M8, VFSUB_VV }, // 2412
  { PseudoVFSUB_VV_M8_MASK, VFSUB_VV }, // 2413
  { PseudoVFSUB_VV_MF2, VFSUB_VV }, // 2414
  { PseudoVFSUB_VV_MF2_MASK, VFSUB_VV }, // 2415
  { PseudoVFSUB_VV_MF4, VFSUB_VV }, // 2416
  { PseudoVFSUB_VV_MF4_MASK, VFSUB_VV }, // 2417
  { PseudoVFSUB_VV_MF8, VFSUB_VV }, // 2418
  { PseudoVFSUB_VV_MF8_MASK, VFSUB_VV }, // 2419
  { PseudoVFWADD_VF16_M1, VFWADD_VF }, // 2420
  { PseudoVFWADD_VF16_M1_MASK, VFWADD_VF }, // 2421
  { PseudoVFWADD_VF16_M2, VFWADD_VF }, // 2422
  { PseudoVFWADD_VF16_M2_MASK, VFWADD_VF }, // 2423
  { PseudoVFWADD_VF16_M4, VFWADD_VF }, // 2424
  { PseudoVFWADD_VF16_M4_MASK, VFWADD_VF }, // 2425
  { PseudoVFWADD_VF16_MF2, VFWADD_VF }, // 2426
  { PseudoVFWADD_VF16_MF2_MASK, VFWADD_VF }, // 2427
  { PseudoVFWADD_VF16_MF4, VFWADD_VF }, // 2428
  { PseudoVFWADD_VF16_MF4_MASK, VFWADD_VF }, // 2429
  { PseudoVFWADD_VF16_MF8, VFWADD_VF }, // 2430
  { PseudoVFWADD_VF16_MF8_MASK, VFWADD_VF }, // 2431
  { PseudoVFWADD_VF32_M1, VFWADD_VF }, // 2432
  { PseudoVFWADD_VF32_M1_MASK, VFWADD_VF }, // 2433
  { PseudoVFWADD_VF32_M2, VFWADD_VF }, // 2434
  { PseudoVFWADD_VF32_M2_MASK, VFWADD_VF }, // 2435
  { PseudoVFWADD_VF32_M4, VFWADD_VF }, // 2436
  { PseudoVFWADD_VF32_M4_MASK, VFWADD_VF }, // 2437
  { PseudoVFWADD_VF32_MF2, VFWADD_VF }, // 2438
  { PseudoVFWADD_VF32_MF2_MASK, VFWADD_VF }, // 2439
  { PseudoVFWADD_VF32_MF4, VFWADD_VF }, // 2440
  { PseudoVFWADD_VF32_MF4_MASK, VFWADD_VF }, // 2441
  { PseudoVFWADD_VF32_MF8, VFWADD_VF }, // 2442
  { PseudoVFWADD_VF32_MF8_MASK, VFWADD_VF }, // 2443
  { PseudoVFWADD_VV_M1, VFWADD_VV }, // 2444
  { PseudoVFWADD_VV_M1_MASK, VFWADD_VV }, // 2445
  { PseudoVFWADD_VV_M2, VFWADD_VV }, // 2446
  { PseudoVFWADD_VV_M2_MASK, VFWADD_VV }, // 2447
  { PseudoVFWADD_VV_M4, VFWADD_VV }, // 2448
  { PseudoVFWADD_VV_M4_MASK, VFWADD_VV }, // 2449
  { PseudoVFWADD_VV_MF2, VFWADD_VV }, // 2450
  { PseudoVFWADD_VV_MF2_MASK, VFWADD_VV }, // 2451
  { PseudoVFWADD_VV_MF4, VFWADD_VV }, // 2452
  { PseudoVFWADD_VV_MF4_MASK, VFWADD_VV }, // 2453
  { PseudoVFWADD_VV_MF8, VFWADD_VV }, // 2454
  { PseudoVFWADD_VV_MF8_MASK, VFWADD_VV }, // 2455
  { PseudoVFWADD_WF16_M1, VFWADD_WF }, // 2456
  { PseudoVFWADD_WF16_M1_MASK, VFWADD_WF }, // 2457
  { PseudoVFWADD_WF16_M2, VFWADD_WF }, // 2458
  { PseudoVFWADD_WF16_M2_MASK, VFWADD_WF }, // 2459
  { PseudoVFWADD_WF16_M4, VFWADD_WF }, // 2460
  { PseudoVFWADD_WF16_M4_MASK, VFWADD_WF }, // 2461
  { PseudoVFWADD_WF16_MF2, VFWADD_WF }, // 2462
  { PseudoVFWADD_WF16_MF2_MASK, VFWADD_WF }, // 2463
  { PseudoVFWADD_WF16_MF4, VFWADD_WF }, // 2464
  { PseudoVFWADD_WF16_MF4_MASK, VFWADD_WF }, // 2465
  { PseudoVFWADD_WF16_MF8, VFWADD_WF }, // 2466
  { PseudoVFWADD_WF16_MF8_MASK, VFWADD_WF }, // 2467
  { PseudoVFWADD_WF32_M1, VFWADD_WF }, // 2468
  { PseudoVFWADD_WF32_M1_MASK, VFWADD_WF }, // 2469
  { PseudoVFWADD_WF32_M2, VFWADD_WF }, // 2470
  { PseudoVFWADD_WF32_M2_MASK, VFWADD_WF }, // 2471
  { PseudoVFWADD_WF32_M4, VFWADD_WF }, // 2472
  { PseudoVFWADD_WF32_M4_MASK, VFWADD_WF }, // 2473
  { PseudoVFWADD_WF32_MF2, VFWADD_WF }, // 2474
  { PseudoVFWADD_WF32_MF2_MASK, VFWADD_WF }, // 2475
  { PseudoVFWADD_WF32_MF4, VFWADD_WF }, // 2476
  { PseudoVFWADD_WF32_MF4_MASK, VFWADD_WF }, // 2477
  { PseudoVFWADD_WF32_MF8, VFWADD_WF }, // 2478
  { PseudoVFWADD_WF32_MF8_MASK, VFWADD_WF }, // 2479
  { PseudoVFWADD_WV_M1, VFWADD_WV }, // 2480
  { PseudoVFWADD_WV_M1_MASK, VFWADD_WV }, // 2481
  { PseudoVFWADD_WV_M2, VFWADD_WV }, // 2482
  { PseudoVFWADD_WV_M2_MASK, VFWADD_WV }, // 2483
  { PseudoVFWADD_WV_M4, VFWADD_WV }, // 2484
  { PseudoVFWADD_WV_M4_MASK, VFWADD_WV }, // 2485
  { PseudoVFWADD_WV_MF2, VFWADD_WV }, // 2486
  { PseudoVFWADD_WV_MF2_MASK, VFWADD_WV }, // 2487
  { PseudoVFWADD_WV_MF4, VFWADD_WV }, // 2488
  { PseudoVFWADD_WV_MF4_MASK, VFWADD_WV }, // 2489
  { PseudoVFWADD_WV_MF8, VFWADD_WV }, // 2490
  { PseudoVFWADD_WV_MF8_MASK, VFWADD_WV }, // 2491
  { PseudoVFWCVT_F_F_V_M1, VFWCVT_F_F_V }, // 2492
  { PseudoVFWCVT_F_F_V_M1_MASK, VFWCVT_F_F_V }, // 2493
  { PseudoVFWCVT_F_F_V_M2, VFWCVT_F_F_V }, // 2494
  { PseudoVFWCVT_F_F_V_M2_MASK, VFWCVT_F_F_V }, // 2495
  { PseudoVFWCVT_F_F_V_M4, VFWCVT_F_F_V }, // 2496
  { PseudoVFWCVT_F_F_V_M4_MASK, VFWCVT_F_F_V }, // 2497
  { PseudoVFWCVT_F_F_V_MF2, VFWCVT_F_F_V }, // 2498
  { PseudoVFWCVT_F_F_V_MF2_MASK, VFWCVT_F_F_V }, // 2499
  { PseudoVFWCVT_F_F_V_MF4, VFWCVT_F_F_V }, // 2500
  { PseudoVFWCVT_F_F_V_MF4_MASK, VFWCVT_F_F_V }, // 2501
  { PseudoVFWCVT_F_F_V_MF8, VFWCVT_F_F_V }, // 2502
  { PseudoVFWCVT_F_F_V_MF8_MASK, VFWCVT_F_F_V }, // 2503
  { PseudoVFWCVT_F_XU_V_M1, VFWCVT_F_XU_V }, // 2504
  { PseudoVFWCVT_F_XU_V_M1_MASK, VFWCVT_F_XU_V }, // 2505
  { PseudoVFWCVT_F_XU_V_M2, VFWCVT_F_XU_V }, // 2506
  { PseudoVFWCVT_F_XU_V_M2_MASK, VFWCVT_F_XU_V }, // 2507
  { PseudoVFWCVT_F_XU_V_M4, VFWCVT_F_XU_V }, // 2508
  { PseudoVFWCVT_F_XU_V_M4_MASK, VFWCVT_F_XU_V }, // 2509
  { PseudoVFWCVT_F_XU_V_MF2, VFWCVT_F_XU_V }, // 2510
  { PseudoVFWCVT_F_XU_V_MF2_MASK, VFWCVT_F_XU_V }, // 2511
  { PseudoVFWCVT_F_XU_V_MF4, VFWCVT_F_XU_V }, // 2512
  { PseudoVFWCVT_F_XU_V_MF4_MASK, VFWCVT_F_XU_V }, // 2513
  { PseudoVFWCVT_F_XU_V_MF8, VFWCVT_F_XU_V }, // 2514
  { PseudoVFWCVT_F_XU_V_MF8_MASK, VFWCVT_F_XU_V }, // 2515
  { PseudoVFWCVT_F_X_V_M1, VFWCVT_F_X_V }, // 2516
  { PseudoVFWCVT_F_X_V_M1_MASK, VFWCVT_F_X_V }, // 2517
  { PseudoVFWCVT_F_X_V_M2, VFWCVT_F_X_V }, // 2518
  { PseudoVFWCVT_F_X_V_M2_MASK, VFWCVT_F_X_V }, // 2519
  { PseudoVFWCVT_F_X_V_M4, VFWCVT_F_X_V }, // 2520
  { PseudoVFWCVT_F_X_V_M4_MASK, VFWCVT_F_X_V }, // 2521
  { PseudoVFWCVT_F_X_V_MF2, VFWCVT_F_X_V }, // 2522
  { PseudoVFWCVT_F_X_V_MF2_MASK, VFWCVT_F_X_V }, // 2523
  { PseudoVFWCVT_F_X_V_MF4, VFWCVT_F_X_V }, // 2524
  { PseudoVFWCVT_F_X_V_MF4_MASK, VFWCVT_F_X_V }, // 2525
  { PseudoVFWCVT_F_X_V_MF8, VFWCVT_F_X_V }, // 2526
  { PseudoVFWCVT_F_X_V_MF8_MASK, VFWCVT_F_X_V }, // 2527
  { PseudoVFWCVT_RTZ_XU_F_V_M1, VFWCVT_RTZ_XU_F_V }, // 2528
  { PseudoVFWCVT_RTZ_XU_F_V_M1_MASK, VFWCVT_RTZ_XU_F_V }, // 2529
  { PseudoVFWCVT_RTZ_XU_F_V_M2, VFWCVT_RTZ_XU_F_V }, // 2530
  { PseudoVFWCVT_RTZ_XU_F_V_M2_MASK, VFWCVT_RTZ_XU_F_V }, // 2531
  { PseudoVFWCVT_RTZ_XU_F_V_M4, VFWCVT_RTZ_XU_F_V }, // 2532
  { PseudoVFWCVT_RTZ_XU_F_V_M4_MASK, VFWCVT_RTZ_XU_F_V }, // 2533
  { PseudoVFWCVT_RTZ_XU_F_V_MF2, VFWCVT_RTZ_XU_F_V }, // 2534
  { PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK, VFWCVT_RTZ_XU_F_V }, // 2535
  { PseudoVFWCVT_RTZ_XU_F_V_MF4, VFWCVT_RTZ_XU_F_V }, // 2536
  { PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK, VFWCVT_RTZ_XU_F_V }, // 2537
  { PseudoVFWCVT_RTZ_XU_F_V_MF8, VFWCVT_RTZ_XU_F_V }, // 2538
  { PseudoVFWCVT_RTZ_XU_F_V_MF8_MASK, VFWCVT_RTZ_XU_F_V }, // 2539
  { PseudoVFWCVT_RTZ_X_F_V_M1, VFWCVT_RTZ_X_F_V }, // 2540
  { PseudoVFWCVT_RTZ_X_F_V_M1_MASK, VFWCVT_RTZ_X_F_V }, // 2541
  { PseudoVFWCVT_RTZ_X_F_V_M2, VFWCVT_RTZ_X_F_V }, // 2542
  { PseudoVFWCVT_RTZ_X_F_V_M2_MASK, VFWCVT_RTZ_X_F_V }, // 2543
  { PseudoVFWCVT_RTZ_X_F_V_M4, VFWCVT_RTZ_X_F_V }, // 2544
  { PseudoVFWCVT_RTZ_X_F_V_M4_MASK, VFWCVT_RTZ_X_F_V }, // 2545
  { PseudoVFWCVT_RTZ_X_F_V_MF2, VFWCVT_RTZ_X_F_V }, // 2546
  { PseudoVFWCVT_RTZ_X_F_V_MF2_MASK, VFWCVT_RTZ_X_F_V }, // 2547
  { PseudoVFWCVT_RTZ_X_F_V_MF4, VFWCVT_RTZ_X_F_V }, // 2548
  { PseudoVFWCVT_RTZ_X_F_V_MF4_MASK, VFWCVT_RTZ_X_F_V }, // 2549
  { PseudoVFWCVT_RTZ_X_F_V_MF8, VFWCVT_RTZ_X_F_V }, // 2550
  { PseudoVFWCVT_RTZ_X_F_V_MF8_MASK, VFWCVT_RTZ_X_F_V }, // 2551
  { PseudoVFWCVT_XU_F_V_M1, VFWCVT_XU_F_V }, // 2552
  { PseudoVFWCVT_XU_F_V_M1_MASK, VFWCVT_XU_F_V }, // 2553
  { PseudoVFWCVT_XU_F_V_M2, VFWCVT_XU_F_V }, // 2554
  { PseudoVFWCVT_XU_F_V_M2_MASK, VFWCVT_XU_F_V }, // 2555
  { PseudoVFWCVT_XU_F_V_M4, VFWCVT_XU_F_V }, // 2556
  { PseudoVFWCVT_XU_F_V_M4_MASK, VFWCVT_XU_F_V }, // 2557
  { PseudoVFWCVT_XU_F_V_MF2, VFWCVT_XU_F_V }, // 2558
  { PseudoVFWCVT_XU_F_V_MF2_MASK, VFWCVT_XU_F_V }, // 2559
  { PseudoVFWCVT_XU_F_V_MF4, VFWCVT_XU_F_V }, // 2560
  { PseudoVFWCVT_XU_F_V_MF4_MASK, VFWCVT_XU_F_V }, // 2561
  { PseudoVFWCVT_XU_F_V_MF8, VFWCVT_XU_F_V }, // 2562
  { PseudoVFWCVT_XU_F_V_MF8_MASK, VFWCVT_XU_F_V }, // 2563
  { PseudoVFWCVT_X_F_V_M1, VFWCVT_X_F_V }, // 2564
  { PseudoVFWCVT_X_F_V_M1_MASK, VFWCVT_X_F_V }, // 2565
  { PseudoVFWCVT_X_F_V_M2, VFWCVT_X_F_V }, // 2566
  { PseudoVFWCVT_X_F_V_M2_MASK, VFWCVT_X_F_V }, // 2567
  { PseudoVFWCVT_X_F_V_M4, VFWCVT_X_F_V }, // 2568
  { PseudoVFWCVT_X_F_V_M4_MASK, VFWCVT_X_F_V }, // 2569
  { PseudoVFWCVT_X_F_V_MF2, VFWCVT_X_F_V }, // 2570
  { PseudoVFWCVT_X_F_V_MF2_MASK, VFWCVT_X_F_V }, // 2571
  { PseudoVFWCVT_X_F_V_MF4, VFWCVT_X_F_V }, // 2572
  { PseudoVFWCVT_X_F_V_MF4_MASK, VFWCVT_X_F_V }, // 2573
  { PseudoVFWCVT_X_F_V_MF8, VFWCVT_X_F_V }, // 2574
  { PseudoVFWCVT_X_F_V_MF8_MASK, VFWCVT_X_F_V }, // 2575
  { PseudoVFWMACC_VF16_M1, VFWMACC_VF }, // 2576
  { PseudoVFWMACC_VF16_M1_MASK, VFWMACC_VF }, // 2577
  { PseudoVFWMACC_VF16_M2, VFWMACC_VF }, // 2578
  { PseudoVFWMACC_VF16_M2_MASK, VFWMACC_VF }, // 2579
  { PseudoVFWMACC_VF16_M4, VFWMACC_VF }, // 2580
  { PseudoVFWMACC_VF16_M4_MASK, VFWMACC_VF }, // 2581
  { PseudoVFWMACC_VF16_MF2, VFWMACC_VF }, // 2582
  { PseudoVFWMACC_VF16_MF2_MASK, VFWMACC_VF }, // 2583
  { PseudoVFWMACC_VF16_MF4, VFWMACC_VF }, // 2584
  { PseudoVFWMACC_VF16_MF4_MASK, VFWMACC_VF }, // 2585
  { PseudoVFWMACC_VF16_MF8, VFWMACC_VF }, // 2586
  { PseudoVFWMACC_VF16_MF8_MASK, VFWMACC_VF }, // 2587
  { PseudoVFWMACC_VF32_M1, VFWMACC_VF }, // 2588
  { PseudoVFWMACC_VF32_M1_MASK, VFWMACC_VF }, // 2589
  { PseudoVFWMACC_VF32_M2, VFWMACC_VF }, // 2590
  { PseudoVFWMACC_VF32_M2_MASK, VFWMACC_VF }, // 2591
  { PseudoVFWMACC_VF32_M4, VFWMACC_VF }, // 2592
  { PseudoVFWMACC_VF32_M4_MASK, VFWMACC_VF }, // 2593
  { PseudoVFWMACC_VF32_MF2, VFWMACC_VF }, // 2594
  { PseudoVFWMACC_VF32_MF2_MASK, VFWMACC_VF }, // 2595
  { PseudoVFWMACC_VF32_MF4, VFWMACC_VF }, // 2596
  { PseudoVFWMACC_VF32_MF4_MASK, VFWMACC_VF }, // 2597
  { PseudoVFWMACC_VF32_MF8, VFWMACC_VF }, // 2598
  { PseudoVFWMACC_VF32_MF8_MASK, VFWMACC_VF }, // 2599
  { PseudoVFWMACC_VV_M1, VFWMACC_VV }, // 2600
  { PseudoVFWMACC_VV_M1_MASK, VFWMACC_VV }, // 2601
  { PseudoVFWMACC_VV_M2, VFWMACC_VV }, // 2602
  { PseudoVFWMACC_VV_M2_MASK, VFWMACC_VV }, // 2603
  { PseudoVFWMACC_VV_M4, VFWMACC_VV }, // 2604
  { PseudoVFWMACC_VV_M4_MASK, VFWMACC_VV }, // 2605
  { PseudoVFWMACC_VV_MF2, VFWMACC_VV }, // 2606
  { PseudoVFWMACC_VV_MF2_MASK, VFWMACC_VV }, // 2607
  { PseudoVFWMACC_VV_MF4, VFWMACC_VV }, // 2608
  { PseudoVFWMACC_VV_MF4_MASK, VFWMACC_VV }, // 2609
  { PseudoVFWMACC_VV_MF8, VFWMACC_VV }, // 2610
  { PseudoVFWMACC_VV_MF8_MASK, VFWMACC_VV }, // 2611
  { PseudoVFWMSAC_VF16_M1, VFWMSAC_VF }, // 2612
  { PseudoVFWMSAC_VF16_M1_MASK, VFWMSAC_VF }, // 2613
  { PseudoVFWMSAC_VF16_M2, VFWMSAC_VF }, // 2614
  { PseudoVFWMSAC_VF16_M2_MASK, VFWMSAC_VF }, // 2615
  { PseudoVFWMSAC_VF16_M4, VFWMSAC_VF }, // 2616
  { PseudoVFWMSAC_VF16_M4_MASK, VFWMSAC_VF }, // 2617
  { PseudoVFWMSAC_VF16_MF2, VFWMSAC_VF }, // 2618
  { PseudoVFWMSAC_VF16_MF2_MASK, VFWMSAC_VF }, // 2619
  { PseudoVFWMSAC_VF16_MF4, VFWMSAC_VF }, // 2620
  { PseudoVFWMSAC_VF16_MF4_MASK, VFWMSAC_VF }, // 2621
  { PseudoVFWMSAC_VF16_MF8, VFWMSAC_VF }, // 2622
  { PseudoVFWMSAC_VF16_MF8_MASK, VFWMSAC_VF }, // 2623
  { PseudoVFWMSAC_VF32_M1, VFWMSAC_VF }, // 2624
  { PseudoVFWMSAC_VF32_M1_MASK, VFWMSAC_VF }, // 2625
  { PseudoVFWMSAC_VF32_M2, VFWMSAC_VF }, // 2626
  { PseudoVFWMSAC_VF32_M2_MASK, VFWMSAC_VF }, // 2627
  { PseudoVFWMSAC_VF32_M4, VFWMSAC_VF }, // 2628
  { PseudoVFWMSAC_VF32_M4_MASK, VFWMSAC_VF }, // 2629
  { PseudoVFWMSAC_VF32_MF2, VFWMSAC_VF }, // 2630
  { PseudoVFWMSAC_VF32_MF2_MASK, VFWMSAC_VF }, // 2631
  { PseudoVFWMSAC_VF32_MF4, VFWMSAC_VF }, // 2632
  { PseudoVFWMSAC_VF32_MF4_MASK, VFWMSAC_VF }, // 2633
  { PseudoVFWMSAC_VF32_MF8, VFWMSAC_VF }, // 2634
  { PseudoVFWMSAC_VF32_MF8_MASK, VFWMSAC_VF }, // 2635
  { PseudoVFWMSAC_VV_M1, VFWMSAC_VV }, // 2636
  { PseudoVFWMSAC_VV_M1_MASK, VFWMSAC_VV }, // 2637
  { PseudoVFWMSAC_VV_M2, VFWMSAC_VV }, // 2638
  { PseudoVFWMSAC_VV_M2_MASK, VFWMSAC_VV }, // 2639
  { PseudoVFWMSAC_VV_M4, VFWMSAC_VV }, // 2640
  { PseudoVFWMSAC_VV_M4_MASK, VFWMSAC_VV }, // 2641
  { PseudoVFWMSAC_VV_MF2, VFWMSAC_VV }, // 2642
  { PseudoVFWMSAC_VV_MF2_MASK, VFWMSAC_VV }, // 2643
  { PseudoVFWMSAC_VV_MF4, VFWMSAC_VV }, // 2644
  { PseudoVFWMSAC_VV_MF4_MASK, VFWMSAC_VV }, // 2645
  { PseudoVFWMSAC_VV_MF8, VFWMSAC_VV }, // 2646
  { PseudoVFWMSAC_VV_MF8_MASK, VFWMSAC_VV }, // 2647
  { PseudoVFWMUL_VF16_M1, VFWMUL_VF }, // 2648
  { PseudoVFWMUL_VF16_M1_MASK, VFWMUL_VF }, // 2649
  { PseudoVFWMUL_VF16_M2, VFWMUL_VF }, // 2650
  { PseudoVFWMUL_VF16_M2_MASK, VFWMUL_VF }, // 2651
  { PseudoVFWMUL_VF16_M4, VFWMUL_VF }, // 2652
  { PseudoVFWMUL_VF16_M4_MASK, VFWMUL_VF }, // 2653
  { PseudoVFWMUL_VF16_MF2, VFWMUL_VF }, // 2654
  { PseudoVFWMUL_VF16_MF2_MASK, VFWMUL_VF }, // 2655
  { PseudoVFWMUL_VF16_MF4, VFWMUL_VF }, // 2656
  { PseudoVFWMUL_VF16_MF4_MASK, VFWMUL_VF }, // 2657
  { PseudoVFWMUL_VF16_MF8, VFWMUL_VF }, // 2658
  { PseudoVFWMUL_VF16_MF8_MASK, VFWMUL_VF }, // 2659
  { PseudoVFWMUL_VF32_M1, VFWMUL_VF }, // 2660
  { PseudoVFWMUL_VF32_M1_MASK, VFWMUL_VF }, // 2661
  { PseudoVFWMUL_VF32_M2, VFWMUL_VF }, // 2662
  { PseudoVFWMUL_VF32_M2_MASK, VFWMUL_VF }, // 2663
  { PseudoVFWMUL_VF32_M4, VFWMUL_VF }, // 2664
  { PseudoVFWMUL_VF32_M4_MASK, VFWMUL_VF }, // 2665
  { PseudoVFWMUL_VF32_MF2, VFWMUL_VF }, // 2666
  { PseudoVFWMUL_VF32_MF2_MASK, VFWMUL_VF }, // 2667
  { PseudoVFWMUL_VF32_MF4, VFWMUL_VF }, // 2668
  { PseudoVFWMUL_VF32_MF4_MASK, VFWMUL_VF }, // 2669
  { PseudoVFWMUL_VF32_MF8, VFWMUL_VF }, // 2670
  { PseudoVFWMUL_VF32_MF8_MASK, VFWMUL_VF }, // 2671
  { PseudoVFWMUL_VV_M1, VFWMUL_VV }, // 2672
  { PseudoVFWMUL_VV_M1_MASK, VFWMUL_VV }, // 2673
  { PseudoVFWMUL_VV_M2, VFWMUL_VV }, // 2674
  { PseudoVFWMUL_VV_M2_MASK, VFWMUL_VV }, // 2675
  { PseudoVFWMUL_VV_M4, VFWMUL_VV }, // 2676
  { PseudoVFWMUL_VV_M4_MASK, VFWMUL_VV }, // 2677
  { PseudoVFWMUL_VV_MF2, VFWMUL_VV }, // 2678
  { PseudoVFWMUL_VV_MF2_MASK, VFWMUL_VV }, // 2679
  { PseudoVFWMUL_VV_MF4, VFWMUL_VV }, // 2680
  { PseudoVFWMUL_VV_MF4_MASK, VFWMUL_VV }, // 2681
  { PseudoVFWMUL_VV_MF8, VFWMUL_VV }, // 2682
  { PseudoVFWMUL_VV_MF8_MASK, VFWMUL_VV }, // 2683
  { PseudoVFWNMACC_VF16_M1, VFWNMACC_VF }, // 2684
  { PseudoVFWNMACC_VF16_M1_MASK, VFWNMACC_VF }, // 2685
  { PseudoVFWNMACC_VF16_M2, VFWNMACC_VF }, // 2686
  { PseudoVFWNMACC_VF16_M2_MASK, VFWNMACC_VF }, // 2687
  { PseudoVFWNMACC_VF16_M4, VFWNMACC_VF }, // 2688
  { PseudoVFWNMACC_VF16_M4_MASK, VFWNMACC_VF }, // 2689
  { PseudoVFWNMACC_VF16_MF2, VFWNMACC_VF }, // 2690
  { PseudoVFWNMACC_VF16_MF2_MASK, VFWNMACC_VF }, // 2691
  { PseudoVFWNMACC_VF16_MF4, VFWNMACC_VF }, // 2692
  { PseudoVFWNMACC_VF16_MF4_MASK, VFWNMACC_VF }, // 2693
  { PseudoVFWNMACC_VF16_MF8, VFWNMACC_VF }, // 2694
  { PseudoVFWNMACC_VF16_MF8_MASK, VFWNMACC_VF }, // 2695
  { PseudoVFWNMACC_VF32_M1, VFWNMACC_VF }, // 2696
  { PseudoVFWNMACC_VF32_M1_MASK, VFWNMACC_VF }, // 2697
  { PseudoVFWNMACC_VF32_M2, VFWNMACC_VF }, // 2698
  { PseudoVFWNMACC_VF32_M2_MASK, VFWNMACC_VF }, // 2699
  { PseudoVFWNMACC_VF32_M4, VFWNMACC_VF }, // 2700
  { PseudoVFWNMACC_VF32_M4_MASK, VFWNMACC_VF }, // 2701
  { PseudoVFWNMACC_VF32_MF2, VFWNMACC_VF }, // 2702
  { PseudoVFWNMACC_VF32_MF2_MASK, VFWNMACC_VF }, // 2703
  { PseudoVFWNMACC_VF32_MF4, VFWNMACC_VF }, // 2704
  { PseudoVFWNMACC_VF32_MF4_MASK, VFWNMACC_VF }, // 2705
  { PseudoVFWNMACC_VF32_MF8, VFWNMACC_VF }, // 2706
  { PseudoVFWNMACC_VF32_MF8_MASK, VFWNMACC_VF }, // 2707
  { PseudoVFWNMACC_VV_M1, VFWNMACC_VV }, // 2708
  { PseudoVFWNMACC_VV_M1_MASK, VFWNMACC_VV }, // 2709
  { PseudoVFWNMACC_VV_M2, VFWNMACC_VV }, // 2710
  { PseudoVFWNMACC_VV_M2_MASK, VFWNMACC_VV }, // 2711
  { PseudoVFWNMACC_VV_M4, VFWNMACC_VV }, // 2712
  { PseudoVFWNMACC_VV_M4_MASK, VFWNMACC_VV }, // 2713
  { PseudoVFWNMACC_VV_MF2, VFWNMACC_VV }, // 2714
  { PseudoVFWNMACC_VV_MF2_MASK, VFWNMACC_VV }, // 2715
  { PseudoVFWNMACC_VV_MF4, VFWNMACC_VV }, // 2716
  { PseudoVFWNMACC_VV_MF4_MASK, VFWNMACC_VV }, // 2717
  { PseudoVFWNMACC_VV_MF8, VFWNMACC_VV }, // 2718
  { PseudoVFWNMACC_VV_MF8_MASK, VFWNMACC_VV }, // 2719
  { PseudoVFWNMSAC_VF16_M1, VFWNMSAC_VF }, // 2720
  { PseudoVFWNMSAC_VF16_M1_MASK, VFWNMSAC_VF }, // 2721
  { PseudoVFWNMSAC_VF16_M2, VFWNMSAC_VF }, // 2722
  { PseudoVFWNMSAC_VF16_M2_MASK, VFWNMSAC_VF }, // 2723
  { PseudoVFWNMSAC_VF16_M4, VFWNMSAC_VF }, // 2724
  { PseudoVFWNMSAC_VF16_M4_MASK, VFWNMSAC_VF }, // 2725
  { PseudoVFWNMSAC_VF16_MF2, VFWNMSAC_VF }, // 2726
  { PseudoVFWNMSAC_VF16_MF2_MASK, VFWNMSAC_VF }, // 2727
  { PseudoVFWNMSAC_VF16_MF4, VFWNMSAC_VF }, // 2728
  { PseudoVFWNMSAC_VF16_MF4_MASK, VFWNMSAC_VF }, // 2729
  { PseudoVFWNMSAC_VF16_MF8, VFWNMSAC_VF }, // 2730
  { PseudoVFWNMSAC_VF16_MF8_MASK, VFWNMSAC_VF }, // 2731
  { PseudoVFWNMSAC_VF32_M1, VFWNMSAC_VF }, // 2732
  { PseudoVFWNMSAC_VF32_M1_MASK, VFWNMSAC_VF }, // 2733
  { PseudoVFWNMSAC_VF32_M2, VFWNMSAC_VF }, // 2734
  { PseudoVFWNMSAC_VF32_M2_MASK, VFWNMSAC_VF }, // 2735
  { PseudoVFWNMSAC_VF32_M4, VFWNMSAC_VF }, // 2736
  { PseudoVFWNMSAC_VF32_M4_MASK, VFWNMSAC_VF }, // 2737
  { PseudoVFWNMSAC_VF32_MF2, VFWNMSAC_VF }, // 2738
  { PseudoVFWNMSAC_VF32_MF2_MASK, VFWNMSAC_VF }, // 2739
  { PseudoVFWNMSAC_VF32_MF4, VFWNMSAC_VF }, // 2740
  { PseudoVFWNMSAC_VF32_MF4_MASK, VFWNMSAC_VF }, // 2741
  { PseudoVFWNMSAC_VF32_MF8, VFWNMSAC_VF }, // 2742
  { PseudoVFWNMSAC_VF32_MF8_MASK, VFWNMSAC_VF }, // 2743
  { PseudoVFWNMSAC_VV_M1, VFWNMSAC_VV }, // 2744
  { PseudoVFWNMSAC_VV_M1_MASK, VFWNMSAC_VV }, // 2745
  { PseudoVFWNMSAC_VV_M2, VFWNMSAC_VV }, // 2746
  { PseudoVFWNMSAC_VV_M2_MASK, VFWNMSAC_VV }, // 2747
  { PseudoVFWNMSAC_VV_M4, VFWNMSAC_VV }, // 2748
  { PseudoVFWNMSAC_VV_M4_MASK, VFWNMSAC_VV }, // 2749
  { PseudoVFWNMSAC_VV_MF2, VFWNMSAC_VV }, // 2750
  { PseudoVFWNMSAC_VV_MF2_MASK, VFWNMSAC_VV }, // 2751
  { PseudoVFWNMSAC_VV_MF4, VFWNMSAC_VV }, // 2752
  { PseudoVFWNMSAC_VV_MF4_MASK, VFWNMSAC_VV }, // 2753
  { PseudoVFWNMSAC_VV_MF8, VFWNMSAC_VV }, // 2754
  { PseudoVFWNMSAC_VV_MF8_MASK, VFWNMSAC_VV }, // 2755
  { PseudoVFWREDOSUM_VS_M1, VFWREDOSUM_VS }, // 2756
  { PseudoVFWREDOSUM_VS_M1_MASK, VFWREDOSUM_VS }, // 2757
  { PseudoVFWREDOSUM_VS_M2, VFWREDOSUM_VS }, // 2758
  { PseudoVFWREDOSUM_VS_M2_MASK, VFWREDOSUM_VS }, // 2759
  { PseudoVFWREDOSUM_VS_M4, VFWREDOSUM_VS }, // 2760
  { PseudoVFWREDOSUM_VS_M4_MASK, VFWREDOSUM_VS }, // 2761
  { PseudoVFWREDOSUM_VS_M8, VFWREDOSUM_VS }, // 2762
  { PseudoVFWREDOSUM_VS_M8_MASK, VFWREDOSUM_VS }, // 2763
  { PseudoVFWREDOSUM_VS_MF2, VFWREDOSUM_VS }, // 2764
  { PseudoVFWREDOSUM_VS_MF2_MASK, VFWREDOSUM_VS }, // 2765
  { PseudoVFWREDOSUM_VS_MF4, VFWREDOSUM_VS }, // 2766
  { PseudoVFWREDOSUM_VS_MF4_MASK, VFWREDOSUM_VS }, // 2767
  { PseudoVFWREDOSUM_VS_MF8, VFWREDOSUM_VS }, // 2768
  { PseudoVFWREDOSUM_VS_MF8_MASK, VFWREDOSUM_VS }, // 2769
  { PseudoVFWREDSUM_VS_M1, VFWREDSUM_VS }, // 2770
  { PseudoVFWREDSUM_VS_M1_MASK, VFWREDSUM_VS }, // 2771
  { PseudoVFWREDSUM_VS_M2, VFWREDSUM_VS }, // 2772
  { PseudoVFWREDSUM_VS_M2_MASK, VFWREDSUM_VS }, // 2773
  { PseudoVFWREDSUM_VS_M4, VFWREDSUM_VS }, // 2774
  { PseudoVFWREDSUM_VS_M4_MASK, VFWREDSUM_VS }, // 2775
  { PseudoVFWREDSUM_VS_M8, VFWREDSUM_VS }, // 2776
  { PseudoVFWREDSUM_VS_M8_MASK, VFWREDSUM_VS }, // 2777
  { PseudoVFWREDSUM_VS_MF2, VFWREDSUM_VS }, // 2778
  { PseudoVFWREDSUM_VS_MF2_MASK, VFWREDSUM_VS }, // 2779
  { PseudoVFWREDSUM_VS_MF4, VFWREDSUM_VS }, // 2780
  { PseudoVFWREDSUM_VS_MF4_MASK, VFWREDSUM_VS }, // 2781
  { PseudoVFWREDSUM_VS_MF8, VFWREDSUM_VS }, // 2782
  { PseudoVFWREDSUM_VS_MF8_MASK, VFWREDSUM_VS }, // 2783
  { PseudoVFWSUB_VF16_M1, VFWSUB_VF }, // 2784
  { PseudoVFWSUB_VF16_M1_MASK, VFWSUB_VF }, // 2785
  { PseudoVFWSUB_VF16_M2, VFWSUB_VF }, // 2786
  { PseudoVFWSUB_VF16_M2_MASK, VFWSUB_VF }, // 2787
  { PseudoVFWSUB_VF16_M4, VFWSUB_VF }, // 2788
  { PseudoVFWSUB_VF16_M4_MASK, VFWSUB_VF }, // 2789
  { PseudoVFWSUB_VF16_MF2, VFWSUB_VF }, // 2790
  { PseudoVFWSUB_VF16_MF2_MASK, VFWSUB_VF }, // 2791
  { PseudoVFWSUB_VF16_MF4, VFWSUB_VF }, // 2792
  { PseudoVFWSUB_VF16_MF4_MASK, VFWSUB_VF }, // 2793
  { PseudoVFWSUB_VF16_MF8, VFWSUB_VF }, // 2794
  { PseudoVFWSUB_VF16_MF8_MASK, VFWSUB_VF }, // 2795
  { PseudoVFWSUB_VF32_M1, VFWSUB_VF }, // 2796
  { PseudoVFWSUB_VF32_M1_MASK, VFWSUB_VF }, // 2797
  { PseudoVFWSUB_VF32_M2, VFWSUB_VF }, // 2798
  { PseudoVFWSUB_VF32_M2_MASK, VFWSUB_VF }, // 2799
  { PseudoVFWSUB_VF32_M4, VFWSUB_VF }, // 2800
  { PseudoVFWSUB_VF32_M4_MASK, VFWSUB_VF }, // 2801
  { PseudoVFWSUB_VF32_MF2, VFWSUB_VF }, // 2802
  { PseudoVFWSUB_VF32_MF2_MASK, VFWSUB_VF }, // 2803
  { PseudoVFWSUB_VF32_MF4, VFWSUB_VF }, // 2804
  { PseudoVFWSUB_VF32_MF4_MASK, VFWSUB_VF }, // 2805
  { PseudoVFWSUB_VF32_MF8, VFWSUB_VF }, // 2806
  { PseudoVFWSUB_VF32_MF8_MASK, VFWSUB_VF }, // 2807
  { PseudoVFWSUB_VV_M1, VFWSUB_VV }, // 2808
  { PseudoVFWSUB_VV_M1_MASK, VFWSUB_VV }, // 2809
  { PseudoVFWSUB_VV_M2, VFWSUB_VV }, // 2810
  { PseudoVFWSUB_VV_M2_MASK, VFWSUB_VV }, // 2811
  { PseudoVFWSUB_VV_M4, VFWSUB_VV }, // 2812
  { PseudoVFWSUB_VV_M4_MASK, VFWSUB_VV }, // 2813
  { PseudoVFWSUB_VV_MF2, VFWSUB_VV }, // 2814
  { PseudoVFWSUB_VV_MF2_MASK, VFWSUB_VV }, // 2815
  { PseudoVFWSUB_VV_MF4, VFWSUB_VV }, // 2816
  { PseudoVFWSUB_VV_MF4_MASK, VFWSUB_VV }, // 2817
  { PseudoVFWSUB_VV_MF8, VFWSUB_VV }, // 2818
  { PseudoVFWSUB_VV_MF8_MASK, VFWSUB_VV }, // 2819
  { PseudoVFWSUB_WF16_M1, VFWSUB_WF }, // 2820
  { PseudoVFWSUB_WF16_M1_MASK, VFWSUB_WF }, // 2821
  { PseudoVFWSUB_WF16_M2, VFWSUB_WF }, // 2822
  { PseudoVFWSUB_WF16_M2_MASK, VFWSUB_WF }, // 2823
  { PseudoVFWSUB_WF16_M4, VFWSUB_WF }, // 2824
  { PseudoVFWSUB_WF16_M4_MASK, VFWSUB_WF }, // 2825
  { PseudoVFWSUB_WF16_MF2, VFWSUB_WF }, // 2826
  { PseudoVFWSUB_WF16_MF2_MASK, VFWSUB_WF }, // 2827
  { PseudoVFWSUB_WF16_MF4, VFWSUB_WF }, // 2828
  { PseudoVFWSUB_WF16_MF4_MASK, VFWSUB_WF }, // 2829
  { PseudoVFWSUB_WF16_MF8, VFWSUB_WF }, // 2830
  { PseudoVFWSUB_WF16_MF8_MASK, VFWSUB_WF }, // 2831
  { PseudoVFWSUB_WF32_M1, VFWSUB_WF }, // 2832
  { PseudoVFWSUB_WF32_M1_MASK, VFWSUB_WF }, // 2833
  { PseudoVFWSUB_WF32_M2, VFWSUB_WF }, // 2834
  { PseudoVFWSUB_WF32_M2_MASK, VFWSUB_WF }, // 2835
  { PseudoVFWSUB_WF32_M4, VFWSUB_WF }, // 2836
  { PseudoVFWSUB_WF32_M4_MASK, VFWSUB_WF }, // 2837
  { PseudoVFWSUB_WF32_MF2, VFWSUB_WF }, // 2838
  { PseudoVFWSUB_WF32_MF2_MASK, VFWSUB_WF }, // 2839
  { PseudoVFWSUB_WF32_MF4, VFWSUB_WF }, // 2840
  { PseudoVFWSUB_WF32_MF4_MASK, VFWSUB_WF }, // 2841
  { PseudoVFWSUB_WF32_MF8, VFWSUB_WF }, // 2842
  { PseudoVFWSUB_WF32_MF8_MASK, VFWSUB_WF }, // 2843
  { PseudoVFWSUB_WV_M1, VFWSUB_WV }, // 2844
  { PseudoVFWSUB_WV_M1_MASK, VFWSUB_WV }, // 2845
  { PseudoVFWSUB_WV_M2, VFWSUB_WV }, // 2846
  { PseudoVFWSUB_WV_M2_MASK, VFWSUB_WV }, // 2847
  { PseudoVFWSUB_WV_M4, VFWSUB_WV }, // 2848
  { PseudoVFWSUB_WV_M4_MASK, VFWSUB_WV }, // 2849
  { PseudoVFWSUB_WV_MF2, VFWSUB_WV }, // 2850
  { PseudoVFWSUB_WV_MF2_MASK, VFWSUB_WV }, // 2851
  { PseudoVFWSUB_WV_MF4, VFWSUB_WV }, // 2852
  { PseudoVFWSUB_WV_MF4_MASK, VFWSUB_WV }, // 2853
  { PseudoVFWSUB_WV_MF8, VFWSUB_WV }, // 2854
  { PseudoVFWSUB_WV_MF8_MASK, VFWSUB_WV }, // 2855
  { PseudoVID_V_M1, VID_V }, // 2856
  { PseudoVID_V_M1_MASK, VID_V }, // 2857
  { PseudoVID_V_M2, VID_V }, // 2858
  { PseudoVID_V_M2_MASK, VID_V }, // 2859
  { PseudoVID_V_M4, VID_V }, // 2860
  { PseudoVID_V_M4_MASK, VID_V }, // 2861
  { PseudoVID_V_M8, VID_V }, // 2862
  { PseudoVID_V_M8_MASK, VID_V }, // 2863
  { PseudoVID_V_MF2, VID_V }, // 2864
  { PseudoVID_V_MF2_MASK, VID_V }, // 2865
  { PseudoVID_V_MF4, VID_V }, // 2866
  { PseudoVID_V_MF4_MASK, VID_V }, // 2867
  { PseudoVID_V_MF8, VID_V }, // 2868
  { PseudoVID_V_MF8_MASK, VID_V }, // 2869
  { PseudoVIOTA_M_M1, VIOTA_M }, // 2870
  { PseudoVIOTA_M_M1_MASK, VIOTA_M }, // 2871
  { PseudoVIOTA_M_M2, VIOTA_M }, // 2872
  { PseudoVIOTA_M_M2_MASK, VIOTA_M }, // 2873
  { PseudoVIOTA_M_M4, VIOTA_M }, // 2874
  { PseudoVIOTA_M_M4_MASK, VIOTA_M }, // 2875
  { PseudoVIOTA_M_M8, VIOTA_M }, // 2876
  { PseudoVIOTA_M_M8_MASK, VIOTA_M }, // 2877
  { PseudoVIOTA_M_MF2, VIOTA_M }, // 2878
  { PseudoVIOTA_M_MF2_MASK, VIOTA_M }, // 2879
  { PseudoVIOTA_M_MF4, VIOTA_M }, // 2880
  { PseudoVIOTA_M_MF4_MASK, VIOTA_M }, // 2881
  { PseudoVIOTA_M_MF8, VIOTA_M }, // 2882
  { PseudoVIOTA_M_MF8_MASK, VIOTA_M }, // 2883
  { PseudoVLE16FF_V_M1, VLE16FF_V }, // 2884
  { PseudoVLE16FF_V_M1_MASK, VLE16FF_V }, // 2885
  { PseudoVLE16FF_V_M2, VLE16FF_V }, // 2886
  { PseudoVLE16FF_V_M2_MASK, VLE16FF_V }, // 2887
  { PseudoVLE16FF_V_M4, VLE16FF_V }, // 2888
  { PseudoVLE16FF_V_M4_MASK, VLE16FF_V }, // 2889
  { PseudoVLE16FF_V_M8, VLE16FF_V }, // 2890
  { PseudoVLE16FF_V_M8_MASK, VLE16FF_V }, // 2891
  { PseudoVLE16FF_V_MF2, VLE16FF_V }, // 2892
  { PseudoVLE16FF_V_MF2_MASK, VLE16FF_V }, // 2893
  { PseudoVLE16FF_V_MF4, VLE16FF_V }, // 2894
  { PseudoVLE16FF_V_MF4_MASK, VLE16FF_V }, // 2895
  { PseudoVLE16FF_V_MF8, VLE16FF_V }, // 2896
  { PseudoVLE16FF_V_MF8_MASK, VLE16FF_V }, // 2897
  { PseudoVLE16_V_M1, VLE16_V }, // 2898
  { PseudoVLE16_V_M1_MASK, VLE16_V }, // 2899
  { PseudoVLE16_V_M2, VLE16_V }, // 2900
  { PseudoVLE16_V_M2_MASK, VLE16_V }, // 2901
  { PseudoVLE16_V_M4, VLE16_V }, // 2902
  { PseudoVLE16_V_M4_MASK, VLE16_V }, // 2903
  { PseudoVLE16_V_M8, VLE16_V }, // 2904
  { PseudoVLE16_V_M8_MASK, VLE16_V }, // 2905
  { PseudoVLE16_V_MF2, VLE16_V }, // 2906
  { PseudoVLE16_V_MF2_MASK, VLE16_V }, // 2907
  { PseudoVLE16_V_MF4, VLE16_V }, // 2908
  { PseudoVLE16_V_MF4_MASK, VLE16_V }, // 2909
  { PseudoVLE16_V_MF8, VLE16_V }, // 2910
  { PseudoVLE16_V_MF8_MASK, VLE16_V }, // 2911
  { PseudoVLE1_V_B1, VLE1_V }, // 2912
  { PseudoVLE1_V_B16, VLE1_V }, // 2913
  { PseudoVLE1_V_B2, VLE1_V }, // 2914
  { PseudoVLE1_V_B32, VLE1_V }, // 2915
  { PseudoVLE1_V_B4, VLE1_V }, // 2916
  { PseudoVLE1_V_B64, VLE1_V }, // 2917
  { PseudoVLE1_V_B8, VLE1_V }, // 2918
  { PseudoVLE32FF_V_M1, VLE32FF_V }, // 2919
  { PseudoVLE32FF_V_M1_MASK, VLE32FF_V }, // 2920
  { PseudoVLE32FF_V_M2, VLE32FF_V }, // 2921
  { PseudoVLE32FF_V_M2_MASK, VLE32FF_V }, // 2922
  { PseudoVLE32FF_V_M4, VLE32FF_V }, // 2923
  { PseudoVLE32FF_V_M4_MASK, VLE32FF_V }, // 2924
  { PseudoVLE32FF_V_M8, VLE32FF_V }, // 2925
  { PseudoVLE32FF_V_M8_MASK, VLE32FF_V }, // 2926
  { PseudoVLE32FF_V_MF2, VLE32FF_V }, // 2927
  { PseudoVLE32FF_V_MF2_MASK, VLE32FF_V }, // 2928
  { PseudoVLE32FF_V_MF4, VLE32FF_V }, // 2929
  { PseudoVLE32FF_V_MF4_MASK, VLE32FF_V }, // 2930
  { PseudoVLE32FF_V_MF8, VLE32FF_V }, // 2931
  { PseudoVLE32FF_V_MF8_MASK, VLE32FF_V }, // 2932
  { PseudoVLE32_V_M1, VLE32_V }, // 2933
  { PseudoVLE32_V_M1_MASK, VLE32_V }, // 2934
  { PseudoVLE32_V_M2, VLE32_V }, // 2935
  { PseudoVLE32_V_M2_MASK, VLE32_V }, // 2936
  { PseudoVLE32_V_M4, VLE32_V }, // 2937
  { PseudoVLE32_V_M4_MASK, VLE32_V }, // 2938
  { PseudoVLE32_V_M8, VLE32_V }, // 2939
  { PseudoVLE32_V_M8_MASK, VLE32_V }, // 2940
  { PseudoVLE32_V_MF2, VLE32_V }, // 2941
  { PseudoVLE32_V_MF2_MASK, VLE32_V }, // 2942
  { PseudoVLE32_V_MF4, VLE32_V }, // 2943
  { PseudoVLE32_V_MF4_MASK, VLE32_V }, // 2944
  { PseudoVLE32_V_MF8, VLE32_V }, // 2945
  { PseudoVLE32_V_MF8_MASK, VLE32_V }, // 2946
  { PseudoVLE64FF_V_M1, VLE64FF_V }, // 2947
  { PseudoVLE64FF_V_M1_MASK, VLE64FF_V }, // 2948
  { PseudoVLE64FF_V_M2, VLE64FF_V }, // 2949
  { PseudoVLE64FF_V_M2_MASK, VLE64FF_V }, // 2950
  { PseudoVLE64FF_V_M4, VLE64FF_V }, // 2951
  { PseudoVLE64FF_V_M4_MASK, VLE64FF_V }, // 2952
  { PseudoVLE64FF_V_M8, VLE64FF_V }, // 2953
  { PseudoVLE64FF_V_M8_MASK, VLE64FF_V }, // 2954
  { PseudoVLE64FF_V_MF2, VLE64FF_V }, // 2955
  { PseudoVLE64FF_V_MF2_MASK, VLE64FF_V }, // 2956
  { PseudoVLE64FF_V_MF4, VLE64FF_V }, // 2957
  { PseudoVLE64FF_V_MF4_MASK, VLE64FF_V }, // 2958
  { PseudoVLE64FF_V_MF8, VLE64FF_V }, // 2959
  { PseudoVLE64FF_V_MF8_MASK, VLE64FF_V }, // 2960
  { PseudoVLE64_V_M1, VLE64_V }, // 2961
  { PseudoVLE64_V_M1_MASK, VLE64_V }, // 2962
  { PseudoVLE64_V_M2, VLE64_V }, // 2963
  { PseudoVLE64_V_M2_MASK, VLE64_V }, // 2964
  { PseudoVLE64_V_M4, VLE64_V }, // 2965
  { PseudoVLE64_V_M4_MASK, VLE64_V }, // 2966
  { PseudoVLE64_V_M8, VLE64_V }, // 2967
  { PseudoVLE64_V_M8_MASK, VLE64_V }, // 2968
  { PseudoVLE64_V_MF2, VLE64_V }, // 2969
  { PseudoVLE64_V_MF2_MASK, VLE64_V }, // 2970
  { PseudoVLE64_V_MF4, VLE64_V }, // 2971
  { PseudoVLE64_V_MF4_MASK, VLE64_V }, // 2972
  { PseudoVLE64_V_MF8, VLE64_V }, // 2973
  { PseudoVLE64_V_MF8_MASK, VLE64_V }, // 2974
  { PseudoVLE8FF_V_M1, VLE8FF_V }, // 2975
  { PseudoVLE8FF_V_M1_MASK, VLE8FF_V }, // 2976
  { PseudoVLE8FF_V_M2, VLE8FF_V }, // 2977
  { PseudoVLE8FF_V_M2_MASK, VLE8FF_V }, // 2978
  { PseudoVLE8FF_V_M4, VLE8FF_V }, // 2979
  { PseudoVLE8FF_V_M4_MASK, VLE8FF_V }, // 2980
  { PseudoVLE8FF_V_M8, VLE8FF_V }, // 2981
  { PseudoVLE8FF_V_M8_MASK, VLE8FF_V }, // 2982
  { PseudoVLE8FF_V_MF2, VLE8FF_V }, // 2983
  { PseudoVLE8FF_V_MF2_MASK, VLE8FF_V }, // 2984
  { PseudoVLE8FF_V_MF4, VLE8FF_V }, // 2985
  { PseudoVLE8FF_V_MF4_MASK, VLE8FF_V }, // 2986
  { PseudoVLE8FF_V_MF8, VLE8FF_V }, // 2987
  { PseudoVLE8FF_V_MF8_MASK, VLE8FF_V }, // 2988
  { PseudoVLE8_V_M1, VLE8_V }, // 2989
  { PseudoVLE8_V_M1_MASK, VLE8_V }, // 2990
  { PseudoVLE8_V_M2, VLE8_V }, // 2991
  { PseudoVLE8_V_M2_MASK, VLE8_V }, // 2992
  { PseudoVLE8_V_M4, VLE8_V }, // 2993
  { PseudoVLE8_V_M4_MASK, VLE8_V }, // 2994
  { PseudoVLE8_V_M8, VLE8_V }, // 2995
  { PseudoVLE8_V_M8_MASK, VLE8_V }, // 2996
  { PseudoVLE8_V_MF2, VLE8_V }, // 2997
  { PseudoVLE8_V_MF2_MASK, VLE8_V }, // 2998
  { PseudoVLE8_V_MF4, VLE8_V }, // 2999
  { PseudoVLE8_V_MF4_MASK, VLE8_V }, // 3000
  { PseudoVLE8_V_MF8, VLE8_V }, // 3001
  { PseudoVLE8_V_MF8_MASK, VLE8_V }, // 3002
  { PseudoVLOXEI16_V_M1_M1, VLOXEI16_V }, // 3003
  { PseudoVLOXEI16_V_M1_M1_MASK, VLOXEI16_V }, // 3004
  { PseudoVLOXEI16_V_M1_M2, VLOXEI16_V }, // 3005
  { PseudoVLOXEI16_V_M1_M2_MASK, VLOXEI16_V }, // 3006
  { PseudoVLOXEI16_V_M1_M4, VLOXEI16_V }, // 3007
  { PseudoVLOXEI16_V_M1_M4_MASK, VLOXEI16_V }, // 3008
  { PseudoVLOXEI16_V_M1_M8, VLOXEI16_V }, // 3009
  { PseudoVLOXEI16_V_M1_M8_MASK, VLOXEI16_V }, // 3010
  { PseudoVLOXEI16_V_M1_MF2, VLOXEI16_V }, // 3011
  { PseudoVLOXEI16_V_M1_MF2_MASK, VLOXEI16_V }, // 3012
  { PseudoVLOXEI16_V_M1_MF4, VLOXEI16_V }, // 3013
  { PseudoVLOXEI16_V_M1_MF4_MASK, VLOXEI16_V }, // 3014
  { PseudoVLOXEI16_V_M1_MF8, VLOXEI16_V }, // 3015
  { PseudoVLOXEI16_V_M1_MF8_MASK, VLOXEI16_V }, // 3016
  { PseudoVLOXEI16_V_M2_M1, VLOXEI16_V }, // 3017
  { PseudoVLOXEI16_V_M2_M1_MASK, VLOXEI16_V }, // 3018
  { PseudoVLOXEI16_V_M2_M2, VLOXEI16_V }, // 3019
  { PseudoVLOXEI16_V_M2_M2_MASK, VLOXEI16_V }, // 3020
  { PseudoVLOXEI16_V_M2_M4, VLOXEI16_V }, // 3021
  { PseudoVLOXEI16_V_M2_M4_MASK, VLOXEI16_V }, // 3022
  { PseudoVLOXEI16_V_M2_M8, VLOXEI16_V }, // 3023
  { PseudoVLOXEI16_V_M2_M8_MASK, VLOXEI16_V }, // 3024
  { PseudoVLOXEI16_V_M2_MF2, VLOXEI16_V }, // 3025
  { PseudoVLOXEI16_V_M2_MF2_MASK, VLOXEI16_V }, // 3026
  { PseudoVLOXEI16_V_M2_MF4, VLOXEI16_V }, // 3027
  { PseudoVLOXEI16_V_M2_MF4_MASK, VLOXEI16_V }, // 3028
  { PseudoVLOXEI16_V_M2_MF8, VLOXEI16_V }, // 3029
  { PseudoVLOXEI16_V_M2_MF8_MASK, VLOXEI16_V }, // 3030
  { PseudoVLOXEI16_V_M4_M1, VLOXEI16_V }, // 3031
  { PseudoVLOXEI16_V_M4_M1_MASK, VLOXEI16_V }, // 3032
  { PseudoVLOXEI16_V_M4_M2, VLOXEI16_V }, // 3033
  { PseudoVLOXEI16_V_M4_M2_MASK, VLOXEI16_V }, // 3034
  { PseudoVLOXEI16_V_M4_M4, VLOXEI16_V }, // 3035
  { PseudoVLOXEI16_V_M4_M4_MASK, VLOXEI16_V }, // 3036
  { PseudoVLOXEI16_V_M4_M8, VLOXEI16_V }, // 3037
  { PseudoVLOXEI16_V_M4_M8_MASK, VLOXEI16_V }, // 3038
  { PseudoVLOXEI16_V_M4_MF2, VLOXEI16_V }, // 3039
  { PseudoVLOXEI16_V_M4_MF2_MASK, VLOXEI16_V }, // 3040
  { PseudoVLOXEI16_V_M4_MF4, VLOXEI16_V }, // 3041
  { PseudoVLOXEI16_V_M4_MF4_MASK, VLOXEI16_V }, // 3042
  { PseudoVLOXEI16_V_M4_MF8, VLOXEI16_V }, // 3043
  { PseudoVLOXEI16_V_M4_MF8_MASK, VLOXEI16_V }, // 3044
  { PseudoVLOXEI16_V_M8_M1, VLOXEI16_V }, // 3045
  { PseudoVLOXEI16_V_M8_M1_MASK, VLOXEI16_V }, // 3046
  { PseudoVLOXEI16_V_M8_M2, VLOXEI16_V }, // 3047
  { PseudoVLOXEI16_V_M8_M2_MASK, VLOXEI16_V }, // 3048
  { PseudoVLOXEI16_V_M8_M4, VLOXEI16_V }, // 3049
  { PseudoVLOXEI16_V_M8_M4_MASK, VLOXEI16_V }, // 3050
  { PseudoVLOXEI16_V_M8_M8, VLOXEI16_V }, // 3051
  { PseudoVLOXEI16_V_M8_M8_MASK, VLOXEI16_V }, // 3052
  { PseudoVLOXEI16_V_M8_MF2, VLOXEI16_V }, // 3053
  { PseudoVLOXEI16_V_M8_MF2_MASK, VLOXEI16_V }, // 3054
  { PseudoVLOXEI16_V_M8_MF4, VLOXEI16_V }, // 3055
  { PseudoVLOXEI16_V_M8_MF4_MASK, VLOXEI16_V }, // 3056
  { PseudoVLOXEI16_V_M8_MF8, VLOXEI16_V }, // 3057
  { PseudoVLOXEI16_V_M8_MF8_MASK, VLOXEI16_V }, // 3058
  { PseudoVLOXEI16_V_MF2_M1, VLOXEI16_V }, // 3059
  { PseudoVLOXEI16_V_MF2_M1_MASK, VLOXEI16_V }, // 3060
  { PseudoVLOXEI16_V_MF2_M2, VLOXEI16_V }, // 3061
  { PseudoVLOXEI16_V_MF2_M2_MASK, VLOXEI16_V }, // 3062
  { PseudoVLOXEI16_V_MF2_M4, VLOXEI16_V }, // 3063
  { PseudoVLOXEI16_V_MF2_M4_MASK, VLOXEI16_V }, // 3064
  { PseudoVLOXEI16_V_MF2_M8, VLOXEI16_V }, // 3065
  { PseudoVLOXEI16_V_MF2_M8_MASK, VLOXEI16_V }, // 3066
  { PseudoVLOXEI16_V_MF2_MF2, VLOXEI16_V }, // 3067
  { PseudoVLOXEI16_V_MF2_MF2_MASK, VLOXEI16_V }, // 3068
  { PseudoVLOXEI16_V_MF2_MF4, VLOXEI16_V }, // 3069
  { PseudoVLOXEI16_V_MF2_MF4_MASK, VLOXEI16_V }, // 3070
  { PseudoVLOXEI16_V_MF2_MF8, VLOXEI16_V }, // 3071
  { PseudoVLOXEI16_V_MF2_MF8_MASK, VLOXEI16_V }, // 3072
  { PseudoVLOXEI16_V_MF4_M1, VLOXEI16_V }, // 3073
  { PseudoVLOXEI16_V_MF4_M1_MASK, VLOXEI16_V }, // 3074
  { PseudoVLOXEI16_V_MF4_M2, VLOXEI16_V }, // 3075
  { PseudoVLOXEI16_V_MF4_M2_MASK, VLOXEI16_V }, // 3076
  { PseudoVLOXEI16_V_MF4_M4, VLOXEI16_V }, // 3077
  { PseudoVLOXEI16_V_MF4_M4_MASK, VLOXEI16_V }, // 3078
  { PseudoVLOXEI16_V_MF4_M8, VLOXEI16_V }, // 3079
  { PseudoVLOXEI16_V_MF4_M8_MASK, VLOXEI16_V }, // 3080
  { PseudoVLOXEI16_V_MF4_MF2, VLOXEI16_V }, // 3081
  { PseudoVLOXEI16_V_MF4_MF2_MASK, VLOXEI16_V }, // 3082
  { PseudoVLOXEI16_V_MF4_MF4, VLOXEI16_V }, // 3083
  { PseudoVLOXEI16_V_MF4_MF4_MASK, VLOXEI16_V }, // 3084
  { PseudoVLOXEI16_V_MF4_MF8, VLOXEI16_V }, // 3085
  { PseudoVLOXEI16_V_MF4_MF8_MASK, VLOXEI16_V }, // 3086
  { PseudoVLOXEI16_V_MF8_M1, VLOXEI16_V }, // 3087
  { PseudoVLOXEI16_V_MF8_M1_MASK, VLOXEI16_V }, // 3088
  { PseudoVLOXEI16_V_MF8_M2, VLOXEI16_V }, // 3089
  { PseudoVLOXEI16_V_MF8_M2_MASK, VLOXEI16_V }, // 3090
  { PseudoVLOXEI16_V_MF8_M4, VLOXEI16_V }, // 3091
  { PseudoVLOXEI16_V_MF8_M4_MASK, VLOXEI16_V }, // 3092
  { PseudoVLOXEI16_V_MF8_M8, VLOXEI16_V }, // 3093
  { PseudoVLOXEI16_V_MF8_M8_MASK, VLOXEI16_V }, // 3094
  { PseudoVLOXEI16_V_MF8_MF2, VLOXEI16_V }, // 3095
  { PseudoVLOXEI16_V_MF8_MF2_MASK, VLOXEI16_V }, // 3096
  { PseudoVLOXEI16_V_MF8_MF4, VLOXEI16_V }, // 3097
  { PseudoVLOXEI16_V_MF8_MF4_MASK, VLOXEI16_V }, // 3098
  { PseudoVLOXEI16_V_MF8_MF8, VLOXEI16_V }, // 3099
  { PseudoVLOXEI16_V_MF8_MF8_MASK, VLOXEI16_V }, // 3100
  { PseudoVLOXEI32_V_M1_M1, VLOXEI32_V }, // 3101
  { PseudoVLOXEI32_V_M1_M1_MASK, VLOXEI32_V }, // 3102
  { PseudoVLOXEI32_V_M1_M2, VLOXEI32_V }, // 3103
  { PseudoVLOXEI32_V_M1_M2_MASK, VLOXEI32_V }, // 3104
  { PseudoVLOXEI32_V_M1_M4, VLOXEI32_V }, // 3105
  { PseudoVLOXEI32_V_M1_M4_MASK, VLOXEI32_V }, // 3106
  { PseudoVLOXEI32_V_M1_M8, VLOXEI32_V }, // 3107
  { PseudoVLOXEI32_V_M1_M8_MASK, VLOXEI32_V }, // 3108
  { PseudoVLOXEI32_V_M1_MF2, VLOXEI32_V }, // 3109
  { PseudoVLOXEI32_V_M1_MF2_MASK, VLOXEI32_V }, // 3110
  { PseudoVLOXEI32_V_M1_MF4, VLOXEI32_V }, // 3111
  { PseudoVLOXEI32_V_M1_MF4_MASK, VLOXEI32_V }, // 3112
  { PseudoVLOXEI32_V_M1_MF8, VLOXEI32_V }, // 3113
  { PseudoVLOXEI32_V_M1_MF8_MASK, VLOXEI32_V }, // 3114
  { PseudoVLOXEI32_V_M2_M1, VLOXEI32_V }, // 3115
  { PseudoVLOXEI32_V_M2_M1_MASK, VLOXEI32_V }, // 3116
  { PseudoVLOXEI32_V_M2_M2, VLOXEI32_V }, // 3117
  { PseudoVLOXEI32_V_M2_M2_MASK, VLOXEI32_V }, // 3118
  { PseudoVLOXEI32_V_M2_M4, VLOXEI32_V }, // 3119
  { PseudoVLOXEI32_V_M2_M4_MASK, VLOXEI32_V }, // 3120
  { PseudoVLOXEI32_V_M2_M8, VLOXEI32_V }, // 3121
  { PseudoVLOXEI32_V_M2_M8_MASK, VLOXEI32_V }, // 3122
  { PseudoVLOXEI32_V_M2_MF2, VLOXEI32_V }, // 3123
  { PseudoVLOXEI32_V_M2_MF2_MASK, VLOXEI32_V }, // 3124
  { PseudoVLOXEI32_V_M2_MF4, VLOXEI32_V }, // 3125
  { PseudoVLOXEI32_V_M2_MF4_MASK, VLOXEI32_V }, // 3126
  { PseudoVLOXEI32_V_M2_MF8, VLOXEI32_V }, // 3127
  { PseudoVLOXEI32_V_M2_MF8_MASK, VLOXEI32_V }, // 3128
  { PseudoVLOXEI32_V_M4_M1, VLOXEI32_V }, // 3129
  { PseudoVLOXEI32_V_M4_M1_MASK, VLOXEI32_V }, // 3130
  { PseudoVLOXEI32_V_M4_M2, VLOXEI32_V }, // 3131
  { PseudoVLOXEI32_V_M4_M2_MASK, VLOXEI32_V }, // 3132
  { PseudoVLOXEI32_V_M4_M4, VLOXEI32_V }, // 3133
  { PseudoVLOXEI32_V_M4_M4_MASK, VLOXEI32_V }, // 3134
  { PseudoVLOXEI32_V_M4_M8, VLOXEI32_V }, // 3135
  { PseudoVLOXEI32_V_M4_M8_MASK, VLOXEI32_V }, // 3136
  { PseudoVLOXEI32_V_M4_MF2, VLOXEI32_V }, // 3137
  { PseudoVLOXEI32_V_M4_MF2_MASK, VLOXEI32_V }, // 3138
  { PseudoVLOXEI32_V_M4_MF4, VLOXEI32_V }, // 3139
  { PseudoVLOXEI32_V_M4_MF4_MASK, VLOXEI32_V }, // 3140
  { PseudoVLOXEI32_V_M4_MF8, VLOXEI32_V }, // 3141
  { PseudoVLOXEI32_V_M4_MF8_MASK, VLOXEI32_V }, // 3142
  { PseudoVLOXEI32_V_M8_M1, VLOXEI32_V }, // 3143
  { PseudoVLOXEI32_V_M8_M1_MASK, VLOXEI32_V }, // 3144
  { PseudoVLOXEI32_V_M8_M2, VLOXEI32_V }, // 3145
  { PseudoVLOXEI32_V_M8_M2_MASK, VLOXEI32_V }, // 3146
  { PseudoVLOXEI32_V_M8_M4, VLOXEI32_V }, // 3147
  { PseudoVLOXEI32_V_M8_M4_MASK, VLOXEI32_V }, // 3148
  { PseudoVLOXEI32_V_M8_M8, VLOXEI32_V }, // 3149
  { PseudoVLOXEI32_V_M8_M8_MASK, VLOXEI32_V }, // 3150
  { PseudoVLOXEI32_V_M8_MF2, VLOXEI32_V }, // 3151
  { PseudoVLOXEI32_V_M8_MF2_MASK, VLOXEI32_V }, // 3152
  { PseudoVLOXEI32_V_M8_MF4, VLOXEI32_V }, // 3153
  { PseudoVLOXEI32_V_M8_MF4_MASK, VLOXEI32_V }, // 3154
  { PseudoVLOXEI32_V_M8_MF8, VLOXEI32_V }, // 3155
  { PseudoVLOXEI32_V_M8_MF8_MASK, VLOXEI32_V }, // 3156
  { PseudoVLOXEI32_V_MF2_M1, VLOXEI32_V }, // 3157
  { PseudoVLOXEI32_V_MF2_M1_MASK, VLOXEI32_V }, // 3158
  { PseudoVLOXEI32_V_MF2_M2, VLOXEI32_V }, // 3159
  { PseudoVLOXEI32_V_MF2_M2_MASK, VLOXEI32_V }, // 3160
  { PseudoVLOXEI32_V_MF2_M4, VLOXEI32_V }, // 3161
  { PseudoVLOXEI32_V_MF2_M4_MASK, VLOXEI32_V }, // 3162
  { PseudoVLOXEI32_V_MF2_M8, VLOXEI32_V }, // 3163
  { PseudoVLOXEI32_V_MF2_M8_MASK, VLOXEI32_V }, // 3164
  { PseudoVLOXEI32_V_MF2_MF2, VLOXEI32_V }, // 3165
  { PseudoVLOXEI32_V_MF2_MF2_MASK, VLOXEI32_V }, // 3166
  { PseudoVLOXEI32_V_MF2_MF4, VLOXEI32_V }, // 3167
  { PseudoVLOXEI32_V_MF2_MF4_MASK, VLOXEI32_V }, // 3168
  { PseudoVLOXEI32_V_MF2_MF8, VLOXEI32_V }, // 3169
  { PseudoVLOXEI32_V_MF2_MF8_MASK, VLOXEI32_V }, // 3170
  { PseudoVLOXEI32_V_MF4_M1, VLOXEI32_V }, // 3171
  { PseudoVLOXEI32_V_MF4_M1_MASK, VLOXEI32_V }, // 3172
  { PseudoVLOXEI32_V_MF4_M2, VLOXEI32_V }, // 3173
  { PseudoVLOXEI32_V_MF4_M2_MASK, VLOXEI32_V }, // 3174
  { PseudoVLOXEI32_V_MF4_M4, VLOXEI32_V }, // 3175
  { PseudoVLOXEI32_V_MF4_M4_MASK, VLOXEI32_V }, // 3176
  { PseudoVLOXEI32_V_MF4_M8, VLOXEI32_V }, // 3177
  { PseudoVLOXEI32_V_MF4_M8_MASK, VLOXEI32_V }, // 3178
  { PseudoVLOXEI32_V_MF4_MF2, VLOXEI32_V }, // 3179
  { PseudoVLOXEI32_V_MF4_MF2_MASK, VLOXEI32_V }, // 3180
  { PseudoVLOXEI32_V_MF4_MF4, VLOXEI32_V }, // 3181
  { PseudoVLOXEI32_V_MF4_MF4_MASK, VLOXEI32_V }, // 3182
  { PseudoVLOXEI32_V_MF4_MF8, VLOXEI32_V }, // 3183
  { PseudoVLOXEI32_V_MF4_MF8_MASK, VLOXEI32_V }, // 3184
  { PseudoVLOXEI32_V_MF8_M1, VLOXEI32_V }, // 3185
  { PseudoVLOXEI32_V_MF8_M1_MASK, VLOXEI32_V }, // 3186
  { PseudoVLOXEI32_V_MF8_M2, VLOXEI32_V }, // 3187
  { PseudoVLOXEI32_V_MF8_M2_MASK, VLOXEI32_V }, // 3188
  { PseudoVLOXEI32_V_MF8_M4, VLOXEI32_V }, // 3189
  { PseudoVLOXEI32_V_MF8_M4_MASK, VLOXEI32_V }, // 3190
  { PseudoVLOXEI32_V_MF8_M8, VLOXEI32_V }, // 3191
  { PseudoVLOXEI32_V_MF8_M8_MASK, VLOXEI32_V }, // 3192
  { PseudoVLOXEI32_V_MF8_MF2, VLOXEI32_V }, // 3193
  { PseudoVLOXEI32_V_MF8_MF2_MASK, VLOXEI32_V }, // 3194
  { PseudoVLOXEI32_V_MF8_MF4, VLOXEI32_V }, // 3195
  { PseudoVLOXEI32_V_MF8_MF4_MASK, VLOXEI32_V }, // 3196
  { PseudoVLOXEI32_V_MF8_MF8, VLOXEI32_V }, // 3197
  { PseudoVLOXEI32_V_MF8_MF8_MASK, VLOXEI32_V }, // 3198
  { PseudoVLOXEI64_V_M1_M1, VLOXEI64_V }, // 3199
  { PseudoVLOXEI64_V_M1_M1_MASK, VLOXEI64_V }, // 3200
  { PseudoVLOXEI64_V_M1_M2, VLOXEI64_V }, // 3201
  { PseudoVLOXEI64_V_M1_M2_MASK, VLOXEI64_V }, // 3202
  { PseudoVLOXEI64_V_M1_M4, VLOXEI64_V }, // 3203
  { PseudoVLOXEI64_V_M1_M4_MASK, VLOXEI64_V }, // 3204
  { PseudoVLOXEI64_V_M1_M8, VLOXEI64_V }, // 3205
  { PseudoVLOXEI64_V_M1_M8_MASK, VLOXEI64_V }, // 3206
  { PseudoVLOXEI64_V_M1_MF2, VLOXEI64_V }, // 3207
  { PseudoVLOXEI64_V_M1_MF2_MASK, VLOXEI64_V }, // 3208
  { PseudoVLOXEI64_V_M1_MF4, VLOXEI64_V }, // 3209
  { PseudoVLOXEI64_V_M1_MF4_MASK, VLOXEI64_V }, // 3210
  { PseudoVLOXEI64_V_M1_MF8, VLOXEI64_V }, // 3211
  { PseudoVLOXEI64_V_M1_MF8_MASK, VLOXEI64_V }, // 3212
  { PseudoVLOXEI64_V_M2_M1, VLOXEI64_V }, // 3213
  { PseudoVLOXEI64_V_M2_M1_MASK, VLOXEI64_V }, // 3214
  { PseudoVLOXEI64_V_M2_M2, VLOXEI64_V }, // 3215
  { PseudoVLOXEI64_V_M2_M2_MASK, VLOXEI64_V }, // 3216
  { PseudoVLOXEI64_V_M2_M4, VLOXEI64_V }, // 3217
  { PseudoVLOXEI64_V_M2_M4_MASK, VLOXEI64_V }, // 3218
  { PseudoVLOXEI64_V_M2_M8, VLOXEI64_V }, // 3219
  { PseudoVLOXEI64_V_M2_M8_MASK, VLOXEI64_V }, // 3220
  { PseudoVLOXEI64_V_M2_MF2, VLOXEI64_V }, // 3221
  { PseudoVLOXEI64_V_M2_MF2_MASK, VLOXEI64_V }, // 3222
  { PseudoVLOXEI64_V_M2_MF4, VLOXEI64_V }, // 3223
  { PseudoVLOXEI64_V_M2_MF4_MASK, VLOXEI64_V }, // 3224
  { PseudoVLOXEI64_V_M2_MF8, VLOXEI64_V }, // 3225
  { PseudoVLOXEI64_V_M2_MF8_MASK, VLOXEI64_V }, // 3226
  { PseudoVLOXEI64_V_M4_M1, VLOXEI64_V }, // 3227
  { PseudoVLOXEI64_V_M4_M1_MASK, VLOXEI64_V }, // 3228
  { PseudoVLOXEI64_V_M4_M2, VLOXEI64_V }, // 3229
  { PseudoVLOXEI64_V_M4_M2_MASK, VLOXEI64_V }, // 3230
  { PseudoVLOXEI64_V_M4_M4, VLOXEI64_V }, // 3231
  { PseudoVLOXEI64_V_M4_M4_MASK, VLOXEI64_V }, // 3232
  { PseudoVLOXEI64_V_M4_M8, VLOXEI64_V }, // 3233
  { PseudoVLOXEI64_V_M4_M8_MASK, VLOXEI64_V }, // 3234
  { PseudoVLOXEI64_V_M4_MF2, VLOXEI64_V }, // 3235
  { PseudoVLOXEI64_V_M4_MF2_MASK, VLOXEI64_V }, // 3236
  { PseudoVLOXEI64_V_M4_MF4, VLOXEI64_V }, // 3237
  { PseudoVLOXEI64_V_M4_MF4_MASK, VLOXEI64_V }, // 3238
  { PseudoVLOXEI64_V_M4_MF8, VLOXEI64_V }, // 3239
  { PseudoVLOXEI64_V_M4_MF8_MASK, VLOXEI64_V }, // 3240
  { PseudoVLOXEI64_V_M8_M1, VLOXEI64_V }, // 3241
  { PseudoVLOXEI64_V_M8_M1_MASK, VLOXEI64_V }, // 3242
  { PseudoVLOXEI64_V_M8_M2, VLOXEI64_V }, // 3243
  { PseudoVLOXEI64_V_M8_M2_MASK, VLOXEI64_V }, // 3244
  { PseudoVLOXEI64_V_M8_M4, VLOXEI64_V }, // 3245
  { PseudoVLOXEI64_V_M8_M4_MASK, VLOXEI64_V }, // 3246
  { PseudoVLOXEI64_V_M8_M8, VLOXEI64_V }, // 3247
  { PseudoVLOXEI64_V_M8_M8_MASK, VLOXEI64_V }, // 3248
  { PseudoVLOXEI64_V_M8_MF2, VLOXEI64_V }, // 3249
  { PseudoVLOXEI64_V_M8_MF2_MASK, VLOXEI64_V }, // 3250
  { PseudoVLOXEI64_V_M8_MF4, VLOXEI64_V }, // 3251
  { PseudoVLOXEI64_V_M8_MF4_MASK, VLOXEI64_V }, // 3252
  { PseudoVLOXEI64_V_M8_MF8, VLOXEI64_V }, // 3253
  { PseudoVLOXEI64_V_M8_MF8_MASK, VLOXEI64_V }, // 3254
  { PseudoVLOXEI64_V_MF2_M1, VLOXEI64_V }, // 3255
  { PseudoVLOXEI64_V_MF2_M1_MASK, VLOXEI64_V }, // 3256
  { PseudoVLOXEI64_V_MF2_M2, VLOXEI64_V }, // 3257
  { PseudoVLOXEI64_V_MF2_M2_MASK, VLOXEI64_V }, // 3258
  { PseudoVLOXEI64_V_MF2_M4, VLOXEI64_V }, // 3259
  { PseudoVLOXEI64_V_MF2_M4_MASK, VLOXEI64_V }, // 3260
  { PseudoVLOXEI64_V_MF2_M8, VLOXEI64_V }, // 3261
  { PseudoVLOXEI64_V_MF2_M8_MASK, VLOXEI64_V }, // 3262
  { PseudoVLOXEI64_V_MF2_MF2, VLOXEI64_V }, // 3263
  { PseudoVLOXEI64_V_MF2_MF2_MASK, VLOXEI64_V }, // 3264
  { PseudoVLOXEI64_V_MF2_MF4, VLOXEI64_V }, // 3265
  { PseudoVLOXEI64_V_MF2_MF4_MASK, VLOXEI64_V }, // 3266
  { PseudoVLOXEI64_V_MF2_MF8, VLOXEI64_V }, // 3267
  { PseudoVLOXEI64_V_MF2_MF8_MASK, VLOXEI64_V }, // 3268
  { PseudoVLOXEI64_V_MF4_M1, VLOXEI64_V }, // 3269
  { PseudoVLOXEI64_V_MF4_M1_MASK, VLOXEI64_V }, // 3270
  { PseudoVLOXEI64_V_MF4_M2, VLOXEI64_V }, // 3271
  { PseudoVLOXEI64_V_MF4_M2_MASK, VLOXEI64_V }, // 3272
  { PseudoVLOXEI64_V_MF4_M4, VLOXEI64_V }, // 3273
  { PseudoVLOXEI64_V_MF4_M4_MASK, VLOXEI64_V }, // 3274
  { PseudoVLOXEI64_V_MF4_M8, VLOXEI64_V }, // 3275
  { PseudoVLOXEI64_V_MF4_M8_MASK, VLOXEI64_V }, // 3276
  { PseudoVLOXEI64_V_MF4_MF2, VLOXEI64_V }, // 3277
  { PseudoVLOXEI64_V_MF4_MF2_MASK, VLOXEI64_V }, // 3278
  { PseudoVLOXEI64_V_MF4_MF4, VLOXEI64_V }, // 3279
  { PseudoVLOXEI64_V_MF4_MF4_MASK, VLOXEI64_V }, // 3280
  { PseudoVLOXEI64_V_MF4_MF8, VLOXEI64_V }, // 3281
  { PseudoVLOXEI64_V_MF4_MF8_MASK, VLOXEI64_V }, // 3282
  { PseudoVLOXEI64_V_MF8_M1, VLOXEI64_V }, // 3283
  { PseudoVLOXEI64_V_MF8_M1_MASK, VLOXEI64_V }, // 3284
  { PseudoVLOXEI64_V_MF8_M2, VLOXEI64_V }, // 3285
  { PseudoVLOXEI64_V_MF8_M2_MASK, VLOXEI64_V }, // 3286
  { PseudoVLOXEI64_V_MF8_M4, VLOXEI64_V }, // 3287
  { PseudoVLOXEI64_V_MF8_M4_MASK, VLOXEI64_V }, // 3288
  { PseudoVLOXEI64_V_MF8_M8, VLOXEI64_V }, // 3289
  { PseudoVLOXEI64_V_MF8_M8_MASK, VLOXEI64_V }, // 3290
  { PseudoVLOXEI64_V_MF8_MF2, VLOXEI64_V }, // 3291
  { PseudoVLOXEI64_V_MF8_MF2_MASK, VLOXEI64_V }, // 3292
  { PseudoVLOXEI64_V_MF8_MF4, VLOXEI64_V }, // 3293
  { PseudoVLOXEI64_V_MF8_MF4_MASK, VLOXEI64_V }, // 3294
  { PseudoVLOXEI64_V_MF8_MF8, VLOXEI64_V }, // 3295
  { PseudoVLOXEI64_V_MF8_MF8_MASK, VLOXEI64_V }, // 3296
  { PseudoVLOXEI8_V_M1_M1, VLOXEI8_V }, // 3297
  { PseudoVLOXEI8_V_M1_M1_MASK, VLOXEI8_V }, // 3298
  { PseudoVLOXEI8_V_M1_M2, VLOXEI8_V }, // 3299
  { PseudoVLOXEI8_V_M1_M2_MASK, VLOXEI8_V }, // 3300
  { PseudoVLOXEI8_V_M1_M4, VLOXEI8_V }, // 3301
  { PseudoVLOXEI8_V_M1_M4_MASK, VLOXEI8_V }, // 3302
  { PseudoVLOXEI8_V_M1_M8, VLOXEI8_V }, // 3303
  { PseudoVLOXEI8_V_M1_M8_MASK, VLOXEI8_V }, // 3304
  { PseudoVLOXEI8_V_M1_MF2, VLOXEI8_V }, // 3305
  { PseudoVLOXEI8_V_M1_MF2_MASK, VLOXEI8_V }, // 3306
  { PseudoVLOXEI8_V_M1_MF4, VLOXEI8_V }, // 3307
  { PseudoVLOXEI8_V_M1_MF4_MASK, VLOXEI8_V }, // 3308
  { PseudoVLOXEI8_V_M1_MF8, VLOXEI8_V }, // 3309
  { PseudoVLOXEI8_V_M1_MF8_MASK, VLOXEI8_V }, // 3310
  { PseudoVLOXEI8_V_M2_M1, VLOXEI8_V }, // 3311
  { PseudoVLOXEI8_V_M2_M1_MASK, VLOXEI8_V }, // 3312
  { PseudoVLOXEI8_V_M2_M2, VLOXEI8_V }, // 3313
  { PseudoVLOXEI8_V_M2_M2_MASK, VLOXEI8_V }, // 3314
  { PseudoVLOXEI8_V_M2_M4, VLOXEI8_V }, // 3315
  { PseudoVLOXEI8_V_M2_M4_MASK, VLOXEI8_V }, // 3316
  { PseudoVLOXEI8_V_M2_M8, VLOXEI8_V }, // 3317
  { PseudoVLOXEI8_V_M2_M8_MASK, VLOXEI8_V }, // 3318
  { PseudoVLOXEI8_V_M2_MF2, VLOXEI8_V }, // 3319
  { PseudoVLOXEI8_V_M2_MF2_MASK, VLOXEI8_V }, // 3320
  { PseudoVLOXEI8_V_M2_MF4, VLOXEI8_V }, // 3321
  { PseudoVLOXEI8_V_M2_MF4_MASK, VLOXEI8_V }, // 3322
  { PseudoVLOXEI8_V_M2_MF8, VLOXEI8_V }, // 3323
  { PseudoVLOXEI8_V_M2_MF8_MASK, VLOXEI8_V }, // 3324
  { PseudoVLOXEI8_V_M4_M1, VLOXEI8_V }, // 3325
  { PseudoVLOXEI8_V_M4_M1_MASK, VLOXEI8_V }, // 3326
  { PseudoVLOXEI8_V_M4_M2, VLOXEI8_V }, // 3327
  { PseudoVLOXEI8_V_M4_M2_MASK, VLOXEI8_V }, // 3328
  { PseudoVLOXEI8_V_M4_M4, VLOXEI8_V }, // 3329
  { PseudoVLOXEI8_V_M4_M4_MASK, VLOXEI8_V }, // 3330
  { PseudoVLOXEI8_V_M4_M8, VLOXEI8_V }, // 3331
  { PseudoVLOXEI8_V_M4_M8_MASK, VLOXEI8_V }, // 3332
  { PseudoVLOXEI8_V_M4_MF2, VLOXEI8_V }, // 3333
  { PseudoVLOXEI8_V_M4_MF2_MASK, VLOXEI8_V }, // 3334
  { PseudoVLOXEI8_V_M4_MF4, VLOXEI8_V }, // 3335
  { PseudoVLOXEI8_V_M4_MF4_MASK, VLOXEI8_V }, // 3336
  { PseudoVLOXEI8_V_M4_MF8, VLOXEI8_V }, // 3337
  { PseudoVLOXEI8_V_M4_MF8_MASK, VLOXEI8_V }, // 3338
  { PseudoVLOXEI8_V_M8_M1, VLOXEI8_V }, // 3339
  { PseudoVLOXEI8_V_M8_M1_MASK, VLOXEI8_V }, // 3340
  { PseudoVLOXEI8_V_M8_M2, VLOXEI8_V }, // 3341
  { PseudoVLOXEI8_V_M8_M2_MASK, VLOXEI8_V }, // 3342
  { PseudoVLOXEI8_V_M8_M4, VLOXEI8_V }, // 3343
  { PseudoVLOXEI8_V_M8_M4_MASK, VLOXEI8_V }, // 3344
  { PseudoVLOXEI8_V_M8_M8, VLOXEI8_V }, // 3345
  { PseudoVLOXEI8_V_M8_M8_MASK, VLOXEI8_V }, // 3346
  { PseudoVLOXEI8_V_M8_MF2, VLOXEI8_V }, // 3347
  { PseudoVLOXEI8_V_M8_MF2_MASK, VLOXEI8_V }, // 3348
  { PseudoVLOXEI8_V_M8_MF4, VLOXEI8_V }, // 3349
  { PseudoVLOXEI8_V_M8_MF4_MASK, VLOXEI8_V }, // 3350
  { PseudoVLOXEI8_V_M8_MF8, VLOXEI8_V }, // 3351
  { PseudoVLOXEI8_V_M8_MF8_MASK, VLOXEI8_V }, // 3352
  { PseudoVLOXEI8_V_MF2_M1, VLOXEI8_V }, // 3353
  { PseudoVLOXEI8_V_MF2_M1_MASK, VLOXEI8_V }, // 3354
  { PseudoVLOXEI8_V_MF2_M2, VLOXEI8_V }, // 3355
  { PseudoVLOXEI8_V_MF2_M2_MASK, VLOXEI8_V }, // 3356
  { PseudoVLOXEI8_V_MF2_M4, VLOXEI8_V }, // 3357
  { PseudoVLOXEI8_V_MF2_M4_MASK, VLOXEI8_V }, // 3358
  { PseudoVLOXEI8_V_MF2_M8, VLOXEI8_V }, // 3359
  { PseudoVLOXEI8_V_MF2_M8_MASK, VLOXEI8_V }, // 3360
  { PseudoVLOXEI8_V_MF2_MF2, VLOXEI8_V }, // 3361
  { PseudoVLOXEI8_V_MF2_MF2_MASK, VLOXEI8_V }, // 3362
  { PseudoVLOXEI8_V_MF2_MF4, VLOXEI8_V }, // 3363
  { PseudoVLOXEI8_V_MF2_MF4_MASK, VLOXEI8_V }, // 3364
  { PseudoVLOXEI8_V_MF2_MF8, VLOXEI8_V }, // 3365
  { PseudoVLOXEI8_V_MF2_MF8_MASK, VLOXEI8_V }, // 3366
  { PseudoVLOXEI8_V_MF4_M1, VLOXEI8_V }, // 3367
  { PseudoVLOXEI8_V_MF4_M1_MASK, VLOXEI8_V }, // 3368
  { PseudoVLOXEI8_V_MF4_M2, VLOXEI8_V }, // 3369
  { PseudoVLOXEI8_V_MF4_M2_MASK, VLOXEI8_V }, // 3370
  { PseudoVLOXEI8_V_MF4_M4, VLOXEI8_V }, // 3371
  { PseudoVLOXEI8_V_MF4_M4_MASK, VLOXEI8_V }, // 3372
  { PseudoVLOXEI8_V_MF4_M8, VLOXEI8_V }, // 3373
  { PseudoVLOXEI8_V_MF4_M8_MASK, VLOXEI8_V }, // 3374
  { PseudoVLOXEI8_V_MF4_MF2, VLOXEI8_V }, // 3375
  { PseudoVLOXEI8_V_MF4_MF2_MASK, VLOXEI8_V }, // 3376
  { PseudoVLOXEI8_V_MF4_MF4, VLOXEI8_V }, // 3377
  { PseudoVLOXEI8_V_MF4_MF4_MASK, VLOXEI8_V }, // 3378
  { PseudoVLOXEI8_V_MF4_MF8, VLOXEI8_V }, // 3379
  { PseudoVLOXEI8_V_MF4_MF8_MASK, VLOXEI8_V }, // 3380
  { PseudoVLOXEI8_V_MF8_M1, VLOXEI8_V }, // 3381
  { PseudoVLOXEI8_V_MF8_M1_MASK, VLOXEI8_V }, // 3382
  { PseudoVLOXEI8_V_MF8_M2, VLOXEI8_V }, // 3383
  { PseudoVLOXEI8_V_MF8_M2_MASK, VLOXEI8_V }, // 3384
  { PseudoVLOXEI8_V_MF8_M4, VLOXEI8_V }, // 3385
  { PseudoVLOXEI8_V_MF8_M4_MASK, VLOXEI8_V }, // 3386
  { PseudoVLOXEI8_V_MF8_M8, VLOXEI8_V }, // 3387
  { PseudoVLOXEI8_V_MF8_M8_MASK, VLOXEI8_V }, // 3388
  { PseudoVLOXEI8_V_MF8_MF2, VLOXEI8_V }, // 3389
  { PseudoVLOXEI8_V_MF8_MF2_MASK, VLOXEI8_V }, // 3390
  { PseudoVLOXEI8_V_MF8_MF4, VLOXEI8_V }, // 3391
  { PseudoVLOXEI8_V_MF8_MF4_MASK, VLOXEI8_V }, // 3392
  { PseudoVLOXEI8_V_MF8_MF8, VLOXEI8_V }, // 3393
  { PseudoVLOXEI8_V_MF8_MF8_MASK, VLOXEI8_V }, // 3394
  { PseudoVLOXSEG2EI16_V_M1_M1, VLOXSEG2EI16_V }, // 3395
  { PseudoVLOXSEG2EI16_V_M1_M1_MASK, VLOXSEG2EI16_V }, // 3396
  { PseudoVLOXSEG2EI16_V_M1_M2, VLOXSEG2EI16_V }, // 3397
  { PseudoVLOXSEG2EI16_V_M1_M2_MASK, VLOXSEG2EI16_V }, // 3398
  { PseudoVLOXSEG2EI16_V_M1_M4, VLOXSEG2EI16_V }, // 3399
  { PseudoVLOXSEG2EI16_V_M1_M4_MASK, VLOXSEG2EI16_V }, // 3400
  { PseudoVLOXSEG2EI16_V_M1_MF2, VLOXSEG2EI16_V }, // 3401
  { PseudoVLOXSEG2EI16_V_M1_MF2_MASK, VLOXSEG2EI16_V }, // 3402
  { PseudoVLOXSEG2EI16_V_M1_MF4, VLOXSEG2EI16_V }, // 3403
  { PseudoVLOXSEG2EI16_V_M1_MF4_MASK, VLOXSEG2EI16_V }, // 3404
  { PseudoVLOXSEG2EI16_V_M1_MF8, VLOXSEG2EI16_V }, // 3405
  { PseudoVLOXSEG2EI16_V_M1_MF8_MASK, VLOXSEG2EI16_V }, // 3406
  { PseudoVLOXSEG2EI16_V_M2_M1, VLOXSEG2EI16_V }, // 3407
  { PseudoVLOXSEG2EI16_V_M2_M1_MASK, VLOXSEG2EI16_V }, // 3408
  { PseudoVLOXSEG2EI16_V_M2_M2, VLOXSEG2EI16_V }, // 3409
  { PseudoVLOXSEG2EI16_V_M2_M2_MASK, VLOXSEG2EI16_V }, // 3410
  { PseudoVLOXSEG2EI16_V_M2_M4, VLOXSEG2EI16_V }, // 3411
  { PseudoVLOXSEG2EI16_V_M2_M4_MASK, VLOXSEG2EI16_V }, // 3412
  { PseudoVLOXSEG2EI16_V_M2_MF2, VLOXSEG2EI16_V }, // 3413
  { PseudoVLOXSEG2EI16_V_M2_MF2_MASK, VLOXSEG2EI16_V }, // 3414
  { PseudoVLOXSEG2EI16_V_M2_MF4, VLOXSEG2EI16_V }, // 3415
  { PseudoVLOXSEG2EI16_V_M2_MF4_MASK, VLOXSEG2EI16_V }, // 3416
  { PseudoVLOXSEG2EI16_V_M2_MF8, VLOXSEG2EI16_V }, // 3417
  { PseudoVLOXSEG2EI16_V_M2_MF8_MASK, VLOXSEG2EI16_V }, // 3418
  { PseudoVLOXSEG2EI16_V_M4_M1, VLOXSEG2EI16_V }, // 3419
  { PseudoVLOXSEG2EI16_V_M4_M1_MASK, VLOXSEG2EI16_V }, // 3420
  { PseudoVLOXSEG2EI16_V_M4_M2, VLOXSEG2EI16_V }, // 3421
  { PseudoVLOXSEG2EI16_V_M4_M2_MASK, VLOXSEG2EI16_V }, // 3422
  { PseudoVLOXSEG2EI16_V_M4_M4, VLOXSEG2EI16_V }, // 3423
  { PseudoVLOXSEG2EI16_V_M4_M4_MASK, VLOXSEG2EI16_V }, // 3424
  { PseudoVLOXSEG2EI16_V_M4_MF2, VLOXSEG2EI16_V }, // 3425
  { PseudoVLOXSEG2EI16_V_M4_MF2_MASK, VLOXSEG2EI16_V }, // 3426
  { PseudoVLOXSEG2EI16_V_M4_MF4, VLOXSEG2EI16_V }, // 3427
  { PseudoVLOXSEG2EI16_V_M4_MF4_MASK, VLOXSEG2EI16_V }, // 3428
  { PseudoVLOXSEG2EI16_V_M4_MF8, VLOXSEG2EI16_V }, // 3429
  { PseudoVLOXSEG2EI16_V_M4_MF8_MASK, VLOXSEG2EI16_V }, // 3430
  { PseudoVLOXSEG2EI16_V_M8_M1, VLOXSEG2EI16_V }, // 3431
  { PseudoVLOXSEG2EI16_V_M8_M1_MASK, VLOXSEG2EI16_V }, // 3432
  { PseudoVLOXSEG2EI16_V_M8_M2, VLOXSEG2EI16_V }, // 3433
  { PseudoVLOXSEG2EI16_V_M8_M2_MASK, VLOXSEG2EI16_V }, // 3434
  { PseudoVLOXSEG2EI16_V_M8_M4, VLOXSEG2EI16_V }, // 3435
  { PseudoVLOXSEG2EI16_V_M8_M4_MASK, VLOXSEG2EI16_V }, // 3436
  { PseudoVLOXSEG2EI16_V_M8_MF2, VLOXSEG2EI16_V }, // 3437
  { PseudoVLOXSEG2EI16_V_M8_MF2_MASK, VLOXSEG2EI16_V }, // 3438
  { PseudoVLOXSEG2EI16_V_M8_MF4, VLOXSEG2EI16_V }, // 3439
  { PseudoVLOXSEG2EI16_V_M8_MF4_MASK, VLOXSEG2EI16_V }, // 3440
  { PseudoVLOXSEG2EI16_V_M8_MF8, VLOXSEG2EI16_V }, // 3441
  { PseudoVLOXSEG2EI16_V_M8_MF8_MASK, VLOXSEG2EI16_V }, // 3442
  { PseudoVLOXSEG2EI16_V_MF2_M1, VLOXSEG2EI16_V }, // 3443
  { PseudoVLOXSEG2EI16_V_MF2_M1_MASK, VLOXSEG2EI16_V }, // 3444
  { PseudoVLOXSEG2EI16_V_MF2_M2, VLOXSEG2EI16_V }, // 3445
  { PseudoVLOXSEG2EI16_V_MF2_M2_MASK, VLOXSEG2EI16_V }, // 3446
  { PseudoVLOXSEG2EI16_V_MF2_M4, VLOXSEG2EI16_V }, // 3447
  { PseudoVLOXSEG2EI16_V_MF2_M4_MASK, VLOXSEG2EI16_V }, // 3448
  { PseudoVLOXSEG2EI16_V_MF2_MF2, VLOXSEG2EI16_V }, // 3449
  { PseudoVLOXSEG2EI16_V_MF2_MF2_MASK, VLOXSEG2EI16_V }, // 3450
  { PseudoVLOXSEG2EI16_V_MF2_MF4, VLOXSEG2EI16_V }, // 3451
  { PseudoVLOXSEG2EI16_V_MF2_MF4_MASK, VLOXSEG2EI16_V }, // 3452
  { PseudoVLOXSEG2EI16_V_MF2_MF8, VLOXSEG2EI16_V }, // 3453
  { PseudoVLOXSEG2EI16_V_MF2_MF8_MASK, VLOXSEG2EI16_V }, // 3454
  { PseudoVLOXSEG2EI16_V_MF4_M1, VLOXSEG2EI16_V }, // 3455
  { PseudoVLOXSEG2EI16_V_MF4_M1_MASK, VLOXSEG2EI16_V }, // 3456
  { PseudoVLOXSEG2EI16_V_MF4_M2, VLOXSEG2EI16_V }, // 3457
  { PseudoVLOXSEG2EI16_V_MF4_M2_MASK, VLOXSEG2EI16_V }, // 3458
  { PseudoVLOXSEG2EI16_V_MF4_M4, VLOXSEG2EI16_V }, // 3459
  { PseudoVLOXSEG2EI16_V_MF4_M4_MASK, VLOXSEG2EI16_V }, // 3460
  { PseudoVLOXSEG2EI16_V_MF4_MF2, VLOXSEG2EI16_V }, // 3461
  { PseudoVLOXSEG2EI16_V_MF4_MF2_MASK, VLOXSEG2EI16_V }, // 3462
  { PseudoVLOXSEG2EI16_V_MF4_MF4, VLOXSEG2EI16_V }, // 3463
  { PseudoVLOXSEG2EI16_V_MF4_MF4_MASK, VLOXSEG2EI16_V }, // 3464
  { PseudoVLOXSEG2EI16_V_MF4_MF8, VLOXSEG2EI16_V }, // 3465
  { PseudoVLOXSEG2EI16_V_MF4_MF8_MASK, VLOXSEG2EI16_V }, // 3466
  { PseudoVLOXSEG2EI32_V_M1_M1, VLOXSEG2EI32_V }, // 3467
  { PseudoVLOXSEG2EI32_V_M1_M1_MASK, VLOXSEG2EI32_V }, // 3468
  { PseudoVLOXSEG2EI32_V_M1_M2, VLOXSEG2EI32_V }, // 3469
  { PseudoVLOXSEG2EI32_V_M1_M2_MASK, VLOXSEG2EI32_V }, // 3470
  { PseudoVLOXSEG2EI32_V_M1_M4, VLOXSEG2EI32_V }, // 3471
  { PseudoVLOXSEG2EI32_V_M1_M4_MASK, VLOXSEG2EI32_V }, // 3472
  { PseudoVLOXSEG2EI32_V_M1_MF2, VLOXSEG2EI32_V }, // 3473
  { PseudoVLOXSEG2EI32_V_M1_MF2_MASK, VLOXSEG2EI32_V }, // 3474
  { PseudoVLOXSEG2EI32_V_M1_MF4, VLOXSEG2EI32_V }, // 3475
  { PseudoVLOXSEG2EI32_V_M1_MF4_MASK, VLOXSEG2EI32_V }, // 3476
  { PseudoVLOXSEG2EI32_V_M1_MF8, VLOXSEG2EI32_V }, // 3477
  { PseudoVLOXSEG2EI32_V_M1_MF8_MASK, VLOXSEG2EI32_V }, // 3478
  { PseudoVLOXSEG2EI32_V_M2_M1, VLOXSEG2EI32_V }, // 3479
  { PseudoVLOXSEG2EI32_V_M2_M1_MASK, VLOXSEG2EI32_V }, // 3480
  { PseudoVLOXSEG2EI32_V_M2_M2, VLOXSEG2EI32_V }, // 3481
  { PseudoVLOXSEG2EI32_V_M2_M2_MASK, VLOXSEG2EI32_V }, // 3482
  { PseudoVLOXSEG2EI32_V_M2_M4, VLOXSEG2EI32_V }, // 3483
  { PseudoVLOXSEG2EI32_V_M2_M4_MASK, VLOXSEG2EI32_V }, // 3484
  { PseudoVLOXSEG2EI32_V_M2_MF2, VLOXSEG2EI32_V }, // 3485
  { PseudoVLOXSEG2EI32_V_M2_MF2_MASK, VLOXSEG2EI32_V }, // 3486
  { PseudoVLOXSEG2EI32_V_M2_MF4, VLOXSEG2EI32_V }, // 3487
  { PseudoVLOXSEG2EI32_V_M2_MF4_MASK, VLOXSEG2EI32_V }, // 3488
  { PseudoVLOXSEG2EI32_V_M2_MF8, VLOXSEG2EI32_V }, // 3489
  { PseudoVLOXSEG2EI32_V_M2_MF8_MASK, VLOXSEG2EI32_V }, // 3490
  { PseudoVLOXSEG2EI32_V_M4_M1, VLOXSEG2EI32_V }, // 3491
  { PseudoVLOXSEG2EI32_V_M4_M1_MASK, VLOXSEG2EI32_V }, // 3492
  { PseudoVLOXSEG2EI32_V_M4_M2, VLOXSEG2EI32_V }, // 3493
  { PseudoVLOXSEG2EI32_V_M4_M2_MASK, VLOXSEG2EI32_V }, // 3494
  { PseudoVLOXSEG2EI32_V_M4_M4, VLOXSEG2EI32_V }, // 3495
  { PseudoVLOXSEG2EI32_V_M4_M4_MASK, VLOXSEG2EI32_V }, // 3496
  { PseudoVLOXSEG2EI32_V_M4_MF2, VLOXSEG2EI32_V }, // 3497
  { PseudoVLOXSEG2EI32_V_M4_MF2_MASK, VLOXSEG2EI32_V }, // 3498
  { PseudoVLOXSEG2EI32_V_M4_MF4, VLOXSEG2EI32_V }, // 3499
  { PseudoVLOXSEG2EI32_V_M4_MF4_MASK, VLOXSEG2EI32_V }, // 3500
  { PseudoVLOXSEG2EI32_V_M4_MF8, VLOXSEG2EI32_V }, // 3501
  { PseudoVLOXSEG2EI32_V_M4_MF8_MASK, VLOXSEG2EI32_V }, // 3502
  { PseudoVLOXSEG2EI32_V_M8_M1, VLOXSEG2EI32_V }, // 3503
  { PseudoVLOXSEG2EI32_V_M8_M1_MASK, VLOXSEG2EI32_V }, // 3504
  { PseudoVLOXSEG2EI32_V_M8_M2, VLOXSEG2EI32_V }, // 3505
  { PseudoVLOXSEG2EI32_V_M8_M2_MASK, VLOXSEG2EI32_V }, // 3506
  { PseudoVLOXSEG2EI32_V_M8_M4, VLOXSEG2EI32_V }, // 3507
  { PseudoVLOXSEG2EI32_V_M8_M4_MASK, VLOXSEG2EI32_V }, // 3508
  { PseudoVLOXSEG2EI32_V_M8_MF2, VLOXSEG2EI32_V }, // 3509
  { PseudoVLOXSEG2EI32_V_M8_MF2_MASK, VLOXSEG2EI32_V }, // 3510
  { PseudoVLOXSEG2EI32_V_M8_MF4, VLOXSEG2EI32_V }, // 3511
  { PseudoVLOXSEG2EI32_V_M8_MF4_MASK, VLOXSEG2EI32_V }, // 3512
  { PseudoVLOXSEG2EI32_V_M8_MF8, VLOXSEG2EI32_V }, // 3513
  { PseudoVLOXSEG2EI32_V_M8_MF8_MASK, VLOXSEG2EI32_V }, // 3514
  { PseudoVLOXSEG2EI32_V_MF2_M1, VLOXSEG2EI32_V }, // 3515
  { PseudoVLOXSEG2EI32_V_MF2_M1_MASK, VLOXSEG2EI32_V }, // 3516
  { PseudoVLOXSEG2EI32_V_MF2_M2, VLOXSEG2EI32_V }, // 3517
  { PseudoVLOXSEG2EI32_V_MF2_M2_MASK, VLOXSEG2EI32_V }, // 3518
  { PseudoVLOXSEG2EI32_V_MF2_M4, VLOXSEG2EI32_V }, // 3519
  { PseudoVLOXSEG2EI32_V_MF2_M4_MASK, VLOXSEG2EI32_V }, // 3520
  { PseudoVLOXSEG2EI32_V_MF2_MF2, VLOXSEG2EI32_V }, // 3521
  { PseudoVLOXSEG2EI32_V_MF2_MF2_MASK, VLOXSEG2EI32_V }, // 3522
  { PseudoVLOXSEG2EI32_V_MF2_MF4, VLOXSEG2EI32_V }, // 3523
  { PseudoVLOXSEG2EI32_V_MF2_MF4_MASK, VLOXSEG2EI32_V }, // 3524
  { PseudoVLOXSEG2EI32_V_MF2_MF8, VLOXSEG2EI32_V }, // 3525
  { PseudoVLOXSEG2EI32_V_MF2_MF8_MASK, VLOXSEG2EI32_V }, // 3526
  { PseudoVLOXSEG2EI64_V_M1_M1, VLOXSEG2EI64_V }, // 3527
  { PseudoVLOXSEG2EI64_V_M1_M1_MASK, VLOXSEG2EI64_V }, // 3528
  { PseudoVLOXSEG2EI64_V_M1_M2, VLOXSEG2EI64_V }, // 3529
  { PseudoVLOXSEG2EI64_V_M1_M2_MASK, VLOXSEG2EI64_V }, // 3530
  { PseudoVLOXSEG2EI64_V_M1_M4, VLOXSEG2EI64_V }, // 3531
  { PseudoVLOXSEG2EI64_V_M1_M4_MASK, VLOXSEG2EI64_V }, // 3532
  { PseudoVLOXSEG2EI64_V_M1_MF2, VLOXSEG2EI64_V }, // 3533
  { PseudoVLOXSEG2EI64_V_M1_MF2_MASK, VLOXSEG2EI64_V }, // 3534
  { PseudoVLOXSEG2EI64_V_M1_MF4, VLOXSEG2EI64_V }, // 3535
  { PseudoVLOXSEG2EI64_V_M1_MF4_MASK, VLOXSEG2EI64_V }, // 3536
  { PseudoVLOXSEG2EI64_V_M1_MF8, VLOXSEG2EI64_V }, // 3537
  { PseudoVLOXSEG2EI64_V_M1_MF8_MASK, VLOXSEG2EI64_V }, // 3538
  { PseudoVLOXSEG2EI64_V_M2_M1, VLOXSEG2EI64_V }, // 3539
  { PseudoVLOXSEG2EI64_V_M2_M1_MASK, VLOXSEG2EI64_V }, // 3540
  { PseudoVLOXSEG2EI64_V_M2_M2, VLOXSEG2EI64_V }, // 3541
  { PseudoVLOXSEG2EI64_V_M2_M2_MASK, VLOXSEG2EI64_V }, // 3542
  { PseudoVLOXSEG2EI64_V_M2_M4, VLOXSEG2EI64_V }, // 3543
  { PseudoVLOXSEG2EI64_V_M2_M4_MASK, VLOXSEG2EI64_V }, // 3544
  { PseudoVLOXSEG2EI64_V_M2_MF2, VLOXSEG2EI64_V }, // 3545
  { PseudoVLOXSEG2EI64_V_M2_MF2_MASK, VLOXSEG2EI64_V }, // 3546
  { PseudoVLOXSEG2EI64_V_M2_MF4, VLOXSEG2EI64_V }, // 3547
  { PseudoVLOXSEG2EI64_V_M2_MF4_MASK, VLOXSEG2EI64_V }, // 3548
  { PseudoVLOXSEG2EI64_V_M2_MF8, VLOXSEG2EI64_V }, // 3549
  { PseudoVLOXSEG2EI64_V_M2_MF8_MASK, VLOXSEG2EI64_V }, // 3550
  { PseudoVLOXSEG2EI64_V_M4_M1, VLOXSEG2EI64_V }, // 3551
  { PseudoVLOXSEG2EI64_V_M4_M1_MASK, VLOXSEG2EI64_V }, // 3552
  { PseudoVLOXSEG2EI64_V_M4_M2, VLOXSEG2EI64_V }, // 3553
  { PseudoVLOXSEG2EI64_V_M4_M2_MASK, VLOXSEG2EI64_V }, // 3554
  { PseudoVLOXSEG2EI64_V_M4_M4, VLOXSEG2EI64_V }, // 3555
  { PseudoVLOXSEG2EI64_V_M4_M4_MASK, VLOXSEG2EI64_V }, // 3556
  { PseudoVLOXSEG2EI64_V_M4_MF2, VLOXSEG2EI64_V }, // 3557
  { PseudoVLOXSEG2EI64_V_M4_MF2_MASK, VLOXSEG2EI64_V }, // 3558
  { PseudoVLOXSEG2EI64_V_M4_MF4, VLOXSEG2EI64_V }, // 3559
  { PseudoVLOXSEG2EI64_V_M4_MF4_MASK, VLOXSEG2EI64_V }, // 3560
  { PseudoVLOXSEG2EI64_V_M4_MF8, VLOXSEG2EI64_V }, // 3561
  { PseudoVLOXSEG2EI64_V_M4_MF8_MASK, VLOXSEG2EI64_V }, // 3562
  { PseudoVLOXSEG2EI64_V_M8_M1, VLOXSEG2EI64_V }, // 3563
  { PseudoVLOXSEG2EI64_V_M8_M1_MASK, VLOXSEG2EI64_V }, // 3564
  { PseudoVLOXSEG2EI64_V_M8_M2, VLOXSEG2EI64_V }, // 3565
  { PseudoVLOXSEG2EI64_V_M8_M2_MASK, VLOXSEG2EI64_V }, // 3566
  { PseudoVLOXSEG2EI64_V_M8_M4, VLOXSEG2EI64_V }, // 3567
  { PseudoVLOXSEG2EI64_V_M8_M4_MASK, VLOXSEG2EI64_V }, // 3568
  { PseudoVLOXSEG2EI64_V_M8_MF2, VLOXSEG2EI64_V }, // 3569
  { PseudoVLOXSEG2EI64_V_M8_MF2_MASK, VLOXSEG2EI64_V }, // 3570
  { PseudoVLOXSEG2EI64_V_M8_MF4, VLOXSEG2EI64_V }, // 3571
  { PseudoVLOXSEG2EI64_V_M8_MF4_MASK, VLOXSEG2EI64_V }, // 3572
  { PseudoVLOXSEG2EI64_V_M8_MF8, VLOXSEG2EI64_V }, // 3573
  { PseudoVLOXSEG2EI64_V_M8_MF8_MASK, VLOXSEG2EI64_V }, // 3574
  { PseudoVLOXSEG2EI8_V_M1_M1, VLOXSEG2EI8_V }, // 3575
  { PseudoVLOXSEG2EI8_V_M1_M1_MASK, VLOXSEG2EI8_V }, // 3576
  { PseudoVLOXSEG2EI8_V_M1_M2, VLOXSEG2EI8_V }, // 3577
  { PseudoVLOXSEG2EI8_V_M1_M2_MASK, VLOXSEG2EI8_V }, // 3578
  { PseudoVLOXSEG2EI8_V_M1_M4, VLOXSEG2EI8_V }, // 3579
  { PseudoVLOXSEG2EI8_V_M1_M4_MASK, VLOXSEG2EI8_V }, // 3580
  { PseudoVLOXSEG2EI8_V_M1_MF2, VLOXSEG2EI8_V }, // 3581
  { PseudoVLOXSEG2EI8_V_M1_MF2_MASK, VLOXSEG2EI8_V }, // 3582
  { PseudoVLOXSEG2EI8_V_M1_MF4, VLOXSEG2EI8_V }, // 3583
  { PseudoVLOXSEG2EI8_V_M1_MF4_MASK, VLOXSEG2EI8_V }, // 3584
  { PseudoVLOXSEG2EI8_V_M1_MF8, VLOXSEG2EI8_V }, // 3585
  { PseudoVLOXSEG2EI8_V_M1_MF8_MASK, VLOXSEG2EI8_V }, // 3586
  { PseudoVLOXSEG2EI8_V_M2_M1, VLOXSEG2EI8_V }, // 3587
  { PseudoVLOXSEG2EI8_V_M2_M1_MASK, VLOXSEG2EI8_V }, // 3588
  { PseudoVLOXSEG2EI8_V_M2_M2, VLOXSEG2EI8_V }, // 3589
  { PseudoVLOXSEG2EI8_V_M2_M2_MASK, VLOXSEG2EI8_V }, // 3590
  { PseudoVLOXSEG2EI8_V_M2_M4, VLOXSEG2EI8_V }, // 3591
  { PseudoVLOXSEG2EI8_V_M2_M4_MASK, VLOXSEG2EI8_V }, // 3592
  { PseudoVLOXSEG2EI8_V_M2_MF2, VLOXSEG2EI8_V }, // 3593
  { PseudoVLOXSEG2EI8_V_M2_MF2_MASK, VLOXSEG2EI8_V }, // 3594
  { PseudoVLOXSEG2EI8_V_M2_MF4, VLOXSEG2EI8_V }, // 3595
  { PseudoVLOXSEG2EI8_V_M2_MF4_MASK, VLOXSEG2EI8_V }, // 3596
  { PseudoVLOXSEG2EI8_V_M2_MF8, VLOXSEG2EI8_V }, // 3597
  { PseudoVLOXSEG2EI8_V_M2_MF8_MASK, VLOXSEG2EI8_V }, // 3598
  { PseudoVLOXSEG2EI8_V_M4_M1, VLOXSEG2EI8_V }, // 3599
  { PseudoVLOXSEG2EI8_V_M4_M1_MASK, VLOXSEG2EI8_V }, // 3600
  { PseudoVLOXSEG2EI8_V_M4_M2, VLOXSEG2EI8_V }, // 3601
  { PseudoVLOXSEG2EI8_V_M4_M2_MASK, VLOXSEG2EI8_V }, // 3602
  { PseudoVLOXSEG2EI8_V_M4_M4, VLOXSEG2EI8_V }, // 3603
  { PseudoVLOXSEG2EI8_V_M4_M4_MASK, VLOXSEG2EI8_V }, // 3604
  { PseudoVLOXSEG2EI8_V_M4_MF2, VLOXSEG2EI8_V }, // 3605
  { PseudoVLOXSEG2EI8_V_M4_MF2_MASK, VLOXSEG2EI8_V }, // 3606
  { PseudoVLOXSEG2EI8_V_M4_MF4, VLOXSEG2EI8_V }, // 3607
  { PseudoVLOXSEG2EI8_V_M4_MF4_MASK, VLOXSEG2EI8_V }, // 3608
  { PseudoVLOXSEG2EI8_V_M4_MF8, VLOXSEG2EI8_V }, // 3609
  { PseudoVLOXSEG2EI8_V_M4_MF8_MASK, VLOXSEG2EI8_V }, // 3610
  { PseudoVLOXSEG2EI8_V_M8_M1, VLOXSEG2EI8_V }, // 3611
  { PseudoVLOXSEG2EI8_V_M8_M1_MASK, VLOXSEG2EI8_V }, // 3612
  { PseudoVLOXSEG2EI8_V_M8_M2, VLOXSEG2EI8_V }, // 3613
  { PseudoVLOXSEG2EI8_V_M8_M2_MASK, VLOXSEG2EI8_V }, // 3614
  { PseudoVLOXSEG2EI8_V_M8_M4, VLOXSEG2EI8_V }, // 3615
  { PseudoVLOXSEG2EI8_V_M8_M4_MASK, VLOXSEG2EI8_V }, // 3616
  { PseudoVLOXSEG2EI8_V_M8_MF2, VLOXSEG2EI8_V }, // 3617
  { PseudoVLOXSEG2EI8_V_M8_MF2_MASK, VLOXSEG2EI8_V }, // 3618
  { PseudoVLOXSEG2EI8_V_M8_MF4, VLOXSEG2EI8_V }, // 3619
  { PseudoVLOXSEG2EI8_V_M8_MF4_MASK, VLOXSEG2EI8_V }, // 3620
  { PseudoVLOXSEG2EI8_V_M8_MF8, VLOXSEG2EI8_V }, // 3621
  { PseudoVLOXSEG2EI8_V_M8_MF8_MASK, VLOXSEG2EI8_V }, // 3622
  { PseudoVLOXSEG2EI8_V_MF2_M1, VLOXSEG2EI8_V }, // 3623
  { PseudoVLOXSEG2EI8_V_MF2_M1_MASK, VLOXSEG2EI8_V }, // 3624
  { PseudoVLOXSEG2EI8_V_MF2_M2, VLOXSEG2EI8_V }, // 3625
  { PseudoVLOXSEG2EI8_V_MF2_M2_MASK, VLOXSEG2EI8_V }, // 3626
  { PseudoVLOXSEG2EI8_V_MF2_M4, VLOXSEG2EI8_V }, // 3627
  { PseudoVLOXSEG2EI8_V_MF2_M4_MASK, VLOXSEG2EI8_V }, // 3628
  { PseudoVLOXSEG2EI8_V_MF2_MF2, VLOXSEG2EI8_V }, // 3629
  { PseudoVLOXSEG2EI8_V_MF2_MF2_MASK, VLOXSEG2EI8_V }, // 3630
  { PseudoVLOXSEG2EI8_V_MF2_MF4, VLOXSEG2EI8_V }, // 3631
  { PseudoVLOXSEG2EI8_V_MF2_MF4_MASK, VLOXSEG2EI8_V }, // 3632
  { PseudoVLOXSEG2EI8_V_MF2_MF8, VLOXSEG2EI8_V }, // 3633
  { PseudoVLOXSEG2EI8_V_MF2_MF8_MASK, VLOXSEG2EI8_V }, // 3634
  { PseudoVLOXSEG2EI8_V_MF4_M1, VLOXSEG2EI8_V }, // 3635
  { PseudoVLOXSEG2EI8_V_MF4_M1_MASK, VLOXSEG2EI8_V }, // 3636
  { PseudoVLOXSEG2EI8_V_MF4_M2, VLOXSEG2EI8_V }, // 3637
  { PseudoVLOXSEG2EI8_V_MF4_M2_MASK, VLOXSEG2EI8_V }, // 3638
  { PseudoVLOXSEG2EI8_V_MF4_M4, VLOXSEG2EI8_V }, // 3639
  { PseudoVLOXSEG2EI8_V_MF4_M4_MASK, VLOXSEG2EI8_V }, // 3640
  { PseudoVLOXSEG2EI8_V_MF4_MF2, VLOXSEG2EI8_V }, // 3641
  { PseudoVLOXSEG2EI8_V_MF4_MF2_MASK, VLOXSEG2EI8_V }, // 3642
  { PseudoVLOXSEG2EI8_V_MF4_MF4, VLOXSEG2EI8_V }, // 3643
  { PseudoVLOXSEG2EI8_V_MF4_MF4_MASK, VLOXSEG2EI8_V }, // 3644
  { PseudoVLOXSEG2EI8_V_MF4_MF8, VLOXSEG2EI8_V }, // 3645
  { PseudoVLOXSEG2EI8_V_MF4_MF8_MASK, VLOXSEG2EI8_V }, // 3646
  { PseudoVLOXSEG2EI8_V_MF8_M1, VLOXSEG2EI8_V }, // 3647
  { PseudoVLOXSEG2EI8_V_MF8_M1_MASK, VLOXSEG2EI8_V }, // 3648
  { PseudoVLOXSEG2EI8_V_MF8_M2, VLOXSEG2EI8_V }, // 3649
  { PseudoVLOXSEG2EI8_V_MF8_M2_MASK, VLOXSEG2EI8_V }, // 3650
  { PseudoVLOXSEG2EI8_V_MF8_M4, VLOXSEG2EI8_V }, // 3651
  { PseudoVLOXSEG2EI8_V_MF8_M4_MASK, VLOXSEG2EI8_V }, // 3652
  { PseudoVLOXSEG2EI8_V_MF8_MF2, VLOXSEG2EI8_V }, // 3653
  { PseudoVLOXSEG2EI8_V_MF8_MF2_MASK, VLOXSEG2EI8_V }, // 3654
  { PseudoVLOXSEG2EI8_V_MF8_MF4, VLOXSEG2EI8_V }, // 3655
  { PseudoVLOXSEG2EI8_V_MF8_MF4_MASK, VLOXSEG2EI8_V }, // 3656
  { PseudoVLOXSEG2EI8_V_MF8_MF8, VLOXSEG2EI8_V }, // 3657
  { PseudoVLOXSEG2EI8_V_MF8_MF8_MASK, VLOXSEG2EI8_V }, // 3658
  { PseudoVLOXSEG3EI16_V_M1_M1, VLOXSEG3EI16_V }, // 3659
  { PseudoVLOXSEG3EI16_V_M1_M1_MASK, VLOXSEG3EI16_V }, // 3660
  { PseudoVLOXSEG3EI16_V_M1_M2, VLOXSEG3EI16_V }, // 3661
  { PseudoVLOXSEG3EI16_V_M1_M2_MASK, VLOXSEG3EI16_V }, // 3662
  { PseudoVLOXSEG3EI16_V_M1_MF2, VLOXSEG3EI16_V }, // 3663
  { PseudoVLOXSEG3EI16_V_M1_MF2_MASK, VLOXSEG3EI16_V }, // 3664
  { PseudoVLOXSEG3EI16_V_M1_MF4, VLOXSEG3EI16_V }, // 3665
  { PseudoVLOXSEG3EI16_V_M1_MF4_MASK, VLOXSEG3EI16_V }, // 3666
  { PseudoVLOXSEG3EI16_V_M1_MF8, VLOXSEG3EI16_V }, // 3667
  { PseudoVLOXSEG3EI16_V_M1_MF8_MASK, VLOXSEG3EI16_V }, // 3668
  { PseudoVLOXSEG3EI16_V_M2_M1, VLOXSEG3EI16_V }, // 3669
  { PseudoVLOXSEG3EI16_V_M2_M1_MASK, VLOXSEG3EI16_V }, // 3670
  { PseudoVLOXSEG3EI16_V_M2_M2, VLOXSEG3EI16_V }, // 3671
  { PseudoVLOXSEG3EI16_V_M2_M2_MASK, VLOXSEG3EI16_V }, // 3672
  { PseudoVLOXSEG3EI16_V_M2_MF2, VLOXSEG3EI16_V }, // 3673
  { PseudoVLOXSEG3EI16_V_M2_MF2_MASK, VLOXSEG3EI16_V }, // 3674
  { PseudoVLOXSEG3EI16_V_M2_MF4, VLOXSEG3EI16_V }, // 3675
  { PseudoVLOXSEG3EI16_V_M2_MF4_MASK, VLOXSEG3EI16_V }, // 3676
  { PseudoVLOXSEG3EI16_V_M2_MF8, VLOXSEG3EI16_V }, // 3677
  { PseudoVLOXSEG3EI16_V_M2_MF8_MASK, VLOXSEG3EI16_V }, // 3678
  { PseudoVLOXSEG3EI16_V_M4_M1, VLOXSEG3EI16_V }, // 3679
  { PseudoVLOXSEG3EI16_V_M4_M1_MASK, VLOXSEG3EI16_V }, // 3680
  { PseudoVLOXSEG3EI16_V_M4_M2, VLOXSEG3EI16_V }, // 3681
  { PseudoVLOXSEG3EI16_V_M4_M2_MASK, VLOXSEG3EI16_V }, // 3682
  { PseudoVLOXSEG3EI16_V_M4_MF2, VLOXSEG3EI16_V }, // 3683
  { PseudoVLOXSEG3EI16_V_M4_MF2_MASK, VLOXSEG3EI16_V }, // 3684
  { PseudoVLOXSEG3EI16_V_M4_MF4, VLOXSEG3EI16_V }, // 3685
  { PseudoVLOXSEG3EI16_V_M4_MF4_MASK, VLOXSEG3EI16_V }, // 3686
  { PseudoVLOXSEG3EI16_V_M4_MF8, VLOXSEG3EI16_V }, // 3687
  { PseudoVLOXSEG3EI16_V_M4_MF8_MASK, VLOXSEG3EI16_V }, // 3688
  { PseudoVLOXSEG3EI16_V_M8_M1, VLOXSEG3EI16_V }, // 3689
  { PseudoVLOXSEG3EI16_V_M8_M1_MASK, VLOXSEG3EI16_V }, // 3690
  { PseudoVLOXSEG3EI16_V_M8_M2, VLOXSEG3EI16_V }, // 3691
  { PseudoVLOXSEG3EI16_V_M8_M2_MASK, VLOXSEG3EI16_V }, // 3692
  { PseudoVLOXSEG3EI16_V_M8_MF2, VLOXSEG3EI16_V }, // 3693
  { PseudoVLOXSEG3EI16_V_M8_MF2_MASK, VLOXSEG3EI16_V }, // 3694
  { PseudoVLOXSEG3EI16_V_M8_MF4, VLOXSEG3EI16_V }, // 3695
  { PseudoVLOXSEG3EI16_V_M8_MF4_MASK, VLOXSEG3EI16_V }, // 3696
  { PseudoVLOXSEG3EI16_V_M8_MF8, VLOXSEG3EI16_V }, // 3697
  { PseudoVLOXSEG3EI16_V_M8_MF8_MASK, VLOXSEG3EI16_V }, // 3698
  { PseudoVLOXSEG3EI16_V_MF2_M1, VLOXSEG3EI16_V }, // 3699
  { PseudoVLOXSEG3EI16_V_MF2_M1_MASK, VLOXSEG3EI16_V }, // 3700
  { PseudoVLOXSEG3EI16_V_MF2_M2, VLOXSEG3EI16_V }, // 3701
  { PseudoVLOXSEG3EI16_V_MF2_M2_MASK, VLOXSEG3EI16_V }, // 3702
  { PseudoVLOXSEG3EI16_V_MF2_MF2, VLOXSEG3EI16_V }, // 3703
  { PseudoVLOXSEG3EI16_V_MF2_MF2_MASK, VLOXSEG3EI16_V }, // 3704
  { PseudoVLOXSEG3EI16_V_MF2_MF4, VLOXSEG3EI16_V }, // 3705
  { PseudoVLOXSEG3EI16_V_MF2_MF4_MASK, VLOXSEG3EI16_V }, // 3706
  { PseudoVLOXSEG3EI16_V_MF2_MF8, VLOXSEG3EI16_V }, // 3707
  { PseudoVLOXSEG3EI16_V_MF2_MF8_MASK, VLOXSEG3EI16_V }, // 3708
  { PseudoVLOXSEG3EI16_V_MF4_M1, VLOXSEG3EI16_V }, // 3709
  { PseudoVLOXSEG3EI16_V_MF4_M1_MASK, VLOXSEG3EI16_V }, // 3710
  { PseudoVLOXSEG3EI16_V_MF4_M2, VLOXSEG3EI16_V }, // 3711
  { PseudoVLOXSEG3EI16_V_MF4_M2_MASK, VLOXSEG3EI16_V }, // 3712
  { PseudoVLOXSEG3EI16_V_MF4_MF2, VLOXSEG3EI16_V }, // 3713
  { PseudoVLOXSEG3EI16_V_MF4_MF2_MASK, VLOXSEG3EI16_V }, // 3714
  { PseudoVLOXSEG3EI16_V_MF4_MF4, VLOXSEG3EI16_V }, // 3715
  { PseudoVLOXSEG3EI16_V_MF4_MF4_MASK, VLOXSEG3EI16_V }, // 3716
  { PseudoVLOXSEG3EI16_V_MF4_MF8, VLOXSEG3EI16_V }, // 3717
  { PseudoVLOXSEG3EI16_V_MF4_MF8_MASK, VLOXSEG3EI16_V }, // 3718
  { PseudoVLOXSEG3EI32_V_M1_M1, VLOXSEG3EI32_V }, // 3719
  { PseudoVLOXSEG3EI32_V_M1_M1_MASK, VLOXSEG3EI32_V }, // 3720
  { PseudoVLOXSEG3EI32_V_M1_M2, VLOXSEG3EI32_V }, // 3721
  { PseudoVLOXSEG3EI32_V_M1_M2_MASK, VLOXSEG3EI32_V }, // 3722
  { PseudoVLOXSEG3EI32_V_M1_MF2, VLOXSEG3EI32_V }, // 3723
  { PseudoVLOXSEG3EI32_V_M1_MF2_MASK, VLOXSEG3EI32_V }, // 3724
  { PseudoVLOXSEG3EI32_V_M1_MF4, VLOXSEG3EI32_V }, // 3725
  { PseudoVLOXSEG3EI32_V_M1_MF4_MASK, VLOXSEG3EI32_V }, // 3726
  { PseudoVLOXSEG3EI32_V_M1_MF8, VLOXSEG3EI32_V }, // 3727
  { PseudoVLOXSEG3EI32_V_M1_MF8_MASK, VLOXSEG3EI32_V }, // 3728
  { PseudoVLOXSEG3EI32_V_M2_M1, VLOXSEG3EI32_V }, // 3729
  { PseudoVLOXSEG3EI32_V_M2_M1_MASK, VLOXSEG3EI32_V }, // 3730
  { PseudoVLOXSEG3EI32_V_M2_M2, VLOXSEG3EI32_V }, // 3731
  { PseudoVLOXSEG3EI32_V_M2_M2_MASK, VLOXSEG3EI32_V }, // 3732
  { PseudoVLOXSEG3EI32_V_M2_MF2, VLOXSEG3EI32_V }, // 3733
  { PseudoVLOXSEG3EI32_V_M2_MF2_MASK, VLOXSEG3EI32_V }, // 3734
  { PseudoVLOXSEG3EI32_V_M2_MF4, VLOXSEG3EI32_V }, // 3735
  { PseudoVLOXSEG3EI32_V_M2_MF4_MASK, VLOXSEG3EI32_V }, // 3736
  { PseudoVLOXSEG3EI32_V_M2_MF8, VLOXSEG3EI32_V }, // 3737
  { PseudoVLOXSEG3EI32_V_M2_MF8_MASK, VLOXSEG3EI32_V }, // 3738
  { PseudoVLOXSEG3EI32_V_M4_M1, VLOXSEG3EI32_V }, // 3739
  { PseudoVLOXSEG3EI32_V_M4_M1_MASK, VLOXSEG3EI32_V }, // 3740
  { PseudoVLOXSEG3EI32_V_M4_M2, VLOXSEG3EI32_V }, // 3741
  { PseudoVLOXSEG3EI32_V_M4_M2_MASK, VLOXSEG3EI32_V }, // 3742
  { PseudoVLOXSEG3EI32_V_M4_MF2, VLOXSEG3EI32_V }, // 3743
  { PseudoVLOXSEG3EI32_V_M4_MF2_MASK, VLOXSEG3EI32_V }, // 3744
  { PseudoVLOXSEG3EI32_V_M4_MF4, VLOXSEG3EI32_V }, // 3745
  { PseudoVLOXSEG3EI32_V_M4_MF4_MASK, VLOXSEG3EI32_V }, // 3746
  { PseudoVLOXSEG3EI32_V_M4_MF8, VLOXSEG3EI32_V }, // 3747
  { PseudoVLOXSEG3EI32_V_M4_MF8_MASK, VLOXSEG3EI32_V }, // 3748
  { PseudoVLOXSEG3EI32_V_M8_M1, VLOXSEG3EI32_V }, // 3749
  { PseudoVLOXSEG3EI32_V_M8_M1_MASK, VLOXSEG3EI32_V }, // 3750
  { PseudoVLOXSEG3EI32_V_M8_M2, VLOXSEG3EI32_V }, // 3751
  { PseudoVLOXSEG3EI32_V_M8_M2_MASK, VLOXSEG3EI32_V }, // 3752
  { PseudoVLOXSEG3EI32_V_M8_MF2, VLOXSEG3EI32_V }, // 3753
  { PseudoVLOXSEG3EI32_V_M8_MF2_MASK, VLOXSEG3EI32_V }, // 3754
  { PseudoVLOXSEG3EI32_V_M8_MF4, VLOXSEG3EI32_V }, // 3755
  { PseudoVLOXSEG3EI32_V_M8_MF4_MASK, VLOXSEG3EI32_V }, // 3756
  { PseudoVLOXSEG3EI32_V_M8_MF8, VLOXSEG3EI32_V }, // 3757
  { PseudoVLOXSEG3EI32_V_M8_MF8_MASK, VLOXSEG3EI32_V }, // 3758
  { PseudoVLOXSEG3EI32_V_MF2_M1, VLOXSEG3EI32_V }, // 3759
  { PseudoVLOXSEG3EI32_V_MF2_M1_MASK, VLOXSEG3EI32_V }, // 3760
  { PseudoVLOXSEG3EI32_V_MF2_M2, VLOXSEG3EI32_V }, // 3761
  { PseudoVLOXSEG3EI32_V_MF2_M2_MASK, VLOXSEG3EI32_V }, // 3762
  { PseudoVLOXSEG3EI32_V_MF2_MF2, VLOXSEG3EI32_V }, // 3763
  { PseudoVLOXSEG3EI32_V_MF2_MF2_MASK, VLOXSEG3EI32_V }, // 3764
  { PseudoVLOXSEG3EI32_V_MF2_MF4, VLOXSEG3EI32_V }, // 3765
  { PseudoVLOXSEG3EI32_V_MF2_MF4_MASK, VLOXSEG3EI32_V }, // 3766
  { PseudoVLOXSEG3EI32_V_MF2_MF8, VLOXSEG3EI32_V }, // 3767
  { PseudoVLOXSEG3EI32_V_MF2_MF8_MASK, VLOXSEG3EI32_V }, // 3768
  { PseudoVLOXSEG3EI64_V_M1_M1, VLOXSEG3EI64_V }, // 3769
  { PseudoVLOXSEG3EI64_V_M1_M1_MASK, VLOXSEG3EI64_V }, // 3770
  { PseudoVLOXSEG3EI64_V_M1_M2, VLOXSEG3EI64_V }, // 3771
  { PseudoVLOXSEG3EI64_V_M1_M2_MASK, VLOXSEG3EI64_V }, // 3772
  { PseudoVLOXSEG3EI64_V_M1_MF2, VLOXSEG3EI64_V }, // 3773
  { PseudoVLOXSEG3EI64_V_M1_MF2_MASK, VLOXSEG3EI64_V }, // 3774
  { PseudoVLOXSEG3EI64_V_M1_MF4, VLOXSEG3EI64_V }, // 3775
  { PseudoVLOXSEG3EI64_V_M1_MF4_MASK, VLOXSEG3EI64_V }, // 3776
  { PseudoVLOXSEG3EI64_V_M1_MF8, VLOXSEG3EI64_V }, // 3777
  { PseudoVLOXSEG3EI64_V_M1_MF8_MASK, VLOXSEG3EI64_V }, // 3778
  { PseudoVLOXSEG3EI64_V_M2_M1, VLOXSEG3EI64_V }, // 3779
  { PseudoVLOXSEG3EI64_V_M2_M1_MASK, VLOXSEG3EI64_V }, // 3780
  { PseudoVLOXSEG3EI64_V_M2_M2, VLOXSEG3EI64_V }, // 3781
  { PseudoVLOXSEG3EI64_V_M2_M2_MASK, VLOXSEG3EI64_V }, // 3782
  { PseudoVLOXSEG3EI64_V_M2_MF2, VLOXSEG3EI64_V }, // 3783
  { PseudoVLOXSEG3EI64_V_M2_MF2_MASK, VLOXSEG3EI64_V }, // 3784
  { PseudoVLOXSEG3EI64_V_M2_MF4, VLOXSEG3EI64_V }, // 3785
  { PseudoVLOXSEG3EI64_V_M2_MF4_MASK, VLOXSEG3EI64_V }, // 3786
  { PseudoVLOXSEG3EI64_V_M2_MF8, VLOXSEG3EI64_V }, // 3787
  { PseudoVLOXSEG3EI64_V_M2_MF8_MASK, VLOXSEG3EI64_V }, // 3788
  { PseudoVLOXSEG3EI64_V_M4_M1, VLOXSEG3EI64_V }, // 3789
  { PseudoVLOXSEG3EI64_V_M4_M1_MASK, VLOXSEG3EI64_V }, // 3790
  { PseudoVLOXSEG3EI64_V_M4_M2, VLOXSEG3EI64_V }, // 3791
  { PseudoVLOXSEG3EI64_V_M4_M2_MASK, VLOXSEG3EI64_V }, // 3792
  { PseudoVLOXSEG3EI64_V_M4_MF2, VLOXSEG3EI64_V }, // 3793
  { PseudoVLOXSEG3EI64_V_M4_MF2_MASK, VLOXSEG3EI64_V }, // 3794
  { PseudoVLOXSEG3EI64_V_M4_MF4, VLOXSEG3EI64_V }, // 3795
  { PseudoVLOXSEG3EI64_V_M4_MF4_MASK, VLOXSEG3EI64_V }, // 3796
  { PseudoVLOXSEG3EI64_V_M4_MF8, VLOXSEG3EI64_V }, // 3797
  { PseudoVLOXSEG3EI64_V_M4_MF8_MASK, VLOXSEG3EI64_V }, // 3798
  { PseudoVLOXSEG3EI64_V_M8_M1, VLOXSEG3EI64_V }, // 3799
  { PseudoVLOXSEG3EI64_V_M8_M1_MASK, VLOXSEG3EI64_V }, // 3800
  { PseudoVLOXSEG3EI64_V_M8_M2, VLOXSEG3EI64_V }, // 3801
  { PseudoVLOXSEG3EI64_V_M8_M2_MASK, VLOXSEG3EI64_V }, // 3802
  { PseudoVLOXSEG3EI64_V_M8_MF2, VLOXSEG3EI64_V }, // 3803
  { PseudoVLOXSEG3EI64_V_M8_MF2_MASK, VLOXSEG3EI64_V }, // 3804
  { PseudoVLOXSEG3EI64_V_M8_MF4, VLOXSEG3EI64_V }, // 3805
  { PseudoVLOXSEG3EI64_V_M8_MF4_MASK, VLOXSEG3EI64_V }, // 3806
  { PseudoVLOXSEG3EI64_V_M8_MF8, VLOXSEG3EI64_V }, // 3807
  { PseudoVLOXSEG3EI64_V_M8_MF8_MASK, VLOXSEG3EI64_V }, // 3808
  { PseudoVLOXSEG3EI8_V_M1_M1, VLOXSEG3EI8_V }, // 3809
  { PseudoVLOXSEG3EI8_V_M1_M1_MASK, VLOXSEG3EI8_V }, // 3810
  { PseudoVLOXSEG3EI8_V_M1_M2, VLOXSEG3EI8_V }, // 3811
  { PseudoVLOXSEG3EI8_V_M1_M2_MASK, VLOXSEG3EI8_V }, // 3812
  { PseudoVLOXSEG3EI8_V_M1_MF2, VLOXSEG3EI8_V }, // 3813
  { PseudoVLOXSEG3EI8_V_M1_MF2_MASK, VLOXSEG3EI8_V }, // 3814
  { PseudoVLOXSEG3EI8_V_M1_MF4, VLOXSEG3EI8_V }, // 3815
  { PseudoVLOXSEG3EI8_V_M1_MF4_MASK, VLOXSEG3EI8_V }, // 3816
  { PseudoVLOXSEG3EI8_V_M1_MF8, VLOXSEG3EI8_V }, // 3817
  { PseudoVLOXSEG3EI8_V_M1_MF8_MASK, VLOXSEG3EI8_V }, // 3818
  { PseudoVLOXSEG3EI8_V_M2_M1, VLOXSEG3EI8_V }, // 3819
  { PseudoVLOXSEG3EI8_V_M2_M1_MASK, VLOXSEG3EI8_V }, // 3820
  { PseudoVLOXSEG3EI8_V_M2_M2, VLOXSEG3EI8_V }, // 3821
  { PseudoVLOXSEG3EI8_V_M2_M2_MASK, VLOXSEG3EI8_V }, // 3822
  { PseudoVLOXSEG3EI8_V_M2_MF2, VLOXSEG3EI8_V }, // 3823
  { PseudoVLOXSEG3EI8_V_M2_MF2_MASK, VLOXSEG3EI8_V }, // 3824
  { PseudoVLOXSEG3EI8_V_M2_MF4, VLOXSEG3EI8_V }, // 3825
  { PseudoVLOXSEG3EI8_V_M2_MF4_MASK, VLOXSEG3EI8_V }, // 3826
  { PseudoVLOXSEG3EI8_V_M2_MF8, VLOXSEG3EI8_V }, // 3827
  { PseudoVLOXSEG3EI8_V_M2_MF8_MASK, VLOXSEG3EI8_V }, // 3828
  { PseudoVLOXSEG3EI8_V_M4_M1, VLOXSEG3EI8_V }, // 3829
  { PseudoVLOXSEG3EI8_V_M4_M1_MASK, VLOXSEG3EI8_V }, // 3830
  { PseudoVLOXSEG3EI8_V_M4_M2, VLOXSEG3EI8_V }, // 3831
  { PseudoVLOXSEG3EI8_V_M4_M2_MASK, VLOXSEG3EI8_V }, // 3832
  { PseudoVLOXSEG3EI8_V_M4_MF2, VLOXSEG3EI8_V }, // 3833
  { PseudoVLOXSEG3EI8_V_M4_MF2_MASK, VLOXSEG3EI8_V }, // 3834
  { PseudoVLOXSEG3EI8_V_M4_MF4, VLOXSEG3EI8_V }, // 3835
  { PseudoVLOXSEG3EI8_V_M4_MF4_MASK, VLOXSEG3EI8_V }, // 3836
  { PseudoVLOXSEG3EI8_V_M4_MF8, VLOXSEG3EI8_V }, // 3837
  { PseudoVLOXSEG3EI8_V_M4_MF8_MASK, VLOXSEG3EI8_V }, // 3838
  { PseudoVLOXSEG3EI8_V_M8_M1, VLOXSEG3EI8_V }, // 3839
  { PseudoVLOXSEG3EI8_V_M8_M1_MASK, VLOXSEG3EI8_V }, // 3840
  { PseudoVLOXSEG3EI8_V_M8_M2, VLOXSEG3EI8_V }, // 3841
  { PseudoVLOXSEG3EI8_V_M8_M2_MASK, VLOXSEG3EI8_V }, // 3842
  { PseudoVLOXSEG3EI8_V_M8_MF2, VLOXSEG3EI8_V }, // 3843
  { PseudoVLOXSEG3EI8_V_M8_MF2_MASK, VLOXSEG3EI8_V }, // 3844
  { PseudoVLOXSEG3EI8_V_M8_MF4, VLOXSEG3EI8_V }, // 3845
  { PseudoVLOXSEG3EI8_V_M8_MF4_MASK, VLOXSEG3EI8_V }, // 3846
  { PseudoVLOXSEG3EI8_V_M8_MF8, VLOXSEG3EI8_V }, // 3847
  { PseudoVLOXSEG3EI8_V_M8_MF8_MASK, VLOXSEG3EI8_V }, // 3848
  { PseudoVLOXSEG3EI8_V_MF2_M1, VLOXSEG3EI8_V }, // 3849
  { PseudoVLOXSEG3EI8_V_MF2_M1_MASK, VLOXSEG3EI8_V }, // 3850
  { PseudoVLOXSEG3EI8_V_MF2_M2, VLOXSEG3EI8_V }, // 3851
  { PseudoVLOXSEG3EI8_V_MF2_M2_MASK, VLOXSEG3EI8_V }, // 3852
  { PseudoVLOXSEG3EI8_V_MF2_MF2, VLOXSEG3EI8_V }, // 3853
  { PseudoVLOXSEG3EI8_V_MF2_MF2_MASK, VLOXSEG3EI8_V }, // 3854
  { PseudoVLOXSEG3EI8_V_MF2_MF4, VLOXSEG3EI8_V }, // 3855
  { PseudoVLOXSEG3EI8_V_MF2_MF4_MASK, VLOXSEG3EI8_V }, // 3856
  { PseudoVLOXSEG3EI8_V_MF2_MF8, VLOXSEG3EI8_V }, // 3857
  { PseudoVLOXSEG3EI8_V_MF2_MF8_MASK, VLOXSEG3EI8_V }, // 3858
  { PseudoVLOXSEG3EI8_V_MF4_M1, VLOXSEG3EI8_V }, // 3859
  { PseudoVLOXSEG3EI8_V_MF4_M1_MASK, VLOXSEG3EI8_V }, // 3860
  { PseudoVLOXSEG3EI8_V_MF4_M2, VLOXSEG3EI8_V }, // 3861
  { PseudoVLOXSEG3EI8_V_MF4_M2_MASK, VLOXSEG3EI8_V }, // 3862
  { PseudoVLOXSEG3EI8_V_MF4_MF2, VLOXSEG3EI8_V }, // 3863
  { PseudoVLOXSEG3EI8_V_MF4_MF2_MASK, VLOXSEG3EI8_V }, // 3864
  { PseudoVLOXSEG3EI8_V_MF4_MF4, VLOXSEG3EI8_V }, // 3865
  { PseudoVLOXSEG3EI8_V_MF4_MF4_MASK, VLOXSEG3EI8_V }, // 3866
  { PseudoVLOXSEG3EI8_V_MF4_MF8, VLOXSEG3EI8_V }, // 3867
  { PseudoVLOXSEG3EI8_V_MF4_MF8_MASK, VLOXSEG3EI8_V }, // 3868
  { PseudoVLOXSEG3EI8_V_MF8_M1, VLOXSEG3EI8_V }, // 3869
  { PseudoVLOXSEG3EI8_V_MF8_M1_MASK, VLOXSEG3EI8_V }, // 3870
  { PseudoVLOXSEG3EI8_V_MF8_M2, VLOXSEG3EI8_V }, // 3871
  { PseudoVLOXSEG3EI8_V_MF8_M2_MASK, VLOXSEG3EI8_V }, // 3872
  { PseudoVLOXSEG3EI8_V_MF8_MF2, VLOXSEG3EI8_V }, // 3873
  { PseudoVLOXSEG3EI8_V_MF8_MF2_MASK, VLOXSEG3EI8_V }, // 3874
  { PseudoVLOXSEG3EI8_V_MF8_MF4, VLOXSEG3EI8_V }, // 3875
  { PseudoVLOXSEG3EI8_V_MF8_MF4_MASK, VLOXSEG3EI8_V }, // 3876
  { PseudoVLOXSEG3EI8_V_MF8_MF8, VLOXSEG3EI8_V }, // 3877
  { PseudoVLOXSEG3EI8_V_MF8_MF8_MASK, VLOXSEG3EI8_V }, // 3878
  { PseudoVLOXSEG4EI16_V_M1_M1, VLOXSEG4EI16_V }, // 3879
  { PseudoVLOXSEG4EI16_V_M1_M1_MASK, VLOXSEG4EI16_V }, // 3880
  { PseudoVLOXSEG4EI16_V_M1_M2, VLOXSEG4EI16_V }, // 3881
  { PseudoVLOXSEG4EI16_V_M1_M2_MASK, VLOXSEG4EI16_V }, // 3882
  { PseudoVLOXSEG4EI16_V_M1_MF2, VLOXSEG4EI16_V }, // 3883
  { PseudoVLOXSEG4EI16_V_M1_MF2_MASK, VLOXSEG4EI16_V }, // 3884
  { PseudoVLOXSEG4EI16_V_M1_MF4, VLOXSEG4EI16_V }, // 3885
  { PseudoVLOXSEG4EI16_V_M1_MF4_MASK, VLOXSEG4EI16_V }, // 3886
  { PseudoVLOXSEG4EI16_V_M1_MF8, VLOXSEG4EI16_V }, // 3887
  { PseudoVLOXSEG4EI16_V_M1_MF8_MASK, VLOXSEG4EI16_V }, // 3888
  { PseudoVLOXSEG4EI16_V_M2_M1, VLOXSEG4EI16_V }, // 3889
  { PseudoVLOXSEG4EI16_V_M2_M1_MASK, VLOXSEG4EI16_V }, // 3890
  { PseudoVLOXSEG4EI16_V_M2_M2, VLOXSEG4EI16_V }, // 3891
  { PseudoVLOXSEG4EI16_V_M2_M2_MASK, VLOXSEG4EI16_V }, // 3892
  { PseudoVLOXSEG4EI16_V_M2_MF2, VLOXSEG4EI16_V }, // 3893
  { PseudoVLOXSEG4EI16_V_M2_MF2_MASK, VLOXSEG4EI16_V }, // 3894
  { PseudoVLOXSEG4EI16_V_M2_MF4, VLOXSEG4EI16_V }, // 3895
  { PseudoVLOXSEG4EI16_V_M2_MF4_MASK, VLOXSEG4EI16_V }, // 3896
  { PseudoVLOXSEG4EI16_V_M2_MF8, VLOXSEG4EI16_V }, // 3897
  { PseudoVLOXSEG4EI16_V_M2_MF8_MASK, VLOXSEG4EI16_V }, // 3898
  { PseudoVLOXSEG4EI16_V_M4_M1, VLOXSEG4EI16_V }, // 3899
  { PseudoVLOXSEG4EI16_V_M4_M1_MASK, VLOXSEG4EI16_V }, // 3900
  { PseudoVLOXSEG4EI16_V_M4_M2, VLOXSEG4EI16_V }, // 3901
  { PseudoVLOXSEG4EI16_V_M4_M2_MASK, VLOXSEG4EI16_V }, // 3902
  { PseudoVLOXSEG4EI16_V_M4_MF2, VLOXSEG4EI16_V }, // 3903
  { PseudoVLOXSEG4EI16_V_M4_MF2_MASK, VLOXSEG4EI16_V }, // 3904
  { PseudoVLOXSEG4EI16_V_M4_MF4, VLOXSEG4EI16_V }, // 3905
  { PseudoVLOXSEG4EI16_V_M4_MF4_MASK, VLOXSEG4EI16_V }, // 3906
  { PseudoVLOXSEG4EI16_V_M4_MF8, VLOXSEG4EI16_V }, // 3907
  { PseudoVLOXSEG4EI16_V_M4_MF8_MASK, VLOXSEG4EI16_V }, // 3908
  { PseudoVLOXSEG4EI16_V_M8_M1, VLOXSEG4EI16_V }, // 3909
  { PseudoVLOXSEG4EI16_V_M8_M1_MASK, VLOXSEG4EI16_V }, // 3910
  { PseudoVLOXSEG4EI16_V_M8_M2, VLOXSEG4EI16_V }, // 3911
  { PseudoVLOXSEG4EI16_V_M8_M2_MASK, VLOXSEG4EI16_V }, // 3912
  { PseudoVLOXSEG4EI16_V_M8_MF2, VLOXSEG4EI16_V }, // 3913
  { PseudoVLOXSEG4EI16_V_M8_MF2_MASK, VLOXSEG4EI16_V }, // 3914
  { PseudoVLOXSEG4EI16_V_M8_MF4, VLOXSEG4EI16_V }, // 3915
  { PseudoVLOXSEG4EI16_V_M8_MF4_MASK, VLOXSEG4EI16_V }, // 3916
  { PseudoVLOXSEG4EI16_V_M8_MF8, VLOXSEG4EI16_V }, // 3917
  { PseudoVLOXSEG4EI16_V_M8_MF8_MASK, VLOXSEG4EI16_V }, // 3918
  { PseudoVLOXSEG4EI16_V_MF2_M1, VLOXSEG4EI16_V }, // 3919
  { PseudoVLOXSEG4EI16_V_MF2_M1_MASK, VLOXSEG4EI16_V }, // 3920
  { PseudoVLOXSEG4EI16_V_MF2_M2, VLOXSEG4EI16_V }, // 3921
  { PseudoVLOXSEG4EI16_V_MF2_M2_MASK, VLOXSEG4EI16_V }, // 3922
  { PseudoVLOXSEG4EI16_V_MF2_MF2, VLOXSEG4EI16_V }, // 3923
  { PseudoVLOXSEG4EI16_V_MF2_MF2_MASK, VLOXSEG4EI16_V }, // 3924
  { PseudoVLOXSEG4EI16_V_MF2_MF4, VLOXSEG4EI16_V }, // 3925
  { PseudoVLOXSEG4EI16_V_MF2_MF4_MASK, VLOXSEG4EI16_V }, // 3926
  { PseudoVLOXSEG4EI16_V_MF2_MF8, VLOXSEG4EI16_V }, // 3927
  { PseudoVLOXSEG4EI16_V_MF2_MF8_MASK, VLOXSEG4EI16_V }, // 3928
  { PseudoVLOXSEG4EI16_V_MF4_M1, VLOXSEG4EI16_V }, // 3929
  { PseudoVLOXSEG4EI16_V_MF4_M1_MASK, VLOXSEG4EI16_V }, // 3930
  { PseudoVLOXSEG4EI16_V_MF4_M2, VLOXSEG4EI16_V }, // 3931
  { PseudoVLOXSEG4EI16_V_MF4_M2_MASK, VLOXSEG4EI16_V }, // 3932
  { PseudoVLOXSEG4EI16_V_MF4_MF2, VLOXSEG4EI16_V }, // 3933
  { PseudoVLOXSEG4EI16_V_MF4_MF2_MASK, VLOXSEG4EI16_V }, // 3934
  { PseudoVLOXSEG4EI16_V_MF4_MF4, VLOXSEG4EI16_V }, // 3935
  { PseudoVLOXSEG4EI16_V_MF4_MF4_MASK, VLOXSEG4EI16_V }, // 3936
  { PseudoVLOXSEG4EI16_V_MF4_MF8, VLOXSEG4EI16_V }, // 3937
  { PseudoVLOXSEG4EI16_V_MF4_MF8_MASK, VLOXSEG4EI16_V }, // 3938
  { PseudoVLOXSEG4EI32_V_M1_M1, VLOXSEG4EI32_V }, // 3939
  { PseudoVLOXSEG4EI32_V_M1_M1_MASK, VLOXSEG4EI32_V }, // 3940
  { PseudoVLOXSEG4EI32_V_M1_M2, VLOXSEG4EI32_V }, // 3941
  { PseudoVLOXSEG4EI32_V_M1_M2_MASK, VLOXSEG4EI32_V }, // 3942
  { PseudoVLOXSEG4EI32_V_M1_MF2, VLOXSEG4EI32_V }, // 3943
  { PseudoVLOXSEG4EI32_V_M1_MF2_MASK, VLOXSEG4EI32_V }, // 3944
  { PseudoVLOXSEG4EI32_V_M1_MF4, VLOXSEG4EI32_V }, // 3945
  { PseudoVLOXSEG4EI32_V_M1_MF4_MASK, VLOXSEG4EI32_V }, // 3946
  { PseudoVLOXSEG4EI32_V_M1_MF8, VLOXSEG4EI32_V }, // 3947
  { PseudoVLOXSEG4EI32_V_M1_MF8_MASK, VLOXSEG4EI32_V }, // 3948
  { PseudoVLOXSEG4EI32_V_M2_M1, VLOXSEG4EI32_V }, // 3949
  { PseudoVLOXSEG4EI32_V_M2_M1_MASK, VLOXSEG4EI32_V }, // 3950
  { PseudoVLOXSEG4EI32_V_M2_M2, VLOXSEG4EI32_V }, // 3951
  { PseudoVLOXSEG4EI32_V_M2_M2_MASK, VLOXSEG4EI32_V }, // 3952
  { PseudoVLOXSEG4EI32_V_M2_MF2, VLOXSEG4EI32_V }, // 3953
  { PseudoVLOXSEG4EI32_V_M2_MF2_MASK, VLOXSEG4EI32_V }, // 3954
  { PseudoVLOXSEG4EI32_V_M2_MF4, VLOXSEG4EI32_V }, // 3955
  { PseudoVLOXSEG4EI32_V_M2_MF4_MASK, VLOXSEG4EI32_V }, // 3956
  { PseudoVLOXSEG4EI32_V_M2_MF8, VLOXSEG4EI32_V }, // 3957
  { PseudoVLOXSEG4EI32_V_M2_MF8_MASK, VLOXSEG4EI32_V }, // 3958
  { PseudoVLOXSEG4EI32_V_M4_M1, VLOXSEG4EI32_V }, // 3959
  { PseudoVLOXSEG4EI32_V_M4_M1_MASK, VLOXSEG4EI32_V }, // 3960
  { PseudoVLOXSEG4EI32_V_M4_M2, VLOXSEG4EI32_V }, // 3961
  { PseudoVLOXSEG4EI32_V_M4_M2_MASK, VLOXSEG4EI32_V }, // 3962
  { PseudoVLOXSEG4EI32_V_M4_MF2, VLOXSEG4EI32_V }, // 3963
  { PseudoVLOXSEG4EI32_V_M4_MF2_MASK, VLOXSEG4EI32_V }, // 3964
  { PseudoVLOXSEG4EI32_V_M4_MF4, VLOXSEG4EI32_V }, // 3965
  { PseudoVLOXSEG4EI32_V_M4_MF4_MASK, VLOXSEG4EI32_V }, // 3966
  { PseudoVLOXSEG4EI32_V_M4_MF8, VLOXSEG4EI32_V }, // 3967
  { PseudoVLOXSEG4EI32_V_M4_MF8_MASK, VLOXSEG4EI32_V }, // 3968
  { PseudoVLOXSEG4EI32_V_M8_M1, VLOXSEG4EI32_V }, // 3969
  { PseudoVLOXSEG4EI32_V_M8_M1_MASK, VLOXSEG4EI32_V }, // 3970
  { PseudoVLOXSEG4EI32_V_M8_M2, VLOXSEG4EI32_V }, // 3971
  { PseudoVLOXSEG4EI32_V_M8_M2_MASK, VLOXSEG4EI32_V }, // 3972
  { PseudoVLOXSEG4EI32_V_M8_MF2, VLOXSEG4EI32_V }, // 3973
  { PseudoVLOXSEG4EI32_V_M8_MF2_MASK, VLOXSEG4EI32_V }, // 3974
  { PseudoVLOXSEG4EI32_V_M8_MF4, VLOXSEG4EI32_V }, // 3975
  { PseudoVLOXSEG4EI32_V_M8_MF4_MASK, VLOXSEG4EI32_V }, // 3976
  { PseudoVLOXSEG4EI32_V_M8_MF8, VLOXSEG4EI32_V }, // 3977
  { PseudoVLOXSEG4EI32_V_M8_MF8_MASK, VLOXSEG4EI32_V }, // 3978
  { PseudoVLOXSEG4EI32_V_MF2_M1, VLOXSEG4EI32_V }, // 3979
  { PseudoVLOXSEG4EI32_V_MF2_M1_MASK, VLOXSEG4EI32_V }, // 3980
  { PseudoVLOXSEG4EI32_V_MF2_M2, VLOXSEG4EI32_V }, // 3981
  { PseudoVLOXSEG4EI32_V_MF2_M2_MASK, VLOXSEG4EI32_V }, // 3982
  { PseudoVLOXSEG4EI32_V_MF2_MF2, VLOXSEG4EI32_V }, // 3983
  { PseudoVLOXSEG4EI32_V_MF2_MF2_MASK, VLOXSEG4EI32_V }, // 3984
  { PseudoVLOXSEG4EI32_V_MF2_MF4, VLOXSEG4EI32_V }, // 3985
  { PseudoVLOXSEG4EI32_V_MF2_MF4_MASK, VLOXSEG4EI32_V }, // 3986
  { PseudoVLOXSEG4EI32_V_MF2_MF8, VLOXSEG4EI32_V }, // 3987
  { PseudoVLOXSEG4EI32_V_MF2_MF8_MASK, VLOXSEG4EI32_V }, // 3988
  { PseudoVLOXSEG4EI64_V_M1_M1, VLOXSEG4EI64_V }, // 3989
  { PseudoVLOXSEG4EI64_V_M1_M1_MASK, VLOXSEG4EI64_V }, // 3990
  { PseudoVLOXSEG4EI64_V_M1_M2, VLOXSEG4EI64_V }, // 3991
  { PseudoVLOXSEG4EI64_V_M1_M2_MASK, VLOXSEG4EI64_V }, // 3992
  { PseudoVLOXSEG4EI64_V_M1_MF2, VLOXSEG4EI64_V }, // 3993
  { PseudoVLOXSEG4EI64_V_M1_MF2_MASK, VLOXSEG4EI64_V }, // 3994
  { PseudoVLOXSEG4EI64_V_M1_MF4, VLOXSEG4EI64_V }, // 3995
  { PseudoVLOXSEG4EI64_V_M1_MF4_MASK, VLOXSEG4EI64_V }, // 3996
  { PseudoVLOXSEG4EI64_V_M1_MF8, VLOXSEG4EI64_V }, // 3997
  { PseudoVLOXSEG4EI64_V_M1_MF8_MASK, VLOXSEG4EI64_V }, // 3998
  { PseudoVLOXSEG4EI64_V_M2_M1, VLOXSEG4EI64_V }, // 3999
  { PseudoVLOXSEG4EI64_V_M2_M1_MASK, VLOXSEG4EI64_V }, // 4000
  { PseudoVLOXSEG4EI64_V_M2_M2, VLOXSEG4EI64_V }, // 4001
  { PseudoVLOXSEG4EI64_V_M2_M2_MASK, VLOXSEG4EI64_V }, // 4002
  { PseudoVLOXSEG4EI64_V_M2_MF2, VLOXSEG4EI64_V }, // 4003
  { PseudoVLOXSEG4EI64_V_M2_MF2_MASK, VLOXSEG4EI64_V }, // 4004
  { PseudoVLOXSEG4EI64_V_M2_MF4, VLOXSEG4EI64_V }, // 4005
  { PseudoVLOXSEG4EI64_V_M2_MF4_MASK, VLOXSEG4EI64_V }, // 4006
  { PseudoVLOXSEG4EI64_V_M2_MF8, VLOXSEG4EI64_V }, // 4007
  { PseudoVLOXSEG4EI64_V_M2_MF8_MASK, VLOXSEG4EI64_V }, // 4008
  { PseudoVLOXSEG4EI64_V_M4_M1, VLOXSEG4EI64_V }, // 4009
  { PseudoVLOXSEG4EI64_V_M4_M1_MASK, VLOXSEG4EI64_V }, // 4010
  { PseudoVLOXSEG4EI64_V_M4_M2, VLOXSEG4EI64_V }, // 4011
  { PseudoVLOXSEG4EI64_V_M4_M2_MASK, VLOXSEG4EI64_V }, // 4012
  { PseudoVLOXSEG4EI64_V_M4_MF2, VLOXSEG4EI64_V }, // 4013
  { PseudoVLOXSEG4EI64_V_M4_MF2_MASK, VLOXSEG4EI64_V }, // 4014
  { PseudoVLOXSEG4EI64_V_M4_MF4, VLOXSEG4EI64_V }, // 4015
  { PseudoVLOXSEG4EI64_V_M4_MF4_MASK, VLOXSEG4EI64_V }, // 4016
  { PseudoVLOXSEG4EI64_V_M4_MF8, VLOXSEG4EI64_V }, // 4017
  { PseudoVLOXSEG4EI64_V_M4_MF8_MASK, VLOXSEG4EI64_V }, // 4018
  { PseudoVLOXSEG4EI64_V_M8_M1, VLOXSEG4EI64_V }, // 4019
  { PseudoVLOXSEG4EI64_V_M8_M1_MASK, VLOXSEG4EI64_V }, // 4020
  { PseudoVLOXSEG4EI64_V_M8_M2, VLOXSEG4EI64_V }, // 4021
  { PseudoVLOXSEG4EI64_V_M8_M2_MASK, VLOXSEG4EI64_V }, // 4022
  { PseudoVLOXSEG4EI64_V_M8_MF2, VLOXSEG4EI64_V }, // 4023
  { PseudoVLOXSEG4EI64_V_M8_MF2_MASK, VLOXSEG4EI64_V }, // 4024
  { PseudoVLOXSEG4EI64_V_M8_MF4, VLOXSEG4EI64_V }, // 4025
  { PseudoVLOXSEG4EI64_V_M8_MF4_MASK, VLOXSEG4EI64_V }, // 4026
  { PseudoVLOXSEG4EI64_V_M8_MF8, VLOXSEG4EI64_V }, // 4027
  { PseudoVLOXSEG4EI64_V_M8_MF8_MASK, VLOXSEG4EI64_V }, // 4028
  { PseudoVLOXSEG4EI8_V_M1_M1, VLOXSEG4EI8_V }, // 4029
  { PseudoVLOXSEG4EI8_V_M1_M1_MASK, VLOXSEG4EI8_V }, // 4030
  { PseudoVLOXSEG4EI8_V_M1_M2, VLOXSEG4EI8_V }, // 4031
  { PseudoVLOXSEG4EI8_V_M1_M2_MASK, VLOXSEG4EI8_V }, // 4032
  { PseudoVLOXSEG4EI8_V_M1_MF2, VLOXSEG4EI8_V }, // 4033
  { PseudoVLOXSEG4EI8_V_M1_MF2_MASK, VLOXSEG4EI8_V }, // 4034
  { PseudoVLOXSEG4EI8_V_M1_MF4, VLOXSEG4EI8_V }, // 4035
  { PseudoVLOXSEG4EI8_V_M1_MF4_MASK, VLOXSEG4EI8_V }, // 4036
  { PseudoVLOXSEG4EI8_V_M1_MF8, VLOXSEG4EI8_V }, // 4037
  { PseudoVLOXSEG4EI8_V_M1_MF8_MASK, VLOXSEG4EI8_V }, // 4038
  { PseudoVLOXSEG4EI8_V_M2_M1, VLOXSEG4EI8_V }, // 4039
  { PseudoVLOXSEG4EI8_V_M2_M1_MASK, VLOXSEG4EI8_V }, // 4040
  { PseudoVLOXSEG4EI8_V_M2_M2, VLOXSEG4EI8_V }, // 4041
  { PseudoVLOXSEG4EI8_V_M2_M2_MASK, VLOXSEG4EI8_V }, // 4042
  { PseudoVLOXSEG4EI8_V_M2_MF2, VLOXSEG4EI8_V }, // 4043
  { PseudoVLOXSEG4EI8_V_M2_MF2_MASK, VLOXSEG4EI8_V }, // 4044
  { PseudoVLOXSEG4EI8_V_M2_MF4, VLOXSEG4EI8_V }, // 4045
  { PseudoVLOXSEG4EI8_V_M2_MF4_MASK, VLOXSEG4EI8_V }, // 4046
  { PseudoVLOXSEG4EI8_V_M2_MF8, VLOXSEG4EI8_V }, // 4047
  { PseudoVLOXSEG4EI8_V_M2_MF8_MASK, VLOXSEG4EI8_V }, // 4048
  { PseudoVLOXSEG4EI8_V_M4_M1, VLOXSEG4EI8_V }, // 4049
  { PseudoVLOXSEG4EI8_V_M4_M1_MASK, VLOXSEG4EI8_V }, // 4050
  { PseudoVLOXSEG4EI8_V_M4_M2, VLOXSEG4EI8_V }, // 4051
  { PseudoVLOXSEG4EI8_V_M4_M2_MASK, VLOXSEG4EI8_V }, // 4052
  { PseudoVLOXSEG4EI8_V_M4_MF2, VLOXSEG4EI8_V }, // 4053
  { PseudoVLOXSEG4EI8_V_M4_MF2_MASK, VLOXSEG4EI8_V }, // 4054
  { PseudoVLOXSEG4EI8_V_M4_MF4, VLOXSEG4EI8_V }, // 4055
  { PseudoVLOXSEG4EI8_V_M4_MF4_MASK, VLOXSEG4EI8_V }, // 4056
  { PseudoVLOXSEG4EI8_V_M4_MF8, VLOXSEG4EI8_V }, // 4057
  { PseudoVLOXSEG4EI8_V_M4_MF8_MASK, VLOXSEG4EI8_V }, // 4058
  { PseudoVLOXSEG4EI8_V_M8_M1, VLOXSEG4EI8_V }, // 4059
  { PseudoVLOXSEG4EI8_V_M8_M1_MASK, VLOXSEG4EI8_V }, // 4060
  { PseudoVLOXSEG4EI8_V_M8_M2, VLOXSEG4EI8_V }, // 4061
  { PseudoVLOXSEG4EI8_V_M8_M2_MASK, VLOXSEG4EI8_V }, // 4062
  { PseudoVLOXSEG4EI8_V_M8_MF2, VLOXSEG4EI8_V }, // 4063
  { PseudoVLOXSEG4EI8_V_M8_MF2_MASK, VLOXSEG4EI8_V }, // 4064
  { PseudoVLOXSEG4EI8_V_M8_MF4, VLOXSEG4EI8_V }, // 4065
  { PseudoVLOXSEG4EI8_V_M8_MF4_MASK, VLOXSEG4EI8_V }, // 4066
  { PseudoVLOXSEG4EI8_V_M8_MF8, VLOXSEG4EI8_V }, // 4067
  { PseudoVLOXSEG4EI8_V_M8_MF8_MASK, VLOXSEG4EI8_V }, // 4068
  { PseudoVLOXSEG4EI8_V_MF2_M1, VLOXSEG4EI8_V }, // 4069
  { PseudoVLOXSEG4EI8_V_MF2_M1_MASK, VLOXSEG4EI8_V }, // 4070
  { PseudoVLOXSEG4EI8_V_MF2_M2, VLOXSEG4EI8_V }, // 4071
  { PseudoVLOXSEG4EI8_V_MF2_M2_MASK, VLOXSEG4EI8_V }, // 4072
  { PseudoVLOXSEG4EI8_V_MF2_MF2, VLOXSEG4EI8_V }, // 4073
  { PseudoVLOXSEG4EI8_V_MF2_MF2_MASK, VLOXSEG4EI8_V }, // 4074
  { PseudoVLOXSEG4EI8_V_MF2_MF4, VLOXSEG4EI8_V }, // 4075
  { PseudoVLOXSEG4EI8_V_MF2_MF4_MASK, VLOXSEG4EI8_V }, // 4076
  { PseudoVLOXSEG4EI8_V_MF2_MF8, VLOXSEG4EI8_V }, // 4077
  { PseudoVLOXSEG4EI8_V_MF2_MF8_MASK, VLOXSEG4EI8_V }, // 4078
  { PseudoVLOXSEG4EI8_V_MF4_M1, VLOXSEG4EI8_V }, // 4079
  { PseudoVLOXSEG4EI8_V_MF4_M1_MASK, VLOXSEG4EI8_V }, // 4080
  { PseudoVLOXSEG4EI8_V_MF4_M2, VLOXSEG4EI8_V }, // 4081
  { PseudoVLOXSEG4EI8_V_MF4_M2_MASK, VLOXSEG4EI8_V }, // 4082
  { PseudoVLOXSEG4EI8_V_MF4_MF2, VLOXSEG4EI8_V }, // 4083
  { PseudoVLOXSEG4EI8_V_MF4_MF2_MASK, VLOXSEG4EI8_V }, // 4084
  { PseudoVLOXSEG4EI8_V_MF4_MF4, VLOXSEG4EI8_V }, // 4085
  { PseudoVLOXSEG4EI8_V_MF4_MF4_MASK, VLOXSEG4EI8_V }, // 4086
  { PseudoVLOXSEG4EI8_V_MF4_MF8, VLOXSEG4EI8_V }, // 4087
  { PseudoVLOXSEG4EI8_V_MF4_MF8_MASK, VLOXSEG4EI8_V }, // 4088
  { PseudoVLOXSEG4EI8_V_MF8_M1, VLOXSEG4EI8_V }, // 4089
  { PseudoVLOXSEG4EI8_V_MF8_M1_MASK, VLOXSEG4EI8_V }, // 4090
  { PseudoVLOXSEG4EI8_V_MF8_M2, VLOXSEG4EI8_V }, // 4091
  { PseudoVLOXSEG4EI8_V_MF8_M2_MASK, VLOXSEG4EI8_V }, // 4092
  { PseudoVLOXSEG4EI8_V_MF8_MF2, VLOXSEG4EI8_V }, // 4093
  { PseudoVLOXSEG4EI8_V_MF8_MF2_MASK, VLOXSEG4EI8_V }, // 4094
  { PseudoVLOXSEG4EI8_V_MF8_MF4, VLOXSEG4EI8_V }, // 4095
  { PseudoVLOXSEG4EI8_V_MF8_MF4_MASK, VLOXSEG4EI8_V }, // 4096
  { PseudoVLOXSEG4EI8_V_MF8_MF8, VLOXSEG4EI8_V }, // 4097
  { PseudoVLOXSEG4EI8_V_MF8_MF8_MASK, VLOXSEG4EI8_V }, // 4098
  { PseudoVLOXSEG5EI16_V_M1_M1, VLOXSEG5EI16_V }, // 4099
  { PseudoVLOXSEG5EI16_V_M1_M1_MASK, VLOXSEG5EI16_V }, // 4100
  { PseudoVLOXSEG5EI16_V_M1_MF2, VLOXSEG5EI16_V }, // 4101
  { PseudoVLOXSEG5EI16_V_M1_MF2_MASK, VLOXSEG5EI16_V }, // 4102
  { PseudoVLOXSEG5EI16_V_M1_MF4, VLOXSEG5EI16_V }, // 4103
  { PseudoVLOXSEG5EI16_V_M1_MF4_MASK, VLOXSEG5EI16_V }, // 4104
  { PseudoVLOXSEG5EI16_V_M1_MF8, VLOXSEG5EI16_V }, // 4105
  { PseudoVLOXSEG5EI16_V_M1_MF8_MASK, VLOXSEG5EI16_V }, // 4106
  { PseudoVLOXSEG5EI16_V_M2_M1, VLOXSEG5EI16_V }, // 4107
  { PseudoVLOXSEG5EI16_V_M2_M1_MASK, VLOXSEG5EI16_V }, // 4108
  { PseudoVLOXSEG5EI16_V_M2_MF2, VLOXSEG5EI16_V }, // 4109
  { PseudoVLOXSEG5EI16_V_M2_MF2_MASK, VLOXSEG5EI16_V }, // 4110
  { PseudoVLOXSEG5EI16_V_M2_MF4, VLOXSEG5EI16_V }, // 4111
  { PseudoVLOXSEG5EI16_V_M2_MF4_MASK, VLOXSEG5EI16_V }, // 4112
  { PseudoVLOXSEG5EI16_V_M2_MF8, VLOXSEG5EI16_V }, // 4113
  { PseudoVLOXSEG5EI16_V_M2_MF8_MASK, VLOXSEG5EI16_V }, // 4114
  { PseudoVLOXSEG5EI16_V_M4_M1, VLOXSEG5EI16_V }, // 4115
  { PseudoVLOXSEG5EI16_V_M4_M1_MASK, VLOXSEG5EI16_V }, // 4116
  { PseudoVLOXSEG5EI16_V_M4_MF2, VLOXSEG5EI16_V }, // 4117
  { PseudoVLOXSEG5EI16_V_M4_MF2_MASK, VLOXSEG5EI16_V }, // 4118
  { PseudoVLOXSEG5EI16_V_M4_MF4, VLOXSEG5EI16_V }, // 4119
  { PseudoVLOXSEG5EI16_V_M4_MF4_MASK, VLOXSEG5EI16_V }, // 4120
  { PseudoVLOXSEG5EI16_V_M4_MF8, VLOXSEG5EI16_V }, // 4121
  { PseudoVLOXSEG5EI16_V_M4_MF8_MASK, VLOXSEG5EI16_V }, // 4122
  { PseudoVLOXSEG5EI16_V_M8_M1, VLOXSEG5EI16_V }, // 4123
  { PseudoVLOXSEG5EI16_V_M8_M1_MASK, VLOXSEG5EI16_V }, // 4124
  { PseudoVLOXSEG5EI16_V_M8_MF2, VLOXSEG5EI16_V }, // 4125
  { PseudoVLOXSEG5EI16_V_M8_MF2_MASK, VLOXSEG5EI16_V }, // 4126
  { PseudoVLOXSEG5EI16_V_M8_MF4, VLOXSEG5EI16_V }, // 4127
  { PseudoVLOXSEG5EI16_V_M8_MF4_MASK, VLOXSEG5EI16_V }, // 4128
  { PseudoVLOXSEG5EI16_V_M8_MF8, VLOXSEG5EI16_V }, // 4129
  { PseudoVLOXSEG5EI16_V_M8_MF8_MASK, VLOXSEG5EI16_V }, // 4130
  { PseudoVLOXSEG5EI16_V_MF2_M1, VLOXSEG5EI16_V }, // 4131
  { PseudoVLOXSEG5EI16_V_MF2_M1_MASK, VLOXSEG5EI16_V }, // 4132
  { PseudoVLOXSEG5EI16_V_MF2_MF2, VLOXSEG5EI16_V }, // 4133
  { PseudoVLOXSEG5EI16_V_MF2_MF2_MASK, VLOXSEG5EI16_V }, // 4134
  { PseudoVLOXSEG5EI16_V_MF2_MF4, VLOXSEG5EI16_V }, // 4135
  { PseudoVLOXSEG5EI16_V_MF2_MF4_MASK, VLOXSEG5EI16_V }, // 4136
  { PseudoVLOXSEG5EI16_V_MF2_MF8, VLOXSEG5EI16_V }, // 4137
  { PseudoVLOXSEG5EI16_V_MF2_MF8_MASK, VLOXSEG5EI16_V }, // 4138
  { PseudoVLOXSEG5EI16_V_MF4_M1, VLOXSEG5EI16_V }, // 4139
  { PseudoVLOXSEG5EI16_V_MF4_M1_MASK, VLOXSEG5EI16_V }, // 4140
  { PseudoVLOXSEG5EI16_V_MF4_MF2, VLOXSEG5EI16_V }, // 4141
  { PseudoVLOXSEG5EI16_V_MF4_MF2_MASK, VLOXSEG5EI16_V }, // 4142
  { PseudoVLOXSEG5EI16_V_MF4_MF4, VLOXSEG5EI16_V }, // 4143
  { PseudoVLOXSEG5EI16_V_MF4_MF4_MASK, VLOXSEG5EI16_V }, // 4144
  { PseudoVLOXSEG5EI16_V_MF4_MF8, VLOXSEG5EI16_V }, // 4145
  { PseudoVLOXSEG5EI16_V_MF4_MF8_MASK, VLOXSEG5EI16_V }, // 4146
  { PseudoVLOXSEG5EI32_V_M1_M1, VLOXSEG5EI32_V }, // 4147
  { PseudoVLOXSEG5EI32_V_M1_M1_MASK, VLOXSEG5EI32_V }, // 4148
  { PseudoVLOXSEG5EI32_V_M1_MF2, VLOXSEG5EI32_V }, // 4149
  { PseudoVLOXSEG5EI32_V_M1_MF2_MASK, VLOXSEG5EI32_V }, // 4150
  { PseudoVLOXSEG5EI32_V_M1_MF4, VLOXSEG5EI32_V }, // 4151
  { PseudoVLOXSEG5EI32_V_M1_MF4_MASK, VLOXSEG5EI32_V }, // 4152
  { PseudoVLOXSEG5EI32_V_M1_MF8, VLOXSEG5EI32_V }, // 4153
  { PseudoVLOXSEG5EI32_V_M1_MF8_MASK, VLOXSEG5EI32_V }, // 4154
  { PseudoVLOXSEG5EI32_V_M2_M1, VLOXSEG5EI32_V }, // 4155
  { PseudoVLOXSEG5EI32_V_M2_M1_MASK, VLOXSEG5EI32_V }, // 4156
  { PseudoVLOXSEG5EI32_V_M2_MF2, VLOXSEG5EI32_V }, // 4157
  { PseudoVLOXSEG5EI32_V_M2_MF2_MASK, VLOXSEG5EI32_V }, // 4158
  { PseudoVLOXSEG5EI32_V_M2_MF4, VLOXSEG5EI32_V }, // 4159
  { PseudoVLOXSEG5EI32_V_M2_MF4_MASK, VLOXSEG5EI32_V }, // 4160
  { PseudoVLOXSEG5EI32_V_M2_MF8, VLOXSEG5EI32_V }, // 4161
  { PseudoVLOXSEG5EI32_V_M2_MF8_MASK, VLOXSEG5EI32_V }, // 4162
  { PseudoVLOXSEG5EI32_V_M4_M1, VLOXSEG5EI32_V }, // 4163
  { PseudoVLOXSEG5EI32_V_M4_M1_MASK, VLOXSEG5EI32_V }, // 4164
  { PseudoVLOXSEG5EI32_V_M4_MF2, VLOXSEG5EI32_V }, // 4165
  { PseudoVLOXSEG5EI32_V_M4_MF2_MASK, VLOXSEG5EI32_V }, // 4166
  { PseudoVLOXSEG5EI32_V_M4_MF4, VLOXSEG5EI32_V }, // 4167
  { PseudoVLOXSEG5EI32_V_M4_MF4_MASK, VLOXSEG5EI32_V }, // 4168
  { PseudoVLOXSEG5EI32_V_M4_MF8, VLOXSEG5EI32_V }, // 4169
  { PseudoVLOXSEG5EI32_V_M4_MF8_MASK, VLOXSEG5EI32_V }, // 4170
  { PseudoVLOXSEG5EI32_V_M8_M1, VLOXSEG5EI32_V }, // 4171
  { PseudoVLOXSEG5EI32_V_M8_M1_MASK, VLOXSEG5EI32_V }, // 4172
  { PseudoVLOXSEG5EI32_V_M8_MF2, VLOXSEG5EI32_V }, // 4173
  { PseudoVLOXSEG5EI32_V_M8_MF2_MASK, VLOXSEG5EI32_V }, // 4174
  { PseudoVLOXSEG5EI32_V_M8_MF4, VLOXSEG5EI32_V }, // 4175
  { PseudoVLOXSEG5EI32_V_M8_MF4_MASK, VLOXSEG5EI32_V }, // 4176
  { PseudoVLOXSEG5EI32_V_M8_MF8, VLOXSEG5EI32_V }, // 4177
  { PseudoVLOXSEG5EI32_V_M8_MF8_MASK, VLOXSEG5EI32_V }, // 4178
  { PseudoVLOXSEG5EI32_V_MF2_M1, VLOXSEG5EI32_V }, // 4179
  { PseudoVLOXSEG5EI32_V_MF2_M1_MASK, VLOXSEG5EI32_V }, // 4180
  { PseudoVLOXSEG5EI32_V_MF2_MF2, VLOXSEG5EI32_V }, // 4181
  { PseudoVLOXSEG5EI32_V_MF2_MF2_MASK, VLOXSEG5EI32_V }, // 4182
  { PseudoVLOXSEG5EI32_V_MF2_MF4, VLOXSEG5EI32_V }, // 4183
  { PseudoVLOXSEG5EI32_V_MF2_MF4_MASK, VLOXSEG5EI32_V }, // 4184
  { PseudoVLOXSEG5EI32_V_MF2_MF8, VLOXSEG5EI32_V }, // 4185
  { PseudoVLOXSEG5EI32_V_MF2_MF8_MASK, VLOXSEG5EI32_V }, // 4186
  { PseudoVLOXSEG5EI64_V_M1_M1, VLOXSEG5EI64_V }, // 4187
  { PseudoVLOXSEG5EI64_V_M1_M1_MASK, VLOXSEG5EI64_V }, // 4188
  { PseudoVLOXSEG5EI64_V_M1_MF2, VLOXSEG5EI64_V }, // 4189
  { PseudoVLOXSEG5EI64_V_M1_MF2_MASK, VLOXSEG5EI64_V }, // 4190
  { PseudoVLOXSEG5EI64_V_M1_MF4, VLOXSEG5EI64_V }, // 4191
  { PseudoVLOXSEG5EI64_V_M1_MF4_MASK, VLOXSEG5EI64_V }, // 4192
  { PseudoVLOXSEG5EI64_V_M1_MF8, VLOXSEG5EI64_V }, // 4193
  { PseudoVLOXSEG5EI64_V_M1_MF8_MASK, VLOXSEG5EI64_V }, // 4194
  { PseudoVLOXSEG5EI64_V_M2_M1, VLOXSEG5EI64_V }, // 4195
  { PseudoVLOXSEG5EI64_V_M2_M1_MASK, VLOXSEG5EI64_V }, // 4196
  { PseudoVLOXSEG5EI64_V_M2_MF2, VLOXSEG5EI64_V }, // 4197
  { PseudoVLOXSEG5EI64_V_M2_MF2_MASK, VLOXSEG5EI64_V }, // 4198
  { PseudoVLOXSEG5EI64_V_M2_MF4, VLOXSEG5EI64_V }, // 4199
  { PseudoVLOXSEG5EI64_V_M2_MF4_MASK, VLOXSEG5EI64_V }, // 4200
  { PseudoVLOXSEG5EI64_V_M2_MF8, VLOXSEG5EI64_V }, // 4201
  { PseudoVLOXSEG5EI64_V_M2_MF8_MASK, VLOXSEG5EI64_V }, // 4202
  { PseudoVLOXSEG5EI64_V_M4_M1, VLOXSEG5EI64_V }, // 4203
  { PseudoVLOXSEG5EI64_V_M4_M1_MASK, VLOXSEG5EI64_V }, // 4204
  { PseudoVLOXSEG5EI64_V_M4_MF2, VLOXSEG5EI64_V }, // 4205
  { PseudoVLOXSEG5EI64_V_M4_MF2_MASK, VLOXSEG5EI64_V }, // 4206
  { PseudoVLOXSEG5EI64_V_M4_MF4, VLOXSEG5EI64_V }, // 4207
  { PseudoVLOXSEG5EI64_V_M4_MF4_MASK, VLOXSEG5EI64_V }, // 4208
  { PseudoVLOXSEG5EI64_V_M4_MF8, VLOXSEG5EI64_V }, // 4209
  { PseudoVLOXSEG5EI64_V_M4_MF8_MASK, VLOXSEG5EI64_V }, // 4210
  { PseudoVLOXSEG5EI64_V_M8_M1, VLOXSEG5EI64_V }, // 4211
  { PseudoVLOXSEG5EI64_V_M8_M1_MASK, VLOXSEG5EI64_V }, // 4212
  { PseudoVLOXSEG5EI64_V_M8_MF2, VLOXSEG5EI64_V }, // 4213
  { PseudoVLOXSEG5EI64_V_M8_MF2_MASK, VLOXSEG5EI64_V }, // 4214
  { PseudoVLOXSEG5EI64_V_M8_MF4, VLOXSEG5EI64_V }, // 4215
  { PseudoVLOXSEG5EI64_V_M8_MF4_MASK, VLOXSEG5EI64_V }, // 4216
  { PseudoVLOXSEG5EI64_V_M8_MF8, VLOXSEG5EI64_V }, // 4217
  { PseudoVLOXSEG5EI64_V_M8_MF8_MASK, VLOXSEG5EI64_V }, // 4218
  { PseudoVLOXSEG5EI8_V_M1_M1, VLOXSEG5EI8_V }, // 4219
  { PseudoVLOXSEG5EI8_V_M1_M1_MASK, VLOXSEG5EI8_V }, // 4220
  { PseudoVLOXSEG5EI8_V_M1_MF2, VLOXSEG5EI8_V }, // 4221
  { PseudoVLOXSEG5EI8_V_M1_MF2_MASK, VLOXSEG5EI8_V }, // 4222
  { PseudoVLOXSEG5EI8_V_M1_MF4, VLOXSEG5EI8_V }, // 4223
  { PseudoVLOXSEG5EI8_V_M1_MF4_MASK, VLOXSEG5EI8_V }, // 4224
  { PseudoVLOXSEG5EI8_V_M1_MF8, VLOXSEG5EI8_V }, // 4225
  { PseudoVLOXSEG5EI8_V_M1_MF8_MASK, VLOXSEG5EI8_V }, // 4226
  { PseudoVLOXSEG5EI8_V_M2_M1, VLOXSEG5EI8_V }, // 4227
  { PseudoVLOXSEG5EI8_V_M2_M1_MASK, VLOXSEG5EI8_V }, // 4228
  { PseudoVLOXSEG5EI8_V_M2_MF2, VLOXSEG5EI8_V }, // 4229
  { PseudoVLOXSEG5EI8_V_M2_MF2_MASK, VLOXSEG5EI8_V }, // 4230
  { PseudoVLOXSEG5EI8_V_M2_MF4, VLOXSEG5EI8_V }, // 4231
  { PseudoVLOXSEG5EI8_V_M2_MF4_MASK, VLOXSEG5EI8_V }, // 4232
  { PseudoVLOXSEG5EI8_V_M2_MF8, VLOXSEG5EI8_V }, // 4233
  { PseudoVLOXSEG5EI8_V_M2_MF8_MASK, VLOXSEG5EI8_V }, // 4234
  { PseudoVLOXSEG5EI8_V_M4_M1, VLOXSEG5EI8_V }, // 4235
  { PseudoVLOXSEG5EI8_V_M4_M1_MASK, VLOXSEG5EI8_V }, // 4236
  { PseudoVLOXSEG5EI8_V_M4_MF2, VLOXSEG5EI8_V }, // 4237
  { PseudoVLOXSEG5EI8_V_M4_MF2_MASK, VLOXSEG5EI8_V }, // 4238
  { PseudoVLOXSEG5EI8_V_M4_MF4, VLOXSEG5EI8_V }, // 4239
  { PseudoVLOXSEG5EI8_V_M4_MF4_MASK, VLOXSEG5EI8_V }, // 4240
  { PseudoVLOXSEG5EI8_V_M4_MF8, VLOXSEG5EI8_V }, // 4241
  { PseudoVLOXSEG5EI8_V_M4_MF8_MASK, VLOXSEG5EI8_V }, // 4242
  { PseudoVLOXSEG5EI8_V_M8_M1, VLOXSEG5EI8_V }, // 4243
  { PseudoVLOXSEG5EI8_V_M8_M1_MASK, VLOXSEG5EI8_V }, // 4244
  { PseudoVLOXSEG5EI8_V_M8_MF2, VLOXSEG5EI8_V }, // 4245
  { PseudoVLOXSEG5EI8_V_M8_MF2_MASK, VLOXSEG5EI8_V }, // 4246
  { PseudoVLOXSEG5EI8_V_M8_MF4, VLOXSEG5EI8_V }, // 4247
  { PseudoVLOXSEG5EI8_V_M8_MF4_MASK, VLOXSEG5EI8_V }, // 4248
  { PseudoVLOXSEG5EI8_V_M8_MF8, VLOXSEG5EI8_V }, // 4249
  { PseudoVLOXSEG5EI8_V_M8_MF8_MASK, VLOXSEG5EI8_V }, // 4250
  { PseudoVLOXSEG5EI8_V_MF2_M1, VLOXSEG5EI8_V }, // 4251
  { PseudoVLOXSEG5EI8_V_MF2_M1_MASK, VLOXSEG5EI8_V }, // 4252
  { PseudoVLOXSEG5EI8_V_MF2_MF2, VLOXSEG5EI8_V }, // 4253
  { PseudoVLOXSEG5EI8_V_MF2_MF2_MASK, VLOXSEG5EI8_V }, // 4254
  { PseudoVLOXSEG5EI8_V_MF2_MF4, VLOXSEG5EI8_V }, // 4255
  { PseudoVLOXSEG5EI8_V_MF2_MF4_MASK, VLOXSEG5EI8_V }, // 4256
  { PseudoVLOXSEG5EI8_V_MF2_MF8, VLOXSEG5EI8_V }, // 4257
  { PseudoVLOXSEG5EI8_V_MF2_MF8_MASK, VLOXSEG5EI8_V }, // 4258
  { PseudoVLOXSEG5EI8_V_MF4_M1, VLOXSEG5EI8_V }, // 4259
  { PseudoVLOXSEG5EI8_V_MF4_M1_MASK, VLOXSEG5EI8_V }, // 4260
  { PseudoVLOXSEG5EI8_V_MF4_MF2, VLOXSEG5EI8_V }, // 4261
  { PseudoVLOXSEG5EI8_V_MF4_MF2_MASK, VLOXSEG5EI8_V }, // 4262
  { PseudoVLOXSEG5EI8_V_MF4_MF4, VLOXSEG5EI8_V }, // 4263
  { PseudoVLOXSEG5EI8_V_MF4_MF4_MASK, VLOXSEG5EI8_V }, // 4264
  { PseudoVLOXSEG5EI8_V_MF4_MF8, VLOXSEG5EI8_V }, // 4265
  { PseudoVLOXSEG5EI8_V_MF4_MF8_MASK, VLOXSEG5EI8_V }, // 4266
  { PseudoVLOXSEG5EI8_V_MF8_M1, VLOXSEG5EI8_V }, // 4267
  { PseudoVLOXSEG5EI8_V_MF8_M1_MASK, VLOXSEG5EI8_V }, // 4268
  { PseudoVLOXSEG5EI8_V_MF8_MF2, VLOXSEG5EI8_V }, // 4269
  { PseudoVLOXSEG5EI8_V_MF8_MF2_MASK, VLOXSEG5EI8_V }, // 4270
  { PseudoVLOXSEG5EI8_V_MF8_MF4, VLOXSEG5EI8_V }, // 4271
  { PseudoVLOXSEG5EI8_V_MF8_MF4_MASK, VLOXSEG5EI8_V }, // 4272
  { PseudoVLOXSEG5EI8_V_MF8_MF8, VLOXSEG5EI8_V }, // 4273
  { PseudoVLOXSEG5EI8_V_MF8_MF8_MASK, VLOXSEG5EI8_V }, // 4274
  { PseudoVLOXSEG6EI16_V_M1_M1, VLOXSEG6EI16_V }, // 4275
  { PseudoVLOXSEG6EI16_V_M1_M1_MASK, VLOXSEG6EI16_V }, // 4276
  { PseudoVLOXSEG6EI16_V_M1_MF2, VLOXSEG6EI16_V }, // 4277
  { PseudoVLOXSEG6EI16_V_M1_MF2_MASK, VLOXSEG6EI16_V }, // 4278
  { PseudoVLOXSEG6EI16_V_M1_MF4, VLOXSEG6EI16_V }, // 4279
  { PseudoVLOXSEG6EI16_V_M1_MF4_MASK, VLOXSEG6EI16_V }, // 4280
  { PseudoVLOXSEG6EI16_V_M1_MF8, VLOXSEG6EI16_V }, // 4281
  { PseudoVLOXSEG6EI16_V_M1_MF8_MASK, VLOXSEG6EI16_V }, // 4282
  { PseudoVLOXSEG6EI16_V_M2_M1, VLOXSEG6EI16_V }, // 4283
  { PseudoVLOXSEG6EI16_V_M2_M1_MASK, VLOXSEG6EI16_V }, // 4284
  { PseudoVLOXSEG6EI16_V_M2_MF2, VLOXSEG6EI16_V }, // 4285
  { PseudoVLOXSEG6EI16_V_M2_MF2_MASK, VLOXSEG6EI16_V }, // 4286
  { PseudoVLOXSEG6EI16_V_M2_MF4, VLOXSEG6EI16_V }, // 4287
  { PseudoVLOXSEG6EI16_V_M2_MF4_MASK, VLOXSEG6EI16_V }, // 4288
  { PseudoVLOXSEG6EI16_V_M2_MF8, VLOXSEG6EI16_V }, // 4289
  { PseudoVLOXSEG6EI16_V_M2_MF8_MASK, VLOXSEG6EI16_V }, // 4290
  { PseudoVLOXSEG6EI16_V_M4_M1, VLOXSEG6EI16_V }, // 4291
  { PseudoVLOXSEG6EI16_V_M4_M1_MASK, VLOXSEG6EI16_V }, // 4292
  { PseudoVLOXSEG6EI16_V_M4_MF2, VLOXSEG6EI16_V }, // 4293
  { PseudoVLOXSEG6EI16_V_M4_MF2_MASK, VLOXSEG6EI16_V }, // 4294
  { PseudoVLOXSEG6EI16_V_M4_MF4, VLOXSEG6EI16_V }, // 4295
  { PseudoVLOXSEG6EI16_V_M4_MF4_MASK, VLOXSEG6EI16_V }, // 4296
  { PseudoVLOXSEG6EI16_V_M4_MF8, VLOXSEG6EI16_V }, // 4297
  { PseudoVLOXSEG6EI16_V_M4_MF8_MASK, VLOXSEG6EI16_V }, // 4298
  { PseudoVLOXSEG6EI16_V_M8_M1, VLOXSEG6EI16_V }, // 4299
  { PseudoVLOXSEG6EI16_V_M8_M1_MASK, VLOXSEG6EI16_V }, // 4300
  { PseudoVLOXSEG6EI16_V_M8_MF2, VLOXSEG6EI16_V }, // 4301
  { PseudoVLOXSEG6EI16_V_M8_MF2_MASK, VLOXSEG6EI16_V }, // 4302
  { PseudoVLOXSEG6EI16_V_M8_MF4, VLOXSEG6EI16_V }, // 4303
  { PseudoVLOXSEG6EI16_V_M8_MF4_MASK, VLOXSEG6EI16_V }, // 4304
  { PseudoVLOXSEG6EI16_V_M8_MF8, VLOXSEG6EI16_V }, // 4305
  { PseudoVLOXSEG6EI16_V_M8_MF8_MASK, VLOXSEG6EI16_V }, // 4306
  { PseudoVLOXSEG6EI16_V_MF2_M1, VLOXSEG6EI16_V }, // 4307
  { PseudoVLOXSEG6EI16_V_MF2_M1_MASK, VLOXSEG6EI16_V }, // 4308
  { PseudoVLOXSEG6EI16_V_MF2_MF2, VLOXSEG6EI16_V }, // 4309
  { PseudoVLOXSEG6EI16_V_MF2_MF2_MASK, VLOXSEG6EI16_V }, // 4310
  { PseudoVLOXSEG6EI16_V_MF2_MF4, VLOXSEG6EI16_V }, // 4311
  { PseudoVLOXSEG6EI16_V_MF2_MF4_MASK, VLOXSEG6EI16_V }, // 4312
  { PseudoVLOXSEG6EI16_V_MF2_MF8, VLOXSEG6EI16_V }, // 4313
  { PseudoVLOXSEG6EI16_V_MF2_MF8_MASK, VLOXSEG6EI16_V }, // 4314
  { PseudoVLOXSEG6EI16_V_MF4_M1, VLOXSEG6EI16_V }, // 4315
  { PseudoVLOXSEG6EI16_V_MF4_M1_MASK, VLOXSEG6EI16_V }, // 4316
  { PseudoVLOXSEG6EI16_V_MF4_MF2, VLOXSEG6EI16_V }, // 4317
  { PseudoVLOXSEG6EI16_V_MF4_MF2_MASK, VLOXSEG6EI16_V }, // 4318
  { PseudoVLOXSEG6EI16_V_MF4_MF4, VLOXSEG6EI16_V }, // 4319
  { PseudoVLOXSEG6EI16_V_MF4_MF4_MASK, VLOXSEG6EI16_V }, // 4320
  { PseudoVLOXSEG6EI16_V_MF4_MF8, VLOXSEG6EI16_V }, // 4321
  { PseudoVLOXSEG6EI16_V_MF4_MF8_MASK, VLOXSEG6EI16_V }, // 4322
  { PseudoVLOXSEG6EI32_V_M1_M1, VLOXSEG6EI32_V }, // 4323
  { PseudoVLOXSEG6EI32_V_M1_M1_MASK, VLOXSEG6EI32_V }, // 4324
  { PseudoVLOXSEG6EI32_V_M1_MF2, VLOXSEG6EI32_V }, // 4325
  { PseudoVLOXSEG6EI32_V_M1_MF2_MASK, VLOXSEG6EI32_V }, // 4326
  { PseudoVLOXSEG6EI32_V_M1_MF4, VLOXSEG6EI32_V }, // 4327
  { PseudoVLOXSEG6EI32_V_M1_MF4_MASK, VLOXSEG6EI32_V }, // 4328
  { PseudoVLOXSEG6EI32_V_M1_MF8, VLOXSEG6EI32_V }, // 4329
  { PseudoVLOXSEG6EI32_V_M1_MF8_MASK, VLOXSEG6EI32_V }, // 4330
  { PseudoVLOXSEG6EI32_V_M2_M1, VLOXSEG6EI32_V }, // 4331
  { PseudoVLOXSEG6EI32_V_M2_M1_MASK, VLOXSEG6EI32_V }, // 4332
  { PseudoVLOXSEG6EI32_V_M2_MF2, VLOXSEG6EI32_V }, // 4333
  { PseudoVLOXSEG6EI32_V_M2_MF2_MASK, VLOXSEG6EI32_V }, // 4334
  { PseudoVLOXSEG6EI32_V_M2_MF4, VLOXSEG6EI32_V }, // 4335
  { PseudoVLOXSEG6EI32_V_M2_MF4_MASK, VLOXSEG6EI32_V }, // 4336
  { PseudoVLOXSEG6EI32_V_M2_MF8, VLOXSEG6EI32_V }, // 4337
  { PseudoVLOXSEG6EI32_V_M2_MF8_MASK, VLOXSEG6EI32_V }, // 4338
  { PseudoVLOXSEG6EI32_V_M4_M1, VLOXSEG6EI32_V }, // 4339
  { PseudoVLOXSEG6EI32_V_M4_M1_MASK, VLOXSEG6EI32_V }, // 4340
  { PseudoVLOXSEG6EI32_V_M4_MF2, VLOXSEG6EI32_V }, // 4341
  { PseudoVLOXSEG6EI32_V_M4_MF2_MASK, VLOXSEG6EI32_V }, // 4342
  { PseudoVLOXSEG6EI32_V_M4_MF4, VLOXSEG6EI32_V }, // 4343
  { PseudoVLOXSEG6EI32_V_M4_MF4_MASK, VLOXSEG6EI32_V }, // 4344
  { PseudoVLOXSEG6EI32_V_M4_MF8, VLOXSEG6EI32_V }, // 4345
  { PseudoVLOXSEG6EI32_V_M4_MF8_MASK, VLOXSEG6EI32_V }, // 4346
  { PseudoVLOXSEG6EI32_V_M8_M1, VLOXSEG6EI32_V }, // 4347
  { PseudoVLOXSEG6EI32_V_M8_M1_MASK, VLOXSEG6EI32_V }, // 4348
  { PseudoVLOXSEG6EI32_V_M8_MF2, VLOXSEG6EI32_V }, // 4349
  { PseudoVLOXSEG6EI32_V_M8_MF2_MASK, VLOXSEG6EI32_V }, // 4350
  { PseudoVLOXSEG6EI32_V_M8_MF4, VLOXSEG6EI32_V }, // 4351
  { PseudoVLOXSEG6EI32_V_M8_MF4_MASK, VLOXSEG6EI32_V }, // 4352
  { PseudoVLOXSEG6EI32_V_M8_MF8, VLOXSEG6EI32_V }, // 4353
  { PseudoVLOXSEG6EI32_V_M8_MF8_MASK, VLOXSEG6EI32_V }, // 4354
  { PseudoVLOXSEG6EI32_V_MF2_M1, VLOXSEG6EI32_V }, // 4355
  { PseudoVLOXSEG6EI32_V_MF2_M1_MASK, VLOXSEG6EI32_V }, // 4356
  { PseudoVLOXSEG6EI32_V_MF2_MF2, VLOXSEG6EI32_V }, // 4357
  { PseudoVLOXSEG6EI32_V_MF2_MF2_MASK, VLOXSEG6EI32_V }, // 4358
  { PseudoVLOXSEG6EI32_V_MF2_MF4, VLOXSEG6EI32_V }, // 4359
  { PseudoVLOXSEG6EI32_V_MF2_MF4_MASK, VLOXSEG6EI32_V }, // 4360
  { PseudoVLOXSEG6EI32_V_MF2_MF8, VLOXSEG6EI32_V }, // 4361
  { PseudoVLOXSEG6EI32_V_MF2_MF8_MASK, VLOXSEG6EI32_V }, // 4362
  { PseudoVLOXSEG6EI64_V_M1_M1, VLOXSEG6EI64_V }, // 4363
  { PseudoVLOXSEG6EI64_V_M1_M1_MASK, VLOXSEG6EI64_V }, // 4364
  { PseudoVLOXSEG6EI64_V_M1_MF2, VLOXSEG6EI64_V }, // 4365
  { PseudoVLOXSEG6EI64_V_M1_MF2_MASK, VLOXSEG6EI64_V }, // 4366
  { PseudoVLOXSEG6EI64_V_M1_MF4, VLOXSEG6EI64_V }, // 4367
  { PseudoVLOXSEG6EI64_V_M1_MF4_MASK, VLOXSEG6EI64_V }, // 4368
  { PseudoVLOXSEG6EI64_V_M1_MF8, VLOXSEG6EI64_V }, // 4369
  { PseudoVLOXSEG6EI64_V_M1_MF8_MASK, VLOXSEG6EI64_V }, // 4370
  { PseudoVLOXSEG6EI64_V_M2_M1, VLOXSEG6EI64_V }, // 4371
  { PseudoVLOXSEG6EI64_V_M2_M1_MASK, VLOXSEG6EI64_V }, // 4372
  { PseudoVLOXSEG6EI64_V_M2_MF2, VLOXSEG6EI64_V }, // 4373
  { PseudoVLOXSEG6EI64_V_M2_MF2_MASK, VLOXSEG6EI64_V }, // 4374
  { PseudoVLOXSEG6EI64_V_M2_MF4, VLOXSEG6EI64_V }, // 4375
  { PseudoVLOXSEG6EI64_V_M2_MF4_MASK, VLOXSEG6EI64_V }, // 4376
  { PseudoVLOXSEG6EI64_V_M2_MF8, VLOXSEG6EI64_V }, // 4377
  { PseudoVLOXSEG6EI64_V_M2_MF8_MASK, VLOXSEG6EI64_V }, // 4378
  { PseudoVLOXSEG6EI64_V_M4_M1, VLOXSEG6EI64_V }, // 4379
  { PseudoVLOXSEG6EI64_V_M4_M1_MASK, VLOXSEG6EI64_V }, // 4380
  { PseudoVLOXSEG6EI64_V_M4_MF2, VLOXSEG6EI64_V }, // 4381
  { PseudoVLOXSEG6EI64_V_M4_MF2_MASK, VLOXSEG6EI64_V }, // 4382
  { PseudoVLOXSEG6EI64_V_M4_MF4, VLOXSEG6EI64_V }, // 4383
  { PseudoVLOXSEG6EI64_V_M4_MF4_MASK, VLOXSEG6EI64_V }, // 4384
  { PseudoVLOXSEG6EI64_V_M4_MF8, VLOXSEG6EI64_V }, // 4385
  { PseudoVLOXSEG6EI64_V_M4_MF8_MASK, VLOXSEG6EI64_V }, // 4386
  { PseudoVLOXSEG6EI64_V_M8_M1, VLOXSEG6EI64_V }, // 4387
  { PseudoVLOXSEG6EI64_V_M8_M1_MASK, VLOXSEG6EI64_V }, // 4388
  { PseudoVLOXSEG6EI64_V_M8_MF2, VLOXSEG6EI64_V }, // 4389
  { PseudoVLOXSEG6EI64_V_M8_MF2_MASK, VLOXSEG6EI64_V }, // 4390
  { PseudoVLOXSEG6EI64_V_M8_MF4, VLOXSEG6EI64_V }, // 4391
  { PseudoVLOXSEG6EI64_V_M8_MF4_MASK, VLOXSEG6EI64_V }, // 4392
  { PseudoVLOXSEG6EI64_V_M8_MF8, VLOXSEG6EI64_V }, // 4393
  { PseudoVLOXSEG6EI64_V_M8_MF8_MASK, VLOXSEG6EI64_V }, // 4394
  { PseudoVLOXSEG6EI8_V_M1_M1, VLOXSEG6EI8_V }, // 4395
  { PseudoVLOXSEG6EI8_V_M1_M1_MASK, VLOXSEG6EI8_V }, // 4396
  { PseudoVLOXSEG6EI8_V_M1_MF2, VLOXSEG6EI8_V }, // 4397
  { PseudoVLOXSEG6EI8_V_M1_MF2_MASK, VLOXSEG6EI8_V }, // 4398
  { PseudoVLOXSEG6EI8_V_M1_MF4, VLOXSEG6EI8_V }, // 4399
  { PseudoVLOXSEG6EI8_V_M1_MF4_MASK, VLOXSEG6EI8_V }, // 4400
  { PseudoVLOXSEG6EI8_V_M1_MF8, VLOXSEG6EI8_V }, // 4401
  { PseudoVLOXSEG6EI8_V_M1_MF8_MASK, VLOXSEG6EI8_V }, // 4402
  { PseudoVLOXSEG6EI8_V_M2_M1, VLOXSEG6EI8_V }, // 4403
  { PseudoVLOXSEG6EI8_V_M2_M1_MASK, VLOXSEG6EI8_V }, // 4404
  { PseudoVLOXSEG6EI8_V_M2_MF2, VLOXSEG6EI8_V }, // 4405
  { PseudoVLOXSEG6EI8_V_M2_MF2_MASK, VLOXSEG6EI8_V }, // 4406
  { PseudoVLOXSEG6EI8_V_M2_MF4, VLOXSEG6EI8_V }, // 4407
  { PseudoVLOXSEG6EI8_V_M2_MF4_MASK, VLOXSEG6EI8_V }, // 4408
  { PseudoVLOXSEG6EI8_V_M2_MF8, VLOXSEG6EI8_V }, // 4409
  { PseudoVLOXSEG6EI8_V_M2_MF8_MASK, VLOXSEG6EI8_V }, // 4410
  { PseudoVLOXSEG6EI8_V_M4_M1, VLOXSEG6EI8_V }, // 4411
  { PseudoVLOXSEG6EI8_V_M4_M1_MASK, VLOXSEG6EI8_V }, // 4412
  { PseudoVLOXSEG6EI8_V_M4_MF2, VLOXSEG6EI8_V }, // 4413
  { PseudoVLOXSEG6EI8_V_M4_MF2_MASK, VLOXSEG6EI8_V }, // 4414
  { PseudoVLOXSEG6EI8_V_M4_MF4, VLOXSEG6EI8_V }, // 4415
  { PseudoVLOXSEG6EI8_V_M4_MF4_MASK, VLOXSEG6EI8_V }, // 4416
  { PseudoVLOXSEG6EI8_V_M4_MF8, VLOXSEG6EI8_V }, // 4417
  { PseudoVLOXSEG6EI8_V_M4_MF8_MASK, VLOXSEG6EI8_V }, // 4418
  { PseudoVLOXSEG6EI8_V_M8_M1, VLOXSEG6EI8_V }, // 4419
  { PseudoVLOXSEG6EI8_V_M8_M1_MASK, VLOXSEG6EI8_V }, // 4420
  { PseudoVLOXSEG6EI8_V_M8_MF2, VLOXSEG6EI8_V }, // 4421
  { PseudoVLOXSEG6EI8_V_M8_MF2_MASK, VLOXSEG6EI8_V }, // 4422
  { PseudoVLOXSEG6EI8_V_M8_MF4, VLOXSEG6EI8_V }, // 4423
  { PseudoVLOXSEG6EI8_V_M8_MF4_MASK, VLOXSEG6EI8_V }, // 4424
  { PseudoVLOXSEG6EI8_V_M8_MF8, VLOXSEG6EI8_V }, // 4425
  { PseudoVLOXSEG6EI8_V_M8_MF8_MASK, VLOXSEG6EI8_V }, // 4426
  { PseudoVLOXSEG6EI8_V_MF2_M1, VLOXSEG6EI8_V }, // 4427
  { PseudoVLOXSEG6EI8_V_MF2_M1_MASK, VLOXSEG6EI8_V }, // 4428
  { PseudoVLOXSEG6EI8_V_MF2_MF2, VLOXSEG6EI8_V }, // 4429
  { PseudoVLOXSEG6EI8_V_MF2_MF2_MASK, VLOXSEG6EI8_V }, // 4430
  { PseudoVLOXSEG6EI8_V_MF2_MF4, VLOXSEG6EI8_V }, // 4431
  { PseudoVLOXSEG6EI8_V_MF2_MF4_MASK, VLOXSEG6EI8_V }, // 4432
  { PseudoVLOXSEG6EI8_V_MF2_MF8, VLOXSEG6EI8_V }, // 4433
  { PseudoVLOXSEG6EI8_V_MF2_MF8_MASK, VLOXSEG6EI8_V }, // 4434
  { PseudoVLOXSEG6EI8_V_MF4_M1, VLOXSEG6EI8_V }, // 4435
  { PseudoVLOXSEG6EI8_V_MF4_M1_MASK, VLOXSEG6EI8_V }, // 4436
  { PseudoVLOXSEG6EI8_V_MF4_MF2, VLOXSEG6EI8_V }, // 4437
  { PseudoVLOXSEG6EI8_V_MF4_MF2_MASK, VLOXSEG6EI8_V }, // 4438
  { PseudoVLOXSEG6EI8_V_MF4_MF4, VLOXSEG6EI8_V }, // 4439
  { PseudoVLOXSEG6EI8_V_MF4_MF4_MASK, VLOXSEG6EI8_V }, // 4440
  { PseudoVLOXSEG6EI8_V_MF4_MF8, VLOXSEG6EI8_V }, // 4441
  { PseudoVLOXSEG6EI8_V_MF4_MF8_MASK, VLOXSEG6EI8_V }, // 4442
  { PseudoVLOXSEG6EI8_V_MF8_M1, VLOXSEG6EI8_V }, // 4443
  { PseudoVLOXSEG6EI8_V_MF8_M1_MASK, VLOXSEG6EI8_V }, // 4444
  { PseudoVLOXSEG6EI8_V_MF8_MF2, VLOXSEG6EI8_V }, // 4445
  { PseudoVLOXSEG6EI8_V_MF8_MF2_MASK, VLOXSEG6EI8_V }, // 4446
  { PseudoVLOXSEG6EI8_V_MF8_MF4, VLOXSEG6EI8_V }, // 4447
  { PseudoVLOXSEG6EI8_V_MF8_MF4_MASK, VLOXSEG6EI8_V }, // 4448
  { PseudoVLOXSEG6EI8_V_MF8_MF8, VLOXSEG6EI8_V }, // 4449
  { PseudoVLOXSEG6EI8_V_MF8_MF8_MASK, VLOXSEG6EI8_V }, // 4450
  { PseudoVLOXSEG7EI16_V_M1_M1, VLOXSEG7EI16_V }, // 4451
  { PseudoVLOXSEG7EI16_V_M1_M1_MASK, VLOXSEG7EI16_V }, // 4452
  { PseudoVLOXSEG7EI16_V_M1_MF2, VLOXSEG7EI16_V }, // 4453
  { PseudoVLOXSEG7EI16_V_M1_MF2_MASK, VLOXSEG7EI16_V }, // 4454
  { PseudoVLOXSEG7EI16_V_M1_MF4, VLOXSEG7EI16_V }, // 4455
  { PseudoVLOXSEG7EI16_V_M1_MF4_MASK, VLOXSEG7EI16_V }, // 4456
  { PseudoVLOXSEG7EI16_V_M1_MF8, VLOXSEG7EI16_V }, // 4457
  { PseudoVLOXSEG7EI16_V_M1_MF8_MASK, VLOXSEG7EI16_V }, // 4458
  { PseudoVLOXSEG7EI16_V_M2_M1, VLOXSEG7EI16_V }, // 4459
  { PseudoVLOXSEG7EI16_V_M2_M1_MASK, VLOXSEG7EI16_V }, // 4460
  { PseudoVLOXSEG7EI16_V_M2_MF2, VLOXSEG7EI16_V }, // 4461
  { PseudoVLOXSEG7EI16_V_M2_MF2_MASK, VLOXSEG7EI16_V }, // 4462
  { PseudoVLOXSEG7EI16_V_M2_MF4, VLOXSEG7EI16_V }, // 4463
  { PseudoVLOXSEG7EI16_V_M2_MF4_MASK, VLOXSEG7EI16_V }, // 4464
  { PseudoVLOXSEG7EI16_V_M2_MF8, VLOXSEG7EI16_V }, // 4465
  { PseudoVLOXSEG7EI16_V_M2_MF8_MASK, VLOXSEG7EI16_V }, // 4466
  { PseudoVLOXSEG7EI16_V_M4_M1, VLOXSEG7EI16_V }, // 4467
  { PseudoVLOXSEG7EI16_V_M4_M1_MASK, VLOXSEG7EI16_V }, // 4468
  { PseudoVLOXSEG7EI16_V_M4_MF2, VLOXSEG7EI16_V }, // 4469
  { PseudoVLOXSEG7EI16_V_M4_MF2_MASK, VLOXSEG7EI16_V }, // 4470
  { PseudoVLOXSEG7EI16_V_M4_MF4, VLOXSEG7EI16_V }, // 4471
  { PseudoVLOXSEG7EI16_V_M4_MF4_MASK, VLOXSEG7EI16_V }, // 4472
  { PseudoVLOXSEG7EI16_V_M4_MF8, VLOXSEG7EI16_V }, // 4473
  { PseudoVLOXSEG7EI16_V_M4_MF8_MASK, VLOXSEG7EI16_V }, // 4474
  { PseudoVLOXSEG7EI16_V_M8_M1, VLOXSEG7EI16_V }, // 4475
  { PseudoVLOXSEG7EI16_V_M8_M1_MASK, VLOXSEG7EI16_V }, // 4476
  { PseudoVLOXSEG7EI16_V_M8_MF2, VLOXSEG7EI16_V }, // 4477
  { PseudoVLOXSEG7EI16_V_M8_MF2_MASK, VLOXSEG7EI16_V }, // 4478
  { PseudoVLOXSEG7EI16_V_M8_MF4, VLOXSEG7EI16_V }, // 4479
  { PseudoVLOXSEG7EI16_V_M8_MF4_MASK, VLOXSEG7EI16_V }, // 4480
  { PseudoVLOXSEG7EI16_V_M8_MF8, VLOXSEG7EI16_V }, // 4481
  { PseudoVLOXSEG7EI16_V_M8_MF8_MASK, VLOXSEG7EI16_V }, // 4482
  { PseudoVLOXSEG7EI16_V_MF2_M1, VLOXSEG7EI16_V }, // 4483
  { PseudoVLOXSEG7EI16_V_MF2_M1_MASK, VLOXSEG7EI16_V }, // 4484
  { PseudoVLOXSEG7EI16_V_MF2_MF2, VLOXSEG7EI16_V }, // 4485
  { PseudoVLOXSEG7EI16_V_MF2_MF2_MASK, VLOXSEG7EI16_V }, // 4486
  { PseudoVLOXSEG7EI16_V_MF2_MF4, VLOXSEG7EI16_V }, // 4487
  { PseudoVLOXSEG7EI16_V_MF2_MF4_MASK, VLOXSEG7EI16_V }, // 4488
  { PseudoVLOXSEG7EI16_V_MF2_MF8, VLOXSEG7EI16_V }, // 4489
  { PseudoVLOXSEG7EI16_V_MF2_MF8_MASK, VLOXSEG7EI16_V }, // 4490
  { PseudoVLOXSEG7EI16_V_MF4_M1, VLOXSEG7EI16_V }, // 4491
  { PseudoVLOXSEG7EI16_V_MF4_M1_MASK, VLOXSEG7EI16_V }, // 4492
  { PseudoVLOXSEG7EI16_V_MF4_MF2, VLOXSEG7EI16_V }, // 4493
  { PseudoVLOXSEG7EI16_V_MF4_MF2_MASK, VLOXSEG7EI16_V }, // 4494
  { PseudoVLOXSEG7EI16_V_MF4_MF4, VLOXSEG7EI16_V }, // 4495
  { PseudoVLOXSEG7EI16_V_MF4_MF4_MASK, VLOXSEG7EI16_V }, // 4496
  { PseudoVLOXSEG7EI16_V_MF4_MF8, VLOXSEG7EI16_V }, // 4497
  { PseudoVLOXSEG7EI16_V_MF4_MF8_MASK, VLOXSEG7EI16_V }, // 4498
  { PseudoVLOXSEG7EI32_V_M1_M1, VLOXSEG7EI32_V }, // 4499
  { PseudoVLOXSEG7EI32_V_M1_M1_MASK, VLOXSEG7EI32_V }, // 4500
  { PseudoVLOXSEG7EI32_V_M1_MF2, VLOXSEG7EI32_V }, // 4501
  { PseudoVLOXSEG7EI32_V_M1_MF2_MASK, VLOXSEG7EI32_V }, // 4502
  { PseudoVLOXSEG7EI32_V_M1_MF4, VLOXSEG7EI32_V }, // 4503
  { PseudoVLOXSEG7EI32_V_M1_MF4_MASK, VLOXSEG7EI32_V }, // 4504
  { PseudoVLOXSEG7EI32_V_M1_MF8, VLOXSEG7EI32_V }, // 4505
  { PseudoVLOXSEG7EI32_V_M1_MF8_MASK, VLOXSEG7EI32_V }, // 4506
  { PseudoVLOXSEG7EI32_V_M2_M1, VLOXSEG7EI32_V }, // 4507
  { PseudoVLOXSEG7EI32_V_M2_M1_MASK, VLOXSEG7EI32_V }, // 4508
  { PseudoVLOXSEG7EI32_V_M2_MF2, VLOXSEG7EI32_V }, // 4509
  { PseudoVLOXSEG7EI32_V_M2_MF2_MASK, VLOXSEG7EI32_V }, // 4510
  { PseudoVLOXSEG7EI32_V_M2_MF4, VLOXSEG7EI32_V }, // 4511
  { PseudoVLOXSEG7EI32_V_M2_MF4_MASK, VLOXSEG7EI32_V }, // 4512
  { PseudoVLOXSEG7EI32_V_M2_MF8, VLOXSEG7EI32_V }, // 4513
  { PseudoVLOXSEG7EI32_V_M2_MF8_MASK, VLOXSEG7EI32_V }, // 4514
  { PseudoVLOXSEG7EI32_V_M4_M1, VLOXSEG7EI32_V }, // 4515
  { PseudoVLOXSEG7EI32_V_M4_M1_MASK, VLOXSEG7EI32_V }, // 4516
  { PseudoVLOXSEG7EI32_V_M4_MF2, VLOXSEG7EI32_V }, // 4517
  { PseudoVLOXSEG7EI32_V_M4_MF2_MASK, VLOXSEG7EI32_V }, // 4518
  { PseudoVLOXSEG7EI32_V_M4_MF4, VLOXSEG7EI32_V }, // 4519
  { PseudoVLOXSEG7EI32_V_M4_MF4_MASK, VLOXSEG7EI32_V }, // 4520
  { PseudoVLOXSEG7EI32_V_M4_MF8, VLOXSEG7EI32_V }, // 4521
  { PseudoVLOXSEG7EI32_V_M4_MF8_MASK, VLOXSEG7EI32_V }, // 4522
  { PseudoVLOXSEG7EI32_V_M8_M1, VLOXSEG7EI32_V }, // 4523
  { PseudoVLOXSEG7EI32_V_M8_M1_MASK, VLOXSEG7EI32_V }, // 4524
  { PseudoVLOXSEG7EI32_V_M8_MF2, VLOXSEG7EI32_V }, // 4525
  { PseudoVLOXSEG7EI32_V_M8_MF2_MASK, VLOXSEG7EI32_V }, // 4526
  { PseudoVLOXSEG7EI32_V_M8_MF4, VLOXSEG7EI32_V }, // 4527
  { PseudoVLOXSEG7EI32_V_M8_MF4_MASK, VLOXSEG7EI32_V }, // 4528
  { PseudoVLOXSEG7EI32_V_M8_MF8, VLOXSEG7EI32_V }, // 4529
  { PseudoVLOXSEG7EI32_V_M8_MF8_MASK, VLOXSEG7EI32_V }, // 4530
  { PseudoVLOXSEG7EI32_V_MF2_M1, VLOXSEG7EI32_V }, // 4531
  { PseudoVLOXSEG7EI32_V_MF2_M1_MASK, VLOXSEG7EI32_V }, // 4532
  { PseudoVLOXSEG7EI32_V_MF2_MF2, VLOXSEG7EI32_V }, // 4533
  { PseudoVLOXSEG7EI32_V_MF2_MF2_MASK, VLOXSEG7EI32_V }, // 4534
  { PseudoVLOXSEG7EI32_V_MF2_MF4, VLOXSEG7EI32_V }, // 4535
  { PseudoVLOXSEG7EI32_V_MF2_MF4_MASK, VLOXSEG7EI32_V }, // 4536
  { PseudoVLOXSEG7EI32_V_MF2_MF8, VLOXSEG7EI32_V }, // 4537
  { PseudoVLOXSEG7EI32_V_MF2_MF8_MASK, VLOXSEG7EI32_V }, // 4538
  { PseudoVLOXSEG7EI64_V_M1_M1, VLOXSEG7EI64_V }, // 4539
  { PseudoVLOXSEG7EI64_V_M1_M1_MASK, VLOXSEG7EI64_V }, // 4540
  { PseudoVLOXSEG7EI64_V_M1_MF2, VLOXSEG7EI64_V }, // 4541
  { PseudoVLOXSEG7EI64_V_M1_MF2_MASK, VLOXSEG7EI64_V }, // 4542
  { PseudoVLOXSEG7EI64_V_M1_MF4, VLOXSEG7EI64_V }, // 4543
  { PseudoVLOXSEG7EI64_V_M1_MF4_MASK, VLOXSEG7EI64_V }, // 4544
  { PseudoVLOXSEG7EI64_V_M1_MF8, VLOXSEG7EI64_V }, // 4545
  { PseudoVLOXSEG7EI64_V_M1_MF8_MASK, VLOXSEG7EI64_V }, // 4546
  { PseudoVLOXSEG7EI64_V_M2_M1, VLOXSEG7EI64_V }, // 4547
  { PseudoVLOXSEG7EI64_V_M2_M1_MASK, VLOXSEG7EI64_V }, // 4548
  { PseudoVLOXSEG7EI64_V_M2_MF2, VLOXSEG7EI64_V }, // 4549
  { PseudoVLOXSEG7EI64_V_M2_MF2_MASK, VLOXSEG7EI64_V }, // 4550
  { PseudoVLOXSEG7EI64_V_M2_MF4, VLOXSEG7EI64_V }, // 4551
  { PseudoVLOXSEG7EI64_V_M2_MF4_MASK, VLOXSEG7EI64_V }, // 4552
  { PseudoVLOXSEG7EI64_V_M2_MF8, VLOXSEG7EI64_V }, // 4553
  { PseudoVLOXSEG7EI64_V_M2_MF8_MASK, VLOXSEG7EI64_V }, // 4554
  { PseudoVLOXSEG7EI64_V_M4_M1, VLOXSEG7EI64_V }, // 4555
  { PseudoVLOXSEG7EI64_V_M4_M1_MASK, VLOXSEG7EI64_V }, // 4556
  { PseudoVLOXSEG7EI64_V_M4_MF2, VLOXSEG7EI64_V }, // 4557
  { PseudoVLOXSEG7EI64_V_M4_MF2_MASK, VLOXSEG7EI64_V }, // 4558
  { PseudoVLOXSEG7EI64_V_M4_MF4, VLOXSEG7EI64_V }, // 4559
  { PseudoVLOXSEG7EI64_V_M4_MF4_MASK, VLOXSEG7EI64_V }, // 4560
  { PseudoVLOXSEG7EI64_V_M4_MF8, VLOXSEG7EI64_V }, // 4561
  { PseudoVLOXSEG7EI64_V_M4_MF8_MASK, VLOXSEG7EI64_V }, // 4562
  { PseudoVLOXSEG7EI64_V_M8_M1, VLOXSEG7EI64_V }, // 4563
  { PseudoVLOXSEG7EI64_V_M8_M1_MASK, VLOXSEG7EI64_V }, // 4564
  { PseudoVLOXSEG7EI64_V_M8_MF2, VLOXSEG7EI64_V }, // 4565
  { PseudoVLOXSEG7EI64_V_M8_MF2_MASK, VLOXSEG7EI64_V }, // 4566
  { PseudoVLOXSEG7EI64_V_M8_MF4, VLOXSEG7EI64_V }, // 4567
  { PseudoVLOXSEG7EI64_V_M8_MF4_MASK, VLOXSEG7EI64_V }, // 4568
  { PseudoVLOXSEG7EI64_V_M8_MF8, VLOXSEG7EI64_V }, // 4569
  { PseudoVLOXSEG7EI64_V_M8_MF8_MASK, VLOXSEG7EI64_V }, // 4570
  { PseudoVLOXSEG7EI8_V_M1_M1, VLOXSEG7EI8_V }, // 4571
  { PseudoVLOXSEG7EI8_V_M1_M1_MASK, VLOXSEG7EI8_V }, // 4572
  { PseudoVLOXSEG7EI8_V_M1_MF2, VLOXSEG7EI8_V }, // 4573
  { PseudoVLOXSEG7EI8_V_M1_MF2_MASK, VLOXSEG7EI8_V }, // 4574
  { PseudoVLOXSEG7EI8_V_M1_MF4, VLOXSEG7EI8_V }, // 4575
  { PseudoVLOXSEG7EI8_V_M1_MF4_MASK, VLOXSEG7EI8_V }, // 4576
  { PseudoVLOXSEG7EI8_V_M1_MF8, VLOXSEG7EI8_V }, // 4577
  { PseudoVLOXSEG7EI8_V_M1_MF8_MASK, VLOXSEG7EI8_V }, // 4578
  { PseudoVLOXSEG7EI8_V_M2_M1, VLOXSEG7EI8_V }, // 4579
  { PseudoVLOXSEG7EI8_V_M2_M1_MASK, VLOXSEG7EI8_V }, // 4580
  { PseudoVLOXSEG7EI8_V_M2_MF2, VLOXSEG7EI8_V }, // 4581
  { PseudoVLOXSEG7EI8_V_M2_MF2_MASK, VLOXSEG7EI8_V }, // 4582
  { PseudoVLOXSEG7EI8_V_M2_MF4, VLOXSEG7EI8_V }, // 4583
  { PseudoVLOXSEG7EI8_V_M2_MF4_MASK, VLOXSEG7EI8_V }, // 4584
  { PseudoVLOXSEG7EI8_V_M2_MF8, VLOXSEG7EI8_V }, // 4585
  { PseudoVLOXSEG7EI8_V_M2_MF8_MASK, VLOXSEG7EI8_V }, // 4586
  { PseudoVLOXSEG7EI8_V_M4_M1, VLOXSEG7EI8_V }, // 4587
  { PseudoVLOXSEG7EI8_V_M4_M1_MASK, VLOXSEG7EI8_V }, // 4588
  { PseudoVLOXSEG7EI8_V_M4_MF2, VLOXSEG7EI8_V }, // 4589
  { PseudoVLOXSEG7EI8_V_M4_MF2_MASK, VLOXSEG7EI8_V }, // 4590
  { PseudoVLOXSEG7EI8_V_M4_MF4, VLOXSEG7EI8_V }, // 4591
  { PseudoVLOXSEG7EI8_V_M4_MF4_MASK, VLOXSEG7EI8_V }, // 4592
  { PseudoVLOXSEG7EI8_V_M4_MF8, VLOXSEG7EI8_V }, // 4593
  { PseudoVLOXSEG7EI8_V_M4_MF8_MASK, VLOXSEG7EI8_V }, // 4594
  { PseudoVLOXSEG7EI8_V_M8_M1, VLOXSEG7EI8_V }, // 4595
  { PseudoVLOXSEG7EI8_V_M8_M1_MASK, VLOXSEG7EI8_V }, // 4596
  { PseudoVLOXSEG7EI8_V_M8_MF2, VLOXSEG7EI8_V }, // 4597
  { PseudoVLOXSEG7EI8_V_M8_MF2_MASK, VLOXSEG7EI8_V }, // 4598
  { PseudoVLOXSEG7EI8_V_M8_MF4, VLOXSEG7EI8_V }, // 4599
  { PseudoVLOXSEG7EI8_V_M8_MF4_MASK, VLOXSEG7EI8_V }, // 4600
  { PseudoVLOXSEG7EI8_V_M8_MF8, VLOXSEG7EI8_V }, // 4601
  { PseudoVLOXSEG7EI8_V_M8_MF8_MASK, VLOXSEG7EI8_V }, // 4602
  { PseudoVLOXSEG7EI8_V_MF2_M1, VLOXSEG7EI8_V }, // 4603
  { PseudoVLOXSEG7EI8_V_MF2_M1_MASK, VLOXSEG7EI8_V }, // 4604
  { PseudoVLOXSEG7EI8_V_MF2_MF2, VLOXSEG7EI8_V }, // 4605
  { PseudoVLOXSEG7EI8_V_MF2_MF2_MASK, VLOXSEG7EI8_V }, // 4606
  { PseudoVLOXSEG7EI8_V_MF2_MF4, VLOXSEG7EI8_V }, // 4607
  { PseudoVLOXSEG7EI8_V_MF2_MF4_MASK, VLOXSEG7EI8_V }, // 4608
  { PseudoVLOXSEG7EI8_V_MF2_MF8, VLOXSEG7EI8_V }, // 4609
  { PseudoVLOXSEG7EI8_V_MF2_MF8_MASK, VLOXSEG7EI8_V }, // 4610
  { PseudoVLOXSEG7EI8_V_MF4_M1, VLOXSEG7EI8_V }, // 4611
  { PseudoVLOXSEG7EI8_V_MF4_M1_MASK, VLOXSEG7EI8_V }, // 4612
  { PseudoVLOXSEG7EI8_V_MF4_MF2, VLOXSEG7EI8_V }, // 4613
  { PseudoVLOXSEG7EI8_V_MF4_MF2_MASK, VLOXSEG7EI8_V }, // 4614
  { PseudoVLOXSEG7EI8_V_MF4_MF4, VLOXSEG7EI8_V }, // 4615
  { PseudoVLOXSEG7EI8_V_MF4_MF4_MASK, VLOXSEG7EI8_V }, // 4616
  { PseudoVLOXSEG7EI8_V_MF4_MF8, VLOXSEG7EI8_V }, // 4617
  { PseudoVLOXSEG7EI8_V_MF4_MF8_MASK, VLOXSEG7EI8_V }, // 4618
  { PseudoVLOXSEG7EI8_V_MF8_M1, VLOXSEG7EI8_V }, // 4619
  { PseudoVLOXSEG7EI8_V_MF8_M1_MASK, VLOXSEG7EI8_V }, // 4620
  { PseudoVLOXSEG7EI8_V_MF8_MF2, VLOXSEG7EI8_V }, // 4621
  { PseudoVLOXSEG7EI8_V_MF8_MF2_MASK, VLOXSEG7EI8_V }, // 4622
  { PseudoVLOXSEG7EI8_V_MF8_MF4, VLOXSEG7EI8_V }, // 4623
  { PseudoVLOXSEG7EI8_V_MF8_MF4_MASK, VLOXSEG7EI8_V }, // 4624
  { PseudoVLOXSEG7EI8_V_MF8_MF8, VLOXSEG7EI8_V }, // 4625
  { PseudoVLOXSEG7EI8_V_MF8_MF8_MASK, VLOXSEG7EI8_V }, // 4626
  { PseudoVLOXSEG8EI16_V_M1_M1, VLOXSEG8EI16_V }, // 4627
  { PseudoVLOXSEG8EI16_V_M1_M1_MASK, VLOXSEG8EI16_V }, // 4628
  { PseudoVLOXSEG8EI16_V_M1_MF2, VLOXSEG8EI16_V }, // 4629
  { PseudoVLOXSEG8EI16_V_M1_MF2_MASK, VLOXSEG8EI16_V }, // 4630
  { PseudoVLOXSEG8EI16_V_M1_MF4, VLOXSEG8EI16_V }, // 4631
  { PseudoVLOXSEG8EI16_V_M1_MF4_MASK, VLOXSEG8EI16_V }, // 4632
  { PseudoVLOXSEG8EI16_V_M1_MF8, VLOXSEG8EI16_V }, // 4633
  { PseudoVLOXSEG8EI16_V_M1_MF8_MASK, VLOXSEG8EI16_V }, // 4634
  { PseudoVLOXSEG8EI16_V_M2_M1, VLOXSEG8EI16_V }, // 4635
  { PseudoVLOXSEG8EI16_V_M2_M1_MASK, VLOXSEG8EI16_V }, // 4636
  { PseudoVLOXSEG8EI16_V_M2_MF2, VLOXSEG8EI16_V }, // 4637
  { PseudoVLOXSEG8EI16_V_M2_MF2_MASK, VLOXSEG8EI16_V }, // 4638
  { PseudoVLOXSEG8EI16_V_M2_MF4, VLOXSEG8EI16_V }, // 4639
  { PseudoVLOXSEG8EI16_V_M2_MF4_MASK, VLOXSEG8EI16_V }, // 4640
  { PseudoVLOXSEG8EI16_V_M2_MF8, VLOXSEG8EI16_V }, // 4641
  { PseudoVLOXSEG8EI16_V_M2_MF8_MASK, VLOXSEG8EI16_V }, // 4642
  { PseudoVLOXSEG8EI16_V_M4_M1, VLOXSEG8EI16_V }, // 4643
  { PseudoVLOXSEG8EI16_V_M4_M1_MASK, VLOXSEG8EI16_V }, // 4644
  { PseudoVLOXSEG8EI16_V_M4_MF2, VLOXSEG8EI16_V }, // 4645
  { PseudoVLOXSEG8EI16_V_M4_MF2_MASK, VLOXSEG8EI16_V }, // 4646
  { PseudoVLOXSEG8EI16_V_M4_MF4, VLOXSEG8EI16_V }, // 4647
  { PseudoVLOXSEG8EI16_V_M4_MF4_MASK, VLOXSEG8EI16_V }, // 4648
  { PseudoVLOXSEG8EI16_V_M4_MF8, VLOXSEG8EI16_V }, // 4649
  { PseudoVLOXSEG8EI16_V_M4_MF8_MASK, VLOXSEG8EI16_V }, // 4650
  { PseudoVLOXSEG8EI16_V_M8_M1, VLOXSEG8EI16_V }, // 4651
  { PseudoVLOXSEG8EI16_V_M8_M1_MASK, VLOXSEG8EI16_V }, // 4652
  { PseudoVLOXSEG8EI16_V_M8_MF2, VLOXSEG8EI16_V }, // 4653
  { PseudoVLOXSEG8EI16_V_M8_MF2_MASK, VLOXSEG8EI16_V }, // 4654
  { PseudoVLOXSEG8EI16_V_M8_MF4, VLOXSEG8EI16_V }, // 4655
  { PseudoVLOXSEG8EI16_V_M8_MF4_MASK, VLOXSEG8EI16_V }, // 4656
  { PseudoVLOXSEG8EI16_V_M8_MF8, VLOXSEG8EI16_V }, // 4657
  { PseudoVLOXSEG8EI16_V_M8_MF8_MASK, VLOXSEG8EI16_V }, // 4658
  { PseudoVLOXSEG8EI16_V_MF2_M1, VLOXSEG8EI16_V }, // 4659
  { PseudoVLOXSEG8EI16_V_MF2_M1_MASK, VLOXSEG8EI16_V }, // 4660
  { PseudoVLOXSEG8EI16_V_MF2_MF2, VLOXSEG8EI16_V }, // 4661
  { PseudoVLOXSEG8EI16_V_MF2_MF2_MASK, VLOXSEG8EI16_V }, // 4662
  { PseudoVLOXSEG8EI16_V_MF2_MF4, VLOXSEG8EI16_V }, // 4663
  { PseudoVLOXSEG8EI16_V_MF2_MF4_MASK, VLOXSEG8EI16_V }, // 4664
  { PseudoVLOXSEG8EI16_V_MF2_MF8, VLOXSEG8EI16_V }, // 4665
  { PseudoVLOXSEG8EI16_V_MF2_MF8_MASK, VLOXSEG8EI16_V }, // 4666
  { PseudoVLOXSEG8EI16_V_MF4_M1, VLOXSEG8EI16_V }, // 4667
  { PseudoVLOXSEG8EI16_V_MF4_M1_MASK, VLOXSEG8EI16_V }, // 4668
  { PseudoVLOXSEG8EI16_V_MF4_MF2, VLOXSEG8EI16_V }, // 4669
  { PseudoVLOXSEG8EI16_V_MF4_MF2_MASK, VLOXSEG8EI16_V }, // 4670
  { PseudoVLOXSEG8EI16_V_MF4_MF4, VLOXSEG8EI16_V }, // 4671
  { PseudoVLOXSEG8EI16_V_MF4_MF4_MASK, VLOXSEG8EI16_V }, // 4672
  { PseudoVLOXSEG8EI16_V_MF4_MF8, VLOXSEG8EI16_V }, // 4673
  { PseudoVLOXSEG8EI16_V_MF4_MF8_MASK, VLOXSEG8EI16_V }, // 4674
  { PseudoVLOXSEG8EI32_V_M1_M1, VLOXSEG8EI32_V }, // 4675
  { PseudoVLOXSEG8EI32_V_M1_M1_MASK, VLOXSEG8EI32_V }, // 4676
  { PseudoVLOXSEG8EI32_V_M1_MF2, VLOXSEG8EI32_V }, // 4677
  { PseudoVLOXSEG8EI32_V_M1_MF2_MASK, VLOXSEG8EI32_V }, // 4678
  { PseudoVLOXSEG8EI32_V_M1_MF4, VLOXSEG8EI32_V }, // 4679
  { PseudoVLOXSEG8EI32_V_M1_MF4_MASK, VLOXSEG8EI32_V }, // 4680
  { PseudoVLOXSEG8EI32_V_M1_MF8, VLOXSEG8EI32_V }, // 4681
  { PseudoVLOXSEG8EI32_V_M1_MF8_MASK, VLOXSEG8EI32_V }, // 4682
  { PseudoVLOXSEG8EI32_V_M2_M1, VLOXSEG8EI32_V }, // 4683
  { PseudoVLOXSEG8EI32_V_M2_M1_MASK, VLOXSEG8EI32_V }, // 4684
  { PseudoVLOXSEG8EI32_V_M2_MF2, VLOXSEG8EI32_V }, // 4685
  { PseudoVLOXSEG8EI32_V_M2_MF2_MASK, VLOXSEG8EI32_V }, // 4686
  { PseudoVLOXSEG8EI32_V_M2_MF4, VLOXSEG8EI32_V }, // 4687
  { PseudoVLOXSEG8EI32_V_M2_MF4_MASK, VLOXSEG8EI32_V }, // 4688
  { PseudoVLOXSEG8EI32_V_M2_MF8, VLOXSEG8EI32_V }, // 4689
  { PseudoVLOXSEG8EI32_V_M2_MF8_MASK, VLOXSEG8EI32_V }, // 4690
  { PseudoVLOXSEG8EI32_V_M4_M1, VLOXSEG8EI32_V }, // 4691
  { PseudoVLOXSEG8EI32_V_M4_M1_MASK, VLOXSEG8EI32_V }, // 4692
  { PseudoVLOXSEG8EI32_V_M4_MF2, VLOXSEG8EI32_V }, // 4693
  { PseudoVLOXSEG8EI32_V_M4_MF2_MASK, VLOXSEG8EI32_V }, // 4694
  { PseudoVLOXSEG8EI32_V_M4_MF4, VLOXSEG8EI32_V }, // 4695
  { PseudoVLOXSEG8EI32_V_M4_MF4_MASK, VLOXSEG8EI32_V }, // 4696
  { PseudoVLOXSEG8EI32_V_M4_MF8, VLOXSEG8EI32_V }, // 4697
  { PseudoVLOXSEG8EI32_V_M4_MF8_MASK, VLOXSEG8EI32_V }, // 4698
  { PseudoVLOXSEG8EI32_V_M8_M1, VLOXSEG8EI32_V }, // 4699
  { PseudoVLOXSEG8EI32_V_M8_M1_MASK, VLOXSEG8EI32_V }, // 4700
  { PseudoVLOXSEG8EI32_V_M8_MF2, VLOXSEG8EI32_V }, // 4701
  { PseudoVLOXSEG8EI32_V_M8_MF2_MASK, VLOXSEG8EI32_V }, // 4702
  { PseudoVLOXSEG8EI32_V_M8_MF4, VLOXSEG8EI32_V }, // 4703
  { PseudoVLOXSEG8EI32_V_M8_MF4_MASK, VLOXSEG8EI32_V }, // 4704
  { PseudoVLOXSEG8EI32_V_M8_MF8, VLOXSEG8EI32_V }, // 4705
  { PseudoVLOXSEG8EI32_V_M8_MF8_MASK, VLOXSEG8EI32_V }, // 4706
  { PseudoVLOXSEG8EI32_V_MF2_M1, VLOXSEG8EI32_V }, // 4707
  { PseudoVLOXSEG8EI32_V_MF2_M1_MASK, VLOXSEG8EI32_V }, // 4708
  { PseudoVLOXSEG8EI32_V_MF2_MF2, VLOXSEG8EI32_V }, // 4709
  { PseudoVLOXSEG8EI32_V_MF2_MF2_MASK, VLOXSEG8EI32_V }, // 4710
  { PseudoVLOXSEG8EI32_V_MF2_MF4, VLOXSEG8EI32_V }, // 4711
  { PseudoVLOXSEG8EI32_V_MF2_MF4_MASK, VLOXSEG8EI32_V }, // 4712
  { PseudoVLOXSEG8EI32_V_MF2_MF8, VLOXSEG8EI32_V }, // 4713
  { PseudoVLOXSEG8EI32_V_MF2_MF8_MASK, VLOXSEG8EI32_V }, // 4714
  { PseudoVLOXSEG8EI64_V_M1_M1, VLOXSEG8EI64_V }, // 4715
  { PseudoVLOXSEG8EI64_V_M1_M1_MASK, VLOXSEG8EI64_V }, // 4716
  { PseudoVLOXSEG8EI64_V_M1_MF2, VLOXSEG8EI64_V }, // 4717
  { PseudoVLOXSEG8EI64_V_M1_MF2_MASK, VLOXSEG8EI64_V }, // 4718
  { PseudoVLOXSEG8EI64_V_M1_MF4, VLOXSEG8EI64_V }, // 4719
  { PseudoVLOXSEG8EI64_V_M1_MF4_MASK, VLOXSEG8EI64_V }, // 4720
  { PseudoVLOXSEG8EI64_V_M1_MF8, VLOXSEG8EI64_V }, // 4721
  { PseudoVLOXSEG8EI64_V_M1_MF8_MASK, VLOXSEG8EI64_V }, // 4722
  { PseudoVLOXSEG8EI64_V_M2_M1, VLOXSEG8EI64_V }, // 4723
  { PseudoVLOXSEG8EI64_V_M2_M1_MASK, VLOXSEG8EI64_V }, // 4724
  { PseudoVLOXSEG8EI64_V_M2_MF2, VLOXSEG8EI64_V }, // 4725
  { PseudoVLOXSEG8EI64_V_M2_MF2_MASK, VLOXSEG8EI64_V }, // 4726
  { PseudoVLOXSEG8EI64_V_M2_MF4, VLOXSEG8EI64_V }, // 4727
  { PseudoVLOXSEG8EI64_V_M2_MF4_MASK, VLOXSEG8EI64_V }, // 4728
  { PseudoVLOXSEG8EI64_V_M2_MF8, VLOXSEG8EI64_V }, // 4729
  { PseudoVLOXSEG8EI64_V_M2_MF8_MASK, VLOXSEG8EI64_V }, // 4730
  { PseudoVLOXSEG8EI64_V_M4_M1, VLOXSEG8EI64_V }, // 4731
  { PseudoVLOXSEG8EI64_V_M4_M1_MASK, VLOXSEG8EI64_V }, // 4732
  { PseudoVLOXSEG8EI64_V_M4_MF2, VLOXSEG8EI64_V }, // 4733
  { PseudoVLOXSEG8EI64_V_M4_MF2_MASK, VLOXSEG8EI64_V }, // 4734
  { PseudoVLOXSEG8EI64_V_M4_MF4, VLOXSEG8EI64_V }, // 4735
  { PseudoVLOXSEG8EI64_V_M4_MF4_MASK, VLOXSEG8EI64_V }, // 4736
  { PseudoVLOXSEG8EI64_V_M4_MF8, VLOXSEG8EI64_V }, // 4737
  { PseudoVLOXSEG8EI64_V_M4_MF8_MASK, VLOXSEG8EI64_V }, // 4738
  { PseudoVLOXSEG8EI64_V_M8_M1, VLOXSEG8EI64_V }, // 4739
  { PseudoVLOXSEG8EI64_V_M8_M1_MASK, VLOXSEG8EI64_V }, // 4740
  { PseudoVLOXSEG8EI64_V_M8_MF2, VLOXSEG8EI64_V }, // 4741
  { PseudoVLOXSEG8EI64_V_M8_MF2_MASK, VLOXSEG8EI64_V }, // 4742
  { PseudoVLOXSEG8EI64_V_M8_MF4, VLOXSEG8EI64_V }, // 4743
  { PseudoVLOXSEG8EI64_V_M8_MF4_MASK, VLOXSEG8EI64_V }, // 4744
  { PseudoVLOXSEG8EI64_V_M8_MF8, VLOXSEG8EI64_V }, // 4745
  { PseudoVLOXSEG8EI64_V_M8_MF8_MASK, VLOXSEG8EI64_V }, // 4746
  { PseudoVLOXSEG8EI8_V_M1_M1, VLOXSEG8EI8_V }, // 4747
  { PseudoVLOXSEG8EI8_V_M1_M1_MASK, VLOXSEG8EI8_V }, // 4748
  { PseudoVLOXSEG8EI8_V_M1_MF2, VLOXSEG8EI8_V }, // 4749
  { PseudoVLOXSEG8EI8_V_M1_MF2_MASK, VLOXSEG8EI8_V }, // 4750
  { PseudoVLOXSEG8EI8_V_M1_MF4, VLOXSEG8EI8_V }, // 4751
  { PseudoVLOXSEG8EI8_V_M1_MF4_MASK, VLOXSEG8EI8_V }, // 4752
  { PseudoVLOXSEG8EI8_V_M1_MF8, VLOXSEG8EI8_V }, // 4753
  { PseudoVLOXSEG8EI8_V_M1_MF8_MASK, VLOXSEG8EI8_V }, // 4754
  { PseudoVLOXSEG8EI8_V_M2_M1, VLOXSEG8EI8_V }, // 4755
  { PseudoVLOXSEG8EI8_V_M2_M1_MASK, VLOXSEG8EI8_V }, // 4756
  { PseudoVLOXSEG8EI8_V_M2_MF2, VLOXSEG8EI8_V }, // 4757
  { PseudoVLOXSEG8EI8_V_M2_MF2_MASK, VLOXSEG8EI8_V }, // 4758
  { PseudoVLOXSEG8EI8_V_M2_MF4, VLOXSEG8EI8_V }, // 4759
  { PseudoVLOXSEG8EI8_V_M2_MF4_MASK, VLOXSEG8EI8_V }, // 4760
  { PseudoVLOXSEG8EI8_V_M2_MF8, VLOXSEG8EI8_V }, // 4761
  { PseudoVLOXSEG8EI8_V_M2_MF8_MASK, VLOXSEG8EI8_V }, // 4762
  { PseudoVLOXSEG8EI8_V_M4_M1, VLOXSEG8EI8_V }, // 4763
  { PseudoVLOXSEG8EI8_V_M4_M1_MASK, VLOXSEG8EI8_V }, // 4764
  { PseudoVLOXSEG8EI8_V_M4_MF2, VLOXSEG8EI8_V }, // 4765
  { PseudoVLOXSEG8EI8_V_M4_MF2_MASK, VLOXSEG8EI8_V }, // 4766
  { PseudoVLOXSEG8EI8_V_M4_MF4, VLOXSEG8EI8_V }, // 4767
  { PseudoVLOXSEG8EI8_V_M4_MF4_MASK, VLOXSEG8EI8_V }, // 4768
  { PseudoVLOXSEG8EI8_V_M4_MF8, VLOXSEG8EI8_V }, // 4769
  { PseudoVLOXSEG8EI8_V_M4_MF8_MASK, VLOXSEG8EI8_V }, // 4770
  { PseudoVLOXSEG8EI8_V_M8_M1, VLOXSEG8EI8_V }, // 4771
  { PseudoVLOXSEG8EI8_V_M8_M1_MASK, VLOXSEG8EI8_V }, // 4772
  { PseudoVLOXSEG8EI8_V_M8_MF2, VLOXSEG8EI8_V }, // 4773
  { PseudoVLOXSEG8EI8_V_M8_MF2_MASK, VLOXSEG8EI8_V }, // 4774
  { PseudoVLOXSEG8EI8_V_M8_MF4, VLOXSEG8EI8_V }, // 4775
  { PseudoVLOXSEG8EI8_V_M8_MF4_MASK, VLOXSEG8EI8_V }, // 4776
  { PseudoVLOXSEG8EI8_V_M8_MF8, VLOXSEG8EI8_V }, // 4777
  { PseudoVLOXSEG8EI8_V_M8_MF8_MASK, VLOXSEG8EI8_V }, // 4778
  { PseudoVLOXSEG8EI8_V_MF2_M1, VLOXSEG8EI8_V }, // 4779
  { PseudoVLOXSEG8EI8_V_MF2_M1_MASK, VLOXSEG8EI8_V }, // 4780
  { PseudoVLOXSEG8EI8_V_MF2_MF2, VLOXSEG8EI8_V }, // 4781
  { PseudoVLOXSEG8EI8_V_MF2_MF2_MASK, VLOXSEG8EI8_V }, // 4782
  { PseudoVLOXSEG8EI8_V_MF2_MF4, VLOXSEG8EI8_V }, // 4783
  { PseudoVLOXSEG8EI8_V_MF2_MF4_MASK, VLOXSEG8EI8_V }, // 4784
  { PseudoVLOXSEG8EI8_V_MF2_MF8, VLOXSEG8EI8_V }, // 4785
  { PseudoVLOXSEG8EI8_V_MF2_MF8_MASK, VLOXSEG8EI8_V }, // 4786
  { PseudoVLOXSEG8EI8_V_MF4_M1, VLOXSEG8EI8_V }, // 4787
  { PseudoVLOXSEG8EI8_V_MF4_M1_MASK, VLOXSEG8EI8_V }, // 4788
  { PseudoVLOXSEG8EI8_V_MF4_MF2, VLOXSEG8EI8_V }, // 4789
  { PseudoVLOXSEG8EI8_V_MF4_MF2_MASK, VLOXSEG8EI8_V }, // 4790
  { PseudoVLOXSEG8EI8_V_MF4_MF4, VLOXSEG8EI8_V }, // 4791
  { PseudoVLOXSEG8EI8_V_MF4_MF4_MASK, VLOXSEG8EI8_V }, // 4792
  { PseudoVLOXSEG8EI8_V_MF4_MF8, VLOXSEG8EI8_V }, // 4793
  { PseudoVLOXSEG8EI8_V_MF4_MF8_MASK, VLOXSEG8EI8_V }, // 4794
  { PseudoVLOXSEG8EI8_V_MF8_M1, VLOXSEG8EI8_V }, // 4795
  { PseudoVLOXSEG8EI8_V_MF8_M1_MASK, VLOXSEG8EI8_V }, // 4796
  { PseudoVLOXSEG8EI8_V_MF8_MF2, VLOXSEG8EI8_V }, // 4797
  { PseudoVLOXSEG8EI8_V_MF8_MF2_MASK, VLOXSEG8EI8_V }, // 4798
  { PseudoVLOXSEG8EI8_V_MF8_MF4, VLOXSEG8EI8_V }, // 4799
  { PseudoVLOXSEG8EI8_V_MF8_MF4_MASK, VLOXSEG8EI8_V }, // 4800
  { PseudoVLOXSEG8EI8_V_MF8_MF8, VLOXSEG8EI8_V }, // 4801
  { PseudoVLOXSEG8EI8_V_MF8_MF8_MASK, VLOXSEG8EI8_V }, // 4802
  { PseudoVLSE16_V_M1, VLSE16_V }, // 4803
  { PseudoVLSE16_V_M1_MASK, VLSE16_V }, // 4804
  { PseudoVLSE16_V_M2, VLSE16_V }, // 4805
  { PseudoVLSE16_V_M2_MASK, VLSE16_V }, // 4806
  { PseudoVLSE16_V_M4, VLSE16_V }, // 4807
  { PseudoVLSE16_V_M4_MASK, VLSE16_V }, // 4808
  { PseudoVLSE16_V_M8, VLSE16_V }, // 4809
  { PseudoVLSE16_V_M8_MASK, VLSE16_V }, // 4810
  { PseudoVLSE16_V_MF2, VLSE16_V }, // 4811
  { PseudoVLSE16_V_MF2_MASK, VLSE16_V }, // 4812
  { PseudoVLSE16_V_MF4, VLSE16_V }, // 4813
  { PseudoVLSE16_V_MF4_MASK, VLSE16_V }, // 4814
  { PseudoVLSE16_V_MF8, VLSE16_V }, // 4815
  { PseudoVLSE16_V_MF8_MASK, VLSE16_V }, // 4816
  { PseudoVLSE32_V_M1, VLSE32_V }, // 4817
  { PseudoVLSE32_V_M1_MASK, VLSE32_V }, // 4818
  { PseudoVLSE32_V_M2, VLSE32_V }, // 4819
  { PseudoVLSE32_V_M2_MASK, VLSE32_V }, // 4820
  { PseudoVLSE32_V_M4, VLSE32_V }, // 4821
  { PseudoVLSE32_V_M4_MASK, VLSE32_V }, // 4822
  { PseudoVLSE32_V_M8, VLSE32_V }, // 4823
  { PseudoVLSE32_V_M8_MASK, VLSE32_V }, // 4824
  { PseudoVLSE32_V_MF2, VLSE32_V }, // 4825
  { PseudoVLSE32_V_MF2_MASK, VLSE32_V }, // 4826
  { PseudoVLSE32_V_MF4, VLSE32_V }, // 4827
  { PseudoVLSE32_V_MF4_MASK, VLSE32_V }, // 4828
  { PseudoVLSE32_V_MF8, VLSE32_V }, // 4829
  { PseudoVLSE32_V_MF8_MASK, VLSE32_V }, // 4830
  { PseudoVLSE64_V_M1, VLSE64_V }, // 4831
  { PseudoVLSE64_V_M1_MASK, VLSE64_V }, // 4832
  { PseudoVLSE64_V_M2, VLSE64_V }, // 4833
  { PseudoVLSE64_V_M2_MASK, VLSE64_V }, // 4834
  { PseudoVLSE64_V_M4, VLSE64_V }, // 4835
  { PseudoVLSE64_V_M4_MASK, VLSE64_V }, // 4836
  { PseudoVLSE64_V_M8, VLSE64_V }, // 4837
  { PseudoVLSE64_V_M8_MASK, VLSE64_V }, // 4838
  { PseudoVLSE64_V_MF2, VLSE64_V }, // 4839
  { PseudoVLSE64_V_MF2_MASK, VLSE64_V }, // 4840
  { PseudoVLSE64_V_MF4, VLSE64_V }, // 4841
  { PseudoVLSE64_V_MF4_MASK, VLSE64_V }, // 4842
  { PseudoVLSE64_V_MF8, VLSE64_V }, // 4843
  { PseudoVLSE64_V_MF8_MASK, VLSE64_V }, // 4844
  { PseudoVLSE8_V_M1, VLSE8_V }, // 4845
  { PseudoVLSE8_V_M1_MASK, VLSE8_V }, // 4846
  { PseudoVLSE8_V_M2, VLSE8_V }, // 4847
  { PseudoVLSE8_V_M2_MASK, VLSE8_V }, // 4848
  { PseudoVLSE8_V_M4, VLSE8_V }, // 4849
  { PseudoVLSE8_V_M4_MASK, VLSE8_V }, // 4850
  { PseudoVLSE8_V_M8, VLSE8_V }, // 4851
  { PseudoVLSE8_V_M8_MASK, VLSE8_V }, // 4852
  { PseudoVLSE8_V_MF2, VLSE8_V }, // 4853
  { PseudoVLSE8_V_MF2_MASK, VLSE8_V }, // 4854
  { PseudoVLSE8_V_MF4, VLSE8_V }, // 4855
  { PseudoVLSE8_V_MF4_MASK, VLSE8_V }, // 4856
  { PseudoVLSE8_V_MF8, VLSE8_V }, // 4857
  { PseudoVLSE8_V_MF8_MASK, VLSE8_V }, // 4858
  { PseudoVLSEG2E16FF_V_M1, VLSEG2E16FF_V }, // 4859
  { PseudoVLSEG2E16FF_V_M1_MASK, VLSEG2E16FF_V }, // 4860
  { PseudoVLSEG2E16FF_V_M2, VLSEG2E16FF_V }, // 4861
  { PseudoVLSEG2E16FF_V_M2_MASK, VLSEG2E16FF_V }, // 4862
  { PseudoVLSEG2E16FF_V_M4, VLSEG2E16FF_V }, // 4863
  { PseudoVLSEG2E16FF_V_M4_MASK, VLSEG2E16FF_V }, // 4864
  { PseudoVLSEG2E16FF_V_MF2, VLSEG2E16FF_V }, // 4865
  { PseudoVLSEG2E16FF_V_MF2_MASK, VLSEG2E16FF_V }, // 4866
  { PseudoVLSEG2E16FF_V_MF4, VLSEG2E16FF_V }, // 4867
  { PseudoVLSEG2E16FF_V_MF4_MASK, VLSEG2E16FF_V }, // 4868
  { PseudoVLSEG2E16_V_M1, VLSEG2E16_V }, // 4869
  { PseudoVLSEG2E16_V_M1_MASK, VLSEG2E16_V }, // 4870
  { PseudoVLSEG2E16_V_M2, VLSEG2E16_V }, // 4871
  { PseudoVLSEG2E16_V_M2_MASK, VLSEG2E16_V }, // 4872
  { PseudoVLSEG2E16_V_M4, VLSEG2E16_V }, // 4873
  { PseudoVLSEG2E16_V_M4_MASK, VLSEG2E16_V }, // 4874
  { PseudoVLSEG2E16_V_MF2, VLSEG2E16_V }, // 4875
  { PseudoVLSEG2E16_V_MF2_MASK, VLSEG2E16_V }, // 4876
  { PseudoVLSEG2E16_V_MF4, VLSEG2E16_V }, // 4877
  { PseudoVLSEG2E16_V_MF4_MASK, VLSEG2E16_V }, // 4878
  { PseudoVLSEG2E32FF_V_M1, VLSEG2E32FF_V }, // 4879
  { PseudoVLSEG2E32FF_V_M1_MASK, VLSEG2E32FF_V }, // 4880
  { PseudoVLSEG2E32FF_V_M2, VLSEG2E32FF_V }, // 4881
  { PseudoVLSEG2E32FF_V_M2_MASK, VLSEG2E32FF_V }, // 4882
  { PseudoVLSEG2E32FF_V_M4, VLSEG2E32FF_V }, // 4883
  { PseudoVLSEG2E32FF_V_M4_MASK, VLSEG2E32FF_V }, // 4884
  { PseudoVLSEG2E32FF_V_MF2, VLSEG2E32FF_V }, // 4885
  { PseudoVLSEG2E32FF_V_MF2_MASK, VLSEG2E32FF_V }, // 4886
  { PseudoVLSEG2E32_V_M1, VLSEG2E32_V }, // 4887
  { PseudoVLSEG2E32_V_M1_MASK, VLSEG2E32_V }, // 4888
  { PseudoVLSEG2E32_V_M2, VLSEG2E32_V }, // 4889
  { PseudoVLSEG2E32_V_M2_MASK, VLSEG2E32_V }, // 4890
  { PseudoVLSEG2E32_V_M4, VLSEG2E32_V }, // 4891
  { PseudoVLSEG2E32_V_M4_MASK, VLSEG2E32_V }, // 4892
  { PseudoVLSEG2E32_V_MF2, VLSEG2E32_V }, // 4893
  { PseudoVLSEG2E32_V_MF2_MASK, VLSEG2E32_V }, // 4894
  { PseudoVLSEG2E64FF_V_M1, VLSEG2E64FF_V }, // 4895
  { PseudoVLSEG2E64FF_V_M1_MASK, VLSEG2E64FF_V }, // 4896
  { PseudoVLSEG2E64FF_V_M2, VLSEG2E64FF_V }, // 4897
  { PseudoVLSEG2E64FF_V_M2_MASK, VLSEG2E64FF_V }, // 4898
  { PseudoVLSEG2E64FF_V_M4, VLSEG2E64FF_V }, // 4899
  { PseudoVLSEG2E64FF_V_M4_MASK, VLSEG2E64FF_V }, // 4900
  { PseudoVLSEG2E64_V_M1, VLSEG2E64_V }, // 4901
  { PseudoVLSEG2E64_V_M1_MASK, VLSEG2E64_V }, // 4902
  { PseudoVLSEG2E64_V_M2, VLSEG2E64_V }, // 4903
  { PseudoVLSEG2E64_V_M2_MASK, VLSEG2E64_V }, // 4904
  { PseudoVLSEG2E64_V_M4, VLSEG2E64_V }, // 4905
  { PseudoVLSEG2E64_V_M4_MASK, VLSEG2E64_V }, // 4906
  { PseudoVLSEG2E8FF_V_M1, VLSEG2E8FF_V }, // 4907
  { PseudoVLSEG2E8FF_V_M1_MASK, VLSEG2E8FF_V }, // 4908
  { PseudoVLSEG2E8FF_V_M2, VLSEG2E8FF_V }, // 4909
  { PseudoVLSEG2E8FF_V_M2_MASK, VLSEG2E8FF_V }, // 4910
  { PseudoVLSEG2E8FF_V_M4, VLSEG2E8FF_V }, // 4911
  { PseudoVLSEG2E8FF_V_M4_MASK, VLSEG2E8FF_V }, // 4912
  { PseudoVLSEG2E8FF_V_MF2, VLSEG2E8FF_V }, // 4913
  { PseudoVLSEG2E8FF_V_MF2_MASK, VLSEG2E8FF_V }, // 4914
  { PseudoVLSEG2E8FF_V_MF4, VLSEG2E8FF_V }, // 4915
  { PseudoVLSEG2E8FF_V_MF4_MASK, VLSEG2E8FF_V }, // 4916
  { PseudoVLSEG2E8FF_V_MF8, VLSEG2E8FF_V }, // 4917
  { PseudoVLSEG2E8FF_V_MF8_MASK, VLSEG2E8FF_V }, // 4918
  { PseudoVLSEG2E8_V_M1, VLSEG2E8_V }, // 4919
  { PseudoVLSEG2E8_V_M1_MASK, VLSEG2E8_V }, // 4920
  { PseudoVLSEG2E8_V_M2, VLSEG2E8_V }, // 4921
  { PseudoVLSEG2E8_V_M2_MASK, VLSEG2E8_V }, // 4922
  { PseudoVLSEG2E8_V_M4, VLSEG2E8_V }, // 4923
  { PseudoVLSEG2E8_V_M4_MASK, VLSEG2E8_V }, // 4924
  { PseudoVLSEG2E8_V_MF2, VLSEG2E8_V }, // 4925
  { PseudoVLSEG2E8_V_MF2_MASK, VLSEG2E8_V }, // 4926
  { PseudoVLSEG2E8_V_MF4, VLSEG2E8_V }, // 4927
  { PseudoVLSEG2E8_V_MF4_MASK, VLSEG2E8_V }, // 4928
  { PseudoVLSEG2E8_V_MF8, VLSEG2E8_V }, // 4929
  { PseudoVLSEG2E8_V_MF8_MASK, VLSEG2E8_V }, // 4930
  { PseudoVLSEG3E16FF_V_M1, VLSEG3E16FF_V }, // 4931
  { PseudoVLSEG3E16FF_V_M1_MASK, VLSEG3E16FF_V }, // 4932
  { PseudoVLSEG3E16FF_V_M2, VLSEG3E16FF_V }, // 4933
  { PseudoVLSEG3E16FF_V_M2_MASK, VLSEG3E16FF_V }, // 4934
  { PseudoVLSEG3E16FF_V_MF2, VLSEG3E16FF_V }, // 4935
  { PseudoVLSEG3E16FF_V_MF2_MASK, VLSEG3E16FF_V }, // 4936
  { PseudoVLSEG3E16FF_V_MF4, VLSEG3E16FF_V }, // 4937
  { PseudoVLSEG3E16FF_V_MF4_MASK, VLSEG3E16FF_V }, // 4938
  { PseudoVLSEG3E16_V_M1, VLSEG3E16_V }, // 4939
  { PseudoVLSEG3E16_V_M1_MASK, VLSEG3E16_V }, // 4940
  { PseudoVLSEG3E16_V_M2, VLSEG3E16_V }, // 4941
  { PseudoVLSEG3E16_V_M2_MASK, VLSEG3E16_V }, // 4942
  { PseudoVLSEG3E16_V_MF2, VLSEG3E16_V }, // 4943
  { PseudoVLSEG3E16_V_MF2_MASK, VLSEG3E16_V }, // 4944
  { PseudoVLSEG3E16_V_MF4, VLSEG3E16_V }, // 4945
  { PseudoVLSEG3E16_V_MF4_MASK, VLSEG3E16_V }, // 4946
  { PseudoVLSEG3E32FF_V_M1, VLSEG3E32FF_V }, // 4947
  { PseudoVLSEG3E32FF_V_M1_MASK, VLSEG3E32FF_V }, // 4948
  { PseudoVLSEG3E32FF_V_M2, VLSEG3E32FF_V }, // 4949
  { PseudoVLSEG3E32FF_V_M2_MASK, VLSEG3E32FF_V }, // 4950
  { PseudoVLSEG3E32FF_V_MF2, VLSEG3E32FF_V }, // 4951
  { PseudoVLSEG3E32FF_V_MF2_MASK, VLSEG3E32FF_V }, // 4952
  { PseudoVLSEG3E32_V_M1, VLSEG3E32_V }, // 4953
  { PseudoVLSEG3E32_V_M1_MASK, VLSEG3E32_V }, // 4954
  { PseudoVLSEG3E32_V_M2, VLSEG3E32_V }, // 4955
  { PseudoVLSEG3E32_V_M2_MASK, VLSEG3E32_V }, // 4956
  { PseudoVLSEG3E32_V_MF2, VLSEG3E32_V }, // 4957
  { PseudoVLSEG3E32_V_MF2_MASK, VLSEG3E32_V }, // 4958
  { PseudoVLSEG3E64FF_V_M1, VLSEG3E64FF_V }, // 4959
  { PseudoVLSEG3E64FF_V_M1_MASK, VLSEG3E64FF_V }, // 4960
  { PseudoVLSEG3E64FF_V_M2, VLSEG3E64FF_V }, // 4961
  { PseudoVLSEG3E64FF_V_M2_MASK, VLSEG3E64FF_V }, // 4962
  { PseudoVLSEG3E64_V_M1, VLSEG3E64_V }, // 4963
  { PseudoVLSEG3E64_V_M1_MASK, VLSEG3E64_V }, // 4964
  { PseudoVLSEG3E64_V_M2, VLSEG3E64_V }, // 4965
  { PseudoVLSEG3E64_V_M2_MASK, VLSEG3E64_V }, // 4966
  { PseudoVLSEG3E8FF_V_M1, VLSEG3E8FF_V }, // 4967
  { PseudoVLSEG3E8FF_V_M1_MASK, VLSEG3E8FF_V }, // 4968
  { PseudoVLSEG3E8FF_V_M2, VLSEG3E8FF_V }, // 4969
  { PseudoVLSEG3E8FF_V_M2_MASK, VLSEG3E8FF_V }, // 4970
  { PseudoVLSEG3E8FF_V_MF2, VLSEG3E8FF_V }, // 4971
  { PseudoVLSEG3E8FF_V_MF2_MASK, VLSEG3E8FF_V }, // 4972
  { PseudoVLSEG3E8FF_V_MF4, VLSEG3E8FF_V }, // 4973
  { PseudoVLSEG3E8FF_V_MF4_MASK, VLSEG3E8FF_V }, // 4974
  { PseudoVLSEG3E8FF_V_MF8, VLSEG3E8FF_V }, // 4975
  { PseudoVLSEG3E8FF_V_MF8_MASK, VLSEG3E8FF_V }, // 4976
  { PseudoVLSEG3E8_V_M1, VLSEG3E8_V }, // 4977
  { PseudoVLSEG3E8_V_M1_MASK, VLSEG3E8_V }, // 4978
  { PseudoVLSEG3E8_V_M2, VLSEG3E8_V }, // 4979
  { PseudoVLSEG3E8_V_M2_MASK, VLSEG3E8_V }, // 4980
  { PseudoVLSEG3E8_V_MF2, VLSEG3E8_V }, // 4981
  { PseudoVLSEG3E8_V_MF2_MASK, VLSEG3E8_V }, // 4982
  { PseudoVLSEG3E8_V_MF4, VLSEG3E8_V }, // 4983
  { PseudoVLSEG3E8_V_MF4_MASK, VLSEG3E8_V }, // 4984
  { PseudoVLSEG3E8_V_MF8, VLSEG3E8_V }, // 4985
  { PseudoVLSEG3E8_V_MF8_MASK, VLSEG3E8_V }, // 4986
  { PseudoVLSEG4E16FF_V_M1, VLSEG4E16FF_V }, // 4987
  { PseudoVLSEG4E16FF_V_M1_MASK, VLSEG4E16FF_V }, // 4988
  { PseudoVLSEG4E16FF_V_M2, VLSEG4E16FF_V }, // 4989
  { PseudoVLSEG4E16FF_V_M2_MASK, VLSEG4E16FF_V }, // 4990
  { PseudoVLSEG4E16FF_V_MF2, VLSEG4E16FF_V }, // 4991
  { PseudoVLSEG4E16FF_V_MF2_MASK, VLSEG4E16FF_V }, // 4992
  { PseudoVLSEG4E16FF_V_MF4, VLSEG4E16FF_V }, // 4993
  { PseudoVLSEG4E16FF_V_MF4_MASK, VLSEG4E16FF_V }, // 4994
  { PseudoVLSEG4E16_V_M1, VLSEG4E16_V }, // 4995
  { PseudoVLSEG4E16_V_M1_MASK, VLSEG4E16_V }, // 4996
  { PseudoVLSEG4E16_V_M2, VLSEG4E16_V }, // 4997
  { PseudoVLSEG4E16_V_M2_MASK, VLSEG4E16_V }, // 4998
  { PseudoVLSEG4E16_V_MF2, VLSEG4E16_V }, // 4999
  { PseudoVLSEG4E16_V_MF2_MASK, VLSEG4E16_V }, // 5000
  { PseudoVLSEG4E16_V_MF4, VLSEG4E16_V }, // 5001
  { PseudoVLSEG4E16_V_MF4_MASK, VLSEG4E16_V }, // 5002
  { PseudoVLSEG4E32FF_V_M1, VLSEG4E32FF_V }, // 5003
  { PseudoVLSEG4E32FF_V_M1_MASK, VLSEG4E32FF_V }, // 5004
  { PseudoVLSEG4E32FF_V_M2, VLSEG4E32FF_V }, // 5005
  { PseudoVLSEG4E32FF_V_M2_MASK, VLSEG4E32FF_V }, // 5006
  { PseudoVLSEG4E32FF_V_MF2, VLSEG4E32FF_V }, // 5007
  { PseudoVLSEG4E32FF_V_MF2_MASK, VLSEG4E32FF_V }, // 5008
  { PseudoVLSEG4E32_V_M1, VLSEG4E32_V }, // 5009
  { PseudoVLSEG4E32_V_M1_MASK, VLSEG4E32_V }, // 5010
  { PseudoVLSEG4E32_V_M2, VLSEG4E32_V }, // 5011
  { PseudoVLSEG4E32_V_M2_MASK, VLSEG4E32_V }, // 5012
  { PseudoVLSEG4E32_V_MF2, VLSEG4E32_V }, // 5013
  { PseudoVLSEG4E32_V_MF2_MASK, VLSEG4E32_V }, // 5014
  { PseudoVLSEG4E64FF_V_M1, VLSEG4E64FF_V }, // 5015
  { PseudoVLSEG4E64FF_V_M1_MASK, VLSEG4E64FF_V }, // 5016
  { PseudoVLSEG4E64FF_V_M2, VLSEG4E64FF_V }, // 5017
  { PseudoVLSEG4E64FF_V_M2_MASK, VLSEG4E64FF_V }, // 5018
  { PseudoVLSEG4E64_V_M1, VLSEG4E64_V }, // 5019
  { PseudoVLSEG4E64_V_M1_MASK, VLSEG4E64_V }, // 5020
  { PseudoVLSEG4E64_V_M2, VLSEG4E64_V }, // 5021
  { PseudoVLSEG4E64_V_M2_MASK, VLSEG4E64_V }, // 5022
  { PseudoVLSEG4E8FF_V_M1, VLSEG4E8FF_V }, // 5023
  { PseudoVLSEG4E8FF_V_M1_MASK, VLSEG4E8FF_V }, // 5024
  { PseudoVLSEG4E8FF_V_M2, VLSEG4E8FF_V }, // 5025
  { PseudoVLSEG4E8FF_V_M2_MASK, VLSEG4E8FF_V }, // 5026
  { PseudoVLSEG4E8FF_V_MF2, VLSEG4E8FF_V }, // 5027
  { PseudoVLSEG4E8FF_V_MF2_MASK, VLSEG4E8FF_V }, // 5028
  { PseudoVLSEG4E8FF_V_MF4, VLSEG4E8FF_V }, // 5029
  { PseudoVLSEG4E8FF_V_MF4_MASK, VLSEG4E8FF_V }, // 5030
  { PseudoVLSEG4E8FF_V_MF8, VLSEG4E8FF_V }, // 5031
  { PseudoVLSEG4E8FF_V_MF8_MASK, VLSEG4E8FF_V }, // 5032
  { PseudoVLSEG4E8_V_M1, VLSEG4E8_V }, // 5033
  { PseudoVLSEG4E8_V_M1_MASK, VLSEG4E8_V }, // 5034
  { PseudoVLSEG4E8_V_M2, VLSEG4E8_V }, // 5035
  { PseudoVLSEG4E8_V_M2_MASK, VLSEG4E8_V }, // 5036
  { PseudoVLSEG4E8_V_MF2, VLSEG4E8_V }, // 5037
  { PseudoVLSEG4E8_V_MF2_MASK, VLSEG4E8_V }, // 5038
  { PseudoVLSEG4E8_V_MF4, VLSEG4E8_V }, // 5039
  { PseudoVLSEG4E8_V_MF4_MASK, VLSEG4E8_V }, // 5040
  { PseudoVLSEG4E8_V_MF8, VLSEG4E8_V }, // 5041
  { PseudoVLSEG4E8_V_MF8_MASK, VLSEG4E8_V }, // 5042
  { PseudoVLSEG5E16FF_V_M1, VLSEG5E16FF_V }, // 5043
  { PseudoVLSEG5E16FF_V_M1_MASK, VLSEG5E16FF_V }, // 5044
  { PseudoVLSEG5E16FF_V_MF2, VLSEG5E16FF_V }, // 5045
  { PseudoVLSEG5E16FF_V_MF2_MASK, VLSEG5E16FF_V }, // 5046
  { PseudoVLSEG5E16FF_V_MF4, VLSEG5E16FF_V }, // 5047
  { PseudoVLSEG5E16FF_V_MF4_MASK, VLSEG5E16FF_V }, // 5048
  { PseudoVLSEG5E16_V_M1, VLSEG5E16_V }, // 5049
  { PseudoVLSEG5E16_V_M1_MASK, VLSEG5E16_V }, // 5050
  { PseudoVLSEG5E16_V_MF2, VLSEG5E16_V }, // 5051
  { PseudoVLSEG5E16_V_MF2_MASK, VLSEG5E16_V }, // 5052
  { PseudoVLSEG5E16_V_MF4, VLSEG5E16_V }, // 5053
  { PseudoVLSEG5E16_V_MF4_MASK, VLSEG5E16_V }, // 5054
  { PseudoVLSEG5E32FF_V_M1, VLSEG5E32FF_V }, // 5055
  { PseudoVLSEG5E32FF_V_M1_MASK, VLSEG5E32FF_V }, // 5056
  { PseudoVLSEG5E32FF_V_MF2, VLSEG5E32FF_V }, // 5057
  { PseudoVLSEG5E32FF_V_MF2_MASK, VLSEG5E32FF_V }, // 5058
  { PseudoVLSEG5E32_V_M1, VLSEG5E32_V }, // 5059
  { PseudoVLSEG5E32_V_M1_MASK, VLSEG5E32_V }, // 5060
  { PseudoVLSEG5E32_V_MF2, VLSEG5E32_V }, // 5061
  { PseudoVLSEG5E32_V_MF2_MASK, VLSEG5E32_V }, // 5062
  { PseudoVLSEG5E64FF_V_M1, VLSEG5E64FF_V }, // 5063
  { PseudoVLSEG5E64FF_V_M1_MASK, VLSEG5E64FF_V }, // 5064
  { PseudoVLSEG5E64_V_M1, VLSEG5E64_V }, // 5065
  { PseudoVLSEG5E64_V_M1_MASK, VLSEG5E64_V }, // 5066
  { PseudoVLSEG5E8FF_V_M1, VLSEG5E8FF_V }, // 5067
  { PseudoVLSEG5E8FF_V_M1_MASK, VLSEG5E8FF_V }, // 5068
  { PseudoVLSEG5E8FF_V_MF2, VLSEG5E8FF_V }, // 5069
  { PseudoVLSEG5E8FF_V_MF2_MASK, VLSEG5E8FF_V }, // 5070
  { PseudoVLSEG5E8FF_V_MF4, VLSEG5E8FF_V }, // 5071
  { PseudoVLSEG5E8FF_V_MF4_MASK, VLSEG5E8FF_V }, // 5072
  { PseudoVLSEG5E8FF_V_MF8, VLSEG5E8FF_V }, // 5073
  { PseudoVLSEG5E8FF_V_MF8_MASK, VLSEG5E8FF_V }, // 5074
  { PseudoVLSEG5E8_V_M1, VLSEG5E8_V }, // 5075
  { PseudoVLSEG5E8_V_M1_MASK, VLSEG5E8_V }, // 5076
  { PseudoVLSEG5E8_V_MF2, VLSEG5E8_V }, // 5077
  { PseudoVLSEG5E8_V_MF2_MASK, VLSEG5E8_V }, // 5078
  { PseudoVLSEG5E8_V_MF4, VLSEG5E8_V }, // 5079
  { PseudoVLSEG5E8_V_MF4_MASK, VLSEG5E8_V }, // 5080
  { PseudoVLSEG5E8_V_MF8, VLSEG5E8_V }, // 5081
  { PseudoVLSEG5E8_V_MF8_MASK, VLSEG5E8_V }, // 5082
  { PseudoVLSEG6E16FF_V_M1, VLSEG6E16FF_V }, // 5083
  { PseudoVLSEG6E16FF_V_M1_MASK, VLSEG6E16FF_V }, // 5084
  { PseudoVLSEG6E16FF_V_MF2, VLSEG6E16FF_V }, // 5085
  { PseudoVLSEG6E16FF_V_MF2_MASK, VLSEG6E16FF_V }, // 5086
  { PseudoVLSEG6E16FF_V_MF4, VLSEG6E16FF_V }, // 5087
  { PseudoVLSEG6E16FF_V_MF4_MASK, VLSEG6E16FF_V }, // 5088
  { PseudoVLSEG6E16_V_M1, VLSEG6E16_V }, // 5089
  { PseudoVLSEG6E16_V_M1_MASK, VLSEG6E16_V }, // 5090
  { PseudoVLSEG6E16_V_MF2, VLSEG6E16_V }, // 5091
  { PseudoVLSEG6E16_V_MF2_MASK, VLSEG6E16_V }, // 5092
  { PseudoVLSEG6E16_V_MF4, VLSEG6E16_V }, // 5093
  { PseudoVLSEG6E16_V_MF4_MASK, VLSEG6E16_V }, // 5094
  { PseudoVLSEG6E32FF_V_M1, VLSEG6E32FF_V }, // 5095
  { PseudoVLSEG6E32FF_V_M1_MASK, VLSEG6E32FF_V }, // 5096
  { PseudoVLSEG6E32FF_V_MF2, VLSEG6E32FF_V }, // 5097
  { PseudoVLSEG6E32FF_V_MF2_MASK, VLSEG6E32FF_V }, // 5098
  { PseudoVLSEG6E32_V_M1, VLSEG6E32_V }, // 5099
  { PseudoVLSEG6E32_V_M1_MASK, VLSEG6E32_V }, // 5100
  { PseudoVLSEG6E32_V_MF2, VLSEG6E32_V }, // 5101
  { PseudoVLSEG6E32_V_MF2_MASK, VLSEG6E32_V }, // 5102
  { PseudoVLSEG6E64FF_V_M1, VLSEG6E64FF_V }, // 5103
  { PseudoVLSEG6E64FF_V_M1_MASK, VLSEG6E64FF_V }, // 5104
  { PseudoVLSEG6E64_V_M1, VLSEG6E64_V }, // 5105
  { PseudoVLSEG6E64_V_M1_MASK, VLSEG6E64_V }, // 5106
  { PseudoVLSEG6E8FF_V_M1, VLSEG6E8FF_V }, // 5107
  { PseudoVLSEG6E8FF_V_M1_MASK, VLSEG6E8FF_V }, // 5108
  { PseudoVLSEG6E8FF_V_MF2, VLSEG6E8FF_V }, // 5109
  { PseudoVLSEG6E8FF_V_MF2_MASK, VLSEG6E8FF_V }, // 5110
  { PseudoVLSEG6E8FF_V_MF4, VLSEG6E8FF_V }, // 5111
  { PseudoVLSEG6E8FF_V_MF4_MASK, VLSEG6E8FF_V }, // 5112
  { PseudoVLSEG6E8FF_V_MF8, VLSEG6E8FF_V }, // 5113
  { PseudoVLSEG6E8FF_V_MF8_MASK, VLSEG6E8FF_V }, // 5114
  { PseudoVLSEG6E8_V_M1, VLSEG6E8_V }, // 5115
  { PseudoVLSEG6E8_V_M1_MASK, VLSEG6E8_V }, // 5116
  { PseudoVLSEG6E8_V_MF2, VLSEG6E8_V }, // 5117
  { PseudoVLSEG6E8_V_MF2_MASK, VLSEG6E8_V }, // 5118
  { PseudoVLSEG6E8_V_MF4, VLSEG6E8_V }, // 5119
  { PseudoVLSEG6E8_V_MF4_MASK, VLSEG6E8_V }, // 5120
  { PseudoVLSEG6E8_V_MF8, VLSEG6E8_V }, // 5121
  { PseudoVLSEG6E8_V_MF8_MASK, VLSEG6E8_V }, // 5122
  { PseudoVLSEG7E16FF_V_M1, VLSEG7E16FF_V }, // 5123
  { PseudoVLSEG7E16FF_V_M1_MASK, VLSEG7E16FF_V }, // 5124
  { PseudoVLSEG7E16FF_V_MF2, VLSEG7E16FF_V }, // 5125
  { PseudoVLSEG7E16FF_V_MF2_MASK, VLSEG7E16FF_V }, // 5126
  { PseudoVLSEG7E16FF_V_MF4, VLSEG7E16FF_V }, // 5127
  { PseudoVLSEG7E16FF_V_MF4_MASK, VLSEG7E16FF_V }, // 5128
  { PseudoVLSEG7E16_V_M1, VLSEG7E16_V }, // 5129
  { PseudoVLSEG7E16_V_M1_MASK, VLSEG7E16_V }, // 5130
  { PseudoVLSEG7E16_V_MF2, VLSEG7E16_V }, // 5131
  { PseudoVLSEG7E16_V_MF2_MASK, VLSEG7E16_V }, // 5132
  { PseudoVLSEG7E16_V_MF4, VLSEG7E16_V }, // 5133
  { PseudoVLSEG7E16_V_MF4_MASK, VLSEG7E16_V }, // 5134
  { PseudoVLSEG7E32FF_V_M1, VLSEG7E32FF_V }, // 5135
  { PseudoVLSEG7E32FF_V_M1_MASK, VLSEG7E32FF_V }, // 5136
  { PseudoVLSEG7E32FF_V_MF2, VLSEG7E32FF_V }, // 5137
  { PseudoVLSEG7E32FF_V_MF2_MASK, VLSEG7E32FF_V }, // 5138
  { PseudoVLSEG7E32_V_M1, VLSEG7E32_V }, // 5139
  { PseudoVLSEG7E32_V_M1_MASK, VLSEG7E32_V }, // 5140
  { PseudoVLSEG7E32_V_MF2, VLSEG7E32_V }, // 5141
  { PseudoVLSEG7E32_V_MF2_MASK, VLSEG7E32_V }, // 5142
  { PseudoVLSEG7E64FF_V_M1, VLSEG7E64FF_V }, // 5143
  { PseudoVLSEG7E64FF_V_M1_MASK, VLSEG7E64FF_V }, // 5144
  { PseudoVLSEG7E64_V_M1, VLSEG7E64_V }, // 5145
  { PseudoVLSEG7E64_V_M1_MASK, VLSEG7E64_V }, // 5146
  { PseudoVLSEG7E8FF_V_M1, VLSEG7E8FF_V }, // 5147
  { PseudoVLSEG7E8FF_V_M1_MASK, VLSEG7E8FF_V }, // 5148
  { PseudoVLSEG7E8FF_V_MF2, VLSEG7E8FF_V }, // 5149
  { PseudoVLSEG7E8FF_V_MF2_MASK, VLSEG7E8FF_V }, // 5150
  { PseudoVLSEG7E8FF_V_MF4, VLSEG7E8FF_V }, // 5151
  { PseudoVLSEG7E8FF_V_MF4_MASK, VLSEG7E8FF_V }, // 5152
  { PseudoVLSEG7E8FF_V_MF8, VLSEG7E8FF_V }, // 5153
  { PseudoVLSEG7E8FF_V_MF8_MASK, VLSEG7E8FF_V }, // 5154
  { PseudoVLSEG7E8_V_M1, VLSEG7E8_V }, // 5155
  { PseudoVLSEG7E8_V_M1_MASK, VLSEG7E8_V }, // 5156
  { PseudoVLSEG7E8_V_MF2, VLSEG7E8_V }, // 5157
  { PseudoVLSEG7E8_V_MF2_MASK, VLSEG7E8_V }, // 5158
  { PseudoVLSEG7E8_V_MF4, VLSEG7E8_V }, // 5159
  { PseudoVLSEG7E8_V_MF4_MASK, VLSEG7E8_V }, // 5160
  { PseudoVLSEG7E8_V_MF8, VLSEG7E8_V }, // 5161
  { PseudoVLSEG7E8_V_MF8_MASK, VLSEG7E8_V }, // 5162
  { PseudoVLSEG8E16FF_V_M1, VLSEG8E16FF_V }, // 5163
  { PseudoVLSEG8E16FF_V_M1_MASK, VLSEG8E16FF_V }, // 5164
  { PseudoVLSEG8E16FF_V_MF2, VLSEG8E16FF_V }, // 5165
  { PseudoVLSEG8E16FF_V_MF2_MASK, VLSEG8E16FF_V }, // 5166
  { PseudoVLSEG8E16FF_V_MF4, VLSEG8E16FF_V }, // 5167
  { PseudoVLSEG8E16FF_V_MF4_MASK, VLSEG8E16FF_V }, // 5168
  { PseudoVLSEG8E16_V_M1, VLSEG8E16_V }, // 5169
  { PseudoVLSEG8E16_V_M1_MASK, VLSEG8E16_V }, // 5170
  { PseudoVLSEG8E16_V_MF2, VLSEG8E16_V }, // 5171
  { PseudoVLSEG8E16_V_MF2_MASK, VLSEG8E16_V }, // 5172
  { PseudoVLSEG8E16_V_MF4, VLSEG8E16_V }, // 5173
  { PseudoVLSEG8E16_V_MF4_MASK, VLSEG8E16_V }, // 5174
  { PseudoVLSEG8E32FF_V_M1, VLSEG8E32FF_V }, // 5175
  { PseudoVLSEG8E32FF_V_M1_MASK, VLSEG8E32FF_V }, // 5176
  { PseudoVLSEG8E32FF_V_MF2, VLSEG8E32FF_V }, // 5177
  { PseudoVLSEG8E32FF_V_MF2_MASK, VLSEG8E32FF_V }, // 5178
  { PseudoVLSEG8E32_V_M1, VLSEG8E32_V }, // 5179
  { PseudoVLSEG8E32_V_M1_MASK, VLSEG8E32_V }, // 5180
  { PseudoVLSEG8E32_V_MF2, VLSEG8E32_V }, // 5181
  { PseudoVLSEG8E32_V_MF2_MASK, VLSEG8E32_V }, // 5182
  { PseudoVLSEG8E64FF_V_M1, VLSEG8E64FF_V }, // 5183
  { PseudoVLSEG8E64FF_V_M1_MASK, VLSEG8E64FF_V }, // 5184
  { PseudoVLSEG8E64_V_M1, VLSEG8E64_V }, // 5185
  { PseudoVLSEG8E64_V_M1_MASK, VLSEG8E64_V }, // 5186
  { PseudoVLSEG8E8FF_V_M1, VLSEG8E8FF_V }, // 5187
  { PseudoVLSEG8E8FF_V_M1_MASK, VLSEG8E8FF_V }, // 5188
  { PseudoVLSEG8E8FF_V_MF2, VLSEG8E8FF_V }, // 5189
  { PseudoVLSEG8E8FF_V_MF2_MASK, VLSEG8E8FF_V }, // 5190
  { PseudoVLSEG8E8FF_V_MF4, VLSEG8E8FF_V }, // 5191
  { PseudoVLSEG8E8FF_V_MF4_MASK, VLSEG8E8FF_V }, // 5192
  { PseudoVLSEG8E8FF_V_MF8, VLSEG8E8FF_V }, // 5193
  { PseudoVLSEG8E8FF_V_MF8_MASK, VLSEG8E8FF_V }, // 5194
  { PseudoVLSEG8E8_V_M1, VLSEG8E8_V }, // 5195
  { PseudoVLSEG8E8_V_M1_MASK, VLSEG8E8_V }, // 5196
  { PseudoVLSEG8E8_V_MF2, VLSEG8E8_V }, // 5197
  { PseudoVLSEG8E8_V_MF2_MASK, VLSEG8E8_V }, // 5198
  { PseudoVLSEG8E8_V_MF4, VLSEG8E8_V }, // 5199
  { PseudoVLSEG8E8_V_MF4_MASK, VLSEG8E8_V }, // 5200
  { PseudoVLSEG8E8_V_MF8, VLSEG8E8_V }, // 5201
  { PseudoVLSEG8E8_V_MF8_MASK, VLSEG8E8_V }, // 5202
  { PseudoVLSSEG2E16_V_M1, VLSSEG2E16_V }, // 5203
  { PseudoVLSSEG2E16_V_M1_MASK, VLSSEG2E16_V }, // 5204
  { PseudoVLSSEG2E16_V_M2, VLSSEG2E16_V }, // 5205
  { PseudoVLSSEG2E16_V_M2_MASK, VLSSEG2E16_V }, // 5206
  { PseudoVLSSEG2E16_V_M4, VLSSEG2E16_V }, // 5207
  { PseudoVLSSEG2E16_V_M4_MASK, VLSSEG2E16_V }, // 5208
  { PseudoVLSSEG2E16_V_MF2, VLSSEG2E16_V }, // 5209
  { PseudoVLSSEG2E16_V_MF2_MASK, VLSSEG2E16_V }, // 5210
  { PseudoVLSSEG2E16_V_MF4, VLSSEG2E16_V }, // 5211
  { PseudoVLSSEG2E16_V_MF4_MASK, VLSSEG2E16_V }, // 5212
  { PseudoVLSSEG2E32_V_M1, VLSSEG2E32_V }, // 5213
  { PseudoVLSSEG2E32_V_M1_MASK, VLSSEG2E32_V }, // 5214
  { PseudoVLSSEG2E32_V_M2, VLSSEG2E32_V }, // 5215
  { PseudoVLSSEG2E32_V_M2_MASK, VLSSEG2E32_V }, // 5216
  { PseudoVLSSEG2E32_V_M4, VLSSEG2E32_V }, // 5217
  { PseudoVLSSEG2E32_V_M4_MASK, VLSSEG2E32_V }, // 5218
  { PseudoVLSSEG2E32_V_MF2, VLSSEG2E32_V }, // 5219
  { PseudoVLSSEG2E32_V_MF2_MASK, VLSSEG2E32_V }, // 5220
  { PseudoVLSSEG2E64_V_M1, VLSSEG2E64_V }, // 5221
  { PseudoVLSSEG2E64_V_M1_MASK, VLSSEG2E64_V }, // 5222
  { PseudoVLSSEG2E64_V_M2, VLSSEG2E64_V }, // 5223
  { PseudoVLSSEG2E64_V_M2_MASK, VLSSEG2E64_V }, // 5224
  { PseudoVLSSEG2E64_V_M4, VLSSEG2E64_V }, // 5225
  { PseudoVLSSEG2E64_V_M4_MASK, VLSSEG2E64_V }, // 5226
  { PseudoVLSSEG2E8_V_M1, VLSSEG2E8_V }, // 5227
  { PseudoVLSSEG2E8_V_M1_MASK, VLSSEG2E8_V }, // 5228
  { PseudoVLSSEG2E8_V_M2, VLSSEG2E8_V }, // 5229
  { PseudoVLSSEG2E8_V_M2_MASK, VLSSEG2E8_V }, // 5230
  { PseudoVLSSEG2E8_V_M4, VLSSEG2E8_V }, // 5231
  { PseudoVLSSEG2E8_V_M4_MASK, VLSSEG2E8_V }, // 5232
  { PseudoVLSSEG2E8_V_MF2, VLSSEG2E8_V }, // 5233
  { PseudoVLSSEG2E8_V_MF2_MASK, VLSSEG2E8_V }, // 5234
  { PseudoVLSSEG2E8_V_MF4, VLSSEG2E8_V }, // 5235
  { PseudoVLSSEG2E8_V_MF4_MASK, VLSSEG2E8_V }, // 5236
  { PseudoVLSSEG2E8_V_MF8, VLSSEG2E8_V }, // 5237
  { PseudoVLSSEG2E8_V_MF8_MASK, VLSSEG2E8_V }, // 5238
  { PseudoVLSSEG3E16_V_M1, VLSSEG3E16_V }, // 5239
  { PseudoVLSSEG3E16_V_M1_MASK, VLSSEG3E16_V }, // 5240
  { PseudoVLSSEG3E16_V_M2, VLSSEG3E16_V }, // 5241
  { PseudoVLSSEG3E16_V_M2_MASK, VLSSEG3E16_V }, // 5242
  { PseudoVLSSEG3E16_V_MF2, VLSSEG3E16_V }, // 5243
  { PseudoVLSSEG3E16_V_MF2_MASK, VLSSEG3E16_V }, // 5244
  { PseudoVLSSEG3E16_V_MF4, VLSSEG3E16_V }, // 5245
  { PseudoVLSSEG3E16_V_MF4_MASK, VLSSEG3E16_V }, // 5246
  { PseudoVLSSEG3E32_V_M1, VLSSEG3E32_V }, // 5247
  { PseudoVLSSEG3E32_V_M1_MASK, VLSSEG3E32_V }, // 5248
  { PseudoVLSSEG3E32_V_M2, VLSSEG3E32_V }, // 5249
  { PseudoVLSSEG3E32_V_M2_MASK, VLSSEG3E32_V }, // 5250
  { PseudoVLSSEG3E32_V_MF2, VLSSEG3E32_V }, // 5251
  { PseudoVLSSEG3E32_V_MF2_MASK, VLSSEG3E32_V }, // 5252
  { PseudoVLSSEG3E64_V_M1, VLSSEG3E64_V }, // 5253
  { PseudoVLSSEG3E64_V_M1_MASK, VLSSEG3E64_V }, // 5254
  { PseudoVLSSEG3E64_V_M2, VLSSEG3E64_V }, // 5255
  { PseudoVLSSEG3E64_V_M2_MASK, VLSSEG3E64_V }, // 5256
  { PseudoVLSSEG3E8_V_M1, VLSSEG3E8_V }, // 5257
  { PseudoVLSSEG3E8_V_M1_MASK, VLSSEG3E8_V }, // 5258
  { PseudoVLSSEG3E8_V_M2, VLSSEG3E8_V }, // 5259
  { PseudoVLSSEG3E8_V_M2_MASK, VLSSEG3E8_V }, // 5260
  { PseudoVLSSEG3E8_V_MF2, VLSSEG3E8_V }, // 5261
  { PseudoVLSSEG3E8_V_MF2_MASK, VLSSEG3E8_V }, // 5262
  { PseudoVLSSEG3E8_V_MF4, VLSSEG3E8_V }, // 5263
  { PseudoVLSSEG3E8_V_MF4_MASK, VLSSEG3E8_V }, // 5264
  { PseudoVLSSEG3E8_V_MF8, VLSSEG3E8_V }, // 5265
  { PseudoVLSSEG3E8_V_MF8_MASK, VLSSEG3E8_V }, // 5266
  { PseudoVLSSEG4E16_V_M1, VLSSEG4E16_V }, // 5267
  { PseudoVLSSEG4E16_V_M1_MASK, VLSSEG4E16_V }, // 5268
  { PseudoVLSSEG4E16_V_M2, VLSSEG4E16_V }, // 5269
  { PseudoVLSSEG4E16_V_M2_MASK, VLSSEG4E16_V }, // 5270
  { PseudoVLSSEG4E16_V_MF2, VLSSEG4E16_V }, // 5271
  { PseudoVLSSEG4E16_V_MF2_MASK, VLSSEG4E16_V }, // 5272
  { PseudoVLSSEG4E16_V_MF4, VLSSEG4E16_V }, // 5273
  { PseudoVLSSEG4E16_V_MF4_MASK, VLSSEG4E16_V }, // 5274
  { PseudoVLSSEG4E32_V_M1, VLSSEG4E32_V }, // 5275
  { PseudoVLSSEG4E32_V_M1_MASK, VLSSEG4E32_V }, // 5276
  { PseudoVLSSEG4E32_V_M2, VLSSEG4E32_V }, // 5277
  { PseudoVLSSEG4E32_V_M2_MASK, VLSSEG4E32_V }, // 5278
  { PseudoVLSSEG4E32_V_MF2, VLSSEG4E32_V }, // 5279
  { PseudoVLSSEG4E32_V_MF2_MASK, VLSSEG4E32_V }, // 5280
  { PseudoVLSSEG4E64_V_M1, VLSSEG4E64_V }, // 5281
  { PseudoVLSSEG4E64_V_M1_MASK, VLSSEG4E64_V }, // 5282
  { PseudoVLSSEG4E64_V_M2, VLSSEG4E64_V }, // 5283
  { PseudoVLSSEG4E64_V_M2_MASK, VLSSEG4E64_V }, // 5284
  { PseudoVLSSEG4E8_V_M1, VLSSEG4E8_V }, // 5285
  { PseudoVLSSEG4E8_V_M1_MASK, VLSSEG4E8_V }, // 5286
  { PseudoVLSSEG4E8_V_M2, VLSSEG4E8_V }, // 5287
  { PseudoVLSSEG4E8_V_M2_MASK, VLSSEG4E8_V }, // 5288
  { PseudoVLSSEG4E8_V_MF2, VLSSEG4E8_V }, // 5289
  { PseudoVLSSEG4E8_V_MF2_MASK, VLSSEG4E8_V }, // 5290
  { PseudoVLSSEG4E8_V_MF4, VLSSEG4E8_V }, // 5291
  { PseudoVLSSEG4E8_V_MF4_MASK, VLSSEG4E8_V }, // 5292
  { PseudoVLSSEG4E8_V_MF8, VLSSEG4E8_V }, // 5293
  { PseudoVLSSEG4E8_V_MF8_MASK, VLSSEG4E8_V }, // 5294
  { PseudoVLSSEG5E16_V_M1, VLSSEG5E16_V }, // 5295
  { PseudoVLSSEG5E16_V_M1_MASK, VLSSEG5E16_V }, // 5296
  { PseudoVLSSEG5E16_V_MF2, VLSSEG5E16_V }, // 5297
  { PseudoVLSSEG5E16_V_MF2_MASK, VLSSEG5E16_V }, // 5298
  { PseudoVLSSEG5E16_V_MF4, VLSSEG5E16_V }, // 5299
  { PseudoVLSSEG5E16_V_MF4_MASK, VLSSEG5E16_V }, // 5300
  { PseudoVLSSEG5E32_V_M1, VLSSEG5E32_V }, // 5301
  { PseudoVLSSEG5E32_V_M1_MASK, VLSSEG5E32_V }, // 5302
  { PseudoVLSSEG5E32_V_MF2, VLSSEG5E32_V }, // 5303
  { PseudoVLSSEG5E32_V_MF2_MASK, VLSSEG5E32_V }, // 5304
  { PseudoVLSSEG5E64_V_M1, VLSSEG5E64_V }, // 5305
  { PseudoVLSSEG5E64_V_M1_MASK, VLSSEG5E64_V }, // 5306
  { PseudoVLSSEG5E8_V_M1, VLSSEG5E8_V }, // 5307
  { PseudoVLSSEG5E8_V_M1_MASK, VLSSEG5E8_V }, // 5308
  { PseudoVLSSEG5E8_V_MF2, VLSSEG5E8_V }, // 5309
  { PseudoVLSSEG5E8_V_MF2_MASK, VLSSEG5E8_V }, // 5310
  { PseudoVLSSEG5E8_V_MF4, VLSSEG5E8_V }, // 5311
  { PseudoVLSSEG5E8_V_MF4_MASK, VLSSEG5E8_V }, // 5312
  { PseudoVLSSEG5E8_V_MF8, VLSSEG5E8_V }, // 5313
  { PseudoVLSSEG5E8_V_MF8_MASK, VLSSEG5E8_V }, // 5314
  { PseudoVLSSEG6E16_V_M1, VLSSEG6E16_V }, // 5315
  { PseudoVLSSEG6E16_V_M1_MASK, VLSSEG6E16_V }, // 5316
  { PseudoVLSSEG6E16_V_MF2, VLSSEG6E16_V }, // 5317
  { PseudoVLSSEG6E16_V_MF2_MASK, VLSSEG6E16_V }, // 5318
  { PseudoVLSSEG6E16_V_MF4, VLSSEG6E16_V }, // 5319
  { PseudoVLSSEG6E16_V_MF4_MASK, VLSSEG6E16_V }, // 5320
  { PseudoVLSSEG6E32_V_M1, VLSSEG6E32_V }, // 5321
  { PseudoVLSSEG6E32_V_M1_MASK, VLSSEG6E32_V }, // 5322
  { PseudoVLSSEG6E32_V_MF2, VLSSEG6E32_V }, // 5323
  { PseudoVLSSEG6E32_V_MF2_MASK, VLSSEG6E32_V }, // 5324
  { PseudoVLSSEG6E64_V_M1, VLSSEG6E64_V }, // 5325
  { PseudoVLSSEG6E64_V_M1_MASK, VLSSEG6E64_V }, // 5326
  { PseudoVLSSEG6E8_V_M1, VLSSEG6E8_V }, // 5327
  { PseudoVLSSEG6E8_V_M1_MASK, VLSSEG6E8_V }, // 5328
  { PseudoVLSSEG6E8_V_MF2, VLSSEG6E8_V }, // 5329
  { PseudoVLSSEG6E8_V_MF2_MASK, VLSSEG6E8_V }, // 5330
  { PseudoVLSSEG6E8_V_MF4, VLSSEG6E8_V }, // 5331
  { PseudoVLSSEG6E8_V_MF4_MASK, VLSSEG6E8_V }, // 5332
  { PseudoVLSSEG6E8_V_MF8, VLSSEG6E8_V }, // 5333
  { PseudoVLSSEG6E8_V_MF8_MASK, VLSSEG6E8_V }, // 5334
  { PseudoVLSSEG7E16_V_M1, VLSSEG7E16_V }, // 5335
  { PseudoVLSSEG7E16_V_M1_MASK, VLSSEG7E16_V }, // 5336
  { PseudoVLSSEG7E16_V_MF2, VLSSEG7E16_V }, // 5337
  { PseudoVLSSEG7E16_V_MF2_MASK, VLSSEG7E16_V }, // 5338
  { PseudoVLSSEG7E16_V_MF4, VLSSEG7E16_V }, // 5339
  { PseudoVLSSEG7E16_V_MF4_MASK, VLSSEG7E16_V }, // 5340
  { PseudoVLSSEG7E32_V_M1, VLSSEG7E32_V }, // 5341
  { PseudoVLSSEG7E32_V_M1_MASK, VLSSEG7E32_V }, // 5342
  { PseudoVLSSEG7E32_V_MF2, VLSSEG7E32_V }, // 5343
  { PseudoVLSSEG7E32_V_MF2_MASK, VLSSEG7E32_V }, // 5344
  { PseudoVLSSEG7E64_V_M1, VLSSEG7E64_V }, // 5345
  { PseudoVLSSEG7E64_V_M1_MASK, VLSSEG7E64_V }, // 5346
  { PseudoVLSSEG7E8_V_M1, VLSSEG7E8_V }, // 5347
  { PseudoVLSSEG7E8_V_M1_MASK, VLSSEG7E8_V }, // 5348
  { PseudoVLSSEG7E8_V_MF2, VLSSEG7E8_V }, // 5349
  { PseudoVLSSEG7E8_V_MF2_MASK, VLSSEG7E8_V }, // 5350
  { PseudoVLSSEG7E8_V_MF4, VLSSEG7E8_V }, // 5351
  { PseudoVLSSEG7E8_V_MF4_MASK, VLSSEG7E8_V }, // 5352
  { PseudoVLSSEG7E8_V_MF8, VLSSEG7E8_V }, // 5353
  { PseudoVLSSEG7E8_V_MF8_MASK, VLSSEG7E8_V }, // 5354
  { PseudoVLSSEG8E16_V_M1, VLSSEG8E16_V }, // 5355
  { PseudoVLSSEG8E16_V_M1_MASK, VLSSEG8E16_V }, // 5356
  { PseudoVLSSEG8E16_V_MF2, VLSSEG8E16_V }, // 5357
  { PseudoVLSSEG8E16_V_MF2_MASK, VLSSEG8E16_V }, // 5358
  { PseudoVLSSEG8E16_V_MF4, VLSSEG8E16_V }, // 5359
  { PseudoVLSSEG8E16_V_MF4_MASK, VLSSEG8E16_V }, // 5360
  { PseudoVLSSEG8E32_V_M1, VLSSEG8E32_V }, // 5361
  { PseudoVLSSEG8E32_V_M1_MASK, VLSSEG8E32_V }, // 5362
  { PseudoVLSSEG8E32_V_MF2, VLSSEG8E32_V }, // 5363
  { PseudoVLSSEG8E32_V_MF2_MASK, VLSSEG8E32_V }, // 5364
  { PseudoVLSSEG8E64_V_M1, VLSSEG8E64_V }, // 5365
  { PseudoVLSSEG8E64_V_M1_MASK, VLSSEG8E64_V }, // 5366
  { PseudoVLSSEG8E8_V_M1, VLSSEG8E8_V }, // 5367
  { PseudoVLSSEG8E8_V_M1_MASK, VLSSEG8E8_V }, // 5368
  { PseudoVLSSEG8E8_V_MF2, VLSSEG8E8_V }, // 5369
  { PseudoVLSSEG8E8_V_MF2_MASK, VLSSEG8E8_V }, // 5370
  { PseudoVLSSEG8E8_V_MF4, VLSSEG8E8_V }, // 5371
  { PseudoVLSSEG8E8_V_MF4_MASK, VLSSEG8E8_V }, // 5372
  { PseudoVLSSEG8E8_V_MF8, VLSSEG8E8_V }, // 5373
  { PseudoVLSSEG8E8_V_MF8_MASK, VLSSEG8E8_V }, // 5374
  { PseudoVLUXEI16_V_M1_M1, VLUXEI16_V }, // 5375
  { PseudoVLUXEI16_V_M1_M1_MASK, VLUXEI16_V }, // 5376
  { PseudoVLUXEI16_V_M1_M2, VLUXEI16_V }, // 5377
  { PseudoVLUXEI16_V_M1_M2_MASK, VLUXEI16_V }, // 5378
  { PseudoVLUXEI16_V_M1_M4, VLUXEI16_V }, // 5379
  { PseudoVLUXEI16_V_M1_M4_MASK, VLUXEI16_V }, // 5380
  { PseudoVLUXEI16_V_M1_M8, VLUXEI16_V }, // 5381
  { PseudoVLUXEI16_V_M1_M8_MASK, VLUXEI16_V }, // 5382
  { PseudoVLUXEI16_V_M1_MF2, VLUXEI16_V }, // 5383
  { PseudoVLUXEI16_V_M1_MF2_MASK, VLUXEI16_V }, // 5384
  { PseudoVLUXEI16_V_M1_MF4, VLUXEI16_V }, // 5385
  { PseudoVLUXEI16_V_M1_MF4_MASK, VLUXEI16_V }, // 5386
  { PseudoVLUXEI16_V_M1_MF8, VLUXEI16_V }, // 5387
  { PseudoVLUXEI16_V_M1_MF8_MASK, VLUXEI16_V }, // 5388
  { PseudoVLUXEI16_V_M2_M1, VLUXEI16_V }, // 5389
  { PseudoVLUXEI16_V_M2_M1_MASK, VLUXEI16_V }, // 5390
  { PseudoVLUXEI16_V_M2_M2, VLUXEI16_V }, // 5391
  { PseudoVLUXEI16_V_M2_M2_MASK, VLUXEI16_V }, // 5392
  { PseudoVLUXEI16_V_M2_M4, VLUXEI16_V }, // 5393
  { PseudoVLUXEI16_V_M2_M4_MASK, VLUXEI16_V }, // 5394
  { PseudoVLUXEI16_V_M2_M8, VLUXEI16_V }, // 5395
  { PseudoVLUXEI16_V_M2_M8_MASK, VLUXEI16_V }, // 5396
  { PseudoVLUXEI16_V_M2_MF2, VLUXEI16_V }, // 5397
  { PseudoVLUXEI16_V_M2_MF2_MASK, VLUXEI16_V }, // 5398
  { PseudoVLUXEI16_V_M2_MF4, VLUXEI16_V }, // 5399
  { PseudoVLUXEI16_V_M2_MF4_MASK, VLUXEI16_V }, // 5400
  { PseudoVLUXEI16_V_M2_MF8, VLUXEI16_V }, // 5401
  { PseudoVLUXEI16_V_M2_MF8_MASK, VLUXEI16_V }, // 5402
  { PseudoVLUXEI16_V_M4_M1, VLUXEI16_V }, // 5403
  { PseudoVLUXEI16_V_M4_M1_MASK, VLUXEI16_V }, // 5404
  { PseudoVLUXEI16_V_M4_M2, VLUXEI16_V }, // 5405
  { PseudoVLUXEI16_V_M4_M2_MASK, VLUXEI16_V }, // 5406
  { PseudoVLUXEI16_V_M4_M4, VLUXEI16_V }, // 5407
  { PseudoVLUXEI16_V_M4_M4_MASK, VLUXEI16_V }, // 5408
  { PseudoVLUXEI16_V_M4_M8, VLUXEI16_V }, // 5409
  { PseudoVLUXEI16_V_M4_M8_MASK, VLUXEI16_V }, // 5410
  { PseudoVLUXEI16_V_M4_MF2, VLUXEI16_V }, // 5411
  { PseudoVLUXEI16_V_M4_MF2_MASK, VLUXEI16_V }, // 5412
  { PseudoVLUXEI16_V_M4_MF4, VLUXEI16_V }, // 5413
  { PseudoVLUXEI16_V_M4_MF4_MASK, VLUXEI16_V }, // 5414
  { PseudoVLUXEI16_V_M4_MF8, VLUXEI16_V }, // 5415
  { PseudoVLUXEI16_V_M4_MF8_MASK, VLUXEI16_V }, // 5416
  { PseudoVLUXEI16_V_M8_M1, VLUXEI16_V }, // 5417
  { PseudoVLUXEI16_V_M8_M1_MASK, VLUXEI16_V }, // 5418
  { PseudoVLUXEI16_V_M8_M2, VLUXEI16_V }, // 5419
  { PseudoVLUXEI16_V_M8_M2_MASK, VLUXEI16_V }, // 5420
  { PseudoVLUXEI16_V_M8_M4, VLUXEI16_V }, // 5421
  { PseudoVLUXEI16_V_M8_M4_MASK, VLUXEI16_V }, // 5422
  { PseudoVLUXEI16_V_M8_M8, VLUXEI16_V }, // 5423
  { PseudoVLUXEI16_V_M8_M8_MASK, VLUXEI16_V }, // 5424
  { PseudoVLUXEI16_V_M8_MF2, VLUXEI16_V }, // 5425
  { PseudoVLUXEI16_V_M8_MF2_MASK, VLUXEI16_V }, // 5426
  { PseudoVLUXEI16_V_M8_MF4, VLUXEI16_V }, // 5427
  { PseudoVLUXEI16_V_M8_MF4_MASK, VLUXEI16_V }, // 5428
  { PseudoVLUXEI16_V_M8_MF8, VLUXEI16_V }, // 5429
  { PseudoVLUXEI16_V_M8_MF8_MASK, VLUXEI16_V }, // 5430
  { PseudoVLUXEI16_V_MF2_M1, VLUXEI16_V }, // 5431
  { PseudoVLUXEI16_V_MF2_M1_MASK, VLUXEI16_V }, // 5432
  { PseudoVLUXEI16_V_MF2_M2, VLUXEI16_V }, // 5433
  { PseudoVLUXEI16_V_MF2_M2_MASK, VLUXEI16_V }, // 5434
  { PseudoVLUXEI16_V_MF2_M4, VLUXEI16_V }, // 5435
  { PseudoVLUXEI16_V_MF2_M4_MASK, VLUXEI16_V }, // 5436
  { PseudoVLUXEI16_V_MF2_M8, VLUXEI16_V }, // 5437
  { PseudoVLUXEI16_V_MF2_M8_MASK, VLUXEI16_V }, // 5438
  { PseudoVLUXEI16_V_MF2_MF2, VLUXEI16_V }, // 5439
  { PseudoVLUXEI16_V_MF2_MF2_MASK, VLUXEI16_V }, // 5440
  { PseudoVLUXEI16_V_MF2_MF4, VLUXEI16_V }, // 5441
  { PseudoVLUXEI16_V_MF2_MF4_MASK, VLUXEI16_V }, // 5442
  { PseudoVLUXEI16_V_MF2_MF8, VLUXEI16_V }, // 5443
  { PseudoVLUXEI16_V_MF2_MF8_MASK, VLUXEI16_V }, // 5444
  { PseudoVLUXEI16_V_MF4_M1, VLUXEI16_V }, // 5445
  { PseudoVLUXEI16_V_MF4_M1_MASK, VLUXEI16_V }, // 5446
  { PseudoVLUXEI16_V_MF4_M2, VLUXEI16_V }, // 5447
  { PseudoVLUXEI16_V_MF4_M2_MASK, VLUXEI16_V }, // 5448
  { PseudoVLUXEI16_V_MF4_M4, VLUXEI16_V }, // 5449
  { PseudoVLUXEI16_V_MF4_M4_MASK, VLUXEI16_V }, // 5450
  { PseudoVLUXEI16_V_MF4_M8, VLUXEI16_V }, // 5451
  { PseudoVLUXEI16_V_MF4_M8_MASK, VLUXEI16_V }, // 5452
  { PseudoVLUXEI16_V_MF4_MF2, VLUXEI16_V }, // 5453
  { PseudoVLUXEI16_V_MF4_MF2_MASK, VLUXEI16_V }, // 5454
  { PseudoVLUXEI16_V_MF4_MF4, VLUXEI16_V }, // 5455
  { PseudoVLUXEI16_V_MF4_MF4_MASK, VLUXEI16_V }, // 5456
  { PseudoVLUXEI16_V_MF4_MF8, VLUXEI16_V }, // 5457
  { PseudoVLUXEI16_V_MF4_MF8_MASK, VLUXEI16_V }, // 5458
  { PseudoVLUXEI16_V_MF8_M1, VLUXEI16_V }, // 5459
  { PseudoVLUXEI16_V_MF8_M1_MASK, VLUXEI16_V }, // 5460
  { PseudoVLUXEI16_V_MF8_M2, VLUXEI16_V }, // 5461
  { PseudoVLUXEI16_V_MF8_M2_MASK, VLUXEI16_V }, // 5462
  { PseudoVLUXEI16_V_MF8_M4, VLUXEI16_V }, // 5463
  { PseudoVLUXEI16_V_MF8_M4_MASK, VLUXEI16_V }, // 5464
  { PseudoVLUXEI16_V_MF8_M8, VLUXEI16_V }, // 5465
  { PseudoVLUXEI16_V_MF8_M8_MASK, VLUXEI16_V }, // 5466
  { PseudoVLUXEI16_V_MF8_MF2, VLUXEI16_V }, // 5467
  { PseudoVLUXEI16_V_MF8_MF2_MASK, VLUXEI16_V }, // 5468
  { PseudoVLUXEI16_V_MF8_MF4, VLUXEI16_V }, // 5469
  { PseudoVLUXEI16_V_MF8_MF4_MASK, VLUXEI16_V }, // 5470
  { PseudoVLUXEI16_V_MF8_MF8, VLUXEI16_V }, // 5471
  { PseudoVLUXEI16_V_MF8_MF8_MASK, VLUXEI16_V }, // 5472
  { PseudoVLUXEI32_V_M1_M1, VLUXEI32_V }, // 5473
  { PseudoVLUXEI32_V_M1_M1_MASK, VLUXEI32_V }, // 5474
  { PseudoVLUXEI32_V_M1_M2, VLUXEI32_V }, // 5475
  { PseudoVLUXEI32_V_M1_M2_MASK, VLUXEI32_V }, // 5476
  { PseudoVLUXEI32_V_M1_M4, VLUXEI32_V }, // 5477
  { PseudoVLUXEI32_V_M1_M4_MASK, VLUXEI32_V }, // 5478
  { PseudoVLUXEI32_V_M1_M8, VLUXEI32_V }, // 5479
  { PseudoVLUXEI32_V_M1_M8_MASK, VLUXEI32_V }, // 5480
  { PseudoVLUXEI32_V_M1_MF2, VLUXEI32_V }, // 5481
  { PseudoVLUXEI32_V_M1_MF2_MASK, VLUXEI32_V }, // 5482
  { PseudoVLUXEI32_V_M1_MF4, VLUXEI32_V }, // 5483
  { PseudoVLUXEI32_V_M1_MF4_MASK, VLUXEI32_V }, // 5484
  { PseudoVLUXEI32_V_M1_MF8, VLUXEI32_V }, // 5485
  { PseudoVLUXEI32_V_M1_MF8_MASK, VLUXEI32_V }, // 5486
  { PseudoVLUXEI32_V_M2_M1, VLUXEI32_V }, // 5487
  { PseudoVLUXEI32_V_M2_M1_MASK, VLUXEI32_V }, // 5488
  { PseudoVLUXEI32_V_M2_M2, VLUXEI32_V }, // 5489
  { PseudoVLUXEI32_V_M2_M2_MASK, VLUXEI32_V }, // 5490
  { PseudoVLUXEI32_V_M2_M4, VLUXEI32_V }, // 5491
  { PseudoVLUXEI32_V_M2_M4_MASK, VLUXEI32_V }, // 5492
  { PseudoVLUXEI32_V_M2_M8, VLUXEI32_V }, // 5493
  { PseudoVLUXEI32_V_M2_M8_MASK, VLUXEI32_V }, // 5494
  { PseudoVLUXEI32_V_M2_MF2, VLUXEI32_V }, // 5495
  { PseudoVLUXEI32_V_M2_MF2_MASK, VLUXEI32_V }, // 5496
  { PseudoVLUXEI32_V_M2_MF4, VLUXEI32_V }, // 5497
  { PseudoVLUXEI32_V_M2_MF4_MASK, VLUXEI32_V }, // 5498
  { PseudoVLUXEI32_V_M2_MF8, VLUXEI32_V }, // 5499
  { PseudoVLUXEI32_V_M2_MF8_MASK, VLUXEI32_V }, // 5500
  { PseudoVLUXEI32_V_M4_M1, VLUXEI32_V }, // 5501
  { PseudoVLUXEI32_V_M4_M1_MASK, VLUXEI32_V }, // 5502
  { PseudoVLUXEI32_V_M4_M2, VLUXEI32_V }, // 5503
  { PseudoVLUXEI32_V_M4_M2_MASK, VLUXEI32_V }, // 5504
  { PseudoVLUXEI32_V_M4_M4, VLUXEI32_V }, // 5505
  { PseudoVLUXEI32_V_M4_M4_MASK, VLUXEI32_V }, // 5506
  { PseudoVLUXEI32_V_M4_M8, VLUXEI32_V }, // 5507
  { PseudoVLUXEI32_V_M4_M8_MASK, VLUXEI32_V }, // 5508
  { PseudoVLUXEI32_V_M4_MF2, VLUXEI32_V }, // 5509
  { PseudoVLUXEI32_V_M4_MF2_MASK, VLUXEI32_V }, // 5510
  { PseudoVLUXEI32_V_M4_MF4, VLUXEI32_V }, // 5511
  { PseudoVLUXEI32_V_M4_MF4_MASK, VLUXEI32_V }, // 5512
  { PseudoVLUXEI32_V_M4_MF8, VLUXEI32_V }, // 5513
  { PseudoVLUXEI32_V_M4_MF8_MASK, VLUXEI32_V }, // 5514
  { PseudoVLUXEI32_V_M8_M1, VLUXEI32_V }, // 5515
  { PseudoVLUXEI32_V_M8_M1_MASK, VLUXEI32_V }, // 5516
  { PseudoVLUXEI32_V_M8_M2, VLUXEI32_V }, // 5517
  { PseudoVLUXEI32_V_M8_M2_MASK, VLUXEI32_V }, // 5518
  { PseudoVLUXEI32_V_M8_M4, VLUXEI32_V }, // 5519
  { PseudoVLUXEI32_V_M8_M4_MASK, VLUXEI32_V }, // 5520
  { PseudoVLUXEI32_V_M8_M8, VLUXEI32_V }, // 5521
  { PseudoVLUXEI32_V_M8_M8_MASK, VLUXEI32_V }, // 5522
  { PseudoVLUXEI32_V_M8_MF2, VLUXEI32_V }, // 5523
  { PseudoVLUXEI32_V_M8_MF2_MASK, VLUXEI32_V }, // 5524
  { PseudoVLUXEI32_V_M8_MF4, VLUXEI32_V }, // 5525
  { PseudoVLUXEI32_V_M8_MF4_MASK, VLUXEI32_V }, // 5526
  { PseudoVLUXEI32_V_M8_MF8, VLUXEI32_V }, // 5527
  { PseudoVLUXEI32_V_M8_MF8_MASK, VLUXEI32_V }, // 5528
  { PseudoVLUXEI32_V_MF2_M1, VLUXEI32_V }, // 5529
  { PseudoVLUXEI32_V_MF2_M1_MASK, VLUXEI32_V }, // 5530
  { PseudoVLUXEI32_V_MF2_M2, VLUXEI32_V }, // 5531
  { PseudoVLUXEI32_V_MF2_M2_MASK, VLUXEI32_V }, // 5532
  { PseudoVLUXEI32_V_MF2_M4, VLUXEI32_V }, // 5533
  { PseudoVLUXEI32_V_MF2_M4_MASK, VLUXEI32_V }, // 5534
  { PseudoVLUXEI32_V_MF2_M8, VLUXEI32_V }, // 5535
  { PseudoVLUXEI32_V_MF2_M8_MASK, VLUXEI32_V }, // 5536
  { PseudoVLUXEI32_V_MF2_MF2, VLUXEI32_V }, // 5537
  { PseudoVLUXEI32_V_MF2_MF2_MASK, VLUXEI32_V }, // 5538
  { PseudoVLUXEI32_V_MF2_MF4, VLUXEI32_V }, // 5539
  { PseudoVLUXEI32_V_MF2_MF4_MASK, VLUXEI32_V }, // 5540
  { PseudoVLUXEI32_V_MF2_MF8, VLUXEI32_V }, // 5541
  { PseudoVLUXEI32_V_MF2_MF8_MASK, VLUXEI32_V }, // 5542
  { PseudoVLUXEI32_V_MF4_M1, VLUXEI32_V }, // 5543
  { PseudoVLUXEI32_V_MF4_M1_MASK, VLUXEI32_V }, // 5544
  { PseudoVLUXEI32_V_MF4_M2, VLUXEI32_V }, // 5545
  { PseudoVLUXEI32_V_MF4_M2_MASK, VLUXEI32_V }, // 5546
  { PseudoVLUXEI32_V_MF4_M4, VLUXEI32_V }, // 5547
  { PseudoVLUXEI32_V_MF4_M4_MASK, VLUXEI32_V }, // 5548
  { PseudoVLUXEI32_V_MF4_M8, VLUXEI32_V }, // 5549
  { PseudoVLUXEI32_V_MF4_M8_MASK, VLUXEI32_V }, // 5550
  { PseudoVLUXEI32_V_MF4_MF2, VLUXEI32_V }, // 5551
  { PseudoVLUXEI32_V_MF4_MF2_MASK, VLUXEI32_V }, // 5552
  { PseudoVLUXEI32_V_MF4_MF4, VLUXEI32_V }, // 5553
  { PseudoVLUXEI32_V_MF4_MF4_MASK, VLUXEI32_V }, // 5554
  { PseudoVLUXEI32_V_MF4_MF8, VLUXEI32_V }, // 5555
  { PseudoVLUXEI32_V_MF4_MF8_MASK, VLUXEI32_V }, // 5556
  { PseudoVLUXEI32_V_MF8_M1, VLUXEI32_V }, // 5557
  { PseudoVLUXEI32_V_MF8_M1_MASK, VLUXEI32_V }, // 5558
  { PseudoVLUXEI32_V_MF8_M2, VLUXEI32_V }, // 5559
  { PseudoVLUXEI32_V_MF8_M2_MASK, VLUXEI32_V }, // 5560
  { PseudoVLUXEI32_V_MF8_M4, VLUXEI32_V }, // 5561
  { PseudoVLUXEI32_V_MF8_M4_MASK, VLUXEI32_V }, // 5562
  { PseudoVLUXEI32_V_MF8_M8, VLUXEI32_V }, // 5563
  { PseudoVLUXEI32_V_MF8_M8_MASK, VLUXEI32_V }, // 5564
  { PseudoVLUXEI32_V_MF8_MF2, VLUXEI32_V }, // 5565
  { PseudoVLUXEI32_V_MF8_MF2_MASK, VLUXEI32_V }, // 5566
  { PseudoVLUXEI32_V_MF8_MF4, VLUXEI32_V }, // 5567
  { PseudoVLUXEI32_V_MF8_MF4_MASK, VLUXEI32_V }, // 5568
  { PseudoVLUXEI32_V_MF8_MF8, VLUXEI32_V }, // 5569
  { PseudoVLUXEI32_V_MF8_MF8_MASK, VLUXEI32_V }, // 5570
  { PseudoVLUXEI64_V_M1_M1, VLUXEI64_V }, // 5571
  { PseudoVLUXEI64_V_M1_M1_MASK, VLUXEI64_V }, // 5572
  { PseudoVLUXEI64_V_M1_M2, VLUXEI64_V }, // 5573
  { PseudoVLUXEI64_V_M1_M2_MASK, VLUXEI64_V }, // 5574
  { PseudoVLUXEI64_V_M1_M4, VLUXEI64_V }, // 5575
  { PseudoVLUXEI64_V_M1_M4_MASK, VLUXEI64_V }, // 5576
  { PseudoVLUXEI64_V_M1_M8, VLUXEI64_V }, // 5577
  { PseudoVLUXEI64_V_M1_M8_MASK, VLUXEI64_V }, // 5578
  { PseudoVLUXEI64_V_M1_MF2, VLUXEI64_V }, // 5579
  { PseudoVLUXEI64_V_M1_MF2_MASK, VLUXEI64_V }, // 5580
  { PseudoVLUXEI64_V_M1_MF4, VLUXEI64_V }, // 5581
  { PseudoVLUXEI64_V_M1_MF4_MASK, VLUXEI64_V }, // 5582
  { PseudoVLUXEI64_V_M1_MF8, VLUXEI64_V }, // 5583
  { PseudoVLUXEI64_V_M1_MF8_MASK, VLUXEI64_V }, // 5584
  { PseudoVLUXEI64_V_M2_M1, VLUXEI64_V }, // 5585
  { PseudoVLUXEI64_V_M2_M1_MASK, VLUXEI64_V }, // 5586
  { PseudoVLUXEI64_V_M2_M2, VLUXEI64_V }, // 5587
  { PseudoVLUXEI64_V_M2_M2_MASK, VLUXEI64_V }, // 5588
  { PseudoVLUXEI64_V_M2_M4, VLUXEI64_V }, // 5589
  { PseudoVLUXEI64_V_M2_M4_MASK, VLUXEI64_V }, // 5590
  { PseudoVLUXEI64_V_M2_M8, VLUXEI64_V }, // 5591
  { PseudoVLUXEI64_V_M2_M8_MASK, VLUXEI64_V }, // 5592
  { PseudoVLUXEI64_V_M2_MF2, VLUXEI64_V }, // 5593
  { PseudoVLUXEI64_V_M2_MF2_MASK, VLUXEI64_V }, // 5594
  { PseudoVLUXEI64_V_M2_MF4, VLUXEI64_V }, // 5595
  { PseudoVLUXEI64_V_M2_MF4_MASK, VLUXEI64_V }, // 5596
  { PseudoVLUXEI64_V_M2_MF8, VLUXEI64_V }, // 5597
  { PseudoVLUXEI64_V_M2_MF8_MASK, VLUXEI64_V }, // 5598
  { PseudoVLUXEI64_V_M4_M1, VLUXEI64_V }, // 5599
  { PseudoVLUXEI64_V_M4_M1_MASK, VLUXEI64_V }, // 5600
  { PseudoVLUXEI64_V_M4_M2, VLUXEI64_V }, // 5601
  { PseudoVLUXEI64_V_M4_M2_MASK, VLUXEI64_V }, // 5602
  { PseudoVLUXEI64_V_M4_M4, VLUXEI64_V }, // 5603
  { PseudoVLUXEI64_V_M4_M4_MASK, VLUXEI64_V }, // 5604
  { PseudoVLUXEI64_V_M4_M8, VLUXEI64_V }, // 5605
  { PseudoVLUXEI64_V_M4_M8_MASK, VLUXEI64_V }, // 5606
  { PseudoVLUXEI64_V_M4_MF2, VLUXEI64_V }, // 5607
  { PseudoVLUXEI64_V_M4_MF2_MASK, VLUXEI64_V }, // 5608
  { PseudoVLUXEI64_V_M4_MF4, VLUXEI64_V }, // 5609
  { PseudoVLUXEI64_V_M4_MF4_MASK, VLUXEI64_V }, // 5610
  { PseudoVLUXEI64_V_M4_MF8, VLUXEI64_V }, // 5611
  { PseudoVLUXEI64_V_M4_MF8_MASK, VLUXEI64_V }, // 5612
  { PseudoVLUXEI64_V_M8_M1, VLUXEI64_V }, // 5613
  { PseudoVLUXEI64_V_M8_M1_MASK, VLUXEI64_V }, // 5614
  { PseudoVLUXEI64_V_M8_M2, VLUXEI64_V }, // 5615
  { PseudoVLUXEI64_V_M8_M2_MASK, VLUXEI64_V }, // 5616
  { PseudoVLUXEI64_V_M8_M4, VLUXEI64_V }, // 5617
  { PseudoVLUXEI64_V_M8_M4_MASK, VLUXEI64_V }, // 5618
  { PseudoVLUXEI64_V_M8_M8, VLUXEI64_V }, // 5619
  { PseudoVLUXEI64_V_M8_M8_MASK, VLUXEI64_V }, // 5620
  { PseudoVLUXEI64_V_M8_MF2, VLUXEI64_V }, // 5621
  { PseudoVLUXEI64_V_M8_MF2_MASK, VLUXEI64_V }, // 5622
  { PseudoVLUXEI64_V_M8_MF4, VLUXEI64_V }, // 5623
  { PseudoVLUXEI64_V_M8_MF4_MASK, VLUXEI64_V }, // 5624
  { PseudoVLUXEI64_V_M8_MF8, VLUXEI64_V }, // 5625
  { PseudoVLUXEI64_V_M8_MF8_MASK, VLUXEI64_V }, // 5626
  { PseudoVLUXEI64_V_MF2_M1, VLUXEI64_V }, // 5627
  { PseudoVLUXEI64_V_MF2_M1_MASK, VLUXEI64_V }, // 5628
  { PseudoVLUXEI64_V_MF2_M2, VLUXEI64_V }, // 5629
  { PseudoVLUXEI64_V_MF2_M2_MASK, VLUXEI64_V }, // 5630
  { PseudoVLUXEI64_V_MF2_M4, VLUXEI64_V }, // 5631
  { PseudoVLUXEI64_V_MF2_M4_MASK, VLUXEI64_V }, // 5632
  { PseudoVLUXEI64_V_MF2_M8, VLUXEI64_V }, // 5633
  { PseudoVLUXEI64_V_MF2_M8_MASK, VLUXEI64_V }, // 5634
  { PseudoVLUXEI64_V_MF2_MF2, VLUXEI64_V }, // 5635
  { PseudoVLUXEI64_V_MF2_MF2_MASK, VLUXEI64_V }, // 5636
  { PseudoVLUXEI64_V_MF2_MF4, VLUXEI64_V }, // 5637
  { PseudoVLUXEI64_V_MF2_MF4_MASK, VLUXEI64_V }, // 5638
  { PseudoVLUXEI64_V_MF2_MF8, VLUXEI64_V }, // 5639
  { PseudoVLUXEI64_V_MF2_MF8_MASK, VLUXEI64_V }, // 5640
  { PseudoVLUXEI64_V_MF4_M1, VLUXEI64_V }, // 5641
  { PseudoVLUXEI64_V_MF4_M1_MASK, VLUXEI64_V }, // 5642
  { PseudoVLUXEI64_V_MF4_M2, VLUXEI64_V }, // 5643
  { PseudoVLUXEI64_V_MF4_M2_MASK, VLUXEI64_V }, // 5644
  { PseudoVLUXEI64_V_MF4_M4, VLUXEI64_V }, // 5645
  { PseudoVLUXEI64_V_MF4_M4_MASK, VLUXEI64_V }, // 5646
  { PseudoVLUXEI64_V_MF4_M8, VLUXEI64_V }, // 5647
  { PseudoVLUXEI64_V_MF4_M8_MASK, VLUXEI64_V }, // 5648
  { PseudoVLUXEI64_V_MF4_MF2, VLUXEI64_V }, // 5649
  { PseudoVLUXEI64_V_MF4_MF2_MASK, VLUXEI64_V }, // 5650
  { PseudoVLUXEI64_V_MF4_MF4, VLUXEI64_V }, // 5651
  { PseudoVLUXEI64_V_MF4_MF4_MASK, VLUXEI64_V }, // 5652
  { PseudoVLUXEI64_V_MF4_MF8, VLUXEI64_V }, // 5653
  { PseudoVLUXEI64_V_MF4_MF8_MASK, VLUXEI64_V }, // 5654
  { PseudoVLUXEI64_V_MF8_M1, VLUXEI64_V }, // 5655
  { PseudoVLUXEI64_V_MF8_M1_MASK, VLUXEI64_V }, // 5656
  { PseudoVLUXEI64_V_MF8_M2, VLUXEI64_V }, // 5657
  { PseudoVLUXEI64_V_MF8_M2_MASK, VLUXEI64_V }, // 5658
  { PseudoVLUXEI64_V_MF8_M4, VLUXEI64_V }, // 5659
  { PseudoVLUXEI64_V_MF8_M4_MASK, VLUXEI64_V }, // 5660
  { PseudoVLUXEI64_V_MF8_M8, VLUXEI64_V }, // 5661
  { PseudoVLUXEI64_V_MF8_M8_MASK, VLUXEI64_V }, // 5662
  { PseudoVLUXEI64_V_MF8_MF2, VLUXEI64_V }, // 5663
  { PseudoVLUXEI64_V_MF8_MF2_MASK, VLUXEI64_V }, // 5664
  { PseudoVLUXEI64_V_MF8_MF4, VLUXEI64_V }, // 5665
  { PseudoVLUXEI64_V_MF8_MF4_MASK, VLUXEI64_V }, // 5666
  { PseudoVLUXEI64_V_MF8_MF8, VLUXEI64_V }, // 5667
  { PseudoVLUXEI64_V_MF8_MF8_MASK, VLUXEI64_V }, // 5668
  { PseudoVLUXEI8_V_M1_M1, VLUXEI8_V }, // 5669
  { PseudoVLUXEI8_V_M1_M1_MASK, VLUXEI8_V }, // 5670
  { PseudoVLUXEI8_V_M1_M2, VLUXEI8_V }, // 5671
  { PseudoVLUXEI8_V_M1_M2_MASK, VLUXEI8_V }, // 5672
  { PseudoVLUXEI8_V_M1_M4, VLUXEI8_V }, // 5673
  { PseudoVLUXEI8_V_M1_M4_MASK, VLUXEI8_V }, // 5674
  { PseudoVLUXEI8_V_M1_M8, VLUXEI8_V }, // 5675
  { PseudoVLUXEI8_V_M1_M8_MASK, VLUXEI8_V }, // 5676
  { PseudoVLUXEI8_V_M1_MF2, VLUXEI8_V }, // 5677
  { PseudoVLUXEI8_V_M1_MF2_MASK, VLUXEI8_V }, // 5678
  { PseudoVLUXEI8_V_M1_MF4, VLUXEI8_V }, // 5679
  { PseudoVLUXEI8_V_M1_MF4_MASK, VLUXEI8_V }, // 5680
  { PseudoVLUXEI8_V_M1_MF8, VLUXEI8_V }, // 5681
  { PseudoVLUXEI8_V_M1_MF8_MASK, VLUXEI8_V }, // 5682
  { PseudoVLUXEI8_V_M2_M1, VLUXEI8_V }, // 5683
  { PseudoVLUXEI8_V_M2_M1_MASK, VLUXEI8_V }, // 5684
  { PseudoVLUXEI8_V_M2_M2, VLUXEI8_V }, // 5685
  { PseudoVLUXEI8_V_M2_M2_MASK, VLUXEI8_V }, // 5686
  { PseudoVLUXEI8_V_M2_M4, VLUXEI8_V }, // 5687
  { PseudoVLUXEI8_V_M2_M4_MASK, VLUXEI8_V }, // 5688
  { PseudoVLUXEI8_V_M2_M8, VLUXEI8_V }, // 5689
  { PseudoVLUXEI8_V_M2_M8_MASK, VLUXEI8_V }, // 5690
  { PseudoVLUXEI8_V_M2_MF2, VLUXEI8_V }, // 5691
  { PseudoVLUXEI8_V_M2_MF2_MASK, VLUXEI8_V }, // 5692
  { PseudoVLUXEI8_V_M2_MF4, VLUXEI8_V }, // 5693
  { PseudoVLUXEI8_V_M2_MF4_MASK, VLUXEI8_V }, // 5694
  { PseudoVLUXEI8_V_M2_MF8, VLUXEI8_V }, // 5695
  { PseudoVLUXEI8_V_M2_MF8_MASK, VLUXEI8_V }, // 5696
  { PseudoVLUXEI8_V_M4_M1, VLUXEI8_V }, // 5697
  { PseudoVLUXEI8_V_M4_M1_MASK, VLUXEI8_V }, // 5698
  { PseudoVLUXEI8_V_M4_M2, VLUXEI8_V }, // 5699
  { PseudoVLUXEI8_V_M4_M2_MASK, VLUXEI8_V }, // 5700
  { PseudoVLUXEI8_V_M4_M4, VLUXEI8_V }, // 5701
  { PseudoVLUXEI8_V_M4_M4_MASK, VLUXEI8_V }, // 5702
  { PseudoVLUXEI8_V_M4_M8, VLUXEI8_V }, // 5703
  { PseudoVLUXEI8_V_M4_M8_MASK, VLUXEI8_V }, // 5704
  { PseudoVLUXEI8_V_M4_MF2, VLUXEI8_V }, // 5705
  { PseudoVLUXEI8_V_M4_MF2_MASK, VLUXEI8_V }, // 5706
  { PseudoVLUXEI8_V_M4_MF4, VLUXEI8_V }, // 5707
  { PseudoVLUXEI8_V_M4_MF4_MASK, VLUXEI8_V }, // 5708
  { PseudoVLUXEI8_V_M4_MF8, VLUXEI8_V }, // 5709
  { PseudoVLUXEI8_V_M4_MF8_MASK, VLUXEI8_V }, // 5710
  { PseudoVLUXEI8_V_M8_M1, VLUXEI8_V }, // 5711
  { PseudoVLUXEI8_V_M8_M1_MASK, VLUXEI8_V }, // 5712
  { PseudoVLUXEI8_V_M8_M2, VLUXEI8_V }, // 5713
  { PseudoVLUXEI8_V_M8_M2_MASK, VLUXEI8_V }, // 5714
  { PseudoVLUXEI8_V_M8_M4, VLUXEI8_V }, // 5715
  { PseudoVLUXEI8_V_M8_M4_MASK, VLUXEI8_V }, // 5716
  { PseudoVLUXEI8_V_M8_M8, VLUXEI8_V }, // 5717
  { PseudoVLUXEI8_V_M8_M8_MASK, VLUXEI8_V }, // 5718
  { PseudoVLUXEI8_V_M8_MF2, VLUXEI8_V }, // 5719
  { PseudoVLUXEI8_V_M8_MF2_MASK, VLUXEI8_V }, // 5720
  { PseudoVLUXEI8_V_M8_MF4, VLUXEI8_V }, // 5721
  { PseudoVLUXEI8_V_M8_MF4_MASK, VLUXEI8_V }, // 5722
  { PseudoVLUXEI8_V_M8_MF8, VLUXEI8_V }, // 5723
  { PseudoVLUXEI8_V_M8_MF8_MASK, VLUXEI8_V }, // 5724
  { PseudoVLUXEI8_V_MF2_M1, VLUXEI8_V }, // 5725
  { PseudoVLUXEI8_V_MF2_M1_MASK, VLUXEI8_V }, // 5726
  { PseudoVLUXEI8_V_MF2_M2, VLUXEI8_V }, // 5727
  { PseudoVLUXEI8_V_MF2_M2_MASK, VLUXEI8_V }, // 5728
  { PseudoVLUXEI8_V_MF2_M4, VLUXEI8_V }, // 5729
  { PseudoVLUXEI8_V_MF2_M4_MASK, VLUXEI8_V }, // 5730
  { PseudoVLUXEI8_V_MF2_M8, VLUXEI8_V }, // 5731
  { PseudoVLUXEI8_V_MF2_M8_MASK, VLUXEI8_V }, // 5732
  { PseudoVLUXEI8_V_MF2_MF2, VLUXEI8_V }, // 5733
  { PseudoVLUXEI8_V_MF2_MF2_MASK, VLUXEI8_V }, // 5734
  { PseudoVLUXEI8_V_MF2_MF4, VLUXEI8_V }, // 5735
  { PseudoVLUXEI8_V_MF2_MF4_MASK, VLUXEI8_V }, // 5736
  { PseudoVLUXEI8_V_MF2_MF8, VLUXEI8_V }, // 5737
  { PseudoVLUXEI8_V_MF2_MF8_MASK, VLUXEI8_V }, // 5738
  { PseudoVLUXEI8_V_MF4_M1, VLUXEI8_V }, // 5739
  { PseudoVLUXEI8_V_MF4_M1_MASK, VLUXEI8_V }, // 5740
  { PseudoVLUXEI8_V_MF4_M2, VLUXEI8_V }, // 5741
  { PseudoVLUXEI8_V_MF4_M2_MASK, VLUXEI8_V }, // 5742
  { PseudoVLUXEI8_V_MF4_M4, VLUXEI8_V }, // 5743
  { PseudoVLUXEI8_V_MF4_M4_MASK, VLUXEI8_V }, // 5744
  { PseudoVLUXEI8_V_MF4_M8, VLUXEI8_V }, // 5745
  { PseudoVLUXEI8_V_MF4_M8_MASK, VLUXEI8_V }, // 5746
  { PseudoVLUXEI8_V_MF4_MF2, VLUXEI8_V }, // 5747
  { PseudoVLUXEI8_V_MF4_MF2_MASK, VLUXEI8_V }, // 5748
  { PseudoVLUXEI8_V_MF4_MF4, VLUXEI8_V }, // 5749
  { PseudoVLUXEI8_V_MF4_MF4_MASK, VLUXEI8_V }, // 5750
  { PseudoVLUXEI8_V_MF4_MF8, VLUXEI8_V }, // 5751
  { PseudoVLUXEI8_V_MF4_MF8_MASK, VLUXEI8_V }, // 5752
  { PseudoVLUXEI8_V_MF8_M1, VLUXEI8_V }, // 5753
  { PseudoVLUXEI8_V_MF8_M1_MASK, VLUXEI8_V }, // 5754
  { PseudoVLUXEI8_V_MF8_M2, VLUXEI8_V }, // 5755
  { PseudoVLUXEI8_V_MF8_M2_MASK, VLUXEI8_V }, // 5756
  { PseudoVLUXEI8_V_MF8_M4, VLUXEI8_V }, // 5757
  { PseudoVLUXEI8_V_MF8_M4_MASK, VLUXEI8_V }, // 5758
  { PseudoVLUXEI8_V_MF8_M8, VLUXEI8_V }, // 5759
  { PseudoVLUXEI8_V_MF8_M8_MASK, VLUXEI8_V }, // 5760
  { PseudoVLUXEI8_V_MF8_MF2, VLUXEI8_V }, // 5761
  { PseudoVLUXEI8_V_MF8_MF2_MASK, VLUXEI8_V }, // 5762
  { PseudoVLUXEI8_V_MF8_MF4, VLUXEI8_V }, // 5763
  { PseudoVLUXEI8_V_MF8_MF4_MASK, VLUXEI8_V }, // 5764
  { PseudoVLUXEI8_V_MF8_MF8, VLUXEI8_V }, // 5765
  { PseudoVLUXEI8_V_MF8_MF8_MASK, VLUXEI8_V }, // 5766
  { PseudoVLUXSEG2EI16_V_M1_M1, VLUXSEG2EI16_V }, // 5767
  { PseudoVLUXSEG2EI16_V_M1_M1_MASK, VLUXSEG2EI16_V }, // 5768
  { PseudoVLUXSEG2EI16_V_M1_M2, VLUXSEG2EI16_V }, // 5769
  { PseudoVLUXSEG2EI16_V_M1_M2_MASK, VLUXSEG2EI16_V }, // 5770
  { PseudoVLUXSEG2EI16_V_M1_M4, VLUXSEG2EI16_V }, // 5771
  { PseudoVLUXSEG2EI16_V_M1_M4_MASK, VLUXSEG2EI16_V }, // 5772
  { PseudoVLUXSEG2EI16_V_M1_MF2, VLUXSEG2EI16_V }, // 5773
  { PseudoVLUXSEG2EI16_V_M1_MF2_MASK, VLUXSEG2EI16_V }, // 5774
  { PseudoVLUXSEG2EI16_V_M1_MF4, VLUXSEG2EI16_V }, // 5775
  { PseudoVLUXSEG2EI16_V_M1_MF4_MASK, VLUXSEG2EI16_V }, // 5776
  { PseudoVLUXSEG2EI16_V_M1_MF8, VLUXSEG2EI16_V }, // 5777
  { PseudoVLUXSEG2EI16_V_M1_MF8_MASK, VLUXSEG2EI16_V }, // 5778
  { PseudoVLUXSEG2EI16_V_M2_M1, VLUXSEG2EI16_V }, // 5779
  { PseudoVLUXSEG2EI16_V_M2_M1_MASK, VLUXSEG2EI16_V }, // 5780
  { PseudoVLUXSEG2EI16_V_M2_M2, VLUXSEG2EI16_V }, // 5781
  { PseudoVLUXSEG2EI16_V_M2_M2_MASK, VLUXSEG2EI16_V }, // 5782
  { PseudoVLUXSEG2EI16_V_M2_M4, VLUXSEG2EI16_V }, // 5783
  { PseudoVLUXSEG2EI16_V_M2_M4_MASK, VLUXSEG2EI16_V }, // 5784
  { PseudoVLUXSEG2EI16_V_M2_MF2, VLUXSEG2EI16_V }, // 5785
  { PseudoVLUXSEG2EI16_V_M2_MF2_MASK, VLUXSEG2EI16_V }, // 5786
  { PseudoVLUXSEG2EI16_V_M2_MF4, VLUXSEG2EI16_V }, // 5787
  { PseudoVLUXSEG2EI16_V_M2_MF4_MASK, VLUXSEG2EI16_V }, // 5788
  { PseudoVLUXSEG2EI16_V_M2_MF8, VLUXSEG2EI16_V }, // 5789
  { PseudoVLUXSEG2EI16_V_M2_MF8_MASK, VLUXSEG2EI16_V }, // 5790
  { PseudoVLUXSEG2EI16_V_M4_M1, VLUXSEG2EI16_V }, // 5791
  { PseudoVLUXSEG2EI16_V_M4_M1_MASK, VLUXSEG2EI16_V }, // 5792
  { PseudoVLUXSEG2EI16_V_M4_M2, VLUXSEG2EI16_V }, // 5793
  { PseudoVLUXSEG2EI16_V_M4_M2_MASK, VLUXSEG2EI16_V }, // 5794
  { PseudoVLUXSEG2EI16_V_M4_M4, VLUXSEG2EI16_V }, // 5795
  { PseudoVLUXSEG2EI16_V_M4_M4_MASK, VLUXSEG2EI16_V }, // 5796
  { PseudoVLUXSEG2EI16_V_M4_MF2, VLUXSEG2EI16_V }, // 5797
  { PseudoVLUXSEG2EI16_V_M4_MF2_MASK, VLUXSEG2EI16_V }, // 5798
  { PseudoVLUXSEG2EI16_V_M4_MF4, VLUXSEG2EI16_V }, // 5799
  { PseudoVLUXSEG2EI16_V_M4_MF4_MASK, VLUXSEG2EI16_V }, // 5800
  { PseudoVLUXSEG2EI16_V_M4_MF8, VLUXSEG2EI16_V }, // 5801
  { PseudoVLUXSEG2EI16_V_M4_MF8_MASK, VLUXSEG2EI16_V }, // 5802
  { PseudoVLUXSEG2EI16_V_M8_M1, VLUXSEG2EI16_V }, // 5803
  { PseudoVLUXSEG2EI16_V_M8_M1_MASK, VLUXSEG2EI16_V }, // 5804
  { PseudoVLUXSEG2EI16_V_M8_M2, VLUXSEG2EI16_V }, // 5805
  { PseudoVLUXSEG2EI16_V_M8_M2_MASK, VLUXSEG2EI16_V }, // 5806
  { PseudoVLUXSEG2EI16_V_M8_M4, VLUXSEG2EI16_V }, // 5807
  { PseudoVLUXSEG2EI16_V_M8_M4_MASK, VLUXSEG2EI16_V }, // 5808
  { PseudoVLUXSEG2EI16_V_M8_MF2, VLUXSEG2EI16_V }, // 5809
  { PseudoVLUXSEG2EI16_V_M8_MF2_MASK, VLUXSEG2EI16_V }, // 5810
  { PseudoVLUXSEG2EI16_V_M8_MF4, VLUXSEG2EI16_V }, // 5811
  { PseudoVLUXSEG2EI16_V_M8_MF4_MASK, VLUXSEG2EI16_V }, // 5812
  { PseudoVLUXSEG2EI16_V_M8_MF8, VLUXSEG2EI16_V }, // 5813
  { PseudoVLUXSEG2EI16_V_M8_MF8_MASK, VLUXSEG2EI16_V }, // 5814
  { PseudoVLUXSEG2EI16_V_MF2_M1, VLUXSEG2EI16_V }, // 5815
  { PseudoVLUXSEG2EI16_V_MF2_M1_MASK, VLUXSEG2EI16_V }, // 5816
  { PseudoVLUXSEG2EI16_V_MF2_M2, VLUXSEG2EI16_V }, // 5817
  { PseudoVLUXSEG2EI16_V_MF2_M2_MASK, VLUXSEG2EI16_V }, // 5818
  { PseudoVLUXSEG2EI16_V_MF2_M4, VLUXSEG2EI16_V }, // 5819
  { PseudoVLUXSEG2EI16_V_MF2_M4_MASK, VLUXSEG2EI16_V }, // 5820
  { PseudoVLUXSEG2EI16_V_MF2_MF2, VLUXSEG2EI16_V }, // 5821
  { PseudoVLUXSEG2EI16_V_MF2_MF2_MASK, VLUXSEG2EI16_V }, // 5822
  { PseudoVLUXSEG2EI16_V_MF2_MF4, VLUXSEG2EI16_V }, // 5823
  { PseudoVLUXSEG2EI16_V_MF2_MF4_MASK, VLUXSEG2EI16_V }, // 5824
  { PseudoVLUXSEG2EI16_V_MF2_MF8, VLUXSEG2EI16_V }, // 5825
  { PseudoVLUXSEG2EI16_V_MF2_MF8_MASK, VLUXSEG2EI16_V }, // 5826
  { PseudoVLUXSEG2EI16_V_MF4_M1, VLUXSEG2EI16_V }, // 5827
  { PseudoVLUXSEG2EI16_V_MF4_M1_MASK, VLUXSEG2EI16_V }, // 5828
  { PseudoVLUXSEG2EI16_V_MF4_M2, VLUXSEG2EI16_V }, // 5829
  { PseudoVLUXSEG2EI16_V_MF4_M2_MASK, VLUXSEG2EI16_V }, // 5830
  { PseudoVLUXSEG2EI16_V_MF4_M4, VLUXSEG2EI16_V }, // 5831
  { PseudoVLUXSEG2EI16_V_MF4_M4_MASK, VLUXSEG2EI16_V }, // 5832
  { PseudoVLUXSEG2EI16_V_MF4_MF2, VLUXSEG2EI16_V }, // 5833
  { PseudoVLUXSEG2EI16_V_MF4_MF2_MASK, VLUXSEG2EI16_V }, // 5834
  { PseudoVLUXSEG2EI16_V_MF4_MF4, VLUXSEG2EI16_V }, // 5835
  { PseudoVLUXSEG2EI16_V_MF4_MF4_MASK, VLUXSEG2EI16_V }, // 5836
  { PseudoVLUXSEG2EI16_V_MF4_MF8, VLUXSEG2EI16_V }, // 5837
  { PseudoVLUXSEG2EI16_V_MF4_MF8_MASK, VLUXSEG2EI16_V }, // 5838
  { PseudoVLUXSEG2EI32_V_M1_M1, VLUXSEG2EI32_V }, // 5839
  { PseudoVLUXSEG2EI32_V_M1_M1_MASK, VLUXSEG2EI32_V }, // 5840
  { PseudoVLUXSEG2EI32_V_M1_M2, VLUXSEG2EI32_V }, // 5841
  { PseudoVLUXSEG2EI32_V_M1_M2_MASK, VLUXSEG2EI32_V }, // 5842
  { PseudoVLUXSEG2EI32_V_M1_M4, VLUXSEG2EI32_V }, // 5843
  { PseudoVLUXSEG2EI32_V_M1_M4_MASK, VLUXSEG2EI32_V }, // 5844
  { PseudoVLUXSEG2EI32_V_M1_MF2, VLUXSEG2EI32_V }, // 5845
  { PseudoVLUXSEG2EI32_V_M1_MF2_MASK, VLUXSEG2EI32_V }, // 5846
  { PseudoVLUXSEG2EI32_V_M1_MF4, VLUXSEG2EI32_V }, // 5847
  { PseudoVLUXSEG2EI32_V_M1_MF4_MASK, VLUXSEG2EI32_V }, // 5848
  { PseudoVLUXSEG2EI32_V_M1_MF8, VLUXSEG2EI32_V }, // 5849
  { PseudoVLUXSEG2EI32_V_M1_MF8_MASK, VLUXSEG2EI32_V }, // 5850
  { PseudoVLUXSEG2EI32_V_M2_M1, VLUXSEG2EI32_V }, // 5851
  { PseudoVLUXSEG2EI32_V_M2_M1_MASK, VLUXSEG2EI32_V }, // 5852
  { PseudoVLUXSEG2EI32_V_M2_M2, VLUXSEG2EI32_V }, // 5853
  { PseudoVLUXSEG2EI32_V_M2_M2_MASK, VLUXSEG2EI32_V }, // 5854
  { PseudoVLUXSEG2EI32_V_M2_M4, VLUXSEG2EI32_V }, // 5855
  { PseudoVLUXSEG2EI32_V_M2_M4_MASK, VLUXSEG2EI32_V }, // 5856
  { PseudoVLUXSEG2EI32_V_M2_MF2, VLUXSEG2EI32_V }, // 5857
  { PseudoVLUXSEG2EI32_V_M2_MF2_MASK, VLUXSEG2EI32_V }, // 5858
  { PseudoVLUXSEG2EI32_V_M2_MF4, VLUXSEG2EI32_V }, // 5859
  { PseudoVLUXSEG2EI32_V_M2_MF4_MASK, VLUXSEG2EI32_V }, // 5860
  { PseudoVLUXSEG2EI32_V_M2_MF8, VLUXSEG2EI32_V }, // 5861
  { PseudoVLUXSEG2EI32_V_M2_MF8_MASK, VLUXSEG2EI32_V }, // 5862
  { PseudoVLUXSEG2EI32_V_M4_M1, VLUXSEG2EI32_V }, // 5863
  { PseudoVLUXSEG2EI32_V_M4_M1_MASK, VLUXSEG2EI32_V }, // 5864
  { PseudoVLUXSEG2EI32_V_M4_M2, VLUXSEG2EI32_V }, // 5865
  { PseudoVLUXSEG2EI32_V_M4_M2_MASK, VLUXSEG2EI32_V }, // 5866
  { PseudoVLUXSEG2EI32_V_M4_M4, VLUXSEG2EI32_V }, // 5867
  { PseudoVLUXSEG2EI32_V_M4_M4_MASK, VLUXSEG2EI32_V }, // 5868
  { PseudoVLUXSEG2EI32_V_M4_MF2, VLUXSEG2EI32_V }, // 5869
  { PseudoVLUXSEG2EI32_V_M4_MF2_MASK, VLUXSEG2EI32_V }, // 5870
  { PseudoVLUXSEG2EI32_V_M4_MF4, VLUXSEG2EI32_V }, // 5871
  { PseudoVLUXSEG2EI32_V_M4_MF4_MASK, VLUXSEG2EI32_V }, // 5872
  { PseudoVLUXSEG2EI32_V_M4_MF8, VLUXSEG2EI32_V }, // 5873
  { PseudoVLUXSEG2EI32_V_M4_MF8_MASK, VLUXSEG2EI32_V }, // 5874
  { PseudoVLUXSEG2EI32_V_M8_M1, VLUXSEG2EI32_V }, // 5875
  { PseudoVLUXSEG2EI32_V_M8_M1_MASK, VLUXSEG2EI32_V }, // 5876
  { PseudoVLUXSEG2EI32_V_M8_M2, VLUXSEG2EI32_V }, // 5877
  { PseudoVLUXSEG2EI32_V_M8_M2_MASK, VLUXSEG2EI32_V }, // 5878
  { PseudoVLUXSEG2EI32_V_M8_M4, VLUXSEG2EI32_V }, // 5879
  { PseudoVLUXSEG2EI32_V_M8_M4_MASK, VLUXSEG2EI32_V }, // 5880
  { PseudoVLUXSEG2EI32_V_M8_MF2, VLUXSEG2EI32_V }, // 5881
  { PseudoVLUXSEG2EI32_V_M8_MF2_MASK, VLUXSEG2EI32_V }, // 5882
  { PseudoVLUXSEG2EI32_V_M8_MF4, VLUXSEG2EI32_V }, // 5883
  { PseudoVLUXSEG2EI32_V_M8_MF4_MASK, VLUXSEG2EI32_V }, // 5884
  { PseudoVLUXSEG2EI32_V_M8_MF8, VLUXSEG2EI32_V }, // 5885
  { PseudoVLUXSEG2EI32_V_M8_MF8_MASK, VLUXSEG2EI32_V }, // 5886
  { PseudoVLUXSEG2EI32_V_MF2_M1, VLUXSEG2EI32_V }, // 5887
  { PseudoVLUXSEG2EI32_V_MF2_M1_MASK, VLUXSEG2EI32_V }, // 5888
  { PseudoVLUXSEG2EI32_V_MF2_M2, VLUXSEG2EI32_V }, // 5889
  { PseudoVLUXSEG2EI32_V_MF2_M2_MASK, VLUXSEG2EI32_V }, // 5890
  { PseudoVLUXSEG2EI32_V_MF2_M4, VLUXSEG2EI32_V }, // 5891
  { PseudoVLUXSEG2EI32_V_MF2_M4_MASK, VLUXSEG2EI32_V }, // 5892
  { PseudoVLUXSEG2EI32_V_MF2_MF2, VLUXSEG2EI32_V }, // 5893
  { PseudoVLUXSEG2EI32_V_MF2_MF2_MASK, VLUXSEG2EI32_V }, // 5894
  { PseudoVLUXSEG2EI32_V_MF2_MF4, VLUXSEG2EI32_V }, // 5895
  { PseudoVLUXSEG2EI32_V_MF2_MF4_MASK, VLUXSEG2EI32_V }, // 5896
  { PseudoVLUXSEG2EI32_V_MF2_MF8, VLUXSEG2EI32_V }, // 5897
  { PseudoVLUXSEG2EI32_V_MF2_MF8_MASK, VLUXSEG2EI32_V }, // 5898
  { PseudoVLUXSEG2EI64_V_M1_M1, VLUXSEG2EI64_V }, // 5899
  { PseudoVLUXSEG2EI64_V_M1_M1_MASK, VLUXSEG2EI64_V }, // 5900
  { PseudoVLUXSEG2EI64_V_M1_M2, VLUXSEG2EI64_V }, // 5901
  { PseudoVLUXSEG2EI64_V_M1_M2_MASK, VLUXSEG2EI64_V }, // 5902
  { PseudoVLUXSEG2EI64_V_M1_M4, VLUXSEG2EI64_V }, // 5903
  { PseudoVLUXSEG2EI64_V_M1_M4_MASK, VLUXSEG2EI64_V }, // 5904
  { PseudoVLUXSEG2EI64_V_M1_MF2, VLUXSEG2EI64_V }, // 5905
  { PseudoVLUXSEG2EI64_V_M1_MF2_MASK, VLUXSEG2EI64_V }, // 5906
  { PseudoVLUXSEG2EI64_V_M1_MF4, VLUXSEG2EI64_V }, // 5907
  { PseudoVLUXSEG2EI64_V_M1_MF4_MASK, VLUXSEG2EI64_V }, // 5908
  { PseudoVLUXSEG2EI64_V_M1_MF8, VLUXSEG2EI64_V }, // 5909
  { PseudoVLUXSEG2EI64_V_M1_MF8_MASK, VLUXSEG2EI64_V }, // 5910
  { PseudoVLUXSEG2EI64_V_M2_M1, VLUXSEG2EI64_V }, // 5911
  { PseudoVLUXSEG2EI64_V_M2_M1_MASK, VLUXSEG2EI64_V }, // 5912
  { PseudoVLUXSEG2EI64_V_M2_M2, VLUXSEG2EI64_V }, // 5913
  { PseudoVLUXSEG2EI64_V_M2_M2_MASK, VLUXSEG2EI64_V }, // 5914
  { PseudoVLUXSEG2EI64_V_M2_M4, VLUXSEG2EI64_V }, // 5915
  { PseudoVLUXSEG2EI64_V_M2_M4_MASK, VLUXSEG2EI64_V }, // 5916
  { PseudoVLUXSEG2EI64_V_M2_MF2, VLUXSEG2EI64_V }, // 5917
  { PseudoVLUXSEG2EI64_V_M2_MF2_MASK, VLUXSEG2EI64_V }, // 5918
  { PseudoVLUXSEG2EI64_V_M2_MF4, VLUXSEG2EI64_V }, // 5919
  { PseudoVLUXSEG2EI64_V_M2_MF4_MASK, VLUXSEG2EI64_V }, // 5920
  { PseudoVLUXSEG2EI64_V_M2_MF8, VLUXSEG2EI64_V }, // 5921
  { PseudoVLUXSEG2EI64_V_M2_MF8_MASK, VLUXSEG2EI64_V }, // 5922
  { PseudoVLUXSEG2EI64_V_M4_M1, VLUXSEG2EI64_V }, // 5923
  { PseudoVLUXSEG2EI64_V_M4_M1_MASK, VLUXSEG2EI64_V }, // 5924
  { PseudoVLUXSEG2EI64_V_M4_M2, VLUXSEG2EI64_V }, // 5925
  { PseudoVLUXSEG2EI64_V_M4_M2_MASK, VLUXSEG2EI64_V }, // 5926
  { PseudoVLUXSEG2EI64_V_M4_M4, VLUXSEG2EI64_V }, // 5927
  { PseudoVLUXSEG2EI64_V_M4_M4_MASK, VLUXSEG2EI64_V }, // 5928
  { PseudoVLUXSEG2EI64_V_M4_MF2, VLUXSEG2EI64_V }, // 5929
  { PseudoVLUXSEG2EI64_V_M4_MF2_MASK, VLUXSEG2EI64_V }, // 5930
  { PseudoVLUXSEG2EI64_V_M4_MF4, VLUXSEG2EI64_V }, // 5931
  { PseudoVLUXSEG2EI64_V_M4_MF4_MASK, VLUXSEG2EI64_V }, // 5932
  { PseudoVLUXSEG2EI64_V_M4_MF8, VLUXSEG2EI64_V }, // 5933
  { PseudoVLUXSEG2EI64_V_M4_MF8_MASK, VLUXSEG2EI64_V }, // 5934
  { PseudoVLUXSEG2EI64_V_M8_M1, VLUXSEG2EI64_V }, // 5935
  { PseudoVLUXSEG2EI64_V_M8_M1_MASK, VLUXSEG2EI64_V }, // 5936
  { PseudoVLUXSEG2EI64_V_M8_M2, VLUXSEG2EI64_V }, // 5937
  { PseudoVLUXSEG2EI64_V_M8_M2_MASK, VLUXSEG2EI64_V }, // 5938
  { PseudoVLUXSEG2EI64_V_M8_M4, VLUXSEG2EI64_V }, // 5939
  { PseudoVLUXSEG2EI64_V_M8_M4_MASK, VLUXSEG2EI64_V }, // 5940
  { PseudoVLUXSEG2EI64_V_M8_MF2, VLUXSEG2EI64_V }, // 5941
  { PseudoVLUXSEG2EI64_V_M8_MF2_MASK, VLUXSEG2EI64_V }, // 5942
  { PseudoVLUXSEG2EI64_V_M8_MF4, VLUXSEG2EI64_V }, // 5943
  { PseudoVLUXSEG2EI64_V_M8_MF4_MASK, VLUXSEG2EI64_V }, // 5944
  { PseudoVLUXSEG2EI64_V_M8_MF8, VLUXSEG2EI64_V }, // 5945
  { PseudoVLUXSEG2EI64_V_M8_MF8_MASK, VLUXSEG2EI64_V }, // 5946
  { PseudoVLUXSEG2EI8_V_M1_M1, VLUXSEG2EI8_V }, // 5947
  { PseudoVLUXSEG2EI8_V_M1_M1_MASK, VLUXSEG2EI8_V }, // 5948
  { PseudoVLUXSEG2EI8_V_M1_M2, VLUXSEG2EI8_V }, // 5949
  { PseudoVLUXSEG2EI8_V_M1_M2_MASK, VLUXSEG2EI8_V }, // 5950
  { PseudoVLUXSEG2EI8_V_M1_M4, VLUXSEG2EI8_V }, // 5951
  { PseudoVLUXSEG2EI8_V_M1_M4_MASK, VLUXSEG2EI8_V }, // 5952
  { PseudoVLUXSEG2EI8_V_M1_MF2, VLUXSEG2EI8_V }, // 5953
  { PseudoVLUXSEG2EI8_V_M1_MF2_MASK, VLUXSEG2EI8_V }, // 5954
  { PseudoVLUXSEG2EI8_V_M1_MF4, VLUXSEG2EI8_V }, // 5955
  { PseudoVLUXSEG2EI8_V_M1_MF4_MASK, VLUXSEG2EI8_V }, // 5956
  { PseudoVLUXSEG2EI8_V_M1_MF8, VLUXSEG2EI8_V }, // 5957
  { PseudoVLUXSEG2EI8_V_M1_MF8_MASK, VLUXSEG2EI8_V }, // 5958
  { PseudoVLUXSEG2EI8_V_M2_M1, VLUXSEG2EI8_V }, // 5959
  { PseudoVLUXSEG2EI8_V_M2_M1_MASK, VLUXSEG2EI8_V }, // 5960
  { PseudoVLUXSEG2EI8_V_M2_M2, VLUXSEG2EI8_V }, // 5961
  { PseudoVLUXSEG2EI8_V_M2_M2_MASK, VLUXSEG2EI8_V }, // 5962
  { PseudoVLUXSEG2EI8_V_M2_M4, VLUXSEG2EI8_V }, // 5963
  { PseudoVLUXSEG2EI8_V_M2_M4_MASK, VLUXSEG2EI8_V }, // 5964
  { PseudoVLUXSEG2EI8_V_M2_MF2, VLUXSEG2EI8_V }, // 5965
  { PseudoVLUXSEG2EI8_V_M2_MF2_MASK, VLUXSEG2EI8_V }, // 5966
  { PseudoVLUXSEG2EI8_V_M2_MF4, VLUXSEG2EI8_V }, // 5967
  { PseudoVLUXSEG2EI8_V_M2_MF4_MASK, VLUXSEG2EI8_V }, // 5968
  { PseudoVLUXSEG2EI8_V_M2_MF8, VLUXSEG2EI8_V }, // 5969
  { PseudoVLUXSEG2EI8_V_M2_MF8_MASK, VLUXSEG2EI8_V }, // 5970
  { PseudoVLUXSEG2EI8_V_M4_M1, VLUXSEG2EI8_V }, // 5971
  { PseudoVLUXSEG2EI8_V_M4_M1_MASK, VLUXSEG2EI8_V }, // 5972
  { PseudoVLUXSEG2EI8_V_M4_M2, VLUXSEG2EI8_V }, // 5973
  { PseudoVLUXSEG2EI8_V_M4_M2_MASK, VLUXSEG2EI8_V }, // 5974
  { PseudoVLUXSEG2EI8_V_M4_M4, VLUXSEG2EI8_V }, // 5975
  { PseudoVLUXSEG2EI8_V_M4_M4_MASK, VLUXSEG2EI8_V }, // 5976
  { PseudoVLUXSEG2EI8_V_M4_MF2, VLUXSEG2EI8_V }, // 5977
  { PseudoVLUXSEG2EI8_V_M4_MF2_MASK, VLUXSEG2EI8_V }, // 5978
  { PseudoVLUXSEG2EI8_V_M4_MF4, VLUXSEG2EI8_V }, // 5979
  { PseudoVLUXSEG2EI8_V_M4_MF4_MASK, VLUXSEG2EI8_V }, // 5980
  { PseudoVLUXSEG2EI8_V_M4_MF8, VLUXSEG2EI8_V }, // 5981
  { PseudoVLUXSEG2EI8_V_M4_MF8_MASK, VLUXSEG2EI8_V }, // 5982
  { PseudoVLUXSEG2EI8_V_M8_M1, VLUXSEG2EI8_V }, // 5983
  { PseudoVLUXSEG2EI8_V_M8_M1_MASK, VLUXSEG2EI8_V }, // 5984
  { PseudoVLUXSEG2EI8_V_M8_M2, VLUXSEG2EI8_V }, // 5985
  { PseudoVLUXSEG2EI8_V_M8_M2_MASK, VLUXSEG2EI8_V }, // 5986
  { PseudoVLUXSEG2EI8_V_M8_M4, VLUXSEG2EI8_V }, // 5987
  { PseudoVLUXSEG2EI8_V_M8_M4_MASK, VLUXSEG2EI8_V }, // 5988
  { PseudoVLUXSEG2EI8_V_M8_MF2, VLUXSEG2EI8_V }, // 5989
  { PseudoVLUXSEG2EI8_V_M8_MF2_MASK, VLUXSEG2EI8_V }, // 5990
  { PseudoVLUXSEG2EI8_V_M8_MF4, VLUXSEG2EI8_V }, // 5991
  { PseudoVLUXSEG2EI8_V_M8_MF4_MASK, VLUXSEG2EI8_V }, // 5992
  { PseudoVLUXSEG2EI8_V_M8_MF8, VLUXSEG2EI8_V }, // 5993
  { PseudoVLUXSEG2EI8_V_M8_MF8_MASK, VLUXSEG2EI8_V }, // 5994
  { PseudoVLUXSEG2EI8_V_MF2_M1, VLUXSEG2EI8_V }, // 5995
  { PseudoVLUXSEG2EI8_V_MF2_M1_MASK, VLUXSEG2EI8_V }, // 5996
  { PseudoVLUXSEG2EI8_V_MF2_M2, VLUXSEG2EI8_V }, // 5997
  { PseudoVLUXSEG2EI8_V_MF2_M2_MASK, VLUXSEG2EI8_V }, // 5998
  { PseudoVLUXSEG2EI8_V_MF2_M4, VLUXSEG2EI8_V }, // 5999
  { PseudoVLUXSEG2EI8_V_MF2_M4_MASK, VLUXSEG2EI8_V }, // 6000
  { PseudoVLUXSEG2EI8_V_MF2_MF2, VLUXSEG2EI8_V }, // 6001
  { PseudoVLUXSEG2EI8_V_MF2_MF2_MASK, VLUXSEG2EI8_V }, // 6002
  { PseudoVLUXSEG2EI8_V_MF2_MF4, VLUXSEG2EI8_V }, // 6003
  { PseudoVLUXSEG2EI8_V_MF2_MF4_MASK, VLUXSEG2EI8_V }, // 6004
  { PseudoVLUXSEG2EI8_V_MF2_MF8, VLUXSEG2EI8_V }, // 6005
  { PseudoVLUXSEG2EI8_V_MF2_MF8_MASK, VLUXSEG2EI8_V }, // 6006
  { PseudoVLUXSEG2EI8_V_MF4_M1, VLUXSEG2EI8_V }, // 6007
  { PseudoVLUXSEG2EI8_V_MF4_M1_MASK, VLUXSEG2EI8_V }, // 6008
  { PseudoVLUXSEG2EI8_V_MF4_M2, VLUXSEG2EI8_V }, // 6009
  { PseudoVLUXSEG2EI8_V_MF4_M2_MASK, VLUXSEG2EI8_V }, // 6010
  { PseudoVLUXSEG2EI8_V_MF4_M4, VLUXSEG2EI8_V }, // 6011
  { PseudoVLUXSEG2EI8_V_MF4_M4_MASK, VLUXSEG2EI8_V }, // 6012
  { PseudoVLUXSEG2EI8_V_MF4_MF2, VLUXSEG2EI8_V }, // 6013
  { PseudoVLUXSEG2EI8_V_MF4_MF2_MASK, VLUXSEG2EI8_V }, // 6014
  { PseudoVLUXSEG2EI8_V_MF4_MF4, VLUXSEG2EI8_V }, // 6015
  { PseudoVLUXSEG2EI8_V_MF4_MF4_MASK, VLUXSEG2EI8_V }, // 6016
  { PseudoVLUXSEG2EI8_V_MF4_MF8, VLUXSEG2EI8_V }, // 6017
  { PseudoVLUXSEG2EI8_V_MF4_MF8_MASK, VLUXSEG2EI8_V }, // 6018
  { PseudoVLUXSEG2EI8_V_MF8_M1, VLUXSEG2EI8_V }, // 6019
  { PseudoVLUXSEG2EI8_V_MF8_M1_MASK, VLUXSEG2EI8_V }, // 6020
  { PseudoVLUXSEG2EI8_V_MF8_M2, VLUXSEG2EI8_V }, // 6021
  { PseudoVLUXSEG2EI8_V_MF8_M2_MASK, VLUXSEG2EI8_V }, // 6022
  { PseudoVLUXSEG2EI8_V_MF8_M4, VLUXSEG2EI8_V }, // 6023
  { PseudoVLUXSEG2EI8_V_MF8_M4_MASK, VLUXSEG2EI8_V }, // 6024
  { PseudoVLUXSEG2EI8_V_MF8_MF2, VLUXSEG2EI8_V }, // 6025
  { PseudoVLUXSEG2EI8_V_MF8_MF2_MASK, VLUXSEG2EI8_V }, // 6026
  { PseudoVLUXSEG2EI8_V_MF8_MF4, VLUXSEG2EI8_V }, // 6027
  { PseudoVLUXSEG2EI8_V_MF8_MF4_MASK, VLUXSEG2EI8_V }, // 6028
  { PseudoVLUXSEG2EI8_V_MF8_MF8, VLUXSEG2EI8_V }, // 6029
  { PseudoVLUXSEG2EI8_V_MF8_MF8_MASK, VLUXSEG2EI8_V }, // 6030
  { PseudoVLUXSEG3EI16_V_M1_M1, VLUXSEG3EI16_V }, // 6031
  { PseudoVLUXSEG3EI16_V_M1_M1_MASK, VLUXSEG3EI16_V }, // 6032
  { PseudoVLUXSEG3EI16_V_M1_M2, VLUXSEG3EI16_V }, // 6033
  { PseudoVLUXSEG3EI16_V_M1_M2_MASK, VLUXSEG3EI16_V }, // 6034
  { PseudoVLUXSEG3EI16_V_M1_MF2, VLUXSEG3EI16_V }, // 6035
  { PseudoVLUXSEG3EI16_V_M1_MF2_MASK, VLUXSEG3EI16_V }, // 6036
  { PseudoVLUXSEG3EI16_V_M1_MF4, VLUXSEG3EI16_V }, // 6037
  { PseudoVLUXSEG3EI16_V_M1_MF4_MASK, VLUXSEG3EI16_V }, // 6038
  { PseudoVLUXSEG3EI16_V_M1_MF8, VLUXSEG3EI16_V }, // 6039
  { PseudoVLUXSEG3EI16_V_M1_MF8_MASK, VLUXSEG3EI16_V }, // 6040
  { PseudoVLUXSEG3EI16_V_M2_M1, VLUXSEG3EI16_V }, // 6041
  { PseudoVLUXSEG3EI16_V_M2_M1_MASK, VLUXSEG3EI16_V }, // 6042
  { PseudoVLUXSEG3EI16_V_M2_M2, VLUXSEG3EI16_V }, // 6043
  { PseudoVLUXSEG3EI16_V_M2_M2_MASK, VLUXSEG3EI16_V }, // 6044
  { PseudoVLUXSEG3EI16_V_M2_MF2, VLUXSEG3EI16_V }, // 6045
  { PseudoVLUXSEG3EI16_V_M2_MF2_MASK, VLUXSEG3EI16_V }, // 6046
  { PseudoVLUXSEG3EI16_V_M2_MF4, VLUXSEG3EI16_V }, // 6047
  { PseudoVLUXSEG3EI16_V_M2_MF4_MASK, VLUXSEG3EI16_V }, // 6048
  { PseudoVLUXSEG3EI16_V_M2_MF8, VLUXSEG3EI16_V }, // 6049
  { PseudoVLUXSEG3EI16_V_M2_MF8_MASK, VLUXSEG3EI16_V }, // 6050
  { PseudoVLUXSEG3EI16_V_M4_M1, VLUXSEG3EI16_V }, // 6051
  { PseudoVLUXSEG3EI16_V_M4_M1_MASK, VLUXSEG3EI16_V }, // 6052
  { PseudoVLUXSEG3EI16_V_M4_M2, VLUXSEG3EI16_V }, // 6053
  { PseudoVLUXSEG3EI16_V_M4_M2_MASK, VLUXSEG3EI16_V }, // 6054
  { PseudoVLUXSEG3EI16_V_M4_MF2, VLUXSEG3EI16_V }, // 6055
  { PseudoVLUXSEG3EI16_V_M4_MF2_MASK, VLUXSEG3EI16_V }, // 6056
  { PseudoVLUXSEG3EI16_V_M4_MF4, VLUXSEG3EI16_V }, // 6057
  { PseudoVLUXSEG3EI16_V_M4_MF4_MASK, VLUXSEG3EI16_V }, // 6058
  { PseudoVLUXSEG3EI16_V_M4_MF8, VLUXSEG3EI16_V }, // 6059
  { PseudoVLUXSEG3EI16_V_M4_MF8_MASK, VLUXSEG3EI16_V }, // 6060
  { PseudoVLUXSEG3EI16_V_M8_M1, VLUXSEG3EI16_V }, // 6061
  { PseudoVLUXSEG3EI16_V_M8_M1_MASK, VLUXSEG3EI16_V }, // 6062
  { PseudoVLUXSEG3EI16_V_M8_M2, VLUXSEG3EI16_V }, // 6063
  { PseudoVLUXSEG3EI16_V_M8_M2_MASK, VLUXSEG3EI16_V }, // 6064
  { PseudoVLUXSEG3EI16_V_M8_MF2, VLUXSEG3EI16_V }, // 6065
  { PseudoVLUXSEG3EI16_V_M8_MF2_MASK, VLUXSEG3EI16_V }, // 6066
  { PseudoVLUXSEG3EI16_V_M8_MF4, VLUXSEG3EI16_V }, // 6067
  { PseudoVLUXSEG3EI16_V_M8_MF4_MASK, VLUXSEG3EI16_V }, // 6068
  { PseudoVLUXSEG3EI16_V_M8_MF8, VLUXSEG3EI16_V }, // 6069
  { PseudoVLUXSEG3EI16_V_M8_MF8_MASK, VLUXSEG3EI16_V }, // 6070
  { PseudoVLUXSEG3EI16_V_MF2_M1, VLUXSEG3EI16_V }, // 6071
  { PseudoVLUXSEG3EI16_V_MF2_M1_MASK, VLUXSEG3EI16_V }, // 6072
  { PseudoVLUXSEG3EI16_V_MF2_M2, VLUXSEG3EI16_V }, // 6073
  { PseudoVLUXSEG3EI16_V_MF2_M2_MASK, VLUXSEG3EI16_V }, // 6074
  { PseudoVLUXSEG3EI16_V_MF2_MF2, VLUXSEG3EI16_V }, // 6075
  { PseudoVLUXSEG3EI16_V_MF2_MF2_MASK, VLUXSEG3EI16_V }, // 6076
  { PseudoVLUXSEG3EI16_V_MF2_MF4, VLUXSEG3EI16_V }, // 6077
  { PseudoVLUXSEG3EI16_V_MF2_MF4_MASK, VLUXSEG3EI16_V }, // 6078
  { PseudoVLUXSEG3EI16_V_MF2_MF8, VLUXSEG3EI16_V }, // 6079
  { PseudoVLUXSEG3EI16_V_MF2_MF8_MASK, VLUXSEG3EI16_V }, // 6080
  { PseudoVLUXSEG3EI16_V_MF4_M1, VLUXSEG3EI16_V }, // 6081
  { PseudoVLUXSEG3EI16_V_MF4_M1_MASK, VLUXSEG3EI16_V }, // 6082
  { PseudoVLUXSEG3EI16_V_MF4_M2, VLUXSEG3EI16_V }, // 6083
  { PseudoVLUXSEG3EI16_V_MF4_M2_MASK, VLUXSEG3EI16_V }, // 6084
  { PseudoVLUXSEG3EI16_V_MF4_MF2, VLUXSEG3EI16_V }, // 6085
  { PseudoVLUXSEG3EI16_V_MF4_MF2_MASK, VLUXSEG3EI16_V }, // 6086
  { PseudoVLUXSEG3EI16_V_MF4_MF4, VLUXSEG3EI16_V }, // 6087
  { PseudoVLUXSEG3EI16_V_MF4_MF4_MASK, VLUXSEG3EI16_V }, // 6088
  { PseudoVLUXSEG3EI16_V_MF4_MF8, VLUXSEG3EI16_V }, // 6089
  { PseudoVLUXSEG3EI16_V_MF4_MF8_MASK, VLUXSEG3EI16_V }, // 6090
  { PseudoVLUXSEG3EI32_V_M1_M1, VLUXSEG3EI32_V }, // 6091
  { PseudoVLUXSEG3EI32_V_M1_M1_MASK, VLUXSEG3EI32_V }, // 6092
  { PseudoVLUXSEG3EI32_V_M1_M2, VLUXSEG3EI32_V }, // 6093
  { PseudoVLUXSEG3EI32_V_M1_M2_MASK, VLUXSEG3EI32_V }, // 6094
  { PseudoVLUXSEG3EI32_V_M1_MF2, VLUXSEG3EI32_V }, // 6095
  { PseudoVLUXSEG3EI32_V_M1_MF2_MASK, VLUXSEG3EI32_V }, // 6096
  { PseudoVLUXSEG3EI32_V_M1_MF4, VLUXSEG3EI32_V }, // 6097
  { PseudoVLUXSEG3EI32_V_M1_MF4_MASK, VLUXSEG3EI32_V }, // 6098
  { PseudoVLUXSEG3EI32_V_M1_MF8, VLUXSEG3EI32_V }, // 6099
  { PseudoVLUXSEG3EI32_V_M1_MF8_MASK, VLUXSEG3EI32_V }, // 6100
  { PseudoVLUXSEG3EI32_V_M2_M1, VLUXSEG3EI32_V }, // 6101
  { PseudoVLUXSEG3EI32_V_M2_M1_MASK, VLUXSEG3EI32_V }, // 6102
  { PseudoVLUXSEG3EI32_V_M2_M2, VLUXSEG3EI32_V }, // 6103
  { PseudoVLUXSEG3EI32_V_M2_M2_MASK, VLUXSEG3EI32_V }, // 6104
  { PseudoVLUXSEG3EI32_V_M2_MF2, VLUXSEG3EI32_V }, // 6105
  { PseudoVLUXSEG3EI32_V_M2_MF2_MASK, VLUXSEG3EI32_V }, // 6106
  { PseudoVLUXSEG3EI32_V_M2_MF4, VLUXSEG3EI32_V }, // 6107
  { PseudoVLUXSEG3EI32_V_M2_MF4_MASK, VLUXSEG3EI32_V }, // 6108
  { PseudoVLUXSEG3EI32_V_M2_MF8, VLUXSEG3EI32_V }, // 6109
  { PseudoVLUXSEG3EI32_V_M2_MF8_MASK, VLUXSEG3EI32_V }, // 6110
  { PseudoVLUXSEG3EI32_V_M4_M1, VLUXSEG3EI32_V }, // 6111
  { PseudoVLUXSEG3EI32_V_M4_M1_MASK, VLUXSEG3EI32_V }, // 6112
  { PseudoVLUXSEG3EI32_V_M4_M2, VLUXSEG3EI32_V }, // 6113
  { PseudoVLUXSEG3EI32_V_M4_M2_MASK, VLUXSEG3EI32_V }, // 6114
  { PseudoVLUXSEG3EI32_V_M4_MF2, VLUXSEG3EI32_V }, // 6115
  { PseudoVLUXSEG3EI32_V_M4_MF2_MASK, VLUXSEG3EI32_V }, // 6116
  { PseudoVLUXSEG3EI32_V_M4_MF4, VLUXSEG3EI32_V }, // 6117
  { PseudoVLUXSEG3EI32_V_M4_MF4_MASK, VLUXSEG3EI32_V }, // 6118
  { PseudoVLUXSEG3EI32_V_M4_MF8, VLUXSEG3EI32_V }, // 6119
  { PseudoVLUXSEG3EI32_V_M4_MF8_MASK, VLUXSEG3EI32_V }, // 6120
  { PseudoVLUXSEG3EI32_V_M8_M1, VLUXSEG3EI32_V }, // 6121
  { PseudoVLUXSEG3EI32_V_M8_M1_MASK, VLUXSEG3EI32_V }, // 6122
  { PseudoVLUXSEG3EI32_V_M8_M2, VLUXSEG3EI32_V }, // 6123
  { PseudoVLUXSEG3EI32_V_M8_M2_MASK, VLUXSEG3EI32_V }, // 6124
  { PseudoVLUXSEG3EI32_V_M8_MF2, VLUXSEG3EI32_V }, // 6125
  { PseudoVLUXSEG3EI32_V_M8_MF2_MASK, VLUXSEG3EI32_V }, // 6126
  { PseudoVLUXSEG3EI32_V_M8_MF4, VLUXSEG3EI32_V }, // 6127
  { PseudoVLUXSEG3EI32_V_M8_MF4_MASK, VLUXSEG3EI32_V }, // 6128
  { PseudoVLUXSEG3EI32_V_M8_MF8, VLUXSEG3EI32_V }, // 6129
  { PseudoVLUXSEG3EI32_V_M8_MF8_MASK, VLUXSEG3EI32_V }, // 6130
  { PseudoVLUXSEG3EI32_V_MF2_M1, VLUXSEG3EI32_V }, // 6131
  { PseudoVLUXSEG3EI32_V_MF2_M1_MASK, VLUXSEG3EI32_V }, // 6132
  { PseudoVLUXSEG3EI32_V_MF2_M2, VLUXSEG3EI32_V }, // 6133
  { PseudoVLUXSEG3EI32_V_MF2_M2_MASK, VLUXSEG3EI32_V }, // 6134
  { PseudoVLUXSEG3EI32_V_MF2_MF2, VLUXSEG3EI32_V }, // 6135
  { PseudoVLUXSEG3EI32_V_MF2_MF2_MASK, VLUXSEG3EI32_V }, // 6136
  { PseudoVLUXSEG3EI32_V_MF2_MF4, VLUXSEG3EI32_V }, // 6137
  { PseudoVLUXSEG3EI32_V_MF2_MF4_MASK, VLUXSEG3EI32_V }, // 6138
  { PseudoVLUXSEG3EI32_V_MF2_MF8, VLUXSEG3EI32_V }, // 6139
  { PseudoVLUXSEG3EI32_V_MF2_MF8_MASK, VLUXSEG3EI32_V }, // 6140
  { PseudoVLUXSEG3EI64_V_M1_M1, VLUXSEG3EI64_V }, // 6141
  { PseudoVLUXSEG3EI64_V_M1_M1_MASK, VLUXSEG3EI64_V }, // 6142
  { PseudoVLUXSEG3EI64_V_M1_M2, VLUXSEG3EI64_V }, // 6143
  { PseudoVLUXSEG3EI64_V_M1_M2_MASK, VLUXSEG3EI64_V }, // 6144
  { PseudoVLUXSEG3EI64_V_M1_MF2, VLUXSEG3EI64_V }, // 6145
  { PseudoVLUXSEG3EI64_V_M1_MF2_MASK, VLUXSEG3EI64_V }, // 6146
  { PseudoVLUXSEG3EI64_V_M1_MF4, VLUXSEG3EI64_V }, // 6147
  { PseudoVLUXSEG3EI64_V_M1_MF4_MASK, VLUXSEG3EI64_V }, // 6148
  { PseudoVLUXSEG3EI64_V_M1_MF8, VLUXSEG3EI64_V }, // 6149
  { PseudoVLUXSEG3EI64_V_M1_MF8_MASK, VLUXSEG3EI64_V }, // 6150
  { PseudoVLUXSEG3EI64_V_M2_M1, VLUXSEG3EI64_V }, // 6151
  { PseudoVLUXSEG3EI64_V_M2_M1_MASK, VLUXSEG3EI64_V }, // 6152
  { PseudoVLUXSEG3EI64_V_M2_M2, VLUXSEG3EI64_V }, // 6153
  { PseudoVLUXSEG3EI64_V_M2_M2_MASK, VLUXSEG3EI64_V }, // 6154
  { PseudoVLUXSEG3EI64_V_M2_MF2, VLUXSEG3EI64_V }, // 6155
  { PseudoVLUXSEG3EI64_V_M2_MF2_MASK, VLUXSEG3EI64_V }, // 6156
  { PseudoVLUXSEG3EI64_V_M2_MF4, VLUXSEG3EI64_V }, // 6157
  { PseudoVLUXSEG3EI64_V_M2_MF4_MASK, VLUXSEG3EI64_V }, // 6158
  { PseudoVLUXSEG3EI64_V_M2_MF8, VLUXSEG3EI64_V }, // 6159
  { PseudoVLUXSEG3EI64_V_M2_MF8_MASK, VLUXSEG3EI64_V }, // 6160
  { PseudoVLUXSEG3EI64_V_M4_M1, VLUXSEG3EI64_V }, // 6161
  { PseudoVLUXSEG3EI64_V_M4_M1_MASK, VLUXSEG3EI64_V }, // 6162
  { PseudoVLUXSEG3EI64_V_M4_M2, VLUXSEG3EI64_V }, // 6163
  { PseudoVLUXSEG3EI64_V_M4_M2_MASK, VLUXSEG3EI64_V }, // 6164
  { PseudoVLUXSEG3EI64_V_M4_MF2, VLUXSEG3EI64_V }, // 6165
  { PseudoVLUXSEG3EI64_V_M4_MF2_MASK, VLUXSEG3EI64_V }, // 6166
  { PseudoVLUXSEG3EI64_V_M4_MF4, VLUXSEG3EI64_V }, // 6167
  { PseudoVLUXSEG3EI64_V_M4_MF4_MASK, VLUXSEG3EI64_V }, // 6168
  { PseudoVLUXSEG3EI64_V_M4_MF8, VLUXSEG3EI64_V }, // 6169
  { PseudoVLUXSEG3EI64_V_M4_MF8_MASK, VLUXSEG3EI64_V }, // 6170
  { PseudoVLUXSEG3EI64_V_M8_M1, VLUXSEG3EI64_V }, // 6171
  { PseudoVLUXSEG3EI64_V_M8_M1_MASK, VLUXSEG3EI64_V }, // 6172
  { PseudoVLUXSEG3EI64_V_M8_M2, VLUXSEG3EI64_V }, // 6173
  { PseudoVLUXSEG3EI64_V_M8_M2_MASK, VLUXSEG3EI64_V }, // 6174
  { PseudoVLUXSEG3EI64_V_M8_MF2, VLUXSEG3EI64_V }, // 6175
  { PseudoVLUXSEG3EI64_V_M8_MF2_MASK, VLUXSEG3EI64_V }, // 6176
  { PseudoVLUXSEG3EI64_V_M8_MF4, VLUXSEG3EI64_V }, // 6177
  { PseudoVLUXSEG3EI64_V_M8_MF4_MASK, VLUXSEG3EI64_V }, // 6178
  { PseudoVLUXSEG3EI64_V_M8_MF8, VLUXSEG3EI64_V }, // 6179
  { PseudoVLUXSEG3EI64_V_M8_MF8_MASK, VLUXSEG3EI64_V }, // 6180
  { PseudoVLUXSEG3EI8_V_M1_M1, VLUXSEG3EI8_V }, // 6181
  { PseudoVLUXSEG3EI8_V_M1_M1_MASK, VLUXSEG3EI8_V }, // 6182
  { PseudoVLUXSEG3EI8_V_M1_M2, VLUXSEG3EI8_V }, // 6183
  { PseudoVLUXSEG3EI8_V_M1_M2_MASK, VLUXSEG3EI8_V }, // 6184
  { PseudoVLUXSEG3EI8_V_M1_MF2, VLUXSEG3EI8_V }, // 6185
  { PseudoVLUXSEG3EI8_V_M1_MF2_MASK, VLUXSEG3EI8_V }, // 6186
  { PseudoVLUXSEG3EI8_V_M1_MF4, VLUXSEG3EI8_V }, // 6187
  { PseudoVLUXSEG3EI8_V_M1_MF4_MASK, VLUXSEG3EI8_V }, // 6188
  { PseudoVLUXSEG3EI8_V_M1_MF8, VLUXSEG3EI8_V }, // 6189
  { PseudoVLUXSEG3EI8_V_M1_MF8_MASK, VLUXSEG3EI8_V }, // 6190
  { PseudoVLUXSEG3EI8_V_M2_M1, VLUXSEG3EI8_V }, // 6191
  { PseudoVLUXSEG3EI8_V_M2_M1_MASK, VLUXSEG3EI8_V }, // 6192
  { PseudoVLUXSEG3EI8_V_M2_M2, VLUXSEG3EI8_V }, // 6193
  { PseudoVLUXSEG3EI8_V_M2_M2_MASK, VLUXSEG3EI8_V }, // 6194
  { PseudoVLUXSEG3EI8_V_M2_MF2, VLUXSEG3EI8_V }, // 6195
  { PseudoVLUXSEG3EI8_V_M2_MF2_MASK, VLUXSEG3EI8_V }, // 6196
  { PseudoVLUXSEG3EI8_V_M2_MF4, VLUXSEG3EI8_V }, // 6197
  { PseudoVLUXSEG3EI8_V_M2_MF4_MASK, VLUXSEG3EI8_V }, // 6198
  { PseudoVLUXSEG3EI8_V_M2_MF8, VLUXSEG3EI8_V }, // 6199
  { PseudoVLUXSEG3EI8_V_M2_MF8_MASK, VLUXSEG3EI8_V }, // 6200
  { PseudoVLUXSEG3EI8_V_M4_M1, VLUXSEG3EI8_V }, // 6201
  { PseudoVLUXSEG3EI8_V_M4_M1_MASK, VLUXSEG3EI8_V }, // 6202
  { PseudoVLUXSEG3EI8_V_M4_M2, VLUXSEG3EI8_V }, // 6203
  { PseudoVLUXSEG3EI8_V_M4_M2_MASK, VLUXSEG3EI8_V }, // 6204
  { PseudoVLUXSEG3EI8_V_M4_MF2, VLUXSEG3EI8_V }, // 6205
  { PseudoVLUXSEG3EI8_V_M4_MF2_MASK, VLUXSEG3EI8_V }, // 6206
  { PseudoVLUXSEG3EI8_V_M4_MF4, VLUXSEG3EI8_V }, // 6207
  { PseudoVLUXSEG3EI8_V_M4_MF4_MASK, VLUXSEG3EI8_V }, // 6208
  { PseudoVLUXSEG3EI8_V_M4_MF8, VLUXSEG3EI8_V }, // 6209
  { PseudoVLUXSEG3EI8_V_M4_MF8_MASK, VLUXSEG3EI8_V }, // 6210
  { PseudoVLUXSEG3EI8_V_M8_M1, VLUXSEG3EI8_V }, // 6211
  { PseudoVLUXSEG3EI8_V_M8_M1_MASK, VLUXSEG3EI8_V }, // 6212
  { PseudoVLUXSEG3EI8_V_M8_M2, VLUXSEG3EI8_V }, // 6213
  { PseudoVLUXSEG3EI8_V_M8_M2_MASK, VLUXSEG3EI8_V }, // 6214
  { PseudoVLUXSEG3EI8_V_M8_MF2, VLUXSEG3EI8_V }, // 6215
  { PseudoVLUXSEG3EI8_V_M8_MF2_MASK, VLUXSEG3EI8_V }, // 6216
  { PseudoVLUXSEG3EI8_V_M8_MF4, VLUXSEG3EI8_V }, // 6217
  { PseudoVLUXSEG3EI8_V_M8_MF4_MASK, VLUXSEG3EI8_V }, // 6218
  { PseudoVLUXSEG3EI8_V_M8_MF8, VLUXSEG3EI8_V }, // 6219
  { PseudoVLUXSEG3EI8_V_M8_MF8_MASK, VLUXSEG3EI8_V }, // 6220
  { PseudoVLUXSEG3EI8_V_MF2_M1, VLUXSEG3EI8_V }, // 6221
  { PseudoVLUXSEG3EI8_V_MF2_M1_MASK, VLUXSEG3EI8_V }, // 6222
  { PseudoVLUXSEG3EI8_V_MF2_M2, VLUXSEG3EI8_V }, // 6223
  { PseudoVLUXSEG3EI8_V_MF2_M2_MASK, VLUXSEG3EI8_V }, // 6224
  { PseudoVLUXSEG3EI8_V_MF2_MF2, VLUXSEG3EI8_V }, // 6225
  { PseudoVLUXSEG3EI8_V_MF2_MF2_MASK, VLUXSEG3EI8_V }, // 6226
  { PseudoVLUXSEG3EI8_V_MF2_MF4, VLUXSEG3EI8_V }, // 6227
  { PseudoVLUXSEG3EI8_V_MF2_MF4_MASK, VLUXSEG3EI8_V }, // 6228
  { PseudoVLUXSEG3EI8_V_MF2_MF8, VLUXSEG3EI8_V }, // 6229
  { PseudoVLUXSEG3EI8_V_MF2_MF8_MASK, VLUXSEG3EI8_V }, // 6230
  { PseudoVLUXSEG3EI8_V_MF4_M1, VLUXSEG3EI8_V }, // 6231
  { PseudoVLUXSEG3EI8_V_MF4_M1_MASK, VLUXSEG3EI8_V }, // 6232
  { PseudoVLUXSEG3EI8_V_MF4_M2, VLUXSEG3EI8_V }, // 6233
  { PseudoVLUXSEG3EI8_V_MF4_M2_MASK, VLUXSEG3EI8_V }, // 6234
  { PseudoVLUXSEG3EI8_V_MF4_MF2, VLUXSEG3EI8_V }, // 6235
  { PseudoVLUXSEG3EI8_V_MF4_MF2_MASK, VLUXSEG3EI8_V }, // 6236
  { PseudoVLUXSEG3EI8_V_MF4_MF4, VLUXSEG3EI8_V }, // 6237
  { PseudoVLUXSEG3EI8_V_MF4_MF4_MASK, VLUXSEG3EI8_V }, // 6238
  { PseudoVLUXSEG3EI8_V_MF4_MF8, VLUXSEG3EI8_V }, // 6239
  { PseudoVLUXSEG3EI8_V_MF4_MF8_MASK, VLUXSEG3EI8_V }, // 6240
  { PseudoVLUXSEG3EI8_V_MF8_M1, VLUXSEG3EI8_V }, // 6241
  { PseudoVLUXSEG3EI8_V_MF8_M1_MASK, VLUXSEG3EI8_V }, // 6242
  { PseudoVLUXSEG3EI8_V_MF8_M2, VLUXSEG3EI8_V }, // 6243
  { PseudoVLUXSEG3EI8_V_MF8_M2_MASK, VLUXSEG3EI8_V }, // 6244
  { PseudoVLUXSEG3EI8_V_MF8_MF2, VLUXSEG3EI8_V }, // 6245
  { PseudoVLUXSEG3EI8_V_MF8_MF2_MASK, VLUXSEG3EI8_V }, // 6246
  { PseudoVLUXSEG3EI8_V_MF8_MF4, VLUXSEG3EI8_V }, // 6247
  { PseudoVLUXSEG3EI8_V_MF8_MF4_MASK, VLUXSEG3EI8_V }, // 6248
  { PseudoVLUXSEG3EI8_V_MF8_MF8, VLUXSEG3EI8_V }, // 6249
  { PseudoVLUXSEG3EI8_V_MF8_MF8_MASK, VLUXSEG3EI8_V }, // 6250
  { PseudoVLUXSEG4EI16_V_M1_M1, VLUXSEG4EI16_V }, // 6251
  { PseudoVLUXSEG4EI16_V_M1_M1_MASK, VLUXSEG4EI16_V }, // 6252
  { PseudoVLUXSEG4EI16_V_M1_M2, VLUXSEG4EI16_V }, // 6253
  { PseudoVLUXSEG4EI16_V_M1_M2_MASK, VLUXSEG4EI16_V }, // 6254
  { PseudoVLUXSEG4EI16_V_M1_MF2, VLUXSEG4EI16_V }, // 6255
  { PseudoVLUXSEG4EI16_V_M1_MF2_MASK, VLUXSEG4EI16_V }, // 6256
  { PseudoVLUXSEG4EI16_V_M1_MF4, VLUXSEG4EI16_V }, // 6257
  { PseudoVLUXSEG4EI16_V_M1_MF4_MASK, VLUXSEG4EI16_V }, // 6258
  { PseudoVLUXSEG4EI16_V_M1_MF8, VLUXSEG4EI16_V }, // 6259
  { PseudoVLUXSEG4EI16_V_M1_MF8_MASK, VLUXSEG4EI16_V }, // 6260
  { PseudoVLUXSEG4EI16_V_M2_M1, VLUXSEG4EI16_V }, // 6261
  { PseudoVLUXSEG4EI16_V_M2_M1_MASK, VLUXSEG4EI16_V }, // 6262
  { PseudoVLUXSEG4EI16_V_M2_M2, VLUXSEG4EI16_V }, // 6263
  { PseudoVLUXSEG4EI16_V_M2_M2_MASK, VLUXSEG4EI16_V }, // 6264
  { PseudoVLUXSEG4EI16_V_M2_MF2, VLUXSEG4EI16_V }, // 6265
  { PseudoVLUXSEG4EI16_V_M2_MF2_MASK, VLUXSEG4EI16_V }, // 6266
  { PseudoVLUXSEG4EI16_V_M2_MF4, VLUXSEG4EI16_V }, // 6267
  { PseudoVLUXSEG4EI16_V_M2_MF4_MASK, VLUXSEG4EI16_V }, // 6268
  { PseudoVLUXSEG4EI16_V_M2_MF8, VLUXSEG4EI16_V }, // 6269
  { PseudoVLUXSEG4EI16_V_M2_MF8_MASK, VLUXSEG4EI16_V }, // 6270
  { PseudoVLUXSEG4EI16_V_M4_M1, VLUXSEG4EI16_V }, // 6271
  { PseudoVLUXSEG4EI16_V_M4_M1_MASK, VLUXSEG4EI16_V }, // 6272
  { PseudoVLUXSEG4EI16_V_M4_M2, VLUXSEG4EI16_V }, // 6273
  { PseudoVLUXSEG4EI16_V_M4_M2_MASK, VLUXSEG4EI16_V }, // 6274
  { PseudoVLUXSEG4EI16_V_M4_MF2, VLUXSEG4EI16_V }, // 6275
  { PseudoVLUXSEG4EI16_V_M4_MF2_MASK, VLUXSEG4EI16_V }, // 6276
  { PseudoVLUXSEG4EI16_V_M4_MF4, VLUXSEG4EI16_V }, // 6277
  { PseudoVLUXSEG4EI16_V_M4_MF4_MASK, VLUXSEG4EI16_V }, // 6278
  { PseudoVLUXSEG4EI16_V_M4_MF8, VLUXSEG4EI16_V }, // 6279
  { PseudoVLUXSEG4EI16_V_M4_MF8_MASK, VLUXSEG4EI16_V }, // 6280
  { PseudoVLUXSEG4EI16_V_M8_M1, VLUXSEG4EI16_V }, // 6281
  { PseudoVLUXSEG4EI16_V_M8_M1_MASK, VLUXSEG4EI16_V }, // 6282
  { PseudoVLUXSEG4EI16_V_M8_M2, VLUXSEG4EI16_V }, // 6283
  { PseudoVLUXSEG4EI16_V_M8_M2_MASK, VLUXSEG4EI16_V }, // 6284
  { PseudoVLUXSEG4EI16_V_M8_MF2, VLUXSEG4EI16_V }, // 6285
  { PseudoVLUXSEG4EI16_V_M8_MF2_MASK, VLUXSEG4EI16_V }, // 6286
  { PseudoVLUXSEG4EI16_V_M8_MF4, VLUXSEG4EI16_V }, // 6287
  { PseudoVLUXSEG4EI16_V_M8_MF4_MASK, VLUXSEG4EI16_V }, // 6288
  { PseudoVLUXSEG4EI16_V_M8_MF8, VLUXSEG4EI16_V }, // 6289
  { PseudoVLUXSEG4EI16_V_M8_MF8_MASK, VLUXSEG4EI16_V }, // 6290
  { PseudoVLUXSEG4EI16_V_MF2_M1, VLUXSEG4EI16_V }, // 6291
  { PseudoVLUXSEG4EI16_V_MF2_M1_MASK, VLUXSEG4EI16_V }, // 6292
  { PseudoVLUXSEG4EI16_V_MF2_M2, VLUXSEG4EI16_V }, // 6293
  { PseudoVLUXSEG4EI16_V_MF2_M2_MASK, VLUXSEG4EI16_V }, // 6294
  { PseudoVLUXSEG4EI16_V_MF2_MF2, VLUXSEG4EI16_V }, // 6295
  { PseudoVLUXSEG4EI16_V_MF2_MF2_MASK, VLUXSEG4EI16_V }, // 6296
  { PseudoVLUXSEG4EI16_V_MF2_MF4, VLUXSEG4EI16_V }, // 6297
  { PseudoVLUXSEG4EI16_V_MF2_MF4_MASK, VLUXSEG4EI16_V }, // 6298
  { PseudoVLUXSEG4EI16_V_MF2_MF8, VLUXSEG4EI16_V }, // 6299
  { PseudoVLUXSEG4EI16_V_MF2_MF8_MASK, VLUXSEG4EI16_V }, // 6300
  { PseudoVLUXSEG4EI16_V_MF4_M1, VLUXSEG4EI16_V }, // 6301
  { PseudoVLUXSEG4EI16_V_MF4_M1_MASK, VLUXSEG4EI16_V }, // 6302
  { PseudoVLUXSEG4EI16_V_MF4_M2, VLUXSEG4EI16_V }, // 6303
  { PseudoVLUXSEG4EI16_V_MF4_M2_MASK, VLUXSEG4EI16_V }, // 6304
  { PseudoVLUXSEG4EI16_V_MF4_MF2, VLUXSEG4EI16_V }, // 6305
  { PseudoVLUXSEG4EI16_V_MF4_MF2_MASK, VLUXSEG4EI16_V }, // 6306
  { PseudoVLUXSEG4EI16_V_MF4_MF4, VLUXSEG4EI16_V }, // 6307
  { PseudoVLUXSEG4EI16_V_MF4_MF4_MASK, VLUXSEG4EI16_V }, // 6308
  { PseudoVLUXSEG4EI16_V_MF4_MF8, VLUXSEG4EI16_V }, // 6309
  { PseudoVLUXSEG4EI16_V_MF4_MF8_MASK, VLUXSEG4EI16_V }, // 6310
  { PseudoVLUXSEG4EI32_V_M1_M1, VLUXSEG4EI32_V }, // 6311
  { PseudoVLUXSEG4EI32_V_M1_M1_MASK, VLUXSEG4EI32_V }, // 6312
  { PseudoVLUXSEG4EI32_V_M1_M2, VLUXSEG4EI32_V }, // 6313
  { PseudoVLUXSEG4EI32_V_M1_M2_MASK, VLUXSEG4EI32_V }, // 6314
  { PseudoVLUXSEG4EI32_V_M1_MF2, VLUXSEG4EI32_V }, // 6315
  { PseudoVLUXSEG4EI32_V_M1_MF2_MASK, VLUXSEG4EI32_V }, // 6316
  { PseudoVLUXSEG4EI32_V_M1_MF4, VLUXSEG4EI32_V }, // 6317
  { PseudoVLUXSEG4EI32_V_M1_MF4_MASK, VLUXSEG4EI32_V }, // 6318
  { PseudoVLUXSEG4EI32_V_M1_MF8, VLUXSEG4EI32_V }, // 6319
  { PseudoVLUXSEG4EI32_V_M1_MF8_MASK, VLUXSEG4EI32_V }, // 6320
  { PseudoVLUXSEG4EI32_V_M2_M1, VLUXSEG4EI32_V }, // 6321
  { PseudoVLUXSEG4EI32_V_M2_M1_MASK, VLUXSEG4EI32_V }, // 6322
  { PseudoVLUXSEG4EI32_V_M2_M2, VLUXSEG4EI32_V }, // 6323
  { PseudoVLUXSEG4EI32_V_M2_M2_MASK, VLUXSEG4EI32_V }, // 6324
  { PseudoVLUXSEG4EI32_V_M2_MF2, VLUXSEG4EI32_V }, // 6325
  { PseudoVLUXSEG4EI32_V_M2_MF2_MASK, VLUXSEG4EI32_V }, // 6326
  { PseudoVLUXSEG4EI32_V_M2_MF4, VLUXSEG4EI32_V }, // 6327
  { PseudoVLUXSEG4EI32_V_M2_MF4_MASK, VLUXSEG4EI32_V }, // 6328
  { PseudoVLUXSEG4EI32_V_M2_MF8, VLUXSEG4EI32_V }, // 6329
  { PseudoVLUXSEG4EI32_V_M2_MF8_MASK, VLUXSEG4EI32_V }, // 6330
  { PseudoVLUXSEG4EI32_V_M4_M1, VLUXSEG4EI32_V }, // 6331
  { PseudoVLUXSEG4EI32_V_M4_M1_MASK, VLUXSEG4EI32_V }, // 6332
  { PseudoVLUXSEG4EI32_V_M4_M2, VLUXSEG4EI32_V }, // 6333
  { PseudoVLUXSEG4EI32_V_M4_M2_MASK, VLUXSEG4EI32_V }, // 6334
  { PseudoVLUXSEG4EI32_V_M4_MF2, VLUXSEG4EI32_V }, // 6335
  { PseudoVLUXSEG4EI32_V_M4_MF2_MASK, VLUXSEG4EI32_V }, // 6336
  { PseudoVLUXSEG4EI32_V_M4_MF4, VLUXSEG4EI32_V }, // 6337
  { PseudoVLUXSEG4EI32_V_M4_MF4_MASK, VLUXSEG4EI32_V }, // 6338
  { PseudoVLUXSEG4EI32_V_M4_MF8, VLUXSEG4EI32_V }, // 6339
  { PseudoVLUXSEG4EI32_V_M4_MF8_MASK, VLUXSEG4EI32_V }, // 6340
  { PseudoVLUXSEG4EI32_V_M8_M1, VLUXSEG4EI32_V }, // 6341
  { PseudoVLUXSEG4EI32_V_M8_M1_MASK, VLUXSEG4EI32_V }, // 6342
  { PseudoVLUXSEG4EI32_V_M8_M2, VLUXSEG4EI32_V }, // 6343
  { PseudoVLUXSEG4EI32_V_M8_M2_MASK, VLUXSEG4EI32_V }, // 6344
  { PseudoVLUXSEG4EI32_V_M8_MF2, VLUXSEG4EI32_V }, // 6345
  { PseudoVLUXSEG4EI32_V_M8_MF2_MASK, VLUXSEG4EI32_V }, // 6346
  { PseudoVLUXSEG4EI32_V_M8_MF4, VLUXSEG4EI32_V }, // 6347
  { PseudoVLUXSEG4EI32_V_M8_MF4_MASK, VLUXSEG4EI32_V }, // 6348
  { PseudoVLUXSEG4EI32_V_M8_MF8, VLUXSEG4EI32_V }, // 6349
  { PseudoVLUXSEG4EI32_V_M8_MF8_MASK, VLUXSEG4EI32_V }, // 6350
  { PseudoVLUXSEG4EI32_V_MF2_M1, VLUXSEG4EI32_V }, // 6351
  { PseudoVLUXSEG4EI32_V_MF2_M1_MASK, VLUXSEG4EI32_V }, // 6352
  { PseudoVLUXSEG4EI32_V_MF2_M2, VLUXSEG4EI32_V }, // 6353
  { PseudoVLUXSEG4EI32_V_MF2_M2_MASK, VLUXSEG4EI32_V }, // 6354
  { PseudoVLUXSEG4EI32_V_MF2_MF2, VLUXSEG4EI32_V }, // 6355
  { PseudoVLUXSEG4EI32_V_MF2_MF2_MASK, VLUXSEG4EI32_V }, // 6356
  { PseudoVLUXSEG4EI32_V_MF2_MF4, VLUXSEG4EI32_V }, // 6357
  { PseudoVLUXSEG4EI32_V_MF2_MF4_MASK, VLUXSEG4EI32_V }, // 6358
  { PseudoVLUXSEG4EI32_V_MF2_MF8, VLUXSEG4EI32_V }, // 6359
  { PseudoVLUXSEG4EI32_V_MF2_MF8_MASK, VLUXSEG4EI32_V }, // 6360
  { PseudoVLUXSEG4EI64_V_M1_M1, VLUXSEG4EI64_V }, // 6361
  { PseudoVLUXSEG4EI64_V_M1_M1_MASK, VLUXSEG4EI64_V }, // 6362
  { PseudoVLUXSEG4EI64_V_M1_M2, VLUXSEG4EI64_V }, // 6363
  { PseudoVLUXSEG4EI64_V_M1_M2_MASK, VLUXSEG4EI64_V }, // 6364
  { PseudoVLUXSEG4EI64_V_M1_MF2, VLUXSEG4EI64_V }, // 6365
  { PseudoVLUXSEG4EI64_V_M1_MF2_MASK, VLUXSEG4EI64_V }, // 6366
  { PseudoVLUXSEG4EI64_V_M1_MF4, VLUXSEG4EI64_V }, // 6367
  { PseudoVLUXSEG4EI64_V_M1_MF4_MASK, VLUXSEG4EI64_V }, // 6368
  { PseudoVLUXSEG4EI64_V_M1_MF8, VLUXSEG4EI64_V }, // 6369
  { PseudoVLUXSEG4EI64_V_M1_MF8_MASK, VLUXSEG4EI64_V }, // 6370
  { PseudoVLUXSEG4EI64_V_M2_M1, VLUXSEG4EI64_V }, // 6371
  { PseudoVLUXSEG4EI64_V_M2_M1_MASK, VLUXSEG4EI64_V }, // 6372
  { PseudoVLUXSEG4EI64_V_M2_M2, VLUXSEG4EI64_V }, // 6373
  { PseudoVLUXSEG4EI64_V_M2_M2_MASK, VLUXSEG4EI64_V }, // 6374
  { PseudoVLUXSEG4EI64_V_M2_MF2, VLUXSEG4EI64_V }, // 6375
  { PseudoVLUXSEG4EI64_V_M2_MF2_MASK, VLUXSEG4EI64_V }, // 6376
  { PseudoVLUXSEG4EI64_V_M2_MF4, VLUXSEG4EI64_V }, // 6377
  { PseudoVLUXSEG4EI64_V_M2_MF4_MASK, VLUXSEG4EI64_V }, // 6378
  { PseudoVLUXSEG4EI64_V_M2_MF8, VLUXSEG4EI64_V }, // 6379
  { PseudoVLUXSEG4EI64_V_M2_MF8_MASK, VLUXSEG4EI64_V }, // 6380
  { PseudoVLUXSEG4EI64_V_M4_M1, VLUXSEG4EI64_V }, // 6381
  { PseudoVLUXSEG4EI64_V_M4_M1_MASK, VLUXSEG4EI64_V }, // 6382
  { PseudoVLUXSEG4EI64_V_M4_M2, VLUXSEG4EI64_V }, // 6383
  { PseudoVLUXSEG4EI64_V_M4_M2_MASK, VLUXSEG4EI64_V }, // 6384
  { PseudoVLUXSEG4EI64_V_M4_MF2, VLUXSEG4EI64_V }, // 6385
  { PseudoVLUXSEG4EI64_V_M4_MF2_MASK, VLUXSEG4EI64_V }, // 6386
  { PseudoVLUXSEG4EI64_V_M4_MF4, VLUXSEG4EI64_V }, // 6387
  { PseudoVLUXSEG4EI64_V_M4_MF4_MASK, VLUXSEG4EI64_V }, // 6388
  { PseudoVLUXSEG4EI64_V_M4_MF8, VLUXSEG4EI64_V }, // 6389
  { PseudoVLUXSEG4EI64_V_M4_MF8_MASK, VLUXSEG4EI64_V }, // 6390
  { PseudoVLUXSEG4EI64_V_M8_M1, VLUXSEG4EI64_V }, // 6391
  { PseudoVLUXSEG4EI64_V_M8_M1_MASK, VLUXSEG4EI64_V }, // 6392
  { PseudoVLUXSEG4EI64_V_M8_M2, VLUXSEG4EI64_V }, // 6393
  { PseudoVLUXSEG4EI64_V_M8_M2_MASK, VLUXSEG4EI64_V }, // 6394
  { PseudoVLUXSEG4EI64_V_M8_MF2, VLUXSEG4EI64_V }, // 6395
  { PseudoVLUXSEG4EI64_V_M8_MF2_MASK, VLUXSEG4EI64_V }, // 6396
  { PseudoVLUXSEG4EI64_V_M8_MF4, VLUXSEG4EI64_V }, // 6397
  { PseudoVLUXSEG4EI64_V_M8_MF4_MASK, VLUXSEG4EI64_V }, // 6398
  { PseudoVLUXSEG4EI64_V_M8_MF8, VLUXSEG4EI64_V }, // 6399
  { PseudoVLUXSEG4EI64_V_M8_MF8_MASK, VLUXSEG4EI64_V }, // 6400
  { PseudoVLUXSEG4EI8_V_M1_M1, VLUXSEG4EI8_V }, // 6401
  { PseudoVLUXSEG4EI8_V_M1_M1_MASK, VLUXSEG4EI8_V }, // 6402
  { PseudoVLUXSEG4EI8_V_M1_M2, VLUXSEG4EI8_V }, // 6403
  { PseudoVLUXSEG4EI8_V_M1_M2_MASK, VLUXSEG4EI8_V }, // 6404
  { PseudoVLUXSEG4EI8_V_M1_MF2, VLUXSEG4EI8_V }, // 6405
  { PseudoVLUXSEG4EI8_V_M1_MF2_MASK, VLUXSEG4EI8_V }, // 6406
  { PseudoVLUXSEG4EI8_V_M1_MF4, VLUXSEG4EI8_V }, // 6407
  { PseudoVLUXSEG4EI8_V_M1_MF4_MASK, VLUXSEG4EI8_V }, // 6408
  { PseudoVLUXSEG4EI8_V_M1_MF8, VLUXSEG4EI8_V }, // 6409
  { PseudoVLUXSEG4EI8_V_M1_MF8_MASK, VLUXSEG4EI8_V }, // 6410
  { PseudoVLUXSEG4EI8_V_M2_M1, VLUXSEG4EI8_V }, // 6411
  { PseudoVLUXSEG4EI8_V_M2_M1_MASK, VLUXSEG4EI8_V }, // 6412
  { PseudoVLUXSEG4EI8_V_M2_M2, VLUXSEG4EI8_V }, // 6413
  { PseudoVLUXSEG4EI8_V_M2_M2_MASK, VLUXSEG4EI8_V }, // 6414
  { PseudoVLUXSEG4EI8_V_M2_MF2, VLUXSEG4EI8_V }, // 6415
  { PseudoVLUXSEG4EI8_V_M2_MF2_MASK, VLUXSEG4EI8_V }, // 6416
  { PseudoVLUXSEG4EI8_V_M2_MF4, VLUXSEG4EI8_V }, // 6417
  { PseudoVLUXSEG4EI8_V_M2_MF4_MASK, VLUXSEG4EI8_V }, // 6418
  { PseudoVLUXSEG4EI8_V_M2_MF8, VLUXSEG4EI8_V }, // 6419
  { PseudoVLUXSEG4EI8_V_M2_MF8_MASK, VLUXSEG4EI8_V }, // 6420
  { PseudoVLUXSEG4EI8_V_M4_M1, VLUXSEG4EI8_V }, // 6421
  { PseudoVLUXSEG4EI8_V_M4_M1_MASK, VLUXSEG4EI8_V }, // 6422
  { PseudoVLUXSEG4EI8_V_M4_M2, VLUXSEG4EI8_V }, // 6423
  { PseudoVLUXSEG4EI8_V_M4_M2_MASK, VLUXSEG4EI8_V }, // 6424
  { PseudoVLUXSEG4EI8_V_M4_MF2, VLUXSEG4EI8_V }, // 6425
  { PseudoVLUXSEG4EI8_V_M4_MF2_MASK, VLUXSEG4EI8_V }, // 6426
  { PseudoVLUXSEG4EI8_V_M4_MF4, VLUXSEG4EI8_V }, // 6427
  { PseudoVLUXSEG4EI8_V_M4_MF4_MASK, VLUXSEG4EI8_V }, // 6428
  { PseudoVLUXSEG4EI8_V_M4_MF8, VLUXSEG4EI8_V }, // 6429
  { PseudoVLUXSEG4EI8_V_M4_MF8_MASK, VLUXSEG4EI8_V }, // 6430
  { PseudoVLUXSEG4EI8_V_M8_M1, VLUXSEG4EI8_V }, // 6431
  { PseudoVLUXSEG4EI8_V_M8_M1_MASK, VLUXSEG4EI8_V }, // 6432
  { PseudoVLUXSEG4EI8_V_M8_M2, VLUXSEG4EI8_V }, // 6433
  { PseudoVLUXSEG4EI8_V_M8_M2_MASK, VLUXSEG4EI8_V }, // 6434
  { PseudoVLUXSEG4EI8_V_M8_MF2, VLUXSEG4EI8_V }, // 6435
  { PseudoVLUXSEG4EI8_V_M8_MF2_MASK, VLUXSEG4EI8_V }, // 6436
  { PseudoVLUXSEG4EI8_V_M8_MF4, VLUXSEG4EI8_V }, // 6437
  { PseudoVLUXSEG4EI8_V_M8_MF4_MASK, VLUXSEG4EI8_V }, // 6438
  { PseudoVLUXSEG4EI8_V_M8_MF8, VLUXSEG4EI8_V }, // 6439
  { PseudoVLUXSEG4EI8_V_M8_MF8_MASK, VLUXSEG4EI8_V }, // 6440
  { PseudoVLUXSEG4EI8_V_MF2_M1, VLUXSEG4EI8_V }, // 6441
  { PseudoVLUXSEG4EI8_V_MF2_M1_MASK, VLUXSEG4EI8_V }, // 6442
  { PseudoVLUXSEG4EI8_V_MF2_M2, VLUXSEG4EI8_V }, // 6443
  { PseudoVLUXSEG4EI8_V_MF2_M2_MASK, VLUXSEG4EI8_V }, // 6444
  { PseudoVLUXSEG4EI8_V_MF2_MF2, VLUXSEG4EI8_V }, // 6445
  { PseudoVLUXSEG4EI8_V_MF2_MF2_MASK, VLUXSEG4EI8_V }, // 6446
  { PseudoVLUXSEG4EI8_V_MF2_MF4, VLUXSEG4EI8_V }, // 6447
  { PseudoVLUXSEG4EI8_V_MF2_MF4_MASK, VLUXSEG4EI8_V }, // 6448
  { PseudoVLUXSEG4EI8_V_MF2_MF8, VLUXSEG4EI8_V }, // 6449
  { PseudoVLUXSEG4EI8_V_MF2_MF8_MASK, VLUXSEG4EI8_V }, // 6450
  { PseudoVLUXSEG4EI8_V_MF4_M1, VLUXSEG4EI8_V }, // 6451
  { PseudoVLUXSEG4EI8_V_MF4_M1_MASK, VLUXSEG4EI8_V }, // 6452
  { PseudoVLUXSEG4EI8_V_MF4_M2, VLUXSEG4EI8_V }, // 6453
  { PseudoVLUXSEG4EI8_V_MF4_M2_MASK, VLUXSEG4EI8_V }, // 6454
  { PseudoVLUXSEG4EI8_V_MF4_MF2, VLUXSEG4EI8_V }, // 6455
  { PseudoVLUXSEG4EI8_V_MF4_MF2_MASK, VLUXSEG4EI8_V }, // 6456
  { PseudoVLUXSEG4EI8_V_MF4_MF4, VLUXSEG4EI8_V }, // 6457
  { PseudoVLUXSEG4EI8_V_MF4_MF4_MASK, VLUXSEG4EI8_V }, // 6458
  { PseudoVLUXSEG4EI8_V_MF4_MF8, VLUXSEG4EI8_V }, // 6459
  { PseudoVLUXSEG4EI8_V_MF4_MF8_MASK, VLUXSEG4EI8_V }, // 6460
  { PseudoVLUXSEG4EI8_V_MF8_M1, VLUXSEG4EI8_V }, // 6461
  { PseudoVLUXSEG4EI8_V_MF8_M1_MASK, VLUXSEG4EI8_V }, // 6462
  { PseudoVLUXSEG4EI8_V_MF8_M2, VLUXSEG4EI8_V }, // 6463
  { PseudoVLUXSEG4EI8_V_MF8_M2_MASK, VLUXSEG4EI8_V }, // 6464
  { PseudoVLUXSEG4EI8_V_MF8_MF2, VLUXSEG4EI8_V }, // 6465
  { PseudoVLUXSEG4EI8_V_MF8_MF2_MASK, VLUXSEG4EI8_V }, // 6466
  { PseudoVLUXSEG4EI8_V_MF8_MF4, VLUXSEG4EI8_V }, // 6467
  { PseudoVLUXSEG4EI8_V_MF8_MF4_MASK, VLUXSEG4EI8_V }, // 6468
  { PseudoVLUXSEG4EI8_V_MF8_MF8, VLUXSEG4EI8_V }, // 6469
  { PseudoVLUXSEG4EI8_V_MF8_MF8_MASK, VLUXSEG4EI8_V }, // 6470
  { PseudoVLUXSEG5EI16_V_M1_M1, VLUXSEG5EI16_V }, // 6471
  { PseudoVLUXSEG5EI16_V_M1_M1_MASK, VLUXSEG5EI16_V }, // 6472
  { PseudoVLUXSEG5EI16_V_M1_MF2, VLUXSEG5EI16_V }, // 6473
  { PseudoVLUXSEG5EI16_V_M1_MF2_MASK, VLUXSEG5EI16_V }, // 6474
  { PseudoVLUXSEG5EI16_V_M1_MF4, VLUXSEG5EI16_V }, // 6475
  { PseudoVLUXSEG5EI16_V_M1_MF4_MASK, VLUXSEG5EI16_V }, // 6476
  { PseudoVLUXSEG5EI16_V_M1_MF8, VLUXSEG5EI16_V }, // 6477
  { PseudoVLUXSEG5EI16_V_M1_MF8_MASK, VLUXSEG5EI16_V }, // 6478
  { PseudoVLUXSEG5EI16_V_M2_M1, VLUXSEG5EI16_V }, // 6479
  { PseudoVLUXSEG5EI16_V_M2_M1_MASK, VLUXSEG5EI16_V }, // 6480
  { PseudoVLUXSEG5EI16_V_M2_MF2, VLUXSEG5EI16_V }, // 6481
  { PseudoVLUXSEG5EI16_V_M2_MF2_MASK, VLUXSEG5EI16_V }, // 6482
  { PseudoVLUXSEG5EI16_V_M2_MF4, VLUXSEG5EI16_V }, // 6483
  { PseudoVLUXSEG5EI16_V_M2_MF4_MASK, VLUXSEG5EI16_V }, // 6484
  { PseudoVLUXSEG5EI16_V_M2_MF8, VLUXSEG5EI16_V }, // 6485
  { PseudoVLUXSEG5EI16_V_M2_MF8_MASK, VLUXSEG5EI16_V }, // 6486
  { PseudoVLUXSEG5EI16_V_M4_M1, VLUXSEG5EI16_V }, // 6487
  { PseudoVLUXSEG5EI16_V_M4_M1_MASK, VLUXSEG5EI16_V }, // 6488
  { PseudoVLUXSEG5EI16_V_M4_MF2, VLUXSEG5EI16_V }, // 6489
  { PseudoVLUXSEG5EI16_V_M4_MF2_MASK, VLUXSEG5EI16_V }, // 6490
  { PseudoVLUXSEG5EI16_V_M4_MF4, VLUXSEG5EI16_V }, // 6491
  { PseudoVLUXSEG5EI16_V_M4_MF4_MASK, VLUXSEG5EI16_V }, // 6492
  { PseudoVLUXSEG5EI16_V_M4_MF8, VLUXSEG5EI16_V }, // 6493
  { PseudoVLUXSEG5EI16_V_M4_MF8_MASK, VLUXSEG5EI16_V }, // 6494
  { PseudoVLUXSEG5EI16_V_M8_M1, VLUXSEG5EI16_V }, // 6495
  { PseudoVLUXSEG5EI16_V_M8_M1_MASK, VLUXSEG5EI16_V }, // 6496
  { PseudoVLUXSEG5EI16_V_M8_MF2, VLUXSEG5EI16_V }, // 6497
  { PseudoVLUXSEG5EI16_V_M8_MF2_MASK, VLUXSEG5EI16_V }, // 6498
  { PseudoVLUXSEG5EI16_V_M8_MF4, VLUXSEG5EI16_V }, // 6499
  { PseudoVLUXSEG5EI16_V_M8_MF4_MASK, VLUXSEG5EI16_V }, // 6500
  { PseudoVLUXSEG5EI16_V_M8_MF8, VLUXSEG5EI16_V }, // 6501
  { PseudoVLUXSEG5EI16_V_M8_MF8_MASK, VLUXSEG5EI16_V }, // 6502
  { PseudoVLUXSEG5EI16_V_MF2_M1, VLUXSEG5EI16_V }, // 6503
  { PseudoVLUXSEG5EI16_V_MF2_M1_MASK, VLUXSEG5EI16_V }, // 6504
  { PseudoVLUXSEG5EI16_V_MF2_MF2, VLUXSEG5EI16_V }, // 6505
  { PseudoVLUXSEG5EI16_V_MF2_MF2_MASK, VLUXSEG5EI16_V }, // 6506
  { PseudoVLUXSEG5EI16_V_MF2_MF4, VLUXSEG5EI16_V }, // 6507
  { PseudoVLUXSEG5EI16_V_MF2_MF4_MASK, VLUXSEG5EI16_V }, // 6508
  { PseudoVLUXSEG5EI16_V_MF2_MF8, VLUXSEG5EI16_V }, // 6509
  { PseudoVLUXSEG5EI16_V_MF2_MF8_MASK, VLUXSEG5EI16_V }, // 6510
  { PseudoVLUXSEG5EI16_V_MF4_M1, VLUXSEG5EI16_V }, // 6511
  { PseudoVLUXSEG5EI16_V_MF4_M1_MASK, VLUXSEG5EI16_V }, // 6512
  { PseudoVLUXSEG5EI16_V_MF4_MF2, VLUXSEG5EI16_V }, // 6513
  { PseudoVLUXSEG5EI16_V_MF4_MF2_MASK, VLUXSEG5EI16_V }, // 6514
  { PseudoVLUXSEG5EI16_V_MF4_MF4, VLUXSEG5EI16_V }, // 6515
  { PseudoVLUXSEG5EI16_V_MF4_MF4_MASK, VLUXSEG5EI16_V }, // 6516
  { PseudoVLUXSEG5EI16_V_MF4_MF8, VLUXSEG5EI16_V }, // 6517
  { PseudoVLUXSEG5EI16_V_MF4_MF8_MASK, VLUXSEG5EI16_V }, // 6518
  { PseudoVLUXSEG5EI32_V_M1_M1, VLUXSEG5EI32_V }, // 6519
  { PseudoVLUXSEG5EI32_V_M1_M1_MASK, VLUXSEG5EI32_V }, // 6520
  { PseudoVLUXSEG5EI32_V_M1_MF2, VLUXSEG5EI32_V }, // 6521
  { PseudoVLUXSEG5EI32_V_M1_MF2_MASK, VLUXSEG5EI32_V }, // 6522
  { PseudoVLUXSEG5EI32_V_M1_MF4, VLUXSEG5EI32_V }, // 6523
  { PseudoVLUXSEG5EI32_V_M1_MF4_MASK, VLUXSEG5EI32_V }, // 6524
  { PseudoVLUXSEG5EI32_V_M1_MF8, VLUXSEG5EI32_V }, // 6525
  { PseudoVLUXSEG5EI32_V_M1_MF8_MASK, VLUXSEG5EI32_V }, // 6526
  { PseudoVLUXSEG5EI32_V_M2_M1, VLUXSEG5EI32_V }, // 6527
  { PseudoVLUXSEG5EI32_V_M2_M1_MASK, VLUXSEG5EI32_V }, // 6528
  { PseudoVLUXSEG5EI32_V_M2_MF2, VLUXSEG5EI32_V }, // 6529
  { PseudoVLUXSEG5EI32_V_M2_MF2_MASK, VLUXSEG5EI32_V }, // 6530
  { PseudoVLUXSEG5EI32_V_M2_MF4, VLUXSEG5EI32_V }, // 6531
  { PseudoVLUXSEG5EI32_V_M2_MF4_MASK, VLUXSEG5EI32_V }, // 6532
  { PseudoVLUXSEG5EI32_V_M2_MF8, VLUXSEG5EI32_V }, // 6533
  { PseudoVLUXSEG5EI32_V_M2_MF8_MASK, VLUXSEG5EI32_V }, // 6534
  { PseudoVLUXSEG5EI32_V_M4_M1, VLUXSEG5EI32_V }, // 6535
  { PseudoVLUXSEG5EI32_V_M4_M1_MASK, VLUXSEG5EI32_V }, // 6536
  { PseudoVLUXSEG5EI32_V_M4_MF2, VLUXSEG5EI32_V }, // 6537
  { PseudoVLUXSEG5EI32_V_M4_MF2_MASK, VLUXSEG5EI32_V }, // 6538
  { PseudoVLUXSEG5EI32_V_M4_MF4, VLUXSEG5EI32_V }, // 6539
  { PseudoVLUXSEG5EI32_V_M4_MF4_MASK, VLUXSEG5EI32_V }, // 6540
  { PseudoVLUXSEG5EI32_V_M4_MF8, VLUXSEG5EI32_V }, // 6541
  { PseudoVLUXSEG5EI32_V_M4_MF8_MASK, VLUXSEG5EI32_V }, // 6542
  { PseudoVLUXSEG5EI32_V_M8_M1, VLUXSEG5EI32_V }, // 6543
  { PseudoVLUXSEG5EI32_V_M8_M1_MASK, VLUXSEG5EI32_V }, // 6544
  { PseudoVLUXSEG5EI32_V_M8_MF2, VLUXSEG5EI32_V }, // 6545
  { PseudoVLUXSEG5EI32_V_M8_MF2_MASK, VLUXSEG5EI32_V }, // 6546
  { PseudoVLUXSEG5EI32_V_M8_MF4, VLUXSEG5EI32_V }, // 6547
  { PseudoVLUXSEG5EI32_V_M8_MF4_MASK, VLUXSEG5EI32_V }, // 6548
  { PseudoVLUXSEG5EI32_V_M8_MF8, VLUXSEG5EI32_V }, // 6549
  { PseudoVLUXSEG5EI32_V_M8_MF8_MASK, VLUXSEG5EI32_V }, // 6550
  { PseudoVLUXSEG5EI32_V_MF2_M1, VLUXSEG5EI32_V }, // 6551
  { PseudoVLUXSEG5EI32_V_MF2_M1_MASK, VLUXSEG5EI32_V }, // 6552
  { PseudoVLUXSEG5EI32_V_MF2_MF2, VLUXSEG5EI32_V }, // 6553
  { PseudoVLUXSEG5EI32_V_MF2_MF2_MASK, VLUXSEG5EI32_V }, // 6554
  { PseudoVLUXSEG5EI32_V_MF2_MF4, VLUXSEG5EI32_V }, // 6555
  { PseudoVLUXSEG5EI32_V_MF2_MF4_MASK, VLUXSEG5EI32_V }, // 6556
  { PseudoVLUXSEG5EI32_V_MF2_MF8, VLUXSEG5EI32_V }, // 6557
  { PseudoVLUXSEG5EI32_V_MF2_MF8_MASK, VLUXSEG5EI32_V }, // 6558
  { PseudoVLUXSEG5EI64_V_M1_M1, VLUXSEG5EI64_V }, // 6559
  { PseudoVLUXSEG5EI64_V_M1_M1_MASK, VLUXSEG5EI64_V }, // 6560
  { PseudoVLUXSEG5EI64_V_M1_MF2, VLUXSEG5EI64_V }, // 6561
  { PseudoVLUXSEG5EI64_V_M1_MF2_MASK, VLUXSEG5EI64_V }, // 6562
  { PseudoVLUXSEG5EI64_V_M1_MF4, VLUXSEG5EI64_V }, // 6563
  { PseudoVLUXSEG5EI64_V_M1_MF4_MASK, VLUXSEG5EI64_V }, // 6564
  { PseudoVLUXSEG5EI64_V_M1_MF8, VLUXSEG5EI64_V }, // 6565
  { PseudoVLUXSEG5EI64_V_M1_MF8_MASK, VLUXSEG5EI64_V }, // 6566
  { PseudoVLUXSEG5EI64_V_M2_M1, VLUXSEG5EI64_V }, // 6567
  { PseudoVLUXSEG5EI64_V_M2_M1_MASK, VLUXSEG5EI64_V }, // 6568
  { PseudoVLUXSEG5EI64_V_M2_MF2, VLUXSEG5EI64_V }, // 6569
  { PseudoVLUXSEG5EI64_V_M2_MF2_MASK, VLUXSEG5EI64_V }, // 6570
  { PseudoVLUXSEG5EI64_V_M2_MF4, VLUXSEG5EI64_V }, // 6571
  { PseudoVLUXSEG5EI64_V_M2_MF4_MASK, VLUXSEG5EI64_V }, // 6572
  { PseudoVLUXSEG5EI64_V_M2_MF8, VLUXSEG5EI64_V }, // 6573
  { PseudoVLUXSEG5EI64_V_M2_MF8_MASK, VLUXSEG5EI64_V }, // 6574
  { PseudoVLUXSEG5EI64_V_M4_M1, VLUXSEG5EI64_V }, // 6575
  { PseudoVLUXSEG5EI64_V_M4_M1_MASK, VLUXSEG5EI64_V }, // 6576
  { PseudoVLUXSEG5EI64_V_M4_MF2, VLUXSEG5EI64_V }, // 6577
  { PseudoVLUXSEG5EI64_V_M4_MF2_MASK, VLUXSEG5EI64_V }, // 6578
  { PseudoVLUXSEG5EI64_V_M4_MF4, VLUXSEG5EI64_V }, // 6579
  { PseudoVLUXSEG5EI64_V_M4_MF4_MASK, VLUXSEG5EI64_V }, // 6580
  { PseudoVLUXSEG5EI64_V_M4_MF8, VLUXSEG5EI64_V }, // 6581
  { PseudoVLUXSEG5EI64_V_M4_MF8_MASK, VLUXSEG5EI64_V }, // 6582
  { PseudoVLUXSEG5EI64_V_M8_M1, VLUXSEG5EI64_V }, // 6583
  { PseudoVLUXSEG5EI64_V_M8_M1_MASK, VLUXSEG5EI64_V }, // 6584
  { PseudoVLUXSEG5EI64_V_M8_MF2, VLUXSEG5EI64_V }, // 6585
  { PseudoVLUXSEG5EI64_V_M8_MF2_MASK, VLUXSEG5EI64_V }, // 6586
  { PseudoVLUXSEG5EI64_V_M8_MF4, VLUXSEG5EI64_V }, // 6587
  { PseudoVLUXSEG5EI64_V_M8_MF4_MASK, VLUXSEG5EI64_V }, // 6588
  { PseudoVLUXSEG5EI64_V_M8_MF8, VLUXSEG5EI64_V }, // 6589
  { PseudoVLUXSEG5EI64_V_M8_MF8_MASK, VLUXSEG5EI64_V }, // 6590
  { PseudoVLUXSEG5EI8_V_M1_M1, VLUXSEG5EI8_V }, // 6591
  { PseudoVLUXSEG5EI8_V_M1_M1_MASK, VLUXSEG5EI8_V }, // 6592
  { PseudoVLUXSEG5EI8_V_M1_MF2, VLUXSEG5EI8_V }, // 6593
  { PseudoVLUXSEG5EI8_V_M1_MF2_MASK, VLUXSEG5EI8_V }, // 6594
  { PseudoVLUXSEG5EI8_V_M1_MF4, VLUXSEG5EI8_V }, // 6595
  { PseudoVLUXSEG5EI8_V_M1_MF4_MASK, VLUXSEG5EI8_V }, // 6596
  { PseudoVLUXSEG5EI8_V_M1_MF8, VLUXSEG5EI8_V }, // 6597
  { PseudoVLUXSEG5EI8_V_M1_MF8_MASK, VLUXSEG5EI8_V }, // 6598
  { PseudoVLUXSEG5EI8_V_M2_M1, VLUXSEG5EI8_V }, // 6599
  { PseudoVLUXSEG5EI8_V_M2_M1_MASK, VLUXSEG5EI8_V }, // 6600
  { PseudoVLUXSEG5EI8_V_M2_MF2, VLUXSEG5EI8_V }, // 6601
  { PseudoVLUXSEG5EI8_V_M2_MF2_MASK, VLUXSEG5EI8_V }, // 6602
  { PseudoVLUXSEG5EI8_V_M2_MF4, VLUXSEG5EI8_V }, // 6603
  { PseudoVLUXSEG5EI8_V_M2_MF4_MASK, VLUXSEG5EI8_V }, // 6604
  { PseudoVLUXSEG5EI8_V_M2_MF8, VLUXSEG5EI8_V }, // 6605
  { PseudoVLUXSEG5EI8_V_M2_MF8_MASK, VLUXSEG5EI8_V }, // 6606
  { PseudoVLUXSEG5EI8_V_M4_M1, VLUXSEG5EI8_V }, // 6607
  { PseudoVLUXSEG5EI8_V_M4_M1_MASK, VLUXSEG5EI8_V }, // 6608
  { PseudoVLUXSEG5EI8_V_M4_MF2, VLUXSEG5EI8_V }, // 6609
  { PseudoVLUXSEG5EI8_V_M4_MF2_MASK, VLUXSEG5EI8_V }, // 6610
  { PseudoVLUXSEG5EI8_V_M4_MF4, VLUXSEG5EI8_V }, // 6611
  { PseudoVLUXSEG5EI8_V_M4_MF4_MASK, VLUXSEG5EI8_V }, // 6612
  { PseudoVLUXSEG5EI8_V_M4_MF8, VLUXSEG5EI8_V }, // 6613
  { PseudoVLUXSEG5EI8_V_M4_MF8_MASK, VLUXSEG5EI8_V }, // 6614
  { PseudoVLUXSEG5EI8_V_M8_M1, VLUXSEG5EI8_V }, // 6615
  { PseudoVLUXSEG5EI8_V_M8_M1_MASK, VLUXSEG5EI8_V }, // 6616
  { PseudoVLUXSEG5EI8_V_M8_MF2, VLUXSEG5EI8_V }, // 6617
  { PseudoVLUXSEG5EI8_V_M8_MF2_MASK, VLUXSEG5EI8_V }, // 6618
  { PseudoVLUXSEG5EI8_V_M8_MF4, VLUXSEG5EI8_V }, // 6619
  { PseudoVLUXSEG5EI8_V_M8_MF4_MASK, VLUXSEG5EI8_V }, // 6620
  { PseudoVLUXSEG5EI8_V_M8_MF8, VLUXSEG5EI8_V }, // 6621
  { PseudoVLUXSEG5EI8_V_M8_MF8_MASK, VLUXSEG5EI8_V }, // 6622
  { PseudoVLUXSEG5EI8_V_MF2_M1, VLUXSEG5EI8_V }, // 6623
  { PseudoVLUXSEG5EI8_V_MF2_M1_MASK, VLUXSEG5EI8_V }, // 6624
  { PseudoVLUXSEG5EI8_V_MF2_MF2, VLUXSEG5EI8_V }, // 6625
  { PseudoVLUXSEG5EI8_V_MF2_MF2_MASK, VLUXSEG5EI8_V }, // 6626
  { PseudoVLUXSEG5EI8_V_MF2_MF4, VLUXSEG5EI8_V }, // 6627
  { PseudoVLUXSEG5EI8_V_MF2_MF4_MASK, VLUXSEG5EI8_V }, // 6628
  { PseudoVLUXSEG5EI8_V_MF2_MF8, VLUXSEG5EI8_V }, // 6629
  { PseudoVLUXSEG5EI8_V_MF2_MF8_MASK, VLUXSEG5EI8_V }, // 6630
  { PseudoVLUXSEG5EI8_V_MF4_M1, VLUXSEG5EI8_V }, // 6631
  { PseudoVLUXSEG5EI8_V_MF4_M1_MASK, VLUXSEG5EI8_V }, // 6632
  { PseudoVLUXSEG5EI8_V_MF4_MF2, VLUXSEG5EI8_V }, // 6633
  { PseudoVLUXSEG5EI8_V_MF4_MF2_MASK, VLUXSEG5EI8_V }, // 6634
  { PseudoVLUXSEG5EI8_V_MF4_MF4, VLUXSEG5EI8_V }, // 6635
  { PseudoVLUXSEG5EI8_V_MF4_MF4_MASK, VLUXSEG5EI8_V }, // 6636
  { PseudoVLUXSEG5EI8_V_MF4_MF8, VLUXSEG5EI8_V }, // 6637
  { PseudoVLUXSEG5EI8_V_MF4_MF8_MASK, VLUXSEG5EI8_V }, // 6638
  { PseudoVLUXSEG5EI8_V_MF8_M1, VLUXSEG5EI8_V }, // 6639
  { PseudoVLUXSEG5EI8_V_MF8_M1_MASK, VLUXSEG5EI8_V }, // 6640
  { PseudoVLUXSEG5EI8_V_MF8_MF2, VLUXSEG5EI8_V }, // 6641
  { PseudoVLUXSEG5EI8_V_MF8_MF2_MASK, VLUXSEG5EI8_V }, // 6642
  { PseudoVLUXSEG5EI8_V_MF8_MF4, VLUXSEG5EI8_V }, // 6643
  { PseudoVLUXSEG5EI8_V_MF8_MF4_MASK, VLUXSEG5EI8_V }, // 6644
  { PseudoVLUXSEG5EI8_V_MF8_MF8, VLUXSEG5EI8_V }, // 6645
  { PseudoVLUXSEG5EI8_V_MF8_MF8_MASK, VLUXSEG5EI8_V }, // 6646
  { PseudoVLUXSEG6EI16_V_M1_M1, VLUXSEG6EI16_V }, // 6647
  { PseudoVLUXSEG6EI16_V_M1_M1_MASK, VLUXSEG6EI16_V }, // 6648
  { PseudoVLUXSEG6EI16_V_M1_MF2, VLUXSEG6EI16_V }, // 6649
  { PseudoVLUXSEG6EI16_V_M1_MF2_MASK, VLUXSEG6EI16_V }, // 6650
  { PseudoVLUXSEG6EI16_V_M1_MF4, VLUXSEG6EI16_V }, // 6651
  { PseudoVLUXSEG6EI16_V_M1_MF4_MASK, VLUXSEG6EI16_V }, // 6652
  { PseudoVLUXSEG6EI16_V_M1_MF8, VLUXSEG6EI16_V }, // 6653
  { PseudoVLUXSEG6EI16_V_M1_MF8_MASK, VLUXSEG6EI16_V }, // 6654
  { PseudoVLUXSEG6EI16_V_M2_M1, VLUXSEG6EI16_V }, // 6655
  { PseudoVLUXSEG6EI16_V_M2_M1_MASK, VLUXSEG6EI16_V }, // 6656
  { PseudoVLUXSEG6EI16_V_M2_MF2, VLUXSEG6EI16_V }, // 6657
  { PseudoVLUXSEG6EI16_V_M2_MF2_MASK, VLUXSEG6EI16_V }, // 6658
  { PseudoVLUXSEG6EI16_V_M2_MF4, VLUXSEG6EI16_V }, // 6659
  { PseudoVLUXSEG6EI16_V_M2_MF4_MASK, VLUXSEG6EI16_V }, // 6660
  { PseudoVLUXSEG6EI16_V_M2_MF8, VLUXSEG6EI16_V }, // 6661
  { PseudoVLUXSEG6EI16_V_M2_MF8_MASK, VLUXSEG6EI16_V }, // 6662
  { PseudoVLUXSEG6EI16_V_M4_M1, VLUXSEG6EI16_V }, // 6663
  { PseudoVLUXSEG6EI16_V_M4_M1_MASK, VLUXSEG6EI16_V }, // 6664
  { PseudoVLUXSEG6EI16_V_M4_MF2, VLUXSEG6EI16_V }, // 6665
  { PseudoVLUXSEG6EI16_V_M4_MF2_MASK, VLUXSEG6EI16_V }, // 6666
  { PseudoVLUXSEG6EI16_V_M4_MF4, VLUXSEG6EI16_V }, // 6667
  { PseudoVLUXSEG6EI16_V_M4_MF4_MASK, VLUXSEG6EI16_V }, // 6668
  { PseudoVLUXSEG6EI16_V_M4_MF8, VLUXSEG6EI16_V }, // 6669
  { PseudoVLUXSEG6EI16_V_M4_MF8_MASK, VLUXSEG6EI16_V }, // 6670
  { PseudoVLUXSEG6EI16_V_M8_M1, VLUXSEG6EI16_V }, // 6671
  { PseudoVLUXSEG6EI16_V_M8_M1_MASK, VLUXSEG6EI16_V }, // 6672
  { PseudoVLUXSEG6EI16_V_M8_MF2, VLUXSEG6EI16_V }, // 6673
  { PseudoVLUXSEG6EI16_V_M8_MF2_MASK, VLUXSEG6EI16_V }, // 6674
  { PseudoVLUXSEG6EI16_V_M8_MF4, VLUXSEG6EI16_V }, // 6675
  { PseudoVLUXSEG6EI16_V_M8_MF4_MASK, VLUXSEG6EI16_V }, // 6676
  { PseudoVLUXSEG6EI16_V_M8_MF8, VLUXSEG6EI16_V }, // 6677
  { PseudoVLUXSEG6EI16_V_M8_MF8_MASK, VLUXSEG6EI16_V }, // 6678
  { PseudoVLUXSEG6EI16_V_MF2_M1, VLUXSEG6EI16_V }, // 6679
  { PseudoVLUXSEG6EI16_V_MF2_M1_MASK, VLUXSEG6EI16_V }, // 6680
  { PseudoVLUXSEG6EI16_V_MF2_MF2, VLUXSEG6EI16_V }, // 6681
  { PseudoVLUXSEG6EI16_V_MF2_MF2_MASK, VLUXSEG6EI16_V }, // 6682
  { PseudoVLUXSEG6EI16_V_MF2_MF4, VLUXSEG6EI16_V }, // 6683
  { PseudoVLUXSEG6EI16_V_MF2_MF4_MASK, VLUXSEG6EI16_V }, // 6684
  { PseudoVLUXSEG6EI16_V_MF2_MF8, VLUXSEG6EI16_V }, // 6685
  { PseudoVLUXSEG6EI16_V_MF2_MF8_MASK, VLUXSEG6EI16_V }, // 6686
  { PseudoVLUXSEG6EI16_V_MF4_M1, VLUXSEG6EI16_V }, // 6687
  { PseudoVLUXSEG6EI16_V_MF4_M1_MASK, VLUXSEG6EI16_V }, // 6688
  { PseudoVLUXSEG6EI16_V_MF4_MF2, VLUXSEG6EI16_V }, // 6689
  { PseudoVLUXSEG6EI16_V_MF4_MF2_MASK, VLUXSEG6EI16_V }, // 6690
  { PseudoVLUXSEG6EI16_V_MF4_MF4, VLUXSEG6EI16_V }, // 6691
  { PseudoVLUXSEG6EI16_V_MF4_MF4_MASK, VLUXSEG6EI16_V }, // 6692
  { PseudoVLUXSEG6EI16_V_MF4_MF8, VLUXSEG6EI16_V }, // 6693
  { PseudoVLUXSEG6EI16_V_MF4_MF8_MASK, VLUXSEG6EI16_V }, // 6694
  { PseudoVLUXSEG6EI32_V_M1_M1, VLUXSEG6EI32_V }, // 6695
  { PseudoVLUXSEG6EI32_V_M1_M1_MASK, VLUXSEG6EI32_V }, // 6696
  { PseudoVLUXSEG6EI32_V_M1_MF2, VLUXSEG6EI32_V }, // 6697
  { PseudoVLUXSEG6EI32_V_M1_MF2_MASK, VLUXSEG6EI32_V }, // 6698
  { PseudoVLUXSEG6EI32_V_M1_MF4, VLUXSEG6EI32_V }, // 6699
  { PseudoVLUXSEG6EI32_V_M1_MF4_MASK, VLUXSEG6EI32_V }, // 6700
  { PseudoVLUXSEG6EI32_V_M1_MF8, VLUXSEG6EI32_V }, // 6701
  { PseudoVLUXSEG6EI32_V_M1_MF8_MASK, VLUXSEG6EI32_V }, // 6702
  { PseudoVLUXSEG6EI32_V_M2_M1, VLUXSEG6EI32_V }, // 6703
  { PseudoVLUXSEG6EI32_V_M2_M1_MASK, VLUXSEG6EI32_V }, // 6704
  { PseudoVLUXSEG6EI32_V_M2_MF2, VLUXSEG6EI32_V }, // 6705
  { PseudoVLUXSEG6EI32_V_M2_MF2_MASK, VLUXSEG6EI32_V }, // 6706
  { PseudoVLUXSEG6EI32_V_M2_MF4, VLUXSEG6EI32_V }, // 6707
  { PseudoVLUXSEG6EI32_V_M2_MF4_MASK, VLUXSEG6EI32_V }, // 6708
  { PseudoVLUXSEG6EI32_V_M2_MF8, VLUXSEG6EI32_V }, // 6709
  { PseudoVLUXSEG6EI32_V_M2_MF8_MASK, VLUXSEG6EI32_V }, // 6710
  { PseudoVLUXSEG6EI32_V_M4_M1, VLUXSEG6EI32_V }, // 6711
  { PseudoVLUXSEG6EI32_V_M4_M1_MASK, VLUXSEG6EI32_V }, // 6712
  { PseudoVLUXSEG6EI32_V_M4_MF2, VLUXSEG6EI32_V }, // 6713
  { PseudoVLUXSEG6EI32_V_M4_MF2_MASK, VLUXSEG6EI32_V }, // 6714
  { PseudoVLUXSEG6EI32_V_M4_MF4, VLUXSEG6EI32_V }, // 6715
  { PseudoVLUXSEG6EI32_V_M4_MF4_MASK, VLUXSEG6EI32_V }, // 6716
  { PseudoVLUXSEG6EI32_V_M4_MF8, VLUXSEG6EI32_V }, // 6717
  { PseudoVLUXSEG6EI32_V_M4_MF8_MASK, VLUXSEG6EI32_V }, // 6718
  { PseudoVLUXSEG6EI32_V_M8_M1, VLUXSEG6EI32_V }, // 6719
  { PseudoVLUXSEG6EI32_V_M8_M1_MASK, VLUXSEG6EI32_V }, // 6720
  { PseudoVLUXSEG6EI32_V_M8_MF2, VLUXSEG6EI32_V }, // 6721
  { PseudoVLUXSEG6EI32_V_M8_MF2_MASK, VLUXSEG6EI32_V }, // 6722
  { PseudoVLUXSEG6EI32_V_M8_MF4, VLUXSEG6EI32_V }, // 6723
  { PseudoVLUXSEG6EI32_V_M8_MF4_MASK, VLUXSEG6EI32_V }, // 6724
  { PseudoVLUXSEG6EI32_V_M8_MF8, VLUXSEG6EI32_V }, // 6725
  { PseudoVLUXSEG6EI32_V_M8_MF8_MASK, VLUXSEG6EI32_V }, // 6726
  { PseudoVLUXSEG6EI32_V_MF2_M1, VLUXSEG6EI32_V }, // 6727
  { PseudoVLUXSEG6EI32_V_MF2_M1_MASK, VLUXSEG6EI32_V }, // 6728
  { PseudoVLUXSEG6EI32_V_MF2_MF2, VLUXSEG6EI32_V }, // 6729
  { PseudoVLUXSEG6EI32_V_MF2_MF2_MASK, VLUXSEG6EI32_V }, // 6730
  { PseudoVLUXSEG6EI32_V_MF2_MF4, VLUXSEG6EI32_V }, // 6731
  { PseudoVLUXSEG6EI32_V_MF2_MF4_MASK, VLUXSEG6EI32_V }, // 6732
  { PseudoVLUXSEG6EI32_V_MF2_MF8, VLUXSEG6EI32_V }, // 6733
  { PseudoVLUXSEG6EI32_V_MF2_MF8_MASK, VLUXSEG6EI32_V }, // 6734
  { PseudoVLUXSEG6EI64_V_M1_M1, VLUXSEG6EI64_V }, // 6735
  { PseudoVLUXSEG6EI64_V_M1_M1_MASK, VLUXSEG6EI64_V }, // 6736
  { PseudoVLUXSEG6EI64_V_M1_MF2, VLUXSEG6EI64_V }, // 6737
  { PseudoVLUXSEG6EI64_V_M1_MF2_MASK, VLUXSEG6EI64_V }, // 6738
  { PseudoVLUXSEG6EI64_V_M1_MF4, VLUXSEG6EI64_V }, // 6739
  { PseudoVLUXSEG6EI64_V_M1_MF4_MASK, VLUXSEG6EI64_V }, // 6740
  { PseudoVLUXSEG6EI64_V_M1_MF8, VLUXSEG6EI64_V }, // 6741
  { PseudoVLUXSEG6EI64_V_M1_MF8_MASK, VLUXSEG6EI64_V }, // 6742
  { PseudoVLUXSEG6EI64_V_M2_M1, VLUXSEG6EI64_V }, // 6743
  { PseudoVLUXSEG6EI64_V_M2_M1_MASK, VLUXSEG6EI64_V }, // 6744
  { PseudoVLUXSEG6EI64_V_M2_MF2, VLUXSEG6EI64_V }, // 6745
  { PseudoVLUXSEG6EI64_V_M2_MF2_MASK, VLUXSEG6EI64_V }, // 6746
  { PseudoVLUXSEG6EI64_V_M2_MF4, VLUXSEG6EI64_V }, // 6747
  { PseudoVLUXSEG6EI64_V_M2_MF4_MASK, VLUXSEG6EI64_V }, // 6748
  { PseudoVLUXSEG6EI64_V_M2_MF8, VLUXSEG6EI64_V }, // 6749
  { PseudoVLUXSEG6EI64_V_M2_MF8_MASK, VLUXSEG6EI64_V }, // 6750
  { PseudoVLUXSEG6EI64_V_M4_M1, VLUXSEG6EI64_V }, // 6751
  { PseudoVLUXSEG6EI64_V_M4_M1_MASK, VLUXSEG6EI64_V }, // 6752
  { PseudoVLUXSEG6EI64_V_M4_MF2, VLUXSEG6EI64_V }, // 6753
  { PseudoVLUXSEG6EI64_V_M4_MF2_MASK, VLUXSEG6EI64_V }, // 6754
  { PseudoVLUXSEG6EI64_V_M4_MF4, VLUXSEG6EI64_V }, // 6755
  { PseudoVLUXSEG6EI64_V_M4_MF4_MASK, VLUXSEG6EI64_V }, // 6756
  { PseudoVLUXSEG6EI64_V_M4_MF8, VLUXSEG6EI64_V }, // 6757
  { PseudoVLUXSEG6EI64_V_M4_MF8_MASK, VLUXSEG6EI64_V }, // 6758
  { PseudoVLUXSEG6EI64_V_M8_M1, VLUXSEG6EI64_V }, // 6759
  { PseudoVLUXSEG6EI64_V_M8_M1_MASK, VLUXSEG6EI64_V }, // 6760
  { PseudoVLUXSEG6EI64_V_M8_MF2, VLUXSEG6EI64_V }, // 6761
  { PseudoVLUXSEG6EI64_V_M8_MF2_MASK, VLUXSEG6EI64_V }, // 6762
  { PseudoVLUXSEG6EI64_V_M8_MF4, VLUXSEG6EI64_V }, // 6763
  { PseudoVLUXSEG6EI64_V_M8_MF4_MASK, VLUXSEG6EI64_V }, // 6764
  { PseudoVLUXSEG6EI64_V_M8_MF8, VLUXSEG6EI64_V }, // 6765
  { PseudoVLUXSEG6EI64_V_M8_MF8_MASK, VLUXSEG6EI64_V }, // 6766
  { PseudoVLUXSEG6EI8_V_M1_M1, VLUXSEG6EI8_V }, // 6767
  { PseudoVLUXSEG6EI8_V_M1_M1_MASK, VLUXSEG6EI8_V }, // 6768
  { PseudoVLUXSEG6EI8_V_M1_MF2, VLUXSEG6EI8_V }, // 6769
  { PseudoVLUXSEG6EI8_V_M1_MF2_MASK, VLUXSEG6EI8_V }, // 6770
  { PseudoVLUXSEG6EI8_V_M1_MF4, VLUXSEG6EI8_V }, // 6771
  { PseudoVLUXSEG6EI8_V_M1_MF4_MASK, VLUXSEG6EI8_V }, // 6772
  { PseudoVLUXSEG6EI8_V_M1_MF8, VLUXSEG6EI8_V }, // 6773
  { PseudoVLUXSEG6EI8_V_M1_MF8_MASK, VLUXSEG6EI8_V }, // 6774
  { PseudoVLUXSEG6EI8_V_M2_M1, VLUXSEG6EI8_V }, // 6775
  { PseudoVLUXSEG6EI8_V_M2_M1_MASK, VLUXSEG6EI8_V }, // 6776
  { PseudoVLUXSEG6EI8_V_M2_MF2, VLUXSEG6EI8_V }, // 6777
  { PseudoVLUXSEG6EI8_V_M2_MF2_MASK, VLUXSEG6EI8_V }, // 6778
  { PseudoVLUXSEG6EI8_V_M2_MF4, VLUXSEG6EI8_V }, // 6779
  { PseudoVLUXSEG6EI8_V_M2_MF4_MASK, VLUXSEG6EI8_V }, // 6780
  { PseudoVLUXSEG6EI8_V_M2_MF8, VLUXSEG6EI8_V }, // 6781
  { PseudoVLUXSEG6EI8_V_M2_MF8_MASK, VLUXSEG6EI8_V }, // 6782
  { PseudoVLUXSEG6EI8_V_M4_M1, VLUXSEG6EI8_V }, // 6783
  { PseudoVLUXSEG6EI8_V_M4_M1_MASK, VLUXSEG6EI8_V }, // 6784
  { PseudoVLUXSEG6EI8_V_M4_MF2, VLUXSEG6EI8_V }, // 6785
  { PseudoVLUXSEG6EI8_V_M4_MF2_MASK, VLUXSEG6EI8_V }, // 6786
  { PseudoVLUXSEG6EI8_V_M4_MF4, VLUXSEG6EI8_V }, // 6787
  { PseudoVLUXSEG6EI8_V_M4_MF4_MASK, VLUXSEG6EI8_V }, // 6788
  { PseudoVLUXSEG6EI8_V_M4_MF8, VLUXSEG6EI8_V }, // 6789
  { PseudoVLUXSEG6EI8_V_M4_MF8_MASK, VLUXSEG6EI8_V }, // 6790
  { PseudoVLUXSEG6EI8_V_M8_M1, VLUXSEG6EI8_V }, // 6791
  { PseudoVLUXSEG6EI8_V_M8_M1_MASK, VLUXSEG6EI8_V }, // 6792
  { PseudoVLUXSEG6EI8_V_M8_MF2, VLUXSEG6EI8_V }, // 6793
  { PseudoVLUXSEG6EI8_V_M8_MF2_MASK, VLUXSEG6EI8_V }, // 6794
  { PseudoVLUXSEG6EI8_V_M8_MF4, VLUXSEG6EI8_V }, // 6795
  { PseudoVLUXSEG6EI8_V_M8_MF4_MASK, VLUXSEG6EI8_V }, // 6796
  { PseudoVLUXSEG6EI8_V_M8_MF8, VLUXSEG6EI8_V }, // 6797
  { PseudoVLUXSEG6EI8_V_M8_MF8_MASK, VLUXSEG6EI8_V }, // 6798
  { PseudoVLUXSEG6EI8_V_MF2_M1, VLUXSEG6EI8_V }, // 6799
  { PseudoVLUXSEG6EI8_V_MF2_M1_MASK, VLUXSEG6EI8_V }, // 6800
  { PseudoVLUXSEG6EI8_V_MF2_MF2, VLUXSEG6EI8_V }, // 6801
  { PseudoVLUXSEG6EI8_V_MF2_MF2_MASK, VLUXSEG6EI8_V }, // 6802
  { PseudoVLUXSEG6EI8_V_MF2_MF4, VLUXSEG6EI8_V }, // 6803
  { PseudoVLUXSEG6EI8_V_MF2_MF4_MASK, VLUXSEG6EI8_V }, // 6804
  { PseudoVLUXSEG6EI8_V_MF2_MF8, VLUXSEG6EI8_V }, // 6805
  { PseudoVLUXSEG6EI8_V_MF2_MF8_MASK, VLUXSEG6EI8_V }, // 6806
  { PseudoVLUXSEG6EI8_V_MF4_M1, VLUXSEG6EI8_V }, // 6807
  { PseudoVLUXSEG6EI8_V_MF4_M1_MASK, VLUXSEG6EI8_V }, // 6808
  { PseudoVLUXSEG6EI8_V_MF4_MF2, VLUXSEG6EI8_V }, // 6809
  { PseudoVLUXSEG6EI8_V_MF4_MF2_MASK, VLUXSEG6EI8_V }, // 6810
  { PseudoVLUXSEG6EI8_V_MF4_MF4, VLUXSEG6EI8_V }, // 6811
  { PseudoVLUXSEG6EI8_V_MF4_MF4_MASK, VLUXSEG6EI8_V }, // 6812
  { PseudoVLUXSEG6EI8_V_MF4_MF8, VLUXSEG6EI8_V }, // 6813
  { PseudoVLUXSEG6EI8_V_MF4_MF8_MASK, VLUXSEG6EI8_V }, // 6814
  { PseudoVLUXSEG6EI8_V_MF8_M1, VLUXSEG6EI8_V }, // 6815
  { PseudoVLUXSEG6EI8_V_MF8_M1_MASK, VLUXSEG6EI8_V }, // 6816
  { PseudoVLUXSEG6EI8_V_MF8_MF2, VLUXSEG6EI8_V }, // 6817
  { PseudoVLUXSEG6EI8_V_MF8_MF2_MASK, VLUXSEG6EI8_V }, // 6818
  { PseudoVLUXSEG6EI8_V_MF8_MF4, VLUXSEG6EI8_V }, // 6819
  { PseudoVLUXSEG6EI8_V_MF8_MF4_MASK, VLUXSEG6EI8_V }, // 6820
  { PseudoVLUXSEG6EI8_V_MF8_MF8, VLUXSEG6EI8_V }, // 6821
  { PseudoVLUXSEG6EI8_V_MF8_MF8_MASK, VLUXSEG6EI8_V }, // 6822
  { PseudoVLUXSEG7EI16_V_M1_M1, VLUXSEG7EI16_V }, // 6823
  { PseudoVLUXSEG7EI16_V_M1_M1_MASK, VLUXSEG7EI16_V }, // 6824
  { PseudoVLUXSEG7EI16_V_M1_MF2, VLUXSEG7EI16_V }, // 6825
  { PseudoVLUXSEG7EI16_V_M1_MF2_MASK, VLUXSEG7EI16_V }, // 6826
  { PseudoVLUXSEG7EI16_V_M1_MF4, VLUXSEG7EI16_V }, // 6827
  { PseudoVLUXSEG7EI16_V_M1_MF4_MASK, VLUXSEG7EI16_V }, // 6828
  { PseudoVLUXSEG7EI16_V_M1_MF8, VLUXSEG7EI16_V }, // 6829
  { PseudoVLUXSEG7EI16_V_M1_MF8_MASK, VLUXSEG7EI16_V }, // 6830
  { PseudoVLUXSEG7EI16_V_M2_M1, VLUXSEG7EI16_V }, // 6831
  { PseudoVLUXSEG7EI16_V_M2_M1_MASK, VLUXSEG7EI16_V }, // 6832
  { PseudoVLUXSEG7EI16_V_M2_MF2, VLUXSEG7EI16_V }, // 6833
  { PseudoVLUXSEG7EI16_V_M2_MF2_MASK, VLUXSEG7EI16_V }, // 6834
  { PseudoVLUXSEG7EI16_V_M2_MF4, VLUXSEG7EI16_V }, // 6835
  { PseudoVLUXSEG7EI16_V_M2_MF4_MASK, VLUXSEG7EI16_V }, // 6836
  { PseudoVLUXSEG7EI16_V_M2_MF8, VLUXSEG7EI16_V }, // 6837
  { PseudoVLUXSEG7EI16_V_M2_MF8_MASK, VLUXSEG7EI16_V }, // 6838
  { PseudoVLUXSEG7EI16_V_M4_M1, VLUXSEG7EI16_V }, // 6839
  { PseudoVLUXSEG7EI16_V_M4_M1_MASK, VLUXSEG7EI16_V }, // 6840
  { PseudoVLUXSEG7EI16_V_M4_MF2, VLUXSEG7EI16_V }, // 6841
  { PseudoVLUXSEG7EI16_V_M4_MF2_MASK, VLUXSEG7EI16_V }, // 6842
  { PseudoVLUXSEG7EI16_V_M4_MF4, VLUXSEG7EI16_V }, // 6843
  { PseudoVLUXSEG7EI16_V_M4_MF4_MASK, VLUXSEG7EI16_V }, // 6844
  { PseudoVLUXSEG7EI16_V_M4_MF8, VLUXSEG7EI16_V }, // 6845
  { PseudoVLUXSEG7EI16_V_M4_MF8_MASK, VLUXSEG7EI16_V }, // 6846
  { PseudoVLUXSEG7EI16_V_M8_M1, VLUXSEG7EI16_V }, // 6847
  { PseudoVLUXSEG7EI16_V_M8_M1_MASK, VLUXSEG7EI16_V }, // 6848
  { PseudoVLUXSEG7EI16_V_M8_MF2, VLUXSEG7EI16_V }, // 6849
  { PseudoVLUXSEG7EI16_V_M8_MF2_MASK, VLUXSEG7EI16_V }, // 6850
  { PseudoVLUXSEG7EI16_V_M8_MF4, VLUXSEG7EI16_V }, // 6851
  { PseudoVLUXSEG7EI16_V_M8_MF4_MASK, VLUXSEG7EI16_V }, // 6852
  { PseudoVLUXSEG7EI16_V_M8_MF8, VLUXSEG7EI16_V }, // 6853
  { PseudoVLUXSEG7EI16_V_M8_MF8_MASK, VLUXSEG7EI16_V }, // 6854
  { PseudoVLUXSEG7EI16_V_MF2_M1, VLUXSEG7EI16_V }, // 6855
  { PseudoVLUXSEG7EI16_V_MF2_M1_MASK, VLUXSEG7EI16_V }, // 6856
  { PseudoVLUXSEG7EI16_V_MF2_MF2, VLUXSEG7EI16_V }, // 6857
  { PseudoVLUXSEG7EI16_V_MF2_MF2_MASK, VLUXSEG7EI16_V }, // 6858
  { PseudoVLUXSEG7EI16_V_MF2_MF4, VLUXSEG7EI16_V }, // 6859
  { PseudoVLUXSEG7EI16_V_MF2_MF4_MASK, VLUXSEG7EI16_V }, // 6860
  { PseudoVLUXSEG7EI16_V_MF2_MF8, VLUXSEG7EI16_V }, // 6861
  { PseudoVLUXSEG7EI16_V_MF2_MF8_MASK, VLUXSEG7EI16_V }, // 6862
  { PseudoVLUXSEG7EI16_V_MF4_M1, VLUXSEG7EI16_V }, // 6863
  { PseudoVLUXSEG7EI16_V_MF4_M1_MASK, VLUXSEG7EI16_V }, // 6864
  { PseudoVLUXSEG7EI16_V_MF4_MF2, VLUXSEG7EI16_V }, // 6865
  { PseudoVLUXSEG7EI16_V_MF4_MF2_MASK, VLUXSEG7EI16_V }, // 6866
  { PseudoVLUXSEG7EI16_V_MF4_MF4, VLUXSEG7EI16_V }, // 6867
  { PseudoVLUXSEG7EI16_V_MF4_MF4_MASK, VLUXSEG7EI16_V }, // 6868
  { PseudoVLUXSEG7EI16_V_MF4_MF8, VLUXSEG7EI16_V }, // 6869
  { PseudoVLUXSEG7EI16_V_MF4_MF8_MASK, VLUXSEG7EI16_V }, // 6870
  { PseudoVLUXSEG7EI32_V_M1_M1, VLUXSEG7EI32_V }, // 6871
  { PseudoVLUXSEG7EI32_V_M1_M1_MASK, VLUXSEG7EI32_V }, // 6872
  { PseudoVLUXSEG7EI32_V_M1_MF2, VLUXSEG7EI32_V }, // 6873
  { PseudoVLUXSEG7EI32_V_M1_MF2_MASK, VLUXSEG7EI32_V }, // 6874
  { PseudoVLUXSEG7EI32_V_M1_MF4, VLUXSEG7EI32_V }, // 6875
  { PseudoVLUXSEG7EI32_V_M1_MF4_MASK, VLUXSEG7EI32_V }, // 6876
  { PseudoVLUXSEG7EI32_V_M1_MF8, VLUXSEG7EI32_V }, // 6877
  { PseudoVLUXSEG7EI32_V_M1_MF8_MASK, VLUXSEG7EI32_V }, // 6878
  { PseudoVLUXSEG7EI32_V_M2_M1, VLUXSEG7EI32_V }, // 6879
  { PseudoVLUXSEG7EI32_V_M2_M1_MASK, VLUXSEG7EI32_V }, // 6880
  { PseudoVLUXSEG7EI32_V_M2_MF2, VLUXSEG7EI32_V }, // 6881
  { PseudoVLUXSEG7EI32_V_M2_MF2_MASK, VLUXSEG7EI32_V }, // 6882
  { PseudoVLUXSEG7EI32_V_M2_MF4, VLUXSEG7EI32_V }, // 6883
  { PseudoVLUXSEG7EI32_V_M2_MF4_MASK, VLUXSEG7EI32_V }, // 6884
  { PseudoVLUXSEG7EI32_V_M2_MF8, VLUXSEG7EI32_V }, // 6885
  { PseudoVLUXSEG7EI32_V_M2_MF8_MASK, VLUXSEG7EI32_V }, // 6886
  { PseudoVLUXSEG7EI32_V_M4_M1, VLUXSEG7EI32_V }, // 6887
  { PseudoVLUXSEG7EI32_V_M4_M1_MASK, VLUXSEG7EI32_V }, // 6888
  { PseudoVLUXSEG7EI32_V_M4_MF2, VLUXSEG7EI32_V }, // 6889
  { PseudoVLUXSEG7EI32_V_M4_MF2_MASK, VLUXSEG7EI32_V }, // 6890
  { PseudoVLUXSEG7EI32_V_M4_MF4, VLUXSEG7EI32_V }, // 6891
  { PseudoVLUXSEG7EI32_V_M4_MF4_MASK, VLUXSEG7EI32_V }, // 6892
  { PseudoVLUXSEG7EI32_V_M4_MF8, VLUXSEG7EI32_V }, // 6893
  { PseudoVLUXSEG7EI32_V_M4_MF8_MASK, VLUXSEG7EI32_V }, // 6894
  { PseudoVLUXSEG7EI32_V_M8_M1, VLUXSEG7EI32_V }, // 6895
  { PseudoVLUXSEG7EI32_V_M8_M1_MASK, VLUXSEG7EI32_V }, // 6896
  { PseudoVLUXSEG7EI32_V_M8_MF2, VLUXSEG7EI32_V }, // 6897
  { PseudoVLUXSEG7EI32_V_M8_MF2_MASK, VLUXSEG7EI32_V }, // 6898
  { PseudoVLUXSEG7EI32_V_M8_MF4, VLUXSEG7EI32_V }, // 6899
  { PseudoVLUXSEG7EI32_V_M8_MF4_MASK, VLUXSEG7EI32_V }, // 6900
  { PseudoVLUXSEG7EI32_V_M8_MF8, VLUXSEG7EI32_V }, // 6901
  { PseudoVLUXSEG7EI32_V_M8_MF8_MASK, VLUXSEG7EI32_V }, // 6902
  { PseudoVLUXSEG7EI32_V_MF2_M1, VLUXSEG7EI32_V }, // 6903
  { PseudoVLUXSEG7EI32_V_MF2_M1_MASK, VLUXSEG7EI32_V }, // 6904
  { PseudoVLUXSEG7EI32_V_MF2_MF2, VLUXSEG7EI32_V }, // 6905
  { PseudoVLUXSEG7EI32_V_MF2_MF2_MASK, VLUXSEG7EI32_V }, // 6906
  { PseudoVLUXSEG7EI32_V_MF2_MF4, VLUXSEG7EI32_V }, // 6907
  { PseudoVLUXSEG7EI32_V_MF2_MF4_MASK, VLUXSEG7EI32_V }, // 6908
  { PseudoVLUXSEG7EI32_V_MF2_MF8, VLUXSEG7EI32_V }, // 6909
  { PseudoVLUXSEG7EI32_V_MF2_MF8_MASK, VLUXSEG7EI32_V }, // 6910
  { PseudoVLUXSEG7EI64_V_M1_M1, VLUXSEG7EI64_V }, // 6911
  { PseudoVLUXSEG7EI64_V_M1_M1_MASK, VLUXSEG7EI64_V }, // 6912
  { PseudoVLUXSEG7EI64_V_M1_MF2, VLUXSEG7EI64_V }, // 6913
  { PseudoVLUXSEG7EI64_V_M1_MF2_MASK, VLUXSEG7EI64_V }, // 6914
  { PseudoVLUXSEG7EI64_V_M1_MF4, VLUXSEG7EI64_V }, // 6915
  { PseudoVLUXSEG7EI64_V_M1_MF4_MASK, VLUXSEG7EI64_V }, // 6916
  { PseudoVLUXSEG7EI64_V_M1_MF8, VLUXSEG7EI64_V }, // 6917
  { PseudoVLUXSEG7EI64_V_M1_MF8_MASK, VLUXSEG7EI64_V }, // 6918
  { PseudoVLUXSEG7EI64_V_M2_M1, VLUXSEG7EI64_V }, // 6919
  { PseudoVLUXSEG7EI64_V_M2_M1_MASK, VLUXSEG7EI64_V }, // 6920
  { PseudoVLUXSEG7EI64_V_M2_MF2, VLUXSEG7EI64_V }, // 6921
  { PseudoVLUXSEG7EI64_V_M2_MF2_MASK, VLUXSEG7EI64_V }, // 6922
  { PseudoVLUXSEG7EI64_V_M2_MF4, VLUXSEG7EI64_V }, // 6923
  { PseudoVLUXSEG7EI64_V_M2_MF4_MASK, VLUXSEG7EI64_V }, // 6924
  { PseudoVLUXSEG7EI64_V_M2_MF8, VLUXSEG7EI64_V }, // 6925
  { PseudoVLUXSEG7EI64_V_M2_MF8_MASK, VLUXSEG7EI64_V }, // 6926
  { PseudoVLUXSEG7EI64_V_M4_M1, VLUXSEG7EI64_V }, // 6927
  { PseudoVLUXSEG7EI64_V_M4_M1_MASK, VLUXSEG7EI64_V }, // 6928
  { PseudoVLUXSEG7EI64_V_M4_MF2, VLUXSEG7EI64_V }, // 6929
  { PseudoVLUXSEG7EI64_V_M4_MF2_MASK, VLUXSEG7EI64_V }, // 6930
  { PseudoVLUXSEG7EI64_V_M4_MF4, VLUXSEG7EI64_V }, // 6931
  { PseudoVLUXSEG7EI64_V_M4_MF4_MASK, VLUXSEG7EI64_V }, // 6932
  { PseudoVLUXSEG7EI64_V_M4_MF8, VLUXSEG7EI64_V }, // 6933
  { PseudoVLUXSEG7EI64_V_M4_MF8_MASK, VLUXSEG7EI64_V }, // 6934
  { PseudoVLUXSEG7EI64_V_M8_M1, VLUXSEG7EI64_V }, // 6935
  { PseudoVLUXSEG7EI64_V_M8_M1_MASK, VLUXSEG7EI64_V }, // 6936
  { PseudoVLUXSEG7EI64_V_M8_MF2, VLUXSEG7EI64_V }, // 6937
  { PseudoVLUXSEG7EI64_V_M8_MF2_MASK, VLUXSEG7EI64_V }, // 6938
  { PseudoVLUXSEG7EI64_V_M8_MF4, VLUXSEG7EI64_V }, // 6939
  { PseudoVLUXSEG7EI64_V_M8_MF4_MASK, VLUXSEG7EI64_V }, // 6940
  { PseudoVLUXSEG7EI64_V_M8_MF8, VLUXSEG7EI64_V }, // 6941
  { PseudoVLUXSEG7EI64_V_M8_MF8_MASK, VLUXSEG7EI64_V }, // 6942
  { PseudoVLUXSEG7EI8_V_M1_M1, VLUXSEG7EI8_V }, // 6943
  { PseudoVLUXSEG7EI8_V_M1_M1_MASK, VLUXSEG7EI8_V }, // 6944
  { PseudoVLUXSEG7EI8_V_M1_MF2, VLUXSEG7EI8_V }, // 6945
  { PseudoVLUXSEG7EI8_V_M1_MF2_MASK, VLUXSEG7EI8_V }, // 6946
  { PseudoVLUXSEG7EI8_V_M1_MF4, VLUXSEG7EI8_V }, // 6947
  { PseudoVLUXSEG7EI8_V_M1_MF4_MASK, VLUXSEG7EI8_V }, // 6948
  { PseudoVLUXSEG7EI8_V_M1_MF8, VLUXSEG7EI8_V }, // 6949
  { PseudoVLUXSEG7EI8_V_M1_MF8_MASK, VLUXSEG7EI8_V }, // 6950
  { PseudoVLUXSEG7EI8_V_M2_M1, VLUXSEG7EI8_V }, // 6951
  { PseudoVLUXSEG7EI8_V_M2_M1_MASK, VLUXSEG7EI8_V }, // 6952
  { PseudoVLUXSEG7EI8_V_M2_MF2, VLUXSEG7EI8_V }, // 6953
  { PseudoVLUXSEG7EI8_V_M2_MF2_MASK, VLUXSEG7EI8_V }, // 6954
  { PseudoVLUXSEG7EI8_V_M2_MF4, VLUXSEG7EI8_V }, // 6955
  { PseudoVLUXSEG7EI8_V_M2_MF4_MASK, VLUXSEG7EI8_V }, // 6956
  { PseudoVLUXSEG7EI8_V_M2_MF8, VLUXSEG7EI8_V }, // 6957
  { PseudoVLUXSEG7EI8_V_M2_MF8_MASK, VLUXSEG7EI8_V }, // 6958
  { PseudoVLUXSEG7EI8_V_M4_M1, VLUXSEG7EI8_V }, // 6959
  { PseudoVLUXSEG7EI8_V_M4_M1_MASK, VLUXSEG7EI8_V }, // 6960
  { PseudoVLUXSEG7EI8_V_M4_MF2, VLUXSEG7EI8_V }, // 6961
  { PseudoVLUXSEG7EI8_V_M4_MF2_MASK, VLUXSEG7EI8_V }, // 6962
  { PseudoVLUXSEG7EI8_V_M4_MF4, VLUXSEG7EI8_V }, // 6963
  { PseudoVLUXSEG7EI8_V_M4_MF4_MASK, VLUXSEG7EI8_V }, // 6964
  { PseudoVLUXSEG7EI8_V_M4_MF8, VLUXSEG7EI8_V }, // 6965
  { PseudoVLUXSEG7EI8_V_M4_MF8_MASK, VLUXSEG7EI8_V }, // 6966
  { PseudoVLUXSEG7EI8_V_M8_M1, VLUXSEG7EI8_V }, // 6967
  { PseudoVLUXSEG7EI8_V_M8_M1_MASK, VLUXSEG7EI8_V }, // 6968
  { PseudoVLUXSEG7EI8_V_M8_MF2, VLUXSEG7EI8_V }, // 6969
  { PseudoVLUXSEG7EI8_V_M8_MF2_MASK, VLUXSEG7EI8_V }, // 6970
  { PseudoVLUXSEG7EI8_V_M8_MF4, VLUXSEG7EI8_V }, // 6971
  { PseudoVLUXSEG7EI8_V_M8_MF4_MASK, VLUXSEG7EI8_V }, // 6972
  { PseudoVLUXSEG7EI8_V_M8_MF8, VLUXSEG7EI8_V }, // 6973
  { PseudoVLUXSEG7EI8_V_M8_MF8_MASK, VLUXSEG7EI8_V }, // 6974
  { PseudoVLUXSEG7EI8_V_MF2_M1, VLUXSEG7EI8_V }, // 6975
  { PseudoVLUXSEG7EI8_V_MF2_M1_MASK, VLUXSEG7EI8_V }, // 6976
  { PseudoVLUXSEG7EI8_V_MF2_MF2, VLUXSEG7EI8_V }, // 6977
  { PseudoVLUXSEG7EI8_V_MF2_MF2_MASK, VLUXSEG7EI8_V }, // 6978
  { PseudoVLUXSEG7EI8_V_MF2_MF4, VLUXSEG7EI8_V }, // 6979
  { PseudoVLUXSEG7EI8_V_MF2_MF4_MASK, VLUXSEG7EI8_V }, // 6980
  { PseudoVLUXSEG7EI8_V_MF2_MF8, VLUXSEG7EI8_V }, // 6981
  { PseudoVLUXSEG7EI8_V_MF2_MF8_MASK, VLUXSEG7EI8_V }, // 6982
  { PseudoVLUXSEG7EI8_V_MF4_M1, VLUXSEG7EI8_V }, // 6983
  { PseudoVLUXSEG7EI8_V_MF4_M1_MASK, VLUXSEG7EI8_V }, // 6984
  { PseudoVLUXSEG7EI8_V_MF4_MF2, VLUXSEG7EI8_V }, // 6985
  { PseudoVLUXSEG7EI8_V_MF4_MF2_MASK, VLUXSEG7EI8_V }, // 6986
  { PseudoVLUXSEG7EI8_V_MF4_MF4, VLUXSEG7EI8_V }, // 6987
  { PseudoVLUXSEG7EI8_V_MF4_MF4_MASK, VLUXSEG7EI8_V }, // 6988
  { PseudoVLUXSEG7EI8_V_MF4_MF8, VLUXSEG7EI8_V }, // 6989
  { PseudoVLUXSEG7EI8_V_MF4_MF8_MASK, VLUXSEG7EI8_V }, // 6990
  { PseudoVLUXSEG7EI8_V_MF8_M1, VLUXSEG7EI8_V }, // 6991
  { PseudoVLUXSEG7EI8_V_MF8_M1_MASK, VLUXSEG7EI8_V }, // 6992
  { PseudoVLUXSEG7EI8_V_MF8_MF2, VLUXSEG7EI8_V }, // 6993
  { PseudoVLUXSEG7EI8_V_MF8_MF2_MASK, VLUXSEG7EI8_V }, // 6994
  { PseudoVLUXSEG7EI8_V_MF8_MF4, VLUXSEG7EI8_V }, // 6995
  { PseudoVLUXSEG7EI8_V_MF8_MF4_MASK, VLUXSEG7EI8_V }, // 6996
  { PseudoVLUXSEG7EI8_V_MF8_MF8, VLUXSEG7EI8_V }, // 6997
  { PseudoVLUXSEG7EI8_V_MF8_MF8_MASK, VLUXSEG7EI8_V }, // 6998
  { PseudoVLUXSEG8EI16_V_M1_M1, VLUXSEG8EI16_V }, // 6999
  { PseudoVLUXSEG8EI16_V_M1_M1_MASK, VLUXSEG8EI16_V }, // 7000
  { PseudoVLUXSEG8EI16_V_M1_MF2, VLUXSEG8EI16_V }, // 7001
  { PseudoVLUXSEG8EI16_V_M1_MF2_MASK, VLUXSEG8EI16_V }, // 7002
  { PseudoVLUXSEG8EI16_V_M1_MF4, VLUXSEG8EI16_V }, // 7003
  { PseudoVLUXSEG8EI16_V_M1_MF4_MASK, VLUXSEG8EI16_V }, // 7004
  { PseudoVLUXSEG8EI16_V_M1_MF8, VLUXSEG8EI16_V }, // 7005
  { PseudoVLUXSEG8EI16_V_M1_MF8_MASK, VLUXSEG8EI16_V }, // 7006
  { PseudoVLUXSEG8EI16_V_M2_M1, VLUXSEG8EI16_V }, // 7007
  { PseudoVLUXSEG8EI16_V_M2_M1_MASK, VLUXSEG8EI16_V }, // 7008
  { PseudoVLUXSEG8EI16_V_M2_MF2, VLUXSEG8EI16_V }, // 7009
  { PseudoVLUXSEG8EI16_V_M2_MF2_MASK, VLUXSEG8EI16_V }, // 7010
  { PseudoVLUXSEG8EI16_V_M2_MF4, VLUXSEG8EI16_V }, // 7011
  { PseudoVLUXSEG8EI16_V_M2_MF4_MASK, VLUXSEG8EI16_V }, // 7012
  { PseudoVLUXSEG8EI16_V_M2_MF8, VLUXSEG8EI16_V }, // 7013
  { PseudoVLUXSEG8EI16_V_M2_MF8_MASK, VLUXSEG8EI16_V }, // 7014
  { PseudoVLUXSEG8EI16_V_M4_M1, VLUXSEG8EI16_V }, // 7015
  { PseudoVLUXSEG8EI16_V_M4_M1_MASK, VLUXSEG8EI16_V }, // 7016
  { PseudoVLUXSEG8EI16_V_M4_MF2, VLUXSEG8EI16_V }, // 7017
  { PseudoVLUXSEG8EI16_V_M4_MF2_MASK, VLUXSEG8EI16_V }, // 7018
  { PseudoVLUXSEG8EI16_V_M4_MF4, VLUXSEG8EI16_V }, // 7019
  { PseudoVLUXSEG8EI16_V_M4_MF4_MASK, VLUXSEG8EI16_V }, // 7020
  { PseudoVLUXSEG8EI16_V_M4_MF8, VLUXSEG8EI16_V }, // 7021
  { PseudoVLUXSEG8EI16_V_M4_MF8_MASK, VLUXSEG8EI16_V }, // 7022
  { PseudoVLUXSEG8EI16_V_M8_M1, VLUXSEG8EI16_V }, // 7023
  { PseudoVLUXSEG8EI16_V_M8_M1_MASK, VLUXSEG8EI16_V }, // 7024
  { PseudoVLUXSEG8EI16_V_M8_MF2, VLUXSEG8EI16_V }, // 7025
  { PseudoVLUXSEG8EI16_V_M8_MF2_MASK, VLUXSEG8EI16_V }, // 7026
  { PseudoVLUXSEG8EI16_V_M8_MF4, VLUXSEG8EI16_V }, // 7027
  { PseudoVLUXSEG8EI16_V_M8_MF4_MASK, VLUXSEG8EI16_V }, // 7028
  { PseudoVLUXSEG8EI16_V_M8_MF8, VLUXSEG8EI16_V }, // 7029
  { PseudoVLUXSEG8EI16_V_M8_MF8_MASK, VLUXSEG8EI16_V }, // 7030
  { PseudoVLUXSEG8EI16_V_MF2_M1, VLUXSEG8EI16_V }, // 7031
  { PseudoVLUXSEG8EI16_V_MF2_M1_MASK, VLUXSEG8EI16_V }, // 7032
  { PseudoVLUXSEG8EI16_V_MF2_MF2, VLUXSEG8EI16_V }, // 7033
  { PseudoVLUXSEG8EI16_V_MF2_MF2_MASK, VLUXSEG8EI16_V }, // 7034
  { PseudoVLUXSEG8EI16_V_MF2_MF4, VLUXSEG8EI16_V }, // 7035
  { PseudoVLUXSEG8EI16_V_MF2_MF4_MASK, VLUXSEG8EI16_V }, // 7036
  { PseudoVLUXSEG8EI16_V_MF2_MF8, VLUXSEG8EI16_V }, // 7037
  { PseudoVLUXSEG8EI16_V_MF2_MF8_MASK, VLUXSEG8EI16_V }, // 7038
  { PseudoVLUXSEG8EI16_V_MF4_M1, VLUXSEG8EI16_V }, // 7039
  { PseudoVLUXSEG8EI16_V_MF4_M1_MASK, VLUXSEG8EI16_V }, // 7040
  { PseudoVLUXSEG8EI16_V_MF4_MF2, VLUXSEG8EI16_V }, // 7041
  { PseudoVLUXSEG8EI16_V_MF4_MF2_MASK, VLUXSEG8EI16_V }, // 7042
  { PseudoVLUXSEG8EI16_V_MF4_MF4, VLUXSEG8EI16_V }, // 7043
  { PseudoVLUXSEG8EI16_V_MF4_MF4_MASK, VLUXSEG8EI16_V }, // 7044
  { PseudoVLUXSEG8EI16_V_MF4_MF8, VLUXSEG8EI16_V }, // 7045
  { PseudoVLUXSEG8EI16_V_MF4_MF8_MASK, VLUXSEG8EI16_V }, // 7046
  { PseudoVLUXSEG8EI32_V_M1_M1, VLUXSEG8EI32_V }, // 7047
  { PseudoVLUXSEG8EI32_V_M1_M1_MASK, VLUXSEG8EI32_V }, // 7048
  { PseudoVLUXSEG8EI32_V_M1_MF2, VLUXSEG8EI32_V }, // 7049
  { PseudoVLUXSEG8EI32_V_M1_MF2_MASK, VLUXSEG8EI32_V }, // 7050
  { PseudoVLUXSEG8EI32_V_M1_MF4, VLUXSEG8EI32_V }, // 7051
  { PseudoVLUXSEG8EI32_V_M1_MF4_MASK, VLUXSEG8EI32_V }, // 7052
  { PseudoVLUXSEG8EI32_V_M1_MF8, VLUXSEG8EI32_V }, // 7053
  { PseudoVLUXSEG8EI32_V_M1_MF8_MASK, VLUXSEG8EI32_V }, // 7054
  { PseudoVLUXSEG8EI32_V_M2_M1, VLUXSEG8EI32_V }, // 7055
  { PseudoVLUXSEG8EI32_V_M2_M1_MASK, VLUXSEG8EI32_V }, // 7056
  { PseudoVLUXSEG8EI32_V_M2_MF2, VLUXSEG8EI32_V }, // 7057
  { PseudoVLUXSEG8EI32_V_M2_MF2_MASK, VLUXSEG8EI32_V }, // 7058
  { PseudoVLUXSEG8EI32_V_M2_MF4, VLUXSEG8EI32_V }, // 7059
  { PseudoVLUXSEG8EI32_V_M2_MF4_MASK, VLUXSEG8EI32_V }, // 7060
  { PseudoVLUXSEG8EI32_V_M2_MF8, VLUXSEG8EI32_V }, // 7061
  { PseudoVLUXSEG8EI32_V_M2_MF8_MASK, VLUXSEG8EI32_V }, // 7062
  { PseudoVLUXSEG8EI32_V_M4_M1, VLUXSEG8EI32_V }, // 7063
  { PseudoVLUXSEG8EI32_V_M4_M1_MASK, VLUXSEG8EI32_V }, // 7064
  { PseudoVLUXSEG8EI32_V_M4_MF2, VLUXSEG8EI32_V }, // 7065
  { PseudoVLUXSEG8EI32_V_M4_MF2_MASK, VLUXSEG8EI32_V }, // 7066
  { PseudoVLUXSEG8EI32_V_M4_MF4, VLUXSEG8EI32_V }, // 7067
  { PseudoVLUXSEG8EI32_V_M4_MF4_MASK, VLUXSEG8EI32_V }, // 7068
  { PseudoVLUXSEG8EI32_V_M4_MF8, VLUXSEG8EI32_V }, // 7069
  { PseudoVLUXSEG8EI32_V_M4_MF8_MASK, VLUXSEG8EI32_V }, // 7070
  { PseudoVLUXSEG8EI32_V_M8_M1, VLUXSEG8EI32_V }, // 7071
  { PseudoVLUXSEG8EI32_V_M8_M1_MASK, VLUXSEG8EI32_V }, // 7072
  { PseudoVLUXSEG8EI32_V_M8_MF2, VLUXSEG8EI32_V }, // 7073
  { PseudoVLUXSEG8EI32_V_M8_MF2_MASK, VLUXSEG8EI32_V }, // 7074
  { PseudoVLUXSEG8EI32_V_M8_MF4, VLUXSEG8EI32_V }, // 7075
  { PseudoVLUXSEG8EI32_V_M8_MF4_MASK, VLUXSEG8EI32_V }, // 7076
  { PseudoVLUXSEG8EI32_V_M8_MF8, VLUXSEG8EI32_V }, // 7077
  { PseudoVLUXSEG8EI32_V_M8_MF8_MASK, VLUXSEG8EI32_V }, // 7078
  { PseudoVLUXSEG8EI32_V_MF2_M1, VLUXSEG8EI32_V }, // 7079
  { PseudoVLUXSEG8EI32_V_MF2_M1_MASK, VLUXSEG8EI32_V }, // 7080
  { PseudoVLUXSEG8EI32_V_MF2_MF2, VLUXSEG8EI32_V }, // 7081
  { PseudoVLUXSEG8EI32_V_MF2_MF2_MASK, VLUXSEG8EI32_V }, // 7082
  { PseudoVLUXSEG8EI32_V_MF2_MF4, VLUXSEG8EI32_V }, // 7083
  { PseudoVLUXSEG8EI32_V_MF2_MF4_MASK, VLUXSEG8EI32_V }, // 7084
  { PseudoVLUXSEG8EI32_V_MF2_MF8, VLUXSEG8EI32_V }, // 7085
  { PseudoVLUXSEG8EI32_V_MF2_MF8_MASK, VLUXSEG8EI32_V }, // 7086
  { PseudoVLUXSEG8EI64_V_M1_M1, VLUXSEG8EI64_V }, // 7087
  { PseudoVLUXSEG8EI64_V_M1_M1_MASK, VLUXSEG8EI64_V }, // 7088
  { PseudoVLUXSEG8EI64_V_M1_MF2, VLUXSEG8EI64_V }, // 7089
  { PseudoVLUXSEG8EI64_V_M1_MF2_MASK, VLUXSEG8EI64_V }, // 7090
  { PseudoVLUXSEG8EI64_V_M1_MF4, VLUXSEG8EI64_V }, // 7091
  { PseudoVLUXSEG8EI64_V_M1_MF4_MASK, VLUXSEG8EI64_V }, // 7092
  { PseudoVLUXSEG8EI64_V_M1_MF8, VLUXSEG8EI64_V }, // 7093
  { PseudoVLUXSEG8EI64_V_M1_MF8_MASK, VLUXSEG8EI64_V }, // 7094
  { PseudoVLUXSEG8EI64_V_M2_M1, VLUXSEG8EI64_V }, // 7095
  { PseudoVLUXSEG8EI64_V_M2_M1_MASK, VLUXSEG8EI64_V }, // 7096
  { PseudoVLUXSEG8EI64_V_M2_MF2, VLUXSEG8EI64_V }, // 7097
  { PseudoVLUXSEG8EI64_V_M2_MF2_MASK, VLUXSEG8EI64_V }, // 7098
  { PseudoVLUXSEG8EI64_V_M2_MF4, VLUXSEG8EI64_V }, // 7099
  { PseudoVLUXSEG8EI64_V_M2_MF4_MASK, VLUXSEG8EI64_V }, // 7100
  { PseudoVLUXSEG8EI64_V_M2_MF8, VLUXSEG8EI64_V }, // 7101
  { PseudoVLUXSEG8EI64_V_M2_MF8_MASK, VLUXSEG8EI64_V }, // 7102
  { PseudoVLUXSEG8EI64_V_M4_M1, VLUXSEG8EI64_V }, // 7103
  { PseudoVLUXSEG8EI64_V_M4_M1_MASK, VLUXSEG8EI64_V }, // 7104
  { PseudoVLUXSEG8EI64_V_M4_MF2, VLUXSEG8EI64_V }, // 7105
  { PseudoVLUXSEG8EI64_V_M4_MF2_MASK, VLUXSEG8EI64_V }, // 7106
  { PseudoVLUXSEG8EI64_V_M4_MF4, VLUXSEG8EI64_V }, // 7107
  { PseudoVLUXSEG8EI64_V_M4_MF4_MASK, VLUXSEG8EI64_V }, // 7108
  { PseudoVLUXSEG8EI64_V_M4_MF8, VLUXSEG8EI64_V }, // 7109
  { PseudoVLUXSEG8EI64_V_M4_MF8_MASK, VLUXSEG8EI64_V }, // 7110
  { PseudoVLUXSEG8EI64_V_M8_M1, VLUXSEG8EI64_V }, // 7111
  { PseudoVLUXSEG8EI64_V_M8_M1_MASK, VLUXSEG8EI64_V }, // 7112
  { PseudoVLUXSEG8EI64_V_M8_MF2, VLUXSEG8EI64_V }, // 7113
  { PseudoVLUXSEG8EI64_V_M8_MF2_MASK, VLUXSEG8EI64_V }, // 7114
  { PseudoVLUXSEG8EI64_V_M8_MF4, VLUXSEG8EI64_V }, // 7115
  { PseudoVLUXSEG8EI64_V_M8_MF4_MASK, VLUXSEG8EI64_V }, // 7116
  { PseudoVLUXSEG8EI64_V_M8_MF8, VLUXSEG8EI64_V }, // 7117
  { PseudoVLUXSEG8EI64_V_M8_MF8_MASK, VLUXSEG8EI64_V }, // 7118
  { PseudoVLUXSEG8EI8_V_M1_M1, VLUXSEG8EI8_V }, // 7119
  { PseudoVLUXSEG8EI8_V_M1_M1_MASK, VLUXSEG8EI8_V }, // 7120
  { PseudoVLUXSEG8EI8_V_M1_MF2, VLUXSEG8EI8_V }, // 7121
  { PseudoVLUXSEG8EI8_V_M1_MF2_MASK, VLUXSEG8EI8_V }, // 7122
  { PseudoVLUXSEG8EI8_V_M1_MF4, VLUXSEG8EI8_V }, // 7123
  { PseudoVLUXSEG8EI8_V_M1_MF4_MASK, VLUXSEG8EI8_V }, // 7124
  { PseudoVLUXSEG8EI8_V_M1_MF8, VLUXSEG8EI8_V }, // 7125
  { PseudoVLUXSEG8EI8_V_M1_MF8_MASK, VLUXSEG8EI8_V }, // 7126
  { PseudoVLUXSEG8EI8_V_M2_M1, VLUXSEG8EI8_V }, // 7127
  { PseudoVLUXSEG8EI8_V_M2_M1_MASK, VLUXSEG8EI8_V }, // 7128
  { PseudoVLUXSEG8EI8_V_M2_MF2, VLUXSEG8EI8_V }, // 7129
  { PseudoVLUXSEG8EI8_V_M2_MF2_MASK, VLUXSEG8EI8_V }, // 7130
  { PseudoVLUXSEG8EI8_V_M2_MF4, VLUXSEG8EI8_V }, // 7131
  { PseudoVLUXSEG8EI8_V_M2_MF4_MASK, VLUXSEG8EI8_V }, // 7132
  { PseudoVLUXSEG8EI8_V_M2_MF8, VLUXSEG8EI8_V }, // 7133
  { PseudoVLUXSEG8EI8_V_M2_MF8_MASK, VLUXSEG8EI8_V }, // 7134
  { PseudoVLUXSEG8EI8_V_M4_M1, VLUXSEG8EI8_V }, // 7135
  { PseudoVLUXSEG8EI8_V_M4_M1_MASK, VLUXSEG8EI8_V }, // 7136
  { PseudoVLUXSEG8EI8_V_M4_MF2, VLUXSEG8EI8_V }, // 7137
  { PseudoVLUXSEG8EI8_V_M4_MF2_MASK, VLUXSEG8EI8_V }, // 7138
  { PseudoVLUXSEG8EI8_V_M4_MF4, VLUXSEG8EI8_V }, // 7139
  { PseudoVLUXSEG8EI8_V_M4_MF4_MASK, VLUXSEG8EI8_V }, // 7140
  { PseudoVLUXSEG8EI8_V_M4_MF8, VLUXSEG8EI8_V }, // 7141
  { PseudoVLUXSEG8EI8_V_M4_MF8_MASK, VLUXSEG8EI8_V }, // 7142
  { PseudoVLUXSEG8EI8_V_M8_M1, VLUXSEG8EI8_V }, // 7143
  { PseudoVLUXSEG8EI8_V_M8_M1_MASK, VLUXSEG8EI8_V }, // 7144
  { PseudoVLUXSEG8EI8_V_M8_MF2, VLUXSEG8EI8_V }, // 7145
  { PseudoVLUXSEG8EI8_V_M8_MF2_MASK, VLUXSEG8EI8_V }, // 7146
  { PseudoVLUXSEG8EI8_V_M8_MF4, VLUXSEG8EI8_V }, // 7147
  { PseudoVLUXSEG8EI8_V_M8_MF4_MASK, VLUXSEG8EI8_V }, // 7148
  { PseudoVLUXSEG8EI8_V_M8_MF8, VLUXSEG8EI8_V }, // 7149
  { PseudoVLUXSEG8EI8_V_M8_MF8_MASK, VLUXSEG8EI8_V }, // 7150
  { PseudoVLUXSEG8EI8_V_MF2_M1, VLUXSEG8EI8_V }, // 7151
  { PseudoVLUXSEG8EI8_V_MF2_M1_MASK, VLUXSEG8EI8_V }, // 7152
  { PseudoVLUXSEG8EI8_V_MF2_MF2, VLUXSEG8EI8_V }, // 7153
  { PseudoVLUXSEG8EI8_V_MF2_MF2_MASK, VLUXSEG8EI8_V }, // 7154
  { PseudoVLUXSEG8EI8_V_MF2_MF4, VLUXSEG8EI8_V }, // 7155
  { PseudoVLUXSEG8EI8_V_MF2_MF4_MASK, VLUXSEG8EI8_V }, // 7156
  { PseudoVLUXSEG8EI8_V_MF2_MF8, VLUXSEG8EI8_V }, // 7157
  { PseudoVLUXSEG8EI8_V_MF2_MF8_MASK, VLUXSEG8EI8_V }, // 7158
  { PseudoVLUXSEG8EI8_V_MF4_M1, VLUXSEG8EI8_V }, // 7159
  { PseudoVLUXSEG8EI8_V_MF4_M1_MASK, VLUXSEG8EI8_V }, // 7160
  { PseudoVLUXSEG8EI8_V_MF4_MF2, VLUXSEG8EI8_V }, // 7161
  { PseudoVLUXSEG8EI8_V_MF4_MF2_MASK, VLUXSEG8EI8_V }, // 7162
  { PseudoVLUXSEG8EI8_V_MF4_MF4, VLUXSEG8EI8_V }, // 7163
  { PseudoVLUXSEG8EI8_V_MF4_MF4_MASK, VLUXSEG8EI8_V }, // 7164
  { PseudoVLUXSEG8EI8_V_MF4_MF8, VLUXSEG8EI8_V }, // 7165
  { PseudoVLUXSEG8EI8_V_MF4_MF8_MASK, VLUXSEG8EI8_V }, // 7166
  { PseudoVLUXSEG8EI8_V_MF8_M1, VLUXSEG8EI8_V }, // 7167
  { PseudoVLUXSEG8EI8_V_MF8_M1_MASK, VLUXSEG8EI8_V }, // 7168
  { PseudoVLUXSEG8EI8_V_MF8_MF2, VLUXSEG8EI8_V }, // 7169
  { PseudoVLUXSEG8EI8_V_MF8_MF2_MASK, VLUXSEG8EI8_V }, // 7170
  { PseudoVLUXSEG8EI8_V_MF8_MF4, VLUXSEG8EI8_V }, // 7171
  { PseudoVLUXSEG8EI8_V_MF8_MF4_MASK, VLUXSEG8EI8_V }, // 7172
  { PseudoVLUXSEG8EI8_V_MF8_MF8, VLUXSEG8EI8_V }, // 7173
  { PseudoVLUXSEG8EI8_V_MF8_MF8_MASK, VLUXSEG8EI8_V }, // 7174
  { PseudoVMACC_VV_M1, VMACC_VV }, // 7175
  { PseudoVMACC_VV_M1_MASK, VMACC_VV }, // 7176
  { PseudoVMACC_VV_M2, VMACC_VV }, // 7177
  { PseudoVMACC_VV_M2_MASK, VMACC_VV }, // 7178
  { PseudoVMACC_VV_M4, VMACC_VV }, // 7179
  { PseudoVMACC_VV_M4_MASK, VMACC_VV }, // 7180
  { PseudoVMACC_VV_M8, VMACC_VV }, // 7181
  { PseudoVMACC_VV_M8_MASK, VMACC_VV }, // 7182
  { PseudoVMACC_VV_MF2, VMACC_VV }, // 7183
  { PseudoVMACC_VV_MF2_MASK, VMACC_VV }, // 7184
  { PseudoVMACC_VV_MF4, VMACC_VV }, // 7185
  { PseudoVMACC_VV_MF4_MASK, VMACC_VV }, // 7186
  { PseudoVMACC_VV_MF8, VMACC_VV }, // 7187
  { PseudoVMACC_VV_MF8_MASK, VMACC_VV }, // 7188
  { PseudoVMACC_VX_M1, VMACC_VX }, // 7189
  { PseudoVMACC_VX_M1_MASK, VMACC_VX }, // 7190
  { PseudoVMACC_VX_M2, VMACC_VX }, // 7191
  { PseudoVMACC_VX_M2_MASK, VMACC_VX }, // 7192
  { PseudoVMACC_VX_M4, VMACC_VX }, // 7193
  { PseudoVMACC_VX_M4_MASK, VMACC_VX }, // 7194
  { PseudoVMACC_VX_M8, VMACC_VX }, // 7195
  { PseudoVMACC_VX_M8_MASK, VMACC_VX }, // 7196
  { PseudoVMACC_VX_MF2, VMACC_VX }, // 7197
  { PseudoVMACC_VX_MF2_MASK, VMACC_VX }, // 7198
  { PseudoVMACC_VX_MF4, VMACC_VX }, // 7199
  { PseudoVMACC_VX_MF4_MASK, VMACC_VX }, // 7200
  { PseudoVMACC_VX_MF8, VMACC_VX }, // 7201
  { PseudoVMACC_VX_MF8_MASK, VMACC_VX }, // 7202
  { PseudoVMADC_VIM_M1, VMADC_VIM }, // 7203
  { PseudoVMADC_VIM_M2, VMADC_VIM }, // 7204
  { PseudoVMADC_VIM_M4, VMADC_VIM }, // 7205
  { PseudoVMADC_VIM_M8, VMADC_VIM }, // 7206
  { PseudoVMADC_VIM_MF2, VMADC_VIM }, // 7207
  { PseudoVMADC_VIM_MF4, VMADC_VIM }, // 7208
  { PseudoVMADC_VIM_MF8, VMADC_VIM }, // 7209
  { PseudoVMADC_VI_M1, VMADC_VI }, // 7210
  { PseudoVMADC_VI_M2, VMADC_VI }, // 7211
  { PseudoVMADC_VI_M4, VMADC_VI }, // 7212
  { PseudoVMADC_VI_M8, VMADC_VI }, // 7213
  { PseudoVMADC_VI_MF2, VMADC_VI }, // 7214
  { PseudoVMADC_VI_MF4, VMADC_VI }, // 7215
  { PseudoVMADC_VI_MF8, VMADC_VI }, // 7216
  { PseudoVMADC_VVM_M1, VMADC_VVM }, // 7217
  { PseudoVMADC_VVM_M2, VMADC_VVM }, // 7218
  { PseudoVMADC_VVM_M4, VMADC_VVM }, // 7219
  { PseudoVMADC_VVM_M8, VMADC_VVM }, // 7220
  { PseudoVMADC_VVM_MF2, VMADC_VVM }, // 7221
  { PseudoVMADC_VVM_MF4, VMADC_VVM }, // 7222
  { PseudoVMADC_VVM_MF8, VMADC_VVM }, // 7223
  { PseudoVMADC_VV_M1, VMADC_VV }, // 7224
  { PseudoVMADC_VV_M2, VMADC_VV }, // 7225
  { PseudoVMADC_VV_M4, VMADC_VV }, // 7226
  { PseudoVMADC_VV_M8, VMADC_VV }, // 7227
  { PseudoVMADC_VV_MF2, VMADC_VV }, // 7228
  { PseudoVMADC_VV_MF4, VMADC_VV }, // 7229
  { PseudoVMADC_VV_MF8, VMADC_VV }, // 7230
  { PseudoVMADC_VXM_M1, VMADC_VXM }, // 7231
  { PseudoVMADC_VXM_M2, VMADC_VXM }, // 7232
  { PseudoVMADC_VXM_M4, VMADC_VXM }, // 7233
  { PseudoVMADC_VXM_M8, VMADC_VXM }, // 7234
  { PseudoVMADC_VXM_MF2, VMADC_VXM }, // 7235
  { PseudoVMADC_VXM_MF4, VMADC_VXM }, // 7236
  { PseudoVMADC_VXM_MF8, VMADC_VXM }, // 7237
  { PseudoVMADC_VX_M1, VMADC_VX }, // 7238
  { PseudoVMADC_VX_M2, VMADC_VX }, // 7239
  { PseudoVMADC_VX_M4, VMADC_VX }, // 7240
  { PseudoVMADC_VX_M8, VMADC_VX }, // 7241
  { PseudoVMADC_VX_MF2, VMADC_VX }, // 7242
  { PseudoVMADC_VX_MF4, VMADC_VX }, // 7243
  { PseudoVMADC_VX_MF8, VMADC_VX }, // 7244
  { PseudoVMADD_VV_M1, VMADD_VV }, // 7245
  { PseudoVMADD_VV_M1_MASK, VMADD_VV }, // 7246
  { PseudoVMADD_VV_M2, VMADD_VV }, // 7247
  { PseudoVMADD_VV_M2_MASK, VMADD_VV }, // 7248
  { PseudoVMADD_VV_M4, VMADD_VV }, // 7249
  { PseudoVMADD_VV_M4_MASK, VMADD_VV }, // 7250
  { PseudoVMADD_VV_M8, VMADD_VV }, // 7251
  { PseudoVMADD_VV_M8_MASK, VMADD_VV }, // 7252
  { PseudoVMADD_VV_MF2, VMADD_VV }, // 7253
  { PseudoVMADD_VV_MF2_MASK, VMADD_VV }, // 7254
  { PseudoVMADD_VV_MF4, VMADD_VV }, // 7255
  { PseudoVMADD_VV_MF4_MASK, VMADD_VV }, // 7256
  { PseudoVMADD_VV_MF8, VMADD_VV }, // 7257
  { PseudoVMADD_VV_MF8_MASK, VMADD_VV }, // 7258
  { PseudoVMADD_VX_M1, VMADD_VX }, // 7259
  { PseudoVMADD_VX_M1_MASK, VMADD_VX }, // 7260
  { PseudoVMADD_VX_M2, VMADD_VX }, // 7261
  { PseudoVMADD_VX_M2_MASK, VMADD_VX }, // 7262
  { PseudoVMADD_VX_M4, VMADD_VX }, // 7263
  { PseudoVMADD_VX_M4_MASK, VMADD_VX }, // 7264
  { PseudoVMADD_VX_M8, VMADD_VX }, // 7265
  { PseudoVMADD_VX_M8_MASK, VMADD_VX }, // 7266
  { PseudoVMADD_VX_MF2, VMADD_VX }, // 7267
  { PseudoVMADD_VX_MF2_MASK, VMADD_VX }, // 7268
  { PseudoVMADD_VX_MF4, VMADD_VX }, // 7269
  { PseudoVMADD_VX_MF4_MASK, VMADD_VX }, // 7270
  { PseudoVMADD_VX_MF8, VMADD_VX }, // 7271
  { PseudoVMADD_VX_MF8_MASK, VMADD_VX }, // 7272
  { PseudoVMANDNOT_MM_M1, VMANDNOT_MM }, // 7273
  { PseudoVMANDNOT_MM_M2, VMANDNOT_MM }, // 7274
  { PseudoVMANDNOT_MM_M4, VMANDNOT_MM }, // 7275
  { PseudoVMANDNOT_MM_M8, VMANDNOT_MM }, // 7276
  { PseudoVMANDNOT_MM_MF2, VMANDNOT_MM }, // 7277
  { PseudoVMANDNOT_MM_MF4, VMANDNOT_MM }, // 7278
  { PseudoVMANDNOT_MM_MF8, VMANDNOT_MM }, // 7279
  { PseudoVMAND_MM_M1, VMAND_MM }, // 7280
  { PseudoVMAND_MM_M2, VMAND_MM }, // 7281
  { PseudoVMAND_MM_M4, VMAND_MM }, // 7282
  { PseudoVMAND_MM_M8, VMAND_MM }, // 7283
  { PseudoVMAND_MM_MF2, VMAND_MM }, // 7284
  { PseudoVMAND_MM_MF4, VMAND_MM }, // 7285
  { PseudoVMAND_MM_MF8, VMAND_MM }, // 7286
  { PseudoVMAXU_VV_M1, VMAXU_VV }, // 7287
  { PseudoVMAXU_VV_M1_MASK, VMAXU_VV }, // 7288
  { PseudoVMAXU_VV_M2, VMAXU_VV }, // 7289
  { PseudoVMAXU_VV_M2_MASK, VMAXU_VV }, // 7290
  { PseudoVMAXU_VV_M4, VMAXU_VV }, // 7291
  { PseudoVMAXU_VV_M4_MASK, VMAXU_VV }, // 7292
  { PseudoVMAXU_VV_M8, VMAXU_VV }, // 7293
  { PseudoVMAXU_VV_M8_MASK, VMAXU_VV }, // 7294
  { PseudoVMAXU_VV_MF2, VMAXU_VV }, // 7295
  { PseudoVMAXU_VV_MF2_MASK, VMAXU_VV }, // 7296
  { PseudoVMAXU_VV_MF4, VMAXU_VV }, // 7297
  { PseudoVMAXU_VV_MF4_MASK, VMAXU_VV }, // 7298
  { PseudoVMAXU_VV_MF8, VMAXU_VV }, // 7299
  { PseudoVMAXU_VV_MF8_MASK, VMAXU_VV }, // 7300
  { PseudoVMAXU_VX_M1, VMAXU_VX }, // 7301
  { PseudoVMAXU_VX_M1_MASK, VMAXU_VX }, // 7302
  { PseudoVMAXU_VX_M2, VMAXU_VX }, // 7303
  { PseudoVMAXU_VX_M2_MASK, VMAXU_VX }, // 7304
  { PseudoVMAXU_VX_M4, VMAXU_VX }, // 7305
  { PseudoVMAXU_VX_M4_MASK, VMAXU_VX }, // 7306
  { PseudoVMAXU_VX_M8, VMAXU_VX }, // 7307
  { PseudoVMAXU_VX_M8_MASK, VMAXU_VX }, // 7308
  { PseudoVMAXU_VX_MF2, VMAXU_VX }, // 7309
  { PseudoVMAXU_VX_MF2_MASK, VMAXU_VX }, // 7310
  { PseudoVMAXU_VX_MF4, VMAXU_VX }, // 7311
  { PseudoVMAXU_VX_MF4_MASK, VMAXU_VX }, // 7312
  { PseudoVMAXU_VX_MF8, VMAXU_VX }, // 7313
  { PseudoVMAXU_VX_MF8_MASK, VMAXU_VX }, // 7314
  { PseudoVMAX_VV_M1, VMAX_VV }, // 7315
  { PseudoVMAX_VV_M1_MASK, VMAX_VV }, // 7316
  { PseudoVMAX_VV_M2, VMAX_VV }, // 7317
  { PseudoVMAX_VV_M2_MASK, VMAX_VV }, // 7318
  { PseudoVMAX_VV_M4, VMAX_VV }, // 7319
  { PseudoVMAX_VV_M4_MASK, VMAX_VV }, // 7320
  { PseudoVMAX_VV_M8, VMAX_VV }, // 7321
  { PseudoVMAX_VV_M8_MASK, VMAX_VV }, // 7322
  { PseudoVMAX_VV_MF2, VMAX_VV }, // 7323
  { PseudoVMAX_VV_MF2_MASK, VMAX_VV }, // 7324
  { PseudoVMAX_VV_MF4, VMAX_VV }, // 7325
  { PseudoVMAX_VV_MF4_MASK, VMAX_VV }, // 7326
  { PseudoVMAX_VV_MF8, VMAX_VV }, // 7327
  { PseudoVMAX_VV_MF8_MASK, VMAX_VV }, // 7328
  { PseudoVMAX_VX_M1, VMAX_VX }, // 7329
  { PseudoVMAX_VX_M1_MASK, VMAX_VX }, // 7330
  { PseudoVMAX_VX_M2, VMAX_VX }, // 7331
  { PseudoVMAX_VX_M2_MASK, VMAX_VX }, // 7332
  { PseudoVMAX_VX_M4, VMAX_VX }, // 7333
  { PseudoVMAX_VX_M4_MASK, VMAX_VX }, // 7334
  { PseudoVMAX_VX_M8, VMAX_VX }, // 7335
  { PseudoVMAX_VX_M8_MASK, VMAX_VX }, // 7336
  { PseudoVMAX_VX_MF2, VMAX_VX }, // 7337
  { PseudoVMAX_VX_MF2_MASK, VMAX_VX }, // 7338
  { PseudoVMAX_VX_MF4, VMAX_VX }, // 7339
  { PseudoVMAX_VX_MF4_MASK, VMAX_VX }, // 7340
  { PseudoVMAX_VX_MF8, VMAX_VX }, // 7341
  { PseudoVMAX_VX_MF8_MASK, VMAX_VX }, // 7342
  { PseudoVMCLR_M_B1, VMXOR_MM }, // 7343
  { PseudoVMCLR_M_B16, VMXOR_MM }, // 7344
  { PseudoVMCLR_M_B2, VMXOR_MM }, // 7345
  { PseudoVMCLR_M_B32, VMXOR_MM }, // 7346
  { PseudoVMCLR_M_B4, VMXOR_MM }, // 7347
  { PseudoVMCLR_M_B64, VMXOR_MM }, // 7348
  { PseudoVMCLR_M_B8, VMXOR_MM }, // 7349
  { PseudoVMERGE_VIM_M1, VMERGE_VIM }, // 7350
  { PseudoVMERGE_VIM_M2, VMERGE_VIM }, // 7351
  { PseudoVMERGE_VIM_M4, VMERGE_VIM }, // 7352
  { PseudoVMERGE_VIM_M8, VMERGE_VIM }, // 7353
  { PseudoVMERGE_VIM_MF2, VMERGE_VIM }, // 7354
  { PseudoVMERGE_VIM_MF4, VMERGE_VIM }, // 7355
  { PseudoVMERGE_VIM_MF8, VMERGE_VIM }, // 7356
  { PseudoVMERGE_VVM_M1, VMERGE_VVM }, // 7357
  { PseudoVMERGE_VVM_M2, VMERGE_VVM }, // 7358
  { PseudoVMERGE_VVM_M4, VMERGE_VVM }, // 7359
  { PseudoVMERGE_VVM_M8, VMERGE_VVM }, // 7360
  { PseudoVMERGE_VVM_MF2, VMERGE_VVM }, // 7361
  { PseudoVMERGE_VVM_MF4, VMERGE_VVM }, // 7362
  { PseudoVMERGE_VVM_MF8, VMERGE_VVM }, // 7363
  { PseudoVMERGE_VXM_M1, VMERGE_VXM }, // 7364
  { PseudoVMERGE_VXM_M2, VMERGE_VXM }, // 7365
  { PseudoVMERGE_VXM_M4, VMERGE_VXM }, // 7366
  { PseudoVMERGE_VXM_M8, VMERGE_VXM }, // 7367
  { PseudoVMERGE_VXM_MF2, VMERGE_VXM }, // 7368
  { PseudoVMERGE_VXM_MF4, VMERGE_VXM }, // 7369
  { PseudoVMERGE_VXM_MF8, VMERGE_VXM }, // 7370
  { PseudoVMFEQ_VF16_M1, VMFEQ_VF }, // 7371
  { PseudoVMFEQ_VF16_M1_MASK, VMFEQ_VF }, // 7372
  { PseudoVMFEQ_VF16_M2, VMFEQ_VF }, // 7373
  { PseudoVMFEQ_VF16_M2_MASK, VMFEQ_VF }, // 7374
  { PseudoVMFEQ_VF16_M4, VMFEQ_VF }, // 7375
  { PseudoVMFEQ_VF16_M4_MASK, VMFEQ_VF }, // 7376
  { PseudoVMFEQ_VF16_M8, VMFEQ_VF }, // 7377
  { PseudoVMFEQ_VF16_M8_MASK, VMFEQ_VF }, // 7378
  { PseudoVMFEQ_VF16_MF2, VMFEQ_VF }, // 7379
  { PseudoVMFEQ_VF16_MF2_MASK, VMFEQ_VF }, // 7380
  { PseudoVMFEQ_VF16_MF4, VMFEQ_VF }, // 7381
  { PseudoVMFEQ_VF16_MF4_MASK, VMFEQ_VF }, // 7382
  { PseudoVMFEQ_VF16_MF8, VMFEQ_VF }, // 7383
  { PseudoVMFEQ_VF16_MF8_MASK, VMFEQ_VF }, // 7384
  { PseudoVMFEQ_VF32_M1, VMFEQ_VF }, // 7385
  { PseudoVMFEQ_VF32_M1_MASK, VMFEQ_VF }, // 7386
  { PseudoVMFEQ_VF32_M2, VMFEQ_VF }, // 7387
  { PseudoVMFEQ_VF32_M2_MASK, VMFEQ_VF }, // 7388
  { PseudoVMFEQ_VF32_M4, VMFEQ_VF }, // 7389
  { PseudoVMFEQ_VF32_M4_MASK, VMFEQ_VF }, // 7390
  { PseudoVMFEQ_VF32_M8, VMFEQ_VF }, // 7391
  { PseudoVMFEQ_VF32_M8_MASK, VMFEQ_VF }, // 7392
  { PseudoVMFEQ_VF32_MF2, VMFEQ_VF }, // 7393
  { PseudoVMFEQ_VF32_MF2_MASK, VMFEQ_VF }, // 7394
  { PseudoVMFEQ_VF32_MF4, VMFEQ_VF }, // 7395
  { PseudoVMFEQ_VF32_MF4_MASK, VMFEQ_VF }, // 7396
  { PseudoVMFEQ_VF32_MF8, VMFEQ_VF }, // 7397
  { PseudoVMFEQ_VF32_MF8_MASK, VMFEQ_VF }, // 7398
  { PseudoVMFEQ_VF64_M1, VMFEQ_VF }, // 7399
  { PseudoVMFEQ_VF64_M1_MASK, VMFEQ_VF }, // 7400
  { PseudoVMFEQ_VF64_M2, VMFEQ_VF }, // 7401
  { PseudoVMFEQ_VF64_M2_MASK, VMFEQ_VF }, // 7402
  { PseudoVMFEQ_VF64_M4, VMFEQ_VF }, // 7403
  { PseudoVMFEQ_VF64_M4_MASK, VMFEQ_VF }, // 7404
  { PseudoVMFEQ_VF64_M8, VMFEQ_VF }, // 7405
  { PseudoVMFEQ_VF64_M8_MASK, VMFEQ_VF }, // 7406
  { PseudoVMFEQ_VF64_MF2, VMFEQ_VF }, // 7407
  { PseudoVMFEQ_VF64_MF2_MASK, VMFEQ_VF }, // 7408
  { PseudoVMFEQ_VF64_MF4, VMFEQ_VF }, // 7409
  { PseudoVMFEQ_VF64_MF4_MASK, VMFEQ_VF }, // 7410
  { PseudoVMFEQ_VF64_MF8, VMFEQ_VF }, // 7411
  { PseudoVMFEQ_VF64_MF8_MASK, VMFEQ_VF }, // 7412
  { PseudoVMFEQ_VV_M1, VMFEQ_VV }, // 7413
  { PseudoVMFEQ_VV_M1_MASK, VMFEQ_VV }, // 7414
  { PseudoVMFEQ_VV_M2, VMFEQ_VV }, // 7415
  { PseudoVMFEQ_VV_M2_MASK, VMFEQ_VV }, // 7416
  { PseudoVMFEQ_VV_M4, VMFEQ_VV }, // 7417
  { PseudoVMFEQ_VV_M4_MASK, VMFEQ_VV }, // 7418
  { PseudoVMFEQ_VV_M8, VMFEQ_VV }, // 7419
  { PseudoVMFEQ_VV_M8_MASK, VMFEQ_VV }, // 7420
  { PseudoVMFEQ_VV_MF2, VMFEQ_VV }, // 7421
  { PseudoVMFEQ_VV_MF2_MASK, VMFEQ_VV }, // 7422
  { PseudoVMFEQ_VV_MF4, VMFEQ_VV }, // 7423
  { PseudoVMFEQ_VV_MF4_MASK, VMFEQ_VV }, // 7424
  { PseudoVMFEQ_VV_MF8, VMFEQ_VV }, // 7425
  { PseudoVMFEQ_VV_MF8_MASK, VMFEQ_VV }, // 7426
  { PseudoVMFGE_VF16_M1, VMFGE_VF }, // 7427
  { PseudoVMFGE_VF16_M1_MASK, VMFGE_VF }, // 7428
  { PseudoVMFGE_VF16_M2, VMFGE_VF }, // 7429
  { PseudoVMFGE_VF16_M2_MASK, VMFGE_VF }, // 7430
  { PseudoVMFGE_VF16_M4, VMFGE_VF }, // 7431
  { PseudoVMFGE_VF16_M4_MASK, VMFGE_VF }, // 7432
  { PseudoVMFGE_VF16_M8, VMFGE_VF }, // 7433
  { PseudoVMFGE_VF16_M8_MASK, VMFGE_VF }, // 7434
  { PseudoVMFGE_VF16_MF2, VMFGE_VF }, // 7435
  { PseudoVMFGE_VF16_MF2_MASK, VMFGE_VF }, // 7436
  { PseudoVMFGE_VF16_MF4, VMFGE_VF }, // 7437
  { PseudoVMFGE_VF16_MF4_MASK, VMFGE_VF }, // 7438
  { PseudoVMFGE_VF16_MF8, VMFGE_VF }, // 7439
  { PseudoVMFGE_VF16_MF8_MASK, VMFGE_VF }, // 7440
  { PseudoVMFGE_VF32_M1, VMFGE_VF }, // 7441
  { PseudoVMFGE_VF32_M1_MASK, VMFGE_VF }, // 7442
  { PseudoVMFGE_VF32_M2, VMFGE_VF }, // 7443
  { PseudoVMFGE_VF32_M2_MASK, VMFGE_VF }, // 7444
  { PseudoVMFGE_VF32_M4, VMFGE_VF }, // 7445
  { PseudoVMFGE_VF32_M4_MASK, VMFGE_VF }, // 7446
  { PseudoVMFGE_VF32_M8, VMFGE_VF }, // 7447
  { PseudoVMFGE_VF32_M8_MASK, VMFGE_VF }, // 7448
  { PseudoVMFGE_VF32_MF2, VMFGE_VF }, // 7449
  { PseudoVMFGE_VF32_MF2_MASK, VMFGE_VF }, // 7450
  { PseudoVMFGE_VF32_MF4, VMFGE_VF }, // 7451
  { PseudoVMFGE_VF32_MF4_MASK, VMFGE_VF }, // 7452
  { PseudoVMFGE_VF32_MF8, VMFGE_VF }, // 7453
  { PseudoVMFGE_VF32_MF8_MASK, VMFGE_VF }, // 7454
  { PseudoVMFGE_VF64_M1, VMFGE_VF }, // 7455
  { PseudoVMFGE_VF64_M1_MASK, VMFGE_VF }, // 7456
  { PseudoVMFGE_VF64_M2, VMFGE_VF }, // 7457
  { PseudoVMFGE_VF64_M2_MASK, VMFGE_VF }, // 7458
  { PseudoVMFGE_VF64_M4, VMFGE_VF }, // 7459
  { PseudoVMFGE_VF64_M4_MASK, VMFGE_VF }, // 7460
  { PseudoVMFGE_VF64_M8, VMFGE_VF }, // 7461
  { PseudoVMFGE_VF64_M8_MASK, VMFGE_VF }, // 7462
  { PseudoVMFGE_VF64_MF2, VMFGE_VF }, // 7463
  { PseudoVMFGE_VF64_MF2_MASK, VMFGE_VF }, // 7464
  { PseudoVMFGE_VF64_MF4, VMFGE_VF }, // 7465
  { PseudoVMFGE_VF64_MF4_MASK, VMFGE_VF }, // 7466
  { PseudoVMFGE_VF64_MF8, VMFGE_VF }, // 7467
  { PseudoVMFGE_VF64_MF8_MASK, VMFGE_VF }, // 7468
  { PseudoVMFGT_VF16_M1, VMFGT_VF }, // 7469
  { PseudoVMFGT_VF16_M1_MASK, VMFGT_VF }, // 7470
  { PseudoVMFGT_VF16_M2, VMFGT_VF }, // 7471
  { PseudoVMFGT_VF16_M2_MASK, VMFGT_VF }, // 7472
  { PseudoVMFGT_VF16_M4, VMFGT_VF }, // 7473
  { PseudoVMFGT_VF16_M4_MASK, VMFGT_VF }, // 7474
  { PseudoVMFGT_VF16_M8, VMFGT_VF }, // 7475
  { PseudoVMFGT_VF16_M8_MASK, VMFGT_VF }, // 7476
  { PseudoVMFGT_VF16_MF2, VMFGT_VF }, // 7477
  { PseudoVMFGT_VF16_MF2_MASK, VMFGT_VF }, // 7478
  { PseudoVMFGT_VF16_MF4, VMFGT_VF }, // 7479
  { PseudoVMFGT_VF16_MF4_MASK, VMFGT_VF }, // 7480
  { PseudoVMFGT_VF16_MF8, VMFGT_VF }, // 7481
  { PseudoVMFGT_VF16_MF8_MASK, VMFGT_VF }, // 7482
  { PseudoVMFGT_VF32_M1, VMFGT_VF }, // 7483
  { PseudoVMFGT_VF32_M1_MASK, VMFGT_VF }, // 7484
  { PseudoVMFGT_VF32_M2, VMFGT_VF }, // 7485
  { PseudoVMFGT_VF32_M2_MASK, VMFGT_VF }, // 7486
  { PseudoVMFGT_VF32_M4, VMFGT_VF }, // 7487
  { PseudoVMFGT_VF32_M4_MASK, VMFGT_VF }, // 7488
  { PseudoVMFGT_VF32_M8, VMFGT_VF }, // 7489
  { PseudoVMFGT_VF32_M8_MASK, VMFGT_VF }, // 7490
  { PseudoVMFGT_VF32_MF2, VMFGT_VF }, // 7491
  { PseudoVMFGT_VF32_MF2_MASK, VMFGT_VF }, // 7492
  { PseudoVMFGT_VF32_MF4, VMFGT_VF }, // 7493
  { PseudoVMFGT_VF32_MF4_MASK, VMFGT_VF }, // 7494
  { PseudoVMFGT_VF32_MF8, VMFGT_VF }, // 7495
  { PseudoVMFGT_VF32_MF8_MASK, VMFGT_VF }, // 7496
  { PseudoVMFGT_VF64_M1, VMFGT_VF }, // 7497
  { PseudoVMFGT_VF64_M1_MASK, VMFGT_VF }, // 7498
  { PseudoVMFGT_VF64_M2, VMFGT_VF }, // 7499
  { PseudoVMFGT_VF64_M2_MASK, VMFGT_VF }, // 7500
  { PseudoVMFGT_VF64_M4, VMFGT_VF }, // 7501
  { PseudoVMFGT_VF64_M4_MASK, VMFGT_VF }, // 7502
  { PseudoVMFGT_VF64_M8, VMFGT_VF }, // 7503
  { PseudoVMFGT_VF64_M8_MASK, VMFGT_VF }, // 7504
  { PseudoVMFGT_VF64_MF2, VMFGT_VF }, // 7505
  { PseudoVMFGT_VF64_MF2_MASK, VMFGT_VF }, // 7506
  { PseudoVMFGT_VF64_MF4, VMFGT_VF }, // 7507
  { PseudoVMFGT_VF64_MF4_MASK, VMFGT_VF }, // 7508
  { PseudoVMFGT_VF64_MF8, VMFGT_VF }, // 7509
  { PseudoVMFGT_VF64_MF8_MASK, VMFGT_VF }, // 7510
  { PseudoVMFLE_VF16_M1, VMFLE_VF }, // 7511
  { PseudoVMFLE_VF16_M1_MASK, VMFLE_VF }, // 7512
  { PseudoVMFLE_VF16_M2, VMFLE_VF }, // 7513
  { PseudoVMFLE_VF16_M2_MASK, VMFLE_VF }, // 7514
  { PseudoVMFLE_VF16_M4, VMFLE_VF }, // 7515
  { PseudoVMFLE_VF16_M4_MASK, VMFLE_VF }, // 7516
  { PseudoVMFLE_VF16_M8, VMFLE_VF }, // 7517
  { PseudoVMFLE_VF16_M8_MASK, VMFLE_VF }, // 7518
  { PseudoVMFLE_VF16_MF2, VMFLE_VF }, // 7519
  { PseudoVMFLE_VF16_MF2_MASK, VMFLE_VF }, // 7520
  { PseudoVMFLE_VF16_MF4, VMFLE_VF }, // 7521
  { PseudoVMFLE_VF16_MF4_MASK, VMFLE_VF }, // 7522
  { PseudoVMFLE_VF16_MF8, VMFLE_VF }, // 7523
  { PseudoVMFLE_VF16_MF8_MASK, VMFLE_VF }, // 7524
  { PseudoVMFLE_VF32_M1, VMFLE_VF }, // 7525
  { PseudoVMFLE_VF32_M1_MASK, VMFLE_VF }, // 7526
  { PseudoVMFLE_VF32_M2, VMFLE_VF }, // 7527
  { PseudoVMFLE_VF32_M2_MASK, VMFLE_VF }, // 7528
  { PseudoVMFLE_VF32_M4, VMFLE_VF }, // 7529
  { PseudoVMFLE_VF32_M4_MASK, VMFLE_VF }, // 7530
  { PseudoVMFLE_VF32_M8, VMFLE_VF }, // 7531
  { PseudoVMFLE_VF32_M8_MASK, VMFLE_VF }, // 7532
  { PseudoVMFLE_VF32_MF2, VMFLE_VF }, // 7533
  { PseudoVMFLE_VF32_MF2_MASK, VMFLE_VF }, // 7534
  { PseudoVMFLE_VF32_MF4, VMFLE_VF }, // 7535
  { PseudoVMFLE_VF32_MF4_MASK, VMFLE_VF }, // 7536
  { PseudoVMFLE_VF32_MF8, VMFLE_VF }, // 7537
  { PseudoVMFLE_VF32_MF8_MASK, VMFLE_VF }, // 7538
  { PseudoVMFLE_VF64_M1, VMFLE_VF }, // 7539
  { PseudoVMFLE_VF64_M1_MASK, VMFLE_VF }, // 7540
  { PseudoVMFLE_VF64_M2, VMFLE_VF }, // 7541
  { PseudoVMFLE_VF64_M2_MASK, VMFLE_VF }, // 7542
  { PseudoVMFLE_VF64_M4, VMFLE_VF }, // 7543
  { PseudoVMFLE_VF64_M4_MASK, VMFLE_VF }, // 7544
  { PseudoVMFLE_VF64_M8, VMFLE_VF }, // 7545
  { PseudoVMFLE_VF64_M8_MASK, VMFLE_VF }, // 7546
  { PseudoVMFLE_VF64_MF2, VMFLE_VF }, // 7547
  { PseudoVMFLE_VF64_MF2_MASK, VMFLE_VF }, // 7548
  { PseudoVMFLE_VF64_MF4, VMFLE_VF }, // 7549
  { PseudoVMFLE_VF64_MF4_MASK, VMFLE_VF }, // 7550
  { PseudoVMFLE_VF64_MF8, VMFLE_VF }, // 7551
  { PseudoVMFLE_VF64_MF8_MASK, VMFLE_VF }, // 7552
  { PseudoVMFLE_VV_M1, VMFLE_VV }, // 7553
  { PseudoVMFLE_VV_M1_MASK, VMFLE_VV }, // 7554
  { PseudoVMFLE_VV_M2, VMFLE_VV }, // 7555
  { PseudoVMFLE_VV_M2_MASK, VMFLE_VV }, // 7556
  { PseudoVMFLE_VV_M4, VMFLE_VV }, // 7557
  { PseudoVMFLE_VV_M4_MASK, VMFLE_VV }, // 7558
  { PseudoVMFLE_VV_M8, VMFLE_VV }, // 7559
  { PseudoVMFLE_VV_M8_MASK, VMFLE_VV }, // 7560
  { PseudoVMFLE_VV_MF2, VMFLE_VV }, // 7561
  { PseudoVMFLE_VV_MF2_MASK, VMFLE_VV }, // 7562
  { PseudoVMFLE_VV_MF4, VMFLE_VV }, // 7563
  { PseudoVMFLE_VV_MF4_MASK, VMFLE_VV }, // 7564
  { PseudoVMFLE_VV_MF8, VMFLE_VV }, // 7565
  { PseudoVMFLE_VV_MF8_MASK, VMFLE_VV }, // 7566
  { PseudoVMFLT_VF16_M1, VMFLT_VF }, // 7567
  { PseudoVMFLT_VF16_M1_MASK, VMFLT_VF }, // 7568
  { PseudoVMFLT_VF16_M2, VMFLT_VF }, // 7569
  { PseudoVMFLT_VF16_M2_MASK, VMFLT_VF }, // 7570
  { PseudoVMFLT_VF16_M4, VMFLT_VF }, // 7571
  { PseudoVMFLT_VF16_M4_MASK, VMFLT_VF }, // 7572
  { PseudoVMFLT_VF16_M8, VMFLT_VF }, // 7573
  { PseudoVMFLT_VF16_M8_MASK, VMFLT_VF }, // 7574
  { PseudoVMFLT_VF16_MF2, VMFLT_VF }, // 7575
  { PseudoVMFLT_VF16_MF2_MASK, VMFLT_VF }, // 7576
  { PseudoVMFLT_VF16_MF4, VMFLT_VF }, // 7577
  { PseudoVMFLT_VF16_MF4_MASK, VMFLT_VF }, // 7578
  { PseudoVMFLT_VF16_MF8, VMFLT_VF }, // 7579
  { PseudoVMFLT_VF16_MF8_MASK, VMFLT_VF }, // 7580
  { PseudoVMFLT_VF32_M1, VMFLT_VF }, // 7581
  { PseudoVMFLT_VF32_M1_MASK, VMFLT_VF }, // 7582
  { PseudoVMFLT_VF32_M2, VMFLT_VF }, // 7583
  { PseudoVMFLT_VF32_M2_MASK, VMFLT_VF }, // 7584
  { PseudoVMFLT_VF32_M4, VMFLT_VF }, // 7585
  { PseudoVMFLT_VF32_M4_MASK, VMFLT_VF }, // 7586
  { PseudoVMFLT_VF32_M8, VMFLT_VF }, // 7587
  { PseudoVMFLT_VF32_M8_MASK, VMFLT_VF }, // 7588
  { PseudoVMFLT_VF32_MF2, VMFLT_VF }, // 7589
  { PseudoVMFLT_VF32_MF2_MASK, VMFLT_VF }, // 7590
  { PseudoVMFLT_VF32_MF4, VMFLT_VF }, // 7591
  { PseudoVMFLT_VF32_MF4_MASK, VMFLT_VF }, // 7592
  { PseudoVMFLT_VF32_MF8, VMFLT_VF }, // 7593
  { PseudoVMFLT_VF32_MF8_MASK, VMFLT_VF }, // 7594
  { PseudoVMFLT_VF64_M1, VMFLT_VF }, // 7595
  { PseudoVMFLT_VF64_M1_MASK, VMFLT_VF }, // 7596
  { PseudoVMFLT_VF64_M2, VMFLT_VF }, // 7597
  { PseudoVMFLT_VF64_M2_MASK, VMFLT_VF }, // 7598
  { PseudoVMFLT_VF64_M4, VMFLT_VF }, // 7599
  { PseudoVMFLT_VF64_M4_MASK, VMFLT_VF }, // 7600
  { PseudoVMFLT_VF64_M8, VMFLT_VF }, // 7601
  { PseudoVMFLT_VF64_M8_MASK, VMFLT_VF }, // 7602
  { PseudoVMFLT_VF64_MF2, VMFLT_VF }, // 7603
  { PseudoVMFLT_VF64_MF2_MASK, VMFLT_VF }, // 7604
  { PseudoVMFLT_VF64_MF4, VMFLT_VF }, // 7605
  { PseudoVMFLT_VF64_MF4_MASK, VMFLT_VF }, // 7606
  { PseudoVMFLT_VF64_MF8, VMFLT_VF }, // 7607
  { PseudoVMFLT_VF64_MF8_MASK, VMFLT_VF }, // 7608
  { PseudoVMFLT_VV_M1, VMFLT_VV }, // 7609
  { PseudoVMFLT_VV_M1_MASK, VMFLT_VV }, // 7610
  { PseudoVMFLT_VV_M2, VMFLT_VV }, // 7611
  { PseudoVMFLT_VV_M2_MASK, VMFLT_VV }, // 7612
  { PseudoVMFLT_VV_M4, VMFLT_VV }, // 7613
  { PseudoVMFLT_VV_M4_MASK, VMFLT_VV }, // 7614
  { PseudoVMFLT_VV_M8, VMFLT_VV }, // 7615
  { PseudoVMFLT_VV_M8_MASK, VMFLT_VV }, // 7616
  { PseudoVMFLT_VV_MF2, VMFLT_VV }, // 7617
  { PseudoVMFLT_VV_MF2_MASK, VMFLT_VV }, // 7618
  { PseudoVMFLT_VV_MF4, VMFLT_VV }, // 7619
  { PseudoVMFLT_VV_MF4_MASK, VMFLT_VV }, // 7620
  { PseudoVMFLT_VV_MF8, VMFLT_VV }, // 7621
  { PseudoVMFLT_VV_MF8_MASK, VMFLT_VV }, // 7622
  { PseudoVMFNE_VF16_M1, VMFNE_VF }, // 7623
  { PseudoVMFNE_VF16_M1_MASK, VMFNE_VF }, // 7624
  { PseudoVMFNE_VF16_M2, VMFNE_VF }, // 7625
  { PseudoVMFNE_VF16_M2_MASK, VMFNE_VF }, // 7626
  { PseudoVMFNE_VF16_M4, VMFNE_VF }, // 7627
  { PseudoVMFNE_VF16_M4_MASK, VMFNE_VF }, // 7628
  { PseudoVMFNE_VF16_M8, VMFNE_VF }, // 7629
  { PseudoVMFNE_VF16_M8_MASK, VMFNE_VF }, // 7630
  { PseudoVMFNE_VF16_MF2, VMFNE_VF }, // 7631
  { PseudoVMFNE_VF16_MF2_MASK, VMFNE_VF }, // 7632
  { PseudoVMFNE_VF16_MF4, VMFNE_VF }, // 7633
  { PseudoVMFNE_VF16_MF4_MASK, VMFNE_VF }, // 7634
  { PseudoVMFNE_VF16_MF8, VMFNE_VF }, // 7635
  { PseudoVMFNE_VF16_MF8_MASK, VMFNE_VF }, // 7636
  { PseudoVMFNE_VF32_M1, VMFNE_VF }, // 7637
  { PseudoVMFNE_VF32_M1_MASK, VMFNE_VF }, // 7638
  { PseudoVMFNE_VF32_M2, VMFNE_VF }, // 7639
  { PseudoVMFNE_VF32_M2_MASK, VMFNE_VF }, // 7640
  { PseudoVMFNE_VF32_M4, VMFNE_VF }, // 7641
  { PseudoVMFNE_VF32_M4_MASK, VMFNE_VF }, // 7642
  { PseudoVMFNE_VF32_M8, VMFNE_VF }, // 7643
  { PseudoVMFNE_VF32_M8_MASK, VMFNE_VF }, // 7644
  { PseudoVMFNE_VF32_MF2, VMFNE_VF }, // 7645
  { PseudoVMFNE_VF32_MF2_MASK, VMFNE_VF }, // 7646
  { PseudoVMFNE_VF32_MF4, VMFNE_VF }, // 7647
  { PseudoVMFNE_VF32_MF4_MASK, VMFNE_VF }, // 7648
  { PseudoVMFNE_VF32_MF8, VMFNE_VF }, // 7649
  { PseudoVMFNE_VF32_MF8_MASK, VMFNE_VF }, // 7650
  { PseudoVMFNE_VF64_M1, VMFNE_VF }, // 7651
  { PseudoVMFNE_VF64_M1_MASK, VMFNE_VF }, // 7652
  { PseudoVMFNE_VF64_M2, VMFNE_VF }, // 7653
  { PseudoVMFNE_VF64_M2_MASK, VMFNE_VF }, // 7654
  { PseudoVMFNE_VF64_M4, VMFNE_VF }, // 7655
  { PseudoVMFNE_VF64_M4_MASK, VMFNE_VF }, // 7656
  { PseudoVMFNE_VF64_M8, VMFNE_VF }, // 7657
  { PseudoVMFNE_VF64_M8_MASK, VMFNE_VF }, // 7658
  { PseudoVMFNE_VF64_MF2, VMFNE_VF }, // 7659
  { PseudoVMFNE_VF64_MF2_MASK, VMFNE_VF }, // 7660
  { PseudoVMFNE_VF64_MF4, VMFNE_VF }, // 7661
  { PseudoVMFNE_VF64_MF4_MASK, VMFNE_VF }, // 7662
  { PseudoVMFNE_VF64_MF8, VMFNE_VF }, // 7663
  { PseudoVMFNE_VF64_MF8_MASK, VMFNE_VF }, // 7664
  { PseudoVMFNE_VV_M1, VMFNE_VV }, // 7665
  { PseudoVMFNE_VV_M1_MASK, VMFNE_VV }, // 7666
  { PseudoVMFNE_VV_M2, VMFNE_VV }, // 7667
  { PseudoVMFNE_VV_M2_MASK, VMFNE_VV }, // 7668
  { PseudoVMFNE_VV_M4, VMFNE_VV }, // 7669
  { PseudoVMFNE_VV_M4_MASK, VMFNE_VV }, // 7670
  { PseudoVMFNE_VV_M8, VMFNE_VV }, // 7671
  { PseudoVMFNE_VV_M8_MASK, VMFNE_VV }, // 7672
  { PseudoVMFNE_VV_MF2, VMFNE_VV }, // 7673
  { PseudoVMFNE_VV_MF2_MASK, VMFNE_VV }, // 7674
  { PseudoVMFNE_VV_MF4, VMFNE_VV }, // 7675
  { PseudoVMFNE_VV_MF4_MASK, VMFNE_VV }, // 7676
  { PseudoVMFNE_VV_MF8, VMFNE_VV }, // 7677
  { PseudoVMFNE_VV_MF8_MASK, VMFNE_VV }, // 7678
  { PseudoVMINU_VV_M1, VMINU_VV }, // 7679
  { PseudoVMINU_VV_M1_MASK, VMINU_VV }, // 7680
  { PseudoVMINU_VV_M2, VMINU_VV }, // 7681
  { PseudoVMINU_VV_M2_MASK, VMINU_VV }, // 7682
  { PseudoVMINU_VV_M4, VMINU_VV }, // 7683
  { PseudoVMINU_VV_M4_MASK, VMINU_VV }, // 7684
  { PseudoVMINU_VV_M8, VMINU_VV }, // 7685
  { PseudoVMINU_VV_M8_MASK, VMINU_VV }, // 7686
  { PseudoVMINU_VV_MF2, VMINU_VV }, // 7687
  { PseudoVMINU_VV_MF2_MASK, VMINU_VV }, // 7688
  { PseudoVMINU_VV_MF4, VMINU_VV }, // 7689
  { PseudoVMINU_VV_MF4_MASK, VMINU_VV }, // 7690
  { PseudoVMINU_VV_MF8, VMINU_VV }, // 7691
  { PseudoVMINU_VV_MF8_MASK, VMINU_VV }, // 7692
  { PseudoVMINU_VX_M1, VMINU_VX }, // 7693
  { PseudoVMINU_VX_M1_MASK, VMINU_VX }, // 7694
  { PseudoVMINU_VX_M2, VMINU_VX }, // 7695
  { PseudoVMINU_VX_M2_MASK, VMINU_VX }, // 7696
  { PseudoVMINU_VX_M4, VMINU_VX }, // 7697
  { PseudoVMINU_VX_M4_MASK, VMINU_VX }, // 7698
  { PseudoVMINU_VX_M8, VMINU_VX }, // 7699
  { PseudoVMINU_VX_M8_MASK, VMINU_VX }, // 7700
  { PseudoVMINU_VX_MF2, VMINU_VX }, // 7701
  { PseudoVMINU_VX_MF2_MASK, VMINU_VX }, // 7702
  { PseudoVMINU_VX_MF4, VMINU_VX }, // 7703
  { PseudoVMINU_VX_MF4_MASK, VMINU_VX }, // 7704
  { PseudoVMINU_VX_MF8, VMINU_VX }, // 7705
  { PseudoVMINU_VX_MF8_MASK, VMINU_VX }, // 7706
  { PseudoVMIN_VV_M1, VMIN_VV }, // 7707
  { PseudoVMIN_VV_M1_MASK, VMIN_VV }, // 7708
  { PseudoVMIN_VV_M2, VMIN_VV }, // 7709
  { PseudoVMIN_VV_M2_MASK, VMIN_VV }, // 7710
  { PseudoVMIN_VV_M4, VMIN_VV }, // 7711
  { PseudoVMIN_VV_M4_MASK, VMIN_VV }, // 7712
  { PseudoVMIN_VV_M8, VMIN_VV }, // 7713
  { PseudoVMIN_VV_M8_MASK, VMIN_VV }, // 7714
  { PseudoVMIN_VV_MF2, VMIN_VV }, // 7715
  { PseudoVMIN_VV_MF2_MASK, VMIN_VV }, // 7716
  { PseudoVMIN_VV_MF4, VMIN_VV }, // 7717
  { PseudoVMIN_VV_MF4_MASK, VMIN_VV }, // 7718
  { PseudoVMIN_VV_MF8, VMIN_VV }, // 7719
  { PseudoVMIN_VV_MF8_MASK, VMIN_VV }, // 7720
  { PseudoVMIN_VX_M1, VMIN_VX }, // 7721
  { PseudoVMIN_VX_M1_MASK, VMIN_VX }, // 7722
  { PseudoVMIN_VX_M2, VMIN_VX }, // 7723
  { PseudoVMIN_VX_M2_MASK, VMIN_VX }, // 7724
  { PseudoVMIN_VX_M4, VMIN_VX }, // 7725
  { PseudoVMIN_VX_M4_MASK, VMIN_VX }, // 7726
  { PseudoVMIN_VX_M8, VMIN_VX }, // 7727
  { PseudoVMIN_VX_M8_MASK, VMIN_VX }, // 7728
  { PseudoVMIN_VX_MF2, VMIN_VX }, // 7729
  { PseudoVMIN_VX_MF2_MASK, VMIN_VX }, // 7730
  { PseudoVMIN_VX_MF4, VMIN_VX }, // 7731
  { PseudoVMIN_VX_MF4_MASK, VMIN_VX }, // 7732
  { PseudoVMIN_VX_MF8, VMIN_VX }, // 7733
  { PseudoVMIN_VX_MF8_MASK, VMIN_VX }, // 7734
  { PseudoVMNAND_MM_M1, VMNAND_MM }, // 7735
  { PseudoVMNAND_MM_M2, VMNAND_MM }, // 7736
  { PseudoVMNAND_MM_M4, VMNAND_MM }, // 7737
  { PseudoVMNAND_MM_M8, VMNAND_MM }, // 7738
  { PseudoVMNAND_MM_MF2, VMNAND_MM }, // 7739
  { PseudoVMNAND_MM_MF4, VMNAND_MM }, // 7740
  { PseudoVMNAND_MM_MF8, VMNAND_MM }, // 7741
  { PseudoVMNOR_MM_M1, VMNOR_MM }, // 7742
  { PseudoVMNOR_MM_M2, VMNOR_MM }, // 7743
  { PseudoVMNOR_MM_M4, VMNOR_MM }, // 7744
  { PseudoVMNOR_MM_M8, VMNOR_MM }, // 7745
  { PseudoVMNOR_MM_MF2, VMNOR_MM }, // 7746
  { PseudoVMNOR_MM_MF4, VMNOR_MM }, // 7747
  { PseudoVMNOR_MM_MF8, VMNOR_MM }, // 7748
  { PseudoVMORNOT_MM_M1, VMORNOT_MM }, // 7749
  { PseudoVMORNOT_MM_M2, VMORNOT_MM }, // 7750
  { PseudoVMORNOT_MM_M4, VMORNOT_MM }, // 7751
  { PseudoVMORNOT_MM_M8, VMORNOT_MM }, // 7752
  { PseudoVMORNOT_MM_MF2, VMORNOT_MM }, // 7753
  { PseudoVMORNOT_MM_MF4, VMORNOT_MM }, // 7754
  { PseudoVMORNOT_MM_MF8, VMORNOT_MM }, // 7755
  { PseudoVMOR_MM_M1, VMOR_MM }, // 7756
  { PseudoVMOR_MM_M2, VMOR_MM }, // 7757
  { PseudoVMOR_MM_M4, VMOR_MM }, // 7758
  { PseudoVMOR_MM_M8, VMOR_MM }, // 7759
  { PseudoVMOR_MM_MF2, VMOR_MM }, // 7760
  { PseudoVMOR_MM_MF4, VMOR_MM }, // 7761
  { PseudoVMOR_MM_MF8, VMOR_MM }, // 7762
  { PseudoVMSBC_VVM_M1, VMSBC_VVM }, // 7763
  { PseudoVMSBC_VVM_M2, VMSBC_VVM }, // 7764
  { PseudoVMSBC_VVM_M4, VMSBC_VVM }, // 7765
  { PseudoVMSBC_VVM_M8, VMSBC_VVM }, // 7766
  { PseudoVMSBC_VVM_MF2, VMSBC_VVM }, // 7767
  { PseudoVMSBC_VVM_MF4, VMSBC_VVM }, // 7768
  { PseudoVMSBC_VVM_MF8, VMSBC_VVM }, // 7769
  { PseudoVMSBC_VV_M1, VMSBC_VV }, // 7770
  { PseudoVMSBC_VV_M2, VMSBC_VV }, // 7771
  { PseudoVMSBC_VV_M4, VMSBC_VV }, // 7772
  { PseudoVMSBC_VV_M8, VMSBC_VV }, // 7773
  { PseudoVMSBC_VV_MF2, VMSBC_VV }, // 7774
  { PseudoVMSBC_VV_MF4, VMSBC_VV }, // 7775
  { PseudoVMSBC_VV_MF8, VMSBC_VV }, // 7776
  { PseudoVMSBC_VXM_M1, VMSBC_VXM }, // 7777
  { PseudoVMSBC_VXM_M2, VMSBC_VXM }, // 7778
  { PseudoVMSBC_VXM_M4, VMSBC_VXM }, // 7779
  { PseudoVMSBC_VXM_M8, VMSBC_VXM }, // 7780
  { PseudoVMSBC_VXM_MF2, VMSBC_VXM }, // 7781
  { PseudoVMSBC_VXM_MF4, VMSBC_VXM }, // 7782
  { PseudoVMSBC_VXM_MF8, VMSBC_VXM }, // 7783
  { PseudoVMSBC_VX_M1, VMSBC_VX }, // 7784
  { PseudoVMSBC_VX_M2, VMSBC_VX }, // 7785
  { PseudoVMSBC_VX_M4, VMSBC_VX }, // 7786
  { PseudoVMSBC_VX_M8, VMSBC_VX }, // 7787
  { PseudoVMSBC_VX_MF2, VMSBC_VX }, // 7788
  { PseudoVMSBC_VX_MF4, VMSBC_VX }, // 7789
  { PseudoVMSBC_VX_MF8, VMSBC_VX }, // 7790
  { PseudoVMSBF_M_B1, VMSBF_M }, // 7791
  { PseudoVMSBF_M_B16, VMSBF_M }, // 7792
  { PseudoVMSBF_M_B16_MASK, VMSBF_M }, // 7793
  { PseudoVMSBF_M_B1_MASK, VMSBF_M }, // 7794
  { PseudoVMSBF_M_B2, VMSBF_M }, // 7795
  { PseudoVMSBF_M_B2_MASK, VMSBF_M }, // 7796
  { PseudoVMSBF_M_B32, VMSBF_M }, // 7797
  { PseudoVMSBF_M_B32_MASK, VMSBF_M }, // 7798
  { PseudoVMSBF_M_B4, VMSBF_M }, // 7799
  { PseudoVMSBF_M_B4_MASK, VMSBF_M }, // 7800
  { PseudoVMSBF_M_B64, VMSBF_M }, // 7801
  { PseudoVMSBF_M_B64_MASK, VMSBF_M }, // 7802
  { PseudoVMSBF_M_B8, VMSBF_M }, // 7803
  { PseudoVMSBF_M_B8_MASK, VMSBF_M }, // 7804
  { PseudoVMSEQ_VI_M1, VMSEQ_VI }, // 7805
  { PseudoVMSEQ_VI_M1_MASK, VMSEQ_VI }, // 7806
  { PseudoVMSEQ_VI_M2, VMSEQ_VI }, // 7807
  { PseudoVMSEQ_VI_M2_MASK, VMSEQ_VI }, // 7808
  { PseudoVMSEQ_VI_M4, VMSEQ_VI }, // 7809
  { PseudoVMSEQ_VI_M4_MASK, VMSEQ_VI }, // 7810
  { PseudoVMSEQ_VI_M8, VMSEQ_VI }, // 7811
  { PseudoVMSEQ_VI_M8_MASK, VMSEQ_VI }, // 7812
  { PseudoVMSEQ_VI_MF2, VMSEQ_VI }, // 7813
  { PseudoVMSEQ_VI_MF2_MASK, VMSEQ_VI }, // 7814
  { PseudoVMSEQ_VI_MF4, VMSEQ_VI }, // 7815
  { PseudoVMSEQ_VI_MF4_MASK, VMSEQ_VI }, // 7816
  { PseudoVMSEQ_VI_MF8, VMSEQ_VI }, // 7817
  { PseudoVMSEQ_VI_MF8_MASK, VMSEQ_VI }, // 7818
  { PseudoVMSEQ_VV_M1, VMSEQ_VV }, // 7819
  { PseudoVMSEQ_VV_M1_MASK, VMSEQ_VV }, // 7820
  { PseudoVMSEQ_VV_M2, VMSEQ_VV }, // 7821
  { PseudoVMSEQ_VV_M2_MASK, VMSEQ_VV }, // 7822
  { PseudoVMSEQ_VV_M4, VMSEQ_VV }, // 7823
  { PseudoVMSEQ_VV_M4_MASK, VMSEQ_VV }, // 7824
  { PseudoVMSEQ_VV_M8, VMSEQ_VV }, // 7825
  { PseudoVMSEQ_VV_M8_MASK, VMSEQ_VV }, // 7826
  { PseudoVMSEQ_VV_MF2, VMSEQ_VV }, // 7827
  { PseudoVMSEQ_VV_MF2_MASK, VMSEQ_VV }, // 7828
  { PseudoVMSEQ_VV_MF4, VMSEQ_VV }, // 7829
  { PseudoVMSEQ_VV_MF4_MASK, VMSEQ_VV }, // 7830
  { PseudoVMSEQ_VV_MF8, VMSEQ_VV }, // 7831
  { PseudoVMSEQ_VV_MF8_MASK, VMSEQ_VV }, // 7832
  { PseudoVMSEQ_VX_M1, VMSEQ_VX }, // 7833
  { PseudoVMSEQ_VX_M1_MASK, VMSEQ_VX }, // 7834
  { PseudoVMSEQ_VX_M2, VMSEQ_VX }, // 7835
  { PseudoVMSEQ_VX_M2_MASK, VMSEQ_VX }, // 7836
  { PseudoVMSEQ_VX_M4, VMSEQ_VX }, // 7837
  { PseudoVMSEQ_VX_M4_MASK, VMSEQ_VX }, // 7838
  { PseudoVMSEQ_VX_M8, VMSEQ_VX }, // 7839
  { PseudoVMSEQ_VX_M8_MASK, VMSEQ_VX }, // 7840
  { PseudoVMSEQ_VX_MF2, VMSEQ_VX }, // 7841
  { PseudoVMSEQ_VX_MF2_MASK, VMSEQ_VX }, // 7842
  { PseudoVMSEQ_VX_MF4, VMSEQ_VX }, // 7843
  { PseudoVMSEQ_VX_MF4_MASK, VMSEQ_VX }, // 7844
  { PseudoVMSEQ_VX_MF8, VMSEQ_VX }, // 7845
  { PseudoVMSEQ_VX_MF8_MASK, VMSEQ_VX }, // 7846
  { PseudoVMSET_M_B1, VMXNOR_MM }, // 7847
  { PseudoVMSET_M_B16, VMXNOR_MM }, // 7848
  { PseudoVMSET_M_B2, VMXNOR_MM }, // 7849
  { PseudoVMSET_M_B32, VMXNOR_MM }, // 7850
  { PseudoVMSET_M_B4, VMXNOR_MM }, // 7851
  { PseudoVMSET_M_B64, VMXNOR_MM }, // 7852
  { PseudoVMSET_M_B8, VMXNOR_MM }, // 7853
  { PseudoVMSGTU_VI_M1, VMSGTU_VI }, // 7854
  { PseudoVMSGTU_VI_M1_MASK, VMSGTU_VI }, // 7855
  { PseudoVMSGTU_VI_M2, VMSGTU_VI }, // 7856
  { PseudoVMSGTU_VI_M2_MASK, VMSGTU_VI }, // 7857
  { PseudoVMSGTU_VI_M4, VMSGTU_VI }, // 7858
  { PseudoVMSGTU_VI_M4_MASK, VMSGTU_VI }, // 7859
  { PseudoVMSGTU_VI_M8, VMSGTU_VI }, // 7860
  { PseudoVMSGTU_VI_M8_MASK, VMSGTU_VI }, // 7861
  { PseudoVMSGTU_VI_MF2, VMSGTU_VI }, // 7862
  { PseudoVMSGTU_VI_MF2_MASK, VMSGTU_VI }, // 7863
  { PseudoVMSGTU_VI_MF4, VMSGTU_VI }, // 7864
  { PseudoVMSGTU_VI_MF4_MASK, VMSGTU_VI }, // 7865
  { PseudoVMSGTU_VI_MF8, VMSGTU_VI }, // 7866
  { PseudoVMSGTU_VI_MF8_MASK, VMSGTU_VI }, // 7867
  { PseudoVMSGTU_VX_M1, VMSGTU_VX }, // 7868
  { PseudoVMSGTU_VX_M1_MASK, VMSGTU_VX }, // 7869
  { PseudoVMSGTU_VX_M2, VMSGTU_VX }, // 7870
  { PseudoVMSGTU_VX_M2_MASK, VMSGTU_VX }, // 7871
  { PseudoVMSGTU_VX_M4, VMSGTU_VX }, // 7872
  { PseudoVMSGTU_VX_M4_MASK, VMSGTU_VX }, // 7873
  { PseudoVMSGTU_VX_M8, VMSGTU_VX }, // 7874
  { PseudoVMSGTU_VX_M8_MASK, VMSGTU_VX }, // 7875
  { PseudoVMSGTU_VX_MF2, VMSGTU_VX }, // 7876
  { PseudoVMSGTU_VX_MF2_MASK, VMSGTU_VX }, // 7877
  { PseudoVMSGTU_VX_MF4, VMSGTU_VX }, // 7878
  { PseudoVMSGTU_VX_MF4_MASK, VMSGTU_VX }, // 7879
  { PseudoVMSGTU_VX_MF8, VMSGTU_VX }, // 7880
  { PseudoVMSGTU_VX_MF8_MASK, VMSGTU_VX }, // 7881
  { PseudoVMSGT_VI_M1, VMSGT_VI }, // 7882
  { PseudoVMSGT_VI_M1_MASK, VMSGT_VI }, // 7883
  { PseudoVMSGT_VI_M2, VMSGT_VI }, // 7884
  { PseudoVMSGT_VI_M2_MASK, VMSGT_VI }, // 7885
  { PseudoVMSGT_VI_M4, VMSGT_VI }, // 7886
  { PseudoVMSGT_VI_M4_MASK, VMSGT_VI }, // 7887
  { PseudoVMSGT_VI_M8, VMSGT_VI }, // 7888
  { PseudoVMSGT_VI_M8_MASK, VMSGT_VI }, // 7889
  { PseudoVMSGT_VI_MF2, VMSGT_VI }, // 7890
  { PseudoVMSGT_VI_MF2_MASK, VMSGT_VI }, // 7891
  { PseudoVMSGT_VI_MF4, VMSGT_VI }, // 7892
  { PseudoVMSGT_VI_MF4_MASK, VMSGT_VI }, // 7893
  { PseudoVMSGT_VI_MF8, VMSGT_VI }, // 7894
  { PseudoVMSGT_VI_MF8_MASK, VMSGT_VI }, // 7895
  { PseudoVMSGT_VX_M1, VMSGT_VX }, // 7896
  { PseudoVMSGT_VX_M1_MASK, VMSGT_VX }, // 7897
  { PseudoVMSGT_VX_M2, VMSGT_VX }, // 7898
  { PseudoVMSGT_VX_M2_MASK, VMSGT_VX }, // 7899
  { PseudoVMSGT_VX_M4, VMSGT_VX }, // 7900
  { PseudoVMSGT_VX_M4_MASK, VMSGT_VX }, // 7901
  { PseudoVMSGT_VX_M8, VMSGT_VX }, // 7902
  { PseudoVMSGT_VX_M8_MASK, VMSGT_VX }, // 7903
  { PseudoVMSGT_VX_MF2, VMSGT_VX }, // 7904
  { PseudoVMSGT_VX_MF2_MASK, VMSGT_VX }, // 7905
  { PseudoVMSGT_VX_MF4, VMSGT_VX }, // 7906
  { PseudoVMSGT_VX_MF4_MASK, VMSGT_VX }, // 7907
  { PseudoVMSGT_VX_MF8, VMSGT_VX }, // 7908
  { PseudoVMSGT_VX_MF8_MASK, VMSGT_VX }, // 7909
  { PseudoVMSIF_M_B1, VMSIF_M }, // 7910
  { PseudoVMSIF_M_B16, VMSIF_M }, // 7911
  { PseudoVMSIF_M_B16_MASK, VMSIF_M }, // 7912
  { PseudoVMSIF_M_B1_MASK, VMSIF_M }, // 7913
  { PseudoVMSIF_M_B2, VMSIF_M }, // 7914
  { PseudoVMSIF_M_B2_MASK, VMSIF_M }, // 7915
  { PseudoVMSIF_M_B32, VMSIF_M }, // 7916
  { PseudoVMSIF_M_B32_MASK, VMSIF_M }, // 7917
  { PseudoVMSIF_M_B4, VMSIF_M }, // 7918
  { PseudoVMSIF_M_B4_MASK, VMSIF_M }, // 7919
  { PseudoVMSIF_M_B64, VMSIF_M }, // 7920
  { PseudoVMSIF_M_B64_MASK, VMSIF_M }, // 7921
  { PseudoVMSIF_M_B8, VMSIF_M }, // 7922
  { PseudoVMSIF_M_B8_MASK, VMSIF_M }, // 7923
  { PseudoVMSLEU_VI_M1, VMSLEU_VI }, // 7924
  { PseudoVMSLEU_VI_M1_MASK, VMSLEU_VI }, // 7925
  { PseudoVMSLEU_VI_M2, VMSLEU_VI }, // 7926
  { PseudoVMSLEU_VI_M2_MASK, VMSLEU_VI }, // 7927
  { PseudoVMSLEU_VI_M4, VMSLEU_VI }, // 7928
  { PseudoVMSLEU_VI_M4_MASK, VMSLEU_VI }, // 7929
  { PseudoVMSLEU_VI_M8, VMSLEU_VI }, // 7930
  { PseudoVMSLEU_VI_M8_MASK, VMSLEU_VI }, // 7931
  { PseudoVMSLEU_VI_MF2, VMSLEU_VI }, // 7932
  { PseudoVMSLEU_VI_MF2_MASK, VMSLEU_VI }, // 7933
  { PseudoVMSLEU_VI_MF4, VMSLEU_VI }, // 7934
  { PseudoVMSLEU_VI_MF4_MASK, VMSLEU_VI }, // 7935
  { PseudoVMSLEU_VI_MF8, VMSLEU_VI }, // 7936
  { PseudoVMSLEU_VI_MF8_MASK, VMSLEU_VI }, // 7937
  { PseudoVMSLEU_VV_M1, VMSLEU_VV }, // 7938
  { PseudoVMSLEU_VV_M1_MASK, VMSLEU_VV }, // 7939
  { PseudoVMSLEU_VV_M2, VMSLEU_VV }, // 7940
  { PseudoVMSLEU_VV_M2_MASK, VMSLEU_VV }, // 7941
  { PseudoVMSLEU_VV_M4, VMSLEU_VV }, // 7942
  { PseudoVMSLEU_VV_M4_MASK, VMSLEU_VV }, // 7943
  { PseudoVMSLEU_VV_M8, VMSLEU_VV }, // 7944
  { PseudoVMSLEU_VV_M8_MASK, VMSLEU_VV }, // 7945
  { PseudoVMSLEU_VV_MF2, VMSLEU_VV }, // 7946
  { PseudoVMSLEU_VV_MF2_MASK, VMSLEU_VV }, // 7947
  { PseudoVMSLEU_VV_MF4, VMSLEU_VV }, // 7948
  { PseudoVMSLEU_VV_MF4_MASK, VMSLEU_VV }, // 7949
  { PseudoVMSLEU_VV_MF8, VMSLEU_VV }, // 7950
  { PseudoVMSLEU_VV_MF8_MASK, VMSLEU_VV }, // 7951
  { PseudoVMSLEU_VX_M1, VMSLEU_VX }, // 7952
  { PseudoVMSLEU_VX_M1_MASK, VMSLEU_VX }, // 7953
  { PseudoVMSLEU_VX_M2, VMSLEU_VX }, // 7954
  { PseudoVMSLEU_VX_M2_MASK, VMSLEU_VX }, // 7955
  { PseudoVMSLEU_VX_M4, VMSLEU_VX }, // 7956
  { PseudoVMSLEU_VX_M4_MASK, VMSLEU_VX }, // 7957
  { PseudoVMSLEU_VX_M8, VMSLEU_VX }, // 7958
  { PseudoVMSLEU_VX_M8_MASK, VMSLEU_VX }, // 7959
  { PseudoVMSLEU_VX_MF2, VMSLEU_VX }, // 7960
  { PseudoVMSLEU_VX_MF2_MASK, VMSLEU_VX }, // 7961
  { PseudoVMSLEU_VX_MF4, VMSLEU_VX }, // 7962
  { PseudoVMSLEU_VX_MF4_MASK, VMSLEU_VX }, // 7963
  { PseudoVMSLEU_VX_MF8, VMSLEU_VX }, // 7964
  { PseudoVMSLEU_VX_MF8_MASK, VMSLEU_VX }, // 7965
  { PseudoVMSLE_VI_M1, VMSLE_VI }, // 7966
  { PseudoVMSLE_VI_M1_MASK, VMSLE_VI }, // 7967
  { PseudoVMSLE_VI_M2, VMSLE_VI }, // 7968
  { PseudoVMSLE_VI_M2_MASK, VMSLE_VI }, // 7969
  { PseudoVMSLE_VI_M4, VMSLE_VI }, // 7970
  { PseudoVMSLE_VI_M4_MASK, VMSLE_VI }, // 7971
  { PseudoVMSLE_VI_M8, VMSLE_VI }, // 7972
  { PseudoVMSLE_VI_M8_MASK, VMSLE_VI }, // 7973
  { PseudoVMSLE_VI_MF2, VMSLE_VI }, // 7974
  { PseudoVMSLE_VI_MF2_MASK, VMSLE_VI }, // 7975
  { PseudoVMSLE_VI_MF4, VMSLE_VI }, // 7976
  { PseudoVMSLE_VI_MF4_MASK, VMSLE_VI }, // 7977
  { PseudoVMSLE_VI_MF8, VMSLE_VI }, // 7978
  { PseudoVMSLE_VI_MF8_MASK, VMSLE_VI }, // 7979
  { PseudoVMSLE_VV_M1, VMSLE_VV }, // 7980
  { PseudoVMSLE_VV_M1_MASK, VMSLE_VV }, // 7981
  { PseudoVMSLE_VV_M2, VMSLE_VV }, // 7982
  { PseudoVMSLE_VV_M2_MASK, VMSLE_VV }, // 7983
  { PseudoVMSLE_VV_M4, VMSLE_VV }, // 7984
  { PseudoVMSLE_VV_M4_MASK, VMSLE_VV }, // 7985
  { PseudoVMSLE_VV_M8, VMSLE_VV }, // 7986
  { PseudoVMSLE_VV_M8_MASK, VMSLE_VV }, // 7987
  { PseudoVMSLE_VV_MF2, VMSLE_VV }, // 7988
  { PseudoVMSLE_VV_MF2_MASK, VMSLE_VV }, // 7989
  { PseudoVMSLE_VV_MF4, VMSLE_VV }, // 7990
  { PseudoVMSLE_VV_MF4_MASK, VMSLE_VV }, // 7991
  { PseudoVMSLE_VV_MF8, VMSLE_VV }, // 7992
  { PseudoVMSLE_VV_MF8_MASK, VMSLE_VV }, // 7993
  { PseudoVMSLE_VX_M1, VMSLE_VX }, // 7994
  { PseudoVMSLE_VX_M1_MASK, VMSLE_VX }, // 7995
  { PseudoVMSLE_VX_M2, VMSLE_VX }, // 7996
  { PseudoVMSLE_VX_M2_MASK, VMSLE_VX }, // 7997
  { PseudoVMSLE_VX_M4, VMSLE_VX }, // 7998
  { PseudoVMSLE_VX_M4_MASK, VMSLE_VX }, // 7999
  { PseudoVMSLE_VX_M8, VMSLE_VX }, // 8000
  { PseudoVMSLE_VX_M8_MASK, VMSLE_VX }, // 8001
  { PseudoVMSLE_VX_MF2, VMSLE_VX }, // 8002
  { PseudoVMSLE_VX_MF2_MASK, VMSLE_VX }, // 8003
  { PseudoVMSLE_VX_MF4, VMSLE_VX }, // 8004
  { PseudoVMSLE_VX_MF4_MASK, VMSLE_VX }, // 8005
  { PseudoVMSLE_VX_MF8, VMSLE_VX }, // 8006
  { PseudoVMSLE_VX_MF8_MASK, VMSLE_VX }, // 8007
  { PseudoVMSLTU_VV_M1, VMSLTU_VV }, // 8008
  { PseudoVMSLTU_VV_M1_MASK, VMSLTU_VV }, // 8009
  { PseudoVMSLTU_VV_M2, VMSLTU_VV }, // 8010
  { PseudoVMSLTU_VV_M2_MASK, VMSLTU_VV }, // 8011
  { PseudoVMSLTU_VV_M4, VMSLTU_VV }, // 8012
  { PseudoVMSLTU_VV_M4_MASK, VMSLTU_VV }, // 8013
  { PseudoVMSLTU_VV_M8, VMSLTU_VV }, // 8014
  { PseudoVMSLTU_VV_M8_MASK, VMSLTU_VV }, // 8015
  { PseudoVMSLTU_VV_MF2, VMSLTU_VV }, // 8016
  { PseudoVMSLTU_VV_MF2_MASK, VMSLTU_VV }, // 8017
  { PseudoVMSLTU_VV_MF4, VMSLTU_VV }, // 8018
  { PseudoVMSLTU_VV_MF4_MASK, VMSLTU_VV }, // 8019
  { PseudoVMSLTU_VV_MF8, VMSLTU_VV }, // 8020
  { PseudoVMSLTU_VV_MF8_MASK, VMSLTU_VV }, // 8021
  { PseudoVMSLTU_VX_M1, VMSLTU_VX }, // 8022
  { PseudoVMSLTU_VX_M1_MASK, VMSLTU_VX }, // 8023
  { PseudoVMSLTU_VX_M2, VMSLTU_VX }, // 8024
  { PseudoVMSLTU_VX_M2_MASK, VMSLTU_VX }, // 8025
  { PseudoVMSLTU_VX_M4, VMSLTU_VX }, // 8026
  { PseudoVMSLTU_VX_M4_MASK, VMSLTU_VX }, // 8027
  { PseudoVMSLTU_VX_M8, VMSLTU_VX }, // 8028
  { PseudoVMSLTU_VX_M8_MASK, VMSLTU_VX }, // 8029
  { PseudoVMSLTU_VX_MF2, VMSLTU_VX }, // 8030
  { PseudoVMSLTU_VX_MF2_MASK, VMSLTU_VX }, // 8031
  { PseudoVMSLTU_VX_MF4, VMSLTU_VX }, // 8032
  { PseudoVMSLTU_VX_MF4_MASK, VMSLTU_VX }, // 8033
  { PseudoVMSLTU_VX_MF8, VMSLTU_VX }, // 8034
  { PseudoVMSLTU_VX_MF8_MASK, VMSLTU_VX }, // 8035
  { PseudoVMSLT_VV_M1, VMSLT_VV }, // 8036
  { PseudoVMSLT_VV_M1_MASK, VMSLT_VV }, // 8037
  { PseudoVMSLT_VV_M2, VMSLT_VV }, // 8038
  { PseudoVMSLT_VV_M2_MASK, VMSLT_VV }, // 8039
  { PseudoVMSLT_VV_M4, VMSLT_VV }, // 8040
  { PseudoVMSLT_VV_M4_MASK, VMSLT_VV }, // 8041
  { PseudoVMSLT_VV_M8, VMSLT_VV }, // 8042
  { PseudoVMSLT_VV_M8_MASK, VMSLT_VV }, // 8043
  { PseudoVMSLT_VV_MF2, VMSLT_VV }, // 8044
  { PseudoVMSLT_VV_MF2_MASK, VMSLT_VV }, // 8045
  { PseudoVMSLT_VV_MF4, VMSLT_VV }, // 8046
  { PseudoVMSLT_VV_MF4_MASK, VMSLT_VV }, // 8047
  { PseudoVMSLT_VV_MF8, VMSLT_VV }, // 8048
  { PseudoVMSLT_VV_MF8_MASK, VMSLT_VV }, // 8049
  { PseudoVMSLT_VX_M1, VMSLT_VX }, // 8050
  { PseudoVMSLT_VX_M1_MASK, VMSLT_VX }, // 8051
  { PseudoVMSLT_VX_M2, VMSLT_VX }, // 8052
  { PseudoVMSLT_VX_M2_MASK, VMSLT_VX }, // 8053
  { PseudoVMSLT_VX_M4, VMSLT_VX }, // 8054
  { PseudoVMSLT_VX_M4_MASK, VMSLT_VX }, // 8055
  { PseudoVMSLT_VX_M8, VMSLT_VX }, // 8056
  { PseudoVMSLT_VX_M8_MASK, VMSLT_VX }, // 8057
  { PseudoVMSLT_VX_MF2, VMSLT_VX }, // 8058
  { PseudoVMSLT_VX_MF2_MASK, VMSLT_VX }, // 8059
  { PseudoVMSLT_VX_MF4, VMSLT_VX }, // 8060
  { PseudoVMSLT_VX_MF4_MASK, VMSLT_VX }, // 8061
  { PseudoVMSLT_VX_MF8, VMSLT_VX }, // 8062
  { PseudoVMSLT_VX_MF8_MASK, VMSLT_VX }, // 8063
  { PseudoVMSNE_VI_M1, VMSNE_VI }, // 8064
  { PseudoVMSNE_VI_M1_MASK, VMSNE_VI }, // 8065
  { PseudoVMSNE_VI_M2, VMSNE_VI }, // 8066
  { PseudoVMSNE_VI_M2_MASK, VMSNE_VI }, // 8067
  { PseudoVMSNE_VI_M4, VMSNE_VI }, // 8068
  { PseudoVMSNE_VI_M4_MASK, VMSNE_VI }, // 8069
  { PseudoVMSNE_VI_M8, VMSNE_VI }, // 8070
  { PseudoVMSNE_VI_M8_MASK, VMSNE_VI }, // 8071
  { PseudoVMSNE_VI_MF2, VMSNE_VI }, // 8072
  { PseudoVMSNE_VI_MF2_MASK, VMSNE_VI }, // 8073
  { PseudoVMSNE_VI_MF4, VMSNE_VI }, // 8074
  { PseudoVMSNE_VI_MF4_MASK, VMSNE_VI }, // 8075
  { PseudoVMSNE_VI_MF8, VMSNE_VI }, // 8076
  { PseudoVMSNE_VI_MF8_MASK, VMSNE_VI }, // 8077
  { PseudoVMSNE_VV_M1, VMSNE_VV }, // 8078
  { PseudoVMSNE_VV_M1_MASK, VMSNE_VV }, // 8079
  { PseudoVMSNE_VV_M2, VMSNE_VV }, // 8080
  { PseudoVMSNE_VV_M2_MASK, VMSNE_VV }, // 8081
  { PseudoVMSNE_VV_M4, VMSNE_VV }, // 8082
  { PseudoVMSNE_VV_M4_MASK, VMSNE_VV }, // 8083
  { PseudoVMSNE_VV_M8, VMSNE_VV }, // 8084
  { PseudoVMSNE_VV_M8_MASK, VMSNE_VV }, // 8085
  { PseudoVMSNE_VV_MF2, VMSNE_VV }, // 8086
  { PseudoVMSNE_VV_MF2_MASK, VMSNE_VV }, // 8087
  { PseudoVMSNE_VV_MF4, VMSNE_VV }, // 8088
  { PseudoVMSNE_VV_MF4_MASK, VMSNE_VV }, // 8089
  { PseudoVMSNE_VV_MF8, VMSNE_VV }, // 8090
  { PseudoVMSNE_VV_MF8_MASK, VMSNE_VV }, // 8091
  { PseudoVMSNE_VX_M1, VMSNE_VX }, // 8092
  { PseudoVMSNE_VX_M1_MASK, VMSNE_VX }, // 8093
  { PseudoVMSNE_VX_M2, VMSNE_VX }, // 8094
  { PseudoVMSNE_VX_M2_MASK, VMSNE_VX }, // 8095
  { PseudoVMSNE_VX_M4, VMSNE_VX }, // 8096
  { PseudoVMSNE_VX_M4_MASK, VMSNE_VX }, // 8097
  { PseudoVMSNE_VX_M8, VMSNE_VX }, // 8098
  { PseudoVMSNE_VX_M8_MASK, VMSNE_VX }, // 8099
  { PseudoVMSNE_VX_MF2, VMSNE_VX }, // 8100
  { PseudoVMSNE_VX_MF2_MASK, VMSNE_VX }, // 8101
  { PseudoVMSNE_VX_MF4, VMSNE_VX }, // 8102
  { PseudoVMSNE_VX_MF4_MASK, VMSNE_VX }, // 8103
  { PseudoVMSNE_VX_MF8, VMSNE_VX }, // 8104
  { PseudoVMSNE_VX_MF8_MASK, VMSNE_VX }, // 8105
  { PseudoVMSOF_M_B1, VMSOF_M }, // 8106
  { PseudoVMSOF_M_B16, VMSOF_M }, // 8107
  { PseudoVMSOF_M_B16_MASK, VMSOF_M }, // 8108
  { PseudoVMSOF_M_B1_MASK, VMSOF_M }, // 8109
  { PseudoVMSOF_M_B2, VMSOF_M }, // 8110
  { PseudoVMSOF_M_B2_MASK, VMSOF_M }, // 8111
  { PseudoVMSOF_M_B32, VMSOF_M }, // 8112
  { PseudoVMSOF_M_B32_MASK, VMSOF_M }, // 8113
  { PseudoVMSOF_M_B4, VMSOF_M }, // 8114
  { PseudoVMSOF_M_B4_MASK, VMSOF_M }, // 8115
  { PseudoVMSOF_M_B64, VMSOF_M }, // 8116
  { PseudoVMSOF_M_B64_MASK, VMSOF_M }, // 8117
  { PseudoVMSOF_M_B8, VMSOF_M }, // 8118
  { PseudoVMSOF_M_B8_MASK, VMSOF_M }, // 8119
  { PseudoVMULHSU_VV_M1, VMULHSU_VV }, // 8120
  { PseudoVMULHSU_VV_M1_MASK, VMULHSU_VV }, // 8121
  { PseudoVMULHSU_VV_M2, VMULHSU_VV }, // 8122
  { PseudoVMULHSU_VV_M2_MASK, VMULHSU_VV }, // 8123
  { PseudoVMULHSU_VV_M4, VMULHSU_VV }, // 8124
  { PseudoVMULHSU_VV_M4_MASK, VMULHSU_VV }, // 8125
  { PseudoVMULHSU_VV_M8, VMULHSU_VV }, // 8126
  { PseudoVMULHSU_VV_M8_MASK, VMULHSU_VV }, // 8127
  { PseudoVMULHSU_VV_MF2, VMULHSU_VV }, // 8128
  { PseudoVMULHSU_VV_MF2_MASK, VMULHSU_VV }, // 8129
  { PseudoVMULHSU_VV_MF4, VMULHSU_VV }, // 8130
  { PseudoVMULHSU_VV_MF4_MASK, VMULHSU_VV }, // 8131
  { PseudoVMULHSU_VV_MF8, VMULHSU_VV }, // 8132
  { PseudoVMULHSU_VV_MF8_MASK, VMULHSU_VV }, // 8133
  { PseudoVMULHSU_VX_M1, VMULHSU_VX }, // 8134
  { PseudoVMULHSU_VX_M1_MASK, VMULHSU_VX }, // 8135
  { PseudoVMULHSU_VX_M2, VMULHSU_VX }, // 8136
  { PseudoVMULHSU_VX_M2_MASK, VMULHSU_VX }, // 8137
  { PseudoVMULHSU_VX_M4, VMULHSU_VX }, // 8138
  { PseudoVMULHSU_VX_M4_MASK, VMULHSU_VX }, // 8139
  { PseudoVMULHSU_VX_M8, VMULHSU_VX }, // 8140
  { PseudoVMULHSU_VX_M8_MASK, VMULHSU_VX }, // 8141
  { PseudoVMULHSU_VX_MF2, VMULHSU_VX }, // 8142
  { PseudoVMULHSU_VX_MF2_MASK, VMULHSU_VX }, // 8143
  { PseudoVMULHSU_VX_MF4, VMULHSU_VX }, // 8144
  { PseudoVMULHSU_VX_MF4_MASK, VMULHSU_VX }, // 8145
  { PseudoVMULHSU_VX_MF8, VMULHSU_VX }, // 8146
  { PseudoVMULHSU_VX_MF8_MASK, VMULHSU_VX }, // 8147
  { PseudoVMULHU_VV_M1, VMULHU_VV }, // 8148
  { PseudoVMULHU_VV_M1_MASK, VMULHU_VV }, // 8149
  { PseudoVMULHU_VV_M2, VMULHU_VV }, // 8150
  { PseudoVMULHU_VV_M2_MASK, VMULHU_VV }, // 8151
  { PseudoVMULHU_VV_M4, VMULHU_VV }, // 8152
  { PseudoVMULHU_VV_M4_MASK, VMULHU_VV }, // 8153
  { PseudoVMULHU_VV_M8, VMULHU_VV }, // 8154
  { PseudoVMULHU_VV_M8_MASK, VMULHU_VV }, // 8155
  { PseudoVMULHU_VV_MF2, VMULHU_VV }, // 8156
  { PseudoVMULHU_VV_MF2_MASK, VMULHU_VV }, // 8157
  { PseudoVMULHU_VV_MF4, VMULHU_VV }, // 8158
  { PseudoVMULHU_VV_MF4_MASK, VMULHU_VV }, // 8159
  { PseudoVMULHU_VV_MF8, VMULHU_VV }, // 8160
  { PseudoVMULHU_VV_MF8_MASK, VMULHU_VV }, // 8161
  { PseudoVMULHU_VX_M1, VMULHU_VX }, // 8162
  { PseudoVMULHU_VX_M1_MASK, VMULHU_VX }, // 8163
  { PseudoVMULHU_VX_M2, VMULHU_VX }, // 8164
  { PseudoVMULHU_VX_M2_MASK, VMULHU_VX }, // 8165
  { PseudoVMULHU_VX_M4, VMULHU_VX }, // 8166
  { PseudoVMULHU_VX_M4_MASK, VMULHU_VX }, // 8167
  { PseudoVMULHU_VX_M8, VMULHU_VX }, // 8168
  { PseudoVMULHU_VX_M8_MASK, VMULHU_VX }, // 8169
  { PseudoVMULHU_VX_MF2, VMULHU_VX }, // 8170
  { PseudoVMULHU_VX_MF2_MASK, VMULHU_VX }, // 8171
  { PseudoVMULHU_VX_MF4, VMULHU_VX }, // 8172
  { PseudoVMULHU_VX_MF4_MASK, VMULHU_VX }, // 8173
  { PseudoVMULHU_VX_MF8, VMULHU_VX }, // 8174
  { PseudoVMULHU_VX_MF8_MASK, VMULHU_VX }, // 8175
  { PseudoVMULH_VV_M1, VMULH_VV }, // 8176
  { PseudoVMULH_VV_M1_MASK, VMULH_VV }, // 8177
  { PseudoVMULH_VV_M2, VMULH_VV }, // 8178
  { PseudoVMULH_VV_M2_MASK, VMULH_VV }, // 8179
  { PseudoVMULH_VV_M4, VMULH_VV }, // 8180
  { PseudoVMULH_VV_M4_MASK, VMULH_VV }, // 8181
  { PseudoVMULH_VV_M8, VMULH_VV }, // 8182
  { PseudoVMULH_VV_M8_MASK, VMULH_VV }, // 8183
  { PseudoVMULH_VV_MF2, VMULH_VV }, // 8184
  { PseudoVMULH_VV_MF2_MASK, VMULH_VV }, // 8185
  { PseudoVMULH_VV_MF4, VMULH_VV }, // 8186
  { PseudoVMULH_VV_MF4_MASK, VMULH_VV }, // 8187
  { PseudoVMULH_VV_MF8, VMULH_VV }, // 8188
  { PseudoVMULH_VV_MF8_MASK, VMULH_VV }, // 8189
  { PseudoVMULH_VX_M1, VMULH_VX }, // 8190
  { PseudoVMULH_VX_M1_MASK, VMULH_VX }, // 8191
  { PseudoVMULH_VX_M2, VMULH_VX }, // 8192
  { PseudoVMULH_VX_M2_MASK, VMULH_VX }, // 8193
  { PseudoVMULH_VX_M4, VMULH_VX }, // 8194
  { PseudoVMULH_VX_M4_MASK, VMULH_VX }, // 8195
  { PseudoVMULH_VX_M8, VMULH_VX }, // 8196
  { PseudoVMULH_VX_M8_MASK, VMULH_VX }, // 8197
  { PseudoVMULH_VX_MF2, VMULH_VX }, // 8198
  { PseudoVMULH_VX_MF2_MASK, VMULH_VX }, // 8199
  { PseudoVMULH_VX_MF4, VMULH_VX }, // 8200
  { PseudoVMULH_VX_MF4_MASK, VMULH_VX }, // 8201
  { PseudoVMULH_VX_MF8, VMULH_VX }, // 8202
  { PseudoVMULH_VX_MF8_MASK, VMULH_VX }, // 8203
  { PseudoVMUL_VV_M1, VMUL_VV }, // 8204
  { PseudoVMUL_VV_M1_MASK, VMUL_VV }, // 8205
  { PseudoVMUL_VV_M2, VMUL_VV }, // 8206
  { PseudoVMUL_VV_M2_MASK, VMUL_VV }, // 8207
  { PseudoVMUL_VV_M4, VMUL_VV }, // 8208
  { PseudoVMUL_VV_M4_MASK, VMUL_VV }, // 8209
  { PseudoVMUL_VV_M8, VMUL_VV }, // 8210
  { PseudoVMUL_VV_M8_MASK, VMUL_VV }, // 8211
  { PseudoVMUL_VV_MF2, VMUL_VV }, // 8212
  { PseudoVMUL_VV_MF2_MASK, VMUL_VV }, // 8213
  { PseudoVMUL_VV_MF4, VMUL_VV }, // 8214
  { PseudoVMUL_VV_MF4_MASK, VMUL_VV }, // 8215
  { PseudoVMUL_VV_MF8, VMUL_VV }, // 8216
  { PseudoVMUL_VV_MF8_MASK, VMUL_VV }, // 8217
  { PseudoVMUL_VX_M1, VMUL_VX }, // 8218
  { PseudoVMUL_VX_M1_MASK, VMUL_VX }, // 8219
  { PseudoVMUL_VX_M2, VMUL_VX }, // 8220
  { PseudoVMUL_VX_M2_MASK, VMUL_VX }, // 8221
  { PseudoVMUL_VX_M4, VMUL_VX }, // 8222
  { PseudoVMUL_VX_M4_MASK, VMUL_VX }, // 8223
  { PseudoVMUL_VX_M8, VMUL_VX }, // 8224
  { PseudoVMUL_VX_M8_MASK, VMUL_VX }, // 8225
  { PseudoVMUL_VX_MF2, VMUL_VX }, // 8226
  { PseudoVMUL_VX_MF2_MASK, VMUL_VX }, // 8227
  { PseudoVMUL_VX_MF4, VMUL_VX }, // 8228
  { PseudoVMUL_VX_MF4_MASK, VMUL_VX }, // 8229
  { PseudoVMUL_VX_MF8, VMUL_VX }, // 8230
  { PseudoVMUL_VX_MF8_MASK, VMUL_VX }, // 8231
  { PseudoVMV1R_V, VMV1R_V }, // 8232
  { PseudoVMV2R_V, VMV2R_V }, // 8233
  { PseudoVMV4R_V, VMV4R_V }, // 8234
  { PseudoVMV8R_V, VMV8R_V }, // 8235
  { PseudoVMV_S_X_M1, VMV_S_X }, // 8236
  { PseudoVMV_S_X_M2, VMV_S_X }, // 8237
  { PseudoVMV_S_X_M4, VMV_S_X }, // 8238
  { PseudoVMV_S_X_M8, VMV_S_X }, // 8239
  { PseudoVMV_S_X_MF2, VMV_S_X }, // 8240
  { PseudoVMV_S_X_MF4, VMV_S_X }, // 8241
  { PseudoVMV_S_X_MF8, VMV_S_X }, // 8242
  { PseudoVMV_V_I_M1, VMV_V_I }, // 8243
  { PseudoVMV_V_I_M2, VMV_V_I }, // 8244
  { PseudoVMV_V_I_M4, VMV_V_I }, // 8245
  { PseudoVMV_V_I_M8, VMV_V_I }, // 8246
  { PseudoVMV_V_I_MF2, VMV_V_I }, // 8247
  { PseudoVMV_V_I_MF4, VMV_V_I }, // 8248
  { PseudoVMV_V_I_MF8, VMV_V_I }, // 8249
  { PseudoVMV_V_V_M1, VMV_V_V }, // 8250
  { PseudoVMV_V_V_M2, VMV_V_V }, // 8251
  { PseudoVMV_V_V_M4, VMV_V_V }, // 8252
  { PseudoVMV_V_V_M8, VMV_V_V }, // 8253
  { PseudoVMV_V_V_MF2, VMV_V_V }, // 8254
  { PseudoVMV_V_V_MF4, VMV_V_V }, // 8255
  { PseudoVMV_V_V_MF8, VMV_V_V }, // 8256
  { PseudoVMV_V_X_M1, VMV_V_X }, // 8257
  { PseudoVMV_V_X_M2, VMV_V_X }, // 8258
  { PseudoVMV_V_X_M4, VMV_V_X }, // 8259
  { PseudoVMV_V_X_M8, VMV_V_X }, // 8260
  { PseudoVMV_V_X_MF2, VMV_V_X }, // 8261
  { PseudoVMV_V_X_MF4, VMV_V_X }, // 8262
  { PseudoVMV_V_X_MF8, VMV_V_X }, // 8263
  { PseudoVMV_X_S_M1, VMV_X_S }, // 8264
  { PseudoVMV_X_S_M2, VMV_X_S }, // 8265
  { PseudoVMV_X_S_M4, VMV_X_S }, // 8266
  { PseudoVMV_X_S_M8, VMV_X_S }, // 8267
  { PseudoVMV_X_S_MF2, VMV_X_S }, // 8268
  { PseudoVMV_X_S_MF4, VMV_X_S }, // 8269
  { PseudoVMV_X_S_MF8, VMV_X_S }, // 8270
  { PseudoVMXNOR_MM_M1, VMXNOR_MM }, // 8271
  { PseudoVMXNOR_MM_M2, VMXNOR_MM }, // 8272
  { PseudoVMXNOR_MM_M4, VMXNOR_MM }, // 8273
  { PseudoVMXNOR_MM_M8, VMXNOR_MM }, // 8274
  { PseudoVMXNOR_MM_MF2, VMXNOR_MM }, // 8275
  { PseudoVMXNOR_MM_MF4, VMXNOR_MM }, // 8276
  { PseudoVMXNOR_MM_MF8, VMXNOR_MM }, // 8277
  { PseudoVMXOR_MM_M1, VMXOR_MM }, // 8278
  { PseudoVMXOR_MM_M2, VMXOR_MM }, // 8279
  { PseudoVMXOR_MM_M4, VMXOR_MM }, // 8280
  { PseudoVMXOR_MM_M8, VMXOR_MM }, // 8281
  { PseudoVMXOR_MM_MF2, VMXOR_MM }, // 8282
  { PseudoVMXOR_MM_MF4, VMXOR_MM }, // 8283
  { PseudoVMXOR_MM_MF8, VMXOR_MM }, // 8284
  { PseudoVNCLIPU_WI_M1, VNCLIPU_WI }, // 8285
  { PseudoVNCLIPU_WI_M1_MASK, VNCLIPU_WI }, // 8286
  { PseudoVNCLIPU_WI_M2, VNCLIPU_WI }, // 8287
  { PseudoVNCLIPU_WI_M2_MASK, VNCLIPU_WI }, // 8288
  { PseudoVNCLIPU_WI_M4, VNCLIPU_WI }, // 8289
  { PseudoVNCLIPU_WI_M4_MASK, VNCLIPU_WI }, // 8290
  { PseudoVNCLIPU_WI_MF2, VNCLIPU_WI }, // 8291
  { PseudoVNCLIPU_WI_MF2_MASK, VNCLIPU_WI }, // 8292
  { PseudoVNCLIPU_WI_MF4, VNCLIPU_WI }, // 8293
  { PseudoVNCLIPU_WI_MF4_MASK, VNCLIPU_WI }, // 8294
  { PseudoVNCLIPU_WI_MF8, VNCLIPU_WI }, // 8295
  { PseudoVNCLIPU_WI_MF8_MASK, VNCLIPU_WI }, // 8296
  { PseudoVNCLIPU_WV_M1, VNCLIPU_WV }, // 8297
  { PseudoVNCLIPU_WV_M1_MASK, VNCLIPU_WV }, // 8298
  { PseudoVNCLIPU_WV_M2, VNCLIPU_WV }, // 8299
  { PseudoVNCLIPU_WV_M2_MASK, VNCLIPU_WV }, // 8300
  { PseudoVNCLIPU_WV_M4, VNCLIPU_WV }, // 8301
  { PseudoVNCLIPU_WV_M4_MASK, VNCLIPU_WV }, // 8302
  { PseudoVNCLIPU_WV_MF2, VNCLIPU_WV }, // 8303
  { PseudoVNCLIPU_WV_MF2_MASK, VNCLIPU_WV }, // 8304
  { PseudoVNCLIPU_WV_MF4, VNCLIPU_WV }, // 8305
  { PseudoVNCLIPU_WV_MF4_MASK, VNCLIPU_WV }, // 8306
  { PseudoVNCLIPU_WV_MF8, VNCLIPU_WV }, // 8307
  { PseudoVNCLIPU_WV_MF8_MASK, VNCLIPU_WV }, // 8308
  { PseudoVNCLIPU_WX_M1, VNCLIPU_WX }, // 8309
  { PseudoVNCLIPU_WX_M1_MASK, VNCLIPU_WX }, // 8310
  { PseudoVNCLIPU_WX_M2, VNCLIPU_WX }, // 8311
  { PseudoVNCLIPU_WX_M2_MASK, VNCLIPU_WX }, // 8312
  { PseudoVNCLIPU_WX_M4, VNCLIPU_WX }, // 8313
  { PseudoVNCLIPU_WX_M4_MASK, VNCLIPU_WX }, // 8314
  { PseudoVNCLIPU_WX_MF2, VNCLIPU_WX }, // 8315
  { PseudoVNCLIPU_WX_MF2_MASK, VNCLIPU_WX }, // 8316
  { PseudoVNCLIPU_WX_MF4, VNCLIPU_WX }, // 8317
  { PseudoVNCLIPU_WX_MF4_MASK, VNCLIPU_WX }, // 8318
  { PseudoVNCLIPU_WX_MF8, VNCLIPU_WX }, // 8319
  { PseudoVNCLIPU_WX_MF8_MASK, VNCLIPU_WX }, // 8320
  { PseudoVNCLIP_WI_M1, VNCLIP_WI }, // 8321
  { PseudoVNCLIP_WI_M1_MASK, VNCLIP_WI }, // 8322
  { PseudoVNCLIP_WI_M2, VNCLIP_WI }, // 8323
  { PseudoVNCLIP_WI_M2_MASK, VNCLIP_WI }, // 8324
  { PseudoVNCLIP_WI_M4, VNCLIP_WI }, // 8325
  { PseudoVNCLIP_WI_M4_MASK, VNCLIP_WI }, // 8326
  { PseudoVNCLIP_WI_MF2, VNCLIP_WI }, // 8327
  { PseudoVNCLIP_WI_MF2_MASK, VNCLIP_WI }, // 8328
  { PseudoVNCLIP_WI_MF4, VNCLIP_WI }, // 8329
  { PseudoVNCLIP_WI_MF4_MASK, VNCLIP_WI }, // 8330
  { PseudoVNCLIP_WI_MF8, VNCLIP_WI }, // 8331
  { PseudoVNCLIP_WI_MF8_MASK, VNCLIP_WI }, // 8332
  { PseudoVNCLIP_WV_M1, VNCLIP_WV }, // 8333
  { PseudoVNCLIP_WV_M1_MASK, VNCLIP_WV }, // 8334
  { PseudoVNCLIP_WV_M2, VNCLIP_WV }, // 8335
  { PseudoVNCLIP_WV_M2_MASK, VNCLIP_WV }, // 8336
  { PseudoVNCLIP_WV_M4, VNCLIP_WV }, // 8337
  { PseudoVNCLIP_WV_M4_MASK, VNCLIP_WV }, // 8338
  { PseudoVNCLIP_WV_MF2, VNCLIP_WV }, // 8339
  { PseudoVNCLIP_WV_MF2_MASK, VNCLIP_WV }, // 8340
  { PseudoVNCLIP_WV_MF4, VNCLIP_WV }, // 8341
  { PseudoVNCLIP_WV_MF4_MASK, VNCLIP_WV }, // 8342
  { PseudoVNCLIP_WV_MF8, VNCLIP_WV }, // 8343
  { PseudoVNCLIP_WV_MF8_MASK, VNCLIP_WV }, // 8344
  { PseudoVNCLIP_WX_M1, VNCLIP_WX }, // 8345
  { PseudoVNCLIP_WX_M1_MASK, VNCLIP_WX }, // 8346
  { PseudoVNCLIP_WX_M2, VNCLIP_WX }, // 8347
  { PseudoVNCLIP_WX_M2_MASK, VNCLIP_WX }, // 8348
  { PseudoVNCLIP_WX_M4, VNCLIP_WX }, // 8349
  { PseudoVNCLIP_WX_M4_MASK, VNCLIP_WX }, // 8350
  { PseudoVNCLIP_WX_MF2, VNCLIP_WX }, // 8351
  { PseudoVNCLIP_WX_MF2_MASK, VNCLIP_WX }, // 8352
  { PseudoVNCLIP_WX_MF4, VNCLIP_WX }, // 8353
  { PseudoVNCLIP_WX_MF4_MASK, VNCLIP_WX }, // 8354
  { PseudoVNCLIP_WX_MF8, VNCLIP_WX }, // 8355
  { PseudoVNCLIP_WX_MF8_MASK, VNCLIP_WX }, // 8356
  { PseudoVNMSAC_VV_M1, VNMSAC_VV }, // 8357
  { PseudoVNMSAC_VV_M1_MASK, VNMSAC_VV }, // 8358
  { PseudoVNMSAC_VV_M2, VNMSAC_VV }, // 8359
  { PseudoVNMSAC_VV_M2_MASK, VNMSAC_VV }, // 8360
  { PseudoVNMSAC_VV_M4, VNMSAC_VV }, // 8361
  { PseudoVNMSAC_VV_M4_MASK, VNMSAC_VV }, // 8362
  { PseudoVNMSAC_VV_M8, VNMSAC_VV }, // 8363
  { PseudoVNMSAC_VV_M8_MASK, VNMSAC_VV }, // 8364
  { PseudoVNMSAC_VV_MF2, VNMSAC_VV }, // 8365
  { PseudoVNMSAC_VV_MF2_MASK, VNMSAC_VV }, // 8366
  { PseudoVNMSAC_VV_MF4, VNMSAC_VV }, // 8367
  { PseudoVNMSAC_VV_MF4_MASK, VNMSAC_VV }, // 8368
  { PseudoVNMSAC_VV_MF8, VNMSAC_VV }, // 8369
  { PseudoVNMSAC_VV_MF8_MASK, VNMSAC_VV }, // 8370
  { PseudoVNMSAC_VX_M1, VNMSAC_VX }, // 8371
  { PseudoVNMSAC_VX_M1_MASK, VNMSAC_VX }, // 8372
  { PseudoVNMSAC_VX_M2, VNMSAC_VX }, // 8373
  { PseudoVNMSAC_VX_M2_MASK, VNMSAC_VX }, // 8374
  { PseudoVNMSAC_VX_M4, VNMSAC_VX }, // 8375
  { PseudoVNMSAC_VX_M4_MASK, VNMSAC_VX }, // 8376
  { PseudoVNMSAC_VX_M8, VNMSAC_VX }, // 8377
  { PseudoVNMSAC_VX_M8_MASK, VNMSAC_VX }, // 8378
  { PseudoVNMSAC_VX_MF2, VNMSAC_VX }, // 8379
  { PseudoVNMSAC_VX_MF2_MASK, VNMSAC_VX }, // 8380
  { PseudoVNMSAC_VX_MF4, VNMSAC_VX }, // 8381
  { PseudoVNMSAC_VX_MF4_MASK, VNMSAC_VX }, // 8382
  { PseudoVNMSAC_VX_MF8, VNMSAC_VX }, // 8383
  { PseudoVNMSAC_VX_MF8_MASK, VNMSAC_VX }, // 8384
  { PseudoVNMSUB_VV_M1, VNMSUB_VV }, // 8385
  { PseudoVNMSUB_VV_M1_MASK, VNMSUB_VV }, // 8386
  { PseudoVNMSUB_VV_M2, VNMSUB_VV }, // 8387
  { PseudoVNMSUB_VV_M2_MASK, VNMSUB_VV }, // 8388
  { PseudoVNMSUB_VV_M4, VNMSUB_VV }, // 8389
  { PseudoVNMSUB_VV_M4_MASK, VNMSUB_VV }, // 8390
  { PseudoVNMSUB_VV_M8, VNMSUB_VV }, // 8391
  { PseudoVNMSUB_VV_M8_MASK, VNMSUB_VV }, // 8392
  { PseudoVNMSUB_VV_MF2, VNMSUB_VV }, // 8393
  { PseudoVNMSUB_VV_MF2_MASK, VNMSUB_VV }, // 8394
  { PseudoVNMSUB_VV_MF4, VNMSUB_VV }, // 8395
  { PseudoVNMSUB_VV_MF4_MASK, VNMSUB_VV }, // 8396
  { PseudoVNMSUB_VV_MF8, VNMSUB_VV }, // 8397
  { PseudoVNMSUB_VV_MF8_MASK, VNMSUB_VV }, // 8398
  { PseudoVNMSUB_VX_M1, VNMSUB_VX }, // 8399
  { PseudoVNMSUB_VX_M1_MASK, VNMSUB_VX }, // 8400
  { PseudoVNMSUB_VX_M2, VNMSUB_VX }, // 8401
  { PseudoVNMSUB_VX_M2_MASK, VNMSUB_VX }, // 8402
  { PseudoVNMSUB_VX_M4, VNMSUB_VX }, // 8403
  { PseudoVNMSUB_VX_M4_MASK, VNMSUB_VX }, // 8404
  { PseudoVNMSUB_VX_M8, VNMSUB_VX }, // 8405
  { PseudoVNMSUB_VX_M8_MASK, VNMSUB_VX }, // 8406
  { PseudoVNMSUB_VX_MF2, VNMSUB_VX }, // 8407
  { PseudoVNMSUB_VX_MF2_MASK, VNMSUB_VX }, // 8408
  { PseudoVNMSUB_VX_MF4, VNMSUB_VX }, // 8409
  { PseudoVNMSUB_VX_MF4_MASK, VNMSUB_VX }, // 8410
  { PseudoVNMSUB_VX_MF8, VNMSUB_VX }, // 8411
  { PseudoVNMSUB_VX_MF8_MASK, VNMSUB_VX }, // 8412
  { PseudoVNSRA_WI_M1, VNSRA_WI }, // 8413
  { PseudoVNSRA_WI_M1_MASK, VNSRA_WI }, // 8414
  { PseudoVNSRA_WI_M2, VNSRA_WI }, // 8415
  { PseudoVNSRA_WI_M2_MASK, VNSRA_WI }, // 8416
  { PseudoVNSRA_WI_M4, VNSRA_WI }, // 8417
  { PseudoVNSRA_WI_M4_MASK, VNSRA_WI }, // 8418
  { PseudoVNSRA_WI_MF2, VNSRA_WI }, // 8419
  { PseudoVNSRA_WI_MF2_MASK, VNSRA_WI }, // 8420
  { PseudoVNSRA_WI_MF4, VNSRA_WI }, // 8421
  { PseudoVNSRA_WI_MF4_MASK, VNSRA_WI }, // 8422
  { PseudoVNSRA_WI_MF8, VNSRA_WI }, // 8423
  { PseudoVNSRA_WI_MF8_MASK, VNSRA_WI }, // 8424
  { PseudoVNSRA_WV_M1, VNSRA_WV }, // 8425
  { PseudoVNSRA_WV_M1_MASK, VNSRA_WV }, // 8426
  { PseudoVNSRA_WV_M2, VNSRA_WV }, // 8427
  { PseudoVNSRA_WV_M2_MASK, VNSRA_WV }, // 8428
  { PseudoVNSRA_WV_M4, VNSRA_WV }, // 8429
  { PseudoVNSRA_WV_M4_MASK, VNSRA_WV }, // 8430
  { PseudoVNSRA_WV_MF2, VNSRA_WV }, // 8431
  { PseudoVNSRA_WV_MF2_MASK, VNSRA_WV }, // 8432
  { PseudoVNSRA_WV_MF4, VNSRA_WV }, // 8433
  { PseudoVNSRA_WV_MF4_MASK, VNSRA_WV }, // 8434
  { PseudoVNSRA_WV_MF8, VNSRA_WV }, // 8435
  { PseudoVNSRA_WV_MF8_MASK, VNSRA_WV }, // 8436
  { PseudoVNSRA_WX_M1, VNSRA_WX }, // 8437
  { PseudoVNSRA_WX_M1_MASK, VNSRA_WX }, // 8438
  { PseudoVNSRA_WX_M2, VNSRA_WX }, // 8439
  { PseudoVNSRA_WX_M2_MASK, VNSRA_WX }, // 8440
  { PseudoVNSRA_WX_M4, VNSRA_WX }, // 8441
  { PseudoVNSRA_WX_M4_MASK, VNSRA_WX }, // 8442
  { PseudoVNSRA_WX_MF2, VNSRA_WX }, // 8443
  { PseudoVNSRA_WX_MF2_MASK, VNSRA_WX }, // 8444
  { PseudoVNSRA_WX_MF4, VNSRA_WX }, // 8445
  { PseudoVNSRA_WX_MF4_MASK, VNSRA_WX }, // 8446
  { PseudoVNSRA_WX_MF8, VNSRA_WX }, // 8447
  { PseudoVNSRA_WX_MF8_MASK, VNSRA_WX }, // 8448
  { PseudoVNSRL_WI_M1, VNSRL_WI }, // 8449
  { PseudoVNSRL_WI_M1_MASK, VNSRL_WI }, // 8450
  { PseudoVNSRL_WI_M2, VNSRL_WI }, // 8451
  { PseudoVNSRL_WI_M2_MASK, VNSRL_WI }, // 8452
  { PseudoVNSRL_WI_M4, VNSRL_WI }, // 8453
  { PseudoVNSRL_WI_M4_MASK, VNSRL_WI }, // 8454
  { PseudoVNSRL_WI_MF2, VNSRL_WI }, // 8455
  { PseudoVNSRL_WI_MF2_MASK, VNSRL_WI }, // 8456
  { PseudoVNSRL_WI_MF4, VNSRL_WI }, // 8457
  { PseudoVNSRL_WI_MF4_MASK, VNSRL_WI }, // 8458
  { PseudoVNSRL_WI_MF8, VNSRL_WI }, // 8459
  { PseudoVNSRL_WI_MF8_MASK, VNSRL_WI }, // 8460
  { PseudoVNSRL_WV_M1, VNSRL_WV }, // 8461
  { PseudoVNSRL_WV_M1_MASK, VNSRL_WV }, // 8462
  { PseudoVNSRL_WV_M2, VNSRL_WV }, // 8463
  { PseudoVNSRL_WV_M2_MASK, VNSRL_WV }, // 8464
  { PseudoVNSRL_WV_M4, VNSRL_WV }, // 8465
  { PseudoVNSRL_WV_M4_MASK, VNSRL_WV }, // 8466
  { PseudoVNSRL_WV_MF2, VNSRL_WV }, // 8467
  { PseudoVNSRL_WV_MF2_MASK, VNSRL_WV }, // 8468
  { PseudoVNSRL_WV_MF4, VNSRL_WV }, // 8469
  { PseudoVNSRL_WV_MF4_MASK, VNSRL_WV }, // 8470
  { PseudoVNSRL_WV_MF8, VNSRL_WV }, // 8471
  { PseudoVNSRL_WV_MF8_MASK, VNSRL_WV }, // 8472
  { PseudoVNSRL_WX_M1, VNSRL_WX }, // 8473
  { PseudoVNSRL_WX_M1_MASK, VNSRL_WX }, // 8474
  { PseudoVNSRL_WX_M2, VNSRL_WX }, // 8475
  { PseudoVNSRL_WX_M2_MASK, VNSRL_WX }, // 8476
  { PseudoVNSRL_WX_M4, VNSRL_WX }, // 8477
  { PseudoVNSRL_WX_M4_MASK, VNSRL_WX }, // 8478
  { PseudoVNSRL_WX_MF2, VNSRL_WX }, // 8479
  { PseudoVNSRL_WX_MF2_MASK, VNSRL_WX }, // 8480
  { PseudoVNSRL_WX_MF4, VNSRL_WX }, // 8481
  { PseudoVNSRL_WX_MF4_MASK, VNSRL_WX }, // 8482
  { PseudoVNSRL_WX_MF8, VNSRL_WX }, // 8483
  { PseudoVNSRL_WX_MF8_MASK, VNSRL_WX }, // 8484
  { PseudoVOR_VI_M1, VOR_VI }, // 8485
  { PseudoVOR_VI_M1_MASK, VOR_VI }, // 8486
  { PseudoVOR_VI_M2, VOR_VI }, // 8487
  { PseudoVOR_VI_M2_MASK, VOR_VI }, // 8488
  { PseudoVOR_VI_M4, VOR_VI }, // 8489
  { PseudoVOR_VI_M4_MASK, VOR_VI }, // 8490
  { PseudoVOR_VI_M8, VOR_VI }, // 8491
  { PseudoVOR_VI_M8_MASK, VOR_VI }, // 8492
  { PseudoVOR_VI_MF2, VOR_VI }, // 8493
  { PseudoVOR_VI_MF2_MASK, VOR_VI }, // 8494
  { PseudoVOR_VI_MF4, VOR_VI }, // 8495
  { PseudoVOR_VI_MF4_MASK, VOR_VI }, // 8496
  { PseudoVOR_VI_MF8, VOR_VI }, // 8497
  { PseudoVOR_VI_MF8_MASK, VOR_VI }, // 8498
  { PseudoVOR_VV_M1, VOR_VV }, // 8499
  { PseudoVOR_VV_M1_MASK, VOR_VV }, // 8500
  { PseudoVOR_VV_M2, VOR_VV }, // 8501
  { PseudoVOR_VV_M2_MASK, VOR_VV }, // 8502
  { PseudoVOR_VV_M4, VOR_VV }, // 8503
  { PseudoVOR_VV_M4_MASK, VOR_VV }, // 8504
  { PseudoVOR_VV_M8, VOR_VV }, // 8505
  { PseudoVOR_VV_M8_MASK, VOR_VV }, // 8506
  { PseudoVOR_VV_MF2, VOR_VV }, // 8507
  { PseudoVOR_VV_MF2_MASK, VOR_VV }, // 8508
  { PseudoVOR_VV_MF4, VOR_VV }, // 8509
  { PseudoVOR_VV_MF4_MASK, VOR_VV }, // 8510
  { PseudoVOR_VV_MF8, VOR_VV }, // 8511
  { PseudoVOR_VV_MF8_MASK, VOR_VV }, // 8512
  { PseudoVOR_VX_M1, VOR_VX }, // 8513
  { PseudoVOR_VX_M1_MASK, VOR_VX }, // 8514
  { PseudoVOR_VX_M2, VOR_VX }, // 8515
  { PseudoVOR_VX_M2_MASK, VOR_VX }, // 8516
  { PseudoVOR_VX_M4, VOR_VX }, // 8517
  { PseudoVOR_VX_M4_MASK, VOR_VX }, // 8518
  { PseudoVOR_VX_M8, VOR_VX }, // 8519
  { PseudoVOR_VX_M8_MASK, VOR_VX }, // 8520
  { PseudoVOR_VX_MF2, VOR_VX }, // 8521
  { PseudoVOR_VX_MF2_MASK, VOR_VX }, // 8522
  { PseudoVOR_VX_MF4, VOR_VX }, // 8523
  { PseudoVOR_VX_MF4_MASK, VOR_VX }, // 8524
  { PseudoVOR_VX_MF8, VOR_VX }, // 8525
  { PseudoVOR_VX_MF8_MASK, VOR_VX }, // 8526
  { PseudoVPOPC_M_B1, VPOPC_M }, // 8527
  { PseudoVPOPC_M_B16, VPOPC_M }, // 8528
  { PseudoVPOPC_M_B16_MASK, VPOPC_M }, // 8529
  { PseudoVPOPC_M_B1_MASK, VPOPC_M }, // 8530
  { PseudoVPOPC_M_B2, VPOPC_M }, // 8531
  { PseudoVPOPC_M_B2_MASK, VPOPC_M }, // 8532
  { PseudoVPOPC_M_B32, VPOPC_M }, // 8533
  { PseudoVPOPC_M_B32_MASK, VPOPC_M }, // 8534
  { PseudoVPOPC_M_B4, VPOPC_M }, // 8535
  { PseudoVPOPC_M_B4_MASK, VPOPC_M }, // 8536
  { PseudoVPOPC_M_B64, VPOPC_M }, // 8537
  { PseudoVPOPC_M_B64_MASK, VPOPC_M }, // 8538
  { PseudoVPOPC_M_B8, VPOPC_M }, // 8539
  { PseudoVPOPC_M_B8_MASK, VPOPC_M }, // 8540
  { PseudoVREDAND_VS_M1, VREDAND_VS }, // 8541
  { PseudoVREDAND_VS_M1_MASK, VREDAND_VS }, // 8542
  { PseudoVREDAND_VS_M2, VREDAND_VS }, // 8543
  { PseudoVREDAND_VS_M2_MASK, VREDAND_VS }, // 8544
  { PseudoVREDAND_VS_M4, VREDAND_VS }, // 8545
  { PseudoVREDAND_VS_M4_MASK, VREDAND_VS }, // 8546
  { PseudoVREDAND_VS_M8, VREDAND_VS }, // 8547
  { PseudoVREDAND_VS_M8_MASK, VREDAND_VS }, // 8548
  { PseudoVREDAND_VS_MF2, VREDAND_VS }, // 8549
  { PseudoVREDAND_VS_MF2_MASK, VREDAND_VS }, // 8550
  { PseudoVREDAND_VS_MF4, VREDAND_VS }, // 8551
  { PseudoVREDAND_VS_MF4_MASK, VREDAND_VS }, // 8552
  { PseudoVREDAND_VS_MF8, VREDAND_VS }, // 8553
  { PseudoVREDAND_VS_MF8_MASK, VREDAND_VS }, // 8554
  { PseudoVREDMAXU_VS_M1, VREDMAXU_VS }, // 8555
  { PseudoVREDMAXU_VS_M1_MASK, VREDMAXU_VS }, // 8556
  { PseudoVREDMAXU_VS_M2, VREDMAXU_VS }, // 8557
  { PseudoVREDMAXU_VS_M2_MASK, VREDMAXU_VS }, // 8558
  { PseudoVREDMAXU_VS_M4, VREDMAXU_VS }, // 8559
  { PseudoVREDMAXU_VS_M4_MASK, VREDMAXU_VS }, // 8560
  { PseudoVREDMAXU_VS_M8, VREDMAXU_VS }, // 8561
  { PseudoVREDMAXU_VS_M8_MASK, VREDMAXU_VS }, // 8562
  { PseudoVREDMAXU_VS_MF2, VREDMAXU_VS }, // 8563
  { PseudoVREDMAXU_VS_MF2_MASK, VREDMAXU_VS }, // 8564
  { PseudoVREDMAXU_VS_MF4, VREDMAXU_VS }, // 8565
  { PseudoVREDMAXU_VS_MF4_MASK, VREDMAXU_VS }, // 8566
  { PseudoVREDMAXU_VS_MF8, VREDMAXU_VS }, // 8567
  { PseudoVREDMAXU_VS_MF8_MASK, VREDMAXU_VS }, // 8568
  { PseudoVREDMAX_VS_M1, VREDMAX_VS }, // 8569
  { PseudoVREDMAX_VS_M1_MASK, VREDMAX_VS }, // 8570
  { PseudoVREDMAX_VS_M2, VREDMAX_VS }, // 8571
  { PseudoVREDMAX_VS_M2_MASK, VREDMAX_VS }, // 8572
  { PseudoVREDMAX_VS_M4, VREDMAX_VS }, // 8573
  { PseudoVREDMAX_VS_M4_MASK, VREDMAX_VS }, // 8574
  { PseudoVREDMAX_VS_M8, VREDMAX_VS }, // 8575
  { PseudoVREDMAX_VS_M8_MASK, VREDMAX_VS }, // 8576
  { PseudoVREDMAX_VS_MF2, VREDMAX_VS }, // 8577
  { PseudoVREDMAX_VS_MF2_MASK, VREDMAX_VS }, // 8578
  { PseudoVREDMAX_VS_MF4, VREDMAX_VS }, // 8579
  { PseudoVREDMAX_VS_MF4_MASK, VREDMAX_VS }, // 8580
  { PseudoVREDMAX_VS_MF8, VREDMAX_VS }, // 8581
  { PseudoVREDMAX_VS_MF8_MASK, VREDMAX_VS }, // 8582
  { PseudoVREDMINU_VS_M1, VREDMINU_VS }, // 8583
  { PseudoVREDMINU_VS_M1_MASK, VREDMINU_VS }, // 8584
  { PseudoVREDMINU_VS_M2, VREDMINU_VS }, // 8585
  { PseudoVREDMINU_VS_M2_MASK, VREDMINU_VS }, // 8586
  { PseudoVREDMINU_VS_M4, VREDMINU_VS }, // 8587
  { PseudoVREDMINU_VS_M4_MASK, VREDMINU_VS }, // 8588
  { PseudoVREDMINU_VS_M8, VREDMINU_VS }, // 8589
  { PseudoVREDMINU_VS_M8_MASK, VREDMINU_VS }, // 8590
  { PseudoVREDMINU_VS_MF2, VREDMINU_VS }, // 8591
  { PseudoVREDMINU_VS_MF2_MASK, VREDMINU_VS }, // 8592
  { PseudoVREDMINU_VS_MF4, VREDMINU_VS }, // 8593
  { PseudoVREDMINU_VS_MF4_MASK, VREDMINU_VS }, // 8594
  { PseudoVREDMINU_VS_MF8, VREDMINU_VS }, // 8595
  { PseudoVREDMINU_VS_MF8_MASK, VREDMINU_VS }, // 8596
  { PseudoVREDMIN_VS_M1, VREDMIN_VS }, // 8597
  { PseudoVREDMIN_VS_M1_MASK, VREDMIN_VS }, // 8598
  { PseudoVREDMIN_VS_M2, VREDMIN_VS }, // 8599
  { PseudoVREDMIN_VS_M2_MASK, VREDMIN_VS }, // 8600
  { PseudoVREDMIN_VS_M4, VREDMIN_VS }, // 8601
  { PseudoVREDMIN_VS_M4_MASK, VREDMIN_VS }, // 8602
  { PseudoVREDMIN_VS_M8, VREDMIN_VS }, // 8603
  { PseudoVREDMIN_VS_M8_MASK, VREDMIN_VS }, // 8604
  { PseudoVREDMIN_VS_MF2, VREDMIN_VS }, // 8605
  { PseudoVREDMIN_VS_MF2_MASK, VREDMIN_VS }, // 8606
  { PseudoVREDMIN_VS_MF4, VREDMIN_VS }, // 8607
  { PseudoVREDMIN_VS_MF4_MASK, VREDMIN_VS }, // 8608
  { PseudoVREDMIN_VS_MF8, VREDMIN_VS }, // 8609
  { PseudoVREDMIN_VS_MF8_MASK, VREDMIN_VS }, // 8610
  { PseudoVREDOR_VS_M1, VREDOR_VS }, // 8611
  { PseudoVREDOR_VS_M1_MASK, VREDOR_VS }, // 8612
  { PseudoVREDOR_VS_M2, VREDOR_VS }, // 8613
  { PseudoVREDOR_VS_M2_MASK, VREDOR_VS }, // 8614
  { PseudoVREDOR_VS_M4, VREDOR_VS }, // 8615
  { PseudoVREDOR_VS_M4_MASK, VREDOR_VS }, // 8616
  { PseudoVREDOR_VS_M8, VREDOR_VS }, // 8617
  { PseudoVREDOR_VS_M8_MASK, VREDOR_VS }, // 8618
  { PseudoVREDOR_VS_MF2, VREDOR_VS }, // 8619
  { PseudoVREDOR_VS_MF2_MASK, VREDOR_VS }, // 8620
  { PseudoVREDOR_VS_MF4, VREDOR_VS }, // 8621
  { PseudoVREDOR_VS_MF4_MASK, VREDOR_VS }, // 8622
  { PseudoVREDOR_VS_MF8, VREDOR_VS }, // 8623
  { PseudoVREDOR_VS_MF8_MASK, VREDOR_VS }, // 8624
  { PseudoVREDSUM_VS_M1, VREDSUM_VS }, // 8625
  { PseudoVREDSUM_VS_M1_MASK, VREDSUM_VS }, // 8626
  { PseudoVREDSUM_VS_M2, VREDSUM_VS }, // 8627
  { PseudoVREDSUM_VS_M2_MASK, VREDSUM_VS }, // 8628
  { PseudoVREDSUM_VS_M4, VREDSUM_VS }, // 8629
  { PseudoVREDSUM_VS_M4_MASK, VREDSUM_VS }, // 8630
  { PseudoVREDSUM_VS_M8, VREDSUM_VS }, // 8631
  { PseudoVREDSUM_VS_M8_MASK, VREDSUM_VS }, // 8632
  { PseudoVREDSUM_VS_MF2, VREDSUM_VS }, // 8633
  { PseudoVREDSUM_VS_MF2_MASK, VREDSUM_VS }, // 8634
  { PseudoVREDSUM_VS_MF4, VREDSUM_VS }, // 8635
  { PseudoVREDSUM_VS_MF4_MASK, VREDSUM_VS }, // 8636
  { PseudoVREDSUM_VS_MF8, VREDSUM_VS }, // 8637
  { PseudoVREDSUM_VS_MF8_MASK, VREDSUM_VS }, // 8638
  { PseudoVREDXOR_VS_M1, VREDXOR_VS }, // 8639
  { PseudoVREDXOR_VS_M1_MASK, VREDXOR_VS }, // 8640
  { PseudoVREDXOR_VS_M2, VREDXOR_VS }, // 8641
  { PseudoVREDXOR_VS_M2_MASK, VREDXOR_VS }, // 8642
  { PseudoVREDXOR_VS_M4, VREDXOR_VS }, // 8643
  { PseudoVREDXOR_VS_M4_MASK, VREDXOR_VS }, // 8644
  { PseudoVREDXOR_VS_M8, VREDXOR_VS }, // 8645
  { PseudoVREDXOR_VS_M8_MASK, VREDXOR_VS }, // 8646
  { PseudoVREDXOR_VS_MF2, VREDXOR_VS }, // 8647
  { PseudoVREDXOR_VS_MF2_MASK, VREDXOR_VS }, // 8648
  { PseudoVREDXOR_VS_MF4, VREDXOR_VS }, // 8649
  { PseudoVREDXOR_VS_MF4_MASK, VREDXOR_VS }, // 8650
  { PseudoVREDXOR_VS_MF8, VREDXOR_VS }, // 8651
  { PseudoVREDXOR_VS_MF8_MASK, VREDXOR_VS }, // 8652
  { PseudoVREMU_VV_M1, VREMU_VV }, // 8653
  { PseudoVREMU_VV_M1_MASK, VREMU_VV }, // 8654
  { PseudoVREMU_VV_M2, VREMU_VV }, // 8655
  { PseudoVREMU_VV_M2_MASK, VREMU_VV }, // 8656
  { PseudoVREMU_VV_M4, VREMU_VV }, // 8657
  { PseudoVREMU_VV_M4_MASK, VREMU_VV }, // 8658
  { PseudoVREMU_VV_M8, VREMU_VV }, // 8659
  { PseudoVREMU_VV_M8_MASK, VREMU_VV }, // 8660
  { PseudoVREMU_VV_MF2, VREMU_VV }, // 8661
  { PseudoVREMU_VV_MF2_MASK, VREMU_VV }, // 8662
  { PseudoVREMU_VV_MF4, VREMU_VV }, // 8663
  { PseudoVREMU_VV_MF4_MASK, VREMU_VV }, // 8664
  { PseudoVREMU_VV_MF8, VREMU_VV }, // 8665
  { PseudoVREMU_VV_MF8_MASK, VREMU_VV }, // 8666
  { PseudoVREMU_VX_M1, VREMU_VX }, // 8667
  { PseudoVREMU_VX_M1_MASK, VREMU_VX }, // 8668
  { PseudoVREMU_VX_M2, VREMU_VX }, // 8669
  { PseudoVREMU_VX_M2_MASK, VREMU_VX }, // 8670
  { PseudoVREMU_VX_M4, VREMU_VX }, // 8671
  { PseudoVREMU_VX_M4_MASK, VREMU_VX }, // 8672
  { PseudoVREMU_VX_M8, VREMU_VX }, // 8673
  { PseudoVREMU_VX_M8_MASK, VREMU_VX }, // 8674
  { PseudoVREMU_VX_MF2, VREMU_VX }, // 8675
  { PseudoVREMU_VX_MF2_MASK, VREMU_VX }, // 8676
  { PseudoVREMU_VX_MF4, VREMU_VX }, // 8677
  { PseudoVREMU_VX_MF4_MASK, VREMU_VX }, // 8678
  { PseudoVREMU_VX_MF8, VREMU_VX }, // 8679
  { PseudoVREMU_VX_MF8_MASK, VREMU_VX }, // 8680
  { PseudoVREM_VV_M1, VREM_VV }, // 8681
  { PseudoVREM_VV_M1_MASK, VREM_VV }, // 8682
  { PseudoVREM_VV_M2, VREM_VV }, // 8683
  { PseudoVREM_VV_M2_MASK, VREM_VV }, // 8684
  { PseudoVREM_VV_M4, VREM_VV }, // 8685
  { PseudoVREM_VV_M4_MASK, VREM_VV }, // 8686
  { PseudoVREM_VV_M8, VREM_VV }, // 8687
  { PseudoVREM_VV_M8_MASK, VREM_VV }, // 8688
  { PseudoVREM_VV_MF2, VREM_VV }, // 8689
  { PseudoVREM_VV_MF2_MASK, VREM_VV }, // 8690
  { PseudoVREM_VV_MF4, VREM_VV }, // 8691
  { PseudoVREM_VV_MF4_MASK, VREM_VV }, // 8692
  { PseudoVREM_VV_MF8, VREM_VV }, // 8693
  { PseudoVREM_VV_MF8_MASK, VREM_VV }, // 8694
  { PseudoVREM_VX_M1, VREM_VX }, // 8695
  { PseudoVREM_VX_M1_MASK, VREM_VX }, // 8696
  { PseudoVREM_VX_M2, VREM_VX }, // 8697
  { PseudoVREM_VX_M2_MASK, VREM_VX }, // 8698
  { PseudoVREM_VX_M4, VREM_VX }, // 8699
  { PseudoVREM_VX_M4_MASK, VREM_VX }, // 8700
  { PseudoVREM_VX_M8, VREM_VX }, // 8701
  { PseudoVREM_VX_M8_MASK, VREM_VX }, // 8702
  { PseudoVREM_VX_MF2, VREM_VX }, // 8703
  { PseudoVREM_VX_MF2_MASK, VREM_VX }, // 8704
  { PseudoVREM_VX_MF4, VREM_VX }, // 8705
  { PseudoVREM_VX_MF4_MASK, VREM_VX }, // 8706
  { PseudoVREM_VX_MF8, VREM_VX }, // 8707
  { PseudoVREM_VX_MF8_MASK, VREM_VX }, // 8708
  { PseudoVRGATHEREI16_VV_M1_M1, VRGATHEREI16_VV }, // 8709
  { PseudoVRGATHEREI16_VV_M1_M1_MASK, VRGATHEREI16_VV }, // 8710
  { PseudoVRGATHEREI16_VV_M1_M2, VRGATHEREI16_VV }, // 8711
  { PseudoVRGATHEREI16_VV_M1_M2_MASK, VRGATHEREI16_VV }, // 8712
  { PseudoVRGATHEREI16_VV_M1_MF2, VRGATHEREI16_VV }, // 8713
  { PseudoVRGATHEREI16_VV_M1_MF2_MASK, VRGATHEREI16_VV }, // 8714
  { PseudoVRGATHEREI16_VV_M1_MF4, VRGATHEREI16_VV }, // 8715
  { PseudoVRGATHEREI16_VV_M1_MF4_MASK, VRGATHEREI16_VV }, // 8716
  { PseudoVRGATHEREI16_VV_M2_M1, VRGATHEREI16_VV }, // 8717
  { PseudoVRGATHEREI16_VV_M2_M1_MASK, VRGATHEREI16_VV }, // 8718
  { PseudoVRGATHEREI16_VV_M2_M2, VRGATHEREI16_VV }, // 8719
  { PseudoVRGATHEREI16_VV_M2_M2_MASK, VRGATHEREI16_VV }, // 8720
  { PseudoVRGATHEREI16_VV_M2_M4, VRGATHEREI16_VV }, // 8721
  { PseudoVRGATHEREI16_VV_M2_M4_MASK, VRGATHEREI16_VV }, // 8722
  { PseudoVRGATHEREI16_VV_M2_MF2, VRGATHEREI16_VV }, // 8723
  { PseudoVRGATHEREI16_VV_M2_MF2_MASK, VRGATHEREI16_VV }, // 8724
  { PseudoVRGATHEREI16_VV_M4_M1, VRGATHEREI16_VV }, // 8725
  { PseudoVRGATHEREI16_VV_M4_M1_MASK, VRGATHEREI16_VV }, // 8726
  { PseudoVRGATHEREI16_VV_M4_M2, VRGATHEREI16_VV }, // 8727
  { PseudoVRGATHEREI16_VV_M4_M2_MASK, VRGATHEREI16_VV }, // 8728
  { PseudoVRGATHEREI16_VV_M4_M4, VRGATHEREI16_VV }, // 8729
  { PseudoVRGATHEREI16_VV_M4_M4_MASK, VRGATHEREI16_VV }, // 8730
  { PseudoVRGATHEREI16_VV_M4_M8, VRGATHEREI16_VV }, // 8731
  { PseudoVRGATHEREI16_VV_M4_M8_MASK, VRGATHEREI16_VV }, // 8732
  { PseudoVRGATHEREI16_VV_M8_M2, VRGATHEREI16_VV }, // 8733
  { PseudoVRGATHEREI16_VV_M8_M2_MASK, VRGATHEREI16_VV }, // 8734
  { PseudoVRGATHEREI16_VV_M8_M4, VRGATHEREI16_VV }, // 8735
  { PseudoVRGATHEREI16_VV_M8_M4_MASK, VRGATHEREI16_VV }, // 8736
  { PseudoVRGATHEREI16_VV_M8_M8, VRGATHEREI16_VV }, // 8737
  { PseudoVRGATHEREI16_VV_M8_M8_MASK, VRGATHEREI16_VV }, // 8738
  { PseudoVRGATHEREI16_VV_MF2_M1, VRGATHEREI16_VV }, // 8739
  { PseudoVRGATHEREI16_VV_MF2_M1_MASK, VRGATHEREI16_VV }, // 8740
  { PseudoVRGATHEREI16_VV_MF2_MF2, VRGATHEREI16_VV }, // 8741
  { PseudoVRGATHEREI16_VV_MF2_MF2_MASK, VRGATHEREI16_VV }, // 8742
  { PseudoVRGATHEREI16_VV_MF2_MF4, VRGATHEREI16_VV }, // 8743
  { PseudoVRGATHEREI16_VV_MF2_MF4_MASK, VRGATHEREI16_VV }, // 8744
  { PseudoVRGATHEREI16_VV_MF2_MF8, VRGATHEREI16_VV }, // 8745
  { PseudoVRGATHEREI16_VV_MF2_MF8_MASK, VRGATHEREI16_VV }, // 8746
  { PseudoVRGATHEREI16_VV_MF4_MF2, VRGATHEREI16_VV }, // 8747
  { PseudoVRGATHEREI16_VV_MF4_MF2_MASK, VRGATHEREI16_VV }, // 8748
  { PseudoVRGATHEREI16_VV_MF4_MF4, VRGATHEREI16_VV }, // 8749
  { PseudoVRGATHEREI16_VV_MF4_MF4_MASK, VRGATHEREI16_VV }, // 8750
  { PseudoVRGATHEREI16_VV_MF4_MF8, VRGATHEREI16_VV }, // 8751
  { PseudoVRGATHEREI16_VV_MF4_MF8_MASK, VRGATHEREI16_VV }, // 8752
  { PseudoVRGATHEREI16_VV_MF8_MF4, VRGATHEREI16_VV }, // 8753
  { PseudoVRGATHEREI16_VV_MF8_MF4_MASK, VRGATHEREI16_VV }, // 8754
  { PseudoVRGATHEREI16_VV_MF8_MF8, VRGATHEREI16_VV }, // 8755
  { PseudoVRGATHEREI16_VV_MF8_MF8_MASK, VRGATHEREI16_VV }, // 8756
  { PseudoVRGATHER_VI_M1, VRGATHER_VI }, // 8757
  { PseudoVRGATHER_VI_M1_MASK, VRGATHER_VI }, // 8758
  { PseudoVRGATHER_VI_M2, VRGATHER_VI }, // 8759
  { PseudoVRGATHER_VI_M2_MASK, VRGATHER_VI }, // 8760
  { PseudoVRGATHER_VI_M4, VRGATHER_VI }, // 8761
  { PseudoVRGATHER_VI_M4_MASK, VRGATHER_VI }, // 8762
  { PseudoVRGATHER_VI_M8, VRGATHER_VI }, // 8763
  { PseudoVRGATHER_VI_M8_MASK, VRGATHER_VI }, // 8764
  { PseudoVRGATHER_VI_MF2, VRGATHER_VI }, // 8765
  { PseudoVRGATHER_VI_MF2_MASK, VRGATHER_VI }, // 8766
  { PseudoVRGATHER_VI_MF4, VRGATHER_VI }, // 8767
  { PseudoVRGATHER_VI_MF4_MASK, VRGATHER_VI }, // 8768
  { PseudoVRGATHER_VI_MF8, VRGATHER_VI }, // 8769
  { PseudoVRGATHER_VI_MF8_MASK, VRGATHER_VI }, // 8770
  { PseudoVRGATHER_VV_M1, VRGATHER_VV }, // 8771
  { PseudoVRGATHER_VV_M1_MASK, VRGATHER_VV }, // 8772
  { PseudoVRGATHER_VV_M2, VRGATHER_VV }, // 8773
  { PseudoVRGATHER_VV_M2_MASK, VRGATHER_VV }, // 8774
  { PseudoVRGATHER_VV_M4, VRGATHER_VV }, // 8775
  { PseudoVRGATHER_VV_M4_MASK, VRGATHER_VV }, // 8776
  { PseudoVRGATHER_VV_M8, VRGATHER_VV }, // 8777
  { PseudoVRGATHER_VV_M8_MASK, VRGATHER_VV }, // 8778
  { PseudoVRGATHER_VV_MF2, VRGATHER_VV }, // 8779
  { PseudoVRGATHER_VV_MF2_MASK, VRGATHER_VV }, // 8780
  { PseudoVRGATHER_VV_MF4, VRGATHER_VV }, // 8781
  { PseudoVRGATHER_VV_MF4_MASK, VRGATHER_VV }, // 8782
  { PseudoVRGATHER_VV_MF8, VRGATHER_VV }, // 8783
  { PseudoVRGATHER_VV_MF8_MASK, VRGATHER_VV }, // 8784
  { PseudoVRGATHER_VX_M1, VRGATHER_VX }, // 8785
  { PseudoVRGATHER_VX_M1_MASK, VRGATHER_VX }, // 8786
  { PseudoVRGATHER_VX_M2, VRGATHER_VX }, // 8787
  { PseudoVRGATHER_VX_M2_MASK, VRGATHER_VX }, // 8788
  { PseudoVRGATHER_VX_M4, VRGATHER_VX }, // 8789
  { PseudoVRGATHER_VX_M4_MASK, VRGATHER_VX }, // 8790
  { PseudoVRGATHER_VX_M8, VRGATHER_VX }, // 8791
  { PseudoVRGATHER_VX_M8_MASK, VRGATHER_VX }, // 8792
  { PseudoVRGATHER_VX_MF2, VRGATHER_VX }, // 8793
  { PseudoVRGATHER_VX_MF2_MASK, VRGATHER_VX }, // 8794
  { PseudoVRGATHER_VX_MF4, VRGATHER_VX }, // 8795
  { PseudoVRGATHER_VX_MF4_MASK, VRGATHER_VX }, // 8796
  { PseudoVRGATHER_VX_MF8, VRGATHER_VX }, // 8797
  { PseudoVRGATHER_VX_MF8_MASK, VRGATHER_VX }, // 8798
  { PseudoVRSUB_VI_M1, VRSUB_VI }, // 8799
  { PseudoVRSUB_VI_M1_MASK, VRSUB_VI }, // 8800
  { PseudoVRSUB_VI_M2, VRSUB_VI }, // 8801
  { PseudoVRSUB_VI_M2_MASK, VRSUB_VI }, // 8802
  { PseudoVRSUB_VI_M4, VRSUB_VI }, // 8803
  { PseudoVRSUB_VI_M4_MASK, VRSUB_VI }, // 8804
  { PseudoVRSUB_VI_M8, VRSUB_VI }, // 8805
  { PseudoVRSUB_VI_M8_MASK, VRSUB_VI }, // 8806
  { PseudoVRSUB_VI_MF2, VRSUB_VI }, // 8807
  { PseudoVRSUB_VI_MF2_MASK, VRSUB_VI }, // 8808
  { PseudoVRSUB_VI_MF4, VRSUB_VI }, // 8809
  { PseudoVRSUB_VI_MF4_MASK, VRSUB_VI }, // 8810
  { PseudoVRSUB_VI_MF8, VRSUB_VI }, // 8811
  { PseudoVRSUB_VI_MF8_MASK, VRSUB_VI }, // 8812
  { PseudoVRSUB_VX_M1, VRSUB_VX }, // 8813
  { PseudoVRSUB_VX_M1_MASK, VRSUB_VX }, // 8814
  { PseudoVRSUB_VX_M2, VRSUB_VX }, // 8815
  { PseudoVRSUB_VX_M2_MASK, VRSUB_VX }, // 8816
  { PseudoVRSUB_VX_M4, VRSUB_VX }, // 8817
  { PseudoVRSUB_VX_M4_MASK, VRSUB_VX }, // 8818
  { PseudoVRSUB_VX_M8, VRSUB_VX }, // 8819
  { PseudoVRSUB_VX_M8_MASK, VRSUB_VX }, // 8820
  { PseudoVRSUB_VX_MF2, VRSUB_VX }, // 8821
  { PseudoVRSUB_VX_MF2_MASK, VRSUB_VX }, // 8822
  { PseudoVRSUB_VX_MF4, VRSUB_VX }, // 8823
  { PseudoVRSUB_VX_MF4_MASK, VRSUB_VX }, // 8824
  { PseudoVRSUB_VX_MF8, VRSUB_VX }, // 8825
  { PseudoVRSUB_VX_MF8_MASK, VRSUB_VX }, // 8826
  { PseudoVSADDU_VI_M1, VSADDU_VI }, // 8827
  { PseudoVSADDU_VI_M1_MASK, VSADDU_VI }, // 8828
  { PseudoVSADDU_VI_M2, VSADDU_VI }, // 8829
  { PseudoVSADDU_VI_M2_MASK, VSADDU_VI }, // 8830
  { PseudoVSADDU_VI_M4, VSADDU_VI }, // 8831
  { PseudoVSADDU_VI_M4_MASK, VSADDU_VI }, // 8832
  { PseudoVSADDU_VI_M8, VSADDU_VI }, // 8833
  { PseudoVSADDU_VI_M8_MASK, VSADDU_VI }, // 8834
  { PseudoVSADDU_VI_MF2, VSADDU_VI }, // 8835
  { PseudoVSADDU_VI_MF2_MASK, VSADDU_VI }, // 8836
  { PseudoVSADDU_VI_MF4, VSADDU_VI }, // 8837
  { PseudoVSADDU_VI_MF4_MASK, VSADDU_VI }, // 8838
  { PseudoVSADDU_VI_MF8, VSADDU_VI }, // 8839
  { PseudoVSADDU_VI_MF8_MASK, VSADDU_VI }, // 8840
  { PseudoVSADDU_VV_M1, VSADDU_VV }, // 8841
  { PseudoVSADDU_VV_M1_MASK, VSADDU_VV }, // 8842
  { PseudoVSADDU_VV_M2, VSADDU_VV }, // 8843
  { PseudoVSADDU_VV_M2_MASK, VSADDU_VV }, // 8844
  { PseudoVSADDU_VV_M4, VSADDU_VV }, // 8845
  { PseudoVSADDU_VV_M4_MASK, VSADDU_VV }, // 8846
  { PseudoVSADDU_VV_M8, VSADDU_VV }, // 8847
  { PseudoVSADDU_VV_M8_MASK, VSADDU_VV }, // 8848
  { PseudoVSADDU_VV_MF2, VSADDU_VV }, // 8849
  { PseudoVSADDU_VV_MF2_MASK, VSADDU_VV }, // 8850
  { PseudoVSADDU_VV_MF4, VSADDU_VV }, // 8851
  { PseudoVSADDU_VV_MF4_MASK, VSADDU_VV }, // 8852
  { PseudoVSADDU_VV_MF8, VSADDU_VV }, // 8853
  { PseudoVSADDU_VV_MF8_MASK, VSADDU_VV }, // 8854
  { PseudoVSADDU_VX_M1, VSADDU_VX }, // 8855
  { PseudoVSADDU_VX_M1_MASK, VSADDU_VX }, // 8856
  { PseudoVSADDU_VX_M2, VSADDU_VX }, // 8857
  { PseudoVSADDU_VX_M2_MASK, VSADDU_VX }, // 8858
  { PseudoVSADDU_VX_M4, VSADDU_VX }, // 8859
  { PseudoVSADDU_VX_M4_MASK, VSADDU_VX }, // 8860
  { PseudoVSADDU_VX_M8, VSADDU_VX }, // 8861
  { PseudoVSADDU_VX_M8_MASK, VSADDU_VX }, // 8862
  { PseudoVSADDU_VX_MF2, VSADDU_VX }, // 8863
  { PseudoVSADDU_VX_MF2_MASK, VSADDU_VX }, // 8864
  { PseudoVSADDU_VX_MF4, VSADDU_VX }, // 8865
  { PseudoVSADDU_VX_MF4_MASK, VSADDU_VX }, // 8866
  { PseudoVSADDU_VX_MF8, VSADDU_VX }, // 8867
  { PseudoVSADDU_VX_MF8_MASK, VSADDU_VX }, // 8868
  { PseudoVSADD_VI_M1, VSADD_VI }, // 8869
  { PseudoVSADD_VI_M1_MASK, VSADD_VI }, // 8870
  { PseudoVSADD_VI_M2, VSADD_VI }, // 8871
  { PseudoVSADD_VI_M2_MASK, VSADD_VI }, // 8872
  { PseudoVSADD_VI_M4, VSADD_VI }, // 8873
  { PseudoVSADD_VI_M4_MASK, VSADD_VI }, // 8874
  { PseudoVSADD_VI_M8, VSADD_VI }, // 8875
  { PseudoVSADD_VI_M8_MASK, VSADD_VI }, // 8876
  { PseudoVSADD_VI_MF2, VSADD_VI }, // 8877
  { PseudoVSADD_VI_MF2_MASK, VSADD_VI }, // 8878
  { PseudoVSADD_VI_MF4, VSADD_VI }, // 8879
  { PseudoVSADD_VI_MF4_MASK, VSADD_VI }, // 8880
  { PseudoVSADD_VI_MF8, VSADD_VI }, // 8881
  { PseudoVSADD_VI_MF8_MASK, VSADD_VI }, // 8882
  { PseudoVSADD_VV_M1, VSADD_VV }, // 8883
  { PseudoVSADD_VV_M1_MASK, VSADD_VV }, // 8884
  { PseudoVSADD_VV_M2, VSADD_VV }, // 8885
  { PseudoVSADD_VV_M2_MASK, VSADD_VV }, // 8886
  { PseudoVSADD_VV_M4, VSADD_VV }, // 8887
  { PseudoVSADD_VV_M4_MASK, VSADD_VV }, // 8888
  { PseudoVSADD_VV_M8, VSADD_VV }, // 8889
  { PseudoVSADD_VV_M8_MASK, VSADD_VV }, // 8890
  { PseudoVSADD_VV_MF2, VSADD_VV }, // 8891
  { PseudoVSADD_VV_MF2_MASK, VSADD_VV }, // 8892
  { PseudoVSADD_VV_MF4, VSADD_VV }, // 8893
  { PseudoVSADD_VV_MF4_MASK, VSADD_VV }, // 8894
  { PseudoVSADD_VV_MF8, VSADD_VV }, // 8895
  { PseudoVSADD_VV_MF8_MASK, VSADD_VV }, // 8896
  { PseudoVSADD_VX_M1, VSADD_VX }, // 8897
  { PseudoVSADD_VX_M1_MASK, VSADD_VX }, // 8898
  { PseudoVSADD_VX_M2, VSADD_VX }, // 8899
  { PseudoVSADD_VX_M2_MASK, VSADD_VX }, // 8900
  { PseudoVSADD_VX_M4, VSADD_VX }, // 8901
  { PseudoVSADD_VX_M4_MASK, VSADD_VX }, // 8902
  { PseudoVSADD_VX_M8, VSADD_VX }, // 8903
  { PseudoVSADD_VX_M8_MASK, VSADD_VX }, // 8904
  { PseudoVSADD_VX_MF2, VSADD_VX }, // 8905
  { PseudoVSADD_VX_MF2_MASK, VSADD_VX }, // 8906
  { PseudoVSADD_VX_MF4, VSADD_VX }, // 8907
  { PseudoVSADD_VX_MF4_MASK, VSADD_VX }, // 8908
  { PseudoVSADD_VX_MF8, VSADD_VX }, // 8909
  { PseudoVSADD_VX_MF8_MASK, VSADD_VX }, // 8910
  { PseudoVSBC_VVM_M1, VSBC_VVM }, // 8911
  { PseudoVSBC_VVM_M2, VSBC_VVM }, // 8912
  { PseudoVSBC_VVM_M4, VSBC_VVM }, // 8913
  { PseudoVSBC_VVM_M8, VSBC_VVM }, // 8914
  { PseudoVSBC_VVM_MF2, VSBC_VVM }, // 8915
  { PseudoVSBC_VVM_MF4, VSBC_VVM }, // 8916
  { PseudoVSBC_VVM_MF8, VSBC_VVM }, // 8917
  { PseudoVSBC_VXM_M1, VSBC_VXM }, // 8918
  { PseudoVSBC_VXM_M2, VSBC_VXM }, // 8919
  { PseudoVSBC_VXM_M4, VSBC_VXM }, // 8920
  { PseudoVSBC_VXM_M8, VSBC_VXM }, // 8921
  { PseudoVSBC_VXM_MF2, VSBC_VXM }, // 8922
  { PseudoVSBC_VXM_MF4, VSBC_VXM }, // 8923
  { PseudoVSBC_VXM_MF8, VSBC_VXM }, // 8924
  { PseudoVSE16_V_M1, VSE16_V }, // 8925
  { PseudoVSE16_V_M1_MASK, VSE16_V }, // 8926
  { PseudoVSE16_V_M2, VSE16_V }, // 8927
  { PseudoVSE16_V_M2_MASK, VSE16_V }, // 8928
  { PseudoVSE16_V_M4, VSE16_V }, // 8929
  { PseudoVSE16_V_M4_MASK, VSE16_V }, // 8930
  { PseudoVSE16_V_M8, VSE16_V }, // 8931
  { PseudoVSE16_V_M8_MASK, VSE16_V }, // 8932
  { PseudoVSE16_V_MF2, VSE16_V }, // 8933
  { PseudoVSE16_V_MF2_MASK, VSE16_V }, // 8934
  { PseudoVSE16_V_MF4, VSE16_V }, // 8935
  { PseudoVSE16_V_MF4_MASK, VSE16_V }, // 8936
  { PseudoVSE16_V_MF8, VSE16_V }, // 8937
  { PseudoVSE16_V_MF8_MASK, VSE16_V }, // 8938
  { PseudoVSE1_V_B1, VSE1_V }, // 8939
  { PseudoVSE1_V_B16, VSE1_V }, // 8940
  { PseudoVSE1_V_B2, VSE1_V }, // 8941
  { PseudoVSE1_V_B32, VSE1_V }, // 8942
  { PseudoVSE1_V_B4, VSE1_V }, // 8943
  { PseudoVSE1_V_B64, VSE1_V }, // 8944
  { PseudoVSE1_V_B8, VSE1_V }, // 8945
  { PseudoVSE32_V_M1, VSE32_V }, // 8946
  { PseudoVSE32_V_M1_MASK, VSE32_V }, // 8947
  { PseudoVSE32_V_M2, VSE32_V }, // 8948
  { PseudoVSE32_V_M2_MASK, VSE32_V }, // 8949
  { PseudoVSE32_V_M4, VSE32_V }, // 8950
  { PseudoVSE32_V_M4_MASK, VSE32_V }, // 8951
  { PseudoVSE32_V_M8, VSE32_V }, // 8952
  { PseudoVSE32_V_M8_MASK, VSE32_V }, // 8953
  { PseudoVSE32_V_MF2, VSE32_V }, // 8954
  { PseudoVSE32_V_MF2_MASK, VSE32_V }, // 8955
  { PseudoVSE32_V_MF4, VSE32_V }, // 8956
  { PseudoVSE32_V_MF4_MASK, VSE32_V }, // 8957
  { PseudoVSE32_V_MF8, VSE32_V }, // 8958
  { PseudoVSE32_V_MF8_MASK, VSE32_V }, // 8959
  { PseudoVSE64_V_M1, VSE64_V }, // 8960
  { PseudoVSE64_V_M1_MASK, VSE64_V }, // 8961
  { PseudoVSE64_V_M2, VSE64_V }, // 8962
  { PseudoVSE64_V_M2_MASK, VSE64_V }, // 8963
  { PseudoVSE64_V_M4, VSE64_V }, // 8964
  { PseudoVSE64_V_M4_MASK, VSE64_V }, // 8965
  { PseudoVSE64_V_M8, VSE64_V }, // 8966
  { PseudoVSE64_V_M8_MASK, VSE64_V }, // 8967
  { PseudoVSE64_V_MF2, VSE64_V }, // 8968
  { PseudoVSE64_V_MF2_MASK, VSE64_V }, // 8969
  { PseudoVSE64_V_MF4, VSE64_V }, // 8970
  { PseudoVSE64_V_MF4_MASK, VSE64_V }, // 8971
  { PseudoVSE64_V_MF8, VSE64_V }, // 8972
  { PseudoVSE64_V_MF8_MASK, VSE64_V }, // 8973
  { PseudoVSE8_V_M1, VSE8_V }, // 8974
  { PseudoVSE8_V_M1_MASK, VSE8_V }, // 8975
  { PseudoVSE8_V_M2, VSE8_V }, // 8976
  { PseudoVSE8_V_M2_MASK, VSE8_V }, // 8977
  { PseudoVSE8_V_M4, VSE8_V }, // 8978
  { PseudoVSE8_V_M4_MASK, VSE8_V }, // 8979
  { PseudoVSE8_V_M8, VSE8_V }, // 8980
  { PseudoVSE8_V_M8_MASK, VSE8_V }, // 8981
  { PseudoVSE8_V_MF2, VSE8_V }, // 8982
  { PseudoVSE8_V_MF2_MASK, VSE8_V }, // 8983
  { PseudoVSE8_V_MF4, VSE8_V }, // 8984
  { PseudoVSE8_V_MF4_MASK, VSE8_V }, // 8985
  { PseudoVSE8_V_MF8, VSE8_V }, // 8986
  { PseudoVSE8_V_MF8_MASK, VSE8_V }, // 8987
  { PseudoVSEXT_VF2_M1, VSEXT_VF2 }, // 8988
  { PseudoVSEXT_VF2_M1_MASK, VSEXT_VF2 }, // 8989
  { PseudoVSEXT_VF2_M2, VSEXT_VF2 }, // 8990
  { PseudoVSEXT_VF2_M2_MASK, VSEXT_VF2 }, // 8991
  { PseudoVSEXT_VF2_M4, VSEXT_VF2 }, // 8992
  { PseudoVSEXT_VF2_M4_MASK, VSEXT_VF2 }, // 8993
  { PseudoVSEXT_VF2_M8, VSEXT_VF2 }, // 8994
  { PseudoVSEXT_VF2_M8_MASK, VSEXT_VF2 }, // 8995
  { PseudoVSEXT_VF2_MF2, VSEXT_VF2 }, // 8996
  { PseudoVSEXT_VF2_MF2_MASK, VSEXT_VF2 }, // 8997
  { PseudoVSEXT_VF2_MF4, VSEXT_VF2 }, // 8998
  { PseudoVSEXT_VF2_MF4_MASK, VSEXT_VF2 }, // 8999
  { PseudoVSEXT_VF4_M1, VSEXT_VF4 }, // 9000
  { PseudoVSEXT_VF4_M1_MASK, VSEXT_VF4 }, // 9001
  { PseudoVSEXT_VF4_M2, VSEXT_VF4 }, // 9002
  { PseudoVSEXT_VF4_M2_MASK, VSEXT_VF4 }, // 9003
  { PseudoVSEXT_VF4_M4, VSEXT_VF4 }, // 9004
  { PseudoVSEXT_VF4_M4_MASK, VSEXT_VF4 }, // 9005
  { PseudoVSEXT_VF4_M8, VSEXT_VF4 }, // 9006
  { PseudoVSEXT_VF4_M8_MASK, VSEXT_VF4 }, // 9007
  { PseudoVSEXT_VF4_MF2, VSEXT_VF4 }, // 9008
  { PseudoVSEXT_VF4_MF2_MASK, VSEXT_VF4 }, // 9009
  { PseudoVSEXT_VF8_M1, VSEXT_VF8 }, // 9010
  { PseudoVSEXT_VF8_M1_MASK, VSEXT_VF8 }, // 9011
  { PseudoVSEXT_VF8_M2, VSEXT_VF8 }, // 9012
  { PseudoVSEXT_VF8_M2_MASK, VSEXT_VF8 }, // 9013
  { PseudoVSEXT_VF8_M4, VSEXT_VF8 }, // 9014
  { PseudoVSEXT_VF8_M4_MASK, VSEXT_VF8 }, // 9015
  { PseudoVSEXT_VF8_M8, VSEXT_VF8 }, // 9016
  { PseudoVSEXT_VF8_M8_MASK, VSEXT_VF8 }, // 9017
  { PseudoVSLIDE1DOWN_VX_M1, VSLIDE1DOWN_VX }, // 9018
  { PseudoVSLIDE1DOWN_VX_M1_MASK, VSLIDE1DOWN_VX }, // 9019
  { PseudoVSLIDE1DOWN_VX_M2, VSLIDE1DOWN_VX }, // 9020
  { PseudoVSLIDE1DOWN_VX_M2_MASK, VSLIDE1DOWN_VX }, // 9021
  { PseudoVSLIDE1DOWN_VX_M4, VSLIDE1DOWN_VX }, // 9022
  { PseudoVSLIDE1DOWN_VX_M4_MASK, VSLIDE1DOWN_VX }, // 9023
  { PseudoVSLIDE1DOWN_VX_M8, VSLIDE1DOWN_VX }, // 9024
  { PseudoVSLIDE1DOWN_VX_M8_MASK, VSLIDE1DOWN_VX }, // 9025
  { PseudoVSLIDE1DOWN_VX_MF2, VSLIDE1DOWN_VX }, // 9026
  { PseudoVSLIDE1DOWN_VX_MF2_MASK, VSLIDE1DOWN_VX }, // 9027
  { PseudoVSLIDE1DOWN_VX_MF4, VSLIDE1DOWN_VX }, // 9028
  { PseudoVSLIDE1DOWN_VX_MF4_MASK, VSLIDE1DOWN_VX }, // 9029
  { PseudoVSLIDE1DOWN_VX_MF8, VSLIDE1DOWN_VX }, // 9030
  { PseudoVSLIDE1DOWN_VX_MF8_MASK, VSLIDE1DOWN_VX }, // 9031
  { PseudoVSLIDE1UP_VX_M1, VSLIDE1UP_VX }, // 9032
  { PseudoVSLIDE1UP_VX_M1_MASK, VSLIDE1UP_VX }, // 9033
  { PseudoVSLIDE1UP_VX_M2, VSLIDE1UP_VX }, // 9034
  { PseudoVSLIDE1UP_VX_M2_MASK, VSLIDE1UP_VX }, // 9035
  { PseudoVSLIDE1UP_VX_M4, VSLIDE1UP_VX }, // 9036
  { PseudoVSLIDE1UP_VX_M4_MASK, VSLIDE1UP_VX }, // 9037
  { PseudoVSLIDE1UP_VX_M8, VSLIDE1UP_VX }, // 9038
  { PseudoVSLIDE1UP_VX_M8_MASK, VSLIDE1UP_VX }, // 9039
  { PseudoVSLIDE1UP_VX_MF2, VSLIDE1UP_VX }, // 9040
  { PseudoVSLIDE1UP_VX_MF2_MASK, VSLIDE1UP_VX }, // 9041
  { PseudoVSLIDE1UP_VX_MF4, VSLIDE1UP_VX }, // 9042
  { PseudoVSLIDE1UP_VX_MF4_MASK, VSLIDE1UP_VX }, // 9043
  { PseudoVSLIDE1UP_VX_MF8, VSLIDE1UP_VX }, // 9044
  { PseudoVSLIDE1UP_VX_MF8_MASK, VSLIDE1UP_VX }, // 9045
  { PseudoVSLIDEDOWN_VI_M1, VSLIDEDOWN_VI }, // 9046
  { PseudoVSLIDEDOWN_VI_M1_MASK, VSLIDEDOWN_VI }, // 9047
  { PseudoVSLIDEDOWN_VI_M2, VSLIDEDOWN_VI }, // 9048
  { PseudoVSLIDEDOWN_VI_M2_MASK, VSLIDEDOWN_VI }, // 9049
  { PseudoVSLIDEDOWN_VI_M4, VSLIDEDOWN_VI }, // 9050
  { PseudoVSLIDEDOWN_VI_M4_MASK, VSLIDEDOWN_VI }, // 9051
  { PseudoVSLIDEDOWN_VI_M8, VSLIDEDOWN_VI }, // 9052
  { PseudoVSLIDEDOWN_VI_M8_MASK, VSLIDEDOWN_VI }, // 9053
  { PseudoVSLIDEDOWN_VI_MF2, VSLIDEDOWN_VI }, // 9054
  { PseudoVSLIDEDOWN_VI_MF2_MASK, VSLIDEDOWN_VI }, // 9055
  { PseudoVSLIDEDOWN_VI_MF4, VSLIDEDOWN_VI }, // 9056
  { PseudoVSLIDEDOWN_VI_MF4_MASK, VSLIDEDOWN_VI }, // 9057
  { PseudoVSLIDEDOWN_VI_MF8, VSLIDEDOWN_VI }, // 9058
  { PseudoVSLIDEDOWN_VI_MF8_MASK, VSLIDEDOWN_VI }, // 9059
  { PseudoVSLIDEDOWN_VX_M1, VSLIDEDOWN_VX }, // 9060
  { PseudoVSLIDEDOWN_VX_M1_MASK, VSLIDEDOWN_VX }, // 9061
  { PseudoVSLIDEDOWN_VX_M2, VSLIDEDOWN_VX }, // 9062
  { PseudoVSLIDEDOWN_VX_M2_MASK, VSLIDEDOWN_VX }, // 9063
  { PseudoVSLIDEDOWN_VX_M4, VSLIDEDOWN_VX }, // 9064
  { PseudoVSLIDEDOWN_VX_M4_MASK, VSLIDEDOWN_VX }, // 9065
  { PseudoVSLIDEDOWN_VX_M8, VSLIDEDOWN_VX }, // 9066
  { PseudoVSLIDEDOWN_VX_M8_MASK, VSLIDEDOWN_VX }, // 9067
  { PseudoVSLIDEDOWN_VX_MF2, VSLIDEDOWN_VX }, // 9068
  { PseudoVSLIDEDOWN_VX_MF2_MASK, VSLIDEDOWN_VX }, // 9069
  { PseudoVSLIDEDOWN_VX_MF4, VSLIDEDOWN_VX }, // 9070
  { PseudoVSLIDEDOWN_VX_MF4_MASK, VSLIDEDOWN_VX }, // 9071
  { PseudoVSLIDEDOWN_VX_MF8, VSLIDEDOWN_VX }, // 9072
  { PseudoVSLIDEDOWN_VX_MF8_MASK, VSLIDEDOWN_VX }, // 9073
  { PseudoVSLIDEUP_VI_M1, VSLIDEUP_VI }, // 9074
  { PseudoVSLIDEUP_VI_M1_MASK, VSLIDEUP_VI }, // 9075
  { PseudoVSLIDEUP_VI_M2, VSLIDEUP_VI }, // 9076
  { PseudoVSLIDEUP_VI_M2_MASK, VSLIDEUP_VI }, // 9077
  { PseudoVSLIDEUP_VI_M4, VSLIDEUP_VI }, // 9078
  { PseudoVSLIDEUP_VI_M4_MASK, VSLIDEUP_VI }, // 9079
  { PseudoVSLIDEUP_VI_M8, VSLIDEUP_VI }, // 9080
  { PseudoVSLIDEUP_VI_M8_MASK, VSLIDEUP_VI }, // 9081
  { PseudoVSLIDEUP_VI_MF2, VSLIDEUP_VI }, // 9082
  { PseudoVSLIDEUP_VI_MF2_MASK, VSLIDEUP_VI }, // 9083
  { PseudoVSLIDEUP_VI_MF4, VSLIDEUP_VI }, // 9084
  { PseudoVSLIDEUP_VI_MF4_MASK, VSLIDEUP_VI }, // 9085
  { PseudoVSLIDEUP_VI_MF8, VSLIDEUP_VI }, // 9086
  { PseudoVSLIDEUP_VI_MF8_MASK, VSLIDEUP_VI }, // 9087
  { PseudoVSLIDEUP_VX_M1, VSLIDEUP_VX }, // 9088
  { PseudoVSLIDEUP_VX_M1_MASK, VSLIDEUP_VX }, // 9089
  { PseudoVSLIDEUP_VX_M2, VSLIDEUP_VX }, // 9090
  { PseudoVSLIDEUP_VX_M2_MASK, VSLIDEUP_VX }, // 9091
  { PseudoVSLIDEUP_VX_M4, VSLIDEUP_VX }, // 9092
  { PseudoVSLIDEUP_VX_M4_MASK, VSLIDEUP_VX }, // 9093
  { PseudoVSLIDEUP_VX_M8, VSLIDEUP_VX }, // 9094
  { PseudoVSLIDEUP_VX_M8_MASK, VSLIDEUP_VX }, // 9095
  { PseudoVSLIDEUP_VX_MF2, VSLIDEUP_VX }, // 9096
  { PseudoVSLIDEUP_VX_MF2_MASK, VSLIDEUP_VX }, // 9097
  { PseudoVSLIDEUP_VX_MF4, VSLIDEUP_VX }, // 9098
  { PseudoVSLIDEUP_VX_MF4_MASK, VSLIDEUP_VX }, // 9099
  { PseudoVSLIDEUP_VX_MF8, VSLIDEUP_VX }, // 9100
  { PseudoVSLIDEUP_VX_MF8_MASK, VSLIDEUP_VX }, // 9101
  { PseudoVSLL_VI_M1, VSLL_VI }, // 9102
  { PseudoVSLL_VI_M1_MASK, VSLL_VI }, // 9103
  { PseudoVSLL_VI_M2, VSLL_VI }, // 9104
  { PseudoVSLL_VI_M2_MASK, VSLL_VI }, // 9105
  { PseudoVSLL_VI_M4, VSLL_VI }, // 9106
  { PseudoVSLL_VI_M4_MASK, VSLL_VI }, // 9107
  { PseudoVSLL_VI_M8, VSLL_VI }, // 9108
  { PseudoVSLL_VI_M8_MASK, VSLL_VI }, // 9109
  { PseudoVSLL_VI_MF2, VSLL_VI }, // 9110
  { PseudoVSLL_VI_MF2_MASK, VSLL_VI }, // 9111
  { PseudoVSLL_VI_MF4, VSLL_VI }, // 9112
  { PseudoVSLL_VI_MF4_MASK, VSLL_VI }, // 9113
  { PseudoVSLL_VI_MF8, VSLL_VI }, // 9114
  { PseudoVSLL_VI_MF8_MASK, VSLL_VI }, // 9115
  { PseudoVSLL_VV_M1, VSLL_VV }, // 9116
  { PseudoVSLL_VV_M1_MASK, VSLL_VV }, // 9117
  { PseudoVSLL_VV_M2, VSLL_VV }, // 9118
  { PseudoVSLL_VV_M2_MASK, VSLL_VV }, // 9119
  { PseudoVSLL_VV_M4, VSLL_VV }, // 9120
  { PseudoVSLL_VV_M4_MASK, VSLL_VV }, // 9121
  { PseudoVSLL_VV_M8, VSLL_VV }, // 9122
  { PseudoVSLL_VV_M8_MASK, VSLL_VV }, // 9123
  { PseudoVSLL_VV_MF2, VSLL_VV }, // 9124
  { PseudoVSLL_VV_MF2_MASK, VSLL_VV }, // 9125
  { PseudoVSLL_VV_MF4, VSLL_VV }, // 9126
  { PseudoVSLL_VV_MF4_MASK, VSLL_VV }, // 9127
  { PseudoVSLL_VV_MF8, VSLL_VV }, // 9128
  { PseudoVSLL_VV_MF8_MASK, VSLL_VV }, // 9129
  { PseudoVSLL_VX_M1, VSLL_VX }, // 9130
  { PseudoVSLL_VX_M1_MASK, VSLL_VX }, // 9131
  { PseudoVSLL_VX_M2, VSLL_VX }, // 9132
  { PseudoVSLL_VX_M2_MASK, VSLL_VX }, // 9133
  { PseudoVSLL_VX_M4, VSLL_VX }, // 9134
  { PseudoVSLL_VX_M4_MASK, VSLL_VX }, // 9135
  { PseudoVSLL_VX_M8, VSLL_VX }, // 9136
  { PseudoVSLL_VX_M8_MASK, VSLL_VX }, // 9137
  { PseudoVSLL_VX_MF2, VSLL_VX }, // 9138
  { PseudoVSLL_VX_MF2_MASK, VSLL_VX }, // 9139
  { PseudoVSLL_VX_MF4, VSLL_VX }, // 9140
  { PseudoVSLL_VX_MF4_MASK, VSLL_VX }, // 9141
  { PseudoVSLL_VX_MF8, VSLL_VX }, // 9142
  { PseudoVSLL_VX_MF8_MASK, VSLL_VX }, // 9143
  { PseudoVSMUL_VV_M1, VSMUL_VV }, // 9144
  { PseudoVSMUL_VV_M1_MASK, VSMUL_VV }, // 9145
  { PseudoVSMUL_VV_M2, VSMUL_VV }, // 9146
  { PseudoVSMUL_VV_M2_MASK, VSMUL_VV }, // 9147
  { PseudoVSMUL_VV_M4, VSMUL_VV }, // 9148
  { PseudoVSMUL_VV_M4_MASK, VSMUL_VV }, // 9149
  { PseudoVSMUL_VV_M8, VSMUL_VV }, // 9150
  { PseudoVSMUL_VV_M8_MASK, VSMUL_VV }, // 9151
  { PseudoVSMUL_VV_MF2, VSMUL_VV }, // 9152
  { PseudoVSMUL_VV_MF2_MASK, VSMUL_VV }, // 9153
  { PseudoVSMUL_VV_MF4, VSMUL_VV }, // 9154
  { PseudoVSMUL_VV_MF4_MASK, VSMUL_VV }, // 9155
  { PseudoVSMUL_VV_MF8, VSMUL_VV }, // 9156
  { PseudoVSMUL_VV_MF8_MASK, VSMUL_VV }, // 9157
  { PseudoVSMUL_VX_M1, VSMUL_VX }, // 9158
  { PseudoVSMUL_VX_M1_MASK, VSMUL_VX }, // 9159
  { PseudoVSMUL_VX_M2, VSMUL_VX }, // 9160
  { PseudoVSMUL_VX_M2_MASK, VSMUL_VX }, // 9161
  { PseudoVSMUL_VX_M4, VSMUL_VX }, // 9162
  { PseudoVSMUL_VX_M4_MASK, VSMUL_VX }, // 9163
  { PseudoVSMUL_VX_M8, VSMUL_VX }, // 9164
  { PseudoVSMUL_VX_M8_MASK, VSMUL_VX }, // 9165
  { PseudoVSMUL_VX_MF2, VSMUL_VX }, // 9166
  { PseudoVSMUL_VX_MF2_MASK, VSMUL_VX }, // 9167
  { PseudoVSMUL_VX_MF4, VSMUL_VX }, // 9168
  { PseudoVSMUL_VX_MF4_MASK, VSMUL_VX }, // 9169
  { PseudoVSMUL_VX_MF8, VSMUL_VX }, // 9170
  { PseudoVSMUL_VX_MF8_MASK, VSMUL_VX }, // 9171
  { PseudoVSOXEI16_V_M1_M1, VSOXEI16_V }, // 9172
  { PseudoVSOXEI16_V_M1_M1_MASK, VSOXEI16_V }, // 9173
  { PseudoVSOXEI16_V_M1_M2, VSOXEI16_V }, // 9174
  { PseudoVSOXEI16_V_M1_M2_MASK, VSOXEI16_V }, // 9175
  { PseudoVSOXEI16_V_M1_M4, VSOXEI16_V }, // 9176
  { PseudoVSOXEI16_V_M1_M4_MASK, VSOXEI16_V }, // 9177
  { PseudoVSOXEI16_V_M1_M8, VSOXEI16_V }, // 9178
  { PseudoVSOXEI16_V_M1_M8_MASK, VSOXEI16_V }, // 9179
  { PseudoVSOXEI16_V_M1_MF2, VSOXEI16_V }, // 9180
  { PseudoVSOXEI16_V_M1_MF2_MASK, VSOXEI16_V }, // 9181
  { PseudoVSOXEI16_V_M1_MF4, VSOXEI16_V }, // 9182
  { PseudoVSOXEI16_V_M1_MF4_MASK, VSOXEI16_V }, // 9183
  { PseudoVSOXEI16_V_M1_MF8, VSOXEI16_V }, // 9184
  { PseudoVSOXEI16_V_M1_MF8_MASK, VSOXEI16_V }, // 9185
  { PseudoVSOXEI16_V_M2_M1, VSOXEI16_V }, // 9186
  { PseudoVSOXEI16_V_M2_M1_MASK, VSOXEI16_V }, // 9187
  { PseudoVSOXEI16_V_M2_M2, VSOXEI16_V }, // 9188
  { PseudoVSOXEI16_V_M2_M2_MASK, VSOXEI16_V }, // 9189
  { PseudoVSOXEI16_V_M2_M4, VSOXEI16_V }, // 9190
  { PseudoVSOXEI16_V_M2_M4_MASK, VSOXEI16_V }, // 9191
  { PseudoVSOXEI16_V_M2_M8, VSOXEI16_V }, // 9192
  { PseudoVSOXEI16_V_M2_M8_MASK, VSOXEI16_V }, // 9193
  { PseudoVSOXEI16_V_M2_MF2, VSOXEI16_V }, // 9194
  { PseudoVSOXEI16_V_M2_MF2_MASK, VSOXEI16_V }, // 9195
  { PseudoVSOXEI16_V_M2_MF4, VSOXEI16_V }, // 9196
  { PseudoVSOXEI16_V_M2_MF4_MASK, VSOXEI16_V }, // 9197
  { PseudoVSOXEI16_V_M2_MF8, VSOXEI16_V }, // 9198
  { PseudoVSOXEI16_V_M2_MF8_MASK, VSOXEI16_V }, // 9199
  { PseudoVSOXEI16_V_M4_M1, VSOXEI16_V }, // 9200
  { PseudoVSOXEI16_V_M4_M1_MASK, VSOXEI16_V }, // 9201
  { PseudoVSOXEI16_V_M4_M2, VSOXEI16_V }, // 9202
  { PseudoVSOXEI16_V_M4_M2_MASK, VSOXEI16_V }, // 9203
  { PseudoVSOXEI16_V_M4_M4, VSOXEI16_V }, // 9204
  { PseudoVSOXEI16_V_M4_M4_MASK, VSOXEI16_V }, // 9205
  { PseudoVSOXEI16_V_M4_M8, VSOXEI16_V }, // 9206
  { PseudoVSOXEI16_V_M4_M8_MASK, VSOXEI16_V }, // 9207
  { PseudoVSOXEI16_V_M4_MF2, VSOXEI16_V }, // 9208
  { PseudoVSOXEI16_V_M4_MF2_MASK, VSOXEI16_V }, // 9209
  { PseudoVSOXEI16_V_M4_MF4, VSOXEI16_V }, // 9210
  { PseudoVSOXEI16_V_M4_MF4_MASK, VSOXEI16_V }, // 9211
  { PseudoVSOXEI16_V_M4_MF8, VSOXEI16_V }, // 9212
  { PseudoVSOXEI16_V_M4_MF8_MASK, VSOXEI16_V }, // 9213
  { PseudoVSOXEI16_V_M8_M1, VSOXEI16_V }, // 9214
  { PseudoVSOXEI16_V_M8_M1_MASK, VSOXEI16_V }, // 9215
  { PseudoVSOXEI16_V_M8_M2, VSOXEI16_V }, // 9216
  { PseudoVSOXEI16_V_M8_M2_MASK, VSOXEI16_V }, // 9217
  { PseudoVSOXEI16_V_M8_M4, VSOXEI16_V }, // 9218
  { PseudoVSOXEI16_V_M8_M4_MASK, VSOXEI16_V }, // 9219
  { PseudoVSOXEI16_V_M8_M8, VSOXEI16_V }, // 9220
  { PseudoVSOXEI16_V_M8_M8_MASK, VSOXEI16_V }, // 9221
  { PseudoVSOXEI16_V_M8_MF2, VSOXEI16_V }, // 9222
  { PseudoVSOXEI16_V_M8_MF2_MASK, VSOXEI16_V }, // 9223
  { PseudoVSOXEI16_V_M8_MF4, VSOXEI16_V }, // 9224
  { PseudoVSOXEI16_V_M8_MF4_MASK, VSOXEI16_V }, // 9225
  { PseudoVSOXEI16_V_M8_MF8, VSOXEI16_V }, // 9226
  { PseudoVSOXEI16_V_M8_MF8_MASK, VSOXEI16_V }, // 9227
  { PseudoVSOXEI16_V_MF2_M1, VSOXEI16_V }, // 9228
  { PseudoVSOXEI16_V_MF2_M1_MASK, VSOXEI16_V }, // 9229
  { PseudoVSOXEI16_V_MF2_M2, VSOXEI16_V }, // 9230
  { PseudoVSOXEI16_V_MF2_M2_MASK, VSOXEI16_V }, // 9231
  { PseudoVSOXEI16_V_MF2_M4, VSOXEI16_V }, // 9232
  { PseudoVSOXEI16_V_MF2_M4_MASK, VSOXEI16_V }, // 9233
  { PseudoVSOXEI16_V_MF2_M8, VSOXEI16_V }, // 9234
  { PseudoVSOXEI16_V_MF2_M8_MASK, VSOXEI16_V }, // 9235
  { PseudoVSOXEI16_V_MF2_MF2, VSOXEI16_V }, // 9236
  { PseudoVSOXEI16_V_MF2_MF2_MASK, VSOXEI16_V }, // 9237
  { PseudoVSOXEI16_V_MF2_MF4, VSOXEI16_V }, // 9238
  { PseudoVSOXEI16_V_MF2_MF4_MASK, VSOXEI16_V }, // 9239
  { PseudoVSOXEI16_V_MF2_MF8, VSOXEI16_V }, // 9240
  { PseudoVSOXEI16_V_MF2_MF8_MASK, VSOXEI16_V }, // 9241
  { PseudoVSOXEI16_V_MF4_M1, VSOXEI16_V }, // 9242
  { PseudoVSOXEI16_V_MF4_M1_MASK, VSOXEI16_V }, // 9243
  { PseudoVSOXEI16_V_MF4_M2, VSOXEI16_V }, // 9244
  { PseudoVSOXEI16_V_MF4_M2_MASK, VSOXEI16_V }, // 9245
  { PseudoVSOXEI16_V_MF4_M4, VSOXEI16_V }, // 9246
  { PseudoVSOXEI16_V_MF4_M4_MASK, VSOXEI16_V }, // 9247
  { PseudoVSOXEI16_V_MF4_M8, VSOXEI16_V }, // 9248
  { PseudoVSOXEI16_V_MF4_M8_MASK, VSOXEI16_V }, // 9249
  { PseudoVSOXEI16_V_MF4_MF2, VSOXEI16_V }, // 9250
  { PseudoVSOXEI16_V_MF4_MF2_MASK, VSOXEI16_V }, // 9251
  { PseudoVSOXEI16_V_MF4_MF4, VSOXEI16_V }, // 9252
  { PseudoVSOXEI16_V_MF4_MF4_MASK, VSOXEI16_V }, // 9253
  { PseudoVSOXEI16_V_MF4_MF8, VSOXEI16_V }, // 9254
  { PseudoVSOXEI16_V_MF4_MF8_MASK, VSOXEI16_V }, // 9255
  { PseudoVSOXEI16_V_MF8_M1, VSOXEI16_V }, // 9256
  { PseudoVSOXEI16_V_MF8_M1_MASK, VSOXEI16_V }, // 9257
  { PseudoVSOXEI16_V_MF8_M2, VSOXEI16_V }, // 9258
  { PseudoVSOXEI16_V_MF8_M2_MASK, VSOXEI16_V }, // 9259
  { PseudoVSOXEI16_V_MF8_M4, VSOXEI16_V }, // 9260
  { PseudoVSOXEI16_V_MF8_M4_MASK, VSOXEI16_V }, // 9261
  { PseudoVSOXEI16_V_MF8_M8, VSOXEI16_V }, // 9262
  { PseudoVSOXEI16_V_MF8_M8_MASK, VSOXEI16_V }, // 9263
  { PseudoVSOXEI16_V_MF8_MF2, VSOXEI16_V }, // 9264
  { PseudoVSOXEI16_V_MF8_MF2_MASK, VSOXEI16_V }, // 9265
  { PseudoVSOXEI16_V_MF8_MF4, VSOXEI16_V }, // 9266
  { PseudoVSOXEI16_V_MF8_MF4_MASK, VSOXEI16_V }, // 9267
  { PseudoVSOXEI16_V_MF8_MF8, VSOXEI16_V }, // 9268
  { PseudoVSOXEI16_V_MF8_MF8_MASK, VSOXEI16_V }, // 9269
  { PseudoVSOXEI32_V_M1_M1, VSOXEI32_V }, // 9270
  { PseudoVSOXEI32_V_M1_M1_MASK, VSOXEI32_V }, // 9271
  { PseudoVSOXEI32_V_M1_M2, VSOXEI32_V }, // 9272
  { PseudoVSOXEI32_V_M1_M2_MASK, VSOXEI32_V }, // 9273
  { PseudoVSOXEI32_V_M1_M4, VSOXEI32_V }, // 9274
  { PseudoVSOXEI32_V_M1_M4_MASK, VSOXEI32_V }, // 9275
  { PseudoVSOXEI32_V_M1_M8, VSOXEI32_V }, // 9276
  { PseudoVSOXEI32_V_M1_M8_MASK, VSOXEI32_V }, // 9277
  { PseudoVSOXEI32_V_M1_MF2, VSOXEI32_V }, // 9278
  { PseudoVSOXEI32_V_M1_MF2_MASK, VSOXEI32_V }, // 9279
  { PseudoVSOXEI32_V_M1_MF4, VSOXEI32_V }, // 9280
  { PseudoVSOXEI32_V_M1_MF4_MASK, VSOXEI32_V }, // 9281
  { PseudoVSOXEI32_V_M1_MF8, VSOXEI32_V }, // 9282
  { PseudoVSOXEI32_V_M1_MF8_MASK, VSOXEI32_V }, // 9283
  { PseudoVSOXEI32_V_M2_M1, VSOXEI32_V }, // 9284
  { PseudoVSOXEI32_V_M2_M1_MASK, VSOXEI32_V }, // 9285
  { PseudoVSOXEI32_V_M2_M2, VSOXEI32_V }, // 9286
  { PseudoVSOXEI32_V_M2_M2_MASK, VSOXEI32_V }, // 9287
  { PseudoVSOXEI32_V_M2_M4, VSOXEI32_V }, // 9288
  { PseudoVSOXEI32_V_M2_M4_MASK, VSOXEI32_V }, // 9289
  { PseudoVSOXEI32_V_M2_M8, VSOXEI32_V }, // 9290
  { PseudoVSOXEI32_V_M2_M8_MASK, VSOXEI32_V }, // 9291
  { PseudoVSOXEI32_V_M2_MF2, VSOXEI32_V }, // 9292
  { PseudoVSOXEI32_V_M2_MF2_MASK, VSOXEI32_V }, // 9293
  { PseudoVSOXEI32_V_M2_MF4, VSOXEI32_V }, // 9294
  { PseudoVSOXEI32_V_M2_MF4_MASK, VSOXEI32_V }, // 9295
  { PseudoVSOXEI32_V_M2_MF8, VSOXEI32_V }, // 9296
  { PseudoVSOXEI32_V_M2_MF8_MASK, VSOXEI32_V }, // 9297
  { PseudoVSOXEI32_V_M4_M1, VSOXEI32_V }, // 9298
  { PseudoVSOXEI32_V_M4_M1_MASK, VSOXEI32_V }, // 9299
  { PseudoVSOXEI32_V_M4_M2, VSOXEI32_V }, // 9300
  { PseudoVSOXEI32_V_M4_M2_MASK, VSOXEI32_V }, // 9301
  { PseudoVSOXEI32_V_M4_M4, VSOXEI32_V }, // 9302
  { PseudoVSOXEI32_V_M4_M4_MASK, VSOXEI32_V }, // 9303
  { PseudoVSOXEI32_V_M4_M8, VSOXEI32_V }, // 9304
  { PseudoVSOXEI32_V_M4_M8_MASK, VSOXEI32_V }, // 9305
  { PseudoVSOXEI32_V_M4_MF2, VSOXEI32_V }, // 9306
  { PseudoVSOXEI32_V_M4_MF2_MASK, VSOXEI32_V }, // 9307
  { PseudoVSOXEI32_V_M4_MF4, VSOXEI32_V }, // 9308
  { PseudoVSOXEI32_V_M4_MF4_MASK, VSOXEI32_V }, // 9309
  { PseudoVSOXEI32_V_M4_MF8, VSOXEI32_V }, // 9310
  { PseudoVSOXEI32_V_M4_MF8_MASK, VSOXEI32_V }, // 9311
  { PseudoVSOXEI32_V_M8_M1, VSOXEI32_V }, // 9312
  { PseudoVSOXEI32_V_M8_M1_MASK, VSOXEI32_V }, // 9313
  { PseudoVSOXEI32_V_M8_M2, VSOXEI32_V }, // 9314
  { PseudoVSOXEI32_V_M8_M2_MASK, VSOXEI32_V }, // 9315
  { PseudoVSOXEI32_V_M8_M4, VSOXEI32_V }, // 9316
  { PseudoVSOXEI32_V_M8_M4_MASK, VSOXEI32_V }, // 9317
  { PseudoVSOXEI32_V_M8_M8, VSOXEI32_V }, // 9318
  { PseudoVSOXEI32_V_M8_M8_MASK, VSOXEI32_V }, // 9319
  { PseudoVSOXEI32_V_M8_MF2, VSOXEI32_V }, // 9320
  { PseudoVSOXEI32_V_M8_MF2_MASK, VSOXEI32_V }, // 9321
  { PseudoVSOXEI32_V_M8_MF4, VSOXEI32_V }, // 9322
  { PseudoVSOXEI32_V_M8_MF4_MASK, VSOXEI32_V }, // 9323
  { PseudoVSOXEI32_V_M8_MF8, VSOXEI32_V }, // 9324
  { PseudoVSOXEI32_V_M8_MF8_MASK, VSOXEI32_V }, // 9325
  { PseudoVSOXEI32_V_MF2_M1, VSOXEI32_V }, // 9326
  { PseudoVSOXEI32_V_MF2_M1_MASK, VSOXEI32_V }, // 9327
  { PseudoVSOXEI32_V_MF2_M2, VSOXEI32_V }, // 9328
  { PseudoVSOXEI32_V_MF2_M2_MASK, VSOXEI32_V }, // 9329
  { PseudoVSOXEI32_V_MF2_M4, VSOXEI32_V }, // 9330
  { PseudoVSOXEI32_V_MF2_M4_MASK, VSOXEI32_V }, // 9331
  { PseudoVSOXEI32_V_MF2_M8, VSOXEI32_V }, // 9332
  { PseudoVSOXEI32_V_MF2_M8_MASK, VSOXEI32_V }, // 9333
  { PseudoVSOXEI32_V_MF2_MF2, VSOXEI32_V }, // 9334
  { PseudoVSOXEI32_V_MF2_MF2_MASK, VSOXEI32_V }, // 9335
  { PseudoVSOXEI32_V_MF2_MF4, VSOXEI32_V }, // 9336
  { PseudoVSOXEI32_V_MF2_MF4_MASK, VSOXEI32_V }, // 9337
  { PseudoVSOXEI32_V_MF2_MF8, VSOXEI32_V }, // 9338
  { PseudoVSOXEI32_V_MF2_MF8_MASK, VSOXEI32_V }, // 9339
  { PseudoVSOXEI32_V_MF4_M1, VSOXEI32_V }, // 9340
  { PseudoVSOXEI32_V_MF4_M1_MASK, VSOXEI32_V }, // 9341
  { PseudoVSOXEI32_V_MF4_M2, VSOXEI32_V }, // 9342
  { PseudoVSOXEI32_V_MF4_M2_MASK, VSOXEI32_V }, // 9343
  { PseudoVSOXEI32_V_MF4_M4, VSOXEI32_V }, // 9344
  { PseudoVSOXEI32_V_MF4_M4_MASK, VSOXEI32_V }, // 9345
  { PseudoVSOXEI32_V_MF4_M8, VSOXEI32_V }, // 9346
  { PseudoVSOXEI32_V_MF4_M8_MASK, VSOXEI32_V }, // 9347
  { PseudoVSOXEI32_V_MF4_MF2, VSOXEI32_V }, // 9348
  { PseudoVSOXEI32_V_MF4_MF2_MASK, VSOXEI32_V }, // 9349
  { PseudoVSOXEI32_V_MF4_MF4, VSOXEI32_V }, // 9350
  { PseudoVSOXEI32_V_MF4_MF4_MASK, VSOXEI32_V }, // 9351
  { PseudoVSOXEI32_V_MF4_MF8, VSOXEI32_V }, // 9352
  { PseudoVSOXEI32_V_MF4_MF8_MASK, VSOXEI32_V }, // 9353
  { PseudoVSOXEI32_V_MF8_M1, VSOXEI32_V }, // 9354
  { PseudoVSOXEI32_V_MF8_M1_MASK, VSOXEI32_V }, // 9355
  { PseudoVSOXEI32_V_MF8_M2, VSOXEI32_V }, // 9356
  { PseudoVSOXEI32_V_MF8_M2_MASK, VSOXEI32_V }, // 9357
  { PseudoVSOXEI32_V_MF8_M4, VSOXEI32_V }, // 9358
  { PseudoVSOXEI32_V_MF8_M4_MASK, VSOXEI32_V }, // 9359
  { PseudoVSOXEI32_V_MF8_M8, VSOXEI32_V }, // 9360
  { PseudoVSOXEI32_V_MF8_M8_MASK, VSOXEI32_V }, // 9361
  { PseudoVSOXEI32_V_MF8_MF2, VSOXEI32_V }, // 9362
  { PseudoVSOXEI32_V_MF8_MF2_MASK, VSOXEI32_V }, // 9363
  { PseudoVSOXEI32_V_MF8_MF4, VSOXEI32_V }, // 9364
  { PseudoVSOXEI32_V_MF8_MF4_MASK, VSOXEI32_V }, // 9365
  { PseudoVSOXEI32_V_MF8_MF8, VSOXEI32_V }, // 9366
  { PseudoVSOXEI32_V_MF8_MF8_MASK, VSOXEI32_V }, // 9367
  { PseudoVSOXEI64_V_M1_M1, VSOXEI64_V }, // 9368
  { PseudoVSOXEI64_V_M1_M1_MASK, VSOXEI64_V }, // 9369
  { PseudoVSOXEI64_V_M1_M2, VSOXEI64_V }, // 9370
  { PseudoVSOXEI64_V_M1_M2_MASK, VSOXEI64_V }, // 9371
  { PseudoVSOXEI64_V_M1_M4, VSOXEI64_V }, // 9372
  { PseudoVSOXEI64_V_M1_M4_MASK, VSOXEI64_V }, // 9373
  { PseudoVSOXEI64_V_M1_M8, VSOXEI64_V }, // 9374
  { PseudoVSOXEI64_V_M1_M8_MASK, VSOXEI64_V }, // 9375
  { PseudoVSOXEI64_V_M1_MF2, VSOXEI64_V }, // 9376
  { PseudoVSOXEI64_V_M1_MF2_MASK, VSOXEI64_V }, // 9377
  { PseudoVSOXEI64_V_M1_MF4, VSOXEI64_V }, // 9378
  { PseudoVSOXEI64_V_M1_MF4_MASK, VSOXEI64_V }, // 9379
  { PseudoVSOXEI64_V_M1_MF8, VSOXEI64_V }, // 9380
  { PseudoVSOXEI64_V_M1_MF8_MASK, VSOXEI64_V }, // 9381
  { PseudoVSOXEI64_V_M2_M1, VSOXEI64_V }, // 9382
  { PseudoVSOXEI64_V_M2_M1_MASK, VSOXEI64_V }, // 9383
  { PseudoVSOXEI64_V_M2_M2, VSOXEI64_V }, // 9384
  { PseudoVSOXEI64_V_M2_M2_MASK, VSOXEI64_V }, // 9385
  { PseudoVSOXEI64_V_M2_M4, VSOXEI64_V }, // 9386
  { PseudoVSOXEI64_V_M2_M4_MASK, VSOXEI64_V }, // 9387
  { PseudoVSOXEI64_V_M2_M8, VSOXEI64_V }, // 9388
  { PseudoVSOXEI64_V_M2_M8_MASK, VSOXEI64_V }, // 9389
  { PseudoVSOXEI64_V_M2_MF2, VSOXEI64_V }, // 9390
  { PseudoVSOXEI64_V_M2_MF2_MASK, VSOXEI64_V }, // 9391
  { PseudoVSOXEI64_V_M2_MF4, VSOXEI64_V }, // 9392
  { PseudoVSOXEI64_V_M2_MF4_MASK, VSOXEI64_V }, // 9393
  { PseudoVSOXEI64_V_M2_MF8, VSOXEI64_V }, // 9394
  { PseudoVSOXEI64_V_M2_MF8_MASK, VSOXEI64_V }, // 9395
  { PseudoVSOXEI64_V_M4_M1, VSOXEI64_V }, // 9396
  { PseudoVSOXEI64_V_M4_M1_MASK, VSOXEI64_V }, // 9397
  { PseudoVSOXEI64_V_M4_M2, VSOXEI64_V }, // 9398
  { PseudoVSOXEI64_V_M4_M2_MASK, VSOXEI64_V }, // 9399
  { PseudoVSOXEI64_V_M4_M4, VSOXEI64_V }, // 9400
  { PseudoVSOXEI64_V_M4_M4_MASK, VSOXEI64_V }, // 9401
  { PseudoVSOXEI64_V_M4_M8, VSOXEI64_V }, // 9402
  { PseudoVSOXEI64_V_M4_M8_MASK, VSOXEI64_V }, // 9403
  { PseudoVSOXEI64_V_M4_MF2, VSOXEI64_V }, // 9404
  { PseudoVSOXEI64_V_M4_MF2_MASK, VSOXEI64_V }, // 9405
  { PseudoVSOXEI64_V_M4_MF4, VSOXEI64_V }, // 9406
  { PseudoVSOXEI64_V_M4_MF4_MASK, VSOXEI64_V }, // 9407
  { PseudoVSOXEI64_V_M4_MF8, VSOXEI64_V }, // 9408
  { PseudoVSOXEI64_V_M4_MF8_MASK, VSOXEI64_V }, // 9409
  { PseudoVSOXEI64_V_M8_M1, VSOXEI64_V }, // 9410
  { PseudoVSOXEI64_V_M8_M1_MASK, VSOXEI64_V }, // 9411
  { PseudoVSOXEI64_V_M8_M2, VSOXEI64_V }, // 9412
  { PseudoVSOXEI64_V_M8_M2_MASK, VSOXEI64_V }, // 9413
  { PseudoVSOXEI64_V_M8_M4, VSOXEI64_V }, // 9414
  { PseudoVSOXEI64_V_M8_M4_MASK, VSOXEI64_V }, // 9415
  { PseudoVSOXEI64_V_M8_M8, VSOXEI64_V }, // 9416
  { PseudoVSOXEI64_V_M8_M8_MASK, VSOXEI64_V }, // 9417
  { PseudoVSOXEI64_V_M8_MF2, VSOXEI64_V }, // 9418
  { PseudoVSOXEI64_V_M8_MF2_MASK, VSOXEI64_V }, // 9419
  { PseudoVSOXEI64_V_M8_MF4, VSOXEI64_V }, // 9420
  { PseudoVSOXEI64_V_M8_MF4_MASK, VSOXEI64_V }, // 9421
  { PseudoVSOXEI64_V_M8_MF8, VSOXEI64_V }, // 9422
  { PseudoVSOXEI64_V_M8_MF8_MASK, VSOXEI64_V }, // 9423
  { PseudoVSOXEI64_V_MF2_M1, VSOXEI64_V }, // 9424
  { PseudoVSOXEI64_V_MF2_M1_MASK, VSOXEI64_V }, // 9425
  { PseudoVSOXEI64_V_MF2_M2, VSOXEI64_V }, // 9426
  { PseudoVSOXEI64_V_MF2_M2_MASK, VSOXEI64_V }, // 9427
  { PseudoVSOXEI64_V_MF2_M4, VSOXEI64_V }, // 9428
  { PseudoVSOXEI64_V_MF2_M4_MASK, VSOXEI64_V }, // 9429
  { PseudoVSOXEI64_V_MF2_M8, VSOXEI64_V }, // 9430
  { PseudoVSOXEI64_V_MF2_M8_MASK, VSOXEI64_V }, // 9431
  { PseudoVSOXEI64_V_MF2_MF2, VSOXEI64_V }, // 9432
  { PseudoVSOXEI64_V_MF2_MF2_MASK, VSOXEI64_V }, // 9433
  { PseudoVSOXEI64_V_MF2_MF4, VSOXEI64_V }, // 9434
  { PseudoVSOXEI64_V_MF2_MF4_MASK, VSOXEI64_V }, // 9435
  { PseudoVSOXEI64_V_MF2_MF8, VSOXEI64_V }, // 9436
  { PseudoVSOXEI64_V_MF2_MF8_MASK, VSOXEI64_V }, // 9437
  { PseudoVSOXEI64_V_MF4_M1, VSOXEI64_V }, // 9438
  { PseudoVSOXEI64_V_MF4_M1_MASK, VSOXEI64_V }, // 9439
  { PseudoVSOXEI64_V_MF4_M2, VSOXEI64_V }, // 9440
  { PseudoVSOXEI64_V_MF4_M2_MASK, VSOXEI64_V }, // 9441
  { PseudoVSOXEI64_V_MF4_M4, VSOXEI64_V }, // 9442
  { PseudoVSOXEI64_V_MF4_M4_MASK, VSOXEI64_V }, // 9443
  { PseudoVSOXEI64_V_MF4_M8, VSOXEI64_V }, // 9444
  { PseudoVSOXEI64_V_MF4_M8_MASK, VSOXEI64_V }, // 9445
  { PseudoVSOXEI64_V_MF4_MF2, VSOXEI64_V }, // 9446
  { PseudoVSOXEI64_V_MF4_MF2_MASK, VSOXEI64_V }, // 9447
  { PseudoVSOXEI64_V_MF4_MF4, VSOXEI64_V }, // 9448
  { PseudoVSOXEI64_V_MF4_MF4_MASK, VSOXEI64_V }, // 9449
  { PseudoVSOXEI64_V_MF4_MF8, VSOXEI64_V }, // 9450
  { PseudoVSOXEI64_V_MF4_MF8_MASK, VSOXEI64_V }, // 9451
  { PseudoVSOXEI64_V_MF8_M1, VSOXEI64_V }, // 9452
  { PseudoVSOXEI64_V_MF8_M1_MASK, VSOXEI64_V }, // 9453
  { PseudoVSOXEI64_V_MF8_M2, VSOXEI64_V }, // 9454
  { PseudoVSOXEI64_V_MF8_M2_MASK, VSOXEI64_V }, // 9455
  { PseudoVSOXEI64_V_MF8_M4, VSOXEI64_V }, // 9456
  { PseudoVSOXEI64_V_MF8_M4_MASK, VSOXEI64_V }, // 9457
  { PseudoVSOXEI64_V_MF8_M8, VSOXEI64_V }, // 9458
  { PseudoVSOXEI64_V_MF8_M8_MASK, VSOXEI64_V }, // 9459
  { PseudoVSOXEI64_V_MF8_MF2, VSOXEI64_V }, // 9460
  { PseudoVSOXEI64_V_MF8_MF2_MASK, VSOXEI64_V }, // 9461
  { PseudoVSOXEI64_V_MF8_MF4, VSOXEI64_V }, // 9462
  { PseudoVSOXEI64_V_MF8_MF4_MASK, VSOXEI64_V }, // 9463
  { PseudoVSOXEI64_V_MF8_MF8, VSOXEI64_V }, // 9464
  { PseudoVSOXEI64_V_MF8_MF8_MASK, VSOXEI64_V }, // 9465
  { PseudoVSOXEI8_V_M1_M1, VSOXEI8_V }, // 9466
  { PseudoVSOXEI8_V_M1_M1_MASK, VSOXEI8_V }, // 9467
  { PseudoVSOXEI8_V_M1_M2, VSOXEI8_V }, // 9468
  { PseudoVSOXEI8_V_M1_M2_MASK, VSOXEI8_V }, // 9469
  { PseudoVSOXEI8_V_M1_M4, VSOXEI8_V }, // 9470
  { PseudoVSOXEI8_V_M1_M4_MASK, VSOXEI8_V }, // 9471
  { PseudoVSOXEI8_V_M1_M8, VSOXEI8_V }, // 9472
  { PseudoVSOXEI8_V_M1_M8_MASK, VSOXEI8_V }, // 9473
  { PseudoVSOXEI8_V_M1_MF2, VSOXEI8_V }, // 9474
  { PseudoVSOXEI8_V_M1_MF2_MASK, VSOXEI8_V }, // 9475
  { PseudoVSOXEI8_V_M1_MF4, VSOXEI8_V }, // 9476
  { PseudoVSOXEI8_V_M1_MF4_MASK, VSOXEI8_V }, // 9477
  { PseudoVSOXEI8_V_M1_MF8, VSOXEI8_V }, // 9478
  { PseudoVSOXEI8_V_M1_MF8_MASK, VSOXEI8_V }, // 9479
  { PseudoVSOXEI8_V_M2_M1, VSOXEI8_V }, // 9480
  { PseudoVSOXEI8_V_M2_M1_MASK, VSOXEI8_V }, // 9481
  { PseudoVSOXEI8_V_M2_M2, VSOXEI8_V }, // 9482
  { PseudoVSOXEI8_V_M2_M2_MASK, VSOXEI8_V }, // 9483
  { PseudoVSOXEI8_V_M2_M4, VSOXEI8_V }, // 9484
  { PseudoVSOXEI8_V_M2_M4_MASK, VSOXEI8_V }, // 9485
  { PseudoVSOXEI8_V_M2_M8, VSOXEI8_V }, // 9486
  { PseudoVSOXEI8_V_M2_M8_MASK, VSOXEI8_V }, // 9487
  { PseudoVSOXEI8_V_M2_MF2, VSOXEI8_V }, // 9488
  { PseudoVSOXEI8_V_M2_MF2_MASK, VSOXEI8_V }, // 9489
  { PseudoVSOXEI8_V_M2_MF4, VSOXEI8_V }, // 9490
  { PseudoVSOXEI8_V_M2_MF4_MASK, VSOXEI8_V }, // 9491
  { PseudoVSOXEI8_V_M2_MF8, VSOXEI8_V }, // 9492
  { PseudoVSOXEI8_V_M2_MF8_MASK, VSOXEI8_V }, // 9493
  { PseudoVSOXEI8_V_M4_M1, VSOXEI8_V }, // 9494
  { PseudoVSOXEI8_V_M4_M1_MASK, VSOXEI8_V }, // 9495
  { PseudoVSOXEI8_V_M4_M2, VSOXEI8_V }, // 9496
  { PseudoVSOXEI8_V_M4_M2_MASK, VSOXEI8_V }, // 9497
  { PseudoVSOXEI8_V_M4_M4, VSOXEI8_V }, // 9498
  { PseudoVSOXEI8_V_M4_M4_MASK, VSOXEI8_V }, // 9499
  { PseudoVSOXEI8_V_M4_M8, VSOXEI8_V }, // 9500
  { PseudoVSOXEI8_V_M4_M8_MASK, VSOXEI8_V }, // 9501
  { PseudoVSOXEI8_V_M4_MF2, VSOXEI8_V }, // 9502
  { PseudoVSOXEI8_V_M4_MF2_MASK, VSOXEI8_V }, // 9503
  { PseudoVSOXEI8_V_M4_MF4, VSOXEI8_V }, // 9504
  { PseudoVSOXEI8_V_M4_MF4_MASK, VSOXEI8_V }, // 9505
  { PseudoVSOXEI8_V_M4_MF8, VSOXEI8_V }, // 9506
  { PseudoVSOXEI8_V_M4_MF8_MASK, VSOXEI8_V }, // 9507
  { PseudoVSOXEI8_V_M8_M1, VSOXEI8_V }, // 9508
  { PseudoVSOXEI8_V_M8_M1_MASK, VSOXEI8_V }, // 9509
  { PseudoVSOXEI8_V_M8_M2, VSOXEI8_V }, // 9510
  { PseudoVSOXEI8_V_M8_M2_MASK, VSOXEI8_V }, // 9511
  { PseudoVSOXEI8_V_M8_M4, VSOXEI8_V }, // 9512
  { PseudoVSOXEI8_V_M8_M4_MASK, VSOXEI8_V }, // 9513
  { PseudoVSOXEI8_V_M8_M8, VSOXEI8_V }, // 9514
  { PseudoVSOXEI8_V_M8_M8_MASK, VSOXEI8_V }, // 9515
  { PseudoVSOXEI8_V_M8_MF2, VSOXEI8_V }, // 9516
  { PseudoVSOXEI8_V_M8_MF2_MASK, VSOXEI8_V }, // 9517
  { PseudoVSOXEI8_V_M8_MF4, VSOXEI8_V }, // 9518
  { PseudoVSOXEI8_V_M8_MF4_MASK, VSOXEI8_V }, // 9519
  { PseudoVSOXEI8_V_M8_MF8, VSOXEI8_V }, // 9520
  { PseudoVSOXEI8_V_M8_MF8_MASK, VSOXEI8_V }, // 9521
  { PseudoVSOXEI8_V_MF2_M1, VSOXEI8_V }, // 9522
  { PseudoVSOXEI8_V_MF2_M1_MASK, VSOXEI8_V }, // 9523
  { PseudoVSOXEI8_V_MF2_M2, VSOXEI8_V }, // 9524
  { PseudoVSOXEI8_V_MF2_M2_MASK, VSOXEI8_V }, // 9525
  { PseudoVSOXEI8_V_MF2_M4, VSOXEI8_V }, // 9526
  { PseudoVSOXEI8_V_MF2_M4_MASK, VSOXEI8_V }, // 9527
  { PseudoVSOXEI8_V_MF2_M8, VSOXEI8_V }, // 9528
  { PseudoVSOXEI8_V_MF2_M8_MASK, VSOXEI8_V }, // 9529
  { PseudoVSOXEI8_V_MF2_MF2, VSOXEI8_V }, // 9530
  { PseudoVSOXEI8_V_MF2_MF2_MASK, VSOXEI8_V }, // 9531
  { PseudoVSOXEI8_V_MF2_MF4, VSOXEI8_V }, // 9532
  { PseudoVSOXEI8_V_MF2_MF4_MASK, VSOXEI8_V }, // 9533
  { PseudoVSOXEI8_V_MF2_MF8, VSOXEI8_V }, // 9534
  { PseudoVSOXEI8_V_MF2_MF8_MASK, VSOXEI8_V }, // 9535
  { PseudoVSOXEI8_V_MF4_M1, VSOXEI8_V }, // 9536
  { PseudoVSOXEI8_V_MF4_M1_MASK, VSOXEI8_V }, // 9537
  { PseudoVSOXEI8_V_MF4_M2, VSOXEI8_V }, // 9538
  { PseudoVSOXEI8_V_MF4_M2_MASK, VSOXEI8_V }, // 9539
  { PseudoVSOXEI8_V_MF4_M4, VSOXEI8_V }, // 9540
  { PseudoVSOXEI8_V_MF4_M4_MASK, VSOXEI8_V }, // 9541
  { PseudoVSOXEI8_V_MF4_M8, VSOXEI8_V }, // 9542
  { PseudoVSOXEI8_V_MF4_M8_MASK, VSOXEI8_V }, // 9543
  { PseudoVSOXEI8_V_MF4_MF2, VSOXEI8_V }, // 9544
  { PseudoVSOXEI8_V_MF4_MF2_MASK, VSOXEI8_V }, // 9545
  { PseudoVSOXEI8_V_MF4_MF4, VSOXEI8_V }, // 9546
  { PseudoVSOXEI8_V_MF4_MF4_MASK, VSOXEI8_V }, // 9547
  { PseudoVSOXEI8_V_MF4_MF8, VSOXEI8_V }, // 9548
  { PseudoVSOXEI8_V_MF4_MF8_MASK, VSOXEI8_V }, // 9549
  { PseudoVSOXEI8_V_MF8_M1, VSOXEI8_V }, // 9550
  { PseudoVSOXEI8_V_MF8_M1_MASK, VSOXEI8_V }, // 9551
  { PseudoVSOXEI8_V_MF8_M2, VSOXEI8_V }, // 9552
  { PseudoVSOXEI8_V_MF8_M2_MASK, VSOXEI8_V }, // 9553
  { PseudoVSOXEI8_V_MF8_M4, VSOXEI8_V }, // 9554
  { PseudoVSOXEI8_V_MF8_M4_MASK, VSOXEI8_V }, // 9555
  { PseudoVSOXEI8_V_MF8_M8, VSOXEI8_V }, // 9556
  { PseudoVSOXEI8_V_MF8_M8_MASK, VSOXEI8_V }, // 9557
  { PseudoVSOXEI8_V_MF8_MF2, VSOXEI8_V }, // 9558
  { PseudoVSOXEI8_V_MF8_MF2_MASK, VSOXEI8_V }, // 9559
  { PseudoVSOXEI8_V_MF8_MF4, VSOXEI8_V }, // 9560
  { PseudoVSOXEI8_V_MF8_MF4_MASK, VSOXEI8_V }, // 9561
  { PseudoVSOXEI8_V_MF8_MF8, VSOXEI8_V }, // 9562
  { PseudoVSOXEI8_V_MF8_MF8_MASK, VSOXEI8_V }, // 9563
  { PseudoVSOXSEG2EI16_V_M1_M1, VSOXSEG2EI16_V }, // 9564
  { PseudoVSOXSEG2EI16_V_M1_M1_MASK, VSOXSEG2EI16_V }, // 9565
  { PseudoVSOXSEG2EI16_V_M1_M2, VSOXSEG2EI16_V }, // 9566
  { PseudoVSOXSEG2EI16_V_M1_M2_MASK, VSOXSEG2EI16_V }, // 9567
  { PseudoVSOXSEG2EI16_V_M1_M4, VSOXSEG2EI16_V }, // 9568
  { PseudoVSOXSEG2EI16_V_M1_M4_MASK, VSOXSEG2EI16_V }, // 9569
  { PseudoVSOXSEG2EI16_V_M1_MF2, VSOXSEG2EI16_V }, // 9570
  { PseudoVSOXSEG2EI16_V_M1_MF2_MASK, VSOXSEG2EI16_V }, // 9571
  { PseudoVSOXSEG2EI16_V_M1_MF4, VSOXSEG2EI16_V }, // 9572
  { PseudoVSOXSEG2EI16_V_M1_MF4_MASK, VSOXSEG2EI16_V }, // 9573
  { PseudoVSOXSEG2EI16_V_M1_MF8, VSOXSEG2EI16_V }, // 9574
  { PseudoVSOXSEG2EI16_V_M1_MF8_MASK, VSOXSEG2EI16_V }, // 9575
  { PseudoVSOXSEG2EI16_V_M2_M1, VSOXSEG2EI16_V }, // 9576
  { PseudoVSOXSEG2EI16_V_M2_M1_MASK, VSOXSEG2EI16_V }, // 9577
  { PseudoVSOXSEG2EI16_V_M2_M2, VSOXSEG2EI16_V }, // 9578
  { PseudoVSOXSEG2EI16_V_M2_M2_MASK, VSOXSEG2EI16_V }, // 9579
  { PseudoVSOXSEG2EI16_V_M2_M4, VSOXSEG2EI16_V }, // 9580
  { PseudoVSOXSEG2EI16_V_M2_M4_MASK, VSOXSEG2EI16_V }, // 9581
  { PseudoVSOXSEG2EI16_V_M2_MF2, VSOXSEG2EI16_V }, // 9582
  { PseudoVSOXSEG2EI16_V_M2_MF2_MASK, VSOXSEG2EI16_V }, // 9583
  { PseudoVSOXSEG2EI16_V_M2_MF4, VSOXSEG2EI16_V }, // 9584
  { PseudoVSOXSEG2EI16_V_M2_MF4_MASK, VSOXSEG2EI16_V }, // 9585
  { PseudoVSOXSEG2EI16_V_M2_MF8, VSOXSEG2EI16_V }, // 9586
  { PseudoVSOXSEG2EI16_V_M2_MF8_MASK, VSOXSEG2EI16_V }, // 9587
  { PseudoVSOXSEG2EI16_V_M4_M1, VSOXSEG2EI16_V }, // 9588
  { PseudoVSOXSEG2EI16_V_M4_M1_MASK, VSOXSEG2EI16_V }, // 9589
  { PseudoVSOXSEG2EI16_V_M4_M2, VSOXSEG2EI16_V }, // 9590
  { PseudoVSOXSEG2EI16_V_M4_M2_MASK, VSOXSEG2EI16_V }, // 9591
  { PseudoVSOXSEG2EI16_V_M4_M4, VSOXSEG2EI16_V }, // 9592
  { PseudoVSOXSEG2EI16_V_M4_M4_MASK, VSOXSEG2EI16_V }, // 9593
  { PseudoVSOXSEG2EI16_V_M4_MF2, VSOXSEG2EI16_V }, // 9594
  { PseudoVSOXSEG2EI16_V_M4_MF2_MASK, VSOXSEG2EI16_V }, // 9595
  { PseudoVSOXSEG2EI16_V_M4_MF4, VSOXSEG2EI16_V }, // 9596
  { PseudoVSOXSEG2EI16_V_M4_MF4_MASK, VSOXSEG2EI16_V }, // 9597
  { PseudoVSOXSEG2EI16_V_M4_MF8, VSOXSEG2EI16_V }, // 9598
  { PseudoVSOXSEG2EI16_V_M4_MF8_MASK, VSOXSEG2EI16_V }, // 9599
  { PseudoVSOXSEG2EI16_V_M8_M1, VSOXSEG2EI16_V }, // 9600
  { PseudoVSOXSEG2EI16_V_M8_M1_MASK, VSOXSEG2EI16_V }, // 9601
  { PseudoVSOXSEG2EI16_V_M8_M2, VSOXSEG2EI16_V }, // 9602
  { PseudoVSOXSEG2EI16_V_M8_M2_MASK, VSOXSEG2EI16_V }, // 9603
  { PseudoVSOXSEG2EI16_V_M8_M4, VSOXSEG2EI16_V }, // 9604
  { PseudoVSOXSEG2EI16_V_M8_M4_MASK, VSOXSEG2EI16_V }, // 9605
  { PseudoVSOXSEG2EI16_V_M8_MF2, VSOXSEG2EI16_V }, // 9606
  { PseudoVSOXSEG2EI16_V_M8_MF2_MASK, VSOXSEG2EI16_V }, // 9607
  { PseudoVSOXSEG2EI16_V_M8_MF4, VSOXSEG2EI16_V }, // 9608
  { PseudoVSOXSEG2EI16_V_M8_MF4_MASK, VSOXSEG2EI16_V }, // 9609
  { PseudoVSOXSEG2EI16_V_M8_MF8, VSOXSEG2EI16_V }, // 9610
  { PseudoVSOXSEG2EI16_V_M8_MF8_MASK, VSOXSEG2EI16_V }, // 9611
  { PseudoVSOXSEG2EI16_V_MF2_M1, VSOXSEG2EI16_V }, // 9612
  { PseudoVSOXSEG2EI16_V_MF2_M1_MASK, VSOXSEG2EI16_V }, // 9613
  { PseudoVSOXSEG2EI16_V_MF2_M2, VSOXSEG2EI16_V }, // 9614
  { PseudoVSOXSEG2EI16_V_MF2_M2_MASK, VSOXSEG2EI16_V }, // 9615
  { PseudoVSOXSEG2EI16_V_MF2_M4, VSOXSEG2EI16_V }, // 9616
  { PseudoVSOXSEG2EI16_V_MF2_M4_MASK, VSOXSEG2EI16_V }, // 9617
  { PseudoVSOXSEG2EI16_V_MF2_MF2, VSOXSEG2EI16_V }, // 9618
  { PseudoVSOXSEG2EI16_V_MF2_MF2_MASK, VSOXSEG2EI16_V }, // 9619
  { PseudoVSOXSEG2EI16_V_MF2_MF4, VSOXSEG2EI16_V }, // 9620
  { PseudoVSOXSEG2EI16_V_MF2_MF4_MASK, VSOXSEG2EI16_V }, // 9621
  { PseudoVSOXSEG2EI16_V_MF2_MF8, VSOXSEG2EI16_V }, // 9622
  { PseudoVSOXSEG2EI16_V_MF2_MF8_MASK, VSOXSEG2EI16_V }, // 9623
  { PseudoVSOXSEG2EI16_V_MF4_M1, VSOXSEG2EI16_V }, // 9624
  { PseudoVSOXSEG2EI16_V_MF4_M1_MASK, VSOXSEG2EI16_V }, // 9625
  { PseudoVSOXSEG2EI16_V_MF4_M2, VSOXSEG2EI16_V }, // 9626
  { PseudoVSOXSEG2EI16_V_MF4_M2_MASK, VSOXSEG2EI16_V }, // 9627
  { PseudoVSOXSEG2EI16_V_MF4_M4, VSOXSEG2EI16_V }, // 9628
  { PseudoVSOXSEG2EI16_V_MF4_M4_MASK, VSOXSEG2EI16_V }, // 9629
  { PseudoVSOXSEG2EI16_V_MF4_MF2, VSOXSEG2EI16_V }, // 9630
  { PseudoVSOXSEG2EI16_V_MF4_MF2_MASK, VSOXSEG2EI16_V }, // 9631
  { PseudoVSOXSEG2EI16_V_MF4_MF4, VSOXSEG2EI16_V }, // 9632
  { PseudoVSOXSEG2EI16_V_MF4_MF4_MASK, VSOXSEG2EI16_V }, // 9633
  { PseudoVSOXSEG2EI16_V_MF4_MF8, VSOXSEG2EI16_V }, // 9634
  { PseudoVSOXSEG2EI16_V_MF4_MF8_MASK, VSOXSEG2EI16_V }, // 9635
  { PseudoVSOXSEG2EI32_V_M1_M1, VSOXSEG2EI32_V }, // 9636
  { PseudoVSOXSEG2EI32_V_M1_M1_MASK, VSOXSEG2EI32_V }, // 9637
  { PseudoVSOXSEG2EI32_V_M1_M2, VSOXSEG2EI32_V }, // 9638
  { PseudoVSOXSEG2EI32_V_M1_M2_MASK, VSOXSEG2EI32_V }, // 9639
  { PseudoVSOXSEG2EI32_V_M1_M4, VSOXSEG2EI32_V }, // 9640
  { PseudoVSOXSEG2EI32_V_M1_M4_MASK, VSOXSEG2EI32_V }, // 9641
  { PseudoVSOXSEG2EI32_V_M1_MF2, VSOXSEG2EI32_V }, // 9642
  { PseudoVSOXSEG2EI32_V_M1_MF2_MASK, VSOXSEG2EI32_V }, // 9643
  { PseudoVSOXSEG2EI32_V_M1_MF4, VSOXSEG2EI32_V }, // 9644
  { PseudoVSOXSEG2EI32_V_M1_MF4_MASK, VSOXSEG2EI32_V }, // 9645
  { PseudoVSOXSEG2EI32_V_M1_MF8, VSOXSEG2EI32_V }, // 9646
  { PseudoVSOXSEG2EI32_V_M1_MF8_MASK, VSOXSEG2EI32_V }, // 9647
  { PseudoVSOXSEG2EI32_V_M2_M1, VSOXSEG2EI32_V }, // 9648
  { PseudoVSOXSEG2EI32_V_M2_M1_MASK, VSOXSEG2EI32_V }, // 9649
  { PseudoVSOXSEG2EI32_V_M2_M2, VSOXSEG2EI32_V }, // 9650
  { PseudoVSOXSEG2EI32_V_M2_M2_MASK, VSOXSEG2EI32_V }, // 9651
  { PseudoVSOXSEG2EI32_V_M2_M4, VSOXSEG2EI32_V }, // 9652
  { PseudoVSOXSEG2EI32_V_M2_M4_MASK, VSOXSEG2EI32_V }, // 9653
  { PseudoVSOXSEG2EI32_V_M2_MF2, VSOXSEG2EI32_V }, // 9654
  { PseudoVSOXSEG2EI32_V_M2_MF2_MASK, VSOXSEG2EI32_V }, // 9655
  { PseudoVSOXSEG2EI32_V_M2_MF4, VSOXSEG2EI32_V }, // 9656
  { PseudoVSOXSEG2EI32_V_M2_MF4_MASK, VSOXSEG2EI32_V }, // 9657
  { PseudoVSOXSEG2EI32_V_M2_MF8, VSOXSEG2EI32_V }, // 9658
  { PseudoVSOXSEG2EI32_V_M2_MF8_MASK, VSOXSEG2EI32_V }, // 9659
  { PseudoVSOXSEG2EI32_V_M4_M1, VSOXSEG2EI32_V }, // 9660
  { PseudoVSOXSEG2EI32_V_M4_M1_MASK, VSOXSEG2EI32_V }, // 9661
  { PseudoVSOXSEG2EI32_V_M4_M2, VSOXSEG2EI32_V }, // 9662
  { PseudoVSOXSEG2EI32_V_M4_M2_MASK, VSOXSEG2EI32_V }, // 9663
  { PseudoVSOXSEG2EI32_V_M4_M4, VSOXSEG2EI32_V }, // 9664
  { PseudoVSOXSEG2EI32_V_M4_M4_MASK, VSOXSEG2EI32_V }, // 9665
  { PseudoVSOXSEG2EI32_V_M4_MF2, VSOXSEG2EI32_V }, // 9666
  { PseudoVSOXSEG2EI32_V_M4_MF2_MASK, VSOXSEG2EI32_V }, // 9667
  { PseudoVSOXSEG2EI32_V_M4_MF4, VSOXSEG2EI32_V }, // 9668
  { PseudoVSOXSEG2EI32_V_M4_MF4_MASK, VSOXSEG2EI32_V }, // 9669
  { PseudoVSOXSEG2EI32_V_M4_MF8, VSOXSEG2EI32_V }, // 9670
  { PseudoVSOXSEG2EI32_V_M4_MF8_MASK, VSOXSEG2EI32_V }, // 9671
  { PseudoVSOXSEG2EI32_V_M8_M1, VSOXSEG2EI32_V }, // 9672
  { PseudoVSOXSEG2EI32_V_M8_M1_MASK, VSOXSEG2EI32_V }, // 9673
  { PseudoVSOXSEG2EI32_V_M8_M2, VSOXSEG2EI32_V }, // 9674
  { PseudoVSOXSEG2EI32_V_M8_M2_MASK, VSOXSEG2EI32_V }, // 9675
  { PseudoVSOXSEG2EI32_V_M8_M4, VSOXSEG2EI32_V }, // 9676
  { PseudoVSOXSEG2EI32_V_M8_M4_MASK, VSOXSEG2EI32_V }, // 9677
  { PseudoVSOXSEG2EI32_V_M8_MF2, VSOXSEG2EI32_V }, // 9678
  { PseudoVSOXSEG2EI32_V_M8_MF2_MASK, VSOXSEG2EI32_V }, // 9679
  { PseudoVSOXSEG2EI32_V_M8_MF4, VSOXSEG2EI32_V }, // 9680
  { PseudoVSOXSEG2EI32_V_M8_MF4_MASK, VSOXSEG2EI32_V }, // 9681
  { PseudoVSOXSEG2EI32_V_M8_MF8, VSOXSEG2EI32_V }, // 9682
  { PseudoVSOXSEG2EI32_V_M8_MF8_MASK, VSOXSEG2EI32_V }, // 9683
  { PseudoVSOXSEG2EI32_V_MF2_M1, VSOXSEG2EI32_V }, // 9684
  { PseudoVSOXSEG2EI32_V_MF2_M1_MASK, VSOXSEG2EI32_V }, // 9685
  { PseudoVSOXSEG2EI32_V_MF2_M2, VSOXSEG2EI32_V }, // 9686
  { PseudoVSOXSEG2EI32_V_MF2_M2_MASK, VSOXSEG2EI32_V }, // 9687
  { PseudoVSOXSEG2EI32_V_MF2_M4, VSOXSEG2EI32_V }, // 9688
  { PseudoVSOXSEG2EI32_V_MF2_M4_MASK, VSOXSEG2EI32_V }, // 9689
  { PseudoVSOXSEG2EI32_V_MF2_MF2, VSOXSEG2EI32_V }, // 9690
  { PseudoVSOXSEG2EI32_V_MF2_MF2_MASK, VSOXSEG2EI32_V }, // 9691
  { PseudoVSOXSEG2EI32_V_MF2_MF4, VSOXSEG2EI32_V }, // 9692
  { PseudoVSOXSEG2EI32_V_MF2_MF4_MASK, VSOXSEG2EI32_V }, // 9693
  { PseudoVSOXSEG2EI32_V_MF2_MF8, VSOXSEG2EI32_V }, // 9694
  { PseudoVSOXSEG2EI32_V_MF2_MF8_MASK, VSOXSEG2EI32_V }, // 9695
  { PseudoVSOXSEG2EI64_V_M1_M1, VSOXSEG2EI64_V }, // 9696
  { PseudoVSOXSEG2EI64_V_M1_M1_MASK, VSOXSEG2EI64_V }, // 9697
  { PseudoVSOXSEG2EI64_V_M1_M2, VSOXSEG2EI64_V }, // 9698
  { PseudoVSOXSEG2EI64_V_M1_M2_MASK, VSOXSEG2EI64_V }, // 9699
  { PseudoVSOXSEG2EI64_V_M1_M4, VSOXSEG2EI64_V }, // 9700
  { PseudoVSOXSEG2EI64_V_M1_M4_MASK, VSOXSEG2EI64_V }, // 9701
  { PseudoVSOXSEG2EI64_V_M1_MF2, VSOXSEG2EI64_V }, // 9702
  { PseudoVSOXSEG2EI64_V_M1_MF2_MASK, VSOXSEG2EI64_V }, // 9703
  { PseudoVSOXSEG2EI64_V_M1_MF4, VSOXSEG2EI64_V }, // 9704
  { PseudoVSOXSEG2EI64_V_M1_MF4_MASK, VSOXSEG2EI64_V }, // 9705
  { PseudoVSOXSEG2EI64_V_M1_MF8, VSOXSEG2EI64_V }, // 9706
  { PseudoVSOXSEG2EI64_V_M1_MF8_MASK, VSOXSEG2EI64_V }, // 9707
  { PseudoVSOXSEG2EI64_V_M2_M1, VSOXSEG2EI64_V }, // 9708
  { PseudoVSOXSEG2EI64_V_M2_M1_MASK, VSOXSEG2EI64_V }, // 9709
  { PseudoVSOXSEG2EI64_V_M2_M2, VSOXSEG2EI64_V }, // 9710
  { PseudoVSOXSEG2EI64_V_M2_M2_MASK, VSOXSEG2EI64_V }, // 9711
  { PseudoVSOXSEG2EI64_V_M2_M4, VSOXSEG2EI64_V }, // 9712
  { PseudoVSOXSEG2EI64_V_M2_M4_MASK, VSOXSEG2EI64_V }, // 9713
  { PseudoVSOXSEG2EI64_V_M2_MF2, VSOXSEG2EI64_V }, // 9714
  { PseudoVSOXSEG2EI64_V_M2_MF2_MASK, VSOXSEG2EI64_V }, // 9715
  { PseudoVSOXSEG2EI64_V_M2_MF4, VSOXSEG2EI64_V }, // 9716
  { PseudoVSOXSEG2EI64_V_M2_MF4_MASK, VSOXSEG2EI64_V }, // 9717
  { PseudoVSOXSEG2EI64_V_M2_MF8, VSOXSEG2EI64_V }, // 9718
  { PseudoVSOXSEG2EI64_V_M2_MF8_MASK, VSOXSEG2EI64_V }, // 9719
  { PseudoVSOXSEG2EI64_V_M4_M1, VSOXSEG2EI64_V }, // 9720
  { PseudoVSOXSEG2EI64_V_M4_M1_MASK, VSOXSEG2EI64_V }, // 9721
  { PseudoVSOXSEG2EI64_V_M4_M2, VSOXSEG2EI64_V }, // 9722
  { PseudoVSOXSEG2EI64_V_M4_M2_MASK, VSOXSEG2EI64_V }, // 9723
  { PseudoVSOXSEG2EI64_V_M4_M4, VSOXSEG2EI64_V }, // 9724
  { PseudoVSOXSEG2EI64_V_M4_M4_MASK, VSOXSEG2EI64_V }, // 9725
  { PseudoVSOXSEG2EI64_V_M4_MF2, VSOXSEG2EI64_V }, // 9726
  { PseudoVSOXSEG2EI64_V_M4_MF2_MASK, VSOXSEG2EI64_V }, // 9727
  { PseudoVSOXSEG2EI64_V_M4_MF4, VSOXSEG2EI64_V }, // 9728
  { PseudoVSOXSEG2EI64_V_M4_MF4_MASK, VSOXSEG2EI64_V }, // 9729
  { PseudoVSOXSEG2EI64_V_M4_MF8, VSOXSEG2EI64_V }, // 9730
  { PseudoVSOXSEG2EI64_V_M4_MF8_MASK, VSOXSEG2EI64_V }, // 9731
  { PseudoVSOXSEG2EI64_V_M8_M1, VSOXSEG2EI64_V }, // 9732
  { PseudoVSOXSEG2EI64_V_M8_M1_MASK, VSOXSEG2EI64_V }, // 9733
  { PseudoVSOXSEG2EI64_V_M8_M2, VSOXSEG2EI64_V }, // 9734
  { PseudoVSOXSEG2EI64_V_M8_M2_MASK, VSOXSEG2EI64_V }, // 9735
  { PseudoVSOXSEG2EI64_V_M8_M4, VSOXSEG2EI64_V }, // 9736
  { PseudoVSOXSEG2EI64_V_M8_M4_MASK, VSOXSEG2EI64_V }, // 9737
  { PseudoVSOXSEG2EI64_V_M8_MF2, VSOXSEG2EI64_V }, // 9738
  { PseudoVSOXSEG2EI64_V_M8_MF2_MASK, VSOXSEG2EI64_V }, // 9739
  { PseudoVSOXSEG2EI64_V_M8_MF4, VSOXSEG2EI64_V }, // 9740
  { PseudoVSOXSEG2EI64_V_M8_MF4_MASK, VSOXSEG2EI64_V }, // 9741
  { PseudoVSOXSEG2EI64_V_M8_MF8, VSOXSEG2EI64_V }, // 9742
  { PseudoVSOXSEG2EI64_V_M8_MF8_MASK, VSOXSEG2EI64_V }, // 9743
  { PseudoVSOXSEG2EI8_V_M1_M1, VSOXSEG2EI8_V }, // 9744
  { PseudoVSOXSEG2EI8_V_M1_M1_MASK, VSOXSEG2EI8_V }, // 9745
  { PseudoVSOXSEG2EI8_V_M1_M2, VSOXSEG2EI8_V }, // 9746
  { PseudoVSOXSEG2EI8_V_M1_M2_MASK, VSOXSEG2EI8_V }, // 9747
  { PseudoVSOXSEG2EI8_V_M1_M4, VSOXSEG2EI8_V }, // 9748
  { PseudoVSOXSEG2EI8_V_M1_M4_MASK, VSOXSEG2EI8_V }, // 9749
  { PseudoVSOXSEG2EI8_V_M1_MF2, VSOXSEG2EI8_V }, // 9750
  { PseudoVSOXSEG2EI8_V_M1_MF2_MASK, VSOXSEG2EI8_V }, // 9751
  { PseudoVSOXSEG2EI8_V_M1_MF4, VSOXSEG2EI8_V }, // 9752
  { PseudoVSOXSEG2EI8_V_M1_MF4_MASK, VSOXSEG2EI8_V }, // 9753
  { PseudoVSOXSEG2EI8_V_M1_MF8, VSOXSEG2EI8_V }, // 9754
  { PseudoVSOXSEG2EI8_V_M1_MF8_MASK, VSOXSEG2EI8_V }, // 9755
  { PseudoVSOXSEG2EI8_V_M2_M1, VSOXSEG2EI8_V }, // 9756
  { PseudoVSOXSEG2EI8_V_M2_M1_MASK, VSOXSEG2EI8_V }, // 9757
  { PseudoVSOXSEG2EI8_V_M2_M2, VSOXSEG2EI8_V }, // 9758
  { PseudoVSOXSEG2EI8_V_M2_M2_MASK, VSOXSEG2EI8_V }, // 9759
  { PseudoVSOXSEG2EI8_V_M2_M4, VSOXSEG2EI8_V }, // 9760
  { PseudoVSOXSEG2EI8_V_M2_M4_MASK, VSOXSEG2EI8_V }, // 9761
  { PseudoVSOXSEG2EI8_V_M2_MF2, VSOXSEG2EI8_V }, // 9762
  { PseudoVSOXSEG2EI8_V_M2_MF2_MASK, VSOXSEG2EI8_V }, // 9763
  { PseudoVSOXSEG2EI8_V_M2_MF4, VSOXSEG2EI8_V }, // 9764
  { PseudoVSOXSEG2EI8_V_M2_MF4_MASK, VSOXSEG2EI8_V }, // 9765
  { PseudoVSOXSEG2EI8_V_M2_MF8, VSOXSEG2EI8_V }, // 9766
  { PseudoVSOXSEG2EI8_V_M2_MF8_MASK, VSOXSEG2EI8_V }, // 9767
  { PseudoVSOXSEG2EI8_V_M4_M1, VSOXSEG2EI8_V }, // 9768
  { PseudoVSOXSEG2EI8_V_M4_M1_MASK, VSOXSEG2EI8_V }, // 9769
  { PseudoVSOXSEG2EI8_V_M4_M2, VSOXSEG2EI8_V }, // 9770
  { PseudoVSOXSEG2EI8_V_M4_M2_MASK, VSOXSEG2EI8_V }, // 9771
  { PseudoVSOXSEG2EI8_V_M4_M4, VSOXSEG2EI8_V }, // 9772
  { PseudoVSOXSEG2EI8_V_M4_M4_MASK, VSOXSEG2EI8_V }, // 9773
  { PseudoVSOXSEG2EI8_V_M4_MF2, VSOXSEG2EI8_V }, // 9774
  { PseudoVSOXSEG2EI8_V_M4_MF2_MASK, VSOXSEG2EI8_V }, // 9775
  { PseudoVSOXSEG2EI8_V_M4_MF4, VSOXSEG2EI8_V }, // 9776
  { PseudoVSOXSEG2EI8_V_M4_MF4_MASK, VSOXSEG2EI8_V }, // 9777
  { PseudoVSOXSEG2EI8_V_M4_MF8, VSOXSEG2EI8_V }, // 9778
  { PseudoVSOXSEG2EI8_V_M4_MF8_MASK, VSOXSEG2EI8_V }, // 9779
  { PseudoVSOXSEG2EI8_V_M8_M1, VSOXSEG2EI8_V }, // 9780
  { PseudoVSOXSEG2EI8_V_M8_M1_MASK, VSOXSEG2EI8_V }, // 9781
  { PseudoVSOXSEG2EI8_V_M8_M2, VSOXSEG2EI8_V }, // 9782
  { PseudoVSOXSEG2EI8_V_M8_M2_MASK, VSOXSEG2EI8_V }, // 9783
  { PseudoVSOXSEG2EI8_V_M8_M4, VSOXSEG2EI8_V }, // 9784
  { PseudoVSOXSEG2EI8_V_M8_M4_MASK, VSOXSEG2EI8_V }, // 9785
  { PseudoVSOXSEG2EI8_V_M8_MF2, VSOXSEG2EI8_V }, // 9786
  { PseudoVSOXSEG2EI8_V_M8_MF2_MASK, VSOXSEG2EI8_V }, // 9787
  { PseudoVSOXSEG2EI8_V_M8_MF4, VSOXSEG2EI8_V }, // 9788
  { PseudoVSOXSEG2EI8_V_M8_MF4_MASK, VSOXSEG2EI8_V }, // 9789
  { PseudoVSOXSEG2EI8_V_M8_MF8, VSOXSEG2EI8_V }, // 9790
  { PseudoVSOXSEG2EI8_V_M8_MF8_MASK, VSOXSEG2EI8_V }, // 9791
  { PseudoVSOXSEG2EI8_V_MF2_M1, VSOXSEG2EI8_V }, // 9792
  { PseudoVSOXSEG2EI8_V_MF2_M1_MASK, VSOXSEG2EI8_V }, // 9793
  { PseudoVSOXSEG2EI8_V_MF2_M2, VSOXSEG2EI8_V }, // 9794
  { PseudoVSOXSEG2EI8_V_MF2_M2_MASK, VSOXSEG2EI8_V }, // 9795
  { PseudoVSOXSEG2EI8_V_MF2_M4, VSOXSEG2EI8_V }, // 9796
  { PseudoVSOXSEG2EI8_V_MF2_M4_MASK, VSOXSEG2EI8_V }, // 9797
  { PseudoVSOXSEG2EI8_V_MF2_MF2, VSOXSEG2EI8_V }, // 9798
  { PseudoVSOXSEG2EI8_V_MF2_MF2_MASK, VSOXSEG2EI8_V }, // 9799
  { PseudoVSOXSEG2EI8_V_MF2_MF4, VSOXSEG2EI8_V }, // 9800
  { PseudoVSOXSEG2EI8_V_MF2_MF4_MASK, VSOXSEG2EI8_V }, // 9801
  { PseudoVSOXSEG2EI8_V_MF2_MF8, VSOXSEG2EI8_V }, // 9802
  { PseudoVSOXSEG2EI8_V_MF2_MF8_MASK, VSOXSEG2EI8_V }, // 9803
  { PseudoVSOXSEG2EI8_V_MF4_M1, VSOXSEG2EI8_V }, // 9804
  { PseudoVSOXSEG2EI8_V_MF4_M1_MASK, VSOXSEG2EI8_V }, // 9805
  { PseudoVSOXSEG2EI8_V_MF4_M2, VSOXSEG2EI8_V }, // 9806
  { PseudoVSOXSEG2EI8_V_MF4_M2_MASK, VSOXSEG2EI8_V }, // 9807
  { PseudoVSOXSEG2EI8_V_MF4_M4, VSOXSEG2EI8_V }, // 9808
  { PseudoVSOXSEG2EI8_V_MF4_M4_MASK, VSOXSEG2EI8_V }, // 9809
  { PseudoVSOXSEG2EI8_V_MF4_MF2, VSOXSEG2EI8_V }, // 9810
  { PseudoVSOXSEG2EI8_V_MF4_MF2_MASK, VSOXSEG2EI8_V }, // 9811
  { PseudoVSOXSEG2EI8_V_MF4_MF4, VSOXSEG2EI8_V }, // 9812
  { PseudoVSOXSEG2EI8_V_MF4_MF4_MASK, VSOXSEG2EI8_V }, // 9813
  { PseudoVSOXSEG2EI8_V_MF4_MF8, VSOXSEG2EI8_V }, // 9814
  { PseudoVSOXSEG2EI8_V_MF4_MF8_MASK, VSOXSEG2EI8_V }, // 9815
  { PseudoVSOXSEG2EI8_V_MF8_M1, VSOXSEG2EI8_V }, // 9816
  { PseudoVSOXSEG2EI8_V_MF8_M1_MASK, VSOXSEG2EI8_V }, // 9817
  { PseudoVSOXSEG2EI8_V_MF8_M2, VSOXSEG2EI8_V }, // 9818
  { PseudoVSOXSEG2EI8_V_MF8_M2_MASK, VSOXSEG2EI8_V }, // 9819
  { PseudoVSOXSEG2EI8_V_MF8_M4, VSOXSEG2EI8_V }, // 9820
  { PseudoVSOXSEG2EI8_V_MF8_M4_MASK, VSOXSEG2EI8_V }, // 9821
  { PseudoVSOXSEG2EI8_V_MF8_MF2, VSOXSEG2EI8_V }, // 9822
  { PseudoVSOXSEG2EI8_V_MF8_MF2_MASK, VSOXSEG2EI8_V }, // 9823
  { PseudoVSOXSEG2EI8_V_MF8_MF4, VSOXSEG2EI8_V }, // 9824
  { PseudoVSOXSEG2EI8_V_MF8_MF4_MASK, VSOXSEG2EI8_V }, // 9825
  { PseudoVSOXSEG2EI8_V_MF8_MF8, VSOXSEG2EI8_V }, // 9826
  { PseudoVSOXSEG2EI8_V_MF8_MF8_MASK, VSOXSEG2EI8_V }, // 9827
  { PseudoVSOXSEG3EI16_V_M1_M1, VSOXSEG3EI16_V }, // 9828
  { PseudoVSOXSEG3EI16_V_M1_M1_MASK, VSOXSEG3EI16_V }, // 9829
  { PseudoVSOXSEG3EI16_V_M1_M2, VSOXSEG3EI16_V }, // 9830
  { PseudoVSOXSEG3EI16_V_M1_M2_MASK, VSOXSEG3EI16_V }, // 9831
  { PseudoVSOXSEG3EI16_V_M1_MF2, VSOXSEG3EI16_V }, // 9832
  { PseudoVSOXSEG3EI16_V_M1_MF2_MASK, VSOXSEG3EI16_V }, // 9833
  { PseudoVSOXSEG3EI16_V_M1_MF4, VSOXSEG3EI16_V }, // 9834
  { PseudoVSOXSEG3EI16_V_M1_MF4_MASK, VSOXSEG3EI16_V }, // 9835
  { PseudoVSOXSEG3EI16_V_M1_MF8, VSOXSEG3EI16_V }, // 9836
  { PseudoVSOXSEG3EI16_V_M1_MF8_MASK, VSOXSEG3EI16_V }, // 9837
  { PseudoVSOXSEG3EI16_V_M2_M1, VSOXSEG3EI16_V }, // 9838
  { PseudoVSOXSEG3EI16_V_M2_M1_MASK, VSOXSEG3EI16_V }, // 9839
  { PseudoVSOXSEG3EI16_V_M2_M2, VSOXSEG3EI16_V }, // 9840
  { PseudoVSOXSEG3EI16_V_M2_M2_MASK, VSOXSEG3EI16_V }, // 9841
  { PseudoVSOXSEG3EI16_V_M2_MF2, VSOXSEG3EI16_V }, // 9842
  { PseudoVSOXSEG3EI16_V_M2_MF2_MASK, VSOXSEG3EI16_V }, // 9843
  { PseudoVSOXSEG3EI16_V_M2_MF4, VSOXSEG3EI16_V }, // 9844
  { PseudoVSOXSEG3EI16_V_M2_MF4_MASK, VSOXSEG3EI16_V }, // 9845
  { PseudoVSOXSEG3EI16_V_M2_MF8, VSOXSEG3EI16_V }, // 9846
  { PseudoVSOXSEG3EI16_V_M2_MF8_MASK, VSOXSEG3EI16_V }, // 9847
  { PseudoVSOXSEG3EI16_V_M4_M1, VSOXSEG3EI16_V }, // 9848
  { PseudoVSOXSEG3EI16_V_M4_M1_MASK, VSOXSEG3EI16_V }, // 9849
  { PseudoVSOXSEG3EI16_V_M4_M2, VSOXSEG3EI16_V }, // 9850
  { PseudoVSOXSEG3EI16_V_M4_M2_MASK, VSOXSEG3EI16_V }, // 9851
  { PseudoVSOXSEG3EI16_V_M4_MF2, VSOXSEG3EI16_V }, // 9852
  { PseudoVSOXSEG3EI16_V_M4_MF2_MASK, VSOXSEG3EI16_V }, // 9853
  { PseudoVSOXSEG3EI16_V_M4_MF4, VSOXSEG3EI16_V }, // 9854
  { PseudoVSOXSEG3EI16_V_M4_MF4_MASK, VSOXSEG3EI16_V }, // 9855
  { PseudoVSOXSEG3EI16_V_M4_MF8, VSOXSEG3EI16_V }, // 9856
  { PseudoVSOXSEG3EI16_V_M4_MF8_MASK, VSOXSEG3EI16_V }, // 9857
  { PseudoVSOXSEG3EI16_V_M8_M1, VSOXSEG3EI16_V }, // 9858
  { PseudoVSOXSEG3EI16_V_M8_M1_MASK, VSOXSEG3EI16_V }, // 9859
  { PseudoVSOXSEG3EI16_V_M8_M2, VSOXSEG3EI16_V }, // 9860
  { PseudoVSOXSEG3EI16_V_M8_M2_MASK, VSOXSEG3EI16_V }, // 9861
  { PseudoVSOXSEG3EI16_V_M8_MF2, VSOXSEG3EI16_V }, // 9862
  { PseudoVSOXSEG3EI16_V_M8_MF2_MASK, VSOXSEG3EI16_V }, // 9863
  { PseudoVSOXSEG3EI16_V_M8_MF4, VSOXSEG3EI16_V }, // 9864
  { PseudoVSOXSEG3EI16_V_M8_MF4_MASK, VSOXSEG3EI16_V }, // 9865
  { PseudoVSOXSEG3EI16_V_M8_MF8, VSOXSEG3EI16_V }, // 9866
  { PseudoVSOXSEG3EI16_V_M8_MF8_MASK, VSOXSEG3EI16_V }, // 9867
  { PseudoVSOXSEG3EI16_V_MF2_M1, VSOXSEG3EI16_V }, // 9868
  { PseudoVSOXSEG3EI16_V_MF2_M1_MASK, VSOXSEG3EI16_V }, // 9869
  { PseudoVSOXSEG3EI16_V_MF2_M2, VSOXSEG3EI16_V }, // 9870
  { PseudoVSOXSEG3EI16_V_MF2_M2_MASK, VSOXSEG3EI16_V }, // 9871
  { PseudoVSOXSEG3EI16_V_MF2_MF2, VSOXSEG3EI16_V }, // 9872
  { PseudoVSOXSEG3EI16_V_MF2_MF2_MASK, VSOXSEG3EI16_V }, // 9873
  { PseudoVSOXSEG3EI16_V_MF2_MF4, VSOXSEG3EI16_V }, // 9874
  { PseudoVSOXSEG3EI16_V_MF2_MF4_MASK, VSOXSEG3EI16_V }, // 9875
  { PseudoVSOXSEG3EI16_V_MF2_MF8, VSOXSEG3EI16_V }, // 9876
  { PseudoVSOXSEG3EI16_V_MF2_MF8_MASK, VSOXSEG3EI16_V }, // 9877
  { PseudoVSOXSEG3EI16_V_MF4_M1, VSOXSEG3EI16_V }, // 9878
  { PseudoVSOXSEG3EI16_V_MF4_M1_MASK, VSOXSEG3EI16_V }, // 9879
  { PseudoVSOXSEG3EI16_V_MF4_M2, VSOXSEG3EI16_V }, // 9880
  { PseudoVSOXSEG3EI16_V_MF4_M2_MASK, VSOXSEG3EI16_V }, // 9881
  { PseudoVSOXSEG3EI16_V_MF4_MF2, VSOXSEG3EI16_V }, // 9882
  { PseudoVSOXSEG3EI16_V_MF4_MF2_MASK, VSOXSEG3EI16_V }, // 9883
  { PseudoVSOXSEG3EI16_V_MF4_MF4, VSOXSEG3EI16_V }, // 9884
  { PseudoVSOXSEG3EI16_V_MF4_MF4_MASK, VSOXSEG3EI16_V }, // 9885
  { PseudoVSOXSEG3EI16_V_MF4_MF8, VSOXSEG3EI16_V }, // 9886
  { PseudoVSOXSEG3EI16_V_MF4_MF8_MASK, VSOXSEG3EI16_V }, // 9887
  { PseudoVSOXSEG3EI32_V_M1_M1, VSOXSEG3EI32_V }, // 9888
  { PseudoVSOXSEG3EI32_V_M1_M1_MASK, VSOXSEG3EI32_V }, // 9889
  { PseudoVSOXSEG3EI32_V_M1_M2, VSOXSEG3EI32_V }, // 9890
  { PseudoVSOXSEG3EI32_V_M1_M2_MASK, VSOXSEG3EI32_V }, // 9891
  { PseudoVSOXSEG3EI32_V_M1_MF2, VSOXSEG3EI32_V }, // 9892
  { PseudoVSOXSEG3EI32_V_M1_MF2_MASK, VSOXSEG3EI32_V }, // 9893
  { PseudoVSOXSEG3EI32_V_M1_MF4, VSOXSEG3EI32_V }, // 9894
  { PseudoVSOXSEG3EI32_V_M1_MF4_MASK, VSOXSEG3EI32_V }, // 9895
  { PseudoVSOXSEG3EI32_V_M1_MF8, VSOXSEG3EI32_V }, // 9896
  { PseudoVSOXSEG3EI32_V_M1_MF8_MASK, VSOXSEG3EI32_V }, // 9897
  { PseudoVSOXSEG3EI32_V_M2_M1, VSOXSEG3EI32_V }, // 9898
  { PseudoVSOXSEG3EI32_V_M2_M1_MASK, VSOXSEG3EI32_V }, // 9899
  { PseudoVSOXSEG3EI32_V_M2_M2, VSOXSEG3EI32_V }, // 9900
  { PseudoVSOXSEG3EI32_V_M2_M2_MASK, VSOXSEG3EI32_V }, // 9901
  { PseudoVSOXSEG3EI32_V_M2_MF2, VSOXSEG3EI32_V }, // 9902
  { PseudoVSOXSEG3EI32_V_M2_MF2_MASK, VSOXSEG3EI32_V }, // 9903
  { PseudoVSOXSEG3EI32_V_M2_MF4, VSOXSEG3EI32_V }, // 9904
  { PseudoVSOXSEG3EI32_V_M2_MF4_MASK, VSOXSEG3EI32_V }, // 9905
  { PseudoVSOXSEG3EI32_V_M2_MF8, VSOXSEG3EI32_V }, // 9906
  { PseudoVSOXSEG3EI32_V_M2_MF8_MASK, VSOXSEG3EI32_V }, // 9907
  { PseudoVSOXSEG3EI32_V_M4_M1, VSOXSEG3EI32_V }, // 9908
  { PseudoVSOXSEG3EI32_V_M4_M1_MASK, VSOXSEG3EI32_V }, // 9909
  { PseudoVSOXSEG3EI32_V_M4_M2, VSOXSEG3EI32_V }, // 9910
  { PseudoVSOXSEG3EI32_V_M4_M2_MASK, VSOXSEG3EI32_V }, // 9911
  { PseudoVSOXSEG3EI32_V_M4_MF2, VSOXSEG3EI32_V }, // 9912
  { PseudoVSOXSEG3EI32_V_M4_MF2_MASK, VSOXSEG3EI32_V }, // 9913
  { PseudoVSOXSEG3EI32_V_M4_MF4, VSOXSEG3EI32_V }, // 9914
  { PseudoVSOXSEG3EI32_V_M4_MF4_MASK, VSOXSEG3EI32_V }, // 9915
  { PseudoVSOXSEG3EI32_V_M4_MF8, VSOXSEG3EI32_V }, // 9916
  { PseudoVSOXSEG3EI32_V_M4_MF8_MASK, VSOXSEG3EI32_V }, // 9917
  { PseudoVSOXSEG3EI32_V_M8_M1, VSOXSEG3EI32_V }, // 9918
  { PseudoVSOXSEG3EI32_V_M8_M1_MASK, VSOXSEG3EI32_V }, // 9919
  { PseudoVSOXSEG3EI32_V_M8_M2, VSOXSEG3EI32_V }, // 9920
  { PseudoVSOXSEG3EI32_V_M8_M2_MASK, VSOXSEG3EI32_V }, // 9921
  { PseudoVSOXSEG3EI32_V_M8_MF2, VSOXSEG3EI32_V }, // 9922
  { PseudoVSOXSEG3EI32_V_M8_MF2_MASK, VSOXSEG3EI32_V }, // 9923
  { PseudoVSOXSEG3EI32_V_M8_MF4, VSOXSEG3EI32_V }, // 9924
  { PseudoVSOXSEG3EI32_V_M8_MF4_MASK, VSOXSEG3EI32_V }, // 9925
  { PseudoVSOXSEG3EI32_V_M8_MF8, VSOXSEG3EI32_V }, // 9926
  { PseudoVSOXSEG3EI32_V_M8_MF8_MASK, VSOXSEG3EI32_V }, // 9927
  { PseudoVSOXSEG3EI32_V_MF2_M1, VSOXSEG3EI32_V }, // 9928
  { PseudoVSOXSEG3EI32_V_MF2_M1_MASK, VSOXSEG3EI32_V }, // 9929
  { PseudoVSOXSEG3EI32_V_MF2_M2, VSOXSEG3EI32_V }, // 9930
  { PseudoVSOXSEG3EI32_V_MF2_M2_MASK, VSOXSEG3EI32_V }, // 9931
  { PseudoVSOXSEG3EI32_V_MF2_MF2, VSOXSEG3EI32_V }, // 9932
  { PseudoVSOXSEG3EI32_V_MF2_MF2_MASK, VSOXSEG3EI32_V }, // 9933
  { PseudoVSOXSEG3EI32_V_MF2_MF4, VSOXSEG3EI32_V }, // 9934
  { PseudoVSOXSEG3EI32_V_MF2_MF4_MASK, VSOXSEG3EI32_V }, // 9935
  { PseudoVSOXSEG3EI32_V_MF2_MF8, VSOXSEG3EI32_V }, // 9936
  { PseudoVSOXSEG3EI32_V_MF2_MF8_MASK, VSOXSEG3EI32_V }, // 9937
  { PseudoVSOXSEG3EI64_V_M1_M1, VSOXSEG3EI64_V }, // 9938
  { PseudoVSOXSEG3EI64_V_M1_M1_MASK, VSOXSEG3EI64_V }, // 9939
  { PseudoVSOXSEG3EI64_V_M1_M2, VSOXSEG3EI64_V }, // 9940
  { PseudoVSOXSEG3EI64_V_M1_M2_MASK, VSOXSEG3EI64_V }, // 9941
  { PseudoVSOXSEG3EI64_V_M1_MF2, VSOXSEG3EI64_V }, // 9942
  { PseudoVSOXSEG3EI64_V_M1_MF2_MASK, VSOXSEG3EI64_V }, // 9943
  { PseudoVSOXSEG3EI64_V_M1_MF4, VSOXSEG3EI64_V }, // 9944
  { PseudoVSOXSEG3EI64_V_M1_MF4_MASK, VSOXSEG3EI64_V }, // 9945
  { PseudoVSOXSEG3EI64_V_M1_MF8, VSOXSEG3EI64_V }, // 9946
  { PseudoVSOXSEG3EI64_V_M1_MF8_MASK, VSOXSEG3EI64_V }, // 9947
  { PseudoVSOXSEG3EI64_V_M2_M1, VSOXSEG3EI64_V }, // 9948
  { PseudoVSOXSEG3EI64_V_M2_M1_MASK, VSOXSEG3EI64_V }, // 9949
  { PseudoVSOXSEG3EI64_V_M2_M2, VSOXSEG3EI64_V }, // 9950
  { PseudoVSOXSEG3EI64_V_M2_M2_MASK, VSOXSEG3EI64_V }, // 9951
  { PseudoVSOXSEG3EI64_V_M2_MF2, VSOXSEG3EI64_V }, // 9952
  { PseudoVSOXSEG3EI64_V_M2_MF2_MASK, VSOXSEG3EI64_V }, // 9953
  { PseudoVSOXSEG3EI64_V_M2_MF4, VSOXSEG3EI64_V }, // 9954
  { PseudoVSOXSEG3EI64_V_M2_MF4_MASK, VSOXSEG3EI64_V }, // 9955
  { PseudoVSOXSEG3EI64_V_M2_MF8, VSOXSEG3EI64_V }, // 9956
  { PseudoVSOXSEG3EI64_V_M2_MF8_MASK, VSOXSEG3EI64_V }, // 9957
  { PseudoVSOXSEG3EI64_V_M4_M1, VSOXSEG3EI64_V }, // 9958
  { PseudoVSOXSEG3EI64_V_M4_M1_MASK, VSOXSEG3EI64_V }, // 9959
  { PseudoVSOXSEG3EI64_V_M4_M2, VSOXSEG3EI64_V }, // 9960
  { PseudoVSOXSEG3EI64_V_M4_M2_MASK, VSOXSEG3EI64_V }, // 9961
  { PseudoVSOXSEG3EI64_V_M4_MF2, VSOXSEG3EI64_V }, // 9962
  { PseudoVSOXSEG3EI64_V_M4_MF2_MASK, VSOXSEG3EI64_V }, // 9963
  { PseudoVSOXSEG3EI64_V_M4_MF4, VSOXSEG3EI64_V }, // 9964
  { PseudoVSOXSEG3EI64_V_M4_MF4_MASK, VSOXSEG3EI64_V }, // 9965
  { PseudoVSOXSEG3EI64_V_M4_MF8, VSOXSEG3EI64_V }, // 9966
  { PseudoVSOXSEG3EI64_V_M4_MF8_MASK, VSOXSEG3EI64_V }, // 9967
  { PseudoVSOXSEG3EI64_V_M8_M1, VSOXSEG3EI64_V }, // 9968
  { PseudoVSOXSEG3EI64_V_M8_M1_MASK, VSOXSEG3EI64_V }, // 9969
  { PseudoVSOXSEG3EI64_V_M8_M2, VSOXSEG3EI64_V }, // 9970
  { PseudoVSOXSEG3EI64_V_M8_M2_MASK, VSOXSEG3EI64_V }, // 9971
  { PseudoVSOXSEG3EI64_V_M8_MF2, VSOXSEG3EI64_V }, // 9972
  { PseudoVSOXSEG3EI64_V_M8_MF2_MASK, VSOXSEG3EI64_V }, // 9973
  { PseudoVSOXSEG3EI64_V_M8_MF4, VSOXSEG3EI64_V }, // 9974
  { PseudoVSOXSEG3EI64_V_M8_MF4_MASK, VSOXSEG3EI64_V }, // 9975
  { PseudoVSOXSEG3EI64_V_M8_MF8, VSOXSEG3EI64_V }, // 9976
  { PseudoVSOXSEG3EI64_V_M8_MF8_MASK, VSOXSEG3EI64_V }, // 9977
  { PseudoVSOXSEG3EI8_V_M1_M1, VSOXSEG3EI8_V }, // 9978
  { PseudoVSOXSEG3EI8_V_M1_M1_MASK, VSOXSEG3EI8_V }, // 9979
  { PseudoVSOXSEG3EI8_V_M1_M2, VSOXSEG3EI8_V }, // 9980
  { PseudoVSOXSEG3EI8_V_M1_M2_MASK, VSOXSEG3EI8_V }, // 9981
  { PseudoVSOXSEG3EI8_V_M1_MF2, VSOXSEG3EI8_V }, // 9982
  { PseudoVSOXSEG3EI8_V_M1_MF2_MASK, VSOXSEG3EI8_V }, // 9983
  { PseudoVSOXSEG3EI8_V_M1_MF4, VSOXSEG3EI8_V }, // 9984
  { PseudoVSOXSEG3EI8_V_M1_MF4_MASK, VSOXSEG3EI8_V }, // 9985
  { PseudoVSOXSEG3EI8_V_M1_MF8, VSOXSEG3EI8_V }, // 9986
  { PseudoVSOXSEG3EI8_V_M1_MF8_MASK, VSOXSEG3EI8_V }, // 9987
  { PseudoVSOXSEG3EI8_V_M2_M1, VSOXSEG3EI8_V }, // 9988
  { PseudoVSOXSEG3EI8_V_M2_M1_MASK, VSOXSEG3EI8_V }, // 9989
  { PseudoVSOXSEG3EI8_V_M2_M2, VSOXSEG3EI8_V }, // 9990
  { PseudoVSOXSEG3EI8_V_M2_M2_MASK, VSOXSEG3EI8_V }, // 9991
  { PseudoVSOXSEG3EI8_V_M2_MF2, VSOXSEG3EI8_V }, // 9992
  { PseudoVSOXSEG3EI8_V_M2_MF2_MASK, VSOXSEG3EI8_V }, // 9993
  { PseudoVSOXSEG3EI8_V_M2_MF4, VSOXSEG3EI8_V }, // 9994
  { PseudoVSOXSEG3EI8_V_M2_MF4_MASK, VSOXSEG3EI8_V }, // 9995
  { PseudoVSOXSEG3EI8_V_M2_MF8, VSOXSEG3EI8_V }, // 9996
  { PseudoVSOXSEG3EI8_V_M2_MF8_MASK, VSOXSEG3EI8_V }, // 9997
  { PseudoVSOXSEG3EI8_V_M4_M1, VSOXSEG3EI8_V }, // 9998
  { PseudoVSOXSEG3EI8_V_M4_M1_MASK, VSOXSEG3EI8_V }, // 9999
  { PseudoVSOXSEG3EI8_V_M4_M2, VSOXSEG3EI8_V }, // 10000
  { PseudoVSOXSEG3EI8_V_M4_M2_MASK, VSOXSEG3EI8_V }, // 10001
  { PseudoVSOXSEG3EI8_V_M4_MF2, VSOXSEG3EI8_V }, // 10002
  { PseudoVSOXSEG3EI8_V_M4_MF2_MASK, VSOXSEG3EI8_V }, // 10003
  { PseudoVSOXSEG3EI8_V_M4_MF4, VSOXSEG3EI8_V }, // 10004
  { PseudoVSOXSEG3EI8_V_M4_MF4_MASK, VSOXSEG3EI8_V }, // 10005
  { PseudoVSOXSEG3EI8_V_M4_MF8, VSOXSEG3EI8_V }, // 10006
  { PseudoVSOXSEG3EI8_V_M4_MF8_MASK, VSOXSEG3EI8_V }, // 10007
  { PseudoVSOXSEG3EI8_V_M8_M1, VSOXSEG3EI8_V }, // 10008
  { PseudoVSOXSEG3EI8_V_M8_M1_MASK, VSOXSEG3EI8_V }, // 10009
  { PseudoVSOXSEG3EI8_V_M8_M2, VSOXSEG3EI8_V }, // 10010
  { PseudoVSOXSEG3EI8_V_M8_M2_MASK, VSOXSEG3EI8_V }, // 10011
  { PseudoVSOXSEG3EI8_V_M8_MF2, VSOXSEG3EI8_V }, // 10012
  { PseudoVSOXSEG3EI8_V_M8_MF2_MASK, VSOXSEG3EI8_V }, // 10013
  { PseudoVSOXSEG3EI8_V_M8_MF4, VSOXSEG3EI8_V }, // 10014
  { PseudoVSOXSEG3EI8_V_M8_MF4_MASK, VSOXSEG3EI8_V }, // 10015
  { PseudoVSOXSEG3EI8_V_M8_MF8, VSOXSEG3EI8_V }, // 10016
  { PseudoVSOXSEG3EI8_V_M8_MF8_MASK, VSOXSEG3EI8_V }, // 10017
  { PseudoVSOXSEG3EI8_V_MF2_M1, VSOXSEG3EI8_V }, // 10018
  { PseudoVSOXSEG3EI8_V_MF2_M1_MASK, VSOXSEG3EI8_V }, // 10019
  { PseudoVSOXSEG3EI8_V_MF2_M2, VSOXSEG3EI8_V }, // 10020
  { PseudoVSOXSEG3EI8_V_MF2_M2_MASK, VSOXSEG3EI8_V }, // 10021
  { PseudoVSOXSEG3EI8_V_MF2_MF2, VSOXSEG3EI8_V }, // 10022
  { PseudoVSOXSEG3EI8_V_MF2_MF2_MASK, VSOXSEG3EI8_V }, // 10023
  { PseudoVSOXSEG3EI8_V_MF2_MF4, VSOXSEG3EI8_V }, // 10024
  { PseudoVSOXSEG3EI8_V_MF2_MF4_MASK, VSOXSEG3EI8_V }, // 10025
  { PseudoVSOXSEG3EI8_V_MF2_MF8, VSOXSEG3EI8_V }, // 10026
  { PseudoVSOXSEG3EI8_V_MF2_MF8_MASK, VSOXSEG3EI8_V }, // 10027
  { PseudoVSOXSEG3EI8_V_MF4_M1, VSOXSEG3EI8_V }, // 10028
  { PseudoVSOXSEG3EI8_V_MF4_M1_MASK, VSOXSEG3EI8_V }, // 10029
  { PseudoVSOXSEG3EI8_V_MF4_M2, VSOXSEG3EI8_V }, // 10030
  { PseudoVSOXSEG3EI8_V_MF4_M2_MASK, VSOXSEG3EI8_V }, // 10031
  { PseudoVSOXSEG3EI8_V_MF4_MF2, VSOXSEG3EI8_V }, // 10032
  { PseudoVSOXSEG3EI8_V_MF4_MF2_MASK, VSOXSEG3EI8_V }, // 10033
  { PseudoVSOXSEG3EI8_V_MF4_MF4, VSOXSEG3EI8_V }, // 10034
  { PseudoVSOXSEG3EI8_V_MF4_MF4_MASK, VSOXSEG3EI8_V }, // 10035
  { PseudoVSOXSEG3EI8_V_MF4_MF8, VSOXSEG3EI8_V }, // 10036
  { PseudoVSOXSEG3EI8_V_MF4_MF8_MASK, VSOXSEG3EI8_V }, // 10037
  { PseudoVSOXSEG3EI8_V_MF8_M1, VSOXSEG3EI8_V }, // 10038
  { PseudoVSOXSEG3EI8_V_MF8_M1_MASK, VSOXSEG3EI8_V }, // 10039
  { PseudoVSOXSEG3EI8_V_MF8_M2, VSOXSEG3EI8_V }, // 10040
  { PseudoVSOXSEG3EI8_V_MF8_M2_MASK, VSOXSEG3EI8_V }, // 10041
  { PseudoVSOXSEG3EI8_V_MF8_MF2, VSOXSEG3EI8_V }, // 10042
  { PseudoVSOXSEG3EI8_V_MF8_MF2_MASK, VSOXSEG3EI8_V }, // 10043
  { PseudoVSOXSEG3EI8_V_MF8_MF4, VSOXSEG3EI8_V }, // 10044
  { PseudoVSOXSEG3EI8_V_MF8_MF4_MASK, VSOXSEG3EI8_V }, // 10045
  { PseudoVSOXSEG3EI8_V_MF8_MF8, VSOXSEG3EI8_V }, // 10046
  { PseudoVSOXSEG3EI8_V_MF8_MF8_MASK, VSOXSEG3EI8_V }, // 10047
  { PseudoVSOXSEG4EI16_V_M1_M1, VSOXSEG4EI16_V }, // 10048
  { PseudoVSOXSEG4EI16_V_M1_M1_MASK, VSOXSEG4EI16_V }, // 10049
  { PseudoVSOXSEG4EI16_V_M1_M2, VSOXSEG4EI16_V }, // 10050
  { PseudoVSOXSEG4EI16_V_M1_M2_MASK, VSOXSEG4EI16_V }, // 10051
  { PseudoVSOXSEG4EI16_V_M1_MF2, VSOXSEG4EI16_V }, // 10052
  { PseudoVSOXSEG4EI16_V_M1_MF2_MASK, VSOXSEG4EI16_V }, // 10053
  { PseudoVSOXSEG4EI16_V_M1_MF4, VSOXSEG4EI16_V }, // 10054
  { PseudoVSOXSEG4EI16_V_M1_MF4_MASK, VSOXSEG4EI16_V }, // 10055
  { PseudoVSOXSEG4EI16_V_M1_MF8, VSOXSEG4EI16_V }, // 10056
  { PseudoVSOXSEG4EI16_V_M1_MF8_MASK, VSOXSEG4EI16_V }, // 10057
  { PseudoVSOXSEG4EI16_V_M2_M1, VSOXSEG4EI16_V }, // 10058
  { PseudoVSOXSEG4EI16_V_M2_M1_MASK, VSOXSEG4EI16_V }, // 10059
  { PseudoVSOXSEG4EI16_V_M2_M2, VSOXSEG4EI16_V }, // 10060
  { PseudoVSOXSEG4EI16_V_M2_M2_MASK, VSOXSEG4EI16_V }, // 10061
  { PseudoVSOXSEG4EI16_V_M2_MF2, VSOXSEG4EI16_V }, // 10062
  { PseudoVSOXSEG4EI16_V_M2_MF2_MASK, VSOXSEG4EI16_V }, // 10063
  { PseudoVSOXSEG4EI16_V_M2_MF4, VSOXSEG4EI16_V }, // 10064
  { PseudoVSOXSEG4EI16_V_M2_MF4_MASK, VSOXSEG4EI16_V }, // 10065
  { PseudoVSOXSEG4EI16_V_M2_MF8, VSOXSEG4EI16_V }, // 10066
  { PseudoVSOXSEG4EI16_V_M2_MF8_MASK, VSOXSEG4EI16_V }, // 10067
  { PseudoVSOXSEG4EI16_V_M4_M1, VSOXSEG4EI16_V }, // 10068
  { PseudoVSOXSEG4EI16_V_M4_M1_MASK, VSOXSEG4EI16_V }, // 10069
  { PseudoVSOXSEG4EI16_V_M4_M2, VSOXSEG4EI16_V }, // 10070
  { PseudoVSOXSEG4EI16_V_M4_M2_MASK, VSOXSEG4EI16_V }, // 10071
  { PseudoVSOXSEG4EI16_V_M4_MF2, VSOXSEG4EI16_V }, // 10072
  { PseudoVSOXSEG4EI16_V_M4_MF2_MASK, VSOXSEG4EI16_V }, // 10073
  { PseudoVSOXSEG4EI16_V_M4_MF4, VSOXSEG4EI16_V }, // 10074
  { PseudoVSOXSEG4EI16_V_M4_MF4_MASK, VSOXSEG4EI16_V }, // 10075
  { PseudoVSOXSEG4EI16_V_M4_MF8, VSOXSEG4EI16_V }, // 10076
  { PseudoVSOXSEG4EI16_V_M4_MF8_MASK, VSOXSEG4EI16_V }, // 10077
  { PseudoVSOXSEG4EI16_V_M8_M1, VSOXSEG4EI16_V }, // 10078
  { PseudoVSOXSEG4EI16_V_M8_M1_MASK, VSOXSEG4EI16_V }, // 10079
  { PseudoVSOXSEG4EI16_V_M8_M2, VSOXSEG4EI16_V }, // 10080
  { PseudoVSOXSEG4EI16_V_M8_M2_MASK, VSOXSEG4EI16_V }, // 10081
  { PseudoVSOXSEG4EI16_V_M8_MF2, VSOXSEG4EI16_V }, // 10082
  { PseudoVSOXSEG4EI16_V_M8_MF2_MASK, VSOXSEG4EI16_V }, // 10083
  { PseudoVSOXSEG4EI16_V_M8_MF4, VSOXSEG4EI16_V }, // 10084
  { PseudoVSOXSEG4EI16_V_M8_MF4_MASK, VSOXSEG4EI16_V }, // 10085
  { PseudoVSOXSEG4EI16_V_M8_MF8, VSOXSEG4EI16_V }, // 10086
  { PseudoVSOXSEG4EI16_V_M8_MF8_MASK, VSOXSEG4EI16_V }, // 10087
  { PseudoVSOXSEG4EI16_V_MF2_M1, VSOXSEG4EI16_V }, // 10088
  { PseudoVSOXSEG4EI16_V_MF2_M1_MASK, VSOXSEG4EI16_V }, // 10089
  { PseudoVSOXSEG4EI16_V_MF2_M2, VSOXSEG4EI16_V }, // 10090
  { PseudoVSOXSEG4EI16_V_MF2_M2_MASK, VSOXSEG4EI16_V }, // 10091
  { PseudoVSOXSEG4EI16_V_MF2_MF2, VSOXSEG4EI16_V }, // 10092
  { PseudoVSOXSEG4EI16_V_MF2_MF2_MASK, VSOXSEG4EI16_V }, // 10093
  { PseudoVSOXSEG4EI16_V_MF2_MF4, VSOXSEG4EI16_V }, // 10094
  { PseudoVSOXSEG4EI16_V_MF2_MF4_MASK, VSOXSEG4EI16_V }, // 10095
  { PseudoVSOXSEG4EI16_V_MF2_MF8, VSOXSEG4EI16_V }, // 10096
  { PseudoVSOXSEG4EI16_V_MF2_MF8_MASK, VSOXSEG4EI16_V }, // 10097
  { PseudoVSOXSEG4EI16_V_MF4_M1, VSOXSEG4EI16_V }, // 10098
  { PseudoVSOXSEG4EI16_V_MF4_M1_MASK, VSOXSEG4EI16_V }, // 10099
  { PseudoVSOXSEG4EI16_V_MF4_M2, VSOXSEG4EI16_V }, // 10100
  { PseudoVSOXSEG4EI16_V_MF4_M2_MASK, VSOXSEG4EI16_V }, // 10101
  { PseudoVSOXSEG4EI16_V_MF4_MF2, VSOXSEG4EI16_V }, // 10102
  { PseudoVSOXSEG4EI16_V_MF4_MF2_MASK, VSOXSEG4EI16_V }, // 10103
  { PseudoVSOXSEG4EI16_V_MF4_MF4, VSOXSEG4EI16_V }, // 10104
  { PseudoVSOXSEG4EI16_V_MF4_MF4_MASK, VSOXSEG4EI16_V }, // 10105
  { PseudoVSOXSEG4EI16_V_MF4_MF8, VSOXSEG4EI16_V }, // 10106
  { PseudoVSOXSEG4EI16_V_MF4_MF8_MASK, VSOXSEG4EI16_V }, // 10107
  { PseudoVSOXSEG4EI32_V_M1_M1, VSOXSEG4EI32_V }, // 10108
  { PseudoVSOXSEG4EI32_V_M1_M1_MASK, VSOXSEG4EI32_V }, // 10109
  { PseudoVSOXSEG4EI32_V_M1_M2, VSOXSEG4EI32_V }, // 10110
  { PseudoVSOXSEG4EI32_V_M1_M2_MASK, VSOXSEG4EI32_V }, // 10111
  { PseudoVSOXSEG4EI32_V_M1_MF2, VSOXSEG4EI32_V }, // 10112
  { PseudoVSOXSEG4EI32_V_M1_MF2_MASK, VSOXSEG4EI32_V }, // 10113
  { PseudoVSOXSEG4EI32_V_M1_MF4, VSOXSEG4EI32_V }, // 10114
  { PseudoVSOXSEG4EI32_V_M1_MF4_MASK, VSOXSEG4EI32_V }, // 10115
  { PseudoVSOXSEG4EI32_V_M1_MF8, VSOXSEG4EI32_V }, // 10116
  { PseudoVSOXSEG4EI32_V_M1_MF8_MASK, VSOXSEG4EI32_V }, // 10117
  { PseudoVSOXSEG4EI32_V_M2_M1, VSOXSEG4EI32_V }, // 10118
  { PseudoVSOXSEG4EI32_V_M2_M1_MASK, VSOXSEG4EI32_V }, // 10119
  { PseudoVSOXSEG4EI32_V_M2_M2, VSOXSEG4EI32_V }, // 10120
  { PseudoVSOXSEG4EI32_V_M2_M2_MASK, VSOXSEG4EI32_V }, // 10121
  { PseudoVSOXSEG4EI32_V_M2_MF2, VSOXSEG4EI32_V }, // 10122
  { PseudoVSOXSEG4EI32_V_M2_MF2_MASK, VSOXSEG4EI32_V }, // 10123
  { PseudoVSOXSEG4EI32_V_M2_MF4, VSOXSEG4EI32_V }, // 10124
  { PseudoVSOXSEG4EI32_V_M2_MF4_MASK, VSOXSEG4EI32_V }, // 10125
  { PseudoVSOXSEG4EI32_V_M2_MF8, VSOXSEG4EI32_V }, // 10126
  { PseudoVSOXSEG4EI32_V_M2_MF8_MASK, VSOXSEG4EI32_V }, // 10127
  { PseudoVSOXSEG4EI32_V_M4_M1, VSOXSEG4EI32_V }, // 10128
  { PseudoVSOXSEG4EI32_V_M4_M1_MASK, VSOXSEG4EI32_V }, // 10129
  { PseudoVSOXSEG4EI32_V_M4_M2, VSOXSEG4EI32_V }, // 10130
  { PseudoVSOXSEG4EI32_V_M4_M2_MASK, VSOXSEG4EI32_V }, // 10131
  { PseudoVSOXSEG4EI32_V_M4_MF2, VSOXSEG4EI32_V }, // 10132
  { PseudoVSOXSEG4EI32_V_M4_MF2_MASK, VSOXSEG4EI32_V }, // 10133
  { PseudoVSOXSEG4EI32_V_M4_MF4, VSOXSEG4EI32_V }, // 10134
  { PseudoVSOXSEG4EI32_V_M4_MF4_MASK, VSOXSEG4EI32_V }, // 10135
  { PseudoVSOXSEG4EI32_V_M4_MF8, VSOXSEG4EI32_V }, // 10136
  { PseudoVSOXSEG4EI32_V_M4_MF8_MASK, VSOXSEG4EI32_V }, // 10137
  { PseudoVSOXSEG4EI32_V_M8_M1, VSOXSEG4EI32_V }, // 10138
  { PseudoVSOXSEG4EI32_V_M8_M1_MASK, VSOXSEG4EI32_V }, // 10139
  { PseudoVSOXSEG4EI32_V_M8_M2, VSOXSEG4EI32_V }, // 10140
  { PseudoVSOXSEG4EI32_V_M8_M2_MASK, VSOXSEG4EI32_V }, // 10141
  { PseudoVSOXSEG4EI32_V_M8_MF2, VSOXSEG4EI32_V }, // 10142
  { PseudoVSOXSEG4EI32_V_M8_MF2_MASK, VSOXSEG4EI32_V }, // 10143
  { PseudoVSOXSEG4EI32_V_M8_MF4, VSOXSEG4EI32_V }, // 10144
  { PseudoVSOXSEG4EI32_V_M8_MF4_MASK, VSOXSEG4EI32_V }, // 10145
  { PseudoVSOXSEG4EI32_V_M8_MF8, VSOXSEG4EI32_V }, // 10146
  { PseudoVSOXSEG4EI32_V_M8_MF8_MASK, VSOXSEG4EI32_V }, // 10147
  { PseudoVSOXSEG4EI32_V_MF2_M1, VSOXSEG4EI32_V }, // 10148
  { PseudoVSOXSEG4EI32_V_MF2_M1_MASK, VSOXSEG4EI32_V }, // 10149
  { PseudoVSOXSEG4EI32_V_MF2_M2, VSOXSEG4EI32_V }, // 10150
  { PseudoVSOXSEG4EI32_V_MF2_M2_MASK, VSOXSEG4EI32_V }, // 10151
  { PseudoVSOXSEG4EI32_V_MF2_MF2, VSOXSEG4EI32_V }, // 10152
  { PseudoVSOXSEG4EI32_V_MF2_MF2_MASK, VSOXSEG4EI32_V }, // 10153
  { PseudoVSOXSEG4EI32_V_MF2_MF4, VSOXSEG4EI32_V }, // 10154
  { PseudoVSOXSEG4EI32_V_MF2_MF4_MASK, VSOXSEG4EI32_V }, // 10155
  { PseudoVSOXSEG4EI32_V_MF2_MF8, VSOXSEG4EI32_V }, // 10156
  { PseudoVSOXSEG4EI32_V_MF2_MF8_MASK, VSOXSEG4EI32_V }, // 10157
  { PseudoVSOXSEG4EI64_V_M1_M1, VSOXSEG4EI64_V }, // 10158
  { PseudoVSOXSEG4EI64_V_M1_M1_MASK, VSOXSEG4EI64_V }, // 10159
  { PseudoVSOXSEG4EI64_V_M1_M2, VSOXSEG4EI64_V }, // 10160
  { PseudoVSOXSEG4EI64_V_M1_M2_MASK, VSOXSEG4EI64_V }, // 10161
  { PseudoVSOXSEG4EI64_V_M1_MF2, VSOXSEG4EI64_V }, // 10162
  { PseudoVSOXSEG4EI64_V_M1_MF2_MASK, VSOXSEG4EI64_V }, // 10163
  { PseudoVSOXSEG4EI64_V_M1_MF4, VSOXSEG4EI64_V }, // 10164
  { PseudoVSOXSEG4EI64_V_M1_MF4_MASK, VSOXSEG4EI64_V }, // 10165
  { PseudoVSOXSEG4EI64_V_M1_MF8, VSOXSEG4EI64_V }, // 10166
  { PseudoVSOXSEG4EI64_V_M1_MF8_MASK, VSOXSEG4EI64_V }, // 10167
  { PseudoVSOXSEG4EI64_V_M2_M1, VSOXSEG4EI64_V }, // 10168
  { PseudoVSOXSEG4EI64_V_M2_M1_MASK, VSOXSEG4EI64_V }, // 10169
  { PseudoVSOXSEG4EI64_V_M2_M2, VSOXSEG4EI64_V }, // 10170
  { PseudoVSOXSEG4EI64_V_M2_M2_MASK, VSOXSEG4EI64_V }, // 10171
  { PseudoVSOXSEG4EI64_V_M2_MF2, VSOXSEG4EI64_V }, // 10172
  { PseudoVSOXSEG4EI64_V_M2_MF2_MASK, VSOXSEG4EI64_V }, // 10173
  { PseudoVSOXSEG4EI64_V_M2_MF4, VSOXSEG4EI64_V }, // 10174
  { PseudoVSOXSEG4EI64_V_M2_MF4_MASK, VSOXSEG4EI64_V }, // 10175
  { PseudoVSOXSEG4EI64_V_M2_MF8, VSOXSEG4EI64_V }, // 10176
  { PseudoVSOXSEG4EI64_V_M2_MF8_MASK, VSOXSEG4EI64_V }, // 10177
  { PseudoVSOXSEG4EI64_V_M4_M1, VSOXSEG4EI64_V }, // 10178
  { PseudoVSOXSEG4EI64_V_M4_M1_MASK, VSOXSEG4EI64_V }, // 10179
  { PseudoVSOXSEG4EI64_V_M4_M2, VSOXSEG4EI64_V }, // 10180
  { PseudoVSOXSEG4EI64_V_M4_M2_MASK, VSOXSEG4EI64_V }, // 10181
  { PseudoVSOXSEG4EI64_V_M4_MF2, VSOXSEG4EI64_V }, // 10182
  { PseudoVSOXSEG4EI64_V_M4_MF2_MASK, VSOXSEG4EI64_V }, // 10183
  { PseudoVSOXSEG4EI64_V_M4_MF4, VSOXSEG4EI64_V }, // 10184
  { PseudoVSOXSEG4EI64_V_M4_MF4_MASK, VSOXSEG4EI64_V }, // 10185
  { PseudoVSOXSEG4EI64_V_M4_MF8, VSOXSEG4EI64_V }, // 10186
  { PseudoVSOXSEG4EI64_V_M4_MF8_MASK, VSOXSEG4EI64_V }, // 10187
  { PseudoVSOXSEG4EI64_V_M8_M1, VSOXSEG4EI64_V }, // 10188
  { PseudoVSOXSEG4EI64_V_M8_M1_MASK, VSOXSEG4EI64_V }, // 10189
  { PseudoVSOXSEG4EI64_V_M8_M2, VSOXSEG4EI64_V }, // 10190
  { PseudoVSOXSEG4EI64_V_M8_M2_MASK, VSOXSEG4EI64_V }, // 10191
  { PseudoVSOXSEG4EI64_V_M8_MF2, VSOXSEG4EI64_V }, // 10192
  { PseudoVSOXSEG4EI64_V_M8_MF2_MASK, VSOXSEG4EI64_V }, // 10193
  { PseudoVSOXSEG4EI64_V_M8_MF4, VSOXSEG4EI64_V }, // 10194
  { PseudoVSOXSEG4EI64_V_M8_MF4_MASK, VSOXSEG4EI64_V }, // 10195
  { PseudoVSOXSEG4EI64_V_M8_MF8, VSOXSEG4EI64_V }, // 10196
  { PseudoVSOXSEG4EI64_V_M8_MF8_MASK, VSOXSEG4EI64_V }, // 10197
  { PseudoVSOXSEG4EI8_V_M1_M1, VSOXSEG4EI8_V }, // 10198
  { PseudoVSOXSEG4EI8_V_M1_M1_MASK, VSOXSEG4EI8_V }, // 10199
  { PseudoVSOXSEG4EI8_V_M1_M2, VSOXSEG4EI8_V }, // 10200
  { PseudoVSOXSEG4EI8_V_M1_M2_MASK, VSOXSEG4EI8_V }, // 10201
  { PseudoVSOXSEG4EI8_V_M1_MF2, VSOXSEG4EI8_V }, // 10202
  { PseudoVSOXSEG4EI8_V_M1_MF2_MASK, VSOXSEG4EI8_V }, // 10203
  { PseudoVSOXSEG4EI8_V_M1_MF4, VSOXSEG4EI8_V }, // 10204
  { PseudoVSOXSEG4EI8_V_M1_MF4_MASK, VSOXSEG4EI8_V }, // 10205
  { PseudoVSOXSEG4EI8_V_M1_MF8, VSOXSEG4EI8_V }, // 10206
  { PseudoVSOXSEG4EI8_V_M1_MF8_MASK, VSOXSEG4EI8_V }, // 10207
  { PseudoVSOXSEG4EI8_V_M2_M1, VSOXSEG4EI8_V }, // 10208
  { PseudoVSOXSEG4EI8_V_M2_M1_MASK, VSOXSEG4EI8_V }, // 10209
  { PseudoVSOXSEG4EI8_V_M2_M2, VSOXSEG4EI8_V }, // 10210
  { PseudoVSOXSEG4EI8_V_M2_M2_MASK, VSOXSEG4EI8_V }, // 10211
  { PseudoVSOXSEG4EI8_V_M2_MF2, VSOXSEG4EI8_V }, // 10212
  { PseudoVSOXSEG4EI8_V_M2_MF2_MASK, VSOXSEG4EI8_V }, // 10213
  { PseudoVSOXSEG4EI8_V_M2_MF4, VSOXSEG4EI8_V }, // 10214
  { PseudoVSOXSEG4EI8_V_M2_MF4_MASK, VSOXSEG4EI8_V }, // 10215
  { PseudoVSOXSEG4EI8_V_M2_MF8, VSOXSEG4EI8_V }, // 10216
  { PseudoVSOXSEG4EI8_V_M2_MF8_MASK, VSOXSEG4EI8_V }, // 10217
  { PseudoVSOXSEG4EI8_V_M4_M1, VSOXSEG4EI8_V }, // 10218
  { PseudoVSOXSEG4EI8_V_M4_M1_MASK, VSOXSEG4EI8_V }, // 10219
  { PseudoVSOXSEG4EI8_V_M4_M2, VSOXSEG4EI8_V }, // 10220
  { PseudoVSOXSEG4EI8_V_M4_M2_MASK, VSOXSEG4EI8_V }, // 10221
  { PseudoVSOXSEG4EI8_V_M4_MF2, VSOXSEG4EI8_V }, // 10222
  { PseudoVSOXSEG4EI8_V_M4_MF2_MASK, VSOXSEG4EI8_V }, // 10223
  { PseudoVSOXSEG4EI8_V_M4_MF4, VSOXSEG4EI8_V }, // 10224
  { PseudoVSOXSEG4EI8_V_M4_MF4_MASK, VSOXSEG4EI8_V }, // 10225
  { PseudoVSOXSEG4EI8_V_M4_MF8, VSOXSEG4EI8_V }, // 10226
  { PseudoVSOXSEG4EI8_V_M4_MF8_MASK, VSOXSEG4EI8_V }, // 10227
  { PseudoVSOXSEG4EI8_V_M8_M1, VSOXSEG4EI8_V }, // 10228
  { PseudoVSOXSEG4EI8_V_M8_M1_MASK, VSOXSEG4EI8_V }, // 10229
  { PseudoVSOXSEG4EI8_V_M8_M2, VSOXSEG4EI8_V }, // 10230
  { PseudoVSOXSEG4EI8_V_M8_M2_MASK, VSOXSEG4EI8_V }, // 10231
  { PseudoVSOXSEG4EI8_V_M8_MF2, VSOXSEG4EI8_V }, // 10232
  { PseudoVSOXSEG4EI8_V_M8_MF2_MASK, VSOXSEG4EI8_V }, // 10233
  { PseudoVSOXSEG4EI8_V_M8_MF4, VSOXSEG4EI8_V }, // 10234
  { PseudoVSOXSEG4EI8_V_M8_MF4_MASK, VSOXSEG4EI8_V }, // 10235
  { PseudoVSOXSEG4EI8_V_M8_MF8, VSOXSEG4EI8_V }, // 10236
  { PseudoVSOXSEG4EI8_V_M8_MF8_MASK, VSOXSEG4EI8_V }, // 10237
  { PseudoVSOXSEG4EI8_V_MF2_M1, VSOXSEG4EI8_V }, // 10238
  { PseudoVSOXSEG4EI8_V_MF2_M1_MASK, VSOXSEG4EI8_V }, // 10239
  { PseudoVSOXSEG4EI8_V_MF2_M2, VSOXSEG4EI8_V }, // 10240
  { PseudoVSOXSEG4EI8_V_MF2_M2_MASK, VSOXSEG4EI8_V }, // 10241
  { PseudoVSOXSEG4EI8_V_MF2_MF2, VSOXSEG4EI8_V }, // 10242
  { PseudoVSOXSEG4EI8_V_MF2_MF2_MASK, VSOXSEG4EI8_V }, // 10243
  { PseudoVSOXSEG4EI8_V_MF2_MF4, VSOXSEG4EI8_V }, // 10244
  { PseudoVSOXSEG4EI8_V_MF2_MF4_MASK, VSOXSEG4EI8_V }, // 10245
  { PseudoVSOXSEG4EI8_V_MF2_MF8, VSOXSEG4EI8_V }, // 10246
  { PseudoVSOXSEG4EI8_V_MF2_MF8_MASK, VSOXSEG4EI8_V }, // 10247
  { PseudoVSOXSEG4EI8_V_MF4_M1, VSOXSEG4EI8_V }, // 10248
  { PseudoVSOXSEG4EI8_V_MF4_M1_MASK, VSOXSEG4EI8_V }, // 10249
  { PseudoVSOXSEG4EI8_V_MF4_M2, VSOXSEG4EI8_V }, // 10250
  { PseudoVSOXSEG4EI8_V_MF4_M2_MASK, VSOXSEG4EI8_V }, // 10251
  { PseudoVSOXSEG4EI8_V_MF4_MF2, VSOXSEG4EI8_V }, // 10252
  { PseudoVSOXSEG4EI8_V_MF4_MF2_MASK, VSOXSEG4EI8_V }, // 10253
  { PseudoVSOXSEG4EI8_V_MF4_MF4, VSOXSEG4EI8_V }, // 10254
  { PseudoVSOXSEG4EI8_V_MF4_MF4_MASK, VSOXSEG4EI8_V }, // 10255
  { PseudoVSOXSEG4EI8_V_MF4_MF8, VSOXSEG4EI8_V }, // 10256
  { PseudoVSOXSEG4EI8_V_MF4_MF8_MASK, VSOXSEG4EI8_V }, // 10257
  { PseudoVSOXSEG4EI8_V_MF8_M1, VSOXSEG4EI8_V }, // 10258
  { PseudoVSOXSEG4EI8_V_MF8_M1_MASK, VSOXSEG4EI8_V }, // 10259
  { PseudoVSOXSEG4EI8_V_MF8_M2, VSOXSEG4EI8_V }, // 10260
  { PseudoVSOXSEG4EI8_V_MF8_M2_MASK, VSOXSEG4EI8_V }, // 10261
  { PseudoVSOXSEG4EI8_V_MF8_MF2, VSOXSEG4EI8_V }, // 10262
  { PseudoVSOXSEG4EI8_V_MF8_MF2_MASK, VSOXSEG4EI8_V }, // 10263
  { PseudoVSOXSEG4EI8_V_MF8_MF4, VSOXSEG4EI8_V }, // 10264
  { PseudoVSOXSEG4EI8_V_MF8_MF4_MASK, VSOXSEG4EI8_V }, // 10265
  { PseudoVSOXSEG4EI8_V_MF8_MF8, VSOXSEG4EI8_V }, // 10266
  { PseudoVSOXSEG4EI8_V_MF8_MF8_MASK, VSOXSEG4EI8_V }, // 10267
  { PseudoVSOXSEG5EI16_V_M1_M1, VSOXSEG5EI16_V }, // 10268
  { PseudoVSOXSEG5EI16_V_M1_M1_MASK, VSOXSEG5EI16_V }, // 10269
  { PseudoVSOXSEG5EI16_V_M1_MF2, VSOXSEG5EI16_V }, // 10270
  { PseudoVSOXSEG5EI16_V_M1_MF2_MASK, VSOXSEG5EI16_V }, // 10271
  { PseudoVSOXSEG5EI16_V_M1_MF4, VSOXSEG5EI16_V }, // 10272
  { PseudoVSOXSEG5EI16_V_M1_MF4_MASK, VSOXSEG5EI16_V }, // 10273
  { PseudoVSOXSEG5EI16_V_M1_MF8, VSOXSEG5EI16_V }, // 10274
  { PseudoVSOXSEG5EI16_V_M1_MF8_MASK, VSOXSEG5EI16_V }, // 10275
  { PseudoVSOXSEG5EI16_V_M2_M1, VSOXSEG5EI16_V }, // 10276
  { PseudoVSOXSEG5EI16_V_M2_M1_MASK, VSOXSEG5EI16_V }, // 10277
  { PseudoVSOXSEG5EI16_V_M2_MF2, VSOXSEG5EI16_V }, // 10278
  { PseudoVSOXSEG5EI16_V_M2_MF2_MASK, VSOXSEG5EI16_V }, // 10279
  { PseudoVSOXSEG5EI16_V_M2_MF4, VSOXSEG5EI16_V }, // 10280
  { PseudoVSOXSEG5EI16_V_M2_MF4_MASK, VSOXSEG5EI16_V }, // 10281
  { PseudoVSOXSEG5EI16_V_M2_MF8, VSOXSEG5EI16_V }, // 10282
  { PseudoVSOXSEG5EI16_V_M2_MF8_MASK, VSOXSEG5EI16_V }, // 10283
  { PseudoVSOXSEG5EI16_V_M4_M1, VSOXSEG5EI16_V }, // 10284
  { PseudoVSOXSEG5EI16_V_M4_M1_MASK, VSOXSEG5EI16_V }, // 10285
  { PseudoVSOXSEG5EI16_V_M4_MF2, VSOXSEG5EI16_V }, // 10286
  { PseudoVSOXSEG5EI16_V_M4_MF2_MASK, VSOXSEG5EI16_V }, // 10287
  { PseudoVSOXSEG5EI16_V_M4_MF4, VSOXSEG5EI16_V }, // 10288
  { PseudoVSOXSEG5EI16_V_M4_MF4_MASK, VSOXSEG5EI16_V }, // 10289
  { PseudoVSOXSEG5EI16_V_M4_MF8, VSOXSEG5EI16_V }, // 10290
  { PseudoVSOXSEG5EI16_V_M4_MF8_MASK, VSOXSEG5EI16_V }, // 10291
  { PseudoVSOXSEG5EI16_V_M8_M1, VSOXSEG5EI16_V }, // 10292
  { PseudoVSOXSEG5EI16_V_M8_M1_MASK, VSOXSEG5EI16_V }, // 10293
  { PseudoVSOXSEG5EI16_V_M8_MF2, VSOXSEG5EI16_V }, // 10294
  { PseudoVSOXSEG5EI16_V_M8_MF2_MASK, VSOXSEG5EI16_V }, // 10295
  { PseudoVSOXSEG5EI16_V_M8_MF4, VSOXSEG5EI16_V }, // 10296
  { PseudoVSOXSEG5EI16_V_M8_MF4_MASK, VSOXSEG5EI16_V }, // 10297
  { PseudoVSOXSEG5EI16_V_M8_MF8, VSOXSEG5EI16_V }, // 10298
  { PseudoVSOXSEG5EI16_V_M8_MF8_MASK, VSOXSEG5EI16_V }, // 10299
  { PseudoVSOXSEG5EI16_V_MF2_M1, VSOXSEG5EI16_V }, // 10300
  { PseudoVSOXSEG5EI16_V_MF2_M1_MASK, VSOXSEG5EI16_V }, // 10301
  { PseudoVSOXSEG5EI16_V_MF2_MF2, VSOXSEG5EI16_V }, // 10302
  { PseudoVSOXSEG5EI16_V_MF2_MF2_MASK, VSOXSEG5EI16_V }, // 10303
  { PseudoVSOXSEG5EI16_V_MF2_MF4, VSOXSEG5EI16_V }, // 10304
  { PseudoVSOXSEG5EI16_V_MF2_MF4_MASK, VSOXSEG5EI16_V }, // 10305
  { PseudoVSOXSEG5EI16_V_MF2_MF8, VSOXSEG5EI16_V }, // 10306
  { PseudoVSOXSEG5EI16_V_MF2_MF8_MASK, VSOXSEG5EI16_V }, // 10307
  { PseudoVSOXSEG5EI16_V_MF4_M1, VSOXSEG5EI16_V }, // 10308
  { PseudoVSOXSEG5EI16_V_MF4_M1_MASK, VSOXSEG5EI16_V }, // 10309
  { PseudoVSOXSEG5EI16_V_MF4_MF2, VSOXSEG5EI16_V }, // 10310
  { PseudoVSOXSEG5EI16_V_MF4_MF2_MASK, VSOXSEG5EI16_V }, // 10311
  { PseudoVSOXSEG5EI16_V_MF4_MF4, VSOXSEG5EI16_V }, // 10312
  { PseudoVSOXSEG5EI16_V_MF4_MF4_MASK, VSOXSEG5EI16_V }, // 10313
  { PseudoVSOXSEG5EI16_V_MF4_MF8, VSOXSEG5EI16_V }, // 10314
  { PseudoVSOXSEG5EI16_V_MF4_MF8_MASK, VSOXSEG5EI16_V }, // 10315
  { PseudoVSOXSEG5EI32_V_M1_M1, VSOXSEG5EI32_V }, // 10316
  { PseudoVSOXSEG5EI32_V_M1_M1_MASK, VSOXSEG5EI32_V }, // 10317
  { PseudoVSOXSEG5EI32_V_M1_MF2, VSOXSEG5EI32_V }, // 10318
  { PseudoVSOXSEG5EI32_V_M1_MF2_MASK, VSOXSEG5EI32_V }, // 10319
  { PseudoVSOXSEG5EI32_V_M1_MF4, VSOXSEG5EI32_V }, // 10320
  { PseudoVSOXSEG5EI32_V_M1_MF4_MASK, VSOXSEG5EI32_V }, // 10321
  { PseudoVSOXSEG5EI32_V_M1_MF8, VSOXSEG5EI32_V }, // 10322
  { PseudoVSOXSEG5EI32_V_M1_MF8_MASK, VSOXSEG5EI32_V }, // 10323
  { PseudoVSOXSEG5EI32_V_M2_M1, VSOXSEG5EI32_V }, // 10324
  { PseudoVSOXSEG5EI32_V_M2_M1_MASK, VSOXSEG5EI32_V }, // 10325
  { PseudoVSOXSEG5EI32_V_M2_MF2, VSOXSEG5EI32_V }, // 10326
  { PseudoVSOXSEG5EI32_V_M2_MF2_MASK, VSOXSEG5EI32_V }, // 10327
  { PseudoVSOXSEG5EI32_V_M2_MF4, VSOXSEG5EI32_V }, // 10328
  { PseudoVSOXSEG5EI32_V_M2_MF4_MASK, VSOXSEG5EI32_V }, // 10329
  { PseudoVSOXSEG5EI32_V_M2_MF8, VSOXSEG5EI32_V }, // 10330
  { PseudoVSOXSEG5EI32_V_M2_MF8_MASK, VSOXSEG5EI32_V }, // 10331
  { PseudoVSOXSEG5EI32_V_M4_M1, VSOXSEG5EI32_V }, // 10332
  { PseudoVSOXSEG5EI32_V_M4_M1_MASK, VSOXSEG5EI32_V }, // 10333
  { PseudoVSOXSEG5EI32_V_M4_MF2, VSOXSEG5EI32_V }, // 10334
  { PseudoVSOXSEG5EI32_V_M4_MF2_MASK, VSOXSEG5EI32_V }, // 10335
  { PseudoVSOXSEG5EI32_V_M4_MF4, VSOXSEG5EI32_V }, // 10336
  { PseudoVSOXSEG5EI32_V_M4_MF4_MASK, VSOXSEG5EI32_V }, // 10337
  { PseudoVSOXSEG5EI32_V_M4_MF8, VSOXSEG5EI32_V }, // 10338
  { PseudoVSOXSEG5EI32_V_M4_MF8_MASK, VSOXSEG5EI32_V }, // 10339
  { PseudoVSOXSEG5EI32_V_M8_M1, VSOXSEG5EI32_V }, // 10340
  { PseudoVSOXSEG5EI32_V_M8_M1_MASK, VSOXSEG5EI32_V }, // 10341
  { PseudoVSOXSEG5EI32_V_M8_MF2, VSOXSEG5EI32_V }, // 10342
  { PseudoVSOXSEG5EI32_V_M8_MF2_MASK, VSOXSEG5EI32_V }, // 10343
  { PseudoVSOXSEG5EI32_V_M8_MF4, VSOXSEG5EI32_V }, // 10344
  { PseudoVSOXSEG5EI32_V_M8_MF4_MASK, VSOXSEG5EI32_V }, // 10345
  { PseudoVSOXSEG5EI32_V_M8_MF8, VSOXSEG5EI32_V }, // 10346
  { PseudoVSOXSEG5EI32_V_M8_MF8_MASK, VSOXSEG5EI32_V }, // 10347
  { PseudoVSOXSEG5EI32_V_MF2_M1, VSOXSEG5EI32_V }, // 10348
  { PseudoVSOXSEG5EI32_V_MF2_M1_MASK, VSOXSEG5EI32_V }, // 10349
  { PseudoVSOXSEG5EI32_V_MF2_MF2, VSOXSEG5EI32_V }, // 10350
  { PseudoVSOXSEG5EI32_V_MF2_MF2_MASK, VSOXSEG5EI32_V }, // 10351
  { PseudoVSOXSEG5EI32_V_MF2_MF4, VSOXSEG5EI32_V }, // 10352
  { PseudoVSOXSEG5EI32_V_MF2_MF4_MASK, VSOXSEG5EI32_V }, // 10353
  { PseudoVSOXSEG5EI32_V_MF2_MF8, VSOXSEG5EI32_V }, // 10354
  { PseudoVSOXSEG5EI32_V_MF2_MF8_MASK, VSOXSEG5EI32_V }, // 10355
  { PseudoVSOXSEG5EI64_V_M1_M1, VSOXSEG5EI64_V }, // 10356
  { PseudoVSOXSEG5EI64_V_M1_M1_MASK, VSOXSEG5EI64_V }, // 10357
  { PseudoVSOXSEG5EI64_V_M1_MF2, VSOXSEG5EI64_V }, // 10358
  { PseudoVSOXSEG5EI64_V_M1_MF2_MASK, VSOXSEG5EI64_V }, // 10359
  { PseudoVSOXSEG5EI64_V_M1_MF4, VSOXSEG5EI64_V }, // 10360
  { PseudoVSOXSEG5EI64_V_M1_MF4_MASK, VSOXSEG5EI64_V }, // 10361
  { PseudoVSOXSEG5EI64_V_M1_MF8, VSOXSEG5EI64_V }, // 10362
  { PseudoVSOXSEG5EI64_V_M1_MF8_MASK, VSOXSEG5EI64_V }, // 10363
  { PseudoVSOXSEG5EI64_V_M2_M1, VSOXSEG5EI64_V }, // 10364
  { PseudoVSOXSEG5EI64_V_M2_M1_MASK, VSOXSEG5EI64_V }, // 10365
  { PseudoVSOXSEG5EI64_V_M2_MF2, VSOXSEG5EI64_V }, // 10366
  { PseudoVSOXSEG5EI64_V_M2_MF2_MASK, VSOXSEG5EI64_V }, // 10367
  { PseudoVSOXSEG5EI64_V_M2_MF4, VSOXSEG5EI64_V }, // 10368
  { PseudoVSOXSEG5EI64_V_M2_MF4_MASK, VSOXSEG5EI64_V }, // 10369
  { PseudoVSOXSEG5EI64_V_M2_MF8, VSOXSEG5EI64_V }, // 10370
  { PseudoVSOXSEG5EI64_V_M2_MF8_MASK, VSOXSEG5EI64_V }, // 10371
  { PseudoVSOXSEG5EI64_V_M4_M1, VSOXSEG5EI64_V }, // 10372
  { PseudoVSOXSEG5EI64_V_M4_M1_MASK, VSOXSEG5EI64_V }, // 10373
  { PseudoVSOXSEG5EI64_V_M4_MF2, VSOXSEG5EI64_V }, // 10374
  { PseudoVSOXSEG5EI64_V_M4_MF2_MASK, VSOXSEG5EI64_V }, // 10375
  { PseudoVSOXSEG5EI64_V_M4_MF4, VSOXSEG5EI64_V }, // 10376
  { PseudoVSOXSEG5EI64_V_M4_MF4_MASK, VSOXSEG5EI64_V }, // 10377
  { PseudoVSOXSEG5EI64_V_M4_MF8, VSOXSEG5EI64_V }, // 10378
  { PseudoVSOXSEG5EI64_V_M4_MF8_MASK, VSOXSEG5EI64_V }, // 10379
  { PseudoVSOXSEG5EI64_V_M8_M1, VSOXSEG5EI64_V }, // 10380
  { PseudoVSOXSEG5EI64_V_M8_M1_MASK, VSOXSEG5EI64_V }, // 10381
  { PseudoVSOXSEG5EI64_V_M8_MF2, VSOXSEG5EI64_V }, // 10382
  { PseudoVSOXSEG5EI64_V_M8_MF2_MASK, VSOXSEG5EI64_V }, // 10383
  { PseudoVSOXSEG5EI64_V_M8_MF4, VSOXSEG5EI64_V }, // 10384
  { PseudoVSOXSEG5EI64_V_M8_MF4_MASK, VSOXSEG5EI64_V }, // 10385
  { PseudoVSOXSEG5EI64_V_M8_MF8, VSOXSEG5EI64_V }, // 10386
  { PseudoVSOXSEG5EI64_V_M8_MF8_MASK, VSOXSEG5EI64_V }, // 10387
  { PseudoVSOXSEG5EI8_V_M1_M1, VSOXSEG5EI8_V }, // 10388
  { PseudoVSOXSEG5EI8_V_M1_M1_MASK, VSOXSEG5EI8_V }, // 10389
  { PseudoVSOXSEG5EI8_V_M1_MF2, VSOXSEG5EI8_V }, // 10390
  { PseudoVSOXSEG5EI8_V_M1_MF2_MASK, VSOXSEG5EI8_V }, // 10391
  { PseudoVSOXSEG5EI8_V_M1_MF4, VSOXSEG5EI8_V }, // 10392
  { PseudoVSOXSEG5EI8_V_M1_MF4_MASK, VSOXSEG5EI8_V }, // 10393
  { PseudoVSOXSEG5EI8_V_M1_MF8, VSOXSEG5EI8_V }, // 10394
  { PseudoVSOXSEG5EI8_V_M1_MF8_MASK, VSOXSEG5EI8_V }, // 10395
  { PseudoVSOXSEG5EI8_V_M2_M1, VSOXSEG5EI8_V }, // 10396
  { PseudoVSOXSEG5EI8_V_M2_M1_MASK, VSOXSEG5EI8_V }, // 10397
  { PseudoVSOXSEG5EI8_V_M2_MF2, VSOXSEG5EI8_V }, // 10398
  { PseudoVSOXSEG5EI8_V_M2_MF2_MASK, VSOXSEG5EI8_V }, // 10399
  { PseudoVSOXSEG5EI8_V_M2_MF4, VSOXSEG5EI8_V }, // 10400
  { PseudoVSOXSEG5EI8_V_M2_MF4_MASK, VSOXSEG5EI8_V }, // 10401
  { PseudoVSOXSEG5EI8_V_M2_MF8, VSOXSEG5EI8_V }, // 10402
  { PseudoVSOXSEG5EI8_V_M2_MF8_MASK, VSOXSEG5EI8_V }, // 10403
  { PseudoVSOXSEG5EI8_V_M4_M1, VSOXSEG5EI8_V }, // 10404
  { PseudoVSOXSEG5EI8_V_M4_M1_MASK, VSOXSEG5EI8_V }, // 10405
  { PseudoVSOXSEG5EI8_V_M4_MF2, VSOXSEG5EI8_V }, // 10406
  { PseudoVSOXSEG5EI8_V_M4_MF2_MASK, VSOXSEG5EI8_V }, // 10407
  { PseudoVSOXSEG5EI8_V_M4_MF4, VSOXSEG5EI8_V }, // 10408
  { PseudoVSOXSEG5EI8_V_M4_MF4_MASK, VSOXSEG5EI8_V }, // 10409
  { PseudoVSOXSEG5EI8_V_M4_MF8, VSOXSEG5EI8_V }, // 10410
  { PseudoVSOXSEG5EI8_V_M4_MF8_MASK, VSOXSEG5EI8_V }, // 10411
  { PseudoVSOXSEG5EI8_V_M8_M1, VSOXSEG5EI8_V }, // 10412
  { PseudoVSOXSEG5EI8_V_M8_M1_MASK, VSOXSEG5EI8_V }, // 10413
  { PseudoVSOXSEG5EI8_V_M8_MF2, VSOXSEG5EI8_V }, // 10414
  { PseudoVSOXSEG5EI8_V_M8_MF2_MASK, VSOXSEG5EI8_V }, // 10415
  { PseudoVSOXSEG5EI8_V_M8_MF4, VSOXSEG5EI8_V }, // 10416
  { PseudoVSOXSEG5EI8_V_M8_MF4_MASK, VSOXSEG5EI8_V }, // 10417
  { PseudoVSOXSEG5EI8_V_M8_MF8, VSOXSEG5EI8_V }, // 10418
  { PseudoVSOXSEG5EI8_V_M8_MF8_MASK, VSOXSEG5EI8_V }, // 10419
  { PseudoVSOXSEG5EI8_V_MF2_M1, VSOXSEG5EI8_V }, // 10420
  { PseudoVSOXSEG5EI8_V_MF2_M1_MASK, VSOXSEG5EI8_V }, // 10421
  { PseudoVSOXSEG5EI8_V_MF2_MF2, VSOXSEG5EI8_V }, // 10422
  { PseudoVSOXSEG5EI8_V_MF2_MF2_MASK, VSOXSEG5EI8_V }, // 10423
  { PseudoVSOXSEG5EI8_V_MF2_MF4, VSOXSEG5EI8_V }, // 10424
  { PseudoVSOXSEG5EI8_V_MF2_MF4_MASK, VSOXSEG5EI8_V }, // 10425
  { PseudoVSOXSEG5EI8_V_MF2_MF8, VSOXSEG5EI8_V }, // 10426
  { PseudoVSOXSEG5EI8_V_MF2_MF8_MASK, VSOXSEG5EI8_V }, // 10427
  { PseudoVSOXSEG5EI8_V_MF4_M1, VSOXSEG5EI8_V }, // 10428
  { PseudoVSOXSEG5EI8_V_MF4_M1_MASK, VSOXSEG5EI8_V }, // 10429
  { PseudoVSOXSEG5EI8_V_MF4_MF2, VSOXSEG5EI8_V }, // 10430
  { PseudoVSOXSEG5EI8_V_MF4_MF2_MASK, VSOXSEG5EI8_V }, // 10431
  { PseudoVSOXSEG5EI8_V_MF4_MF4, VSOXSEG5EI8_V }, // 10432
  { PseudoVSOXSEG5EI8_V_MF4_MF4_MASK, VSOXSEG5EI8_V }, // 10433
  { PseudoVSOXSEG5EI8_V_MF4_MF8, VSOXSEG5EI8_V }, // 10434
  { PseudoVSOXSEG5EI8_V_MF4_MF8_MASK, VSOXSEG5EI8_V }, // 10435
  { PseudoVSOXSEG5EI8_V_MF8_M1, VSOXSEG5EI8_V }, // 10436
  { PseudoVSOXSEG5EI8_V_MF8_M1_MASK, VSOXSEG5EI8_V }, // 10437
  { PseudoVSOXSEG5EI8_V_MF8_MF2, VSOXSEG5EI8_V }, // 10438
  { PseudoVSOXSEG5EI8_V_MF8_MF2_MASK, VSOXSEG5EI8_V }, // 10439
  { PseudoVSOXSEG5EI8_V_MF8_MF4, VSOXSEG5EI8_V }, // 10440
  { PseudoVSOXSEG5EI8_V_MF8_MF4_MASK, VSOXSEG5EI8_V }, // 10441
  { PseudoVSOXSEG5EI8_V_MF8_MF8, VSOXSEG5EI8_V }, // 10442
  { PseudoVSOXSEG5EI8_V_MF8_MF8_MASK, VSOXSEG5EI8_V }, // 10443
  { PseudoVSOXSEG6EI16_V_M1_M1, VSOXSEG6EI16_V }, // 10444
  { PseudoVSOXSEG6EI16_V_M1_M1_MASK, VSOXSEG6EI16_V }, // 10445
  { PseudoVSOXSEG6EI16_V_M1_MF2, VSOXSEG6EI16_V }, // 10446
  { PseudoVSOXSEG6EI16_V_M1_MF2_MASK, VSOXSEG6EI16_V }, // 10447
  { PseudoVSOXSEG6EI16_V_M1_MF4, VSOXSEG6EI16_V }, // 10448
  { PseudoVSOXSEG6EI16_V_M1_MF4_MASK, VSOXSEG6EI16_V }, // 10449
  { PseudoVSOXSEG6EI16_V_M1_MF8, VSOXSEG6EI16_V }, // 10450
  { PseudoVSOXSEG6EI16_V_M1_MF8_MASK, VSOXSEG6EI16_V }, // 10451
  { PseudoVSOXSEG6EI16_V_M2_M1, VSOXSEG6EI16_V }, // 10452
  { PseudoVSOXSEG6EI16_V_M2_M1_MASK, VSOXSEG6EI16_V }, // 10453
  { PseudoVSOXSEG6EI16_V_M2_MF2, VSOXSEG6EI16_V }, // 10454
  { PseudoVSOXSEG6EI16_V_M2_MF2_MASK, VSOXSEG6EI16_V }, // 10455
  { PseudoVSOXSEG6EI16_V_M2_MF4, VSOXSEG6EI16_V }, // 10456
  { PseudoVSOXSEG6EI16_V_M2_MF4_MASK, VSOXSEG6EI16_V }, // 10457
  { PseudoVSOXSEG6EI16_V_M2_MF8, VSOXSEG6EI16_V }, // 10458
  { PseudoVSOXSEG6EI16_V_M2_MF8_MASK, VSOXSEG6EI16_V }, // 10459
  { PseudoVSOXSEG6EI16_V_M4_M1, VSOXSEG6EI16_V }, // 10460
  { PseudoVSOXSEG6EI16_V_M4_M1_MASK, VSOXSEG6EI16_V }, // 10461
  { PseudoVSOXSEG6EI16_V_M4_MF2, VSOXSEG6EI16_V }, // 10462
  { PseudoVSOXSEG6EI16_V_M4_MF2_MASK, VSOXSEG6EI16_V }, // 10463
  { PseudoVSOXSEG6EI16_V_M4_MF4, VSOXSEG6EI16_V }, // 10464
  { PseudoVSOXSEG6EI16_V_M4_MF4_MASK, VSOXSEG6EI16_V }, // 10465
  { PseudoVSOXSEG6EI16_V_M4_MF8, VSOXSEG6EI16_V }, // 10466
  { PseudoVSOXSEG6EI16_V_M4_MF8_MASK, VSOXSEG6EI16_V }, // 10467
  { PseudoVSOXSEG6EI16_V_M8_M1, VSOXSEG6EI16_V }, // 10468
  { PseudoVSOXSEG6EI16_V_M8_M1_MASK, VSOXSEG6EI16_V }, // 10469
  { PseudoVSOXSEG6EI16_V_M8_MF2, VSOXSEG6EI16_V }, // 10470
  { PseudoVSOXSEG6EI16_V_M8_MF2_MASK, VSOXSEG6EI16_V }, // 10471
  { PseudoVSOXSEG6EI16_V_M8_MF4, VSOXSEG6EI16_V }, // 10472
  { PseudoVSOXSEG6EI16_V_M8_MF4_MASK, VSOXSEG6EI16_V }, // 10473
  { PseudoVSOXSEG6EI16_V_M8_MF8, VSOXSEG6EI16_V }, // 10474
  { PseudoVSOXSEG6EI16_V_M8_MF8_MASK, VSOXSEG6EI16_V }, // 10475
  { PseudoVSOXSEG6EI16_V_MF2_M1, VSOXSEG6EI16_V }, // 10476
  { PseudoVSOXSEG6EI16_V_MF2_M1_MASK, VSOXSEG6EI16_V }, // 10477
  { PseudoVSOXSEG6EI16_V_MF2_MF2, VSOXSEG6EI16_V }, // 10478
  { PseudoVSOXSEG6EI16_V_MF2_MF2_MASK, VSOXSEG6EI16_V }, // 10479
  { PseudoVSOXSEG6EI16_V_MF2_MF4, VSOXSEG6EI16_V }, // 10480
  { PseudoVSOXSEG6EI16_V_MF2_MF4_MASK, VSOXSEG6EI16_V }, // 10481
  { PseudoVSOXSEG6EI16_V_MF2_MF8, VSOXSEG6EI16_V }, // 10482
  { PseudoVSOXSEG6EI16_V_MF2_MF8_MASK, VSOXSEG6EI16_V }, // 10483
  { PseudoVSOXSEG6EI16_V_MF4_M1, VSOXSEG6EI16_V }, // 10484
  { PseudoVSOXSEG6EI16_V_MF4_M1_MASK, VSOXSEG6EI16_V }, // 10485
  { PseudoVSOXSEG6EI16_V_MF4_MF2, VSOXSEG6EI16_V }, // 10486
  { PseudoVSOXSEG6EI16_V_MF4_MF2_MASK, VSOXSEG6EI16_V }, // 10487
  { PseudoVSOXSEG6EI16_V_MF4_MF4, VSOXSEG6EI16_V }, // 10488
  { PseudoVSOXSEG6EI16_V_MF4_MF4_MASK, VSOXSEG6EI16_V }, // 10489
  { PseudoVSOXSEG6EI16_V_MF4_MF8, VSOXSEG6EI16_V }, // 10490
  { PseudoVSOXSEG6EI16_V_MF4_MF8_MASK, VSOXSEG6EI16_V }, // 10491
  { PseudoVSOXSEG6EI32_V_M1_M1, VSOXSEG6EI32_V }, // 10492
  { PseudoVSOXSEG6EI32_V_M1_M1_MASK, VSOXSEG6EI32_V }, // 10493
  { PseudoVSOXSEG6EI32_V_M1_MF2, VSOXSEG6EI32_V }, // 10494
  { PseudoVSOXSEG6EI32_V_M1_MF2_MASK, VSOXSEG6EI32_V }, // 10495
  { PseudoVSOXSEG6EI32_V_M1_MF4, VSOXSEG6EI32_V }, // 10496
  { PseudoVSOXSEG6EI32_V_M1_MF4_MASK, VSOXSEG6EI32_V }, // 10497
  { PseudoVSOXSEG6EI32_V_M1_MF8, VSOXSEG6EI32_V }, // 10498
  { PseudoVSOXSEG6EI32_V_M1_MF8_MASK, VSOXSEG6EI32_V }, // 10499
  { PseudoVSOXSEG6EI32_V_M2_M1, VSOXSEG6EI32_V }, // 10500
  { PseudoVSOXSEG6EI32_V_M2_M1_MASK, VSOXSEG6EI32_V }, // 10501
  { PseudoVSOXSEG6EI32_V_M2_MF2, VSOXSEG6EI32_V }, // 10502
  { PseudoVSOXSEG6EI32_V_M2_MF2_MASK, VSOXSEG6EI32_V }, // 10503
  { PseudoVSOXSEG6EI32_V_M2_MF4, VSOXSEG6EI32_V }, // 10504
  { PseudoVSOXSEG6EI32_V_M2_MF4_MASK, VSOXSEG6EI32_V }, // 10505
  { PseudoVSOXSEG6EI32_V_M2_MF8, VSOXSEG6EI32_V }, // 10506
  { PseudoVSOXSEG6EI32_V_M2_MF8_MASK, VSOXSEG6EI32_V }, // 10507
  { PseudoVSOXSEG6EI32_V_M4_M1, VSOXSEG6EI32_V }, // 10508
  { PseudoVSOXSEG6EI32_V_M4_M1_MASK, VSOXSEG6EI32_V }, // 10509
  { PseudoVSOXSEG6EI32_V_M4_MF2, VSOXSEG6EI32_V }, // 10510
  { PseudoVSOXSEG6EI32_V_M4_MF2_MASK, VSOXSEG6EI32_V }, // 10511
  { PseudoVSOXSEG6EI32_V_M4_MF4, VSOXSEG6EI32_V }, // 10512
  { PseudoVSOXSEG6EI32_V_M4_MF4_MASK, VSOXSEG6EI32_V }, // 10513
  { PseudoVSOXSEG6EI32_V_M4_MF8, VSOXSEG6EI32_V }, // 10514
  { PseudoVSOXSEG6EI32_V_M4_MF8_MASK, VSOXSEG6EI32_V }, // 10515
  { PseudoVSOXSEG6EI32_V_M8_M1, VSOXSEG6EI32_V }, // 10516
  { PseudoVSOXSEG6EI32_V_M8_M1_MASK, VSOXSEG6EI32_V }, // 10517
  { PseudoVSOXSEG6EI32_V_M8_MF2, VSOXSEG6EI32_V }, // 10518
  { PseudoVSOXSEG6EI32_V_M8_MF2_MASK, VSOXSEG6EI32_V }, // 10519
  { PseudoVSOXSEG6EI32_V_M8_MF4, VSOXSEG6EI32_V }, // 10520
  { PseudoVSOXSEG6EI32_V_M8_MF4_MASK, VSOXSEG6EI32_V }, // 10521
  { PseudoVSOXSEG6EI32_V_M8_MF8, VSOXSEG6EI32_V }, // 10522
  { PseudoVSOXSEG6EI32_V_M8_MF8_MASK, VSOXSEG6EI32_V }, // 10523
  { PseudoVSOXSEG6EI32_V_MF2_M1, VSOXSEG6EI32_V }, // 10524
  { PseudoVSOXSEG6EI32_V_MF2_M1_MASK, VSOXSEG6EI32_V }, // 10525
  { PseudoVSOXSEG6EI32_V_MF2_MF2, VSOXSEG6EI32_V }, // 10526
  { PseudoVSOXSEG6EI32_V_MF2_MF2_MASK, VSOXSEG6EI32_V }, // 10527
  { PseudoVSOXSEG6EI32_V_MF2_MF4, VSOXSEG6EI32_V }, // 10528
  { PseudoVSOXSEG6EI32_V_MF2_MF4_MASK, VSOXSEG6EI32_V }, // 10529
  { PseudoVSOXSEG6EI32_V_MF2_MF8, VSOXSEG6EI32_V }, // 10530
  { PseudoVSOXSEG6EI32_V_MF2_MF8_MASK, VSOXSEG6EI32_V }, // 10531
  { PseudoVSOXSEG6EI64_V_M1_M1, VSOXSEG6EI64_V }, // 10532
  { PseudoVSOXSEG6EI64_V_M1_M1_MASK, VSOXSEG6EI64_V }, // 10533
  { PseudoVSOXSEG6EI64_V_M1_MF2, VSOXSEG6EI64_V }, // 10534
  { PseudoVSOXSEG6EI64_V_M1_MF2_MASK, VSOXSEG6EI64_V }, // 10535
  { PseudoVSOXSEG6EI64_V_M1_MF4, VSOXSEG6EI64_V }, // 10536
  { PseudoVSOXSEG6EI64_V_M1_MF4_MASK, VSOXSEG6EI64_V }, // 10537
  { PseudoVSOXSEG6EI64_V_M1_MF8, VSOXSEG6EI64_V }, // 10538
  { PseudoVSOXSEG6EI64_V_M1_MF8_MASK, VSOXSEG6EI64_V }, // 10539
  { PseudoVSOXSEG6EI64_V_M2_M1, VSOXSEG6EI64_V }, // 10540
  { PseudoVSOXSEG6EI64_V_M2_M1_MASK, VSOXSEG6EI64_V }, // 10541
  { PseudoVSOXSEG6EI64_V_M2_MF2, VSOXSEG6EI64_V }, // 10542
  { PseudoVSOXSEG6EI64_V_M2_MF2_MASK, VSOXSEG6EI64_V }, // 10543
  { PseudoVSOXSEG6EI64_V_M2_MF4, VSOXSEG6EI64_V }, // 10544
  { PseudoVSOXSEG6EI64_V_M2_MF4_MASK, VSOXSEG6EI64_V }, // 10545
  { PseudoVSOXSEG6EI64_V_M2_MF8, VSOXSEG6EI64_V }, // 10546
  { PseudoVSOXSEG6EI64_V_M2_MF8_MASK, VSOXSEG6EI64_V }, // 10547
  { PseudoVSOXSEG6EI64_V_M4_M1, VSOXSEG6EI64_V }, // 10548
  { PseudoVSOXSEG6EI64_V_M4_M1_MASK, VSOXSEG6EI64_V }, // 10549
  { PseudoVSOXSEG6EI64_V_M4_MF2, VSOXSEG6EI64_V }, // 10550
  { PseudoVSOXSEG6EI64_V_M4_MF2_MASK, VSOXSEG6EI64_V }, // 10551
  { PseudoVSOXSEG6EI64_V_M4_MF4, VSOXSEG6EI64_V }, // 10552
  { PseudoVSOXSEG6EI64_V_M4_MF4_MASK, VSOXSEG6EI64_V }, // 10553
  { PseudoVSOXSEG6EI64_V_M4_MF8, VSOXSEG6EI64_V }, // 10554
  { PseudoVSOXSEG6EI64_V_M4_MF8_MASK, VSOXSEG6EI64_V }, // 10555
  { PseudoVSOXSEG6EI64_V_M8_M1, VSOXSEG6EI64_V }, // 10556
  { PseudoVSOXSEG6EI64_V_M8_M1_MASK, VSOXSEG6EI64_V }, // 10557
  { PseudoVSOXSEG6EI64_V_M8_MF2, VSOXSEG6EI64_V }, // 10558
  { PseudoVSOXSEG6EI64_V_M8_MF2_MASK, VSOXSEG6EI64_V }, // 10559
  { PseudoVSOXSEG6EI64_V_M8_MF4, VSOXSEG6EI64_V }, // 10560
  { PseudoVSOXSEG6EI64_V_M8_MF4_MASK, VSOXSEG6EI64_V }, // 10561
  { PseudoVSOXSEG6EI64_V_M8_MF8, VSOXSEG6EI64_V }, // 10562
  { PseudoVSOXSEG6EI64_V_M8_MF8_MASK, VSOXSEG6EI64_V }, // 10563
  { PseudoVSOXSEG6EI8_V_M1_M1, VSOXSEG6EI8_V }, // 10564
  { PseudoVSOXSEG6EI8_V_M1_M1_MASK, VSOXSEG6EI8_V }, // 10565
  { PseudoVSOXSEG6EI8_V_M1_MF2, VSOXSEG6EI8_V }, // 10566
  { PseudoVSOXSEG6EI8_V_M1_MF2_MASK, VSOXSEG6EI8_V }, // 10567
  { PseudoVSOXSEG6EI8_V_M1_MF4, VSOXSEG6EI8_V }, // 10568
  { PseudoVSOXSEG6EI8_V_M1_MF4_MASK, VSOXSEG6EI8_V }, // 10569
  { PseudoVSOXSEG6EI8_V_M1_MF8, VSOXSEG6EI8_V }, // 10570
  { PseudoVSOXSEG6EI8_V_M1_MF8_MASK, VSOXSEG6EI8_V }, // 10571
  { PseudoVSOXSEG6EI8_V_M2_M1, VSOXSEG6EI8_V }, // 10572
  { PseudoVSOXSEG6EI8_V_M2_M1_MASK, VSOXSEG6EI8_V }, // 10573
  { PseudoVSOXSEG6EI8_V_M2_MF2, VSOXSEG6EI8_V }, // 10574
  { PseudoVSOXSEG6EI8_V_M2_MF2_MASK, VSOXSEG6EI8_V }, // 10575
  { PseudoVSOXSEG6EI8_V_M2_MF4, VSOXSEG6EI8_V }, // 10576
  { PseudoVSOXSEG6EI8_V_M2_MF4_MASK, VSOXSEG6EI8_V }, // 10577
  { PseudoVSOXSEG6EI8_V_M2_MF8, VSOXSEG6EI8_V }, // 10578
  { PseudoVSOXSEG6EI8_V_M2_MF8_MASK, VSOXSEG6EI8_V }, // 10579
  { PseudoVSOXSEG6EI8_V_M4_M1, VSOXSEG6EI8_V }, // 10580
  { PseudoVSOXSEG6EI8_V_M4_M1_MASK, VSOXSEG6EI8_V }, // 10581
  { PseudoVSOXSEG6EI8_V_M4_MF2, VSOXSEG6EI8_V }, // 10582
  { PseudoVSOXSEG6EI8_V_M4_MF2_MASK, VSOXSEG6EI8_V }, // 10583
  { PseudoVSOXSEG6EI8_V_M4_MF4, VSOXSEG6EI8_V }, // 10584
  { PseudoVSOXSEG6EI8_V_M4_MF4_MASK, VSOXSEG6EI8_V }, // 10585
  { PseudoVSOXSEG6EI8_V_M4_MF8, VSOXSEG6EI8_V }, // 10586
  { PseudoVSOXSEG6EI8_V_M4_MF8_MASK, VSOXSEG6EI8_V }, // 10587
  { PseudoVSOXSEG6EI8_V_M8_M1, VSOXSEG6EI8_V }, // 10588
  { PseudoVSOXSEG6EI8_V_M8_M1_MASK, VSOXSEG6EI8_V }, // 10589
  { PseudoVSOXSEG6EI8_V_M8_MF2, VSOXSEG6EI8_V }, // 10590
  { PseudoVSOXSEG6EI8_V_M8_MF2_MASK, VSOXSEG6EI8_V }, // 10591
  { PseudoVSOXSEG6EI8_V_M8_MF4, VSOXSEG6EI8_V }, // 10592
  { PseudoVSOXSEG6EI8_V_M8_MF4_MASK, VSOXSEG6EI8_V }, // 10593
  { PseudoVSOXSEG6EI8_V_M8_MF8, VSOXSEG6EI8_V }, // 10594
  { PseudoVSOXSEG6EI8_V_M8_MF8_MASK, VSOXSEG6EI8_V }, // 10595
  { PseudoVSOXSEG6EI8_V_MF2_M1, VSOXSEG6EI8_V }, // 10596
  { PseudoVSOXSEG6EI8_V_MF2_M1_MASK, VSOXSEG6EI8_V }, // 10597
  { PseudoVSOXSEG6EI8_V_MF2_MF2, VSOXSEG6EI8_V }, // 10598
  { PseudoVSOXSEG6EI8_V_MF2_MF2_MASK, VSOXSEG6EI8_V }, // 10599
  { PseudoVSOXSEG6EI8_V_MF2_MF4, VSOXSEG6EI8_V }, // 10600
  { PseudoVSOXSEG6EI8_V_MF2_MF4_MASK, VSOXSEG6EI8_V }, // 10601
  { PseudoVSOXSEG6EI8_V_MF2_MF8, VSOXSEG6EI8_V }, // 10602
  { PseudoVSOXSEG6EI8_V_MF2_MF8_MASK, VSOXSEG6EI8_V }, // 10603
  { PseudoVSOXSEG6EI8_V_MF4_M1, VSOXSEG6EI8_V }, // 10604
  { PseudoVSOXSEG6EI8_V_MF4_M1_MASK, VSOXSEG6EI8_V }, // 10605
  { PseudoVSOXSEG6EI8_V_MF4_MF2, VSOXSEG6EI8_V }, // 10606
  { PseudoVSOXSEG6EI8_V_MF4_MF2_MASK, VSOXSEG6EI8_V }, // 10607
  { PseudoVSOXSEG6EI8_V_MF4_MF4, VSOXSEG6EI8_V }, // 10608
  { PseudoVSOXSEG6EI8_V_MF4_MF4_MASK, VSOXSEG6EI8_V }, // 10609
  { PseudoVSOXSEG6EI8_V_MF4_MF8, VSOXSEG6EI8_V }, // 10610
  { PseudoVSOXSEG6EI8_V_MF4_MF8_MASK, VSOXSEG6EI8_V }, // 10611
  { PseudoVSOXSEG6EI8_V_MF8_M1, VSOXSEG6EI8_V }, // 10612
  { PseudoVSOXSEG6EI8_V_MF8_M1_MASK, VSOXSEG6EI8_V }, // 10613
  { PseudoVSOXSEG6EI8_V_MF8_MF2, VSOXSEG6EI8_V }, // 10614
  { PseudoVSOXSEG6EI8_V_MF8_MF2_MASK, VSOXSEG6EI8_V }, // 10615
  { PseudoVSOXSEG6EI8_V_MF8_MF4, VSOXSEG6EI8_V }, // 10616
  { PseudoVSOXSEG6EI8_V_MF8_MF4_MASK, VSOXSEG6EI8_V }, // 10617
  { PseudoVSOXSEG6EI8_V_MF8_MF8, VSOXSEG6EI8_V }, // 10618
  { PseudoVSOXSEG6EI8_V_MF8_MF8_MASK, VSOXSEG6EI8_V }, // 10619
  { PseudoVSOXSEG7EI16_V_M1_M1, VSOXSEG7EI16_V }, // 10620
  { PseudoVSOXSEG7EI16_V_M1_M1_MASK, VSOXSEG7EI16_V }, // 10621
  { PseudoVSOXSEG7EI16_V_M1_MF2, VSOXSEG7EI16_V }, // 10622
  { PseudoVSOXSEG7EI16_V_M1_MF2_MASK, VSOXSEG7EI16_V }, // 10623
  { PseudoVSOXSEG7EI16_V_M1_MF4, VSOXSEG7EI16_V }, // 10624
  { PseudoVSOXSEG7EI16_V_M1_MF4_MASK, VSOXSEG7EI16_V }, // 10625
  { PseudoVSOXSEG7EI16_V_M1_MF8, VSOXSEG7EI16_V }, // 10626
  { PseudoVSOXSEG7EI16_V_M1_MF8_MASK, VSOXSEG7EI16_V }, // 10627
  { PseudoVSOXSEG7EI16_V_M2_M1, VSOXSEG7EI16_V }, // 10628
  { PseudoVSOXSEG7EI16_V_M2_M1_MASK, VSOXSEG7EI16_V }, // 10629
  { PseudoVSOXSEG7EI16_V_M2_MF2, VSOXSEG7EI16_V }, // 10630
  { PseudoVSOXSEG7EI16_V_M2_MF2_MASK, VSOXSEG7EI16_V }, // 10631
  { PseudoVSOXSEG7EI16_V_M2_MF4, VSOXSEG7EI16_V }, // 10632
  { PseudoVSOXSEG7EI16_V_M2_MF4_MASK, VSOXSEG7EI16_V }, // 10633
  { PseudoVSOXSEG7EI16_V_M2_MF8, VSOXSEG7EI16_V }, // 10634
  { PseudoVSOXSEG7EI16_V_M2_MF8_MASK, VSOXSEG7EI16_V }, // 10635
  { PseudoVSOXSEG7EI16_V_M4_M1, VSOXSEG7EI16_V }, // 10636
  { PseudoVSOXSEG7EI16_V_M4_M1_MASK, VSOXSEG7EI16_V }, // 10637
  { PseudoVSOXSEG7EI16_V_M4_MF2, VSOXSEG7EI16_V }, // 10638
  { PseudoVSOXSEG7EI16_V_M4_MF2_MASK, VSOXSEG7EI16_V }, // 10639
  { PseudoVSOXSEG7EI16_V_M4_MF4, VSOXSEG7EI16_V }, // 10640
  { PseudoVSOXSEG7EI16_V_M4_MF4_MASK, VSOXSEG7EI16_V }, // 10641
  { PseudoVSOXSEG7EI16_V_M4_MF8, VSOXSEG7EI16_V }, // 10642
  { PseudoVSOXSEG7EI16_V_M4_MF8_MASK, VSOXSEG7EI16_V }, // 10643
  { PseudoVSOXSEG7EI16_V_M8_M1, VSOXSEG7EI16_V }, // 10644
  { PseudoVSOXSEG7EI16_V_M8_M1_MASK, VSOXSEG7EI16_V }, // 10645
  { PseudoVSOXSEG7EI16_V_M8_MF2, VSOXSEG7EI16_V }, // 10646
  { PseudoVSOXSEG7EI16_V_M8_MF2_MASK, VSOXSEG7EI16_V }, // 10647
  { PseudoVSOXSEG7EI16_V_M8_MF4, VSOXSEG7EI16_V }, // 10648
  { PseudoVSOXSEG7EI16_V_M8_MF4_MASK, VSOXSEG7EI16_V }, // 10649
  { PseudoVSOXSEG7EI16_V_M8_MF8, VSOXSEG7EI16_V }, // 10650
  { PseudoVSOXSEG7EI16_V_M8_MF8_MASK, VSOXSEG7EI16_V }, // 10651
  { PseudoVSOXSEG7EI16_V_MF2_M1, VSOXSEG7EI16_V }, // 10652
  { PseudoVSOXSEG7EI16_V_MF2_M1_MASK, VSOXSEG7EI16_V }, // 10653
  { PseudoVSOXSEG7EI16_V_MF2_MF2, VSOXSEG7EI16_V }, // 10654
  { PseudoVSOXSEG7EI16_V_MF2_MF2_MASK, VSOXSEG7EI16_V }, // 10655
  { PseudoVSOXSEG7EI16_V_MF2_MF4, VSOXSEG7EI16_V }, // 10656
  { PseudoVSOXSEG7EI16_V_MF2_MF4_MASK, VSOXSEG7EI16_V }, // 10657
  { PseudoVSOXSEG7EI16_V_MF2_MF8, VSOXSEG7EI16_V }, // 10658
  { PseudoVSOXSEG7EI16_V_MF2_MF8_MASK, VSOXSEG7EI16_V }, // 10659
  { PseudoVSOXSEG7EI16_V_MF4_M1, VSOXSEG7EI16_V }, // 10660
  { PseudoVSOXSEG7EI16_V_MF4_M1_MASK, VSOXSEG7EI16_V }, // 10661
  { PseudoVSOXSEG7EI16_V_MF4_MF2, VSOXSEG7EI16_V }, // 10662
  { PseudoVSOXSEG7EI16_V_MF4_MF2_MASK, VSOXSEG7EI16_V }, // 10663
  { PseudoVSOXSEG7EI16_V_MF4_MF4, VSOXSEG7EI16_V }, // 10664
  { PseudoVSOXSEG7EI16_V_MF4_MF4_MASK, VSOXSEG7EI16_V }, // 10665
  { PseudoVSOXSEG7EI16_V_MF4_MF8, VSOXSEG7EI16_V }, // 10666
  { PseudoVSOXSEG7EI16_V_MF4_MF8_MASK, VSOXSEG7EI16_V }, // 10667
  { PseudoVSOXSEG7EI32_V_M1_M1, VSOXSEG7EI32_V }, // 10668
  { PseudoVSOXSEG7EI32_V_M1_M1_MASK, VSOXSEG7EI32_V }, // 10669
  { PseudoVSOXSEG7EI32_V_M1_MF2, VSOXSEG7EI32_V }, // 10670
  { PseudoVSOXSEG7EI32_V_M1_MF2_MASK, VSOXSEG7EI32_V }, // 10671
  { PseudoVSOXSEG7EI32_V_M1_MF4, VSOXSEG7EI32_V }, // 10672
  { PseudoVSOXSEG7EI32_V_M1_MF4_MASK, VSOXSEG7EI32_V }, // 10673
  { PseudoVSOXSEG7EI32_V_M1_MF8, VSOXSEG7EI32_V }, // 10674
  { PseudoVSOXSEG7EI32_V_M1_MF8_MASK, VSOXSEG7EI32_V }, // 10675
  { PseudoVSOXSEG7EI32_V_M2_M1, VSOXSEG7EI32_V }, // 10676
  { PseudoVSOXSEG7EI32_V_M2_M1_MASK, VSOXSEG7EI32_V }, // 10677
  { PseudoVSOXSEG7EI32_V_M2_MF2, VSOXSEG7EI32_V }, // 10678
  { PseudoVSOXSEG7EI32_V_M2_MF2_MASK, VSOXSEG7EI32_V }, // 10679
  { PseudoVSOXSEG7EI32_V_M2_MF4, VSOXSEG7EI32_V }, // 10680
  { PseudoVSOXSEG7EI32_V_M2_MF4_MASK, VSOXSEG7EI32_V }, // 10681
  { PseudoVSOXSEG7EI32_V_M2_MF8, VSOXSEG7EI32_V }, // 10682
  { PseudoVSOXSEG7EI32_V_M2_MF8_MASK, VSOXSEG7EI32_V }, // 10683
  { PseudoVSOXSEG7EI32_V_M4_M1, VSOXSEG7EI32_V }, // 10684
  { PseudoVSOXSEG7EI32_V_M4_M1_MASK, VSOXSEG7EI32_V }, // 10685
  { PseudoVSOXSEG7EI32_V_M4_MF2, VSOXSEG7EI32_V }, // 10686
  { PseudoVSOXSEG7EI32_V_M4_MF2_MASK, VSOXSEG7EI32_V }, // 10687
  { PseudoVSOXSEG7EI32_V_M4_MF4, VSOXSEG7EI32_V }, // 10688
  { PseudoVSOXSEG7EI32_V_M4_MF4_MASK, VSOXSEG7EI32_V }, // 10689
  { PseudoVSOXSEG7EI32_V_M4_MF8, VSOXSEG7EI32_V }, // 10690
  { PseudoVSOXSEG7EI32_V_M4_MF8_MASK, VSOXSEG7EI32_V }, // 10691
  { PseudoVSOXSEG7EI32_V_M8_M1, VSOXSEG7EI32_V }, // 10692
  { PseudoVSOXSEG7EI32_V_M8_M1_MASK, VSOXSEG7EI32_V }, // 10693
  { PseudoVSOXSEG7EI32_V_M8_MF2, VSOXSEG7EI32_V }, // 10694
  { PseudoVSOXSEG7EI32_V_M8_MF2_MASK, VSOXSEG7EI32_V }, // 10695
  { PseudoVSOXSEG7EI32_V_M8_MF4, VSOXSEG7EI32_V }, // 10696
  { PseudoVSOXSEG7EI32_V_M8_MF4_MASK, VSOXSEG7EI32_V }, // 10697
  { PseudoVSOXSEG7EI32_V_M8_MF8, VSOXSEG7EI32_V }, // 10698
  { PseudoVSOXSEG7EI32_V_M8_MF8_MASK, VSOXSEG7EI32_V }, // 10699
  { PseudoVSOXSEG7EI32_V_MF2_M1, VSOXSEG7EI32_V }, // 10700
  { PseudoVSOXSEG7EI32_V_MF2_M1_MASK, VSOXSEG7EI32_V }, // 10701
  { PseudoVSOXSEG7EI32_V_MF2_MF2, VSOXSEG7EI32_V }, // 10702
  { PseudoVSOXSEG7EI32_V_MF2_MF2_MASK, VSOXSEG7EI32_V }, // 10703
  { PseudoVSOXSEG7EI32_V_MF2_MF4, VSOXSEG7EI32_V }, // 10704
  { PseudoVSOXSEG7EI32_V_MF2_MF4_MASK, VSOXSEG7EI32_V }, // 10705
  { PseudoVSOXSEG7EI32_V_MF2_MF8, VSOXSEG7EI32_V }, // 10706
  { PseudoVSOXSEG7EI32_V_MF2_MF8_MASK, VSOXSEG7EI32_V }, // 10707
  { PseudoVSOXSEG7EI64_V_M1_M1, VSOXSEG7EI64_V }, // 10708
  { PseudoVSOXSEG7EI64_V_M1_M1_MASK, VSOXSEG7EI64_V }, // 10709
  { PseudoVSOXSEG7EI64_V_M1_MF2, VSOXSEG7EI64_V }, // 10710
  { PseudoVSOXSEG7EI64_V_M1_MF2_MASK, VSOXSEG7EI64_V }, // 10711
  { PseudoVSOXSEG7EI64_V_M1_MF4, VSOXSEG7EI64_V }, // 10712
  { PseudoVSOXSEG7EI64_V_M1_MF4_MASK, VSOXSEG7EI64_V }, // 10713
  { PseudoVSOXSEG7EI64_V_M1_MF8, VSOXSEG7EI64_V }, // 10714
  { PseudoVSOXSEG7EI64_V_M1_MF8_MASK, VSOXSEG7EI64_V }, // 10715
  { PseudoVSOXSEG7EI64_V_M2_M1, VSOXSEG7EI64_V }, // 10716
  { PseudoVSOXSEG7EI64_V_M2_M1_MASK, VSOXSEG7EI64_V }, // 10717
  { PseudoVSOXSEG7EI64_V_M2_MF2, VSOXSEG7EI64_V }, // 10718
  { PseudoVSOXSEG7EI64_V_M2_MF2_MASK, VSOXSEG7EI64_V }, // 10719
  { PseudoVSOXSEG7EI64_V_M2_MF4, VSOXSEG7EI64_V }, // 10720
  { PseudoVSOXSEG7EI64_V_M2_MF4_MASK, VSOXSEG7EI64_V }, // 10721
  { PseudoVSOXSEG7EI64_V_M2_MF8, VSOXSEG7EI64_V }, // 10722
  { PseudoVSOXSEG7EI64_V_M2_MF8_MASK, VSOXSEG7EI64_V }, // 10723
  { PseudoVSOXSEG7EI64_V_M4_M1, VSOXSEG7EI64_V }, // 10724
  { PseudoVSOXSEG7EI64_V_M4_M1_MASK, VSOXSEG7EI64_V }, // 10725
  { PseudoVSOXSEG7EI64_V_M4_MF2, VSOXSEG7EI64_V }, // 10726
  { PseudoVSOXSEG7EI64_V_M4_MF2_MASK, VSOXSEG7EI64_V }, // 10727
  { PseudoVSOXSEG7EI64_V_M4_MF4, VSOXSEG7EI64_V }, // 10728
  { PseudoVSOXSEG7EI64_V_M4_MF4_MASK, VSOXSEG7EI64_V }, // 10729
  { PseudoVSOXSEG7EI64_V_M4_MF8, VSOXSEG7EI64_V }, // 10730
  { PseudoVSOXSEG7EI64_V_M4_MF8_MASK, VSOXSEG7EI64_V }, // 10731
  { PseudoVSOXSEG7EI64_V_M8_M1, VSOXSEG7EI64_V }, // 10732
  { PseudoVSOXSEG7EI64_V_M8_M1_MASK, VSOXSEG7EI64_V }, // 10733
  { PseudoVSOXSEG7EI64_V_M8_MF2, VSOXSEG7EI64_V }, // 10734
  { PseudoVSOXSEG7EI64_V_M8_MF2_MASK, VSOXSEG7EI64_V }, // 10735
  { PseudoVSOXSEG7EI64_V_M8_MF4, VSOXSEG7EI64_V }, // 10736
  { PseudoVSOXSEG7EI64_V_M8_MF4_MASK, VSOXSEG7EI64_V }, // 10737
  { PseudoVSOXSEG7EI64_V_M8_MF8, VSOXSEG7EI64_V }, // 10738
  { PseudoVSOXSEG7EI64_V_M8_MF8_MASK, VSOXSEG7EI64_V }, // 10739
  { PseudoVSOXSEG7EI8_V_M1_M1, VSOXSEG7EI8_V }, // 10740
  { PseudoVSOXSEG7EI8_V_M1_M1_MASK, VSOXSEG7EI8_V }, // 10741
  { PseudoVSOXSEG7EI8_V_M1_MF2, VSOXSEG7EI8_V }, // 10742
  { PseudoVSOXSEG7EI8_V_M1_MF2_MASK, VSOXSEG7EI8_V }, // 10743
  { PseudoVSOXSEG7EI8_V_M1_MF4, VSOXSEG7EI8_V }, // 10744
  { PseudoVSOXSEG7EI8_V_M1_MF4_MASK, VSOXSEG7EI8_V }, // 10745
  { PseudoVSOXSEG7EI8_V_M1_MF8, VSOXSEG7EI8_V }, // 10746
  { PseudoVSOXSEG7EI8_V_M1_MF8_MASK, VSOXSEG7EI8_V }, // 10747
  { PseudoVSOXSEG7EI8_V_M2_M1, VSOXSEG7EI8_V }, // 10748
  { PseudoVSOXSEG7EI8_V_M2_M1_MASK, VSOXSEG7EI8_V }, // 10749
  { PseudoVSOXSEG7EI8_V_M2_MF2, VSOXSEG7EI8_V }, // 10750
  { PseudoVSOXSEG7EI8_V_M2_MF2_MASK, VSOXSEG7EI8_V }, // 10751
  { PseudoVSOXSEG7EI8_V_M2_MF4, VSOXSEG7EI8_V }, // 10752
  { PseudoVSOXSEG7EI8_V_M2_MF4_MASK, VSOXSEG7EI8_V }, // 10753
  { PseudoVSOXSEG7EI8_V_M2_MF8, VSOXSEG7EI8_V }, // 10754
  { PseudoVSOXSEG7EI8_V_M2_MF8_MASK, VSOXSEG7EI8_V }, // 10755
  { PseudoVSOXSEG7EI8_V_M4_M1, VSOXSEG7EI8_V }, // 10756
  { PseudoVSOXSEG7EI8_V_M4_M1_MASK, VSOXSEG7EI8_V }, // 10757
  { PseudoVSOXSEG7EI8_V_M4_MF2, VSOXSEG7EI8_V }, // 10758
  { PseudoVSOXSEG7EI8_V_M4_MF2_MASK, VSOXSEG7EI8_V }, // 10759
  { PseudoVSOXSEG7EI8_V_M4_MF4, VSOXSEG7EI8_V }, // 10760
  { PseudoVSOXSEG7EI8_V_M4_MF4_MASK, VSOXSEG7EI8_V }, // 10761
  { PseudoVSOXSEG7EI8_V_M4_MF8, VSOXSEG7EI8_V }, // 10762
  { PseudoVSOXSEG7EI8_V_M4_MF8_MASK, VSOXSEG7EI8_V }, // 10763
  { PseudoVSOXSEG7EI8_V_M8_M1, VSOXSEG7EI8_V }, // 10764
  { PseudoVSOXSEG7EI8_V_M8_M1_MASK, VSOXSEG7EI8_V }, // 10765
  { PseudoVSOXSEG7EI8_V_M8_MF2, VSOXSEG7EI8_V }, // 10766
  { PseudoVSOXSEG7EI8_V_M8_MF2_MASK, VSOXSEG7EI8_V }, // 10767
  { PseudoVSOXSEG7EI8_V_M8_MF4, VSOXSEG7EI8_V }, // 10768
  { PseudoVSOXSEG7EI8_V_M8_MF4_MASK, VSOXSEG7EI8_V }, // 10769
  { PseudoVSOXSEG7EI8_V_M8_MF8, VSOXSEG7EI8_V }, // 10770
  { PseudoVSOXSEG7EI8_V_M8_MF8_MASK, VSOXSEG7EI8_V }, // 10771
  { PseudoVSOXSEG7EI8_V_MF2_M1, VSOXSEG7EI8_V }, // 10772
  { PseudoVSOXSEG7EI8_V_MF2_M1_MASK, VSOXSEG7EI8_V }, // 10773
  { PseudoVSOXSEG7EI8_V_MF2_MF2, VSOXSEG7EI8_V }, // 10774
  { PseudoVSOXSEG7EI8_V_MF2_MF2_MASK, VSOXSEG7EI8_V }, // 10775
  { PseudoVSOXSEG7EI8_V_MF2_MF4, VSOXSEG7EI8_V }, // 10776
  { PseudoVSOXSEG7EI8_V_MF2_MF4_MASK, VSOXSEG7EI8_V }, // 10777
  { PseudoVSOXSEG7EI8_V_MF2_MF8, VSOXSEG7EI8_V }, // 10778
  { PseudoVSOXSEG7EI8_V_MF2_MF8_MASK, VSOXSEG7EI8_V }, // 10779
  { PseudoVSOXSEG7EI8_V_MF4_M1, VSOXSEG7EI8_V }, // 10780
  { PseudoVSOXSEG7EI8_V_MF4_M1_MASK, VSOXSEG7EI8_V }, // 10781
  { PseudoVSOXSEG7EI8_V_MF4_MF2, VSOXSEG7EI8_V }, // 10782
  { PseudoVSOXSEG7EI8_V_MF4_MF2_MASK, VSOXSEG7EI8_V }, // 10783
  { PseudoVSOXSEG7EI8_V_MF4_MF4, VSOXSEG7EI8_V }, // 10784
  { PseudoVSOXSEG7EI8_V_MF4_MF4_MASK, VSOXSEG7EI8_V }, // 10785
  { PseudoVSOXSEG7EI8_V_MF4_MF8, VSOXSEG7EI8_V }, // 10786
  { PseudoVSOXSEG7EI8_V_MF4_MF8_MASK, VSOXSEG7EI8_V }, // 10787
  { PseudoVSOXSEG7EI8_V_MF8_M1, VSOXSEG7EI8_V }, // 10788
  { PseudoVSOXSEG7EI8_V_MF8_M1_MASK, VSOXSEG7EI8_V }, // 10789
  { PseudoVSOXSEG7EI8_V_MF8_MF2, VSOXSEG7EI8_V }, // 10790
  { PseudoVSOXSEG7EI8_V_MF8_MF2_MASK, VSOXSEG7EI8_V }, // 10791
  { PseudoVSOXSEG7EI8_V_MF8_MF4, VSOXSEG7EI8_V }, // 10792
  { PseudoVSOXSEG7EI8_V_MF8_MF4_MASK, VSOXSEG7EI8_V }, // 10793
  { PseudoVSOXSEG7EI8_V_MF8_MF8, VSOXSEG7EI8_V }, // 10794
  { PseudoVSOXSEG7EI8_V_MF8_MF8_MASK, VSOXSEG7EI8_V }, // 10795
  { PseudoVSOXSEG8EI16_V_M1_M1, VSOXSEG8EI16_V }, // 10796
  { PseudoVSOXSEG8EI16_V_M1_M1_MASK, VSOXSEG8EI16_V }, // 10797
  { PseudoVSOXSEG8EI16_V_M1_MF2, VSOXSEG8EI16_V }, // 10798
  { PseudoVSOXSEG8EI16_V_M1_MF2_MASK, VSOXSEG8EI16_V }, // 10799
  { PseudoVSOXSEG8EI16_V_M1_MF4, VSOXSEG8EI16_V }, // 10800
  { PseudoVSOXSEG8EI16_V_M1_MF4_MASK, VSOXSEG8EI16_V }, // 10801
  { PseudoVSOXSEG8EI16_V_M1_MF8, VSOXSEG8EI16_V }, // 10802
  { PseudoVSOXSEG8EI16_V_M1_MF8_MASK, VSOXSEG8EI16_V }, // 10803
  { PseudoVSOXSEG8EI16_V_M2_M1, VSOXSEG8EI16_V }, // 10804
  { PseudoVSOXSEG8EI16_V_M2_M1_MASK, VSOXSEG8EI16_V }, // 10805
  { PseudoVSOXSEG8EI16_V_M2_MF2, VSOXSEG8EI16_V }, // 10806
  { PseudoVSOXSEG8EI16_V_M2_MF2_MASK, VSOXSEG8EI16_V }, // 10807
  { PseudoVSOXSEG8EI16_V_M2_MF4, VSOXSEG8EI16_V }, // 10808
  { PseudoVSOXSEG8EI16_V_M2_MF4_MASK, VSOXSEG8EI16_V }, // 10809
  { PseudoVSOXSEG8EI16_V_M2_MF8, VSOXSEG8EI16_V }, // 10810
  { PseudoVSOXSEG8EI16_V_M2_MF8_MASK, VSOXSEG8EI16_V }, // 10811
  { PseudoVSOXSEG8EI16_V_M4_M1, VSOXSEG8EI16_V }, // 10812
  { PseudoVSOXSEG8EI16_V_M4_M1_MASK, VSOXSEG8EI16_V }, // 10813
  { PseudoVSOXSEG8EI16_V_M4_MF2, VSOXSEG8EI16_V }, // 10814
  { PseudoVSOXSEG8EI16_V_M4_MF2_MASK, VSOXSEG8EI16_V }, // 10815
  { PseudoVSOXSEG8EI16_V_M4_MF4, VSOXSEG8EI16_V }, // 10816
  { PseudoVSOXSEG8EI16_V_M4_MF4_MASK, VSOXSEG8EI16_V }, // 10817
  { PseudoVSOXSEG8EI16_V_M4_MF8, VSOXSEG8EI16_V }, // 10818
  { PseudoVSOXSEG8EI16_V_M4_MF8_MASK, VSOXSEG8EI16_V }, // 10819
  { PseudoVSOXSEG8EI16_V_M8_M1, VSOXSEG8EI16_V }, // 10820
  { PseudoVSOXSEG8EI16_V_M8_M1_MASK, VSOXSEG8EI16_V }, // 10821
  { PseudoVSOXSEG8EI16_V_M8_MF2, VSOXSEG8EI16_V }, // 10822
  { PseudoVSOXSEG8EI16_V_M8_MF2_MASK, VSOXSEG8EI16_V }, // 10823
  { PseudoVSOXSEG8EI16_V_M8_MF4, VSOXSEG8EI16_V }, // 10824
  { PseudoVSOXSEG8EI16_V_M8_MF4_MASK, VSOXSEG8EI16_V }, // 10825
  { PseudoVSOXSEG8EI16_V_M8_MF8, VSOXSEG8EI16_V }, // 10826
  { PseudoVSOXSEG8EI16_V_M8_MF8_MASK, VSOXSEG8EI16_V }, // 10827
  { PseudoVSOXSEG8EI16_V_MF2_M1, VSOXSEG8EI16_V }, // 10828
  { PseudoVSOXSEG8EI16_V_MF2_M1_MASK, VSOXSEG8EI16_V }, // 10829
  { PseudoVSOXSEG8EI16_V_MF2_MF2, VSOXSEG8EI16_V }, // 10830
  { PseudoVSOXSEG8EI16_V_MF2_MF2_MASK, VSOXSEG8EI16_V }, // 10831
  { PseudoVSOXSEG8EI16_V_MF2_MF4, VSOXSEG8EI16_V }, // 10832
  { PseudoVSOXSEG8EI16_V_MF2_MF4_MASK, VSOXSEG8EI16_V }, // 10833
  { PseudoVSOXSEG8EI16_V_MF2_MF8, VSOXSEG8EI16_V }, // 10834
  { PseudoVSOXSEG8EI16_V_MF2_MF8_MASK, VSOXSEG8EI16_V }, // 10835
  { PseudoVSOXSEG8EI16_V_MF4_M1, VSOXSEG8EI16_V }, // 10836
  { PseudoVSOXSEG8EI16_V_MF4_M1_MASK, VSOXSEG8EI16_V }, // 10837
  { PseudoVSOXSEG8EI16_V_MF4_MF2, VSOXSEG8EI16_V }, // 10838
  { PseudoVSOXSEG8EI16_V_MF4_MF2_MASK, VSOXSEG8EI16_V }, // 10839
  { PseudoVSOXSEG8EI16_V_MF4_MF4, VSOXSEG8EI16_V }, // 10840
  { PseudoVSOXSEG8EI16_V_MF4_MF4_MASK, VSOXSEG8EI16_V }, // 10841
  { PseudoVSOXSEG8EI16_V_MF4_MF8, VSOXSEG8EI16_V }, // 10842
  { PseudoVSOXSEG8EI16_V_MF4_MF8_MASK, VSOXSEG8EI16_V }, // 10843
  { PseudoVSOXSEG8EI32_V_M1_M1, VSOXSEG8EI32_V }, // 10844
  { PseudoVSOXSEG8EI32_V_M1_M1_MASK, VSOXSEG8EI32_V }, // 10845
  { PseudoVSOXSEG8EI32_V_M1_MF2, VSOXSEG8EI32_V }, // 10846
  { PseudoVSOXSEG8EI32_V_M1_MF2_MASK, VSOXSEG8EI32_V }, // 10847
  { PseudoVSOXSEG8EI32_V_M1_MF4, VSOXSEG8EI32_V }, // 10848
  { PseudoVSOXSEG8EI32_V_M1_MF4_MASK, VSOXSEG8EI32_V }, // 10849
  { PseudoVSOXSEG8EI32_V_M1_MF8, VSOXSEG8EI32_V }, // 10850
  { PseudoVSOXSEG8EI32_V_M1_MF8_MASK, VSOXSEG8EI32_V }, // 10851
  { PseudoVSOXSEG8EI32_V_M2_M1, VSOXSEG8EI32_V }, // 10852
  { PseudoVSOXSEG8EI32_V_M2_M1_MASK, VSOXSEG8EI32_V }, // 10853
  { PseudoVSOXSEG8EI32_V_M2_MF2, VSOXSEG8EI32_V }, // 10854
  { PseudoVSOXSEG8EI32_V_M2_MF2_MASK, VSOXSEG8EI32_V }, // 10855
  { PseudoVSOXSEG8EI32_V_M2_MF4, VSOXSEG8EI32_V }, // 10856
  { PseudoVSOXSEG8EI32_V_M2_MF4_MASK, VSOXSEG8EI32_V }, // 10857
  { PseudoVSOXSEG8EI32_V_M2_MF8, VSOXSEG8EI32_V }, // 10858
  { PseudoVSOXSEG8EI32_V_M2_MF8_MASK, VSOXSEG8EI32_V }, // 10859
  { PseudoVSOXSEG8EI32_V_M4_M1, VSOXSEG8EI32_V }, // 10860
  { PseudoVSOXSEG8EI32_V_M4_M1_MASK, VSOXSEG8EI32_V }, // 10861
  { PseudoVSOXSEG8EI32_V_M4_MF2, VSOXSEG8EI32_V }, // 10862
  { PseudoVSOXSEG8EI32_V_M4_MF2_MASK, VSOXSEG8EI32_V }, // 10863
  { PseudoVSOXSEG8EI32_V_M4_MF4, VSOXSEG8EI32_V }, // 10864
  { PseudoVSOXSEG8EI32_V_M4_MF4_MASK, VSOXSEG8EI32_V }, // 10865
  { PseudoVSOXSEG8EI32_V_M4_MF8, VSOXSEG8EI32_V }, // 10866
  { PseudoVSOXSEG8EI32_V_M4_MF8_MASK, VSOXSEG8EI32_V }, // 10867
  { PseudoVSOXSEG8EI32_V_M8_M1, VSOXSEG8EI32_V }, // 10868
  { PseudoVSOXSEG8EI32_V_M8_M1_MASK, VSOXSEG8EI32_V }, // 10869
  { PseudoVSOXSEG8EI32_V_M8_MF2, VSOXSEG8EI32_V }, // 10870
  { PseudoVSOXSEG8EI32_V_M8_MF2_MASK, VSOXSEG8EI32_V }, // 10871
  { PseudoVSOXSEG8EI32_V_M8_MF4, VSOXSEG8EI32_V }, // 10872
  { PseudoVSOXSEG8EI32_V_M8_MF4_MASK, VSOXSEG8EI32_V }, // 10873
  { PseudoVSOXSEG8EI32_V_M8_MF8, VSOXSEG8EI32_V }, // 10874
  { PseudoVSOXSEG8EI32_V_M8_MF8_MASK, VSOXSEG8EI32_V }, // 10875
  { PseudoVSOXSEG8EI32_V_MF2_M1, VSOXSEG8EI32_V }, // 10876
  { PseudoVSOXSEG8EI32_V_MF2_M1_MASK, VSOXSEG8EI32_V }, // 10877
  { PseudoVSOXSEG8EI32_V_MF2_MF2, VSOXSEG8EI32_V }, // 10878
  { PseudoVSOXSEG8EI32_V_MF2_MF2_MASK, VSOXSEG8EI32_V }, // 10879
  { PseudoVSOXSEG8EI32_V_MF2_MF4, VSOXSEG8EI32_V }, // 10880
  { PseudoVSOXSEG8EI32_V_MF2_MF4_MASK, VSOXSEG8EI32_V }, // 10881
  { PseudoVSOXSEG8EI32_V_MF2_MF8, VSOXSEG8EI32_V }, // 10882
  { PseudoVSOXSEG8EI32_V_MF2_MF8_MASK, VSOXSEG8EI32_V }, // 10883
  { PseudoVSOXSEG8EI64_V_M1_M1, VSOXSEG8EI64_V }, // 10884
  { PseudoVSOXSEG8EI64_V_M1_M1_MASK, VSOXSEG8EI64_V }, // 10885
  { PseudoVSOXSEG8EI64_V_M1_MF2, VSOXSEG8EI64_V }, // 10886
  { PseudoVSOXSEG8EI64_V_M1_MF2_MASK, VSOXSEG8EI64_V }, // 10887
  { PseudoVSOXSEG8EI64_V_M1_MF4, VSOXSEG8EI64_V }, // 10888
  { PseudoVSOXSEG8EI64_V_M1_MF4_MASK, VSOXSEG8EI64_V }, // 10889
  { PseudoVSOXSEG8EI64_V_M1_MF8, VSOXSEG8EI64_V }, // 10890
  { PseudoVSOXSEG8EI64_V_M1_MF8_MASK, VSOXSEG8EI64_V }, // 10891
  { PseudoVSOXSEG8EI64_V_M2_M1, VSOXSEG8EI64_V }, // 10892
  { PseudoVSOXSEG8EI64_V_M2_M1_MASK, VSOXSEG8EI64_V }, // 10893
  { PseudoVSOXSEG8EI64_V_M2_MF2, VSOXSEG8EI64_V }, // 10894
  { PseudoVSOXSEG8EI64_V_M2_MF2_MASK, VSOXSEG8EI64_V }, // 10895
  { PseudoVSOXSEG8EI64_V_M2_MF4, VSOXSEG8EI64_V }, // 10896
  { PseudoVSOXSEG8EI64_V_M2_MF4_MASK, VSOXSEG8EI64_V }, // 10897
  { PseudoVSOXSEG8EI64_V_M2_MF8, VSOXSEG8EI64_V }, // 10898
  { PseudoVSOXSEG8EI64_V_M2_MF8_MASK, VSOXSEG8EI64_V }, // 10899
  { PseudoVSOXSEG8EI64_V_M4_M1, VSOXSEG8EI64_V }, // 10900
  { PseudoVSOXSEG8EI64_V_M4_M1_MASK, VSOXSEG8EI64_V }, // 10901
  { PseudoVSOXSEG8EI64_V_M4_MF2, VSOXSEG8EI64_V }, // 10902
  { PseudoVSOXSEG8EI64_V_M4_MF2_MASK, VSOXSEG8EI64_V }, // 10903
  { PseudoVSOXSEG8EI64_V_M4_MF4, VSOXSEG8EI64_V }, // 10904
  { PseudoVSOXSEG8EI64_V_M4_MF4_MASK, VSOXSEG8EI64_V }, // 10905
  { PseudoVSOXSEG8EI64_V_M4_MF8, VSOXSEG8EI64_V }, // 10906
  { PseudoVSOXSEG8EI64_V_M4_MF8_MASK, VSOXSEG8EI64_V }, // 10907
  { PseudoVSOXSEG8EI64_V_M8_M1, VSOXSEG8EI64_V }, // 10908
  { PseudoVSOXSEG8EI64_V_M8_M1_MASK, VSOXSEG8EI64_V }, // 10909
  { PseudoVSOXSEG8EI64_V_M8_MF2, VSOXSEG8EI64_V }, // 10910
  { PseudoVSOXSEG8EI64_V_M8_MF2_MASK, VSOXSEG8EI64_V }, // 10911
  { PseudoVSOXSEG8EI64_V_M8_MF4, VSOXSEG8EI64_V }, // 10912
  { PseudoVSOXSEG8EI64_V_M8_MF4_MASK, VSOXSEG8EI64_V }, // 10913
  { PseudoVSOXSEG8EI64_V_M8_MF8, VSOXSEG8EI64_V }, // 10914
  { PseudoVSOXSEG8EI64_V_M8_MF8_MASK, VSOXSEG8EI64_V }, // 10915
  { PseudoVSOXSEG8EI8_V_M1_M1, VSOXSEG8EI8_V }, // 10916
  { PseudoVSOXSEG8EI8_V_M1_M1_MASK, VSOXSEG8EI8_V }, // 10917
  { PseudoVSOXSEG8EI8_V_M1_MF2, VSOXSEG8EI8_V }, // 10918
  { PseudoVSOXSEG8EI8_V_M1_MF2_MASK, VSOXSEG8EI8_V }, // 10919
  { PseudoVSOXSEG8EI8_V_M1_MF4, VSOXSEG8EI8_V }, // 10920
  { PseudoVSOXSEG8EI8_V_M1_MF4_MASK, VSOXSEG8EI8_V }, // 10921
  { PseudoVSOXSEG8EI8_V_M1_MF8, VSOXSEG8EI8_V }, // 10922
  { PseudoVSOXSEG8EI8_V_M1_MF8_MASK, VSOXSEG8EI8_V }, // 10923
  { PseudoVSOXSEG8EI8_V_M2_M1, VSOXSEG8EI8_V }, // 10924
  { PseudoVSOXSEG8EI8_V_M2_M1_MASK, VSOXSEG8EI8_V }, // 10925
  { PseudoVSOXSEG8EI8_V_M2_MF2, VSOXSEG8EI8_V }, // 10926
  { PseudoVSOXSEG8EI8_V_M2_MF2_MASK, VSOXSEG8EI8_V }, // 10927
  { PseudoVSOXSEG8EI8_V_M2_MF4, VSOXSEG8EI8_V }, // 10928
  { PseudoVSOXSEG8EI8_V_M2_MF4_MASK, VSOXSEG8EI8_V }, // 10929
  { PseudoVSOXSEG8EI8_V_M2_MF8, VSOXSEG8EI8_V }, // 10930
  { PseudoVSOXSEG8EI8_V_M2_MF8_MASK, VSOXSEG8EI8_V }, // 10931
  { PseudoVSOXSEG8EI8_V_M4_M1, VSOXSEG8EI8_V }, // 10932
  { PseudoVSOXSEG8EI8_V_M4_M1_MASK, VSOXSEG8EI8_V }, // 10933
  { PseudoVSOXSEG8EI8_V_M4_MF2, VSOXSEG8EI8_V }, // 10934
  { PseudoVSOXSEG8EI8_V_M4_MF2_MASK, VSOXSEG8EI8_V }, // 10935
  { PseudoVSOXSEG8EI8_V_M4_MF4, VSOXSEG8EI8_V }, // 10936
  { PseudoVSOXSEG8EI8_V_M4_MF4_MASK, VSOXSEG8EI8_V }, // 10937
  { PseudoVSOXSEG8EI8_V_M4_MF8, VSOXSEG8EI8_V }, // 10938
  { PseudoVSOXSEG8EI8_V_M4_MF8_MASK, VSOXSEG8EI8_V }, // 10939
  { PseudoVSOXSEG8EI8_V_M8_M1, VSOXSEG8EI8_V }, // 10940
  { PseudoVSOXSEG8EI8_V_M8_M1_MASK, VSOXSEG8EI8_V }, // 10941
  { PseudoVSOXSEG8EI8_V_M8_MF2, VSOXSEG8EI8_V }, // 10942
  { PseudoVSOXSEG8EI8_V_M8_MF2_MASK, VSOXSEG8EI8_V }, // 10943
  { PseudoVSOXSEG8EI8_V_M8_MF4, VSOXSEG8EI8_V }, // 10944
  { PseudoVSOXSEG8EI8_V_M8_MF4_MASK, VSOXSEG8EI8_V }, // 10945
  { PseudoVSOXSEG8EI8_V_M8_MF8, VSOXSEG8EI8_V }, // 10946
  { PseudoVSOXSEG8EI8_V_M8_MF8_MASK, VSOXSEG8EI8_V }, // 10947
  { PseudoVSOXSEG8EI8_V_MF2_M1, VSOXSEG8EI8_V }, // 10948
  { PseudoVSOXSEG8EI8_V_MF2_M1_MASK, VSOXSEG8EI8_V }, // 10949
  { PseudoVSOXSEG8EI8_V_MF2_MF2, VSOXSEG8EI8_V }, // 10950
  { PseudoVSOXSEG8EI8_V_MF2_MF2_MASK, VSOXSEG8EI8_V }, // 10951
  { PseudoVSOXSEG8EI8_V_MF2_MF4, VSOXSEG8EI8_V }, // 10952
  { PseudoVSOXSEG8EI8_V_MF2_MF4_MASK, VSOXSEG8EI8_V }, // 10953
  { PseudoVSOXSEG8EI8_V_MF2_MF8, VSOXSEG8EI8_V }, // 10954
  { PseudoVSOXSEG8EI8_V_MF2_MF8_MASK, VSOXSEG8EI8_V }, // 10955
  { PseudoVSOXSEG8EI8_V_MF4_M1, VSOXSEG8EI8_V }, // 10956
  { PseudoVSOXSEG8EI8_V_MF4_M1_MASK, VSOXSEG8EI8_V }, // 10957
  { PseudoVSOXSEG8EI8_V_MF4_MF2, VSOXSEG8EI8_V }, // 10958
  { PseudoVSOXSEG8EI8_V_MF4_MF2_MASK, VSOXSEG8EI8_V }, // 10959
  { PseudoVSOXSEG8EI8_V_MF4_MF4, VSOXSEG8EI8_V }, // 10960
  { PseudoVSOXSEG8EI8_V_MF4_MF4_MASK, VSOXSEG8EI8_V }, // 10961
  { PseudoVSOXSEG8EI8_V_MF4_MF8, VSOXSEG8EI8_V }, // 10962
  { PseudoVSOXSEG8EI8_V_MF4_MF8_MASK, VSOXSEG8EI8_V }, // 10963
  { PseudoVSOXSEG8EI8_V_MF8_M1, VSOXSEG8EI8_V }, // 10964
  { PseudoVSOXSEG8EI8_V_MF8_M1_MASK, VSOXSEG8EI8_V }, // 10965
  { PseudoVSOXSEG8EI8_V_MF8_MF2, VSOXSEG8EI8_V }, // 10966
  { PseudoVSOXSEG8EI8_V_MF8_MF2_MASK, VSOXSEG8EI8_V }, // 10967
  { PseudoVSOXSEG8EI8_V_MF8_MF4, VSOXSEG8EI8_V }, // 10968
  { PseudoVSOXSEG8EI8_V_MF8_MF4_MASK, VSOXSEG8EI8_V }, // 10969
  { PseudoVSOXSEG8EI8_V_MF8_MF8, VSOXSEG8EI8_V }, // 10970
  { PseudoVSOXSEG8EI8_V_MF8_MF8_MASK, VSOXSEG8EI8_V }, // 10971
  { PseudoVSRA_VI_M1, VSRA_VI }, // 10972
  { PseudoVSRA_VI_M1_MASK, VSRA_VI }, // 10973
  { PseudoVSRA_VI_M2, VSRA_VI }, // 10974
  { PseudoVSRA_VI_M2_MASK, VSRA_VI }, // 10975
  { PseudoVSRA_VI_M4, VSRA_VI }, // 10976
  { PseudoVSRA_VI_M4_MASK, VSRA_VI }, // 10977
  { PseudoVSRA_VI_M8, VSRA_VI }, // 10978
  { PseudoVSRA_VI_M8_MASK, VSRA_VI }, // 10979
  { PseudoVSRA_VI_MF2, VSRA_VI }, // 10980
  { PseudoVSRA_VI_MF2_MASK, VSRA_VI }, // 10981
  { PseudoVSRA_VI_MF4, VSRA_VI }, // 10982
  { PseudoVSRA_VI_MF4_MASK, VSRA_VI }, // 10983
  { PseudoVSRA_VI_MF8, VSRA_VI }, // 10984
  { PseudoVSRA_VI_MF8_MASK, VSRA_VI }, // 10985
  { PseudoVSRA_VV_M1, VSRA_VV }, // 10986
  { PseudoVSRA_VV_M1_MASK, VSRA_VV }, // 10987
  { PseudoVSRA_VV_M2, VSRA_VV }, // 10988
  { PseudoVSRA_VV_M2_MASK, VSRA_VV }, // 10989
  { PseudoVSRA_VV_M4, VSRA_VV }, // 10990
  { PseudoVSRA_VV_M4_MASK, VSRA_VV }, // 10991
  { PseudoVSRA_VV_M8, VSRA_VV }, // 10992
  { PseudoVSRA_VV_M8_MASK, VSRA_VV }, // 10993
  { PseudoVSRA_VV_MF2, VSRA_VV }, // 10994
  { PseudoVSRA_VV_MF2_MASK, VSRA_VV }, // 10995
  { PseudoVSRA_VV_MF4, VSRA_VV }, // 10996
  { PseudoVSRA_VV_MF4_MASK, VSRA_VV }, // 10997
  { PseudoVSRA_VV_MF8, VSRA_VV }, // 10998
  { PseudoVSRA_VV_MF8_MASK, VSRA_VV }, // 10999
  { PseudoVSRA_VX_M1, VSRA_VX }, // 11000
  { PseudoVSRA_VX_M1_MASK, VSRA_VX }, // 11001
  { PseudoVSRA_VX_M2, VSRA_VX }, // 11002
  { PseudoVSRA_VX_M2_MASK, VSRA_VX }, // 11003
  { PseudoVSRA_VX_M4, VSRA_VX }, // 11004
  { PseudoVSRA_VX_M4_MASK, VSRA_VX }, // 11005
  { PseudoVSRA_VX_M8, VSRA_VX }, // 11006
  { PseudoVSRA_VX_M8_MASK, VSRA_VX }, // 11007
  { PseudoVSRA_VX_MF2, VSRA_VX }, // 11008
  { PseudoVSRA_VX_MF2_MASK, VSRA_VX }, // 11009
  { PseudoVSRA_VX_MF4, VSRA_VX }, // 11010
  { PseudoVSRA_VX_MF4_MASK, VSRA_VX }, // 11011
  { PseudoVSRA_VX_MF8, VSRA_VX }, // 11012
  { PseudoVSRA_VX_MF8_MASK, VSRA_VX }, // 11013
  { PseudoVSRL_VI_M1, VSRL_VI }, // 11014
  { PseudoVSRL_VI_M1_MASK, VSRL_VI }, // 11015
  { PseudoVSRL_VI_M2, VSRL_VI }, // 11016
  { PseudoVSRL_VI_M2_MASK, VSRL_VI }, // 11017
  { PseudoVSRL_VI_M4, VSRL_VI }, // 11018
  { PseudoVSRL_VI_M4_MASK, VSRL_VI }, // 11019
  { PseudoVSRL_VI_M8, VSRL_VI }, // 11020
  { PseudoVSRL_VI_M8_MASK, VSRL_VI }, // 11021
  { PseudoVSRL_VI_MF2, VSRL_VI }, // 11022
  { PseudoVSRL_VI_MF2_MASK, VSRL_VI }, // 11023
  { PseudoVSRL_VI_MF4, VSRL_VI }, // 11024
  { PseudoVSRL_VI_MF4_MASK, VSRL_VI }, // 11025
  { PseudoVSRL_VI_MF8, VSRL_VI }, // 11026
  { PseudoVSRL_VI_MF8_MASK, VSRL_VI }, // 11027
  { PseudoVSRL_VV_M1, VSRL_VV }, // 11028
  { PseudoVSRL_VV_M1_MASK, VSRL_VV }, // 11029
  { PseudoVSRL_VV_M2, VSRL_VV }, // 11030
  { PseudoVSRL_VV_M2_MASK, VSRL_VV }, // 11031
  { PseudoVSRL_VV_M4, VSRL_VV }, // 11032
  { PseudoVSRL_VV_M4_MASK, VSRL_VV }, // 11033
  { PseudoVSRL_VV_M8, VSRL_VV }, // 11034
  { PseudoVSRL_VV_M8_MASK, VSRL_VV }, // 11035
  { PseudoVSRL_VV_MF2, VSRL_VV }, // 11036
  { PseudoVSRL_VV_MF2_MASK, VSRL_VV }, // 11037
  { PseudoVSRL_VV_MF4, VSRL_VV }, // 11038
  { PseudoVSRL_VV_MF4_MASK, VSRL_VV }, // 11039
  { PseudoVSRL_VV_MF8, VSRL_VV }, // 11040
  { PseudoVSRL_VV_MF8_MASK, VSRL_VV }, // 11041
  { PseudoVSRL_VX_M1, VSRL_VX }, // 11042
  { PseudoVSRL_VX_M1_MASK, VSRL_VX }, // 11043
  { PseudoVSRL_VX_M2, VSRL_VX }, // 11044
  { PseudoVSRL_VX_M2_MASK, VSRL_VX }, // 11045
  { PseudoVSRL_VX_M4, VSRL_VX }, // 11046
  { PseudoVSRL_VX_M4_MASK, VSRL_VX }, // 11047
  { PseudoVSRL_VX_M8, VSRL_VX }, // 11048
  { PseudoVSRL_VX_M8_MASK, VSRL_VX }, // 11049
  { PseudoVSRL_VX_MF2, VSRL_VX }, // 11050
  { PseudoVSRL_VX_MF2_MASK, VSRL_VX }, // 11051
  { PseudoVSRL_VX_MF4, VSRL_VX }, // 11052
  { PseudoVSRL_VX_MF4_MASK, VSRL_VX }, // 11053
  { PseudoVSRL_VX_MF8, VSRL_VX }, // 11054
  { PseudoVSRL_VX_MF8_MASK, VSRL_VX }, // 11055
  { PseudoVSSE16_V_M1, VSSE16_V }, // 11056
  { PseudoVSSE16_V_M1_MASK, VSSE16_V }, // 11057
  { PseudoVSSE16_V_M2, VSSE16_V }, // 11058
  { PseudoVSSE16_V_M2_MASK, VSSE16_V }, // 11059
  { PseudoVSSE16_V_M4, VSSE16_V }, // 11060
  { PseudoVSSE16_V_M4_MASK, VSSE16_V }, // 11061
  { PseudoVSSE16_V_M8, VSSE16_V }, // 11062
  { PseudoVSSE16_V_M8_MASK, VSSE16_V }, // 11063
  { PseudoVSSE16_V_MF2, VSSE16_V }, // 11064
  { PseudoVSSE16_V_MF2_MASK, VSSE16_V }, // 11065
  { PseudoVSSE16_V_MF4, VSSE16_V }, // 11066
  { PseudoVSSE16_V_MF4_MASK, VSSE16_V }, // 11067
  { PseudoVSSE16_V_MF8, VSSE16_V }, // 11068
  { PseudoVSSE16_V_MF8_MASK, VSSE16_V }, // 11069
  { PseudoVSSE32_V_M1, VSSE32_V }, // 11070
  { PseudoVSSE32_V_M1_MASK, VSSE32_V }, // 11071
  { PseudoVSSE32_V_M2, VSSE32_V }, // 11072
  { PseudoVSSE32_V_M2_MASK, VSSE32_V }, // 11073
  { PseudoVSSE32_V_M4, VSSE32_V }, // 11074
  { PseudoVSSE32_V_M4_MASK, VSSE32_V }, // 11075
  { PseudoVSSE32_V_M8, VSSE32_V }, // 11076
  { PseudoVSSE32_V_M8_MASK, VSSE32_V }, // 11077
  { PseudoVSSE32_V_MF2, VSSE32_V }, // 11078
  { PseudoVSSE32_V_MF2_MASK, VSSE32_V }, // 11079
  { PseudoVSSE32_V_MF4, VSSE32_V }, // 11080
  { PseudoVSSE32_V_MF4_MASK, VSSE32_V }, // 11081
  { PseudoVSSE32_V_MF8, VSSE32_V }, // 11082
  { PseudoVSSE32_V_MF8_MASK, VSSE32_V }, // 11083
  { PseudoVSSE64_V_M1, VSSE64_V }, // 11084
  { PseudoVSSE64_V_M1_MASK, VSSE64_V }, // 11085
  { PseudoVSSE64_V_M2, VSSE64_V }, // 11086
  { PseudoVSSE64_V_M2_MASK, VSSE64_V }, // 11087
  { PseudoVSSE64_V_M4, VSSE64_V }, // 11088
  { PseudoVSSE64_V_M4_MASK, VSSE64_V }, // 11089
  { PseudoVSSE64_V_M8, VSSE64_V }, // 11090
  { PseudoVSSE64_V_M8_MASK, VSSE64_V }, // 11091
  { PseudoVSSE64_V_MF2, VSSE64_V }, // 11092
  { PseudoVSSE64_V_MF2_MASK, VSSE64_V }, // 11093
  { PseudoVSSE64_V_MF4, VSSE64_V }, // 11094
  { PseudoVSSE64_V_MF4_MASK, VSSE64_V }, // 11095
  { PseudoVSSE64_V_MF8, VSSE64_V }, // 11096
  { PseudoVSSE64_V_MF8_MASK, VSSE64_V }, // 11097
  { PseudoVSSE8_V_M1, VSSE8_V }, // 11098
  { PseudoVSSE8_V_M1_MASK, VSSE8_V }, // 11099
  { PseudoVSSE8_V_M2, VSSE8_V }, // 11100
  { PseudoVSSE8_V_M2_MASK, VSSE8_V }, // 11101
  { PseudoVSSE8_V_M4, VSSE8_V }, // 11102
  { PseudoVSSE8_V_M4_MASK, VSSE8_V }, // 11103
  { PseudoVSSE8_V_M8, VSSE8_V }, // 11104
  { PseudoVSSE8_V_M8_MASK, VSSE8_V }, // 11105
  { PseudoVSSE8_V_MF2, VSSE8_V }, // 11106
  { PseudoVSSE8_V_MF2_MASK, VSSE8_V }, // 11107
  { PseudoVSSE8_V_MF4, VSSE8_V }, // 11108
  { PseudoVSSE8_V_MF4_MASK, VSSE8_V }, // 11109
  { PseudoVSSE8_V_MF8, VSSE8_V }, // 11110
  { PseudoVSSE8_V_MF8_MASK, VSSE8_V }, // 11111
  { PseudoVSSEG2E16_V_M1, VSSEG2E16_V }, // 11112
  { PseudoVSSEG2E16_V_M1_MASK, VSSEG2E16_V }, // 11113
  { PseudoVSSEG2E16_V_M2, VSSEG2E16_V }, // 11114
  { PseudoVSSEG2E16_V_M2_MASK, VSSEG2E16_V }, // 11115
  { PseudoVSSEG2E16_V_M4, VSSEG2E16_V }, // 11116
  { PseudoVSSEG2E16_V_M4_MASK, VSSEG2E16_V }, // 11117
  { PseudoVSSEG2E16_V_MF2, VSSEG2E16_V }, // 11118
  { PseudoVSSEG2E16_V_MF2_MASK, VSSEG2E16_V }, // 11119
  { PseudoVSSEG2E16_V_MF4, VSSEG2E16_V }, // 11120
  { PseudoVSSEG2E16_V_MF4_MASK, VSSEG2E16_V }, // 11121
  { PseudoVSSEG2E32_V_M1, VSSEG2E32_V }, // 11122
  { PseudoVSSEG2E32_V_M1_MASK, VSSEG2E32_V }, // 11123
  { PseudoVSSEG2E32_V_M2, VSSEG2E32_V }, // 11124
  { PseudoVSSEG2E32_V_M2_MASK, VSSEG2E32_V }, // 11125
  { PseudoVSSEG2E32_V_M4, VSSEG2E32_V }, // 11126
  { PseudoVSSEG2E32_V_M4_MASK, VSSEG2E32_V }, // 11127
  { PseudoVSSEG2E32_V_MF2, VSSEG2E32_V }, // 11128
  { PseudoVSSEG2E32_V_MF2_MASK, VSSEG2E32_V }, // 11129
  { PseudoVSSEG2E64_V_M1, VSSEG2E64_V }, // 11130
  { PseudoVSSEG2E64_V_M1_MASK, VSSEG2E64_V }, // 11131
  { PseudoVSSEG2E64_V_M2, VSSEG2E64_V }, // 11132
  { PseudoVSSEG2E64_V_M2_MASK, VSSEG2E64_V }, // 11133
  { PseudoVSSEG2E64_V_M4, VSSEG2E64_V }, // 11134
  { PseudoVSSEG2E64_V_M4_MASK, VSSEG2E64_V }, // 11135
  { PseudoVSSEG2E8_V_M1, VSSEG2E8_V }, // 11136
  { PseudoVSSEG2E8_V_M1_MASK, VSSEG2E8_V }, // 11137
  { PseudoVSSEG2E8_V_M2, VSSEG2E8_V }, // 11138
  { PseudoVSSEG2E8_V_M2_MASK, VSSEG2E8_V }, // 11139
  { PseudoVSSEG2E8_V_M4, VSSEG2E8_V }, // 11140
  { PseudoVSSEG2E8_V_M4_MASK, VSSEG2E8_V }, // 11141
  { PseudoVSSEG2E8_V_MF2, VSSEG2E8_V }, // 11142
  { PseudoVSSEG2E8_V_MF2_MASK, VSSEG2E8_V }, // 11143
  { PseudoVSSEG2E8_V_MF4, VSSEG2E8_V }, // 11144
  { PseudoVSSEG2E8_V_MF4_MASK, VSSEG2E8_V }, // 11145
  { PseudoVSSEG2E8_V_MF8, VSSEG2E8_V }, // 11146
  { PseudoVSSEG2E8_V_MF8_MASK, VSSEG2E8_V }, // 11147
  { PseudoVSSEG3E16_V_M1, VSSEG3E16_V }, // 11148
  { PseudoVSSEG3E16_V_M1_MASK, VSSEG3E16_V }, // 11149
  { PseudoVSSEG3E16_V_M2, VSSEG3E16_V }, // 11150
  { PseudoVSSEG3E16_V_M2_MASK, VSSEG3E16_V }, // 11151
  { PseudoVSSEG3E16_V_MF2, VSSEG3E16_V }, // 11152
  { PseudoVSSEG3E16_V_MF2_MASK, VSSEG3E16_V }, // 11153
  { PseudoVSSEG3E16_V_MF4, VSSEG3E16_V }, // 11154
  { PseudoVSSEG3E16_V_MF4_MASK, VSSEG3E16_V }, // 11155
  { PseudoVSSEG3E32_V_M1, VSSEG3E32_V }, // 11156
  { PseudoVSSEG3E32_V_M1_MASK, VSSEG3E32_V }, // 11157
  { PseudoVSSEG3E32_V_M2, VSSEG3E32_V }, // 11158
  { PseudoVSSEG3E32_V_M2_MASK, VSSEG3E32_V }, // 11159
  { PseudoVSSEG3E32_V_MF2, VSSEG3E32_V }, // 11160
  { PseudoVSSEG3E32_V_MF2_MASK, VSSEG3E32_V }, // 11161
  { PseudoVSSEG3E64_V_M1, VSSEG3E64_V }, // 11162
  { PseudoVSSEG3E64_V_M1_MASK, VSSEG3E64_V }, // 11163
  { PseudoVSSEG3E64_V_M2, VSSEG3E64_V }, // 11164
  { PseudoVSSEG3E64_V_M2_MASK, VSSEG3E64_V }, // 11165
  { PseudoVSSEG3E8_V_M1, VSSEG3E8_V }, // 11166
  { PseudoVSSEG3E8_V_M1_MASK, VSSEG3E8_V }, // 11167
  { PseudoVSSEG3E8_V_M2, VSSEG3E8_V }, // 11168
  { PseudoVSSEG3E8_V_M2_MASK, VSSEG3E8_V }, // 11169
  { PseudoVSSEG3E8_V_MF2, VSSEG3E8_V }, // 11170
  { PseudoVSSEG3E8_V_MF2_MASK, VSSEG3E8_V }, // 11171
  { PseudoVSSEG3E8_V_MF4, VSSEG3E8_V }, // 11172
  { PseudoVSSEG3E8_V_MF4_MASK, VSSEG3E8_V }, // 11173
  { PseudoVSSEG3E8_V_MF8, VSSEG3E8_V }, // 11174
  { PseudoVSSEG3E8_V_MF8_MASK, VSSEG3E8_V }, // 11175
  { PseudoVSSEG4E16_V_M1, VSSEG4E16_V }, // 11176
  { PseudoVSSEG4E16_V_M1_MASK, VSSEG4E16_V }, // 11177
  { PseudoVSSEG4E16_V_M2, VSSEG4E16_V }, // 11178
  { PseudoVSSEG4E16_V_M2_MASK, VSSEG4E16_V }, // 11179
  { PseudoVSSEG4E16_V_MF2, VSSEG4E16_V }, // 11180
  { PseudoVSSEG4E16_V_MF2_MASK, VSSEG4E16_V }, // 11181
  { PseudoVSSEG4E16_V_MF4, VSSEG4E16_V }, // 11182
  { PseudoVSSEG4E16_V_MF4_MASK, VSSEG4E16_V }, // 11183
  { PseudoVSSEG4E32_V_M1, VSSEG4E32_V }, // 11184
  { PseudoVSSEG4E32_V_M1_MASK, VSSEG4E32_V }, // 11185
  { PseudoVSSEG4E32_V_M2, VSSEG4E32_V }, // 11186
  { PseudoVSSEG4E32_V_M2_MASK, VSSEG4E32_V }, // 11187
  { PseudoVSSEG4E32_V_MF2, VSSEG4E32_V }, // 11188
  { PseudoVSSEG4E32_V_MF2_MASK, VSSEG4E32_V }, // 11189
  { PseudoVSSEG4E64_V_M1, VSSEG4E64_V }, // 11190
  { PseudoVSSEG4E64_V_M1_MASK, VSSEG4E64_V }, // 11191
  { PseudoVSSEG4E64_V_M2, VSSEG4E64_V }, // 11192
  { PseudoVSSEG4E64_V_M2_MASK, VSSEG4E64_V }, // 11193
  { PseudoVSSEG4E8_V_M1, VSSEG4E8_V }, // 11194
  { PseudoVSSEG4E8_V_M1_MASK, VSSEG4E8_V }, // 11195
  { PseudoVSSEG4E8_V_M2, VSSEG4E8_V }, // 11196
  { PseudoVSSEG4E8_V_M2_MASK, VSSEG4E8_V }, // 11197
  { PseudoVSSEG4E8_V_MF2, VSSEG4E8_V }, // 11198
  { PseudoVSSEG4E8_V_MF2_MASK, VSSEG4E8_V }, // 11199
  { PseudoVSSEG4E8_V_MF4, VSSEG4E8_V }, // 11200
  { PseudoVSSEG4E8_V_MF4_MASK, VSSEG4E8_V }, // 11201
  { PseudoVSSEG4E8_V_MF8, VSSEG4E8_V }, // 11202
  { PseudoVSSEG4E8_V_MF8_MASK, VSSEG4E8_V }, // 11203
  { PseudoVSSEG5E16_V_M1, VSSEG5E16_V }, // 11204
  { PseudoVSSEG5E16_V_M1_MASK, VSSEG5E16_V }, // 11205
  { PseudoVSSEG5E16_V_MF2, VSSEG5E16_V }, // 11206
  { PseudoVSSEG5E16_V_MF2_MASK, VSSEG5E16_V }, // 11207
  { PseudoVSSEG5E16_V_MF4, VSSEG5E16_V }, // 11208
  { PseudoVSSEG5E16_V_MF4_MASK, VSSEG5E16_V }, // 11209
  { PseudoVSSEG5E32_V_M1, VSSEG5E32_V }, // 11210
  { PseudoVSSEG5E32_V_M1_MASK, VSSEG5E32_V }, // 11211
  { PseudoVSSEG5E32_V_MF2, VSSEG5E32_V }, // 11212
  { PseudoVSSEG5E32_V_MF2_MASK, VSSEG5E32_V }, // 11213
  { PseudoVSSEG5E64_V_M1, VSSEG5E64_V }, // 11214
  { PseudoVSSEG5E64_V_M1_MASK, VSSEG5E64_V }, // 11215
  { PseudoVSSEG5E8_V_M1, VSSEG5E8_V }, // 11216
  { PseudoVSSEG5E8_V_M1_MASK, VSSEG5E8_V }, // 11217
  { PseudoVSSEG5E8_V_MF2, VSSEG5E8_V }, // 11218
  { PseudoVSSEG5E8_V_MF2_MASK, VSSEG5E8_V }, // 11219
  { PseudoVSSEG5E8_V_MF4, VSSEG5E8_V }, // 11220
  { PseudoVSSEG5E8_V_MF4_MASK, VSSEG5E8_V }, // 11221
  { PseudoVSSEG5E8_V_MF8, VSSEG5E8_V }, // 11222
  { PseudoVSSEG5E8_V_MF8_MASK, VSSEG5E8_V }, // 11223
  { PseudoVSSEG6E16_V_M1, VSSEG6E16_V }, // 11224
  { PseudoVSSEG6E16_V_M1_MASK, VSSEG6E16_V }, // 11225
  { PseudoVSSEG6E16_V_MF2, VSSEG6E16_V }, // 11226
  { PseudoVSSEG6E16_V_MF2_MASK, VSSEG6E16_V }, // 11227
  { PseudoVSSEG6E16_V_MF4, VSSEG6E16_V }, // 11228
  { PseudoVSSEG6E16_V_MF4_MASK, VSSEG6E16_V }, // 11229
  { PseudoVSSEG6E32_V_M1, VSSEG6E32_V }, // 11230
  { PseudoVSSEG6E32_V_M1_MASK, VSSEG6E32_V }, // 11231
  { PseudoVSSEG6E32_V_MF2, VSSEG6E32_V }, // 11232
  { PseudoVSSEG6E32_V_MF2_MASK, VSSEG6E32_V }, // 11233
  { PseudoVSSEG6E64_V_M1, VSSEG6E64_V }, // 11234
  { PseudoVSSEG6E64_V_M1_MASK, VSSEG6E64_V }, // 11235
  { PseudoVSSEG6E8_V_M1, VSSEG6E8_V }, // 11236
  { PseudoVSSEG6E8_V_M1_MASK, VSSEG6E8_V }, // 11237
  { PseudoVSSEG6E8_V_MF2, VSSEG6E8_V }, // 11238
  { PseudoVSSEG6E8_V_MF2_MASK, VSSEG6E8_V }, // 11239
  { PseudoVSSEG6E8_V_MF4, VSSEG6E8_V }, // 11240
  { PseudoVSSEG6E8_V_MF4_MASK, VSSEG6E8_V }, // 11241
  { PseudoVSSEG6E8_V_MF8, VSSEG6E8_V }, // 11242
  { PseudoVSSEG6E8_V_MF8_MASK, VSSEG6E8_V }, // 11243
  { PseudoVSSEG7E16_V_M1, VSSEG7E16_V }, // 11244
  { PseudoVSSEG7E16_V_M1_MASK, VSSEG7E16_V }, // 11245
  { PseudoVSSEG7E16_V_MF2, VSSEG7E16_V }, // 11246
  { PseudoVSSEG7E16_V_MF2_MASK, VSSEG7E16_V }, // 11247
  { PseudoVSSEG7E16_V_MF4, VSSEG7E16_V }, // 11248
  { PseudoVSSEG7E16_V_MF4_MASK, VSSEG7E16_V }, // 11249
  { PseudoVSSEG7E32_V_M1, VSSEG7E32_V }, // 11250
  { PseudoVSSEG7E32_V_M1_MASK, VSSEG7E32_V }, // 11251
  { PseudoVSSEG7E32_V_MF2, VSSEG7E32_V }, // 11252
  { PseudoVSSEG7E32_V_MF2_MASK, VSSEG7E32_V }, // 11253
  { PseudoVSSEG7E64_V_M1, VSSEG7E64_V }, // 11254
  { PseudoVSSEG7E64_V_M1_MASK, VSSEG7E64_V }, // 11255
  { PseudoVSSEG7E8_V_M1, VSSEG7E8_V }, // 11256
  { PseudoVSSEG7E8_V_M1_MASK, VSSEG7E8_V }, // 11257
  { PseudoVSSEG7E8_V_MF2, VSSEG7E8_V }, // 11258
  { PseudoVSSEG7E8_V_MF2_MASK, VSSEG7E8_V }, // 11259
  { PseudoVSSEG7E8_V_MF4, VSSEG7E8_V }, // 11260
  { PseudoVSSEG7E8_V_MF4_MASK, VSSEG7E8_V }, // 11261
  { PseudoVSSEG7E8_V_MF8, VSSEG7E8_V }, // 11262
  { PseudoVSSEG7E8_V_MF8_MASK, VSSEG7E8_V }, // 11263
  { PseudoVSSEG8E16_V_M1, VSSEG8E16_V }, // 11264
  { PseudoVSSEG8E16_V_M1_MASK, VSSEG8E16_V }, // 11265
  { PseudoVSSEG8E16_V_MF2, VSSEG8E16_V }, // 11266
  { PseudoVSSEG8E16_V_MF2_MASK, VSSEG8E16_V }, // 11267
  { PseudoVSSEG8E16_V_MF4, VSSEG8E16_V }, // 11268
  { PseudoVSSEG8E16_V_MF4_MASK, VSSEG8E16_V }, // 11269
  { PseudoVSSEG8E32_V_M1, VSSEG8E32_V }, // 11270
  { PseudoVSSEG8E32_V_M1_MASK, VSSEG8E32_V }, // 11271
  { PseudoVSSEG8E32_V_MF2, VSSEG8E32_V }, // 11272
  { PseudoVSSEG8E32_V_MF2_MASK, VSSEG8E32_V }, // 11273
  { PseudoVSSEG8E64_V_M1, VSSEG8E64_V }, // 11274
  { PseudoVSSEG8E64_V_M1_MASK, VSSEG8E64_V }, // 11275
  { PseudoVSSEG8E8_V_M1, VSSEG8E8_V }, // 11276
  { PseudoVSSEG8E8_V_M1_MASK, VSSEG8E8_V }, // 11277
  { PseudoVSSEG8E8_V_MF2, VSSEG8E8_V }, // 11278
  { PseudoVSSEG8E8_V_MF2_MASK, VSSEG8E8_V }, // 11279
  { PseudoVSSEG8E8_V_MF4, VSSEG8E8_V }, // 11280
  { PseudoVSSEG8E8_V_MF4_MASK, VSSEG8E8_V }, // 11281
  { PseudoVSSEG8E8_V_MF8, VSSEG8E8_V }, // 11282
  { PseudoVSSEG8E8_V_MF8_MASK, VSSEG8E8_V }, // 11283
  { PseudoVSSRA_VI_M1, VSSRA_VI }, // 11284
  { PseudoVSSRA_VI_M1_MASK, VSSRA_VI }, // 11285
  { PseudoVSSRA_VI_M2, VSSRA_VI }, // 11286
  { PseudoVSSRA_VI_M2_MASK, VSSRA_VI }, // 11287
  { PseudoVSSRA_VI_M4, VSSRA_VI }, // 11288
  { PseudoVSSRA_VI_M4_MASK, VSSRA_VI }, // 11289
  { PseudoVSSRA_VI_M8, VSSRA_VI }, // 11290
  { PseudoVSSRA_VI_M8_MASK, VSSRA_VI }, // 11291
  { PseudoVSSRA_VI_MF2, VSSRA_VI }, // 11292
  { PseudoVSSRA_VI_MF2_MASK, VSSRA_VI }, // 11293
  { PseudoVSSRA_VI_MF4, VSSRA_VI }, // 11294
  { PseudoVSSRA_VI_MF4_MASK, VSSRA_VI }, // 11295
  { PseudoVSSRA_VI_MF8, VSSRA_VI }, // 11296
  { PseudoVSSRA_VI_MF8_MASK, VSSRA_VI }, // 11297
  { PseudoVSSRA_VV_M1, VSSRA_VV }, // 11298
  { PseudoVSSRA_VV_M1_MASK, VSSRA_VV }, // 11299
  { PseudoVSSRA_VV_M2, VSSRA_VV }, // 11300
  { PseudoVSSRA_VV_M2_MASK, VSSRA_VV }, // 11301
  { PseudoVSSRA_VV_M4, VSSRA_VV }, // 11302
  { PseudoVSSRA_VV_M4_MASK, VSSRA_VV }, // 11303
  { PseudoVSSRA_VV_M8, VSSRA_VV }, // 11304
  { PseudoVSSRA_VV_M8_MASK, VSSRA_VV }, // 11305
  { PseudoVSSRA_VV_MF2, VSSRA_VV }, // 11306
  { PseudoVSSRA_VV_MF2_MASK, VSSRA_VV }, // 11307
  { PseudoVSSRA_VV_MF4, VSSRA_VV }, // 11308
  { PseudoVSSRA_VV_MF4_MASK, VSSRA_VV }, // 11309
  { PseudoVSSRA_VV_MF8, VSSRA_VV }, // 11310
  { PseudoVSSRA_VV_MF8_MASK, VSSRA_VV }, // 11311
  { PseudoVSSRA_VX_M1, VSSRA_VX }, // 11312
  { PseudoVSSRA_VX_M1_MASK, VSSRA_VX }, // 11313
  { PseudoVSSRA_VX_M2, VSSRA_VX }, // 11314
  { PseudoVSSRA_VX_M2_MASK, VSSRA_VX }, // 11315
  { PseudoVSSRA_VX_M4, VSSRA_VX }, // 11316
  { PseudoVSSRA_VX_M4_MASK, VSSRA_VX }, // 11317
  { PseudoVSSRA_VX_M8, VSSRA_VX }, // 11318
  { PseudoVSSRA_VX_M8_MASK, VSSRA_VX }, // 11319
  { PseudoVSSRA_VX_MF2, VSSRA_VX }, // 11320
  { PseudoVSSRA_VX_MF2_MASK, VSSRA_VX }, // 11321
  { PseudoVSSRA_VX_MF4, VSSRA_VX }, // 11322
  { PseudoVSSRA_VX_MF4_MASK, VSSRA_VX }, // 11323
  { PseudoVSSRA_VX_MF8, VSSRA_VX }, // 11324
  { PseudoVSSRA_VX_MF8_MASK, VSSRA_VX }, // 11325
  { PseudoVSSRL_VI_M1, VSSRL_VI }, // 11326
  { PseudoVSSRL_VI_M1_MASK, VSSRL_VI }, // 11327
  { PseudoVSSRL_VI_M2, VSSRL_VI }, // 11328
  { PseudoVSSRL_VI_M2_MASK, VSSRL_VI }, // 11329
  { PseudoVSSRL_VI_M4, VSSRL_VI }, // 11330
  { PseudoVSSRL_VI_M4_MASK, VSSRL_VI }, // 11331
  { PseudoVSSRL_VI_M8, VSSRL_VI }, // 11332
  { PseudoVSSRL_VI_M8_MASK, VSSRL_VI }, // 11333
  { PseudoVSSRL_VI_MF2, VSSRL_VI }, // 11334
  { PseudoVSSRL_VI_MF2_MASK, VSSRL_VI }, // 11335
  { PseudoVSSRL_VI_MF4, VSSRL_VI }, // 11336
  { PseudoVSSRL_VI_MF4_MASK, VSSRL_VI }, // 11337
  { PseudoVSSRL_VI_MF8, VSSRL_VI }, // 11338
  { PseudoVSSRL_VI_MF8_MASK, VSSRL_VI }, // 11339
  { PseudoVSSRL_VV_M1, VSSRL_VV }, // 11340
  { PseudoVSSRL_VV_M1_MASK, VSSRL_VV }, // 11341
  { PseudoVSSRL_VV_M2, VSSRL_VV }, // 11342
  { PseudoVSSRL_VV_M2_MASK, VSSRL_VV }, // 11343
  { PseudoVSSRL_VV_M4, VSSRL_VV }, // 11344
  { PseudoVSSRL_VV_M4_MASK, VSSRL_VV }, // 11345
  { PseudoVSSRL_VV_M8, VSSRL_VV }, // 11346
  { PseudoVSSRL_VV_M8_MASK, VSSRL_VV }, // 11347
  { PseudoVSSRL_VV_MF2, VSSRL_VV }, // 11348
  { PseudoVSSRL_VV_MF2_MASK, VSSRL_VV }, // 11349
  { PseudoVSSRL_VV_MF4, VSSRL_VV }, // 11350
  { PseudoVSSRL_VV_MF4_MASK, VSSRL_VV }, // 11351
  { PseudoVSSRL_VV_MF8, VSSRL_VV }, // 11352
  { PseudoVSSRL_VV_MF8_MASK, VSSRL_VV }, // 11353
  { PseudoVSSRL_VX_M1, VSSRL_VX }, // 11354
  { PseudoVSSRL_VX_M1_MASK, VSSRL_VX }, // 11355
  { PseudoVSSRL_VX_M2, VSSRL_VX }, // 11356
  { PseudoVSSRL_VX_M2_MASK, VSSRL_VX }, // 11357
  { PseudoVSSRL_VX_M4, VSSRL_VX }, // 11358
  { PseudoVSSRL_VX_M4_MASK, VSSRL_VX }, // 11359
  { PseudoVSSRL_VX_M8, VSSRL_VX }, // 11360
  { PseudoVSSRL_VX_M8_MASK, VSSRL_VX }, // 11361
  { PseudoVSSRL_VX_MF2, VSSRL_VX }, // 11362
  { PseudoVSSRL_VX_MF2_MASK, VSSRL_VX }, // 11363
  { PseudoVSSRL_VX_MF4, VSSRL_VX }, // 11364
  { PseudoVSSRL_VX_MF4_MASK, VSSRL_VX }, // 11365
  { PseudoVSSRL_VX_MF8, VSSRL_VX }, // 11366
  { PseudoVSSRL_VX_MF8_MASK, VSSRL_VX }, // 11367
  { PseudoVSSSEG2E16_V_M1, VSSSEG2E16_V }, // 11368
  { PseudoVSSSEG2E16_V_M1_MASK, VSSSEG2E16_V }, // 11369
  { PseudoVSSSEG2E16_V_M2, VSSSEG2E16_V }, // 11370
  { PseudoVSSSEG2E16_V_M2_MASK, VSSSEG2E16_V }, // 11371
  { PseudoVSSSEG2E16_V_M4, VSSSEG2E16_V }, // 11372
  { PseudoVSSSEG2E16_V_M4_MASK, VSSSEG2E16_V }, // 11373
  { PseudoVSSSEG2E16_V_MF2, VSSSEG2E16_V }, // 11374
  { PseudoVSSSEG2E16_V_MF2_MASK, VSSSEG2E16_V }, // 11375
  { PseudoVSSSEG2E16_V_MF4, VSSSEG2E16_V }, // 11376
  { PseudoVSSSEG2E16_V_MF4_MASK, VSSSEG2E16_V }, // 11377
  { PseudoVSSSEG2E32_V_M1, VSSSEG2E32_V }, // 11378
  { PseudoVSSSEG2E32_V_M1_MASK, VSSSEG2E32_V }, // 11379
  { PseudoVSSSEG2E32_V_M2, VSSSEG2E32_V }, // 11380
  { PseudoVSSSEG2E32_V_M2_MASK, VSSSEG2E32_V }, // 11381
  { PseudoVSSSEG2E32_V_M4, VSSSEG2E32_V }, // 11382
  { PseudoVSSSEG2E32_V_M4_MASK, VSSSEG2E32_V }, // 11383
  { PseudoVSSSEG2E32_V_MF2, VSSSEG2E32_V }, // 11384
  { PseudoVSSSEG2E32_V_MF2_MASK, VSSSEG2E32_V }, // 11385
  { PseudoVSSSEG2E64_V_M1, VSSSEG2E64_V }, // 11386
  { PseudoVSSSEG2E64_V_M1_MASK, VSSSEG2E64_V }, // 11387
  { PseudoVSSSEG2E64_V_M2, VSSSEG2E64_V }, // 11388
  { PseudoVSSSEG2E64_V_M2_MASK, VSSSEG2E64_V }, // 11389
  { PseudoVSSSEG2E64_V_M4, VSSSEG2E64_V }, // 11390
  { PseudoVSSSEG2E64_V_M4_MASK, VSSSEG2E64_V }, // 11391
  { PseudoVSSSEG2E8_V_M1, VSSSEG2E8_V }, // 11392
  { PseudoVSSSEG2E8_V_M1_MASK, VSSSEG2E8_V }, // 11393
  { PseudoVSSSEG2E8_V_M2, VSSSEG2E8_V }, // 11394
  { PseudoVSSSEG2E8_V_M2_MASK, VSSSEG2E8_V }, // 11395
  { PseudoVSSSEG2E8_V_M4, VSSSEG2E8_V }, // 11396
  { PseudoVSSSEG2E8_V_M4_MASK, VSSSEG2E8_V }, // 11397
  { PseudoVSSSEG2E8_V_MF2, VSSSEG2E8_V }, // 11398
  { PseudoVSSSEG2E8_V_MF2_MASK, VSSSEG2E8_V }, // 11399
  { PseudoVSSSEG2E8_V_MF4, VSSSEG2E8_V }, // 11400
  { PseudoVSSSEG2E8_V_MF4_MASK, VSSSEG2E8_V }, // 11401
  { PseudoVSSSEG2E8_V_MF8, VSSSEG2E8_V }, // 11402
  { PseudoVSSSEG2E8_V_MF8_MASK, VSSSEG2E8_V }, // 11403
  { PseudoVSSSEG3E16_V_M1, VSSSEG3E16_V }, // 11404
  { PseudoVSSSEG3E16_V_M1_MASK, VSSSEG3E16_V }, // 11405
  { PseudoVSSSEG3E16_V_M2, VSSSEG3E16_V }, // 11406
  { PseudoVSSSEG3E16_V_M2_MASK, VSSSEG3E16_V }, // 11407
  { PseudoVSSSEG3E16_V_MF2, VSSSEG3E16_V }, // 11408
  { PseudoVSSSEG3E16_V_MF2_MASK, VSSSEG3E16_V }, // 11409
  { PseudoVSSSEG3E16_V_MF4, VSSSEG3E16_V }, // 11410
  { PseudoVSSSEG3E16_V_MF4_MASK, VSSSEG3E16_V }, // 11411
  { PseudoVSSSEG3E32_V_M1, VSSSEG3E32_V }, // 11412
  { PseudoVSSSEG3E32_V_M1_MASK, VSSSEG3E32_V }, // 11413
  { PseudoVSSSEG3E32_V_M2, VSSSEG3E32_V }, // 11414
  { PseudoVSSSEG3E32_V_M2_MASK, VSSSEG3E32_V }, // 11415
  { PseudoVSSSEG3E32_V_MF2, VSSSEG3E32_V }, // 11416
  { PseudoVSSSEG3E32_V_MF2_MASK, VSSSEG3E32_V }, // 11417
  { PseudoVSSSEG3E64_V_M1, VSSSEG3E64_V }, // 11418
  { PseudoVSSSEG3E64_V_M1_MASK, VSSSEG3E64_V }, // 11419
  { PseudoVSSSEG3E64_V_M2, VSSSEG3E64_V }, // 11420
  { PseudoVSSSEG3E64_V_M2_MASK, VSSSEG3E64_V }, // 11421
  { PseudoVSSSEG3E8_V_M1, VSSSEG3E8_V }, // 11422
  { PseudoVSSSEG3E8_V_M1_MASK, VSSSEG3E8_V }, // 11423
  { PseudoVSSSEG3E8_V_M2, VSSSEG3E8_V }, // 11424
  { PseudoVSSSEG3E8_V_M2_MASK, VSSSEG3E8_V }, // 11425
  { PseudoVSSSEG3E8_V_MF2, VSSSEG3E8_V }, // 11426
  { PseudoVSSSEG3E8_V_MF2_MASK, VSSSEG3E8_V }, // 11427
  { PseudoVSSSEG3E8_V_MF4, VSSSEG3E8_V }, // 11428
  { PseudoVSSSEG3E8_V_MF4_MASK, VSSSEG3E8_V }, // 11429
  { PseudoVSSSEG3E8_V_MF8, VSSSEG3E8_V }, // 11430
  { PseudoVSSSEG3E8_V_MF8_MASK, VSSSEG3E8_V }, // 11431
  { PseudoVSSSEG4E16_V_M1, VSSSEG4E16_V }, // 11432
  { PseudoVSSSEG4E16_V_M1_MASK, VSSSEG4E16_V }, // 11433
  { PseudoVSSSEG4E16_V_M2, VSSSEG4E16_V }, // 11434
  { PseudoVSSSEG4E16_V_M2_MASK, VSSSEG4E16_V }, // 11435
  { PseudoVSSSEG4E16_V_MF2, VSSSEG4E16_V }, // 11436
  { PseudoVSSSEG4E16_V_MF2_MASK, VSSSEG4E16_V }, // 11437
  { PseudoVSSSEG4E16_V_MF4, VSSSEG4E16_V }, // 11438
  { PseudoVSSSEG4E16_V_MF4_MASK, VSSSEG4E16_V }, // 11439
  { PseudoVSSSEG4E32_V_M1, VSSSEG4E32_V }, // 11440
  { PseudoVSSSEG4E32_V_M1_MASK, VSSSEG4E32_V }, // 11441
  { PseudoVSSSEG4E32_V_M2, VSSSEG4E32_V }, // 11442
  { PseudoVSSSEG4E32_V_M2_MASK, VSSSEG4E32_V }, // 11443
  { PseudoVSSSEG4E32_V_MF2, VSSSEG4E32_V }, // 11444
  { PseudoVSSSEG4E32_V_MF2_MASK, VSSSEG4E32_V }, // 11445
  { PseudoVSSSEG4E64_V_M1, VSSSEG4E64_V }, // 11446
  { PseudoVSSSEG4E64_V_M1_MASK, VSSSEG4E64_V }, // 11447
  { PseudoVSSSEG4E64_V_M2, VSSSEG4E64_V }, // 11448
  { PseudoVSSSEG4E64_V_M2_MASK, VSSSEG4E64_V }, // 11449
  { PseudoVSSSEG4E8_V_M1, VSSSEG4E8_V }, // 11450
  { PseudoVSSSEG4E8_V_M1_MASK, VSSSEG4E8_V }, // 11451
  { PseudoVSSSEG4E8_V_M2, VSSSEG4E8_V }, // 11452
  { PseudoVSSSEG4E8_V_M2_MASK, VSSSEG4E8_V }, // 11453
  { PseudoVSSSEG4E8_V_MF2, VSSSEG4E8_V }, // 11454
  { PseudoVSSSEG4E8_V_MF2_MASK, VSSSEG4E8_V }, // 11455
  { PseudoVSSSEG4E8_V_MF4, VSSSEG4E8_V }, // 11456
  { PseudoVSSSEG4E8_V_MF4_MASK, VSSSEG4E8_V }, // 11457
  { PseudoVSSSEG4E8_V_MF8, VSSSEG4E8_V }, // 11458
  { PseudoVSSSEG4E8_V_MF8_MASK, VSSSEG4E8_V }, // 11459
  { PseudoVSSSEG5E16_V_M1, VSSSEG5E16_V }, // 11460
  { PseudoVSSSEG5E16_V_M1_MASK, VSSSEG5E16_V }, // 11461
  { PseudoVSSSEG5E16_V_MF2, VSSSEG5E16_V }, // 11462
  { PseudoVSSSEG5E16_V_MF2_MASK, VSSSEG5E16_V }, // 11463
  { PseudoVSSSEG5E16_V_MF4, VSSSEG5E16_V }, // 11464
  { PseudoVSSSEG5E16_V_MF4_MASK, VSSSEG5E16_V }, // 11465
  { PseudoVSSSEG5E32_V_M1, VSSSEG5E32_V }, // 11466
  { PseudoVSSSEG5E32_V_M1_MASK, VSSSEG5E32_V }, // 11467
  { PseudoVSSSEG5E32_V_MF2, VSSSEG5E32_V }, // 11468
  { PseudoVSSSEG5E32_V_MF2_MASK, VSSSEG5E32_V }, // 11469
  { PseudoVSSSEG5E64_V_M1, VSSSEG5E64_V }, // 11470
  { PseudoVSSSEG5E64_V_M1_MASK, VSSSEG5E64_V }, // 11471
  { PseudoVSSSEG5E8_V_M1, VSSSEG5E8_V }, // 11472
  { PseudoVSSSEG5E8_V_M1_MASK, VSSSEG5E8_V }, // 11473
  { PseudoVSSSEG5E8_V_MF2, VSSSEG5E8_V }, // 11474
  { PseudoVSSSEG5E8_V_MF2_MASK, VSSSEG5E8_V }, // 11475
  { PseudoVSSSEG5E8_V_MF4, VSSSEG5E8_V }, // 11476
  { PseudoVSSSEG5E8_V_MF4_MASK, VSSSEG5E8_V }, // 11477
  { PseudoVSSSEG5E8_V_MF8, VSSSEG5E8_V }, // 11478
  { PseudoVSSSEG5E8_V_MF8_MASK, VSSSEG5E8_V }, // 11479
  { PseudoVSSSEG6E16_V_M1, VSSSEG6E16_V }, // 11480
  { PseudoVSSSEG6E16_V_M1_MASK, VSSSEG6E16_V }, // 11481
  { PseudoVSSSEG6E16_V_MF2, VSSSEG6E16_V }, // 11482
  { PseudoVSSSEG6E16_V_MF2_MASK, VSSSEG6E16_V }, // 11483
  { PseudoVSSSEG6E16_V_MF4, VSSSEG6E16_V }, // 11484
  { PseudoVSSSEG6E16_V_MF4_MASK, VSSSEG6E16_V }, // 11485
  { PseudoVSSSEG6E32_V_M1, VSSSEG6E32_V }, // 11486
  { PseudoVSSSEG6E32_V_M1_MASK, VSSSEG6E32_V }, // 11487
  { PseudoVSSSEG6E32_V_MF2, VSSSEG6E32_V }, // 11488
  { PseudoVSSSEG6E32_V_MF2_MASK, VSSSEG6E32_V }, // 11489
  { PseudoVSSSEG6E64_V_M1, VSSSEG6E64_V }, // 11490
  { PseudoVSSSEG6E64_V_M1_MASK, VSSSEG6E64_V }, // 11491
  { PseudoVSSSEG6E8_V_M1, VSSSEG6E8_V }, // 11492
  { PseudoVSSSEG6E8_V_M1_MASK, VSSSEG6E8_V }, // 11493
  { PseudoVSSSEG6E8_V_MF2, VSSSEG6E8_V }, // 11494
  { PseudoVSSSEG6E8_V_MF2_MASK, VSSSEG6E8_V }, // 11495
  { PseudoVSSSEG6E8_V_MF4, VSSSEG6E8_V }, // 11496
  { PseudoVSSSEG6E8_V_MF4_MASK, VSSSEG6E8_V }, // 11497
  { PseudoVSSSEG6E8_V_MF8, VSSSEG6E8_V }, // 11498
  { PseudoVSSSEG6E8_V_MF8_MASK, VSSSEG6E8_V }, // 11499
  { PseudoVSSSEG7E16_V_M1, VSSSEG7E16_V }, // 11500
  { PseudoVSSSEG7E16_V_M1_MASK, VSSSEG7E16_V }, // 11501
  { PseudoVSSSEG7E16_V_MF2, VSSSEG7E16_V }, // 11502
  { PseudoVSSSEG7E16_V_MF2_MASK, VSSSEG7E16_V }, // 11503
  { PseudoVSSSEG7E16_V_MF4, VSSSEG7E16_V }, // 11504
  { PseudoVSSSEG7E16_V_MF4_MASK, VSSSEG7E16_V }, // 11505
  { PseudoVSSSEG7E32_V_M1, VSSSEG7E32_V }, // 11506
  { PseudoVSSSEG7E32_V_M1_MASK, VSSSEG7E32_V }, // 11507
  { PseudoVSSSEG7E32_V_MF2, VSSSEG7E32_V }, // 11508
  { PseudoVSSSEG7E32_V_MF2_MASK, VSSSEG7E32_V }, // 11509
  { PseudoVSSSEG7E64_V_M1, VSSSEG7E64_V }, // 11510
  { PseudoVSSSEG7E64_V_M1_MASK, VSSSEG7E64_V }, // 11511
  { PseudoVSSSEG7E8_V_M1, VSSSEG7E8_V }, // 11512
  { PseudoVSSSEG7E8_V_M1_MASK, VSSSEG7E8_V }, // 11513
  { PseudoVSSSEG7E8_V_MF2, VSSSEG7E8_V }, // 11514
  { PseudoVSSSEG7E8_V_MF2_MASK, VSSSEG7E8_V }, // 11515
  { PseudoVSSSEG7E8_V_MF4, VSSSEG7E8_V }, // 11516
  { PseudoVSSSEG7E8_V_MF4_MASK, VSSSEG7E8_V }, // 11517
  { PseudoVSSSEG7E8_V_MF8, VSSSEG7E8_V }, // 11518
  { PseudoVSSSEG7E8_V_MF8_MASK, VSSSEG7E8_V }, // 11519
  { PseudoVSSSEG8E16_V_M1, VSSSEG8E16_V }, // 11520
  { PseudoVSSSEG8E16_V_M1_MASK, VSSSEG8E16_V }, // 11521
  { PseudoVSSSEG8E16_V_MF2, VSSSEG8E16_V }, // 11522
  { PseudoVSSSEG8E16_V_MF2_MASK, VSSSEG8E16_V }, // 11523
  { PseudoVSSSEG8E16_V_MF4, VSSSEG8E16_V }, // 11524
  { PseudoVSSSEG8E16_V_MF4_MASK, VSSSEG8E16_V }, // 11525
  { PseudoVSSSEG8E32_V_M1, VSSSEG8E32_V }, // 11526
  { PseudoVSSSEG8E32_V_M1_MASK, VSSSEG8E32_V }, // 11527
  { PseudoVSSSEG8E32_V_MF2, VSSSEG8E32_V }, // 11528
  { PseudoVSSSEG8E32_V_MF2_MASK, VSSSEG8E32_V }, // 11529
  { PseudoVSSSEG8E64_V_M1, VSSSEG8E64_V }, // 11530
  { PseudoVSSSEG8E64_V_M1_MASK, VSSSEG8E64_V }, // 11531
  { PseudoVSSSEG8E8_V_M1, VSSSEG8E8_V }, // 11532
  { PseudoVSSSEG8E8_V_M1_MASK, VSSSEG8E8_V }, // 11533
  { PseudoVSSSEG8E8_V_MF2, VSSSEG8E8_V }, // 11534
  { PseudoVSSSEG8E8_V_MF2_MASK, VSSSEG8E8_V }, // 11535
  { PseudoVSSSEG8E8_V_MF4, VSSSEG8E8_V }, // 11536
  { PseudoVSSSEG8E8_V_MF4_MASK, VSSSEG8E8_V }, // 11537
  { PseudoVSSSEG8E8_V_MF8, VSSSEG8E8_V }, // 11538
  { PseudoVSSSEG8E8_V_MF8_MASK, VSSSEG8E8_V }, // 11539
  { PseudoVSSUBU_VV_M1, VSSUBU_VV }, // 11540
  { PseudoVSSUBU_VV_M1_MASK, VSSUBU_VV }, // 11541
  { PseudoVSSUBU_VV_M2, VSSUBU_VV }, // 11542
  { PseudoVSSUBU_VV_M2_MASK, VSSUBU_VV }, // 11543
  { PseudoVSSUBU_VV_M4, VSSUBU_VV }, // 11544
  { PseudoVSSUBU_VV_M4_MASK, VSSUBU_VV }, // 11545
  { PseudoVSSUBU_VV_M8, VSSUBU_VV }, // 11546
  { PseudoVSSUBU_VV_M8_MASK, VSSUBU_VV }, // 11547
  { PseudoVSSUBU_VV_MF2, VSSUBU_VV }, // 11548
  { PseudoVSSUBU_VV_MF2_MASK, VSSUBU_VV }, // 11549
  { PseudoVSSUBU_VV_MF4, VSSUBU_VV }, // 11550
  { PseudoVSSUBU_VV_MF4_MASK, VSSUBU_VV }, // 11551
  { PseudoVSSUBU_VV_MF8, VSSUBU_VV }, // 11552
  { PseudoVSSUBU_VV_MF8_MASK, VSSUBU_VV }, // 11553
  { PseudoVSSUBU_VX_M1, VSSUBU_VX }, // 11554
  { PseudoVSSUBU_VX_M1_MASK, VSSUBU_VX }, // 11555
  { PseudoVSSUBU_VX_M2, VSSUBU_VX }, // 11556
  { PseudoVSSUBU_VX_M2_MASK, VSSUBU_VX }, // 11557
  { PseudoVSSUBU_VX_M4, VSSUBU_VX }, // 11558
  { PseudoVSSUBU_VX_M4_MASK, VSSUBU_VX }, // 11559
  { PseudoVSSUBU_VX_M8, VSSUBU_VX }, // 11560
  { PseudoVSSUBU_VX_M8_MASK, VSSUBU_VX }, // 11561
  { PseudoVSSUBU_VX_MF2, VSSUBU_VX }, // 11562
  { PseudoVSSUBU_VX_MF2_MASK, VSSUBU_VX }, // 11563
  { PseudoVSSUBU_VX_MF4, VSSUBU_VX }, // 11564
  { PseudoVSSUBU_VX_MF4_MASK, VSSUBU_VX }, // 11565
  { PseudoVSSUBU_VX_MF8, VSSUBU_VX }, // 11566
  { PseudoVSSUBU_VX_MF8_MASK, VSSUBU_VX }, // 11567
  { PseudoVSSUB_VV_M1, VSSUB_VV }, // 11568
  { PseudoVSSUB_VV_M1_MASK, VSSUB_VV }, // 11569
  { PseudoVSSUB_VV_M2, VSSUB_VV }, // 11570
  { PseudoVSSUB_VV_M2_MASK, VSSUB_VV }, // 11571
  { PseudoVSSUB_VV_M4, VSSUB_VV }, // 11572
  { PseudoVSSUB_VV_M4_MASK, VSSUB_VV }, // 11573
  { PseudoVSSUB_VV_M8, VSSUB_VV }, // 11574
  { PseudoVSSUB_VV_M8_MASK, VSSUB_VV }, // 11575
  { PseudoVSSUB_VV_MF2, VSSUB_VV }, // 11576
  { PseudoVSSUB_VV_MF2_MASK, VSSUB_VV }, // 11577
  { PseudoVSSUB_VV_MF4, VSSUB_VV }, // 11578
  { PseudoVSSUB_VV_MF4_MASK, VSSUB_VV }, // 11579
  { PseudoVSSUB_VV_MF8, VSSUB_VV }, // 11580
  { PseudoVSSUB_VV_MF8_MASK, VSSUB_VV }, // 11581
  { PseudoVSSUB_VX_M1, VSSUB_VX }, // 11582
  { PseudoVSSUB_VX_M1_MASK, VSSUB_VX }, // 11583
  { PseudoVSSUB_VX_M2, VSSUB_VX }, // 11584
  { PseudoVSSUB_VX_M2_MASK, VSSUB_VX }, // 11585
  { PseudoVSSUB_VX_M4, VSSUB_VX }, // 11586
  { PseudoVSSUB_VX_M4_MASK, VSSUB_VX }, // 11587
  { PseudoVSSUB_VX_M8, VSSUB_VX }, // 11588
  { PseudoVSSUB_VX_M8_MASK, VSSUB_VX }, // 11589
  { PseudoVSSUB_VX_MF2, VSSUB_VX }, // 11590
  { PseudoVSSUB_VX_MF2_MASK, VSSUB_VX }, // 11591
  { PseudoVSSUB_VX_MF4, VSSUB_VX }, // 11592
  { PseudoVSSUB_VX_MF4_MASK, VSSUB_VX }, // 11593
  { PseudoVSSUB_VX_MF8, VSSUB_VX }, // 11594
  { PseudoVSSUB_VX_MF8_MASK, VSSUB_VX }, // 11595
  { PseudoVSUB_VV_M1, VSUB_VV }, // 11596
  { PseudoVSUB_VV_M1_MASK, VSUB_VV }, // 11597
  { PseudoVSUB_VV_M2, VSUB_VV }, // 11598
  { PseudoVSUB_VV_M2_MASK, VSUB_VV }, // 11599
  { PseudoVSUB_VV_M4, VSUB_VV }, // 11600
  { PseudoVSUB_VV_M4_MASK, VSUB_VV }, // 11601
  { PseudoVSUB_VV_M8, VSUB_VV }, // 11602
  { PseudoVSUB_VV_M8_MASK, VSUB_VV }, // 11603
  { PseudoVSUB_VV_MF2, VSUB_VV }, // 11604
  { PseudoVSUB_VV_MF2_MASK, VSUB_VV }, // 11605
  { PseudoVSUB_VV_MF4, VSUB_VV }, // 11606
  { PseudoVSUB_VV_MF4_MASK, VSUB_VV }, // 11607
  { PseudoVSUB_VV_MF8, VSUB_VV }, // 11608
  { PseudoVSUB_VV_MF8_MASK, VSUB_VV }, // 11609
  { PseudoVSUB_VX_M1, VSUB_VX }, // 11610
  { PseudoVSUB_VX_M1_MASK, VSUB_VX }, // 11611
  { PseudoVSUB_VX_M2, VSUB_VX }, // 11612
  { PseudoVSUB_VX_M2_MASK, VSUB_VX }, // 11613
  { PseudoVSUB_VX_M4, VSUB_VX }, // 11614
  { PseudoVSUB_VX_M4_MASK, VSUB_VX }, // 11615
  { PseudoVSUB_VX_M8, VSUB_VX }, // 11616
  { PseudoVSUB_VX_M8_MASK, VSUB_VX }, // 11617
  { PseudoVSUB_VX_MF2, VSUB_VX }, // 11618
  { PseudoVSUB_VX_MF2_MASK, VSUB_VX }, // 11619
  { PseudoVSUB_VX_MF4, VSUB_VX }, // 11620
  { PseudoVSUB_VX_MF4_MASK, VSUB_VX }, // 11621
  { PseudoVSUB_VX_MF8, VSUB_VX }, // 11622
  { PseudoVSUB_VX_MF8_MASK, VSUB_VX }, // 11623
  { PseudoVSUXEI16_V_M1_M1, VSUXEI16_V }, // 11624
  { PseudoVSUXEI16_V_M1_M1_MASK, VSUXEI16_V }, // 11625
  { PseudoVSUXEI16_V_M1_M2, VSUXEI16_V }, // 11626
  { PseudoVSUXEI16_V_M1_M2_MASK, VSUXEI16_V }, // 11627
  { PseudoVSUXEI16_V_M1_M4, VSUXEI16_V }, // 11628
  { PseudoVSUXEI16_V_M1_M4_MASK, VSUXEI16_V }, // 11629
  { PseudoVSUXEI16_V_M1_M8, VSUXEI16_V }, // 11630
  { PseudoVSUXEI16_V_M1_M8_MASK, VSUXEI16_V }, // 11631
  { PseudoVSUXEI16_V_M1_MF2, VSUXEI16_V }, // 11632
  { PseudoVSUXEI16_V_M1_MF2_MASK, VSUXEI16_V }, // 11633
  { PseudoVSUXEI16_V_M1_MF4, VSUXEI16_V }, // 11634
  { PseudoVSUXEI16_V_M1_MF4_MASK, VSUXEI16_V }, // 11635
  { PseudoVSUXEI16_V_M1_MF8, VSUXEI16_V }, // 11636
  { PseudoVSUXEI16_V_M1_MF8_MASK, VSUXEI16_V }, // 11637
  { PseudoVSUXEI16_V_M2_M1, VSUXEI16_V }, // 11638
  { PseudoVSUXEI16_V_M2_M1_MASK, VSUXEI16_V }, // 11639
  { PseudoVSUXEI16_V_M2_M2, VSUXEI16_V }, // 11640
  { PseudoVSUXEI16_V_M2_M2_MASK, VSUXEI16_V }, // 11641
  { PseudoVSUXEI16_V_M2_M4, VSUXEI16_V }, // 11642
  { PseudoVSUXEI16_V_M2_M4_MASK, VSUXEI16_V }, // 11643
  { PseudoVSUXEI16_V_M2_M8, VSUXEI16_V }, // 11644
  { PseudoVSUXEI16_V_M2_M8_MASK, VSUXEI16_V }, // 11645
  { PseudoVSUXEI16_V_M2_MF2, VSUXEI16_V }, // 11646
  { PseudoVSUXEI16_V_M2_MF2_MASK, VSUXEI16_V }, // 11647
  { PseudoVSUXEI16_V_M2_MF4, VSUXEI16_V }, // 11648
  { PseudoVSUXEI16_V_M2_MF4_MASK, VSUXEI16_V }, // 11649
  { PseudoVSUXEI16_V_M2_MF8, VSUXEI16_V }, // 11650
  { PseudoVSUXEI16_V_M2_MF8_MASK, VSUXEI16_V }, // 11651
  { PseudoVSUXEI16_V_M4_M1, VSUXEI16_V }, // 11652
  { PseudoVSUXEI16_V_M4_M1_MASK, VSUXEI16_V }, // 11653
  { PseudoVSUXEI16_V_M4_M2, VSUXEI16_V }, // 11654
  { PseudoVSUXEI16_V_M4_M2_MASK, VSUXEI16_V }, // 11655
  { PseudoVSUXEI16_V_M4_M4, VSUXEI16_V }, // 11656
  { PseudoVSUXEI16_V_M4_M4_MASK, VSUXEI16_V }, // 11657
  { PseudoVSUXEI16_V_M4_M8, VSUXEI16_V }, // 11658
  { PseudoVSUXEI16_V_M4_M8_MASK, VSUXEI16_V }, // 11659
  { PseudoVSUXEI16_V_M4_MF2, VSUXEI16_V }, // 11660
  { PseudoVSUXEI16_V_M4_MF2_MASK, VSUXEI16_V }, // 11661
  { PseudoVSUXEI16_V_M4_MF4, VSUXEI16_V }, // 11662
  { PseudoVSUXEI16_V_M4_MF4_MASK, VSUXEI16_V }, // 11663
  { PseudoVSUXEI16_V_M4_MF8, VSUXEI16_V }, // 11664
  { PseudoVSUXEI16_V_M4_MF8_MASK, VSUXEI16_V }, // 11665
  { PseudoVSUXEI16_V_M8_M1, VSUXEI16_V }, // 11666
  { PseudoVSUXEI16_V_M8_M1_MASK, VSUXEI16_V }, // 11667
  { PseudoVSUXEI16_V_M8_M2, VSUXEI16_V }, // 11668
  { PseudoVSUXEI16_V_M8_M2_MASK, VSUXEI16_V }, // 11669
  { PseudoVSUXEI16_V_M8_M4, VSUXEI16_V }, // 11670
  { PseudoVSUXEI16_V_M8_M4_MASK, VSUXEI16_V }, // 11671
  { PseudoVSUXEI16_V_M8_M8, VSUXEI16_V }, // 11672
  { PseudoVSUXEI16_V_M8_M8_MASK, VSUXEI16_V }, // 11673
  { PseudoVSUXEI16_V_M8_MF2, VSUXEI16_V }, // 11674
  { PseudoVSUXEI16_V_M8_MF2_MASK, VSUXEI16_V }, // 11675
  { PseudoVSUXEI16_V_M8_MF4, VSUXEI16_V }, // 11676
  { PseudoVSUXEI16_V_M8_MF4_MASK, VSUXEI16_V }, // 11677
  { PseudoVSUXEI16_V_M8_MF8, VSUXEI16_V }, // 11678
  { PseudoVSUXEI16_V_M8_MF8_MASK, VSUXEI16_V }, // 11679
  { PseudoVSUXEI16_V_MF2_M1, VSUXEI16_V }, // 11680
  { PseudoVSUXEI16_V_MF2_M1_MASK, VSUXEI16_V }, // 11681
  { PseudoVSUXEI16_V_MF2_M2, VSUXEI16_V }, // 11682
  { PseudoVSUXEI16_V_MF2_M2_MASK, VSUXEI16_V }, // 11683
  { PseudoVSUXEI16_V_MF2_M4, VSUXEI16_V }, // 11684
  { PseudoVSUXEI16_V_MF2_M4_MASK, VSUXEI16_V }, // 11685
  { PseudoVSUXEI16_V_MF2_M8, VSUXEI16_V }, // 11686
  { PseudoVSUXEI16_V_MF2_M8_MASK, VSUXEI16_V }, // 11687
  { PseudoVSUXEI16_V_MF2_MF2, VSUXEI16_V }, // 11688
  { PseudoVSUXEI16_V_MF2_MF2_MASK, VSUXEI16_V }, // 11689
  { PseudoVSUXEI16_V_MF2_MF4, VSUXEI16_V }, // 11690
  { PseudoVSUXEI16_V_MF2_MF4_MASK, VSUXEI16_V }, // 11691
  { PseudoVSUXEI16_V_MF2_MF8, VSUXEI16_V }, // 11692
  { PseudoVSUXEI16_V_MF2_MF8_MASK, VSUXEI16_V }, // 11693
  { PseudoVSUXEI16_V_MF4_M1, VSUXEI16_V }, // 11694
  { PseudoVSUXEI16_V_MF4_M1_MASK, VSUXEI16_V }, // 11695
  { PseudoVSUXEI16_V_MF4_M2, VSUXEI16_V }, // 11696
  { PseudoVSUXEI16_V_MF4_M2_MASK, VSUXEI16_V }, // 11697
  { PseudoVSUXEI16_V_MF4_M4, VSUXEI16_V }, // 11698
  { PseudoVSUXEI16_V_MF4_M4_MASK, VSUXEI16_V }, // 11699
  { PseudoVSUXEI16_V_MF4_M8, VSUXEI16_V }, // 11700
  { PseudoVSUXEI16_V_MF4_M8_MASK, VSUXEI16_V }, // 11701
  { PseudoVSUXEI16_V_MF4_MF2, VSUXEI16_V }, // 11702
  { PseudoVSUXEI16_V_MF4_MF2_MASK, VSUXEI16_V }, // 11703
  { PseudoVSUXEI16_V_MF4_MF4, VSUXEI16_V }, // 11704
  { PseudoVSUXEI16_V_MF4_MF4_MASK, VSUXEI16_V }, // 11705
  { PseudoVSUXEI16_V_MF4_MF8, VSUXEI16_V }, // 11706
  { PseudoVSUXEI16_V_MF4_MF8_MASK, VSUXEI16_V }, // 11707
  { PseudoVSUXEI16_V_MF8_M1, VSUXEI16_V }, // 11708
  { PseudoVSUXEI16_V_MF8_M1_MASK, VSUXEI16_V }, // 11709
  { PseudoVSUXEI16_V_MF8_M2, VSUXEI16_V }, // 11710
  { PseudoVSUXEI16_V_MF8_M2_MASK, VSUXEI16_V }, // 11711
  { PseudoVSUXEI16_V_MF8_M4, VSUXEI16_V }, // 11712
  { PseudoVSUXEI16_V_MF8_M4_MASK, VSUXEI16_V }, // 11713
  { PseudoVSUXEI16_V_MF8_M8, VSUXEI16_V }, // 11714
  { PseudoVSUXEI16_V_MF8_M8_MASK, VSUXEI16_V }, // 11715
  { PseudoVSUXEI16_V_MF8_MF2, VSUXEI16_V }, // 11716
  { PseudoVSUXEI16_V_MF8_MF2_MASK, VSUXEI16_V }, // 11717
  { PseudoVSUXEI16_V_MF8_MF4, VSUXEI16_V }, // 11718
  { PseudoVSUXEI16_V_MF8_MF4_MASK, VSUXEI16_V }, // 11719
  { PseudoVSUXEI16_V_MF8_MF8, VSUXEI16_V }, // 11720
  { PseudoVSUXEI16_V_MF8_MF8_MASK, VSUXEI16_V }, // 11721
  { PseudoVSUXEI32_V_M1_M1, VSUXEI32_V }, // 11722
  { PseudoVSUXEI32_V_M1_M1_MASK, VSUXEI32_V }, // 11723
  { PseudoVSUXEI32_V_M1_M2, VSUXEI32_V }, // 11724
  { PseudoVSUXEI32_V_M1_M2_MASK, VSUXEI32_V }, // 11725
  { PseudoVSUXEI32_V_M1_M4, VSUXEI32_V }, // 11726
  { PseudoVSUXEI32_V_M1_M4_MASK, VSUXEI32_V }, // 11727
  { PseudoVSUXEI32_V_M1_M8, VSUXEI32_V }, // 11728
  { PseudoVSUXEI32_V_M1_M8_MASK, VSUXEI32_V }, // 11729
  { PseudoVSUXEI32_V_M1_MF2, VSUXEI32_V }, // 11730
  { PseudoVSUXEI32_V_M1_MF2_MASK, VSUXEI32_V }, // 11731
  { PseudoVSUXEI32_V_M1_MF4, VSUXEI32_V }, // 11732
  { PseudoVSUXEI32_V_M1_MF4_MASK, VSUXEI32_V }, // 11733
  { PseudoVSUXEI32_V_M1_MF8, VSUXEI32_V }, // 11734
  { PseudoVSUXEI32_V_M1_MF8_MASK, VSUXEI32_V }, // 11735
  { PseudoVSUXEI32_V_M2_M1, VSUXEI32_V }, // 11736
  { PseudoVSUXEI32_V_M2_M1_MASK, VSUXEI32_V }, // 11737
  { PseudoVSUXEI32_V_M2_M2, VSUXEI32_V }, // 11738
  { PseudoVSUXEI32_V_M2_M2_MASK, VSUXEI32_V }, // 11739
  { PseudoVSUXEI32_V_M2_M4, VSUXEI32_V }, // 11740
  { PseudoVSUXEI32_V_M2_M4_MASK, VSUXEI32_V }, // 11741
  { PseudoVSUXEI32_V_M2_M8, VSUXEI32_V }, // 11742
  { PseudoVSUXEI32_V_M2_M8_MASK, VSUXEI32_V }, // 11743
  { PseudoVSUXEI32_V_M2_MF2, VSUXEI32_V }, // 11744
  { PseudoVSUXEI32_V_M2_MF2_MASK, VSUXEI32_V }, // 11745
  { PseudoVSUXEI32_V_M2_MF4, VSUXEI32_V }, // 11746
  { PseudoVSUXEI32_V_M2_MF4_MASK, VSUXEI32_V }, // 11747
  { PseudoVSUXEI32_V_M2_MF8, VSUXEI32_V }, // 11748
  { PseudoVSUXEI32_V_M2_MF8_MASK, VSUXEI32_V }, // 11749
  { PseudoVSUXEI32_V_M4_M1, VSUXEI32_V }, // 11750
  { PseudoVSUXEI32_V_M4_M1_MASK, VSUXEI32_V }, // 11751
  { PseudoVSUXEI32_V_M4_M2, VSUXEI32_V }, // 11752
  { PseudoVSUXEI32_V_M4_M2_MASK, VSUXEI32_V }, // 11753
  { PseudoVSUXEI32_V_M4_M4, VSUXEI32_V }, // 11754
  { PseudoVSUXEI32_V_M4_M4_MASK, VSUXEI32_V }, // 11755
  { PseudoVSUXEI32_V_M4_M8, VSUXEI32_V }, // 11756
  { PseudoVSUXEI32_V_M4_M8_MASK, VSUXEI32_V }, // 11757
  { PseudoVSUXEI32_V_M4_MF2, VSUXEI32_V }, // 11758
  { PseudoVSUXEI32_V_M4_MF2_MASK, VSUXEI32_V }, // 11759
  { PseudoVSUXEI32_V_M4_MF4, VSUXEI32_V }, // 11760
  { PseudoVSUXEI32_V_M4_MF4_MASK, VSUXEI32_V }, // 11761
  { PseudoVSUXEI32_V_M4_MF8, VSUXEI32_V }, // 11762
  { PseudoVSUXEI32_V_M4_MF8_MASK, VSUXEI32_V }, // 11763
  { PseudoVSUXEI32_V_M8_M1, VSUXEI32_V }, // 11764
  { PseudoVSUXEI32_V_M8_M1_MASK, VSUXEI32_V }, // 11765
  { PseudoVSUXEI32_V_M8_M2, VSUXEI32_V }, // 11766
  { PseudoVSUXEI32_V_M8_M2_MASK, VSUXEI32_V }, // 11767
  { PseudoVSUXEI32_V_M8_M4, VSUXEI32_V }, // 11768
  { PseudoVSUXEI32_V_M8_M4_MASK, VSUXEI32_V }, // 11769
  { PseudoVSUXEI32_V_M8_M8, VSUXEI32_V }, // 11770
  { PseudoVSUXEI32_V_M8_M8_MASK, VSUXEI32_V }, // 11771
  { PseudoVSUXEI32_V_M8_MF2, VSUXEI32_V }, // 11772
  { PseudoVSUXEI32_V_M8_MF2_MASK, VSUXEI32_V }, // 11773
  { PseudoVSUXEI32_V_M8_MF4, VSUXEI32_V }, // 11774
  { PseudoVSUXEI32_V_M8_MF4_MASK, VSUXEI32_V }, // 11775
  { PseudoVSUXEI32_V_M8_MF8, VSUXEI32_V }, // 11776
  { PseudoVSUXEI32_V_M8_MF8_MASK, VSUXEI32_V }, // 11777
  { PseudoVSUXEI32_V_MF2_M1, VSUXEI32_V }, // 11778
  { PseudoVSUXEI32_V_MF2_M1_MASK, VSUXEI32_V }, // 11779
  { PseudoVSUXEI32_V_MF2_M2, VSUXEI32_V }, // 11780
  { PseudoVSUXEI32_V_MF2_M2_MASK, VSUXEI32_V }, // 11781
  { PseudoVSUXEI32_V_MF2_M4, VSUXEI32_V }, // 11782
  { PseudoVSUXEI32_V_MF2_M4_MASK, VSUXEI32_V }, // 11783
  { PseudoVSUXEI32_V_MF2_M8, VSUXEI32_V }, // 11784
  { PseudoVSUXEI32_V_MF2_M8_MASK, VSUXEI32_V }, // 11785
  { PseudoVSUXEI32_V_MF2_MF2, VSUXEI32_V }, // 11786
  { PseudoVSUXEI32_V_MF2_MF2_MASK, VSUXEI32_V }, // 11787
  { PseudoVSUXEI32_V_MF2_MF4, VSUXEI32_V }, // 11788
  { PseudoVSUXEI32_V_MF2_MF4_MASK, VSUXEI32_V }, // 11789
  { PseudoVSUXEI32_V_MF2_MF8, VSUXEI32_V }, // 11790
  { PseudoVSUXEI32_V_MF2_MF8_MASK, VSUXEI32_V }, // 11791
  { PseudoVSUXEI32_V_MF4_M1, VSUXEI32_V }, // 11792
  { PseudoVSUXEI32_V_MF4_M1_MASK, VSUXEI32_V }, // 11793
  { PseudoVSUXEI32_V_MF4_M2, VSUXEI32_V }, // 11794
  { PseudoVSUXEI32_V_MF4_M2_MASK, VSUXEI32_V }, // 11795
  { PseudoVSUXEI32_V_MF4_M4, VSUXEI32_V }, // 11796
  { PseudoVSUXEI32_V_MF4_M4_MASK, VSUXEI32_V }, // 11797
  { PseudoVSUXEI32_V_MF4_M8, VSUXEI32_V }, // 11798
  { PseudoVSUXEI32_V_MF4_M8_MASK, VSUXEI32_V }, // 11799
  { PseudoVSUXEI32_V_MF4_MF2, VSUXEI32_V }, // 11800
  { PseudoVSUXEI32_V_MF4_MF2_MASK, VSUXEI32_V }, // 11801
  { PseudoVSUXEI32_V_MF4_MF4, VSUXEI32_V }, // 11802
  { PseudoVSUXEI32_V_MF4_MF4_MASK, VSUXEI32_V }, // 11803
  { PseudoVSUXEI32_V_MF4_MF8, VSUXEI32_V }, // 11804
  { PseudoVSUXEI32_V_MF4_MF8_MASK, VSUXEI32_V }, // 11805
  { PseudoVSUXEI32_V_MF8_M1, VSUXEI32_V }, // 11806
  { PseudoVSUXEI32_V_MF8_M1_MASK, VSUXEI32_V }, // 11807
  { PseudoVSUXEI32_V_MF8_M2, VSUXEI32_V }, // 11808
  { PseudoVSUXEI32_V_MF8_M2_MASK, VSUXEI32_V }, // 11809
  { PseudoVSUXEI32_V_MF8_M4, VSUXEI32_V }, // 11810
  { PseudoVSUXEI32_V_MF8_M4_MASK, VSUXEI32_V }, // 11811
  { PseudoVSUXEI32_V_MF8_M8, VSUXEI32_V }, // 11812
  { PseudoVSUXEI32_V_MF8_M8_MASK, VSUXEI32_V }, // 11813
  { PseudoVSUXEI32_V_MF8_MF2, VSUXEI32_V }, // 11814
  { PseudoVSUXEI32_V_MF8_MF2_MASK, VSUXEI32_V }, // 11815
  { PseudoVSUXEI32_V_MF8_MF4, VSUXEI32_V }, // 11816
  { PseudoVSUXEI32_V_MF8_MF4_MASK, VSUXEI32_V }, // 11817
  { PseudoVSUXEI32_V_MF8_MF8, VSUXEI32_V }, // 11818
  { PseudoVSUXEI32_V_MF8_MF8_MASK, VSUXEI32_V }, // 11819
  { PseudoVSUXEI64_V_M1_M1, VSUXEI64_V }, // 11820
  { PseudoVSUXEI64_V_M1_M1_MASK, VSUXEI64_V }, // 11821
  { PseudoVSUXEI64_V_M1_M2, VSUXEI64_V }, // 11822
  { PseudoVSUXEI64_V_M1_M2_MASK, VSUXEI64_V }, // 11823
  { PseudoVSUXEI64_V_M1_M4, VSUXEI64_V }, // 11824
  { PseudoVSUXEI64_V_M1_M4_MASK, VSUXEI64_V }, // 11825
  { PseudoVSUXEI64_V_M1_M8, VSUXEI64_V }, // 11826
  { PseudoVSUXEI64_V_M1_M8_MASK, VSUXEI64_V }, // 11827
  { PseudoVSUXEI64_V_M1_MF2, VSUXEI64_V }, // 11828
  { PseudoVSUXEI64_V_M1_MF2_MASK, VSUXEI64_V }, // 11829
  { PseudoVSUXEI64_V_M1_MF4, VSUXEI64_V }, // 11830
  { PseudoVSUXEI64_V_M1_MF4_MASK, VSUXEI64_V }, // 11831
  { PseudoVSUXEI64_V_M1_MF8, VSUXEI64_V }, // 11832
  { PseudoVSUXEI64_V_M1_MF8_MASK, VSUXEI64_V }, // 11833
  { PseudoVSUXEI64_V_M2_M1, VSUXEI64_V }, // 11834
  { PseudoVSUXEI64_V_M2_M1_MASK, VSUXEI64_V }, // 11835
  { PseudoVSUXEI64_V_M2_M2, VSUXEI64_V }, // 11836
  { PseudoVSUXEI64_V_M2_M2_MASK, VSUXEI64_V }, // 11837
  { PseudoVSUXEI64_V_M2_M4, VSUXEI64_V }, // 11838
  { PseudoVSUXEI64_V_M2_M4_MASK, VSUXEI64_V }, // 11839
  { PseudoVSUXEI64_V_M2_M8, VSUXEI64_V }, // 11840
  { PseudoVSUXEI64_V_M2_M8_MASK, VSUXEI64_V }, // 11841
  { PseudoVSUXEI64_V_M2_MF2, VSUXEI64_V }, // 11842
  { PseudoVSUXEI64_V_M2_MF2_MASK, VSUXEI64_V }, // 11843
  { PseudoVSUXEI64_V_M2_MF4, VSUXEI64_V }, // 11844
  { PseudoVSUXEI64_V_M2_MF4_MASK, VSUXEI64_V }, // 11845
  { PseudoVSUXEI64_V_M2_MF8, VSUXEI64_V }, // 11846
  { PseudoVSUXEI64_V_M2_MF8_MASK, VSUXEI64_V }, // 11847
  { PseudoVSUXEI64_V_M4_M1, VSUXEI64_V }, // 11848
  { PseudoVSUXEI64_V_M4_M1_MASK, VSUXEI64_V }, // 11849
  { PseudoVSUXEI64_V_M4_M2, VSUXEI64_V }, // 11850
  { PseudoVSUXEI64_V_M4_M2_MASK, VSUXEI64_V }, // 11851
  { PseudoVSUXEI64_V_M4_M4, VSUXEI64_V }, // 11852
  { PseudoVSUXEI64_V_M4_M4_MASK, VSUXEI64_V }, // 11853
  { PseudoVSUXEI64_V_M4_M8, VSUXEI64_V }, // 11854
  { PseudoVSUXEI64_V_M4_M8_MASK, VSUXEI64_V }, // 11855
  { PseudoVSUXEI64_V_M4_MF2, VSUXEI64_V }, // 11856
  { PseudoVSUXEI64_V_M4_MF2_MASK, VSUXEI64_V }, // 11857
  { PseudoVSUXEI64_V_M4_MF4, VSUXEI64_V }, // 11858
  { PseudoVSUXEI64_V_M4_MF4_MASK, VSUXEI64_V }, // 11859
  { PseudoVSUXEI64_V_M4_MF8, VSUXEI64_V }, // 11860
  { PseudoVSUXEI64_V_M4_MF8_MASK, VSUXEI64_V }, // 11861
  { PseudoVSUXEI64_V_M8_M1, VSUXEI64_V }, // 11862
  { PseudoVSUXEI64_V_M8_M1_MASK, VSUXEI64_V }, // 11863
  { PseudoVSUXEI64_V_M8_M2, VSUXEI64_V }, // 11864
  { PseudoVSUXEI64_V_M8_M2_MASK, VSUXEI64_V }, // 11865
  { PseudoVSUXEI64_V_M8_M4, VSUXEI64_V }, // 11866
  { PseudoVSUXEI64_V_M8_M4_MASK, VSUXEI64_V }, // 11867
  { PseudoVSUXEI64_V_M8_M8, VSUXEI64_V }, // 11868
  { PseudoVSUXEI64_V_M8_M8_MASK, VSUXEI64_V }, // 11869
  { PseudoVSUXEI64_V_M8_MF2, VSUXEI64_V }, // 11870
  { PseudoVSUXEI64_V_M8_MF2_MASK, VSUXEI64_V }, // 11871
  { PseudoVSUXEI64_V_M8_MF4, VSUXEI64_V }, // 11872
  { PseudoVSUXEI64_V_M8_MF4_MASK, VSUXEI64_V }, // 11873
  { PseudoVSUXEI64_V_M8_MF8, VSUXEI64_V }, // 11874
  { PseudoVSUXEI64_V_M8_MF8_MASK, VSUXEI64_V }, // 11875
  { PseudoVSUXEI64_V_MF2_M1, VSUXEI64_V }, // 11876
  { PseudoVSUXEI64_V_MF2_M1_MASK, VSUXEI64_V }, // 11877
  { PseudoVSUXEI64_V_MF2_M2, VSUXEI64_V }, // 11878
  { PseudoVSUXEI64_V_MF2_M2_MASK, VSUXEI64_V }, // 11879
  { PseudoVSUXEI64_V_MF2_M4, VSUXEI64_V }, // 11880
  { PseudoVSUXEI64_V_MF2_M4_MASK, VSUXEI64_V }, // 11881
  { PseudoVSUXEI64_V_MF2_M8, VSUXEI64_V }, // 11882
  { PseudoVSUXEI64_V_MF2_M8_MASK, VSUXEI64_V }, // 11883
  { PseudoVSUXEI64_V_MF2_MF2, VSUXEI64_V }, // 11884
  { PseudoVSUXEI64_V_MF2_MF2_MASK, VSUXEI64_V }, // 11885
  { PseudoVSUXEI64_V_MF2_MF4, VSUXEI64_V }, // 11886
  { PseudoVSUXEI64_V_MF2_MF4_MASK, VSUXEI64_V }, // 11887
  { PseudoVSUXEI64_V_MF2_MF8, VSUXEI64_V }, // 11888
  { PseudoVSUXEI64_V_MF2_MF8_MASK, VSUXEI64_V }, // 11889
  { PseudoVSUXEI64_V_MF4_M1, VSUXEI64_V }, // 11890
  { PseudoVSUXEI64_V_MF4_M1_MASK, VSUXEI64_V }, // 11891
  { PseudoVSUXEI64_V_MF4_M2, VSUXEI64_V }, // 11892
  { PseudoVSUXEI64_V_MF4_M2_MASK, VSUXEI64_V }, // 11893
  { PseudoVSUXEI64_V_MF4_M4, VSUXEI64_V }, // 11894
  { PseudoVSUXEI64_V_MF4_M4_MASK, VSUXEI64_V }, // 11895
  { PseudoVSUXEI64_V_MF4_M8, VSUXEI64_V }, // 11896
  { PseudoVSUXEI64_V_MF4_M8_MASK, VSUXEI64_V }, // 11897
  { PseudoVSUXEI64_V_MF4_MF2, VSUXEI64_V }, // 11898
  { PseudoVSUXEI64_V_MF4_MF2_MASK, VSUXEI64_V }, // 11899
  { PseudoVSUXEI64_V_MF4_MF4, VSUXEI64_V }, // 11900
  { PseudoVSUXEI64_V_MF4_MF4_MASK, VSUXEI64_V }, // 11901
  { PseudoVSUXEI64_V_MF4_MF8, VSUXEI64_V }, // 11902
  { PseudoVSUXEI64_V_MF4_MF8_MASK, VSUXEI64_V }, // 11903
  { PseudoVSUXEI64_V_MF8_M1, VSUXEI64_V }, // 11904
  { PseudoVSUXEI64_V_MF8_M1_MASK, VSUXEI64_V }, // 11905
  { PseudoVSUXEI64_V_MF8_M2, VSUXEI64_V }, // 11906
  { PseudoVSUXEI64_V_MF8_M2_MASK, VSUXEI64_V }, // 11907
  { PseudoVSUXEI64_V_MF8_M4, VSUXEI64_V }, // 11908
  { PseudoVSUXEI64_V_MF8_M4_MASK, VSUXEI64_V }, // 11909
  { PseudoVSUXEI64_V_MF8_M8, VSUXEI64_V }, // 11910
  { PseudoVSUXEI64_V_MF8_M8_MASK, VSUXEI64_V }, // 11911
  { PseudoVSUXEI64_V_MF8_MF2, VSUXEI64_V }, // 11912
  { PseudoVSUXEI64_V_MF8_MF2_MASK, VSUXEI64_V }, // 11913
  { PseudoVSUXEI64_V_MF8_MF4, VSUXEI64_V }, // 11914
  { PseudoVSUXEI64_V_MF8_MF4_MASK, VSUXEI64_V }, // 11915
  { PseudoVSUXEI64_V_MF8_MF8, VSUXEI64_V }, // 11916
  { PseudoVSUXEI64_V_MF8_MF8_MASK, VSUXEI64_V }, // 11917
  { PseudoVSUXEI8_V_M1_M1, VSUXEI8_V }, // 11918
  { PseudoVSUXEI8_V_M1_M1_MASK, VSUXEI8_V }, // 11919
  { PseudoVSUXEI8_V_M1_M2, VSUXEI8_V }, // 11920
  { PseudoVSUXEI8_V_M1_M2_MASK, VSUXEI8_V }, // 11921
  { PseudoVSUXEI8_V_M1_M4, VSUXEI8_V }, // 11922
  { PseudoVSUXEI8_V_M1_M4_MASK, VSUXEI8_V }, // 11923
  { PseudoVSUXEI8_V_M1_M8, VSUXEI8_V }, // 11924
  { PseudoVSUXEI8_V_M1_M8_MASK, VSUXEI8_V }, // 11925
  { PseudoVSUXEI8_V_M1_MF2, VSUXEI8_V }, // 11926
  { PseudoVSUXEI8_V_M1_MF2_MASK, VSUXEI8_V }, // 11927
  { PseudoVSUXEI8_V_M1_MF4, VSUXEI8_V }, // 11928
  { PseudoVSUXEI8_V_M1_MF4_MASK, VSUXEI8_V }, // 11929
  { PseudoVSUXEI8_V_M1_MF8, VSUXEI8_V }, // 11930
  { PseudoVSUXEI8_V_M1_MF8_MASK, VSUXEI8_V }, // 11931
  { PseudoVSUXEI8_V_M2_M1, VSUXEI8_V }, // 11932
  { PseudoVSUXEI8_V_M2_M1_MASK, VSUXEI8_V }, // 11933
  { PseudoVSUXEI8_V_M2_M2, VSUXEI8_V }, // 11934
  { PseudoVSUXEI8_V_M2_M2_MASK, VSUXEI8_V }, // 11935
  { PseudoVSUXEI8_V_M2_M4, VSUXEI8_V }, // 11936
  { PseudoVSUXEI8_V_M2_M4_MASK, VSUXEI8_V }, // 11937
  { PseudoVSUXEI8_V_M2_M8, VSUXEI8_V }, // 11938
  { PseudoVSUXEI8_V_M2_M8_MASK, VSUXEI8_V }, // 11939
  { PseudoVSUXEI8_V_M2_MF2, VSUXEI8_V }, // 11940
  { PseudoVSUXEI8_V_M2_MF2_MASK, VSUXEI8_V }, // 11941
  { PseudoVSUXEI8_V_M2_MF4, VSUXEI8_V }, // 11942
  { PseudoVSUXEI8_V_M2_MF4_MASK, VSUXEI8_V }, // 11943
  { PseudoVSUXEI8_V_M2_MF8, VSUXEI8_V }, // 11944
  { PseudoVSUXEI8_V_M2_MF8_MASK, VSUXEI8_V }, // 11945
  { PseudoVSUXEI8_V_M4_M1, VSUXEI8_V }, // 11946
  { PseudoVSUXEI8_V_M4_M1_MASK, VSUXEI8_V }, // 11947
  { PseudoVSUXEI8_V_M4_M2, VSUXEI8_V }, // 11948
  { PseudoVSUXEI8_V_M4_M2_MASK, VSUXEI8_V }, // 11949
  { PseudoVSUXEI8_V_M4_M4, VSUXEI8_V }, // 11950
  { PseudoVSUXEI8_V_M4_M4_MASK, VSUXEI8_V }, // 11951
  { PseudoVSUXEI8_V_M4_M8, VSUXEI8_V }, // 11952
  { PseudoVSUXEI8_V_M4_M8_MASK, VSUXEI8_V }, // 11953
  { PseudoVSUXEI8_V_M4_MF2, VSUXEI8_V }, // 11954
  { PseudoVSUXEI8_V_M4_MF2_MASK, VSUXEI8_V }, // 11955
  { PseudoVSUXEI8_V_M4_MF4, VSUXEI8_V }, // 11956
  { PseudoVSUXEI8_V_M4_MF4_MASK, VSUXEI8_V }, // 11957
  { PseudoVSUXEI8_V_M4_MF8, VSUXEI8_V }, // 11958
  { PseudoVSUXEI8_V_M4_MF8_MASK, VSUXEI8_V }, // 11959
  { PseudoVSUXEI8_V_M8_M1, VSUXEI8_V }, // 11960
  { PseudoVSUXEI8_V_M8_M1_MASK, VSUXEI8_V }, // 11961
  { PseudoVSUXEI8_V_M8_M2, VSUXEI8_V }, // 11962
  { PseudoVSUXEI8_V_M8_M2_MASK, VSUXEI8_V }, // 11963
  { PseudoVSUXEI8_V_M8_M4, VSUXEI8_V }, // 11964
  { PseudoVSUXEI8_V_M8_M4_MASK, VSUXEI8_V }, // 11965
  { PseudoVSUXEI8_V_M8_M8, VSUXEI8_V }, // 11966
  { PseudoVSUXEI8_V_M8_M8_MASK, VSUXEI8_V }, // 11967
  { PseudoVSUXEI8_V_M8_MF2, VSUXEI8_V }, // 11968
  { PseudoVSUXEI8_V_M8_MF2_MASK, VSUXEI8_V }, // 11969
  { PseudoVSUXEI8_V_M8_MF4, VSUXEI8_V }, // 11970
  { PseudoVSUXEI8_V_M8_MF4_MASK, VSUXEI8_V }, // 11971
  { PseudoVSUXEI8_V_M8_MF8, VSUXEI8_V }, // 11972
  { PseudoVSUXEI8_V_M8_MF8_MASK, VSUXEI8_V }, // 11973
  { PseudoVSUXEI8_V_MF2_M1, VSUXEI8_V }, // 11974
  { PseudoVSUXEI8_V_MF2_M1_MASK, VSUXEI8_V }, // 11975
  { PseudoVSUXEI8_V_MF2_M2, VSUXEI8_V }, // 11976
  { PseudoVSUXEI8_V_MF2_M2_MASK, VSUXEI8_V }, // 11977
  { PseudoVSUXEI8_V_MF2_M4, VSUXEI8_V }, // 11978
  { PseudoVSUXEI8_V_MF2_M4_MASK, VSUXEI8_V }, // 11979
  { PseudoVSUXEI8_V_MF2_M8, VSUXEI8_V }, // 11980
  { PseudoVSUXEI8_V_MF2_M8_MASK, VSUXEI8_V }, // 11981
  { PseudoVSUXEI8_V_MF2_MF2, VSUXEI8_V }, // 11982
  { PseudoVSUXEI8_V_MF2_MF2_MASK, VSUXEI8_V }, // 11983
  { PseudoVSUXEI8_V_MF2_MF4, VSUXEI8_V }, // 11984
  { PseudoVSUXEI8_V_MF2_MF4_MASK, VSUXEI8_V }, // 11985
  { PseudoVSUXEI8_V_MF2_MF8, VSUXEI8_V }, // 11986
  { PseudoVSUXEI8_V_MF2_MF8_MASK, VSUXEI8_V }, // 11987
  { PseudoVSUXEI8_V_MF4_M1, VSUXEI8_V }, // 11988
  { PseudoVSUXEI8_V_MF4_M1_MASK, VSUXEI8_V }, // 11989
  { PseudoVSUXEI8_V_MF4_M2, VSUXEI8_V }, // 11990
  { PseudoVSUXEI8_V_MF4_M2_MASK, VSUXEI8_V }, // 11991
  { PseudoVSUXEI8_V_MF4_M4, VSUXEI8_V }, // 11992
  { PseudoVSUXEI8_V_MF4_M4_MASK, VSUXEI8_V }, // 11993
  { PseudoVSUXEI8_V_MF4_M8, VSUXEI8_V }, // 11994
  { PseudoVSUXEI8_V_MF4_M8_MASK, VSUXEI8_V }, // 11995
  { PseudoVSUXEI8_V_MF4_MF2, VSUXEI8_V }, // 11996
  { PseudoVSUXEI8_V_MF4_MF2_MASK, VSUXEI8_V }, // 11997
  { PseudoVSUXEI8_V_MF4_MF4, VSUXEI8_V }, // 11998
  { PseudoVSUXEI8_V_MF4_MF4_MASK, VSUXEI8_V }, // 11999
  { PseudoVSUXEI8_V_MF4_MF8, VSUXEI8_V }, // 12000
  { PseudoVSUXEI8_V_MF4_MF8_MASK, VSUXEI8_V }, // 12001
  { PseudoVSUXEI8_V_MF8_M1, VSUXEI8_V }, // 12002
  { PseudoVSUXEI8_V_MF8_M1_MASK, VSUXEI8_V }, // 12003
  { PseudoVSUXEI8_V_MF8_M2, VSUXEI8_V }, // 12004
  { PseudoVSUXEI8_V_MF8_M2_MASK, VSUXEI8_V }, // 12005
  { PseudoVSUXEI8_V_MF8_M4, VSUXEI8_V }, // 12006
  { PseudoVSUXEI8_V_MF8_M4_MASK, VSUXEI8_V }, // 12007
  { PseudoVSUXEI8_V_MF8_M8, VSUXEI8_V }, // 12008
  { PseudoVSUXEI8_V_MF8_M8_MASK, VSUXEI8_V }, // 12009
  { PseudoVSUXEI8_V_MF8_MF2, VSUXEI8_V }, // 12010
  { PseudoVSUXEI8_V_MF8_MF2_MASK, VSUXEI8_V }, // 12011
  { PseudoVSUXEI8_V_MF8_MF4, VSUXEI8_V }, // 12012
  { PseudoVSUXEI8_V_MF8_MF4_MASK, VSUXEI8_V }, // 12013
  { PseudoVSUXEI8_V_MF8_MF8, VSUXEI8_V }, // 12014
  { PseudoVSUXEI8_V_MF8_MF8_MASK, VSUXEI8_V }, // 12015
  { PseudoVSUXSEG2EI16_V_M1_M1, VSUXSEG2EI16_V }, // 12016
  { PseudoVSUXSEG2EI16_V_M1_M1_MASK, VSUXSEG2EI16_V }, // 12017
  { PseudoVSUXSEG2EI16_V_M1_M2, VSUXSEG2EI16_V }, // 12018
  { PseudoVSUXSEG2EI16_V_M1_M2_MASK, VSUXSEG2EI16_V }, // 12019
  { PseudoVSUXSEG2EI16_V_M1_M4, VSUXSEG2EI16_V }, // 12020
  { PseudoVSUXSEG2EI16_V_M1_M4_MASK, VSUXSEG2EI16_V }, // 12021
  { PseudoVSUXSEG2EI16_V_M1_MF2, VSUXSEG2EI16_V }, // 12022
  { PseudoVSUXSEG2EI16_V_M1_MF2_MASK, VSUXSEG2EI16_V }, // 12023
  { PseudoVSUXSEG2EI16_V_M1_MF4, VSUXSEG2EI16_V }, // 12024
  { PseudoVSUXSEG2EI16_V_M1_MF4_MASK, VSUXSEG2EI16_V }, // 12025
  { PseudoVSUXSEG2EI16_V_M1_MF8, VSUXSEG2EI16_V }, // 12026
  { PseudoVSUXSEG2EI16_V_M1_MF8_MASK, VSUXSEG2EI16_V }, // 12027
  { PseudoVSUXSEG2EI16_V_M2_M1, VSUXSEG2EI16_V }, // 12028
  { PseudoVSUXSEG2EI16_V_M2_M1_MASK, VSUXSEG2EI16_V }, // 12029
  { PseudoVSUXSEG2EI16_V_M2_M2, VSUXSEG2EI16_V }, // 12030
  { PseudoVSUXSEG2EI16_V_M2_M2_MASK, VSUXSEG2EI16_V }, // 12031
  { PseudoVSUXSEG2EI16_V_M2_M4, VSUXSEG2EI16_V }, // 12032
  { PseudoVSUXSEG2EI16_V_M2_M4_MASK, VSUXSEG2EI16_V }, // 12033
  { PseudoVSUXSEG2EI16_V_M2_MF2, VSUXSEG2EI16_V }, // 12034
  { PseudoVSUXSEG2EI16_V_M2_MF2_MASK, VSUXSEG2EI16_V }, // 12035
  { PseudoVSUXSEG2EI16_V_M2_MF4, VSUXSEG2EI16_V }, // 12036
  { PseudoVSUXSEG2EI16_V_M2_MF4_MASK, VSUXSEG2EI16_V }, // 12037
  { PseudoVSUXSEG2EI16_V_M2_MF8, VSUXSEG2EI16_V }, // 12038
  { PseudoVSUXSEG2EI16_V_M2_MF8_MASK, VSUXSEG2EI16_V }, // 12039
  { PseudoVSUXSEG2EI16_V_M4_M1, VSUXSEG2EI16_V }, // 12040
  { PseudoVSUXSEG2EI16_V_M4_M1_MASK, VSUXSEG2EI16_V }, // 12041
  { PseudoVSUXSEG2EI16_V_M4_M2, VSUXSEG2EI16_V }, // 12042
  { PseudoVSUXSEG2EI16_V_M4_M2_MASK, VSUXSEG2EI16_V }, // 12043
  { PseudoVSUXSEG2EI16_V_M4_M4, VSUXSEG2EI16_V }, // 12044
  { PseudoVSUXSEG2EI16_V_M4_M4_MASK, VSUXSEG2EI16_V }, // 12045
  { PseudoVSUXSEG2EI16_V_M4_MF2, VSUXSEG2EI16_V }, // 12046
  { PseudoVSUXSEG2EI16_V_M4_MF2_MASK, VSUXSEG2EI16_V }, // 12047
  { PseudoVSUXSEG2EI16_V_M4_MF4, VSUXSEG2EI16_V }, // 12048
  { PseudoVSUXSEG2EI16_V_M4_MF4_MASK, VSUXSEG2EI16_V }, // 12049
  { PseudoVSUXSEG2EI16_V_M4_MF8, VSUXSEG2EI16_V }, // 12050
  { PseudoVSUXSEG2EI16_V_M4_MF8_MASK, VSUXSEG2EI16_V }, // 12051
  { PseudoVSUXSEG2EI16_V_M8_M1, VSUXSEG2EI16_V }, // 12052
  { PseudoVSUXSEG2EI16_V_M8_M1_MASK, VSUXSEG2EI16_V }, // 12053
  { PseudoVSUXSEG2EI16_V_M8_M2, VSUXSEG2EI16_V }, // 12054
  { PseudoVSUXSEG2EI16_V_M8_M2_MASK, VSUXSEG2EI16_V }, // 12055
  { PseudoVSUXSEG2EI16_V_M8_M4, VSUXSEG2EI16_V }, // 12056
  { PseudoVSUXSEG2EI16_V_M8_M4_MASK, VSUXSEG2EI16_V }, // 12057
  { PseudoVSUXSEG2EI16_V_M8_MF2, VSUXSEG2EI16_V }, // 12058
  { PseudoVSUXSEG2EI16_V_M8_MF2_MASK, VSUXSEG2EI16_V }, // 12059
  { PseudoVSUXSEG2EI16_V_M8_MF4, VSUXSEG2EI16_V }, // 12060
  { PseudoVSUXSEG2EI16_V_M8_MF4_MASK, VSUXSEG2EI16_V }, // 12061
  { PseudoVSUXSEG2EI16_V_M8_MF8, VSUXSEG2EI16_V }, // 12062
  { PseudoVSUXSEG2EI16_V_M8_MF8_MASK, VSUXSEG2EI16_V }, // 12063
  { PseudoVSUXSEG2EI16_V_MF2_M1, VSUXSEG2EI16_V }, // 12064
  { PseudoVSUXSEG2EI16_V_MF2_M1_MASK, VSUXSEG2EI16_V }, // 12065
  { PseudoVSUXSEG2EI16_V_MF2_M2, VSUXSEG2EI16_V }, // 12066
  { PseudoVSUXSEG2EI16_V_MF2_M2_MASK, VSUXSEG2EI16_V }, // 12067
  { PseudoVSUXSEG2EI16_V_MF2_M4, VSUXSEG2EI16_V }, // 12068
  { PseudoVSUXSEG2EI16_V_MF2_M4_MASK, VSUXSEG2EI16_V }, // 12069
  { PseudoVSUXSEG2EI16_V_MF2_MF2, VSUXSEG2EI16_V }, // 12070
  { PseudoVSUXSEG2EI16_V_MF2_MF2_MASK, VSUXSEG2EI16_V }, // 12071
  { PseudoVSUXSEG2EI16_V_MF2_MF4, VSUXSEG2EI16_V }, // 12072
  { PseudoVSUXSEG2EI16_V_MF2_MF4_MASK, VSUXSEG2EI16_V }, // 12073
  { PseudoVSUXSEG2EI16_V_MF2_MF8, VSUXSEG2EI16_V }, // 12074
  { PseudoVSUXSEG2EI16_V_MF2_MF8_MASK, VSUXSEG2EI16_V }, // 12075
  { PseudoVSUXSEG2EI16_V_MF4_M1, VSUXSEG2EI16_V }, // 12076
  { PseudoVSUXSEG2EI16_V_MF4_M1_MASK, VSUXSEG2EI16_V }, // 12077
  { PseudoVSUXSEG2EI16_V_MF4_M2, VSUXSEG2EI16_V }, // 12078
  { PseudoVSUXSEG2EI16_V_MF4_M2_MASK, VSUXSEG2EI16_V }, // 12079
  { PseudoVSUXSEG2EI16_V_MF4_M4, VSUXSEG2EI16_V }, // 12080
  { PseudoVSUXSEG2EI16_V_MF4_M4_MASK, VSUXSEG2EI16_V }, // 12081
  { PseudoVSUXSEG2EI16_V_MF4_MF2, VSUXSEG2EI16_V }, // 12082
  { PseudoVSUXSEG2EI16_V_MF4_MF2_MASK, VSUXSEG2EI16_V }, // 12083
  { PseudoVSUXSEG2EI16_V_MF4_MF4, VSUXSEG2EI16_V }, // 12084
  { PseudoVSUXSEG2EI16_V_MF4_MF4_MASK, VSUXSEG2EI16_V }, // 12085
  { PseudoVSUXSEG2EI16_V_MF4_MF8, VSUXSEG2EI16_V }, // 12086
  { PseudoVSUXSEG2EI16_V_MF4_MF8_MASK, VSUXSEG2EI16_V }, // 12087
  { PseudoVSUXSEG2EI32_V_M1_M1, VSUXSEG2EI32_V }, // 12088
  { PseudoVSUXSEG2EI32_V_M1_M1_MASK, VSUXSEG2EI32_V }, // 12089
  { PseudoVSUXSEG2EI32_V_M1_M2, VSUXSEG2EI32_V }, // 12090
  { PseudoVSUXSEG2EI32_V_M1_M2_MASK, VSUXSEG2EI32_V }, // 12091
  { PseudoVSUXSEG2EI32_V_M1_M4, VSUXSEG2EI32_V }, // 12092
  { PseudoVSUXSEG2EI32_V_M1_M4_MASK, VSUXSEG2EI32_V }, // 12093
  { PseudoVSUXSEG2EI32_V_M1_MF2, VSUXSEG2EI32_V }, // 12094
  { PseudoVSUXSEG2EI32_V_M1_MF2_MASK, VSUXSEG2EI32_V }, // 12095
  { PseudoVSUXSEG2EI32_V_M1_MF4, VSUXSEG2EI32_V }, // 12096
  { PseudoVSUXSEG2EI32_V_M1_MF4_MASK, VSUXSEG2EI32_V }, // 12097
  { PseudoVSUXSEG2EI32_V_M1_MF8, VSUXSEG2EI32_V }, // 12098
  { PseudoVSUXSEG2EI32_V_M1_MF8_MASK, VSUXSEG2EI32_V }, // 12099
  { PseudoVSUXSEG2EI32_V_M2_M1, VSUXSEG2EI32_V }, // 12100
  { PseudoVSUXSEG2EI32_V_M2_M1_MASK, VSUXSEG2EI32_V }, // 12101
  { PseudoVSUXSEG2EI32_V_M2_M2, VSUXSEG2EI32_V }, // 12102
  { PseudoVSUXSEG2EI32_V_M2_M2_MASK, VSUXSEG2EI32_V }, // 12103
  { PseudoVSUXSEG2EI32_V_M2_M4, VSUXSEG2EI32_V }, // 12104
  { PseudoVSUXSEG2EI32_V_M2_M4_MASK, VSUXSEG2EI32_V }, // 12105
  { PseudoVSUXSEG2EI32_V_M2_MF2, VSUXSEG2EI32_V }, // 12106
  { PseudoVSUXSEG2EI32_V_M2_MF2_MASK, VSUXSEG2EI32_V }, // 12107
  { PseudoVSUXSEG2EI32_V_M2_MF4, VSUXSEG2EI32_V }, // 12108
  { PseudoVSUXSEG2EI32_V_M2_MF4_MASK, VSUXSEG2EI32_V }, // 12109
  { PseudoVSUXSEG2EI32_V_M2_MF8, VSUXSEG2EI32_V }, // 12110
  { PseudoVSUXSEG2EI32_V_M2_MF8_MASK, VSUXSEG2EI32_V }, // 12111
  { PseudoVSUXSEG2EI32_V_M4_M1, VSUXSEG2EI32_V }, // 12112
  { PseudoVSUXSEG2EI32_V_M4_M1_MASK, VSUXSEG2EI32_V }, // 12113
  { PseudoVSUXSEG2EI32_V_M4_M2, VSUXSEG2EI32_V }, // 12114
  { PseudoVSUXSEG2EI32_V_M4_M2_MASK, VSUXSEG2EI32_V }, // 12115
  { PseudoVSUXSEG2EI32_V_M4_M4, VSUXSEG2EI32_V }, // 12116
  { PseudoVSUXSEG2EI32_V_M4_M4_MASK, VSUXSEG2EI32_V }, // 12117
  { PseudoVSUXSEG2EI32_V_M4_MF2, VSUXSEG2EI32_V }, // 12118
  { PseudoVSUXSEG2EI32_V_M4_MF2_MASK, VSUXSEG2EI32_V }, // 12119
  { PseudoVSUXSEG2EI32_V_M4_MF4, VSUXSEG2EI32_V }, // 12120
  { PseudoVSUXSEG2EI32_V_M4_MF4_MASK, VSUXSEG2EI32_V }, // 12121
  { PseudoVSUXSEG2EI32_V_M4_MF8, VSUXSEG2EI32_V }, // 12122
  { PseudoVSUXSEG2EI32_V_M4_MF8_MASK, VSUXSEG2EI32_V }, // 12123
  { PseudoVSUXSEG2EI32_V_M8_M1, VSUXSEG2EI32_V }, // 12124
  { PseudoVSUXSEG2EI32_V_M8_M1_MASK, VSUXSEG2EI32_V }, // 12125
  { PseudoVSUXSEG2EI32_V_M8_M2, VSUXSEG2EI32_V }, // 12126
  { PseudoVSUXSEG2EI32_V_M8_M2_MASK, VSUXSEG2EI32_V }, // 12127
  { PseudoVSUXSEG2EI32_V_M8_M4, VSUXSEG2EI32_V }, // 12128
  { PseudoVSUXSEG2EI32_V_M8_M4_MASK, VSUXSEG2EI32_V }, // 12129
  { PseudoVSUXSEG2EI32_V_M8_MF2, VSUXSEG2EI32_V }, // 12130
  { PseudoVSUXSEG2EI32_V_M8_MF2_MASK, VSUXSEG2EI32_V }, // 12131
  { PseudoVSUXSEG2EI32_V_M8_MF4, VSUXSEG2EI32_V }, // 12132
  { PseudoVSUXSEG2EI32_V_M8_MF4_MASK, VSUXSEG2EI32_V }, // 12133
  { PseudoVSUXSEG2EI32_V_M8_MF8, VSUXSEG2EI32_V }, // 12134
  { PseudoVSUXSEG2EI32_V_M8_MF8_MASK, VSUXSEG2EI32_V }, // 12135
  { PseudoVSUXSEG2EI32_V_MF2_M1, VSUXSEG2EI32_V }, // 12136
  { PseudoVSUXSEG2EI32_V_MF2_M1_MASK, VSUXSEG2EI32_V }, // 12137
  { PseudoVSUXSEG2EI32_V_MF2_M2, VSUXSEG2EI32_V }, // 12138
  { PseudoVSUXSEG2EI32_V_MF2_M2_MASK, VSUXSEG2EI32_V }, // 12139
  { PseudoVSUXSEG2EI32_V_MF2_M4, VSUXSEG2EI32_V }, // 12140
  { PseudoVSUXSEG2EI32_V_MF2_M4_MASK, VSUXSEG2EI32_V }, // 12141
  { PseudoVSUXSEG2EI32_V_MF2_MF2, VSUXSEG2EI32_V }, // 12142
  { PseudoVSUXSEG2EI32_V_MF2_MF2_MASK, VSUXSEG2EI32_V }, // 12143
  { PseudoVSUXSEG2EI32_V_MF2_MF4, VSUXSEG2EI32_V }, // 12144
  { PseudoVSUXSEG2EI32_V_MF2_MF4_MASK, VSUXSEG2EI32_V }, // 12145
  { PseudoVSUXSEG2EI32_V_MF2_MF8, VSUXSEG2EI32_V }, // 12146
  { PseudoVSUXSEG2EI32_V_MF2_MF8_MASK, VSUXSEG2EI32_V }, // 12147
  { PseudoVSUXSEG2EI64_V_M1_M1, VSUXSEG2EI64_V }, // 12148
  { PseudoVSUXSEG2EI64_V_M1_M1_MASK, VSUXSEG2EI64_V }, // 12149
  { PseudoVSUXSEG2EI64_V_M1_M2, VSUXSEG2EI64_V }, // 12150
  { PseudoVSUXSEG2EI64_V_M1_M2_MASK, VSUXSEG2EI64_V }, // 12151
  { PseudoVSUXSEG2EI64_V_M1_M4, VSUXSEG2EI64_V }, // 12152
  { PseudoVSUXSEG2EI64_V_M1_M4_MASK, VSUXSEG2EI64_V }, // 12153
  { PseudoVSUXSEG2EI64_V_M1_MF2, VSUXSEG2EI64_V }, // 12154
  { PseudoVSUXSEG2EI64_V_M1_MF2_MASK, VSUXSEG2EI64_V }, // 12155
  { PseudoVSUXSEG2EI64_V_M1_MF4, VSUXSEG2EI64_V }, // 12156
  { PseudoVSUXSEG2EI64_V_M1_MF4_MASK, VSUXSEG2EI64_V }, // 12157
  { PseudoVSUXSEG2EI64_V_M1_MF8, VSUXSEG2EI64_V }, // 12158
  { PseudoVSUXSEG2EI64_V_M1_MF8_MASK, VSUXSEG2EI64_V }, // 12159
  { PseudoVSUXSEG2EI64_V_M2_M1, VSUXSEG2EI64_V }, // 12160
  { PseudoVSUXSEG2EI64_V_M2_M1_MASK, VSUXSEG2EI64_V }, // 12161
  { PseudoVSUXSEG2EI64_V_M2_M2, VSUXSEG2EI64_V }, // 12162
  { PseudoVSUXSEG2EI64_V_M2_M2_MASK, VSUXSEG2EI64_V }, // 12163
  { PseudoVSUXSEG2EI64_V_M2_M4, VSUXSEG2EI64_V }, // 12164
  { PseudoVSUXSEG2EI64_V_M2_M4_MASK, VSUXSEG2EI64_V }, // 12165
  { PseudoVSUXSEG2EI64_V_M2_MF2, VSUXSEG2EI64_V }, // 12166
  { PseudoVSUXSEG2EI64_V_M2_MF2_MASK, VSUXSEG2EI64_V }, // 12167
  { PseudoVSUXSEG2EI64_V_M2_MF4, VSUXSEG2EI64_V }, // 12168
  { PseudoVSUXSEG2EI64_V_M2_MF4_MASK, VSUXSEG2EI64_V }, // 12169
  { PseudoVSUXSEG2EI64_V_M2_MF8, VSUXSEG2EI64_V }, // 12170
  { PseudoVSUXSEG2EI64_V_M2_MF8_MASK, VSUXSEG2EI64_V }, // 12171
  { PseudoVSUXSEG2EI64_V_M4_M1, VSUXSEG2EI64_V }, // 12172
  { PseudoVSUXSEG2EI64_V_M4_M1_MASK, VSUXSEG2EI64_V }, // 12173
  { PseudoVSUXSEG2EI64_V_M4_M2, VSUXSEG2EI64_V }, // 12174
  { PseudoVSUXSEG2EI64_V_M4_M2_MASK, VSUXSEG2EI64_V }, // 12175
  { PseudoVSUXSEG2EI64_V_M4_M4, VSUXSEG2EI64_V }, // 12176
  { PseudoVSUXSEG2EI64_V_M4_M4_MASK, VSUXSEG2EI64_V }, // 12177
  { PseudoVSUXSEG2EI64_V_M4_MF2, VSUXSEG2EI64_V }, // 12178
  { PseudoVSUXSEG2EI64_V_M4_MF2_MASK, VSUXSEG2EI64_V }, // 12179
  { PseudoVSUXSEG2EI64_V_M4_MF4, VSUXSEG2EI64_V }, // 12180
  { PseudoVSUXSEG2EI64_V_M4_MF4_MASK, VSUXSEG2EI64_V }, // 12181
  { PseudoVSUXSEG2EI64_V_M4_MF8, VSUXSEG2EI64_V }, // 12182
  { PseudoVSUXSEG2EI64_V_M4_MF8_MASK, VSUXSEG2EI64_V }, // 12183
  { PseudoVSUXSEG2EI64_V_M8_M1, VSUXSEG2EI64_V }, // 12184
  { PseudoVSUXSEG2EI64_V_M8_M1_MASK, VSUXSEG2EI64_V }, // 12185
  { PseudoVSUXSEG2EI64_V_M8_M2, VSUXSEG2EI64_V }, // 12186
  { PseudoVSUXSEG2EI64_V_M8_M2_MASK, VSUXSEG2EI64_V }, // 12187
  { PseudoVSUXSEG2EI64_V_M8_M4, VSUXSEG2EI64_V }, // 12188
  { PseudoVSUXSEG2EI64_V_M8_M4_MASK, VSUXSEG2EI64_V }, // 12189
  { PseudoVSUXSEG2EI64_V_M8_MF2, VSUXSEG2EI64_V }, // 12190
  { PseudoVSUXSEG2EI64_V_M8_MF2_MASK, VSUXSEG2EI64_V }, // 12191
  { PseudoVSUXSEG2EI64_V_M8_MF4, VSUXSEG2EI64_V }, // 12192
  { PseudoVSUXSEG2EI64_V_M8_MF4_MASK, VSUXSEG2EI64_V }, // 12193
  { PseudoVSUXSEG2EI64_V_M8_MF8, VSUXSEG2EI64_V }, // 12194
  { PseudoVSUXSEG2EI64_V_M8_MF8_MASK, VSUXSEG2EI64_V }, // 12195
  { PseudoVSUXSEG2EI8_V_M1_M1, VSUXSEG2EI8_V }, // 12196
  { PseudoVSUXSEG2EI8_V_M1_M1_MASK, VSUXSEG2EI8_V }, // 12197
  { PseudoVSUXSEG2EI8_V_M1_M2, VSUXSEG2EI8_V }, // 12198
  { PseudoVSUXSEG2EI8_V_M1_M2_MASK, VSUXSEG2EI8_V }, // 12199
  { PseudoVSUXSEG2EI8_V_M1_M4, VSUXSEG2EI8_V }, // 12200
  { PseudoVSUXSEG2EI8_V_M1_M4_MASK, VSUXSEG2EI8_V }, // 12201
  { PseudoVSUXSEG2EI8_V_M1_MF2, VSUXSEG2EI8_V }, // 12202
  { PseudoVSUXSEG2EI8_V_M1_MF2_MASK, VSUXSEG2EI8_V }, // 12203
  { PseudoVSUXSEG2EI8_V_M1_MF4, VSUXSEG2EI8_V }, // 12204
  { PseudoVSUXSEG2EI8_V_M1_MF4_MASK, VSUXSEG2EI8_V }, // 12205
  { PseudoVSUXSEG2EI8_V_M1_MF8, VSUXSEG2EI8_V }, // 12206
  { PseudoVSUXSEG2EI8_V_M1_MF8_MASK, VSUXSEG2EI8_V }, // 12207
  { PseudoVSUXSEG2EI8_V_M2_M1, VSUXSEG2EI8_V }, // 12208
  { PseudoVSUXSEG2EI8_V_M2_M1_MASK, VSUXSEG2EI8_V }, // 12209
  { PseudoVSUXSEG2EI8_V_M2_M2, VSUXSEG2EI8_V }, // 12210
  { PseudoVSUXSEG2EI8_V_M2_M2_MASK, VSUXSEG2EI8_V }, // 12211
  { PseudoVSUXSEG2EI8_V_M2_M4, VSUXSEG2EI8_V }, // 12212
  { PseudoVSUXSEG2EI8_V_M2_M4_MASK, VSUXSEG2EI8_V }, // 12213
  { PseudoVSUXSEG2EI8_V_M2_MF2, VSUXSEG2EI8_V }, // 12214
  { PseudoVSUXSEG2EI8_V_M2_MF2_MASK, VSUXSEG2EI8_V }, // 12215
  { PseudoVSUXSEG2EI8_V_M2_MF4, VSUXSEG2EI8_V }, // 12216
  { PseudoVSUXSEG2EI8_V_M2_MF4_MASK, VSUXSEG2EI8_V }, // 12217
  { PseudoVSUXSEG2EI8_V_M2_MF8, VSUXSEG2EI8_V }, // 12218
  { PseudoVSUXSEG2EI8_V_M2_MF8_MASK, VSUXSEG2EI8_V }, // 12219
  { PseudoVSUXSEG2EI8_V_M4_M1, VSUXSEG2EI8_V }, // 12220
  { PseudoVSUXSEG2EI8_V_M4_M1_MASK, VSUXSEG2EI8_V }, // 12221
  { PseudoVSUXSEG2EI8_V_M4_M2, VSUXSEG2EI8_V }, // 12222
  { PseudoVSUXSEG2EI8_V_M4_M2_MASK, VSUXSEG2EI8_V }, // 12223
  { PseudoVSUXSEG2EI8_V_M4_M4, VSUXSEG2EI8_V }, // 12224
  { PseudoVSUXSEG2EI8_V_M4_M4_MASK, VSUXSEG2EI8_V }, // 12225
  { PseudoVSUXSEG2EI8_V_M4_MF2, VSUXSEG2EI8_V }, // 12226
  { PseudoVSUXSEG2EI8_V_M4_MF2_MASK, VSUXSEG2EI8_V }, // 12227
  { PseudoVSUXSEG2EI8_V_M4_MF4, VSUXSEG2EI8_V }, // 12228
  { PseudoVSUXSEG2EI8_V_M4_MF4_MASK, VSUXSEG2EI8_V }, // 12229
  { PseudoVSUXSEG2EI8_V_M4_MF8, VSUXSEG2EI8_V }, // 12230
  { PseudoVSUXSEG2EI8_V_M4_MF8_MASK, VSUXSEG2EI8_V }, // 12231
  { PseudoVSUXSEG2EI8_V_M8_M1, VSUXSEG2EI8_V }, // 12232
  { PseudoVSUXSEG2EI8_V_M8_M1_MASK, VSUXSEG2EI8_V }, // 12233
  { PseudoVSUXSEG2EI8_V_M8_M2, VSUXSEG2EI8_V }, // 12234
  { PseudoVSUXSEG2EI8_V_M8_M2_MASK, VSUXSEG2EI8_V }, // 12235
  { PseudoVSUXSEG2EI8_V_M8_M4, VSUXSEG2EI8_V }, // 12236
  { PseudoVSUXSEG2EI8_V_M8_M4_MASK, VSUXSEG2EI8_V }, // 12237
  { PseudoVSUXSEG2EI8_V_M8_MF2, VSUXSEG2EI8_V }, // 12238
  { PseudoVSUXSEG2EI8_V_M8_MF2_MASK, VSUXSEG2EI8_V }, // 12239
  { PseudoVSUXSEG2EI8_V_M8_MF4, VSUXSEG2EI8_V }, // 12240
  { PseudoVSUXSEG2EI8_V_M8_MF4_MASK, VSUXSEG2EI8_V }, // 12241
  { PseudoVSUXSEG2EI8_V_M8_MF8, VSUXSEG2EI8_V }, // 12242
  { PseudoVSUXSEG2EI8_V_M8_MF8_MASK, VSUXSEG2EI8_V }, // 12243
  { PseudoVSUXSEG2EI8_V_MF2_M1, VSUXSEG2EI8_V }, // 12244
  { PseudoVSUXSEG2EI8_V_MF2_M1_MASK, VSUXSEG2EI8_V }, // 12245
  { PseudoVSUXSEG2EI8_V_MF2_M2, VSUXSEG2EI8_V }, // 12246
  { PseudoVSUXSEG2EI8_V_MF2_M2_MASK, VSUXSEG2EI8_V }, // 12247
  { PseudoVSUXSEG2EI8_V_MF2_M4, VSUXSEG2EI8_V }, // 12248
  { PseudoVSUXSEG2EI8_V_MF2_M4_MASK, VSUXSEG2EI8_V }, // 12249
  { PseudoVSUXSEG2EI8_V_MF2_MF2, VSUXSEG2EI8_V }, // 12250
  { PseudoVSUXSEG2EI8_V_MF2_MF2_MASK, VSUXSEG2EI8_V }, // 12251
  { PseudoVSUXSEG2EI8_V_MF2_MF4, VSUXSEG2EI8_V }, // 12252
  { PseudoVSUXSEG2EI8_V_MF2_MF4_MASK, VSUXSEG2EI8_V }, // 12253
  { PseudoVSUXSEG2EI8_V_MF2_MF8, VSUXSEG2EI8_V }, // 12254
  { PseudoVSUXSEG2EI8_V_MF2_MF8_MASK, VSUXSEG2EI8_V }, // 12255
  { PseudoVSUXSEG2EI8_V_MF4_M1, VSUXSEG2EI8_V }, // 12256
  { PseudoVSUXSEG2EI8_V_MF4_M1_MASK, VSUXSEG2EI8_V }, // 12257
  { PseudoVSUXSEG2EI8_V_MF4_M2, VSUXSEG2EI8_V }, // 12258
  { PseudoVSUXSEG2EI8_V_MF4_M2_MASK, VSUXSEG2EI8_V }, // 12259
  { PseudoVSUXSEG2EI8_V_MF4_M4, VSUXSEG2EI8_V }, // 12260
  { PseudoVSUXSEG2EI8_V_MF4_M4_MASK, VSUXSEG2EI8_V }, // 12261
  { PseudoVSUXSEG2EI8_V_MF4_MF2, VSUXSEG2EI8_V }, // 12262
  { PseudoVSUXSEG2EI8_V_MF4_MF2_MASK, VSUXSEG2EI8_V }, // 12263
  { PseudoVSUXSEG2EI8_V_MF4_MF4, VSUXSEG2EI8_V }, // 12264
  { PseudoVSUXSEG2EI8_V_MF4_MF4_MASK, VSUXSEG2EI8_V }, // 12265
  { PseudoVSUXSEG2EI8_V_MF4_MF8, VSUXSEG2EI8_V }, // 12266
  { PseudoVSUXSEG2EI8_V_MF4_MF8_MASK, VSUXSEG2EI8_V }, // 12267
  { PseudoVSUXSEG2EI8_V_MF8_M1, VSUXSEG2EI8_V }, // 12268
  { PseudoVSUXSEG2EI8_V_MF8_M1_MASK, VSUXSEG2EI8_V }, // 12269
  { PseudoVSUXSEG2EI8_V_MF8_M2, VSUXSEG2EI8_V }, // 12270
  { PseudoVSUXSEG2EI8_V_MF8_M2_MASK, VSUXSEG2EI8_V }, // 12271
  { PseudoVSUXSEG2EI8_V_MF8_M4, VSUXSEG2EI8_V }, // 12272
  { PseudoVSUXSEG2EI8_V_MF8_M4_MASK, VSUXSEG2EI8_V }, // 12273
  { PseudoVSUXSEG2EI8_V_MF8_MF2, VSUXSEG2EI8_V }, // 12274
  { PseudoVSUXSEG2EI8_V_MF8_MF2_MASK, VSUXSEG2EI8_V }, // 12275
  { PseudoVSUXSEG2EI8_V_MF8_MF4, VSUXSEG2EI8_V }, // 12276
  { PseudoVSUXSEG2EI8_V_MF8_MF4_MASK, VSUXSEG2EI8_V }, // 12277
  { PseudoVSUXSEG2EI8_V_MF8_MF8, VSUXSEG2EI8_V }, // 12278
  { PseudoVSUXSEG2EI8_V_MF8_MF8_MASK, VSUXSEG2EI8_V }, // 12279
  { PseudoVSUXSEG3EI16_V_M1_M1, VSUXSEG3EI16_V }, // 12280
  { PseudoVSUXSEG3EI16_V_M1_M1_MASK, VSUXSEG3EI16_V }, // 12281
  { PseudoVSUXSEG3EI16_V_M1_M2, VSUXSEG3EI16_V }, // 12282
  { PseudoVSUXSEG3EI16_V_M1_M2_MASK, VSUXSEG3EI16_V }, // 12283
  { PseudoVSUXSEG3EI16_V_M1_MF2, VSUXSEG3EI16_V }, // 12284
  { PseudoVSUXSEG3EI16_V_M1_MF2_MASK, VSUXSEG3EI16_V }, // 12285
  { PseudoVSUXSEG3EI16_V_M1_MF4, VSUXSEG3EI16_V }, // 12286
  { PseudoVSUXSEG3EI16_V_M1_MF4_MASK, VSUXSEG3EI16_V }, // 12287
  { PseudoVSUXSEG3EI16_V_M1_MF8, VSUXSEG3EI16_V }, // 12288
  { PseudoVSUXSEG3EI16_V_M1_MF8_MASK, VSUXSEG3EI16_V }, // 12289
  { PseudoVSUXSEG3EI16_V_M2_M1, VSUXSEG3EI16_V }, // 12290
  { PseudoVSUXSEG3EI16_V_M2_M1_MASK, VSUXSEG3EI16_V }, // 12291
  { PseudoVSUXSEG3EI16_V_M2_M2, VSUXSEG3EI16_V }, // 12292
  { PseudoVSUXSEG3EI16_V_M2_M2_MASK, VSUXSEG3EI16_V }, // 12293
  { PseudoVSUXSEG3EI16_V_M2_MF2, VSUXSEG3EI16_V }, // 12294
  { PseudoVSUXSEG3EI16_V_M2_MF2_MASK, VSUXSEG3EI16_V }, // 12295
  { PseudoVSUXSEG3EI16_V_M2_MF4, VSUXSEG3EI16_V }, // 12296
  { PseudoVSUXSEG3EI16_V_M2_MF4_MASK, VSUXSEG3EI16_V }, // 12297
  { PseudoVSUXSEG3EI16_V_M2_MF8, VSUXSEG3EI16_V }, // 12298
  { PseudoVSUXSEG3EI16_V_M2_MF8_MASK, VSUXSEG3EI16_V }, // 12299
  { PseudoVSUXSEG3EI16_V_M4_M1, VSUXSEG3EI16_V }, // 12300
  { PseudoVSUXSEG3EI16_V_M4_M1_MASK, VSUXSEG3EI16_V }, // 12301
  { PseudoVSUXSEG3EI16_V_M4_M2, VSUXSEG3EI16_V }, // 12302
  { PseudoVSUXSEG3EI16_V_M4_M2_MASK, VSUXSEG3EI16_V }, // 12303
  { PseudoVSUXSEG3EI16_V_M4_MF2, VSUXSEG3EI16_V }, // 12304
  { PseudoVSUXSEG3EI16_V_M4_MF2_MASK, VSUXSEG3EI16_V }, // 12305
  { PseudoVSUXSEG3EI16_V_M4_MF4, VSUXSEG3EI16_V }, // 12306
  { PseudoVSUXSEG3EI16_V_M4_MF4_MASK, VSUXSEG3EI16_V }, // 12307
  { PseudoVSUXSEG3EI16_V_M4_MF8, VSUXSEG3EI16_V }, // 12308
  { PseudoVSUXSEG3EI16_V_M4_MF8_MASK, VSUXSEG3EI16_V }, // 12309
  { PseudoVSUXSEG3EI16_V_M8_M1, VSUXSEG3EI16_V }, // 12310
  { PseudoVSUXSEG3EI16_V_M8_M1_MASK, VSUXSEG3EI16_V }, // 12311
  { PseudoVSUXSEG3EI16_V_M8_M2, VSUXSEG3EI16_V }, // 12312
  { PseudoVSUXSEG3EI16_V_M8_M2_MASK, VSUXSEG3EI16_V }, // 12313
  { PseudoVSUXSEG3EI16_V_M8_MF2, VSUXSEG3EI16_V }, // 12314
  { PseudoVSUXSEG3EI16_V_M8_MF2_MASK, VSUXSEG3EI16_V }, // 12315
  { PseudoVSUXSEG3EI16_V_M8_MF4, VSUXSEG3EI16_V }, // 12316
  { PseudoVSUXSEG3EI16_V_M8_MF4_MASK, VSUXSEG3EI16_V }, // 12317
  { PseudoVSUXSEG3EI16_V_M8_MF8, VSUXSEG3EI16_V }, // 12318
  { PseudoVSUXSEG3EI16_V_M8_MF8_MASK, VSUXSEG3EI16_V }, // 12319
  { PseudoVSUXSEG3EI16_V_MF2_M1, VSUXSEG3EI16_V }, // 12320
  { PseudoVSUXSEG3EI16_V_MF2_M1_MASK, VSUXSEG3EI16_V }, // 12321
  { PseudoVSUXSEG3EI16_V_MF2_M2, VSUXSEG3EI16_V }, // 12322
  { PseudoVSUXSEG3EI16_V_MF2_M2_MASK, VSUXSEG3EI16_V }, // 12323
  { PseudoVSUXSEG3EI16_V_MF2_MF2, VSUXSEG3EI16_V }, // 12324
  { PseudoVSUXSEG3EI16_V_MF2_MF2_MASK, VSUXSEG3EI16_V }, // 12325
  { PseudoVSUXSEG3EI16_V_MF2_MF4, VSUXSEG3EI16_V }, // 12326
  { PseudoVSUXSEG3EI16_V_MF2_MF4_MASK, VSUXSEG3EI16_V }, // 12327
  { PseudoVSUXSEG3EI16_V_MF2_MF8, VSUXSEG3EI16_V }, // 12328
  { PseudoVSUXSEG3EI16_V_MF2_MF8_MASK, VSUXSEG3EI16_V }, // 12329
  { PseudoVSUXSEG3EI16_V_MF4_M1, VSUXSEG3EI16_V }, // 12330
  { PseudoVSUXSEG3EI16_V_MF4_M1_MASK, VSUXSEG3EI16_V }, // 12331
  { PseudoVSUXSEG3EI16_V_MF4_M2, VSUXSEG3EI16_V }, // 12332
  { PseudoVSUXSEG3EI16_V_MF4_M2_MASK, VSUXSEG3EI16_V }, // 12333
  { PseudoVSUXSEG3EI16_V_MF4_MF2, VSUXSEG3EI16_V }, // 12334
  { PseudoVSUXSEG3EI16_V_MF4_MF2_MASK, VSUXSEG3EI16_V }, // 12335
  { PseudoVSUXSEG3EI16_V_MF4_MF4, VSUXSEG3EI16_V }, // 12336
  { PseudoVSUXSEG3EI16_V_MF4_MF4_MASK, VSUXSEG3EI16_V }, // 12337
  { PseudoVSUXSEG3EI16_V_MF4_MF8, VSUXSEG3EI16_V }, // 12338
  { PseudoVSUXSEG3EI16_V_MF4_MF8_MASK, VSUXSEG3EI16_V }, // 12339
  { PseudoVSUXSEG3EI32_V_M1_M1, VSUXSEG3EI32_V }, // 12340
  { PseudoVSUXSEG3EI32_V_M1_M1_MASK, VSUXSEG3EI32_V }, // 12341
  { PseudoVSUXSEG3EI32_V_M1_M2, VSUXSEG3EI32_V }, // 12342
  { PseudoVSUXSEG3EI32_V_M1_M2_MASK, VSUXSEG3EI32_V }, // 12343
  { PseudoVSUXSEG3EI32_V_M1_MF2, VSUXSEG3EI32_V }, // 12344
  { PseudoVSUXSEG3EI32_V_M1_MF2_MASK, VSUXSEG3EI32_V }, // 12345
  { PseudoVSUXSEG3EI32_V_M1_MF4, VSUXSEG3EI32_V }, // 12346
  { PseudoVSUXSEG3EI32_V_M1_MF4_MASK, VSUXSEG3EI32_V }, // 12347
  { PseudoVSUXSEG3EI32_V_M1_MF8, VSUXSEG3EI32_V }, // 12348
  { PseudoVSUXSEG3EI32_V_M1_MF8_MASK, VSUXSEG3EI32_V }, // 12349
  { PseudoVSUXSEG3EI32_V_M2_M1, VSUXSEG3EI32_V }, // 12350
  { PseudoVSUXSEG3EI32_V_M2_M1_MASK, VSUXSEG3EI32_V }, // 12351
  { PseudoVSUXSEG3EI32_V_M2_M2, VSUXSEG3EI32_V }, // 12352
  { PseudoVSUXSEG3EI32_V_M2_M2_MASK, VSUXSEG3EI32_V }, // 12353
  { PseudoVSUXSEG3EI32_V_M2_MF2, VSUXSEG3EI32_V }, // 12354
  { PseudoVSUXSEG3EI32_V_M2_MF2_MASK, VSUXSEG3EI32_V }, // 12355
  { PseudoVSUXSEG3EI32_V_M2_MF4, VSUXSEG3EI32_V }, // 12356
  { PseudoVSUXSEG3EI32_V_M2_MF4_MASK, VSUXSEG3EI32_V }, // 12357
  { PseudoVSUXSEG3EI32_V_M2_MF8, VSUXSEG3EI32_V }, // 12358
  { PseudoVSUXSEG3EI32_V_M2_MF8_MASK, VSUXSEG3EI32_V }, // 12359
  { PseudoVSUXSEG3EI32_V_M4_M1, VSUXSEG3EI32_V }, // 12360
  { PseudoVSUXSEG3EI32_V_M4_M1_MASK, VSUXSEG3EI32_V }, // 12361
  { PseudoVSUXSEG3EI32_V_M4_M2, VSUXSEG3EI32_V }, // 12362
  { PseudoVSUXSEG3EI32_V_M4_M2_MASK, VSUXSEG3EI32_V }, // 12363
  { PseudoVSUXSEG3EI32_V_M4_MF2, VSUXSEG3EI32_V }, // 12364
  { PseudoVSUXSEG3EI32_V_M4_MF2_MASK, VSUXSEG3EI32_V }, // 12365
  { PseudoVSUXSEG3EI32_V_M4_MF4, VSUXSEG3EI32_V }, // 12366
  { PseudoVSUXSEG3EI32_V_M4_MF4_MASK, VSUXSEG3EI32_V }, // 12367
  { PseudoVSUXSEG3EI32_V_M4_MF8, VSUXSEG3EI32_V }, // 12368
  { PseudoVSUXSEG3EI32_V_M4_MF8_MASK, VSUXSEG3EI32_V }, // 12369
  { PseudoVSUXSEG3EI32_V_M8_M1, VSUXSEG3EI32_V }, // 12370
  { PseudoVSUXSEG3EI32_V_M8_M1_MASK, VSUXSEG3EI32_V }, // 12371
  { PseudoVSUXSEG3EI32_V_M8_M2, VSUXSEG3EI32_V }, // 12372
  { PseudoVSUXSEG3EI32_V_M8_M2_MASK, VSUXSEG3EI32_V }, // 12373
  { PseudoVSUXSEG3EI32_V_M8_MF2, VSUXSEG3EI32_V }, // 12374
  { PseudoVSUXSEG3EI32_V_M8_MF2_MASK, VSUXSEG3EI32_V }, // 12375
  { PseudoVSUXSEG3EI32_V_M8_MF4, VSUXSEG3EI32_V }, // 12376
  { PseudoVSUXSEG3EI32_V_M8_MF4_MASK, VSUXSEG3EI32_V }, // 12377
  { PseudoVSUXSEG3EI32_V_M8_MF8, VSUXSEG3EI32_V }, // 12378
  { PseudoVSUXSEG3EI32_V_M8_MF8_MASK, VSUXSEG3EI32_V }, // 12379
  { PseudoVSUXSEG3EI32_V_MF2_M1, VSUXSEG3EI32_V }, // 12380
  { PseudoVSUXSEG3EI32_V_MF2_M1_MASK, VSUXSEG3EI32_V }, // 12381
  { PseudoVSUXSEG3EI32_V_MF2_M2, VSUXSEG3EI32_V }, // 12382
  { PseudoVSUXSEG3EI32_V_MF2_M2_MASK, VSUXSEG3EI32_V }, // 12383
  { PseudoVSUXSEG3EI32_V_MF2_MF2, VSUXSEG3EI32_V }, // 12384
  { PseudoVSUXSEG3EI32_V_MF2_MF2_MASK, VSUXSEG3EI32_V }, // 12385
  { PseudoVSUXSEG3EI32_V_MF2_MF4, VSUXSEG3EI32_V }, // 12386
  { PseudoVSUXSEG3EI32_V_MF2_MF4_MASK, VSUXSEG3EI32_V }, // 12387
  { PseudoVSUXSEG3EI32_V_MF2_MF8, VSUXSEG3EI32_V }, // 12388
  { PseudoVSUXSEG3EI32_V_MF2_MF8_MASK, VSUXSEG3EI32_V }, // 12389
  { PseudoVSUXSEG3EI64_V_M1_M1, VSUXSEG3EI64_V }, // 12390
  { PseudoVSUXSEG3EI64_V_M1_M1_MASK, VSUXSEG3EI64_V }, // 12391
  { PseudoVSUXSEG3EI64_V_M1_M2, VSUXSEG3EI64_V }, // 12392
  { PseudoVSUXSEG3EI64_V_M1_M2_MASK, VSUXSEG3EI64_V }, // 12393
  { PseudoVSUXSEG3EI64_V_M1_MF2, VSUXSEG3EI64_V }, // 12394
  { PseudoVSUXSEG3EI64_V_M1_MF2_MASK, VSUXSEG3EI64_V }, // 12395
  { PseudoVSUXSEG3EI64_V_M1_MF4, VSUXSEG3EI64_V }, // 12396
  { PseudoVSUXSEG3EI64_V_M1_MF4_MASK, VSUXSEG3EI64_V }, // 12397
  { PseudoVSUXSEG3EI64_V_M1_MF8, VSUXSEG3EI64_V }, // 12398
  { PseudoVSUXSEG3EI64_V_M1_MF8_MASK, VSUXSEG3EI64_V }, // 12399
  { PseudoVSUXSEG3EI64_V_M2_M1, VSUXSEG3EI64_V }, // 12400
  { PseudoVSUXSEG3EI64_V_M2_M1_MASK, VSUXSEG3EI64_V }, // 12401
  { PseudoVSUXSEG3EI64_V_M2_M2, VSUXSEG3EI64_V }, // 12402
  { PseudoVSUXSEG3EI64_V_M2_M2_MASK, VSUXSEG3EI64_V }, // 12403
  { PseudoVSUXSEG3EI64_V_M2_MF2, VSUXSEG3EI64_V }, // 12404
  { PseudoVSUXSEG3EI64_V_M2_MF2_MASK, VSUXSEG3EI64_V }, // 12405
  { PseudoVSUXSEG3EI64_V_M2_MF4, VSUXSEG3EI64_V }, // 12406
  { PseudoVSUXSEG3EI64_V_M2_MF4_MASK, VSUXSEG3EI64_V }, // 12407
  { PseudoVSUXSEG3EI64_V_M2_MF8, VSUXSEG3EI64_V }, // 12408
  { PseudoVSUXSEG3EI64_V_M2_MF8_MASK, VSUXSEG3EI64_V }, // 12409
  { PseudoVSUXSEG3EI64_V_M4_M1, VSUXSEG3EI64_V }, // 12410
  { PseudoVSUXSEG3EI64_V_M4_M1_MASK, VSUXSEG3EI64_V }, // 12411
  { PseudoVSUXSEG3EI64_V_M4_M2, VSUXSEG3EI64_V }, // 12412
  { PseudoVSUXSEG3EI64_V_M4_M2_MASK, VSUXSEG3EI64_V }, // 12413
  { PseudoVSUXSEG3EI64_V_M4_MF2, VSUXSEG3EI64_V }, // 12414
  { PseudoVSUXSEG3EI64_V_M4_MF2_MASK, VSUXSEG3EI64_V }, // 12415
  { PseudoVSUXSEG3EI64_V_M4_MF4, VSUXSEG3EI64_V }, // 12416
  { PseudoVSUXSEG3EI64_V_M4_MF4_MASK, VSUXSEG3EI64_V }, // 12417
  { PseudoVSUXSEG3EI64_V_M4_MF8, VSUXSEG3EI64_V }, // 12418
  { PseudoVSUXSEG3EI64_V_M4_MF8_MASK, VSUXSEG3EI64_V }, // 12419
  { PseudoVSUXSEG3EI64_V_M8_M1, VSUXSEG3EI64_V }, // 12420
  { PseudoVSUXSEG3EI64_V_M8_M1_MASK, VSUXSEG3EI64_V }, // 12421
  { PseudoVSUXSEG3EI64_V_M8_M2, VSUXSEG3EI64_V }, // 12422
  { PseudoVSUXSEG3EI64_V_M8_M2_MASK, VSUXSEG3EI64_V }, // 12423
  { PseudoVSUXSEG3EI64_V_M8_MF2, VSUXSEG3EI64_V }, // 12424
  { PseudoVSUXSEG3EI64_V_M8_MF2_MASK, VSUXSEG3EI64_V }, // 12425
  { PseudoVSUXSEG3EI64_V_M8_MF4, VSUXSEG3EI64_V }, // 12426
  { PseudoVSUXSEG3EI64_V_M8_MF4_MASK, VSUXSEG3EI64_V }, // 12427
  { PseudoVSUXSEG3EI64_V_M8_MF8, VSUXSEG3EI64_V }, // 12428
  { PseudoVSUXSEG3EI64_V_M8_MF8_MASK, VSUXSEG3EI64_V }, // 12429
  { PseudoVSUXSEG3EI8_V_M1_M1, VSUXSEG3EI8_V }, // 12430
  { PseudoVSUXSEG3EI8_V_M1_M1_MASK, VSUXSEG3EI8_V }, // 12431
  { PseudoVSUXSEG3EI8_V_M1_M2, VSUXSEG3EI8_V }, // 12432
  { PseudoVSUXSEG3EI8_V_M1_M2_MASK, VSUXSEG3EI8_V }, // 12433
  { PseudoVSUXSEG3EI8_V_M1_MF2, VSUXSEG3EI8_V }, // 12434
  { PseudoVSUXSEG3EI8_V_M1_MF2_MASK, VSUXSEG3EI8_V }, // 12435
  { PseudoVSUXSEG3EI8_V_M1_MF4, VSUXSEG3EI8_V }, // 12436
  { PseudoVSUXSEG3EI8_V_M1_MF4_MASK, VSUXSEG3EI8_V }, // 12437
  { PseudoVSUXSEG3EI8_V_M1_MF8, VSUXSEG3EI8_V }, // 12438
  { PseudoVSUXSEG3EI8_V_M1_MF8_MASK, VSUXSEG3EI8_V }, // 12439
  { PseudoVSUXSEG3EI8_V_M2_M1, VSUXSEG3EI8_V }, // 12440
  { PseudoVSUXSEG3EI8_V_M2_M1_MASK, VSUXSEG3EI8_V }, // 12441
  { PseudoVSUXSEG3EI8_V_M2_M2, VSUXSEG3EI8_V }, // 12442
  { PseudoVSUXSEG3EI8_V_M2_M2_MASK, VSUXSEG3EI8_V }, // 12443
  { PseudoVSUXSEG3EI8_V_M2_MF2, VSUXSEG3EI8_V }, // 12444
  { PseudoVSUXSEG3EI8_V_M2_MF2_MASK, VSUXSEG3EI8_V }, // 12445
  { PseudoVSUXSEG3EI8_V_M2_MF4, VSUXSEG3EI8_V }, // 12446
  { PseudoVSUXSEG3EI8_V_M2_MF4_MASK, VSUXSEG3EI8_V }, // 12447
  { PseudoVSUXSEG3EI8_V_M2_MF8, VSUXSEG3EI8_V }, // 12448
  { PseudoVSUXSEG3EI8_V_M2_MF8_MASK, VSUXSEG3EI8_V }, // 12449
  { PseudoVSUXSEG3EI8_V_M4_M1, VSUXSEG3EI8_V }, // 12450
  { PseudoVSUXSEG3EI8_V_M4_M1_MASK, VSUXSEG3EI8_V }, // 12451
  { PseudoVSUXSEG3EI8_V_M4_M2, VSUXSEG3EI8_V }, // 12452
  { PseudoVSUXSEG3EI8_V_M4_M2_MASK, VSUXSEG3EI8_V }, // 12453
  { PseudoVSUXSEG3EI8_V_M4_MF2, VSUXSEG3EI8_V }, // 12454
  { PseudoVSUXSEG3EI8_V_M4_MF2_MASK, VSUXSEG3EI8_V }, // 12455
  { PseudoVSUXSEG3EI8_V_M4_MF4, VSUXSEG3EI8_V }, // 12456
  { PseudoVSUXSEG3EI8_V_M4_MF4_MASK, VSUXSEG3EI8_V }, // 12457
  { PseudoVSUXSEG3EI8_V_M4_MF8, VSUXSEG3EI8_V }, // 12458
  { PseudoVSUXSEG3EI8_V_M4_MF8_MASK, VSUXSEG3EI8_V }, // 12459
  { PseudoVSUXSEG3EI8_V_M8_M1, VSUXSEG3EI8_V }, // 12460
  { PseudoVSUXSEG3EI8_V_M8_M1_MASK, VSUXSEG3EI8_V }, // 12461
  { PseudoVSUXSEG3EI8_V_M8_M2, VSUXSEG3EI8_V }, // 12462
  { PseudoVSUXSEG3EI8_V_M8_M2_MASK, VSUXSEG3EI8_V }, // 12463
  { PseudoVSUXSEG3EI8_V_M8_MF2, VSUXSEG3EI8_V }, // 12464
  { PseudoVSUXSEG3EI8_V_M8_MF2_MASK, VSUXSEG3EI8_V }, // 12465
  { PseudoVSUXSEG3EI8_V_M8_MF4, VSUXSEG3EI8_V }, // 12466
  { PseudoVSUXSEG3EI8_V_M8_MF4_MASK, VSUXSEG3EI8_V }, // 12467
  { PseudoVSUXSEG3EI8_V_M8_MF8, VSUXSEG3EI8_V }, // 12468
  { PseudoVSUXSEG3EI8_V_M8_MF8_MASK, VSUXSEG3EI8_V }, // 12469
  { PseudoVSUXSEG3EI8_V_MF2_M1, VSUXSEG3EI8_V }, // 12470
  { PseudoVSUXSEG3EI8_V_MF2_M1_MASK, VSUXSEG3EI8_V }, // 12471
  { PseudoVSUXSEG3EI8_V_MF2_M2, VSUXSEG3EI8_V }, // 12472
  { PseudoVSUXSEG3EI8_V_MF2_M2_MASK, VSUXSEG3EI8_V }, // 12473
  { PseudoVSUXSEG3EI8_V_MF2_MF2, VSUXSEG3EI8_V }, // 12474
  { PseudoVSUXSEG3EI8_V_MF2_MF2_MASK, VSUXSEG3EI8_V }, // 12475
  { PseudoVSUXSEG3EI8_V_MF2_MF4, VSUXSEG3EI8_V }, // 12476
  { PseudoVSUXSEG3EI8_V_MF2_MF4_MASK, VSUXSEG3EI8_V }, // 12477
  { PseudoVSUXSEG3EI8_V_MF2_MF8, VSUXSEG3EI8_V }, // 12478
  { PseudoVSUXSEG3EI8_V_MF2_MF8_MASK, VSUXSEG3EI8_V }, // 12479
  { PseudoVSUXSEG3EI8_V_MF4_M1, VSUXSEG3EI8_V }, // 12480
  { PseudoVSUXSEG3EI8_V_MF4_M1_MASK, VSUXSEG3EI8_V }, // 12481
  { PseudoVSUXSEG3EI8_V_MF4_M2, VSUXSEG3EI8_V }, // 12482
  { PseudoVSUXSEG3EI8_V_MF4_M2_MASK, VSUXSEG3EI8_V }, // 12483
  { PseudoVSUXSEG3EI8_V_MF4_MF2, VSUXSEG3EI8_V }, // 12484
  { PseudoVSUXSEG3EI8_V_MF4_MF2_MASK, VSUXSEG3EI8_V }, // 12485
  { PseudoVSUXSEG3EI8_V_MF4_MF4, VSUXSEG3EI8_V }, // 12486
  { PseudoVSUXSEG3EI8_V_MF4_MF4_MASK, VSUXSEG3EI8_V }, // 12487
  { PseudoVSUXSEG3EI8_V_MF4_MF8, VSUXSEG3EI8_V }, // 12488
  { PseudoVSUXSEG3EI8_V_MF4_MF8_MASK, VSUXSEG3EI8_V }, // 12489
  { PseudoVSUXSEG3EI8_V_MF8_M1, VSUXSEG3EI8_V }, // 12490
  { PseudoVSUXSEG3EI8_V_MF8_M1_MASK, VSUXSEG3EI8_V }, // 12491
  { PseudoVSUXSEG3EI8_V_MF8_M2, VSUXSEG3EI8_V }, // 12492
  { PseudoVSUXSEG3EI8_V_MF8_M2_MASK, VSUXSEG3EI8_V }, // 12493
  { PseudoVSUXSEG3EI8_V_MF8_MF2, VSUXSEG3EI8_V }, // 12494
  { PseudoVSUXSEG3EI8_V_MF8_MF2_MASK, VSUXSEG3EI8_V }, // 12495
  { PseudoVSUXSEG3EI8_V_MF8_MF4, VSUXSEG3EI8_V }, // 12496
  { PseudoVSUXSEG3EI8_V_MF8_MF4_MASK, VSUXSEG3EI8_V }, // 12497
  { PseudoVSUXSEG3EI8_V_MF8_MF8, VSUXSEG3EI8_V }, // 12498
  { PseudoVSUXSEG3EI8_V_MF8_MF8_MASK, VSUXSEG3EI8_V }, // 12499
  { PseudoVSUXSEG4EI16_V_M1_M1, VSUXSEG4EI16_V }, // 12500
  { PseudoVSUXSEG4EI16_V_M1_M1_MASK, VSUXSEG4EI16_V }, // 12501
  { PseudoVSUXSEG4EI16_V_M1_M2, VSUXSEG4EI16_V }, // 12502
  { PseudoVSUXSEG4EI16_V_M1_M2_MASK, VSUXSEG4EI16_V }, // 12503
  { PseudoVSUXSEG4EI16_V_M1_MF2, VSUXSEG4EI16_V }, // 12504
  { PseudoVSUXSEG4EI16_V_M1_MF2_MASK, VSUXSEG4EI16_V }, // 12505
  { PseudoVSUXSEG4EI16_V_M1_MF4, VSUXSEG4EI16_V }, // 12506
  { PseudoVSUXSEG4EI16_V_M1_MF4_MASK, VSUXSEG4EI16_V }, // 12507
  { PseudoVSUXSEG4EI16_V_M1_MF8, VSUXSEG4EI16_V }, // 12508
  { PseudoVSUXSEG4EI16_V_M1_MF8_MASK, VSUXSEG4EI16_V }, // 12509
  { PseudoVSUXSEG4EI16_V_M2_M1, VSUXSEG4EI16_V }, // 12510
  { PseudoVSUXSEG4EI16_V_M2_M1_MASK, VSUXSEG4EI16_V }, // 12511
  { PseudoVSUXSEG4EI16_V_M2_M2, VSUXSEG4EI16_V }, // 12512
  { PseudoVSUXSEG4EI16_V_M2_M2_MASK, VSUXSEG4EI16_V }, // 12513
  { PseudoVSUXSEG4EI16_V_M2_MF2, VSUXSEG4EI16_V }, // 12514
  { PseudoVSUXSEG4EI16_V_M2_MF2_MASK, VSUXSEG4EI16_V }, // 12515
  { PseudoVSUXSEG4EI16_V_M2_MF4, VSUXSEG4EI16_V }, // 12516
  { PseudoVSUXSEG4EI16_V_M2_MF4_MASK, VSUXSEG4EI16_V }, // 12517
  { PseudoVSUXSEG4EI16_V_M2_MF8, VSUXSEG4EI16_V }, // 12518
  { PseudoVSUXSEG4EI16_V_M2_MF8_MASK, VSUXSEG4EI16_V }, // 12519
  { PseudoVSUXSEG4EI16_V_M4_M1, VSUXSEG4EI16_V }, // 12520
  { PseudoVSUXSEG4EI16_V_M4_M1_MASK, VSUXSEG4EI16_V }, // 12521
  { PseudoVSUXSEG4EI16_V_M4_M2, VSUXSEG4EI16_V }, // 12522
  { PseudoVSUXSEG4EI16_V_M4_M2_MASK, VSUXSEG4EI16_V }, // 12523
  { PseudoVSUXSEG4EI16_V_M4_MF2, VSUXSEG4EI16_V }, // 12524
  { PseudoVSUXSEG4EI16_V_M4_MF2_MASK, VSUXSEG4EI16_V }, // 12525
  { PseudoVSUXSEG4EI16_V_M4_MF4, VSUXSEG4EI16_V }, // 12526
  { PseudoVSUXSEG4EI16_V_M4_MF4_MASK, VSUXSEG4EI16_V }, // 12527
  { PseudoVSUXSEG4EI16_V_M4_MF8, VSUXSEG4EI16_V }, // 12528
  { PseudoVSUXSEG4EI16_V_M4_MF8_MASK, VSUXSEG4EI16_V }, // 12529
  { PseudoVSUXSEG4EI16_V_M8_M1, VSUXSEG4EI16_V }, // 12530
  { PseudoVSUXSEG4EI16_V_M8_M1_MASK, VSUXSEG4EI16_V }, // 12531
  { PseudoVSUXSEG4EI16_V_M8_M2, VSUXSEG4EI16_V }, // 12532
  { PseudoVSUXSEG4EI16_V_M8_M2_MASK, VSUXSEG4EI16_V }, // 12533
  { PseudoVSUXSEG4EI16_V_M8_MF2, VSUXSEG4EI16_V }, // 12534
  { PseudoVSUXSEG4EI16_V_M8_MF2_MASK, VSUXSEG4EI16_V }, // 12535
  { PseudoVSUXSEG4EI16_V_M8_MF4, VSUXSEG4EI16_V }, // 12536
  { PseudoVSUXSEG4EI16_V_M8_MF4_MASK, VSUXSEG4EI16_V }, // 12537
  { PseudoVSUXSEG4EI16_V_M8_MF8, VSUXSEG4EI16_V }, // 12538
  { PseudoVSUXSEG4EI16_V_M8_MF8_MASK, VSUXSEG4EI16_V }, // 12539
  { PseudoVSUXSEG4EI16_V_MF2_M1, VSUXSEG4EI16_V }, // 12540
  { PseudoVSUXSEG4EI16_V_MF2_M1_MASK, VSUXSEG4EI16_V }, // 12541
  { PseudoVSUXSEG4EI16_V_MF2_M2, VSUXSEG4EI16_V }, // 12542
  { PseudoVSUXSEG4EI16_V_MF2_M2_MASK, VSUXSEG4EI16_V }, // 12543
  { PseudoVSUXSEG4EI16_V_MF2_MF2, VSUXSEG4EI16_V }, // 12544
  { PseudoVSUXSEG4EI16_V_MF2_MF2_MASK, VSUXSEG4EI16_V }, // 12545
  { PseudoVSUXSEG4EI16_V_MF2_MF4, VSUXSEG4EI16_V }, // 12546
  { PseudoVSUXSEG4EI16_V_MF2_MF4_MASK, VSUXSEG4EI16_V }, // 12547
  { PseudoVSUXSEG4EI16_V_MF2_MF8, VSUXSEG4EI16_V }, // 12548
  { PseudoVSUXSEG4EI16_V_MF2_MF8_MASK, VSUXSEG4EI16_V }, // 12549
  { PseudoVSUXSEG4EI16_V_MF4_M1, VSUXSEG4EI16_V }, // 12550
  { PseudoVSUXSEG4EI16_V_MF4_M1_MASK, VSUXSEG4EI16_V }, // 12551
  { PseudoVSUXSEG4EI16_V_MF4_M2, VSUXSEG4EI16_V }, // 12552
  { PseudoVSUXSEG4EI16_V_MF4_M2_MASK, VSUXSEG4EI16_V }, // 12553
  { PseudoVSUXSEG4EI16_V_MF4_MF2, VSUXSEG4EI16_V }, // 12554
  { PseudoVSUXSEG4EI16_V_MF4_MF2_MASK, VSUXSEG4EI16_V }, // 12555
  { PseudoVSUXSEG4EI16_V_MF4_MF4, VSUXSEG4EI16_V }, // 12556
  { PseudoVSUXSEG4EI16_V_MF4_MF4_MASK, VSUXSEG4EI16_V }, // 12557
  { PseudoVSUXSEG4EI16_V_MF4_MF8, VSUXSEG4EI16_V }, // 12558
  { PseudoVSUXSEG4EI16_V_MF4_MF8_MASK, VSUXSEG4EI16_V }, // 12559
  { PseudoVSUXSEG4EI32_V_M1_M1, VSUXSEG4EI32_V }, // 12560
  { PseudoVSUXSEG4EI32_V_M1_M1_MASK, VSUXSEG4EI32_V }, // 12561
  { PseudoVSUXSEG4EI32_V_M1_M2, VSUXSEG4EI32_V }, // 12562
  { PseudoVSUXSEG4EI32_V_M1_M2_MASK, VSUXSEG4EI32_V }, // 12563
  { PseudoVSUXSEG4EI32_V_M1_MF2, VSUXSEG4EI32_V }, // 12564
  { PseudoVSUXSEG4EI32_V_M1_MF2_MASK, VSUXSEG4EI32_V }, // 12565
  { PseudoVSUXSEG4EI32_V_M1_MF4, VSUXSEG4EI32_V }, // 12566
  { PseudoVSUXSEG4EI32_V_M1_MF4_MASK, VSUXSEG4EI32_V }, // 12567
  { PseudoVSUXSEG4EI32_V_M1_MF8, VSUXSEG4EI32_V }, // 12568
  { PseudoVSUXSEG4EI32_V_M1_MF8_MASK, VSUXSEG4EI32_V }, // 12569
  { PseudoVSUXSEG4EI32_V_M2_M1, VSUXSEG4EI32_V }, // 12570
  { PseudoVSUXSEG4EI32_V_M2_M1_MASK, VSUXSEG4EI32_V }, // 12571
  { PseudoVSUXSEG4EI32_V_M2_M2, VSUXSEG4EI32_V }, // 12572
  { PseudoVSUXSEG4EI32_V_M2_M2_MASK, VSUXSEG4EI32_V }, // 12573
  { PseudoVSUXSEG4EI32_V_M2_MF2, VSUXSEG4EI32_V }, // 12574
  { PseudoVSUXSEG4EI32_V_M2_MF2_MASK, VSUXSEG4EI32_V }, // 12575
  { PseudoVSUXSEG4EI32_V_M2_MF4, VSUXSEG4EI32_V }, // 12576
  { PseudoVSUXSEG4EI32_V_M2_MF4_MASK, VSUXSEG4EI32_V }, // 12577
  { PseudoVSUXSEG4EI32_V_M2_MF8, VSUXSEG4EI32_V }, // 12578
  { PseudoVSUXSEG4EI32_V_M2_MF8_MASK, VSUXSEG4EI32_V }, // 12579
  { PseudoVSUXSEG4EI32_V_M4_M1, VSUXSEG4EI32_V }, // 12580
  { PseudoVSUXSEG4EI32_V_M4_M1_MASK, VSUXSEG4EI32_V }, // 12581
  { PseudoVSUXSEG4EI32_V_M4_M2, VSUXSEG4EI32_V }, // 12582
  { PseudoVSUXSEG4EI32_V_M4_M2_MASK, VSUXSEG4EI32_V }, // 12583
  { PseudoVSUXSEG4EI32_V_M4_MF2, VSUXSEG4EI32_V }, // 12584
  { PseudoVSUXSEG4EI32_V_M4_MF2_MASK, VSUXSEG4EI32_V }, // 12585
  { PseudoVSUXSEG4EI32_V_M4_MF4, VSUXSEG4EI32_V }, // 12586
  { PseudoVSUXSEG4EI32_V_M4_MF4_MASK, VSUXSEG4EI32_V }, // 12587
  { PseudoVSUXSEG4EI32_V_M4_MF8, VSUXSEG4EI32_V }, // 12588
  { PseudoVSUXSEG4EI32_V_M4_MF8_MASK, VSUXSEG4EI32_V }, // 12589
  { PseudoVSUXSEG4EI32_V_M8_M1, VSUXSEG4EI32_V }, // 12590
  { PseudoVSUXSEG4EI32_V_M8_M1_MASK, VSUXSEG4EI32_V }, // 12591
  { PseudoVSUXSEG4EI32_V_M8_M2, VSUXSEG4EI32_V }, // 12592
  { PseudoVSUXSEG4EI32_V_M8_M2_MASK, VSUXSEG4EI32_V }, // 12593
  { PseudoVSUXSEG4EI32_V_M8_MF2, VSUXSEG4EI32_V }, // 12594
  { PseudoVSUXSEG4EI32_V_M8_MF2_MASK, VSUXSEG4EI32_V }, // 12595
  { PseudoVSUXSEG4EI32_V_M8_MF4, VSUXSEG4EI32_V }, // 12596
  { PseudoVSUXSEG4EI32_V_M8_MF4_MASK, VSUXSEG4EI32_V }, // 12597
  { PseudoVSUXSEG4EI32_V_M8_MF8, VSUXSEG4EI32_V }, // 12598
  { PseudoVSUXSEG4EI32_V_M8_MF8_MASK, VSUXSEG4EI32_V }, // 12599
  { PseudoVSUXSEG4EI32_V_MF2_M1, VSUXSEG4EI32_V }, // 12600
  { PseudoVSUXSEG4EI32_V_MF2_M1_MASK, VSUXSEG4EI32_V }, // 12601
  { PseudoVSUXSEG4EI32_V_MF2_M2, VSUXSEG4EI32_V }, // 12602
  { PseudoVSUXSEG4EI32_V_MF2_M2_MASK, VSUXSEG4EI32_V }, // 12603
  { PseudoVSUXSEG4EI32_V_MF2_MF2, VSUXSEG4EI32_V }, // 12604
  { PseudoVSUXSEG4EI32_V_MF2_MF2_MASK, VSUXSEG4EI32_V }, // 12605
  { PseudoVSUXSEG4EI32_V_MF2_MF4, VSUXSEG4EI32_V }, // 12606
  { PseudoVSUXSEG4EI32_V_MF2_MF4_MASK, VSUXSEG4EI32_V }, // 12607
  { PseudoVSUXSEG4EI32_V_MF2_MF8, VSUXSEG4EI32_V }, // 12608
  { PseudoVSUXSEG4EI32_V_MF2_MF8_MASK, VSUXSEG4EI32_V }, // 12609
  { PseudoVSUXSEG4EI64_V_M1_M1, VSUXSEG4EI64_V }, // 12610
  { PseudoVSUXSEG4EI64_V_M1_M1_MASK, VSUXSEG4EI64_V }, // 12611
  { PseudoVSUXSEG4EI64_V_M1_M2, VSUXSEG4EI64_V }, // 12612
  { PseudoVSUXSEG4EI64_V_M1_M2_MASK, VSUXSEG4EI64_V }, // 12613
  { PseudoVSUXSEG4EI64_V_M1_MF2, VSUXSEG4EI64_V }, // 12614
  { PseudoVSUXSEG4EI64_V_M1_MF2_MASK, VSUXSEG4EI64_V }, // 12615
  { PseudoVSUXSEG4EI64_V_M1_MF4, VSUXSEG4EI64_V }, // 12616
  { PseudoVSUXSEG4EI64_V_M1_MF4_MASK, VSUXSEG4EI64_V }, // 12617
  { PseudoVSUXSEG4EI64_V_M1_MF8, VSUXSEG4EI64_V }, // 12618
  { PseudoVSUXSEG4EI64_V_M1_MF8_MASK, VSUXSEG4EI64_V }, // 12619
  { PseudoVSUXSEG4EI64_V_M2_M1, VSUXSEG4EI64_V }, // 12620
  { PseudoVSUXSEG4EI64_V_M2_M1_MASK, VSUXSEG4EI64_V }, // 12621
  { PseudoVSUXSEG4EI64_V_M2_M2, VSUXSEG4EI64_V }, // 12622
  { PseudoVSUXSEG4EI64_V_M2_M2_MASK, VSUXSEG4EI64_V }, // 12623
  { PseudoVSUXSEG4EI64_V_M2_MF2, VSUXSEG4EI64_V }, // 12624
  { PseudoVSUXSEG4EI64_V_M2_MF2_MASK, VSUXSEG4EI64_V }, // 12625
  { PseudoVSUXSEG4EI64_V_M2_MF4, VSUXSEG4EI64_V }, // 12626
  { PseudoVSUXSEG4EI64_V_M2_MF4_MASK, VSUXSEG4EI64_V }, // 12627
  { PseudoVSUXSEG4EI64_V_M2_MF8, VSUXSEG4EI64_V }, // 12628
  { PseudoVSUXSEG4EI64_V_M2_MF8_MASK, VSUXSEG4EI64_V }, // 12629
  { PseudoVSUXSEG4EI64_V_M4_M1, VSUXSEG4EI64_V }, // 12630
  { PseudoVSUXSEG4EI64_V_M4_M1_MASK, VSUXSEG4EI64_V }, // 12631
  { PseudoVSUXSEG4EI64_V_M4_M2, VSUXSEG4EI64_V }, // 12632
  { PseudoVSUXSEG4EI64_V_M4_M2_MASK, VSUXSEG4EI64_V }, // 12633
  { PseudoVSUXSEG4EI64_V_M4_MF2, VSUXSEG4EI64_V }, // 12634
  { PseudoVSUXSEG4EI64_V_M4_MF2_MASK, VSUXSEG4EI64_V }, // 12635
  { PseudoVSUXSEG4EI64_V_M4_MF4, VSUXSEG4EI64_V }, // 12636
  { PseudoVSUXSEG4EI64_V_M4_MF4_MASK, VSUXSEG4EI64_V }, // 12637
  { PseudoVSUXSEG4EI64_V_M4_MF8, VSUXSEG4EI64_V }, // 12638
  { PseudoVSUXSEG4EI64_V_M4_MF8_MASK, VSUXSEG4EI64_V }, // 12639
  { PseudoVSUXSEG4EI64_V_M8_M1, VSUXSEG4EI64_V }, // 12640
  { PseudoVSUXSEG4EI64_V_M8_M1_MASK, VSUXSEG4EI64_V }, // 12641
  { PseudoVSUXSEG4EI64_V_M8_M2, VSUXSEG4EI64_V }, // 12642
  { PseudoVSUXSEG4EI64_V_M8_M2_MASK, VSUXSEG4EI64_V }, // 12643
  { PseudoVSUXSEG4EI64_V_M8_MF2, VSUXSEG4EI64_V }, // 12644
  { PseudoVSUXSEG4EI64_V_M8_MF2_MASK, VSUXSEG4EI64_V }, // 12645
  { PseudoVSUXSEG4EI64_V_M8_MF4, VSUXSEG4EI64_V }, // 12646
  { PseudoVSUXSEG4EI64_V_M8_MF4_MASK, VSUXSEG4EI64_V }, // 12647
  { PseudoVSUXSEG4EI64_V_M8_MF8, VSUXSEG4EI64_V }, // 12648
  { PseudoVSUXSEG4EI64_V_M8_MF8_MASK, VSUXSEG4EI64_V }, // 12649
  { PseudoVSUXSEG4EI8_V_M1_M1, VSUXSEG4EI8_V }, // 12650
  { PseudoVSUXSEG4EI8_V_M1_M1_MASK, VSUXSEG4EI8_V }, // 12651
  { PseudoVSUXSEG4EI8_V_M1_M2, VSUXSEG4EI8_V }, // 12652
  { PseudoVSUXSEG4EI8_V_M1_M2_MASK, VSUXSEG4EI8_V }, // 12653
  { PseudoVSUXSEG4EI8_V_M1_MF2, VSUXSEG4EI8_V }, // 12654
  { PseudoVSUXSEG4EI8_V_M1_MF2_MASK, VSUXSEG4EI8_V }, // 12655
  { PseudoVSUXSEG4EI8_V_M1_MF4, VSUXSEG4EI8_V }, // 12656
  { PseudoVSUXSEG4EI8_V_M1_MF4_MASK, VSUXSEG4EI8_V }, // 12657
  { PseudoVSUXSEG4EI8_V_M1_MF8, VSUXSEG4EI8_V }, // 12658
  { PseudoVSUXSEG4EI8_V_M1_MF8_MASK, VSUXSEG4EI8_V }, // 12659
  { PseudoVSUXSEG4EI8_V_M2_M1, VSUXSEG4EI8_V }, // 12660
  { PseudoVSUXSEG4EI8_V_M2_M1_MASK, VSUXSEG4EI8_V }, // 12661
  { PseudoVSUXSEG4EI8_V_M2_M2, VSUXSEG4EI8_V }, // 12662
  { PseudoVSUXSEG4EI8_V_M2_M2_MASK, VSUXSEG4EI8_V }, // 12663
  { PseudoVSUXSEG4EI8_V_M2_MF2, VSUXSEG4EI8_V }, // 12664
  { PseudoVSUXSEG4EI8_V_M2_MF2_MASK, VSUXSEG4EI8_V }, // 12665
  { PseudoVSUXSEG4EI8_V_M2_MF4, VSUXSEG4EI8_V }, // 12666
  { PseudoVSUXSEG4EI8_V_M2_MF4_MASK, VSUXSEG4EI8_V }, // 12667
  { PseudoVSUXSEG4EI8_V_M2_MF8, VSUXSEG4EI8_V }, // 12668
  { PseudoVSUXSEG4EI8_V_M2_MF8_MASK, VSUXSEG4EI8_V }, // 12669
  { PseudoVSUXSEG4EI8_V_M4_M1, VSUXSEG4EI8_V }, // 12670
  { PseudoVSUXSEG4EI8_V_M4_M1_MASK, VSUXSEG4EI8_V }, // 12671
  { PseudoVSUXSEG4EI8_V_M4_M2, VSUXSEG4EI8_V }, // 12672
  { PseudoVSUXSEG4EI8_V_M4_M2_MASK, VSUXSEG4EI8_V }, // 12673
  { PseudoVSUXSEG4EI8_V_M4_MF2, VSUXSEG4EI8_V }, // 12674
  { PseudoVSUXSEG4EI8_V_M4_MF2_MASK, VSUXSEG4EI8_V }, // 12675
  { PseudoVSUXSEG4EI8_V_M4_MF4, VSUXSEG4EI8_V }, // 12676
  { PseudoVSUXSEG4EI8_V_M4_MF4_MASK, VSUXSEG4EI8_V }, // 12677
  { PseudoVSUXSEG4EI8_V_M4_MF8, VSUXSEG4EI8_V }, // 12678
  { PseudoVSUXSEG4EI8_V_M4_MF8_MASK, VSUXSEG4EI8_V }, // 12679
  { PseudoVSUXSEG4EI8_V_M8_M1, VSUXSEG4EI8_V }, // 12680
  { PseudoVSUXSEG4EI8_V_M8_M1_MASK, VSUXSEG4EI8_V }, // 12681
  { PseudoVSUXSEG4EI8_V_M8_M2, VSUXSEG4EI8_V }, // 12682
  { PseudoVSUXSEG4EI8_V_M8_M2_MASK, VSUXSEG4EI8_V }, // 12683
  { PseudoVSUXSEG4EI8_V_M8_MF2, VSUXSEG4EI8_V }, // 12684
  { PseudoVSUXSEG4EI8_V_M8_MF2_MASK, VSUXSEG4EI8_V }, // 12685
  { PseudoVSUXSEG4EI8_V_M8_MF4, VSUXSEG4EI8_V }, // 12686
  { PseudoVSUXSEG4EI8_V_M8_MF4_MASK, VSUXSEG4EI8_V }, // 12687
  { PseudoVSUXSEG4EI8_V_M8_MF8, VSUXSEG4EI8_V }, // 12688
  { PseudoVSUXSEG4EI8_V_M8_MF8_MASK, VSUXSEG4EI8_V }, // 12689
  { PseudoVSUXSEG4EI8_V_MF2_M1, VSUXSEG4EI8_V }, // 12690
  { PseudoVSUXSEG4EI8_V_MF2_M1_MASK, VSUXSEG4EI8_V }, // 12691
  { PseudoVSUXSEG4EI8_V_MF2_M2, VSUXSEG4EI8_V }, // 12692
  { PseudoVSUXSEG4EI8_V_MF2_M2_MASK, VSUXSEG4EI8_V }, // 12693
  { PseudoVSUXSEG4EI8_V_MF2_MF2, VSUXSEG4EI8_V }, // 12694
  { PseudoVSUXSEG4EI8_V_MF2_MF2_MASK, VSUXSEG4EI8_V }, // 12695
  { PseudoVSUXSEG4EI8_V_MF2_MF4, VSUXSEG4EI8_V }, // 12696
  { PseudoVSUXSEG4EI8_V_MF2_MF4_MASK, VSUXSEG4EI8_V }, // 12697
  { PseudoVSUXSEG4EI8_V_MF2_MF8, VSUXSEG4EI8_V }, // 12698
  { PseudoVSUXSEG4EI8_V_MF2_MF8_MASK, VSUXSEG4EI8_V }, // 12699
  { PseudoVSUXSEG4EI8_V_MF4_M1, VSUXSEG4EI8_V }, // 12700
  { PseudoVSUXSEG4EI8_V_MF4_M1_MASK, VSUXSEG4EI8_V }, // 12701
  { PseudoVSUXSEG4EI8_V_MF4_M2, VSUXSEG4EI8_V }, // 12702
  { PseudoVSUXSEG4EI8_V_MF4_M2_MASK, VSUXSEG4EI8_V }, // 12703
  { PseudoVSUXSEG4EI8_V_MF4_MF2, VSUXSEG4EI8_V }, // 12704
  { PseudoVSUXSEG4EI8_V_MF4_MF2_MASK, VSUXSEG4EI8_V }, // 12705
  { PseudoVSUXSEG4EI8_V_MF4_MF4, VSUXSEG4EI8_V }, // 12706
  { PseudoVSUXSEG4EI8_V_MF4_MF4_MASK, VSUXSEG4EI8_V }, // 12707
  { PseudoVSUXSEG4EI8_V_MF4_MF8, VSUXSEG4EI8_V }, // 12708
  { PseudoVSUXSEG4EI8_V_MF4_MF8_MASK, VSUXSEG4EI8_V }, // 12709
  { PseudoVSUXSEG4EI8_V_MF8_M1, VSUXSEG4EI8_V }, // 12710
  { PseudoVSUXSEG4EI8_V_MF8_M1_MASK, VSUXSEG4EI8_V }, // 12711
  { PseudoVSUXSEG4EI8_V_MF8_M2, VSUXSEG4EI8_V }, // 12712
  { PseudoVSUXSEG4EI8_V_MF8_M2_MASK, VSUXSEG4EI8_V }, // 12713
  { PseudoVSUXSEG4EI8_V_MF8_MF2, VSUXSEG4EI8_V }, // 12714
  { PseudoVSUXSEG4EI8_V_MF8_MF2_MASK, VSUXSEG4EI8_V }, // 12715
  { PseudoVSUXSEG4EI8_V_MF8_MF4, VSUXSEG4EI8_V }, // 12716
  { PseudoVSUXSEG4EI8_V_MF8_MF4_MASK, VSUXSEG4EI8_V }, // 12717
  { PseudoVSUXSEG4EI8_V_MF8_MF8, VSUXSEG4EI8_V }, // 12718
  { PseudoVSUXSEG4EI8_V_MF8_MF8_MASK, VSUXSEG4EI8_V }, // 12719
  { PseudoVSUXSEG5EI16_V_M1_M1, VSUXSEG5EI16_V }, // 12720
  { PseudoVSUXSEG5EI16_V_M1_M1_MASK, VSUXSEG5EI16_V }, // 12721
  { PseudoVSUXSEG5EI16_V_M1_MF2, VSUXSEG5EI16_V }, // 12722
  { PseudoVSUXSEG5EI16_V_M1_MF2_MASK, VSUXSEG5EI16_V }, // 12723
  { PseudoVSUXSEG5EI16_V_M1_MF4, VSUXSEG5EI16_V }, // 12724
  { PseudoVSUXSEG5EI16_V_M1_MF4_MASK, VSUXSEG5EI16_V }, // 12725
  { PseudoVSUXSEG5EI16_V_M1_MF8, VSUXSEG5EI16_V }, // 12726
  { PseudoVSUXSEG5EI16_V_M1_MF8_MASK, VSUXSEG5EI16_V }, // 12727
  { PseudoVSUXSEG5EI16_V_M2_M1, VSUXSEG5EI16_V }, // 12728
  { PseudoVSUXSEG5EI16_V_M2_M1_MASK, VSUXSEG5EI16_V }, // 12729
  { PseudoVSUXSEG5EI16_V_M2_MF2, VSUXSEG5EI16_V }, // 12730
  { PseudoVSUXSEG5EI16_V_M2_MF2_MASK, VSUXSEG5EI16_V }, // 12731
  { PseudoVSUXSEG5EI16_V_M2_MF4, VSUXSEG5EI16_V }, // 12732
  { PseudoVSUXSEG5EI16_V_M2_MF4_MASK, VSUXSEG5EI16_V }, // 12733
  { PseudoVSUXSEG5EI16_V_M2_MF8, VSUXSEG5EI16_V }, // 12734
  { PseudoVSUXSEG5EI16_V_M2_MF8_MASK, VSUXSEG5EI16_V }, // 12735
  { PseudoVSUXSEG5EI16_V_M4_M1, VSUXSEG5EI16_V }, // 12736
  { PseudoVSUXSEG5EI16_V_M4_M1_MASK, VSUXSEG5EI16_V }, // 12737
  { PseudoVSUXSEG5EI16_V_M4_MF2, VSUXSEG5EI16_V }, // 12738
  { PseudoVSUXSEG5EI16_V_M4_MF2_MASK, VSUXSEG5EI16_V }, // 12739
  { PseudoVSUXSEG5EI16_V_M4_MF4, VSUXSEG5EI16_V }, // 12740
  { PseudoVSUXSEG5EI16_V_M4_MF4_MASK, VSUXSEG5EI16_V }, // 12741
  { PseudoVSUXSEG5EI16_V_M4_MF8, VSUXSEG5EI16_V }, // 12742
  { PseudoVSUXSEG5EI16_V_M4_MF8_MASK, VSUXSEG5EI16_V }, // 12743
  { PseudoVSUXSEG5EI16_V_M8_M1, VSUXSEG5EI16_V }, // 12744
  { PseudoVSUXSEG5EI16_V_M8_M1_MASK, VSUXSEG5EI16_V }, // 12745
  { PseudoVSUXSEG5EI16_V_M8_MF2, VSUXSEG5EI16_V }, // 12746
  { PseudoVSUXSEG5EI16_V_M8_MF2_MASK, VSUXSEG5EI16_V }, // 12747
  { PseudoVSUXSEG5EI16_V_M8_MF4, VSUXSEG5EI16_V }, // 12748
  { PseudoVSUXSEG5EI16_V_M8_MF4_MASK, VSUXSEG5EI16_V }, // 12749
  { PseudoVSUXSEG5EI16_V_M8_MF8, VSUXSEG5EI16_V }, // 12750
  { PseudoVSUXSEG5EI16_V_M8_MF8_MASK, VSUXSEG5EI16_V }, // 12751
  { PseudoVSUXSEG5EI16_V_MF2_M1, VSUXSEG5EI16_V }, // 12752
  { PseudoVSUXSEG5EI16_V_MF2_M1_MASK, VSUXSEG5EI16_V }, // 12753
  { PseudoVSUXSEG5EI16_V_MF2_MF2, VSUXSEG5EI16_V }, // 12754
  { PseudoVSUXSEG5EI16_V_MF2_MF2_MASK, VSUXSEG5EI16_V }, // 12755
  { PseudoVSUXSEG5EI16_V_MF2_MF4, VSUXSEG5EI16_V }, // 12756
  { PseudoVSUXSEG5EI16_V_MF2_MF4_MASK, VSUXSEG5EI16_V }, // 12757
  { PseudoVSUXSEG5EI16_V_MF2_MF8, VSUXSEG5EI16_V }, // 12758
  { PseudoVSUXSEG5EI16_V_MF2_MF8_MASK, VSUXSEG5EI16_V }, // 12759
  { PseudoVSUXSEG5EI16_V_MF4_M1, VSUXSEG5EI16_V }, // 12760
  { PseudoVSUXSEG5EI16_V_MF4_M1_MASK, VSUXSEG5EI16_V }, // 12761
  { PseudoVSUXSEG5EI16_V_MF4_MF2, VSUXSEG5EI16_V }, // 12762
  { PseudoVSUXSEG5EI16_V_MF4_MF2_MASK, VSUXSEG5EI16_V }, // 12763
  { PseudoVSUXSEG5EI16_V_MF4_MF4, VSUXSEG5EI16_V }, // 12764
  { PseudoVSUXSEG5EI16_V_MF4_MF4_MASK, VSUXSEG5EI16_V }, // 12765
  { PseudoVSUXSEG5EI16_V_MF4_MF8, VSUXSEG5EI16_V }, // 12766
  { PseudoVSUXSEG5EI16_V_MF4_MF8_MASK, VSUXSEG5EI16_V }, // 12767
  { PseudoVSUXSEG5EI32_V_M1_M1, VSUXSEG5EI32_V }, // 12768
  { PseudoVSUXSEG5EI32_V_M1_M1_MASK, VSUXSEG5EI32_V }, // 12769
  { PseudoVSUXSEG5EI32_V_M1_MF2, VSUXSEG5EI32_V }, // 12770
  { PseudoVSUXSEG5EI32_V_M1_MF2_MASK, VSUXSEG5EI32_V }, // 12771
  { PseudoVSUXSEG5EI32_V_M1_MF4, VSUXSEG5EI32_V }, // 12772
  { PseudoVSUXSEG5EI32_V_M1_MF4_MASK, VSUXSEG5EI32_V }, // 12773
  { PseudoVSUXSEG5EI32_V_M1_MF8, VSUXSEG5EI32_V }, // 12774
  { PseudoVSUXSEG5EI32_V_M1_MF8_MASK, VSUXSEG5EI32_V }, // 12775
  { PseudoVSUXSEG5EI32_V_M2_M1, VSUXSEG5EI32_V }, // 12776
  { PseudoVSUXSEG5EI32_V_M2_M1_MASK, VSUXSEG5EI32_V }, // 12777
  { PseudoVSUXSEG5EI32_V_M2_MF2, VSUXSEG5EI32_V }, // 12778
  { PseudoVSUXSEG5EI32_V_M2_MF2_MASK, VSUXSEG5EI32_V }, // 12779
  { PseudoVSUXSEG5EI32_V_M2_MF4, VSUXSEG5EI32_V }, // 12780
  { PseudoVSUXSEG5EI32_V_M2_MF4_MASK, VSUXSEG5EI32_V }, // 12781
  { PseudoVSUXSEG5EI32_V_M2_MF8, VSUXSEG5EI32_V }, // 12782
  { PseudoVSUXSEG5EI32_V_M2_MF8_MASK, VSUXSEG5EI32_V }, // 12783
  { PseudoVSUXSEG5EI32_V_M4_M1, VSUXSEG5EI32_V }, // 12784
  { PseudoVSUXSEG5EI32_V_M4_M1_MASK, VSUXSEG5EI32_V }, // 12785
  { PseudoVSUXSEG5EI32_V_M4_MF2, VSUXSEG5EI32_V }, // 12786
  { PseudoVSUXSEG5EI32_V_M4_MF2_MASK, VSUXSEG5EI32_V }, // 12787
  { PseudoVSUXSEG5EI32_V_M4_MF4, VSUXSEG5EI32_V }, // 12788
  { PseudoVSUXSEG5EI32_V_M4_MF4_MASK, VSUXSEG5EI32_V }, // 12789
  { PseudoVSUXSEG5EI32_V_M4_MF8, VSUXSEG5EI32_V }, // 12790
  { PseudoVSUXSEG5EI32_V_M4_MF8_MASK, VSUXSEG5EI32_V }, // 12791
  { PseudoVSUXSEG5EI32_V_M8_M1, VSUXSEG5EI32_V }, // 12792
  { PseudoVSUXSEG5EI32_V_M8_M1_MASK, VSUXSEG5EI32_V }, // 12793
  { PseudoVSUXSEG5EI32_V_M8_MF2, VSUXSEG5EI32_V }, // 12794
  { PseudoVSUXSEG5EI32_V_M8_MF2_MASK, VSUXSEG5EI32_V }, // 12795
  { PseudoVSUXSEG5EI32_V_M8_MF4, VSUXSEG5EI32_V }, // 12796
  { PseudoVSUXSEG5EI32_V_M8_MF4_MASK, VSUXSEG5EI32_V }, // 12797
  { PseudoVSUXSEG5EI32_V_M8_MF8, VSUXSEG5EI32_V }, // 12798
  { PseudoVSUXSEG5EI32_V_M8_MF8_MASK, VSUXSEG5EI32_V }, // 12799
  { PseudoVSUXSEG5EI32_V_MF2_M1, VSUXSEG5EI32_V }, // 12800
  { PseudoVSUXSEG5EI32_V_MF2_M1_MASK, VSUXSEG5EI32_V }, // 12801
  { PseudoVSUXSEG5EI32_V_MF2_MF2, VSUXSEG5EI32_V }, // 12802
  { PseudoVSUXSEG5EI32_V_MF2_MF2_MASK, VSUXSEG5EI32_V }, // 12803
  { PseudoVSUXSEG5EI32_V_MF2_MF4, VSUXSEG5EI32_V }, // 12804
  { PseudoVSUXSEG5EI32_V_MF2_MF4_MASK, VSUXSEG5EI32_V }, // 12805
  { PseudoVSUXSEG5EI32_V_MF2_MF8, VSUXSEG5EI32_V }, // 12806
  { PseudoVSUXSEG5EI32_V_MF2_MF8_MASK, VSUXSEG5EI32_V }, // 12807
  { PseudoVSUXSEG5EI64_V_M1_M1, VSUXSEG5EI64_V }, // 12808
  { PseudoVSUXSEG5EI64_V_M1_M1_MASK, VSUXSEG5EI64_V }, // 12809
  { PseudoVSUXSEG5EI64_V_M1_MF2, VSUXSEG5EI64_V }, // 12810
  { PseudoVSUXSEG5EI64_V_M1_MF2_MASK, VSUXSEG5EI64_V }, // 12811
  { PseudoVSUXSEG5EI64_V_M1_MF4, VSUXSEG5EI64_V }, // 12812
  { PseudoVSUXSEG5EI64_V_M1_MF4_MASK, VSUXSEG5EI64_V }, // 12813
  { PseudoVSUXSEG5EI64_V_M1_MF8, VSUXSEG5EI64_V }, // 12814
  { PseudoVSUXSEG5EI64_V_M1_MF8_MASK, VSUXSEG5EI64_V }, // 12815
  { PseudoVSUXSEG5EI64_V_M2_M1, VSUXSEG5EI64_V }, // 12816
  { PseudoVSUXSEG5EI64_V_M2_M1_MASK, VSUXSEG5EI64_V }, // 12817
  { PseudoVSUXSEG5EI64_V_M2_MF2, VSUXSEG5EI64_V }, // 12818
  { PseudoVSUXSEG5EI64_V_M2_MF2_MASK, VSUXSEG5EI64_V }, // 12819
  { PseudoVSUXSEG5EI64_V_M2_MF4, VSUXSEG5EI64_V }, // 12820
  { PseudoVSUXSEG5EI64_V_M2_MF4_MASK, VSUXSEG5EI64_V }, // 12821
  { PseudoVSUXSEG5EI64_V_M2_MF8, VSUXSEG5EI64_V }, // 12822
  { PseudoVSUXSEG5EI64_V_M2_MF8_MASK, VSUXSEG5EI64_V }, // 12823
  { PseudoVSUXSEG5EI64_V_M4_M1, VSUXSEG5EI64_V }, // 12824
  { PseudoVSUXSEG5EI64_V_M4_M1_MASK, VSUXSEG5EI64_V }, // 12825
  { PseudoVSUXSEG5EI64_V_M4_MF2, VSUXSEG5EI64_V }, // 12826
  { PseudoVSUXSEG5EI64_V_M4_MF2_MASK, VSUXSEG5EI64_V }, // 12827
  { PseudoVSUXSEG5EI64_V_M4_MF4, VSUXSEG5EI64_V }, // 12828
  { PseudoVSUXSEG5EI64_V_M4_MF4_MASK, VSUXSEG5EI64_V }, // 12829
  { PseudoVSUXSEG5EI64_V_M4_MF8, VSUXSEG5EI64_V }, // 12830
  { PseudoVSUXSEG5EI64_V_M4_MF8_MASK, VSUXSEG5EI64_V }, // 12831
  { PseudoVSUXSEG5EI64_V_M8_M1, VSUXSEG5EI64_V }, // 12832
  { PseudoVSUXSEG5EI64_V_M8_M1_MASK, VSUXSEG5EI64_V }, // 12833
  { PseudoVSUXSEG5EI64_V_M8_MF2, VSUXSEG5EI64_V }, // 12834
  { PseudoVSUXSEG5EI64_V_M8_MF2_MASK, VSUXSEG5EI64_V }, // 12835
  { PseudoVSUXSEG5EI64_V_M8_MF4, VSUXSEG5EI64_V }, // 12836
  { PseudoVSUXSEG5EI64_V_M8_MF4_MASK, VSUXSEG5EI64_V }, // 12837
  { PseudoVSUXSEG5EI64_V_M8_MF8, VSUXSEG5EI64_V }, // 12838
  { PseudoVSUXSEG5EI64_V_M8_MF8_MASK, VSUXSEG5EI64_V }, // 12839
  { PseudoVSUXSEG5EI8_V_M1_M1, VSUXSEG5EI8_V }, // 12840
  { PseudoVSUXSEG5EI8_V_M1_M1_MASK, VSUXSEG5EI8_V }, // 12841
  { PseudoVSUXSEG5EI8_V_M1_MF2, VSUXSEG5EI8_V }, // 12842
  { PseudoVSUXSEG5EI8_V_M1_MF2_MASK, VSUXSEG5EI8_V }, // 12843
  { PseudoVSUXSEG5EI8_V_M1_MF4, VSUXSEG5EI8_V }, // 12844
  { PseudoVSUXSEG5EI8_V_M1_MF4_MASK, VSUXSEG5EI8_V }, // 12845
  { PseudoVSUXSEG5EI8_V_M1_MF8, VSUXSEG5EI8_V }, // 12846
  { PseudoVSUXSEG5EI8_V_M1_MF8_MASK, VSUXSEG5EI8_V }, // 12847
  { PseudoVSUXSEG5EI8_V_M2_M1, VSUXSEG5EI8_V }, // 12848
  { PseudoVSUXSEG5EI8_V_M2_M1_MASK, VSUXSEG5EI8_V }, // 12849
  { PseudoVSUXSEG5EI8_V_M2_MF2, VSUXSEG5EI8_V }, // 12850
  { PseudoVSUXSEG5EI8_V_M2_MF2_MASK, VSUXSEG5EI8_V }, // 12851
  { PseudoVSUXSEG5EI8_V_M2_MF4, VSUXSEG5EI8_V }, // 12852
  { PseudoVSUXSEG5EI8_V_M2_MF4_MASK, VSUXSEG5EI8_V }, // 12853
  { PseudoVSUXSEG5EI8_V_M2_MF8, VSUXSEG5EI8_V }, // 12854
  { PseudoVSUXSEG5EI8_V_M2_MF8_MASK, VSUXSEG5EI8_V }, // 12855
  { PseudoVSUXSEG5EI8_V_M4_M1, VSUXSEG5EI8_V }, // 12856
  { PseudoVSUXSEG5EI8_V_M4_M1_MASK, VSUXSEG5EI8_V }, // 12857
  { PseudoVSUXSEG5EI8_V_M4_MF2, VSUXSEG5EI8_V }, // 12858
  { PseudoVSUXSEG5EI8_V_M4_MF2_MASK, VSUXSEG5EI8_V }, // 12859
  { PseudoVSUXSEG5EI8_V_M4_MF4, VSUXSEG5EI8_V }, // 12860
  { PseudoVSUXSEG5EI8_V_M4_MF4_MASK, VSUXSEG5EI8_V }, // 12861
  { PseudoVSUXSEG5EI8_V_M4_MF8, VSUXSEG5EI8_V }, // 12862
  { PseudoVSUXSEG5EI8_V_M4_MF8_MASK, VSUXSEG5EI8_V }, // 12863
  { PseudoVSUXSEG5EI8_V_M8_M1, VSUXSEG5EI8_V }, // 12864
  { PseudoVSUXSEG5EI8_V_M8_M1_MASK, VSUXSEG5EI8_V }, // 12865
  { PseudoVSUXSEG5EI8_V_M8_MF2, VSUXSEG5EI8_V }, // 12866
  { PseudoVSUXSEG5EI8_V_M8_MF2_MASK, VSUXSEG5EI8_V }, // 12867
  { PseudoVSUXSEG5EI8_V_M8_MF4, VSUXSEG5EI8_V }, // 12868
  { PseudoVSUXSEG5EI8_V_M8_MF4_MASK, VSUXSEG5EI8_V }, // 12869
  { PseudoVSUXSEG5EI8_V_M8_MF8, VSUXSEG5EI8_V }, // 12870
  { PseudoVSUXSEG5EI8_V_M8_MF8_MASK, VSUXSEG5EI8_V }, // 12871
  { PseudoVSUXSEG5EI8_V_MF2_M1, VSUXSEG5EI8_V }, // 12872
  { PseudoVSUXSEG5EI8_V_MF2_M1_MASK, VSUXSEG5EI8_V }, // 12873
  { PseudoVSUXSEG5EI8_V_MF2_MF2, VSUXSEG5EI8_V }, // 12874
  { PseudoVSUXSEG5EI8_V_MF2_MF2_MASK, VSUXSEG5EI8_V }, // 12875
  { PseudoVSUXSEG5EI8_V_MF2_MF4, VSUXSEG5EI8_V }, // 12876
  { PseudoVSUXSEG5EI8_V_MF2_MF4_MASK, VSUXSEG5EI8_V }, // 12877
  { PseudoVSUXSEG5EI8_V_MF2_MF8, VSUXSEG5EI8_V }, // 12878
  { PseudoVSUXSEG5EI8_V_MF2_MF8_MASK, VSUXSEG5EI8_V }, // 12879
  { PseudoVSUXSEG5EI8_V_MF4_M1, VSUXSEG5EI8_V }, // 12880
  { PseudoVSUXSEG5EI8_V_MF4_M1_MASK, VSUXSEG5EI8_V }, // 12881
  { PseudoVSUXSEG5EI8_V_MF4_MF2, VSUXSEG5EI8_V }, // 12882
  { PseudoVSUXSEG5EI8_V_MF4_MF2_MASK, VSUXSEG5EI8_V }, // 12883
  { PseudoVSUXSEG5EI8_V_MF4_MF4, VSUXSEG5EI8_V }, // 12884
  { PseudoVSUXSEG5EI8_V_MF4_MF4_MASK, VSUXSEG5EI8_V }, // 12885
  { PseudoVSUXSEG5EI8_V_MF4_MF8, VSUXSEG5EI8_V }, // 12886
  { PseudoVSUXSEG5EI8_V_MF4_MF8_MASK, VSUXSEG5EI8_V }, // 12887
  { PseudoVSUXSEG5EI8_V_MF8_M1, VSUXSEG5EI8_V }, // 12888
  { PseudoVSUXSEG5EI8_V_MF8_M1_MASK, VSUXSEG5EI8_V }, // 12889
  { PseudoVSUXSEG5EI8_V_MF8_MF2, VSUXSEG5EI8_V }, // 12890
  { PseudoVSUXSEG5EI8_V_MF8_MF2_MASK, VSUXSEG5EI8_V }, // 12891
  { PseudoVSUXSEG5EI8_V_MF8_MF4, VSUXSEG5EI8_V }, // 12892
  { PseudoVSUXSEG5EI8_V_MF8_MF4_MASK, VSUXSEG5EI8_V }, // 12893
  { PseudoVSUXSEG5EI8_V_MF8_MF8, VSUXSEG5EI8_V }, // 12894
  { PseudoVSUXSEG5EI8_V_MF8_MF8_MASK, VSUXSEG5EI8_V }, // 12895
  { PseudoVSUXSEG6EI16_V_M1_M1, VSUXSEG6EI16_V }, // 12896
  { PseudoVSUXSEG6EI16_V_M1_M1_MASK, VSUXSEG6EI16_V }, // 12897
  { PseudoVSUXSEG6EI16_V_M1_MF2, VSUXSEG6EI16_V }, // 12898
  { PseudoVSUXSEG6EI16_V_M1_MF2_MASK, VSUXSEG6EI16_V }, // 12899
  { PseudoVSUXSEG6EI16_V_M1_MF4, VSUXSEG6EI16_V }, // 12900
  { PseudoVSUXSEG6EI16_V_M1_MF4_MASK, VSUXSEG6EI16_V }, // 12901
  { PseudoVSUXSEG6EI16_V_M1_MF8, VSUXSEG6EI16_V }, // 12902
  { PseudoVSUXSEG6EI16_V_M1_MF8_MASK, VSUXSEG6EI16_V }, // 12903
  { PseudoVSUXSEG6EI16_V_M2_M1, VSUXSEG6EI16_V }, // 12904
  { PseudoVSUXSEG6EI16_V_M2_M1_MASK, VSUXSEG6EI16_V }, // 12905
  { PseudoVSUXSEG6EI16_V_M2_MF2, VSUXSEG6EI16_V }, // 12906
  { PseudoVSUXSEG6EI16_V_M2_MF2_MASK, VSUXSEG6EI16_V }, // 12907
  { PseudoVSUXSEG6EI16_V_M2_MF4, VSUXSEG6EI16_V }, // 12908
  { PseudoVSUXSEG6EI16_V_M2_MF4_MASK, VSUXSEG6EI16_V }, // 12909
  { PseudoVSUXSEG6EI16_V_M2_MF8, VSUXSEG6EI16_V }, // 12910
  { PseudoVSUXSEG6EI16_V_M2_MF8_MASK, VSUXSEG6EI16_V }, // 12911
  { PseudoVSUXSEG6EI16_V_M4_M1, VSUXSEG6EI16_V }, // 12912
  { PseudoVSUXSEG6EI16_V_M4_M1_MASK, VSUXSEG6EI16_V }, // 12913
  { PseudoVSUXSEG6EI16_V_M4_MF2, VSUXSEG6EI16_V }, // 12914
  { PseudoVSUXSEG6EI16_V_M4_MF2_MASK, VSUXSEG6EI16_V }, // 12915
  { PseudoVSUXSEG6EI16_V_M4_MF4, VSUXSEG6EI16_V }, // 12916
  { PseudoVSUXSEG6EI16_V_M4_MF4_MASK, VSUXSEG6EI16_V }, // 12917
  { PseudoVSUXSEG6EI16_V_M4_MF8, VSUXSEG6EI16_V }, // 12918
  { PseudoVSUXSEG6EI16_V_M4_MF8_MASK, VSUXSEG6EI16_V }, // 12919
  { PseudoVSUXSEG6EI16_V_M8_M1, VSUXSEG6EI16_V }, // 12920
  { PseudoVSUXSEG6EI16_V_M8_M1_MASK, VSUXSEG6EI16_V }, // 12921
  { PseudoVSUXSEG6EI16_V_M8_MF2, VSUXSEG6EI16_V }, // 12922
  { PseudoVSUXSEG6EI16_V_M8_MF2_MASK, VSUXSEG6EI16_V }, // 12923
  { PseudoVSUXSEG6EI16_V_M8_MF4, VSUXSEG6EI16_V }, // 12924
  { PseudoVSUXSEG6EI16_V_M8_MF4_MASK, VSUXSEG6EI16_V }, // 12925
  { PseudoVSUXSEG6EI16_V_M8_MF8, VSUXSEG6EI16_V }, // 12926
  { PseudoVSUXSEG6EI16_V_M8_MF8_MASK, VSUXSEG6EI16_V }, // 12927
  { PseudoVSUXSEG6EI16_V_MF2_M1, VSUXSEG6EI16_V }, // 12928
  { PseudoVSUXSEG6EI16_V_MF2_M1_MASK, VSUXSEG6EI16_V }, // 12929
  { PseudoVSUXSEG6EI16_V_MF2_MF2, VSUXSEG6EI16_V }, // 12930
  { PseudoVSUXSEG6EI16_V_MF2_MF2_MASK, VSUXSEG6EI16_V }, // 12931
  { PseudoVSUXSEG6EI16_V_MF2_MF4, VSUXSEG6EI16_V }, // 12932
  { PseudoVSUXSEG6EI16_V_MF2_MF4_MASK, VSUXSEG6EI16_V }, // 12933
  { PseudoVSUXSEG6EI16_V_MF2_MF8, VSUXSEG6EI16_V }, // 12934
  { PseudoVSUXSEG6EI16_V_MF2_MF8_MASK, VSUXSEG6EI16_V }, // 12935
  { PseudoVSUXSEG6EI16_V_MF4_M1, VSUXSEG6EI16_V }, // 12936
  { PseudoVSUXSEG6EI16_V_MF4_M1_MASK, VSUXSEG6EI16_V }, // 12937
  { PseudoVSUXSEG6EI16_V_MF4_MF2, VSUXSEG6EI16_V }, // 12938
  { PseudoVSUXSEG6EI16_V_MF4_MF2_MASK, VSUXSEG6EI16_V }, // 12939
  { PseudoVSUXSEG6EI16_V_MF4_MF4, VSUXSEG6EI16_V }, // 12940
  { PseudoVSUXSEG6EI16_V_MF4_MF4_MASK, VSUXSEG6EI16_V }, // 12941
  { PseudoVSUXSEG6EI16_V_MF4_MF8, VSUXSEG6EI16_V }, // 12942
  { PseudoVSUXSEG6EI16_V_MF4_MF8_MASK, VSUXSEG6EI16_V }, // 12943
  { PseudoVSUXSEG6EI32_V_M1_M1, VSUXSEG6EI32_V }, // 12944
  { PseudoVSUXSEG6EI32_V_M1_M1_MASK, VSUXSEG6EI32_V }, // 12945
  { PseudoVSUXSEG6EI32_V_M1_MF2, VSUXSEG6EI32_V }, // 12946
  { PseudoVSUXSEG6EI32_V_M1_MF2_MASK, VSUXSEG6EI32_V }, // 12947
  { PseudoVSUXSEG6EI32_V_M1_MF4, VSUXSEG6EI32_V }, // 12948
  { PseudoVSUXSEG6EI32_V_M1_MF4_MASK, VSUXSEG6EI32_V }, // 12949
  { PseudoVSUXSEG6EI32_V_M1_MF8, VSUXSEG6EI32_V }, // 12950
  { PseudoVSUXSEG6EI32_V_M1_MF8_MASK, VSUXSEG6EI32_V }, // 12951
  { PseudoVSUXSEG6EI32_V_M2_M1, VSUXSEG6EI32_V }, // 12952
  { PseudoVSUXSEG6EI32_V_M2_M1_MASK, VSUXSEG6EI32_V }, // 12953
  { PseudoVSUXSEG6EI32_V_M2_MF2, VSUXSEG6EI32_V }, // 12954
  { PseudoVSUXSEG6EI32_V_M2_MF2_MASK, VSUXSEG6EI32_V }, // 12955
  { PseudoVSUXSEG6EI32_V_M2_MF4, VSUXSEG6EI32_V }, // 12956
  { PseudoVSUXSEG6EI32_V_M2_MF4_MASK, VSUXSEG6EI32_V }, // 12957
  { PseudoVSUXSEG6EI32_V_M2_MF8, VSUXSEG6EI32_V }, // 12958
  { PseudoVSUXSEG6EI32_V_M2_MF8_MASK, VSUXSEG6EI32_V }, // 12959
  { PseudoVSUXSEG6EI32_V_M4_M1, VSUXSEG6EI32_V }, // 12960
  { PseudoVSUXSEG6EI32_V_M4_M1_MASK, VSUXSEG6EI32_V }, // 12961
  { PseudoVSUXSEG6EI32_V_M4_MF2, VSUXSEG6EI32_V }, // 12962
  { PseudoVSUXSEG6EI32_V_M4_MF2_MASK, VSUXSEG6EI32_V }, // 12963
  { PseudoVSUXSEG6EI32_V_M4_MF4, VSUXSEG6EI32_V }, // 12964
  { PseudoVSUXSEG6EI32_V_M4_MF4_MASK, VSUXSEG6EI32_V }, // 12965
  { PseudoVSUXSEG6EI32_V_M4_MF8, VSUXSEG6EI32_V }, // 12966
  { PseudoVSUXSEG6EI32_V_M4_MF8_MASK, VSUXSEG6EI32_V }, // 12967
  { PseudoVSUXSEG6EI32_V_M8_M1, VSUXSEG6EI32_V }, // 12968
  { PseudoVSUXSEG6EI32_V_M8_M1_MASK, VSUXSEG6EI32_V }, // 12969
  { PseudoVSUXSEG6EI32_V_M8_MF2, VSUXSEG6EI32_V }, // 12970
  { PseudoVSUXSEG6EI32_V_M8_MF2_MASK, VSUXSEG6EI32_V }, // 12971
  { PseudoVSUXSEG6EI32_V_M8_MF4, VSUXSEG6EI32_V }, // 12972
  { PseudoVSUXSEG6EI32_V_M8_MF4_MASK, VSUXSEG6EI32_V }, // 12973
  { PseudoVSUXSEG6EI32_V_M8_MF8, VSUXSEG6EI32_V }, // 12974
  { PseudoVSUXSEG6EI32_V_M8_MF8_MASK, VSUXSEG6EI32_V }, // 12975
  { PseudoVSUXSEG6EI32_V_MF2_M1, VSUXSEG6EI32_V }, // 12976
  { PseudoVSUXSEG6EI32_V_MF2_M1_MASK, VSUXSEG6EI32_V }, // 12977
  { PseudoVSUXSEG6EI32_V_MF2_MF2, VSUXSEG6EI32_V }, // 12978
  { PseudoVSUXSEG6EI32_V_MF2_MF2_MASK, VSUXSEG6EI32_V }, // 12979
  { PseudoVSUXSEG6EI32_V_MF2_MF4, VSUXSEG6EI32_V }, // 12980
  { PseudoVSUXSEG6EI32_V_MF2_MF4_MASK, VSUXSEG6EI32_V }, // 12981
  { PseudoVSUXSEG6EI32_V_MF2_MF8, VSUXSEG6EI32_V }, // 12982
  { PseudoVSUXSEG6EI32_V_MF2_MF8_MASK, VSUXSEG6EI32_V }, // 12983
  { PseudoVSUXSEG6EI64_V_M1_M1, VSUXSEG6EI64_V }, // 12984
  { PseudoVSUXSEG6EI64_V_M1_M1_MASK, VSUXSEG6EI64_V }, // 12985
  { PseudoVSUXSEG6EI64_V_M1_MF2, VSUXSEG6EI64_V }, // 12986
  { PseudoVSUXSEG6EI64_V_M1_MF2_MASK, VSUXSEG6EI64_V }, // 12987
  { PseudoVSUXSEG6EI64_V_M1_MF4, VSUXSEG6EI64_V }, // 12988
  { PseudoVSUXSEG6EI64_V_M1_MF4_MASK, VSUXSEG6EI64_V }, // 12989
  { PseudoVSUXSEG6EI64_V_M1_MF8, VSUXSEG6EI64_V }, // 12990
  { PseudoVSUXSEG6EI64_V_M1_MF8_MASK, VSUXSEG6EI64_V }, // 12991
  { PseudoVSUXSEG6EI64_V_M2_M1, VSUXSEG6EI64_V }, // 12992
  { PseudoVSUXSEG6EI64_V_M2_M1_MASK, VSUXSEG6EI64_V }, // 12993
  { PseudoVSUXSEG6EI64_V_M2_MF2, VSUXSEG6EI64_V }, // 12994
  { PseudoVSUXSEG6EI64_V_M2_MF2_MASK, VSUXSEG6EI64_V }, // 12995
  { PseudoVSUXSEG6EI64_V_M2_MF4, VSUXSEG6EI64_V }, // 12996
  { PseudoVSUXSEG6EI64_V_M2_MF4_MASK, VSUXSEG6EI64_V }, // 12997
  { PseudoVSUXSEG6EI64_V_M2_MF8, VSUXSEG6EI64_V }, // 12998
  { PseudoVSUXSEG6EI64_V_M2_MF8_MASK, VSUXSEG6EI64_V }, // 12999
  { PseudoVSUXSEG6EI64_V_M4_M1, VSUXSEG6EI64_V }, // 13000
  { PseudoVSUXSEG6EI64_V_M4_M1_MASK, VSUXSEG6EI64_V }, // 13001
  { PseudoVSUXSEG6EI64_V_M4_MF2, VSUXSEG6EI64_V }, // 13002
  { PseudoVSUXSEG6EI64_V_M4_MF2_MASK, VSUXSEG6EI64_V }, // 13003
  { PseudoVSUXSEG6EI64_V_M4_MF4, VSUXSEG6EI64_V }, // 13004
  { PseudoVSUXSEG6EI64_V_M4_MF4_MASK, VSUXSEG6EI64_V }, // 13005
  { PseudoVSUXSEG6EI64_V_M4_MF8, VSUXSEG6EI64_V }, // 13006
  { PseudoVSUXSEG6EI64_V_M4_MF8_MASK, VSUXSEG6EI64_V }, // 13007
  { PseudoVSUXSEG6EI64_V_M8_M1, VSUXSEG6EI64_V }, // 13008
  { PseudoVSUXSEG6EI64_V_M8_M1_MASK, VSUXSEG6EI64_V }, // 13009
  { PseudoVSUXSEG6EI64_V_M8_MF2, VSUXSEG6EI64_V }, // 13010
  { PseudoVSUXSEG6EI64_V_M8_MF2_MASK, VSUXSEG6EI64_V }, // 13011
  { PseudoVSUXSEG6EI64_V_M8_MF4, VSUXSEG6EI64_V }, // 13012
  { PseudoVSUXSEG6EI64_V_M8_MF4_MASK, VSUXSEG6EI64_V }, // 13013
  { PseudoVSUXSEG6EI64_V_M8_MF8, VSUXSEG6EI64_V }, // 13014
  { PseudoVSUXSEG6EI64_V_M8_MF8_MASK, VSUXSEG6EI64_V }, // 13015
  { PseudoVSUXSEG6EI8_V_M1_M1, VSUXSEG6EI8_V }, // 13016
  { PseudoVSUXSEG6EI8_V_M1_M1_MASK, VSUXSEG6EI8_V }, // 13017
  { PseudoVSUXSEG6EI8_V_M1_MF2, VSUXSEG6EI8_V }, // 13018
  { PseudoVSUXSEG6EI8_V_M1_MF2_MASK, VSUXSEG6EI8_V }, // 13019
  { PseudoVSUXSEG6EI8_V_M1_MF4, VSUXSEG6EI8_V }, // 13020
  { PseudoVSUXSEG6EI8_V_M1_MF4_MASK, VSUXSEG6EI8_V }, // 13021
  { PseudoVSUXSEG6EI8_V_M1_MF8, VSUXSEG6EI8_V }, // 13022
  { PseudoVSUXSEG6EI8_V_M1_MF8_MASK, VSUXSEG6EI8_V }, // 13023
  { PseudoVSUXSEG6EI8_V_M2_M1, VSUXSEG6EI8_V }, // 13024
  { PseudoVSUXSEG6EI8_V_M2_M1_MASK, VSUXSEG6EI8_V }, // 13025
  { PseudoVSUXSEG6EI8_V_M2_MF2, VSUXSEG6EI8_V }, // 13026
  { PseudoVSUXSEG6EI8_V_M2_MF2_MASK, VSUXSEG6EI8_V }, // 13027
  { PseudoVSUXSEG6EI8_V_M2_MF4, VSUXSEG6EI8_V }, // 13028
  { PseudoVSUXSEG6EI8_V_M2_MF4_MASK, VSUXSEG6EI8_V }, // 13029
  { PseudoVSUXSEG6EI8_V_M2_MF8, VSUXSEG6EI8_V }, // 13030
  { PseudoVSUXSEG6EI8_V_M2_MF8_MASK, VSUXSEG6EI8_V }, // 13031
  { PseudoVSUXSEG6EI8_V_M4_M1, VSUXSEG6EI8_V }, // 13032
  { PseudoVSUXSEG6EI8_V_M4_M1_MASK, VSUXSEG6EI8_V }, // 13033
  { PseudoVSUXSEG6EI8_V_M4_MF2, VSUXSEG6EI8_V }, // 13034
  { PseudoVSUXSEG6EI8_V_M4_MF2_MASK, VSUXSEG6EI8_V }, // 13035
  { PseudoVSUXSEG6EI8_V_M4_MF4, VSUXSEG6EI8_V }, // 13036
  { PseudoVSUXSEG6EI8_V_M4_MF4_MASK, VSUXSEG6EI8_V }, // 13037
  { PseudoVSUXSEG6EI8_V_M4_MF8, VSUXSEG6EI8_V }, // 13038
  { PseudoVSUXSEG6EI8_V_M4_MF8_MASK, VSUXSEG6EI8_V }, // 13039
  { PseudoVSUXSEG6EI8_V_M8_M1, VSUXSEG6EI8_V }, // 13040
  { PseudoVSUXSEG6EI8_V_M8_M1_MASK, VSUXSEG6EI8_V }, // 13041
  { PseudoVSUXSEG6EI8_V_M8_MF2, VSUXSEG6EI8_V }, // 13042
  { PseudoVSUXSEG6EI8_V_M8_MF2_MASK, VSUXSEG6EI8_V }, // 13043
  { PseudoVSUXSEG6EI8_V_M8_MF4, VSUXSEG6EI8_V }, // 13044
  { PseudoVSUXSEG6EI8_V_M8_MF4_MASK, VSUXSEG6EI8_V }, // 13045
  { PseudoVSUXSEG6EI8_V_M8_MF8, VSUXSEG6EI8_V }, // 13046
  { PseudoVSUXSEG6EI8_V_M8_MF8_MASK, VSUXSEG6EI8_V }, // 13047
  { PseudoVSUXSEG6EI8_V_MF2_M1, VSUXSEG6EI8_V }, // 13048
  { PseudoVSUXSEG6EI8_V_MF2_M1_MASK, VSUXSEG6EI8_V }, // 13049
  { PseudoVSUXSEG6EI8_V_MF2_MF2, VSUXSEG6EI8_V }, // 13050
  { PseudoVSUXSEG6EI8_V_MF2_MF2_MASK, VSUXSEG6EI8_V }, // 13051
  { PseudoVSUXSEG6EI8_V_MF2_MF4, VSUXSEG6EI8_V }, // 13052
  { PseudoVSUXSEG6EI8_V_MF2_MF4_MASK, VSUXSEG6EI8_V }, // 13053
  { PseudoVSUXSEG6EI8_V_MF2_MF8, VSUXSEG6EI8_V }, // 13054
  { PseudoVSUXSEG6EI8_V_MF2_MF8_MASK, VSUXSEG6EI8_V }, // 13055
  { PseudoVSUXSEG6EI8_V_MF4_M1, VSUXSEG6EI8_V }, // 13056
  { PseudoVSUXSEG6EI8_V_MF4_M1_MASK, VSUXSEG6EI8_V }, // 13057
  { PseudoVSUXSEG6EI8_V_MF4_MF2, VSUXSEG6EI8_V }, // 13058
  { PseudoVSUXSEG6EI8_V_MF4_MF2_MASK, VSUXSEG6EI8_V }, // 13059
  { PseudoVSUXSEG6EI8_V_MF4_MF4, VSUXSEG6EI8_V }, // 13060
  { PseudoVSUXSEG6EI8_V_MF4_MF4_MASK, VSUXSEG6EI8_V }, // 13061
  { PseudoVSUXSEG6EI8_V_MF4_MF8, VSUXSEG6EI8_V }, // 13062
  { PseudoVSUXSEG6EI8_V_MF4_MF8_MASK, VSUXSEG6EI8_V }, // 13063
  { PseudoVSUXSEG6EI8_V_MF8_M1, VSUXSEG6EI8_V }, // 13064
  { PseudoVSUXSEG6EI8_V_MF8_M1_MASK, VSUXSEG6EI8_V }, // 13065
  { PseudoVSUXSEG6EI8_V_MF8_MF2, VSUXSEG6EI8_V }, // 13066
  { PseudoVSUXSEG6EI8_V_MF8_MF2_MASK, VSUXSEG6EI8_V }, // 13067
  { PseudoVSUXSEG6EI8_V_MF8_MF4, VSUXSEG6EI8_V }, // 13068
  { PseudoVSUXSEG6EI8_V_MF8_MF4_MASK, VSUXSEG6EI8_V }, // 13069
  { PseudoVSUXSEG6EI8_V_MF8_MF8, VSUXSEG6EI8_V }, // 13070
  { PseudoVSUXSEG6EI8_V_MF8_MF8_MASK, VSUXSEG6EI8_V }, // 13071
  { PseudoVSUXSEG7EI16_V_M1_M1, VSUXSEG7EI16_V }, // 13072
  { PseudoVSUXSEG7EI16_V_M1_M1_MASK, VSUXSEG7EI16_V }, // 13073
  { PseudoVSUXSEG7EI16_V_M1_MF2, VSUXSEG7EI16_V }, // 13074
  { PseudoVSUXSEG7EI16_V_M1_MF2_MASK, VSUXSEG7EI16_V }, // 13075
  { PseudoVSUXSEG7EI16_V_M1_MF4, VSUXSEG7EI16_V }, // 13076
  { PseudoVSUXSEG7EI16_V_M1_MF4_MASK, VSUXSEG7EI16_V }, // 13077
  { PseudoVSUXSEG7EI16_V_M1_MF8, VSUXSEG7EI16_V }, // 13078
  { PseudoVSUXSEG7EI16_V_M1_MF8_MASK, VSUXSEG7EI16_V }, // 13079
  { PseudoVSUXSEG7EI16_V_M2_M1, VSUXSEG7EI16_V }, // 13080
  { PseudoVSUXSEG7EI16_V_M2_M1_MASK, VSUXSEG7EI16_V }, // 13081
  { PseudoVSUXSEG7EI16_V_M2_MF2, VSUXSEG7EI16_V }, // 13082
  { PseudoVSUXSEG7EI16_V_M2_MF2_MASK, VSUXSEG7EI16_V }, // 13083
  { PseudoVSUXSEG7EI16_V_M2_MF4, VSUXSEG7EI16_V }, // 13084
  { PseudoVSUXSEG7EI16_V_M2_MF4_MASK, VSUXSEG7EI16_V }, // 13085
  { PseudoVSUXSEG7EI16_V_M2_MF8, VSUXSEG7EI16_V }, // 13086
  { PseudoVSUXSEG7EI16_V_M2_MF8_MASK, VSUXSEG7EI16_V }, // 13087
  { PseudoVSUXSEG7EI16_V_M4_M1, VSUXSEG7EI16_V }, // 13088
  { PseudoVSUXSEG7EI16_V_M4_M1_MASK, VSUXSEG7EI16_V }, // 13089
  { PseudoVSUXSEG7EI16_V_M4_MF2, VSUXSEG7EI16_V }, // 13090
  { PseudoVSUXSEG7EI16_V_M4_MF2_MASK, VSUXSEG7EI16_V }, // 13091
  { PseudoVSUXSEG7EI16_V_M4_MF4, VSUXSEG7EI16_V }, // 13092
  { PseudoVSUXSEG7EI16_V_M4_MF4_MASK, VSUXSEG7EI16_V }, // 13093
  { PseudoVSUXSEG7EI16_V_M4_MF8, VSUXSEG7EI16_V }, // 13094
  { PseudoVSUXSEG7EI16_V_M4_MF8_MASK, VSUXSEG7EI16_V }, // 13095
  { PseudoVSUXSEG7EI16_V_M8_M1, VSUXSEG7EI16_V }, // 13096
  { PseudoVSUXSEG7EI16_V_M8_M1_MASK, VSUXSEG7EI16_V }, // 13097
  { PseudoVSUXSEG7EI16_V_M8_MF2, VSUXSEG7EI16_V }, // 13098
  { PseudoVSUXSEG7EI16_V_M8_MF2_MASK, VSUXSEG7EI16_V }, // 13099
  { PseudoVSUXSEG7EI16_V_M8_MF4, VSUXSEG7EI16_V }, // 13100
  { PseudoVSUXSEG7EI16_V_M8_MF4_MASK, VSUXSEG7EI16_V }, // 13101
  { PseudoVSUXSEG7EI16_V_M8_MF8, VSUXSEG7EI16_V }, // 13102
  { PseudoVSUXSEG7EI16_V_M8_MF8_MASK, VSUXSEG7EI16_V }, // 13103
  { PseudoVSUXSEG7EI16_V_MF2_M1, VSUXSEG7EI16_V }, // 13104
  { PseudoVSUXSEG7EI16_V_MF2_M1_MASK, VSUXSEG7EI16_V }, // 13105
  { PseudoVSUXSEG7EI16_V_MF2_MF2, VSUXSEG7EI16_V }, // 13106
  { PseudoVSUXSEG7EI16_V_MF2_MF2_MASK, VSUXSEG7EI16_V }, // 13107
  { PseudoVSUXSEG7EI16_V_MF2_MF4, VSUXSEG7EI16_V }, // 13108
  { PseudoVSUXSEG7EI16_V_MF2_MF4_MASK, VSUXSEG7EI16_V }, // 13109
  { PseudoVSUXSEG7EI16_V_MF2_MF8, VSUXSEG7EI16_V }, // 13110
  { PseudoVSUXSEG7EI16_V_MF2_MF8_MASK, VSUXSEG7EI16_V }, // 13111
  { PseudoVSUXSEG7EI16_V_MF4_M1, VSUXSEG7EI16_V }, // 13112
  { PseudoVSUXSEG7EI16_V_MF4_M1_MASK, VSUXSEG7EI16_V }, // 13113
  { PseudoVSUXSEG7EI16_V_MF4_MF2, VSUXSEG7EI16_V }, // 13114
  { PseudoVSUXSEG7EI16_V_MF4_MF2_MASK, VSUXSEG7EI16_V }, // 13115
  { PseudoVSUXSEG7EI16_V_MF4_MF4, VSUXSEG7EI16_V }, // 13116
  { PseudoVSUXSEG7EI16_V_MF4_MF4_MASK, VSUXSEG7EI16_V }, // 13117
  { PseudoVSUXSEG7EI16_V_MF4_MF8, VSUXSEG7EI16_V }, // 13118
  { PseudoVSUXSEG7EI16_V_MF4_MF8_MASK, VSUXSEG7EI16_V }, // 13119
  { PseudoVSUXSEG7EI32_V_M1_M1, VSUXSEG7EI32_V }, // 13120
  { PseudoVSUXSEG7EI32_V_M1_M1_MASK, VSUXSEG7EI32_V }, // 13121
  { PseudoVSUXSEG7EI32_V_M1_MF2, VSUXSEG7EI32_V }, // 13122
  { PseudoVSUXSEG7EI32_V_M1_MF2_MASK, VSUXSEG7EI32_V }, // 13123
  { PseudoVSUXSEG7EI32_V_M1_MF4, VSUXSEG7EI32_V }, // 13124
  { PseudoVSUXSEG7EI32_V_M1_MF4_MASK, VSUXSEG7EI32_V }, // 13125
  { PseudoVSUXSEG7EI32_V_M1_MF8, VSUXSEG7EI32_V }, // 13126
  { PseudoVSUXSEG7EI32_V_M1_MF8_MASK, VSUXSEG7EI32_V }, // 13127
  { PseudoVSUXSEG7EI32_V_M2_M1, VSUXSEG7EI32_V }, // 13128
  { PseudoVSUXSEG7EI32_V_M2_M1_MASK, VSUXSEG7EI32_V }, // 13129
  { PseudoVSUXSEG7EI32_V_M2_MF2, VSUXSEG7EI32_V }, // 13130
  { PseudoVSUXSEG7EI32_V_M2_MF2_MASK, VSUXSEG7EI32_V }, // 13131
  { PseudoVSUXSEG7EI32_V_M2_MF4, VSUXSEG7EI32_V }, // 13132
  { PseudoVSUXSEG7EI32_V_M2_MF4_MASK, VSUXSEG7EI32_V }, // 13133
  { PseudoVSUXSEG7EI32_V_M2_MF8, VSUXSEG7EI32_V }, // 13134
  { PseudoVSUXSEG7EI32_V_M2_MF8_MASK, VSUXSEG7EI32_V }, // 13135
  { PseudoVSUXSEG7EI32_V_M4_M1, VSUXSEG7EI32_V }, // 13136
  { PseudoVSUXSEG7EI32_V_M4_M1_MASK, VSUXSEG7EI32_V }, // 13137
  { PseudoVSUXSEG7EI32_V_M4_MF2, VSUXSEG7EI32_V }, // 13138
  { PseudoVSUXSEG7EI32_V_M4_MF2_MASK, VSUXSEG7EI32_V }, // 13139
  { PseudoVSUXSEG7EI32_V_M4_MF4, VSUXSEG7EI32_V }, // 13140
  { PseudoVSUXSEG7EI32_V_M4_MF4_MASK, VSUXSEG7EI32_V }, // 13141
  { PseudoVSUXSEG7EI32_V_M4_MF8, VSUXSEG7EI32_V }, // 13142
  { PseudoVSUXSEG7EI32_V_M4_MF8_MASK, VSUXSEG7EI32_V }, // 13143
  { PseudoVSUXSEG7EI32_V_M8_M1, VSUXSEG7EI32_V }, // 13144
  { PseudoVSUXSEG7EI32_V_M8_M1_MASK, VSUXSEG7EI32_V }, // 13145
  { PseudoVSUXSEG7EI32_V_M8_MF2, VSUXSEG7EI32_V }, // 13146
  { PseudoVSUXSEG7EI32_V_M8_MF2_MASK, VSUXSEG7EI32_V }, // 13147
  { PseudoVSUXSEG7EI32_V_M8_MF4, VSUXSEG7EI32_V }, // 13148
  { PseudoVSUXSEG7EI32_V_M8_MF4_MASK, VSUXSEG7EI32_V }, // 13149
  { PseudoVSUXSEG7EI32_V_M8_MF8, VSUXSEG7EI32_V }, // 13150
  { PseudoVSUXSEG7EI32_V_M8_MF8_MASK, VSUXSEG7EI32_V }, // 13151
  { PseudoVSUXSEG7EI32_V_MF2_M1, VSUXSEG7EI32_V }, // 13152
  { PseudoVSUXSEG7EI32_V_MF2_M1_MASK, VSUXSEG7EI32_V }, // 13153
  { PseudoVSUXSEG7EI32_V_MF2_MF2, VSUXSEG7EI32_V }, // 13154
  { PseudoVSUXSEG7EI32_V_MF2_MF2_MASK, VSUXSEG7EI32_V }, // 13155
  { PseudoVSUXSEG7EI32_V_MF2_MF4, VSUXSEG7EI32_V }, // 13156
  { PseudoVSUXSEG7EI32_V_MF2_MF4_MASK, VSUXSEG7EI32_V }, // 13157
  { PseudoVSUXSEG7EI32_V_MF2_MF8, VSUXSEG7EI32_V }, // 13158
  { PseudoVSUXSEG7EI32_V_MF2_MF8_MASK, VSUXSEG7EI32_V }, // 13159
  { PseudoVSUXSEG7EI64_V_M1_M1, VSUXSEG7EI64_V }, // 13160
  { PseudoVSUXSEG7EI64_V_M1_M1_MASK, VSUXSEG7EI64_V }, // 13161
  { PseudoVSUXSEG7EI64_V_M1_MF2, VSUXSEG7EI64_V }, // 13162
  { PseudoVSUXSEG7EI64_V_M1_MF2_MASK, VSUXSEG7EI64_V }, // 13163
  { PseudoVSUXSEG7EI64_V_M1_MF4, VSUXSEG7EI64_V }, // 13164
  { PseudoVSUXSEG7EI64_V_M1_MF4_MASK, VSUXSEG7EI64_V }, // 13165
  { PseudoVSUXSEG7EI64_V_M1_MF8, VSUXSEG7EI64_V }, // 13166
  { PseudoVSUXSEG7EI64_V_M1_MF8_MASK, VSUXSEG7EI64_V }, // 13167
  { PseudoVSUXSEG7EI64_V_M2_M1, VSUXSEG7EI64_V }, // 13168
  { PseudoVSUXSEG7EI64_V_M2_M1_MASK, VSUXSEG7EI64_V }, // 13169
  { PseudoVSUXSEG7EI64_V_M2_MF2, VSUXSEG7EI64_V }, // 13170
  { PseudoVSUXSEG7EI64_V_M2_MF2_MASK, VSUXSEG7EI64_V }, // 13171
  { PseudoVSUXSEG7EI64_V_M2_MF4, VSUXSEG7EI64_V }, // 13172
  { PseudoVSUXSEG7EI64_V_M2_MF4_MASK, VSUXSEG7EI64_V }, // 13173
  { PseudoVSUXSEG7EI64_V_M2_MF8, VSUXSEG7EI64_V }, // 13174
  { PseudoVSUXSEG7EI64_V_M2_MF8_MASK, VSUXSEG7EI64_V }, // 13175
  { PseudoVSUXSEG7EI64_V_M4_M1, VSUXSEG7EI64_V }, // 13176
  { PseudoVSUXSEG7EI64_V_M4_M1_MASK, VSUXSEG7EI64_V }, // 13177
  { PseudoVSUXSEG7EI64_V_M4_MF2, VSUXSEG7EI64_V }, // 13178
  { PseudoVSUXSEG7EI64_V_M4_MF2_MASK, VSUXSEG7EI64_V }, // 13179
  { PseudoVSUXSEG7EI64_V_M4_MF4, VSUXSEG7EI64_V }, // 13180
  { PseudoVSUXSEG7EI64_V_M4_MF4_MASK, VSUXSEG7EI64_V }, // 13181
  { PseudoVSUXSEG7EI64_V_M4_MF8, VSUXSEG7EI64_V }, // 13182
  { PseudoVSUXSEG7EI64_V_M4_MF8_MASK, VSUXSEG7EI64_V }, // 13183
  { PseudoVSUXSEG7EI64_V_M8_M1, VSUXSEG7EI64_V }, // 13184
  { PseudoVSUXSEG7EI64_V_M8_M1_MASK, VSUXSEG7EI64_V }, // 13185
  { PseudoVSUXSEG7EI64_V_M8_MF2, VSUXSEG7EI64_V }, // 13186
  { PseudoVSUXSEG7EI64_V_M8_MF2_MASK, VSUXSEG7EI64_V }, // 13187
  { PseudoVSUXSEG7EI64_V_M8_MF4, VSUXSEG7EI64_V }, // 13188
  { PseudoVSUXSEG7EI64_V_M8_MF4_MASK, VSUXSEG7EI64_V }, // 13189
  { PseudoVSUXSEG7EI64_V_M8_MF8, VSUXSEG7EI64_V }, // 13190
  { PseudoVSUXSEG7EI64_V_M8_MF8_MASK, VSUXSEG7EI64_V }, // 13191
  { PseudoVSUXSEG7EI8_V_M1_M1, VSUXSEG7EI8_V }, // 13192
  { PseudoVSUXSEG7EI8_V_M1_M1_MASK, VSUXSEG7EI8_V }, // 13193
  { PseudoVSUXSEG7EI8_V_M1_MF2, VSUXSEG7EI8_V }, // 13194
  { PseudoVSUXSEG7EI8_V_M1_MF2_MASK, VSUXSEG7EI8_V }, // 13195
  { PseudoVSUXSEG7EI8_V_M1_MF4, VSUXSEG7EI8_V }, // 13196
  { PseudoVSUXSEG7EI8_V_M1_MF4_MASK, VSUXSEG7EI8_V }, // 13197
  { PseudoVSUXSEG7EI8_V_M1_MF8, VSUXSEG7EI8_V }, // 13198
  { PseudoVSUXSEG7EI8_V_M1_MF8_MASK, VSUXSEG7EI8_V }, // 13199
  { PseudoVSUXSEG7EI8_V_M2_M1, VSUXSEG7EI8_V }, // 13200
  { PseudoVSUXSEG7EI8_V_M2_M1_MASK, VSUXSEG7EI8_V }, // 13201
  { PseudoVSUXSEG7EI8_V_M2_MF2, VSUXSEG7EI8_V }, // 13202
  { PseudoVSUXSEG7EI8_V_M2_MF2_MASK, VSUXSEG7EI8_V }, // 13203
  { PseudoVSUXSEG7EI8_V_M2_MF4, VSUXSEG7EI8_V }, // 13204
  { PseudoVSUXSEG7EI8_V_M2_MF4_MASK, VSUXSEG7EI8_V }, // 13205
  { PseudoVSUXSEG7EI8_V_M2_MF8, VSUXSEG7EI8_V }, // 13206
  { PseudoVSUXSEG7EI8_V_M2_MF8_MASK, VSUXSEG7EI8_V }, // 13207
  { PseudoVSUXSEG7EI8_V_M4_M1, VSUXSEG7EI8_V }, // 13208
  { PseudoVSUXSEG7EI8_V_M4_M1_MASK, VSUXSEG7EI8_V }, // 13209
  { PseudoVSUXSEG7EI8_V_M4_MF2, VSUXSEG7EI8_V }, // 13210
  { PseudoVSUXSEG7EI8_V_M4_MF2_MASK, VSUXSEG7EI8_V }, // 13211
  { PseudoVSUXSEG7EI8_V_M4_MF4, VSUXSEG7EI8_V }, // 13212
  { PseudoVSUXSEG7EI8_V_M4_MF4_MASK, VSUXSEG7EI8_V }, // 13213
  { PseudoVSUXSEG7EI8_V_M4_MF8, VSUXSEG7EI8_V }, // 13214
  { PseudoVSUXSEG7EI8_V_M4_MF8_MASK, VSUXSEG7EI8_V }, // 13215
  { PseudoVSUXSEG7EI8_V_M8_M1, VSUXSEG7EI8_V }, // 13216
  { PseudoVSUXSEG7EI8_V_M8_M1_MASK, VSUXSEG7EI8_V }, // 13217
  { PseudoVSUXSEG7EI8_V_M8_MF2, VSUXSEG7EI8_V }, // 13218
  { PseudoVSUXSEG7EI8_V_M8_MF2_MASK, VSUXSEG7EI8_V }, // 13219
  { PseudoVSUXSEG7EI8_V_M8_MF4, VSUXSEG7EI8_V }, // 13220
  { PseudoVSUXSEG7EI8_V_M8_MF4_MASK, VSUXSEG7EI8_V }, // 13221
  { PseudoVSUXSEG7EI8_V_M8_MF8, VSUXSEG7EI8_V }, // 13222
  { PseudoVSUXSEG7EI8_V_M8_MF8_MASK, VSUXSEG7EI8_V }, // 13223
  { PseudoVSUXSEG7EI8_V_MF2_M1, VSUXSEG7EI8_V }, // 13224
  { PseudoVSUXSEG7EI8_V_MF2_M1_MASK, VSUXSEG7EI8_V }, // 13225
  { PseudoVSUXSEG7EI8_V_MF2_MF2, VSUXSEG7EI8_V }, // 13226
  { PseudoVSUXSEG7EI8_V_MF2_MF2_MASK, VSUXSEG7EI8_V }, // 13227
  { PseudoVSUXSEG7EI8_V_MF2_MF4, VSUXSEG7EI8_V }, // 13228
  { PseudoVSUXSEG7EI8_V_MF2_MF4_MASK, VSUXSEG7EI8_V }, // 13229
  { PseudoVSUXSEG7EI8_V_MF2_MF8, VSUXSEG7EI8_V }, // 13230
  { PseudoVSUXSEG7EI8_V_MF2_MF8_MASK, VSUXSEG7EI8_V }, // 13231
  { PseudoVSUXSEG7EI8_V_MF4_M1, VSUXSEG7EI8_V }, // 13232
  { PseudoVSUXSEG7EI8_V_MF4_M1_MASK, VSUXSEG7EI8_V }, // 13233
  { PseudoVSUXSEG7EI8_V_MF4_MF2, VSUXSEG7EI8_V }, // 13234
  { PseudoVSUXSEG7EI8_V_MF4_MF2_MASK, VSUXSEG7EI8_V }, // 13235
  { PseudoVSUXSEG7EI8_V_MF4_MF4, VSUXSEG7EI8_V }, // 13236
  { PseudoVSUXSEG7EI8_V_MF4_MF4_MASK, VSUXSEG7EI8_V }, // 13237
  { PseudoVSUXSEG7EI8_V_MF4_MF8, VSUXSEG7EI8_V }, // 13238
  { PseudoVSUXSEG7EI8_V_MF4_MF8_MASK, VSUXSEG7EI8_V }, // 13239
  { PseudoVSUXSEG7EI8_V_MF8_M1, VSUXSEG7EI8_V }, // 13240
  { PseudoVSUXSEG7EI8_V_MF8_M1_MASK, VSUXSEG7EI8_V }, // 13241
  { PseudoVSUXSEG7EI8_V_MF8_MF2, VSUXSEG7EI8_V }, // 13242
  { PseudoVSUXSEG7EI8_V_MF8_MF2_MASK, VSUXSEG7EI8_V }, // 13243
  { PseudoVSUXSEG7EI8_V_MF8_MF4, VSUXSEG7EI8_V }, // 13244
  { PseudoVSUXSEG7EI8_V_MF8_MF4_MASK, VSUXSEG7EI8_V }, // 13245
  { PseudoVSUXSEG7EI8_V_MF8_MF8, VSUXSEG7EI8_V }, // 13246
  { PseudoVSUXSEG7EI8_V_MF8_MF8_MASK, VSUXSEG7EI8_V }, // 13247
  { PseudoVSUXSEG8EI16_V_M1_M1, VSUXSEG8EI16_V }, // 13248
  { PseudoVSUXSEG8EI16_V_M1_M1_MASK, VSUXSEG8EI16_V }, // 13249
  { PseudoVSUXSEG8EI16_V_M1_MF2, VSUXSEG8EI16_V }, // 13250
  { PseudoVSUXSEG8EI16_V_M1_MF2_MASK, VSUXSEG8EI16_V }, // 13251
  { PseudoVSUXSEG8EI16_V_M1_MF4, VSUXSEG8EI16_V }, // 13252
  { PseudoVSUXSEG8EI16_V_M1_MF4_MASK, VSUXSEG8EI16_V }, // 13253
  { PseudoVSUXSEG8EI16_V_M1_MF8, VSUXSEG8EI16_V }, // 13254
  { PseudoVSUXSEG8EI16_V_M1_MF8_MASK, VSUXSEG8EI16_V }, // 13255
  { PseudoVSUXSEG8EI16_V_M2_M1, VSUXSEG8EI16_V }, // 13256
  { PseudoVSUXSEG8EI16_V_M2_M1_MASK, VSUXSEG8EI16_V }, // 13257
  { PseudoVSUXSEG8EI16_V_M2_MF2, VSUXSEG8EI16_V }, // 13258
  { PseudoVSUXSEG8EI16_V_M2_MF2_MASK, VSUXSEG8EI16_V }, // 13259
  { PseudoVSUXSEG8EI16_V_M2_MF4, VSUXSEG8EI16_V }, // 13260
  { PseudoVSUXSEG8EI16_V_M2_MF4_MASK, VSUXSEG8EI16_V }, // 13261
  { PseudoVSUXSEG8EI16_V_M2_MF8, VSUXSEG8EI16_V }, // 13262
  { PseudoVSUXSEG8EI16_V_M2_MF8_MASK, VSUXSEG8EI16_V }, // 13263
  { PseudoVSUXSEG8EI16_V_M4_M1, VSUXSEG8EI16_V }, // 13264
  { PseudoVSUXSEG8EI16_V_M4_M1_MASK, VSUXSEG8EI16_V }, // 13265
  { PseudoVSUXSEG8EI16_V_M4_MF2, VSUXSEG8EI16_V }, // 13266
  { PseudoVSUXSEG8EI16_V_M4_MF2_MASK, VSUXSEG8EI16_V }, // 13267
  { PseudoVSUXSEG8EI16_V_M4_MF4, VSUXSEG8EI16_V }, // 13268
  { PseudoVSUXSEG8EI16_V_M4_MF4_MASK, VSUXSEG8EI16_V }, // 13269
  { PseudoVSUXSEG8EI16_V_M4_MF8, VSUXSEG8EI16_V }, // 13270
  { PseudoVSUXSEG8EI16_V_M4_MF8_MASK, VSUXSEG8EI16_V }, // 13271
  { PseudoVSUXSEG8EI16_V_M8_M1, VSUXSEG8EI16_V }, // 13272
  { PseudoVSUXSEG8EI16_V_M8_M1_MASK, VSUXSEG8EI16_V }, // 13273
  { PseudoVSUXSEG8EI16_V_M8_MF2, VSUXSEG8EI16_V }, // 13274
  { PseudoVSUXSEG8EI16_V_M8_MF2_MASK, VSUXSEG8EI16_V }, // 13275
  { PseudoVSUXSEG8EI16_V_M8_MF4, VSUXSEG8EI16_V }, // 13276
  { PseudoVSUXSEG8EI16_V_M8_MF4_MASK, VSUXSEG8EI16_V }, // 13277
  { PseudoVSUXSEG8EI16_V_M8_MF8, VSUXSEG8EI16_V }, // 13278
  { PseudoVSUXSEG8EI16_V_M8_MF8_MASK, VSUXSEG8EI16_V }, // 13279
  { PseudoVSUXSEG8EI16_V_MF2_M1, VSUXSEG8EI16_V }, // 13280
  { PseudoVSUXSEG8EI16_V_MF2_M1_MASK, VSUXSEG8EI16_V }, // 13281
  { PseudoVSUXSEG8EI16_V_MF2_MF2, VSUXSEG8EI16_V }, // 13282
  { PseudoVSUXSEG8EI16_V_MF2_MF2_MASK, VSUXSEG8EI16_V }, // 13283
  { PseudoVSUXSEG8EI16_V_MF2_MF4, VSUXSEG8EI16_V }, // 13284
  { PseudoVSUXSEG8EI16_V_MF2_MF4_MASK, VSUXSEG8EI16_V }, // 13285
  { PseudoVSUXSEG8EI16_V_MF2_MF8, VSUXSEG8EI16_V }, // 13286
  { PseudoVSUXSEG8EI16_V_MF2_MF8_MASK, VSUXSEG8EI16_V }, // 13287
  { PseudoVSUXSEG8EI16_V_MF4_M1, VSUXSEG8EI16_V }, // 13288
  { PseudoVSUXSEG8EI16_V_MF4_M1_MASK, VSUXSEG8EI16_V }, // 13289
  { PseudoVSUXSEG8EI16_V_MF4_MF2, VSUXSEG8EI16_V }, // 13290
  { PseudoVSUXSEG8EI16_V_MF4_MF2_MASK, VSUXSEG8EI16_V }, // 13291
  { PseudoVSUXSEG8EI16_V_MF4_MF4, VSUXSEG8EI16_V }, // 13292
  { PseudoVSUXSEG8EI16_V_MF4_MF4_MASK, VSUXSEG8EI16_V }, // 13293
  { PseudoVSUXSEG8EI16_V_MF4_MF8, VSUXSEG8EI16_V }, // 13294
  { PseudoVSUXSEG8EI16_V_MF4_MF8_MASK, VSUXSEG8EI16_V }, // 13295
  { PseudoVSUXSEG8EI32_V_M1_M1, VSUXSEG8EI32_V }, // 13296
  { PseudoVSUXSEG8EI32_V_M1_M1_MASK, VSUXSEG8EI32_V }, // 13297
  { PseudoVSUXSEG8EI32_V_M1_MF2, VSUXSEG8EI32_V }, // 13298
  { PseudoVSUXSEG8EI32_V_M1_MF2_MASK, VSUXSEG8EI32_V }, // 13299
  { PseudoVSUXSEG8EI32_V_M1_MF4, VSUXSEG8EI32_V }, // 13300
  { PseudoVSUXSEG8EI32_V_M1_MF4_MASK, VSUXSEG8EI32_V }, // 13301
  { PseudoVSUXSEG8EI32_V_M1_MF8, VSUXSEG8EI32_V }, // 13302
  { PseudoVSUXSEG8EI32_V_M1_MF8_MASK, VSUXSEG8EI32_V }, // 13303
  { PseudoVSUXSEG8EI32_V_M2_M1, VSUXSEG8EI32_V }, // 13304
  { PseudoVSUXSEG8EI32_V_M2_M1_MASK, VSUXSEG8EI32_V }, // 13305
  { PseudoVSUXSEG8EI32_V_M2_MF2, VSUXSEG8EI32_V }, // 13306
  { PseudoVSUXSEG8EI32_V_M2_MF2_MASK, VSUXSEG8EI32_V }, // 13307
  { PseudoVSUXSEG8EI32_V_M2_MF4, VSUXSEG8EI32_V }, // 13308
  { PseudoVSUXSEG8EI32_V_M2_MF4_MASK, VSUXSEG8EI32_V }, // 13309
  { PseudoVSUXSEG8EI32_V_M2_MF8, VSUXSEG8EI32_V }, // 13310
  { PseudoVSUXSEG8EI32_V_M2_MF8_MASK, VSUXSEG8EI32_V }, // 13311
  { PseudoVSUXSEG8EI32_V_M4_M1, VSUXSEG8EI32_V }, // 13312
  { PseudoVSUXSEG8EI32_V_M4_M1_MASK, VSUXSEG8EI32_V }, // 13313
  { PseudoVSUXSEG8EI32_V_M4_MF2, VSUXSEG8EI32_V }, // 13314
  { PseudoVSUXSEG8EI32_V_M4_MF2_MASK, VSUXSEG8EI32_V }, // 13315
  { PseudoVSUXSEG8EI32_V_M4_MF4, VSUXSEG8EI32_V }, // 13316
  { PseudoVSUXSEG8EI32_V_M4_MF4_MASK, VSUXSEG8EI32_V }, // 13317
  { PseudoVSUXSEG8EI32_V_M4_MF8, VSUXSEG8EI32_V }, // 13318
  { PseudoVSUXSEG8EI32_V_M4_MF8_MASK, VSUXSEG8EI32_V }, // 13319
  { PseudoVSUXSEG8EI32_V_M8_M1, VSUXSEG8EI32_V }, // 13320
  { PseudoVSUXSEG8EI32_V_M8_M1_MASK, VSUXSEG8EI32_V }, // 13321
  { PseudoVSUXSEG8EI32_V_M8_MF2, VSUXSEG8EI32_V }, // 13322
  { PseudoVSUXSEG8EI32_V_M8_MF2_MASK, VSUXSEG8EI32_V }, // 13323
  { PseudoVSUXSEG8EI32_V_M8_MF4, VSUXSEG8EI32_V }, // 13324
  { PseudoVSUXSEG8EI32_V_M8_MF4_MASK, VSUXSEG8EI32_V }, // 13325
  { PseudoVSUXSEG8EI32_V_M8_MF8, VSUXSEG8EI32_V }, // 13326
  { PseudoVSUXSEG8EI32_V_M8_MF8_MASK, VSUXSEG8EI32_V }, // 13327
  { PseudoVSUXSEG8EI32_V_MF2_M1, VSUXSEG8EI32_V }, // 13328
  { PseudoVSUXSEG8EI32_V_MF2_M1_MASK, VSUXSEG8EI32_V }, // 13329
  { PseudoVSUXSEG8EI32_V_MF2_MF2, VSUXSEG8EI32_V }, // 13330
  { PseudoVSUXSEG8EI32_V_MF2_MF2_MASK, VSUXSEG8EI32_V }, // 13331
  { PseudoVSUXSEG8EI32_V_MF2_MF4, VSUXSEG8EI32_V }, // 13332
  { PseudoVSUXSEG8EI32_V_MF2_MF4_MASK, VSUXSEG8EI32_V }, // 13333
  { PseudoVSUXSEG8EI32_V_MF2_MF8, VSUXSEG8EI32_V }, // 13334
  { PseudoVSUXSEG8EI32_V_MF2_MF8_MASK, VSUXSEG8EI32_V }, // 13335
  { PseudoVSUXSEG8EI64_V_M1_M1, VSUXSEG8EI64_V }, // 13336
  { PseudoVSUXSEG8EI64_V_M1_M1_MASK, VSUXSEG8EI64_V }, // 13337
  { PseudoVSUXSEG8EI64_V_M1_MF2, VSUXSEG8EI64_V }, // 13338
  { PseudoVSUXSEG8EI64_V_M1_MF2_MASK, VSUXSEG8EI64_V }, // 13339
  { PseudoVSUXSEG8EI64_V_M1_MF4, VSUXSEG8EI64_V }, // 13340
  { PseudoVSUXSEG8EI64_V_M1_MF4_MASK, VSUXSEG8EI64_V }, // 13341
  { PseudoVSUXSEG8EI64_V_M1_MF8, VSUXSEG8EI64_V }, // 13342
  { PseudoVSUXSEG8EI64_V_M1_MF8_MASK, VSUXSEG8EI64_V }, // 13343
  { PseudoVSUXSEG8EI64_V_M2_M1, VSUXSEG8EI64_V }, // 13344
  { PseudoVSUXSEG8EI64_V_M2_M1_MASK, VSUXSEG8EI64_V }, // 13345
  { PseudoVSUXSEG8EI64_V_M2_MF2, VSUXSEG8EI64_V }, // 13346
  { PseudoVSUXSEG8EI64_V_M2_MF2_MASK, VSUXSEG8EI64_V }, // 13347
  { PseudoVSUXSEG8EI64_V_M2_MF4, VSUXSEG8EI64_V }, // 13348
  { PseudoVSUXSEG8EI64_V_M2_MF4_MASK, VSUXSEG8EI64_V }, // 13349
  { PseudoVSUXSEG8EI64_V_M2_MF8, VSUXSEG8EI64_V }, // 13350
  { PseudoVSUXSEG8EI64_V_M2_MF8_MASK, VSUXSEG8EI64_V }, // 13351
  { PseudoVSUXSEG8EI64_V_M4_M1, VSUXSEG8EI64_V }, // 13352
  { PseudoVSUXSEG8EI64_V_M4_M1_MASK, VSUXSEG8EI64_V }, // 13353
  { PseudoVSUXSEG8EI64_V_M4_MF2, VSUXSEG8EI64_V }, // 13354
  { PseudoVSUXSEG8EI64_V_M4_MF2_MASK, VSUXSEG8EI64_V }, // 13355
  { PseudoVSUXSEG8EI64_V_M4_MF4, VSUXSEG8EI64_V }, // 13356
  { PseudoVSUXSEG8EI64_V_M4_MF4_MASK, VSUXSEG8EI64_V }, // 13357
  { PseudoVSUXSEG8EI64_V_M4_MF8, VSUXSEG8EI64_V }, // 13358
  { PseudoVSUXSEG8EI64_V_M4_MF8_MASK, VSUXSEG8EI64_V }, // 13359
  { PseudoVSUXSEG8EI64_V_M8_M1, VSUXSEG8EI64_V }, // 13360
  { PseudoVSUXSEG8EI64_V_M8_M1_MASK, VSUXSEG8EI64_V }, // 13361
  { PseudoVSUXSEG8EI64_V_M8_MF2, VSUXSEG8EI64_V }, // 13362
  { PseudoVSUXSEG8EI64_V_M8_MF2_MASK, VSUXSEG8EI64_V }, // 13363
  { PseudoVSUXSEG8EI64_V_M8_MF4, VSUXSEG8EI64_V }, // 13364
  { PseudoVSUXSEG8EI64_V_M8_MF4_MASK, VSUXSEG8EI64_V }, // 13365
  { PseudoVSUXSEG8EI64_V_M8_MF8, VSUXSEG8EI64_V }, // 13366
  { PseudoVSUXSEG8EI64_V_M8_MF8_MASK, VSUXSEG8EI64_V }, // 13367
  { PseudoVSUXSEG8EI8_V_M1_M1, VSUXSEG8EI8_V }, // 13368
  { PseudoVSUXSEG8EI8_V_M1_M1_MASK, VSUXSEG8EI8_V }, // 13369
  { PseudoVSUXSEG8EI8_V_M1_MF2, VSUXSEG8EI8_V }, // 13370
  { PseudoVSUXSEG8EI8_V_M1_MF2_MASK, VSUXSEG8EI8_V }, // 13371
  { PseudoVSUXSEG8EI8_V_M1_MF4, VSUXSEG8EI8_V }, // 13372
  { PseudoVSUXSEG8EI8_V_M1_MF4_MASK, VSUXSEG8EI8_V }, // 13373
  { PseudoVSUXSEG8EI8_V_M1_MF8, VSUXSEG8EI8_V }, // 13374
  { PseudoVSUXSEG8EI8_V_M1_MF8_MASK, VSUXSEG8EI8_V }, // 13375
  { PseudoVSUXSEG8EI8_V_M2_M1, VSUXSEG8EI8_V }, // 13376
  { PseudoVSUXSEG8EI8_V_M2_M1_MASK, VSUXSEG8EI8_V }, // 13377
  { PseudoVSUXSEG8EI8_V_M2_MF2, VSUXSEG8EI8_V }, // 13378
  { PseudoVSUXSEG8EI8_V_M2_MF2_MASK, VSUXSEG8EI8_V }, // 13379
  { PseudoVSUXSEG8EI8_V_M2_MF4, VSUXSEG8EI8_V }, // 13380
  { PseudoVSUXSEG8EI8_V_M2_MF4_MASK, VSUXSEG8EI8_V }, // 13381
  { PseudoVSUXSEG8EI8_V_M2_MF8, VSUXSEG8EI8_V }, // 13382
  { PseudoVSUXSEG8EI8_V_M2_MF8_MASK, VSUXSEG8EI8_V }, // 13383
  { PseudoVSUXSEG8EI8_V_M4_M1, VSUXSEG8EI8_V }, // 13384
  { PseudoVSUXSEG8EI8_V_M4_M1_MASK, VSUXSEG8EI8_V }, // 13385
  { PseudoVSUXSEG8EI8_V_M4_MF2, VSUXSEG8EI8_V }, // 13386
  { PseudoVSUXSEG8EI8_V_M4_MF2_MASK, VSUXSEG8EI8_V }, // 13387
  { PseudoVSUXSEG8EI8_V_M4_MF4, VSUXSEG8EI8_V }, // 13388
  { PseudoVSUXSEG8EI8_V_M4_MF4_MASK, VSUXSEG8EI8_V }, // 13389
  { PseudoVSUXSEG8EI8_V_M4_MF8, VSUXSEG8EI8_V }, // 13390
  { PseudoVSUXSEG8EI8_V_M4_MF8_MASK, VSUXSEG8EI8_V }, // 13391
  { PseudoVSUXSEG8EI8_V_M8_M1, VSUXSEG8EI8_V }, // 13392
  { PseudoVSUXSEG8EI8_V_M8_M1_MASK, VSUXSEG8EI8_V }, // 13393
  { PseudoVSUXSEG8EI8_V_M8_MF2, VSUXSEG8EI8_V }, // 13394
  { PseudoVSUXSEG8EI8_V_M8_MF2_MASK, VSUXSEG8EI8_V }, // 13395
  { PseudoVSUXSEG8EI8_V_M8_MF4, VSUXSEG8EI8_V }, // 13396
  { PseudoVSUXSEG8EI8_V_M8_MF4_MASK, VSUXSEG8EI8_V }, // 13397
  { PseudoVSUXSEG8EI8_V_M8_MF8, VSUXSEG8EI8_V }, // 13398
  { PseudoVSUXSEG8EI8_V_M8_MF8_MASK, VSUXSEG8EI8_V }, // 13399
  { PseudoVSUXSEG8EI8_V_MF2_M1, VSUXSEG8EI8_V }, // 13400
  { PseudoVSUXSEG8EI8_V_MF2_M1_MASK, VSUXSEG8EI8_V }, // 13401
  { PseudoVSUXSEG8EI8_V_MF2_MF2, VSUXSEG8EI8_V }, // 13402
  { PseudoVSUXSEG8EI8_V_MF2_MF2_MASK, VSUXSEG8EI8_V }, // 13403
  { PseudoVSUXSEG8EI8_V_MF2_MF4, VSUXSEG8EI8_V }, // 13404
  { PseudoVSUXSEG8EI8_V_MF2_MF4_MASK, VSUXSEG8EI8_V }, // 13405
  { PseudoVSUXSEG8EI8_V_MF2_MF8, VSUXSEG8EI8_V }, // 13406
  { PseudoVSUXSEG8EI8_V_MF2_MF8_MASK, VSUXSEG8EI8_V }, // 13407
  { PseudoVSUXSEG8EI8_V_MF4_M1, VSUXSEG8EI8_V }, // 13408
  { PseudoVSUXSEG8EI8_V_MF4_M1_MASK, VSUXSEG8EI8_V }, // 13409
  { PseudoVSUXSEG8EI8_V_MF4_MF2, VSUXSEG8EI8_V }, // 13410
  { PseudoVSUXSEG8EI8_V_MF4_MF2_MASK, VSUXSEG8EI8_V }, // 13411
  { PseudoVSUXSEG8EI8_V_MF4_MF4, VSUXSEG8EI8_V }, // 13412
  { PseudoVSUXSEG8EI8_V_MF4_MF4_MASK, VSUXSEG8EI8_V }, // 13413
  { PseudoVSUXSEG8EI8_V_MF4_MF8, VSUXSEG8EI8_V }, // 13414
  { PseudoVSUXSEG8EI8_V_MF4_MF8_MASK, VSUXSEG8EI8_V }, // 13415
  { PseudoVSUXSEG8EI8_V_MF8_M1, VSUXSEG8EI8_V }, // 13416
  { PseudoVSUXSEG8EI8_V_MF8_M1_MASK, VSUXSEG8EI8_V }, // 13417
  { PseudoVSUXSEG8EI8_V_MF8_MF2, VSUXSEG8EI8_V }, // 13418
  { PseudoVSUXSEG8EI8_V_MF8_MF2_MASK, VSUXSEG8EI8_V }, // 13419
  { PseudoVSUXSEG8EI8_V_MF8_MF4, VSUXSEG8EI8_V }, // 13420
  { PseudoVSUXSEG8EI8_V_MF8_MF4_MASK, VSUXSEG8EI8_V }, // 13421
  { PseudoVSUXSEG8EI8_V_MF8_MF8, VSUXSEG8EI8_V }, // 13422
  { PseudoVSUXSEG8EI8_V_MF8_MF8_MASK, VSUXSEG8EI8_V }, // 13423
  { PseudoVWADDU_VV_M1, VWADDU_VV }, // 13424
  { PseudoVWADDU_VV_M1_MASK, VWADDU_VV }, // 13425
  { PseudoVWADDU_VV_M2, VWADDU_VV }, // 13426
  { PseudoVWADDU_VV_M2_MASK, VWADDU_VV }, // 13427
  { PseudoVWADDU_VV_M4, VWADDU_VV }, // 13428
  { PseudoVWADDU_VV_M4_MASK, VWADDU_VV }, // 13429
  { PseudoVWADDU_VV_MF2, VWADDU_VV }, // 13430
  { PseudoVWADDU_VV_MF2_MASK, VWADDU_VV }, // 13431
  { PseudoVWADDU_VV_MF4, VWADDU_VV }, // 13432
  { PseudoVWADDU_VV_MF4_MASK, VWADDU_VV }, // 13433
  { PseudoVWADDU_VV_MF8, VWADDU_VV }, // 13434
  { PseudoVWADDU_VV_MF8_MASK, VWADDU_VV }, // 13435
  { PseudoVWADDU_VX_M1, VWADDU_VX }, // 13436
  { PseudoVWADDU_VX_M1_MASK, VWADDU_VX }, // 13437
  { PseudoVWADDU_VX_M2, VWADDU_VX }, // 13438
  { PseudoVWADDU_VX_M2_MASK, VWADDU_VX }, // 13439
  { PseudoVWADDU_VX_M4, VWADDU_VX }, // 13440
  { PseudoVWADDU_VX_M4_MASK, VWADDU_VX }, // 13441
  { PseudoVWADDU_VX_MF2, VWADDU_VX }, // 13442
  { PseudoVWADDU_VX_MF2_MASK, VWADDU_VX }, // 13443
  { PseudoVWADDU_VX_MF4, VWADDU_VX }, // 13444
  { PseudoVWADDU_VX_MF4_MASK, VWADDU_VX }, // 13445
  { PseudoVWADDU_VX_MF8, VWADDU_VX }, // 13446
  { PseudoVWADDU_VX_MF8_MASK, VWADDU_VX }, // 13447
  { PseudoVWADDU_WV_M1, VWADDU_WV }, // 13448
  { PseudoVWADDU_WV_M1_MASK, VWADDU_WV }, // 13449
  { PseudoVWADDU_WV_M2, VWADDU_WV }, // 13450
  { PseudoVWADDU_WV_M2_MASK, VWADDU_WV }, // 13451
  { PseudoVWADDU_WV_M4, VWADDU_WV }, // 13452
  { PseudoVWADDU_WV_M4_MASK, VWADDU_WV }, // 13453
  { PseudoVWADDU_WV_MF2, VWADDU_WV }, // 13454
  { PseudoVWADDU_WV_MF2_MASK, VWADDU_WV }, // 13455
  { PseudoVWADDU_WV_MF4, VWADDU_WV }, // 13456
  { PseudoVWADDU_WV_MF4_MASK, VWADDU_WV }, // 13457
  { PseudoVWADDU_WV_MF8, VWADDU_WV }, // 13458
  { PseudoVWADDU_WV_MF8_MASK, VWADDU_WV }, // 13459
  { PseudoVWADDU_WX_M1, VWADDU_WX }, // 13460
  { PseudoVWADDU_WX_M1_MASK, VWADDU_WX }, // 13461
  { PseudoVWADDU_WX_M2, VWADDU_WX }, // 13462
  { PseudoVWADDU_WX_M2_MASK, VWADDU_WX }, // 13463
  { PseudoVWADDU_WX_M4, VWADDU_WX }, // 13464
  { PseudoVWADDU_WX_M4_MASK, VWADDU_WX }, // 13465
  { PseudoVWADDU_WX_MF2, VWADDU_WX }, // 13466
  { PseudoVWADDU_WX_MF2_MASK, VWADDU_WX }, // 13467
  { PseudoVWADDU_WX_MF4, VWADDU_WX }, // 13468
  { PseudoVWADDU_WX_MF4_MASK, VWADDU_WX }, // 13469
  { PseudoVWADDU_WX_MF8, VWADDU_WX }, // 13470
  { PseudoVWADDU_WX_MF8_MASK, VWADDU_WX }, // 13471
  { PseudoVWADD_VV_M1, VWADD_VV }, // 13472
  { PseudoVWADD_VV_M1_MASK, VWADD_VV }, // 13473
  { PseudoVWADD_VV_M2, VWADD_VV }, // 13474
  { PseudoVWADD_VV_M2_MASK, VWADD_VV }, // 13475
  { PseudoVWADD_VV_M4, VWADD_VV }, // 13476
  { PseudoVWADD_VV_M4_MASK, VWADD_VV }, // 13477
  { PseudoVWADD_VV_MF2, VWADD_VV }, // 13478
  { PseudoVWADD_VV_MF2_MASK, VWADD_VV }, // 13479
  { PseudoVWADD_VV_MF4, VWADD_VV }, // 13480
  { PseudoVWADD_VV_MF4_MASK, VWADD_VV }, // 13481
  { PseudoVWADD_VV_MF8, VWADD_VV }, // 13482
  { PseudoVWADD_VV_MF8_MASK, VWADD_VV }, // 13483
  { PseudoVWADD_VX_M1, VWADD_VX }, // 13484
  { PseudoVWADD_VX_M1_MASK, VWADD_VX }, // 13485
  { PseudoVWADD_VX_M2, VWADD_VX }, // 13486
  { PseudoVWADD_VX_M2_MASK, VWADD_VX }, // 13487
  { PseudoVWADD_VX_M4, VWADD_VX }, // 13488
  { PseudoVWADD_VX_M4_MASK, VWADD_VX }, // 13489
  { PseudoVWADD_VX_MF2, VWADD_VX }, // 13490
  { PseudoVWADD_VX_MF2_MASK, VWADD_VX }, // 13491
  { PseudoVWADD_VX_MF4, VWADD_VX }, // 13492
  { PseudoVWADD_VX_MF4_MASK, VWADD_VX }, // 13493
  { PseudoVWADD_VX_MF8, VWADD_VX }, // 13494
  { PseudoVWADD_VX_MF8_MASK, VWADD_VX }, // 13495
  { PseudoVWADD_WV_M1, VWADD_WV }, // 13496
  { PseudoVWADD_WV_M1_MASK, VWADD_WV }, // 13497
  { PseudoVWADD_WV_M2, VWADD_WV }, // 13498
  { PseudoVWADD_WV_M2_MASK, VWADD_WV }, // 13499
  { PseudoVWADD_WV_M4, VWADD_WV }, // 13500
  { PseudoVWADD_WV_M4_MASK, VWADD_WV }, // 13501
  { PseudoVWADD_WV_MF2, VWADD_WV }, // 13502
  { PseudoVWADD_WV_MF2_MASK, VWADD_WV }, // 13503
  { PseudoVWADD_WV_MF4, VWADD_WV }, // 13504
  { PseudoVWADD_WV_MF4_MASK, VWADD_WV }, // 13505
  { PseudoVWADD_WV_MF8, VWADD_WV }, // 13506
  { PseudoVWADD_WV_MF8_MASK, VWADD_WV }, // 13507
  { PseudoVWADD_WX_M1, VWADD_WX }, // 13508
  { PseudoVWADD_WX_M1_MASK, VWADD_WX }, // 13509
  { PseudoVWADD_WX_M2, VWADD_WX }, // 13510
  { PseudoVWADD_WX_M2_MASK, VWADD_WX }, // 13511
  { PseudoVWADD_WX_M4, VWADD_WX }, // 13512
  { PseudoVWADD_WX_M4_MASK, VWADD_WX }, // 13513
  { PseudoVWADD_WX_MF2, VWADD_WX }, // 13514
  { PseudoVWADD_WX_MF2_MASK, VWADD_WX }, // 13515
  { PseudoVWADD_WX_MF4, VWADD_WX }, // 13516
  { PseudoVWADD_WX_MF4_MASK, VWADD_WX }, // 13517
  { PseudoVWADD_WX_MF8, VWADD_WX }, // 13518
  { PseudoVWADD_WX_MF8_MASK, VWADD_WX }, // 13519
  { PseudoVWMACCSU_VV_M1, VWMACCSU_VV }, // 13520
  { PseudoVWMACCSU_VV_M1_MASK, VWMACCSU_VV }, // 13521
  { PseudoVWMACCSU_VV_M2, VWMACCSU_VV }, // 13522
  { PseudoVWMACCSU_VV_M2_MASK, VWMACCSU_VV }, // 13523
  { PseudoVWMACCSU_VV_M4, VWMACCSU_VV }, // 13524
  { PseudoVWMACCSU_VV_M4_MASK, VWMACCSU_VV }, // 13525
  { PseudoVWMACCSU_VV_MF2, VWMACCSU_VV }, // 13526
  { PseudoVWMACCSU_VV_MF2_MASK, VWMACCSU_VV }, // 13527
  { PseudoVWMACCSU_VV_MF4, VWMACCSU_VV }, // 13528
  { PseudoVWMACCSU_VV_MF4_MASK, VWMACCSU_VV }, // 13529
  { PseudoVWMACCSU_VV_MF8, VWMACCSU_VV }, // 13530
  { PseudoVWMACCSU_VV_MF8_MASK, VWMACCSU_VV }, // 13531
  { PseudoVWMACCSU_VX_M1, VWMACCSU_VX }, // 13532
  { PseudoVWMACCSU_VX_M1_MASK, VWMACCSU_VX }, // 13533
  { PseudoVWMACCSU_VX_M2, VWMACCSU_VX }, // 13534
  { PseudoVWMACCSU_VX_M2_MASK, VWMACCSU_VX }, // 13535
  { PseudoVWMACCSU_VX_M4, VWMACCSU_VX }, // 13536
  { PseudoVWMACCSU_VX_M4_MASK, VWMACCSU_VX }, // 13537
  { PseudoVWMACCSU_VX_MF2, VWMACCSU_VX }, // 13538
  { PseudoVWMACCSU_VX_MF2_MASK, VWMACCSU_VX }, // 13539
  { PseudoVWMACCSU_VX_MF4, VWMACCSU_VX }, // 13540
  { PseudoVWMACCSU_VX_MF4_MASK, VWMACCSU_VX }, // 13541
  { PseudoVWMACCSU_VX_MF8, VWMACCSU_VX }, // 13542
  { PseudoVWMACCSU_VX_MF8_MASK, VWMACCSU_VX }, // 13543
  { PseudoVWMACCUS_VX_M1, VWMACCUS_VX }, // 13544
  { PseudoVWMACCUS_VX_M1_MASK, VWMACCUS_VX }, // 13545
  { PseudoVWMACCUS_VX_M2, VWMACCUS_VX }, // 13546
  { PseudoVWMACCUS_VX_M2_MASK, VWMACCUS_VX }, // 13547
  { PseudoVWMACCUS_VX_M4, VWMACCUS_VX }, // 13548
  { PseudoVWMACCUS_VX_M4_MASK, VWMACCUS_VX }, // 13549
  { PseudoVWMACCUS_VX_MF2, VWMACCUS_VX }, // 13550
  { PseudoVWMACCUS_VX_MF2_MASK, VWMACCUS_VX }, // 13551
  { PseudoVWMACCUS_VX_MF4, VWMACCUS_VX }, // 13552
  { PseudoVWMACCUS_VX_MF4_MASK, VWMACCUS_VX }, // 13553
  { PseudoVWMACCUS_VX_MF8, VWMACCUS_VX }, // 13554
  { PseudoVWMACCUS_VX_MF8_MASK, VWMACCUS_VX }, // 13555
  { PseudoVWMACCU_VV_M1, VWMACCU_VV }, // 13556
  { PseudoVWMACCU_VV_M1_MASK, VWMACCU_VV }, // 13557
  { PseudoVWMACCU_VV_M2, VWMACCU_VV }, // 13558
  { PseudoVWMACCU_VV_M2_MASK, VWMACCU_VV }, // 13559
  { PseudoVWMACCU_VV_M4, VWMACCU_VV }, // 13560
  { PseudoVWMACCU_VV_M4_MASK, VWMACCU_VV }, // 13561
  { PseudoVWMACCU_VV_MF2, VWMACCU_VV }, // 13562
  { PseudoVWMACCU_VV_MF2_MASK, VWMACCU_VV }, // 13563
  { PseudoVWMACCU_VV_MF4, VWMACCU_VV }, // 13564
  { PseudoVWMACCU_VV_MF4_MASK, VWMACCU_VV }, // 13565
  { PseudoVWMACCU_VV_MF8, VWMACCU_VV }, // 13566
  { PseudoVWMACCU_VV_MF8_MASK, VWMACCU_VV }, // 13567
  { PseudoVWMACCU_VX_M1, VWMACCU_VX }, // 13568
  { PseudoVWMACCU_VX_M1_MASK, VWMACCU_VX }, // 13569
  { PseudoVWMACCU_VX_M2, VWMACCU_VX }, // 13570
  { PseudoVWMACCU_VX_M2_MASK, VWMACCU_VX }, // 13571
  { PseudoVWMACCU_VX_M4, VWMACCU_VX }, // 13572
  { PseudoVWMACCU_VX_M4_MASK, VWMACCU_VX }, // 13573
  { PseudoVWMACCU_VX_MF2, VWMACCU_VX }, // 13574
  { PseudoVWMACCU_VX_MF2_MASK, VWMACCU_VX }, // 13575
  { PseudoVWMACCU_VX_MF4, VWMACCU_VX }, // 13576
  { PseudoVWMACCU_VX_MF4_MASK, VWMACCU_VX }, // 13577
  { PseudoVWMACCU_VX_MF8, VWMACCU_VX }, // 13578
  { PseudoVWMACCU_VX_MF8_MASK, VWMACCU_VX }, // 13579
  { PseudoVWMACC_VV_M1, VWMACC_VV }, // 13580
  { PseudoVWMACC_VV_M1_MASK, VWMACC_VV }, // 13581
  { PseudoVWMACC_VV_M2, VWMACC_VV }, // 13582
  { PseudoVWMACC_VV_M2_MASK, VWMACC_VV }, // 13583
  { PseudoVWMACC_VV_M4, VWMACC_VV }, // 13584
  { PseudoVWMACC_VV_M4_MASK, VWMACC_VV }, // 13585
  { PseudoVWMACC_VV_MF2, VWMACC_VV }, // 13586
  { PseudoVWMACC_VV_MF2_MASK, VWMACC_VV }, // 13587
  { PseudoVWMACC_VV_MF4, VWMACC_VV }, // 13588
  { PseudoVWMACC_VV_MF4_MASK, VWMACC_VV }, // 13589
  { PseudoVWMACC_VV_MF8, VWMACC_VV }, // 13590
  { PseudoVWMACC_VV_MF8_MASK, VWMACC_VV }, // 13591
  { PseudoVWMACC_VX_M1, VWMACC_VX }, // 13592
  { PseudoVWMACC_VX_M1_MASK, VWMACC_VX }, // 13593
  { PseudoVWMACC_VX_M2, VWMACC_VX }, // 13594
  { PseudoVWMACC_VX_M2_MASK, VWMACC_VX }, // 13595
  { PseudoVWMACC_VX_M4, VWMACC_VX }, // 13596
  { PseudoVWMACC_VX_M4_MASK, VWMACC_VX }, // 13597
  { PseudoVWMACC_VX_MF2, VWMACC_VX }, // 13598
  { PseudoVWMACC_VX_MF2_MASK, VWMACC_VX }, // 13599
  { PseudoVWMACC_VX_MF4, VWMACC_VX }, // 13600
  { PseudoVWMACC_VX_MF4_MASK, VWMACC_VX }, // 13601
  { PseudoVWMACC_VX_MF8, VWMACC_VX }, // 13602
  { PseudoVWMACC_VX_MF8_MASK, VWMACC_VX }, // 13603
  { PseudoVWMULSU_VV_M1, VWMULSU_VV }, // 13604
  { PseudoVWMULSU_VV_M1_MASK, VWMULSU_VV }, // 13605
  { PseudoVWMULSU_VV_M2, VWMULSU_VV }, // 13606
  { PseudoVWMULSU_VV_M2_MASK, VWMULSU_VV }, // 13607
  { PseudoVWMULSU_VV_M4, VWMULSU_VV }, // 13608
  { PseudoVWMULSU_VV_M4_MASK, VWMULSU_VV }, // 13609
  { PseudoVWMULSU_VV_MF2, VWMULSU_VV }, // 13610
  { PseudoVWMULSU_VV_MF2_MASK, VWMULSU_VV }, // 13611
  { PseudoVWMULSU_VV_MF4, VWMULSU_VV }, // 13612
  { PseudoVWMULSU_VV_MF4_MASK, VWMULSU_VV }, // 13613
  { PseudoVWMULSU_VV_MF8, VWMULSU_VV }, // 13614
  { PseudoVWMULSU_VV_MF8_MASK, VWMULSU_VV }, // 13615
  { PseudoVWMULSU_VX_M1, VWMULSU_VX }, // 13616
  { PseudoVWMULSU_VX_M1_MASK, VWMULSU_VX }, // 13617
  { PseudoVWMULSU_VX_M2, VWMULSU_VX }, // 13618
  { PseudoVWMULSU_VX_M2_MASK, VWMULSU_VX }, // 13619
  { PseudoVWMULSU_VX_M4, VWMULSU_VX }, // 13620
  { PseudoVWMULSU_VX_M4_MASK, VWMULSU_VX }, // 13621
  { PseudoVWMULSU_VX_MF2, VWMULSU_VX }, // 13622
  { PseudoVWMULSU_VX_MF2_MASK, VWMULSU_VX }, // 13623
  { PseudoVWMULSU_VX_MF4, VWMULSU_VX }, // 13624
  { PseudoVWMULSU_VX_MF4_MASK, VWMULSU_VX }, // 13625
  { PseudoVWMULSU_VX_MF8, VWMULSU_VX }, // 13626
  { PseudoVWMULSU_VX_MF8_MASK, VWMULSU_VX }, // 13627
  { PseudoVWMULU_VV_M1, VWMULU_VV }, // 13628
  { PseudoVWMULU_VV_M1_MASK, VWMULU_VV }, // 13629
  { PseudoVWMULU_VV_M2, VWMULU_VV }, // 13630
  { PseudoVWMULU_VV_M2_MASK, VWMULU_VV }, // 13631
  { PseudoVWMULU_VV_M4, VWMULU_VV }, // 13632
  { PseudoVWMULU_VV_M4_MASK, VWMULU_VV }, // 13633
  { PseudoVWMULU_VV_MF2, VWMULU_VV }, // 13634
  { PseudoVWMULU_VV_MF2_MASK, VWMULU_VV }, // 13635
  { PseudoVWMULU_VV_MF4, VWMULU_VV }, // 13636
  { PseudoVWMULU_VV_MF4_MASK, VWMULU_VV }, // 13637
  { PseudoVWMULU_VV_MF8, VWMULU_VV }, // 13638
  { PseudoVWMULU_VV_MF8_MASK, VWMULU_VV }, // 13639
  { PseudoVWMULU_VX_M1, VWMULU_VX }, // 13640
  { PseudoVWMULU_VX_M1_MASK, VWMULU_VX }, // 13641
  { PseudoVWMULU_VX_M2, VWMULU_VX }, // 13642
  { PseudoVWMULU_VX_M2_MASK, VWMULU_VX }, // 13643
  { PseudoVWMULU_VX_M4, VWMULU_VX }, // 13644
  { PseudoVWMULU_VX_M4_MASK, VWMULU_VX }, // 13645
  { PseudoVWMULU_VX_MF2, VWMULU_VX }, // 13646
  { PseudoVWMULU_VX_MF2_MASK, VWMULU_VX }, // 13647
  { PseudoVWMULU_VX_MF4, VWMULU_VX }, // 13648
  { PseudoVWMULU_VX_MF4_MASK, VWMULU_VX }, // 13649
  { PseudoVWMULU_VX_MF8, VWMULU_VX }, // 13650
  { PseudoVWMULU_VX_MF8_MASK, VWMULU_VX }, // 13651
  { PseudoVWMUL_VV_M1, VWMUL_VV }, // 13652
  { PseudoVWMUL_VV_M1_MASK, VWMUL_VV }, // 13653
  { PseudoVWMUL_VV_M2, VWMUL_VV }, // 13654
  { PseudoVWMUL_VV_M2_MASK, VWMUL_VV }, // 13655
  { PseudoVWMUL_VV_M4, VWMUL_VV }, // 13656
  { PseudoVWMUL_VV_M4_MASK, VWMUL_VV }, // 13657
  { PseudoVWMUL_VV_MF2, VWMUL_VV }, // 13658
  { PseudoVWMUL_VV_MF2_MASK, VWMUL_VV }, // 13659
  { PseudoVWMUL_VV_MF4, VWMUL_VV }, // 13660
  { PseudoVWMUL_VV_MF4_MASK, VWMUL_VV }, // 13661
  { PseudoVWMUL_VV_MF8, VWMUL_VV }, // 13662
  { PseudoVWMUL_VV_MF8_MASK, VWMUL_VV }, // 13663
  { PseudoVWMUL_VX_M1, VWMUL_VX }, // 13664
  { PseudoVWMUL_VX_M1_MASK, VWMUL_VX }, // 13665
  { PseudoVWMUL_VX_M2, VWMUL_VX }, // 13666
  { PseudoVWMUL_VX_M2_MASK, VWMUL_VX }, // 13667
  { PseudoVWMUL_VX_M4, VWMUL_VX }, // 13668
  { PseudoVWMUL_VX_M4_MASK, VWMUL_VX }, // 13669
  { PseudoVWMUL_VX_MF2, VWMUL_VX }, // 13670
  { PseudoVWMUL_VX_MF2_MASK, VWMUL_VX }, // 13671
  { PseudoVWMUL_VX_MF4, VWMUL_VX }, // 13672
  { PseudoVWMUL_VX_MF4_MASK, VWMUL_VX }, // 13673
  { PseudoVWMUL_VX_MF8, VWMUL_VX }, // 13674
  { PseudoVWMUL_VX_MF8_MASK, VWMUL_VX }, // 13675
  { PseudoVWREDSUMU_VS_M1, VWREDSUMU_VS }, // 13676
  { PseudoVWREDSUMU_VS_M1_MASK, VWREDSUMU_VS }, // 13677
  { PseudoVWREDSUMU_VS_M2, VWREDSUMU_VS }, // 13678
  { PseudoVWREDSUMU_VS_M2_MASK, VWREDSUMU_VS }, // 13679
  { PseudoVWREDSUMU_VS_M4, VWREDSUMU_VS }, // 13680
  { PseudoVWREDSUMU_VS_M4_MASK, VWREDSUMU_VS }, // 13681
  { PseudoVWREDSUMU_VS_M8, VWREDSUMU_VS }, // 13682
  { PseudoVWREDSUMU_VS_M8_MASK, VWREDSUMU_VS }, // 13683
  { PseudoVWREDSUMU_VS_MF2, VWREDSUMU_VS }, // 13684
  { PseudoVWREDSUMU_VS_MF2_MASK, VWREDSUMU_VS }, // 13685
  { PseudoVWREDSUMU_VS_MF4, VWREDSUMU_VS }, // 13686
  { PseudoVWREDSUMU_VS_MF4_MASK, VWREDSUMU_VS }, // 13687
  { PseudoVWREDSUMU_VS_MF8, VWREDSUMU_VS }, // 13688
  { PseudoVWREDSUMU_VS_MF8_MASK, VWREDSUMU_VS }, // 13689
  { PseudoVWREDSUM_VS_M1, VWREDSUM_VS }, // 13690
  { PseudoVWREDSUM_VS_M1_MASK, VWREDSUM_VS }, // 13691
  { PseudoVWREDSUM_VS_M2, VWREDSUM_VS }, // 13692
  { PseudoVWREDSUM_VS_M2_MASK, VWREDSUM_VS }, // 13693
  { PseudoVWREDSUM_VS_M4, VWREDSUM_VS }, // 13694
  { PseudoVWREDSUM_VS_M4_MASK, VWREDSUM_VS }, // 13695
  { PseudoVWREDSUM_VS_M8, VWREDSUM_VS }, // 13696
  { PseudoVWREDSUM_VS_M8_MASK, VWREDSUM_VS }, // 13697
  { PseudoVWREDSUM_VS_MF2, VWREDSUM_VS }, // 13698
  { PseudoVWREDSUM_VS_MF2_MASK, VWREDSUM_VS }, // 13699
  { PseudoVWREDSUM_VS_MF4, VWREDSUM_VS }, // 13700
  { PseudoVWREDSUM_VS_MF4_MASK, VWREDSUM_VS }, // 13701
  { PseudoVWREDSUM_VS_MF8, VWREDSUM_VS }, // 13702
  { PseudoVWREDSUM_VS_MF8_MASK, VWREDSUM_VS }, // 13703
  { PseudoVWSUBU_VV_M1, VWSUBU_VV }, // 13704
  { PseudoVWSUBU_VV_M1_MASK, VWSUBU_VV }, // 13705
  { PseudoVWSUBU_VV_M2, VWSUBU_VV }, // 13706
  { PseudoVWSUBU_VV_M2_MASK, VWSUBU_VV }, // 13707
  { PseudoVWSUBU_VV_M4, VWSUBU_VV }, // 13708
  { PseudoVWSUBU_VV_M4_MASK, VWSUBU_VV }, // 13709
  { PseudoVWSUBU_VV_MF2, VWSUBU_VV }, // 13710
  { PseudoVWSUBU_VV_MF2_MASK, VWSUBU_VV }, // 13711
  { PseudoVWSUBU_VV_MF4, VWSUBU_VV }, // 13712
  { PseudoVWSUBU_VV_MF4_MASK, VWSUBU_VV }, // 13713
  { PseudoVWSUBU_VV_MF8, VWSUBU_VV }, // 13714
  { PseudoVWSUBU_VV_MF8_MASK, VWSUBU_VV }, // 13715
  { PseudoVWSUBU_VX_M1, VWSUBU_VX }, // 13716
  { PseudoVWSUBU_VX_M1_MASK, VWSUBU_VX }, // 13717
  { PseudoVWSUBU_VX_M2, VWSUBU_VX }, // 13718
  { PseudoVWSUBU_VX_M2_MASK, VWSUBU_VX }, // 13719
  { PseudoVWSUBU_VX_M4, VWSUBU_VX }, // 13720
  { PseudoVWSUBU_VX_M4_MASK, VWSUBU_VX }, // 13721
  { PseudoVWSUBU_VX_MF2, VWSUBU_VX }, // 13722
  { PseudoVWSUBU_VX_MF2_MASK, VWSUBU_VX }, // 13723
  { PseudoVWSUBU_VX_MF4, VWSUBU_VX }, // 13724
  { PseudoVWSUBU_VX_MF4_MASK, VWSUBU_VX }, // 13725
  { PseudoVWSUBU_VX_MF8, VWSUBU_VX }, // 13726
  { PseudoVWSUBU_VX_MF8_MASK, VWSUBU_VX }, // 13727
  { PseudoVWSUBU_WV_M1, VWSUBU_WV }, // 13728
  { PseudoVWSUBU_WV_M1_MASK, VWSUBU_WV }, // 13729
  { PseudoVWSUBU_WV_M2, VWSUBU_WV }, // 13730
  { PseudoVWSUBU_WV_M2_MASK, VWSUBU_WV }, // 13731
  { PseudoVWSUBU_WV_M4, VWSUBU_WV }, // 13732
  { PseudoVWSUBU_WV_M4_MASK, VWSUBU_WV }, // 13733
  { PseudoVWSUBU_WV_MF2, VWSUBU_WV }, // 13734
  { PseudoVWSUBU_WV_MF2_MASK, VWSUBU_WV }, // 13735
  { PseudoVWSUBU_WV_MF4, VWSUBU_WV }, // 13736
  { PseudoVWSUBU_WV_MF4_MASK, VWSUBU_WV }, // 13737
  { PseudoVWSUBU_WV_MF8, VWSUBU_WV }, // 13738
  { PseudoVWSUBU_WV_MF8_MASK, VWSUBU_WV }, // 13739
  { PseudoVWSUBU_WX_M1, VWSUBU_WX }, // 13740
  { PseudoVWSUBU_WX_M1_MASK, VWSUBU_WX }, // 13741
  { PseudoVWSUBU_WX_M2, VWSUBU_WX }, // 13742
  { PseudoVWSUBU_WX_M2_MASK, VWSUBU_WX }, // 13743
  { PseudoVWSUBU_WX_M4, VWSUBU_WX }, // 13744
  { PseudoVWSUBU_WX_M4_MASK, VWSUBU_WX }, // 13745
  { PseudoVWSUBU_WX_MF2, VWSUBU_WX }, // 13746
  { PseudoVWSUBU_WX_MF2_MASK, VWSUBU_WX }, // 13747
  { PseudoVWSUBU_WX_MF4, VWSUBU_WX }, // 13748
  { PseudoVWSUBU_WX_MF4_MASK, VWSUBU_WX }, // 13749
  { PseudoVWSUBU_WX_MF8, VWSUBU_WX }, // 13750
  { PseudoVWSUBU_WX_MF8_MASK, VWSUBU_WX }, // 13751
  { PseudoVWSUB_VV_M1, VWSUB_VV }, // 13752
  { PseudoVWSUB_VV_M1_MASK, VWSUB_VV }, // 13753
  { PseudoVWSUB_VV_M2, VWSUB_VV }, // 13754
  { PseudoVWSUB_VV_M2_MASK, VWSUB_VV }, // 13755
  { PseudoVWSUB_VV_M4, VWSUB_VV }, // 13756
  { PseudoVWSUB_VV_M4_MASK, VWSUB_VV }, // 13757
  { PseudoVWSUB_VV_MF2, VWSUB_VV }, // 13758
  { PseudoVWSUB_VV_MF2_MASK, VWSUB_VV }, // 13759
  { PseudoVWSUB_VV_MF4, VWSUB_VV }, // 13760
  { PseudoVWSUB_VV_MF4_MASK, VWSUB_VV }, // 13761
  { PseudoVWSUB_VV_MF8, VWSUB_VV }, // 13762
  { PseudoVWSUB_VV_MF8_MASK, VWSUB_VV }, // 13763
  { PseudoVWSUB_VX_M1, VWSUB_VX }, // 13764
  { PseudoVWSUB_VX_M1_MASK, VWSUB_VX }, // 13765
  { PseudoVWSUB_VX_M2, VWSUB_VX }, // 13766
  { PseudoVWSUB_VX_M2_MASK, VWSUB_VX }, // 13767
  { PseudoVWSUB_VX_M4, VWSUB_VX }, // 13768
  { PseudoVWSUB_VX_M4_MASK, VWSUB_VX }, // 13769
  { PseudoVWSUB_VX_MF2, VWSUB_VX }, // 13770
  { PseudoVWSUB_VX_MF2_MASK, VWSUB_VX }, // 13771
  { PseudoVWSUB_VX_MF4, VWSUB_VX }, // 13772
  { PseudoVWSUB_VX_MF4_MASK, VWSUB_VX }, // 13773
  { PseudoVWSUB_VX_MF8, VWSUB_VX }, // 13774
  { PseudoVWSUB_VX_MF8_MASK, VWSUB_VX }, // 13775
  { PseudoVWSUB_WV_M1, VWSUB_WV }, // 13776
  { PseudoVWSUB_WV_M1_MASK, VWSUB_WV }, // 13777
  { PseudoVWSUB_WV_M2, VWSUB_WV }, // 13778
  { PseudoVWSUB_WV_M2_MASK, VWSUB_WV }, // 13779
  { PseudoVWSUB_WV_M4, VWSUB_WV }, // 13780
  { PseudoVWSUB_WV_M4_MASK, VWSUB_WV }, // 13781
  { PseudoVWSUB_WV_MF2, VWSUB_WV }, // 13782
  { PseudoVWSUB_WV_MF2_MASK, VWSUB_WV }, // 13783
  { PseudoVWSUB_WV_MF4, VWSUB_WV }, // 13784
  { PseudoVWSUB_WV_MF4_MASK, VWSUB_WV }, // 13785
  { PseudoVWSUB_WV_MF8, VWSUB_WV }, // 13786
  { PseudoVWSUB_WV_MF8_MASK, VWSUB_WV }, // 13787
  { PseudoVWSUB_WX_M1, VWSUB_WX }, // 13788
  { PseudoVWSUB_WX_M1_MASK, VWSUB_WX }, // 13789
  { PseudoVWSUB_WX_M2, VWSUB_WX }, // 13790
  { PseudoVWSUB_WX_M2_MASK, VWSUB_WX }, // 13791
  { PseudoVWSUB_WX_M4, VWSUB_WX }, // 13792
  { PseudoVWSUB_WX_M4_MASK, VWSUB_WX }, // 13793
  { PseudoVWSUB_WX_MF2, VWSUB_WX }, // 13794
  { PseudoVWSUB_WX_MF2_MASK, VWSUB_WX }, // 13795
  { PseudoVWSUB_WX_MF4, VWSUB_WX }, // 13796
  { PseudoVWSUB_WX_MF4_MASK, VWSUB_WX }, // 13797
  { PseudoVWSUB_WX_MF8, VWSUB_WX }, // 13798
  { PseudoVWSUB_WX_MF8_MASK, VWSUB_WX }, // 13799
  { PseudoVXOR_VI_M1, VXOR_VI }, // 13800
  { PseudoVXOR_VI_M1_MASK, VXOR_VI }, // 13801
  { PseudoVXOR_VI_M2, VXOR_VI }, // 13802
  { PseudoVXOR_VI_M2_MASK, VXOR_VI }, // 13803
  { PseudoVXOR_VI_M4, VXOR_VI }, // 13804
  { PseudoVXOR_VI_M4_MASK, VXOR_VI }, // 13805
  { PseudoVXOR_VI_M8, VXOR_VI }, // 13806
  { PseudoVXOR_VI_M8_MASK, VXOR_VI }, // 13807
  { PseudoVXOR_VI_MF2, VXOR_VI }, // 13808
  { PseudoVXOR_VI_MF2_MASK, VXOR_VI }, // 13809
  { PseudoVXOR_VI_MF4, VXOR_VI }, // 13810
  { PseudoVXOR_VI_MF4_MASK, VXOR_VI }, // 13811
  { PseudoVXOR_VI_MF8, VXOR_VI }, // 13812
  { PseudoVXOR_VI_MF8_MASK, VXOR_VI }, // 13813
  { PseudoVXOR_VV_M1, VXOR_VV }, // 13814
  { PseudoVXOR_VV_M1_MASK, VXOR_VV }, // 13815
  { PseudoVXOR_VV_M2, VXOR_VV }, // 13816
  { PseudoVXOR_VV_M2_MASK, VXOR_VV }, // 13817
  { PseudoVXOR_VV_M4, VXOR_VV }, // 13818
  { PseudoVXOR_VV_M4_MASK, VXOR_VV }, // 13819
  { PseudoVXOR_VV_M8, VXOR_VV }, // 13820
  { PseudoVXOR_VV_M8_MASK, VXOR_VV }, // 13821
  { PseudoVXOR_VV_MF2, VXOR_VV }, // 13822
  { PseudoVXOR_VV_MF2_MASK, VXOR_VV }, // 13823
  { PseudoVXOR_VV_MF4, VXOR_VV }, // 13824
  { PseudoVXOR_VV_MF4_MASK, VXOR_VV }, // 13825
  { PseudoVXOR_VV_MF8, VXOR_VV }, // 13826
  { PseudoVXOR_VV_MF8_MASK, VXOR_VV }, // 13827
  { PseudoVXOR_VX_M1, VXOR_VX }, // 13828
  { PseudoVXOR_VX_M1_MASK, VXOR_VX }, // 13829
  { PseudoVXOR_VX_M2, VXOR_VX }, // 13830
  { PseudoVXOR_VX_M2_MASK, VXOR_VX }, // 13831
  { PseudoVXOR_VX_M4, VXOR_VX }, // 13832
  { PseudoVXOR_VX_M4_MASK, VXOR_VX }, // 13833
  { PseudoVXOR_VX_M8, VXOR_VX }, // 13834
  { PseudoVXOR_VX_M8_MASK, VXOR_VX }, // 13835
  { PseudoVXOR_VX_MF2, VXOR_VX }, // 13836
  { PseudoVXOR_VX_MF2_MASK, VXOR_VX }, // 13837
  { PseudoVXOR_VX_MF4, VXOR_VX }, // 13838
  { PseudoVXOR_VX_MF4_MASK, VXOR_VX }, // 13839
  { PseudoVXOR_VX_MF8, VXOR_VX }, // 13840
  { PseudoVXOR_VX_MF8_MASK, VXOR_VX }, // 13841
  { PseudoVZEXT_VF2_M1, VZEXT_VF2 }, // 13842
  { PseudoVZEXT_VF2_M1_MASK, VZEXT_VF2 }, // 13843
  { PseudoVZEXT_VF2_M2, VZEXT_VF2 }, // 13844
  { PseudoVZEXT_VF2_M2_MASK, VZEXT_VF2 }, // 13845
  { PseudoVZEXT_VF2_M4, VZEXT_VF2 }, // 13846
  { PseudoVZEXT_VF2_M4_MASK, VZEXT_VF2 }, // 13847
  { PseudoVZEXT_VF2_M8, VZEXT_VF2 }, // 13848
  { PseudoVZEXT_VF2_M8_MASK, VZEXT_VF2 }, // 13849
  { PseudoVZEXT_VF2_MF2, VZEXT_VF2 }, // 13850
  { PseudoVZEXT_VF2_MF2_MASK, VZEXT_VF2 }, // 13851
  { PseudoVZEXT_VF2_MF4, VZEXT_VF2 }, // 13852
  { PseudoVZEXT_VF2_MF4_MASK, VZEXT_VF2 }, // 13853
  { PseudoVZEXT_VF4_M1, VZEXT_VF4 }, // 13854
  { PseudoVZEXT_VF4_M1_MASK, VZEXT_VF4 }, // 13855
  { PseudoVZEXT_VF4_M2, VZEXT_VF4 }, // 13856
  { PseudoVZEXT_VF4_M2_MASK, VZEXT_VF4 }, // 13857
  { PseudoVZEXT_VF4_M4, VZEXT_VF4 }, // 13858
  { PseudoVZEXT_VF4_M4_MASK, VZEXT_VF4 }, // 13859
  { PseudoVZEXT_VF4_M8, VZEXT_VF4 }, // 13860
  { PseudoVZEXT_VF4_M8_MASK, VZEXT_VF4 }, // 13861
  { PseudoVZEXT_VF4_MF2, VZEXT_VF4 }, // 13862
  { PseudoVZEXT_VF4_MF2_MASK, VZEXT_VF4 }, // 13863
  { PseudoVZEXT_VF8_M1, VZEXT_VF8 }, // 13864
  { PseudoVZEXT_VF8_M1_MASK, VZEXT_VF8 }, // 13865
  { PseudoVZEXT_VF8_M2, VZEXT_VF8 }, // 13866
  { PseudoVZEXT_VF8_M2_MASK, VZEXT_VF8 }, // 13867
  { PseudoVZEXT_VF8_M4, VZEXT_VF8 }, // 13868
  { PseudoVZEXT_VF8_M4_MASK, VZEXT_VF8 }, // 13869
  { PseudoVZEXT_VF8_M8, VZEXT_VF8 }, // 13870
  { PseudoVZEXT_VF8_M8_MASK, VZEXT_VF8 }, // 13871
 };

const PseudoInfo *getPseudoInfo(unsigned Pseudo) {
  struct KeyType {
    unsigned Pseudo;
  };
  KeyType Key = {Pseudo};
  auto Table = makeArrayRef(RISCVVPseudosTable);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const PseudoInfo &LHS, const KeyType &RHS) {
      if (LHS.Pseudo < RHS.Pseudo)
        return true;
      if (LHS.Pseudo > RHS.Pseudo)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Pseudo != Idx->Pseudo)
    return nullptr;
  return &*Idx;
}
#endif

#ifdef GET_RISCVZvlssegTable_DECL
const RISCVZvlsseg *getPseudo(unsigned IntrinsicID, uint16_t SEW, uint8_t LMUL, uint8_t IndexLMUL);
#endif

#ifdef GET_RISCVZvlssegTable_IMPL
constexpr RISCVZvlsseg RISCVZvlssegTable[] = {
  { Intrinsic::riscv_vloxseg2, 0x8, 0x0, 0x0, PseudoVLOXSEG2EI8_V_M1_M1 }, // 0
  { Intrinsic::riscv_vloxseg2, 0x8, 0x0, 0x1, PseudoVLOXSEG2EI8_V_M2_M1 }, // 1
  { Intrinsic::riscv_vloxseg2, 0x8, 0x0, 0x2, PseudoVLOXSEG2EI8_V_M4_M1 }, // 2
  { Intrinsic::riscv_vloxseg2, 0x8, 0x0, 0x3, PseudoVLOXSEG2EI8_V_M8_M1 }, // 3
  { Intrinsic::riscv_vloxseg2, 0x8, 0x0, 0x5, PseudoVLOXSEG2EI8_V_MF8_M1 }, // 4
  { Intrinsic::riscv_vloxseg2, 0x8, 0x0, 0x6, PseudoVLOXSEG2EI8_V_MF4_M1 }, // 5
  { Intrinsic::riscv_vloxseg2, 0x8, 0x0, 0x7, PseudoVLOXSEG2EI8_V_MF2_M1 }, // 6
  { Intrinsic::riscv_vloxseg2, 0x8, 0x1, 0x0, PseudoVLOXSEG2EI8_V_M1_M2 }, // 7
  { Intrinsic::riscv_vloxseg2, 0x8, 0x1, 0x1, PseudoVLOXSEG2EI8_V_M2_M2 }, // 8
  { Intrinsic::riscv_vloxseg2, 0x8, 0x1, 0x2, PseudoVLOXSEG2EI8_V_M4_M2 }, // 9
  { Intrinsic::riscv_vloxseg2, 0x8, 0x1, 0x3, PseudoVLOXSEG2EI8_V_M8_M2 }, // 10
  { Intrinsic::riscv_vloxseg2, 0x8, 0x1, 0x5, PseudoVLOXSEG2EI8_V_MF8_M2 }, // 11
  { Intrinsic::riscv_vloxseg2, 0x8, 0x1, 0x6, PseudoVLOXSEG2EI8_V_MF4_M2 }, // 12
  { Intrinsic::riscv_vloxseg2, 0x8, 0x1, 0x7, PseudoVLOXSEG2EI8_V_MF2_M2 }, // 13
  { Intrinsic::riscv_vloxseg2, 0x8, 0x2, 0x0, PseudoVLOXSEG2EI8_V_M1_M4 }, // 14
  { Intrinsic::riscv_vloxseg2, 0x8, 0x2, 0x1, PseudoVLOXSEG2EI8_V_M2_M4 }, // 15
  { Intrinsic::riscv_vloxseg2, 0x8, 0x2, 0x2, PseudoVLOXSEG2EI8_V_M4_M4 }, // 16
  { Intrinsic::riscv_vloxseg2, 0x8, 0x2, 0x3, PseudoVLOXSEG2EI8_V_M8_M4 }, // 17
  { Intrinsic::riscv_vloxseg2, 0x8, 0x2, 0x5, PseudoVLOXSEG2EI8_V_MF8_M4 }, // 18
  { Intrinsic::riscv_vloxseg2, 0x8, 0x2, 0x6, PseudoVLOXSEG2EI8_V_MF4_M4 }, // 19
  { Intrinsic::riscv_vloxseg2, 0x8, 0x2, 0x7, PseudoVLOXSEG2EI8_V_MF2_M4 }, // 20
  { Intrinsic::riscv_vloxseg2, 0x8, 0x5, 0x0, PseudoVLOXSEG2EI8_V_M1_MF8 }, // 21
  { Intrinsic::riscv_vloxseg2, 0x8, 0x5, 0x1, PseudoVLOXSEG2EI8_V_M2_MF8 }, // 22
  { Intrinsic::riscv_vloxseg2, 0x8, 0x5, 0x2, PseudoVLOXSEG2EI8_V_M4_MF8 }, // 23
  { Intrinsic::riscv_vloxseg2, 0x8, 0x5, 0x3, PseudoVLOXSEG2EI8_V_M8_MF8 }, // 24
  { Intrinsic::riscv_vloxseg2, 0x8, 0x5, 0x5, PseudoVLOXSEG2EI8_V_MF8_MF8 }, // 25
  { Intrinsic::riscv_vloxseg2, 0x8, 0x5, 0x6, PseudoVLOXSEG2EI8_V_MF4_MF8 }, // 26
  { Intrinsic::riscv_vloxseg2, 0x8, 0x5, 0x7, PseudoVLOXSEG2EI8_V_MF2_MF8 }, // 27
  { Intrinsic::riscv_vloxseg2, 0x8, 0x6, 0x0, PseudoVLOXSEG2EI8_V_M1_MF4 }, // 28
  { Intrinsic::riscv_vloxseg2, 0x8, 0x6, 0x1, PseudoVLOXSEG2EI8_V_M2_MF4 }, // 29
  { Intrinsic::riscv_vloxseg2, 0x8, 0x6, 0x2, PseudoVLOXSEG2EI8_V_M4_MF4 }, // 30
  { Intrinsic::riscv_vloxseg2, 0x8, 0x6, 0x3, PseudoVLOXSEG2EI8_V_M8_MF4 }, // 31
  { Intrinsic::riscv_vloxseg2, 0x8, 0x6, 0x5, PseudoVLOXSEG2EI8_V_MF8_MF4 }, // 32
  { Intrinsic::riscv_vloxseg2, 0x8, 0x6, 0x6, PseudoVLOXSEG2EI8_V_MF4_MF4 }, // 33
  { Intrinsic::riscv_vloxseg2, 0x8, 0x6, 0x7, PseudoVLOXSEG2EI8_V_MF2_MF4 }, // 34
  { Intrinsic::riscv_vloxseg2, 0x8, 0x7, 0x0, PseudoVLOXSEG2EI8_V_M1_MF2 }, // 35
  { Intrinsic::riscv_vloxseg2, 0x8, 0x7, 0x1, PseudoVLOXSEG2EI8_V_M2_MF2 }, // 36
  { Intrinsic::riscv_vloxseg2, 0x8, 0x7, 0x2, PseudoVLOXSEG2EI8_V_M4_MF2 }, // 37
  { Intrinsic::riscv_vloxseg2, 0x8, 0x7, 0x3, PseudoVLOXSEG2EI8_V_M8_MF2 }, // 38
  { Intrinsic::riscv_vloxseg2, 0x8, 0x7, 0x5, PseudoVLOXSEG2EI8_V_MF8_MF2 }, // 39
  { Intrinsic::riscv_vloxseg2, 0x8, 0x7, 0x6, PseudoVLOXSEG2EI8_V_MF4_MF2 }, // 40
  { Intrinsic::riscv_vloxseg2, 0x8, 0x7, 0x7, PseudoVLOXSEG2EI8_V_MF2_MF2 }, // 41
  { Intrinsic::riscv_vloxseg2, 0x10, 0x0, 0x0, PseudoVLOXSEG2EI16_V_M1_M1 }, // 42
  { Intrinsic::riscv_vloxseg2, 0x10, 0x0, 0x1, PseudoVLOXSEG2EI16_V_M2_M1 }, // 43
  { Intrinsic::riscv_vloxseg2, 0x10, 0x0, 0x2, PseudoVLOXSEG2EI16_V_M4_M1 }, // 44
  { Intrinsic::riscv_vloxseg2, 0x10, 0x0, 0x3, PseudoVLOXSEG2EI16_V_M8_M1 }, // 45
  { Intrinsic::riscv_vloxseg2, 0x10, 0x0, 0x6, PseudoVLOXSEG2EI16_V_MF4_M1 }, // 46
  { Intrinsic::riscv_vloxseg2, 0x10, 0x0, 0x7, PseudoVLOXSEG2EI16_V_MF2_M1 }, // 47
  { Intrinsic::riscv_vloxseg2, 0x10, 0x1, 0x0, PseudoVLOXSEG2EI16_V_M1_M2 }, // 48
  { Intrinsic::riscv_vloxseg2, 0x10, 0x1, 0x1, PseudoVLOXSEG2EI16_V_M2_M2 }, // 49
  { Intrinsic::riscv_vloxseg2, 0x10, 0x1, 0x2, PseudoVLOXSEG2EI16_V_M4_M2 }, // 50
  { Intrinsic::riscv_vloxseg2, 0x10, 0x1, 0x3, PseudoVLOXSEG2EI16_V_M8_M2 }, // 51
  { Intrinsic::riscv_vloxseg2, 0x10, 0x1, 0x6, PseudoVLOXSEG2EI16_V_MF4_M2 }, // 52
  { Intrinsic::riscv_vloxseg2, 0x10, 0x1, 0x7, PseudoVLOXSEG2EI16_V_MF2_M2 }, // 53
  { Intrinsic::riscv_vloxseg2, 0x10, 0x2, 0x0, PseudoVLOXSEG2EI16_V_M1_M4 }, // 54
  { Intrinsic::riscv_vloxseg2, 0x10, 0x2, 0x1, PseudoVLOXSEG2EI16_V_M2_M4 }, // 55
  { Intrinsic::riscv_vloxseg2, 0x10, 0x2, 0x2, PseudoVLOXSEG2EI16_V_M4_M4 }, // 56
  { Intrinsic::riscv_vloxseg2, 0x10, 0x2, 0x3, PseudoVLOXSEG2EI16_V_M8_M4 }, // 57
  { Intrinsic::riscv_vloxseg2, 0x10, 0x2, 0x6, PseudoVLOXSEG2EI16_V_MF4_M4 }, // 58
  { Intrinsic::riscv_vloxseg2, 0x10, 0x2, 0x7, PseudoVLOXSEG2EI16_V_MF2_M4 }, // 59
  { Intrinsic::riscv_vloxseg2, 0x10, 0x5, 0x0, PseudoVLOXSEG2EI16_V_M1_MF8 }, // 60
  { Intrinsic::riscv_vloxseg2, 0x10, 0x5, 0x1, PseudoVLOXSEG2EI16_V_M2_MF8 }, // 61
  { Intrinsic::riscv_vloxseg2, 0x10, 0x5, 0x2, PseudoVLOXSEG2EI16_V_M4_MF8 }, // 62
  { Intrinsic::riscv_vloxseg2, 0x10, 0x5, 0x3, PseudoVLOXSEG2EI16_V_M8_MF8 }, // 63
  { Intrinsic::riscv_vloxseg2, 0x10, 0x5, 0x6, PseudoVLOXSEG2EI16_V_MF4_MF8 }, // 64
  { Intrinsic::riscv_vloxseg2, 0x10, 0x5, 0x7, PseudoVLOXSEG2EI16_V_MF2_MF8 }, // 65
  { Intrinsic::riscv_vloxseg2, 0x10, 0x6, 0x0, PseudoVLOXSEG2EI16_V_M1_MF4 }, // 66
  { Intrinsic::riscv_vloxseg2, 0x10, 0x6, 0x1, PseudoVLOXSEG2EI16_V_M2_MF4 }, // 67
  { Intrinsic::riscv_vloxseg2, 0x10, 0x6, 0x2, PseudoVLOXSEG2EI16_V_M4_MF4 }, // 68
  { Intrinsic::riscv_vloxseg2, 0x10, 0x6, 0x3, PseudoVLOXSEG2EI16_V_M8_MF4 }, // 69
  { Intrinsic::riscv_vloxseg2, 0x10, 0x6, 0x6, PseudoVLOXSEG2EI16_V_MF4_MF4 }, // 70
  { Intrinsic::riscv_vloxseg2, 0x10, 0x6, 0x7, PseudoVLOXSEG2EI16_V_MF2_MF4 }, // 71
  { Intrinsic::riscv_vloxseg2, 0x10, 0x7, 0x0, PseudoVLOXSEG2EI16_V_M1_MF2 }, // 72
  { Intrinsic::riscv_vloxseg2, 0x10, 0x7, 0x1, PseudoVLOXSEG2EI16_V_M2_MF2 }, // 73
  { Intrinsic::riscv_vloxseg2, 0x10, 0x7, 0x2, PseudoVLOXSEG2EI16_V_M4_MF2 }, // 74
  { Intrinsic::riscv_vloxseg2, 0x10, 0x7, 0x3, PseudoVLOXSEG2EI16_V_M8_MF2 }, // 75
  { Intrinsic::riscv_vloxseg2, 0x10, 0x7, 0x6, PseudoVLOXSEG2EI16_V_MF4_MF2 }, // 76
  { Intrinsic::riscv_vloxseg2, 0x10, 0x7, 0x7, PseudoVLOXSEG2EI16_V_MF2_MF2 }, // 77
  { Intrinsic::riscv_vloxseg2, 0x20, 0x0, 0x0, PseudoVLOXSEG2EI32_V_M1_M1 }, // 78
  { Intrinsic::riscv_vloxseg2, 0x20, 0x0, 0x1, PseudoVLOXSEG2EI32_V_M2_M1 }, // 79
  { Intrinsic::riscv_vloxseg2, 0x20, 0x0, 0x2, PseudoVLOXSEG2EI32_V_M4_M1 }, // 80
  { Intrinsic::riscv_vloxseg2, 0x20, 0x0, 0x3, PseudoVLOXSEG2EI32_V_M8_M1 }, // 81
  { Intrinsic::riscv_vloxseg2, 0x20, 0x0, 0x7, PseudoVLOXSEG2EI32_V_MF2_M1 }, // 82
  { Intrinsic::riscv_vloxseg2, 0x20, 0x1, 0x0, PseudoVLOXSEG2EI32_V_M1_M2 }, // 83
  { Intrinsic::riscv_vloxseg2, 0x20, 0x1, 0x1, PseudoVLOXSEG2EI32_V_M2_M2 }, // 84
  { Intrinsic::riscv_vloxseg2, 0x20, 0x1, 0x2, PseudoVLOXSEG2EI32_V_M4_M2 }, // 85
  { Intrinsic::riscv_vloxseg2, 0x20, 0x1, 0x3, PseudoVLOXSEG2EI32_V_M8_M2 }, // 86
  { Intrinsic::riscv_vloxseg2, 0x20, 0x1, 0x7, PseudoVLOXSEG2EI32_V_MF2_M2 }, // 87
  { Intrinsic::riscv_vloxseg2, 0x20, 0x2, 0x0, PseudoVLOXSEG2EI32_V_M1_M4 }, // 88
  { Intrinsic::riscv_vloxseg2, 0x20, 0x2, 0x1, PseudoVLOXSEG2EI32_V_M2_M4 }, // 89
  { Intrinsic::riscv_vloxseg2, 0x20, 0x2, 0x2, PseudoVLOXSEG2EI32_V_M4_M4 }, // 90
  { Intrinsic::riscv_vloxseg2, 0x20, 0x2, 0x3, PseudoVLOXSEG2EI32_V_M8_M4 }, // 91
  { Intrinsic::riscv_vloxseg2, 0x20, 0x2, 0x7, PseudoVLOXSEG2EI32_V_MF2_M4 }, // 92
  { Intrinsic::riscv_vloxseg2, 0x20, 0x5, 0x0, PseudoVLOXSEG2EI32_V_M1_MF8 }, // 93
  { Intrinsic::riscv_vloxseg2, 0x20, 0x5, 0x1, PseudoVLOXSEG2EI32_V_M2_MF8 }, // 94
  { Intrinsic::riscv_vloxseg2, 0x20, 0x5, 0x2, PseudoVLOXSEG2EI32_V_M4_MF8 }, // 95
  { Intrinsic::riscv_vloxseg2, 0x20, 0x5, 0x3, PseudoVLOXSEG2EI32_V_M8_MF8 }, // 96
  { Intrinsic::riscv_vloxseg2, 0x20, 0x5, 0x7, PseudoVLOXSEG2EI32_V_MF2_MF8 }, // 97
  { Intrinsic::riscv_vloxseg2, 0x20, 0x6, 0x0, PseudoVLOXSEG2EI32_V_M1_MF4 }, // 98
  { Intrinsic::riscv_vloxseg2, 0x20, 0x6, 0x1, PseudoVLOXSEG2EI32_V_M2_MF4 }, // 99
  { Intrinsic::riscv_vloxseg2, 0x20, 0x6, 0x2, PseudoVLOXSEG2EI32_V_M4_MF4 }, // 100
  { Intrinsic::riscv_vloxseg2, 0x20, 0x6, 0x3, PseudoVLOXSEG2EI32_V_M8_MF4 }, // 101
  { Intrinsic::riscv_vloxseg2, 0x20, 0x6, 0x7, PseudoVLOXSEG2EI32_V_MF2_MF4 }, // 102
  { Intrinsic::riscv_vloxseg2, 0x20, 0x7, 0x0, PseudoVLOXSEG2EI32_V_M1_MF2 }, // 103
  { Intrinsic::riscv_vloxseg2, 0x20, 0x7, 0x1, PseudoVLOXSEG2EI32_V_M2_MF2 }, // 104
  { Intrinsic::riscv_vloxseg2, 0x20, 0x7, 0x2, PseudoVLOXSEG2EI32_V_M4_MF2 }, // 105
  { Intrinsic::riscv_vloxseg2, 0x20, 0x7, 0x3, PseudoVLOXSEG2EI32_V_M8_MF2 }, // 106
  { Intrinsic::riscv_vloxseg2, 0x20, 0x7, 0x7, PseudoVLOXSEG2EI32_V_MF2_MF2 }, // 107
  { Intrinsic::riscv_vloxseg2, 0x40, 0x0, 0x0, PseudoVLOXSEG2EI64_V_M1_M1 }, // 108
  { Intrinsic::riscv_vloxseg2, 0x40, 0x0, 0x1, PseudoVLOXSEG2EI64_V_M2_M1 }, // 109
  { Intrinsic::riscv_vloxseg2, 0x40, 0x0, 0x2, PseudoVLOXSEG2EI64_V_M4_M1 }, // 110
  { Intrinsic::riscv_vloxseg2, 0x40, 0x0, 0x3, PseudoVLOXSEG2EI64_V_M8_M1 }, // 111
  { Intrinsic::riscv_vloxseg2, 0x40, 0x1, 0x0, PseudoVLOXSEG2EI64_V_M1_M2 }, // 112
  { Intrinsic::riscv_vloxseg2, 0x40, 0x1, 0x1, PseudoVLOXSEG2EI64_V_M2_M2 }, // 113
  { Intrinsic::riscv_vloxseg2, 0x40, 0x1, 0x2, PseudoVLOXSEG2EI64_V_M4_M2 }, // 114
  { Intrinsic::riscv_vloxseg2, 0x40, 0x1, 0x3, PseudoVLOXSEG2EI64_V_M8_M2 }, // 115
  { Intrinsic::riscv_vloxseg2, 0x40, 0x2, 0x0, PseudoVLOXSEG2EI64_V_M1_M4 }, // 116
  { Intrinsic::riscv_vloxseg2, 0x40, 0x2, 0x1, PseudoVLOXSEG2EI64_V_M2_M4 }, // 117
  { Intrinsic::riscv_vloxseg2, 0x40, 0x2, 0x2, PseudoVLOXSEG2EI64_V_M4_M4 }, // 118
  { Intrinsic::riscv_vloxseg2, 0x40, 0x2, 0x3, PseudoVLOXSEG2EI64_V_M8_M4 }, // 119
  { Intrinsic::riscv_vloxseg2, 0x40, 0x5, 0x0, PseudoVLOXSEG2EI64_V_M1_MF8 }, // 120
  { Intrinsic::riscv_vloxseg2, 0x40, 0x5, 0x1, PseudoVLOXSEG2EI64_V_M2_MF8 }, // 121
  { Intrinsic::riscv_vloxseg2, 0x40, 0x5, 0x2, PseudoVLOXSEG2EI64_V_M4_MF8 }, // 122
  { Intrinsic::riscv_vloxseg2, 0x40, 0x5, 0x3, PseudoVLOXSEG2EI64_V_M8_MF8 }, // 123
  { Intrinsic::riscv_vloxseg2, 0x40, 0x6, 0x0, PseudoVLOXSEG2EI64_V_M1_MF4 }, // 124
  { Intrinsic::riscv_vloxseg2, 0x40, 0x6, 0x1, PseudoVLOXSEG2EI64_V_M2_MF4 }, // 125
  { Intrinsic::riscv_vloxseg2, 0x40, 0x6, 0x2, PseudoVLOXSEG2EI64_V_M4_MF4 }, // 126
  { Intrinsic::riscv_vloxseg2, 0x40, 0x6, 0x3, PseudoVLOXSEG2EI64_V_M8_MF4 }, // 127
  { Intrinsic::riscv_vloxseg2, 0x40, 0x7, 0x0, PseudoVLOXSEG2EI64_V_M1_MF2 }, // 128
  { Intrinsic::riscv_vloxseg2, 0x40, 0x7, 0x1, PseudoVLOXSEG2EI64_V_M2_MF2 }, // 129
  { Intrinsic::riscv_vloxseg2, 0x40, 0x7, 0x2, PseudoVLOXSEG2EI64_V_M4_MF2 }, // 130
  { Intrinsic::riscv_vloxseg2, 0x40, 0x7, 0x3, PseudoVLOXSEG2EI64_V_M8_MF2 }, // 131
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x0, 0x0, PseudoVLOXSEG2EI8_V_M1_M1_MASK }, // 132
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x0, 0x1, PseudoVLOXSEG2EI8_V_M2_M1_MASK }, // 133
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x0, 0x2, PseudoVLOXSEG2EI8_V_M4_M1_MASK }, // 134
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x0, 0x3, PseudoVLOXSEG2EI8_V_M8_M1_MASK }, // 135
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x0, 0x5, PseudoVLOXSEG2EI8_V_MF8_M1_MASK }, // 136
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x0, 0x6, PseudoVLOXSEG2EI8_V_MF4_M1_MASK }, // 137
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x0, 0x7, PseudoVLOXSEG2EI8_V_MF2_M1_MASK }, // 138
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x1, 0x0, PseudoVLOXSEG2EI8_V_M1_M2_MASK }, // 139
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x1, 0x1, PseudoVLOXSEG2EI8_V_M2_M2_MASK }, // 140
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x1, 0x2, PseudoVLOXSEG2EI8_V_M4_M2_MASK }, // 141
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x1, 0x3, PseudoVLOXSEG2EI8_V_M8_M2_MASK }, // 142
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x1, 0x5, PseudoVLOXSEG2EI8_V_MF8_M2_MASK }, // 143
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x1, 0x6, PseudoVLOXSEG2EI8_V_MF4_M2_MASK }, // 144
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x1, 0x7, PseudoVLOXSEG2EI8_V_MF2_M2_MASK }, // 145
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x2, 0x0, PseudoVLOXSEG2EI8_V_M1_M4_MASK }, // 146
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x2, 0x1, PseudoVLOXSEG2EI8_V_M2_M4_MASK }, // 147
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x2, 0x2, PseudoVLOXSEG2EI8_V_M4_M4_MASK }, // 148
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x2, 0x3, PseudoVLOXSEG2EI8_V_M8_M4_MASK }, // 149
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x2, 0x5, PseudoVLOXSEG2EI8_V_MF8_M4_MASK }, // 150
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x2, 0x6, PseudoVLOXSEG2EI8_V_MF4_M4_MASK }, // 151
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x2, 0x7, PseudoVLOXSEG2EI8_V_MF2_M4_MASK }, // 152
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x5, 0x0, PseudoVLOXSEG2EI8_V_M1_MF8_MASK }, // 153
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x5, 0x1, PseudoVLOXSEG2EI8_V_M2_MF8_MASK }, // 154
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x5, 0x2, PseudoVLOXSEG2EI8_V_M4_MF8_MASK }, // 155
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x5, 0x3, PseudoVLOXSEG2EI8_V_M8_MF8_MASK }, // 156
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x5, 0x5, PseudoVLOXSEG2EI8_V_MF8_MF8_MASK }, // 157
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x5, 0x6, PseudoVLOXSEG2EI8_V_MF4_MF8_MASK }, // 158
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x5, 0x7, PseudoVLOXSEG2EI8_V_MF2_MF8_MASK }, // 159
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x6, 0x0, PseudoVLOXSEG2EI8_V_M1_MF4_MASK }, // 160
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x6, 0x1, PseudoVLOXSEG2EI8_V_M2_MF4_MASK }, // 161
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x6, 0x2, PseudoVLOXSEG2EI8_V_M4_MF4_MASK }, // 162
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x6, 0x3, PseudoVLOXSEG2EI8_V_M8_MF4_MASK }, // 163
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x6, 0x5, PseudoVLOXSEG2EI8_V_MF8_MF4_MASK }, // 164
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x6, 0x6, PseudoVLOXSEG2EI8_V_MF4_MF4_MASK }, // 165
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x6, 0x7, PseudoVLOXSEG2EI8_V_MF2_MF4_MASK }, // 166
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x7, 0x0, PseudoVLOXSEG2EI8_V_M1_MF2_MASK }, // 167
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x7, 0x1, PseudoVLOXSEG2EI8_V_M2_MF2_MASK }, // 168
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x7, 0x2, PseudoVLOXSEG2EI8_V_M4_MF2_MASK }, // 169
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x7, 0x3, PseudoVLOXSEG2EI8_V_M8_MF2_MASK }, // 170
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x7, 0x5, PseudoVLOXSEG2EI8_V_MF8_MF2_MASK }, // 171
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x7, 0x6, PseudoVLOXSEG2EI8_V_MF4_MF2_MASK }, // 172
  { Intrinsic::riscv_vloxseg2_mask, 0x8, 0x7, 0x7, PseudoVLOXSEG2EI8_V_MF2_MF2_MASK }, // 173
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x0, 0x0, PseudoVLOXSEG2EI16_V_M1_M1_MASK }, // 174
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x0, 0x1, PseudoVLOXSEG2EI16_V_M2_M1_MASK }, // 175
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x0, 0x2, PseudoVLOXSEG2EI16_V_M4_M1_MASK }, // 176
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x0, 0x3, PseudoVLOXSEG2EI16_V_M8_M1_MASK }, // 177
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x0, 0x6, PseudoVLOXSEG2EI16_V_MF4_M1_MASK }, // 178
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x0, 0x7, PseudoVLOXSEG2EI16_V_MF2_M1_MASK }, // 179
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x1, 0x0, PseudoVLOXSEG2EI16_V_M1_M2_MASK }, // 180
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x1, 0x1, PseudoVLOXSEG2EI16_V_M2_M2_MASK }, // 181
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x1, 0x2, PseudoVLOXSEG2EI16_V_M4_M2_MASK }, // 182
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x1, 0x3, PseudoVLOXSEG2EI16_V_M8_M2_MASK }, // 183
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x1, 0x6, PseudoVLOXSEG2EI16_V_MF4_M2_MASK }, // 184
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x1, 0x7, PseudoVLOXSEG2EI16_V_MF2_M2_MASK }, // 185
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x2, 0x0, PseudoVLOXSEG2EI16_V_M1_M4_MASK }, // 186
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x2, 0x1, PseudoVLOXSEG2EI16_V_M2_M4_MASK }, // 187
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x2, 0x2, PseudoVLOXSEG2EI16_V_M4_M4_MASK }, // 188
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x2, 0x3, PseudoVLOXSEG2EI16_V_M8_M4_MASK }, // 189
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x2, 0x6, PseudoVLOXSEG2EI16_V_MF4_M4_MASK }, // 190
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x2, 0x7, PseudoVLOXSEG2EI16_V_MF2_M4_MASK }, // 191
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x5, 0x0, PseudoVLOXSEG2EI16_V_M1_MF8_MASK }, // 192
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x5, 0x1, PseudoVLOXSEG2EI16_V_M2_MF8_MASK }, // 193
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x5, 0x2, PseudoVLOXSEG2EI16_V_M4_MF8_MASK }, // 194
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x5, 0x3, PseudoVLOXSEG2EI16_V_M8_MF8_MASK }, // 195
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x5, 0x6, PseudoVLOXSEG2EI16_V_MF4_MF8_MASK }, // 196
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x5, 0x7, PseudoVLOXSEG2EI16_V_MF2_MF8_MASK }, // 197
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x6, 0x0, PseudoVLOXSEG2EI16_V_M1_MF4_MASK }, // 198
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x6, 0x1, PseudoVLOXSEG2EI16_V_M2_MF4_MASK }, // 199
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x6, 0x2, PseudoVLOXSEG2EI16_V_M4_MF4_MASK }, // 200
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x6, 0x3, PseudoVLOXSEG2EI16_V_M8_MF4_MASK }, // 201
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x6, 0x6, PseudoVLOXSEG2EI16_V_MF4_MF4_MASK }, // 202
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x6, 0x7, PseudoVLOXSEG2EI16_V_MF2_MF4_MASK }, // 203
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x7, 0x0, PseudoVLOXSEG2EI16_V_M1_MF2_MASK }, // 204
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x7, 0x1, PseudoVLOXSEG2EI16_V_M2_MF2_MASK }, // 205
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x7, 0x2, PseudoVLOXSEG2EI16_V_M4_MF2_MASK }, // 206
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x7, 0x3, PseudoVLOXSEG2EI16_V_M8_MF2_MASK }, // 207
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x7, 0x6, PseudoVLOXSEG2EI16_V_MF4_MF2_MASK }, // 208
  { Intrinsic::riscv_vloxseg2_mask, 0x10, 0x7, 0x7, PseudoVLOXSEG2EI16_V_MF2_MF2_MASK }, // 209
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x0, 0x0, PseudoVLOXSEG2EI32_V_M1_M1_MASK }, // 210
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x0, 0x1, PseudoVLOXSEG2EI32_V_M2_M1_MASK }, // 211
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x0, 0x2, PseudoVLOXSEG2EI32_V_M4_M1_MASK }, // 212
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x0, 0x3, PseudoVLOXSEG2EI32_V_M8_M1_MASK }, // 213
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x0, 0x7, PseudoVLOXSEG2EI32_V_MF2_M1_MASK }, // 214
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x1, 0x0, PseudoVLOXSEG2EI32_V_M1_M2_MASK }, // 215
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x1, 0x1, PseudoVLOXSEG2EI32_V_M2_M2_MASK }, // 216
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x1, 0x2, PseudoVLOXSEG2EI32_V_M4_M2_MASK }, // 217
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x1, 0x3, PseudoVLOXSEG2EI32_V_M8_M2_MASK }, // 218
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x1, 0x7, PseudoVLOXSEG2EI32_V_MF2_M2_MASK }, // 219
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x2, 0x0, PseudoVLOXSEG2EI32_V_M1_M4_MASK }, // 220
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x2, 0x1, PseudoVLOXSEG2EI32_V_M2_M4_MASK }, // 221
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x2, 0x2, PseudoVLOXSEG2EI32_V_M4_M4_MASK }, // 222
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x2, 0x3, PseudoVLOXSEG2EI32_V_M8_M4_MASK }, // 223
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x2, 0x7, PseudoVLOXSEG2EI32_V_MF2_M4_MASK }, // 224
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x5, 0x0, PseudoVLOXSEG2EI32_V_M1_MF8_MASK }, // 225
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x5, 0x1, PseudoVLOXSEG2EI32_V_M2_MF8_MASK }, // 226
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x5, 0x2, PseudoVLOXSEG2EI32_V_M4_MF8_MASK }, // 227
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x5, 0x3, PseudoVLOXSEG2EI32_V_M8_MF8_MASK }, // 228
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x5, 0x7, PseudoVLOXSEG2EI32_V_MF2_MF8_MASK }, // 229
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x6, 0x0, PseudoVLOXSEG2EI32_V_M1_MF4_MASK }, // 230
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x6, 0x1, PseudoVLOXSEG2EI32_V_M2_MF4_MASK }, // 231
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x6, 0x2, PseudoVLOXSEG2EI32_V_M4_MF4_MASK }, // 232
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x6, 0x3, PseudoVLOXSEG2EI32_V_M8_MF4_MASK }, // 233
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x6, 0x7, PseudoVLOXSEG2EI32_V_MF2_MF4_MASK }, // 234
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x7, 0x0, PseudoVLOXSEG2EI32_V_M1_MF2_MASK }, // 235
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x7, 0x1, PseudoVLOXSEG2EI32_V_M2_MF2_MASK }, // 236
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x7, 0x2, PseudoVLOXSEG2EI32_V_M4_MF2_MASK }, // 237
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x7, 0x3, PseudoVLOXSEG2EI32_V_M8_MF2_MASK }, // 238
  { Intrinsic::riscv_vloxseg2_mask, 0x20, 0x7, 0x7, PseudoVLOXSEG2EI32_V_MF2_MF2_MASK }, // 239
  { Intrinsic::riscv_vloxseg2_mask, 0x40, 0x0, 0x0, PseudoVLOXSEG2EI64_V_M1_M1_MASK }, // 240
  { Intrinsic::riscv_vloxseg2_mask, 0x40, 0x0, 0x1, PseudoVLOXSEG2EI64_V_M2_M1_MASK }, // 241
  { Intrinsic::riscv_vloxseg2_mask, 0x40, 0x0, 0x2, PseudoVLOXSEG2EI64_V_M4_M1_MASK }, // 242
  { Intrinsic::riscv_vloxseg2_mask, 0x40, 0x0, 0x3, PseudoVLOXSEG2EI64_V_M8_M1_MASK }, // 243
  { Intrinsic::riscv_vloxseg2_mask, 0x40, 0x1, 0x0, PseudoVLOXSEG2EI64_V_M1_M2_MASK }, // 244
  { Intrinsic::riscv_vloxseg2_mask, 0x40, 0x1, 0x1, PseudoVLOXSEG2EI64_V_M2_M2_MASK }, // 245
  { Intrinsic::riscv_vloxseg2_mask, 0x40, 0x1, 0x2, PseudoVLOXSEG2EI64_V_M4_M2_MASK }, // 246
  { Intrinsic::riscv_vloxseg2_mask, 0x40, 0x1, 0x3, PseudoVLOXSEG2EI64_V_M8_M2_MASK }, // 247
  { Intrinsic::riscv_vloxseg2_mask, 0x40, 0x2, 0x0, PseudoVLOXSEG2EI64_V_M1_M4_MASK }, // 248
  { Intrinsic::riscv_vloxseg2_mask, 0x40, 0x2, 0x1, PseudoVLOXSEG2EI64_V_M2_M4_MASK }, // 249
  { Intrinsic::riscv_vloxseg2_mask, 0x40, 0x2, 0x2, PseudoVLOXSEG2EI64_V_M4_M4_MASK }, // 250
  { Intrinsic::riscv_vloxseg2_mask, 0x40, 0x2, 0x3, PseudoVLOXSEG2EI64_V_M8_M4_MASK }, // 251
  { Intrinsic::riscv_vloxseg2_mask, 0x40, 0x5, 0x0, PseudoVLOXSEG2EI64_V_M1_MF8_MASK }, // 252
  { Intrinsic::riscv_vloxseg2_mask, 0x40, 0x5, 0x1, PseudoVLOXSEG2EI64_V_M2_MF8_MASK }, // 253
  { Intrinsic::riscv_vloxseg2_mask, 0x40, 0x5, 0x2, PseudoVLOXSEG2EI64_V_M4_MF8_MASK }, // 254
  { Intrinsic::riscv_vloxseg2_mask, 0x40, 0x5, 0x3, PseudoVLOXSEG2EI64_V_M8_MF8_MASK }, // 255
  { Intrinsic::riscv_vloxseg2_mask, 0x40, 0x6, 0x0, PseudoVLOXSEG2EI64_V_M1_MF4_MASK }, // 256
  { Intrinsic::riscv_vloxseg2_mask, 0x40, 0x6, 0x1, PseudoVLOXSEG2EI64_V_M2_MF4_MASK }, // 257
  { Intrinsic::riscv_vloxseg2_mask, 0x40, 0x6, 0x2, PseudoVLOXSEG2EI64_V_M4_MF4_MASK }, // 258
  { Intrinsic::riscv_vloxseg2_mask, 0x40, 0x6, 0x3, PseudoVLOXSEG2EI64_V_M8_MF4_MASK }, // 259
  { Intrinsic::riscv_vloxseg2_mask, 0x40, 0x7, 0x0, PseudoVLOXSEG2EI64_V_M1_MF2_MASK }, // 260
  { Intrinsic::riscv_vloxseg2_mask, 0x40, 0x7, 0x1, PseudoVLOXSEG2EI64_V_M2_MF2_MASK }, // 261
  { Intrinsic::riscv_vloxseg2_mask, 0x40, 0x7, 0x2, PseudoVLOXSEG2EI64_V_M4_MF2_MASK }, // 262
  { Intrinsic::riscv_vloxseg2_mask, 0x40, 0x7, 0x3, PseudoVLOXSEG2EI64_V_M8_MF2_MASK }, // 263
  { Intrinsic::riscv_vloxseg3, 0x8, 0x0, 0x0, PseudoVLOXSEG3EI8_V_M1_M1 }, // 264
  { Intrinsic::riscv_vloxseg3, 0x8, 0x0, 0x1, PseudoVLOXSEG3EI8_V_M2_M1 }, // 265
  { Intrinsic::riscv_vloxseg3, 0x8, 0x0, 0x2, PseudoVLOXSEG3EI8_V_M4_M1 }, // 266
  { Intrinsic::riscv_vloxseg3, 0x8, 0x0, 0x3, PseudoVLOXSEG3EI8_V_M8_M1 }, // 267
  { Intrinsic::riscv_vloxseg3, 0x8, 0x0, 0x5, PseudoVLOXSEG3EI8_V_MF8_M1 }, // 268
  { Intrinsic::riscv_vloxseg3, 0x8, 0x0, 0x6, PseudoVLOXSEG3EI8_V_MF4_M1 }, // 269
  { Intrinsic::riscv_vloxseg3, 0x8, 0x0, 0x7, PseudoVLOXSEG3EI8_V_MF2_M1 }, // 270
  { Intrinsic::riscv_vloxseg3, 0x8, 0x1, 0x0, PseudoVLOXSEG3EI8_V_M1_M2 }, // 271
  { Intrinsic::riscv_vloxseg3, 0x8, 0x1, 0x1, PseudoVLOXSEG3EI8_V_M2_M2 }, // 272
  { Intrinsic::riscv_vloxseg3, 0x8, 0x1, 0x2, PseudoVLOXSEG3EI8_V_M4_M2 }, // 273
  { Intrinsic::riscv_vloxseg3, 0x8, 0x1, 0x3, PseudoVLOXSEG3EI8_V_M8_M2 }, // 274
  { Intrinsic::riscv_vloxseg3, 0x8, 0x1, 0x5, PseudoVLOXSEG3EI8_V_MF8_M2 }, // 275
  { Intrinsic::riscv_vloxseg3, 0x8, 0x1, 0x6, PseudoVLOXSEG3EI8_V_MF4_M2 }, // 276
  { Intrinsic::riscv_vloxseg3, 0x8, 0x1, 0x7, PseudoVLOXSEG3EI8_V_MF2_M2 }, // 277
  { Intrinsic::riscv_vloxseg3, 0x8, 0x5, 0x0, PseudoVLOXSEG3EI8_V_M1_MF8 }, // 278
  { Intrinsic::riscv_vloxseg3, 0x8, 0x5, 0x1, PseudoVLOXSEG3EI8_V_M2_MF8 }, // 279
  { Intrinsic::riscv_vloxseg3, 0x8, 0x5, 0x2, PseudoVLOXSEG3EI8_V_M4_MF8 }, // 280
  { Intrinsic::riscv_vloxseg3, 0x8, 0x5, 0x3, PseudoVLOXSEG3EI8_V_M8_MF8 }, // 281
  { Intrinsic::riscv_vloxseg3, 0x8, 0x5, 0x5, PseudoVLOXSEG3EI8_V_MF8_MF8 }, // 282
  { Intrinsic::riscv_vloxseg3, 0x8, 0x5, 0x6, PseudoVLOXSEG3EI8_V_MF4_MF8 }, // 283
  { Intrinsic::riscv_vloxseg3, 0x8, 0x5, 0x7, PseudoVLOXSEG3EI8_V_MF2_MF8 }, // 284
  { Intrinsic::riscv_vloxseg3, 0x8, 0x6, 0x0, PseudoVLOXSEG3EI8_V_M1_MF4 }, // 285
  { Intrinsic::riscv_vloxseg3, 0x8, 0x6, 0x1, PseudoVLOXSEG3EI8_V_M2_MF4 }, // 286
  { Intrinsic::riscv_vloxseg3, 0x8, 0x6, 0x2, PseudoVLOXSEG3EI8_V_M4_MF4 }, // 287
  { Intrinsic::riscv_vloxseg3, 0x8, 0x6, 0x3, PseudoVLOXSEG3EI8_V_M8_MF4 }, // 288
  { Intrinsic::riscv_vloxseg3, 0x8, 0x6, 0x5, PseudoVLOXSEG3EI8_V_MF8_MF4 }, // 289
  { Intrinsic::riscv_vloxseg3, 0x8, 0x6, 0x6, PseudoVLOXSEG3EI8_V_MF4_MF4 }, // 290
  { Intrinsic::riscv_vloxseg3, 0x8, 0x6, 0x7, PseudoVLOXSEG3EI8_V_MF2_MF4 }, // 291
  { Intrinsic::riscv_vloxseg3, 0x8, 0x7, 0x0, PseudoVLOXSEG3EI8_V_M1_MF2 }, // 292
  { Intrinsic::riscv_vloxseg3, 0x8, 0x7, 0x1, PseudoVLOXSEG3EI8_V_M2_MF2 }, // 293
  { Intrinsic::riscv_vloxseg3, 0x8, 0x7, 0x2, PseudoVLOXSEG3EI8_V_M4_MF2 }, // 294
  { Intrinsic::riscv_vloxseg3, 0x8, 0x7, 0x3, PseudoVLOXSEG3EI8_V_M8_MF2 }, // 295
  { Intrinsic::riscv_vloxseg3, 0x8, 0x7, 0x5, PseudoVLOXSEG3EI8_V_MF8_MF2 }, // 296
  { Intrinsic::riscv_vloxseg3, 0x8, 0x7, 0x6, PseudoVLOXSEG3EI8_V_MF4_MF2 }, // 297
  { Intrinsic::riscv_vloxseg3, 0x8, 0x7, 0x7, PseudoVLOXSEG3EI8_V_MF2_MF2 }, // 298
  { Intrinsic::riscv_vloxseg3, 0x10, 0x0, 0x0, PseudoVLOXSEG3EI16_V_M1_M1 }, // 299
  { Intrinsic::riscv_vloxseg3, 0x10, 0x0, 0x1, PseudoVLOXSEG3EI16_V_M2_M1 }, // 300
  { Intrinsic::riscv_vloxseg3, 0x10, 0x0, 0x2, PseudoVLOXSEG3EI16_V_M4_M1 }, // 301
  { Intrinsic::riscv_vloxseg3, 0x10, 0x0, 0x3, PseudoVLOXSEG3EI16_V_M8_M1 }, // 302
  { Intrinsic::riscv_vloxseg3, 0x10, 0x0, 0x6, PseudoVLOXSEG3EI16_V_MF4_M1 }, // 303
  { Intrinsic::riscv_vloxseg3, 0x10, 0x0, 0x7, PseudoVLOXSEG3EI16_V_MF2_M1 }, // 304
  { Intrinsic::riscv_vloxseg3, 0x10, 0x1, 0x0, PseudoVLOXSEG3EI16_V_M1_M2 }, // 305
  { Intrinsic::riscv_vloxseg3, 0x10, 0x1, 0x1, PseudoVLOXSEG3EI16_V_M2_M2 }, // 306
  { Intrinsic::riscv_vloxseg3, 0x10, 0x1, 0x2, PseudoVLOXSEG3EI16_V_M4_M2 }, // 307
  { Intrinsic::riscv_vloxseg3, 0x10, 0x1, 0x3, PseudoVLOXSEG3EI16_V_M8_M2 }, // 308
  { Intrinsic::riscv_vloxseg3, 0x10, 0x1, 0x6, PseudoVLOXSEG3EI16_V_MF4_M2 }, // 309
  { Intrinsic::riscv_vloxseg3, 0x10, 0x1, 0x7, PseudoVLOXSEG3EI16_V_MF2_M2 }, // 310
  { Intrinsic::riscv_vloxseg3, 0x10, 0x5, 0x0, PseudoVLOXSEG3EI16_V_M1_MF8 }, // 311
  { Intrinsic::riscv_vloxseg3, 0x10, 0x5, 0x1, PseudoVLOXSEG3EI16_V_M2_MF8 }, // 312
  { Intrinsic::riscv_vloxseg3, 0x10, 0x5, 0x2, PseudoVLOXSEG3EI16_V_M4_MF8 }, // 313
  { Intrinsic::riscv_vloxseg3, 0x10, 0x5, 0x3, PseudoVLOXSEG3EI16_V_M8_MF8 }, // 314
  { Intrinsic::riscv_vloxseg3, 0x10, 0x5, 0x6, PseudoVLOXSEG3EI16_V_MF4_MF8 }, // 315
  { Intrinsic::riscv_vloxseg3, 0x10, 0x5, 0x7, PseudoVLOXSEG3EI16_V_MF2_MF8 }, // 316
  { Intrinsic::riscv_vloxseg3, 0x10, 0x6, 0x0, PseudoVLOXSEG3EI16_V_M1_MF4 }, // 317
  { Intrinsic::riscv_vloxseg3, 0x10, 0x6, 0x1, PseudoVLOXSEG3EI16_V_M2_MF4 }, // 318
  { Intrinsic::riscv_vloxseg3, 0x10, 0x6, 0x2, PseudoVLOXSEG3EI16_V_M4_MF4 }, // 319
  { Intrinsic::riscv_vloxseg3, 0x10, 0x6, 0x3, PseudoVLOXSEG3EI16_V_M8_MF4 }, // 320
  { Intrinsic::riscv_vloxseg3, 0x10, 0x6, 0x6, PseudoVLOXSEG3EI16_V_MF4_MF4 }, // 321
  { Intrinsic::riscv_vloxseg3, 0x10, 0x6, 0x7, PseudoVLOXSEG3EI16_V_MF2_MF4 }, // 322
  { Intrinsic::riscv_vloxseg3, 0x10, 0x7, 0x0, PseudoVLOXSEG3EI16_V_M1_MF2 }, // 323
  { Intrinsic::riscv_vloxseg3, 0x10, 0x7, 0x1, PseudoVLOXSEG3EI16_V_M2_MF2 }, // 324
  { Intrinsic::riscv_vloxseg3, 0x10, 0x7, 0x2, PseudoVLOXSEG3EI16_V_M4_MF2 }, // 325
  { Intrinsic::riscv_vloxseg3, 0x10, 0x7, 0x3, PseudoVLOXSEG3EI16_V_M8_MF2 }, // 326
  { Intrinsic::riscv_vloxseg3, 0x10, 0x7, 0x6, PseudoVLOXSEG3EI16_V_MF4_MF2 }, // 327
  { Intrinsic::riscv_vloxseg3, 0x10, 0x7, 0x7, PseudoVLOXSEG3EI16_V_MF2_MF2 }, // 328
  { Intrinsic::riscv_vloxseg3, 0x20, 0x0, 0x0, PseudoVLOXSEG3EI32_V_M1_M1 }, // 329
  { Intrinsic::riscv_vloxseg3, 0x20, 0x0, 0x1, PseudoVLOXSEG3EI32_V_M2_M1 }, // 330
  { Intrinsic::riscv_vloxseg3, 0x20, 0x0, 0x2, PseudoVLOXSEG3EI32_V_M4_M1 }, // 331
  { Intrinsic::riscv_vloxseg3, 0x20, 0x0, 0x3, PseudoVLOXSEG3EI32_V_M8_M1 }, // 332
  { Intrinsic::riscv_vloxseg3, 0x20, 0x0, 0x7, PseudoVLOXSEG3EI32_V_MF2_M1 }, // 333
  { Intrinsic::riscv_vloxseg3, 0x20, 0x1, 0x0, PseudoVLOXSEG3EI32_V_M1_M2 }, // 334
  { Intrinsic::riscv_vloxseg3, 0x20, 0x1, 0x1, PseudoVLOXSEG3EI32_V_M2_M2 }, // 335
  { Intrinsic::riscv_vloxseg3, 0x20, 0x1, 0x2, PseudoVLOXSEG3EI32_V_M4_M2 }, // 336
  { Intrinsic::riscv_vloxseg3, 0x20, 0x1, 0x3, PseudoVLOXSEG3EI32_V_M8_M2 }, // 337
  { Intrinsic::riscv_vloxseg3, 0x20, 0x1, 0x7, PseudoVLOXSEG3EI32_V_MF2_M2 }, // 338
  { Intrinsic::riscv_vloxseg3, 0x20, 0x5, 0x0, PseudoVLOXSEG3EI32_V_M1_MF8 }, // 339
  { Intrinsic::riscv_vloxseg3, 0x20, 0x5, 0x1, PseudoVLOXSEG3EI32_V_M2_MF8 }, // 340
  { Intrinsic::riscv_vloxseg3, 0x20, 0x5, 0x2, PseudoVLOXSEG3EI32_V_M4_MF8 }, // 341
  { Intrinsic::riscv_vloxseg3, 0x20, 0x5, 0x3, PseudoVLOXSEG3EI32_V_M8_MF8 }, // 342
  { Intrinsic::riscv_vloxseg3, 0x20, 0x5, 0x7, PseudoVLOXSEG3EI32_V_MF2_MF8 }, // 343
  { Intrinsic::riscv_vloxseg3, 0x20, 0x6, 0x0, PseudoVLOXSEG3EI32_V_M1_MF4 }, // 344
  { Intrinsic::riscv_vloxseg3, 0x20, 0x6, 0x1, PseudoVLOXSEG3EI32_V_M2_MF4 }, // 345
  { Intrinsic::riscv_vloxseg3, 0x20, 0x6, 0x2, PseudoVLOXSEG3EI32_V_M4_MF4 }, // 346
  { Intrinsic::riscv_vloxseg3, 0x20, 0x6, 0x3, PseudoVLOXSEG3EI32_V_M8_MF4 }, // 347
  { Intrinsic::riscv_vloxseg3, 0x20, 0x6, 0x7, PseudoVLOXSEG3EI32_V_MF2_MF4 }, // 348
  { Intrinsic::riscv_vloxseg3, 0x20, 0x7, 0x0, PseudoVLOXSEG3EI32_V_M1_MF2 }, // 349
  { Intrinsic::riscv_vloxseg3, 0x20, 0x7, 0x1, PseudoVLOXSEG3EI32_V_M2_MF2 }, // 350
  { Intrinsic::riscv_vloxseg3, 0x20, 0x7, 0x2, PseudoVLOXSEG3EI32_V_M4_MF2 }, // 351
  { Intrinsic::riscv_vloxseg3, 0x20, 0x7, 0x3, PseudoVLOXSEG3EI32_V_M8_MF2 }, // 352
  { Intrinsic::riscv_vloxseg3, 0x20, 0x7, 0x7, PseudoVLOXSEG3EI32_V_MF2_MF2 }, // 353
  { Intrinsic::riscv_vloxseg3, 0x40, 0x0, 0x0, PseudoVLOXSEG3EI64_V_M1_M1 }, // 354
  { Intrinsic::riscv_vloxseg3, 0x40, 0x0, 0x1, PseudoVLOXSEG3EI64_V_M2_M1 }, // 355
  { Intrinsic::riscv_vloxseg3, 0x40, 0x0, 0x2, PseudoVLOXSEG3EI64_V_M4_M1 }, // 356
  { Intrinsic::riscv_vloxseg3, 0x40, 0x0, 0x3, PseudoVLOXSEG3EI64_V_M8_M1 }, // 357
  { Intrinsic::riscv_vloxseg3, 0x40, 0x1, 0x0, PseudoVLOXSEG3EI64_V_M1_M2 }, // 358
  { Intrinsic::riscv_vloxseg3, 0x40, 0x1, 0x1, PseudoVLOXSEG3EI64_V_M2_M2 }, // 359
  { Intrinsic::riscv_vloxseg3, 0x40, 0x1, 0x2, PseudoVLOXSEG3EI64_V_M4_M2 }, // 360
  { Intrinsic::riscv_vloxseg3, 0x40, 0x1, 0x3, PseudoVLOXSEG3EI64_V_M8_M2 }, // 361
  { Intrinsic::riscv_vloxseg3, 0x40, 0x5, 0x0, PseudoVLOXSEG3EI64_V_M1_MF8 }, // 362
  { Intrinsic::riscv_vloxseg3, 0x40, 0x5, 0x1, PseudoVLOXSEG3EI64_V_M2_MF8 }, // 363
  { Intrinsic::riscv_vloxseg3, 0x40, 0x5, 0x2, PseudoVLOXSEG3EI64_V_M4_MF8 }, // 364
  { Intrinsic::riscv_vloxseg3, 0x40, 0x5, 0x3, PseudoVLOXSEG3EI64_V_M8_MF8 }, // 365
  { Intrinsic::riscv_vloxseg3, 0x40, 0x6, 0x0, PseudoVLOXSEG3EI64_V_M1_MF4 }, // 366
  { Intrinsic::riscv_vloxseg3, 0x40, 0x6, 0x1, PseudoVLOXSEG3EI64_V_M2_MF4 }, // 367
  { Intrinsic::riscv_vloxseg3, 0x40, 0x6, 0x2, PseudoVLOXSEG3EI64_V_M4_MF4 }, // 368
  { Intrinsic::riscv_vloxseg3, 0x40, 0x6, 0x3, PseudoVLOXSEG3EI64_V_M8_MF4 }, // 369
  { Intrinsic::riscv_vloxseg3, 0x40, 0x7, 0x0, PseudoVLOXSEG3EI64_V_M1_MF2 }, // 370
  { Intrinsic::riscv_vloxseg3, 0x40, 0x7, 0x1, PseudoVLOXSEG3EI64_V_M2_MF2 }, // 371
  { Intrinsic::riscv_vloxseg3, 0x40, 0x7, 0x2, PseudoVLOXSEG3EI64_V_M4_MF2 }, // 372
  { Intrinsic::riscv_vloxseg3, 0x40, 0x7, 0x3, PseudoVLOXSEG3EI64_V_M8_MF2 }, // 373
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x0, 0x0, PseudoVLOXSEG3EI8_V_M1_M1_MASK }, // 374
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x0, 0x1, PseudoVLOXSEG3EI8_V_M2_M1_MASK }, // 375
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x0, 0x2, PseudoVLOXSEG3EI8_V_M4_M1_MASK }, // 376
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x0, 0x3, PseudoVLOXSEG3EI8_V_M8_M1_MASK }, // 377
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x0, 0x5, PseudoVLOXSEG3EI8_V_MF8_M1_MASK }, // 378
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x0, 0x6, PseudoVLOXSEG3EI8_V_MF4_M1_MASK }, // 379
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x0, 0x7, PseudoVLOXSEG3EI8_V_MF2_M1_MASK }, // 380
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x1, 0x0, PseudoVLOXSEG3EI8_V_M1_M2_MASK }, // 381
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x1, 0x1, PseudoVLOXSEG3EI8_V_M2_M2_MASK }, // 382
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x1, 0x2, PseudoVLOXSEG3EI8_V_M4_M2_MASK }, // 383
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x1, 0x3, PseudoVLOXSEG3EI8_V_M8_M2_MASK }, // 384
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x1, 0x5, PseudoVLOXSEG3EI8_V_MF8_M2_MASK }, // 385
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x1, 0x6, PseudoVLOXSEG3EI8_V_MF4_M2_MASK }, // 386
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x1, 0x7, PseudoVLOXSEG3EI8_V_MF2_M2_MASK }, // 387
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x5, 0x0, PseudoVLOXSEG3EI8_V_M1_MF8_MASK }, // 388
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x5, 0x1, PseudoVLOXSEG3EI8_V_M2_MF8_MASK }, // 389
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x5, 0x2, PseudoVLOXSEG3EI8_V_M4_MF8_MASK }, // 390
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x5, 0x3, PseudoVLOXSEG3EI8_V_M8_MF8_MASK }, // 391
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x5, 0x5, PseudoVLOXSEG3EI8_V_MF8_MF8_MASK }, // 392
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x5, 0x6, PseudoVLOXSEG3EI8_V_MF4_MF8_MASK }, // 393
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x5, 0x7, PseudoVLOXSEG3EI8_V_MF2_MF8_MASK }, // 394
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x6, 0x0, PseudoVLOXSEG3EI8_V_M1_MF4_MASK }, // 395
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x6, 0x1, PseudoVLOXSEG3EI8_V_M2_MF4_MASK }, // 396
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x6, 0x2, PseudoVLOXSEG3EI8_V_M4_MF4_MASK }, // 397
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x6, 0x3, PseudoVLOXSEG3EI8_V_M8_MF4_MASK }, // 398
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x6, 0x5, PseudoVLOXSEG3EI8_V_MF8_MF4_MASK }, // 399
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x6, 0x6, PseudoVLOXSEG3EI8_V_MF4_MF4_MASK }, // 400
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x6, 0x7, PseudoVLOXSEG3EI8_V_MF2_MF4_MASK }, // 401
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x7, 0x0, PseudoVLOXSEG3EI8_V_M1_MF2_MASK }, // 402
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x7, 0x1, PseudoVLOXSEG3EI8_V_M2_MF2_MASK }, // 403
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x7, 0x2, PseudoVLOXSEG3EI8_V_M4_MF2_MASK }, // 404
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x7, 0x3, PseudoVLOXSEG3EI8_V_M8_MF2_MASK }, // 405
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x7, 0x5, PseudoVLOXSEG3EI8_V_MF8_MF2_MASK }, // 406
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x7, 0x6, PseudoVLOXSEG3EI8_V_MF4_MF2_MASK }, // 407
  { Intrinsic::riscv_vloxseg3_mask, 0x8, 0x7, 0x7, PseudoVLOXSEG3EI8_V_MF2_MF2_MASK }, // 408
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x0, 0x0, PseudoVLOXSEG3EI16_V_M1_M1_MASK }, // 409
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x0, 0x1, PseudoVLOXSEG3EI16_V_M2_M1_MASK }, // 410
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x0, 0x2, PseudoVLOXSEG3EI16_V_M4_M1_MASK }, // 411
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x0, 0x3, PseudoVLOXSEG3EI16_V_M8_M1_MASK }, // 412
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x0, 0x6, PseudoVLOXSEG3EI16_V_MF4_M1_MASK }, // 413
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x0, 0x7, PseudoVLOXSEG3EI16_V_MF2_M1_MASK }, // 414
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x1, 0x0, PseudoVLOXSEG3EI16_V_M1_M2_MASK }, // 415
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x1, 0x1, PseudoVLOXSEG3EI16_V_M2_M2_MASK }, // 416
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x1, 0x2, PseudoVLOXSEG3EI16_V_M4_M2_MASK }, // 417
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x1, 0x3, PseudoVLOXSEG3EI16_V_M8_M2_MASK }, // 418
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x1, 0x6, PseudoVLOXSEG3EI16_V_MF4_M2_MASK }, // 419
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x1, 0x7, PseudoVLOXSEG3EI16_V_MF2_M2_MASK }, // 420
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x5, 0x0, PseudoVLOXSEG3EI16_V_M1_MF8_MASK }, // 421
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x5, 0x1, PseudoVLOXSEG3EI16_V_M2_MF8_MASK }, // 422
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x5, 0x2, PseudoVLOXSEG3EI16_V_M4_MF8_MASK }, // 423
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x5, 0x3, PseudoVLOXSEG3EI16_V_M8_MF8_MASK }, // 424
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x5, 0x6, PseudoVLOXSEG3EI16_V_MF4_MF8_MASK }, // 425
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x5, 0x7, PseudoVLOXSEG3EI16_V_MF2_MF8_MASK }, // 426
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x6, 0x0, PseudoVLOXSEG3EI16_V_M1_MF4_MASK }, // 427
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x6, 0x1, PseudoVLOXSEG3EI16_V_M2_MF4_MASK }, // 428
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x6, 0x2, PseudoVLOXSEG3EI16_V_M4_MF4_MASK }, // 429
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x6, 0x3, PseudoVLOXSEG3EI16_V_M8_MF4_MASK }, // 430
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x6, 0x6, PseudoVLOXSEG3EI16_V_MF4_MF4_MASK }, // 431
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x6, 0x7, PseudoVLOXSEG3EI16_V_MF2_MF4_MASK }, // 432
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x7, 0x0, PseudoVLOXSEG3EI16_V_M1_MF2_MASK }, // 433
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x7, 0x1, PseudoVLOXSEG3EI16_V_M2_MF2_MASK }, // 434
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x7, 0x2, PseudoVLOXSEG3EI16_V_M4_MF2_MASK }, // 435
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x7, 0x3, PseudoVLOXSEG3EI16_V_M8_MF2_MASK }, // 436
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x7, 0x6, PseudoVLOXSEG3EI16_V_MF4_MF2_MASK }, // 437
  { Intrinsic::riscv_vloxseg3_mask, 0x10, 0x7, 0x7, PseudoVLOXSEG3EI16_V_MF2_MF2_MASK }, // 438
  { Intrinsic::riscv_vloxseg3_mask, 0x20, 0x0, 0x0, PseudoVLOXSEG3EI32_V_M1_M1_MASK }, // 439
  { Intrinsic::riscv_vloxseg3_mask, 0x20, 0x0, 0x1, PseudoVLOXSEG3EI32_V_M2_M1_MASK }, // 440
  { Intrinsic::riscv_vloxseg3_mask, 0x20, 0x0, 0x2, PseudoVLOXSEG3EI32_V_M4_M1_MASK }, // 441
  { Intrinsic::riscv_vloxseg3_mask, 0x20, 0x0, 0x3, PseudoVLOXSEG3EI32_V_M8_M1_MASK }, // 442
  { Intrinsic::riscv_vloxseg3_mask, 0x20, 0x0, 0x7, PseudoVLOXSEG3EI32_V_MF2_M1_MASK }, // 443
  { Intrinsic::riscv_vloxseg3_mask, 0x20, 0x1, 0x0, PseudoVLOXSEG3EI32_V_M1_M2_MASK }, // 444
  { Intrinsic::riscv_vloxseg3_mask, 0x20, 0x1, 0x1, PseudoVLOXSEG3EI32_V_M2_M2_MASK }, // 445
  { Intrinsic::riscv_vloxseg3_mask, 0x20, 0x1, 0x2, PseudoVLOXSEG3EI32_V_M4_M2_MASK }, // 446
  { Intrinsic::riscv_vloxseg3_mask, 0x20, 0x1, 0x3, PseudoVLOXSEG3EI32_V_M8_M2_MASK }, // 447
  { Intrinsic::riscv_vloxseg3_mask, 0x20, 0x1, 0x7, PseudoVLOXSEG3EI32_V_MF2_M2_MASK }, // 448
  { Intrinsic::riscv_vloxseg3_mask, 0x20, 0x5, 0x0, PseudoVLOXSEG3EI32_V_M1_MF8_MASK }, // 449
  { Intrinsic::riscv_vloxseg3_mask, 0x20, 0x5, 0x1, PseudoVLOXSEG3EI32_V_M2_MF8_MASK }, // 450
  { Intrinsic::riscv_vloxseg3_mask, 0x20, 0x5, 0x2, PseudoVLOXSEG3EI32_V_M4_MF8_MASK }, // 451
  { Intrinsic::riscv_vloxseg3_mask, 0x20, 0x5, 0x3, PseudoVLOXSEG3EI32_V_M8_MF8_MASK }, // 452
  { Intrinsic::riscv_vloxseg3_mask, 0x20, 0x5, 0x7, PseudoVLOXSEG3EI32_V_MF2_MF8_MASK }, // 453
  { Intrinsic::riscv_vloxseg3_mask, 0x20, 0x6, 0x0, PseudoVLOXSEG3EI32_V_M1_MF4_MASK }, // 454
  { Intrinsic::riscv_vloxseg3_mask, 0x20, 0x6, 0x1, PseudoVLOXSEG3EI32_V_M2_MF4_MASK }, // 455
  { Intrinsic::riscv_vloxseg3_mask, 0x20, 0x6, 0x2, PseudoVLOXSEG3EI32_V_M4_MF4_MASK }, // 456
  { Intrinsic::riscv_vloxseg3_mask, 0x20, 0x6, 0x3, PseudoVLOXSEG3EI32_V_M8_MF4_MASK }, // 457
  { Intrinsic::riscv_vloxseg3_mask, 0x20, 0x6, 0x7, PseudoVLOXSEG3EI32_V_MF2_MF4_MASK }, // 458
  { Intrinsic::riscv_vloxseg3_mask, 0x20, 0x7, 0x0, PseudoVLOXSEG3EI32_V_M1_MF2_MASK }, // 459
  { Intrinsic::riscv_vloxseg3_mask, 0x20, 0x7, 0x1, PseudoVLOXSEG3EI32_V_M2_MF2_MASK }, // 460
  { Intrinsic::riscv_vloxseg3_mask, 0x20, 0x7, 0x2, PseudoVLOXSEG3EI32_V_M4_MF2_MASK }, // 461
  { Intrinsic::riscv_vloxseg3_mask, 0x20, 0x7, 0x3, PseudoVLOXSEG3EI32_V_M8_MF2_MASK }, // 462
  { Intrinsic::riscv_vloxseg3_mask, 0x20, 0x7, 0x7, PseudoVLOXSEG3EI32_V_MF2_MF2_MASK }, // 463
  { Intrinsic::riscv_vloxseg3_mask, 0x40, 0x0, 0x0, PseudoVLOXSEG3EI64_V_M1_M1_MASK }, // 464
  { Intrinsic::riscv_vloxseg3_mask, 0x40, 0x0, 0x1, PseudoVLOXSEG3EI64_V_M2_M1_MASK }, // 465
  { Intrinsic::riscv_vloxseg3_mask, 0x40, 0x0, 0x2, PseudoVLOXSEG3EI64_V_M4_M1_MASK }, // 466
  { Intrinsic::riscv_vloxseg3_mask, 0x40, 0x0, 0x3, PseudoVLOXSEG3EI64_V_M8_M1_MASK }, // 467
  { Intrinsic::riscv_vloxseg3_mask, 0x40, 0x1, 0x0, PseudoVLOXSEG3EI64_V_M1_M2_MASK }, // 468
  { Intrinsic::riscv_vloxseg3_mask, 0x40, 0x1, 0x1, PseudoVLOXSEG3EI64_V_M2_M2_MASK }, // 469
  { Intrinsic::riscv_vloxseg3_mask, 0x40, 0x1, 0x2, PseudoVLOXSEG3EI64_V_M4_M2_MASK }, // 470
  { Intrinsic::riscv_vloxseg3_mask, 0x40, 0x1, 0x3, PseudoVLOXSEG3EI64_V_M8_M2_MASK }, // 471
  { Intrinsic::riscv_vloxseg3_mask, 0x40, 0x5, 0x0, PseudoVLOXSEG3EI64_V_M1_MF8_MASK }, // 472
  { Intrinsic::riscv_vloxseg3_mask, 0x40, 0x5, 0x1, PseudoVLOXSEG3EI64_V_M2_MF8_MASK }, // 473
  { Intrinsic::riscv_vloxseg3_mask, 0x40, 0x5, 0x2, PseudoVLOXSEG3EI64_V_M4_MF8_MASK }, // 474
  { Intrinsic::riscv_vloxseg3_mask, 0x40, 0x5, 0x3, PseudoVLOXSEG3EI64_V_M8_MF8_MASK }, // 475
  { Intrinsic::riscv_vloxseg3_mask, 0x40, 0x6, 0x0, PseudoVLOXSEG3EI64_V_M1_MF4_MASK }, // 476
  { Intrinsic::riscv_vloxseg3_mask, 0x40, 0x6, 0x1, PseudoVLOXSEG3EI64_V_M2_MF4_MASK }, // 477
  { Intrinsic::riscv_vloxseg3_mask, 0x40, 0x6, 0x2, PseudoVLOXSEG3EI64_V_M4_MF4_MASK }, // 478
  { Intrinsic::riscv_vloxseg3_mask, 0x40, 0x6, 0x3, PseudoVLOXSEG3EI64_V_M8_MF4_MASK }, // 479
  { Intrinsic::riscv_vloxseg3_mask, 0x40, 0x7, 0x0, PseudoVLOXSEG3EI64_V_M1_MF2_MASK }, // 480
  { Intrinsic::riscv_vloxseg3_mask, 0x40, 0x7, 0x1, PseudoVLOXSEG3EI64_V_M2_MF2_MASK }, // 481
  { Intrinsic::riscv_vloxseg3_mask, 0x40, 0x7, 0x2, PseudoVLOXSEG3EI64_V_M4_MF2_MASK }, // 482
  { Intrinsic::riscv_vloxseg3_mask, 0x40, 0x7, 0x3, PseudoVLOXSEG3EI64_V_M8_MF2_MASK }, // 483
  { Intrinsic::riscv_vloxseg4, 0x8, 0x0, 0x0, PseudoVLOXSEG4EI8_V_M1_M1 }, // 484
  { Intrinsic::riscv_vloxseg4, 0x8, 0x0, 0x1, PseudoVLOXSEG4EI8_V_M2_M1 }, // 485
  { Intrinsic::riscv_vloxseg4, 0x8, 0x0, 0x2, PseudoVLOXSEG4EI8_V_M4_M1 }, // 486
  { Intrinsic::riscv_vloxseg4, 0x8, 0x0, 0x3, PseudoVLOXSEG4EI8_V_M8_M1 }, // 487
  { Intrinsic::riscv_vloxseg4, 0x8, 0x0, 0x5, PseudoVLOXSEG4EI8_V_MF8_M1 }, // 488
  { Intrinsic::riscv_vloxseg4, 0x8, 0x0, 0x6, PseudoVLOXSEG4EI8_V_MF4_M1 }, // 489
  { Intrinsic::riscv_vloxseg4, 0x8, 0x0, 0x7, PseudoVLOXSEG4EI8_V_MF2_M1 }, // 490
  { Intrinsic::riscv_vloxseg4, 0x8, 0x1, 0x0, PseudoVLOXSEG4EI8_V_M1_M2 }, // 491
  { Intrinsic::riscv_vloxseg4, 0x8, 0x1, 0x1, PseudoVLOXSEG4EI8_V_M2_M2 }, // 492
  { Intrinsic::riscv_vloxseg4, 0x8, 0x1, 0x2, PseudoVLOXSEG4EI8_V_M4_M2 }, // 493
  { Intrinsic::riscv_vloxseg4, 0x8, 0x1, 0x3, PseudoVLOXSEG4EI8_V_M8_M2 }, // 494
  { Intrinsic::riscv_vloxseg4, 0x8, 0x1, 0x5, PseudoVLOXSEG4EI8_V_MF8_M2 }, // 495
  { Intrinsic::riscv_vloxseg4, 0x8, 0x1, 0x6, PseudoVLOXSEG4EI8_V_MF4_M2 }, // 496
  { Intrinsic::riscv_vloxseg4, 0x8, 0x1, 0x7, PseudoVLOXSEG4EI8_V_MF2_M2 }, // 497
  { Intrinsic::riscv_vloxseg4, 0x8, 0x5, 0x0, PseudoVLOXSEG4EI8_V_M1_MF8 }, // 498
  { Intrinsic::riscv_vloxseg4, 0x8, 0x5, 0x1, PseudoVLOXSEG4EI8_V_M2_MF8 }, // 499
  { Intrinsic::riscv_vloxseg4, 0x8, 0x5, 0x2, PseudoVLOXSEG4EI8_V_M4_MF8 }, // 500
  { Intrinsic::riscv_vloxseg4, 0x8, 0x5, 0x3, PseudoVLOXSEG4EI8_V_M8_MF8 }, // 501
  { Intrinsic::riscv_vloxseg4, 0x8, 0x5, 0x5, PseudoVLOXSEG4EI8_V_MF8_MF8 }, // 502
  { Intrinsic::riscv_vloxseg4, 0x8, 0x5, 0x6, PseudoVLOXSEG4EI8_V_MF4_MF8 }, // 503
  { Intrinsic::riscv_vloxseg4, 0x8, 0x5, 0x7, PseudoVLOXSEG4EI8_V_MF2_MF8 }, // 504
  { Intrinsic::riscv_vloxseg4, 0x8, 0x6, 0x0, PseudoVLOXSEG4EI8_V_M1_MF4 }, // 505
  { Intrinsic::riscv_vloxseg4, 0x8, 0x6, 0x1, PseudoVLOXSEG4EI8_V_M2_MF4 }, // 506
  { Intrinsic::riscv_vloxseg4, 0x8, 0x6, 0x2, PseudoVLOXSEG4EI8_V_M4_MF4 }, // 507
  { Intrinsic::riscv_vloxseg4, 0x8, 0x6, 0x3, PseudoVLOXSEG4EI8_V_M8_MF4 }, // 508
  { Intrinsic::riscv_vloxseg4, 0x8, 0x6, 0x5, PseudoVLOXSEG4EI8_V_MF8_MF4 }, // 509
  { Intrinsic::riscv_vloxseg4, 0x8, 0x6, 0x6, PseudoVLOXSEG4EI8_V_MF4_MF4 }, // 510
  { Intrinsic::riscv_vloxseg4, 0x8, 0x6, 0x7, PseudoVLOXSEG4EI8_V_MF2_MF4 }, // 511
  { Intrinsic::riscv_vloxseg4, 0x8, 0x7, 0x0, PseudoVLOXSEG4EI8_V_M1_MF2 }, // 512
  { Intrinsic::riscv_vloxseg4, 0x8, 0x7, 0x1, PseudoVLOXSEG4EI8_V_M2_MF2 }, // 513
  { Intrinsic::riscv_vloxseg4, 0x8, 0x7, 0x2, PseudoVLOXSEG4EI8_V_M4_MF2 }, // 514
  { Intrinsic::riscv_vloxseg4, 0x8, 0x7, 0x3, PseudoVLOXSEG4EI8_V_M8_MF2 }, // 515
  { Intrinsic::riscv_vloxseg4, 0x8, 0x7, 0x5, PseudoVLOXSEG4EI8_V_MF8_MF2 }, // 516
  { Intrinsic::riscv_vloxseg4, 0x8, 0x7, 0x6, PseudoVLOXSEG4EI8_V_MF4_MF2 }, // 517
  { Intrinsic::riscv_vloxseg4, 0x8, 0x7, 0x7, PseudoVLOXSEG4EI8_V_MF2_MF2 }, // 518
  { Intrinsic::riscv_vloxseg4, 0x10, 0x0, 0x0, PseudoVLOXSEG4EI16_V_M1_M1 }, // 519
  { Intrinsic::riscv_vloxseg4, 0x10, 0x0, 0x1, PseudoVLOXSEG4EI16_V_M2_M1 }, // 520
  { Intrinsic::riscv_vloxseg4, 0x10, 0x0, 0x2, PseudoVLOXSEG4EI16_V_M4_M1 }, // 521
  { Intrinsic::riscv_vloxseg4, 0x10, 0x0, 0x3, PseudoVLOXSEG4EI16_V_M8_M1 }, // 522
  { Intrinsic::riscv_vloxseg4, 0x10, 0x0, 0x6, PseudoVLOXSEG4EI16_V_MF4_M1 }, // 523
  { Intrinsic::riscv_vloxseg4, 0x10, 0x0, 0x7, PseudoVLOXSEG4EI16_V_MF2_M1 }, // 524
  { Intrinsic::riscv_vloxseg4, 0x10, 0x1, 0x0, PseudoVLOXSEG4EI16_V_M1_M2 }, // 525
  { Intrinsic::riscv_vloxseg4, 0x10, 0x1, 0x1, PseudoVLOXSEG4EI16_V_M2_M2 }, // 526
  { Intrinsic::riscv_vloxseg4, 0x10, 0x1, 0x2, PseudoVLOXSEG4EI16_V_M4_M2 }, // 527
  { Intrinsic::riscv_vloxseg4, 0x10, 0x1, 0x3, PseudoVLOXSEG4EI16_V_M8_M2 }, // 528
  { Intrinsic::riscv_vloxseg4, 0x10, 0x1, 0x6, PseudoVLOXSEG4EI16_V_MF4_M2 }, // 529
  { Intrinsic::riscv_vloxseg4, 0x10, 0x1, 0x7, PseudoVLOXSEG4EI16_V_MF2_M2 }, // 530
  { Intrinsic::riscv_vloxseg4, 0x10, 0x5, 0x0, PseudoVLOXSEG4EI16_V_M1_MF8 }, // 531
  { Intrinsic::riscv_vloxseg4, 0x10, 0x5, 0x1, PseudoVLOXSEG4EI16_V_M2_MF8 }, // 532
  { Intrinsic::riscv_vloxseg4, 0x10, 0x5, 0x2, PseudoVLOXSEG4EI16_V_M4_MF8 }, // 533
  { Intrinsic::riscv_vloxseg4, 0x10, 0x5, 0x3, PseudoVLOXSEG4EI16_V_M8_MF8 }, // 534
  { Intrinsic::riscv_vloxseg4, 0x10, 0x5, 0x6, PseudoVLOXSEG4EI16_V_MF4_MF8 }, // 535
  { Intrinsic::riscv_vloxseg4, 0x10, 0x5, 0x7, PseudoVLOXSEG4EI16_V_MF2_MF8 }, // 536
  { Intrinsic::riscv_vloxseg4, 0x10, 0x6, 0x0, PseudoVLOXSEG4EI16_V_M1_MF4 }, // 537
  { Intrinsic::riscv_vloxseg4, 0x10, 0x6, 0x1, PseudoVLOXSEG4EI16_V_M2_MF4 }, // 538
  { Intrinsic::riscv_vloxseg4, 0x10, 0x6, 0x2, PseudoVLOXSEG4EI16_V_M4_MF4 }, // 539
  { Intrinsic::riscv_vloxseg4, 0x10, 0x6, 0x3, PseudoVLOXSEG4EI16_V_M8_MF4 }, // 540
  { Intrinsic::riscv_vloxseg4, 0x10, 0x6, 0x6, PseudoVLOXSEG4EI16_V_MF4_MF4 }, // 541
  { Intrinsic::riscv_vloxseg4, 0x10, 0x6, 0x7, PseudoVLOXSEG4EI16_V_MF2_MF4 }, // 542
  { Intrinsic::riscv_vloxseg4, 0x10, 0x7, 0x0, PseudoVLOXSEG4EI16_V_M1_MF2 }, // 543
  { Intrinsic::riscv_vloxseg4, 0x10, 0x7, 0x1, PseudoVLOXSEG4EI16_V_M2_MF2 }, // 544
  { Intrinsic::riscv_vloxseg4, 0x10, 0x7, 0x2, PseudoVLOXSEG4EI16_V_M4_MF2 }, // 545
  { Intrinsic::riscv_vloxseg4, 0x10, 0x7, 0x3, PseudoVLOXSEG4EI16_V_M8_MF2 }, // 546
  { Intrinsic::riscv_vloxseg4, 0x10, 0x7, 0x6, PseudoVLOXSEG4EI16_V_MF4_MF2 }, // 547
  { Intrinsic::riscv_vloxseg4, 0x10, 0x7, 0x7, PseudoVLOXSEG4EI16_V_MF2_MF2 }, // 548
  { Intrinsic::riscv_vloxseg4, 0x20, 0x0, 0x0, PseudoVLOXSEG4EI32_V_M1_M1 }, // 549
  { Intrinsic::riscv_vloxseg4, 0x20, 0x0, 0x1, PseudoVLOXSEG4EI32_V_M2_M1 }, // 550
  { Intrinsic::riscv_vloxseg4, 0x20, 0x0, 0x2, PseudoVLOXSEG4EI32_V_M4_M1 }, // 551
  { Intrinsic::riscv_vloxseg4, 0x20, 0x0, 0x3, PseudoVLOXSEG4EI32_V_M8_M1 }, // 552
  { Intrinsic::riscv_vloxseg4, 0x20, 0x0, 0x7, PseudoVLOXSEG4EI32_V_MF2_M1 }, // 553
  { Intrinsic::riscv_vloxseg4, 0x20, 0x1, 0x0, PseudoVLOXSEG4EI32_V_M1_M2 }, // 554
  { Intrinsic::riscv_vloxseg4, 0x20, 0x1, 0x1, PseudoVLOXSEG4EI32_V_M2_M2 }, // 555
  { Intrinsic::riscv_vloxseg4, 0x20, 0x1, 0x2, PseudoVLOXSEG4EI32_V_M4_M2 }, // 556
  { Intrinsic::riscv_vloxseg4, 0x20, 0x1, 0x3, PseudoVLOXSEG4EI32_V_M8_M2 }, // 557
  { Intrinsic::riscv_vloxseg4, 0x20, 0x1, 0x7, PseudoVLOXSEG4EI32_V_MF2_M2 }, // 558
  { Intrinsic::riscv_vloxseg4, 0x20, 0x5, 0x0, PseudoVLOXSEG4EI32_V_M1_MF8 }, // 559
  { Intrinsic::riscv_vloxseg4, 0x20, 0x5, 0x1, PseudoVLOXSEG4EI32_V_M2_MF8 }, // 560
  { Intrinsic::riscv_vloxseg4, 0x20, 0x5, 0x2, PseudoVLOXSEG4EI32_V_M4_MF8 }, // 561
  { Intrinsic::riscv_vloxseg4, 0x20, 0x5, 0x3, PseudoVLOXSEG4EI32_V_M8_MF8 }, // 562
  { Intrinsic::riscv_vloxseg4, 0x20, 0x5, 0x7, PseudoVLOXSEG4EI32_V_MF2_MF8 }, // 563
  { Intrinsic::riscv_vloxseg4, 0x20, 0x6, 0x0, PseudoVLOXSEG4EI32_V_M1_MF4 }, // 564
  { Intrinsic::riscv_vloxseg4, 0x20, 0x6, 0x1, PseudoVLOXSEG4EI32_V_M2_MF4 }, // 565
  { Intrinsic::riscv_vloxseg4, 0x20, 0x6, 0x2, PseudoVLOXSEG4EI32_V_M4_MF4 }, // 566
  { Intrinsic::riscv_vloxseg4, 0x20, 0x6, 0x3, PseudoVLOXSEG4EI32_V_M8_MF4 }, // 567
  { Intrinsic::riscv_vloxseg4, 0x20, 0x6, 0x7, PseudoVLOXSEG4EI32_V_MF2_MF4 }, // 568
  { Intrinsic::riscv_vloxseg4, 0x20, 0x7, 0x0, PseudoVLOXSEG4EI32_V_M1_MF2 }, // 569
  { Intrinsic::riscv_vloxseg4, 0x20, 0x7, 0x1, PseudoVLOXSEG4EI32_V_M2_MF2 }, // 570
  { Intrinsic::riscv_vloxseg4, 0x20, 0x7, 0x2, PseudoVLOXSEG4EI32_V_M4_MF2 }, // 571
  { Intrinsic::riscv_vloxseg4, 0x20, 0x7, 0x3, PseudoVLOXSEG4EI32_V_M8_MF2 }, // 572
  { Intrinsic::riscv_vloxseg4, 0x20, 0x7, 0x7, PseudoVLOXSEG4EI32_V_MF2_MF2 }, // 573
  { Intrinsic::riscv_vloxseg4, 0x40, 0x0, 0x0, PseudoVLOXSEG4EI64_V_M1_M1 }, // 574
  { Intrinsic::riscv_vloxseg4, 0x40, 0x0, 0x1, PseudoVLOXSEG4EI64_V_M2_M1 }, // 575
  { Intrinsic::riscv_vloxseg4, 0x40, 0x0, 0x2, PseudoVLOXSEG4EI64_V_M4_M1 }, // 576
  { Intrinsic::riscv_vloxseg4, 0x40, 0x0, 0x3, PseudoVLOXSEG4EI64_V_M8_M1 }, // 577
  { Intrinsic::riscv_vloxseg4, 0x40, 0x1, 0x0, PseudoVLOXSEG4EI64_V_M1_M2 }, // 578
  { Intrinsic::riscv_vloxseg4, 0x40, 0x1, 0x1, PseudoVLOXSEG4EI64_V_M2_M2 }, // 579
  { Intrinsic::riscv_vloxseg4, 0x40, 0x1, 0x2, PseudoVLOXSEG4EI64_V_M4_M2 }, // 580
  { Intrinsic::riscv_vloxseg4, 0x40, 0x1, 0x3, PseudoVLOXSEG4EI64_V_M8_M2 }, // 581
  { Intrinsic::riscv_vloxseg4, 0x40, 0x5, 0x0, PseudoVLOXSEG4EI64_V_M1_MF8 }, // 582
  { Intrinsic::riscv_vloxseg4, 0x40, 0x5, 0x1, PseudoVLOXSEG4EI64_V_M2_MF8 }, // 583
  { Intrinsic::riscv_vloxseg4, 0x40, 0x5, 0x2, PseudoVLOXSEG4EI64_V_M4_MF8 }, // 584
  { Intrinsic::riscv_vloxseg4, 0x40, 0x5, 0x3, PseudoVLOXSEG4EI64_V_M8_MF8 }, // 585
  { Intrinsic::riscv_vloxseg4, 0x40, 0x6, 0x0, PseudoVLOXSEG4EI64_V_M1_MF4 }, // 586
  { Intrinsic::riscv_vloxseg4, 0x40, 0x6, 0x1, PseudoVLOXSEG4EI64_V_M2_MF4 }, // 587
  { Intrinsic::riscv_vloxseg4, 0x40, 0x6, 0x2, PseudoVLOXSEG4EI64_V_M4_MF4 }, // 588
  { Intrinsic::riscv_vloxseg4, 0x40, 0x6, 0x3, PseudoVLOXSEG4EI64_V_M8_MF4 }, // 589
  { Intrinsic::riscv_vloxseg4, 0x40, 0x7, 0x0, PseudoVLOXSEG4EI64_V_M1_MF2 }, // 590
  { Intrinsic::riscv_vloxseg4, 0x40, 0x7, 0x1, PseudoVLOXSEG4EI64_V_M2_MF2 }, // 591
  { Intrinsic::riscv_vloxseg4, 0x40, 0x7, 0x2, PseudoVLOXSEG4EI64_V_M4_MF2 }, // 592
  { Intrinsic::riscv_vloxseg4, 0x40, 0x7, 0x3, PseudoVLOXSEG4EI64_V_M8_MF2 }, // 593
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x0, 0x0, PseudoVLOXSEG4EI8_V_M1_M1_MASK }, // 594
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x0, 0x1, PseudoVLOXSEG4EI8_V_M2_M1_MASK }, // 595
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x0, 0x2, PseudoVLOXSEG4EI8_V_M4_M1_MASK }, // 596
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x0, 0x3, PseudoVLOXSEG4EI8_V_M8_M1_MASK }, // 597
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x0, 0x5, PseudoVLOXSEG4EI8_V_MF8_M1_MASK }, // 598
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x0, 0x6, PseudoVLOXSEG4EI8_V_MF4_M1_MASK }, // 599
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x0, 0x7, PseudoVLOXSEG4EI8_V_MF2_M1_MASK }, // 600
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x1, 0x0, PseudoVLOXSEG4EI8_V_M1_M2_MASK }, // 601
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x1, 0x1, PseudoVLOXSEG4EI8_V_M2_M2_MASK }, // 602
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x1, 0x2, PseudoVLOXSEG4EI8_V_M4_M2_MASK }, // 603
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x1, 0x3, PseudoVLOXSEG4EI8_V_M8_M2_MASK }, // 604
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x1, 0x5, PseudoVLOXSEG4EI8_V_MF8_M2_MASK }, // 605
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x1, 0x6, PseudoVLOXSEG4EI8_V_MF4_M2_MASK }, // 606
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x1, 0x7, PseudoVLOXSEG4EI8_V_MF2_M2_MASK }, // 607
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x5, 0x0, PseudoVLOXSEG4EI8_V_M1_MF8_MASK }, // 608
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x5, 0x1, PseudoVLOXSEG4EI8_V_M2_MF8_MASK }, // 609
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x5, 0x2, PseudoVLOXSEG4EI8_V_M4_MF8_MASK }, // 610
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x5, 0x3, PseudoVLOXSEG4EI8_V_M8_MF8_MASK }, // 611
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x5, 0x5, PseudoVLOXSEG4EI8_V_MF8_MF8_MASK }, // 612
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x5, 0x6, PseudoVLOXSEG4EI8_V_MF4_MF8_MASK }, // 613
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x5, 0x7, PseudoVLOXSEG4EI8_V_MF2_MF8_MASK }, // 614
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x6, 0x0, PseudoVLOXSEG4EI8_V_M1_MF4_MASK }, // 615
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x6, 0x1, PseudoVLOXSEG4EI8_V_M2_MF4_MASK }, // 616
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x6, 0x2, PseudoVLOXSEG4EI8_V_M4_MF4_MASK }, // 617
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x6, 0x3, PseudoVLOXSEG4EI8_V_M8_MF4_MASK }, // 618
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x6, 0x5, PseudoVLOXSEG4EI8_V_MF8_MF4_MASK }, // 619
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x6, 0x6, PseudoVLOXSEG4EI8_V_MF4_MF4_MASK }, // 620
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x6, 0x7, PseudoVLOXSEG4EI8_V_MF2_MF4_MASK }, // 621
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x7, 0x0, PseudoVLOXSEG4EI8_V_M1_MF2_MASK }, // 622
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x7, 0x1, PseudoVLOXSEG4EI8_V_M2_MF2_MASK }, // 623
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x7, 0x2, PseudoVLOXSEG4EI8_V_M4_MF2_MASK }, // 624
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x7, 0x3, PseudoVLOXSEG4EI8_V_M8_MF2_MASK }, // 625
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x7, 0x5, PseudoVLOXSEG4EI8_V_MF8_MF2_MASK }, // 626
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x7, 0x6, PseudoVLOXSEG4EI8_V_MF4_MF2_MASK }, // 627
  { Intrinsic::riscv_vloxseg4_mask, 0x8, 0x7, 0x7, PseudoVLOXSEG4EI8_V_MF2_MF2_MASK }, // 628
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x0, 0x0, PseudoVLOXSEG4EI16_V_M1_M1_MASK }, // 629
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x0, 0x1, PseudoVLOXSEG4EI16_V_M2_M1_MASK }, // 630
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x0, 0x2, PseudoVLOXSEG4EI16_V_M4_M1_MASK }, // 631
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x0, 0x3, PseudoVLOXSEG4EI16_V_M8_M1_MASK }, // 632
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x0, 0x6, PseudoVLOXSEG4EI16_V_MF4_M1_MASK }, // 633
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x0, 0x7, PseudoVLOXSEG4EI16_V_MF2_M1_MASK }, // 634
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x1, 0x0, PseudoVLOXSEG4EI16_V_M1_M2_MASK }, // 635
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x1, 0x1, PseudoVLOXSEG4EI16_V_M2_M2_MASK }, // 636
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x1, 0x2, PseudoVLOXSEG4EI16_V_M4_M2_MASK }, // 637
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x1, 0x3, PseudoVLOXSEG4EI16_V_M8_M2_MASK }, // 638
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x1, 0x6, PseudoVLOXSEG4EI16_V_MF4_M2_MASK }, // 639
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x1, 0x7, PseudoVLOXSEG4EI16_V_MF2_M2_MASK }, // 640
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x5, 0x0, PseudoVLOXSEG4EI16_V_M1_MF8_MASK }, // 641
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x5, 0x1, PseudoVLOXSEG4EI16_V_M2_MF8_MASK }, // 642
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x5, 0x2, PseudoVLOXSEG4EI16_V_M4_MF8_MASK }, // 643
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x5, 0x3, PseudoVLOXSEG4EI16_V_M8_MF8_MASK }, // 644
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x5, 0x6, PseudoVLOXSEG4EI16_V_MF4_MF8_MASK }, // 645
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x5, 0x7, PseudoVLOXSEG4EI16_V_MF2_MF8_MASK }, // 646
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x6, 0x0, PseudoVLOXSEG4EI16_V_M1_MF4_MASK }, // 647
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x6, 0x1, PseudoVLOXSEG4EI16_V_M2_MF4_MASK }, // 648
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x6, 0x2, PseudoVLOXSEG4EI16_V_M4_MF4_MASK }, // 649
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x6, 0x3, PseudoVLOXSEG4EI16_V_M8_MF4_MASK }, // 650
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x6, 0x6, PseudoVLOXSEG4EI16_V_MF4_MF4_MASK }, // 651
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x6, 0x7, PseudoVLOXSEG4EI16_V_MF2_MF4_MASK }, // 652
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x7, 0x0, PseudoVLOXSEG4EI16_V_M1_MF2_MASK }, // 653
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x7, 0x1, PseudoVLOXSEG4EI16_V_M2_MF2_MASK }, // 654
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x7, 0x2, PseudoVLOXSEG4EI16_V_M4_MF2_MASK }, // 655
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x7, 0x3, PseudoVLOXSEG4EI16_V_M8_MF2_MASK }, // 656
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x7, 0x6, PseudoVLOXSEG4EI16_V_MF4_MF2_MASK }, // 657
  { Intrinsic::riscv_vloxseg4_mask, 0x10, 0x7, 0x7, PseudoVLOXSEG4EI16_V_MF2_MF2_MASK }, // 658
  { Intrinsic::riscv_vloxseg4_mask, 0x20, 0x0, 0x0, PseudoVLOXSEG4EI32_V_M1_M1_MASK }, // 659
  { Intrinsic::riscv_vloxseg4_mask, 0x20, 0x0, 0x1, PseudoVLOXSEG4EI32_V_M2_M1_MASK }, // 660
  { Intrinsic::riscv_vloxseg4_mask, 0x20, 0x0, 0x2, PseudoVLOXSEG4EI32_V_M4_M1_MASK }, // 661
  { Intrinsic::riscv_vloxseg4_mask, 0x20, 0x0, 0x3, PseudoVLOXSEG4EI32_V_M8_M1_MASK }, // 662
  { Intrinsic::riscv_vloxseg4_mask, 0x20, 0x0, 0x7, PseudoVLOXSEG4EI32_V_MF2_M1_MASK }, // 663
  { Intrinsic::riscv_vloxseg4_mask, 0x20, 0x1, 0x0, PseudoVLOXSEG4EI32_V_M1_M2_MASK }, // 664
  { Intrinsic::riscv_vloxseg4_mask, 0x20, 0x1, 0x1, PseudoVLOXSEG4EI32_V_M2_M2_MASK }, // 665
  { Intrinsic::riscv_vloxseg4_mask, 0x20, 0x1, 0x2, PseudoVLOXSEG4EI32_V_M4_M2_MASK }, // 666
  { Intrinsic::riscv_vloxseg4_mask, 0x20, 0x1, 0x3, PseudoVLOXSEG4EI32_V_M8_M2_MASK }, // 667
  { Intrinsic::riscv_vloxseg4_mask, 0x20, 0x1, 0x7, PseudoVLOXSEG4EI32_V_MF2_M2_MASK }, // 668
  { Intrinsic::riscv_vloxseg4_mask, 0x20, 0x5, 0x0, PseudoVLOXSEG4EI32_V_M1_MF8_MASK }, // 669
  { Intrinsic::riscv_vloxseg4_mask, 0x20, 0x5, 0x1, PseudoVLOXSEG4EI32_V_M2_MF8_MASK }, // 670
  { Intrinsic::riscv_vloxseg4_mask, 0x20, 0x5, 0x2, PseudoVLOXSEG4EI32_V_M4_MF8_MASK }, // 671
  { Intrinsic::riscv_vloxseg4_mask, 0x20, 0x5, 0x3, PseudoVLOXSEG4EI32_V_M8_MF8_MASK }, // 672
  { Intrinsic::riscv_vloxseg4_mask, 0x20, 0x5, 0x7, PseudoVLOXSEG4EI32_V_MF2_MF8_MASK }, // 673
  { Intrinsic::riscv_vloxseg4_mask, 0x20, 0x6, 0x0, PseudoVLOXSEG4EI32_V_M1_MF4_MASK }, // 674
  { Intrinsic::riscv_vloxseg4_mask, 0x20, 0x6, 0x1, PseudoVLOXSEG4EI32_V_M2_MF4_MASK }, // 675
  { Intrinsic::riscv_vloxseg4_mask, 0x20, 0x6, 0x2, PseudoVLOXSEG4EI32_V_M4_MF4_MASK }, // 676
  { Intrinsic::riscv_vloxseg4_mask, 0x20, 0x6, 0x3, PseudoVLOXSEG4EI32_V_M8_MF4_MASK }, // 677
  { Intrinsic::riscv_vloxseg4_mask, 0x20, 0x6, 0x7, PseudoVLOXSEG4EI32_V_MF2_MF4_MASK }, // 678
  { Intrinsic::riscv_vloxseg4_mask, 0x20, 0x7, 0x0, PseudoVLOXSEG4EI32_V_M1_MF2_MASK }, // 679
  { Intrinsic::riscv_vloxseg4_mask, 0x20, 0x7, 0x1, PseudoVLOXSEG4EI32_V_M2_MF2_MASK }, // 680
  { Intrinsic::riscv_vloxseg4_mask, 0x20, 0x7, 0x2, PseudoVLOXSEG4EI32_V_M4_MF2_MASK }, // 681
  { Intrinsic::riscv_vloxseg4_mask, 0x20, 0x7, 0x3, PseudoVLOXSEG4EI32_V_M8_MF2_MASK }, // 682
  { Intrinsic::riscv_vloxseg4_mask, 0x20, 0x7, 0x7, PseudoVLOXSEG4EI32_V_MF2_MF2_MASK }, // 683
  { Intrinsic::riscv_vloxseg4_mask, 0x40, 0x0, 0x0, PseudoVLOXSEG4EI64_V_M1_M1_MASK }, // 684
  { Intrinsic::riscv_vloxseg4_mask, 0x40, 0x0, 0x1, PseudoVLOXSEG4EI64_V_M2_M1_MASK }, // 685
  { Intrinsic::riscv_vloxseg4_mask, 0x40, 0x0, 0x2, PseudoVLOXSEG4EI64_V_M4_M1_MASK }, // 686
  { Intrinsic::riscv_vloxseg4_mask, 0x40, 0x0, 0x3, PseudoVLOXSEG4EI64_V_M8_M1_MASK }, // 687
  { Intrinsic::riscv_vloxseg4_mask, 0x40, 0x1, 0x0, PseudoVLOXSEG4EI64_V_M1_M2_MASK }, // 688
  { Intrinsic::riscv_vloxseg4_mask, 0x40, 0x1, 0x1, PseudoVLOXSEG4EI64_V_M2_M2_MASK }, // 689
  { Intrinsic::riscv_vloxseg4_mask, 0x40, 0x1, 0x2, PseudoVLOXSEG4EI64_V_M4_M2_MASK }, // 690
  { Intrinsic::riscv_vloxseg4_mask, 0x40, 0x1, 0x3, PseudoVLOXSEG4EI64_V_M8_M2_MASK }, // 691
  { Intrinsic::riscv_vloxseg4_mask, 0x40, 0x5, 0x0, PseudoVLOXSEG4EI64_V_M1_MF8_MASK }, // 692
  { Intrinsic::riscv_vloxseg4_mask, 0x40, 0x5, 0x1, PseudoVLOXSEG4EI64_V_M2_MF8_MASK }, // 693
  { Intrinsic::riscv_vloxseg4_mask, 0x40, 0x5, 0x2, PseudoVLOXSEG4EI64_V_M4_MF8_MASK }, // 694
  { Intrinsic::riscv_vloxseg4_mask, 0x40, 0x5, 0x3, PseudoVLOXSEG4EI64_V_M8_MF8_MASK }, // 695
  { Intrinsic::riscv_vloxseg4_mask, 0x40, 0x6, 0x0, PseudoVLOXSEG4EI64_V_M1_MF4_MASK }, // 696
  { Intrinsic::riscv_vloxseg4_mask, 0x40, 0x6, 0x1, PseudoVLOXSEG4EI64_V_M2_MF4_MASK }, // 697
  { Intrinsic::riscv_vloxseg4_mask, 0x40, 0x6, 0x2, PseudoVLOXSEG4EI64_V_M4_MF4_MASK }, // 698
  { Intrinsic::riscv_vloxseg4_mask, 0x40, 0x6, 0x3, PseudoVLOXSEG4EI64_V_M8_MF4_MASK }, // 699
  { Intrinsic::riscv_vloxseg4_mask, 0x40, 0x7, 0x0, PseudoVLOXSEG4EI64_V_M1_MF2_MASK }, // 700
  { Intrinsic::riscv_vloxseg4_mask, 0x40, 0x7, 0x1, PseudoVLOXSEG4EI64_V_M2_MF2_MASK }, // 701
  { Intrinsic::riscv_vloxseg4_mask, 0x40, 0x7, 0x2, PseudoVLOXSEG4EI64_V_M4_MF2_MASK }, // 702
  { Intrinsic::riscv_vloxseg4_mask, 0x40, 0x7, 0x3, PseudoVLOXSEG4EI64_V_M8_MF2_MASK }, // 703
  { Intrinsic::riscv_vloxseg5, 0x8, 0x0, 0x0, PseudoVLOXSEG5EI8_V_M1_M1 }, // 704
  { Intrinsic::riscv_vloxseg5, 0x8, 0x0, 0x1, PseudoVLOXSEG5EI8_V_M2_M1 }, // 705
  { Intrinsic::riscv_vloxseg5, 0x8, 0x0, 0x2, PseudoVLOXSEG5EI8_V_M4_M1 }, // 706
  { Intrinsic::riscv_vloxseg5, 0x8, 0x0, 0x3, PseudoVLOXSEG5EI8_V_M8_M1 }, // 707
  { Intrinsic::riscv_vloxseg5, 0x8, 0x0, 0x5, PseudoVLOXSEG5EI8_V_MF8_M1 }, // 708
  { Intrinsic::riscv_vloxseg5, 0x8, 0x0, 0x6, PseudoVLOXSEG5EI8_V_MF4_M1 }, // 709
  { Intrinsic::riscv_vloxseg5, 0x8, 0x0, 0x7, PseudoVLOXSEG5EI8_V_MF2_M1 }, // 710
  { Intrinsic::riscv_vloxseg5, 0x8, 0x5, 0x0, PseudoVLOXSEG5EI8_V_M1_MF8 }, // 711
  { Intrinsic::riscv_vloxseg5, 0x8, 0x5, 0x1, PseudoVLOXSEG5EI8_V_M2_MF8 }, // 712
  { Intrinsic::riscv_vloxseg5, 0x8, 0x5, 0x2, PseudoVLOXSEG5EI8_V_M4_MF8 }, // 713
  { Intrinsic::riscv_vloxseg5, 0x8, 0x5, 0x3, PseudoVLOXSEG5EI8_V_M8_MF8 }, // 714
  { Intrinsic::riscv_vloxseg5, 0x8, 0x5, 0x5, PseudoVLOXSEG5EI8_V_MF8_MF8 }, // 715
  { Intrinsic::riscv_vloxseg5, 0x8, 0x5, 0x6, PseudoVLOXSEG5EI8_V_MF4_MF8 }, // 716
  { Intrinsic::riscv_vloxseg5, 0x8, 0x5, 0x7, PseudoVLOXSEG5EI8_V_MF2_MF8 }, // 717
  { Intrinsic::riscv_vloxseg5, 0x8, 0x6, 0x0, PseudoVLOXSEG5EI8_V_M1_MF4 }, // 718
  { Intrinsic::riscv_vloxseg5, 0x8, 0x6, 0x1, PseudoVLOXSEG5EI8_V_M2_MF4 }, // 719
  { Intrinsic::riscv_vloxseg5, 0x8, 0x6, 0x2, PseudoVLOXSEG5EI8_V_M4_MF4 }, // 720
  { Intrinsic::riscv_vloxseg5, 0x8, 0x6, 0x3, PseudoVLOXSEG5EI8_V_M8_MF4 }, // 721
  { Intrinsic::riscv_vloxseg5, 0x8, 0x6, 0x5, PseudoVLOXSEG5EI8_V_MF8_MF4 }, // 722
  { Intrinsic::riscv_vloxseg5, 0x8, 0x6, 0x6, PseudoVLOXSEG5EI8_V_MF4_MF4 }, // 723
  { Intrinsic::riscv_vloxseg5, 0x8, 0x6, 0x7, PseudoVLOXSEG5EI8_V_MF2_MF4 }, // 724
  { Intrinsic::riscv_vloxseg5, 0x8, 0x7, 0x0, PseudoVLOXSEG5EI8_V_M1_MF2 }, // 725
  { Intrinsic::riscv_vloxseg5, 0x8, 0x7, 0x1, PseudoVLOXSEG5EI8_V_M2_MF2 }, // 726
  { Intrinsic::riscv_vloxseg5, 0x8, 0x7, 0x2, PseudoVLOXSEG5EI8_V_M4_MF2 }, // 727
  { Intrinsic::riscv_vloxseg5, 0x8, 0x7, 0x3, PseudoVLOXSEG5EI8_V_M8_MF2 }, // 728
  { Intrinsic::riscv_vloxseg5, 0x8, 0x7, 0x5, PseudoVLOXSEG5EI8_V_MF8_MF2 }, // 729
  { Intrinsic::riscv_vloxseg5, 0x8, 0x7, 0x6, PseudoVLOXSEG5EI8_V_MF4_MF2 }, // 730
  { Intrinsic::riscv_vloxseg5, 0x8, 0x7, 0x7, PseudoVLOXSEG5EI8_V_MF2_MF2 }, // 731
  { Intrinsic::riscv_vloxseg5, 0x10, 0x0, 0x0, PseudoVLOXSEG5EI16_V_M1_M1 }, // 732
  { Intrinsic::riscv_vloxseg5, 0x10, 0x0, 0x1, PseudoVLOXSEG5EI16_V_M2_M1 }, // 733
  { Intrinsic::riscv_vloxseg5, 0x10, 0x0, 0x2, PseudoVLOXSEG5EI16_V_M4_M1 }, // 734
  { Intrinsic::riscv_vloxseg5, 0x10, 0x0, 0x3, PseudoVLOXSEG5EI16_V_M8_M1 }, // 735
  { Intrinsic::riscv_vloxseg5, 0x10, 0x0, 0x6, PseudoVLOXSEG5EI16_V_MF4_M1 }, // 736
  { Intrinsic::riscv_vloxseg5, 0x10, 0x0, 0x7, PseudoVLOXSEG5EI16_V_MF2_M1 }, // 737
  { Intrinsic::riscv_vloxseg5, 0x10, 0x5, 0x0, PseudoVLOXSEG5EI16_V_M1_MF8 }, // 738
  { Intrinsic::riscv_vloxseg5, 0x10, 0x5, 0x1, PseudoVLOXSEG5EI16_V_M2_MF8 }, // 739
  { Intrinsic::riscv_vloxseg5, 0x10, 0x5, 0x2, PseudoVLOXSEG5EI16_V_M4_MF8 }, // 740
  { Intrinsic::riscv_vloxseg5, 0x10, 0x5, 0x3, PseudoVLOXSEG5EI16_V_M8_MF8 }, // 741
  { Intrinsic::riscv_vloxseg5, 0x10, 0x5, 0x6, PseudoVLOXSEG5EI16_V_MF4_MF8 }, // 742
  { Intrinsic::riscv_vloxseg5, 0x10, 0x5, 0x7, PseudoVLOXSEG5EI16_V_MF2_MF8 }, // 743
  { Intrinsic::riscv_vloxseg5, 0x10, 0x6, 0x0, PseudoVLOXSEG5EI16_V_M1_MF4 }, // 744
  { Intrinsic::riscv_vloxseg5, 0x10, 0x6, 0x1, PseudoVLOXSEG5EI16_V_M2_MF4 }, // 745
  { Intrinsic::riscv_vloxseg5, 0x10, 0x6, 0x2, PseudoVLOXSEG5EI16_V_M4_MF4 }, // 746
  { Intrinsic::riscv_vloxseg5, 0x10, 0x6, 0x3, PseudoVLOXSEG5EI16_V_M8_MF4 }, // 747
  { Intrinsic::riscv_vloxseg5, 0x10, 0x6, 0x6, PseudoVLOXSEG5EI16_V_MF4_MF4 }, // 748
  { Intrinsic::riscv_vloxseg5, 0x10, 0x6, 0x7, PseudoVLOXSEG5EI16_V_MF2_MF4 }, // 749
  { Intrinsic::riscv_vloxseg5, 0x10, 0x7, 0x0, PseudoVLOXSEG5EI16_V_M1_MF2 }, // 750
  { Intrinsic::riscv_vloxseg5, 0x10, 0x7, 0x1, PseudoVLOXSEG5EI16_V_M2_MF2 }, // 751
  { Intrinsic::riscv_vloxseg5, 0x10, 0x7, 0x2, PseudoVLOXSEG5EI16_V_M4_MF2 }, // 752
  { Intrinsic::riscv_vloxseg5, 0x10, 0x7, 0x3, PseudoVLOXSEG5EI16_V_M8_MF2 }, // 753
  { Intrinsic::riscv_vloxseg5, 0x10, 0x7, 0x6, PseudoVLOXSEG5EI16_V_MF4_MF2 }, // 754
  { Intrinsic::riscv_vloxseg5, 0x10, 0x7, 0x7, PseudoVLOXSEG5EI16_V_MF2_MF2 }, // 755
  { Intrinsic::riscv_vloxseg5, 0x20, 0x0, 0x0, PseudoVLOXSEG5EI32_V_M1_M1 }, // 756
  { Intrinsic::riscv_vloxseg5, 0x20, 0x0, 0x1, PseudoVLOXSEG5EI32_V_M2_M1 }, // 757
  { Intrinsic::riscv_vloxseg5, 0x20, 0x0, 0x2, PseudoVLOXSEG5EI32_V_M4_M1 }, // 758
  { Intrinsic::riscv_vloxseg5, 0x20, 0x0, 0x3, PseudoVLOXSEG5EI32_V_M8_M1 }, // 759
  { Intrinsic::riscv_vloxseg5, 0x20, 0x0, 0x7, PseudoVLOXSEG5EI32_V_MF2_M1 }, // 760
  { Intrinsic::riscv_vloxseg5, 0x20, 0x5, 0x0, PseudoVLOXSEG5EI32_V_M1_MF8 }, // 761
  { Intrinsic::riscv_vloxseg5, 0x20, 0x5, 0x1, PseudoVLOXSEG5EI32_V_M2_MF8 }, // 762
  { Intrinsic::riscv_vloxseg5, 0x20, 0x5, 0x2, PseudoVLOXSEG5EI32_V_M4_MF8 }, // 763
  { Intrinsic::riscv_vloxseg5, 0x20, 0x5, 0x3, PseudoVLOXSEG5EI32_V_M8_MF8 }, // 764
  { Intrinsic::riscv_vloxseg5, 0x20, 0x5, 0x7, PseudoVLOXSEG5EI32_V_MF2_MF8 }, // 765
  { Intrinsic::riscv_vloxseg5, 0x20, 0x6, 0x0, PseudoVLOXSEG5EI32_V_M1_MF4 }, // 766
  { Intrinsic::riscv_vloxseg5, 0x20, 0x6, 0x1, PseudoVLOXSEG5EI32_V_M2_MF4 }, // 767
  { Intrinsic::riscv_vloxseg5, 0x20, 0x6, 0x2, PseudoVLOXSEG5EI32_V_M4_MF4 }, // 768
  { Intrinsic::riscv_vloxseg5, 0x20, 0x6, 0x3, PseudoVLOXSEG5EI32_V_M8_MF4 }, // 769
  { Intrinsic::riscv_vloxseg5, 0x20, 0x6, 0x7, PseudoVLOXSEG5EI32_V_MF2_MF4 }, // 770
  { Intrinsic::riscv_vloxseg5, 0x20, 0x7, 0x0, PseudoVLOXSEG5EI32_V_M1_MF2 }, // 771
  { Intrinsic::riscv_vloxseg5, 0x20, 0x7, 0x1, PseudoVLOXSEG5EI32_V_M2_MF2 }, // 772
  { Intrinsic::riscv_vloxseg5, 0x20, 0x7, 0x2, PseudoVLOXSEG5EI32_V_M4_MF2 }, // 773
  { Intrinsic::riscv_vloxseg5, 0x20, 0x7, 0x3, PseudoVLOXSEG5EI32_V_M8_MF2 }, // 774
  { Intrinsic::riscv_vloxseg5, 0x20, 0x7, 0x7, PseudoVLOXSEG5EI32_V_MF2_MF2 }, // 775
  { Intrinsic::riscv_vloxseg5, 0x40, 0x0, 0x0, PseudoVLOXSEG5EI64_V_M1_M1 }, // 776
  { Intrinsic::riscv_vloxseg5, 0x40, 0x0, 0x1, PseudoVLOXSEG5EI64_V_M2_M1 }, // 777
  { Intrinsic::riscv_vloxseg5, 0x40, 0x0, 0x2, PseudoVLOXSEG5EI64_V_M4_M1 }, // 778
  { Intrinsic::riscv_vloxseg5, 0x40, 0x0, 0x3, PseudoVLOXSEG5EI64_V_M8_M1 }, // 779
  { Intrinsic::riscv_vloxseg5, 0x40, 0x5, 0x0, PseudoVLOXSEG5EI64_V_M1_MF8 }, // 780
  { Intrinsic::riscv_vloxseg5, 0x40, 0x5, 0x1, PseudoVLOXSEG5EI64_V_M2_MF8 }, // 781
  { Intrinsic::riscv_vloxseg5, 0x40, 0x5, 0x2, PseudoVLOXSEG5EI64_V_M4_MF8 }, // 782
  { Intrinsic::riscv_vloxseg5, 0x40, 0x5, 0x3, PseudoVLOXSEG5EI64_V_M8_MF8 }, // 783
  { Intrinsic::riscv_vloxseg5, 0x40, 0x6, 0x0, PseudoVLOXSEG5EI64_V_M1_MF4 }, // 784
  { Intrinsic::riscv_vloxseg5, 0x40, 0x6, 0x1, PseudoVLOXSEG5EI64_V_M2_MF4 }, // 785
  { Intrinsic::riscv_vloxseg5, 0x40, 0x6, 0x2, PseudoVLOXSEG5EI64_V_M4_MF4 }, // 786
  { Intrinsic::riscv_vloxseg5, 0x40, 0x6, 0x3, PseudoVLOXSEG5EI64_V_M8_MF4 }, // 787
  { Intrinsic::riscv_vloxseg5, 0x40, 0x7, 0x0, PseudoVLOXSEG5EI64_V_M1_MF2 }, // 788
  { Intrinsic::riscv_vloxseg5, 0x40, 0x7, 0x1, PseudoVLOXSEG5EI64_V_M2_MF2 }, // 789
  { Intrinsic::riscv_vloxseg5, 0x40, 0x7, 0x2, PseudoVLOXSEG5EI64_V_M4_MF2 }, // 790
  { Intrinsic::riscv_vloxseg5, 0x40, 0x7, 0x3, PseudoVLOXSEG5EI64_V_M8_MF2 }, // 791
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x0, 0x0, PseudoVLOXSEG5EI8_V_M1_M1_MASK }, // 792
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x0, 0x1, PseudoVLOXSEG5EI8_V_M2_M1_MASK }, // 793
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x0, 0x2, PseudoVLOXSEG5EI8_V_M4_M1_MASK }, // 794
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x0, 0x3, PseudoVLOXSEG5EI8_V_M8_M1_MASK }, // 795
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x0, 0x5, PseudoVLOXSEG5EI8_V_MF8_M1_MASK }, // 796
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x0, 0x6, PseudoVLOXSEG5EI8_V_MF4_M1_MASK }, // 797
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x0, 0x7, PseudoVLOXSEG5EI8_V_MF2_M1_MASK }, // 798
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x5, 0x0, PseudoVLOXSEG5EI8_V_M1_MF8_MASK }, // 799
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x5, 0x1, PseudoVLOXSEG5EI8_V_M2_MF8_MASK }, // 800
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x5, 0x2, PseudoVLOXSEG5EI8_V_M4_MF8_MASK }, // 801
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x5, 0x3, PseudoVLOXSEG5EI8_V_M8_MF8_MASK }, // 802
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x5, 0x5, PseudoVLOXSEG5EI8_V_MF8_MF8_MASK }, // 803
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x5, 0x6, PseudoVLOXSEG5EI8_V_MF4_MF8_MASK }, // 804
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x5, 0x7, PseudoVLOXSEG5EI8_V_MF2_MF8_MASK }, // 805
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x6, 0x0, PseudoVLOXSEG5EI8_V_M1_MF4_MASK }, // 806
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x6, 0x1, PseudoVLOXSEG5EI8_V_M2_MF4_MASK }, // 807
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x6, 0x2, PseudoVLOXSEG5EI8_V_M4_MF4_MASK }, // 808
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x6, 0x3, PseudoVLOXSEG5EI8_V_M8_MF4_MASK }, // 809
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x6, 0x5, PseudoVLOXSEG5EI8_V_MF8_MF4_MASK }, // 810
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x6, 0x6, PseudoVLOXSEG5EI8_V_MF4_MF4_MASK }, // 811
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x6, 0x7, PseudoVLOXSEG5EI8_V_MF2_MF4_MASK }, // 812
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x7, 0x0, PseudoVLOXSEG5EI8_V_M1_MF2_MASK }, // 813
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x7, 0x1, PseudoVLOXSEG5EI8_V_M2_MF2_MASK }, // 814
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x7, 0x2, PseudoVLOXSEG5EI8_V_M4_MF2_MASK }, // 815
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x7, 0x3, PseudoVLOXSEG5EI8_V_M8_MF2_MASK }, // 816
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x7, 0x5, PseudoVLOXSEG5EI8_V_MF8_MF2_MASK }, // 817
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x7, 0x6, PseudoVLOXSEG5EI8_V_MF4_MF2_MASK }, // 818
  { Intrinsic::riscv_vloxseg5_mask, 0x8, 0x7, 0x7, PseudoVLOXSEG5EI8_V_MF2_MF2_MASK }, // 819
  { Intrinsic::riscv_vloxseg5_mask, 0x10, 0x0, 0x0, PseudoVLOXSEG5EI16_V_M1_M1_MASK }, // 820
  { Intrinsic::riscv_vloxseg5_mask, 0x10, 0x0, 0x1, PseudoVLOXSEG5EI16_V_M2_M1_MASK }, // 821
  { Intrinsic::riscv_vloxseg5_mask, 0x10, 0x0, 0x2, PseudoVLOXSEG5EI16_V_M4_M1_MASK }, // 822
  { Intrinsic::riscv_vloxseg5_mask, 0x10, 0x0, 0x3, PseudoVLOXSEG5EI16_V_M8_M1_MASK }, // 823
  { Intrinsic::riscv_vloxseg5_mask, 0x10, 0x0, 0x6, PseudoVLOXSEG5EI16_V_MF4_M1_MASK }, // 824
  { Intrinsic::riscv_vloxseg5_mask, 0x10, 0x0, 0x7, PseudoVLOXSEG5EI16_V_MF2_M1_MASK }, // 825
  { Intrinsic::riscv_vloxseg5_mask, 0x10, 0x5, 0x0, PseudoVLOXSEG5EI16_V_M1_MF8_MASK }, // 826
  { Intrinsic::riscv_vloxseg5_mask, 0x10, 0x5, 0x1, PseudoVLOXSEG5EI16_V_M2_MF8_MASK }, // 827
  { Intrinsic::riscv_vloxseg5_mask, 0x10, 0x5, 0x2, PseudoVLOXSEG5EI16_V_M4_MF8_MASK }, // 828
  { Intrinsic::riscv_vloxseg5_mask, 0x10, 0x5, 0x3, PseudoVLOXSEG5EI16_V_M8_MF8_MASK }, // 829
  { Intrinsic::riscv_vloxseg5_mask, 0x10, 0x5, 0x6, PseudoVLOXSEG5EI16_V_MF4_MF8_MASK }, // 830
  { Intrinsic::riscv_vloxseg5_mask, 0x10, 0x5, 0x7, PseudoVLOXSEG5EI16_V_MF2_MF8_MASK }, // 831
  { Intrinsic::riscv_vloxseg5_mask, 0x10, 0x6, 0x0, PseudoVLOXSEG5EI16_V_M1_MF4_MASK }, // 832
  { Intrinsic::riscv_vloxseg5_mask, 0x10, 0x6, 0x1, PseudoVLOXSEG5EI16_V_M2_MF4_MASK }, // 833
  { Intrinsic::riscv_vloxseg5_mask, 0x10, 0x6, 0x2, PseudoVLOXSEG5EI16_V_M4_MF4_MASK }, // 834
  { Intrinsic::riscv_vloxseg5_mask, 0x10, 0x6, 0x3, PseudoVLOXSEG5EI16_V_M8_MF4_MASK }, // 835
  { Intrinsic::riscv_vloxseg5_mask, 0x10, 0x6, 0x6, PseudoVLOXSEG5EI16_V_MF4_MF4_MASK }, // 836
  { Intrinsic::riscv_vloxseg5_mask, 0x10, 0x6, 0x7, PseudoVLOXSEG5EI16_V_MF2_MF4_MASK }, // 837
  { Intrinsic::riscv_vloxseg5_mask, 0x10, 0x7, 0x0, PseudoVLOXSEG5EI16_V_M1_MF2_MASK }, // 838
  { Intrinsic::riscv_vloxseg5_mask, 0x10, 0x7, 0x1, PseudoVLOXSEG5EI16_V_M2_MF2_MASK }, // 839
  { Intrinsic::riscv_vloxseg5_mask, 0x10, 0x7, 0x2, PseudoVLOXSEG5EI16_V_M4_MF2_MASK }, // 840
  { Intrinsic::riscv_vloxseg5_mask, 0x10, 0x7, 0x3, PseudoVLOXSEG5EI16_V_M8_MF2_MASK }, // 841
  { Intrinsic::riscv_vloxseg5_mask, 0x10, 0x7, 0x6, PseudoVLOXSEG5EI16_V_MF4_MF2_MASK }, // 842
  { Intrinsic::riscv_vloxseg5_mask, 0x10, 0x7, 0x7, PseudoVLOXSEG5EI16_V_MF2_MF2_MASK }, // 843
  { Intrinsic::riscv_vloxseg5_mask, 0x20, 0x0, 0x0, PseudoVLOXSEG5EI32_V_M1_M1_MASK }, // 844
  { Intrinsic::riscv_vloxseg5_mask, 0x20, 0x0, 0x1, PseudoVLOXSEG5EI32_V_M2_M1_MASK }, // 845
  { Intrinsic::riscv_vloxseg5_mask, 0x20, 0x0, 0x2, PseudoVLOXSEG5EI32_V_M4_M1_MASK }, // 846
  { Intrinsic::riscv_vloxseg5_mask, 0x20, 0x0, 0x3, PseudoVLOXSEG5EI32_V_M8_M1_MASK }, // 847
  { Intrinsic::riscv_vloxseg5_mask, 0x20, 0x0, 0x7, PseudoVLOXSEG5EI32_V_MF2_M1_MASK }, // 848
  { Intrinsic::riscv_vloxseg5_mask, 0x20, 0x5, 0x0, PseudoVLOXSEG5EI32_V_M1_MF8_MASK }, // 849
  { Intrinsic::riscv_vloxseg5_mask, 0x20, 0x5, 0x1, PseudoVLOXSEG5EI32_V_M2_MF8_MASK }, // 850
  { Intrinsic::riscv_vloxseg5_mask, 0x20, 0x5, 0x2, PseudoVLOXSEG5EI32_V_M4_MF8_MASK }, // 851
  { Intrinsic::riscv_vloxseg5_mask, 0x20, 0x5, 0x3, PseudoVLOXSEG5EI32_V_M8_MF8_MASK }, // 852
  { Intrinsic::riscv_vloxseg5_mask, 0x20, 0x5, 0x7, PseudoVLOXSEG5EI32_V_MF2_MF8_MASK }, // 853
  { Intrinsic::riscv_vloxseg5_mask, 0x20, 0x6, 0x0, PseudoVLOXSEG5EI32_V_M1_MF4_MASK }, // 854
  { Intrinsic::riscv_vloxseg5_mask, 0x20, 0x6, 0x1, PseudoVLOXSEG5EI32_V_M2_MF4_MASK }, // 855
  { Intrinsic::riscv_vloxseg5_mask, 0x20, 0x6, 0x2, PseudoVLOXSEG5EI32_V_M4_MF4_MASK }, // 856
  { Intrinsic::riscv_vloxseg5_mask, 0x20, 0x6, 0x3, PseudoVLOXSEG5EI32_V_M8_MF4_MASK }, // 857
  { Intrinsic::riscv_vloxseg5_mask, 0x20, 0x6, 0x7, PseudoVLOXSEG5EI32_V_MF2_MF4_MASK }, // 858
  { Intrinsic::riscv_vloxseg5_mask, 0x20, 0x7, 0x0, PseudoVLOXSEG5EI32_V_M1_MF2_MASK }, // 859
  { Intrinsic::riscv_vloxseg5_mask, 0x20, 0x7, 0x1, PseudoVLOXSEG5EI32_V_M2_MF2_MASK }, // 860
  { Intrinsic::riscv_vloxseg5_mask, 0x20, 0x7, 0x2, PseudoVLOXSEG5EI32_V_M4_MF2_MASK }, // 861
  { Intrinsic::riscv_vloxseg5_mask, 0x20, 0x7, 0x3, PseudoVLOXSEG5EI32_V_M8_MF2_MASK }, // 862
  { Intrinsic::riscv_vloxseg5_mask, 0x20, 0x7, 0x7, PseudoVLOXSEG5EI32_V_MF2_MF2_MASK }, // 863
  { Intrinsic::riscv_vloxseg5_mask, 0x40, 0x0, 0x0, PseudoVLOXSEG5EI64_V_M1_M1_MASK }, // 864
  { Intrinsic::riscv_vloxseg5_mask, 0x40, 0x0, 0x1, PseudoVLOXSEG5EI64_V_M2_M1_MASK }, // 865
  { Intrinsic::riscv_vloxseg5_mask, 0x40, 0x0, 0x2, PseudoVLOXSEG5EI64_V_M4_M1_MASK }, // 866
  { Intrinsic::riscv_vloxseg5_mask, 0x40, 0x0, 0x3, PseudoVLOXSEG5EI64_V_M8_M1_MASK }, // 867
  { Intrinsic::riscv_vloxseg5_mask, 0x40, 0x5, 0x0, PseudoVLOXSEG5EI64_V_M1_MF8_MASK }, // 868
  { Intrinsic::riscv_vloxseg5_mask, 0x40, 0x5, 0x1, PseudoVLOXSEG5EI64_V_M2_MF8_MASK }, // 869
  { Intrinsic::riscv_vloxseg5_mask, 0x40, 0x5, 0x2, PseudoVLOXSEG5EI64_V_M4_MF8_MASK }, // 870
  { Intrinsic::riscv_vloxseg5_mask, 0x40, 0x5, 0x3, PseudoVLOXSEG5EI64_V_M8_MF8_MASK }, // 871
  { Intrinsic::riscv_vloxseg5_mask, 0x40, 0x6, 0x0, PseudoVLOXSEG5EI64_V_M1_MF4_MASK }, // 872
  { Intrinsic::riscv_vloxseg5_mask, 0x40, 0x6, 0x1, PseudoVLOXSEG5EI64_V_M2_MF4_MASK }, // 873
  { Intrinsic::riscv_vloxseg5_mask, 0x40, 0x6, 0x2, PseudoVLOXSEG5EI64_V_M4_MF4_MASK }, // 874
  { Intrinsic::riscv_vloxseg5_mask, 0x40, 0x6, 0x3, PseudoVLOXSEG5EI64_V_M8_MF4_MASK }, // 875
  { Intrinsic::riscv_vloxseg5_mask, 0x40, 0x7, 0x0, PseudoVLOXSEG5EI64_V_M1_MF2_MASK }, // 876
  { Intrinsic::riscv_vloxseg5_mask, 0x40, 0x7, 0x1, PseudoVLOXSEG5EI64_V_M2_MF2_MASK }, // 877
  { Intrinsic::riscv_vloxseg5_mask, 0x40, 0x7, 0x2, PseudoVLOXSEG5EI64_V_M4_MF2_MASK }, // 878
  { Intrinsic::riscv_vloxseg5_mask, 0x40, 0x7, 0x3, PseudoVLOXSEG5EI64_V_M8_MF2_MASK }, // 879
  { Intrinsic::riscv_vloxseg6, 0x8, 0x0, 0x0, PseudoVLOXSEG6EI8_V_M1_M1 }, // 880
  { Intrinsic::riscv_vloxseg6, 0x8, 0x0, 0x1, PseudoVLOXSEG6EI8_V_M2_M1 }, // 881
  { Intrinsic::riscv_vloxseg6, 0x8, 0x0, 0x2, PseudoVLOXSEG6EI8_V_M4_M1 }, // 882
  { Intrinsic::riscv_vloxseg6, 0x8, 0x0, 0x3, PseudoVLOXSEG6EI8_V_M8_M1 }, // 883
  { Intrinsic::riscv_vloxseg6, 0x8, 0x0, 0x5, PseudoVLOXSEG6EI8_V_MF8_M1 }, // 884
  { Intrinsic::riscv_vloxseg6, 0x8, 0x0, 0x6, PseudoVLOXSEG6EI8_V_MF4_M1 }, // 885
  { Intrinsic::riscv_vloxseg6, 0x8, 0x0, 0x7, PseudoVLOXSEG6EI8_V_MF2_M1 }, // 886
  { Intrinsic::riscv_vloxseg6, 0x8, 0x5, 0x0, PseudoVLOXSEG6EI8_V_M1_MF8 }, // 887
  { Intrinsic::riscv_vloxseg6, 0x8, 0x5, 0x1, PseudoVLOXSEG6EI8_V_M2_MF8 }, // 888
  { Intrinsic::riscv_vloxseg6, 0x8, 0x5, 0x2, PseudoVLOXSEG6EI8_V_M4_MF8 }, // 889
  { Intrinsic::riscv_vloxseg6, 0x8, 0x5, 0x3, PseudoVLOXSEG6EI8_V_M8_MF8 }, // 890
  { Intrinsic::riscv_vloxseg6, 0x8, 0x5, 0x5, PseudoVLOXSEG6EI8_V_MF8_MF8 }, // 891
  { Intrinsic::riscv_vloxseg6, 0x8, 0x5, 0x6, PseudoVLOXSEG6EI8_V_MF4_MF8 }, // 892
  { Intrinsic::riscv_vloxseg6, 0x8, 0x5, 0x7, PseudoVLOXSEG6EI8_V_MF2_MF8 }, // 893
  { Intrinsic::riscv_vloxseg6, 0x8, 0x6, 0x0, PseudoVLOXSEG6EI8_V_M1_MF4 }, // 894
  { Intrinsic::riscv_vloxseg6, 0x8, 0x6, 0x1, PseudoVLOXSEG6EI8_V_M2_MF4 }, // 895
  { Intrinsic::riscv_vloxseg6, 0x8, 0x6, 0x2, PseudoVLOXSEG6EI8_V_M4_MF4 }, // 896
  { Intrinsic::riscv_vloxseg6, 0x8, 0x6, 0x3, PseudoVLOXSEG6EI8_V_M8_MF4 }, // 897
  { Intrinsic::riscv_vloxseg6, 0x8, 0x6, 0x5, PseudoVLOXSEG6EI8_V_MF8_MF4 }, // 898
  { Intrinsic::riscv_vloxseg6, 0x8, 0x6, 0x6, PseudoVLOXSEG6EI8_V_MF4_MF4 }, // 899
  { Intrinsic::riscv_vloxseg6, 0x8, 0x6, 0x7, PseudoVLOXSEG6EI8_V_MF2_MF4 }, // 900
  { Intrinsic::riscv_vloxseg6, 0x8, 0x7, 0x0, PseudoVLOXSEG6EI8_V_M1_MF2 }, // 901
  { Intrinsic::riscv_vloxseg6, 0x8, 0x7, 0x1, PseudoVLOXSEG6EI8_V_M2_MF2 }, // 902
  { Intrinsic::riscv_vloxseg6, 0x8, 0x7, 0x2, PseudoVLOXSEG6EI8_V_M4_MF2 }, // 903
  { Intrinsic::riscv_vloxseg6, 0x8, 0x7, 0x3, PseudoVLOXSEG6EI8_V_M8_MF2 }, // 904
  { Intrinsic::riscv_vloxseg6, 0x8, 0x7, 0x5, PseudoVLOXSEG6EI8_V_MF8_MF2 }, // 905
  { Intrinsic::riscv_vloxseg6, 0x8, 0x7, 0x6, PseudoVLOXSEG6EI8_V_MF4_MF2 }, // 906
  { Intrinsic::riscv_vloxseg6, 0x8, 0x7, 0x7, PseudoVLOXSEG6EI8_V_MF2_MF2 }, // 907
  { Intrinsic::riscv_vloxseg6, 0x10, 0x0, 0x0, PseudoVLOXSEG6EI16_V_M1_M1 }, // 908
  { Intrinsic::riscv_vloxseg6, 0x10, 0x0, 0x1, PseudoVLOXSEG6EI16_V_M2_M1 }, // 909
  { Intrinsic::riscv_vloxseg6, 0x10, 0x0, 0x2, PseudoVLOXSEG6EI16_V_M4_M1 }, // 910
  { Intrinsic::riscv_vloxseg6, 0x10, 0x0, 0x3, PseudoVLOXSEG6EI16_V_M8_M1 }, // 911
  { Intrinsic::riscv_vloxseg6, 0x10, 0x0, 0x6, PseudoVLOXSEG6EI16_V_MF4_M1 }, // 912
  { Intrinsic::riscv_vloxseg6, 0x10, 0x0, 0x7, PseudoVLOXSEG6EI16_V_MF2_M1 }, // 913
  { Intrinsic::riscv_vloxseg6, 0x10, 0x5, 0x0, PseudoVLOXSEG6EI16_V_M1_MF8 }, // 914
  { Intrinsic::riscv_vloxseg6, 0x10, 0x5, 0x1, PseudoVLOXSEG6EI16_V_M2_MF8 }, // 915
  { Intrinsic::riscv_vloxseg6, 0x10, 0x5, 0x2, PseudoVLOXSEG6EI16_V_M4_MF8 }, // 916
  { Intrinsic::riscv_vloxseg6, 0x10, 0x5, 0x3, PseudoVLOXSEG6EI16_V_M8_MF8 }, // 917
  { Intrinsic::riscv_vloxseg6, 0x10, 0x5, 0x6, PseudoVLOXSEG6EI16_V_MF4_MF8 }, // 918
  { Intrinsic::riscv_vloxseg6, 0x10, 0x5, 0x7, PseudoVLOXSEG6EI16_V_MF2_MF8 }, // 919
  { Intrinsic::riscv_vloxseg6, 0x10, 0x6, 0x0, PseudoVLOXSEG6EI16_V_M1_MF4 }, // 920
  { Intrinsic::riscv_vloxseg6, 0x10, 0x6, 0x1, PseudoVLOXSEG6EI16_V_M2_MF4 }, // 921
  { Intrinsic::riscv_vloxseg6, 0x10, 0x6, 0x2, PseudoVLOXSEG6EI16_V_M4_MF4 }, // 922
  { Intrinsic::riscv_vloxseg6, 0x10, 0x6, 0x3, PseudoVLOXSEG6EI16_V_M8_MF4 }, // 923
  { Intrinsic::riscv_vloxseg6, 0x10, 0x6, 0x6, PseudoVLOXSEG6EI16_V_MF4_MF4 }, // 924
  { Intrinsic::riscv_vloxseg6, 0x10, 0x6, 0x7, PseudoVLOXSEG6EI16_V_MF2_MF4 }, // 925
  { Intrinsic::riscv_vloxseg6, 0x10, 0x7, 0x0, PseudoVLOXSEG6EI16_V_M1_MF2 }, // 926
  { Intrinsic::riscv_vloxseg6, 0x10, 0x7, 0x1, PseudoVLOXSEG6EI16_V_M2_MF2 }, // 927
  { Intrinsic::riscv_vloxseg6, 0x10, 0x7, 0x2, PseudoVLOXSEG6EI16_V_M4_MF2 }, // 928
  { Intrinsic::riscv_vloxseg6, 0x10, 0x7, 0x3, PseudoVLOXSEG6EI16_V_M8_MF2 }, // 929
  { Intrinsic::riscv_vloxseg6, 0x10, 0x7, 0x6, PseudoVLOXSEG6EI16_V_MF4_MF2 }, // 930
  { Intrinsic::riscv_vloxseg6, 0x10, 0x7, 0x7, PseudoVLOXSEG6EI16_V_MF2_MF2 }, // 931
  { Intrinsic::riscv_vloxseg6, 0x20, 0x0, 0x0, PseudoVLOXSEG6EI32_V_M1_M1 }, // 932
  { Intrinsic::riscv_vloxseg6, 0x20, 0x0, 0x1, PseudoVLOXSEG6EI32_V_M2_M1 }, // 933
  { Intrinsic::riscv_vloxseg6, 0x20, 0x0, 0x2, PseudoVLOXSEG6EI32_V_M4_M1 }, // 934
  { Intrinsic::riscv_vloxseg6, 0x20, 0x0, 0x3, PseudoVLOXSEG6EI32_V_M8_M1 }, // 935
  { Intrinsic::riscv_vloxseg6, 0x20, 0x0, 0x7, PseudoVLOXSEG6EI32_V_MF2_M1 }, // 936
  { Intrinsic::riscv_vloxseg6, 0x20, 0x5, 0x0, PseudoVLOXSEG6EI32_V_M1_MF8 }, // 937
  { Intrinsic::riscv_vloxseg6, 0x20, 0x5, 0x1, PseudoVLOXSEG6EI32_V_M2_MF8 }, // 938
  { Intrinsic::riscv_vloxseg6, 0x20, 0x5, 0x2, PseudoVLOXSEG6EI32_V_M4_MF8 }, // 939
  { Intrinsic::riscv_vloxseg6, 0x20, 0x5, 0x3, PseudoVLOXSEG6EI32_V_M8_MF8 }, // 940
  { Intrinsic::riscv_vloxseg6, 0x20, 0x5, 0x7, PseudoVLOXSEG6EI32_V_MF2_MF8 }, // 941
  { Intrinsic::riscv_vloxseg6, 0x20, 0x6, 0x0, PseudoVLOXSEG6EI32_V_M1_MF4 }, // 942
  { Intrinsic::riscv_vloxseg6, 0x20, 0x6, 0x1, PseudoVLOXSEG6EI32_V_M2_MF4 }, // 943
  { Intrinsic::riscv_vloxseg6, 0x20, 0x6, 0x2, PseudoVLOXSEG6EI32_V_M4_MF4 }, // 944
  { Intrinsic::riscv_vloxseg6, 0x20, 0x6, 0x3, PseudoVLOXSEG6EI32_V_M8_MF4 }, // 945
  { Intrinsic::riscv_vloxseg6, 0x20, 0x6, 0x7, PseudoVLOXSEG6EI32_V_MF2_MF4 }, // 946
  { Intrinsic::riscv_vloxseg6, 0x20, 0x7, 0x0, PseudoVLOXSEG6EI32_V_M1_MF2 }, // 947
  { Intrinsic::riscv_vloxseg6, 0x20, 0x7, 0x1, PseudoVLOXSEG6EI32_V_M2_MF2 }, // 948
  { Intrinsic::riscv_vloxseg6, 0x20, 0x7, 0x2, PseudoVLOXSEG6EI32_V_M4_MF2 }, // 949
  { Intrinsic::riscv_vloxseg6, 0x20, 0x7, 0x3, PseudoVLOXSEG6EI32_V_M8_MF2 }, // 950
  { Intrinsic::riscv_vloxseg6, 0x20, 0x7, 0x7, PseudoVLOXSEG6EI32_V_MF2_MF2 }, // 951
  { Intrinsic::riscv_vloxseg6, 0x40, 0x0, 0x0, PseudoVLOXSEG6EI64_V_M1_M1 }, // 952
  { Intrinsic::riscv_vloxseg6, 0x40, 0x0, 0x1, PseudoVLOXSEG6EI64_V_M2_M1 }, // 953
  { Intrinsic::riscv_vloxseg6, 0x40, 0x0, 0x2, PseudoVLOXSEG6EI64_V_M4_M1 }, // 954
  { Intrinsic::riscv_vloxseg6, 0x40, 0x0, 0x3, PseudoVLOXSEG6EI64_V_M8_M1 }, // 955
  { Intrinsic::riscv_vloxseg6, 0x40, 0x5, 0x0, PseudoVLOXSEG6EI64_V_M1_MF8 }, // 956
  { Intrinsic::riscv_vloxseg6, 0x40, 0x5, 0x1, PseudoVLOXSEG6EI64_V_M2_MF8 }, // 957
  { Intrinsic::riscv_vloxseg6, 0x40, 0x5, 0x2, PseudoVLOXSEG6EI64_V_M4_MF8 }, // 958
  { Intrinsic::riscv_vloxseg6, 0x40, 0x5, 0x3, PseudoVLOXSEG6EI64_V_M8_MF8 }, // 959
  { Intrinsic::riscv_vloxseg6, 0x40, 0x6, 0x0, PseudoVLOXSEG6EI64_V_M1_MF4 }, // 960
  { Intrinsic::riscv_vloxseg6, 0x40, 0x6, 0x1, PseudoVLOXSEG6EI64_V_M2_MF4 }, // 961
  { Intrinsic::riscv_vloxseg6, 0x40, 0x6, 0x2, PseudoVLOXSEG6EI64_V_M4_MF4 }, // 962
  { Intrinsic::riscv_vloxseg6, 0x40, 0x6, 0x3, PseudoVLOXSEG6EI64_V_M8_MF4 }, // 963
  { Intrinsic::riscv_vloxseg6, 0x40, 0x7, 0x0, PseudoVLOXSEG6EI64_V_M1_MF2 }, // 964
  { Intrinsic::riscv_vloxseg6, 0x40, 0x7, 0x1, PseudoVLOXSEG6EI64_V_M2_MF2 }, // 965
  { Intrinsic::riscv_vloxseg6, 0x40, 0x7, 0x2, PseudoVLOXSEG6EI64_V_M4_MF2 }, // 966
  { Intrinsic::riscv_vloxseg6, 0x40, 0x7, 0x3, PseudoVLOXSEG6EI64_V_M8_MF2 }, // 967
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x0, 0x0, PseudoVLOXSEG6EI8_V_M1_M1_MASK }, // 968
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x0, 0x1, PseudoVLOXSEG6EI8_V_M2_M1_MASK }, // 969
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x0, 0x2, PseudoVLOXSEG6EI8_V_M4_M1_MASK }, // 970
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x0, 0x3, PseudoVLOXSEG6EI8_V_M8_M1_MASK }, // 971
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x0, 0x5, PseudoVLOXSEG6EI8_V_MF8_M1_MASK }, // 972
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x0, 0x6, PseudoVLOXSEG6EI8_V_MF4_M1_MASK }, // 973
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x0, 0x7, PseudoVLOXSEG6EI8_V_MF2_M1_MASK }, // 974
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x5, 0x0, PseudoVLOXSEG6EI8_V_M1_MF8_MASK }, // 975
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x5, 0x1, PseudoVLOXSEG6EI8_V_M2_MF8_MASK }, // 976
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x5, 0x2, PseudoVLOXSEG6EI8_V_M4_MF8_MASK }, // 977
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x5, 0x3, PseudoVLOXSEG6EI8_V_M8_MF8_MASK }, // 978
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x5, 0x5, PseudoVLOXSEG6EI8_V_MF8_MF8_MASK }, // 979
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x5, 0x6, PseudoVLOXSEG6EI8_V_MF4_MF8_MASK }, // 980
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x5, 0x7, PseudoVLOXSEG6EI8_V_MF2_MF8_MASK }, // 981
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x6, 0x0, PseudoVLOXSEG6EI8_V_M1_MF4_MASK }, // 982
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x6, 0x1, PseudoVLOXSEG6EI8_V_M2_MF4_MASK }, // 983
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x6, 0x2, PseudoVLOXSEG6EI8_V_M4_MF4_MASK }, // 984
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x6, 0x3, PseudoVLOXSEG6EI8_V_M8_MF4_MASK }, // 985
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x6, 0x5, PseudoVLOXSEG6EI8_V_MF8_MF4_MASK }, // 986
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x6, 0x6, PseudoVLOXSEG6EI8_V_MF4_MF4_MASK }, // 987
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x6, 0x7, PseudoVLOXSEG6EI8_V_MF2_MF4_MASK }, // 988
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x7, 0x0, PseudoVLOXSEG6EI8_V_M1_MF2_MASK }, // 989
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x7, 0x1, PseudoVLOXSEG6EI8_V_M2_MF2_MASK }, // 990
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x7, 0x2, PseudoVLOXSEG6EI8_V_M4_MF2_MASK }, // 991
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x7, 0x3, PseudoVLOXSEG6EI8_V_M8_MF2_MASK }, // 992
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x7, 0x5, PseudoVLOXSEG6EI8_V_MF8_MF2_MASK }, // 993
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x7, 0x6, PseudoVLOXSEG6EI8_V_MF4_MF2_MASK }, // 994
  { Intrinsic::riscv_vloxseg6_mask, 0x8, 0x7, 0x7, PseudoVLOXSEG6EI8_V_MF2_MF2_MASK }, // 995
  { Intrinsic::riscv_vloxseg6_mask, 0x10, 0x0, 0x0, PseudoVLOXSEG6EI16_V_M1_M1_MASK }, // 996
  { Intrinsic::riscv_vloxseg6_mask, 0x10, 0x0, 0x1, PseudoVLOXSEG6EI16_V_M2_M1_MASK }, // 997
  { Intrinsic::riscv_vloxseg6_mask, 0x10, 0x0, 0x2, PseudoVLOXSEG6EI16_V_M4_M1_MASK }, // 998
  { Intrinsic::riscv_vloxseg6_mask, 0x10, 0x0, 0x3, PseudoVLOXSEG6EI16_V_M8_M1_MASK }, // 999
  { Intrinsic::riscv_vloxseg6_mask, 0x10, 0x0, 0x6, PseudoVLOXSEG6EI16_V_MF4_M1_MASK }, // 1000
  { Intrinsic::riscv_vloxseg6_mask, 0x10, 0x0, 0x7, PseudoVLOXSEG6EI16_V_MF2_M1_MASK }, // 1001
  { Intrinsic::riscv_vloxseg6_mask, 0x10, 0x5, 0x0, PseudoVLOXSEG6EI16_V_M1_MF8_MASK }, // 1002
  { Intrinsic::riscv_vloxseg6_mask, 0x10, 0x5, 0x1, PseudoVLOXSEG6EI16_V_M2_MF8_MASK }, // 1003
  { Intrinsic::riscv_vloxseg6_mask, 0x10, 0x5, 0x2, PseudoVLOXSEG6EI16_V_M4_MF8_MASK }, // 1004
  { Intrinsic::riscv_vloxseg6_mask, 0x10, 0x5, 0x3, PseudoVLOXSEG6EI16_V_M8_MF8_MASK }, // 1005
  { Intrinsic::riscv_vloxseg6_mask, 0x10, 0x5, 0x6, PseudoVLOXSEG6EI16_V_MF4_MF8_MASK }, // 1006
  { Intrinsic::riscv_vloxseg6_mask, 0x10, 0x5, 0x7, PseudoVLOXSEG6EI16_V_MF2_MF8_MASK }, // 1007
  { Intrinsic::riscv_vloxseg6_mask, 0x10, 0x6, 0x0, PseudoVLOXSEG6EI16_V_M1_MF4_MASK }, // 1008
  { Intrinsic::riscv_vloxseg6_mask, 0x10, 0x6, 0x1, PseudoVLOXSEG6EI16_V_M2_MF4_MASK }, // 1009
  { Intrinsic::riscv_vloxseg6_mask, 0x10, 0x6, 0x2, PseudoVLOXSEG6EI16_V_M4_MF4_MASK }, // 1010
  { Intrinsic::riscv_vloxseg6_mask, 0x10, 0x6, 0x3, PseudoVLOXSEG6EI16_V_M8_MF4_MASK }, // 1011
  { Intrinsic::riscv_vloxseg6_mask, 0x10, 0x6, 0x6, PseudoVLOXSEG6EI16_V_MF4_MF4_MASK }, // 1012
  { Intrinsic::riscv_vloxseg6_mask, 0x10, 0x6, 0x7, PseudoVLOXSEG6EI16_V_MF2_MF4_MASK }, // 1013
  { Intrinsic::riscv_vloxseg6_mask, 0x10, 0x7, 0x0, PseudoVLOXSEG6EI16_V_M1_MF2_MASK }, // 1014
  { Intrinsic::riscv_vloxseg6_mask, 0x10, 0x7, 0x1, PseudoVLOXSEG6EI16_V_M2_MF2_MASK }, // 1015
  { Intrinsic::riscv_vloxseg6_mask, 0x10, 0x7, 0x2, PseudoVLOXSEG6EI16_V_M4_MF2_MASK }, // 1016
  { Intrinsic::riscv_vloxseg6_mask, 0x10, 0x7, 0x3, PseudoVLOXSEG6EI16_V_M8_MF2_MASK }, // 1017
  { Intrinsic::riscv_vloxseg6_mask, 0x10, 0x7, 0x6, PseudoVLOXSEG6EI16_V_MF4_MF2_MASK }, // 1018
  { Intrinsic::riscv_vloxseg6_mask, 0x10, 0x7, 0x7, PseudoVLOXSEG6EI16_V_MF2_MF2_MASK }, // 1019
  { Intrinsic::riscv_vloxseg6_mask, 0x20, 0x0, 0x0, PseudoVLOXSEG6EI32_V_M1_M1_MASK }, // 1020
  { Intrinsic::riscv_vloxseg6_mask, 0x20, 0x0, 0x1, PseudoVLOXSEG6EI32_V_M2_M1_MASK }, // 1021
  { Intrinsic::riscv_vloxseg6_mask, 0x20, 0x0, 0x2, PseudoVLOXSEG6EI32_V_M4_M1_MASK }, // 1022
  { Intrinsic::riscv_vloxseg6_mask, 0x20, 0x0, 0x3, PseudoVLOXSEG6EI32_V_M8_M1_MASK }, // 1023
  { Intrinsic::riscv_vloxseg6_mask, 0x20, 0x0, 0x7, PseudoVLOXSEG6EI32_V_MF2_M1_MASK }, // 1024
  { Intrinsic::riscv_vloxseg6_mask, 0x20, 0x5, 0x0, PseudoVLOXSEG6EI32_V_M1_MF8_MASK }, // 1025
  { Intrinsic::riscv_vloxseg6_mask, 0x20, 0x5, 0x1, PseudoVLOXSEG6EI32_V_M2_MF8_MASK }, // 1026
  { Intrinsic::riscv_vloxseg6_mask, 0x20, 0x5, 0x2, PseudoVLOXSEG6EI32_V_M4_MF8_MASK }, // 1027
  { Intrinsic::riscv_vloxseg6_mask, 0x20, 0x5, 0x3, PseudoVLOXSEG6EI32_V_M8_MF8_MASK }, // 1028
  { Intrinsic::riscv_vloxseg6_mask, 0x20, 0x5, 0x7, PseudoVLOXSEG6EI32_V_MF2_MF8_MASK }, // 1029
  { Intrinsic::riscv_vloxseg6_mask, 0x20, 0x6, 0x0, PseudoVLOXSEG6EI32_V_M1_MF4_MASK }, // 1030
  { Intrinsic::riscv_vloxseg6_mask, 0x20, 0x6, 0x1, PseudoVLOXSEG6EI32_V_M2_MF4_MASK }, // 1031
  { Intrinsic::riscv_vloxseg6_mask, 0x20, 0x6, 0x2, PseudoVLOXSEG6EI32_V_M4_MF4_MASK }, // 1032
  { Intrinsic::riscv_vloxseg6_mask, 0x20, 0x6, 0x3, PseudoVLOXSEG6EI32_V_M8_MF4_MASK }, // 1033
  { Intrinsic::riscv_vloxseg6_mask, 0x20, 0x6, 0x7, PseudoVLOXSEG6EI32_V_MF2_MF4_MASK }, // 1034
  { Intrinsic::riscv_vloxseg6_mask, 0x20, 0x7, 0x0, PseudoVLOXSEG6EI32_V_M1_MF2_MASK }, // 1035
  { Intrinsic::riscv_vloxseg6_mask, 0x20, 0x7, 0x1, PseudoVLOXSEG6EI32_V_M2_MF2_MASK }, // 1036
  { Intrinsic::riscv_vloxseg6_mask, 0x20, 0x7, 0x2, PseudoVLOXSEG6EI32_V_M4_MF2_MASK }, // 1037
  { Intrinsic::riscv_vloxseg6_mask, 0x20, 0x7, 0x3, PseudoVLOXSEG6EI32_V_M8_MF2_MASK }, // 1038
  { Intrinsic::riscv_vloxseg6_mask, 0x20, 0x7, 0x7, PseudoVLOXSEG6EI32_V_MF2_MF2_MASK }, // 1039
  { Intrinsic::riscv_vloxseg6_mask, 0x40, 0x0, 0x0, PseudoVLOXSEG6EI64_V_M1_M1_MASK }, // 1040
  { Intrinsic::riscv_vloxseg6_mask, 0x40, 0x0, 0x1, PseudoVLOXSEG6EI64_V_M2_M1_MASK }, // 1041
  { Intrinsic::riscv_vloxseg6_mask, 0x40, 0x0, 0x2, PseudoVLOXSEG6EI64_V_M4_M1_MASK }, // 1042
  { Intrinsic::riscv_vloxseg6_mask, 0x40, 0x0, 0x3, PseudoVLOXSEG6EI64_V_M8_M1_MASK }, // 1043
  { Intrinsic::riscv_vloxseg6_mask, 0x40, 0x5, 0x0, PseudoVLOXSEG6EI64_V_M1_MF8_MASK }, // 1044
  { Intrinsic::riscv_vloxseg6_mask, 0x40, 0x5, 0x1, PseudoVLOXSEG6EI64_V_M2_MF8_MASK }, // 1045
  { Intrinsic::riscv_vloxseg6_mask, 0x40, 0x5, 0x2, PseudoVLOXSEG6EI64_V_M4_MF8_MASK }, // 1046
  { Intrinsic::riscv_vloxseg6_mask, 0x40, 0x5, 0x3, PseudoVLOXSEG6EI64_V_M8_MF8_MASK }, // 1047
  { Intrinsic::riscv_vloxseg6_mask, 0x40, 0x6, 0x0, PseudoVLOXSEG6EI64_V_M1_MF4_MASK }, // 1048
  { Intrinsic::riscv_vloxseg6_mask, 0x40, 0x6, 0x1, PseudoVLOXSEG6EI64_V_M2_MF4_MASK }, // 1049
  { Intrinsic::riscv_vloxseg6_mask, 0x40, 0x6, 0x2, PseudoVLOXSEG6EI64_V_M4_MF4_MASK }, // 1050
  { Intrinsic::riscv_vloxseg6_mask, 0x40, 0x6, 0x3, PseudoVLOXSEG6EI64_V_M8_MF4_MASK }, // 1051
  { Intrinsic::riscv_vloxseg6_mask, 0x40, 0x7, 0x0, PseudoVLOXSEG6EI64_V_M1_MF2_MASK }, // 1052
  { Intrinsic::riscv_vloxseg6_mask, 0x40, 0x7, 0x1, PseudoVLOXSEG6EI64_V_M2_MF2_MASK }, // 1053
  { Intrinsic::riscv_vloxseg6_mask, 0x40, 0x7, 0x2, PseudoVLOXSEG6EI64_V_M4_MF2_MASK }, // 1054
  { Intrinsic::riscv_vloxseg6_mask, 0x40, 0x7, 0x3, PseudoVLOXSEG6EI64_V_M8_MF2_MASK }, // 1055
  { Intrinsic::riscv_vloxseg7, 0x8, 0x0, 0x0, PseudoVLOXSEG7EI8_V_M1_M1 }, // 1056
  { Intrinsic::riscv_vloxseg7, 0x8, 0x0, 0x1, PseudoVLOXSEG7EI8_V_M2_M1 }, // 1057
  { Intrinsic::riscv_vloxseg7, 0x8, 0x0, 0x2, PseudoVLOXSEG7EI8_V_M4_M1 }, // 1058
  { Intrinsic::riscv_vloxseg7, 0x8, 0x0, 0x3, PseudoVLOXSEG7EI8_V_M8_M1 }, // 1059
  { Intrinsic::riscv_vloxseg7, 0x8, 0x0, 0x5, PseudoVLOXSEG7EI8_V_MF8_M1 }, // 1060
  { Intrinsic::riscv_vloxseg7, 0x8, 0x0, 0x6, PseudoVLOXSEG7EI8_V_MF4_M1 }, // 1061
  { Intrinsic::riscv_vloxseg7, 0x8, 0x0, 0x7, PseudoVLOXSEG7EI8_V_MF2_M1 }, // 1062
  { Intrinsic::riscv_vloxseg7, 0x8, 0x5, 0x0, PseudoVLOXSEG7EI8_V_M1_MF8 }, // 1063
  { Intrinsic::riscv_vloxseg7, 0x8, 0x5, 0x1, PseudoVLOXSEG7EI8_V_M2_MF8 }, // 1064
  { Intrinsic::riscv_vloxseg7, 0x8, 0x5, 0x2, PseudoVLOXSEG7EI8_V_M4_MF8 }, // 1065
  { Intrinsic::riscv_vloxseg7, 0x8, 0x5, 0x3, PseudoVLOXSEG7EI8_V_M8_MF8 }, // 1066
  { Intrinsic::riscv_vloxseg7, 0x8, 0x5, 0x5, PseudoVLOXSEG7EI8_V_MF8_MF8 }, // 1067
  { Intrinsic::riscv_vloxseg7, 0x8, 0x5, 0x6, PseudoVLOXSEG7EI8_V_MF4_MF8 }, // 1068
  { Intrinsic::riscv_vloxseg7, 0x8, 0x5, 0x7, PseudoVLOXSEG7EI8_V_MF2_MF8 }, // 1069
  { Intrinsic::riscv_vloxseg7, 0x8, 0x6, 0x0, PseudoVLOXSEG7EI8_V_M1_MF4 }, // 1070
  { Intrinsic::riscv_vloxseg7, 0x8, 0x6, 0x1, PseudoVLOXSEG7EI8_V_M2_MF4 }, // 1071
  { Intrinsic::riscv_vloxseg7, 0x8, 0x6, 0x2, PseudoVLOXSEG7EI8_V_M4_MF4 }, // 1072
  { Intrinsic::riscv_vloxseg7, 0x8, 0x6, 0x3, PseudoVLOXSEG7EI8_V_M8_MF4 }, // 1073
  { Intrinsic::riscv_vloxseg7, 0x8, 0x6, 0x5, PseudoVLOXSEG7EI8_V_MF8_MF4 }, // 1074
  { Intrinsic::riscv_vloxseg7, 0x8, 0x6, 0x6, PseudoVLOXSEG7EI8_V_MF4_MF4 }, // 1075
  { Intrinsic::riscv_vloxseg7, 0x8, 0x6, 0x7, PseudoVLOXSEG7EI8_V_MF2_MF4 }, // 1076
  { Intrinsic::riscv_vloxseg7, 0x8, 0x7, 0x0, PseudoVLOXSEG7EI8_V_M1_MF2 }, // 1077
  { Intrinsic::riscv_vloxseg7, 0x8, 0x7, 0x1, PseudoVLOXSEG7EI8_V_M2_MF2 }, // 1078
  { Intrinsic::riscv_vloxseg7, 0x8, 0x7, 0x2, PseudoVLOXSEG7EI8_V_M4_MF2 }, // 1079
  { Intrinsic::riscv_vloxseg7, 0x8, 0x7, 0x3, PseudoVLOXSEG7EI8_V_M8_MF2 }, // 1080
  { Intrinsic::riscv_vloxseg7, 0x8, 0x7, 0x5, PseudoVLOXSEG7EI8_V_MF8_MF2 }, // 1081
  { Intrinsic::riscv_vloxseg7, 0x8, 0x7, 0x6, PseudoVLOXSEG7EI8_V_MF4_MF2 }, // 1082
  { Intrinsic::riscv_vloxseg7, 0x8, 0x7, 0x7, PseudoVLOXSEG7EI8_V_MF2_MF2 }, // 1083
  { Intrinsic::riscv_vloxseg7, 0x10, 0x0, 0x0, PseudoVLOXSEG7EI16_V_M1_M1 }, // 1084
  { Intrinsic::riscv_vloxseg7, 0x10, 0x0, 0x1, PseudoVLOXSEG7EI16_V_M2_M1 }, // 1085
  { Intrinsic::riscv_vloxseg7, 0x10, 0x0, 0x2, PseudoVLOXSEG7EI16_V_M4_M1 }, // 1086
  { Intrinsic::riscv_vloxseg7, 0x10, 0x0, 0x3, PseudoVLOXSEG7EI16_V_M8_M1 }, // 1087
  { Intrinsic::riscv_vloxseg7, 0x10, 0x0, 0x6, PseudoVLOXSEG7EI16_V_MF4_M1 }, // 1088
  { Intrinsic::riscv_vloxseg7, 0x10, 0x0, 0x7, PseudoVLOXSEG7EI16_V_MF2_M1 }, // 1089
  { Intrinsic::riscv_vloxseg7, 0x10, 0x5, 0x0, PseudoVLOXSEG7EI16_V_M1_MF8 }, // 1090
  { Intrinsic::riscv_vloxseg7, 0x10, 0x5, 0x1, PseudoVLOXSEG7EI16_V_M2_MF8 }, // 1091
  { Intrinsic::riscv_vloxseg7, 0x10, 0x5, 0x2, PseudoVLOXSEG7EI16_V_M4_MF8 }, // 1092
  { Intrinsic::riscv_vloxseg7, 0x10, 0x5, 0x3, PseudoVLOXSEG7EI16_V_M8_MF8 }, // 1093
  { Intrinsic::riscv_vloxseg7, 0x10, 0x5, 0x6, PseudoVLOXSEG7EI16_V_MF4_MF8 }, // 1094
  { Intrinsic::riscv_vloxseg7, 0x10, 0x5, 0x7, PseudoVLOXSEG7EI16_V_MF2_MF8 }, // 1095
  { Intrinsic::riscv_vloxseg7, 0x10, 0x6, 0x0, PseudoVLOXSEG7EI16_V_M1_MF4 }, // 1096
  { Intrinsic::riscv_vloxseg7, 0x10, 0x6, 0x1, PseudoVLOXSEG7EI16_V_M2_MF4 }, // 1097
  { Intrinsic::riscv_vloxseg7, 0x10, 0x6, 0x2, PseudoVLOXSEG7EI16_V_M4_MF4 }, // 1098
  { Intrinsic::riscv_vloxseg7, 0x10, 0x6, 0x3, PseudoVLOXSEG7EI16_V_M8_MF4 }, // 1099
  { Intrinsic::riscv_vloxseg7, 0x10, 0x6, 0x6, PseudoVLOXSEG7EI16_V_MF4_MF4 }, // 1100
  { Intrinsic::riscv_vloxseg7, 0x10, 0x6, 0x7, PseudoVLOXSEG7EI16_V_MF2_MF4 }, // 1101
  { Intrinsic::riscv_vloxseg7, 0x10, 0x7, 0x0, PseudoVLOXSEG7EI16_V_M1_MF2 }, // 1102
  { Intrinsic::riscv_vloxseg7, 0x10, 0x7, 0x1, PseudoVLOXSEG7EI16_V_M2_MF2 }, // 1103
  { Intrinsic::riscv_vloxseg7, 0x10, 0x7, 0x2, PseudoVLOXSEG7EI16_V_M4_MF2 }, // 1104
  { Intrinsic::riscv_vloxseg7, 0x10, 0x7, 0x3, PseudoVLOXSEG7EI16_V_M8_MF2 }, // 1105
  { Intrinsic::riscv_vloxseg7, 0x10, 0x7, 0x6, PseudoVLOXSEG7EI16_V_MF4_MF2 }, // 1106
  { Intrinsic::riscv_vloxseg7, 0x10, 0x7, 0x7, PseudoVLOXSEG7EI16_V_MF2_MF2 }, // 1107
  { Intrinsic::riscv_vloxseg7, 0x20, 0x0, 0x0, PseudoVLOXSEG7EI32_V_M1_M1 }, // 1108
  { Intrinsic::riscv_vloxseg7, 0x20, 0x0, 0x1, PseudoVLOXSEG7EI32_V_M2_M1 }, // 1109
  { Intrinsic::riscv_vloxseg7, 0x20, 0x0, 0x2, PseudoVLOXSEG7EI32_V_M4_M1 }, // 1110
  { Intrinsic::riscv_vloxseg7, 0x20, 0x0, 0x3, PseudoVLOXSEG7EI32_V_M8_M1 }, // 1111
  { Intrinsic::riscv_vloxseg7, 0x20, 0x0, 0x7, PseudoVLOXSEG7EI32_V_MF2_M1 }, // 1112
  { Intrinsic::riscv_vloxseg7, 0x20, 0x5, 0x0, PseudoVLOXSEG7EI32_V_M1_MF8 }, // 1113
  { Intrinsic::riscv_vloxseg7, 0x20, 0x5, 0x1, PseudoVLOXSEG7EI32_V_M2_MF8 }, // 1114
  { Intrinsic::riscv_vloxseg7, 0x20, 0x5, 0x2, PseudoVLOXSEG7EI32_V_M4_MF8 }, // 1115
  { Intrinsic::riscv_vloxseg7, 0x20, 0x5, 0x3, PseudoVLOXSEG7EI32_V_M8_MF8 }, // 1116
  { Intrinsic::riscv_vloxseg7, 0x20, 0x5, 0x7, PseudoVLOXSEG7EI32_V_MF2_MF8 }, // 1117
  { Intrinsic::riscv_vloxseg7, 0x20, 0x6, 0x0, PseudoVLOXSEG7EI32_V_M1_MF4 }, // 1118
  { Intrinsic::riscv_vloxseg7, 0x20, 0x6, 0x1, PseudoVLOXSEG7EI32_V_M2_MF4 }, // 1119
  { Intrinsic::riscv_vloxseg7, 0x20, 0x6, 0x2, PseudoVLOXSEG7EI32_V_M4_MF4 }, // 1120
  { Intrinsic::riscv_vloxseg7, 0x20, 0x6, 0x3, PseudoVLOXSEG7EI32_V_M8_MF4 }, // 1121
  { Intrinsic::riscv_vloxseg7, 0x20, 0x6, 0x7, PseudoVLOXSEG7EI32_V_MF2_MF4 }, // 1122
  { Intrinsic::riscv_vloxseg7, 0x20, 0x7, 0x0, PseudoVLOXSEG7EI32_V_M1_MF2 }, // 1123
  { Intrinsic::riscv_vloxseg7, 0x20, 0x7, 0x1, PseudoVLOXSEG7EI32_V_M2_MF2 }, // 1124
  { Intrinsic::riscv_vloxseg7, 0x20, 0x7, 0x2, PseudoVLOXSEG7EI32_V_M4_MF2 }, // 1125
  { Intrinsic::riscv_vloxseg7, 0x20, 0x7, 0x3, PseudoVLOXSEG7EI32_V_M8_MF2 }, // 1126
  { Intrinsic::riscv_vloxseg7, 0x20, 0x7, 0x7, PseudoVLOXSEG7EI32_V_MF2_MF2 }, // 1127
  { Intrinsic::riscv_vloxseg7, 0x40, 0x0, 0x0, PseudoVLOXSEG7EI64_V_M1_M1 }, // 1128
  { Intrinsic::riscv_vloxseg7, 0x40, 0x0, 0x1, PseudoVLOXSEG7EI64_V_M2_M1 }, // 1129
  { Intrinsic::riscv_vloxseg7, 0x40, 0x0, 0x2, PseudoVLOXSEG7EI64_V_M4_M1 }, // 1130
  { Intrinsic::riscv_vloxseg7, 0x40, 0x0, 0x3, PseudoVLOXSEG7EI64_V_M8_M1 }, // 1131
  { Intrinsic::riscv_vloxseg7, 0x40, 0x5, 0x0, PseudoVLOXSEG7EI64_V_M1_MF8 }, // 1132
  { Intrinsic::riscv_vloxseg7, 0x40, 0x5, 0x1, PseudoVLOXSEG7EI64_V_M2_MF8 }, // 1133
  { Intrinsic::riscv_vloxseg7, 0x40, 0x5, 0x2, PseudoVLOXSEG7EI64_V_M4_MF8 }, // 1134
  { Intrinsic::riscv_vloxseg7, 0x40, 0x5, 0x3, PseudoVLOXSEG7EI64_V_M8_MF8 }, // 1135
  { Intrinsic::riscv_vloxseg7, 0x40, 0x6, 0x0, PseudoVLOXSEG7EI64_V_M1_MF4 }, // 1136
  { Intrinsic::riscv_vloxseg7, 0x40, 0x6, 0x1, PseudoVLOXSEG7EI64_V_M2_MF4 }, // 1137
  { Intrinsic::riscv_vloxseg7, 0x40, 0x6, 0x2, PseudoVLOXSEG7EI64_V_M4_MF4 }, // 1138
  { Intrinsic::riscv_vloxseg7, 0x40, 0x6, 0x3, PseudoVLOXSEG7EI64_V_M8_MF4 }, // 1139
  { Intrinsic::riscv_vloxseg7, 0x40, 0x7, 0x0, PseudoVLOXSEG7EI64_V_M1_MF2 }, // 1140
  { Intrinsic::riscv_vloxseg7, 0x40, 0x7, 0x1, PseudoVLOXSEG7EI64_V_M2_MF2 }, // 1141
  { Intrinsic::riscv_vloxseg7, 0x40, 0x7, 0x2, PseudoVLOXSEG7EI64_V_M4_MF2 }, // 1142
  { Intrinsic::riscv_vloxseg7, 0x40, 0x7, 0x3, PseudoVLOXSEG7EI64_V_M8_MF2 }, // 1143
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x0, 0x0, PseudoVLOXSEG7EI8_V_M1_M1_MASK }, // 1144
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x0, 0x1, PseudoVLOXSEG7EI8_V_M2_M1_MASK }, // 1145
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x0, 0x2, PseudoVLOXSEG7EI8_V_M4_M1_MASK }, // 1146
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x0, 0x3, PseudoVLOXSEG7EI8_V_M8_M1_MASK }, // 1147
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x0, 0x5, PseudoVLOXSEG7EI8_V_MF8_M1_MASK }, // 1148
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x0, 0x6, PseudoVLOXSEG7EI8_V_MF4_M1_MASK }, // 1149
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x0, 0x7, PseudoVLOXSEG7EI8_V_MF2_M1_MASK }, // 1150
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x5, 0x0, PseudoVLOXSEG7EI8_V_M1_MF8_MASK }, // 1151
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x5, 0x1, PseudoVLOXSEG7EI8_V_M2_MF8_MASK }, // 1152
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x5, 0x2, PseudoVLOXSEG7EI8_V_M4_MF8_MASK }, // 1153
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x5, 0x3, PseudoVLOXSEG7EI8_V_M8_MF8_MASK }, // 1154
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x5, 0x5, PseudoVLOXSEG7EI8_V_MF8_MF8_MASK }, // 1155
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x5, 0x6, PseudoVLOXSEG7EI8_V_MF4_MF8_MASK }, // 1156
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x5, 0x7, PseudoVLOXSEG7EI8_V_MF2_MF8_MASK }, // 1157
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x6, 0x0, PseudoVLOXSEG7EI8_V_M1_MF4_MASK }, // 1158
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x6, 0x1, PseudoVLOXSEG7EI8_V_M2_MF4_MASK }, // 1159
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x6, 0x2, PseudoVLOXSEG7EI8_V_M4_MF4_MASK }, // 1160
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x6, 0x3, PseudoVLOXSEG7EI8_V_M8_MF4_MASK }, // 1161
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x6, 0x5, PseudoVLOXSEG7EI8_V_MF8_MF4_MASK }, // 1162
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x6, 0x6, PseudoVLOXSEG7EI8_V_MF4_MF4_MASK }, // 1163
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x6, 0x7, PseudoVLOXSEG7EI8_V_MF2_MF4_MASK }, // 1164
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x7, 0x0, PseudoVLOXSEG7EI8_V_M1_MF2_MASK }, // 1165
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x7, 0x1, PseudoVLOXSEG7EI8_V_M2_MF2_MASK }, // 1166
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x7, 0x2, PseudoVLOXSEG7EI8_V_M4_MF2_MASK }, // 1167
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x7, 0x3, PseudoVLOXSEG7EI8_V_M8_MF2_MASK }, // 1168
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x7, 0x5, PseudoVLOXSEG7EI8_V_MF8_MF2_MASK }, // 1169
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x7, 0x6, PseudoVLOXSEG7EI8_V_MF4_MF2_MASK }, // 1170
  { Intrinsic::riscv_vloxseg7_mask, 0x8, 0x7, 0x7, PseudoVLOXSEG7EI8_V_MF2_MF2_MASK }, // 1171
  { Intrinsic::riscv_vloxseg7_mask, 0x10, 0x0, 0x0, PseudoVLOXSEG7EI16_V_M1_M1_MASK }, // 1172
  { Intrinsic::riscv_vloxseg7_mask, 0x10, 0x0, 0x1, PseudoVLOXSEG7EI16_V_M2_M1_MASK }, // 1173
  { Intrinsic::riscv_vloxseg7_mask, 0x10, 0x0, 0x2, PseudoVLOXSEG7EI16_V_M4_M1_MASK }, // 1174
  { Intrinsic::riscv_vloxseg7_mask, 0x10, 0x0, 0x3, PseudoVLOXSEG7EI16_V_M8_M1_MASK }, // 1175
  { Intrinsic::riscv_vloxseg7_mask, 0x10, 0x0, 0x6, PseudoVLOXSEG7EI16_V_MF4_M1_MASK }, // 1176
  { Intrinsic::riscv_vloxseg7_mask, 0x10, 0x0, 0x7, PseudoVLOXSEG7EI16_V_MF2_M1_MASK }, // 1177
  { Intrinsic::riscv_vloxseg7_mask, 0x10, 0x5, 0x0, PseudoVLOXSEG7EI16_V_M1_MF8_MASK }, // 1178
  { Intrinsic::riscv_vloxseg7_mask, 0x10, 0x5, 0x1, PseudoVLOXSEG7EI16_V_M2_MF8_MASK }, // 1179
  { Intrinsic::riscv_vloxseg7_mask, 0x10, 0x5, 0x2, PseudoVLOXSEG7EI16_V_M4_MF8_MASK }, // 1180
  { Intrinsic::riscv_vloxseg7_mask, 0x10, 0x5, 0x3, PseudoVLOXSEG7EI16_V_M8_MF8_MASK }, // 1181
  { Intrinsic::riscv_vloxseg7_mask, 0x10, 0x5, 0x6, PseudoVLOXSEG7EI16_V_MF4_MF8_MASK }, // 1182
  { Intrinsic::riscv_vloxseg7_mask, 0x10, 0x5, 0x7, PseudoVLOXSEG7EI16_V_MF2_MF8_MASK }, // 1183
  { Intrinsic::riscv_vloxseg7_mask, 0x10, 0x6, 0x0, PseudoVLOXSEG7EI16_V_M1_MF4_MASK }, // 1184
  { Intrinsic::riscv_vloxseg7_mask, 0x10, 0x6, 0x1, PseudoVLOXSEG7EI16_V_M2_MF4_MASK }, // 1185
  { Intrinsic::riscv_vloxseg7_mask, 0x10, 0x6, 0x2, PseudoVLOXSEG7EI16_V_M4_MF4_MASK }, // 1186
  { Intrinsic::riscv_vloxseg7_mask, 0x10, 0x6, 0x3, PseudoVLOXSEG7EI16_V_M8_MF4_MASK }, // 1187
  { Intrinsic::riscv_vloxseg7_mask, 0x10, 0x6, 0x6, PseudoVLOXSEG7EI16_V_MF4_MF4_MASK }, // 1188
  { Intrinsic::riscv_vloxseg7_mask, 0x10, 0x6, 0x7, PseudoVLOXSEG7EI16_V_MF2_MF4_MASK }, // 1189
  { Intrinsic::riscv_vloxseg7_mask, 0x10, 0x7, 0x0, PseudoVLOXSEG7EI16_V_M1_MF2_MASK }, // 1190
  { Intrinsic::riscv_vloxseg7_mask, 0x10, 0x7, 0x1, PseudoVLOXSEG7EI16_V_M2_MF2_MASK }, // 1191
  { Intrinsic::riscv_vloxseg7_mask, 0x10, 0x7, 0x2, PseudoVLOXSEG7EI16_V_M4_MF2_MASK }, // 1192
  { Intrinsic::riscv_vloxseg7_mask, 0x10, 0x7, 0x3, PseudoVLOXSEG7EI16_V_M8_MF2_MASK }, // 1193
  { Intrinsic::riscv_vloxseg7_mask, 0x10, 0x7, 0x6, PseudoVLOXSEG7EI16_V_MF4_MF2_MASK }, // 1194
  { Intrinsic::riscv_vloxseg7_mask, 0x10, 0x7, 0x7, PseudoVLOXSEG7EI16_V_MF2_MF2_MASK }, // 1195
  { Intrinsic::riscv_vloxseg7_mask, 0x20, 0x0, 0x0, PseudoVLOXSEG7EI32_V_M1_M1_MASK }, // 1196
  { Intrinsic::riscv_vloxseg7_mask, 0x20, 0x0, 0x1, PseudoVLOXSEG7EI32_V_M2_M1_MASK }, // 1197
  { Intrinsic::riscv_vloxseg7_mask, 0x20, 0x0, 0x2, PseudoVLOXSEG7EI32_V_M4_M1_MASK }, // 1198
  { Intrinsic::riscv_vloxseg7_mask, 0x20, 0x0, 0x3, PseudoVLOXSEG7EI32_V_M8_M1_MASK }, // 1199
  { Intrinsic::riscv_vloxseg7_mask, 0x20, 0x0, 0x7, PseudoVLOXSEG7EI32_V_MF2_M1_MASK }, // 1200
  { Intrinsic::riscv_vloxseg7_mask, 0x20, 0x5, 0x0, PseudoVLOXSEG7EI32_V_M1_MF8_MASK }, // 1201
  { Intrinsic::riscv_vloxseg7_mask, 0x20, 0x5, 0x1, PseudoVLOXSEG7EI32_V_M2_MF8_MASK }, // 1202
  { Intrinsic::riscv_vloxseg7_mask, 0x20, 0x5, 0x2, PseudoVLOXSEG7EI32_V_M4_MF8_MASK }, // 1203
  { Intrinsic::riscv_vloxseg7_mask, 0x20, 0x5, 0x3, PseudoVLOXSEG7EI32_V_M8_MF8_MASK }, // 1204
  { Intrinsic::riscv_vloxseg7_mask, 0x20, 0x5, 0x7, PseudoVLOXSEG7EI32_V_MF2_MF8_MASK }, // 1205
  { Intrinsic::riscv_vloxseg7_mask, 0x20, 0x6, 0x0, PseudoVLOXSEG7EI32_V_M1_MF4_MASK }, // 1206
  { Intrinsic::riscv_vloxseg7_mask, 0x20, 0x6, 0x1, PseudoVLOXSEG7EI32_V_M2_MF4_MASK }, // 1207
  { Intrinsic::riscv_vloxseg7_mask, 0x20, 0x6, 0x2, PseudoVLOXSEG7EI32_V_M4_MF4_MASK }, // 1208
  { Intrinsic::riscv_vloxseg7_mask, 0x20, 0x6, 0x3, PseudoVLOXSEG7EI32_V_M8_MF4_MASK }, // 1209
  { Intrinsic::riscv_vloxseg7_mask, 0x20, 0x6, 0x7, PseudoVLOXSEG7EI32_V_MF2_MF4_MASK }, // 1210
  { Intrinsic::riscv_vloxseg7_mask, 0x20, 0x7, 0x0, PseudoVLOXSEG7EI32_V_M1_MF2_MASK }, // 1211
  { Intrinsic::riscv_vloxseg7_mask, 0x20, 0x7, 0x1, PseudoVLOXSEG7EI32_V_M2_MF2_MASK }, // 1212
  { Intrinsic::riscv_vloxseg7_mask, 0x20, 0x7, 0x2, PseudoVLOXSEG7EI32_V_M4_MF2_MASK }, // 1213
  { Intrinsic::riscv_vloxseg7_mask, 0x20, 0x7, 0x3, PseudoVLOXSEG7EI32_V_M8_MF2_MASK }, // 1214
  { Intrinsic::riscv_vloxseg7_mask, 0x20, 0x7, 0x7, PseudoVLOXSEG7EI32_V_MF2_MF2_MASK }, // 1215
  { Intrinsic::riscv_vloxseg7_mask, 0x40, 0x0, 0x0, PseudoVLOXSEG7EI64_V_M1_M1_MASK }, // 1216
  { Intrinsic::riscv_vloxseg7_mask, 0x40, 0x0, 0x1, PseudoVLOXSEG7EI64_V_M2_M1_MASK }, // 1217
  { Intrinsic::riscv_vloxseg7_mask, 0x40, 0x0, 0x2, PseudoVLOXSEG7EI64_V_M4_M1_MASK }, // 1218
  { Intrinsic::riscv_vloxseg7_mask, 0x40, 0x0, 0x3, PseudoVLOXSEG7EI64_V_M8_M1_MASK }, // 1219
  { Intrinsic::riscv_vloxseg7_mask, 0x40, 0x5, 0x0, PseudoVLOXSEG7EI64_V_M1_MF8_MASK }, // 1220
  { Intrinsic::riscv_vloxseg7_mask, 0x40, 0x5, 0x1, PseudoVLOXSEG7EI64_V_M2_MF8_MASK }, // 1221
  { Intrinsic::riscv_vloxseg7_mask, 0x40, 0x5, 0x2, PseudoVLOXSEG7EI64_V_M4_MF8_MASK }, // 1222
  { Intrinsic::riscv_vloxseg7_mask, 0x40, 0x5, 0x3, PseudoVLOXSEG7EI64_V_M8_MF8_MASK }, // 1223
  { Intrinsic::riscv_vloxseg7_mask, 0x40, 0x6, 0x0, PseudoVLOXSEG7EI64_V_M1_MF4_MASK }, // 1224
  { Intrinsic::riscv_vloxseg7_mask, 0x40, 0x6, 0x1, PseudoVLOXSEG7EI64_V_M2_MF4_MASK }, // 1225
  { Intrinsic::riscv_vloxseg7_mask, 0x40, 0x6, 0x2, PseudoVLOXSEG7EI64_V_M4_MF4_MASK }, // 1226
  { Intrinsic::riscv_vloxseg7_mask, 0x40, 0x6, 0x3, PseudoVLOXSEG7EI64_V_M8_MF4_MASK }, // 1227
  { Intrinsic::riscv_vloxseg7_mask, 0x40, 0x7, 0x0, PseudoVLOXSEG7EI64_V_M1_MF2_MASK }, // 1228
  { Intrinsic::riscv_vloxseg7_mask, 0x40, 0x7, 0x1, PseudoVLOXSEG7EI64_V_M2_MF2_MASK }, // 1229
  { Intrinsic::riscv_vloxseg7_mask, 0x40, 0x7, 0x2, PseudoVLOXSEG7EI64_V_M4_MF2_MASK }, // 1230
  { Intrinsic::riscv_vloxseg7_mask, 0x40, 0x7, 0x3, PseudoVLOXSEG7EI64_V_M8_MF2_MASK }, // 1231
  { Intrinsic::riscv_vloxseg8, 0x8, 0x0, 0x0, PseudoVLOXSEG8EI8_V_M1_M1 }, // 1232
  { Intrinsic::riscv_vloxseg8, 0x8, 0x0, 0x1, PseudoVLOXSEG8EI8_V_M2_M1 }, // 1233
  { Intrinsic::riscv_vloxseg8, 0x8, 0x0, 0x2, PseudoVLOXSEG8EI8_V_M4_M1 }, // 1234
  { Intrinsic::riscv_vloxseg8, 0x8, 0x0, 0x3, PseudoVLOXSEG8EI8_V_M8_M1 }, // 1235
  { Intrinsic::riscv_vloxseg8, 0x8, 0x0, 0x5, PseudoVLOXSEG8EI8_V_MF8_M1 }, // 1236
  { Intrinsic::riscv_vloxseg8, 0x8, 0x0, 0x6, PseudoVLOXSEG8EI8_V_MF4_M1 }, // 1237
  { Intrinsic::riscv_vloxseg8, 0x8, 0x0, 0x7, PseudoVLOXSEG8EI8_V_MF2_M1 }, // 1238
  { Intrinsic::riscv_vloxseg8, 0x8, 0x5, 0x0, PseudoVLOXSEG8EI8_V_M1_MF8 }, // 1239
  { Intrinsic::riscv_vloxseg8, 0x8, 0x5, 0x1, PseudoVLOXSEG8EI8_V_M2_MF8 }, // 1240
  { Intrinsic::riscv_vloxseg8, 0x8, 0x5, 0x2, PseudoVLOXSEG8EI8_V_M4_MF8 }, // 1241
  { Intrinsic::riscv_vloxseg8, 0x8, 0x5, 0x3, PseudoVLOXSEG8EI8_V_M8_MF8 }, // 1242
  { Intrinsic::riscv_vloxseg8, 0x8, 0x5, 0x5, PseudoVLOXSEG8EI8_V_MF8_MF8 }, // 1243
  { Intrinsic::riscv_vloxseg8, 0x8, 0x5, 0x6, PseudoVLOXSEG8EI8_V_MF4_MF8 }, // 1244
  { Intrinsic::riscv_vloxseg8, 0x8, 0x5, 0x7, PseudoVLOXSEG8EI8_V_MF2_MF8 }, // 1245
  { Intrinsic::riscv_vloxseg8, 0x8, 0x6, 0x0, PseudoVLOXSEG8EI8_V_M1_MF4 }, // 1246
  { Intrinsic::riscv_vloxseg8, 0x8, 0x6, 0x1, PseudoVLOXSEG8EI8_V_M2_MF4 }, // 1247
  { Intrinsic::riscv_vloxseg8, 0x8, 0x6, 0x2, PseudoVLOXSEG8EI8_V_M4_MF4 }, // 1248
  { Intrinsic::riscv_vloxseg8, 0x8, 0x6, 0x3, PseudoVLOXSEG8EI8_V_M8_MF4 }, // 1249
  { Intrinsic::riscv_vloxseg8, 0x8, 0x6, 0x5, PseudoVLOXSEG8EI8_V_MF8_MF4 }, // 1250
  { Intrinsic::riscv_vloxseg8, 0x8, 0x6, 0x6, PseudoVLOXSEG8EI8_V_MF4_MF4 }, // 1251
  { Intrinsic::riscv_vloxseg8, 0x8, 0x6, 0x7, PseudoVLOXSEG8EI8_V_MF2_MF4 }, // 1252
  { Intrinsic::riscv_vloxseg8, 0x8, 0x7, 0x0, PseudoVLOXSEG8EI8_V_M1_MF2 }, // 1253
  { Intrinsic::riscv_vloxseg8, 0x8, 0x7, 0x1, PseudoVLOXSEG8EI8_V_M2_MF2 }, // 1254
  { Intrinsic::riscv_vloxseg8, 0x8, 0x7, 0x2, PseudoVLOXSEG8EI8_V_M4_MF2 }, // 1255
  { Intrinsic::riscv_vloxseg8, 0x8, 0x7, 0x3, PseudoVLOXSEG8EI8_V_M8_MF2 }, // 1256
  { Intrinsic::riscv_vloxseg8, 0x8, 0x7, 0x5, PseudoVLOXSEG8EI8_V_MF8_MF2 }, // 1257
  { Intrinsic::riscv_vloxseg8, 0x8, 0x7, 0x6, PseudoVLOXSEG8EI8_V_MF4_MF2 }, // 1258
  { Intrinsic::riscv_vloxseg8, 0x8, 0x7, 0x7, PseudoVLOXSEG8EI8_V_MF2_MF2 }, // 1259
  { Intrinsic::riscv_vloxseg8, 0x10, 0x0, 0x0, PseudoVLOXSEG8EI16_V_M1_M1 }, // 1260
  { Intrinsic::riscv_vloxseg8, 0x10, 0x0, 0x1, PseudoVLOXSEG8EI16_V_M2_M1 }, // 1261
  { Intrinsic::riscv_vloxseg8, 0x10, 0x0, 0x2, PseudoVLOXSEG8EI16_V_M4_M1 }, // 1262
  { Intrinsic::riscv_vloxseg8, 0x10, 0x0, 0x3, PseudoVLOXSEG8EI16_V_M8_M1 }, // 1263
  { Intrinsic::riscv_vloxseg8, 0x10, 0x0, 0x6, PseudoVLOXSEG8EI16_V_MF4_M1 }, // 1264
  { Intrinsic::riscv_vloxseg8, 0x10, 0x0, 0x7, PseudoVLOXSEG8EI16_V_MF2_M1 }, // 1265
  { Intrinsic::riscv_vloxseg8, 0x10, 0x5, 0x0, PseudoVLOXSEG8EI16_V_M1_MF8 }, // 1266
  { Intrinsic::riscv_vloxseg8, 0x10, 0x5, 0x1, PseudoVLOXSEG8EI16_V_M2_MF8 }, // 1267
  { Intrinsic::riscv_vloxseg8, 0x10, 0x5, 0x2, PseudoVLOXSEG8EI16_V_M4_MF8 }, // 1268
  { Intrinsic::riscv_vloxseg8, 0x10, 0x5, 0x3, PseudoVLOXSEG8EI16_V_M8_MF8 }, // 1269
  { Intrinsic::riscv_vloxseg8, 0x10, 0x5, 0x6, PseudoVLOXSEG8EI16_V_MF4_MF8 }, // 1270
  { Intrinsic::riscv_vloxseg8, 0x10, 0x5, 0x7, PseudoVLOXSEG8EI16_V_MF2_MF8 }, // 1271
  { Intrinsic::riscv_vloxseg8, 0x10, 0x6, 0x0, PseudoVLOXSEG8EI16_V_M1_MF4 }, // 1272
  { Intrinsic::riscv_vloxseg8, 0x10, 0x6, 0x1, PseudoVLOXSEG8EI16_V_M2_MF4 }, // 1273
  { Intrinsic::riscv_vloxseg8, 0x10, 0x6, 0x2, PseudoVLOXSEG8EI16_V_M4_MF4 }, // 1274
  { Intrinsic::riscv_vloxseg8, 0x10, 0x6, 0x3, PseudoVLOXSEG8EI16_V_M8_MF4 }, // 1275
  { Intrinsic::riscv_vloxseg8, 0x10, 0x6, 0x6, PseudoVLOXSEG8EI16_V_MF4_MF4 }, // 1276
  { Intrinsic::riscv_vloxseg8, 0x10, 0x6, 0x7, PseudoVLOXSEG8EI16_V_MF2_MF4 }, // 1277
  { Intrinsic::riscv_vloxseg8, 0x10, 0x7, 0x0, PseudoVLOXSEG8EI16_V_M1_MF2 }, // 1278
  { Intrinsic::riscv_vloxseg8, 0x10, 0x7, 0x1, PseudoVLOXSEG8EI16_V_M2_MF2 }, // 1279
  { Intrinsic::riscv_vloxseg8, 0x10, 0x7, 0x2, PseudoVLOXSEG8EI16_V_M4_MF2 }, // 1280
  { Intrinsic::riscv_vloxseg8, 0x10, 0x7, 0x3, PseudoVLOXSEG8EI16_V_M8_MF2 }, // 1281
  { Intrinsic::riscv_vloxseg8, 0x10, 0x7, 0x6, PseudoVLOXSEG8EI16_V_MF4_MF2 }, // 1282
  { Intrinsic::riscv_vloxseg8, 0x10, 0x7, 0x7, PseudoVLOXSEG8EI16_V_MF2_MF2 }, // 1283
  { Intrinsic::riscv_vloxseg8, 0x20, 0x0, 0x0, PseudoVLOXSEG8EI32_V_M1_M1 }, // 1284
  { Intrinsic::riscv_vloxseg8, 0x20, 0x0, 0x1, PseudoVLOXSEG8EI32_V_M2_M1 }, // 1285
  { Intrinsic::riscv_vloxseg8, 0x20, 0x0, 0x2, PseudoVLOXSEG8EI32_V_M4_M1 }, // 1286
  { Intrinsic::riscv_vloxseg8, 0x20, 0x0, 0x3, PseudoVLOXSEG8EI32_V_M8_M1 }, // 1287
  { Intrinsic::riscv_vloxseg8, 0x20, 0x0, 0x7, PseudoVLOXSEG8EI32_V_MF2_M1 }, // 1288
  { Intrinsic::riscv_vloxseg8, 0x20, 0x5, 0x0, PseudoVLOXSEG8EI32_V_M1_MF8 }, // 1289
  { Intrinsic::riscv_vloxseg8, 0x20, 0x5, 0x1, PseudoVLOXSEG8EI32_V_M2_MF8 }, // 1290
  { Intrinsic::riscv_vloxseg8, 0x20, 0x5, 0x2, PseudoVLOXSEG8EI32_V_M4_MF8 }, // 1291
  { Intrinsic::riscv_vloxseg8, 0x20, 0x5, 0x3, PseudoVLOXSEG8EI32_V_M8_MF8 }, // 1292
  { Intrinsic::riscv_vloxseg8, 0x20, 0x5, 0x7, PseudoVLOXSEG8EI32_V_MF2_MF8 }, // 1293
  { Intrinsic::riscv_vloxseg8, 0x20, 0x6, 0x0, PseudoVLOXSEG8EI32_V_M1_MF4 }, // 1294
  { Intrinsic::riscv_vloxseg8, 0x20, 0x6, 0x1, PseudoVLOXSEG8EI32_V_M2_MF4 }, // 1295
  { Intrinsic::riscv_vloxseg8, 0x20, 0x6, 0x2, PseudoVLOXSEG8EI32_V_M4_MF4 }, // 1296
  { Intrinsic::riscv_vloxseg8, 0x20, 0x6, 0x3, PseudoVLOXSEG8EI32_V_M8_MF4 }, // 1297
  { Intrinsic::riscv_vloxseg8, 0x20, 0x6, 0x7, PseudoVLOXSEG8EI32_V_MF2_MF4 }, // 1298
  { Intrinsic::riscv_vloxseg8, 0x20, 0x7, 0x0, PseudoVLOXSEG8EI32_V_M1_MF2 }, // 1299
  { Intrinsic::riscv_vloxseg8, 0x20, 0x7, 0x1, PseudoVLOXSEG8EI32_V_M2_MF2 }, // 1300
  { Intrinsic::riscv_vloxseg8, 0x20, 0x7, 0x2, PseudoVLOXSEG8EI32_V_M4_MF2 }, // 1301
  { Intrinsic::riscv_vloxseg8, 0x20, 0x7, 0x3, PseudoVLOXSEG8EI32_V_M8_MF2 }, // 1302
  { Intrinsic::riscv_vloxseg8, 0x20, 0x7, 0x7, PseudoVLOXSEG8EI32_V_MF2_MF2 }, // 1303
  { Intrinsic::riscv_vloxseg8, 0x40, 0x0, 0x0, PseudoVLOXSEG8EI64_V_M1_M1 }, // 1304
  { Intrinsic::riscv_vloxseg8, 0x40, 0x0, 0x1, PseudoVLOXSEG8EI64_V_M2_M1 }, // 1305
  { Intrinsic::riscv_vloxseg8, 0x40, 0x0, 0x2, PseudoVLOXSEG8EI64_V_M4_M1 }, // 1306
  { Intrinsic::riscv_vloxseg8, 0x40, 0x0, 0x3, PseudoVLOXSEG8EI64_V_M8_M1 }, // 1307
  { Intrinsic::riscv_vloxseg8, 0x40, 0x5, 0x0, PseudoVLOXSEG8EI64_V_M1_MF8 }, // 1308
  { Intrinsic::riscv_vloxseg8, 0x40, 0x5, 0x1, PseudoVLOXSEG8EI64_V_M2_MF8 }, // 1309
  { Intrinsic::riscv_vloxseg8, 0x40, 0x5, 0x2, PseudoVLOXSEG8EI64_V_M4_MF8 }, // 1310
  { Intrinsic::riscv_vloxseg8, 0x40, 0x5, 0x3, PseudoVLOXSEG8EI64_V_M8_MF8 }, // 1311
  { Intrinsic::riscv_vloxseg8, 0x40, 0x6, 0x0, PseudoVLOXSEG8EI64_V_M1_MF4 }, // 1312
  { Intrinsic::riscv_vloxseg8, 0x40, 0x6, 0x1, PseudoVLOXSEG8EI64_V_M2_MF4 }, // 1313
  { Intrinsic::riscv_vloxseg8, 0x40, 0x6, 0x2, PseudoVLOXSEG8EI64_V_M4_MF4 }, // 1314
  { Intrinsic::riscv_vloxseg8, 0x40, 0x6, 0x3, PseudoVLOXSEG8EI64_V_M8_MF4 }, // 1315
  { Intrinsic::riscv_vloxseg8, 0x40, 0x7, 0x0, PseudoVLOXSEG8EI64_V_M1_MF2 }, // 1316
  { Intrinsic::riscv_vloxseg8, 0x40, 0x7, 0x1, PseudoVLOXSEG8EI64_V_M2_MF2 }, // 1317
  { Intrinsic::riscv_vloxseg8, 0x40, 0x7, 0x2, PseudoVLOXSEG8EI64_V_M4_MF2 }, // 1318
  { Intrinsic::riscv_vloxseg8, 0x40, 0x7, 0x3, PseudoVLOXSEG8EI64_V_M8_MF2 }, // 1319
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x0, 0x0, PseudoVLOXSEG8EI8_V_M1_M1_MASK }, // 1320
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x0, 0x1, PseudoVLOXSEG8EI8_V_M2_M1_MASK }, // 1321
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x0, 0x2, PseudoVLOXSEG8EI8_V_M4_M1_MASK }, // 1322
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x0, 0x3, PseudoVLOXSEG8EI8_V_M8_M1_MASK }, // 1323
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x0, 0x5, PseudoVLOXSEG8EI8_V_MF8_M1_MASK }, // 1324
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x0, 0x6, PseudoVLOXSEG8EI8_V_MF4_M1_MASK }, // 1325
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x0, 0x7, PseudoVLOXSEG8EI8_V_MF2_M1_MASK }, // 1326
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x5, 0x0, PseudoVLOXSEG8EI8_V_M1_MF8_MASK }, // 1327
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x5, 0x1, PseudoVLOXSEG8EI8_V_M2_MF8_MASK }, // 1328
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x5, 0x2, PseudoVLOXSEG8EI8_V_M4_MF8_MASK }, // 1329
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x5, 0x3, PseudoVLOXSEG8EI8_V_M8_MF8_MASK }, // 1330
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x5, 0x5, PseudoVLOXSEG8EI8_V_MF8_MF8_MASK }, // 1331
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x5, 0x6, PseudoVLOXSEG8EI8_V_MF4_MF8_MASK }, // 1332
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x5, 0x7, PseudoVLOXSEG8EI8_V_MF2_MF8_MASK }, // 1333
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x6, 0x0, PseudoVLOXSEG8EI8_V_M1_MF4_MASK }, // 1334
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x6, 0x1, PseudoVLOXSEG8EI8_V_M2_MF4_MASK }, // 1335
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x6, 0x2, PseudoVLOXSEG8EI8_V_M4_MF4_MASK }, // 1336
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x6, 0x3, PseudoVLOXSEG8EI8_V_M8_MF4_MASK }, // 1337
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x6, 0x5, PseudoVLOXSEG8EI8_V_MF8_MF4_MASK }, // 1338
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x6, 0x6, PseudoVLOXSEG8EI8_V_MF4_MF4_MASK }, // 1339
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x6, 0x7, PseudoVLOXSEG8EI8_V_MF2_MF4_MASK }, // 1340
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x7, 0x0, PseudoVLOXSEG8EI8_V_M1_MF2_MASK }, // 1341
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x7, 0x1, PseudoVLOXSEG8EI8_V_M2_MF2_MASK }, // 1342
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x7, 0x2, PseudoVLOXSEG8EI8_V_M4_MF2_MASK }, // 1343
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x7, 0x3, PseudoVLOXSEG8EI8_V_M8_MF2_MASK }, // 1344
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x7, 0x5, PseudoVLOXSEG8EI8_V_MF8_MF2_MASK }, // 1345
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x7, 0x6, PseudoVLOXSEG8EI8_V_MF4_MF2_MASK }, // 1346
  { Intrinsic::riscv_vloxseg8_mask, 0x8, 0x7, 0x7, PseudoVLOXSEG8EI8_V_MF2_MF2_MASK }, // 1347
  { Intrinsic::riscv_vloxseg8_mask, 0x10, 0x0, 0x0, PseudoVLOXSEG8EI16_V_M1_M1_MASK }, // 1348
  { Intrinsic::riscv_vloxseg8_mask, 0x10, 0x0, 0x1, PseudoVLOXSEG8EI16_V_M2_M1_MASK }, // 1349
  { Intrinsic::riscv_vloxseg8_mask, 0x10, 0x0, 0x2, PseudoVLOXSEG8EI16_V_M4_M1_MASK }, // 1350
  { Intrinsic::riscv_vloxseg8_mask, 0x10, 0x0, 0x3, PseudoVLOXSEG8EI16_V_M8_M1_MASK }, // 1351
  { Intrinsic::riscv_vloxseg8_mask, 0x10, 0x0, 0x6, PseudoVLOXSEG8EI16_V_MF4_M1_MASK }, // 1352
  { Intrinsic::riscv_vloxseg8_mask, 0x10, 0x0, 0x7, PseudoVLOXSEG8EI16_V_MF2_M1_MASK }, // 1353
  { Intrinsic::riscv_vloxseg8_mask, 0x10, 0x5, 0x0, PseudoVLOXSEG8EI16_V_M1_MF8_MASK }, // 1354
  { Intrinsic::riscv_vloxseg8_mask, 0x10, 0x5, 0x1, PseudoVLOXSEG8EI16_V_M2_MF8_MASK }, // 1355
  { Intrinsic::riscv_vloxseg8_mask, 0x10, 0x5, 0x2, PseudoVLOXSEG8EI16_V_M4_MF8_MASK }, // 1356
  { Intrinsic::riscv_vloxseg8_mask, 0x10, 0x5, 0x3, PseudoVLOXSEG8EI16_V_M8_MF8_MASK }, // 1357
  { Intrinsic::riscv_vloxseg8_mask, 0x10, 0x5, 0x6, PseudoVLOXSEG8EI16_V_MF4_MF8_MASK }, // 1358
  { Intrinsic::riscv_vloxseg8_mask, 0x10, 0x5, 0x7, PseudoVLOXSEG8EI16_V_MF2_MF8_MASK }, // 1359
  { Intrinsic::riscv_vloxseg8_mask, 0x10, 0x6, 0x0, PseudoVLOXSEG8EI16_V_M1_MF4_MASK }, // 1360
  { Intrinsic::riscv_vloxseg8_mask, 0x10, 0x6, 0x1, PseudoVLOXSEG8EI16_V_M2_MF4_MASK }, // 1361
  { Intrinsic::riscv_vloxseg8_mask, 0x10, 0x6, 0x2, PseudoVLOXSEG8EI16_V_M4_MF4_MASK }, // 1362
  { Intrinsic::riscv_vloxseg8_mask, 0x10, 0x6, 0x3, PseudoVLOXSEG8EI16_V_M8_MF4_MASK }, // 1363
  { Intrinsic::riscv_vloxseg8_mask, 0x10, 0x6, 0x6, PseudoVLOXSEG8EI16_V_MF4_MF4_MASK }, // 1364
  { Intrinsic::riscv_vloxseg8_mask, 0x10, 0x6, 0x7, PseudoVLOXSEG8EI16_V_MF2_MF4_MASK }, // 1365
  { Intrinsic::riscv_vloxseg8_mask, 0x10, 0x7, 0x0, PseudoVLOXSEG8EI16_V_M1_MF2_MASK }, // 1366
  { Intrinsic::riscv_vloxseg8_mask, 0x10, 0x7, 0x1, PseudoVLOXSEG8EI16_V_M2_MF2_MASK }, // 1367
  { Intrinsic::riscv_vloxseg8_mask, 0x10, 0x7, 0x2, PseudoVLOXSEG8EI16_V_M4_MF2_MASK }, // 1368
  { Intrinsic::riscv_vloxseg8_mask, 0x10, 0x7, 0x3, PseudoVLOXSEG8EI16_V_M8_MF2_MASK }, // 1369
  { Intrinsic::riscv_vloxseg8_mask, 0x10, 0x7, 0x6, PseudoVLOXSEG8EI16_V_MF4_MF2_MASK }, // 1370
  { Intrinsic::riscv_vloxseg8_mask, 0x10, 0x7, 0x7, PseudoVLOXSEG8EI16_V_MF2_MF2_MASK }, // 1371
  { Intrinsic::riscv_vloxseg8_mask, 0x20, 0x0, 0x0, PseudoVLOXSEG8EI32_V_M1_M1_MASK }, // 1372
  { Intrinsic::riscv_vloxseg8_mask, 0x20, 0x0, 0x1, PseudoVLOXSEG8EI32_V_M2_M1_MASK }, // 1373
  { Intrinsic::riscv_vloxseg8_mask, 0x20, 0x0, 0x2, PseudoVLOXSEG8EI32_V_M4_M1_MASK }, // 1374
  { Intrinsic::riscv_vloxseg8_mask, 0x20, 0x0, 0x3, PseudoVLOXSEG8EI32_V_M8_M1_MASK }, // 1375
  { Intrinsic::riscv_vloxseg8_mask, 0x20, 0x0, 0x7, PseudoVLOXSEG8EI32_V_MF2_M1_MASK }, // 1376
  { Intrinsic::riscv_vloxseg8_mask, 0x20, 0x5, 0x0, PseudoVLOXSEG8EI32_V_M1_MF8_MASK }, // 1377
  { Intrinsic::riscv_vloxseg8_mask, 0x20, 0x5, 0x1, PseudoVLOXSEG8EI32_V_M2_MF8_MASK }, // 1378
  { Intrinsic::riscv_vloxseg8_mask, 0x20, 0x5, 0x2, PseudoVLOXSEG8EI32_V_M4_MF8_MASK }, // 1379
  { Intrinsic::riscv_vloxseg8_mask, 0x20, 0x5, 0x3, PseudoVLOXSEG8EI32_V_M8_MF8_MASK }, // 1380
  { Intrinsic::riscv_vloxseg8_mask, 0x20, 0x5, 0x7, PseudoVLOXSEG8EI32_V_MF2_MF8_MASK }, // 1381
  { Intrinsic::riscv_vloxseg8_mask, 0x20, 0x6, 0x0, PseudoVLOXSEG8EI32_V_M1_MF4_MASK }, // 1382
  { Intrinsic::riscv_vloxseg8_mask, 0x20, 0x6, 0x1, PseudoVLOXSEG8EI32_V_M2_MF4_MASK }, // 1383
  { Intrinsic::riscv_vloxseg8_mask, 0x20, 0x6, 0x2, PseudoVLOXSEG8EI32_V_M4_MF4_MASK }, // 1384
  { Intrinsic::riscv_vloxseg8_mask, 0x20, 0x6, 0x3, PseudoVLOXSEG8EI32_V_M8_MF4_MASK }, // 1385
  { Intrinsic::riscv_vloxseg8_mask, 0x20, 0x6, 0x7, PseudoVLOXSEG8EI32_V_MF2_MF4_MASK }, // 1386
  { Intrinsic::riscv_vloxseg8_mask, 0x20, 0x7, 0x0, PseudoVLOXSEG8EI32_V_M1_MF2_MASK }, // 1387
  { Intrinsic::riscv_vloxseg8_mask, 0x20, 0x7, 0x1, PseudoVLOXSEG8EI32_V_M2_MF2_MASK }, // 1388
  { Intrinsic::riscv_vloxseg8_mask, 0x20, 0x7, 0x2, PseudoVLOXSEG8EI32_V_M4_MF2_MASK }, // 1389
  { Intrinsic::riscv_vloxseg8_mask, 0x20, 0x7, 0x3, PseudoVLOXSEG8EI32_V_M8_MF2_MASK }, // 1390
  { Intrinsic::riscv_vloxseg8_mask, 0x20, 0x7, 0x7, PseudoVLOXSEG8EI32_V_MF2_MF2_MASK }, // 1391
  { Intrinsic::riscv_vloxseg8_mask, 0x40, 0x0, 0x0, PseudoVLOXSEG8EI64_V_M1_M1_MASK }, // 1392
  { Intrinsic::riscv_vloxseg8_mask, 0x40, 0x0, 0x1, PseudoVLOXSEG8EI64_V_M2_M1_MASK }, // 1393
  { Intrinsic::riscv_vloxseg8_mask, 0x40, 0x0, 0x2, PseudoVLOXSEG8EI64_V_M4_M1_MASK }, // 1394
  { Intrinsic::riscv_vloxseg8_mask, 0x40, 0x0, 0x3, PseudoVLOXSEG8EI64_V_M8_M1_MASK }, // 1395
  { Intrinsic::riscv_vloxseg8_mask, 0x40, 0x5, 0x0, PseudoVLOXSEG8EI64_V_M1_MF8_MASK }, // 1396
  { Intrinsic::riscv_vloxseg8_mask, 0x40, 0x5, 0x1, PseudoVLOXSEG8EI64_V_M2_MF8_MASK }, // 1397
  { Intrinsic::riscv_vloxseg8_mask, 0x40, 0x5, 0x2, PseudoVLOXSEG8EI64_V_M4_MF8_MASK }, // 1398
  { Intrinsic::riscv_vloxseg8_mask, 0x40, 0x5, 0x3, PseudoVLOXSEG8EI64_V_M8_MF8_MASK }, // 1399
  { Intrinsic::riscv_vloxseg8_mask, 0x40, 0x6, 0x0, PseudoVLOXSEG8EI64_V_M1_MF4_MASK }, // 1400
  { Intrinsic::riscv_vloxseg8_mask, 0x40, 0x6, 0x1, PseudoVLOXSEG8EI64_V_M2_MF4_MASK }, // 1401
  { Intrinsic::riscv_vloxseg8_mask, 0x40, 0x6, 0x2, PseudoVLOXSEG8EI64_V_M4_MF4_MASK }, // 1402
  { Intrinsic::riscv_vloxseg8_mask, 0x40, 0x6, 0x3, PseudoVLOXSEG8EI64_V_M8_MF4_MASK }, // 1403
  { Intrinsic::riscv_vloxseg8_mask, 0x40, 0x7, 0x0, PseudoVLOXSEG8EI64_V_M1_MF2_MASK }, // 1404
  { Intrinsic::riscv_vloxseg8_mask, 0x40, 0x7, 0x1, PseudoVLOXSEG8EI64_V_M2_MF2_MASK }, // 1405
  { Intrinsic::riscv_vloxseg8_mask, 0x40, 0x7, 0x2, PseudoVLOXSEG8EI64_V_M4_MF2_MASK }, // 1406
  { Intrinsic::riscv_vloxseg8_mask, 0x40, 0x7, 0x3, PseudoVLOXSEG8EI64_V_M8_MF2_MASK }, // 1407
  { Intrinsic::riscv_vlseg2, 0x8, 0x0, 0x0, PseudoVLSEG2E8_V_M1 }, // 1408
  { Intrinsic::riscv_vlseg2, 0x8, 0x1, 0x0, PseudoVLSEG2E8_V_M2 }, // 1409
  { Intrinsic::riscv_vlseg2, 0x8, 0x2, 0x0, PseudoVLSEG2E8_V_M4 }, // 1410
  { Intrinsic::riscv_vlseg2, 0x8, 0x5, 0x0, PseudoVLSEG2E8_V_MF8 }, // 1411
  { Intrinsic::riscv_vlseg2, 0x8, 0x6, 0x0, PseudoVLSEG2E8_V_MF4 }, // 1412
  { Intrinsic::riscv_vlseg2, 0x8, 0x7, 0x0, PseudoVLSEG2E8_V_MF2 }, // 1413
  { Intrinsic::riscv_vlseg2, 0x10, 0x0, 0x0, PseudoVLSEG2E16_V_M1 }, // 1414
  { Intrinsic::riscv_vlseg2, 0x10, 0x1, 0x0, PseudoVLSEG2E16_V_M2 }, // 1415
  { Intrinsic::riscv_vlseg2, 0x10, 0x2, 0x0, PseudoVLSEG2E16_V_M4 }, // 1416
  { Intrinsic::riscv_vlseg2, 0x10, 0x6, 0x0, PseudoVLSEG2E16_V_MF4 }, // 1417
  { Intrinsic::riscv_vlseg2, 0x10, 0x7, 0x0, PseudoVLSEG2E16_V_MF2 }, // 1418
  { Intrinsic::riscv_vlseg2, 0x20, 0x0, 0x0, PseudoVLSEG2E32_V_M1 }, // 1419
  { Intrinsic::riscv_vlseg2, 0x20, 0x1, 0x0, PseudoVLSEG2E32_V_M2 }, // 1420
  { Intrinsic::riscv_vlseg2, 0x20, 0x2, 0x0, PseudoVLSEG2E32_V_M4 }, // 1421
  { Intrinsic::riscv_vlseg2, 0x20, 0x7, 0x0, PseudoVLSEG2E32_V_MF2 }, // 1422
  { Intrinsic::riscv_vlseg2, 0x40, 0x0, 0x0, PseudoVLSEG2E64_V_M1 }, // 1423
  { Intrinsic::riscv_vlseg2, 0x40, 0x1, 0x0, PseudoVLSEG2E64_V_M2 }, // 1424
  { Intrinsic::riscv_vlseg2, 0x40, 0x2, 0x0, PseudoVLSEG2E64_V_M4 }, // 1425
  { Intrinsic::riscv_vlseg2_mask, 0x8, 0x0, 0x0, PseudoVLSEG2E8_V_M1_MASK }, // 1426
  { Intrinsic::riscv_vlseg2_mask, 0x8, 0x1, 0x0, PseudoVLSEG2E8_V_M2_MASK }, // 1427
  { Intrinsic::riscv_vlseg2_mask, 0x8, 0x2, 0x0, PseudoVLSEG2E8_V_M4_MASK }, // 1428
  { Intrinsic::riscv_vlseg2_mask, 0x8, 0x5, 0x0, PseudoVLSEG2E8_V_MF8_MASK }, // 1429
  { Intrinsic::riscv_vlseg2_mask, 0x8, 0x6, 0x0, PseudoVLSEG2E8_V_MF4_MASK }, // 1430
  { Intrinsic::riscv_vlseg2_mask, 0x8, 0x7, 0x0, PseudoVLSEG2E8_V_MF2_MASK }, // 1431
  { Intrinsic::riscv_vlseg2_mask, 0x10, 0x0, 0x0, PseudoVLSEG2E16_V_M1_MASK }, // 1432
  { Intrinsic::riscv_vlseg2_mask, 0x10, 0x1, 0x0, PseudoVLSEG2E16_V_M2_MASK }, // 1433
  { Intrinsic::riscv_vlseg2_mask, 0x10, 0x2, 0x0, PseudoVLSEG2E16_V_M4_MASK }, // 1434
  { Intrinsic::riscv_vlseg2_mask, 0x10, 0x6, 0x0, PseudoVLSEG2E16_V_MF4_MASK }, // 1435
  { Intrinsic::riscv_vlseg2_mask, 0x10, 0x7, 0x0, PseudoVLSEG2E16_V_MF2_MASK }, // 1436
  { Intrinsic::riscv_vlseg2_mask, 0x20, 0x0, 0x0, PseudoVLSEG2E32_V_M1_MASK }, // 1437
  { Intrinsic::riscv_vlseg2_mask, 0x20, 0x1, 0x0, PseudoVLSEG2E32_V_M2_MASK }, // 1438
  { Intrinsic::riscv_vlseg2_mask, 0x20, 0x2, 0x0, PseudoVLSEG2E32_V_M4_MASK }, // 1439
  { Intrinsic::riscv_vlseg2_mask, 0x20, 0x7, 0x0, PseudoVLSEG2E32_V_MF2_MASK }, // 1440
  { Intrinsic::riscv_vlseg2_mask, 0x40, 0x0, 0x0, PseudoVLSEG2E64_V_M1_MASK }, // 1441
  { Intrinsic::riscv_vlseg2_mask, 0x40, 0x1, 0x0, PseudoVLSEG2E64_V_M2_MASK }, // 1442
  { Intrinsic::riscv_vlseg2_mask, 0x40, 0x2, 0x0, PseudoVLSEG2E64_V_M4_MASK }, // 1443
  { Intrinsic::riscv_vlseg2ff, 0x8, 0x0, 0x0, PseudoVLSEG2E8FF_V_M1 }, // 1444
  { Intrinsic::riscv_vlseg2ff, 0x8, 0x1, 0x0, PseudoVLSEG2E8FF_V_M2 }, // 1445
  { Intrinsic::riscv_vlseg2ff, 0x8, 0x2, 0x0, PseudoVLSEG2E8FF_V_M4 }, // 1446
  { Intrinsic::riscv_vlseg2ff, 0x8, 0x5, 0x0, PseudoVLSEG2E8FF_V_MF8 }, // 1447
  { Intrinsic::riscv_vlseg2ff, 0x8, 0x6, 0x0, PseudoVLSEG2E8FF_V_MF4 }, // 1448
  { Intrinsic::riscv_vlseg2ff, 0x8, 0x7, 0x0, PseudoVLSEG2E8FF_V_MF2 }, // 1449
  { Intrinsic::riscv_vlseg2ff, 0x10, 0x0, 0x0, PseudoVLSEG2E16FF_V_M1 }, // 1450
  { Intrinsic::riscv_vlseg2ff, 0x10, 0x1, 0x0, PseudoVLSEG2E16FF_V_M2 }, // 1451
  { Intrinsic::riscv_vlseg2ff, 0x10, 0x2, 0x0, PseudoVLSEG2E16FF_V_M4 }, // 1452
  { Intrinsic::riscv_vlseg2ff, 0x10, 0x6, 0x0, PseudoVLSEG2E16FF_V_MF4 }, // 1453
  { Intrinsic::riscv_vlseg2ff, 0x10, 0x7, 0x0, PseudoVLSEG2E16FF_V_MF2 }, // 1454
  { Intrinsic::riscv_vlseg2ff, 0x20, 0x0, 0x0, PseudoVLSEG2E32FF_V_M1 }, // 1455
  { Intrinsic::riscv_vlseg2ff, 0x20, 0x1, 0x0, PseudoVLSEG2E32FF_V_M2 }, // 1456
  { Intrinsic::riscv_vlseg2ff, 0x20, 0x2, 0x0, PseudoVLSEG2E32FF_V_M4 }, // 1457
  { Intrinsic::riscv_vlseg2ff, 0x20, 0x7, 0x0, PseudoVLSEG2E32FF_V_MF2 }, // 1458
  { Intrinsic::riscv_vlseg2ff, 0x40, 0x0, 0x0, PseudoVLSEG2E64FF_V_M1 }, // 1459
  { Intrinsic::riscv_vlseg2ff, 0x40, 0x1, 0x0, PseudoVLSEG2E64FF_V_M2 }, // 1460
  { Intrinsic::riscv_vlseg2ff, 0x40, 0x2, 0x0, PseudoVLSEG2E64FF_V_M4 }, // 1461
  { Intrinsic::riscv_vlseg2ff_mask, 0x8, 0x0, 0x0, PseudoVLSEG2E8FF_V_M1_MASK }, // 1462
  { Intrinsic::riscv_vlseg2ff_mask, 0x8, 0x1, 0x0, PseudoVLSEG2E8FF_V_M2_MASK }, // 1463
  { Intrinsic::riscv_vlseg2ff_mask, 0x8, 0x2, 0x0, PseudoVLSEG2E8FF_V_M4_MASK }, // 1464
  { Intrinsic::riscv_vlseg2ff_mask, 0x8, 0x5, 0x0, PseudoVLSEG2E8FF_V_MF8_MASK }, // 1465
  { Intrinsic::riscv_vlseg2ff_mask, 0x8, 0x6, 0x0, PseudoVLSEG2E8FF_V_MF4_MASK }, // 1466
  { Intrinsic::riscv_vlseg2ff_mask, 0x8, 0x7, 0x0, PseudoVLSEG2E8FF_V_MF2_MASK }, // 1467
  { Intrinsic::riscv_vlseg2ff_mask, 0x10, 0x0, 0x0, PseudoVLSEG2E16FF_V_M1_MASK }, // 1468
  { Intrinsic::riscv_vlseg2ff_mask, 0x10, 0x1, 0x0, PseudoVLSEG2E16FF_V_M2_MASK }, // 1469
  { Intrinsic::riscv_vlseg2ff_mask, 0x10, 0x2, 0x0, PseudoVLSEG2E16FF_V_M4_MASK }, // 1470
  { Intrinsic::riscv_vlseg2ff_mask, 0x10, 0x6, 0x0, PseudoVLSEG2E16FF_V_MF4_MASK }, // 1471
  { Intrinsic::riscv_vlseg2ff_mask, 0x10, 0x7, 0x0, PseudoVLSEG2E16FF_V_MF2_MASK }, // 1472
  { Intrinsic::riscv_vlseg2ff_mask, 0x20, 0x0, 0x0, PseudoVLSEG2E32FF_V_M1_MASK }, // 1473
  { Intrinsic::riscv_vlseg2ff_mask, 0x20, 0x1, 0x0, PseudoVLSEG2E32FF_V_M2_MASK }, // 1474
  { Intrinsic::riscv_vlseg2ff_mask, 0x20, 0x2, 0x0, PseudoVLSEG2E32FF_V_M4_MASK }, // 1475
  { Intrinsic::riscv_vlseg2ff_mask, 0x20, 0x7, 0x0, PseudoVLSEG2E32FF_V_MF2_MASK }, // 1476
  { Intrinsic::riscv_vlseg2ff_mask, 0x40, 0x0, 0x0, PseudoVLSEG2E64FF_V_M1_MASK }, // 1477
  { Intrinsic::riscv_vlseg2ff_mask, 0x40, 0x1, 0x0, PseudoVLSEG2E64FF_V_M2_MASK }, // 1478
  { Intrinsic::riscv_vlseg2ff_mask, 0x40, 0x2, 0x0, PseudoVLSEG2E64FF_V_M4_MASK }, // 1479
  { Intrinsic::riscv_vlseg3, 0x8, 0x0, 0x0, PseudoVLSEG3E8_V_M1 }, // 1480
  { Intrinsic::riscv_vlseg3, 0x8, 0x1, 0x0, PseudoVLSEG3E8_V_M2 }, // 1481
  { Intrinsic::riscv_vlseg3, 0x8, 0x5, 0x0, PseudoVLSEG3E8_V_MF8 }, // 1482
  { Intrinsic::riscv_vlseg3, 0x8, 0x6, 0x0, PseudoVLSEG3E8_V_MF4 }, // 1483
  { Intrinsic::riscv_vlseg3, 0x8, 0x7, 0x0, PseudoVLSEG3E8_V_MF2 }, // 1484
  { Intrinsic::riscv_vlseg3, 0x10, 0x0, 0x0, PseudoVLSEG3E16_V_M1 }, // 1485
  { Intrinsic::riscv_vlseg3, 0x10, 0x1, 0x0, PseudoVLSEG3E16_V_M2 }, // 1486
  { Intrinsic::riscv_vlseg3, 0x10, 0x6, 0x0, PseudoVLSEG3E16_V_MF4 }, // 1487
  { Intrinsic::riscv_vlseg3, 0x10, 0x7, 0x0, PseudoVLSEG3E16_V_MF2 }, // 1488
  { Intrinsic::riscv_vlseg3, 0x20, 0x0, 0x0, PseudoVLSEG3E32_V_M1 }, // 1489
  { Intrinsic::riscv_vlseg3, 0x20, 0x1, 0x0, PseudoVLSEG3E32_V_M2 }, // 1490
  { Intrinsic::riscv_vlseg3, 0x20, 0x7, 0x0, PseudoVLSEG3E32_V_MF2 }, // 1491
  { Intrinsic::riscv_vlseg3, 0x40, 0x0, 0x0, PseudoVLSEG3E64_V_M1 }, // 1492
  { Intrinsic::riscv_vlseg3, 0x40, 0x1, 0x0, PseudoVLSEG3E64_V_M2 }, // 1493
  { Intrinsic::riscv_vlseg3_mask, 0x8, 0x0, 0x0, PseudoVLSEG3E8_V_M1_MASK }, // 1494
  { Intrinsic::riscv_vlseg3_mask, 0x8, 0x1, 0x0, PseudoVLSEG3E8_V_M2_MASK }, // 1495
  { Intrinsic::riscv_vlseg3_mask, 0x8, 0x5, 0x0, PseudoVLSEG3E8_V_MF8_MASK }, // 1496
  { Intrinsic::riscv_vlseg3_mask, 0x8, 0x6, 0x0, PseudoVLSEG3E8_V_MF4_MASK }, // 1497
  { Intrinsic::riscv_vlseg3_mask, 0x8, 0x7, 0x0, PseudoVLSEG3E8_V_MF2_MASK }, // 1498
  { Intrinsic::riscv_vlseg3_mask, 0x10, 0x0, 0x0, PseudoVLSEG3E16_V_M1_MASK }, // 1499
  { Intrinsic::riscv_vlseg3_mask, 0x10, 0x1, 0x0, PseudoVLSEG3E16_V_M2_MASK }, // 1500
  { Intrinsic::riscv_vlseg3_mask, 0x10, 0x6, 0x0, PseudoVLSEG3E16_V_MF4_MASK }, // 1501
  { Intrinsic::riscv_vlseg3_mask, 0x10, 0x7, 0x0, PseudoVLSEG3E16_V_MF2_MASK }, // 1502
  { Intrinsic::riscv_vlseg3_mask, 0x20, 0x0, 0x0, PseudoVLSEG3E32_V_M1_MASK }, // 1503
  { Intrinsic::riscv_vlseg3_mask, 0x20, 0x1, 0x0, PseudoVLSEG3E32_V_M2_MASK }, // 1504
  { Intrinsic::riscv_vlseg3_mask, 0x20, 0x7, 0x0, PseudoVLSEG3E32_V_MF2_MASK }, // 1505
  { Intrinsic::riscv_vlseg3_mask, 0x40, 0x0, 0x0, PseudoVLSEG3E64_V_M1_MASK }, // 1506
  { Intrinsic::riscv_vlseg3_mask, 0x40, 0x1, 0x0, PseudoVLSEG3E64_V_M2_MASK }, // 1507
  { Intrinsic::riscv_vlseg3ff, 0x8, 0x0, 0x0, PseudoVLSEG3E8FF_V_M1 }, // 1508
  { Intrinsic::riscv_vlseg3ff, 0x8, 0x1, 0x0, PseudoVLSEG3E8FF_V_M2 }, // 1509
  { Intrinsic::riscv_vlseg3ff, 0x8, 0x5, 0x0, PseudoVLSEG3E8FF_V_MF8 }, // 1510
  { Intrinsic::riscv_vlseg3ff, 0x8, 0x6, 0x0, PseudoVLSEG3E8FF_V_MF4 }, // 1511
  { Intrinsic::riscv_vlseg3ff, 0x8, 0x7, 0x0, PseudoVLSEG3E8FF_V_MF2 }, // 1512
  { Intrinsic::riscv_vlseg3ff, 0x10, 0x0, 0x0, PseudoVLSEG3E16FF_V_M1 }, // 1513
  { Intrinsic::riscv_vlseg3ff, 0x10, 0x1, 0x0, PseudoVLSEG3E16FF_V_M2 }, // 1514
  { Intrinsic::riscv_vlseg3ff, 0x10, 0x6, 0x0, PseudoVLSEG3E16FF_V_MF4 }, // 1515
  { Intrinsic::riscv_vlseg3ff, 0x10, 0x7, 0x0, PseudoVLSEG3E16FF_V_MF2 }, // 1516
  { Intrinsic::riscv_vlseg3ff, 0x20, 0x0, 0x0, PseudoVLSEG3E32FF_V_M1 }, // 1517
  { Intrinsic::riscv_vlseg3ff, 0x20, 0x1, 0x0, PseudoVLSEG3E32FF_V_M2 }, // 1518
  { Intrinsic::riscv_vlseg3ff, 0x20, 0x7, 0x0, PseudoVLSEG3E32FF_V_MF2 }, // 1519
  { Intrinsic::riscv_vlseg3ff, 0x40, 0x0, 0x0, PseudoVLSEG3E64FF_V_M1 }, // 1520
  { Intrinsic::riscv_vlseg3ff, 0x40, 0x1, 0x0, PseudoVLSEG3E64FF_V_M2 }, // 1521
  { Intrinsic::riscv_vlseg3ff_mask, 0x8, 0x0, 0x0, PseudoVLSEG3E8FF_V_M1_MASK }, // 1522
  { Intrinsic::riscv_vlseg3ff_mask, 0x8, 0x1, 0x0, PseudoVLSEG3E8FF_V_M2_MASK }, // 1523
  { Intrinsic::riscv_vlseg3ff_mask, 0x8, 0x5, 0x0, PseudoVLSEG3E8FF_V_MF8_MASK }, // 1524
  { Intrinsic::riscv_vlseg3ff_mask, 0x8, 0x6, 0x0, PseudoVLSEG3E8FF_V_MF4_MASK }, // 1525
  { Intrinsic::riscv_vlseg3ff_mask, 0x8, 0x7, 0x0, PseudoVLSEG3E8FF_V_MF2_MASK }, // 1526
  { Intrinsic::riscv_vlseg3ff_mask, 0x10, 0x0, 0x0, PseudoVLSEG3E16FF_V_M1_MASK }, // 1527
  { Intrinsic::riscv_vlseg3ff_mask, 0x10, 0x1, 0x0, PseudoVLSEG3E16FF_V_M2_MASK }, // 1528
  { Intrinsic::riscv_vlseg3ff_mask, 0x10, 0x6, 0x0, PseudoVLSEG3E16FF_V_MF4_MASK }, // 1529
  { Intrinsic::riscv_vlseg3ff_mask, 0x10, 0x7, 0x0, PseudoVLSEG3E16FF_V_MF2_MASK }, // 1530
  { Intrinsic::riscv_vlseg3ff_mask, 0x20, 0x0, 0x0, PseudoVLSEG3E32FF_V_M1_MASK }, // 1531
  { Intrinsic::riscv_vlseg3ff_mask, 0x20, 0x1, 0x0, PseudoVLSEG3E32FF_V_M2_MASK }, // 1532
  { Intrinsic::riscv_vlseg3ff_mask, 0x20, 0x7, 0x0, PseudoVLSEG3E32FF_V_MF2_MASK }, // 1533
  { Intrinsic::riscv_vlseg3ff_mask, 0x40, 0x0, 0x0, PseudoVLSEG3E64FF_V_M1_MASK }, // 1534
  { Intrinsic::riscv_vlseg3ff_mask, 0x40, 0x1, 0x0, PseudoVLSEG3E64FF_V_M2_MASK }, // 1535
  { Intrinsic::riscv_vlseg4, 0x8, 0x0, 0x0, PseudoVLSEG4E8_V_M1 }, // 1536
  { Intrinsic::riscv_vlseg4, 0x8, 0x1, 0x0, PseudoVLSEG4E8_V_M2 }, // 1537
  { Intrinsic::riscv_vlseg4, 0x8, 0x5, 0x0, PseudoVLSEG4E8_V_MF8 }, // 1538
  { Intrinsic::riscv_vlseg4, 0x8, 0x6, 0x0, PseudoVLSEG4E8_V_MF4 }, // 1539
  { Intrinsic::riscv_vlseg4, 0x8, 0x7, 0x0, PseudoVLSEG4E8_V_MF2 }, // 1540
  { Intrinsic::riscv_vlseg4, 0x10, 0x0, 0x0, PseudoVLSEG4E16_V_M1 }, // 1541
  { Intrinsic::riscv_vlseg4, 0x10, 0x1, 0x0, PseudoVLSEG4E16_V_M2 }, // 1542
  { Intrinsic::riscv_vlseg4, 0x10, 0x6, 0x0, PseudoVLSEG4E16_V_MF4 }, // 1543
  { Intrinsic::riscv_vlseg4, 0x10, 0x7, 0x0, PseudoVLSEG4E16_V_MF2 }, // 1544
  { Intrinsic::riscv_vlseg4, 0x20, 0x0, 0x0, PseudoVLSEG4E32_V_M1 }, // 1545
  { Intrinsic::riscv_vlseg4, 0x20, 0x1, 0x0, PseudoVLSEG4E32_V_M2 }, // 1546
  { Intrinsic::riscv_vlseg4, 0x20, 0x7, 0x0, PseudoVLSEG4E32_V_MF2 }, // 1547
  { Intrinsic::riscv_vlseg4, 0x40, 0x0, 0x0, PseudoVLSEG4E64_V_M1 }, // 1548
  { Intrinsic::riscv_vlseg4, 0x40, 0x1, 0x0, PseudoVLSEG4E64_V_M2 }, // 1549
  { Intrinsic::riscv_vlseg4_mask, 0x8, 0x0, 0x0, PseudoVLSEG4E8_V_M1_MASK }, // 1550
  { Intrinsic::riscv_vlseg4_mask, 0x8, 0x1, 0x0, PseudoVLSEG4E8_V_M2_MASK }, // 1551
  { Intrinsic::riscv_vlseg4_mask, 0x8, 0x5, 0x0, PseudoVLSEG4E8_V_MF8_MASK }, // 1552
  { Intrinsic::riscv_vlseg4_mask, 0x8, 0x6, 0x0, PseudoVLSEG4E8_V_MF4_MASK }, // 1553
  { Intrinsic::riscv_vlseg4_mask, 0x8, 0x7, 0x0, PseudoVLSEG4E8_V_MF2_MASK }, // 1554
  { Intrinsic::riscv_vlseg4_mask, 0x10, 0x0, 0x0, PseudoVLSEG4E16_V_M1_MASK }, // 1555
  { Intrinsic::riscv_vlseg4_mask, 0x10, 0x1, 0x0, PseudoVLSEG4E16_V_M2_MASK }, // 1556
  { Intrinsic::riscv_vlseg4_mask, 0x10, 0x6, 0x0, PseudoVLSEG4E16_V_MF4_MASK }, // 1557
  { Intrinsic::riscv_vlseg4_mask, 0x10, 0x7, 0x0, PseudoVLSEG4E16_V_MF2_MASK }, // 1558
  { Intrinsic::riscv_vlseg4_mask, 0x20, 0x0, 0x0, PseudoVLSEG4E32_V_M1_MASK }, // 1559
  { Intrinsic::riscv_vlseg4_mask, 0x20, 0x1, 0x0, PseudoVLSEG4E32_V_M2_MASK }, // 1560
  { Intrinsic::riscv_vlseg4_mask, 0x20, 0x7, 0x0, PseudoVLSEG4E32_V_MF2_MASK }, // 1561
  { Intrinsic::riscv_vlseg4_mask, 0x40, 0x0, 0x0, PseudoVLSEG4E64_V_M1_MASK }, // 1562
  { Intrinsic::riscv_vlseg4_mask, 0x40, 0x1, 0x0, PseudoVLSEG4E64_V_M2_MASK }, // 1563
  { Intrinsic::riscv_vlseg4ff, 0x8, 0x0, 0x0, PseudoVLSEG4E8FF_V_M1 }, // 1564
  { Intrinsic::riscv_vlseg4ff, 0x8, 0x1, 0x0, PseudoVLSEG4E8FF_V_M2 }, // 1565
  { Intrinsic::riscv_vlseg4ff, 0x8, 0x5, 0x0, PseudoVLSEG4E8FF_V_MF8 }, // 1566
  { Intrinsic::riscv_vlseg4ff, 0x8, 0x6, 0x0, PseudoVLSEG4E8FF_V_MF4 }, // 1567
  { Intrinsic::riscv_vlseg4ff, 0x8, 0x7, 0x0, PseudoVLSEG4E8FF_V_MF2 }, // 1568
  { Intrinsic::riscv_vlseg4ff, 0x10, 0x0, 0x0, PseudoVLSEG4E16FF_V_M1 }, // 1569
  { Intrinsic::riscv_vlseg4ff, 0x10, 0x1, 0x0, PseudoVLSEG4E16FF_V_M2 }, // 1570
  { Intrinsic::riscv_vlseg4ff, 0x10, 0x6, 0x0, PseudoVLSEG4E16FF_V_MF4 }, // 1571
  { Intrinsic::riscv_vlseg4ff, 0x10, 0x7, 0x0, PseudoVLSEG4E16FF_V_MF2 }, // 1572
  { Intrinsic::riscv_vlseg4ff, 0x20, 0x0, 0x0, PseudoVLSEG4E32FF_V_M1 }, // 1573
  { Intrinsic::riscv_vlseg4ff, 0x20, 0x1, 0x0, PseudoVLSEG4E32FF_V_M2 }, // 1574
  { Intrinsic::riscv_vlseg4ff, 0x20, 0x7, 0x0, PseudoVLSEG4E32FF_V_MF2 }, // 1575
  { Intrinsic::riscv_vlseg4ff, 0x40, 0x0, 0x0, PseudoVLSEG4E64FF_V_M1 }, // 1576
  { Intrinsic::riscv_vlseg4ff, 0x40, 0x1, 0x0, PseudoVLSEG4E64FF_V_M2 }, // 1577
  { Intrinsic::riscv_vlseg4ff_mask, 0x8, 0x0, 0x0, PseudoVLSEG4E8FF_V_M1_MASK }, // 1578
  { Intrinsic::riscv_vlseg4ff_mask, 0x8, 0x1, 0x0, PseudoVLSEG4E8FF_V_M2_MASK }, // 1579
  { Intrinsic::riscv_vlseg4ff_mask, 0x8, 0x5, 0x0, PseudoVLSEG4E8FF_V_MF8_MASK }, // 1580
  { Intrinsic::riscv_vlseg4ff_mask, 0x8, 0x6, 0x0, PseudoVLSEG4E8FF_V_MF4_MASK }, // 1581
  { Intrinsic::riscv_vlseg4ff_mask, 0x8, 0x7, 0x0, PseudoVLSEG4E8FF_V_MF2_MASK }, // 1582
  { Intrinsic::riscv_vlseg4ff_mask, 0x10, 0x0, 0x0, PseudoVLSEG4E16FF_V_M1_MASK }, // 1583
  { Intrinsic::riscv_vlseg4ff_mask, 0x10, 0x1, 0x0, PseudoVLSEG4E16FF_V_M2_MASK }, // 1584
  { Intrinsic::riscv_vlseg4ff_mask, 0x10, 0x6, 0x0, PseudoVLSEG4E16FF_V_MF4_MASK }, // 1585
  { Intrinsic::riscv_vlseg4ff_mask, 0x10, 0x7, 0x0, PseudoVLSEG4E16FF_V_MF2_MASK }, // 1586
  { Intrinsic::riscv_vlseg4ff_mask, 0x20, 0x0, 0x0, PseudoVLSEG4E32FF_V_M1_MASK }, // 1587
  { Intrinsic::riscv_vlseg4ff_mask, 0x20, 0x1, 0x0, PseudoVLSEG4E32FF_V_M2_MASK }, // 1588
  { Intrinsic::riscv_vlseg4ff_mask, 0x20, 0x7, 0x0, PseudoVLSEG4E32FF_V_MF2_MASK }, // 1589
  { Intrinsic::riscv_vlseg4ff_mask, 0x40, 0x0, 0x0, PseudoVLSEG4E64FF_V_M1_MASK }, // 1590
  { Intrinsic::riscv_vlseg4ff_mask, 0x40, 0x1, 0x0, PseudoVLSEG4E64FF_V_M2_MASK }, // 1591
  { Intrinsic::riscv_vlseg5, 0x8, 0x0, 0x0, PseudoVLSEG5E8_V_M1 }, // 1592
  { Intrinsic::riscv_vlseg5, 0x8, 0x5, 0x0, PseudoVLSEG5E8_V_MF8 }, // 1593
  { Intrinsic::riscv_vlseg5, 0x8, 0x6, 0x0, PseudoVLSEG5E8_V_MF4 }, // 1594
  { Intrinsic::riscv_vlseg5, 0x8, 0x7, 0x0, PseudoVLSEG5E8_V_MF2 }, // 1595
  { Intrinsic::riscv_vlseg5, 0x10, 0x0, 0x0, PseudoVLSEG5E16_V_M1 }, // 1596
  { Intrinsic::riscv_vlseg5, 0x10, 0x6, 0x0, PseudoVLSEG5E16_V_MF4 }, // 1597
  { Intrinsic::riscv_vlseg5, 0x10, 0x7, 0x0, PseudoVLSEG5E16_V_MF2 }, // 1598
  { Intrinsic::riscv_vlseg5, 0x20, 0x0, 0x0, PseudoVLSEG5E32_V_M1 }, // 1599
  { Intrinsic::riscv_vlseg5, 0x20, 0x7, 0x0, PseudoVLSEG5E32_V_MF2 }, // 1600
  { Intrinsic::riscv_vlseg5, 0x40, 0x0, 0x0, PseudoVLSEG5E64_V_M1 }, // 1601
  { Intrinsic::riscv_vlseg5_mask, 0x8, 0x0, 0x0, PseudoVLSEG5E8_V_M1_MASK }, // 1602
  { Intrinsic::riscv_vlseg5_mask, 0x8, 0x5, 0x0, PseudoVLSEG5E8_V_MF8_MASK }, // 1603
  { Intrinsic::riscv_vlseg5_mask, 0x8, 0x6, 0x0, PseudoVLSEG5E8_V_MF4_MASK }, // 1604
  { Intrinsic::riscv_vlseg5_mask, 0x8, 0x7, 0x0, PseudoVLSEG5E8_V_MF2_MASK }, // 1605
  { Intrinsic::riscv_vlseg5_mask, 0x10, 0x0, 0x0, PseudoVLSEG5E16_V_M1_MASK }, // 1606
  { Intrinsic::riscv_vlseg5_mask, 0x10, 0x6, 0x0, PseudoVLSEG5E16_V_MF4_MASK }, // 1607
  { Intrinsic::riscv_vlseg5_mask, 0x10, 0x7, 0x0, PseudoVLSEG5E16_V_MF2_MASK }, // 1608
  { Intrinsic::riscv_vlseg5_mask, 0x20, 0x0, 0x0, PseudoVLSEG5E32_V_M1_MASK }, // 1609
  { Intrinsic::riscv_vlseg5_mask, 0x20, 0x7, 0x0, PseudoVLSEG5E32_V_MF2_MASK }, // 1610
  { Intrinsic::riscv_vlseg5_mask, 0x40, 0x0, 0x0, PseudoVLSEG5E64_V_M1_MASK }, // 1611
  { Intrinsic::riscv_vlseg5ff, 0x8, 0x0, 0x0, PseudoVLSEG5E8FF_V_M1 }, // 1612
  { Intrinsic::riscv_vlseg5ff, 0x8, 0x5, 0x0, PseudoVLSEG5E8FF_V_MF8 }, // 1613
  { Intrinsic::riscv_vlseg5ff, 0x8, 0x6, 0x0, PseudoVLSEG5E8FF_V_MF4 }, // 1614
  { Intrinsic::riscv_vlseg5ff, 0x8, 0x7, 0x0, PseudoVLSEG5E8FF_V_MF2 }, // 1615
  { Intrinsic::riscv_vlseg5ff, 0x10, 0x0, 0x0, PseudoVLSEG5E16FF_V_M1 }, // 1616
  { Intrinsic::riscv_vlseg5ff, 0x10, 0x6, 0x0, PseudoVLSEG5E16FF_V_MF4 }, // 1617
  { Intrinsic::riscv_vlseg5ff, 0x10, 0x7, 0x0, PseudoVLSEG5E16FF_V_MF2 }, // 1618
  { Intrinsic::riscv_vlseg5ff, 0x20, 0x0, 0x0, PseudoVLSEG5E32FF_V_M1 }, // 1619
  { Intrinsic::riscv_vlseg5ff, 0x20, 0x7, 0x0, PseudoVLSEG5E32FF_V_MF2 }, // 1620
  { Intrinsic::riscv_vlseg5ff, 0x40, 0x0, 0x0, PseudoVLSEG5E64FF_V_M1 }, // 1621
  { Intrinsic::riscv_vlseg5ff_mask, 0x8, 0x0, 0x0, PseudoVLSEG5E8FF_V_M1_MASK }, // 1622
  { Intrinsic::riscv_vlseg5ff_mask, 0x8, 0x5, 0x0, PseudoVLSEG5E8FF_V_MF8_MASK }, // 1623
  { Intrinsic::riscv_vlseg5ff_mask, 0x8, 0x6, 0x0, PseudoVLSEG5E8FF_V_MF4_MASK }, // 1624
  { Intrinsic::riscv_vlseg5ff_mask, 0x8, 0x7, 0x0, PseudoVLSEG5E8FF_V_MF2_MASK }, // 1625
  { Intrinsic::riscv_vlseg5ff_mask, 0x10, 0x0, 0x0, PseudoVLSEG5E16FF_V_M1_MASK }, // 1626
  { Intrinsic::riscv_vlseg5ff_mask, 0x10, 0x6, 0x0, PseudoVLSEG5E16FF_V_MF4_MASK }, // 1627
  { Intrinsic::riscv_vlseg5ff_mask, 0x10, 0x7, 0x0, PseudoVLSEG5E16FF_V_MF2_MASK }, // 1628
  { Intrinsic::riscv_vlseg5ff_mask, 0x20, 0x0, 0x0, PseudoVLSEG5E32FF_V_M1_MASK }, // 1629
  { Intrinsic::riscv_vlseg5ff_mask, 0x20, 0x7, 0x0, PseudoVLSEG5E32FF_V_MF2_MASK }, // 1630
  { Intrinsic::riscv_vlseg5ff_mask, 0x40, 0x0, 0x0, PseudoVLSEG5E64FF_V_M1_MASK }, // 1631
  { Intrinsic::riscv_vlseg6, 0x8, 0x0, 0x0, PseudoVLSEG6E8_V_M1 }, // 1632
  { Intrinsic::riscv_vlseg6, 0x8, 0x5, 0x0, PseudoVLSEG6E8_V_MF8 }, // 1633
  { Intrinsic::riscv_vlseg6, 0x8, 0x6, 0x0, PseudoVLSEG6E8_V_MF4 }, // 1634
  { Intrinsic::riscv_vlseg6, 0x8, 0x7, 0x0, PseudoVLSEG6E8_V_MF2 }, // 1635
  { Intrinsic::riscv_vlseg6, 0x10, 0x0, 0x0, PseudoVLSEG6E16_V_M1 }, // 1636
  { Intrinsic::riscv_vlseg6, 0x10, 0x6, 0x0, PseudoVLSEG6E16_V_MF4 }, // 1637
  { Intrinsic::riscv_vlseg6, 0x10, 0x7, 0x0, PseudoVLSEG6E16_V_MF2 }, // 1638
  { Intrinsic::riscv_vlseg6, 0x20, 0x0, 0x0, PseudoVLSEG6E32_V_M1 }, // 1639
  { Intrinsic::riscv_vlseg6, 0x20, 0x7, 0x0, PseudoVLSEG6E32_V_MF2 }, // 1640
  { Intrinsic::riscv_vlseg6, 0x40, 0x0, 0x0, PseudoVLSEG6E64_V_M1 }, // 1641
  { Intrinsic::riscv_vlseg6_mask, 0x8, 0x0, 0x0, PseudoVLSEG6E8_V_M1_MASK }, // 1642
  { Intrinsic::riscv_vlseg6_mask, 0x8, 0x5, 0x0, PseudoVLSEG6E8_V_MF8_MASK }, // 1643
  { Intrinsic::riscv_vlseg6_mask, 0x8, 0x6, 0x0, PseudoVLSEG6E8_V_MF4_MASK }, // 1644
  { Intrinsic::riscv_vlseg6_mask, 0x8, 0x7, 0x0, PseudoVLSEG6E8_V_MF2_MASK }, // 1645
  { Intrinsic::riscv_vlseg6_mask, 0x10, 0x0, 0x0, PseudoVLSEG6E16_V_M1_MASK }, // 1646
  { Intrinsic::riscv_vlseg6_mask, 0x10, 0x6, 0x0, PseudoVLSEG6E16_V_MF4_MASK }, // 1647
  { Intrinsic::riscv_vlseg6_mask, 0x10, 0x7, 0x0, PseudoVLSEG6E16_V_MF2_MASK }, // 1648
  { Intrinsic::riscv_vlseg6_mask, 0x20, 0x0, 0x0, PseudoVLSEG6E32_V_M1_MASK }, // 1649
  { Intrinsic::riscv_vlseg6_mask, 0x20, 0x7, 0x0, PseudoVLSEG6E32_V_MF2_MASK }, // 1650
  { Intrinsic::riscv_vlseg6_mask, 0x40, 0x0, 0x0, PseudoVLSEG6E64_V_M1_MASK }, // 1651
  { Intrinsic::riscv_vlseg6ff, 0x8, 0x0, 0x0, PseudoVLSEG6E8FF_V_M1 }, // 1652
  { Intrinsic::riscv_vlseg6ff, 0x8, 0x5, 0x0, PseudoVLSEG6E8FF_V_MF8 }, // 1653
  { Intrinsic::riscv_vlseg6ff, 0x8, 0x6, 0x0, PseudoVLSEG6E8FF_V_MF4 }, // 1654
  { Intrinsic::riscv_vlseg6ff, 0x8, 0x7, 0x0, PseudoVLSEG6E8FF_V_MF2 }, // 1655
  { Intrinsic::riscv_vlseg6ff, 0x10, 0x0, 0x0, PseudoVLSEG6E16FF_V_M1 }, // 1656
  { Intrinsic::riscv_vlseg6ff, 0x10, 0x6, 0x0, PseudoVLSEG6E16FF_V_MF4 }, // 1657
  { Intrinsic::riscv_vlseg6ff, 0x10, 0x7, 0x0, PseudoVLSEG6E16FF_V_MF2 }, // 1658
  { Intrinsic::riscv_vlseg6ff, 0x20, 0x0, 0x0, PseudoVLSEG6E32FF_V_M1 }, // 1659
  { Intrinsic::riscv_vlseg6ff, 0x20, 0x7, 0x0, PseudoVLSEG6E32FF_V_MF2 }, // 1660
  { Intrinsic::riscv_vlseg6ff, 0x40, 0x0, 0x0, PseudoVLSEG6E64FF_V_M1 }, // 1661
  { Intrinsic::riscv_vlseg6ff_mask, 0x8, 0x0, 0x0, PseudoVLSEG6E8FF_V_M1_MASK }, // 1662
  { Intrinsic::riscv_vlseg6ff_mask, 0x8, 0x5, 0x0, PseudoVLSEG6E8FF_V_MF8_MASK }, // 1663
  { Intrinsic::riscv_vlseg6ff_mask, 0x8, 0x6, 0x0, PseudoVLSEG6E8FF_V_MF4_MASK }, // 1664
  { Intrinsic::riscv_vlseg6ff_mask, 0x8, 0x7, 0x0, PseudoVLSEG6E8FF_V_MF2_MASK }, // 1665
  { Intrinsic::riscv_vlseg6ff_mask, 0x10, 0x0, 0x0, PseudoVLSEG6E16FF_V_M1_MASK }, // 1666
  { Intrinsic::riscv_vlseg6ff_mask, 0x10, 0x6, 0x0, PseudoVLSEG6E16FF_V_MF4_MASK }, // 1667
  { Intrinsic::riscv_vlseg6ff_mask, 0x10, 0x7, 0x0, PseudoVLSEG6E16FF_V_MF2_MASK }, // 1668
  { Intrinsic::riscv_vlseg6ff_mask, 0x20, 0x0, 0x0, PseudoVLSEG6E32FF_V_M1_MASK }, // 1669
  { Intrinsic::riscv_vlseg6ff_mask, 0x20, 0x7, 0x0, PseudoVLSEG6E32FF_V_MF2_MASK }, // 1670
  { Intrinsic::riscv_vlseg6ff_mask, 0x40, 0x0, 0x0, PseudoVLSEG6E64FF_V_M1_MASK }, // 1671
  { Intrinsic::riscv_vlseg7, 0x8, 0x0, 0x0, PseudoVLSEG7E8_V_M1 }, // 1672
  { Intrinsic::riscv_vlseg7, 0x8, 0x5, 0x0, PseudoVLSEG7E8_V_MF8 }, // 1673
  { Intrinsic::riscv_vlseg7, 0x8, 0x6, 0x0, PseudoVLSEG7E8_V_MF4 }, // 1674
  { Intrinsic::riscv_vlseg7, 0x8, 0x7, 0x0, PseudoVLSEG7E8_V_MF2 }, // 1675
  { Intrinsic::riscv_vlseg7, 0x10, 0x0, 0x0, PseudoVLSEG7E16_V_M1 }, // 1676
  { Intrinsic::riscv_vlseg7, 0x10, 0x6, 0x0, PseudoVLSEG7E16_V_MF4 }, // 1677
  { Intrinsic::riscv_vlseg7, 0x10, 0x7, 0x0, PseudoVLSEG7E16_V_MF2 }, // 1678
  { Intrinsic::riscv_vlseg7, 0x20, 0x0, 0x0, PseudoVLSEG7E32_V_M1 }, // 1679
  { Intrinsic::riscv_vlseg7, 0x20, 0x7, 0x0, PseudoVLSEG7E32_V_MF2 }, // 1680
  { Intrinsic::riscv_vlseg7, 0x40, 0x0, 0x0, PseudoVLSEG7E64_V_M1 }, // 1681
  { Intrinsic::riscv_vlseg7_mask, 0x8, 0x0, 0x0, PseudoVLSEG7E8_V_M1_MASK }, // 1682
  { Intrinsic::riscv_vlseg7_mask, 0x8, 0x5, 0x0, PseudoVLSEG7E8_V_MF8_MASK }, // 1683
  { Intrinsic::riscv_vlseg7_mask, 0x8, 0x6, 0x0, PseudoVLSEG7E8_V_MF4_MASK }, // 1684
  { Intrinsic::riscv_vlseg7_mask, 0x8, 0x7, 0x0, PseudoVLSEG7E8_V_MF2_MASK }, // 1685
  { Intrinsic::riscv_vlseg7_mask, 0x10, 0x0, 0x0, PseudoVLSEG7E16_V_M1_MASK }, // 1686
  { Intrinsic::riscv_vlseg7_mask, 0x10, 0x6, 0x0, PseudoVLSEG7E16_V_MF4_MASK }, // 1687
  { Intrinsic::riscv_vlseg7_mask, 0x10, 0x7, 0x0, PseudoVLSEG7E16_V_MF2_MASK }, // 1688
  { Intrinsic::riscv_vlseg7_mask, 0x20, 0x0, 0x0, PseudoVLSEG7E32_V_M1_MASK }, // 1689
  { Intrinsic::riscv_vlseg7_mask, 0x20, 0x7, 0x0, PseudoVLSEG7E32_V_MF2_MASK }, // 1690
  { Intrinsic::riscv_vlseg7_mask, 0x40, 0x0, 0x0, PseudoVLSEG7E64_V_M1_MASK }, // 1691
  { Intrinsic::riscv_vlseg7ff, 0x8, 0x0, 0x0, PseudoVLSEG7E8FF_V_M1 }, // 1692
  { Intrinsic::riscv_vlseg7ff, 0x8, 0x5, 0x0, PseudoVLSEG7E8FF_V_MF8 }, // 1693
  { Intrinsic::riscv_vlseg7ff, 0x8, 0x6, 0x0, PseudoVLSEG7E8FF_V_MF4 }, // 1694
  { Intrinsic::riscv_vlseg7ff, 0x8, 0x7, 0x0, PseudoVLSEG7E8FF_V_MF2 }, // 1695
  { Intrinsic::riscv_vlseg7ff, 0x10, 0x0, 0x0, PseudoVLSEG7E16FF_V_M1 }, // 1696
  { Intrinsic::riscv_vlseg7ff, 0x10, 0x6, 0x0, PseudoVLSEG7E16FF_V_MF4 }, // 1697
  { Intrinsic::riscv_vlseg7ff, 0x10, 0x7, 0x0, PseudoVLSEG7E16FF_V_MF2 }, // 1698
  { Intrinsic::riscv_vlseg7ff, 0x20, 0x0, 0x0, PseudoVLSEG7E32FF_V_M1 }, // 1699
  { Intrinsic::riscv_vlseg7ff, 0x20, 0x7, 0x0, PseudoVLSEG7E32FF_V_MF2 }, // 1700
  { Intrinsic::riscv_vlseg7ff, 0x40, 0x0, 0x0, PseudoVLSEG7E64FF_V_M1 }, // 1701
  { Intrinsic::riscv_vlseg7ff_mask, 0x8, 0x0, 0x0, PseudoVLSEG7E8FF_V_M1_MASK }, // 1702
  { Intrinsic::riscv_vlseg7ff_mask, 0x8, 0x5, 0x0, PseudoVLSEG7E8FF_V_MF8_MASK }, // 1703
  { Intrinsic::riscv_vlseg7ff_mask, 0x8, 0x6, 0x0, PseudoVLSEG7E8FF_V_MF4_MASK }, // 1704
  { Intrinsic::riscv_vlseg7ff_mask, 0x8, 0x7, 0x0, PseudoVLSEG7E8FF_V_MF2_MASK }, // 1705
  { Intrinsic::riscv_vlseg7ff_mask, 0x10, 0x0, 0x0, PseudoVLSEG7E16FF_V_M1_MASK }, // 1706
  { Intrinsic::riscv_vlseg7ff_mask, 0x10, 0x6, 0x0, PseudoVLSEG7E16FF_V_MF4_MASK }, // 1707
  { Intrinsic::riscv_vlseg7ff_mask, 0x10, 0x7, 0x0, PseudoVLSEG7E16FF_V_MF2_MASK }, // 1708
  { Intrinsic::riscv_vlseg7ff_mask, 0x20, 0x0, 0x0, PseudoVLSEG7E32FF_V_M1_MASK }, // 1709
  { Intrinsic::riscv_vlseg7ff_mask, 0x20, 0x7, 0x0, PseudoVLSEG7E32FF_V_MF2_MASK }, // 1710
  { Intrinsic::riscv_vlseg7ff_mask, 0x40, 0x0, 0x0, PseudoVLSEG7E64FF_V_M1_MASK }, // 1711
  { Intrinsic::riscv_vlseg8, 0x8, 0x0, 0x0, PseudoVLSEG8E8_V_M1 }, // 1712
  { Intrinsic::riscv_vlseg8, 0x8, 0x5, 0x0, PseudoVLSEG8E8_V_MF8 }, // 1713
  { Intrinsic::riscv_vlseg8, 0x8, 0x6, 0x0, PseudoVLSEG8E8_V_MF4 }, // 1714
  { Intrinsic::riscv_vlseg8, 0x8, 0x7, 0x0, PseudoVLSEG8E8_V_MF2 }, // 1715
  { Intrinsic::riscv_vlseg8, 0x10, 0x0, 0x0, PseudoVLSEG8E16_V_M1 }, // 1716
  { Intrinsic::riscv_vlseg8, 0x10, 0x6, 0x0, PseudoVLSEG8E16_V_MF4 }, // 1717
  { Intrinsic::riscv_vlseg8, 0x10, 0x7, 0x0, PseudoVLSEG8E16_V_MF2 }, // 1718
  { Intrinsic::riscv_vlseg8, 0x20, 0x0, 0x0, PseudoVLSEG8E32_V_M1 }, // 1719
  { Intrinsic::riscv_vlseg8, 0x20, 0x7, 0x0, PseudoVLSEG8E32_V_MF2 }, // 1720
  { Intrinsic::riscv_vlseg8, 0x40, 0x0, 0x0, PseudoVLSEG8E64_V_M1 }, // 1721
  { Intrinsic::riscv_vlseg8_mask, 0x8, 0x0, 0x0, PseudoVLSEG8E8_V_M1_MASK }, // 1722
  { Intrinsic::riscv_vlseg8_mask, 0x8, 0x5, 0x0, PseudoVLSEG8E8_V_MF8_MASK }, // 1723
  { Intrinsic::riscv_vlseg8_mask, 0x8, 0x6, 0x0, PseudoVLSEG8E8_V_MF4_MASK }, // 1724
  { Intrinsic::riscv_vlseg8_mask, 0x8, 0x7, 0x0, PseudoVLSEG8E8_V_MF2_MASK }, // 1725
  { Intrinsic::riscv_vlseg8_mask, 0x10, 0x0, 0x0, PseudoVLSEG8E16_V_M1_MASK }, // 1726
  { Intrinsic::riscv_vlseg8_mask, 0x10, 0x6, 0x0, PseudoVLSEG8E16_V_MF4_MASK }, // 1727
  { Intrinsic::riscv_vlseg8_mask, 0x10, 0x7, 0x0, PseudoVLSEG8E16_V_MF2_MASK }, // 1728
  { Intrinsic::riscv_vlseg8_mask, 0x20, 0x0, 0x0, PseudoVLSEG8E32_V_M1_MASK }, // 1729
  { Intrinsic::riscv_vlseg8_mask, 0x20, 0x7, 0x0, PseudoVLSEG8E32_V_MF2_MASK }, // 1730
  { Intrinsic::riscv_vlseg8_mask, 0x40, 0x0, 0x0, PseudoVLSEG8E64_V_M1_MASK }, // 1731
  { Intrinsic::riscv_vlseg8ff, 0x8, 0x0, 0x0, PseudoVLSEG8E8FF_V_M1 }, // 1732
  { Intrinsic::riscv_vlseg8ff, 0x8, 0x5, 0x0, PseudoVLSEG8E8FF_V_MF8 }, // 1733
  { Intrinsic::riscv_vlseg8ff, 0x8, 0x6, 0x0, PseudoVLSEG8E8FF_V_MF4 }, // 1734
  { Intrinsic::riscv_vlseg8ff, 0x8, 0x7, 0x0, PseudoVLSEG8E8FF_V_MF2 }, // 1735
  { Intrinsic::riscv_vlseg8ff, 0x10, 0x0, 0x0, PseudoVLSEG8E16FF_V_M1 }, // 1736
  { Intrinsic::riscv_vlseg8ff, 0x10, 0x6, 0x0, PseudoVLSEG8E16FF_V_MF4 }, // 1737
  { Intrinsic::riscv_vlseg8ff, 0x10, 0x7, 0x0, PseudoVLSEG8E16FF_V_MF2 }, // 1738
  { Intrinsic::riscv_vlseg8ff, 0x20, 0x0, 0x0, PseudoVLSEG8E32FF_V_M1 }, // 1739
  { Intrinsic::riscv_vlseg8ff, 0x20, 0x7, 0x0, PseudoVLSEG8E32FF_V_MF2 }, // 1740
  { Intrinsic::riscv_vlseg8ff, 0x40, 0x0, 0x0, PseudoVLSEG8E64FF_V_M1 }, // 1741
  { Intrinsic::riscv_vlseg8ff_mask, 0x8, 0x0, 0x0, PseudoVLSEG8E8FF_V_M1_MASK }, // 1742
  { Intrinsic::riscv_vlseg8ff_mask, 0x8, 0x5, 0x0, PseudoVLSEG8E8FF_V_MF8_MASK }, // 1743
  { Intrinsic::riscv_vlseg8ff_mask, 0x8, 0x6, 0x0, PseudoVLSEG8E8FF_V_MF4_MASK }, // 1744
  { Intrinsic::riscv_vlseg8ff_mask, 0x8, 0x7, 0x0, PseudoVLSEG8E8FF_V_MF2_MASK }, // 1745
  { Intrinsic::riscv_vlseg8ff_mask, 0x10, 0x0, 0x0, PseudoVLSEG8E16FF_V_M1_MASK }, // 1746
  { Intrinsic::riscv_vlseg8ff_mask, 0x10, 0x6, 0x0, PseudoVLSEG8E16FF_V_MF4_MASK }, // 1747
  { Intrinsic::riscv_vlseg8ff_mask, 0x10, 0x7, 0x0, PseudoVLSEG8E16FF_V_MF2_MASK }, // 1748
  { Intrinsic::riscv_vlseg8ff_mask, 0x20, 0x0, 0x0, PseudoVLSEG8E32FF_V_M1_MASK }, // 1749
  { Intrinsic::riscv_vlseg8ff_mask, 0x20, 0x7, 0x0, PseudoVLSEG8E32FF_V_MF2_MASK }, // 1750
  { Intrinsic::riscv_vlseg8ff_mask, 0x40, 0x0, 0x0, PseudoVLSEG8E64FF_V_M1_MASK }, // 1751
  { Intrinsic::riscv_vlsseg2, 0x8, 0x0, 0x0, PseudoVLSSEG2E8_V_M1 }, // 1752
  { Intrinsic::riscv_vlsseg2, 0x8, 0x1, 0x0, PseudoVLSSEG2E8_V_M2 }, // 1753
  { Intrinsic::riscv_vlsseg2, 0x8, 0x2, 0x0, PseudoVLSSEG2E8_V_M4 }, // 1754
  { Intrinsic::riscv_vlsseg2, 0x8, 0x5, 0x0, PseudoVLSSEG2E8_V_MF8 }, // 1755
  { Intrinsic::riscv_vlsseg2, 0x8, 0x6, 0x0, PseudoVLSSEG2E8_V_MF4 }, // 1756
  { Intrinsic::riscv_vlsseg2, 0x8, 0x7, 0x0, PseudoVLSSEG2E8_V_MF2 }, // 1757
  { Intrinsic::riscv_vlsseg2, 0x10, 0x0, 0x0, PseudoVLSSEG2E16_V_M1 }, // 1758
  { Intrinsic::riscv_vlsseg2, 0x10, 0x1, 0x0, PseudoVLSSEG2E16_V_M2 }, // 1759
  { Intrinsic::riscv_vlsseg2, 0x10, 0x2, 0x0, PseudoVLSSEG2E16_V_M4 }, // 1760
  { Intrinsic::riscv_vlsseg2, 0x10, 0x6, 0x0, PseudoVLSSEG2E16_V_MF4 }, // 1761
  { Intrinsic::riscv_vlsseg2, 0x10, 0x7, 0x0, PseudoVLSSEG2E16_V_MF2 }, // 1762
  { Intrinsic::riscv_vlsseg2, 0x20, 0x0, 0x0, PseudoVLSSEG2E32_V_M1 }, // 1763
  { Intrinsic::riscv_vlsseg2, 0x20, 0x1, 0x0, PseudoVLSSEG2E32_V_M2 }, // 1764
  { Intrinsic::riscv_vlsseg2, 0x20, 0x2, 0x0, PseudoVLSSEG2E32_V_M4 }, // 1765
  { Intrinsic::riscv_vlsseg2, 0x20, 0x7, 0x0, PseudoVLSSEG2E32_V_MF2 }, // 1766
  { Intrinsic::riscv_vlsseg2, 0x40, 0x0, 0x0, PseudoVLSSEG2E64_V_M1 }, // 1767
  { Intrinsic::riscv_vlsseg2, 0x40, 0x1, 0x0, PseudoVLSSEG2E64_V_M2 }, // 1768
  { Intrinsic::riscv_vlsseg2, 0x40, 0x2, 0x0, PseudoVLSSEG2E64_V_M4 }, // 1769
  { Intrinsic::riscv_vlsseg2_mask, 0x8, 0x0, 0x0, PseudoVLSSEG2E8_V_M1_MASK }, // 1770
  { Intrinsic::riscv_vlsseg2_mask, 0x8, 0x1, 0x0, PseudoVLSSEG2E8_V_M2_MASK }, // 1771
  { Intrinsic::riscv_vlsseg2_mask, 0x8, 0x2, 0x0, PseudoVLSSEG2E8_V_M4_MASK }, // 1772
  { Intrinsic::riscv_vlsseg2_mask, 0x8, 0x5, 0x0, PseudoVLSSEG2E8_V_MF8_MASK }, // 1773
  { Intrinsic::riscv_vlsseg2_mask, 0x8, 0x6, 0x0, PseudoVLSSEG2E8_V_MF4_MASK }, // 1774
  { Intrinsic::riscv_vlsseg2_mask, 0x8, 0x7, 0x0, PseudoVLSSEG2E8_V_MF2_MASK }, // 1775
  { Intrinsic::riscv_vlsseg2_mask, 0x10, 0x0, 0x0, PseudoVLSSEG2E16_V_M1_MASK }, // 1776
  { Intrinsic::riscv_vlsseg2_mask, 0x10, 0x1, 0x0, PseudoVLSSEG2E16_V_M2_MASK }, // 1777
  { Intrinsic::riscv_vlsseg2_mask, 0x10, 0x2, 0x0, PseudoVLSSEG2E16_V_M4_MASK }, // 1778
  { Intrinsic::riscv_vlsseg2_mask, 0x10, 0x6, 0x0, PseudoVLSSEG2E16_V_MF4_MASK }, // 1779
  { Intrinsic::riscv_vlsseg2_mask, 0x10, 0x7, 0x0, PseudoVLSSEG2E16_V_MF2_MASK }, // 1780
  { Intrinsic::riscv_vlsseg2_mask, 0x20, 0x0, 0x0, PseudoVLSSEG2E32_V_M1_MASK }, // 1781
  { Intrinsic::riscv_vlsseg2_mask, 0x20, 0x1, 0x0, PseudoVLSSEG2E32_V_M2_MASK }, // 1782
  { Intrinsic::riscv_vlsseg2_mask, 0x20, 0x2, 0x0, PseudoVLSSEG2E32_V_M4_MASK }, // 1783
  { Intrinsic::riscv_vlsseg2_mask, 0x20, 0x7, 0x0, PseudoVLSSEG2E32_V_MF2_MASK }, // 1784
  { Intrinsic::riscv_vlsseg2_mask, 0x40, 0x0, 0x0, PseudoVLSSEG2E64_V_M1_MASK }, // 1785
  { Intrinsic::riscv_vlsseg2_mask, 0x40, 0x1, 0x0, PseudoVLSSEG2E64_V_M2_MASK }, // 1786
  { Intrinsic::riscv_vlsseg2_mask, 0x40, 0x2, 0x0, PseudoVLSSEG2E64_V_M4_MASK }, // 1787
  { Intrinsic::riscv_vlsseg3, 0x8, 0x0, 0x0, PseudoVLSSEG3E8_V_M1 }, // 1788
  { Intrinsic::riscv_vlsseg3, 0x8, 0x1, 0x0, PseudoVLSSEG3E8_V_M2 }, // 1789
  { Intrinsic::riscv_vlsseg3, 0x8, 0x5, 0x0, PseudoVLSSEG3E8_V_MF8 }, // 1790
  { Intrinsic::riscv_vlsseg3, 0x8, 0x6, 0x0, PseudoVLSSEG3E8_V_MF4 }, // 1791
  { Intrinsic::riscv_vlsseg3, 0x8, 0x7, 0x0, PseudoVLSSEG3E8_V_MF2 }, // 1792
  { Intrinsic::riscv_vlsseg3, 0x10, 0x0, 0x0, PseudoVLSSEG3E16_V_M1 }, // 1793
  { Intrinsic::riscv_vlsseg3, 0x10, 0x1, 0x0, PseudoVLSSEG3E16_V_M2 }, // 1794
  { Intrinsic::riscv_vlsseg3, 0x10, 0x6, 0x0, PseudoVLSSEG3E16_V_MF4 }, // 1795
  { Intrinsic::riscv_vlsseg3, 0x10, 0x7, 0x0, PseudoVLSSEG3E16_V_MF2 }, // 1796
  { Intrinsic::riscv_vlsseg3, 0x20, 0x0, 0x0, PseudoVLSSEG3E32_V_M1 }, // 1797
  { Intrinsic::riscv_vlsseg3, 0x20, 0x1, 0x0, PseudoVLSSEG3E32_V_M2 }, // 1798
  { Intrinsic::riscv_vlsseg3, 0x20, 0x7, 0x0, PseudoVLSSEG3E32_V_MF2 }, // 1799
  { Intrinsic::riscv_vlsseg3, 0x40, 0x0, 0x0, PseudoVLSSEG3E64_V_M1 }, // 1800
  { Intrinsic::riscv_vlsseg3, 0x40, 0x1, 0x0, PseudoVLSSEG3E64_V_M2 }, // 1801
  { Intrinsic::riscv_vlsseg3_mask, 0x8, 0x0, 0x0, PseudoVLSSEG3E8_V_M1_MASK }, // 1802
  { Intrinsic::riscv_vlsseg3_mask, 0x8, 0x1, 0x0, PseudoVLSSEG3E8_V_M2_MASK }, // 1803
  { Intrinsic::riscv_vlsseg3_mask, 0x8, 0x5, 0x0, PseudoVLSSEG3E8_V_MF8_MASK }, // 1804
  { Intrinsic::riscv_vlsseg3_mask, 0x8, 0x6, 0x0, PseudoVLSSEG3E8_V_MF4_MASK }, // 1805
  { Intrinsic::riscv_vlsseg3_mask, 0x8, 0x7, 0x0, PseudoVLSSEG3E8_V_MF2_MASK }, // 1806
  { Intrinsic::riscv_vlsseg3_mask, 0x10, 0x0, 0x0, PseudoVLSSEG3E16_V_M1_MASK }, // 1807
  { Intrinsic::riscv_vlsseg3_mask, 0x10, 0x1, 0x0, PseudoVLSSEG3E16_V_M2_MASK }, // 1808
  { Intrinsic::riscv_vlsseg3_mask, 0x10, 0x6, 0x0, PseudoVLSSEG3E16_V_MF4_MASK }, // 1809
  { Intrinsic::riscv_vlsseg3_mask, 0x10, 0x7, 0x0, PseudoVLSSEG3E16_V_MF2_MASK }, // 1810
  { Intrinsic::riscv_vlsseg3_mask, 0x20, 0x0, 0x0, PseudoVLSSEG3E32_V_M1_MASK }, // 1811
  { Intrinsic::riscv_vlsseg3_mask, 0x20, 0x1, 0x0, PseudoVLSSEG3E32_V_M2_MASK }, // 1812
  { Intrinsic::riscv_vlsseg3_mask, 0x20, 0x7, 0x0, PseudoVLSSEG3E32_V_MF2_MASK }, // 1813
  { Intrinsic::riscv_vlsseg3_mask, 0x40, 0x0, 0x0, PseudoVLSSEG3E64_V_M1_MASK }, // 1814
  { Intrinsic::riscv_vlsseg3_mask, 0x40, 0x1, 0x0, PseudoVLSSEG3E64_V_M2_MASK }, // 1815
  { Intrinsic::riscv_vlsseg4, 0x8, 0x0, 0x0, PseudoVLSSEG4E8_V_M1 }, // 1816
  { Intrinsic::riscv_vlsseg4, 0x8, 0x1, 0x0, PseudoVLSSEG4E8_V_M2 }, // 1817
  { Intrinsic::riscv_vlsseg4, 0x8, 0x5, 0x0, PseudoVLSSEG4E8_V_MF8 }, // 1818
  { Intrinsic::riscv_vlsseg4, 0x8, 0x6, 0x0, PseudoVLSSEG4E8_V_MF4 }, // 1819
  { Intrinsic::riscv_vlsseg4, 0x8, 0x7, 0x0, PseudoVLSSEG4E8_V_MF2 }, // 1820
  { Intrinsic::riscv_vlsseg4, 0x10, 0x0, 0x0, PseudoVLSSEG4E16_V_M1 }, // 1821
  { Intrinsic::riscv_vlsseg4, 0x10, 0x1, 0x0, PseudoVLSSEG4E16_V_M2 }, // 1822
  { Intrinsic::riscv_vlsseg4, 0x10, 0x6, 0x0, PseudoVLSSEG4E16_V_MF4 }, // 1823
  { Intrinsic::riscv_vlsseg4, 0x10, 0x7, 0x0, PseudoVLSSEG4E16_V_MF2 }, // 1824
  { Intrinsic::riscv_vlsseg4, 0x20, 0x0, 0x0, PseudoVLSSEG4E32_V_M1 }, // 1825
  { Intrinsic::riscv_vlsseg4, 0x20, 0x1, 0x0, PseudoVLSSEG4E32_V_M2 }, // 1826
  { Intrinsic::riscv_vlsseg4, 0x20, 0x7, 0x0, PseudoVLSSEG4E32_V_MF2 }, // 1827
  { Intrinsic::riscv_vlsseg4, 0x40, 0x0, 0x0, PseudoVLSSEG4E64_V_M1 }, // 1828
  { Intrinsic::riscv_vlsseg4, 0x40, 0x1, 0x0, PseudoVLSSEG4E64_V_M2 }, // 1829
  { Intrinsic::riscv_vlsseg4_mask, 0x8, 0x0, 0x0, PseudoVLSSEG4E8_V_M1_MASK }, // 1830
  { Intrinsic::riscv_vlsseg4_mask, 0x8, 0x1, 0x0, PseudoVLSSEG4E8_V_M2_MASK }, // 1831
  { Intrinsic::riscv_vlsseg4_mask, 0x8, 0x5, 0x0, PseudoVLSSEG4E8_V_MF8_MASK }, // 1832
  { Intrinsic::riscv_vlsseg4_mask, 0x8, 0x6, 0x0, PseudoVLSSEG4E8_V_MF4_MASK }, // 1833
  { Intrinsic::riscv_vlsseg4_mask, 0x8, 0x7, 0x0, PseudoVLSSEG4E8_V_MF2_MASK }, // 1834
  { Intrinsic::riscv_vlsseg4_mask, 0x10, 0x0, 0x0, PseudoVLSSEG4E16_V_M1_MASK }, // 1835
  { Intrinsic::riscv_vlsseg4_mask, 0x10, 0x1, 0x0, PseudoVLSSEG4E16_V_M2_MASK }, // 1836
  { Intrinsic::riscv_vlsseg4_mask, 0x10, 0x6, 0x0, PseudoVLSSEG4E16_V_MF4_MASK }, // 1837
  { Intrinsic::riscv_vlsseg4_mask, 0x10, 0x7, 0x0, PseudoVLSSEG4E16_V_MF2_MASK }, // 1838
  { Intrinsic::riscv_vlsseg4_mask, 0x20, 0x0, 0x0, PseudoVLSSEG4E32_V_M1_MASK }, // 1839
  { Intrinsic::riscv_vlsseg4_mask, 0x20, 0x1, 0x0, PseudoVLSSEG4E32_V_M2_MASK }, // 1840
  { Intrinsic::riscv_vlsseg4_mask, 0x20, 0x7, 0x0, PseudoVLSSEG4E32_V_MF2_MASK }, // 1841
  { Intrinsic::riscv_vlsseg4_mask, 0x40, 0x0, 0x0, PseudoVLSSEG4E64_V_M1_MASK }, // 1842
  { Intrinsic::riscv_vlsseg4_mask, 0x40, 0x1, 0x0, PseudoVLSSEG4E64_V_M2_MASK }, // 1843
  { Intrinsic::riscv_vlsseg5, 0x8, 0x0, 0x0, PseudoVLSSEG5E8_V_M1 }, // 1844
  { Intrinsic::riscv_vlsseg5, 0x8, 0x5, 0x0, PseudoVLSSEG5E8_V_MF8 }, // 1845
  { Intrinsic::riscv_vlsseg5, 0x8, 0x6, 0x0, PseudoVLSSEG5E8_V_MF4 }, // 1846
  { Intrinsic::riscv_vlsseg5, 0x8, 0x7, 0x0, PseudoVLSSEG5E8_V_MF2 }, // 1847
  { Intrinsic::riscv_vlsseg5, 0x10, 0x0, 0x0, PseudoVLSSEG5E16_V_M1 }, // 1848
  { Intrinsic::riscv_vlsseg5, 0x10, 0x6, 0x0, PseudoVLSSEG5E16_V_MF4 }, // 1849
  { Intrinsic::riscv_vlsseg5, 0x10, 0x7, 0x0, PseudoVLSSEG5E16_V_MF2 }, // 1850
  { Intrinsic::riscv_vlsseg5, 0x20, 0x0, 0x0, PseudoVLSSEG5E32_V_M1 }, // 1851
  { Intrinsic::riscv_vlsseg5, 0x20, 0x7, 0x0, PseudoVLSSEG5E32_V_MF2 }, // 1852
  { Intrinsic::riscv_vlsseg5, 0x40, 0x0, 0x0, PseudoVLSSEG5E64_V_M1 }, // 1853
  { Intrinsic::riscv_vlsseg5_mask, 0x8, 0x0, 0x0, PseudoVLSSEG5E8_V_M1_MASK }, // 1854
  { Intrinsic::riscv_vlsseg5_mask, 0x8, 0x5, 0x0, PseudoVLSSEG5E8_V_MF8_MASK }, // 1855
  { Intrinsic::riscv_vlsseg5_mask, 0x8, 0x6, 0x0, PseudoVLSSEG5E8_V_MF4_MASK }, // 1856
  { Intrinsic::riscv_vlsseg5_mask, 0x8, 0x7, 0x0, PseudoVLSSEG5E8_V_MF2_MASK }, // 1857
  { Intrinsic::riscv_vlsseg5_mask, 0x10, 0x0, 0x0, PseudoVLSSEG5E16_V_M1_MASK }, // 1858
  { Intrinsic::riscv_vlsseg5_mask, 0x10, 0x6, 0x0, PseudoVLSSEG5E16_V_MF4_MASK }, // 1859
  { Intrinsic::riscv_vlsseg5_mask, 0x10, 0x7, 0x0, PseudoVLSSEG5E16_V_MF2_MASK }, // 1860
  { Intrinsic::riscv_vlsseg5_mask, 0x20, 0x0, 0x0, PseudoVLSSEG5E32_V_M1_MASK }, // 1861
  { Intrinsic::riscv_vlsseg5_mask, 0x20, 0x7, 0x0, PseudoVLSSEG5E32_V_MF2_MASK }, // 1862
  { Intrinsic::riscv_vlsseg5_mask, 0x40, 0x0, 0x0, PseudoVLSSEG5E64_V_M1_MASK }, // 1863
  { Intrinsic::riscv_vlsseg6, 0x8, 0x0, 0x0, PseudoVLSSEG6E8_V_M1 }, // 1864
  { Intrinsic::riscv_vlsseg6, 0x8, 0x5, 0x0, PseudoVLSSEG6E8_V_MF8 }, // 1865
  { Intrinsic::riscv_vlsseg6, 0x8, 0x6, 0x0, PseudoVLSSEG6E8_V_MF4 }, // 1866
  { Intrinsic::riscv_vlsseg6, 0x8, 0x7, 0x0, PseudoVLSSEG6E8_V_MF2 }, // 1867
  { Intrinsic::riscv_vlsseg6, 0x10, 0x0, 0x0, PseudoVLSSEG6E16_V_M1 }, // 1868
  { Intrinsic::riscv_vlsseg6, 0x10, 0x6, 0x0, PseudoVLSSEG6E16_V_MF4 }, // 1869
  { Intrinsic::riscv_vlsseg6, 0x10, 0x7, 0x0, PseudoVLSSEG6E16_V_MF2 }, // 1870
  { Intrinsic::riscv_vlsseg6, 0x20, 0x0, 0x0, PseudoVLSSEG6E32_V_M1 }, // 1871
  { Intrinsic::riscv_vlsseg6, 0x20, 0x7, 0x0, PseudoVLSSEG6E32_V_MF2 }, // 1872
  { Intrinsic::riscv_vlsseg6, 0x40, 0x0, 0x0, PseudoVLSSEG6E64_V_M1 }, // 1873
  { Intrinsic::riscv_vlsseg6_mask, 0x8, 0x0, 0x0, PseudoVLSSEG6E8_V_M1_MASK }, // 1874
  { Intrinsic::riscv_vlsseg6_mask, 0x8, 0x5, 0x0, PseudoVLSSEG6E8_V_MF8_MASK }, // 1875
  { Intrinsic::riscv_vlsseg6_mask, 0x8, 0x6, 0x0, PseudoVLSSEG6E8_V_MF4_MASK }, // 1876
  { Intrinsic::riscv_vlsseg6_mask, 0x8, 0x7, 0x0, PseudoVLSSEG6E8_V_MF2_MASK }, // 1877
  { Intrinsic::riscv_vlsseg6_mask, 0x10, 0x0, 0x0, PseudoVLSSEG6E16_V_M1_MASK }, // 1878
  { Intrinsic::riscv_vlsseg6_mask, 0x10, 0x6, 0x0, PseudoVLSSEG6E16_V_MF4_MASK }, // 1879
  { Intrinsic::riscv_vlsseg6_mask, 0x10, 0x7, 0x0, PseudoVLSSEG6E16_V_MF2_MASK }, // 1880
  { Intrinsic::riscv_vlsseg6_mask, 0x20, 0x0, 0x0, PseudoVLSSEG6E32_V_M1_MASK }, // 1881
  { Intrinsic::riscv_vlsseg6_mask, 0x20, 0x7, 0x0, PseudoVLSSEG6E32_V_MF2_MASK }, // 1882
  { Intrinsic::riscv_vlsseg6_mask, 0x40, 0x0, 0x0, PseudoVLSSEG6E64_V_M1_MASK }, // 1883
  { Intrinsic::riscv_vlsseg7, 0x8, 0x0, 0x0, PseudoVLSSEG7E8_V_M1 }, // 1884
  { Intrinsic::riscv_vlsseg7, 0x8, 0x5, 0x0, PseudoVLSSEG7E8_V_MF8 }, // 1885
  { Intrinsic::riscv_vlsseg7, 0x8, 0x6, 0x0, PseudoVLSSEG7E8_V_MF4 }, // 1886
  { Intrinsic::riscv_vlsseg7, 0x8, 0x7, 0x0, PseudoVLSSEG7E8_V_MF2 }, // 1887
  { Intrinsic::riscv_vlsseg7, 0x10, 0x0, 0x0, PseudoVLSSEG7E16_V_M1 }, // 1888
  { Intrinsic::riscv_vlsseg7, 0x10, 0x6, 0x0, PseudoVLSSEG7E16_V_MF4 }, // 1889
  { Intrinsic::riscv_vlsseg7, 0x10, 0x7, 0x0, PseudoVLSSEG7E16_V_MF2 }, // 1890
  { Intrinsic::riscv_vlsseg7, 0x20, 0x0, 0x0, PseudoVLSSEG7E32_V_M1 }, // 1891
  { Intrinsic::riscv_vlsseg7, 0x20, 0x7, 0x0, PseudoVLSSEG7E32_V_MF2 }, // 1892
  { Intrinsic::riscv_vlsseg7, 0x40, 0x0, 0x0, PseudoVLSSEG7E64_V_M1 }, // 1893
  { Intrinsic::riscv_vlsseg7_mask, 0x8, 0x0, 0x0, PseudoVLSSEG7E8_V_M1_MASK }, // 1894
  { Intrinsic::riscv_vlsseg7_mask, 0x8, 0x5, 0x0, PseudoVLSSEG7E8_V_MF8_MASK }, // 1895
  { Intrinsic::riscv_vlsseg7_mask, 0x8, 0x6, 0x0, PseudoVLSSEG7E8_V_MF4_MASK }, // 1896
  { Intrinsic::riscv_vlsseg7_mask, 0x8, 0x7, 0x0, PseudoVLSSEG7E8_V_MF2_MASK }, // 1897
  { Intrinsic::riscv_vlsseg7_mask, 0x10, 0x0, 0x0, PseudoVLSSEG7E16_V_M1_MASK }, // 1898
  { Intrinsic::riscv_vlsseg7_mask, 0x10, 0x6, 0x0, PseudoVLSSEG7E16_V_MF4_MASK }, // 1899
  { Intrinsic::riscv_vlsseg7_mask, 0x10, 0x7, 0x0, PseudoVLSSEG7E16_V_MF2_MASK }, // 1900
  { Intrinsic::riscv_vlsseg7_mask, 0x20, 0x0, 0x0, PseudoVLSSEG7E32_V_M1_MASK }, // 1901
  { Intrinsic::riscv_vlsseg7_mask, 0x20, 0x7, 0x0, PseudoVLSSEG7E32_V_MF2_MASK }, // 1902
  { Intrinsic::riscv_vlsseg7_mask, 0x40, 0x0, 0x0, PseudoVLSSEG7E64_V_M1_MASK }, // 1903
  { Intrinsic::riscv_vlsseg8, 0x8, 0x0, 0x0, PseudoVLSSEG8E8_V_M1 }, // 1904
  { Intrinsic::riscv_vlsseg8, 0x8, 0x5, 0x0, PseudoVLSSEG8E8_V_MF8 }, // 1905
  { Intrinsic::riscv_vlsseg8, 0x8, 0x6, 0x0, PseudoVLSSEG8E8_V_MF4 }, // 1906
  { Intrinsic::riscv_vlsseg8, 0x8, 0x7, 0x0, PseudoVLSSEG8E8_V_MF2 }, // 1907
  { Intrinsic::riscv_vlsseg8, 0x10, 0x0, 0x0, PseudoVLSSEG8E16_V_M1 }, // 1908
  { Intrinsic::riscv_vlsseg8, 0x10, 0x6, 0x0, PseudoVLSSEG8E16_V_MF4 }, // 1909
  { Intrinsic::riscv_vlsseg8, 0x10, 0x7, 0x0, PseudoVLSSEG8E16_V_MF2 }, // 1910
  { Intrinsic::riscv_vlsseg8, 0x20, 0x0, 0x0, PseudoVLSSEG8E32_V_M1 }, // 1911
  { Intrinsic::riscv_vlsseg8, 0x20, 0x7, 0x0, PseudoVLSSEG8E32_V_MF2 }, // 1912
  { Intrinsic::riscv_vlsseg8, 0x40, 0x0, 0x0, PseudoVLSSEG8E64_V_M1 }, // 1913
  { Intrinsic::riscv_vlsseg8_mask, 0x8, 0x0, 0x0, PseudoVLSSEG8E8_V_M1_MASK }, // 1914
  { Intrinsic::riscv_vlsseg8_mask, 0x8, 0x5, 0x0, PseudoVLSSEG8E8_V_MF8_MASK }, // 1915
  { Intrinsic::riscv_vlsseg8_mask, 0x8, 0x6, 0x0, PseudoVLSSEG8E8_V_MF4_MASK }, // 1916
  { Intrinsic::riscv_vlsseg8_mask, 0x8, 0x7, 0x0, PseudoVLSSEG8E8_V_MF2_MASK }, // 1917
  { Intrinsic::riscv_vlsseg8_mask, 0x10, 0x0, 0x0, PseudoVLSSEG8E16_V_M1_MASK }, // 1918
  { Intrinsic::riscv_vlsseg8_mask, 0x10, 0x6, 0x0, PseudoVLSSEG8E16_V_MF4_MASK }, // 1919
  { Intrinsic::riscv_vlsseg8_mask, 0x10, 0x7, 0x0, PseudoVLSSEG8E16_V_MF2_MASK }, // 1920
  { Intrinsic::riscv_vlsseg8_mask, 0x20, 0x0, 0x0, PseudoVLSSEG8E32_V_M1_MASK }, // 1921
  { Intrinsic::riscv_vlsseg8_mask, 0x20, 0x7, 0x0, PseudoVLSSEG8E32_V_MF2_MASK }, // 1922
  { Intrinsic::riscv_vlsseg8_mask, 0x40, 0x0, 0x0, PseudoVLSSEG8E64_V_M1_MASK }, // 1923
  { Intrinsic::riscv_vluxseg2, 0x8, 0x0, 0x0, PseudoVLUXSEG2EI8_V_M1_M1 }, // 1924
  { Intrinsic::riscv_vluxseg2, 0x8, 0x0, 0x1, PseudoVLUXSEG2EI8_V_M2_M1 }, // 1925
  { Intrinsic::riscv_vluxseg2, 0x8, 0x0, 0x2, PseudoVLUXSEG2EI8_V_M4_M1 }, // 1926
  { Intrinsic::riscv_vluxseg2, 0x8, 0x0, 0x3, PseudoVLUXSEG2EI8_V_M8_M1 }, // 1927
  { Intrinsic::riscv_vluxseg2, 0x8, 0x0, 0x5, PseudoVLUXSEG2EI8_V_MF8_M1 }, // 1928
  { Intrinsic::riscv_vluxseg2, 0x8, 0x0, 0x6, PseudoVLUXSEG2EI8_V_MF4_M1 }, // 1929
  { Intrinsic::riscv_vluxseg2, 0x8, 0x0, 0x7, PseudoVLUXSEG2EI8_V_MF2_M1 }, // 1930
  { Intrinsic::riscv_vluxseg2, 0x8, 0x1, 0x0, PseudoVLUXSEG2EI8_V_M1_M2 }, // 1931
  { Intrinsic::riscv_vluxseg2, 0x8, 0x1, 0x1, PseudoVLUXSEG2EI8_V_M2_M2 }, // 1932
  { Intrinsic::riscv_vluxseg2, 0x8, 0x1, 0x2, PseudoVLUXSEG2EI8_V_M4_M2 }, // 1933
  { Intrinsic::riscv_vluxseg2, 0x8, 0x1, 0x3, PseudoVLUXSEG2EI8_V_M8_M2 }, // 1934
  { Intrinsic::riscv_vluxseg2, 0x8, 0x1, 0x5, PseudoVLUXSEG2EI8_V_MF8_M2 }, // 1935
  { Intrinsic::riscv_vluxseg2, 0x8, 0x1, 0x6, PseudoVLUXSEG2EI8_V_MF4_M2 }, // 1936
  { Intrinsic::riscv_vluxseg2, 0x8, 0x1, 0x7, PseudoVLUXSEG2EI8_V_MF2_M2 }, // 1937
  { Intrinsic::riscv_vluxseg2, 0x8, 0x2, 0x0, PseudoVLUXSEG2EI8_V_M1_M4 }, // 1938
  { Intrinsic::riscv_vluxseg2, 0x8, 0x2, 0x1, PseudoVLUXSEG2EI8_V_M2_M4 }, // 1939
  { Intrinsic::riscv_vluxseg2, 0x8, 0x2, 0x2, PseudoVLUXSEG2EI8_V_M4_M4 }, // 1940
  { Intrinsic::riscv_vluxseg2, 0x8, 0x2, 0x3, PseudoVLUXSEG2EI8_V_M8_M4 }, // 1941
  { Intrinsic::riscv_vluxseg2, 0x8, 0x2, 0x5, PseudoVLUXSEG2EI8_V_MF8_M4 }, // 1942
  { Intrinsic::riscv_vluxseg2, 0x8, 0x2, 0x6, PseudoVLUXSEG2EI8_V_MF4_M4 }, // 1943
  { Intrinsic::riscv_vluxseg2, 0x8, 0x2, 0x7, PseudoVLUXSEG2EI8_V_MF2_M4 }, // 1944
  { Intrinsic::riscv_vluxseg2, 0x8, 0x5, 0x0, PseudoVLUXSEG2EI8_V_M1_MF8 }, // 1945
  { Intrinsic::riscv_vluxseg2, 0x8, 0x5, 0x1, PseudoVLUXSEG2EI8_V_M2_MF8 }, // 1946
  { Intrinsic::riscv_vluxseg2, 0x8, 0x5, 0x2, PseudoVLUXSEG2EI8_V_M4_MF8 }, // 1947
  { Intrinsic::riscv_vluxseg2, 0x8, 0x5, 0x3, PseudoVLUXSEG2EI8_V_M8_MF8 }, // 1948
  { Intrinsic::riscv_vluxseg2, 0x8, 0x5, 0x5, PseudoVLUXSEG2EI8_V_MF8_MF8 }, // 1949
  { Intrinsic::riscv_vluxseg2, 0x8, 0x5, 0x6, PseudoVLUXSEG2EI8_V_MF4_MF8 }, // 1950
  { Intrinsic::riscv_vluxseg2, 0x8, 0x5, 0x7, PseudoVLUXSEG2EI8_V_MF2_MF8 }, // 1951
  { Intrinsic::riscv_vluxseg2, 0x8, 0x6, 0x0, PseudoVLUXSEG2EI8_V_M1_MF4 }, // 1952
  { Intrinsic::riscv_vluxseg2, 0x8, 0x6, 0x1, PseudoVLUXSEG2EI8_V_M2_MF4 }, // 1953
  { Intrinsic::riscv_vluxseg2, 0x8, 0x6, 0x2, PseudoVLUXSEG2EI8_V_M4_MF4 }, // 1954
  { Intrinsic::riscv_vluxseg2, 0x8, 0x6, 0x3, PseudoVLUXSEG2EI8_V_M8_MF4 }, // 1955
  { Intrinsic::riscv_vluxseg2, 0x8, 0x6, 0x5, PseudoVLUXSEG2EI8_V_MF8_MF4 }, // 1956
  { Intrinsic::riscv_vluxseg2, 0x8, 0x6, 0x6, PseudoVLUXSEG2EI8_V_MF4_MF4 }, // 1957
  { Intrinsic::riscv_vluxseg2, 0x8, 0x6, 0x7, PseudoVLUXSEG2EI8_V_MF2_MF4 }, // 1958
  { Intrinsic::riscv_vluxseg2, 0x8, 0x7, 0x0, PseudoVLUXSEG2EI8_V_M1_MF2 }, // 1959
  { Intrinsic::riscv_vluxseg2, 0x8, 0x7, 0x1, PseudoVLUXSEG2EI8_V_M2_MF2 }, // 1960
  { Intrinsic::riscv_vluxseg2, 0x8, 0x7, 0x2, PseudoVLUXSEG2EI8_V_M4_MF2 }, // 1961
  { Intrinsic::riscv_vluxseg2, 0x8, 0x7, 0x3, PseudoVLUXSEG2EI8_V_M8_MF2 }, // 1962
  { Intrinsic::riscv_vluxseg2, 0x8, 0x7, 0x5, PseudoVLUXSEG2EI8_V_MF8_MF2 }, // 1963
  { Intrinsic::riscv_vluxseg2, 0x8, 0x7, 0x6, PseudoVLUXSEG2EI8_V_MF4_MF2 }, // 1964
  { Intrinsic::riscv_vluxseg2, 0x8, 0x7, 0x7, PseudoVLUXSEG2EI8_V_MF2_MF2 }, // 1965
  { Intrinsic::riscv_vluxseg2, 0x10, 0x0, 0x0, PseudoVLUXSEG2EI16_V_M1_M1 }, // 1966
  { Intrinsic::riscv_vluxseg2, 0x10, 0x0, 0x1, PseudoVLUXSEG2EI16_V_M2_M1 }, // 1967
  { Intrinsic::riscv_vluxseg2, 0x10, 0x0, 0x2, PseudoVLUXSEG2EI16_V_M4_M1 }, // 1968
  { Intrinsic::riscv_vluxseg2, 0x10, 0x0, 0x3, PseudoVLUXSEG2EI16_V_M8_M1 }, // 1969
  { Intrinsic::riscv_vluxseg2, 0x10, 0x0, 0x6, PseudoVLUXSEG2EI16_V_MF4_M1 }, // 1970
  { Intrinsic::riscv_vluxseg2, 0x10, 0x0, 0x7, PseudoVLUXSEG2EI16_V_MF2_M1 }, // 1971
  { Intrinsic::riscv_vluxseg2, 0x10, 0x1, 0x0, PseudoVLUXSEG2EI16_V_M1_M2 }, // 1972
  { Intrinsic::riscv_vluxseg2, 0x10, 0x1, 0x1, PseudoVLUXSEG2EI16_V_M2_M2 }, // 1973
  { Intrinsic::riscv_vluxseg2, 0x10, 0x1, 0x2, PseudoVLUXSEG2EI16_V_M4_M2 }, // 1974
  { Intrinsic::riscv_vluxseg2, 0x10, 0x1, 0x3, PseudoVLUXSEG2EI16_V_M8_M2 }, // 1975
  { Intrinsic::riscv_vluxseg2, 0x10, 0x1, 0x6, PseudoVLUXSEG2EI16_V_MF4_M2 }, // 1976
  { Intrinsic::riscv_vluxseg2, 0x10, 0x1, 0x7, PseudoVLUXSEG2EI16_V_MF2_M2 }, // 1977
  { Intrinsic::riscv_vluxseg2, 0x10, 0x2, 0x0, PseudoVLUXSEG2EI16_V_M1_M4 }, // 1978
  { Intrinsic::riscv_vluxseg2, 0x10, 0x2, 0x1, PseudoVLUXSEG2EI16_V_M2_M4 }, // 1979
  { Intrinsic::riscv_vluxseg2, 0x10, 0x2, 0x2, PseudoVLUXSEG2EI16_V_M4_M4 }, // 1980
  { Intrinsic::riscv_vluxseg2, 0x10, 0x2, 0x3, PseudoVLUXSEG2EI16_V_M8_M4 }, // 1981
  { Intrinsic::riscv_vluxseg2, 0x10, 0x2, 0x6, PseudoVLUXSEG2EI16_V_MF4_M4 }, // 1982
  { Intrinsic::riscv_vluxseg2, 0x10, 0x2, 0x7, PseudoVLUXSEG2EI16_V_MF2_M4 }, // 1983
  { Intrinsic::riscv_vluxseg2, 0x10, 0x5, 0x0, PseudoVLUXSEG2EI16_V_M1_MF8 }, // 1984
  { Intrinsic::riscv_vluxseg2, 0x10, 0x5, 0x1, PseudoVLUXSEG2EI16_V_M2_MF8 }, // 1985
  { Intrinsic::riscv_vluxseg2, 0x10, 0x5, 0x2, PseudoVLUXSEG2EI16_V_M4_MF8 }, // 1986
  { Intrinsic::riscv_vluxseg2, 0x10, 0x5, 0x3, PseudoVLUXSEG2EI16_V_M8_MF8 }, // 1987
  { Intrinsic::riscv_vluxseg2, 0x10, 0x5, 0x6, PseudoVLUXSEG2EI16_V_MF4_MF8 }, // 1988
  { Intrinsic::riscv_vluxseg2, 0x10, 0x5, 0x7, PseudoVLUXSEG2EI16_V_MF2_MF8 }, // 1989
  { Intrinsic::riscv_vluxseg2, 0x10, 0x6, 0x0, PseudoVLUXSEG2EI16_V_M1_MF4 }, // 1990
  { Intrinsic::riscv_vluxseg2, 0x10, 0x6, 0x1, PseudoVLUXSEG2EI16_V_M2_MF4 }, // 1991
  { Intrinsic::riscv_vluxseg2, 0x10, 0x6, 0x2, PseudoVLUXSEG2EI16_V_M4_MF4 }, // 1992
  { Intrinsic::riscv_vluxseg2, 0x10, 0x6, 0x3, PseudoVLUXSEG2EI16_V_M8_MF4 }, // 1993
  { Intrinsic::riscv_vluxseg2, 0x10, 0x6, 0x6, PseudoVLUXSEG2EI16_V_MF4_MF4 }, // 1994
  { Intrinsic::riscv_vluxseg2, 0x10, 0x6, 0x7, PseudoVLUXSEG2EI16_V_MF2_MF4 }, // 1995
  { Intrinsic::riscv_vluxseg2, 0x10, 0x7, 0x0, PseudoVLUXSEG2EI16_V_M1_MF2 }, // 1996
  { Intrinsic::riscv_vluxseg2, 0x10, 0x7, 0x1, PseudoVLUXSEG2EI16_V_M2_MF2 }, // 1997
  { Intrinsic::riscv_vluxseg2, 0x10, 0x7, 0x2, PseudoVLUXSEG2EI16_V_M4_MF2 }, // 1998
  { Intrinsic::riscv_vluxseg2, 0x10, 0x7, 0x3, PseudoVLUXSEG2EI16_V_M8_MF2 }, // 1999
  { Intrinsic::riscv_vluxseg2, 0x10, 0x7, 0x6, PseudoVLUXSEG2EI16_V_MF4_MF2 }, // 2000
  { Intrinsic::riscv_vluxseg2, 0x10, 0x7, 0x7, PseudoVLUXSEG2EI16_V_MF2_MF2 }, // 2001
  { Intrinsic::riscv_vluxseg2, 0x20, 0x0, 0x0, PseudoVLUXSEG2EI32_V_M1_M1 }, // 2002
  { Intrinsic::riscv_vluxseg2, 0x20, 0x0, 0x1, PseudoVLUXSEG2EI32_V_M2_M1 }, // 2003
  { Intrinsic::riscv_vluxseg2, 0x20, 0x0, 0x2, PseudoVLUXSEG2EI32_V_M4_M1 }, // 2004
  { Intrinsic::riscv_vluxseg2, 0x20, 0x0, 0x3, PseudoVLUXSEG2EI32_V_M8_M1 }, // 2005
  { Intrinsic::riscv_vluxseg2, 0x20, 0x0, 0x7, PseudoVLUXSEG2EI32_V_MF2_M1 }, // 2006
  { Intrinsic::riscv_vluxseg2, 0x20, 0x1, 0x0, PseudoVLUXSEG2EI32_V_M1_M2 }, // 2007
  { Intrinsic::riscv_vluxseg2, 0x20, 0x1, 0x1, PseudoVLUXSEG2EI32_V_M2_M2 }, // 2008
  { Intrinsic::riscv_vluxseg2, 0x20, 0x1, 0x2, PseudoVLUXSEG2EI32_V_M4_M2 }, // 2009
  { Intrinsic::riscv_vluxseg2, 0x20, 0x1, 0x3, PseudoVLUXSEG2EI32_V_M8_M2 }, // 2010
  { Intrinsic::riscv_vluxseg2, 0x20, 0x1, 0x7, PseudoVLUXSEG2EI32_V_MF2_M2 }, // 2011
  { Intrinsic::riscv_vluxseg2, 0x20, 0x2, 0x0, PseudoVLUXSEG2EI32_V_M1_M4 }, // 2012
  { Intrinsic::riscv_vluxseg2, 0x20, 0x2, 0x1, PseudoVLUXSEG2EI32_V_M2_M4 }, // 2013
  { Intrinsic::riscv_vluxseg2, 0x20, 0x2, 0x2, PseudoVLUXSEG2EI32_V_M4_M4 }, // 2014
  { Intrinsic::riscv_vluxseg2, 0x20, 0x2, 0x3, PseudoVLUXSEG2EI32_V_M8_M4 }, // 2015
  { Intrinsic::riscv_vluxseg2, 0x20, 0x2, 0x7, PseudoVLUXSEG2EI32_V_MF2_M4 }, // 2016
  { Intrinsic::riscv_vluxseg2, 0x20, 0x5, 0x0, PseudoVLUXSEG2EI32_V_M1_MF8 }, // 2017
  { Intrinsic::riscv_vluxseg2, 0x20, 0x5, 0x1, PseudoVLUXSEG2EI32_V_M2_MF8 }, // 2018
  { Intrinsic::riscv_vluxseg2, 0x20, 0x5, 0x2, PseudoVLUXSEG2EI32_V_M4_MF8 }, // 2019
  { Intrinsic::riscv_vluxseg2, 0x20, 0x5, 0x3, PseudoVLUXSEG2EI32_V_M8_MF8 }, // 2020
  { Intrinsic::riscv_vluxseg2, 0x20, 0x5, 0x7, PseudoVLUXSEG2EI32_V_MF2_MF8 }, // 2021
  { Intrinsic::riscv_vluxseg2, 0x20, 0x6, 0x0, PseudoVLUXSEG2EI32_V_M1_MF4 }, // 2022
  { Intrinsic::riscv_vluxseg2, 0x20, 0x6, 0x1, PseudoVLUXSEG2EI32_V_M2_MF4 }, // 2023
  { Intrinsic::riscv_vluxseg2, 0x20, 0x6, 0x2, PseudoVLUXSEG2EI32_V_M4_MF4 }, // 2024
  { Intrinsic::riscv_vluxseg2, 0x20, 0x6, 0x3, PseudoVLUXSEG2EI32_V_M8_MF4 }, // 2025
  { Intrinsic::riscv_vluxseg2, 0x20, 0x6, 0x7, PseudoVLUXSEG2EI32_V_MF2_MF4 }, // 2026
  { Intrinsic::riscv_vluxseg2, 0x20, 0x7, 0x0, PseudoVLUXSEG2EI32_V_M1_MF2 }, // 2027
  { Intrinsic::riscv_vluxseg2, 0x20, 0x7, 0x1, PseudoVLUXSEG2EI32_V_M2_MF2 }, // 2028
  { Intrinsic::riscv_vluxseg2, 0x20, 0x7, 0x2, PseudoVLUXSEG2EI32_V_M4_MF2 }, // 2029
  { Intrinsic::riscv_vluxseg2, 0x20, 0x7, 0x3, PseudoVLUXSEG2EI32_V_M8_MF2 }, // 2030
  { Intrinsic::riscv_vluxseg2, 0x20, 0x7, 0x7, PseudoVLUXSEG2EI32_V_MF2_MF2 }, // 2031
  { Intrinsic::riscv_vluxseg2, 0x40, 0x0, 0x0, PseudoVLUXSEG2EI64_V_M1_M1 }, // 2032
  { Intrinsic::riscv_vluxseg2, 0x40, 0x0, 0x1, PseudoVLUXSEG2EI64_V_M2_M1 }, // 2033
  { Intrinsic::riscv_vluxseg2, 0x40, 0x0, 0x2, PseudoVLUXSEG2EI64_V_M4_M1 }, // 2034
  { Intrinsic::riscv_vluxseg2, 0x40, 0x0, 0x3, PseudoVLUXSEG2EI64_V_M8_M1 }, // 2035
  { Intrinsic::riscv_vluxseg2, 0x40, 0x1, 0x0, PseudoVLUXSEG2EI64_V_M1_M2 }, // 2036
  { Intrinsic::riscv_vluxseg2, 0x40, 0x1, 0x1, PseudoVLUXSEG2EI64_V_M2_M2 }, // 2037
  { Intrinsic::riscv_vluxseg2, 0x40, 0x1, 0x2, PseudoVLUXSEG2EI64_V_M4_M2 }, // 2038
  { Intrinsic::riscv_vluxseg2, 0x40, 0x1, 0x3, PseudoVLUXSEG2EI64_V_M8_M2 }, // 2039
  { Intrinsic::riscv_vluxseg2, 0x40, 0x2, 0x0, PseudoVLUXSEG2EI64_V_M1_M4 }, // 2040
  { Intrinsic::riscv_vluxseg2, 0x40, 0x2, 0x1, PseudoVLUXSEG2EI64_V_M2_M4 }, // 2041
  { Intrinsic::riscv_vluxseg2, 0x40, 0x2, 0x2, PseudoVLUXSEG2EI64_V_M4_M4 }, // 2042
  { Intrinsic::riscv_vluxseg2, 0x40, 0x2, 0x3, PseudoVLUXSEG2EI64_V_M8_M4 }, // 2043
  { Intrinsic::riscv_vluxseg2, 0x40, 0x5, 0x0, PseudoVLUXSEG2EI64_V_M1_MF8 }, // 2044
  { Intrinsic::riscv_vluxseg2, 0x40, 0x5, 0x1, PseudoVLUXSEG2EI64_V_M2_MF8 }, // 2045
  { Intrinsic::riscv_vluxseg2, 0x40, 0x5, 0x2, PseudoVLUXSEG2EI64_V_M4_MF8 }, // 2046
  { Intrinsic::riscv_vluxseg2, 0x40, 0x5, 0x3, PseudoVLUXSEG2EI64_V_M8_MF8 }, // 2047
  { Intrinsic::riscv_vluxseg2, 0x40, 0x6, 0x0, PseudoVLUXSEG2EI64_V_M1_MF4 }, // 2048
  { Intrinsic::riscv_vluxseg2, 0x40, 0x6, 0x1, PseudoVLUXSEG2EI64_V_M2_MF4 }, // 2049
  { Intrinsic::riscv_vluxseg2, 0x40, 0x6, 0x2, PseudoVLUXSEG2EI64_V_M4_MF4 }, // 2050
  { Intrinsic::riscv_vluxseg2, 0x40, 0x6, 0x3, PseudoVLUXSEG2EI64_V_M8_MF4 }, // 2051
  { Intrinsic::riscv_vluxseg2, 0x40, 0x7, 0x0, PseudoVLUXSEG2EI64_V_M1_MF2 }, // 2052
  { Intrinsic::riscv_vluxseg2, 0x40, 0x7, 0x1, PseudoVLUXSEG2EI64_V_M2_MF2 }, // 2053
  { Intrinsic::riscv_vluxseg2, 0x40, 0x7, 0x2, PseudoVLUXSEG2EI64_V_M4_MF2 }, // 2054
  { Intrinsic::riscv_vluxseg2, 0x40, 0x7, 0x3, PseudoVLUXSEG2EI64_V_M8_MF2 }, // 2055
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x0, 0x0, PseudoVLUXSEG2EI8_V_M1_M1_MASK }, // 2056
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x0, 0x1, PseudoVLUXSEG2EI8_V_M2_M1_MASK }, // 2057
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x0, 0x2, PseudoVLUXSEG2EI8_V_M4_M1_MASK }, // 2058
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x0, 0x3, PseudoVLUXSEG2EI8_V_M8_M1_MASK }, // 2059
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x0, 0x5, PseudoVLUXSEG2EI8_V_MF8_M1_MASK }, // 2060
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x0, 0x6, PseudoVLUXSEG2EI8_V_MF4_M1_MASK }, // 2061
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x0, 0x7, PseudoVLUXSEG2EI8_V_MF2_M1_MASK }, // 2062
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x1, 0x0, PseudoVLUXSEG2EI8_V_M1_M2_MASK }, // 2063
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x1, 0x1, PseudoVLUXSEG2EI8_V_M2_M2_MASK }, // 2064
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x1, 0x2, PseudoVLUXSEG2EI8_V_M4_M2_MASK }, // 2065
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x1, 0x3, PseudoVLUXSEG2EI8_V_M8_M2_MASK }, // 2066
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x1, 0x5, PseudoVLUXSEG2EI8_V_MF8_M2_MASK }, // 2067
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x1, 0x6, PseudoVLUXSEG2EI8_V_MF4_M2_MASK }, // 2068
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x1, 0x7, PseudoVLUXSEG2EI8_V_MF2_M2_MASK }, // 2069
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x2, 0x0, PseudoVLUXSEG2EI8_V_M1_M4_MASK }, // 2070
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x2, 0x1, PseudoVLUXSEG2EI8_V_M2_M4_MASK }, // 2071
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x2, 0x2, PseudoVLUXSEG2EI8_V_M4_M4_MASK }, // 2072
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x2, 0x3, PseudoVLUXSEG2EI8_V_M8_M4_MASK }, // 2073
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x2, 0x5, PseudoVLUXSEG2EI8_V_MF8_M4_MASK }, // 2074
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x2, 0x6, PseudoVLUXSEG2EI8_V_MF4_M4_MASK }, // 2075
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x2, 0x7, PseudoVLUXSEG2EI8_V_MF2_M4_MASK }, // 2076
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x5, 0x0, PseudoVLUXSEG2EI8_V_M1_MF8_MASK }, // 2077
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x5, 0x1, PseudoVLUXSEG2EI8_V_M2_MF8_MASK }, // 2078
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x5, 0x2, PseudoVLUXSEG2EI8_V_M4_MF8_MASK }, // 2079
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x5, 0x3, PseudoVLUXSEG2EI8_V_M8_MF8_MASK }, // 2080
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x5, 0x5, PseudoVLUXSEG2EI8_V_MF8_MF8_MASK }, // 2081
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x5, 0x6, PseudoVLUXSEG2EI8_V_MF4_MF8_MASK }, // 2082
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x5, 0x7, PseudoVLUXSEG2EI8_V_MF2_MF8_MASK }, // 2083
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x6, 0x0, PseudoVLUXSEG2EI8_V_M1_MF4_MASK }, // 2084
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x6, 0x1, PseudoVLUXSEG2EI8_V_M2_MF4_MASK }, // 2085
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x6, 0x2, PseudoVLUXSEG2EI8_V_M4_MF4_MASK }, // 2086
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x6, 0x3, PseudoVLUXSEG2EI8_V_M8_MF4_MASK }, // 2087
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x6, 0x5, PseudoVLUXSEG2EI8_V_MF8_MF4_MASK }, // 2088
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x6, 0x6, PseudoVLUXSEG2EI8_V_MF4_MF4_MASK }, // 2089
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x6, 0x7, PseudoVLUXSEG2EI8_V_MF2_MF4_MASK }, // 2090
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x7, 0x0, PseudoVLUXSEG2EI8_V_M1_MF2_MASK }, // 2091
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x7, 0x1, PseudoVLUXSEG2EI8_V_M2_MF2_MASK }, // 2092
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x7, 0x2, PseudoVLUXSEG2EI8_V_M4_MF2_MASK }, // 2093
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x7, 0x3, PseudoVLUXSEG2EI8_V_M8_MF2_MASK }, // 2094
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x7, 0x5, PseudoVLUXSEG2EI8_V_MF8_MF2_MASK }, // 2095
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x7, 0x6, PseudoVLUXSEG2EI8_V_MF4_MF2_MASK }, // 2096
  { Intrinsic::riscv_vluxseg2_mask, 0x8, 0x7, 0x7, PseudoVLUXSEG2EI8_V_MF2_MF2_MASK }, // 2097
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x0, 0x0, PseudoVLUXSEG2EI16_V_M1_M1_MASK }, // 2098
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x0, 0x1, PseudoVLUXSEG2EI16_V_M2_M1_MASK }, // 2099
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x0, 0x2, PseudoVLUXSEG2EI16_V_M4_M1_MASK }, // 2100
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x0, 0x3, PseudoVLUXSEG2EI16_V_M8_M1_MASK }, // 2101
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x0, 0x6, PseudoVLUXSEG2EI16_V_MF4_M1_MASK }, // 2102
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x0, 0x7, PseudoVLUXSEG2EI16_V_MF2_M1_MASK }, // 2103
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x1, 0x0, PseudoVLUXSEG2EI16_V_M1_M2_MASK }, // 2104
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x1, 0x1, PseudoVLUXSEG2EI16_V_M2_M2_MASK }, // 2105
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x1, 0x2, PseudoVLUXSEG2EI16_V_M4_M2_MASK }, // 2106
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x1, 0x3, PseudoVLUXSEG2EI16_V_M8_M2_MASK }, // 2107
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x1, 0x6, PseudoVLUXSEG2EI16_V_MF4_M2_MASK }, // 2108
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x1, 0x7, PseudoVLUXSEG2EI16_V_MF2_M2_MASK }, // 2109
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x2, 0x0, PseudoVLUXSEG2EI16_V_M1_M4_MASK }, // 2110
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x2, 0x1, PseudoVLUXSEG2EI16_V_M2_M4_MASK }, // 2111
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x2, 0x2, PseudoVLUXSEG2EI16_V_M4_M4_MASK }, // 2112
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x2, 0x3, PseudoVLUXSEG2EI16_V_M8_M4_MASK }, // 2113
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x2, 0x6, PseudoVLUXSEG2EI16_V_MF4_M4_MASK }, // 2114
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x2, 0x7, PseudoVLUXSEG2EI16_V_MF2_M4_MASK }, // 2115
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x5, 0x0, PseudoVLUXSEG2EI16_V_M1_MF8_MASK }, // 2116
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x5, 0x1, PseudoVLUXSEG2EI16_V_M2_MF8_MASK }, // 2117
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x5, 0x2, PseudoVLUXSEG2EI16_V_M4_MF8_MASK }, // 2118
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x5, 0x3, PseudoVLUXSEG2EI16_V_M8_MF8_MASK }, // 2119
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x5, 0x6, PseudoVLUXSEG2EI16_V_MF4_MF8_MASK }, // 2120
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x5, 0x7, PseudoVLUXSEG2EI16_V_MF2_MF8_MASK }, // 2121
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x6, 0x0, PseudoVLUXSEG2EI16_V_M1_MF4_MASK }, // 2122
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x6, 0x1, PseudoVLUXSEG2EI16_V_M2_MF4_MASK }, // 2123
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x6, 0x2, PseudoVLUXSEG2EI16_V_M4_MF4_MASK }, // 2124
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x6, 0x3, PseudoVLUXSEG2EI16_V_M8_MF4_MASK }, // 2125
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x6, 0x6, PseudoVLUXSEG2EI16_V_MF4_MF4_MASK }, // 2126
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x6, 0x7, PseudoVLUXSEG2EI16_V_MF2_MF4_MASK }, // 2127
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x7, 0x0, PseudoVLUXSEG2EI16_V_M1_MF2_MASK }, // 2128
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x7, 0x1, PseudoVLUXSEG2EI16_V_M2_MF2_MASK }, // 2129
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x7, 0x2, PseudoVLUXSEG2EI16_V_M4_MF2_MASK }, // 2130
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x7, 0x3, PseudoVLUXSEG2EI16_V_M8_MF2_MASK }, // 2131
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x7, 0x6, PseudoVLUXSEG2EI16_V_MF4_MF2_MASK }, // 2132
  { Intrinsic::riscv_vluxseg2_mask, 0x10, 0x7, 0x7, PseudoVLUXSEG2EI16_V_MF2_MF2_MASK }, // 2133
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x0, 0x0, PseudoVLUXSEG2EI32_V_M1_M1_MASK }, // 2134
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x0, 0x1, PseudoVLUXSEG2EI32_V_M2_M1_MASK }, // 2135
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x0, 0x2, PseudoVLUXSEG2EI32_V_M4_M1_MASK }, // 2136
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x0, 0x3, PseudoVLUXSEG2EI32_V_M8_M1_MASK }, // 2137
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x0, 0x7, PseudoVLUXSEG2EI32_V_MF2_M1_MASK }, // 2138
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x1, 0x0, PseudoVLUXSEG2EI32_V_M1_M2_MASK }, // 2139
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x1, 0x1, PseudoVLUXSEG2EI32_V_M2_M2_MASK }, // 2140
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x1, 0x2, PseudoVLUXSEG2EI32_V_M4_M2_MASK }, // 2141
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x1, 0x3, PseudoVLUXSEG2EI32_V_M8_M2_MASK }, // 2142
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x1, 0x7, PseudoVLUXSEG2EI32_V_MF2_M2_MASK }, // 2143
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x2, 0x0, PseudoVLUXSEG2EI32_V_M1_M4_MASK }, // 2144
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x2, 0x1, PseudoVLUXSEG2EI32_V_M2_M4_MASK }, // 2145
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x2, 0x2, PseudoVLUXSEG2EI32_V_M4_M4_MASK }, // 2146
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x2, 0x3, PseudoVLUXSEG2EI32_V_M8_M4_MASK }, // 2147
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x2, 0x7, PseudoVLUXSEG2EI32_V_MF2_M4_MASK }, // 2148
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x5, 0x0, PseudoVLUXSEG2EI32_V_M1_MF8_MASK }, // 2149
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x5, 0x1, PseudoVLUXSEG2EI32_V_M2_MF8_MASK }, // 2150
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x5, 0x2, PseudoVLUXSEG2EI32_V_M4_MF8_MASK }, // 2151
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x5, 0x3, PseudoVLUXSEG2EI32_V_M8_MF8_MASK }, // 2152
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x5, 0x7, PseudoVLUXSEG2EI32_V_MF2_MF8_MASK }, // 2153
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x6, 0x0, PseudoVLUXSEG2EI32_V_M1_MF4_MASK }, // 2154
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x6, 0x1, PseudoVLUXSEG2EI32_V_M2_MF4_MASK }, // 2155
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x6, 0x2, PseudoVLUXSEG2EI32_V_M4_MF4_MASK }, // 2156
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x6, 0x3, PseudoVLUXSEG2EI32_V_M8_MF4_MASK }, // 2157
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x6, 0x7, PseudoVLUXSEG2EI32_V_MF2_MF4_MASK }, // 2158
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x7, 0x0, PseudoVLUXSEG2EI32_V_M1_MF2_MASK }, // 2159
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x7, 0x1, PseudoVLUXSEG2EI32_V_M2_MF2_MASK }, // 2160
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x7, 0x2, PseudoVLUXSEG2EI32_V_M4_MF2_MASK }, // 2161
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x7, 0x3, PseudoVLUXSEG2EI32_V_M8_MF2_MASK }, // 2162
  { Intrinsic::riscv_vluxseg2_mask, 0x20, 0x7, 0x7, PseudoVLUXSEG2EI32_V_MF2_MF2_MASK }, // 2163
  { Intrinsic::riscv_vluxseg2_mask, 0x40, 0x0, 0x0, PseudoVLUXSEG2EI64_V_M1_M1_MASK }, // 2164
  { Intrinsic::riscv_vluxseg2_mask, 0x40, 0x0, 0x1, PseudoVLUXSEG2EI64_V_M2_M1_MASK }, // 2165
  { Intrinsic::riscv_vluxseg2_mask, 0x40, 0x0, 0x2, PseudoVLUXSEG2EI64_V_M4_M1_MASK }, // 2166
  { Intrinsic::riscv_vluxseg2_mask, 0x40, 0x0, 0x3, PseudoVLUXSEG2EI64_V_M8_M1_MASK }, // 2167
  { Intrinsic::riscv_vluxseg2_mask, 0x40, 0x1, 0x0, PseudoVLUXSEG2EI64_V_M1_M2_MASK }, // 2168
  { Intrinsic::riscv_vluxseg2_mask, 0x40, 0x1, 0x1, PseudoVLUXSEG2EI64_V_M2_M2_MASK }, // 2169
  { Intrinsic::riscv_vluxseg2_mask, 0x40, 0x1, 0x2, PseudoVLUXSEG2EI64_V_M4_M2_MASK }, // 2170
  { Intrinsic::riscv_vluxseg2_mask, 0x40, 0x1, 0x3, PseudoVLUXSEG2EI64_V_M8_M2_MASK }, // 2171
  { Intrinsic::riscv_vluxseg2_mask, 0x40, 0x2, 0x0, PseudoVLUXSEG2EI64_V_M1_M4_MASK }, // 2172
  { Intrinsic::riscv_vluxseg2_mask, 0x40, 0x2, 0x1, PseudoVLUXSEG2EI64_V_M2_M4_MASK }, // 2173
  { Intrinsic::riscv_vluxseg2_mask, 0x40, 0x2, 0x2, PseudoVLUXSEG2EI64_V_M4_M4_MASK }, // 2174
  { Intrinsic::riscv_vluxseg2_mask, 0x40, 0x2, 0x3, PseudoVLUXSEG2EI64_V_M8_M4_MASK }, // 2175
  { Intrinsic::riscv_vluxseg2_mask, 0x40, 0x5, 0x0, PseudoVLUXSEG2EI64_V_M1_MF8_MASK }, // 2176
  { Intrinsic::riscv_vluxseg2_mask, 0x40, 0x5, 0x1, PseudoVLUXSEG2EI64_V_M2_MF8_MASK }, // 2177
  { Intrinsic::riscv_vluxseg2_mask, 0x40, 0x5, 0x2, PseudoVLUXSEG2EI64_V_M4_MF8_MASK }, // 2178
  { Intrinsic::riscv_vluxseg2_mask, 0x40, 0x5, 0x3, PseudoVLUXSEG2EI64_V_M8_MF8_MASK }, // 2179
  { Intrinsic::riscv_vluxseg2_mask, 0x40, 0x6, 0x0, PseudoVLUXSEG2EI64_V_M1_MF4_MASK }, // 2180
  { Intrinsic::riscv_vluxseg2_mask, 0x40, 0x6, 0x1, PseudoVLUXSEG2EI64_V_M2_MF4_MASK }, // 2181
  { Intrinsic::riscv_vluxseg2_mask, 0x40, 0x6, 0x2, PseudoVLUXSEG2EI64_V_M4_MF4_MASK }, // 2182
  { Intrinsic::riscv_vluxseg2_mask, 0x40, 0x6, 0x3, PseudoVLUXSEG2EI64_V_M8_MF4_MASK }, // 2183
  { Intrinsic::riscv_vluxseg2_mask, 0x40, 0x7, 0x0, PseudoVLUXSEG2EI64_V_M1_MF2_MASK }, // 2184
  { Intrinsic::riscv_vluxseg2_mask, 0x40, 0x7, 0x1, PseudoVLUXSEG2EI64_V_M2_MF2_MASK }, // 2185
  { Intrinsic::riscv_vluxseg2_mask, 0x40, 0x7, 0x2, PseudoVLUXSEG2EI64_V_M4_MF2_MASK }, // 2186
  { Intrinsic::riscv_vluxseg2_mask, 0x40, 0x7, 0x3, PseudoVLUXSEG2EI64_V_M8_MF2_MASK }, // 2187
  { Intrinsic::riscv_vluxseg3, 0x8, 0x0, 0x0, PseudoVLUXSEG3EI8_V_M1_M1 }, // 2188
  { Intrinsic::riscv_vluxseg3, 0x8, 0x0, 0x1, PseudoVLUXSEG3EI8_V_M2_M1 }, // 2189
  { Intrinsic::riscv_vluxseg3, 0x8, 0x0, 0x2, PseudoVLUXSEG3EI8_V_M4_M1 }, // 2190
  { Intrinsic::riscv_vluxseg3, 0x8, 0x0, 0x3, PseudoVLUXSEG3EI8_V_M8_M1 }, // 2191
  { Intrinsic::riscv_vluxseg3, 0x8, 0x0, 0x5, PseudoVLUXSEG3EI8_V_MF8_M1 }, // 2192
  { Intrinsic::riscv_vluxseg3, 0x8, 0x0, 0x6, PseudoVLUXSEG3EI8_V_MF4_M1 }, // 2193
  { Intrinsic::riscv_vluxseg3, 0x8, 0x0, 0x7, PseudoVLUXSEG3EI8_V_MF2_M1 }, // 2194
  { Intrinsic::riscv_vluxseg3, 0x8, 0x1, 0x0, PseudoVLUXSEG3EI8_V_M1_M2 }, // 2195
  { Intrinsic::riscv_vluxseg3, 0x8, 0x1, 0x1, PseudoVLUXSEG3EI8_V_M2_M2 }, // 2196
  { Intrinsic::riscv_vluxseg3, 0x8, 0x1, 0x2, PseudoVLUXSEG3EI8_V_M4_M2 }, // 2197
  { Intrinsic::riscv_vluxseg3, 0x8, 0x1, 0x3, PseudoVLUXSEG3EI8_V_M8_M2 }, // 2198
  { Intrinsic::riscv_vluxseg3, 0x8, 0x1, 0x5, PseudoVLUXSEG3EI8_V_MF8_M2 }, // 2199
  { Intrinsic::riscv_vluxseg3, 0x8, 0x1, 0x6, PseudoVLUXSEG3EI8_V_MF4_M2 }, // 2200
  { Intrinsic::riscv_vluxseg3, 0x8, 0x1, 0x7, PseudoVLUXSEG3EI8_V_MF2_M2 }, // 2201
  { Intrinsic::riscv_vluxseg3, 0x8, 0x5, 0x0, PseudoVLUXSEG3EI8_V_M1_MF8 }, // 2202
  { Intrinsic::riscv_vluxseg3, 0x8, 0x5, 0x1, PseudoVLUXSEG3EI8_V_M2_MF8 }, // 2203
  { Intrinsic::riscv_vluxseg3, 0x8, 0x5, 0x2, PseudoVLUXSEG3EI8_V_M4_MF8 }, // 2204
  { Intrinsic::riscv_vluxseg3, 0x8, 0x5, 0x3, PseudoVLUXSEG3EI8_V_M8_MF8 }, // 2205
  { Intrinsic::riscv_vluxseg3, 0x8, 0x5, 0x5, PseudoVLUXSEG3EI8_V_MF8_MF8 }, // 2206
  { Intrinsic::riscv_vluxseg3, 0x8, 0x5, 0x6, PseudoVLUXSEG3EI8_V_MF4_MF8 }, // 2207
  { Intrinsic::riscv_vluxseg3, 0x8, 0x5, 0x7, PseudoVLUXSEG3EI8_V_MF2_MF8 }, // 2208
  { Intrinsic::riscv_vluxseg3, 0x8, 0x6, 0x0, PseudoVLUXSEG3EI8_V_M1_MF4 }, // 2209
  { Intrinsic::riscv_vluxseg3, 0x8, 0x6, 0x1, PseudoVLUXSEG3EI8_V_M2_MF4 }, // 2210
  { Intrinsic::riscv_vluxseg3, 0x8, 0x6, 0x2, PseudoVLUXSEG3EI8_V_M4_MF4 }, // 2211
  { Intrinsic::riscv_vluxseg3, 0x8, 0x6, 0x3, PseudoVLUXSEG3EI8_V_M8_MF4 }, // 2212
  { Intrinsic::riscv_vluxseg3, 0x8, 0x6, 0x5, PseudoVLUXSEG3EI8_V_MF8_MF4 }, // 2213
  { Intrinsic::riscv_vluxseg3, 0x8, 0x6, 0x6, PseudoVLUXSEG3EI8_V_MF4_MF4 }, // 2214
  { Intrinsic::riscv_vluxseg3, 0x8, 0x6, 0x7, PseudoVLUXSEG3EI8_V_MF2_MF4 }, // 2215
  { Intrinsic::riscv_vluxseg3, 0x8, 0x7, 0x0, PseudoVLUXSEG3EI8_V_M1_MF2 }, // 2216
  { Intrinsic::riscv_vluxseg3, 0x8, 0x7, 0x1, PseudoVLUXSEG3EI8_V_M2_MF2 }, // 2217
  { Intrinsic::riscv_vluxseg3, 0x8, 0x7, 0x2, PseudoVLUXSEG3EI8_V_M4_MF2 }, // 2218
  { Intrinsic::riscv_vluxseg3, 0x8, 0x7, 0x3, PseudoVLUXSEG3EI8_V_M8_MF2 }, // 2219
  { Intrinsic::riscv_vluxseg3, 0x8, 0x7, 0x5, PseudoVLUXSEG3EI8_V_MF8_MF2 }, // 2220
  { Intrinsic::riscv_vluxseg3, 0x8, 0x7, 0x6, PseudoVLUXSEG3EI8_V_MF4_MF2 }, // 2221
  { Intrinsic::riscv_vluxseg3, 0x8, 0x7, 0x7, PseudoVLUXSEG3EI8_V_MF2_MF2 }, // 2222
  { Intrinsic::riscv_vluxseg3, 0x10, 0x0, 0x0, PseudoVLUXSEG3EI16_V_M1_M1 }, // 2223
  { Intrinsic::riscv_vluxseg3, 0x10, 0x0, 0x1, PseudoVLUXSEG3EI16_V_M2_M1 }, // 2224
  { Intrinsic::riscv_vluxseg3, 0x10, 0x0, 0x2, PseudoVLUXSEG3EI16_V_M4_M1 }, // 2225
  { Intrinsic::riscv_vluxseg3, 0x10, 0x0, 0x3, PseudoVLUXSEG3EI16_V_M8_M1 }, // 2226
  { Intrinsic::riscv_vluxseg3, 0x10, 0x0, 0x6, PseudoVLUXSEG3EI16_V_MF4_M1 }, // 2227
  { Intrinsic::riscv_vluxseg3, 0x10, 0x0, 0x7, PseudoVLUXSEG3EI16_V_MF2_M1 }, // 2228
  { Intrinsic::riscv_vluxseg3, 0x10, 0x1, 0x0, PseudoVLUXSEG3EI16_V_M1_M2 }, // 2229
  { Intrinsic::riscv_vluxseg3, 0x10, 0x1, 0x1, PseudoVLUXSEG3EI16_V_M2_M2 }, // 2230
  { Intrinsic::riscv_vluxseg3, 0x10, 0x1, 0x2, PseudoVLUXSEG3EI16_V_M4_M2 }, // 2231
  { Intrinsic::riscv_vluxseg3, 0x10, 0x1, 0x3, PseudoVLUXSEG3EI16_V_M8_M2 }, // 2232
  { Intrinsic::riscv_vluxseg3, 0x10, 0x1, 0x6, PseudoVLUXSEG3EI16_V_MF4_M2 }, // 2233
  { Intrinsic::riscv_vluxseg3, 0x10, 0x1, 0x7, PseudoVLUXSEG3EI16_V_MF2_M2 }, // 2234
  { Intrinsic::riscv_vluxseg3, 0x10, 0x5, 0x0, PseudoVLUXSEG3EI16_V_M1_MF8 }, // 2235
  { Intrinsic::riscv_vluxseg3, 0x10, 0x5, 0x1, PseudoVLUXSEG3EI16_V_M2_MF8 }, // 2236
  { Intrinsic::riscv_vluxseg3, 0x10, 0x5, 0x2, PseudoVLUXSEG3EI16_V_M4_MF8 }, // 2237
  { Intrinsic::riscv_vluxseg3, 0x10, 0x5, 0x3, PseudoVLUXSEG3EI16_V_M8_MF8 }, // 2238
  { Intrinsic::riscv_vluxseg3, 0x10, 0x5, 0x6, PseudoVLUXSEG3EI16_V_MF4_MF8 }, // 2239
  { Intrinsic::riscv_vluxseg3, 0x10, 0x5, 0x7, PseudoVLUXSEG3EI16_V_MF2_MF8 }, // 2240
  { Intrinsic::riscv_vluxseg3, 0x10, 0x6, 0x0, PseudoVLUXSEG3EI16_V_M1_MF4 }, // 2241
  { Intrinsic::riscv_vluxseg3, 0x10, 0x6, 0x1, PseudoVLUXSEG3EI16_V_M2_MF4 }, // 2242
  { Intrinsic::riscv_vluxseg3, 0x10, 0x6, 0x2, PseudoVLUXSEG3EI16_V_M4_MF4 }, // 2243
  { Intrinsic::riscv_vluxseg3, 0x10, 0x6, 0x3, PseudoVLUXSEG3EI16_V_M8_MF4 }, // 2244
  { Intrinsic::riscv_vluxseg3, 0x10, 0x6, 0x6, PseudoVLUXSEG3EI16_V_MF4_MF4 }, // 2245
  { Intrinsic::riscv_vluxseg3, 0x10, 0x6, 0x7, PseudoVLUXSEG3EI16_V_MF2_MF4 }, // 2246
  { Intrinsic::riscv_vluxseg3, 0x10, 0x7, 0x0, PseudoVLUXSEG3EI16_V_M1_MF2 }, // 2247
  { Intrinsic::riscv_vluxseg3, 0x10, 0x7, 0x1, PseudoVLUXSEG3EI16_V_M2_MF2 }, // 2248
  { Intrinsic::riscv_vluxseg3, 0x10, 0x7, 0x2, PseudoVLUXSEG3EI16_V_M4_MF2 }, // 2249
  { Intrinsic::riscv_vluxseg3, 0x10, 0x7, 0x3, PseudoVLUXSEG3EI16_V_M8_MF2 }, // 2250
  { Intrinsic::riscv_vluxseg3, 0x10, 0x7, 0x6, PseudoVLUXSEG3EI16_V_MF4_MF2 }, // 2251
  { Intrinsic::riscv_vluxseg3, 0x10, 0x7, 0x7, PseudoVLUXSEG3EI16_V_MF2_MF2 }, // 2252
  { Intrinsic::riscv_vluxseg3, 0x20, 0x0, 0x0, PseudoVLUXSEG3EI32_V_M1_M1 }, // 2253
  { Intrinsic::riscv_vluxseg3, 0x20, 0x0, 0x1, PseudoVLUXSEG3EI32_V_M2_M1 }, // 2254
  { Intrinsic::riscv_vluxseg3, 0x20, 0x0, 0x2, PseudoVLUXSEG3EI32_V_M4_M1 }, // 2255
  { Intrinsic::riscv_vluxseg3, 0x20, 0x0, 0x3, PseudoVLUXSEG3EI32_V_M8_M1 }, // 2256
  { Intrinsic::riscv_vluxseg3, 0x20, 0x0, 0x7, PseudoVLUXSEG3EI32_V_MF2_M1 }, // 2257
  { Intrinsic::riscv_vluxseg3, 0x20, 0x1, 0x0, PseudoVLUXSEG3EI32_V_M1_M2 }, // 2258
  { Intrinsic::riscv_vluxseg3, 0x20, 0x1, 0x1, PseudoVLUXSEG3EI32_V_M2_M2 }, // 2259
  { Intrinsic::riscv_vluxseg3, 0x20, 0x1, 0x2, PseudoVLUXSEG3EI32_V_M4_M2 }, // 2260
  { Intrinsic::riscv_vluxseg3, 0x20, 0x1, 0x3, PseudoVLUXSEG3EI32_V_M8_M2 }, // 2261
  { Intrinsic::riscv_vluxseg3, 0x20, 0x1, 0x7, PseudoVLUXSEG3EI32_V_MF2_M2 }, // 2262
  { Intrinsic::riscv_vluxseg3, 0x20, 0x5, 0x0, PseudoVLUXSEG3EI32_V_M1_MF8 }, // 2263
  { Intrinsic::riscv_vluxseg3, 0x20, 0x5, 0x1, PseudoVLUXSEG3EI32_V_M2_MF8 }, // 2264
  { Intrinsic::riscv_vluxseg3, 0x20, 0x5, 0x2, PseudoVLUXSEG3EI32_V_M4_MF8 }, // 2265
  { Intrinsic::riscv_vluxseg3, 0x20, 0x5, 0x3, PseudoVLUXSEG3EI32_V_M8_MF8 }, // 2266
  { Intrinsic::riscv_vluxseg3, 0x20, 0x5, 0x7, PseudoVLUXSEG3EI32_V_MF2_MF8 }, // 2267
  { Intrinsic::riscv_vluxseg3, 0x20, 0x6, 0x0, PseudoVLUXSEG3EI32_V_M1_MF4 }, // 2268
  { Intrinsic::riscv_vluxseg3, 0x20, 0x6, 0x1, PseudoVLUXSEG3EI32_V_M2_MF4 }, // 2269
  { Intrinsic::riscv_vluxseg3, 0x20, 0x6, 0x2, PseudoVLUXSEG3EI32_V_M4_MF4 }, // 2270
  { Intrinsic::riscv_vluxseg3, 0x20, 0x6, 0x3, PseudoVLUXSEG3EI32_V_M8_MF4 }, // 2271
  { Intrinsic::riscv_vluxseg3, 0x20, 0x6, 0x7, PseudoVLUXSEG3EI32_V_MF2_MF4 }, // 2272
  { Intrinsic::riscv_vluxseg3, 0x20, 0x7, 0x0, PseudoVLUXSEG3EI32_V_M1_MF2 }, // 2273
  { Intrinsic::riscv_vluxseg3, 0x20, 0x7, 0x1, PseudoVLUXSEG3EI32_V_M2_MF2 }, // 2274
  { Intrinsic::riscv_vluxseg3, 0x20, 0x7, 0x2, PseudoVLUXSEG3EI32_V_M4_MF2 }, // 2275
  { Intrinsic::riscv_vluxseg3, 0x20, 0x7, 0x3, PseudoVLUXSEG3EI32_V_M8_MF2 }, // 2276
  { Intrinsic::riscv_vluxseg3, 0x20, 0x7, 0x7, PseudoVLUXSEG3EI32_V_MF2_MF2 }, // 2277
  { Intrinsic::riscv_vluxseg3, 0x40, 0x0, 0x0, PseudoVLUXSEG3EI64_V_M1_M1 }, // 2278
  { Intrinsic::riscv_vluxseg3, 0x40, 0x0, 0x1, PseudoVLUXSEG3EI64_V_M2_M1 }, // 2279
  { Intrinsic::riscv_vluxseg3, 0x40, 0x0, 0x2, PseudoVLUXSEG3EI64_V_M4_M1 }, // 2280
  { Intrinsic::riscv_vluxseg3, 0x40, 0x0, 0x3, PseudoVLUXSEG3EI64_V_M8_M1 }, // 2281
  { Intrinsic::riscv_vluxseg3, 0x40, 0x1, 0x0, PseudoVLUXSEG3EI64_V_M1_M2 }, // 2282
  { Intrinsic::riscv_vluxseg3, 0x40, 0x1, 0x1, PseudoVLUXSEG3EI64_V_M2_M2 }, // 2283
  { Intrinsic::riscv_vluxseg3, 0x40, 0x1, 0x2, PseudoVLUXSEG3EI64_V_M4_M2 }, // 2284
  { Intrinsic::riscv_vluxseg3, 0x40, 0x1, 0x3, PseudoVLUXSEG3EI64_V_M8_M2 }, // 2285
  { Intrinsic::riscv_vluxseg3, 0x40, 0x5, 0x0, PseudoVLUXSEG3EI64_V_M1_MF8 }, // 2286
  { Intrinsic::riscv_vluxseg3, 0x40, 0x5, 0x1, PseudoVLUXSEG3EI64_V_M2_MF8 }, // 2287
  { Intrinsic::riscv_vluxseg3, 0x40, 0x5, 0x2, PseudoVLUXSEG3EI64_V_M4_MF8 }, // 2288
  { Intrinsic::riscv_vluxseg3, 0x40, 0x5, 0x3, PseudoVLUXSEG3EI64_V_M8_MF8 }, // 2289
  { Intrinsic::riscv_vluxseg3, 0x40, 0x6, 0x0, PseudoVLUXSEG3EI64_V_M1_MF4 }, // 2290
  { Intrinsic::riscv_vluxseg3, 0x40, 0x6, 0x1, PseudoVLUXSEG3EI64_V_M2_MF4 }, // 2291
  { Intrinsic::riscv_vluxseg3, 0x40, 0x6, 0x2, PseudoVLUXSEG3EI64_V_M4_MF4 }, // 2292
  { Intrinsic::riscv_vluxseg3, 0x40, 0x6, 0x3, PseudoVLUXSEG3EI64_V_M8_MF4 }, // 2293
  { Intrinsic::riscv_vluxseg3, 0x40, 0x7, 0x0, PseudoVLUXSEG3EI64_V_M1_MF2 }, // 2294
  { Intrinsic::riscv_vluxseg3, 0x40, 0x7, 0x1, PseudoVLUXSEG3EI64_V_M2_MF2 }, // 2295
  { Intrinsic::riscv_vluxseg3, 0x40, 0x7, 0x2, PseudoVLUXSEG3EI64_V_M4_MF2 }, // 2296
  { Intrinsic::riscv_vluxseg3, 0x40, 0x7, 0x3, PseudoVLUXSEG3EI64_V_M8_MF2 }, // 2297
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x0, 0x0, PseudoVLUXSEG3EI8_V_M1_M1_MASK }, // 2298
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x0, 0x1, PseudoVLUXSEG3EI8_V_M2_M1_MASK }, // 2299
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x0, 0x2, PseudoVLUXSEG3EI8_V_M4_M1_MASK }, // 2300
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x0, 0x3, PseudoVLUXSEG3EI8_V_M8_M1_MASK }, // 2301
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x0, 0x5, PseudoVLUXSEG3EI8_V_MF8_M1_MASK }, // 2302
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x0, 0x6, PseudoVLUXSEG3EI8_V_MF4_M1_MASK }, // 2303
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x0, 0x7, PseudoVLUXSEG3EI8_V_MF2_M1_MASK }, // 2304
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x1, 0x0, PseudoVLUXSEG3EI8_V_M1_M2_MASK }, // 2305
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x1, 0x1, PseudoVLUXSEG3EI8_V_M2_M2_MASK }, // 2306
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x1, 0x2, PseudoVLUXSEG3EI8_V_M4_M2_MASK }, // 2307
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x1, 0x3, PseudoVLUXSEG3EI8_V_M8_M2_MASK }, // 2308
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x1, 0x5, PseudoVLUXSEG3EI8_V_MF8_M2_MASK }, // 2309
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x1, 0x6, PseudoVLUXSEG3EI8_V_MF4_M2_MASK }, // 2310
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x1, 0x7, PseudoVLUXSEG3EI8_V_MF2_M2_MASK }, // 2311
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x5, 0x0, PseudoVLUXSEG3EI8_V_M1_MF8_MASK }, // 2312
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x5, 0x1, PseudoVLUXSEG3EI8_V_M2_MF8_MASK }, // 2313
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x5, 0x2, PseudoVLUXSEG3EI8_V_M4_MF8_MASK }, // 2314
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x5, 0x3, PseudoVLUXSEG3EI8_V_M8_MF8_MASK }, // 2315
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x5, 0x5, PseudoVLUXSEG3EI8_V_MF8_MF8_MASK }, // 2316
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x5, 0x6, PseudoVLUXSEG3EI8_V_MF4_MF8_MASK }, // 2317
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x5, 0x7, PseudoVLUXSEG3EI8_V_MF2_MF8_MASK }, // 2318
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x6, 0x0, PseudoVLUXSEG3EI8_V_M1_MF4_MASK }, // 2319
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x6, 0x1, PseudoVLUXSEG3EI8_V_M2_MF4_MASK }, // 2320
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x6, 0x2, PseudoVLUXSEG3EI8_V_M4_MF4_MASK }, // 2321
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x6, 0x3, PseudoVLUXSEG3EI8_V_M8_MF4_MASK }, // 2322
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x6, 0x5, PseudoVLUXSEG3EI8_V_MF8_MF4_MASK }, // 2323
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x6, 0x6, PseudoVLUXSEG3EI8_V_MF4_MF4_MASK }, // 2324
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x6, 0x7, PseudoVLUXSEG3EI8_V_MF2_MF4_MASK }, // 2325
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x7, 0x0, PseudoVLUXSEG3EI8_V_M1_MF2_MASK }, // 2326
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x7, 0x1, PseudoVLUXSEG3EI8_V_M2_MF2_MASK }, // 2327
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x7, 0x2, PseudoVLUXSEG3EI8_V_M4_MF2_MASK }, // 2328
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x7, 0x3, PseudoVLUXSEG3EI8_V_M8_MF2_MASK }, // 2329
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x7, 0x5, PseudoVLUXSEG3EI8_V_MF8_MF2_MASK }, // 2330
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x7, 0x6, PseudoVLUXSEG3EI8_V_MF4_MF2_MASK }, // 2331
  { Intrinsic::riscv_vluxseg3_mask, 0x8, 0x7, 0x7, PseudoVLUXSEG3EI8_V_MF2_MF2_MASK }, // 2332
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x0, 0x0, PseudoVLUXSEG3EI16_V_M1_M1_MASK }, // 2333
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x0, 0x1, PseudoVLUXSEG3EI16_V_M2_M1_MASK }, // 2334
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x0, 0x2, PseudoVLUXSEG3EI16_V_M4_M1_MASK }, // 2335
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x0, 0x3, PseudoVLUXSEG3EI16_V_M8_M1_MASK }, // 2336
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x0, 0x6, PseudoVLUXSEG3EI16_V_MF4_M1_MASK }, // 2337
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x0, 0x7, PseudoVLUXSEG3EI16_V_MF2_M1_MASK }, // 2338
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x1, 0x0, PseudoVLUXSEG3EI16_V_M1_M2_MASK }, // 2339
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x1, 0x1, PseudoVLUXSEG3EI16_V_M2_M2_MASK }, // 2340
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x1, 0x2, PseudoVLUXSEG3EI16_V_M4_M2_MASK }, // 2341
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x1, 0x3, PseudoVLUXSEG3EI16_V_M8_M2_MASK }, // 2342
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x1, 0x6, PseudoVLUXSEG3EI16_V_MF4_M2_MASK }, // 2343
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x1, 0x7, PseudoVLUXSEG3EI16_V_MF2_M2_MASK }, // 2344
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x5, 0x0, PseudoVLUXSEG3EI16_V_M1_MF8_MASK }, // 2345
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x5, 0x1, PseudoVLUXSEG3EI16_V_M2_MF8_MASK }, // 2346
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x5, 0x2, PseudoVLUXSEG3EI16_V_M4_MF8_MASK }, // 2347
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x5, 0x3, PseudoVLUXSEG3EI16_V_M8_MF8_MASK }, // 2348
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x5, 0x6, PseudoVLUXSEG3EI16_V_MF4_MF8_MASK }, // 2349
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x5, 0x7, PseudoVLUXSEG3EI16_V_MF2_MF8_MASK }, // 2350
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x6, 0x0, PseudoVLUXSEG3EI16_V_M1_MF4_MASK }, // 2351
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x6, 0x1, PseudoVLUXSEG3EI16_V_M2_MF4_MASK }, // 2352
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x6, 0x2, PseudoVLUXSEG3EI16_V_M4_MF4_MASK }, // 2353
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x6, 0x3, PseudoVLUXSEG3EI16_V_M8_MF4_MASK }, // 2354
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x6, 0x6, PseudoVLUXSEG3EI16_V_MF4_MF4_MASK }, // 2355
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x6, 0x7, PseudoVLUXSEG3EI16_V_MF2_MF4_MASK }, // 2356
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x7, 0x0, PseudoVLUXSEG3EI16_V_M1_MF2_MASK }, // 2357
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x7, 0x1, PseudoVLUXSEG3EI16_V_M2_MF2_MASK }, // 2358
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x7, 0x2, PseudoVLUXSEG3EI16_V_M4_MF2_MASK }, // 2359
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x7, 0x3, PseudoVLUXSEG3EI16_V_M8_MF2_MASK }, // 2360
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x7, 0x6, PseudoVLUXSEG3EI16_V_MF4_MF2_MASK }, // 2361
  { Intrinsic::riscv_vluxseg3_mask, 0x10, 0x7, 0x7, PseudoVLUXSEG3EI16_V_MF2_MF2_MASK }, // 2362
  { Intrinsic::riscv_vluxseg3_mask, 0x20, 0x0, 0x0, PseudoVLUXSEG3EI32_V_M1_M1_MASK }, // 2363
  { Intrinsic::riscv_vluxseg3_mask, 0x20, 0x0, 0x1, PseudoVLUXSEG3EI32_V_M2_M1_MASK }, // 2364
  { Intrinsic::riscv_vluxseg3_mask, 0x20, 0x0, 0x2, PseudoVLUXSEG3EI32_V_M4_M1_MASK }, // 2365
  { Intrinsic::riscv_vluxseg3_mask, 0x20, 0x0, 0x3, PseudoVLUXSEG3EI32_V_M8_M1_MASK }, // 2366
  { Intrinsic::riscv_vluxseg3_mask, 0x20, 0x0, 0x7, PseudoVLUXSEG3EI32_V_MF2_M1_MASK }, // 2367
  { Intrinsic::riscv_vluxseg3_mask, 0x20, 0x1, 0x0, PseudoVLUXSEG3EI32_V_M1_M2_MASK }, // 2368
  { Intrinsic::riscv_vluxseg3_mask, 0x20, 0x1, 0x1, PseudoVLUXSEG3EI32_V_M2_M2_MASK }, // 2369
  { Intrinsic::riscv_vluxseg3_mask, 0x20, 0x1, 0x2, PseudoVLUXSEG3EI32_V_M4_M2_MASK }, // 2370
  { Intrinsic::riscv_vluxseg3_mask, 0x20, 0x1, 0x3, PseudoVLUXSEG3EI32_V_M8_M2_MASK }, // 2371
  { Intrinsic::riscv_vluxseg3_mask, 0x20, 0x1, 0x7, PseudoVLUXSEG3EI32_V_MF2_M2_MASK }, // 2372
  { Intrinsic::riscv_vluxseg3_mask, 0x20, 0x5, 0x0, PseudoVLUXSEG3EI32_V_M1_MF8_MASK }, // 2373
  { Intrinsic::riscv_vluxseg3_mask, 0x20, 0x5, 0x1, PseudoVLUXSEG3EI32_V_M2_MF8_MASK }, // 2374
  { Intrinsic::riscv_vluxseg3_mask, 0x20, 0x5, 0x2, PseudoVLUXSEG3EI32_V_M4_MF8_MASK }, // 2375
  { Intrinsic::riscv_vluxseg3_mask, 0x20, 0x5, 0x3, PseudoVLUXSEG3EI32_V_M8_MF8_MASK }, // 2376
  { Intrinsic::riscv_vluxseg3_mask, 0x20, 0x5, 0x7, PseudoVLUXSEG3EI32_V_MF2_MF8_MASK }, // 2377
  { Intrinsic::riscv_vluxseg3_mask, 0x20, 0x6, 0x0, PseudoVLUXSEG3EI32_V_M1_MF4_MASK }, // 2378
  { Intrinsic::riscv_vluxseg3_mask, 0x20, 0x6, 0x1, PseudoVLUXSEG3EI32_V_M2_MF4_MASK }, // 2379
  { Intrinsic::riscv_vluxseg3_mask, 0x20, 0x6, 0x2, PseudoVLUXSEG3EI32_V_M4_MF4_MASK }, // 2380
  { Intrinsic::riscv_vluxseg3_mask, 0x20, 0x6, 0x3, PseudoVLUXSEG3EI32_V_M8_MF4_MASK }, // 2381
  { Intrinsic::riscv_vluxseg3_mask, 0x20, 0x6, 0x7, PseudoVLUXSEG3EI32_V_MF2_MF4_MASK }, // 2382
  { Intrinsic::riscv_vluxseg3_mask, 0x20, 0x7, 0x0, PseudoVLUXSEG3EI32_V_M1_MF2_MASK }, // 2383
  { Intrinsic::riscv_vluxseg3_mask, 0x20, 0x7, 0x1, PseudoVLUXSEG3EI32_V_M2_MF2_MASK }, // 2384
  { Intrinsic::riscv_vluxseg3_mask, 0x20, 0x7, 0x2, PseudoVLUXSEG3EI32_V_M4_MF2_MASK }, // 2385
  { Intrinsic::riscv_vluxseg3_mask, 0x20, 0x7, 0x3, PseudoVLUXSEG3EI32_V_M8_MF2_MASK }, // 2386
  { Intrinsic::riscv_vluxseg3_mask, 0x20, 0x7, 0x7, PseudoVLUXSEG3EI32_V_MF2_MF2_MASK }, // 2387
  { Intrinsic::riscv_vluxseg3_mask, 0x40, 0x0, 0x0, PseudoVLUXSEG3EI64_V_M1_M1_MASK }, // 2388
  { Intrinsic::riscv_vluxseg3_mask, 0x40, 0x0, 0x1, PseudoVLUXSEG3EI64_V_M2_M1_MASK }, // 2389
  { Intrinsic::riscv_vluxseg3_mask, 0x40, 0x0, 0x2, PseudoVLUXSEG3EI64_V_M4_M1_MASK }, // 2390
  { Intrinsic::riscv_vluxseg3_mask, 0x40, 0x0, 0x3, PseudoVLUXSEG3EI64_V_M8_M1_MASK }, // 2391
  { Intrinsic::riscv_vluxseg3_mask, 0x40, 0x1, 0x0, PseudoVLUXSEG3EI64_V_M1_M2_MASK }, // 2392
  { Intrinsic::riscv_vluxseg3_mask, 0x40, 0x1, 0x1, PseudoVLUXSEG3EI64_V_M2_M2_MASK }, // 2393
  { Intrinsic::riscv_vluxseg3_mask, 0x40, 0x1, 0x2, PseudoVLUXSEG3EI64_V_M4_M2_MASK }, // 2394
  { Intrinsic::riscv_vluxseg3_mask, 0x40, 0x1, 0x3, PseudoVLUXSEG3EI64_V_M8_M2_MASK }, // 2395
  { Intrinsic::riscv_vluxseg3_mask, 0x40, 0x5, 0x0, PseudoVLUXSEG3EI64_V_M1_MF8_MASK }, // 2396
  { Intrinsic::riscv_vluxseg3_mask, 0x40, 0x5, 0x1, PseudoVLUXSEG3EI64_V_M2_MF8_MASK }, // 2397
  { Intrinsic::riscv_vluxseg3_mask, 0x40, 0x5, 0x2, PseudoVLUXSEG3EI64_V_M4_MF8_MASK }, // 2398
  { Intrinsic::riscv_vluxseg3_mask, 0x40, 0x5, 0x3, PseudoVLUXSEG3EI64_V_M8_MF8_MASK }, // 2399
  { Intrinsic::riscv_vluxseg3_mask, 0x40, 0x6, 0x0, PseudoVLUXSEG3EI64_V_M1_MF4_MASK }, // 2400
  { Intrinsic::riscv_vluxseg3_mask, 0x40, 0x6, 0x1, PseudoVLUXSEG3EI64_V_M2_MF4_MASK }, // 2401
  { Intrinsic::riscv_vluxseg3_mask, 0x40, 0x6, 0x2, PseudoVLUXSEG3EI64_V_M4_MF4_MASK }, // 2402
  { Intrinsic::riscv_vluxseg3_mask, 0x40, 0x6, 0x3, PseudoVLUXSEG3EI64_V_M8_MF4_MASK }, // 2403
  { Intrinsic::riscv_vluxseg3_mask, 0x40, 0x7, 0x0, PseudoVLUXSEG3EI64_V_M1_MF2_MASK }, // 2404
  { Intrinsic::riscv_vluxseg3_mask, 0x40, 0x7, 0x1, PseudoVLUXSEG3EI64_V_M2_MF2_MASK }, // 2405
  { Intrinsic::riscv_vluxseg3_mask, 0x40, 0x7, 0x2, PseudoVLUXSEG3EI64_V_M4_MF2_MASK }, // 2406
  { Intrinsic::riscv_vluxseg3_mask, 0x40, 0x7, 0x3, PseudoVLUXSEG3EI64_V_M8_MF2_MASK }, // 2407
  { Intrinsic::riscv_vluxseg4, 0x8, 0x0, 0x0, PseudoVLUXSEG4EI8_V_M1_M1 }, // 2408
  { Intrinsic::riscv_vluxseg4, 0x8, 0x0, 0x1, PseudoVLUXSEG4EI8_V_M2_M1 }, // 2409
  { Intrinsic::riscv_vluxseg4, 0x8, 0x0, 0x2, PseudoVLUXSEG4EI8_V_M4_M1 }, // 2410
  { Intrinsic::riscv_vluxseg4, 0x8, 0x0, 0x3, PseudoVLUXSEG4EI8_V_M8_M1 }, // 2411
  { Intrinsic::riscv_vluxseg4, 0x8, 0x0, 0x5, PseudoVLUXSEG4EI8_V_MF8_M1 }, // 2412
  { Intrinsic::riscv_vluxseg4, 0x8, 0x0, 0x6, PseudoVLUXSEG4EI8_V_MF4_M1 }, // 2413
  { Intrinsic::riscv_vluxseg4, 0x8, 0x0, 0x7, PseudoVLUXSEG4EI8_V_MF2_M1 }, // 2414
  { Intrinsic::riscv_vluxseg4, 0x8, 0x1, 0x0, PseudoVLUXSEG4EI8_V_M1_M2 }, // 2415
  { Intrinsic::riscv_vluxseg4, 0x8, 0x1, 0x1, PseudoVLUXSEG4EI8_V_M2_M2 }, // 2416
  { Intrinsic::riscv_vluxseg4, 0x8, 0x1, 0x2, PseudoVLUXSEG4EI8_V_M4_M2 }, // 2417
  { Intrinsic::riscv_vluxseg4, 0x8, 0x1, 0x3, PseudoVLUXSEG4EI8_V_M8_M2 }, // 2418
  { Intrinsic::riscv_vluxseg4, 0x8, 0x1, 0x5, PseudoVLUXSEG4EI8_V_MF8_M2 }, // 2419
  { Intrinsic::riscv_vluxseg4, 0x8, 0x1, 0x6, PseudoVLUXSEG4EI8_V_MF4_M2 }, // 2420
  { Intrinsic::riscv_vluxseg4, 0x8, 0x1, 0x7, PseudoVLUXSEG4EI8_V_MF2_M2 }, // 2421
  { Intrinsic::riscv_vluxseg4, 0x8, 0x5, 0x0, PseudoVLUXSEG4EI8_V_M1_MF8 }, // 2422
  { Intrinsic::riscv_vluxseg4, 0x8, 0x5, 0x1, PseudoVLUXSEG4EI8_V_M2_MF8 }, // 2423
  { Intrinsic::riscv_vluxseg4, 0x8, 0x5, 0x2, PseudoVLUXSEG4EI8_V_M4_MF8 }, // 2424
  { Intrinsic::riscv_vluxseg4, 0x8, 0x5, 0x3, PseudoVLUXSEG4EI8_V_M8_MF8 }, // 2425
  { Intrinsic::riscv_vluxseg4, 0x8, 0x5, 0x5, PseudoVLUXSEG4EI8_V_MF8_MF8 }, // 2426
  { Intrinsic::riscv_vluxseg4, 0x8, 0x5, 0x6, PseudoVLUXSEG4EI8_V_MF4_MF8 }, // 2427
  { Intrinsic::riscv_vluxseg4, 0x8, 0x5, 0x7, PseudoVLUXSEG4EI8_V_MF2_MF8 }, // 2428
  { Intrinsic::riscv_vluxseg4, 0x8, 0x6, 0x0, PseudoVLUXSEG4EI8_V_M1_MF4 }, // 2429
  { Intrinsic::riscv_vluxseg4, 0x8, 0x6, 0x1, PseudoVLUXSEG4EI8_V_M2_MF4 }, // 2430
  { Intrinsic::riscv_vluxseg4, 0x8, 0x6, 0x2, PseudoVLUXSEG4EI8_V_M4_MF4 }, // 2431
  { Intrinsic::riscv_vluxseg4, 0x8, 0x6, 0x3, PseudoVLUXSEG4EI8_V_M8_MF4 }, // 2432
  { Intrinsic::riscv_vluxseg4, 0x8, 0x6, 0x5, PseudoVLUXSEG4EI8_V_MF8_MF4 }, // 2433
  { Intrinsic::riscv_vluxseg4, 0x8, 0x6, 0x6, PseudoVLUXSEG4EI8_V_MF4_MF4 }, // 2434
  { Intrinsic::riscv_vluxseg4, 0x8, 0x6, 0x7, PseudoVLUXSEG4EI8_V_MF2_MF4 }, // 2435
  { Intrinsic::riscv_vluxseg4, 0x8, 0x7, 0x0, PseudoVLUXSEG4EI8_V_M1_MF2 }, // 2436
  { Intrinsic::riscv_vluxseg4, 0x8, 0x7, 0x1, PseudoVLUXSEG4EI8_V_M2_MF2 }, // 2437
  { Intrinsic::riscv_vluxseg4, 0x8, 0x7, 0x2, PseudoVLUXSEG4EI8_V_M4_MF2 }, // 2438
  { Intrinsic::riscv_vluxseg4, 0x8, 0x7, 0x3, PseudoVLUXSEG4EI8_V_M8_MF2 }, // 2439
  { Intrinsic::riscv_vluxseg4, 0x8, 0x7, 0x5, PseudoVLUXSEG4EI8_V_MF8_MF2 }, // 2440
  { Intrinsic::riscv_vluxseg4, 0x8, 0x7, 0x6, PseudoVLUXSEG4EI8_V_MF4_MF2 }, // 2441
  { Intrinsic::riscv_vluxseg4, 0x8, 0x7, 0x7, PseudoVLUXSEG4EI8_V_MF2_MF2 }, // 2442
  { Intrinsic::riscv_vluxseg4, 0x10, 0x0, 0x0, PseudoVLUXSEG4EI16_V_M1_M1 }, // 2443
  { Intrinsic::riscv_vluxseg4, 0x10, 0x0, 0x1, PseudoVLUXSEG4EI16_V_M2_M1 }, // 2444
  { Intrinsic::riscv_vluxseg4, 0x10, 0x0, 0x2, PseudoVLUXSEG4EI16_V_M4_M1 }, // 2445
  { Intrinsic::riscv_vluxseg4, 0x10, 0x0, 0x3, PseudoVLUXSEG4EI16_V_M8_M1 }, // 2446
  { Intrinsic::riscv_vluxseg4, 0x10, 0x0, 0x6, PseudoVLUXSEG4EI16_V_MF4_M1 }, // 2447
  { Intrinsic::riscv_vluxseg4, 0x10, 0x0, 0x7, PseudoVLUXSEG4EI16_V_MF2_M1 }, // 2448
  { Intrinsic::riscv_vluxseg4, 0x10, 0x1, 0x0, PseudoVLUXSEG4EI16_V_M1_M2 }, // 2449
  { Intrinsic::riscv_vluxseg4, 0x10, 0x1, 0x1, PseudoVLUXSEG4EI16_V_M2_M2 }, // 2450
  { Intrinsic::riscv_vluxseg4, 0x10, 0x1, 0x2, PseudoVLUXSEG4EI16_V_M4_M2 }, // 2451
  { Intrinsic::riscv_vluxseg4, 0x10, 0x1, 0x3, PseudoVLUXSEG4EI16_V_M8_M2 }, // 2452
  { Intrinsic::riscv_vluxseg4, 0x10, 0x1, 0x6, PseudoVLUXSEG4EI16_V_MF4_M2 }, // 2453
  { Intrinsic::riscv_vluxseg4, 0x10, 0x1, 0x7, PseudoVLUXSEG4EI16_V_MF2_M2 }, // 2454
  { Intrinsic::riscv_vluxseg4, 0x10, 0x5, 0x0, PseudoVLUXSEG4EI16_V_M1_MF8 }, // 2455
  { Intrinsic::riscv_vluxseg4, 0x10, 0x5, 0x1, PseudoVLUXSEG4EI16_V_M2_MF8 }, // 2456
  { Intrinsic::riscv_vluxseg4, 0x10, 0x5, 0x2, PseudoVLUXSEG4EI16_V_M4_MF8 }, // 2457
  { Intrinsic::riscv_vluxseg4, 0x10, 0x5, 0x3, PseudoVLUXSEG4EI16_V_M8_MF8 }, // 2458
  { Intrinsic::riscv_vluxseg4, 0x10, 0x5, 0x6, PseudoVLUXSEG4EI16_V_MF4_MF8 }, // 2459
  { Intrinsic::riscv_vluxseg4, 0x10, 0x5, 0x7, PseudoVLUXSEG4EI16_V_MF2_MF8 }, // 2460
  { Intrinsic::riscv_vluxseg4, 0x10, 0x6, 0x0, PseudoVLUXSEG4EI16_V_M1_MF4 }, // 2461
  { Intrinsic::riscv_vluxseg4, 0x10, 0x6, 0x1, PseudoVLUXSEG4EI16_V_M2_MF4 }, // 2462
  { Intrinsic::riscv_vluxseg4, 0x10, 0x6, 0x2, PseudoVLUXSEG4EI16_V_M4_MF4 }, // 2463
  { Intrinsic::riscv_vluxseg4, 0x10, 0x6, 0x3, PseudoVLUXSEG4EI16_V_M8_MF4 }, // 2464
  { Intrinsic::riscv_vluxseg4, 0x10, 0x6, 0x6, PseudoVLUXSEG4EI16_V_MF4_MF4 }, // 2465
  { Intrinsic::riscv_vluxseg4, 0x10, 0x6, 0x7, PseudoVLUXSEG4EI16_V_MF2_MF4 }, // 2466
  { Intrinsic::riscv_vluxseg4, 0x10, 0x7, 0x0, PseudoVLUXSEG4EI16_V_M1_MF2 }, // 2467
  { Intrinsic::riscv_vluxseg4, 0x10, 0x7, 0x1, PseudoVLUXSEG4EI16_V_M2_MF2 }, // 2468
  { Intrinsic::riscv_vluxseg4, 0x10, 0x7, 0x2, PseudoVLUXSEG4EI16_V_M4_MF2 }, // 2469
  { Intrinsic::riscv_vluxseg4, 0x10, 0x7, 0x3, PseudoVLUXSEG4EI16_V_M8_MF2 }, // 2470
  { Intrinsic::riscv_vluxseg4, 0x10, 0x7, 0x6, PseudoVLUXSEG4EI16_V_MF4_MF2 }, // 2471
  { Intrinsic::riscv_vluxseg4, 0x10, 0x7, 0x7, PseudoVLUXSEG4EI16_V_MF2_MF2 }, // 2472
  { Intrinsic::riscv_vluxseg4, 0x20, 0x0, 0x0, PseudoVLUXSEG4EI32_V_M1_M1 }, // 2473
  { Intrinsic::riscv_vluxseg4, 0x20, 0x0, 0x1, PseudoVLUXSEG4EI32_V_M2_M1 }, // 2474
  { Intrinsic::riscv_vluxseg4, 0x20, 0x0, 0x2, PseudoVLUXSEG4EI32_V_M4_M1 }, // 2475
  { Intrinsic::riscv_vluxseg4, 0x20, 0x0, 0x3, PseudoVLUXSEG4EI32_V_M8_M1 }, // 2476
  { Intrinsic::riscv_vluxseg4, 0x20, 0x0, 0x7, PseudoVLUXSEG4EI32_V_MF2_M1 }, // 2477
  { Intrinsic::riscv_vluxseg4, 0x20, 0x1, 0x0, PseudoVLUXSEG4EI32_V_M1_M2 }, // 2478
  { Intrinsic::riscv_vluxseg4, 0x20, 0x1, 0x1, PseudoVLUXSEG4EI32_V_M2_M2 }, // 2479
  { Intrinsic::riscv_vluxseg4, 0x20, 0x1, 0x2, PseudoVLUXSEG4EI32_V_M4_M2 }, // 2480
  { Intrinsic::riscv_vluxseg4, 0x20, 0x1, 0x3, PseudoVLUXSEG4EI32_V_M8_M2 }, // 2481
  { Intrinsic::riscv_vluxseg4, 0x20, 0x1, 0x7, PseudoVLUXSEG4EI32_V_MF2_M2 }, // 2482
  { Intrinsic::riscv_vluxseg4, 0x20, 0x5, 0x0, PseudoVLUXSEG4EI32_V_M1_MF8 }, // 2483
  { Intrinsic::riscv_vluxseg4, 0x20, 0x5, 0x1, PseudoVLUXSEG4EI32_V_M2_MF8 }, // 2484
  { Intrinsic::riscv_vluxseg4, 0x20, 0x5, 0x2, PseudoVLUXSEG4EI32_V_M4_MF8 }, // 2485
  { Intrinsic::riscv_vluxseg4, 0x20, 0x5, 0x3, PseudoVLUXSEG4EI32_V_M8_MF8 }, // 2486
  { Intrinsic::riscv_vluxseg4, 0x20, 0x5, 0x7, PseudoVLUXSEG4EI32_V_MF2_MF8 }, // 2487
  { Intrinsic::riscv_vluxseg4, 0x20, 0x6, 0x0, PseudoVLUXSEG4EI32_V_M1_MF4 }, // 2488
  { Intrinsic::riscv_vluxseg4, 0x20, 0x6, 0x1, PseudoVLUXSEG4EI32_V_M2_MF4 }, // 2489
  { Intrinsic::riscv_vluxseg4, 0x20, 0x6, 0x2, PseudoVLUXSEG4EI32_V_M4_MF4 }, // 2490
  { Intrinsic::riscv_vluxseg4, 0x20, 0x6, 0x3, PseudoVLUXSEG4EI32_V_M8_MF4 }, // 2491
  { Intrinsic::riscv_vluxseg4, 0x20, 0x6, 0x7, PseudoVLUXSEG4EI32_V_MF2_MF4 }, // 2492
  { Intrinsic::riscv_vluxseg4, 0x20, 0x7, 0x0, PseudoVLUXSEG4EI32_V_M1_MF2 }, // 2493
  { Intrinsic::riscv_vluxseg4, 0x20, 0x7, 0x1, PseudoVLUXSEG4EI32_V_M2_MF2 }, // 2494
  { Intrinsic::riscv_vluxseg4, 0x20, 0x7, 0x2, PseudoVLUXSEG4EI32_V_M4_MF2 }, // 2495
  { Intrinsic::riscv_vluxseg4, 0x20, 0x7, 0x3, PseudoVLUXSEG4EI32_V_M8_MF2 }, // 2496
  { Intrinsic::riscv_vluxseg4, 0x20, 0x7, 0x7, PseudoVLUXSEG4EI32_V_MF2_MF2 }, // 2497
  { Intrinsic::riscv_vluxseg4, 0x40, 0x0, 0x0, PseudoVLUXSEG4EI64_V_M1_M1 }, // 2498
  { Intrinsic::riscv_vluxseg4, 0x40, 0x0, 0x1, PseudoVLUXSEG4EI64_V_M2_M1 }, // 2499
  { Intrinsic::riscv_vluxseg4, 0x40, 0x0, 0x2, PseudoVLUXSEG4EI64_V_M4_M1 }, // 2500
  { Intrinsic::riscv_vluxseg4, 0x40, 0x0, 0x3, PseudoVLUXSEG4EI64_V_M8_M1 }, // 2501
  { Intrinsic::riscv_vluxseg4, 0x40, 0x1, 0x0, PseudoVLUXSEG4EI64_V_M1_M2 }, // 2502
  { Intrinsic::riscv_vluxseg4, 0x40, 0x1, 0x1, PseudoVLUXSEG4EI64_V_M2_M2 }, // 2503
  { Intrinsic::riscv_vluxseg4, 0x40, 0x1, 0x2, PseudoVLUXSEG4EI64_V_M4_M2 }, // 2504
  { Intrinsic::riscv_vluxseg4, 0x40, 0x1, 0x3, PseudoVLUXSEG4EI64_V_M8_M2 }, // 2505
  { Intrinsic::riscv_vluxseg4, 0x40, 0x5, 0x0, PseudoVLUXSEG4EI64_V_M1_MF8 }, // 2506
  { Intrinsic::riscv_vluxseg4, 0x40, 0x5, 0x1, PseudoVLUXSEG4EI64_V_M2_MF8 }, // 2507
  { Intrinsic::riscv_vluxseg4, 0x40, 0x5, 0x2, PseudoVLUXSEG4EI64_V_M4_MF8 }, // 2508
  { Intrinsic::riscv_vluxseg4, 0x40, 0x5, 0x3, PseudoVLUXSEG4EI64_V_M8_MF8 }, // 2509
  { Intrinsic::riscv_vluxseg4, 0x40, 0x6, 0x0, PseudoVLUXSEG4EI64_V_M1_MF4 }, // 2510
  { Intrinsic::riscv_vluxseg4, 0x40, 0x6, 0x1, PseudoVLUXSEG4EI64_V_M2_MF4 }, // 2511
  { Intrinsic::riscv_vluxseg4, 0x40, 0x6, 0x2, PseudoVLUXSEG4EI64_V_M4_MF4 }, // 2512
  { Intrinsic::riscv_vluxseg4, 0x40, 0x6, 0x3, PseudoVLUXSEG4EI64_V_M8_MF4 }, // 2513
  { Intrinsic::riscv_vluxseg4, 0x40, 0x7, 0x0, PseudoVLUXSEG4EI64_V_M1_MF2 }, // 2514
  { Intrinsic::riscv_vluxseg4, 0x40, 0x7, 0x1, PseudoVLUXSEG4EI64_V_M2_MF2 }, // 2515
  { Intrinsic::riscv_vluxseg4, 0x40, 0x7, 0x2, PseudoVLUXSEG4EI64_V_M4_MF2 }, // 2516
  { Intrinsic::riscv_vluxseg4, 0x40, 0x7, 0x3, PseudoVLUXSEG4EI64_V_M8_MF2 }, // 2517
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x0, 0x0, PseudoVLUXSEG4EI8_V_M1_M1_MASK }, // 2518
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x0, 0x1, PseudoVLUXSEG4EI8_V_M2_M1_MASK }, // 2519
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x0, 0x2, PseudoVLUXSEG4EI8_V_M4_M1_MASK }, // 2520
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x0, 0x3, PseudoVLUXSEG4EI8_V_M8_M1_MASK }, // 2521
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x0, 0x5, PseudoVLUXSEG4EI8_V_MF8_M1_MASK }, // 2522
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x0, 0x6, PseudoVLUXSEG4EI8_V_MF4_M1_MASK }, // 2523
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x0, 0x7, PseudoVLUXSEG4EI8_V_MF2_M1_MASK }, // 2524
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x1, 0x0, PseudoVLUXSEG4EI8_V_M1_M2_MASK }, // 2525
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x1, 0x1, PseudoVLUXSEG4EI8_V_M2_M2_MASK }, // 2526
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x1, 0x2, PseudoVLUXSEG4EI8_V_M4_M2_MASK }, // 2527
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x1, 0x3, PseudoVLUXSEG4EI8_V_M8_M2_MASK }, // 2528
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x1, 0x5, PseudoVLUXSEG4EI8_V_MF8_M2_MASK }, // 2529
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x1, 0x6, PseudoVLUXSEG4EI8_V_MF4_M2_MASK }, // 2530
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x1, 0x7, PseudoVLUXSEG4EI8_V_MF2_M2_MASK }, // 2531
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x5, 0x0, PseudoVLUXSEG4EI8_V_M1_MF8_MASK }, // 2532
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x5, 0x1, PseudoVLUXSEG4EI8_V_M2_MF8_MASK }, // 2533
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x5, 0x2, PseudoVLUXSEG4EI8_V_M4_MF8_MASK }, // 2534
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x5, 0x3, PseudoVLUXSEG4EI8_V_M8_MF8_MASK }, // 2535
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x5, 0x5, PseudoVLUXSEG4EI8_V_MF8_MF8_MASK }, // 2536
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x5, 0x6, PseudoVLUXSEG4EI8_V_MF4_MF8_MASK }, // 2537
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x5, 0x7, PseudoVLUXSEG4EI8_V_MF2_MF8_MASK }, // 2538
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x6, 0x0, PseudoVLUXSEG4EI8_V_M1_MF4_MASK }, // 2539
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x6, 0x1, PseudoVLUXSEG4EI8_V_M2_MF4_MASK }, // 2540
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x6, 0x2, PseudoVLUXSEG4EI8_V_M4_MF4_MASK }, // 2541
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x6, 0x3, PseudoVLUXSEG4EI8_V_M8_MF4_MASK }, // 2542
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x6, 0x5, PseudoVLUXSEG4EI8_V_MF8_MF4_MASK }, // 2543
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x6, 0x6, PseudoVLUXSEG4EI8_V_MF4_MF4_MASK }, // 2544
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x6, 0x7, PseudoVLUXSEG4EI8_V_MF2_MF4_MASK }, // 2545
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x7, 0x0, PseudoVLUXSEG4EI8_V_M1_MF2_MASK }, // 2546
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x7, 0x1, PseudoVLUXSEG4EI8_V_M2_MF2_MASK }, // 2547
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x7, 0x2, PseudoVLUXSEG4EI8_V_M4_MF2_MASK }, // 2548
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x7, 0x3, PseudoVLUXSEG4EI8_V_M8_MF2_MASK }, // 2549
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x7, 0x5, PseudoVLUXSEG4EI8_V_MF8_MF2_MASK }, // 2550
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x7, 0x6, PseudoVLUXSEG4EI8_V_MF4_MF2_MASK }, // 2551
  { Intrinsic::riscv_vluxseg4_mask, 0x8, 0x7, 0x7, PseudoVLUXSEG4EI8_V_MF2_MF2_MASK }, // 2552
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x0, 0x0, PseudoVLUXSEG4EI16_V_M1_M1_MASK }, // 2553
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x0, 0x1, PseudoVLUXSEG4EI16_V_M2_M1_MASK }, // 2554
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x0, 0x2, PseudoVLUXSEG4EI16_V_M4_M1_MASK }, // 2555
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x0, 0x3, PseudoVLUXSEG4EI16_V_M8_M1_MASK }, // 2556
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x0, 0x6, PseudoVLUXSEG4EI16_V_MF4_M1_MASK }, // 2557
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x0, 0x7, PseudoVLUXSEG4EI16_V_MF2_M1_MASK }, // 2558
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x1, 0x0, PseudoVLUXSEG4EI16_V_M1_M2_MASK }, // 2559
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x1, 0x1, PseudoVLUXSEG4EI16_V_M2_M2_MASK }, // 2560
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x1, 0x2, PseudoVLUXSEG4EI16_V_M4_M2_MASK }, // 2561
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x1, 0x3, PseudoVLUXSEG4EI16_V_M8_M2_MASK }, // 2562
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x1, 0x6, PseudoVLUXSEG4EI16_V_MF4_M2_MASK }, // 2563
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x1, 0x7, PseudoVLUXSEG4EI16_V_MF2_M2_MASK }, // 2564
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x5, 0x0, PseudoVLUXSEG4EI16_V_M1_MF8_MASK }, // 2565
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x5, 0x1, PseudoVLUXSEG4EI16_V_M2_MF8_MASK }, // 2566
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x5, 0x2, PseudoVLUXSEG4EI16_V_M4_MF8_MASK }, // 2567
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x5, 0x3, PseudoVLUXSEG4EI16_V_M8_MF8_MASK }, // 2568
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x5, 0x6, PseudoVLUXSEG4EI16_V_MF4_MF8_MASK }, // 2569
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x5, 0x7, PseudoVLUXSEG4EI16_V_MF2_MF8_MASK }, // 2570
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x6, 0x0, PseudoVLUXSEG4EI16_V_M1_MF4_MASK }, // 2571
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x6, 0x1, PseudoVLUXSEG4EI16_V_M2_MF4_MASK }, // 2572
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x6, 0x2, PseudoVLUXSEG4EI16_V_M4_MF4_MASK }, // 2573
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x6, 0x3, PseudoVLUXSEG4EI16_V_M8_MF4_MASK }, // 2574
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x6, 0x6, PseudoVLUXSEG4EI16_V_MF4_MF4_MASK }, // 2575
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x6, 0x7, PseudoVLUXSEG4EI16_V_MF2_MF4_MASK }, // 2576
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x7, 0x0, PseudoVLUXSEG4EI16_V_M1_MF2_MASK }, // 2577
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x7, 0x1, PseudoVLUXSEG4EI16_V_M2_MF2_MASK }, // 2578
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x7, 0x2, PseudoVLUXSEG4EI16_V_M4_MF2_MASK }, // 2579
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x7, 0x3, PseudoVLUXSEG4EI16_V_M8_MF2_MASK }, // 2580
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x7, 0x6, PseudoVLUXSEG4EI16_V_MF4_MF2_MASK }, // 2581
  { Intrinsic::riscv_vluxseg4_mask, 0x10, 0x7, 0x7, PseudoVLUXSEG4EI16_V_MF2_MF2_MASK }, // 2582
  { Intrinsic::riscv_vluxseg4_mask, 0x20, 0x0, 0x0, PseudoVLUXSEG4EI32_V_M1_M1_MASK }, // 2583
  { Intrinsic::riscv_vluxseg4_mask, 0x20, 0x0, 0x1, PseudoVLUXSEG4EI32_V_M2_M1_MASK }, // 2584
  { Intrinsic::riscv_vluxseg4_mask, 0x20, 0x0, 0x2, PseudoVLUXSEG4EI32_V_M4_M1_MASK }, // 2585
  { Intrinsic::riscv_vluxseg4_mask, 0x20, 0x0, 0x3, PseudoVLUXSEG4EI32_V_M8_M1_MASK }, // 2586
  { Intrinsic::riscv_vluxseg4_mask, 0x20, 0x0, 0x7, PseudoVLUXSEG4EI32_V_MF2_M1_MASK }, // 2587
  { Intrinsic::riscv_vluxseg4_mask, 0x20, 0x1, 0x0, PseudoVLUXSEG4EI32_V_M1_M2_MASK }, // 2588
  { Intrinsic::riscv_vluxseg4_mask, 0x20, 0x1, 0x1, PseudoVLUXSEG4EI32_V_M2_M2_MASK }, // 2589
  { Intrinsic::riscv_vluxseg4_mask, 0x20, 0x1, 0x2, PseudoVLUXSEG4EI32_V_M4_M2_MASK }, // 2590
  { Intrinsic::riscv_vluxseg4_mask, 0x20, 0x1, 0x3, PseudoVLUXSEG4EI32_V_M8_M2_MASK }, // 2591
  { Intrinsic::riscv_vluxseg4_mask, 0x20, 0x1, 0x7, PseudoVLUXSEG4EI32_V_MF2_M2_MASK }, // 2592
  { Intrinsic::riscv_vluxseg4_mask, 0x20, 0x5, 0x0, PseudoVLUXSEG4EI32_V_M1_MF8_MASK }, // 2593
  { Intrinsic::riscv_vluxseg4_mask, 0x20, 0x5, 0x1, PseudoVLUXSEG4EI32_V_M2_MF8_MASK }, // 2594
  { Intrinsic::riscv_vluxseg4_mask, 0x20, 0x5, 0x2, PseudoVLUXSEG4EI32_V_M4_MF8_MASK }, // 2595
  { Intrinsic::riscv_vluxseg4_mask, 0x20, 0x5, 0x3, PseudoVLUXSEG4EI32_V_M8_MF8_MASK }, // 2596
  { Intrinsic::riscv_vluxseg4_mask, 0x20, 0x5, 0x7, PseudoVLUXSEG4EI32_V_MF2_MF8_MASK }, // 2597
  { Intrinsic::riscv_vluxseg4_mask, 0x20, 0x6, 0x0, PseudoVLUXSEG4EI32_V_M1_MF4_MASK }, // 2598
  { Intrinsic::riscv_vluxseg4_mask, 0x20, 0x6, 0x1, PseudoVLUXSEG4EI32_V_M2_MF4_MASK }, // 2599
  { Intrinsic::riscv_vluxseg4_mask, 0x20, 0x6, 0x2, PseudoVLUXSEG4EI32_V_M4_MF4_MASK }, // 2600
  { Intrinsic::riscv_vluxseg4_mask, 0x20, 0x6, 0x3, PseudoVLUXSEG4EI32_V_M8_MF4_MASK }, // 2601
  { Intrinsic::riscv_vluxseg4_mask, 0x20, 0x6, 0x7, PseudoVLUXSEG4EI32_V_MF2_MF4_MASK }, // 2602
  { Intrinsic::riscv_vluxseg4_mask, 0x20, 0x7, 0x0, PseudoVLUXSEG4EI32_V_M1_MF2_MASK }, // 2603
  { Intrinsic::riscv_vluxseg4_mask, 0x20, 0x7, 0x1, PseudoVLUXSEG4EI32_V_M2_MF2_MASK }, // 2604
  { Intrinsic::riscv_vluxseg4_mask, 0x20, 0x7, 0x2, PseudoVLUXSEG4EI32_V_M4_MF2_MASK }, // 2605
  { Intrinsic::riscv_vluxseg4_mask, 0x20, 0x7, 0x3, PseudoVLUXSEG4EI32_V_M8_MF2_MASK }, // 2606
  { Intrinsic::riscv_vluxseg4_mask, 0x20, 0x7, 0x7, PseudoVLUXSEG4EI32_V_MF2_MF2_MASK }, // 2607
  { Intrinsic::riscv_vluxseg4_mask, 0x40, 0x0, 0x0, PseudoVLUXSEG4EI64_V_M1_M1_MASK }, // 2608
  { Intrinsic::riscv_vluxseg4_mask, 0x40, 0x0, 0x1, PseudoVLUXSEG4EI64_V_M2_M1_MASK }, // 2609
  { Intrinsic::riscv_vluxseg4_mask, 0x40, 0x0, 0x2, PseudoVLUXSEG4EI64_V_M4_M1_MASK }, // 2610
  { Intrinsic::riscv_vluxseg4_mask, 0x40, 0x0, 0x3, PseudoVLUXSEG4EI64_V_M8_M1_MASK }, // 2611
  { Intrinsic::riscv_vluxseg4_mask, 0x40, 0x1, 0x0, PseudoVLUXSEG4EI64_V_M1_M2_MASK }, // 2612
  { Intrinsic::riscv_vluxseg4_mask, 0x40, 0x1, 0x1, PseudoVLUXSEG4EI64_V_M2_M2_MASK }, // 2613
  { Intrinsic::riscv_vluxseg4_mask, 0x40, 0x1, 0x2, PseudoVLUXSEG4EI64_V_M4_M2_MASK }, // 2614
  { Intrinsic::riscv_vluxseg4_mask, 0x40, 0x1, 0x3, PseudoVLUXSEG4EI64_V_M8_M2_MASK }, // 2615
  { Intrinsic::riscv_vluxseg4_mask, 0x40, 0x5, 0x0, PseudoVLUXSEG4EI64_V_M1_MF8_MASK }, // 2616
  { Intrinsic::riscv_vluxseg4_mask, 0x40, 0x5, 0x1, PseudoVLUXSEG4EI64_V_M2_MF8_MASK }, // 2617
  { Intrinsic::riscv_vluxseg4_mask, 0x40, 0x5, 0x2, PseudoVLUXSEG4EI64_V_M4_MF8_MASK }, // 2618
  { Intrinsic::riscv_vluxseg4_mask, 0x40, 0x5, 0x3, PseudoVLUXSEG4EI64_V_M8_MF8_MASK }, // 2619
  { Intrinsic::riscv_vluxseg4_mask, 0x40, 0x6, 0x0, PseudoVLUXSEG4EI64_V_M1_MF4_MASK }, // 2620
  { Intrinsic::riscv_vluxseg4_mask, 0x40, 0x6, 0x1, PseudoVLUXSEG4EI64_V_M2_MF4_MASK }, // 2621
  { Intrinsic::riscv_vluxseg4_mask, 0x40, 0x6, 0x2, PseudoVLUXSEG4EI64_V_M4_MF4_MASK }, // 2622
  { Intrinsic::riscv_vluxseg4_mask, 0x40, 0x6, 0x3, PseudoVLUXSEG4EI64_V_M8_MF4_MASK }, // 2623
  { Intrinsic::riscv_vluxseg4_mask, 0x40, 0x7, 0x0, PseudoVLUXSEG4EI64_V_M1_MF2_MASK }, // 2624
  { Intrinsic::riscv_vluxseg4_mask, 0x40, 0x7, 0x1, PseudoVLUXSEG4EI64_V_M2_MF2_MASK }, // 2625
  { Intrinsic::riscv_vluxseg4_mask, 0x40, 0x7, 0x2, PseudoVLUXSEG4EI64_V_M4_MF2_MASK }, // 2626
  { Intrinsic::riscv_vluxseg4_mask, 0x40, 0x7, 0x3, PseudoVLUXSEG4EI64_V_M8_MF2_MASK }, // 2627
  { Intrinsic::riscv_vluxseg5, 0x8, 0x0, 0x0, PseudoVLUXSEG5EI8_V_M1_M1 }, // 2628
  { Intrinsic::riscv_vluxseg5, 0x8, 0x0, 0x1, PseudoVLUXSEG5EI8_V_M2_M1 }, // 2629
  { Intrinsic::riscv_vluxseg5, 0x8, 0x0, 0x2, PseudoVLUXSEG5EI8_V_M4_M1 }, // 2630
  { Intrinsic::riscv_vluxseg5, 0x8, 0x0, 0x3, PseudoVLUXSEG5EI8_V_M8_M1 }, // 2631
  { Intrinsic::riscv_vluxseg5, 0x8, 0x0, 0x5, PseudoVLUXSEG5EI8_V_MF8_M1 }, // 2632
  { Intrinsic::riscv_vluxseg5, 0x8, 0x0, 0x6, PseudoVLUXSEG5EI8_V_MF4_M1 }, // 2633
  { Intrinsic::riscv_vluxseg5, 0x8, 0x0, 0x7, PseudoVLUXSEG5EI8_V_MF2_M1 }, // 2634
  { Intrinsic::riscv_vluxseg5, 0x8, 0x5, 0x0, PseudoVLUXSEG5EI8_V_M1_MF8 }, // 2635
  { Intrinsic::riscv_vluxseg5, 0x8, 0x5, 0x1, PseudoVLUXSEG5EI8_V_M2_MF8 }, // 2636
  { Intrinsic::riscv_vluxseg5, 0x8, 0x5, 0x2, PseudoVLUXSEG5EI8_V_M4_MF8 }, // 2637
  { Intrinsic::riscv_vluxseg5, 0x8, 0x5, 0x3, PseudoVLUXSEG5EI8_V_M8_MF8 }, // 2638
  { Intrinsic::riscv_vluxseg5, 0x8, 0x5, 0x5, PseudoVLUXSEG5EI8_V_MF8_MF8 }, // 2639
  { Intrinsic::riscv_vluxseg5, 0x8, 0x5, 0x6, PseudoVLUXSEG5EI8_V_MF4_MF8 }, // 2640
  { Intrinsic::riscv_vluxseg5, 0x8, 0x5, 0x7, PseudoVLUXSEG5EI8_V_MF2_MF8 }, // 2641
  { Intrinsic::riscv_vluxseg5, 0x8, 0x6, 0x0, PseudoVLUXSEG5EI8_V_M1_MF4 }, // 2642
  { Intrinsic::riscv_vluxseg5, 0x8, 0x6, 0x1, PseudoVLUXSEG5EI8_V_M2_MF4 }, // 2643
  { Intrinsic::riscv_vluxseg5, 0x8, 0x6, 0x2, PseudoVLUXSEG5EI8_V_M4_MF4 }, // 2644
  { Intrinsic::riscv_vluxseg5, 0x8, 0x6, 0x3, PseudoVLUXSEG5EI8_V_M8_MF4 }, // 2645
  { Intrinsic::riscv_vluxseg5, 0x8, 0x6, 0x5, PseudoVLUXSEG5EI8_V_MF8_MF4 }, // 2646
  { Intrinsic::riscv_vluxseg5, 0x8, 0x6, 0x6, PseudoVLUXSEG5EI8_V_MF4_MF4 }, // 2647
  { Intrinsic::riscv_vluxseg5, 0x8, 0x6, 0x7, PseudoVLUXSEG5EI8_V_MF2_MF4 }, // 2648
  { Intrinsic::riscv_vluxseg5, 0x8, 0x7, 0x0, PseudoVLUXSEG5EI8_V_M1_MF2 }, // 2649
  { Intrinsic::riscv_vluxseg5, 0x8, 0x7, 0x1, PseudoVLUXSEG5EI8_V_M2_MF2 }, // 2650
  { Intrinsic::riscv_vluxseg5, 0x8, 0x7, 0x2, PseudoVLUXSEG5EI8_V_M4_MF2 }, // 2651
  { Intrinsic::riscv_vluxseg5, 0x8, 0x7, 0x3, PseudoVLUXSEG5EI8_V_M8_MF2 }, // 2652
  { Intrinsic::riscv_vluxseg5, 0x8, 0x7, 0x5, PseudoVLUXSEG5EI8_V_MF8_MF2 }, // 2653
  { Intrinsic::riscv_vluxseg5, 0x8, 0x7, 0x6, PseudoVLUXSEG5EI8_V_MF4_MF2 }, // 2654
  { Intrinsic::riscv_vluxseg5, 0x8, 0x7, 0x7, PseudoVLUXSEG5EI8_V_MF2_MF2 }, // 2655
  { Intrinsic::riscv_vluxseg5, 0x10, 0x0, 0x0, PseudoVLUXSEG5EI16_V_M1_M1 }, // 2656
  { Intrinsic::riscv_vluxseg5, 0x10, 0x0, 0x1, PseudoVLUXSEG5EI16_V_M2_M1 }, // 2657
  { Intrinsic::riscv_vluxseg5, 0x10, 0x0, 0x2, PseudoVLUXSEG5EI16_V_M4_M1 }, // 2658
  { Intrinsic::riscv_vluxseg5, 0x10, 0x0, 0x3, PseudoVLUXSEG5EI16_V_M8_M1 }, // 2659
  { Intrinsic::riscv_vluxseg5, 0x10, 0x0, 0x6, PseudoVLUXSEG5EI16_V_MF4_M1 }, // 2660
  { Intrinsic::riscv_vluxseg5, 0x10, 0x0, 0x7, PseudoVLUXSEG5EI16_V_MF2_M1 }, // 2661
  { Intrinsic::riscv_vluxseg5, 0x10, 0x5, 0x0, PseudoVLUXSEG5EI16_V_M1_MF8 }, // 2662
  { Intrinsic::riscv_vluxseg5, 0x10, 0x5, 0x1, PseudoVLUXSEG5EI16_V_M2_MF8 }, // 2663
  { Intrinsic::riscv_vluxseg5, 0x10, 0x5, 0x2, PseudoVLUXSEG5EI16_V_M4_MF8 }, // 2664
  { Intrinsic::riscv_vluxseg5, 0x10, 0x5, 0x3, PseudoVLUXSEG5EI16_V_M8_MF8 }, // 2665
  { Intrinsic::riscv_vluxseg5, 0x10, 0x5, 0x6, PseudoVLUXSEG5EI16_V_MF4_MF8 }, // 2666
  { Intrinsic::riscv_vluxseg5, 0x10, 0x5, 0x7, PseudoVLUXSEG5EI16_V_MF2_MF8 }, // 2667
  { Intrinsic::riscv_vluxseg5, 0x10, 0x6, 0x0, PseudoVLUXSEG5EI16_V_M1_MF4 }, // 2668
  { Intrinsic::riscv_vluxseg5, 0x10, 0x6, 0x1, PseudoVLUXSEG5EI16_V_M2_MF4 }, // 2669
  { Intrinsic::riscv_vluxseg5, 0x10, 0x6, 0x2, PseudoVLUXSEG5EI16_V_M4_MF4 }, // 2670
  { Intrinsic::riscv_vluxseg5, 0x10, 0x6, 0x3, PseudoVLUXSEG5EI16_V_M8_MF4 }, // 2671
  { Intrinsic::riscv_vluxseg5, 0x10, 0x6, 0x6, PseudoVLUXSEG5EI16_V_MF4_MF4 }, // 2672
  { Intrinsic::riscv_vluxseg5, 0x10, 0x6, 0x7, PseudoVLUXSEG5EI16_V_MF2_MF4 }, // 2673
  { Intrinsic::riscv_vluxseg5, 0x10, 0x7, 0x0, PseudoVLUXSEG5EI16_V_M1_MF2 }, // 2674
  { Intrinsic::riscv_vluxseg5, 0x10, 0x7, 0x1, PseudoVLUXSEG5EI16_V_M2_MF2 }, // 2675
  { Intrinsic::riscv_vluxseg5, 0x10, 0x7, 0x2, PseudoVLUXSEG5EI16_V_M4_MF2 }, // 2676
  { Intrinsic::riscv_vluxseg5, 0x10, 0x7, 0x3, PseudoVLUXSEG5EI16_V_M8_MF2 }, // 2677
  { Intrinsic::riscv_vluxseg5, 0x10, 0x7, 0x6, PseudoVLUXSEG5EI16_V_MF4_MF2 }, // 2678
  { Intrinsic::riscv_vluxseg5, 0x10, 0x7, 0x7, PseudoVLUXSEG5EI16_V_MF2_MF2 }, // 2679
  { Intrinsic::riscv_vluxseg5, 0x20, 0x0, 0x0, PseudoVLUXSEG5EI32_V_M1_M1 }, // 2680
  { Intrinsic::riscv_vluxseg5, 0x20, 0x0, 0x1, PseudoVLUXSEG5EI32_V_M2_M1 }, // 2681
  { Intrinsic::riscv_vluxseg5, 0x20, 0x0, 0x2, PseudoVLUXSEG5EI32_V_M4_M1 }, // 2682
  { Intrinsic::riscv_vluxseg5, 0x20, 0x0, 0x3, PseudoVLUXSEG5EI32_V_M8_M1 }, // 2683
  { Intrinsic::riscv_vluxseg5, 0x20, 0x0, 0x7, PseudoVLUXSEG5EI32_V_MF2_M1 }, // 2684
  { Intrinsic::riscv_vluxseg5, 0x20, 0x5, 0x0, PseudoVLUXSEG5EI32_V_M1_MF8 }, // 2685
  { Intrinsic::riscv_vluxseg5, 0x20, 0x5, 0x1, PseudoVLUXSEG5EI32_V_M2_MF8 }, // 2686
  { Intrinsic::riscv_vluxseg5, 0x20, 0x5, 0x2, PseudoVLUXSEG5EI32_V_M4_MF8 }, // 2687
  { Intrinsic::riscv_vluxseg5, 0x20, 0x5, 0x3, PseudoVLUXSEG5EI32_V_M8_MF8 }, // 2688
  { Intrinsic::riscv_vluxseg5, 0x20, 0x5, 0x7, PseudoVLUXSEG5EI32_V_MF2_MF8 }, // 2689
  { Intrinsic::riscv_vluxseg5, 0x20, 0x6, 0x0, PseudoVLUXSEG5EI32_V_M1_MF4 }, // 2690
  { Intrinsic::riscv_vluxseg5, 0x20, 0x6, 0x1, PseudoVLUXSEG5EI32_V_M2_MF4 }, // 2691
  { Intrinsic::riscv_vluxseg5, 0x20, 0x6, 0x2, PseudoVLUXSEG5EI32_V_M4_MF4 }, // 2692
  { Intrinsic::riscv_vluxseg5, 0x20, 0x6, 0x3, PseudoVLUXSEG5EI32_V_M8_MF4 }, // 2693
  { Intrinsic::riscv_vluxseg5, 0x20, 0x6, 0x7, PseudoVLUXSEG5EI32_V_MF2_MF4 }, // 2694
  { Intrinsic::riscv_vluxseg5, 0x20, 0x7, 0x0, PseudoVLUXSEG5EI32_V_M1_MF2 }, // 2695
  { Intrinsic::riscv_vluxseg5, 0x20, 0x7, 0x1, PseudoVLUXSEG5EI32_V_M2_MF2 }, // 2696
  { Intrinsic::riscv_vluxseg5, 0x20, 0x7, 0x2, PseudoVLUXSEG5EI32_V_M4_MF2 }, // 2697
  { Intrinsic::riscv_vluxseg5, 0x20, 0x7, 0x3, PseudoVLUXSEG5EI32_V_M8_MF2 }, // 2698
  { Intrinsic::riscv_vluxseg5, 0x20, 0x7, 0x7, PseudoVLUXSEG5EI32_V_MF2_MF2 }, // 2699
  { Intrinsic::riscv_vluxseg5, 0x40, 0x0, 0x0, PseudoVLUXSEG5EI64_V_M1_M1 }, // 2700
  { Intrinsic::riscv_vluxseg5, 0x40, 0x0, 0x1, PseudoVLUXSEG5EI64_V_M2_M1 }, // 2701
  { Intrinsic::riscv_vluxseg5, 0x40, 0x0, 0x2, PseudoVLUXSEG5EI64_V_M4_M1 }, // 2702
  { Intrinsic::riscv_vluxseg5, 0x40, 0x0, 0x3, PseudoVLUXSEG5EI64_V_M8_M1 }, // 2703
  { Intrinsic::riscv_vluxseg5, 0x40, 0x5, 0x0, PseudoVLUXSEG5EI64_V_M1_MF8 }, // 2704
  { Intrinsic::riscv_vluxseg5, 0x40, 0x5, 0x1, PseudoVLUXSEG5EI64_V_M2_MF8 }, // 2705
  { Intrinsic::riscv_vluxseg5, 0x40, 0x5, 0x2, PseudoVLUXSEG5EI64_V_M4_MF8 }, // 2706
  { Intrinsic::riscv_vluxseg5, 0x40, 0x5, 0x3, PseudoVLUXSEG5EI64_V_M8_MF8 }, // 2707
  { Intrinsic::riscv_vluxseg5, 0x40, 0x6, 0x0, PseudoVLUXSEG5EI64_V_M1_MF4 }, // 2708
  { Intrinsic::riscv_vluxseg5, 0x40, 0x6, 0x1, PseudoVLUXSEG5EI64_V_M2_MF4 }, // 2709
  { Intrinsic::riscv_vluxseg5, 0x40, 0x6, 0x2, PseudoVLUXSEG5EI64_V_M4_MF4 }, // 2710
  { Intrinsic::riscv_vluxseg5, 0x40, 0x6, 0x3, PseudoVLUXSEG5EI64_V_M8_MF4 }, // 2711
  { Intrinsic::riscv_vluxseg5, 0x40, 0x7, 0x0, PseudoVLUXSEG5EI64_V_M1_MF2 }, // 2712
  { Intrinsic::riscv_vluxseg5, 0x40, 0x7, 0x1, PseudoVLUXSEG5EI64_V_M2_MF2 }, // 2713
  { Intrinsic::riscv_vluxseg5, 0x40, 0x7, 0x2, PseudoVLUXSEG5EI64_V_M4_MF2 }, // 2714
  { Intrinsic::riscv_vluxseg5, 0x40, 0x7, 0x3, PseudoVLUXSEG5EI64_V_M8_MF2 }, // 2715
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x0, 0x0, PseudoVLUXSEG5EI8_V_M1_M1_MASK }, // 2716
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x0, 0x1, PseudoVLUXSEG5EI8_V_M2_M1_MASK }, // 2717
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x0, 0x2, PseudoVLUXSEG5EI8_V_M4_M1_MASK }, // 2718
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x0, 0x3, PseudoVLUXSEG5EI8_V_M8_M1_MASK }, // 2719
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x0, 0x5, PseudoVLUXSEG5EI8_V_MF8_M1_MASK }, // 2720
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x0, 0x6, PseudoVLUXSEG5EI8_V_MF4_M1_MASK }, // 2721
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x0, 0x7, PseudoVLUXSEG5EI8_V_MF2_M1_MASK }, // 2722
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x5, 0x0, PseudoVLUXSEG5EI8_V_M1_MF8_MASK }, // 2723
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x5, 0x1, PseudoVLUXSEG5EI8_V_M2_MF8_MASK }, // 2724
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x5, 0x2, PseudoVLUXSEG5EI8_V_M4_MF8_MASK }, // 2725
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x5, 0x3, PseudoVLUXSEG5EI8_V_M8_MF8_MASK }, // 2726
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x5, 0x5, PseudoVLUXSEG5EI8_V_MF8_MF8_MASK }, // 2727
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x5, 0x6, PseudoVLUXSEG5EI8_V_MF4_MF8_MASK }, // 2728
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x5, 0x7, PseudoVLUXSEG5EI8_V_MF2_MF8_MASK }, // 2729
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x6, 0x0, PseudoVLUXSEG5EI8_V_M1_MF4_MASK }, // 2730
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x6, 0x1, PseudoVLUXSEG5EI8_V_M2_MF4_MASK }, // 2731
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x6, 0x2, PseudoVLUXSEG5EI8_V_M4_MF4_MASK }, // 2732
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x6, 0x3, PseudoVLUXSEG5EI8_V_M8_MF4_MASK }, // 2733
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x6, 0x5, PseudoVLUXSEG5EI8_V_MF8_MF4_MASK }, // 2734
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x6, 0x6, PseudoVLUXSEG5EI8_V_MF4_MF4_MASK }, // 2735
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x6, 0x7, PseudoVLUXSEG5EI8_V_MF2_MF4_MASK }, // 2736
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x7, 0x0, PseudoVLUXSEG5EI8_V_M1_MF2_MASK }, // 2737
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x7, 0x1, PseudoVLUXSEG5EI8_V_M2_MF2_MASK }, // 2738
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x7, 0x2, PseudoVLUXSEG5EI8_V_M4_MF2_MASK }, // 2739
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x7, 0x3, PseudoVLUXSEG5EI8_V_M8_MF2_MASK }, // 2740
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x7, 0x5, PseudoVLUXSEG5EI8_V_MF8_MF2_MASK }, // 2741
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x7, 0x6, PseudoVLUXSEG5EI8_V_MF4_MF2_MASK }, // 2742
  { Intrinsic::riscv_vluxseg5_mask, 0x8, 0x7, 0x7, PseudoVLUXSEG5EI8_V_MF2_MF2_MASK }, // 2743
  { Intrinsic::riscv_vluxseg5_mask, 0x10, 0x0, 0x0, PseudoVLUXSEG5EI16_V_M1_M1_MASK }, // 2744
  { Intrinsic::riscv_vluxseg5_mask, 0x10, 0x0, 0x1, PseudoVLUXSEG5EI16_V_M2_M1_MASK }, // 2745
  { Intrinsic::riscv_vluxseg5_mask, 0x10, 0x0, 0x2, PseudoVLUXSEG5EI16_V_M4_M1_MASK }, // 2746
  { Intrinsic::riscv_vluxseg5_mask, 0x10, 0x0, 0x3, PseudoVLUXSEG5EI16_V_M8_M1_MASK }, // 2747
  { Intrinsic::riscv_vluxseg5_mask, 0x10, 0x0, 0x6, PseudoVLUXSEG5EI16_V_MF4_M1_MASK }, // 2748
  { Intrinsic::riscv_vluxseg5_mask, 0x10, 0x0, 0x7, PseudoVLUXSEG5EI16_V_MF2_M1_MASK }, // 2749
  { Intrinsic::riscv_vluxseg5_mask, 0x10, 0x5, 0x0, PseudoVLUXSEG5EI16_V_M1_MF8_MASK }, // 2750
  { Intrinsic::riscv_vluxseg5_mask, 0x10, 0x5, 0x1, PseudoVLUXSEG5EI16_V_M2_MF8_MASK }, // 2751
  { Intrinsic::riscv_vluxseg5_mask, 0x10, 0x5, 0x2, PseudoVLUXSEG5EI16_V_M4_MF8_MASK }, // 2752
  { Intrinsic::riscv_vluxseg5_mask, 0x10, 0x5, 0x3, PseudoVLUXSEG5EI16_V_M8_MF8_MASK }, // 2753
  { Intrinsic::riscv_vluxseg5_mask, 0x10, 0x5, 0x6, PseudoVLUXSEG5EI16_V_MF4_MF8_MASK }, // 2754
  { Intrinsic::riscv_vluxseg5_mask, 0x10, 0x5, 0x7, PseudoVLUXSEG5EI16_V_MF2_MF8_MASK }, // 2755
  { Intrinsic::riscv_vluxseg5_mask, 0x10, 0x6, 0x0, PseudoVLUXSEG5EI16_V_M1_MF4_MASK }, // 2756
  { Intrinsic::riscv_vluxseg5_mask, 0x10, 0x6, 0x1, PseudoVLUXSEG5EI16_V_M2_MF4_MASK }, // 2757
  { Intrinsic::riscv_vluxseg5_mask, 0x10, 0x6, 0x2, PseudoVLUXSEG5EI16_V_M4_MF4_MASK }, // 2758
  { Intrinsic::riscv_vluxseg5_mask, 0x10, 0x6, 0x3, PseudoVLUXSEG5EI16_V_M8_MF4_MASK }, // 2759
  { Intrinsic::riscv_vluxseg5_mask, 0x10, 0x6, 0x6, PseudoVLUXSEG5EI16_V_MF4_MF4_MASK }, // 2760
  { Intrinsic::riscv_vluxseg5_mask, 0x10, 0x6, 0x7, PseudoVLUXSEG5EI16_V_MF2_MF4_MASK }, // 2761
  { Intrinsic::riscv_vluxseg5_mask, 0x10, 0x7, 0x0, PseudoVLUXSEG5EI16_V_M1_MF2_MASK }, // 2762
  { Intrinsic::riscv_vluxseg5_mask, 0x10, 0x7, 0x1, PseudoVLUXSEG5EI16_V_M2_MF2_MASK }, // 2763
  { Intrinsic::riscv_vluxseg5_mask, 0x10, 0x7, 0x2, PseudoVLUXSEG5EI16_V_M4_MF2_MASK }, // 2764
  { Intrinsic::riscv_vluxseg5_mask, 0x10, 0x7, 0x3, PseudoVLUXSEG5EI16_V_M8_MF2_MASK }, // 2765
  { Intrinsic::riscv_vluxseg5_mask, 0x10, 0x7, 0x6, PseudoVLUXSEG5EI16_V_MF4_MF2_MASK }, // 2766
  { Intrinsic::riscv_vluxseg5_mask, 0x10, 0x7, 0x7, PseudoVLUXSEG5EI16_V_MF2_MF2_MASK }, // 2767
  { Intrinsic::riscv_vluxseg5_mask, 0x20, 0x0, 0x0, PseudoVLUXSEG5EI32_V_M1_M1_MASK }, // 2768
  { Intrinsic::riscv_vluxseg5_mask, 0x20, 0x0, 0x1, PseudoVLUXSEG5EI32_V_M2_M1_MASK }, // 2769
  { Intrinsic::riscv_vluxseg5_mask, 0x20, 0x0, 0x2, PseudoVLUXSEG5EI32_V_M4_M1_MASK }, // 2770
  { Intrinsic::riscv_vluxseg5_mask, 0x20, 0x0, 0x3, PseudoVLUXSEG5EI32_V_M8_M1_MASK }, // 2771
  { Intrinsic::riscv_vluxseg5_mask, 0x20, 0x0, 0x7, PseudoVLUXSEG5EI32_V_MF2_M1_MASK }, // 2772
  { Intrinsic::riscv_vluxseg5_mask, 0x20, 0x5, 0x0, PseudoVLUXSEG5EI32_V_M1_MF8_MASK }, // 2773
  { Intrinsic::riscv_vluxseg5_mask, 0x20, 0x5, 0x1, PseudoVLUXSEG5EI32_V_M2_MF8_MASK }, // 2774
  { Intrinsic::riscv_vluxseg5_mask, 0x20, 0x5, 0x2, PseudoVLUXSEG5EI32_V_M4_MF8_MASK }, // 2775
  { Intrinsic::riscv_vluxseg5_mask, 0x20, 0x5, 0x3, PseudoVLUXSEG5EI32_V_M8_MF8_MASK }, // 2776
  { Intrinsic::riscv_vluxseg5_mask, 0x20, 0x5, 0x7, PseudoVLUXSEG5EI32_V_MF2_MF8_MASK }, // 2777
  { Intrinsic::riscv_vluxseg5_mask, 0x20, 0x6, 0x0, PseudoVLUXSEG5EI32_V_M1_MF4_MASK }, // 2778
  { Intrinsic::riscv_vluxseg5_mask, 0x20, 0x6, 0x1, PseudoVLUXSEG5EI32_V_M2_MF4_MASK }, // 2779
  { Intrinsic::riscv_vluxseg5_mask, 0x20, 0x6, 0x2, PseudoVLUXSEG5EI32_V_M4_MF4_MASK }, // 2780
  { Intrinsic::riscv_vluxseg5_mask, 0x20, 0x6, 0x3, PseudoVLUXSEG5EI32_V_M8_MF4_MASK }, // 2781
  { Intrinsic::riscv_vluxseg5_mask, 0x20, 0x6, 0x7, PseudoVLUXSEG5EI32_V_MF2_MF4_MASK }, // 2782
  { Intrinsic::riscv_vluxseg5_mask, 0x20, 0x7, 0x0, PseudoVLUXSEG5EI32_V_M1_MF2_MASK }, // 2783
  { Intrinsic::riscv_vluxseg5_mask, 0x20, 0x7, 0x1, PseudoVLUXSEG5EI32_V_M2_MF2_MASK }, // 2784
  { Intrinsic::riscv_vluxseg5_mask, 0x20, 0x7, 0x2, PseudoVLUXSEG5EI32_V_M4_MF2_MASK }, // 2785
  { Intrinsic::riscv_vluxseg5_mask, 0x20, 0x7, 0x3, PseudoVLUXSEG5EI32_V_M8_MF2_MASK }, // 2786
  { Intrinsic::riscv_vluxseg5_mask, 0x20, 0x7, 0x7, PseudoVLUXSEG5EI32_V_MF2_MF2_MASK }, // 2787
  { Intrinsic::riscv_vluxseg5_mask, 0x40, 0x0, 0x0, PseudoVLUXSEG5EI64_V_M1_M1_MASK }, // 2788
  { Intrinsic::riscv_vluxseg5_mask, 0x40, 0x0, 0x1, PseudoVLUXSEG5EI64_V_M2_M1_MASK }, // 2789
  { Intrinsic::riscv_vluxseg5_mask, 0x40, 0x0, 0x2, PseudoVLUXSEG5EI64_V_M4_M1_MASK }, // 2790
  { Intrinsic::riscv_vluxseg5_mask, 0x40, 0x0, 0x3, PseudoVLUXSEG5EI64_V_M8_M1_MASK }, // 2791
  { Intrinsic::riscv_vluxseg5_mask, 0x40, 0x5, 0x0, PseudoVLUXSEG5EI64_V_M1_MF8_MASK }, // 2792
  { Intrinsic::riscv_vluxseg5_mask, 0x40, 0x5, 0x1, PseudoVLUXSEG5EI64_V_M2_MF8_MASK }, // 2793
  { Intrinsic::riscv_vluxseg5_mask, 0x40, 0x5, 0x2, PseudoVLUXSEG5EI64_V_M4_MF8_MASK }, // 2794
  { Intrinsic::riscv_vluxseg5_mask, 0x40, 0x5, 0x3, PseudoVLUXSEG5EI64_V_M8_MF8_MASK }, // 2795
  { Intrinsic::riscv_vluxseg5_mask, 0x40, 0x6, 0x0, PseudoVLUXSEG5EI64_V_M1_MF4_MASK }, // 2796
  { Intrinsic::riscv_vluxseg5_mask, 0x40, 0x6, 0x1, PseudoVLUXSEG5EI64_V_M2_MF4_MASK }, // 2797
  { Intrinsic::riscv_vluxseg5_mask, 0x40, 0x6, 0x2, PseudoVLUXSEG5EI64_V_M4_MF4_MASK }, // 2798
  { Intrinsic::riscv_vluxseg5_mask, 0x40, 0x6, 0x3, PseudoVLUXSEG5EI64_V_M8_MF4_MASK }, // 2799
  { Intrinsic::riscv_vluxseg5_mask, 0x40, 0x7, 0x0, PseudoVLUXSEG5EI64_V_M1_MF2_MASK }, // 2800
  { Intrinsic::riscv_vluxseg5_mask, 0x40, 0x7, 0x1, PseudoVLUXSEG5EI64_V_M2_MF2_MASK }, // 2801
  { Intrinsic::riscv_vluxseg5_mask, 0x40, 0x7, 0x2, PseudoVLUXSEG5EI64_V_M4_MF2_MASK }, // 2802
  { Intrinsic::riscv_vluxseg5_mask, 0x40, 0x7, 0x3, PseudoVLUXSEG5EI64_V_M8_MF2_MASK }, // 2803
  { Intrinsic::riscv_vluxseg6, 0x8, 0x0, 0x0, PseudoVLUXSEG6EI8_V_M1_M1 }, // 2804
  { Intrinsic::riscv_vluxseg6, 0x8, 0x0, 0x1, PseudoVLUXSEG6EI8_V_M2_M1 }, // 2805
  { Intrinsic::riscv_vluxseg6, 0x8, 0x0, 0x2, PseudoVLUXSEG6EI8_V_M4_M1 }, // 2806
  { Intrinsic::riscv_vluxseg6, 0x8, 0x0, 0x3, PseudoVLUXSEG6EI8_V_M8_M1 }, // 2807
  { Intrinsic::riscv_vluxseg6, 0x8, 0x0, 0x5, PseudoVLUXSEG6EI8_V_MF8_M1 }, // 2808
  { Intrinsic::riscv_vluxseg6, 0x8, 0x0, 0x6, PseudoVLUXSEG6EI8_V_MF4_M1 }, // 2809
  { Intrinsic::riscv_vluxseg6, 0x8, 0x0, 0x7, PseudoVLUXSEG6EI8_V_MF2_M1 }, // 2810
  { Intrinsic::riscv_vluxseg6, 0x8, 0x5, 0x0, PseudoVLUXSEG6EI8_V_M1_MF8 }, // 2811
  { Intrinsic::riscv_vluxseg6, 0x8, 0x5, 0x1, PseudoVLUXSEG6EI8_V_M2_MF8 }, // 2812
  { Intrinsic::riscv_vluxseg6, 0x8, 0x5, 0x2, PseudoVLUXSEG6EI8_V_M4_MF8 }, // 2813
  { Intrinsic::riscv_vluxseg6, 0x8, 0x5, 0x3, PseudoVLUXSEG6EI8_V_M8_MF8 }, // 2814
  { Intrinsic::riscv_vluxseg6, 0x8, 0x5, 0x5, PseudoVLUXSEG6EI8_V_MF8_MF8 }, // 2815
  { Intrinsic::riscv_vluxseg6, 0x8, 0x5, 0x6, PseudoVLUXSEG6EI8_V_MF4_MF8 }, // 2816
  { Intrinsic::riscv_vluxseg6, 0x8, 0x5, 0x7, PseudoVLUXSEG6EI8_V_MF2_MF8 }, // 2817
  { Intrinsic::riscv_vluxseg6, 0x8, 0x6, 0x0, PseudoVLUXSEG6EI8_V_M1_MF4 }, // 2818
  { Intrinsic::riscv_vluxseg6, 0x8, 0x6, 0x1, PseudoVLUXSEG6EI8_V_M2_MF4 }, // 2819
  { Intrinsic::riscv_vluxseg6, 0x8, 0x6, 0x2, PseudoVLUXSEG6EI8_V_M4_MF4 }, // 2820
  { Intrinsic::riscv_vluxseg6, 0x8, 0x6, 0x3, PseudoVLUXSEG6EI8_V_M8_MF4 }, // 2821
  { Intrinsic::riscv_vluxseg6, 0x8, 0x6, 0x5, PseudoVLUXSEG6EI8_V_MF8_MF4 }, // 2822
  { Intrinsic::riscv_vluxseg6, 0x8, 0x6, 0x6, PseudoVLUXSEG6EI8_V_MF4_MF4 }, // 2823
  { Intrinsic::riscv_vluxseg6, 0x8, 0x6, 0x7, PseudoVLUXSEG6EI8_V_MF2_MF4 }, // 2824
  { Intrinsic::riscv_vluxseg6, 0x8, 0x7, 0x0, PseudoVLUXSEG6EI8_V_M1_MF2 }, // 2825
  { Intrinsic::riscv_vluxseg6, 0x8, 0x7, 0x1, PseudoVLUXSEG6EI8_V_M2_MF2 }, // 2826
  { Intrinsic::riscv_vluxseg6, 0x8, 0x7, 0x2, PseudoVLUXSEG6EI8_V_M4_MF2 }, // 2827
  { Intrinsic::riscv_vluxseg6, 0x8, 0x7, 0x3, PseudoVLUXSEG6EI8_V_M8_MF2 }, // 2828
  { Intrinsic::riscv_vluxseg6, 0x8, 0x7, 0x5, PseudoVLUXSEG6EI8_V_MF8_MF2 }, // 2829
  { Intrinsic::riscv_vluxseg6, 0x8, 0x7, 0x6, PseudoVLUXSEG6EI8_V_MF4_MF2 }, // 2830
  { Intrinsic::riscv_vluxseg6, 0x8, 0x7, 0x7, PseudoVLUXSEG6EI8_V_MF2_MF2 }, // 2831
  { Intrinsic::riscv_vluxseg6, 0x10, 0x0, 0x0, PseudoVLUXSEG6EI16_V_M1_M1 }, // 2832
  { Intrinsic::riscv_vluxseg6, 0x10, 0x0, 0x1, PseudoVLUXSEG6EI16_V_M2_M1 }, // 2833
  { Intrinsic::riscv_vluxseg6, 0x10, 0x0, 0x2, PseudoVLUXSEG6EI16_V_M4_M1 }, // 2834
  { Intrinsic::riscv_vluxseg6, 0x10, 0x0, 0x3, PseudoVLUXSEG6EI16_V_M8_M1 }, // 2835
  { Intrinsic::riscv_vluxseg6, 0x10, 0x0, 0x6, PseudoVLUXSEG6EI16_V_MF4_M1 }, // 2836
  { Intrinsic::riscv_vluxseg6, 0x10, 0x0, 0x7, PseudoVLUXSEG6EI16_V_MF2_M1 }, // 2837
  { Intrinsic::riscv_vluxseg6, 0x10, 0x5, 0x0, PseudoVLUXSEG6EI16_V_M1_MF8 }, // 2838
  { Intrinsic::riscv_vluxseg6, 0x10, 0x5, 0x1, PseudoVLUXSEG6EI16_V_M2_MF8 }, // 2839
  { Intrinsic::riscv_vluxseg6, 0x10, 0x5, 0x2, PseudoVLUXSEG6EI16_V_M4_MF8 }, // 2840
  { Intrinsic::riscv_vluxseg6, 0x10, 0x5, 0x3, PseudoVLUXSEG6EI16_V_M8_MF8 }, // 2841
  { Intrinsic::riscv_vluxseg6, 0x10, 0x5, 0x6, PseudoVLUXSEG6EI16_V_MF4_MF8 }, // 2842
  { Intrinsic::riscv_vluxseg6, 0x10, 0x5, 0x7, PseudoVLUXSEG6EI16_V_MF2_MF8 }, // 2843
  { Intrinsic::riscv_vluxseg6, 0x10, 0x6, 0x0, PseudoVLUXSEG6EI16_V_M1_MF4 }, // 2844
  { Intrinsic::riscv_vluxseg6, 0x10, 0x6, 0x1, PseudoVLUXSEG6EI16_V_M2_MF4 }, // 2845
  { Intrinsic::riscv_vluxseg6, 0x10, 0x6, 0x2, PseudoVLUXSEG6EI16_V_M4_MF4 }, // 2846
  { Intrinsic::riscv_vluxseg6, 0x10, 0x6, 0x3, PseudoVLUXSEG6EI16_V_M8_MF4 }, // 2847
  { Intrinsic::riscv_vluxseg6, 0x10, 0x6, 0x6, PseudoVLUXSEG6EI16_V_MF4_MF4 }, // 2848
  { Intrinsic::riscv_vluxseg6, 0x10, 0x6, 0x7, PseudoVLUXSEG6EI16_V_MF2_MF4 }, // 2849
  { Intrinsic::riscv_vluxseg6, 0x10, 0x7, 0x0, PseudoVLUXSEG6EI16_V_M1_MF2 }, // 2850
  { Intrinsic::riscv_vluxseg6, 0x10, 0x7, 0x1, PseudoVLUXSEG6EI16_V_M2_MF2 }, // 2851
  { Intrinsic::riscv_vluxseg6, 0x10, 0x7, 0x2, PseudoVLUXSEG6EI16_V_M4_MF2 }, // 2852
  { Intrinsic::riscv_vluxseg6, 0x10, 0x7, 0x3, PseudoVLUXSEG6EI16_V_M8_MF2 }, // 2853
  { Intrinsic::riscv_vluxseg6, 0x10, 0x7, 0x6, PseudoVLUXSEG6EI16_V_MF4_MF2 }, // 2854
  { Intrinsic::riscv_vluxseg6, 0x10, 0x7, 0x7, PseudoVLUXSEG6EI16_V_MF2_MF2 }, // 2855
  { Intrinsic::riscv_vluxseg6, 0x20, 0x0, 0x0, PseudoVLUXSEG6EI32_V_M1_M1 }, // 2856
  { Intrinsic::riscv_vluxseg6, 0x20, 0x0, 0x1, PseudoVLUXSEG6EI32_V_M2_M1 }, // 2857
  { Intrinsic::riscv_vluxseg6, 0x20, 0x0, 0x2, PseudoVLUXSEG6EI32_V_M4_M1 }, // 2858
  { Intrinsic::riscv_vluxseg6, 0x20, 0x0, 0x3, PseudoVLUXSEG6EI32_V_M8_M1 }, // 2859
  { Intrinsic::riscv_vluxseg6, 0x20, 0x0, 0x7, PseudoVLUXSEG6EI32_V_MF2_M1 }, // 2860
  { Intrinsic::riscv_vluxseg6, 0x20, 0x5, 0x0, PseudoVLUXSEG6EI32_V_M1_MF8 }, // 2861
  { Intrinsic::riscv_vluxseg6, 0x20, 0x5, 0x1, PseudoVLUXSEG6EI32_V_M2_MF8 }, // 2862
  { Intrinsic::riscv_vluxseg6, 0x20, 0x5, 0x2, PseudoVLUXSEG6EI32_V_M4_MF8 }, // 2863
  { Intrinsic::riscv_vluxseg6, 0x20, 0x5, 0x3, PseudoVLUXSEG6EI32_V_M8_MF8 }, // 2864
  { Intrinsic::riscv_vluxseg6, 0x20, 0x5, 0x7, PseudoVLUXSEG6EI32_V_MF2_MF8 }, // 2865
  { Intrinsic::riscv_vluxseg6, 0x20, 0x6, 0x0, PseudoVLUXSEG6EI32_V_M1_MF4 }, // 2866
  { Intrinsic::riscv_vluxseg6, 0x20, 0x6, 0x1, PseudoVLUXSEG6EI32_V_M2_MF4 }, // 2867
  { Intrinsic::riscv_vluxseg6, 0x20, 0x6, 0x2, PseudoVLUXSEG6EI32_V_M4_MF4 }, // 2868
  { Intrinsic::riscv_vluxseg6, 0x20, 0x6, 0x3, PseudoVLUXSEG6EI32_V_M8_MF4 }, // 2869
  { Intrinsic::riscv_vluxseg6, 0x20, 0x6, 0x7, PseudoVLUXSEG6EI32_V_MF2_MF4 }, // 2870
  { Intrinsic::riscv_vluxseg6, 0x20, 0x7, 0x0, PseudoVLUXSEG6EI32_V_M1_MF2 }, // 2871
  { Intrinsic::riscv_vluxseg6, 0x20, 0x7, 0x1, PseudoVLUXSEG6EI32_V_M2_MF2 }, // 2872
  { Intrinsic::riscv_vluxseg6, 0x20, 0x7, 0x2, PseudoVLUXSEG6EI32_V_M4_MF2 }, // 2873
  { Intrinsic::riscv_vluxseg6, 0x20, 0x7, 0x3, PseudoVLUXSEG6EI32_V_M8_MF2 }, // 2874
  { Intrinsic::riscv_vluxseg6, 0x20, 0x7, 0x7, PseudoVLUXSEG6EI32_V_MF2_MF2 }, // 2875
  { Intrinsic::riscv_vluxseg6, 0x40, 0x0, 0x0, PseudoVLUXSEG6EI64_V_M1_M1 }, // 2876
  { Intrinsic::riscv_vluxseg6, 0x40, 0x0, 0x1, PseudoVLUXSEG6EI64_V_M2_M1 }, // 2877
  { Intrinsic::riscv_vluxseg6, 0x40, 0x0, 0x2, PseudoVLUXSEG6EI64_V_M4_M1 }, // 2878
  { Intrinsic::riscv_vluxseg6, 0x40, 0x0, 0x3, PseudoVLUXSEG6EI64_V_M8_M1 }, // 2879
  { Intrinsic::riscv_vluxseg6, 0x40, 0x5, 0x0, PseudoVLUXSEG6EI64_V_M1_MF8 }, // 2880
  { Intrinsic::riscv_vluxseg6, 0x40, 0x5, 0x1, PseudoVLUXSEG6EI64_V_M2_MF8 }, // 2881
  { Intrinsic::riscv_vluxseg6, 0x40, 0x5, 0x2, PseudoVLUXSEG6EI64_V_M4_MF8 }, // 2882
  { Intrinsic::riscv_vluxseg6, 0x40, 0x5, 0x3, PseudoVLUXSEG6EI64_V_M8_MF8 }, // 2883
  { Intrinsic::riscv_vluxseg6, 0x40, 0x6, 0x0, PseudoVLUXSEG6EI64_V_M1_MF4 }, // 2884
  { Intrinsic::riscv_vluxseg6, 0x40, 0x6, 0x1, PseudoVLUXSEG6EI64_V_M2_MF4 }, // 2885
  { Intrinsic::riscv_vluxseg6, 0x40, 0x6, 0x2, PseudoVLUXSEG6EI64_V_M4_MF4 }, // 2886
  { Intrinsic::riscv_vluxseg6, 0x40, 0x6, 0x3, PseudoVLUXSEG6EI64_V_M8_MF4 }, // 2887
  { Intrinsic::riscv_vluxseg6, 0x40, 0x7, 0x0, PseudoVLUXSEG6EI64_V_M1_MF2 }, // 2888
  { Intrinsic::riscv_vluxseg6, 0x40, 0x7, 0x1, PseudoVLUXSEG6EI64_V_M2_MF2 }, // 2889
  { Intrinsic::riscv_vluxseg6, 0x40, 0x7, 0x2, PseudoVLUXSEG6EI64_V_M4_MF2 }, // 2890
  { Intrinsic::riscv_vluxseg6, 0x40, 0x7, 0x3, PseudoVLUXSEG6EI64_V_M8_MF2 }, // 2891
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x0, 0x0, PseudoVLUXSEG6EI8_V_M1_M1_MASK }, // 2892
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x0, 0x1, PseudoVLUXSEG6EI8_V_M2_M1_MASK }, // 2893
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x0, 0x2, PseudoVLUXSEG6EI8_V_M4_M1_MASK }, // 2894
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x0, 0x3, PseudoVLUXSEG6EI8_V_M8_M1_MASK }, // 2895
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x0, 0x5, PseudoVLUXSEG6EI8_V_MF8_M1_MASK }, // 2896
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x0, 0x6, PseudoVLUXSEG6EI8_V_MF4_M1_MASK }, // 2897
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x0, 0x7, PseudoVLUXSEG6EI8_V_MF2_M1_MASK }, // 2898
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x5, 0x0, PseudoVLUXSEG6EI8_V_M1_MF8_MASK }, // 2899
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x5, 0x1, PseudoVLUXSEG6EI8_V_M2_MF8_MASK }, // 2900
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x5, 0x2, PseudoVLUXSEG6EI8_V_M4_MF8_MASK }, // 2901
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x5, 0x3, PseudoVLUXSEG6EI8_V_M8_MF8_MASK }, // 2902
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x5, 0x5, PseudoVLUXSEG6EI8_V_MF8_MF8_MASK }, // 2903
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x5, 0x6, PseudoVLUXSEG6EI8_V_MF4_MF8_MASK }, // 2904
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x5, 0x7, PseudoVLUXSEG6EI8_V_MF2_MF8_MASK }, // 2905
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x6, 0x0, PseudoVLUXSEG6EI8_V_M1_MF4_MASK }, // 2906
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x6, 0x1, PseudoVLUXSEG6EI8_V_M2_MF4_MASK }, // 2907
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x6, 0x2, PseudoVLUXSEG6EI8_V_M4_MF4_MASK }, // 2908
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x6, 0x3, PseudoVLUXSEG6EI8_V_M8_MF4_MASK }, // 2909
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x6, 0x5, PseudoVLUXSEG6EI8_V_MF8_MF4_MASK }, // 2910
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x6, 0x6, PseudoVLUXSEG6EI8_V_MF4_MF4_MASK }, // 2911
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x6, 0x7, PseudoVLUXSEG6EI8_V_MF2_MF4_MASK }, // 2912
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x7, 0x0, PseudoVLUXSEG6EI8_V_M1_MF2_MASK }, // 2913
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x7, 0x1, PseudoVLUXSEG6EI8_V_M2_MF2_MASK }, // 2914
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x7, 0x2, PseudoVLUXSEG6EI8_V_M4_MF2_MASK }, // 2915
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x7, 0x3, PseudoVLUXSEG6EI8_V_M8_MF2_MASK }, // 2916
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x7, 0x5, PseudoVLUXSEG6EI8_V_MF8_MF2_MASK }, // 2917
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x7, 0x6, PseudoVLUXSEG6EI8_V_MF4_MF2_MASK }, // 2918
  { Intrinsic::riscv_vluxseg6_mask, 0x8, 0x7, 0x7, PseudoVLUXSEG6EI8_V_MF2_MF2_MASK }, // 2919
  { Intrinsic::riscv_vluxseg6_mask, 0x10, 0x0, 0x0, PseudoVLUXSEG6EI16_V_M1_M1_MASK }, // 2920
  { Intrinsic::riscv_vluxseg6_mask, 0x10, 0x0, 0x1, PseudoVLUXSEG6EI16_V_M2_M1_MASK }, // 2921
  { Intrinsic::riscv_vluxseg6_mask, 0x10, 0x0, 0x2, PseudoVLUXSEG6EI16_V_M4_M1_MASK }, // 2922
  { Intrinsic::riscv_vluxseg6_mask, 0x10, 0x0, 0x3, PseudoVLUXSEG6EI16_V_M8_M1_MASK }, // 2923
  { Intrinsic::riscv_vluxseg6_mask, 0x10, 0x0, 0x6, PseudoVLUXSEG6EI16_V_MF4_M1_MASK }, // 2924
  { Intrinsic::riscv_vluxseg6_mask, 0x10, 0x0, 0x7, PseudoVLUXSEG6EI16_V_MF2_M1_MASK }, // 2925
  { Intrinsic::riscv_vluxseg6_mask, 0x10, 0x5, 0x0, PseudoVLUXSEG6EI16_V_M1_MF8_MASK }, // 2926
  { Intrinsic::riscv_vluxseg6_mask, 0x10, 0x5, 0x1, PseudoVLUXSEG6EI16_V_M2_MF8_MASK }, // 2927
  { Intrinsic::riscv_vluxseg6_mask, 0x10, 0x5, 0x2, PseudoVLUXSEG6EI16_V_M4_MF8_MASK }, // 2928
  { Intrinsic::riscv_vluxseg6_mask, 0x10, 0x5, 0x3, PseudoVLUXSEG6EI16_V_M8_MF8_MASK }, // 2929
  { Intrinsic::riscv_vluxseg6_mask, 0x10, 0x5, 0x6, PseudoVLUXSEG6EI16_V_MF4_MF8_MASK }, // 2930
  { Intrinsic::riscv_vluxseg6_mask, 0x10, 0x5, 0x7, PseudoVLUXSEG6EI16_V_MF2_MF8_MASK }, // 2931
  { Intrinsic::riscv_vluxseg6_mask, 0x10, 0x6, 0x0, PseudoVLUXSEG6EI16_V_M1_MF4_MASK }, // 2932
  { Intrinsic::riscv_vluxseg6_mask, 0x10, 0x6, 0x1, PseudoVLUXSEG6EI16_V_M2_MF4_MASK }, // 2933
  { Intrinsic::riscv_vluxseg6_mask, 0x10, 0x6, 0x2, PseudoVLUXSEG6EI16_V_M4_MF4_MASK }, // 2934
  { Intrinsic::riscv_vluxseg6_mask, 0x10, 0x6, 0x3, PseudoVLUXSEG6EI16_V_M8_MF4_MASK }, // 2935
  { Intrinsic::riscv_vluxseg6_mask, 0x10, 0x6, 0x6, PseudoVLUXSEG6EI16_V_MF4_MF4_MASK }, // 2936
  { Intrinsic::riscv_vluxseg6_mask, 0x10, 0x6, 0x7, PseudoVLUXSEG6EI16_V_MF2_MF4_MASK }, // 2937
  { Intrinsic::riscv_vluxseg6_mask, 0x10, 0x7, 0x0, PseudoVLUXSEG6EI16_V_M1_MF2_MASK }, // 2938
  { Intrinsic::riscv_vluxseg6_mask, 0x10, 0x7, 0x1, PseudoVLUXSEG6EI16_V_M2_MF2_MASK }, // 2939
  { Intrinsic::riscv_vluxseg6_mask, 0x10, 0x7, 0x2, PseudoVLUXSEG6EI16_V_M4_MF2_MASK }, // 2940
  { Intrinsic::riscv_vluxseg6_mask, 0x10, 0x7, 0x3, PseudoVLUXSEG6EI16_V_M8_MF2_MASK }, // 2941
  { Intrinsic::riscv_vluxseg6_mask, 0x10, 0x7, 0x6, PseudoVLUXSEG6EI16_V_MF4_MF2_MASK }, // 2942
  { Intrinsic::riscv_vluxseg6_mask, 0x10, 0x7, 0x7, PseudoVLUXSEG6EI16_V_MF2_MF2_MASK }, // 2943
  { Intrinsic::riscv_vluxseg6_mask, 0x20, 0x0, 0x0, PseudoVLUXSEG6EI32_V_M1_M1_MASK }, // 2944
  { Intrinsic::riscv_vluxseg6_mask, 0x20, 0x0, 0x1, PseudoVLUXSEG6EI32_V_M2_M1_MASK }, // 2945
  { Intrinsic::riscv_vluxseg6_mask, 0x20, 0x0, 0x2, PseudoVLUXSEG6EI32_V_M4_M1_MASK }, // 2946
  { Intrinsic::riscv_vluxseg6_mask, 0x20, 0x0, 0x3, PseudoVLUXSEG6EI32_V_M8_M1_MASK }, // 2947
  { Intrinsic::riscv_vluxseg6_mask, 0x20, 0x0, 0x7, PseudoVLUXSEG6EI32_V_MF2_M1_MASK }, // 2948
  { Intrinsic::riscv_vluxseg6_mask, 0x20, 0x5, 0x0, PseudoVLUXSEG6EI32_V_M1_MF8_MASK }, // 2949
  { Intrinsic::riscv_vluxseg6_mask, 0x20, 0x5, 0x1, PseudoVLUXSEG6EI32_V_M2_MF8_MASK }, // 2950
  { Intrinsic::riscv_vluxseg6_mask, 0x20, 0x5, 0x2, PseudoVLUXSEG6EI32_V_M4_MF8_MASK }, // 2951
  { Intrinsic::riscv_vluxseg6_mask, 0x20, 0x5, 0x3, PseudoVLUXSEG6EI32_V_M8_MF8_MASK }, // 2952
  { Intrinsic::riscv_vluxseg6_mask, 0x20, 0x5, 0x7, PseudoVLUXSEG6EI32_V_MF2_MF8_MASK }, // 2953
  { Intrinsic::riscv_vluxseg6_mask, 0x20, 0x6, 0x0, PseudoVLUXSEG6EI32_V_M1_MF4_MASK }, // 2954
  { Intrinsic::riscv_vluxseg6_mask, 0x20, 0x6, 0x1, PseudoVLUXSEG6EI32_V_M2_MF4_MASK }, // 2955
  { Intrinsic::riscv_vluxseg6_mask, 0x20, 0x6, 0x2, PseudoVLUXSEG6EI32_V_M4_MF4_MASK }, // 2956
  { Intrinsic::riscv_vluxseg6_mask, 0x20, 0x6, 0x3, PseudoVLUXSEG6EI32_V_M8_MF4_MASK }, // 2957
  { Intrinsic::riscv_vluxseg6_mask, 0x20, 0x6, 0x7, PseudoVLUXSEG6EI32_V_MF2_MF4_MASK }, // 2958
  { Intrinsic::riscv_vluxseg6_mask, 0x20, 0x7, 0x0, PseudoVLUXSEG6EI32_V_M1_MF2_MASK }, // 2959
  { Intrinsic::riscv_vluxseg6_mask, 0x20, 0x7, 0x1, PseudoVLUXSEG6EI32_V_M2_MF2_MASK }, // 2960
  { Intrinsic::riscv_vluxseg6_mask, 0x20, 0x7, 0x2, PseudoVLUXSEG6EI32_V_M4_MF2_MASK }, // 2961
  { Intrinsic::riscv_vluxseg6_mask, 0x20, 0x7, 0x3, PseudoVLUXSEG6EI32_V_M8_MF2_MASK }, // 2962
  { Intrinsic::riscv_vluxseg6_mask, 0x20, 0x7, 0x7, PseudoVLUXSEG6EI32_V_MF2_MF2_MASK }, // 2963
  { Intrinsic::riscv_vluxseg6_mask, 0x40, 0x0, 0x0, PseudoVLUXSEG6EI64_V_M1_M1_MASK }, // 2964
  { Intrinsic::riscv_vluxseg6_mask, 0x40, 0x0, 0x1, PseudoVLUXSEG6EI64_V_M2_M1_MASK }, // 2965
  { Intrinsic::riscv_vluxseg6_mask, 0x40, 0x0, 0x2, PseudoVLUXSEG6EI64_V_M4_M1_MASK }, // 2966
  { Intrinsic::riscv_vluxseg6_mask, 0x40, 0x0, 0x3, PseudoVLUXSEG6EI64_V_M8_M1_MASK }, // 2967
  { Intrinsic::riscv_vluxseg6_mask, 0x40, 0x5, 0x0, PseudoVLUXSEG6EI64_V_M1_MF8_MASK }, // 2968
  { Intrinsic::riscv_vluxseg6_mask, 0x40, 0x5, 0x1, PseudoVLUXSEG6EI64_V_M2_MF8_MASK }, // 2969
  { Intrinsic::riscv_vluxseg6_mask, 0x40, 0x5, 0x2, PseudoVLUXSEG6EI64_V_M4_MF8_MASK }, // 2970
  { Intrinsic::riscv_vluxseg6_mask, 0x40, 0x5, 0x3, PseudoVLUXSEG6EI64_V_M8_MF8_MASK }, // 2971
  { Intrinsic::riscv_vluxseg6_mask, 0x40, 0x6, 0x0, PseudoVLUXSEG6EI64_V_M1_MF4_MASK }, // 2972
  { Intrinsic::riscv_vluxseg6_mask, 0x40, 0x6, 0x1, PseudoVLUXSEG6EI64_V_M2_MF4_MASK }, // 2973
  { Intrinsic::riscv_vluxseg6_mask, 0x40, 0x6, 0x2, PseudoVLUXSEG6EI64_V_M4_MF4_MASK }, // 2974
  { Intrinsic::riscv_vluxseg6_mask, 0x40, 0x6, 0x3, PseudoVLUXSEG6EI64_V_M8_MF4_MASK }, // 2975
  { Intrinsic::riscv_vluxseg6_mask, 0x40, 0x7, 0x0, PseudoVLUXSEG6EI64_V_M1_MF2_MASK }, // 2976
  { Intrinsic::riscv_vluxseg6_mask, 0x40, 0x7, 0x1, PseudoVLUXSEG6EI64_V_M2_MF2_MASK }, // 2977
  { Intrinsic::riscv_vluxseg6_mask, 0x40, 0x7, 0x2, PseudoVLUXSEG6EI64_V_M4_MF2_MASK }, // 2978
  { Intrinsic::riscv_vluxseg6_mask, 0x40, 0x7, 0x3, PseudoVLUXSEG6EI64_V_M8_MF2_MASK }, // 2979
  { Intrinsic::riscv_vluxseg7, 0x8, 0x0, 0x0, PseudoVLUXSEG7EI8_V_M1_M1 }, // 2980
  { Intrinsic::riscv_vluxseg7, 0x8, 0x0, 0x1, PseudoVLUXSEG7EI8_V_M2_M1 }, // 2981
  { Intrinsic::riscv_vluxseg7, 0x8, 0x0, 0x2, PseudoVLUXSEG7EI8_V_M4_M1 }, // 2982
  { Intrinsic::riscv_vluxseg7, 0x8, 0x0, 0x3, PseudoVLUXSEG7EI8_V_M8_M1 }, // 2983
  { Intrinsic::riscv_vluxseg7, 0x8, 0x0, 0x5, PseudoVLUXSEG7EI8_V_MF8_M1 }, // 2984
  { Intrinsic::riscv_vluxseg7, 0x8, 0x0, 0x6, PseudoVLUXSEG7EI8_V_MF4_M1 }, // 2985
  { Intrinsic::riscv_vluxseg7, 0x8, 0x0, 0x7, PseudoVLUXSEG7EI8_V_MF2_M1 }, // 2986
  { Intrinsic::riscv_vluxseg7, 0x8, 0x5, 0x0, PseudoVLUXSEG7EI8_V_M1_MF8 }, // 2987
  { Intrinsic::riscv_vluxseg7, 0x8, 0x5, 0x1, PseudoVLUXSEG7EI8_V_M2_MF8 }, // 2988
  { Intrinsic::riscv_vluxseg7, 0x8, 0x5, 0x2, PseudoVLUXSEG7EI8_V_M4_MF8 }, // 2989
  { Intrinsic::riscv_vluxseg7, 0x8, 0x5, 0x3, PseudoVLUXSEG7EI8_V_M8_MF8 }, // 2990
  { Intrinsic::riscv_vluxseg7, 0x8, 0x5, 0x5, PseudoVLUXSEG7EI8_V_MF8_MF8 }, // 2991
  { Intrinsic::riscv_vluxseg7, 0x8, 0x5, 0x6, PseudoVLUXSEG7EI8_V_MF4_MF8 }, // 2992
  { Intrinsic::riscv_vluxseg7, 0x8, 0x5, 0x7, PseudoVLUXSEG7EI8_V_MF2_MF8 }, // 2993
  { Intrinsic::riscv_vluxseg7, 0x8, 0x6, 0x0, PseudoVLUXSEG7EI8_V_M1_MF4 }, // 2994
  { Intrinsic::riscv_vluxseg7, 0x8, 0x6, 0x1, PseudoVLUXSEG7EI8_V_M2_MF4 }, // 2995
  { Intrinsic::riscv_vluxseg7, 0x8, 0x6, 0x2, PseudoVLUXSEG7EI8_V_M4_MF4 }, // 2996
  { Intrinsic::riscv_vluxseg7, 0x8, 0x6, 0x3, PseudoVLUXSEG7EI8_V_M8_MF4 }, // 2997
  { Intrinsic::riscv_vluxseg7, 0x8, 0x6, 0x5, PseudoVLUXSEG7EI8_V_MF8_MF4 }, // 2998
  { Intrinsic::riscv_vluxseg7, 0x8, 0x6, 0x6, PseudoVLUXSEG7EI8_V_MF4_MF4 }, // 2999
  { Intrinsic::riscv_vluxseg7, 0x8, 0x6, 0x7, PseudoVLUXSEG7EI8_V_MF2_MF4 }, // 3000
  { Intrinsic::riscv_vluxseg7, 0x8, 0x7, 0x0, PseudoVLUXSEG7EI8_V_M1_MF2 }, // 3001
  { Intrinsic::riscv_vluxseg7, 0x8, 0x7, 0x1, PseudoVLUXSEG7EI8_V_M2_MF2 }, // 3002
  { Intrinsic::riscv_vluxseg7, 0x8, 0x7, 0x2, PseudoVLUXSEG7EI8_V_M4_MF2 }, // 3003
  { Intrinsic::riscv_vluxseg7, 0x8, 0x7, 0x3, PseudoVLUXSEG7EI8_V_M8_MF2 }, // 3004
  { Intrinsic::riscv_vluxseg7, 0x8, 0x7, 0x5, PseudoVLUXSEG7EI8_V_MF8_MF2 }, // 3005
  { Intrinsic::riscv_vluxseg7, 0x8, 0x7, 0x6, PseudoVLUXSEG7EI8_V_MF4_MF2 }, // 3006
  { Intrinsic::riscv_vluxseg7, 0x8, 0x7, 0x7, PseudoVLUXSEG7EI8_V_MF2_MF2 }, // 3007
  { Intrinsic::riscv_vluxseg7, 0x10, 0x0, 0x0, PseudoVLUXSEG7EI16_V_M1_M1 }, // 3008
  { Intrinsic::riscv_vluxseg7, 0x10, 0x0, 0x1, PseudoVLUXSEG7EI16_V_M2_M1 }, // 3009
  { Intrinsic::riscv_vluxseg7, 0x10, 0x0, 0x2, PseudoVLUXSEG7EI16_V_M4_M1 }, // 3010
  { Intrinsic::riscv_vluxseg7, 0x10, 0x0, 0x3, PseudoVLUXSEG7EI16_V_M8_M1 }, // 3011
  { Intrinsic::riscv_vluxseg7, 0x10, 0x0, 0x6, PseudoVLUXSEG7EI16_V_MF4_M1 }, // 3012
  { Intrinsic::riscv_vluxseg7, 0x10, 0x0, 0x7, PseudoVLUXSEG7EI16_V_MF2_M1 }, // 3013
  { Intrinsic::riscv_vluxseg7, 0x10, 0x5, 0x0, PseudoVLUXSEG7EI16_V_M1_MF8 }, // 3014
  { Intrinsic::riscv_vluxseg7, 0x10, 0x5, 0x1, PseudoVLUXSEG7EI16_V_M2_MF8 }, // 3015
  { Intrinsic::riscv_vluxseg7, 0x10, 0x5, 0x2, PseudoVLUXSEG7EI16_V_M4_MF8 }, // 3016
  { Intrinsic::riscv_vluxseg7, 0x10, 0x5, 0x3, PseudoVLUXSEG7EI16_V_M8_MF8 }, // 3017
  { Intrinsic::riscv_vluxseg7, 0x10, 0x5, 0x6, PseudoVLUXSEG7EI16_V_MF4_MF8 }, // 3018
  { Intrinsic::riscv_vluxseg7, 0x10, 0x5, 0x7, PseudoVLUXSEG7EI16_V_MF2_MF8 }, // 3019
  { Intrinsic::riscv_vluxseg7, 0x10, 0x6, 0x0, PseudoVLUXSEG7EI16_V_M1_MF4 }, // 3020
  { Intrinsic::riscv_vluxseg7, 0x10, 0x6, 0x1, PseudoVLUXSEG7EI16_V_M2_MF4 }, // 3021
  { Intrinsic::riscv_vluxseg7, 0x10, 0x6, 0x2, PseudoVLUXSEG7EI16_V_M4_MF4 }, // 3022
  { Intrinsic::riscv_vluxseg7, 0x10, 0x6, 0x3, PseudoVLUXSEG7EI16_V_M8_MF4 }, // 3023
  { Intrinsic::riscv_vluxseg7, 0x10, 0x6, 0x6, PseudoVLUXSEG7EI16_V_MF4_MF4 }, // 3024
  { Intrinsic::riscv_vluxseg7, 0x10, 0x6, 0x7, PseudoVLUXSEG7EI16_V_MF2_MF4 }, // 3025
  { Intrinsic::riscv_vluxseg7, 0x10, 0x7, 0x0, PseudoVLUXSEG7EI16_V_M1_MF2 }, // 3026
  { Intrinsic::riscv_vluxseg7, 0x10, 0x7, 0x1, PseudoVLUXSEG7EI16_V_M2_MF2 }, // 3027
  { Intrinsic::riscv_vluxseg7, 0x10, 0x7, 0x2, PseudoVLUXSEG7EI16_V_M4_MF2 }, // 3028
  { Intrinsic::riscv_vluxseg7, 0x10, 0x7, 0x3, PseudoVLUXSEG7EI16_V_M8_MF2 }, // 3029
  { Intrinsic::riscv_vluxseg7, 0x10, 0x7, 0x6, PseudoVLUXSEG7EI16_V_MF4_MF2 }, // 3030
  { Intrinsic::riscv_vluxseg7, 0x10, 0x7, 0x7, PseudoVLUXSEG7EI16_V_MF2_MF2 }, // 3031
  { Intrinsic::riscv_vluxseg7, 0x20, 0x0, 0x0, PseudoVLUXSEG7EI32_V_M1_M1 }, // 3032
  { Intrinsic::riscv_vluxseg7, 0x20, 0x0, 0x1, PseudoVLUXSEG7EI32_V_M2_M1 }, // 3033
  { Intrinsic::riscv_vluxseg7, 0x20, 0x0, 0x2, PseudoVLUXSEG7EI32_V_M4_M1 }, // 3034
  { Intrinsic::riscv_vluxseg7, 0x20, 0x0, 0x3, PseudoVLUXSEG7EI32_V_M8_M1 }, // 3035
  { Intrinsic::riscv_vluxseg7, 0x20, 0x0, 0x7, PseudoVLUXSEG7EI32_V_MF2_M1 }, // 3036
  { Intrinsic::riscv_vluxseg7, 0x20, 0x5, 0x0, PseudoVLUXSEG7EI32_V_M1_MF8 }, // 3037
  { Intrinsic::riscv_vluxseg7, 0x20, 0x5, 0x1, PseudoVLUXSEG7EI32_V_M2_MF8 }, // 3038
  { Intrinsic::riscv_vluxseg7, 0x20, 0x5, 0x2, PseudoVLUXSEG7EI32_V_M4_MF8 }, // 3039
  { Intrinsic::riscv_vluxseg7, 0x20, 0x5, 0x3, PseudoVLUXSEG7EI32_V_M8_MF8 }, // 3040
  { Intrinsic::riscv_vluxseg7, 0x20, 0x5, 0x7, PseudoVLUXSEG7EI32_V_MF2_MF8 }, // 3041
  { Intrinsic::riscv_vluxseg7, 0x20, 0x6, 0x0, PseudoVLUXSEG7EI32_V_M1_MF4 }, // 3042
  { Intrinsic::riscv_vluxseg7, 0x20, 0x6, 0x1, PseudoVLUXSEG7EI32_V_M2_MF4 }, // 3043
  { Intrinsic::riscv_vluxseg7, 0x20, 0x6, 0x2, PseudoVLUXSEG7EI32_V_M4_MF4 }, // 3044
  { Intrinsic::riscv_vluxseg7, 0x20, 0x6, 0x3, PseudoVLUXSEG7EI32_V_M8_MF4 }, // 3045
  { Intrinsic::riscv_vluxseg7, 0x20, 0x6, 0x7, PseudoVLUXSEG7EI32_V_MF2_MF4 }, // 3046
  { Intrinsic::riscv_vluxseg7, 0x20, 0x7, 0x0, PseudoVLUXSEG7EI32_V_M1_MF2 }, // 3047
  { Intrinsic::riscv_vluxseg7, 0x20, 0x7, 0x1, PseudoVLUXSEG7EI32_V_M2_MF2 }, // 3048
  { Intrinsic::riscv_vluxseg7, 0x20, 0x7, 0x2, PseudoVLUXSEG7EI32_V_M4_MF2 }, // 3049
  { Intrinsic::riscv_vluxseg7, 0x20, 0x7, 0x3, PseudoVLUXSEG7EI32_V_M8_MF2 }, // 3050
  { Intrinsic::riscv_vluxseg7, 0x20, 0x7, 0x7, PseudoVLUXSEG7EI32_V_MF2_MF2 }, // 3051
  { Intrinsic::riscv_vluxseg7, 0x40, 0x0, 0x0, PseudoVLUXSEG7EI64_V_M1_M1 }, // 3052
  { Intrinsic::riscv_vluxseg7, 0x40, 0x0, 0x1, PseudoVLUXSEG7EI64_V_M2_M1 }, // 3053
  { Intrinsic::riscv_vluxseg7, 0x40, 0x0, 0x2, PseudoVLUXSEG7EI64_V_M4_M1 }, // 3054
  { Intrinsic::riscv_vluxseg7, 0x40, 0x0, 0x3, PseudoVLUXSEG7EI64_V_M8_M1 }, // 3055
  { Intrinsic::riscv_vluxseg7, 0x40, 0x5, 0x0, PseudoVLUXSEG7EI64_V_M1_MF8 }, // 3056
  { Intrinsic::riscv_vluxseg7, 0x40, 0x5, 0x1, PseudoVLUXSEG7EI64_V_M2_MF8 }, // 3057
  { Intrinsic::riscv_vluxseg7, 0x40, 0x5, 0x2, PseudoVLUXSEG7EI64_V_M4_MF8 }, // 3058
  { Intrinsic::riscv_vluxseg7, 0x40, 0x5, 0x3, PseudoVLUXSEG7EI64_V_M8_MF8 }, // 3059
  { Intrinsic::riscv_vluxseg7, 0x40, 0x6, 0x0, PseudoVLUXSEG7EI64_V_M1_MF4 }, // 3060
  { Intrinsic::riscv_vluxseg7, 0x40, 0x6, 0x1, PseudoVLUXSEG7EI64_V_M2_MF4 }, // 3061
  { Intrinsic::riscv_vluxseg7, 0x40, 0x6, 0x2, PseudoVLUXSEG7EI64_V_M4_MF4 }, // 3062
  { Intrinsic::riscv_vluxseg7, 0x40, 0x6, 0x3, PseudoVLUXSEG7EI64_V_M8_MF4 }, // 3063
  { Intrinsic::riscv_vluxseg7, 0x40, 0x7, 0x0, PseudoVLUXSEG7EI64_V_M1_MF2 }, // 3064
  { Intrinsic::riscv_vluxseg7, 0x40, 0x7, 0x1, PseudoVLUXSEG7EI64_V_M2_MF2 }, // 3065
  { Intrinsic::riscv_vluxseg7, 0x40, 0x7, 0x2, PseudoVLUXSEG7EI64_V_M4_MF2 }, // 3066
  { Intrinsic::riscv_vluxseg7, 0x40, 0x7, 0x3, PseudoVLUXSEG7EI64_V_M8_MF2 }, // 3067
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x0, 0x0, PseudoVLUXSEG7EI8_V_M1_M1_MASK }, // 3068
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x0, 0x1, PseudoVLUXSEG7EI8_V_M2_M1_MASK }, // 3069
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x0, 0x2, PseudoVLUXSEG7EI8_V_M4_M1_MASK }, // 3070
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x0, 0x3, PseudoVLUXSEG7EI8_V_M8_M1_MASK }, // 3071
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x0, 0x5, PseudoVLUXSEG7EI8_V_MF8_M1_MASK }, // 3072
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x0, 0x6, PseudoVLUXSEG7EI8_V_MF4_M1_MASK }, // 3073
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x0, 0x7, PseudoVLUXSEG7EI8_V_MF2_M1_MASK }, // 3074
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x5, 0x0, PseudoVLUXSEG7EI8_V_M1_MF8_MASK }, // 3075
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x5, 0x1, PseudoVLUXSEG7EI8_V_M2_MF8_MASK }, // 3076
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x5, 0x2, PseudoVLUXSEG7EI8_V_M4_MF8_MASK }, // 3077
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x5, 0x3, PseudoVLUXSEG7EI8_V_M8_MF8_MASK }, // 3078
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x5, 0x5, PseudoVLUXSEG7EI8_V_MF8_MF8_MASK }, // 3079
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x5, 0x6, PseudoVLUXSEG7EI8_V_MF4_MF8_MASK }, // 3080
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x5, 0x7, PseudoVLUXSEG7EI8_V_MF2_MF8_MASK }, // 3081
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x6, 0x0, PseudoVLUXSEG7EI8_V_M1_MF4_MASK }, // 3082
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x6, 0x1, PseudoVLUXSEG7EI8_V_M2_MF4_MASK }, // 3083
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x6, 0x2, PseudoVLUXSEG7EI8_V_M4_MF4_MASK }, // 3084
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x6, 0x3, PseudoVLUXSEG7EI8_V_M8_MF4_MASK }, // 3085
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x6, 0x5, PseudoVLUXSEG7EI8_V_MF8_MF4_MASK }, // 3086
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x6, 0x6, PseudoVLUXSEG7EI8_V_MF4_MF4_MASK }, // 3087
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x6, 0x7, PseudoVLUXSEG7EI8_V_MF2_MF4_MASK }, // 3088
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x7, 0x0, PseudoVLUXSEG7EI8_V_M1_MF2_MASK }, // 3089
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x7, 0x1, PseudoVLUXSEG7EI8_V_M2_MF2_MASK }, // 3090
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x7, 0x2, PseudoVLUXSEG7EI8_V_M4_MF2_MASK }, // 3091
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x7, 0x3, PseudoVLUXSEG7EI8_V_M8_MF2_MASK }, // 3092
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x7, 0x5, PseudoVLUXSEG7EI8_V_MF8_MF2_MASK }, // 3093
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x7, 0x6, PseudoVLUXSEG7EI8_V_MF4_MF2_MASK }, // 3094
  { Intrinsic::riscv_vluxseg7_mask, 0x8, 0x7, 0x7, PseudoVLUXSEG7EI8_V_MF2_MF2_MASK }, // 3095
  { Intrinsic::riscv_vluxseg7_mask, 0x10, 0x0, 0x0, PseudoVLUXSEG7EI16_V_M1_M1_MASK }, // 3096
  { Intrinsic::riscv_vluxseg7_mask, 0x10, 0x0, 0x1, PseudoVLUXSEG7EI16_V_M2_M1_MASK }, // 3097
  { Intrinsic::riscv_vluxseg7_mask, 0x10, 0x0, 0x2, PseudoVLUXSEG7EI16_V_M4_M1_MASK }, // 3098
  { Intrinsic::riscv_vluxseg7_mask, 0x10, 0x0, 0x3, PseudoVLUXSEG7EI16_V_M8_M1_MASK }, // 3099
  { Intrinsic::riscv_vluxseg7_mask, 0x10, 0x0, 0x6, PseudoVLUXSEG7EI16_V_MF4_M1_MASK }, // 3100
  { Intrinsic::riscv_vluxseg7_mask, 0x10, 0x0, 0x7, PseudoVLUXSEG7EI16_V_MF2_M1_MASK }, // 3101
  { Intrinsic::riscv_vluxseg7_mask, 0x10, 0x5, 0x0, PseudoVLUXSEG7EI16_V_M1_MF8_MASK }, // 3102
  { Intrinsic::riscv_vluxseg7_mask, 0x10, 0x5, 0x1, PseudoVLUXSEG7EI16_V_M2_MF8_MASK }, // 3103
  { Intrinsic::riscv_vluxseg7_mask, 0x10, 0x5, 0x2, PseudoVLUXSEG7EI16_V_M4_MF8_MASK }, // 3104
  { Intrinsic::riscv_vluxseg7_mask, 0x10, 0x5, 0x3, PseudoVLUXSEG7EI16_V_M8_MF8_MASK }, // 3105
  { Intrinsic::riscv_vluxseg7_mask, 0x10, 0x5, 0x6, PseudoVLUXSEG7EI16_V_MF4_MF8_MASK }, // 3106
  { Intrinsic::riscv_vluxseg7_mask, 0x10, 0x5, 0x7, PseudoVLUXSEG7EI16_V_MF2_MF8_MASK }, // 3107
  { Intrinsic::riscv_vluxseg7_mask, 0x10, 0x6, 0x0, PseudoVLUXSEG7EI16_V_M1_MF4_MASK }, // 3108
  { Intrinsic::riscv_vluxseg7_mask, 0x10, 0x6, 0x1, PseudoVLUXSEG7EI16_V_M2_MF4_MASK }, // 3109
  { Intrinsic::riscv_vluxseg7_mask, 0x10, 0x6, 0x2, PseudoVLUXSEG7EI16_V_M4_MF4_MASK }, // 3110
  { Intrinsic::riscv_vluxseg7_mask, 0x10, 0x6, 0x3, PseudoVLUXSEG7EI16_V_M8_MF4_MASK }, // 3111
  { Intrinsic::riscv_vluxseg7_mask, 0x10, 0x6, 0x6, PseudoVLUXSEG7EI16_V_MF4_MF4_MASK }, // 3112
  { Intrinsic::riscv_vluxseg7_mask, 0x10, 0x6, 0x7, PseudoVLUXSEG7EI16_V_MF2_MF4_MASK }, // 3113
  { Intrinsic::riscv_vluxseg7_mask, 0x10, 0x7, 0x0, PseudoVLUXSEG7EI16_V_M1_MF2_MASK }, // 3114
  { Intrinsic::riscv_vluxseg7_mask, 0x10, 0x7, 0x1, PseudoVLUXSEG7EI16_V_M2_MF2_MASK }, // 3115
  { Intrinsic::riscv_vluxseg7_mask, 0x10, 0x7, 0x2, PseudoVLUXSEG7EI16_V_M4_MF2_MASK }, // 3116
  { Intrinsic::riscv_vluxseg7_mask, 0x10, 0x7, 0x3, PseudoVLUXSEG7EI16_V_M8_MF2_MASK }, // 3117
  { Intrinsic::riscv_vluxseg7_mask, 0x10, 0x7, 0x6, PseudoVLUXSEG7EI16_V_MF4_MF2_MASK }, // 3118
  { Intrinsic::riscv_vluxseg7_mask, 0x10, 0x7, 0x7, PseudoVLUXSEG7EI16_V_MF2_MF2_MASK }, // 3119
  { Intrinsic::riscv_vluxseg7_mask, 0x20, 0x0, 0x0, PseudoVLUXSEG7EI32_V_M1_M1_MASK }, // 3120
  { Intrinsic::riscv_vluxseg7_mask, 0x20, 0x0, 0x1, PseudoVLUXSEG7EI32_V_M2_M1_MASK }, // 3121
  { Intrinsic::riscv_vluxseg7_mask, 0x20, 0x0, 0x2, PseudoVLUXSEG7EI32_V_M4_M1_MASK }, // 3122
  { Intrinsic::riscv_vluxseg7_mask, 0x20, 0x0, 0x3, PseudoVLUXSEG7EI32_V_M8_M1_MASK }, // 3123
  { Intrinsic::riscv_vluxseg7_mask, 0x20, 0x0, 0x7, PseudoVLUXSEG7EI32_V_MF2_M1_MASK }, // 3124
  { Intrinsic::riscv_vluxseg7_mask, 0x20, 0x5, 0x0, PseudoVLUXSEG7EI32_V_M1_MF8_MASK }, // 3125
  { Intrinsic::riscv_vluxseg7_mask, 0x20, 0x5, 0x1, PseudoVLUXSEG7EI32_V_M2_MF8_MASK }, // 3126
  { Intrinsic::riscv_vluxseg7_mask, 0x20, 0x5, 0x2, PseudoVLUXSEG7EI32_V_M4_MF8_MASK }, // 3127
  { Intrinsic::riscv_vluxseg7_mask, 0x20, 0x5, 0x3, PseudoVLUXSEG7EI32_V_M8_MF8_MASK }, // 3128
  { Intrinsic::riscv_vluxseg7_mask, 0x20, 0x5, 0x7, PseudoVLUXSEG7EI32_V_MF2_MF8_MASK }, // 3129
  { Intrinsic::riscv_vluxseg7_mask, 0x20, 0x6, 0x0, PseudoVLUXSEG7EI32_V_M1_MF4_MASK }, // 3130
  { Intrinsic::riscv_vluxseg7_mask, 0x20, 0x6, 0x1, PseudoVLUXSEG7EI32_V_M2_MF4_MASK }, // 3131
  { Intrinsic::riscv_vluxseg7_mask, 0x20, 0x6, 0x2, PseudoVLUXSEG7EI32_V_M4_MF4_MASK }, // 3132
  { Intrinsic::riscv_vluxseg7_mask, 0x20, 0x6, 0x3, PseudoVLUXSEG7EI32_V_M8_MF4_MASK }, // 3133
  { Intrinsic::riscv_vluxseg7_mask, 0x20, 0x6, 0x7, PseudoVLUXSEG7EI32_V_MF2_MF4_MASK }, // 3134
  { Intrinsic::riscv_vluxseg7_mask, 0x20, 0x7, 0x0, PseudoVLUXSEG7EI32_V_M1_MF2_MASK }, // 3135
  { Intrinsic::riscv_vluxseg7_mask, 0x20, 0x7, 0x1, PseudoVLUXSEG7EI32_V_M2_MF2_MASK }, // 3136
  { Intrinsic::riscv_vluxseg7_mask, 0x20, 0x7, 0x2, PseudoVLUXSEG7EI32_V_M4_MF2_MASK }, // 3137
  { Intrinsic::riscv_vluxseg7_mask, 0x20, 0x7, 0x3, PseudoVLUXSEG7EI32_V_M8_MF2_MASK }, // 3138
  { Intrinsic::riscv_vluxseg7_mask, 0x20, 0x7, 0x7, PseudoVLUXSEG7EI32_V_MF2_MF2_MASK }, // 3139
  { Intrinsic::riscv_vluxseg7_mask, 0x40, 0x0, 0x0, PseudoVLUXSEG7EI64_V_M1_M1_MASK }, // 3140
  { Intrinsic::riscv_vluxseg7_mask, 0x40, 0x0, 0x1, PseudoVLUXSEG7EI64_V_M2_M1_MASK }, // 3141
  { Intrinsic::riscv_vluxseg7_mask, 0x40, 0x0, 0x2, PseudoVLUXSEG7EI64_V_M4_M1_MASK }, // 3142
  { Intrinsic::riscv_vluxseg7_mask, 0x40, 0x0, 0x3, PseudoVLUXSEG7EI64_V_M8_M1_MASK }, // 3143
  { Intrinsic::riscv_vluxseg7_mask, 0x40, 0x5, 0x0, PseudoVLUXSEG7EI64_V_M1_MF8_MASK }, // 3144
  { Intrinsic::riscv_vluxseg7_mask, 0x40, 0x5, 0x1, PseudoVLUXSEG7EI64_V_M2_MF8_MASK }, // 3145
  { Intrinsic::riscv_vluxseg7_mask, 0x40, 0x5, 0x2, PseudoVLUXSEG7EI64_V_M4_MF8_MASK }, // 3146
  { Intrinsic::riscv_vluxseg7_mask, 0x40, 0x5, 0x3, PseudoVLUXSEG7EI64_V_M8_MF8_MASK }, // 3147
  { Intrinsic::riscv_vluxseg7_mask, 0x40, 0x6, 0x0, PseudoVLUXSEG7EI64_V_M1_MF4_MASK }, // 3148
  { Intrinsic::riscv_vluxseg7_mask, 0x40, 0x6, 0x1, PseudoVLUXSEG7EI64_V_M2_MF4_MASK }, // 3149
  { Intrinsic::riscv_vluxseg7_mask, 0x40, 0x6, 0x2, PseudoVLUXSEG7EI64_V_M4_MF4_MASK }, // 3150
  { Intrinsic::riscv_vluxseg7_mask, 0x40, 0x6, 0x3, PseudoVLUXSEG7EI64_V_M8_MF4_MASK }, // 3151
  { Intrinsic::riscv_vluxseg7_mask, 0x40, 0x7, 0x0, PseudoVLUXSEG7EI64_V_M1_MF2_MASK }, // 3152
  { Intrinsic::riscv_vluxseg7_mask, 0x40, 0x7, 0x1, PseudoVLUXSEG7EI64_V_M2_MF2_MASK }, // 3153
  { Intrinsic::riscv_vluxseg7_mask, 0x40, 0x7, 0x2, PseudoVLUXSEG7EI64_V_M4_MF2_MASK }, // 3154
  { Intrinsic::riscv_vluxseg7_mask, 0x40, 0x7, 0x3, PseudoVLUXSEG7EI64_V_M8_MF2_MASK }, // 3155
  { Intrinsic::riscv_vluxseg8, 0x8, 0x0, 0x0, PseudoVLUXSEG8EI8_V_M1_M1 }, // 3156
  { Intrinsic::riscv_vluxseg8, 0x8, 0x0, 0x1, PseudoVLUXSEG8EI8_V_M2_M1 }, // 3157
  { Intrinsic::riscv_vluxseg8, 0x8, 0x0, 0x2, PseudoVLUXSEG8EI8_V_M4_M1 }, // 3158
  { Intrinsic::riscv_vluxseg8, 0x8, 0x0, 0x3, PseudoVLUXSEG8EI8_V_M8_M1 }, // 3159
  { Intrinsic::riscv_vluxseg8, 0x8, 0x0, 0x5, PseudoVLUXSEG8EI8_V_MF8_M1 }, // 3160
  { Intrinsic::riscv_vluxseg8, 0x8, 0x0, 0x6, PseudoVLUXSEG8EI8_V_MF4_M1 }, // 3161
  { Intrinsic::riscv_vluxseg8, 0x8, 0x0, 0x7, PseudoVLUXSEG8EI8_V_MF2_M1 }, // 3162
  { Intrinsic::riscv_vluxseg8, 0x8, 0x5, 0x0, PseudoVLUXSEG8EI8_V_M1_MF8 }, // 3163
  { Intrinsic::riscv_vluxseg8, 0x8, 0x5, 0x1, PseudoVLUXSEG8EI8_V_M2_MF8 }, // 3164
  { Intrinsic::riscv_vluxseg8, 0x8, 0x5, 0x2, PseudoVLUXSEG8EI8_V_M4_MF8 }, // 3165
  { Intrinsic::riscv_vluxseg8, 0x8, 0x5, 0x3, PseudoVLUXSEG8EI8_V_M8_MF8 }, // 3166
  { Intrinsic::riscv_vluxseg8, 0x8, 0x5, 0x5, PseudoVLUXSEG8EI8_V_MF8_MF8 }, // 3167
  { Intrinsic::riscv_vluxseg8, 0x8, 0x5, 0x6, PseudoVLUXSEG8EI8_V_MF4_MF8 }, // 3168
  { Intrinsic::riscv_vluxseg8, 0x8, 0x5, 0x7, PseudoVLUXSEG8EI8_V_MF2_MF8 }, // 3169
  { Intrinsic::riscv_vluxseg8, 0x8, 0x6, 0x0, PseudoVLUXSEG8EI8_V_M1_MF4 }, // 3170
  { Intrinsic::riscv_vluxseg8, 0x8, 0x6, 0x1, PseudoVLUXSEG8EI8_V_M2_MF4 }, // 3171
  { Intrinsic::riscv_vluxseg8, 0x8, 0x6, 0x2, PseudoVLUXSEG8EI8_V_M4_MF4 }, // 3172
  { Intrinsic::riscv_vluxseg8, 0x8, 0x6, 0x3, PseudoVLUXSEG8EI8_V_M8_MF4 }, // 3173
  { Intrinsic::riscv_vluxseg8, 0x8, 0x6, 0x5, PseudoVLUXSEG8EI8_V_MF8_MF4 }, // 3174
  { Intrinsic::riscv_vluxseg8, 0x8, 0x6, 0x6, PseudoVLUXSEG8EI8_V_MF4_MF4 }, // 3175
  { Intrinsic::riscv_vluxseg8, 0x8, 0x6, 0x7, PseudoVLUXSEG8EI8_V_MF2_MF4 }, // 3176
  { Intrinsic::riscv_vluxseg8, 0x8, 0x7, 0x0, PseudoVLUXSEG8EI8_V_M1_MF2 }, // 3177
  { Intrinsic::riscv_vluxseg8, 0x8, 0x7, 0x1, PseudoVLUXSEG8EI8_V_M2_MF2 }, // 3178
  { Intrinsic::riscv_vluxseg8, 0x8, 0x7, 0x2, PseudoVLUXSEG8EI8_V_M4_MF2 }, // 3179
  { Intrinsic::riscv_vluxseg8, 0x8, 0x7, 0x3, PseudoVLUXSEG8EI8_V_M8_MF2 }, // 3180
  { Intrinsic::riscv_vluxseg8, 0x8, 0x7, 0x5, PseudoVLUXSEG8EI8_V_MF8_MF2 }, // 3181
  { Intrinsic::riscv_vluxseg8, 0x8, 0x7, 0x6, PseudoVLUXSEG8EI8_V_MF4_MF2 }, // 3182
  { Intrinsic::riscv_vluxseg8, 0x8, 0x7, 0x7, PseudoVLUXSEG8EI8_V_MF2_MF2 }, // 3183
  { Intrinsic::riscv_vluxseg8, 0x10, 0x0, 0x0, PseudoVLUXSEG8EI16_V_M1_M1 }, // 3184
  { Intrinsic::riscv_vluxseg8, 0x10, 0x0, 0x1, PseudoVLUXSEG8EI16_V_M2_M1 }, // 3185
  { Intrinsic::riscv_vluxseg8, 0x10, 0x0, 0x2, PseudoVLUXSEG8EI16_V_M4_M1 }, // 3186
  { Intrinsic::riscv_vluxseg8, 0x10, 0x0, 0x3, PseudoVLUXSEG8EI16_V_M8_M1 }, // 3187
  { Intrinsic::riscv_vluxseg8, 0x10, 0x0, 0x6, PseudoVLUXSEG8EI16_V_MF4_M1 }, // 3188
  { Intrinsic::riscv_vluxseg8, 0x10, 0x0, 0x7, PseudoVLUXSEG8EI16_V_MF2_M1 }, // 3189
  { Intrinsic::riscv_vluxseg8, 0x10, 0x5, 0x0, PseudoVLUXSEG8EI16_V_M1_MF8 }, // 3190
  { Intrinsic::riscv_vluxseg8, 0x10, 0x5, 0x1, PseudoVLUXSEG8EI16_V_M2_MF8 }, // 3191
  { Intrinsic::riscv_vluxseg8, 0x10, 0x5, 0x2, PseudoVLUXSEG8EI16_V_M4_MF8 }, // 3192
  { Intrinsic::riscv_vluxseg8, 0x10, 0x5, 0x3, PseudoVLUXSEG8EI16_V_M8_MF8 }, // 3193
  { Intrinsic::riscv_vluxseg8, 0x10, 0x5, 0x6, PseudoVLUXSEG8EI16_V_MF4_MF8 }, // 3194
  { Intrinsic::riscv_vluxseg8, 0x10, 0x5, 0x7, PseudoVLUXSEG8EI16_V_MF2_MF8 }, // 3195
  { Intrinsic::riscv_vluxseg8, 0x10, 0x6, 0x0, PseudoVLUXSEG8EI16_V_M1_MF4 }, // 3196
  { Intrinsic::riscv_vluxseg8, 0x10, 0x6, 0x1, PseudoVLUXSEG8EI16_V_M2_MF4 }, // 3197
  { Intrinsic::riscv_vluxseg8, 0x10, 0x6, 0x2, PseudoVLUXSEG8EI16_V_M4_MF4 }, // 3198
  { Intrinsic::riscv_vluxseg8, 0x10, 0x6, 0x3, PseudoVLUXSEG8EI16_V_M8_MF4 }, // 3199
  { Intrinsic::riscv_vluxseg8, 0x10, 0x6, 0x6, PseudoVLUXSEG8EI16_V_MF4_MF4 }, // 3200
  { Intrinsic::riscv_vluxseg8, 0x10, 0x6, 0x7, PseudoVLUXSEG8EI16_V_MF2_MF4 }, // 3201
  { Intrinsic::riscv_vluxseg8, 0x10, 0x7, 0x0, PseudoVLUXSEG8EI16_V_M1_MF2 }, // 3202
  { Intrinsic::riscv_vluxseg8, 0x10, 0x7, 0x1, PseudoVLUXSEG8EI16_V_M2_MF2 }, // 3203
  { Intrinsic::riscv_vluxseg8, 0x10, 0x7, 0x2, PseudoVLUXSEG8EI16_V_M4_MF2 }, // 3204
  { Intrinsic::riscv_vluxseg8, 0x10, 0x7, 0x3, PseudoVLUXSEG8EI16_V_M8_MF2 }, // 3205
  { Intrinsic::riscv_vluxseg8, 0x10, 0x7, 0x6, PseudoVLUXSEG8EI16_V_MF4_MF2 }, // 3206
  { Intrinsic::riscv_vluxseg8, 0x10, 0x7, 0x7, PseudoVLUXSEG8EI16_V_MF2_MF2 }, // 3207
  { Intrinsic::riscv_vluxseg8, 0x20, 0x0, 0x0, PseudoVLUXSEG8EI32_V_M1_M1 }, // 3208
  { Intrinsic::riscv_vluxseg8, 0x20, 0x0, 0x1, PseudoVLUXSEG8EI32_V_M2_M1 }, // 3209
  { Intrinsic::riscv_vluxseg8, 0x20, 0x0, 0x2, PseudoVLUXSEG8EI32_V_M4_M1 }, // 3210
  { Intrinsic::riscv_vluxseg8, 0x20, 0x0, 0x3, PseudoVLUXSEG8EI32_V_M8_M1 }, // 3211
  { Intrinsic::riscv_vluxseg8, 0x20, 0x0, 0x7, PseudoVLUXSEG8EI32_V_MF2_M1 }, // 3212
  { Intrinsic::riscv_vluxseg8, 0x20, 0x5, 0x0, PseudoVLUXSEG8EI32_V_M1_MF8 }, // 3213
  { Intrinsic::riscv_vluxseg8, 0x20, 0x5, 0x1, PseudoVLUXSEG8EI32_V_M2_MF8 }, // 3214
  { Intrinsic::riscv_vluxseg8, 0x20, 0x5, 0x2, PseudoVLUXSEG8EI32_V_M4_MF8 }, // 3215
  { Intrinsic::riscv_vluxseg8, 0x20, 0x5, 0x3, PseudoVLUXSEG8EI32_V_M8_MF8 }, // 3216
  { Intrinsic::riscv_vluxseg8, 0x20, 0x5, 0x7, PseudoVLUXSEG8EI32_V_MF2_MF8 }, // 3217
  { Intrinsic::riscv_vluxseg8, 0x20, 0x6, 0x0, PseudoVLUXSEG8EI32_V_M1_MF4 }, // 3218
  { Intrinsic::riscv_vluxseg8, 0x20, 0x6, 0x1, PseudoVLUXSEG8EI32_V_M2_MF4 }, // 3219
  { Intrinsic::riscv_vluxseg8, 0x20, 0x6, 0x2, PseudoVLUXSEG8EI32_V_M4_MF4 }, // 3220
  { Intrinsic::riscv_vluxseg8, 0x20, 0x6, 0x3, PseudoVLUXSEG8EI32_V_M8_MF4 }, // 3221
  { Intrinsic::riscv_vluxseg8, 0x20, 0x6, 0x7, PseudoVLUXSEG8EI32_V_MF2_MF4 }, // 3222
  { Intrinsic::riscv_vluxseg8, 0x20, 0x7, 0x0, PseudoVLUXSEG8EI32_V_M1_MF2 }, // 3223
  { Intrinsic::riscv_vluxseg8, 0x20, 0x7, 0x1, PseudoVLUXSEG8EI32_V_M2_MF2 }, // 3224
  { Intrinsic::riscv_vluxseg8, 0x20, 0x7, 0x2, PseudoVLUXSEG8EI32_V_M4_MF2 }, // 3225
  { Intrinsic::riscv_vluxseg8, 0x20, 0x7, 0x3, PseudoVLUXSEG8EI32_V_M8_MF2 }, // 3226
  { Intrinsic::riscv_vluxseg8, 0x20, 0x7, 0x7, PseudoVLUXSEG8EI32_V_MF2_MF2 }, // 3227
  { Intrinsic::riscv_vluxseg8, 0x40, 0x0, 0x0, PseudoVLUXSEG8EI64_V_M1_M1 }, // 3228
  { Intrinsic::riscv_vluxseg8, 0x40, 0x0, 0x1, PseudoVLUXSEG8EI64_V_M2_M1 }, // 3229
  { Intrinsic::riscv_vluxseg8, 0x40, 0x0, 0x2, PseudoVLUXSEG8EI64_V_M4_M1 }, // 3230
  { Intrinsic::riscv_vluxseg8, 0x40, 0x0, 0x3, PseudoVLUXSEG8EI64_V_M8_M1 }, // 3231
  { Intrinsic::riscv_vluxseg8, 0x40, 0x5, 0x0, PseudoVLUXSEG8EI64_V_M1_MF8 }, // 3232
  { Intrinsic::riscv_vluxseg8, 0x40, 0x5, 0x1, PseudoVLUXSEG8EI64_V_M2_MF8 }, // 3233
  { Intrinsic::riscv_vluxseg8, 0x40, 0x5, 0x2, PseudoVLUXSEG8EI64_V_M4_MF8 }, // 3234
  { Intrinsic::riscv_vluxseg8, 0x40, 0x5, 0x3, PseudoVLUXSEG8EI64_V_M8_MF8 }, // 3235
  { Intrinsic::riscv_vluxseg8, 0x40, 0x6, 0x0, PseudoVLUXSEG8EI64_V_M1_MF4 }, // 3236
  { Intrinsic::riscv_vluxseg8, 0x40, 0x6, 0x1, PseudoVLUXSEG8EI64_V_M2_MF4 }, // 3237
  { Intrinsic::riscv_vluxseg8, 0x40, 0x6, 0x2, PseudoVLUXSEG8EI64_V_M4_MF4 }, // 3238
  { Intrinsic::riscv_vluxseg8, 0x40, 0x6, 0x3, PseudoVLUXSEG8EI64_V_M8_MF4 }, // 3239
  { Intrinsic::riscv_vluxseg8, 0x40, 0x7, 0x0, PseudoVLUXSEG8EI64_V_M1_MF2 }, // 3240
  { Intrinsic::riscv_vluxseg8, 0x40, 0x7, 0x1, PseudoVLUXSEG8EI64_V_M2_MF2 }, // 3241
  { Intrinsic::riscv_vluxseg8, 0x40, 0x7, 0x2, PseudoVLUXSEG8EI64_V_M4_MF2 }, // 3242
  { Intrinsic::riscv_vluxseg8, 0x40, 0x7, 0x3, PseudoVLUXSEG8EI64_V_M8_MF2 }, // 3243
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x0, 0x0, PseudoVLUXSEG8EI8_V_M1_M1_MASK }, // 3244
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x0, 0x1, PseudoVLUXSEG8EI8_V_M2_M1_MASK }, // 3245
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x0, 0x2, PseudoVLUXSEG8EI8_V_M4_M1_MASK }, // 3246
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x0, 0x3, PseudoVLUXSEG8EI8_V_M8_M1_MASK }, // 3247
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x0, 0x5, PseudoVLUXSEG8EI8_V_MF8_M1_MASK }, // 3248
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x0, 0x6, PseudoVLUXSEG8EI8_V_MF4_M1_MASK }, // 3249
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x0, 0x7, PseudoVLUXSEG8EI8_V_MF2_M1_MASK }, // 3250
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x5, 0x0, PseudoVLUXSEG8EI8_V_M1_MF8_MASK }, // 3251
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x5, 0x1, PseudoVLUXSEG8EI8_V_M2_MF8_MASK }, // 3252
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x5, 0x2, PseudoVLUXSEG8EI8_V_M4_MF8_MASK }, // 3253
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x5, 0x3, PseudoVLUXSEG8EI8_V_M8_MF8_MASK }, // 3254
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x5, 0x5, PseudoVLUXSEG8EI8_V_MF8_MF8_MASK }, // 3255
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x5, 0x6, PseudoVLUXSEG8EI8_V_MF4_MF8_MASK }, // 3256
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x5, 0x7, PseudoVLUXSEG8EI8_V_MF2_MF8_MASK }, // 3257
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x6, 0x0, PseudoVLUXSEG8EI8_V_M1_MF4_MASK }, // 3258
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x6, 0x1, PseudoVLUXSEG8EI8_V_M2_MF4_MASK }, // 3259
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x6, 0x2, PseudoVLUXSEG8EI8_V_M4_MF4_MASK }, // 3260
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x6, 0x3, PseudoVLUXSEG8EI8_V_M8_MF4_MASK }, // 3261
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x6, 0x5, PseudoVLUXSEG8EI8_V_MF8_MF4_MASK }, // 3262
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x6, 0x6, PseudoVLUXSEG8EI8_V_MF4_MF4_MASK }, // 3263
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x6, 0x7, PseudoVLUXSEG8EI8_V_MF2_MF4_MASK }, // 3264
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x7, 0x0, PseudoVLUXSEG8EI8_V_M1_MF2_MASK }, // 3265
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x7, 0x1, PseudoVLUXSEG8EI8_V_M2_MF2_MASK }, // 3266
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x7, 0x2, PseudoVLUXSEG8EI8_V_M4_MF2_MASK }, // 3267
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x7, 0x3, PseudoVLUXSEG8EI8_V_M8_MF2_MASK }, // 3268
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x7, 0x5, PseudoVLUXSEG8EI8_V_MF8_MF2_MASK }, // 3269
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x7, 0x6, PseudoVLUXSEG8EI8_V_MF4_MF2_MASK }, // 3270
  { Intrinsic::riscv_vluxseg8_mask, 0x8, 0x7, 0x7, PseudoVLUXSEG8EI8_V_MF2_MF2_MASK }, // 3271
  { Intrinsic::riscv_vluxseg8_mask, 0x10, 0x0, 0x0, PseudoVLUXSEG8EI16_V_M1_M1_MASK }, // 3272
  { Intrinsic::riscv_vluxseg8_mask, 0x10, 0x0, 0x1, PseudoVLUXSEG8EI16_V_M2_M1_MASK }, // 3273
  { Intrinsic::riscv_vluxseg8_mask, 0x10, 0x0, 0x2, PseudoVLUXSEG8EI16_V_M4_M1_MASK }, // 3274
  { Intrinsic::riscv_vluxseg8_mask, 0x10, 0x0, 0x3, PseudoVLUXSEG8EI16_V_M8_M1_MASK }, // 3275
  { Intrinsic::riscv_vluxseg8_mask, 0x10, 0x0, 0x6, PseudoVLUXSEG8EI16_V_MF4_M1_MASK }, // 3276
  { Intrinsic::riscv_vluxseg8_mask, 0x10, 0x0, 0x7, PseudoVLUXSEG8EI16_V_MF2_M1_MASK }, // 3277
  { Intrinsic::riscv_vluxseg8_mask, 0x10, 0x5, 0x0, PseudoVLUXSEG8EI16_V_M1_MF8_MASK }, // 3278
  { Intrinsic::riscv_vluxseg8_mask, 0x10, 0x5, 0x1, PseudoVLUXSEG8EI16_V_M2_MF8_MASK }, // 3279
  { Intrinsic::riscv_vluxseg8_mask, 0x10, 0x5, 0x2, PseudoVLUXSEG8EI16_V_M4_MF8_MASK }, // 3280
  { Intrinsic::riscv_vluxseg8_mask, 0x10, 0x5, 0x3, PseudoVLUXSEG8EI16_V_M8_MF8_MASK }, // 3281
  { Intrinsic::riscv_vluxseg8_mask, 0x10, 0x5, 0x6, PseudoVLUXSEG8EI16_V_MF4_MF8_MASK }, // 3282
  { Intrinsic::riscv_vluxseg8_mask, 0x10, 0x5, 0x7, PseudoVLUXSEG8EI16_V_MF2_MF8_MASK }, // 3283
  { Intrinsic::riscv_vluxseg8_mask, 0x10, 0x6, 0x0, PseudoVLUXSEG8EI16_V_M1_MF4_MASK }, // 3284
  { Intrinsic::riscv_vluxseg8_mask, 0x10, 0x6, 0x1, PseudoVLUXSEG8EI16_V_M2_MF4_MASK }, // 3285
  { Intrinsic::riscv_vluxseg8_mask, 0x10, 0x6, 0x2, PseudoVLUXSEG8EI16_V_M4_MF4_MASK }, // 3286
  { Intrinsic::riscv_vluxseg8_mask, 0x10, 0x6, 0x3, PseudoVLUXSEG8EI16_V_M8_MF4_MASK }, // 3287
  { Intrinsic::riscv_vluxseg8_mask, 0x10, 0x6, 0x6, PseudoVLUXSEG8EI16_V_MF4_MF4_MASK }, // 3288
  { Intrinsic::riscv_vluxseg8_mask, 0x10, 0x6, 0x7, PseudoVLUXSEG8EI16_V_MF2_MF4_MASK }, // 3289
  { Intrinsic::riscv_vluxseg8_mask, 0x10, 0x7, 0x0, PseudoVLUXSEG8EI16_V_M1_MF2_MASK }, // 3290
  { Intrinsic::riscv_vluxseg8_mask, 0x10, 0x7, 0x1, PseudoVLUXSEG8EI16_V_M2_MF2_MASK }, // 3291
  { Intrinsic::riscv_vluxseg8_mask, 0x10, 0x7, 0x2, PseudoVLUXSEG8EI16_V_M4_MF2_MASK }, // 3292
  { Intrinsic::riscv_vluxseg8_mask, 0x10, 0x7, 0x3, PseudoVLUXSEG8EI16_V_M8_MF2_MASK }, // 3293
  { Intrinsic::riscv_vluxseg8_mask, 0x10, 0x7, 0x6, PseudoVLUXSEG8EI16_V_MF4_MF2_MASK }, // 3294
  { Intrinsic::riscv_vluxseg8_mask, 0x10, 0x7, 0x7, PseudoVLUXSEG8EI16_V_MF2_MF2_MASK }, // 3295
  { Intrinsic::riscv_vluxseg8_mask, 0x20, 0x0, 0x0, PseudoVLUXSEG8EI32_V_M1_M1_MASK }, // 3296
  { Intrinsic::riscv_vluxseg8_mask, 0x20, 0x0, 0x1, PseudoVLUXSEG8EI32_V_M2_M1_MASK }, // 3297
  { Intrinsic::riscv_vluxseg8_mask, 0x20, 0x0, 0x2, PseudoVLUXSEG8EI32_V_M4_M1_MASK }, // 3298
  { Intrinsic::riscv_vluxseg8_mask, 0x20, 0x0, 0x3, PseudoVLUXSEG8EI32_V_M8_M1_MASK }, // 3299
  { Intrinsic::riscv_vluxseg8_mask, 0x20, 0x0, 0x7, PseudoVLUXSEG8EI32_V_MF2_M1_MASK }, // 3300
  { Intrinsic::riscv_vluxseg8_mask, 0x20, 0x5, 0x0, PseudoVLUXSEG8EI32_V_M1_MF8_MASK }, // 3301
  { Intrinsic::riscv_vluxseg8_mask, 0x20, 0x5, 0x1, PseudoVLUXSEG8EI32_V_M2_MF8_MASK }, // 3302
  { Intrinsic::riscv_vluxseg8_mask, 0x20, 0x5, 0x2, PseudoVLUXSEG8EI32_V_M4_MF8_MASK }, // 3303
  { Intrinsic::riscv_vluxseg8_mask, 0x20, 0x5, 0x3, PseudoVLUXSEG8EI32_V_M8_MF8_MASK }, // 3304
  { Intrinsic::riscv_vluxseg8_mask, 0x20, 0x5, 0x7, PseudoVLUXSEG8EI32_V_MF2_MF8_MASK }, // 3305
  { Intrinsic::riscv_vluxseg8_mask, 0x20, 0x6, 0x0, PseudoVLUXSEG8EI32_V_M1_MF4_MASK }, // 3306
  { Intrinsic::riscv_vluxseg8_mask, 0x20, 0x6, 0x1, PseudoVLUXSEG8EI32_V_M2_MF4_MASK }, // 3307
  { Intrinsic::riscv_vluxseg8_mask, 0x20, 0x6, 0x2, PseudoVLUXSEG8EI32_V_M4_MF4_MASK }, // 3308
  { Intrinsic::riscv_vluxseg8_mask, 0x20, 0x6, 0x3, PseudoVLUXSEG8EI32_V_M8_MF4_MASK }, // 3309
  { Intrinsic::riscv_vluxseg8_mask, 0x20, 0x6, 0x7, PseudoVLUXSEG8EI32_V_MF2_MF4_MASK }, // 3310
  { Intrinsic::riscv_vluxseg8_mask, 0x20, 0x7, 0x0, PseudoVLUXSEG8EI32_V_M1_MF2_MASK }, // 3311
  { Intrinsic::riscv_vluxseg8_mask, 0x20, 0x7, 0x1, PseudoVLUXSEG8EI32_V_M2_MF2_MASK }, // 3312
  { Intrinsic::riscv_vluxseg8_mask, 0x20, 0x7, 0x2, PseudoVLUXSEG8EI32_V_M4_MF2_MASK }, // 3313
  { Intrinsic::riscv_vluxseg8_mask, 0x20, 0x7, 0x3, PseudoVLUXSEG8EI32_V_M8_MF2_MASK }, // 3314
  { Intrinsic::riscv_vluxseg8_mask, 0x20, 0x7, 0x7, PseudoVLUXSEG8EI32_V_MF2_MF2_MASK }, // 3315
  { Intrinsic::riscv_vluxseg8_mask, 0x40, 0x0, 0x0, PseudoVLUXSEG8EI64_V_M1_M1_MASK }, // 3316
  { Intrinsic::riscv_vluxseg8_mask, 0x40, 0x0, 0x1, PseudoVLUXSEG8EI64_V_M2_M1_MASK }, // 3317
  { Intrinsic::riscv_vluxseg8_mask, 0x40, 0x0, 0x2, PseudoVLUXSEG8EI64_V_M4_M1_MASK }, // 3318
  { Intrinsic::riscv_vluxseg8_mask, 0x40, 0x0, 0x3, PseudoVLUXSEG8EI64_V_M8_M1_MASK }, // 3319
  { Intrinsic::riscv_vluxseg8_mask, 0x40, 0x5, 0x0, PseudoVLUXSEG8EI64_V_M1_MF8_MASK }, // 3320
  { Intrinsic::riscv_vluxseg8_mask, 0x40, 0x5, 0x1, PseudoVLUXSEG8EI64_V_M2_MF8_MASK }, // 3321
  { Intrinsic::riscv_vluxseg8_mask, 0x40, 0x5, 0x2, PseudoVLUXSEG8EI64_V_M4_MF8_MASK }, // 3322
  { Intrinsic::riscv_vluxseg8_mask, 0x40, 0x5, 0x3, PseudoVLUXSEG8EI64_V_M8_MF8_MASK }, // 3323
  { Intrinsic::riscv_vluxseg8_mask, 0x40, 0x6, 0x0, PseudoVLUXSEG8EI64_V_M1_MF4_MASK }, // 3324
  { Intrinsic::riscv_vluxseg8_mask, 0x40, 0x6, 0x1, PseudoVLUXSEG8EI64_V_M2_MF4_MASK }, // 3325
  { Intrinsic::riscv_vluxseg8_mask, 0x40, 0x6, 0x2, PseudoVLUXSEG8EI64_V_M4_MF4_MASK }, // 3326
  { Intrinsic::riscv_vluxseg8_mask, 0x40, 0x6, 0x3, PseudoVLUXSEG8EI64_V_M8_MF4_MASK }, // 3327
  { Intrinsic::riscv_vluxseg8_mask, 0x40, 0x7, 0x0, PseudoVLUXSEG8EI64_V_M1_MF2_MASK }, // 3328
  { Intrinsic::riscv_vluxseg8_mask, 0x40, 0x7, 0x1, PseudoVLUXSEG8EI64_V_M2_MF2_MASK }, // 3329
  { Intrinsic::riscv_vluxseg8_mask, 0x40, 0x7, 0x2, PseudoVLUXSEG8EI64_V_M4_MF2_MASK }, // 3330
  { Intrinsic::riscv_vluxseg8_mask, 0x40, 0x7, 0x3, PseudoVLUXSEG8EI64_V_M8_MF2_MASK }, // 3331
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x0, 0x0, PseudoVSOXSEG2EI8_V_M1_M1 }, // 3332
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x0, 0x1, PseudoVSOXSEG2EI8_V_M2_M1 }, // 3333
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x0, 0x2, PseudoVSOXSEG2EI8_V_M4_M1 }, // 3334
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x0, 0x3, PseudoVSOXSEG2EI8_V_M8_M1 }, // 3335
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x0, 0x5, PseudoVSOXSEG2EI8_V_MF8_M1 }, // 3336
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x0, 0x6, PseudoVSOXSEG2EI8_V_MF4_M1 }, // 3337
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x0, 0x7, PseudoVSOXSEG2EI8_V_MF2_M1 }, // 3338
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x1, 0x0, PseudoVSOXSEG2EI8_V_M1_M2 }, // 3339
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x1, 0x1, PseudoVSOXSEG2EI8_V_M2_M2 }, // 3340
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x1, 0x2, PseudoVSOXSEG2EI8_V_M4_M2 }, // 3341
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x1, 0x3, PseudoVSOXSEG2EI8_V_M8_M2 }, // 3342
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x1, 0x5, PseudoVSOXSEG2EI8_V_MF8_M2 }, // 3343
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x1, 0x6, PseudoVSOXSEG2EI8_V_MF4_M2 }, // 3344
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x1, 0x7, PseudoVSOXSEG2EI8_V_MF2_M2 }, // 3345
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x2, 0x0, PseudoVSOXSEG2EI8_V_M1_M4 }, // 3346
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x2, 0x1, PseudoVSOXSEG2EI8_V_M2_M4 }, // 3347
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x2, 0x2, PseudoVSOXSEG2EI8_V_M4_M4 }, // 3348
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x2, 0x3, PseudoVSOXSEG2EI8_V_M8_M4 }, // 3349
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x2, 0x5, PseudoVSOXSEG2EI8_V_MF8_M4 }, // 3350
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x2, 0x6, PseudoVSOXSEG2EI8_V_MF4_M4 }, // 3351
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x2, 0x7, PseudoVSOXSEG2EI8_V_MF2_M4 }, // 3352
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x5, 0x0, PseudoVSOXSEG2EI8_V_M1_MF8 }, // 3353
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x5, 0x1, PseudoVSOXSEG2EI8_V_M2_MF8 }, // 3354
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x5, 0x2, PseudoVSOXSEG2EI8_V_M4_MF8 }, // 3355
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x5, 0x3, PseudoVSOXSEG2EI8_V_M8_MF8 }, // 3356
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x5, 0x5, PseudoVSOXSEG2EI8_V_MF8_MF8 }, // 3357
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x5, 0x6, PseudoVSOXSEG2EI8_V_MF4_MF8 }, // 3358
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x5, 0x7, PseudoVSOXSEG2EI8_V_MF2_MF8 }, // 3359
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x6, 0x0, PseudoVSOXSEG2EI8_V_M1_MF4 }, // 3360
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x6, 0x1, PseudoVSOXSEG2EI8_V_M2_MF4 }, // 3361
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x6, 0x2, PseudoVSOXSEG2EI8_V_M4_MF4 }, // 3362
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x6, 0x3, PseudoVSOXSEG2EI8_V_M8_MF4 }, // 3363
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x6, 0x5, PseudoVSOXSEG2EI8_V_MF8_MF4 }, // 3364
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x6, 0x6, PseudoVSOXSEG2EI8_V_MF4_MF4 }, // 3365
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x6, 0x7, PseudoVSOXSEG2EI8_V_MF2_MF4 }, // 3366
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x7, 0x0, PseudoVSOXSEG2EI8_V_M1_MF2 }, // 3367
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x7, 0x1, PseudoVSOXSEG2EI8_V_M2_MF2 }, // 3368
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x7, 0x2, PseudoVSOXSEG2EI8_V_M4_MF2 }, // 3369
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x7, 0x3, PseudoVSOXSEG2EI8_V_M8_MF2 }, // 3370
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x7, 0x5, PseudoVSOXSEG2EI8_V_MF8_MF2 }, // 3371
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x7, 0x6, PseudoVSOXSEG2EI8_V_MF4_MF2 }, // 3372
  { Intrinsic::riscv_vsoxseg2, 0x8, 0x7, 0x7, PseudoVSOXSEG2EI8_V_MF2_MF2 }, // 3373
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x0, 0x0, PseudoVSOXSEG2EI16_V_M1_M1 }, // 3374
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x0, 0x1, PseudoVSOXSEG2EI16_V_M2_M1 }, // 3375
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x0, 0x2, PseudoVSOXSEG2EI16_V_M4_M1 }, // 3376
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x0, 0x3, PseudoVSOXSEG2EI16_V_M8_M1 }, // 3377
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x0, 0x6, PseudoVSOXSEG2EI16_V_MF4_M1 }, // 3378
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x0, 0x7, PseudoVSOXSEG2EI16_V_MF2_M1 }, // 3379
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x1, 0x0, PseudoVSOXSEG2EI16_V_M1_M2 }, // 3380
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x1, 0x1, PseudoVSOXSEG2EI16_V_M2_M2 }, // 3381
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x1, 0x2, PseudoVSOXSEG2EI16_V_M4_M2 }, // 3382
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x1, 0x3, PseudoVSOXSEG2EI16_V_M8_M2 }, // 3383
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x1, 0x6, PseudoVSOXSEG2EI16_V_MF4_M2 }, // 3384
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x1, 0x7, PseudoVSOXSEG2EI16_V_MF2_M2 }, // 3385
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x2, 0x0, PseudoVSOXSEG2EI16_V_M1_M4 }, // 3386
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x2, 0x1, PseudoVSOXSEG2EI16_V_M2_M4 }, // 3387
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x2, 0x2, PseudoVSOXSEG2EI16_V_M4_M4 }, // 3388
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x2, 0x3, PseudoVSOXSEG2EI16_V_M8_M4 }, // 3389
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x2, 0x6, PseudoVSOXSEG2EI16_V_MF4_M4 }, // 3390
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x2, 0x7, PseudoVSOXSEG2EI16_V_MF2_M4 }, // 3391
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x5, 0x0, PseudoVSOXSEG2EI16_V_M1_MF8 }, // 3392
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x5, 0x1, PseudoVSOXSEG2EI16_V_M2_MF8 }, // 3393
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x5, 0x2, PseudoVSOXSEG2EI16_V_M4_MF8 }, // 3394
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x5, 0x3, PseudoVSOXSEG2EI16_V_M8_MF8 }, // 3395
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x5, 0x6, PseudoVSOXSEG2EI16_V_MF4_MF8 }, // 3396
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x5, 0x7, PseudoVSOXSEG2EI16_V_MF2_MF8 }, // 3397
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x6, 0x0, PseudoVSOXSEG2EI16_V_M1_MF4 }, // 3398
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x6, 0x1, PseudoVSOXSEG2EI16_V_M2_MF4 }, // 3399
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x6, 0x2, PseudoVSOXSEG2EI16_V_M4_MF4 }, // 3400
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x6, 0x3, PseudoVSOXSEG2EI16_V_M8_MF4 }, // 3401
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x6, 0x6, PseudoVSOXSEG2EI16_V_MF4_MF4 }, // 3402
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x6, 0x7, PseudoVSOXSEG2EI16_V_MF2_MF4 }, // 3403
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x7, 0x0, PseudoVSOXSEG2EI16_V_M1_MF2 }, // 3404
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x7, 0x1, PseudoVSOXSEG2EI16_V_M2_MF2 }, // 3405
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x7, 0x2, PseudoVSOXSEG2EI16_V_M4_MF2 }, // 3406
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x7, 0x3, PseudoVSOXSEG2EI16_V_M8_MF2 }, // 3407
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x7, 0x6, PseudoVSOXSEG2EI16_V_MF4_MF2 }, // 3408
  { Intrinsic::riscv_vsoxseg2, 0x10, 0x7, 0x7, PseudoVSOXSEG2EI16_V_MF2_MF2 }, // 3409
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x0, 0x0, PseudoVSOXSEG2EI32_V_M1_M1 }, // 3410
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x0, 0x1, PseudoVSOXSEG2EI32_V_M2_M1 }, // 3411
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x0, 0x2, PseudoVSOXSEG2EI32_V_M4_M1 }, // 3412
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x0, 0x3, PseudoVSOXSEG2EI32_V_M8_M1 }, // 3413
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x0, 0x7, PseudoVSOXSEG2EI32_V_MF2_M1 }, // 3414
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x1, 0x0, PseudoVSOXSEG2EI32_V_M1_M2 }, // 3415
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x1, 0x1, PseudoVSOXSEG2EI32_V_M2_M2 }, // 3416
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x1, 0x2, PseudoVSOXSEG2EI32_V_M4_M2 }, // 3417
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x1, 0x3, PseudoVSOXSEG2EI32_V_M8_M2 }, // 3418
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x1, 0x7, PseudoVSOXSEG2EI32_V_MF2_M2 }, // 3419
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x2, 0x0, PseudoVSOXSEG2EI32_V_M1_M4 }, // 3420
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x2, 0x1, PseudoVSOXSEG2EI32_V_M2_M4 }, // 3421
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x2, 0x2, PseudoVSOXSEG2EI32_V_M4_M4 }, // 3422
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x2, 0x3, PseudoVSOXSEG2EI32_V_M8_M4 }, // 3423
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x2, 0x7, PseudoVSOXSEG2EI32_V_MF2_M4 }, // 3424
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x5, 0x0, PseudoVSOXSEG2EI32_V_M1_MF8 }, // 3425
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x5, 0x1, PseudoVSOXSEG2EI32_V_M2_MF8 }, // 3426
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x5, 0x2, PseudoVSOXSEG2EI32_V_M4_MF8 }, // 3427
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x5, 0x3, PseudoVSOXSEG2EI32_V_M8_MF8 }, // 3428
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x5, 0x7, PseudoVSOXSEG2EI32_V_MF2_MF8 }, // 3429
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x6, 0x0, PseudoVSOXSEG2EI32_V_M1_MF4 }, // 3430
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x6, 0x1, PseudoVSOXSEG2EI32_V_M2_MF4 }, // 3431
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x6, 0x2, PseudoVSOXSEG2EI32_V_M4_MF4 }, // 3432
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x6, 0x3, PseudoVSOXSEG2EI32_V_M8_MF4 }, // 3433
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x6, 0x7, PseudoVSOXSEG2EI32_V_MF2_MF4 }, // 3434
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x7, 0x0, PseudoVSOXSEG2EI32_V_M1_MF2 }, // 3435
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x7, 0x1, PseudoVSOXSEG2EI32_V_M2_MF2 }, // 3436
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x7, 0x2, PseudoVSOXSEG2EI32_V_M4_MF2 }, // 3437
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x7, 0x3, PseudoVSOXSEG2EI32_V_M8_MF2 }, // 3438
  { Intrinsic::riscv_vsoxseg2, 0x20, 0x7, 0x7, PseudoVSOXSEG2EI32_V_MF2_MF2 }, // 3439
  { Intrinsic::riscv_vsoxseg2, 0x40, 0x0, 0x0, PseudoVSOXSEG2EI64_V_M1_M1 }, // 3440
  { Intrinsic::riscv_vsoxseg2, 0x40, 0x0, 0x1, PseudoVSOXSEG2EI64_V_M2_M1 }, // 3441
  { Intrinsic::riscv_vsoxseg2, 0x40, 0x0, 0x2, PseudoVSOXSEG2EI64_V_M4_M1 }, // 3442
  { Intrinsic::riscv_vsoxseg2, 0x40, 0x0, 0x3, PseudoVSOXSEG2EI64_V_M8_M1 }, // 3443
  { Intrinsic::riscv_vsoxseg2, 0x40, 0x1, 0x0, PseudoVSOXSEG2EI64_V_M1_M2 }, // 3444
  { Intrinsic::riscv_vsoxseg2, 0x40, 0x1, 0x1, PseudoVSOXSEG2EI64_V_M2_M2 }, // 3445
  { Intrinsic::riscv_vsoxseg2, 0x40, 0x1, 0x2, PseudoVSOXSEG2EI64_V_M4_M2 }, // 3446
  { Intrinsic::riscv_vsoxseg2, 0x40, 0x1, 0x3, PseudoVSOXSEG2EI64_V_M8_M2 }, // 3447
  { Intrinsic::riscv_vsoxseg2, 0x40, 0x2, 0x0, PseudoVSOXSEG2EI64_V_M1_M4 }, // 3448
  { Intrinsic::riscv_vsoxseg2, 0x40, 0x2, 0x1, PseudoVSOXSEG2EI64_V_M2_M4 }, // 3449
  { Intrinsic::riscv_vsoxseg2, 0x40, 0x2, 0x2, PseudoVSOXSEG2EI64_V_M4_M4 }, // 3450
  { Intrinsic::riscv_vsoxseg2, 0x40, 0x2, 0x3, PseudoVSOXSEG2EI64_V_M8_M4 }, // 3451
  { Intrinsic::riscv_vsoxseg2, 0x40, 0x5, 0x0, PseudoVSOXSEG2EI64_V_M1_MF8 }, // 3452
  { Intrinsic::riscv_vsoxseg2, 0x40, 0x5, 0x1, PseudoVSOXSEG2EI64_V_M2_MF8 }, // 3453
  { Intrinsic::riscv_vsoxseg2, 0x40, 0x5, 0x2, PseudoVSOXSEG2EI64_V_M4_MF8 }, // 3454
  { Intrinsic::riscv_vsoxseg2, 0x40, 0x5, 0x3, PseudoVSOXSEG2EI64_V_M8_MF8 }, // 3455
  { Intrinsic::riscv_vsoxseg2, 0x40, 0x6, 0x0, PseudoVSOXSEG2EI64_V_M1_MF4 }, // 3456
  { Intrinsic::riscv_vsoxseg2, 0x40, 0x6, 0x1, PseudoVSOXSEG2EI64_V_M2_MF4 }, // 3457
  { Intrinsic::riscv_vsoxseg2, 0x40, 0x6, 0x2, PseudoVSOXSEG2EI64_V_M4_MF4 }, // 3458
  { Intrinsic::riscv_vsoxseg2, 0x40, 0x6, 0x3, PseudoVSOXSEG2EI64_V_M8_MF4 }, // 3459
  { Intrinsic::riscv_vsoxseg2, 0x40, 0x7, 0x0, PseudoVSOXSEG2EI64_V_M1_MF2 }, // 3460
  { Intrinsic::riscv_vsoxseg2, 0x40, 0x7, 0x1, PseudoVSOXSEG2EI64_V_M2_MF2 }, // 3461
  { Intrinsic::riscv_vsoxseg2, 0x40, 0x7, 0x2, PseudoVSOXSEG2EI64_V_M4_MF2 }, // 3462
  { Intrinsic::riscv_vsoxseg2, 0x40, 0x7, 0x3, PseudoVSOXSEG2EI64_V_M8_MF2 }, // 3463
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x0, 0x0, PseudoVSOXSEG2EI8_V_M1_M1_MASK }, // 3464
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x0, 0x1, PseudoVSOXSEG2EI8_V_M2_M1_MASK }, // 3465
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x0, 0x2, PseudoVSOXSEG2EI8_V_M4_M1_MASK }, // 3466
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x0, 0x3, PseudoVSOXSEG2EI8_V_M8_M1_MASK }, // 3467
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x0, 0x5, PseudoVSOXSEG2EI8_V_MF8_M1_MASK }, // 3468
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x0, 0x6, PseudoVSOXSEG2EI8_V_MF4_M1_MASK }, // 3469
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x0, 0x7, PseudoVSOXSEG2EI8_V_MF2_M1_MASK }, // 3470
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x1, 0x0, PseudoVSOXSEG2EI8_V_M1_M2_MASK }, // 3471
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x1, 0x1, PseudoVSOXSEG2EI8_V_M2_M2_MASK }, // 3472
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x1, 0x2, PseudoVSOXSEG2EI8_V_M4_M2_MASK }, // 3473
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x1, 0x3, PseudoVSOXSEG2EI8_V_M8_M2_MASK }, // 3474
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x1, 0x5, PseudoVSOXSEG2EI8_V_MF8_M2_MASK }, // 3475
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x1, 0x6, PseudoVSOXSEG2EI8_V_MF4_M2_MASK }, // 3476
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x1, 0x7, PseudoVSOXSEG2EI8_V_MF2_M2_MASK }, // 3477
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x2, 0x0, PseudoVSOXSEG2EI8_V_M1_M4_MASK }, // 3478
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x2, 0x1, PseudoVSOXSEG2EI8_V_M2_M4_MASK }, // 3479
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x2, 0x2, PseudoVSOXSEG2EI8_V_M4_M4_MASK }, // 3480
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x2, 0x3, PseudoVSOXSEG2EI8_V_M8_M4_MASK }, // 3481
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x2, 0x5, PseudoVSOXSEG2EI8_V_MF8_M4_MASK }, // 3482
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x2, 0x6, PseudoVSOXSEG2EI8_V_MF4_M4_MASK }, // 3483
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x2, 0x7, PseudoVSOXSEG2EI8_V_MF2_M4_MASK }, // 3484
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x5, 0x0, PseudoVSOXSEG2EI8_V_M1_MF8_MASK }, // 3485
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x5, 0x1, PseudoVSOXSEG2EI8_V_M2_MF8_MASK }, // 3486
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x5, 0x2, PseudoVSOXSEG2EI8_V_M4_MF8_MASK }, // 3487
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x5, 0x3, PseudoVSOXSEG2EI8_V_M8_MF8_MASK }, // 3488
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x5, 0x5, PseudoVSOXSEG2EI8_V_MF8_MF8_MASK }, // 3489
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x5, 0x6, PseudoVSOXSEG2EI8_V_MF4_MF8_MASK }, // 3490
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x5, 0x7, PseudoVSOXSEG2EI8_V_MF2_MF8_MASK }, // 3491
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x6, 0x0, PseudoVSOXSEG2EI8_V_M1_MF4_MASK }, // 3492
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x6, 0x1, PseudoVSOXSEG2EI8_V_M2_MF4_MASK }, // 3493
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x6, 0x2, PseudoVSOXSEG2EI8_V_M4_MF4_MASK }, // 3494
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x6, 0x3, PseudoVSOXSEG2EI8_V_M8_MF4_MASK }, // 3495
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x6, 0x5, PseudoVSOXSEG2EI8_V_MF8_MF4_MASK }, // 3496
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x6, 0x6, PseudoVSOXSEG2EI8_V_MF4_MF4_MASK }, // 3497
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x6, 0x7, PseudoVSOXSEG2EI8_V_MF2_MF4_MASK }, // 3498
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x7, 0x0, PseudoVSOXSEG2EI8_V_M1_MF2_MASK }, // 3499
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x7, 0x1, PseudoVSOXSEG2EI8_V_M2_MF2_MASK }, // 3500
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x7, 0x2, PseudoVSOXSEG2EI8_V_M4_MF2_MASK }, // 3501
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x7, 0x3, PseudoVSOXSEG2EI8_V_M8_MF2_MASK }, // 3502
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x7, 0x5, PseudoVSOXSEG2EI8_V_MF8_MF2_MASK }, // 3503
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x7, 0x6, PseudoVSOXSEG2EI8_V_MF4_MF2_MASK }, // 3504
  { Intrinsic::riscv_vsoxseg2_mask, 0x8, 0x7, 0x7, PseudoVSOXSEG2EI8_V_MF2_MF2_MASK }, // 3505
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x0, 0x0, PseudoVSOXSEG2EI16_V_M1_M1_MASK }, // 3506
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x0, 0x1, PseudoVSOXSEG2EI16_V_M2_M1_MASK }, // 3507
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x0, 0x2, PseudoVSOXSEG2EI16_V_M4_M1_MASK }, // 3508
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x0, 0x3, PseudoVSOXSEG2EI16_V_M8_M1_MASK }, // 3509
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x0, 0x6, PseudoVSOXSEG2EI16_V_MF4_M1_MASK }, // 3510
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x0, 0x7, PseudoVSOXSEG2EI16_V_MF2_M1_MASK }, // 3511
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x1, 0x0, PseudoVSOXSEG2EI16_V_M1_M2_MASK }, // 3512
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x1, 0x1, PseudoVSOXSEG2EI16_V_M2_M2_MASK }, // 3513
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x1, 0x2, PseudoVSOXSEG2EI16_V_M4_M2_MASK }, // 3514
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x1, 0x3, PseudoVSOXSEG2EI16_V_M8_M2_MASK }, // 3515
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x1, 0x6, PseudoVSOXSEG2EI16_V_MF4_M2_MASK }, // 3516
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x1, 0x7, PseudoVSOXSEG2EI16_V_MF2_M2_MASK }, // 3517
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x2, 0x0, PseudoVSOXSEG2EI16_V_M1_M4_MASK }, // 3518
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x2, 0x1, PseudoVSOXSEG2EI16_V_M2_M4_MASK }, // 3519
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x2, 0x2, PseudoVSOXSEG2EI16_V_M4_M4_MASK }, // 3520
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x2, 0x3, PseudoVSOXSEG2EI16_V_M8_M4_MASK }, // 3521
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x2, 0x6, PseudoVSOXSEG2EI16_V_MF4_M4_MASK }, // 3522
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x2, 0x7, PseudoVSOXSEG2EI16_V_MF2_M4_MASK }, // 3523
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x5, 0x0, PseudoVSOXSEG2EI16_V_M1_MF8_MASK }, // 3524
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x5, 0x1, PseudoVSOXSEG2EI16_V_M2_MF8_MASK }, // 3525
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x5, 0x2, PseudoVSOXSEG2EI16_V_M4_MF8_MASK }, // 3526
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x5, 0x3, PseudoVSOXSEG2EI16_V_M8_MF8_MASK }, // 3527
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x5, 0x6, PseudoVSOXSEG2EI16_V_MF4_MF8_MASK }, // 3528
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x5, 0x7, PseudoVSOXSEG2EI16_V_MF2_MF8_MASK }, // 3529
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x6, 0x0, PseudoVSOXSEG2EI16_V_M1_MF4_MASK }, // 3530
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x6, 0x1, PseudoVSOXSEG2EI16_V_M2_MF4_MASK }, // 3531
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x6, 0x2, PseudoVSOXSEG2EI16_V_M4_MF4_MASK }, // 3532
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x6, 0x3, PseudoVSOXSEG2EI16_V_M8_MF4_MASK }, // 3533
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x6, 0x6, PseudoVSOXSEG2EI16_V_MF4_MF4_MASK }, // 3534
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x6, 0x7, PseudoVSOXSEG2EI16_V_MF2_MF4_MASK }, // 3535
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x7, 0x0, PseudoVSOXSEG2EI16_V_M1_MF2_MASK }, // 3536
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x7, 0x1, PseudoVSOXSEG2EI16_V_M2_MF2_MASK }, // 3537
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x7, 0x2, PseudoVSOXSEG2EI16_V_M4_MF2_MASK }, // 3538
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x7, 0x3, PseudoVSOXSEG2EI16_V_M8_MF2_MASK }, // 3539
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x7, 0x6, PseudoVSOXSEG2EI16_V_MF4_MF2_MASK }, // 3540
  { Intrinsic::riscv_vsoxseg2_mask, 0x10, 0x7, 0x7, PseudoVSOXSEG2EI16_V_MF2_MF2_MASK }, // 3541
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x0, 0x0, PseudoVSOXSEG2EI32_V_M1_M1_MASK }, // 3542
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x0, 0x1, PseudoVSOXSEG2EI32_V_M2_M1_MASK }, // 3543
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x0, 0x2, PseudoVSOXSEG2EI32_V_M4_M1_MASK }, // 3544
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x0, 0x3, PseudoVSOXSEG2EI32_V_M8_M1_MASK }, // 3545
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x0, 0x7, PseudoVSOXSEG2EI32_V_MF2_M1_MASK }, // 3546
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x1, 0x0, PseudoVSOXSEG2EI32_V_M1_M2_MASK }, // 3547
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x1, 0x1, PseudoVSOXSEG2EI32_V_M2_M2_MASK }, // 3548
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x1, 0x2, PseudoVSOXSEG2EI32_V_M4_M2_MASK }, // 3549
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x1, 0x3, PseudoVSOXSEG2EI32_V_M8_M2_MASK }, // 3550
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x1, 0x7, PseudoVSOXSEG2EI32_V_MF2_M2_MASK }, // 3551
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x2, 0x0, PseudoVSOXSEG2EI32_V_M1_M4_MASK }, // 3552
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x2, 0x1, PseudoVSOXSEG2EI32_V_M2_M4_MASK }, // 3553
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x2, 0x2, PseudoVSOXSEG2EI32_V_M4_M4_MASK }, // 3554
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x2, 0x3, PseudoVSOXSEG2EI32_V_M8_M4_MASK }, // 3555
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x2, 0x7, PseudoVSOXSEG2EI32_V_MF2_M4_MASK }, // 3556
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x5, 0x0, PseudoVSOXSEG2EI32_V_M1_MF8_MASK }, // 3557
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x5, 0x1, PseudoVSOXSEG2EI32_V_M2_MF8_MASK }, // 3558
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x5, 0x2, PseudoVSOXSEG2EI32_V_M4_MF8_MASK }, // 3559
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x5, 0x3, PseudoVSOXSEG2EI32_V_M8_MF8_MASK }, // 3560
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x5, 0x7, PseudoVSOXSEG2EI32_V_MF2_MF8_MASK }, // 3561
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x6, 0x0, PseudoVSOXSEG2EI32_V_M1_MF4_MASK }, // 3562
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x6, 0x1, PseudoVSOXSEG2EI32_V_M2_MF4_MASK }, // 3563
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x6, 0x2, PseudoVSOXSEG2EI32_V_M4_MF4_MASK }, // 3564
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x6, 0x3, PseudoVSOXSEG2EI32_V_M8_MF4_MASK }, // 3565
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x6, 0x7, PseudoVSOXSEG2EI32_V_MF2_MF4_MASK }, // 3566
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x7, 0x0, PseudoVSOXSEG2EI32_V_M1_MF2_MASK }, // 3567
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x7, 0x1, PseudoVSOXSEG2EI32_V_M2_MF2_MASK }, // 3568
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x7, 0x2, PseudoVSOXSEG2EI32_V_M4_MF2_MASK }, // 3569
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x7, 0x3, PseudoVSOXSEG2EI32_V_M8_MF2_MASK }, // 3570
  { Intrinsic::riscv_vsoxseg2_mask, 0x20, 0x7, 0x7, PseudoVSOXSEG2EI32_V_MF2_MF2_MASK }, // 3571
  { Intrinsic::riscv_vsoxseg2_mask, 0x40, 0x0, 0x0, PseudoVSOXSEG2EI64_V_M1_M1_MASK }, // 3572
  { Intrinsic::riscv_vsoxseg2_mask, 0x40, 0x0, 0x1, PseudoVSOXSEG2EI64_V_M2_M1_MASK }, // 3573
  { Intrinsic::riscv_vsoxseg2_mask, 0x40, 0x0, 0x2, PseudoVSOXSEG2EI64_V_M4_M1_MASK }, // 3574
  { Intrinsic::riscv_vsoxseg2_mask, 0x40, 0x0, 0x3, PseudoVSOXSEG2EI64_V_M8_M1_MASK }, // 3575
  { Intrinsic::riscv_vsoxseg2_mask, 0x40, 0x1, 0x0, PseudoVSOXSEG2EI64_V_M1_M2_MASK }, // 3576
  { Intrinsic::riscv_vsoxseg2_mask, 0x40, 0x1, 0x1, PseudoVSOXSEG2EI64_V_M2_M2_MASK }, // 3577
  { Intrinsic::riscv_vsoxseg2_mask, 0x40, 0x1, 0x2, PseudoVSOXSEG2EI64_V_M4_M2_MASK }, // 3578
  { Intrinsic::riscv_vsoxseg2_mask, 0x40, 0x1, 0x3, PseudoVSOXSEG2EI64_V_M8_M2_MASK }, // 3579
  { Intrinsic::riscv_vsoxseg2_mask, 0x40, 0x2, 0x0, PseudoVSOXSEG2EI64_V_M1_M4_MASK }, // 3580
  { Intrinsic::riscv_vsoxseg2_mask, 0x40, 0x2, 0x1, PseudoVSOXSEG2EI64_V_M2_M4_MASK }, // 3581
  { Intrinsic::riscv_vsoxseg2_mask, 0x40, 0x2, 0x2, PseudoVSOXSEG2EI64_V_M4_M4_MASK }, // 3582
  { Intrinsic::riscv_vsoxseg2_mask, 0x40, 0x2, 0x3, PseudoVSOXSEG2EI64_V_M8_M4_MASK }, // 3583
  { Intrinsic::riscv_vsoxseg2_mask, 0x40, 0x5, 0x0, PseudoVSOXSEG2EI64_V_M1_MF8_MASK }, // 3584
  { Intrinsic::riscv_vsoxseg2_mask, 0x40, 0x5, 0x1, PseudoVSOXSEG2EI64_V_M2_MF8_MASK }, // 3585
  { Intrinsic::riscv_vsoxseg2_mask, 0x40, 0x5, 0x2, PseudoVSOXSEG2EI64_V_M4_MF8_MASK }, // 3586
  { Intrinsic::riscv_vsoxseg2_mask, 0x40, 0x5, 0x3, PseudoVSOXSEG2EI64_V_M8_MF8_MASK }, // 3587
  { Intrinsic::riscv_vsoxseg2_mask, 0x40, 0x6, 0x0, PseudoVSOXSEG2EI64_V_M1_MF4_MASK }, // 3588
  { Intrinsic::riscv_vsoxseg2_mask, 0x40, 0x6, 0x1, PseudoVSOXSEG2EI64_V_M2_MF4_MASK }, // 3589
  { Intrinsic::riscv_vsoxseg2_mask, 0x40, 0x6, 0x2, PseudoVSOXSEG2EI64_V_M4_MF4_MASK }, // 3590
  { Intrinsic::riscv_vsoxseg2_mask, 0x40, 0x6, 0x3, PseudoVSOXSEG2EI64_V_M8_MF4_MASK }, // 3591
  { Intrinsic::riscv_vsoxseg2_mask, 0x40, 0x7, 0x0, PseudoVSOXSEG2EI64_V_M1_MF2_MASK }, // 3592
  { Intrinsic::riscv_vsoxseg2_mask, 0x40, 0x7, 0x1, PseudoVSOXSEG2EI64_V_M2_MF2_MASK }, // 3593
  { Intrinsic::riscv_vsoxseg2_mask, 0x40, 0x7, 0x2, PseudoVSOXSEG2EI64_V_M4_MF2_MASK }, // 3594
  { Intrinsic::riscv_vsoxseg2_mask, 0x40, 0x7, 0x3, PseudoVSOXSEG2EI64_V_M8_MF2_MASK }, // 3595
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x0, 0x0, PseudoVSOXSEG3EI8_V_M1_M1 }, // 3596
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x0, 0x1, PseudoVSOXSEG3EI8_V_M2_M1 }, // 3597
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x0, 0x2, PseudoVSOXSEG3EI8_V_M4_M1 }, // 3598
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x0, 0x3, PseudoVSOXSEG3EI8_V_M8_M1 }, // 3599
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x0, 0x5, PseudoVSOXSEG3EI8_V_MF8_M1 }, // 3600
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x0, 0x6, PseudoVSOXSEG3EI8_V_MF4_M1 }, // 3601
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x0, 0x7, PseudoVSOXSEG3EI8_V_MF2_M1 }, // 3602
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x1, 0x0, PseudoVSOXSEG3EI8_V_M1_M2 }, // 3603
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x1, 0x1, PseudoVSOXSEG3EI8_V_M2_M2 }, // 3604
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x1, 0x2, PseudoVSOXSEG3EI8_V_M4_M2 }, // 3605
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x1, 0x3, PseudoVSOXSEG3EI8_V_M8_M2 }, // 3606
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x1, 0x5, PseudoVSOXSEG3EI8_V_MF8_M2 }, // 3607
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x1, 0x6, PseudoVSOXSEG3EI8_V_MF4_M2 }, // 3608
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x1, 0x7, PseudoVSOXSEG3EI8_V_MF2_M2 }, // 3609
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x5, 0x0, PseudoVSOXSEG3EI8_V_M1_MF8 }, // 3610
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x5, 0x1, PseudoVSOXSEG3EI8_V_M2_MF8 }, // 3611
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x5, 0x2, PseudoVSOXSEG3EI8_V_M4_MF8 }, // 3612
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x5, 0x3, PseudoVSOXSEG3EI8_V_M8_MF8 }, // 3613
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x5, 0x5, PseudoVSOXSEG3EI8_V_MF8_MF8 }, // 3614
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x5, 0x6, PseudoVSOXSEG3EI8_V_MF4_MF8 }, // 3615
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x5, 0x7, PseudoVSOXSEG3EI8_V_MF2_MF8 }, // 3616
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x6, 0x0, PseudoVSOXSEG3EI8_V_M1_MF4 }, // 3617
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x6, 0x1, PseudoVSOXSEG3EI8_V_M2_MF4 }, // 3618
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x6, 0x2, PseudoVSOXSEG3EI8_V_M4_MF4 }, // 3619
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x6, 0x3, PseudoVSOXSEG3EI8_V_M8_MF4 }, // 3620
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x6, 0x5, PseudoVSOXSEG3EI8_V_MF8_MF4 }, // 3621
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x6, 0x6, PseudoVSOXSEG3EI8_V_MF4_MF4 }, // 3622
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x6, 0x7, PseudoVSOXSEG3EI8_V_MF2_MF4 }, // 3623
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x7, 0x0, PseudoVSOXSEG3EI8_V_M1_MF2 }, // 3624
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x7, 0x1, PseudoVSOXSEG3EI8_V_M2_MF2 }, // 3625
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x7, 0x2, PseudoVSOXSEG3EI8_V_M4_MF2 }, // 3626
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x7, 0x3, PseudoVSOXSEG3EI8_V_M8_MF2 }, // 3627
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x7, 0x5, PseudoVSOXSEG3EI8_V_MF8_MF2 }, // 3628
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x7, 0x6, PseudoVSOXSEG3EI8_V_MF4_MF2 }, // 3629
  { Intrinsic::riscv_vsoxseg3, 0x8, 0x7, 0x7, PseudoVSOXSEG3EI8_V_MF2_MF2 }, // 3630
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x0, 0x0, PseudoVSOXSEG3EI16_V_M1_M1 }, // 3631
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x0, 0x1, PseudoVSOXSEG3EI16_V_M2_M1 }, // 3632
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x0, 0x2, PseudoVSOXSEG3EI16_V_M4_M1 }, // 3633
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x0, 0x3, PseudoVSOXSEG3EI16_V_M8_M1 }, // 3634
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x0, 0x6, PseudoVSOXSEG3EI16_V_MF4_M1 }, // 3635
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x0, 0x7, PseudoVSOXSEG3EI16_V_MF2_M1 }, // 3636
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x1, 0x0, PseudoVSOXSEG3EI16_V_M1_M2 }, // 3637
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x1, 0x1, PseudoVSOXSEG3EI16_V_M2_M2 }, // 3638
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x1, 0x2, PseudoVSOXSEG3EI16_V_M4_M2 }, // 3639
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x1, 0x3, PseudoVSOXSEG3EI16_V_M8_M2 }, // 3640
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x1, 0x6, PseudoVSOXSEG3EI16_V_MF4_M2 }, // 3641
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x1, 0x7, PseudoVSOXSEG3EI16_V_MF2_M2 }, // 3642
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x5, 0x0, PseudoVSOXSEG3EI16_V_M1_MF8 }, // 3643
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x5, 0x1, PseudoVSOXSEG3EI16_V_M2_MF8 }, // 3644
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x5, 0x2, PseudoVSOXSEG3EI16_V_M4_MF8 }, // 3645
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x5, 0x3, PseudoVSOXSEG3EI16_V_M8_MF8 }, // 3646
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x5, 0x6, PseudoVSOXSEG3EI16_V_MF4_MF8 }, // 3647
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x5, 0x7, PseudoVSOXSEG3EI16_V_MF2_MF8 }, // 3648
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x6, 0x0, PseudoVSOXSEG3EI16_V_M1_MF4 }, // 3649
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x6, 0x1, PseudoVSOXSEG3EI16_V_M2_MF4 }, // 3650
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x6, 0x2, PseudoVSOXSEG3EI16_V_M4_MF4 }, // 3651
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x6, 0x3, PseudoVSOXSEG3EI16_V_M8_MF4 }, // 3652
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x6, 0x6, PseudoVSOXSEG3EI16_V_MF4_MF4 }, // 3653
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x6, 0x7, PseudoVSOXSEG3EI16_V_MF2_MF4 }, // 3654
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x7, 0x0, PseudoVSOXSEG3EI16_V_M1_MF2 }, // 3655
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x7, 0x1, PseudoVSOXSEG3EI16_V_M2_MF2 }, // 3656
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x7, 0x2, PseudoVSOXSEG3EI16_V_M4_MF2 }, // 3657
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x7, 0x3, PseudoVSOXSEG3EI16_V_M8_MF2 }, // 3658
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x7, 0x6, PseudoVSOXSEG3EI16_V_MF4_MF2 }, // 3659
  { Intrinsic::riscv_vsoxseg3, 0x10, 0x7, 0x7, PseudoVSOXSEG3EI16_V_MF2_MF2 }, // 3660
  { Intrinsic::riscv_vsoxseg3, 0x20, 0x0, 0x0, PseudoVSOXSEG3EI32_V_M1_M1 }, // 3661
  { Intrinsic::riscv_vsoxseg3, 0x20, 0x0, 0x1, PseudoVSOXSEG3EI32_V_M2_M1 }, // 3662
  { Intrinsic::riscv_vsoxseg3, 0x20, 0x0, 0x2, PseudoVSOXSEG3EI32_V_M4_M1 }, // 3663
  { Intrinsic::riscv_vsoxseg3, 0x20, 0x0, 0x3, PseudoVSOXSEG3EI32_V_M8_M1 }, // 3664
  { Intrinsic::riscv_vsoxseg3, 0x20, 0x0, 0x7, PseudoVSOXSEG3EI32_V_MF2_M1 }, // 3665
  { Intrinsic::riscv_vsoxseg3, 0x20, 0x1, 0x0, PseudoVSOXSEG3EI32_V_M1_M2 }, // 3666
  { Intrinsic::riscv_vsoxseg3, 0x20, 0x1, 0x1, PseudoVSOXSEG3EI32_V_M2_M2 }, // 3667
  { Intrinsic::riscv_vsoxseg3, 0x20, 0x1, 0x2, PseudoVSOXSEG3EI32_V_M4_M2 }, // 3668
  { Intrinsic::riscv_vsoxseg3, 0x20, 0x1, 0x3, PseudoVSOXSEG3EI32_V_M8_M2 }, // 3669
  { Intrinsic::riscv_vsoxseg3, 0x20, 0x1, 0x7, PseudoVSOXSEG3EI32_V_MF2_M2 }, // 3670
  { Intrinsic::riscv_vsoxseg3, 0x20, 0x5, 0x0, PseudoVSOXSEG3EI32_V_M1_MF8 }, // 3671
  { Intrinsic::riscv_vsoxseg3, 0x20, 0x5, 0x1, PseudoVSOXSEG3EI32_V_M2_MF8 }, // 3672
  { Intrinsic::riscv_vsoxseg3, 0x20, 0x5, 0x2, PseudoVSOXSEG3EI32_V_M4_MF8 }, // 3673
  { Intrinsic::riscv_vsoxseg3, 0x20, 0x5, 0x3, PseudoVSOXSEG3EI32_V_M8_MF8 }, // 3674
  { Intrinsic::riscv_vsoxseg3, 0x20, 0x5, 0x7, PseudoVSOXSEG3EI32_V_MF2_MF8 }, // 3675
  { Intrinsic::riscv_vsoxseg3, 0x20, 0x6, 0x0, PseudoVSOXSEG3EI32_V_M1_MF4 }, // 3676
  { Intrinsic::riscv_vsoxseg3, 0x20, 0x6, 0x1, PseudoVSOXSEG3EI32_V_M2_MF4 }, // 3677
  { Intrinsic::riscv_vsoxseg3, 0x20, 0x6, 0x2, PseudoVSOXSEG3EI32_V_M4_MF4 }, // 3678
  { Intrinsic::riscv_vsoxseg3, 0x20, 0x6, 0x3, PseudoVSOXSEG3EI32_V_M8_MF4 }, // 3679
  { Intrinsic::riscv_vsoxseg3, 0x20, 0x6, 0x7, PseudoVSOXSEG3EI32_V_MF2_MF4 }, // 3680
  { Intrinsic::riscv_vsoxseg3, 0x20, 0x7, 0x0, PseudoVSOXSEG3EI32_V_M1_MF2 }, // 3681
  { Intrinsic::riscv_vsoxseg3, 0x20, 0x7, 0x1, PseudoVSOXSEG3EI32_V_M2_MF2 }, // 3682
  { Intrinsic::riscv_vsoxseg3, 0x20, 0x7, 0x2, PseudoVSOXSEG3EI32_V_M4_MF2 }, // 3683
  { Intrinsic::riscv_vsoxseg3, 0x20, 0x7, 0x3, PseudoVSOXSEG3EI32_V_M8_MF2 }, // 3684
  { Intrinsic::riscv_vsoxseg3, 0x20, 0x7, 0x7, PseudoVSOXSEG3EI32_V_MF2_MF2 }, // 3685
  { Intrinsic::riscv_vsoxseg3, 0x40, 0x0, 0x0, PseudoVSOXSEG3EI64_V_M1_M1 }, // 3686
  { Intrinsic::riscv_vsoxseg3, 0x40, 0x0, 0x1, PseudoVSOXSEG3EI64_V_M2_M1 }, // 3687
  { Intrinsic::riscv_vsoxseg3, 0x40, 0x0, 0x2, PseudoVSOXSEG3EI64_V_M4_M1 }, // 3688
  { Intrinsic::riscv_vsoxseg3, 0x40, 0x0, 0x3, PseudoVSOXSEG3EI64_V_M8_M1 }, // 3689
  { Intrinsic::riscv_vsoxseg3, 0x40, 0x1, 0x0, PseudoVSOXSEG3EI64_V_M1_M2 }, // 3690
  { Intrinsic::riscv_vsoxseg3, 0x40, 0x1, 0x1, PseudoVSOXSEG3EI64_V_M2_M2 }, // 3691
  { Intrinsic::riscv_vsoxseg3, 0x40, 0x1, 0x2, PseudoVSOXSEG3EI64_V_M4_M2 }, // 3692
  { Intrinsic::riscv_vsoxseg3, 0x40, 0x1, 0x3, PseudoVSOXSEG3EI64_V_M8_M2 }, // 3693
  { Intrinsic::riscv_vsoxseg3, 0x40, 0x5, 0x0, PseudoVSOXSEG3EI64_V_M1_MF8 }, // 3694
  { Intrinsic::riscv_vsoxseg3, 0x40, 0x5, 0x1, PseudoVSOXSEG3EI64_V_M2_MF8 }, // 3695
  { Intrinsic::riscv_vsoxseg3, 0x40, 0x5, 0x2, PseudoVSOXSEG3EI64_V_M4_MF8 }, // 3696
  { Intrinsic::riscv_vsoxseg3, 0x40, 0x5, 0x3, PseudoVSOXSEG3EI64_V_M8_MF8 }, // 3697
  { Intrinsic::riscv_vsoxseg3, 0x40, 0x6, 0x0, PseudoVSOXSEG3EI64_V_M1_MF4 }, // 3698
  { Intrinsic::riscv_vsoxseg3, 0x40, 0x6, 0x1, PseudoVSOXSEG3EI64_V_M2_MF4 }, // 3699
  { Intrinsic::riscv_vsoxseg3, 0x40, 0x6, 0x2, PseudoVSOXSEG3EI64_V_M4_MF4 }, // 3700
  { Intrinsic::riscv_vsoxseg3, 0x40, 0x6, 0x3, PseudoVSOXSEG3EI64_V_M8_MF4 }, // 3701
  { Intrinsic::riscv_vsoxseg3, 0x40, 0x7, 0x0, PseudoVSOXSEG3EI64_V_M1_MF2 }, // 3702
  { Intrinsic::riscv_vsoxseg3, 0x40, 0x7, 0x1, PseudoVSOXSEG3EI64_V_M2_MF2 }, // 3703
  { Intrinsic::riscv_vsoxseg3, 0x40, 0x7, 0x2, PseudoVSOXSEG3EI64_V_M4_MF2 }, // 3704
  { Intrinsic::riscv_vsoxseg3, 0x40, 0x7, 0x3, PseudoVSOXSEG3EI64_V_M8_MF2 }, // 3705
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x0, 0x0, PseudoVSOXSEG3EI8_V_M1_M1_MASK }, // 3706
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x0, 0x1, PseudoVSOXSEG3EI8_V_M2_M1_MASK }, // 3707
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x0, 0x2, PseudoVSOXSEG3EI8_V_M4_M1_MASK }, // 3708
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x0, 0x3, PseudoVSOXSEG3EI8_V_M8_M1_MASK }, // 3709
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x0, 0x5, PseudoVSOXSEG3EI8_V_MF8_M1_MASK }, // 3710
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x0, 0x6, PseudoVSOXSEG3EI8_V_MF4_M1_MASK }, // 3711
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x0, 0x7, PseudoVSOXSEG3EI8_V_MF2_M1_MASK }, // 3712
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x1, 0x0, PseudoVSOXSEG3EI8_V_M1_M2_MASK }, // 3713
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x1, 0x1, PseudoVSOXSEG3EI8_V_M2_M2_MASK }, // 3714
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x1, 0x2, PseudoVSOXSEG3EI8_V_M4_M2_MASK }, // 3715
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x1, 0x3, PseudoVSOXSEG3EI8_V_M8_M2_MASK }, // 3716
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x1, 0x5, PseudoVSOXSEG3EI8_V_MF8_M2_MASK }, // 3717
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x1, 0x6, PseudoVSOXSEG3EI8_V_MF4_M2_MASK }, // 3718
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x1, 0x7, PseudoVSOXSEG3EI8_V_MF2_M2_MASK }, // 3719
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x5, 0x0, PseudoVSOXSEG3EI8_V_M1_MF8_MASK }, // 3720
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x5, 0x1, PseudoVSOXSEG3EI8_V_M2_MF8_MASK }, // 3721
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x5, 0x2, PseudoVSOXSEG3EI8_V_M4_MF8_MASK }, // 3722
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x5, 0x3, PseudoVSOXSEG3EI8_V_M8_MF8_MASK }, // 3723
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x5, 0x5, PseudoVSOXSEG3EI8_V_MF8_MF8_MASK }, // 3724
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x5, 0x6, PseudoVSOXSEG3EI8_V_MF4_MF8_MASK }, // 3725
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x5, 0x7, PseudoVSOXSEG3EI8_V_MF2_MF8_MASK }, // 3726
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x6, 0x0, PseudoVSOXSEG3EI8_V_M1_MF4_MASK }, // 3727
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x6, 0x1, PseudoVSOXSEG3EI8_V_M2_MF4_MASK }, // 3728
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x6, 0x2, PseudoVSOXSEG3EI8_V_M4_MF4_MASK }, // 3729
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x6, 0x3, PseudoVSOXSEG3EI8_V_M8_MF4_MASK }, // 3730
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x6, 0x5, PseudoVSOXSEG3EI8_V_MF8_MF4_MASK }, // 3731
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x6, 0x6, PseudoVSOXSEG3EI8_V_MF4_MF4_MASK }, // 3732
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x6, 0x7, PseudoVSOXSEG3EI8_V_MF2_MF4_MASK }, // 3733
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x7, 0x0, PseudoVSOXSEG3EI8_V_M1_MF2_MASK }, // 3734
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x7, 0x1, PseudoVSOXSEG3EI8_V_M2_MF2_MASK }, // 3735
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x7, 0x2, PseudoVSOXSEG3EI8_V_M4_MF2_MASK }, // 3736
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x7, 0x3, PseudoVSOXSEG3EI8_V_M8_MF2_MASK }, // 3737
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x7, 0x5, PseudoVSOXSEG3EI8_V_MF8_MF2_MASK }, // 3738
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x7, 0x6, PseudoVSOXSEG3EI8_V_MF4_MF2_MASK }, // 3739
  { Intrinsic::riscv_vsoxseg3_mask, 0x8, 0x7, 0x7, PseudoVSOXSEG3EI8_V_MF2_MF2_MASK }, // 3740
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x0, 0x0, PseudoVSOXSEG3EI16_V_M1_M1_MASK }, // 3741
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x0, 0x1, PseudoVSOXSEG3EI16_V_M2_M1_MASK }, // 3742
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x0, 0x2, PseudoVSOXSEG3EI16_V_M4_M1_MASK }, // 3743
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x0, 0x3, PseudoVSOXSEG3EI16_V_M8_M1_MASK }, // 3744
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x0, 0x6, PseudoVSOXSEG3EI16_V_MF4_M1_MASK }, // 3745
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x0, 0x7, PseudoVSOXSEG3EI16_V_MF2_M1_MASK }, // 3746
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x1, 0x0, PseudoVSOXSEG3EI16_V_M1_M2_MASK }, // 3747
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x1, 0x1, PseudoVSOXSEG3EI16_V_M2_M2_MASK }, // 3748
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x1, 0x2, PseudoVSOXSEG3EI16_V_M4_M2_MASK }, // 3749
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x1, 0x3, PseudoVSOXSEG3EI16_V_M8_M2_MASK }, // 3750
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x1, 0x6, PseudoVSOXSEG3EI16_V_MF4_M2_MASK }, // 3751
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x1, 0x7, PseudoVSOXSEG3EI16_V_MF2_M2_MASK }, // 3752
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x5, 0x0, PseudoVSOXSEG3EI16_V_M1_MF8_MASK }, // 3753
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x5, 0x1, PseudoVSOXSEG3EI16_V_M2_MF8_MASK }, // 3754
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x5, 0x2, PseudoVSOXSEG3EI16_V_M4_MF8_MASK }, // 3755
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x5, 0x3, PseudoVSOXSEG3EI16_V_M8_MF8_MASK }, // 3756
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x5, 0x6, PseudoVSOXSEG3EI16_V_MF4_MF8_MASK }, // 3757
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x5, 0x7, PseudoVSOXSEG3EI16_V_MF2_MF8_MASK }, // 3758
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x6, 0x0, PseudoVSOXSEG3EI16_V_M1_MF4_MASK }, // 3759
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x6, 0x1, PseudoVSOXSEG3EI16_V_M2_MF4_MASK }, // 3760
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x6, 0x2, PseudoVSOXSEG3EI16_V_M4_MF4_MASK }, // 3761
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x6, 0x3, PseudoVSOXSEG3EI16_V_M8_MF4_MASK }, // 3762
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x6, 0x6, PseudoVSOXSEG3EI16_V_MF4_MF4_MASK }, // 3763
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x6, 0x7, PseudoVSOXSEG3EI16_V_MF2_MF4_MASK }, // 3764
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x7, 0x0, PseudoVSOXSEG3EI16_V_M1_MF2_MASK }, // 3765
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x7, 0x1, PseudoVSOXSEG3EI16_V_M2_MF2_MASK }, // 3766
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x7, 0x2, PseudoVSOXSEG3EI16_V_M4_MF2_MASK }, // 3767
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x7, 0x3, PseudoVSOXSEG3EI16_V_M8_MF2_MASK }, // 3768
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x7, 0x6, PseudoVSOXSEG3EI16_V_MF4_MF2_MASK }, // 3769
  { Intrinsic::riscv_vsoxseg3_mask, 0x10, 0x7, 0x7, PseudoVSOXSEG3EI16_V_MF2_MF2_MASK }, // 3770
  { Intrinsic::riscv_vsoxseg3_mask, 0x20, 0x0, 0x0, PseudoVSOXSEG3EI32_V_M1_M1_MASK }, // 3771
  { Intrinsic::riscv_vsoxseg3_mask, 0x20, 0x0, 0x1, PseudoVSOXSEG3EI32_V_M2_M1_MASK }, // 3772
  { Intrinsic::riscv_vsoxseg3_mask, 0x20, 0x0, 0x2, PseudoVSOXSEG3EI32_V_M4_M1_MASK }, // 3773
  { Intrinsic::riscv_vsoxseg3_mask, 0x20, 0x0, 0x3, PseudoVSOXSEG3EI32_V_M8_M1_MASK }, // 3774
  { Intrinsic::riscv_vsoxseg3_mask, 0x20, 0x0, 0x7, PseudoVSOXSEG3EI32_V_MF2_M1_MASK }, // 3775
  { Intrinsic::riscv_vsoxseg3_mask, 0x20, 0x1, 0x0, PseudoVSOXSEG3EI32_V_M1_M2_MASK }, // 3776
  { Intrinsic::riscv_vsoxseg3_mask, 0x20, 0x1, 0x1, PseudoVSOXSEG3EI32_V_M2_M2_MASK }, // 3777
  { Intrinsic::riscv_vsoxseg3_mask, 0x20, 0x1, 0x2, PseudoVSOXSEG3EI32_V_M4_M2_MASK }, // 3778
  { Intrinsic::riscv_vsoxseg3_mask, 0x20, 0x1, 0x3, PseudoVSOXSEG3EI32_V_M8_M2_MASK }, // 3779
  { Intrinsic::riscv_vsoxseg3_mask, 0x20, 0x1, 0x7, PseudoVSOXSEG3EI32_V_MF2_M2_MASK }, // 3780
  { Intrinsic::riscv_vsoxseg3_mask, 0x20, 0x5, 0x0, PseudoVSOXSEG3EI32_V_M1_MF8_MASK }, // 3781
  { Intrinsic::riscv_vsoxseg3_mask, 0x20, 0x5, 0x1, PseudoVSOXSEG3EI32_V_M2_MF8_MASK }, // 3782
  { Intrinsic::riscv_vsoxseg3_mask, 0x20, 0x5, 0x2, PseudoVSOXSEG3EI32_V_M4_MF8_MASK }, // 3783
  { Intrinsic::riscv_vsoxseg3_mask, 0x20, 0x5, 0x3, PseudoVSOXSEG3EI32_V_M8_MF8_MASK }, // 3784
  { Intrinsic::riscv_vsoxseg3_mask, 0x20, 0x5, 0x7, PseudoVSOXSEG3EI32_V_MF2_MF8_MASK }, // 3785
  { Intrinsic::riscv_vsoxseg3_mask, 0x20, 0x6, 0x0, PseudoVSOXSEG3EI32_V_M1_MF4_MASK }, // 3786
  { Intrinsic::riscv_vsoxseg3_mask, 0x20, 0x6, 0x1, PseudoVSOXSEG3EI32_V_M2_MF4_MASK }, // 3787
  { Intrinsic::riscv_vsoxseg3_mask, 0x20, 0x6, 0x2, PseudoVSOXSEG3EI32_V_M4_MF4_MASK }, // 3788
  { Intrinsic::riscv_vsoxseg3_mask, 0x20, 0x6, 0x3, PseudoVSOXSEG3EI32_V_M8_MF4_MASK }, // 3789
  { Intrinsic::riscv_vsoxseg3_mask, 0x20, 0x6, 0x7, PseudoVSOXSEG3EI32_V_MF2_MF4_MASK }, // 3790
  { Intrinsic::riscv_vsoxseg3_mask, 0x20, 0x7, 0x0, PseudoVSOXSEG3EI32_V_M1_MF2_MASK }, // 3791
  { Intrinsic::riscv_vsoxseg3_mask, 0x20, 0x7, 0x1, PseudoVSOXSEG3EI32_V_M2_MF2_MASK }, // 3792
  { Intrinsic::riscv_vsoxseg3_mask, 0x20, 0x7, 0x2, PseudoVSOXSEG3EI32_V_M4_MF2_MASK }, // 3793
  { Intrinsic::riscv_vsoxseg3_mask, 0x20, 0x7, 0x3, PseudoVSOXSEG3EI32_V_M8_MF2_MASK }, // 3794
  { Intrinsic::riscv_vsoxseg3_mask, 0x20, 0x7, 0x7, PseudoVSOXSEG3EI32_V_MF2_MF2_MASK }, // 3795
  { Intrinsic::riscv_vsoxseg3_mask, 0x40, 0x0, 0x0, PseudoVSOXSEG3EI64_V_M1_M1_MASK }, // 3796
  { Intrinsic::riscv_vsoxseg3_mask, 0x40, 0x0, 0x1, PseudoVSOXSEG3EI64_V_M2_M1_MASK }, // 3797
  { Intrinsic::riscv_vsoxseg3_mask, 0x40, 0x0, 0x2, PseudoVSOXSEG3EI64_V_M4_M1_MASK }, // 3798
  { Intrinsic::riscv_vsoxseg3_mask, 0x40, 0x0, 0x3, PseudoVSOXSEG3EI64_V_M8_M1_MASK }, // 3799
  { Intrinsic::riscv_vsoxseg3_mask, 0x40, 0x1, 0x0, PseudoVSOXSEG3EI64_V_M1_M2_MASK }, // 3800
  { Intrinsic::riscv_vsoxseg3_mask, 0x40, 0x1, 0x1, PseudoVSOXSEG3EI64_V_M2_M2_MASK }, // 3801
  { Intrinsic::riscv_vsoxseg3_mask, 0x40, 0x1, 0x2, PseudoVSOXSEG3EI64_V_M4_M2_MASK }, // 3802
  { Intrinsic::riscv_vsoxseg3_mask, 0x40, 0x1, 0x3, PseudoVSOXSEG3EI64_V_M8_M2_MASK }, // 3803
  { Intrinsic::riscv_vsoxseg3_mask, 0x40, 0x5, 0x0, PseudoVSOXSEG3EI64_V_M1_MF8_MASK }, // 3804
  { Intrinsic::riscv_vsoxseg3_mask, 0x40, 0x5, 0x1, PseudoVSOXSEG3EI64_V_M2_MF8_MASK }, // 3805
  { Intrinsic::riscv_vsoxseg3_mask, 0x40, 0x5, 0x2, PseudoVSOXSEG3EI64_V_M4_MF8_MASK }, // 3806
  { Intrinsic::riscv_vsoxseg3_mask, 0x40, 0x5, 0x3, PseudoVSOXSEG3EI64_V_M8_MF8_MASK }, // 3807
  { Intrinsic::riscv_vsoxseg3_mask, 0x40, 0x6, 0x0, PseudoVSOXSEG3EI64_V_M1_MF4_MASK }, // 3808
  { Intrinsic::riscv_vsoxseg3_mask, 0x40, 0x6, 0x1, PseudoVSOXSEG3EI64_V_M2_MF4_MASK }, // 3809
  { Intrinsic::riscv_vsoxseg3_mask, 0x40, 0x6, 0x2, PseudoVSOXSEG3EI64_V_M4_MF4_MASK }, // 3810
  { Intrinsic::riscv_vsoxseg3_mask, 0x40, 0x6, 0x3, PseudoVSOXSEG3EI64_V_M8_MF4_MASK }, // 3811
  { Intrinsic::riscv_vsoxseg3_mask, 0x40, 0x7, 0x0, PseudoVSOXSEG3EI64_V_M1_MF2_MASK }, // 3812
  { Intrinsic::riscv_vsoxseg3_mask, 0x40, 0x7, 0x1, PseudoVSOXSEG3EI64_V_M2_MF2_MASK }, // 3813
  { Intrinsic::riscv_vsoxseg3_mask, 0x40, 0x7, 0x2, PseudoVSOXSEG3EI64_V_M4_MF2_MASK }, // 3814
  { Intrinsic::riscv_vsoxseg3_mask, 0x40, 0x7, 0x3, PseudoVSOXSEG3EI64_V_M8_MF2_MASK }, // 3815
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x0, 0x0, PseudoVSOXSEG4EI8_V_M1_M1 }, // 3816
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x0, 0x1, PseudoVSOXSEG4EI8_V_M2_M1 }, // 3817
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x0, 0x2, PseudoVSOXSEG4EI8_V_M4_M1 }, // 3818
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x0, 0x3, PseudoVSOXSEG4EI8_V_M8_M1 }, // 3819
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x0, 0x5, PseudoVSOXSEG4EI8_V_MF8_M1 }, // 3820
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x0, 0x6, PseudoVSOXSEG4EI8_V_MF4_M1 }, // 3821
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x0, 0x7, PseudoVSOXSEG4EI8_V_MF2_M1 }, // 3822
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x1, 0x0, PseudoVSOXSEG4EI8_V_M1_M2 }, // 3823
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x1, 0x1, PseudoVSOXSEG4EI8_V_M2_M2 }, // 3824
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x1, 0x2, PseudoVSOXSEG4EI8_V_M4_M2 }, // 3825
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x1, 0x3, PseudoVSOXSEG4EI8_V_M8_M2 }, // 3826
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x1, 0x5, PseudoVSOXSEG4EI8_V_MF8_M2 }, // 3827
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x1, 0x6, PseudoVSOXSEG4EI8_V_MF4_M2 }, // 3828
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x1, 0x7, PseudoVSOXSEG4EI8_V_MF2_M2 }, // 3829
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x5, 0x0, PseudoVSOXSEG4EI8_V_M1_MF8 }, // 3830
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x5, 0x1, PseudoVSOXSEG4EI8_V_M2_MF8 }, // 3831
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x5, 0x2, PseudoVSOXSEG4EI8_V_M4_MF8 }, // 3832
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x5, 0x3, PseudoVSOXSEG4EI8_V_M8_MF8 }, // 3833
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x5, 0x5, PseudoVSOXSEG4EI8_V_MF8_MF8 }, // 3834
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x5, 0x6, PseudoVSOXSEG4EI8_V_MF4_MF8 }, // 3835
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x5, 0x7, PseudoVSOXSEG4EI8_V_MF2_MF8 }, // 3836
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x6, 0x0, PseudoVSOXSEG4EI8_V_M1_MF4 }, // 3837
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x6, 0x1, PseudoVSOXSEG4EI8_V_M2_MF4 }, // 3838
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x6, 0x2, PseudoVSOXSEG4EI8_V_M4_MF4 }, // 3839
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x6, 0x3, PseudoVSOXSEG4EI8_V_M8_MF4 }, // 3840
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x6, 0x5, PseudoVSOXSEG4EI8_V_MF8_MF4 }, // 3841
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x6, 0x6, PseudoVSOXSEG4EI8_V_MF4_MF4 }, // 3842
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x6, 0x7, PseudoVSOXSEG4EI8_V_MF2_MF4 }, // 3843
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x7, 0x0, PseudoVSOXSEG4EI8_V_M1_MF2 }, // 3844
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x7, 0x1, PseudoVSOXSEG4EI8_V_M2_MF2 }, // 3845
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x7, 0x2, PseudoVSOXSEG4EI8_V_M4_MF2 }, // 3846
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x7, 0x3, PseudoVSOXSEG4EI8_V_M8_MF2 }, // 3847
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x7, 0x5, PseudoVSOXSEG4EI8_V_MF8_MF2 }, // 3848
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x7, 0x6, PseudoVSOXSEG4EI8_V_MF4_MF2 }, // 3849
  { Intrinsic::riscv_vsoxseg4, 0x8, 0x7, 0x7, PseudoVSOXSEG4EI8_V_MF2_MF2 }, // 3850
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x0, 0x0, PseudoVSOXSEG4EI16_V_M1_M1 }, // 3851
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x0, 0x1, PseudoVSOXSEG4EI16_V_M2_M1 }, // 3852
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x0, 0x2, PseudoVSOXSEG4EI16_V_M4_M1 }, // 3853
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x0, 0x3, PseudoVSOXSEG4EI16_V_M8_M1 }, // 3854
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x0, 0x6, PseudoVSOXSEG4EI16_V_MF4_M1 }, // 3855
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x0, 0x7, PseudoVSOXSEG4EI16_V_MF2_M1 }, // 3856
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x1, 0x0, PseudoVSOXSEG4EI16_V_M1_M2 }, // 3857
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x1, 0x1, PseudoVSOXSEG4EI16_V_M2_M2 }, // 3858
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x1, 0x2, PseudoVSOXSEG4EI16_V_M4_M2 }, // 3859
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x1, 0x3, PseudoVSOXSEG4EI16_V_M8_M2 }, // 3860
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x1, 0x6, PseudoVSOXSEG4EI16_V_MF4_M2 }, // 3861
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x1, 0x7, PseudoVSOXSEG4EI16_V_MF2_M2 }, // 3862
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x5, 0x0, PseudoVSOXSEG4EI16_V_M1_MF8 }, // 3863
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x5, 0x1, PseudoVSOXSEG4EI16_V_M2_MF8 }, // 3864
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x5, 0x2, PseudoVSOXSEG4EI16_V_M4_MF8 }, // 3865
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x5, 0x3, PseudoVSOXSEG4EI16_V_M8_MF8 }, // 3866
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x5, 0x6, PseudoVSOXSEG4EI16_V_MF4_MF8 }, // 3867
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x5, 0x7, PseudoVSOXSEG4EI16_V_MF2_MF8 }, // 3868
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x6, 0x0, PseudoVSOXSEG4EI16_V_M1_MF4 }, // 3869
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x6, 0x1, PseudoVSOXSEG4EI16_V_M2_MF4 }, // 3870
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x6, 0x2, PseudoVSOXSEG4EI16_V_M4_MF4 }, // 3871
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x6, 0x3, PseudoVSOXSEG4EI16_V_M8_MF4 }, // 3872
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x6, 0x6, PseudoVSOXSEG4EI16_V_MF4_MF4 }, // 3873
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x6, 0x7, PseudoVSOXSEG4EI16_V_MF2_MF4 }, // 3874
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x7, 0x0, PseudoVSOXSEG4EI16_V_M1_MF2 }, // 3875
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x7, 0x1, PseudoVSOXSEG4EI16_V_M2_MF2 }, // 3876
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x7, 0x2, PseudoVSOXSEG4EI16_V_M4_MF2 }, // 3877
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x7, 0x3, PseudoVSOXSEG4EI16_V_M8_MF2 }, // 3878
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x7, 0x6, PseudoVSOXSEG4EI16_V_MF4_MF2 }, // 3879
  { Intrinsic::riscv_vsoxseg4, 0x10, 0x7, 0x7, PseudoVSOXSEG4EI16_V_MF2_MF2 }, // 3880
  { Intrinsic::riscv_vsoxseg4, 0x20, 0x0, 0x0, PseudoVSOXSEG4EI32_V_M1_M1 }, // 3881
  { Intrinsic::riscv_vsoxseg4, 0x20, 0x0, 0x1, PseudoVSOXSEG4EI32_V_M2_M1 }, // 3882
  { Intrinsic::riscv_vsoxseg4, 0x20, 0x0, 0x2, PseudoVSOXSEG4EI32_V_M4_M1 }, // 3883
  { Intrinsic::riscv_vsoxseg4, 0x20, 0x0, 0x3, PseudoVSOXSEG4EI32_V_M8_M1 }, // 3884
  { Intrinsic::riscv_vsoxseg4, 0x20, 0x0, 0x7, PseudoVSOXSEG4EI32_V_MF2_M1 }, // 3885
  { Intrinsic::riscv_vsoxseg4, 0x20, 0x1, 0x0, PseudoVSOXSEG4EI32_V_M1_M2 }, // 3886
  { Intrinsic::riscv_vsoxseg4, 0x20, 0x1, 0x1, PseudoVSOXSEG4EI32_V_M2_M2 }, // 3887
  { Intrinsic::riscv_vsoxseg4, 0x20, 0x1, 0x2, PseudoVSOXSEG4EI32_V_M4_M2 }, // 3888
  { Intrinsic::riscv_vsoxseg4, 0x20, 0x1, 0x3, PseudoVSOXSEG4EI32_V_M8_M2 }, // 3889
  { Intrinsic::riscv_vsoxseg4, 0x20, 0x1, 0x7, PseudoVSOXSEG4EI32_V_MF2_M2 }, // 3890
  { Intrinsic::riscv_vsoxseg4, 0x20, 0x5, 0x0, PseudoVSOXSEG4EI32_V_M1_MF8 }, // 3891
  { Intrinsic::riscv_vsoxseg4, 0x20, 0x5, 0x1, PseudoVSOXSEG4EI32_V_M2_MF8 }, // 3892
  { Intrinsic::riscv_vsoxseg4, 0x20, 0x5, 0x2, PseudoVSOXSEG4EI32_V_M4_MF8 }, // 3893
  { Intrinsic::riscv_vsoxseg4, 0x20, 0x5, 0x3, PseudoVSOXSEG4EI32_V_M8_MF8 }, // 3894
  { Intrinsic::riscv_vsoxseg4, 0x20, 0x5, 0x7, PseudoVSOXSEG4EI32_V_MF2_MF8 }, // 3895
  { Intrinsic::riscv_vsoxseg4, 0x20, 0x6, 0x0, PseudoVSOXSEG4EI32_V_M1_MF4 }, // 3896
  { Intrinsic::riscv_vsoxseg4, 0x20, 0x6, 0x1, PseudoVSOXSEG4EI32_V_M2_MF4 }, // 3897
  { Intrinsic::riscv_vsoxseg4, 0x20, 0x6, 0x2, PseudoVSOXSEG4EI32_V_M4_MF4 }, // 3898
  { Intrinsic::riscv_vsoxseg4, 0x20, 0x6, 0x3, PseudoVSOXSEG4EI32_V_M8_MF4 }, // 3899
  { Intrinsic::riscv_vsoxseg4, 0x20, 0x6, 0x7, PseudoVSOXSEG4EI32_V_MF2_MF4 }, // 3900
  { Intrinsic::riscv_vsoxseg4, 0x20, 0x7, 0x0, PseudoVSOXSEG4EI32_V_M1_MF2 }, // 3901
  { Intrinsic::riscv_vsoxseg4, 0x20, 0x7, 0x1, PseudoVSOXSEG4EI32_V_M2_MF2 }, // 3902
  { Intrinsic::riscv_vsoxseg4, 0x20, 0x7, 0x2, PseudoVSOXSEG4EI32_V_M4_MF2 }, // 3903
  { Intrinsic::riscv_vsoxseg4, 0x20, 0x7, 0x3, PseudoVSOXSEG4EI32_V_M8_MF2 }, // 3904
  { Intrinsic::riscv_vsoxseg4, 0x20, 0x7, 0x7, PseudoVSOXSEG4EI32_V_MF2_MF2 }, // 3905
  { Intrinsic::riscv_vsoxseg4, 0x40, 0x0, 0x0, PseudoVSOXSEG4EI64_V_M1_M1 }, // 3906
  { Intrinsic::riscv_vsoxseg4, 0x40, 0x0, 0x1, PseudoVSOXSEG4EI64_V_M2_M1 }, // 3907
  { Intrinsic::riscv_vsoxseg4, 0x40, 0x0, 0x2, PseudoVSOXSEG4EI64_V_M4_M1 }, // 3908
  { Intrinsic::riscv_vsoxseg4, 0x40, 0x0, 0x3, PseudoVSOXSEG4EI64_V_M8_M1 }, // 3909
  { Intrinsic::riscv_vsoxseg4, 0x40, 0x1, 0x0, PseudoVSOXSEG4EI64_V_M1_M2 }, // 3910
  { Intrinsic::riscv_vsoxseg4, 0x40, 0x1, 0x1, PseudoVSOXSEG4EI64_V_M2_M2 }, // 3911
  { Intrinsic::riscv_vsoxseg4, 0x40, 0x1, 0x2, PseudoVSOXSEG4EI64_V_M4_M2 }, // 3912
  { Intrinsic::riscv_vsoxseg4, 0x40, 0x1, 0x3, PseudoVSOXSEG4EI64_V_M8_M2 }, // 3913
  { Intrinsic::riscv_vsoxseg4, 0x40, 0x5, 0x0, PseudoVSOXSEG4EI64_V_M1_MF8 }, // 3914
  { Intrinsic::riscv_vsoxseg4, 0x40, 0x5, 0x1, PseudoVSOXSEG4EI64_V_M2_MF8 }, // 3915
  { Intrinsic::riscv_vsoxseg4, 0x40, 0x5, 0x2, PseudoVSOXSEG4EI64_V_M4_MF8 }, // 3916
  { Intrinsic::riscv_vsoxseg4, 0x40, 0x5, 0x3, PseudoVSOXSEG4EI64_V_M8_MF8 }, // 3917
  { Intrinsic::riscv_vsoxseg4, 0x40, 0x6, 0x0, PseudoVSOXSEG4EI64_V_M1_MF4 }, // 3918
  { Intrinsic::riscv_vsoxseg4, 0x40, 0x6, 0x1, PseudoVSOXSEG4EI64_V_M2_MF4 }, // 3919
  { Intrinsic::riscv_vsoxseg4, 0x40, 0x6, 0x2, PseudoVSOXSEG4EI64_V_M4_MF4 }, // 3920
  { Intrinsic::riscv_vsoxseg4, 0x40, 0x6, 0x3, PseudoVSOXSEG4EI64_V_M8_MF4 }, // 3921
  { Intrinsic::riscv_vsoxseg4, 0x40, 0x7, 0x0, PseudoVSOXSEG4EI64_V_M1_MF2 }, // 3922
  { Intrinsic::riscv_vsoxseg4, 0x40, 0x7, 0x1, PseudoVSOXSEG4EI64_V_M2_MF2 }, // 3923
  { Intrinsic::riscv_vsoxseg4, 0x40, 0x7, 0x2, PseudoVSOXSEG4EI64_V_M4_MF2 }, // 3924
  { Intrinsic::riscv_vsoxseg4, 0x40, 0x7, 0x3, PseudoVSOXSEG4EI64_V_M8_MF2 }, // 3925
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x0, 0x0, PseudoVSOXSEG4EI8_V_M1_M1_MASK }, // 3926
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x0, 0x1, PseudoVSOXSEG4EI8_V_M2_M1_MASK }, // 3927
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x0, 0x2, PseudoVSOXSEG4EI8_V_M4_M1_MASK }, // 3928
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x0, 0x3, PseudoVSOXSEG4EI8_V_M8_M1_MASK }, // 3929
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x0, 0x5, PseudoVSOXSEG4EI8_V_MF8_M1_MASK }, // 3930
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x0, 0x6, PseudoVSOXSEG4EI8_V_MF4_M1_MASK }, // 3931
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x0, 0x7, PseudoVSOXSEG4EI8_V_MF2_M1_MASK }, // 3932
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x1, 0x0, PseudoVSOXSEG4EI8_V_M1_M2_MASK }, // 3933
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x1, 0x1, PseudoVSOXSEG4EI8_V_M2_M2_MASK }, // 3934
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x1, 0x2, PseudoVSOXSEG4EI8_V_M4_M2_MASK }, // 3935
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x1, 0x3, PseudoVSOXSEG4EI8_V_M8_M2_MASK }, // 3936
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x1, 0x5, PseudoVSOXSEG4EI8_V_MF8_M2_MASK }, // 3937
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x1, 0x6, PseudoVSOXSEG4EI8_V_MF4_M2_MASK }, // 3938
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x1, 0x7, PseudoVSOXSEG4EI8_V_MF2_M2_MASK }, // 3939
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x5, 0x0, PseudoVSOXSEG4EI8_V_M1_MF8_MASK }, // 3940
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x5, 0x1, PseudoVSOXSEG4EI8_V_M2_MF8_MASK }, // 3941
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x5, 0x2, PseudoVSOXSEG4EI8_V_M4_MF8_MASK }, // 3942
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x5, 0x3, PseudoVSOXSEG4EI8_V_M8_MF8_MASK }, // 3943
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x5, 0x5, PseudoVSOXSEG4EI8_V_MF8_MF8_MASK }, // 3944
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x5, 0x6, PseudoVSOXSEG4EI8_V_MF4_MF8_MASK }, // 3945
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x5, 0x7, PseudoVSOXSEG4EI8_V_MF2_MF8_MASK }, // 3946
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x6, 0x0, PseudoVSOXSEG4EI8_V_M1_MF4_MASK }, // 3947
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x6, 0x1, PseudoVSOXSEG4EI8_V_M2_MF4_MASK }, // 3948
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x6, 0x2, PseudoVSOXSEG4EI8_V_M4_MF4_MASK }, // 3949
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x6, 0x3, PseudoVSOXSEG4EI8_V_M8_MF4_MASK }, // 3950
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x6, 0x5, PseudoVSOXSEG4EI8_V_MF8_MF4_MASK }, // 3951
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x6, 0x6, PseudoVSOXSEG4EI8_V_MF4_MF4_MASK }, // 3952
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x6, 0x7, PseudoVSOXSEG4EI8_V_MF2_MF4_MASK }, // 3953
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x7, 0x0, PseudoVSOXSEG4EI8_V_M1_MF2_MASK }, // 3954
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x7, 0x1, PseudoVSOXSEG4EI8_V_M2_MF2_MASK }, // 3955
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x7, 0x2, PseudoVSOXSEG4EI8_V_M4_MF2_MASK }, // 3956
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x7, 0x3, PseudoVSOXSEG4EI8_V_M8_MF2_MASK }, // 3957
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x7, 0x5, PseudoVSOXSEG4EI8_V_MF8_MF2_MASK }, // 3958
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x7, 0x6, PseudoVSOXSEG4EI8_V_MF4_MF2_MASK }, // 3959
  { Intrinsic::riscv_vsoxseg4_mask, 0x8, 0x7, 0x7, PseudoVSOXSEG4EI8_V_MF2_MF2_MASK }, // 3960
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x0, 0x0, PseudoVSOXSEG4EI16_V_M1_M1_MASK }, // 3961
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x0, 0x1, PseudoVSOXSEG4EI16_V_M2_M1_MASK }, // 3962
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x0, 0x2, PseudoVSOXSEG4EI16_V_M4_M1_MASK }, // 3963
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x0, 0x3, PseudoVSOXSEG4EI16_V_M8_M1_MASK }, // 3964
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x0, 0x6, PseudoVSOXSEG4EI16_V_MF4_M1_MASK }, // 3965
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x0, 0x7, PseudoVSOXSEG4EI16_V_MF2_M1_MASK }, // 3966
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x1, 0x0, PseudoVSOXSEG4EI16_V_M1_M2_MASK }, // 3967
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x1, 0x1, PseudoVSOXSEG4EI16_V_M2_M2_MASK }, // 3968
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x1, 0x2, PseudoVSOXSEG4EI16_V_M4_M2_MASK }, // 3969
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x1, 0x3, PseudoVSOXSEG4EI16_V_M8_M2_MASK }, // 3970
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x1, 0x6, PseudoVSOXSEG4EI16_V_MF4_M2_MASK }, // 3971
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x1, 0x7, PseudoVSOXSEG4EI16_V_MF2_M2_MASK }, // 3972
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x5, 0x0, PseudoVSOXSEG4EI16_V_M1_MF8_MASK }, // 3973
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x5, 0x1, PseudoVSOXSEG4EI16_V_M2_MF8_MASK }, // 3974
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x5, 0x2, PseudoVSOXSEG4EI16_V_M4_MF8_MASK }, // 3975
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x5, 0x3, PseudoVSOXSEG4EI16_V_M8_MF8_MASK }, // 3976
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x5, 0x6, PseudoVSOXSEG4EI16_V_MF4_MF8_MASK }, // 3977
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x5, 0x7, PseudoVSOXSEG4EI16_V_MF2_MF8_MASK }, // 3978
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x6, 0x0, PseudoVSOXSEG4EI16_V_M1_MF4_MASK }, // 3979
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x6, 0x1, PseudoVSOXSEG4EI16_V_M2_MF4_MASK }, // 3980
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x6, 0x2, PseudoVSOXSEG4EI16_V_M4_MF4_MASK }, // 3981
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x6, 0x3, PseudoVSOXSEG4EI16_V_M8_MF4_MASK }, // 3982
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x6, 0x6, PseudoVSOXSEG4EI16_V_MF4_MF4_MASK }, // 3983
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x6, 0x7, PseudoVSOXSEG4EI16_V_MF2_MF4_MASK }, // 3984
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x7, 0x0, PseudoVSOXSEG4EI16_V_M1_MF2_MASK }, // 3985
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x7, 0x1, PseudoVSOXSEG4EI16_V_M2_MF2_MASK }, // 3986
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x7, 0x2, PseudoVSOXSEG4EI16_V_M4_MF2_MASK }, // 3987
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x7, 0x3, PseudoVSOXSEG4EI16_V_M8_MF2_MASK }, // 3988
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x7, 0x6, PseudoVSOXSEG4EI16_V_MF4_MF2_MASK }, // 3989
  { Intrinsic::riscv_vsoxseg4_mask, 0x10, 0x7, 0x7, PseudoVSOXSEG4EI16_V_MF2_MF2_MASK }, // 3990
  { Intrinsic::riscv_vsoxseg4_mask, 0x20, 0x0, 0x0, PseudoVSOXSEG4EI32_V_M1_M1_MASK }, // 3991
  { Intrinsic::riscv_vsoxseg4_mask, 0x20, 0x0, 0x1, PseudoVSOXSEG4EI32_V_M2_M1_MASK }, // 3992
  { Intrinsic::riscv_vsoxseg4_mask, 0x20, 0x0, 0x2, PseudoVSOXSEG4EI32_V_M4_M1_MASK }, // 3993
  { Intrinsic::riscv_vsoxseg4_mask, 0x20, 0x0, 0x3, PseudoVSOXSEG4EI32_V_M8_M1_MASK }, // 3994
  { Intrinsic::riscv_vsoxseg4_mask, 0x20, 0x0, 0x7, PseudoVSOXSEG4EI32_V_MF2_M1_MASK }, // 3995
  { Intrinsic::riscv_vsoxseg4_mask, 0x20, 0x1, 0x0, PseudoVSOXSEG4EI32_V_M1_M2_MASK }, // 3996
  { Intrinsic::riscv_vsoxseg4_mask, 0x20, 0x1, 0x1, PseudoVSOXSEG4EI32_V_M2_M2_MASK }, // 3997
  { Intrinsic::riscv_vsoxseg4_mask, 0x20, 0x1, 0x2, PseudoVSOXSEG4EI32_V_M4_M2_MASK }, // 3998
  { Intrinsic::riscv_vsoxseg4_mask, 0x20, 0x1, 0x3, PseudoVSOXSEG4EI32_V_M8_M2_MASK }, // 3999
  { Intrinsic::riscv_vsoxseg4_mask, 0x20, 0x1, 0x7, PseudoVSOXSEG4EI32_V_MF2_M2_MASK }, // 4000
  { Intrinsic::riscv_vsoxseg4_mask, 0x20, 0x5, 0x0, PseudoVSOXSEG4EI32_V_M1_MF8_MASK }, // 4001
  { Intrinsic::riscv_vsoxseg4_mask, 0x20, 0x5, 0x1, PseudoVSOXSEG4EI32_V_M2_MF8_MASK }, // 4002
  { Intrinsic::riscv_vsoxseg4_mask, 0x20, 0x5, 0x2, PseudoVSOXSEG4EI32_V_M4_MF8_MASK }, // 4003
  { Intrinsic::riscv_vsoxseg4_mask, 0x20, 0x5, 0x3, PseudoVSOXSEG4EI32_V_M8_MF8_MASK }, // 4004
  { Intrinsic::riscv_vsoxseg4_mask, 0x20, 0x5, 0x7, PseudoVSOXSEG4EI32_V_MF2_MF8_MASK }, // 4005
  { Intrinsic::riscv_vsoxseg4_mask, 0x20, 0x6, 0x0, PseudoVSOXSEG4EI32_V_M1_MF4_MASK }, // 4006
  { Intrinsic::riscv_vsoxseg4_mask, 0x20, 0x6, 0x1, PseudoVSOXSEG4EI32_V_M2_MF4_MASK }, // 4007
  { Intrinsic::riscv_vsoxseg4_mask, 0x20, 0x6, 0x2, PseudoVSOXSEG4EI32_V_M4_MF4_MASK }, // 4008
  { Intrinsic::riscv_vsoxseg4_mask, 0x20, 0x6, 0x3, PseudoVSOXSEG4EI32_V_M8_MF4_MASK }, // 4009
  { Intrinsic::riscv_vsoxseg4_mask, 0x20, 0x6, 0x7, PseudoVSOXSEG4EI32_V_MF2_MF4_MASK }, // 4010
  { Intrinsic::riscv_vsoxseg4_mask, 0x20, 0x7, 0x0, PseudoVSOXSEG4EI32_V_M1_MF2_MASK }, // 4011
  { Intrinsic::riscv_vsoxseg4_mask, 0x20, 0x7, 0x1, PseudoVSOXSEG4EI32_V_M2_MF2_MASK }, // 4012
  { Intrinsic::riscv_vsoxseg4_mask, 0x20, 0x7, 0x2, PseudoVSOXSEG4EI32_V_M4_MF2_MASK }, // 4013
  { Intrinsic::riscv_vsoxseg4_mask, 0x20, 0x7, 0x3, PseudoVSOXSEG4EI32_V_M8_MF2_MASK }, // 4014
  { Intrinsic::riscv_vsoxseg4_mask, 0x20, 0x7, 0x7, PseudoVSOXSEG4EI32_V_MF2_MF2_MASK }, // 4015
  { Intrinsic::riscv_vsoxseg4_mask, 0x40, 0x0, 0x0, PseudoVSOXSEG4EI64_V_M1_M1_MASK }, // 4016
  { Intrinsic::riscv_vsoxseg4_mask, 0x40, 0x0, 0x1, PseudoVSOXSEG4EI64_V_M2_M1_MASK }, // 4017
  { Intrinsic::riscv_vsoxseg4_mask, 0x40, 0x0, 0x2, PseudoVSOXSEG4EI64_V_M4_M1_MASK }, // 4018
  { Intrinsic::riscv_vsoxseg4_mask, 0x40, 0x0, 0x3, PseudoVSOXSEG4EI64_V_M8_M1_MASK }, // 4019
  { Intrinsic::riscv_vsoxseg4_mask, 0x40, 0x1, 0x0, PseudoVSOXSEG4EI64_V_M1_M2_MASK }, // 4020
  { Intrinsic::riscv_vsoxseg4_mask, 0x40, 0x1, 0x1, PseudoVSOXSEG4EI64_V_M2_M2_MASK }, // 4021
  { Intrinsic::riscv_vsoxseg4_mask, 0x40, 0x1, 0x2, PseudoVSOXSEG4EI64_V_M4_M2_MASK }, // 4022
  { Intrinsic::riscv_vsoxseg4_mask, 0x40, 0x1, 0x3, PseudoVSOXSEG4EI64_V_M8_M2_MASK }, // 4023
  { Intrinsic::riscv_vsoxseg4_mask, 0x40, 0x5, 0x0, PseudoVSOXSEG4EI64_V_M1_MF8_MASK }, // 4024
  { Intrinsic::riscv_vsoxseg4_mask, 0x40, 0x5, 0x1, PseudoVSOXSEG4EI64_V_M2_MF8_MASK }, // 4025
  { Intrinsic::riscv_vsoxseg4_mask, 0x40, 0x5, 0x2, PseudoVSOXSEG4EI64_V_M4_MF8_MASK }, // 4026
  { Intrinsic::riscv_vsoxseg4_mask, 0x40, 0x5, 0x3, PseudoVSOXSEG4EI64_V_M8_MF8_MASK }, // 4027
  { Intrinsic::riscv_vsoxseg4_mask, 0x40, 0x6, 0x0, PseudoVSOXSEG4EI64_V_M1_MF4_MASK }, // 4028
  { Intrinsic::riscv_vsoxseg4_mask, 0x40, 0x6, 0x1, PseudoVSOXSEG4EI64_V_M2_MF4_MASK }, // 4029
  { Intrinsic::riscv_vsoxseg4_mask, 0x40, 0x6, 0x2, PseudoVSOXSEG4EI64_V_M4_MF4_MASK }, // 4030
  { Intrinsic::riscv_vsoxseg4_mask, 0x40, 0x6, 0x3, PseudoVSOXSEG4EI64_V_M8_MF4_MASK }, // 4031
  { Intrinsic::riscv_vsoxseg4_mask, 0x40, 0x7, 0x0, PseudoVSOXSEG4EI64_V_M1_MF2_MASK }, // 4032
  { Intrinsic::riscv_vsoxseg4_mask, 0x40, 0x7, 0x1, PseudoVSOXSEG4EI64_V_M2_MF2_MASK }, // 4033
  { Intrinsic::riscv_vsoxseg4_mask, 0x40, 0x7, 0x2, PseudoVSOXSEG4EI64_V_M4_MF2_MASK }, // 4034
  { Intrinsic::riscv_vsoxseg4_mask, 0x40, 0x7, 0x3, PseudoVSOXSEG4EI64_V_M8_MF2_MASK }, // 4035
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x0, 0x0, PseudoVSOXSEG5EI8_V_M1_M1 }, // 4036
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x0, 0x1, PseudoVSOXSEG5EI8_V_M2_M1 }, // 4037
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x0, 0x2, PseudoVSOXSEG5EI8_V_M4_M1 }, // 4038
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x0, 0x3, PseudoVSOXSEG5EI8_V_M8_M1 }, // 4039
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x0, 0x5, PseudoVSOXSEG5EI8_V_MF8_M1 }, // 4040
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x0, 0x6, PseudoVSOXSEG5EI8_V_MF4_M1 }, // 4041
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x0, 0x7, PseudoVSOXSEG5EI8_V_MF2_M1 }, // 4042
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x5, 0x0, PseudoVSOXSEG5EI8_V_M1_MF8 }, // 4043
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x5, 0x1, PseudoVSOXSEG5EI8_V_M2_MF8 }, // 4044
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x5, 0x2, PseudoVSOXSEG5EI8_V_M4_MF8 }, // 4045
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x5, 0x3, PseudoVSOXSEG5EI8_V_M8_MF8 }, // 4046
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x5, 0x5, PseudoVSOXSEG5EI8_V_MF8_MF8 }, // 4047
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x5, 0x6, PseudoVSOXSEG5EI8_V_MF4_MF8 }, // 4048
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x5, 0x7, PseudoVSOXSEG5EI8_V_MF2_MF8 }, // 4049
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x6, 0x0, PseudoVSOXSEG5EI8_V_M1_MF4 }, // 4050
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x6, 0x1, PseudoVSOXSEG5EI8_V_M2_MF4 }, // 4051
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x6, 0x2, PseudoVSOXSEG5EI8_V_M4_MF4 }, // 4052
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x6, 0x3, PseudoVSOXSEG5EI8_V_M8_MF4 }, // 4053
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x6, 0x5, PseudoVSOXSEG5EI8_V_MF8_MF4 }, // 4054
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x6, 0x6, PseudoVSOXSEG5EI8_V_MF4_MF4 }, // 4055
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x6, 0x7, PseudoVSOXSEG5EI8_V_MF2_MF4 }, // 4056
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x7, 0x0, PseudoVSOXSEG5EI8_V_M1_MF2 }, // 4057
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x7, 0x1, PseudoVSOXSEG5EI8_V_M2_MF2 }, // 4058
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x7, 0x2, PseudoVSOXSEG5EI8_V_M4_MF2 }, // 4059
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x7, 0x3, PseudoVSOXSEG5EI8_V_M8_MF2 }, // 4060
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x7, 0x5, PseudoVSOXSEG5EI8_V_MF8_MF2 }, // 4061
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x7, 0x6, PseudoVSOXSEG5EI8_V_MF4_MF2 }, // 4062
  { Intrinsic::riscv_vsoxseg5, 0x8, 0x7, 0x7, PseudoVSOXSEG5EI8_V_MF2_MF2 }, // 4063
  { Intrinsic::riscv_vsoxseg5, 0x10, 0x0, 0x0, PseudoVSOXSEG5EI16_V_M1_M1 }, // 4064
  { Intrinsic::riscv_vsoxseg5, 0x10, 0x0, 0x1, PseudoVSOXSEG5EI16_V_M2_M1 }, // 4065
  { Intrinsic::riscv_vsoxseg5, 0x10, 0x0, 0x2, PseudoVSOXSEG5EI16_V_M4_M1 }, // 4066
  { Intrinsic::riscv_vsoxseg5, 0x10, 0x0, 0x3, PseudoVSOXSEG5EI16_V_M8_M1 }, // 4067
  { Intrinsic::riscv_vsoxseg5, 0x10, 0x0, 0x6, PseudoVSOXSEG5EI16_V_MF4_M1 }, // 4068
  { Intrinsic::riscv_vsoxseg5, 0x10, 0x0, 0x7, PseudoVSOXSEG5EI16_V_MF2_M1 }, // 4069
  { Intrinsic::riscv_vsoxseg5, 0x10, 0x5, 0x0, PseudoVSOXSEG5EI16_V_M1_MF8 }, // 4070
  { Intrinsic::riscv_vsoxseg5, 0x10, 0x5, 0x1, PseudoVSOXSEG5EI16_V_M2_MF8 }, // 4071
  { Intrinsic::riscv_vsoxseg5, 0x10, 0x5, 0x2, PseudoVSOXSEG5EI16_V_M4_MF8 }, // 4072
  { Intrinsic::riscv_vsoxseg5, 0x10, 0x5, 0x3, PseudoVSOXSEG5EI16_V_M8_MF8 }, // 4073
  { Intrinsic::riscv_vsoxseg5, 0x10, 0x5, 0x6, PseudoVSOXSEG5EI16_V_MF4_MF8 }, // 4074
  { Intrinsic::riscv_vsoxseg5, 0x10, 0x5, 0x7, PseudoVSOXSEG5EI16_V_MF2_MF8 }, // 4075
  { Intrinsic::riscv_vsoxseg5, 0x10, 0x6, 0x0, PseudoVSOXSEG5EI16_V_M1_MF4 }, // 4076
  { Intrinsic::riscv_vsoxseg5, 0x10, 0x6, 0x1, PseudoVSOXSEG5EI16_V_M2_MF4 }, // 4077
  { Intrinsic::riscv_vsoxseg5, 0x10, 0x6, 0x2, PseudoVSOXSEG5EI16_V_M4_MF4 }, // 4078
  { Intrinsic::riscv_vsoxseg5, 0x10, 0x6, 0x3, PseudoVSOXSEG5EI16_V_M8_MF4 }, // 4079
  { Intrinsic::riscv_vsoxseg5, 0x10, 0x6, 0x6, PseudoVSOXSEG5EI16_V_MF4_MF4 }, // 4080
  { Intrinsic::riscv_vsoxseg5, 0x10, 0x6, 0x7, PseudoVSOXSEG5EI16_V_MF2_MF4 }, // 4081
  { Intrinsic::riscv_vsoxseg5, 0x10, 0x7, 0x0, PseudoVSOXSEG5EI16_V_M1_MF2 }, // 4082
  { Intrinsic::riscv_vsoxseg5, 0x10, 0x7, 0x1, PseudoVSOXSEG5EI16_V_M2_MF2 }, // 4083
  { Intrinsic::riscv_vsoxseg5, 0x10, 0x7, 0x2, PseudoVSOXSEG5EI16_V_M4_MF2 }, // 4084
  { Intrinsic::riscv_vsoxseg5, 0x10, 0x7, 0x3, PseudoVSOXSEG5EI16_V_M8_MF2 }, // 4085
  { Intrinsic::riscv_vsoxseg5, 0x10, 0x7, 0x6, PseudoVSOXSEG5EI16_V_MF4_MF2 }, // 4086
  { Intrinsic::riscv_vsoxseg5, 0x10, 0x7, 0x7, PseudoVSOXSEG5EI16_V_MF2_MF2 }, // 4087
  { Intrinsic::riscv_vsoxseg5, 0x20, 0x0, 0x0, PseudoVSOXSEG5EI32_V_M1_M1 }, // 4088
  { Intrinsic::riscv_vsoxseg5, 0x20, 0x0, 0x1, PseudoVSOXSEG5EI32_V_M2_M1 }, // 4089
  { Intrinsic::riscv_vsoxseg5, 0x20, 0x0, 0x2, PseudoVSOXSEG5EI32_V_M4_M1 }, // 4090
  { Intrinsic::riscv_vsoxseg5, 0x20, 0x0, 0x3, PseudoVSOXSEG5EI32_V_M8_M1 }, // 4091
  { Intrinsic::riscv_vsoxseg5, 0x20, 0x0, 0x7, PseudoVSOXSEG5EI32_V_MF2_M1 }, // 4092
  { Intrinsic::riscv_vsoxseg5, 0x20, 0x5, 0x0, PseudoVSOXSEG5EI32_V_M1_MF8 }, // 4093
  { Intrinsic::riscv_vsoxseg5, 0x20, 0x5, 0x1, PseudoVSOXSEG5EI32_V_M2_MF8 }, // 4094
  { Intrinsic::riscv_vsoxseg5, 0x20, 0x5, 0x2, PseudoVSOXSEG5EI32_V_M4_MF8 }, // 4095
  { Intrinsic::riscv_vsoxseg5, 0x20, 0x5, 0x3, PseudoVSOXSEG5EI32_V_M8_MF8 }, // 4096
  { Intrinsic::riscv_vsoxseg5, 0x20, 0x5, 0x7, PseudoVSOXSEG5EI32_V_MF2_MF8 }, // 4097
  { Intrinsic::riscv_vsoxseg5, 0x20, 0x6, 0x0, PseudoVSOXSEG5EI32_V_M1_MF4 }, // 4098
  { Intrinsic::riscv_vsoxseg5, 0x20, 0x6, 0x1, PseudoVSOXSEG5EI32_V_M2_MF4 }, // 4099
  { Intrinsic::riscv_vsoxseg5, 0x20, 0x6, 0x2, PseudoVSOXSEG5EI32_V_M4_MF4 }, // 4100
  { Intrinsic::riscv_vsoxseg5, 0x20, 0x6, 0x3, PseudoVSOXSEG5EI32_V_M8_MF4 }, // 4101
  { Intrinsic::riscv_vsoxseg5, 0x20, 0x6, 0x7, PseudoVSOXSEG5EI32_V_MF2_MF4 }, // 4102
  { Intrinsic::riscv_vsoxseg5, 0x20, 0x7, 0x0, PseudoVSOXSEG5EI32_V_M1_MF2 }, // 4103
  { Intrinsic::riscv_vsoxseg5, 0x20, 0x7, 0x1, PseudoVSOXSEG5EI32_V_M2_MF2 }, // 4104
  { Intrinsic::riscv_vsoxseg5, 0x20, 0x7, 0x2, PseudoVSOXSEG5EI32_V_M4_MF2 }, // 4105
  { Intrinsic::riscv_vsoxseg5, 0x20, 0x7, 0x3, PseudoVSOXSEG5EI32_V_M8_MF2 }, // 4106
  { Intrinsic::riscv_vsoxseg5, 0x20, 0x7, 0x7, PseudoVSOXSEG5EI32_V_MF2_MF2 }, // 4107
  { Intrinsic::riscv_vsoxseg5, 0x40, 0x0, 0x0, PseudoVSOXSEG5EI64_V_M1_M1 }, // 4108
  { Intrinsic::riscv_vsoxseg5, 0x40, 0x0, 0x1, PseudoVSOXSEG5EI64_V_M2_M1 }, // 4109
  { Intrinsic::riscv_vsoxseg5, 0x40, 0x0, 0x2, PseudoVSOXSEG5EI64_V_M4_M1 }, // 4110
  { Intrinsic::riscv_vsoxseg5, 0x40, 0x0, 0x3, PseudoVSOXSEG5EI64_V_M8_M1 }, // 4111
  { Intrinsic::riscv_vsoxseg5, 0x40, 0x5, 0x0, PseudoVSOXSEG5EI64_V_M1_MF8 }, // 4112
  { Intrinsic::riscv_vsoxseg5, 0x40, 0x5, 0x1, PseudoVSOXSEG5EI64_V_M2_MF8 }, // 4113
  { Intrinsic::riscv_vsoxseg5, 0x40, 0x5, 0x2, PseudoVSOXSEG5EI64_V_M4_MF8 }, // 4114
  { Intrinsic::riscv_vsoxseg5, 0x40, 0x5, 0x3, PseudoVSOXSEG5EI64_V_M8_MF8 }, // 4115
  { Intrinsic::riscv_vsoxseg5, 0x40, 0x6, 0x0, PseudoVSOXSEG5EI64_V_M1_MF4 }, // 4116
  { Intrinsic::riscv_vsoxseg5, 0x40, 0x6, 0x1, PseudoVSOXSEG5EI64_V_M2_MF4 }, // 4117
  { Intrinsic::riscv_vsoxseg5, 0x40, 0x6, 0x2, PseudoVSOXSEG5EI64_V_M4_MF4 }, // 4118
  { Intrinsic::riscv_vsoxseg5, 0x40, 0x6, 0x3, PseudoVSOXSEG5EI64_V_M8_MF4 }, // 4119
  { Intrinsic::riscv_vsoxseg5, 0x40, 0x7, 0x0, PseudoVSOXSEG5EI64_V_M1_MF2 }, // 4120
  { Intrinsic::riscv_vsoxseg5, 0x40, 0x7, 0x1, PseudoVSOXSEG5EI64_V_M2_MF2 }, // 4121
  { Intrinsic::riscv_vsoxseg5, 0x40, 0x7, 0x2, PseudoVSOXSEG5EI64_V_M4_MF2 }, // 4122
  { Intrinsic::riscv_vsoxseg5, 0x40, 0x7, 0x3, PseudoVSOXSEG5EI64_V_M8_MF2 }, // 4123
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x0, 0x0, PseudoVSOXSEG5EI8_V_M1_M1_MASK }, // 4124
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x0, 0x1, PseudoVSOXSEG5EI8_V_M2_M1_MASK }, // 4125
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x0, 0x2, PseudoVSOXSEG5EI8_V_M4_M1_MASK }, // 4126
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x0, 0x3, PseudoVSOXSEG5EI8_V_M8_M1_MASK }, // 4127
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x0, 0x5, PseudoVSOXSEG5EI8_V_MF8_M1_MASK }, // 4128
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x0, 0x6, PseudoVSOXSEG5EI8_V_MF4_M1_MASK }, // 4129
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x0, 0x7, PseudoVSOXSEG5EI8_V_MF2_M1_MASK }, // 4130
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x5, 0x0, PseudoVSOXSEG5EI8_V_M1_MF8_MASK }, // 4131
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x5, 0x1, PseudoVSOXSEG5EI8_V_M2_MF8_MASK }, // 4132
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x5, 0x2, PseudoVSOXSEG5EI8_V_M4_MF8_MASK }, // 4133
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x5, 0x3, PseudoVSOXSEG5EI8_V_M8_MF8_MASK }, // 4134
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x5, 0x5, PseudoVSOXSEG5EI8_V_MF8_MF8_MASK }, // 4135
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x5, 0x6, PseudoVSOXSEG5EI8_V_MF4_MF8_MASK }, // 4136
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x5, 0x7, PseudoVSOXSEG5EI8_V_MF2_MF8_MASK }, // 4137
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x6, 0x0, PseudoVSOXSEG5EI8_V_M1_MF4_MASK }, // 4138
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x6, 0x1, PseudoVSOXSEG5EI8_V_M2_MF4_MASK }, // 4139
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x6, 0x2, PseudoVSOXSEG5EI8_V_M4_MF4_MASK }, // 4140
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x6, 0x3, PseudoVSOXSEG5EI8_V_M8_MF4_MASK }, // 4141
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x6, 0x5, PseudoVSOXSEG5EI8_V_MF8_MF4_MASK }, // 4142
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x6, 0x6, PseudoVSOXSEG5EI8_V_MF4_MF4_MASK }, // 4143
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x6, 0x7, PseudoVSOXSEG5EI8_V_MF2_MF4_MASK }, // 4144
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x7, 0x0, PseudoVSOXSEG5EI8_V_M1_MF2_MASK }, // 4145
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x7, 0x1, PseudoVSOXSEG5EI8_V_M2_MF2_MASK }, // 4146
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x7, 0x2, PseudoVSOXSEG5EI8_V_M4_MF2_MASK }, // 4147
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x7, 0x3, PseudoVSOXSEG5EI8_V_M8_MF2_MASK }, // 4148
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x7, 0x5, PseudoVSOXSEG5EI8_V_MF8_MF2_MASK }, // 4149
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x7, 0x6, PseudoVSOXSEG5EI8_V_MF4_MF2_MASK }, // 4150
  { Intrinsic::riscv_vsoxseg5_mask, 0x8, 0x7, 0x7, PseudoVSOXSEG5EI8_V_MF2_MF2_MASK }, // 4151
  { Intrinsic::riscv_vsoxseg5_mask, 0x10, 0x0, 0x0, PseudoVSOXSEG5EI16_V_M1_M1_MASK }, // 4152
  { Intrinsic::riscv_vsoxseg5_mask, 0x10, 0x0, 0x1, PseudoVSOXSEG5EI16_V_M2_M1_MASK }, // 4153
  { Intrinsic::riscv_vsoxseg5_mask, 0x10, 0x0, 0x2, PseudoVSOXSEG5EI16_V_M4_M1_MASK }, // 4154
  { Intrinsic::riscv_vsoxseg5_mask, 0x10, 0x0, 0x3, PseudoVSOXSEG5EI16_V_M8_M1_MASK }, // 4155
  { Intrinsic::riscv_vsoxseg5_mask, 0x10, 0x0, 0x6, PseudoVSOXSEG5EI16_V_MF4_M1_MASK }, // 4156
  { Intrinsic::riscv_vsoxseg5_mask, 0x10, 0x0, 0x7, PseudoVSOXSEG5EI16_V_MF2_M1_MASK }, // 4157
  { Intrinsic::riscv_vsoxseg5_mask, 0x10, 0x5, 0x0, PseudoVSOXSEG5EI16_V_M1_MF8_MASK }, // 4158
  { Intrinsic::riscv_vsoxseg5_mask, 0x10, 0x5, 0x1, PseudoVSOXSEG5EI16_V_M2_MF8_MASK }, // 4159
  { Intrinsic::riscv_vsoxseg5_mask, 0x10, 0x5, 0x2, PseudoVSOXSEG5EI16_V_M4_MF8_MASK }, // 4160
  { Intrinsic::riscv_vsoxseg5_mask, 0x10, 0x5, 0x3, PseudoVSOXSEG5EI16_V_M8_MF8_MASK }, // 4161
  { Intrinsic::riscv_vsoxseg5_mask, 0x10, 0x5, 0x6, PseudoVSOXSEG5EI16_V_MF4_MF8_MASK }, // 4162
  { Intrinsic::riscv_vsoxseg5_mask, 0x10, 0x5, 0x7, PseudoVSOXSEG5EI16_V_MF2_MF8_MASK }, // 4163
  { Intrinsic::riscv_vsoxseg5_mask, 0x10, 0x6, 0x0, PseudoVSOXSEG5EI16_V_M1_MF4_MASK }, // 4164
  { Intrinsic::riscv_vsoxseg5_mask, 0x10, 0x6, 0x1, PseudoVSOXSEG5EI16_V_M2_MF4_MASK }, // 4165
  { Intrinsic::riscv_vsoxseg5_mask, 0x10, 0x6, 0x2, PseudoVSOXSEG5EI16_V_M4_MF4_MASK }, // 4166
  { Intrinsic::riscv_vsoxseg5_mask, 0x10, 0x6, 0x3, PseudoVSOXSEG5EI16_V_M8_MF4_MASK }, // 4167
  { Intrinsic::riscv_vsoxseg5_mask, 0x10, 0x6, 0x6, PseudoVSOXSEG5EI16_V_MF4_MF4_MASK }, // 4168
  { Intrinsic::riscv_vsoxseg5_mask, 0x10, 0x6, 0x7, PseudoVSOXSEG5EI16_V_MF2_MF4_MASK }, // 4169
  { Intrinsic::riscv_vsoxseg5_mask, 0x10, 0x7, 0x0, PseudoVSOXSEG5EI16_V_M1_MF2_MASK }, // 4170
  { Intrinsic::riscv_vsoxseg5_mask, 0x10, 0x7, 0x1, PseudoVSOXSEG5EI16_V_M2_MF2_MASK }, // 4171
  { Intrinsic::riscv_vsoxseg5_mask, 0x10, 0x7, 0x2, PseudoVSOXSEG5EI16_V_M4_MF2_MASK }, // 4172
  { Intrinsic::riscv_vsoxseg5_mask, 0x10, 0x7, 0x3, PseudoVSOXSEG5EI16_V_M8_MF2_MASK }, // 4173
  { Intrinsic::riscv_vsoxseg5_mask, 0x10, 0x7, 0x6, PseudoVSOXSEG5EI16_V_MF4_MF2_MASK }, // 4174
  { Intrinsic::riscv_vsoxseg5_mask, 0x10, 0x7, 0x7, PseudoVSOXSEG5EI16_V_MF2_MF2_MASK }, // 4175
  { Intrinsic::riscv_vsoxseg5_mask, 0x20, 0x0, 0x0, PseudoVSOXSEG5EI32_V_M1_M1_MASK }, // 4176
  { Intrinsic::riscv_vsoxseg5_mask, 0x20, 0x0, 0x1, PseudoVSOXSEG5EI32_V_M2_M1_MASK }, // 4177
  { Intrinsic::riscv_vsoxseg5_mask, 0x20, 0x0, 0x2, PseudoVSOXSEG5EI32_V_M4_M1_MASK }, // 4178
  { Intrinsic::riscv_vsoxseg5_mask, 0x20, 0x0, 0x3, PseudoVSOXSEG5EI32_V_M8_M1_MASK }, // 4179
  { Intrinsic::riscv_vsoxseg5_mask, 0x20, 0x0, 0x7, PseudoVSOXSEG5EI32_V_MF2_M1_MASK }, // 4180
  { Intrinsic::riscv_vsoxseg5_mask, 0x20, 0x5, 0x0, PseudoVSOXSEG5EI32_V_M1_MF8_MASK }, // 4181
  { Intrinsic::riscv_vsoxseg5_mask, 0x20, 0x5, 0x1, PseudoVSOXSEG5EI32_V_M2_MF8_MASK }, // 4182
  { Intrinsic::riscv_vsoxseg5_mask, 0x20, 0x5, 0x2, PseudoVSOXSEG5EI32_V_M4_MF8_MASK }, // 4183
  { Intrinsic::riscv_vsoxseg5_mask, 0x20, 0x5, 0x3, PseudoVSOXSEG5EI32_V_M8_MF8_MASK }, // 4184
  { Intrinsic::riscv_vsoxseg5_mask, 0x20, 0x5, 0x7, PseudoVSOXSEG5EI32_V_MF2_MF8_MASK }, // 4185
  { Intrinsic::riscv_vsoxseg5_mask, 0x20, 0x6, 0x0, PseudoVSOXSEG5EI32_V_M1_MF4_MASK }, // 4186
  { Intrinsic::riscv_vsoxseg5_mask, 0x20, 0x6, 0x1, PseudoVSOXSEG5EI32_V_M2_MF4_MASK }, // 4187
  { Intrinsic::riscv_vsoxseg5_mask, 0x20, 0x6, 0x2, PseudoVSOXSEG5EI32_V_M4_MF4_MASK }, // 4188
  { Intrinsic::riscv_vsoxseg5_mask, 0x20, 0x6, 0x3, PseudoVSOXSEG5EI32_V_M8_MF4_MASK }, // 4189
  { Intrinsic::riscv_vsoxseg5_mask, 0x20, 0x6, 0x7, PseudoVSOXSEG5EI32_V_MF2_MF4_MASK }, // 4190
  { Intrinsic::riscv_vsoxseg5_mask, 0x20, 0x7, 0x0, PseudoVSOXSEG5EI32_V_M1_MF2_MASK }, // 4191
  { Intrinsic::riscv_vsoxseg5_mask, 0x20, 0x7, 0x1, PseudoVSOXSEG5EI32_V_M2_MF2_MASK }, // 4192
  { Intrinsic::riscv_vsoxseg5_mask, 0x20, 0x7, 0x2, PseudoVSOXSEG5EI32_V_M4_MF2_MASK }, // 4193
  { Intrinsic::riscv_vsoxseg5_mask, 0x20, 0x7, 0x3, PseudoVSOXSEG5EI32_V_M8_MF2_MASK }, // 4194
  { Intrinsic::riscv_vsoxseg5_mask, 0x20, 0x7, 0x7, PseudoVSOXSEG5EI32_V_MF2_MF2_MASK }, // 4195
  { Intrinsic::riscv_vsoxseg5_mask, 0x40, 0x0, 0x0, PseudoVSOXSEG5EI64_V_M1_M1_MASK }, // 4196
  { Intrinsic::riscv_vsoxseg5_mask, 0x40, 0x0, 0x1, PseudoVSOXSEG5EI64_V_M2_M1_MASK }, // 4197
  { Intrinsic::riscv_vsoxseg5_mask, 0x40, 0x0, 0x2, PseudoVSOXSEG5EI64_V_M4_M1_MASK }, // 4198
  { Intrinsic::riscv_vsoxseg5_mask, 0x40, 0x0, 0x3, PseudoVSOXSEG5EI64_V_M8_M1_MASK }, // 4199
  { Intrinsic::riscv_vsoxseg5_mask, 0x40, 0x5, 0x0, PseudoVSOXSEG5EI64_V_M1_MF8_MASK }, // 4200
  { Intrinsic::riscv_vsoxseg5_mask, 0x40, 0x5, 0x1, PseudoVSOXSEG5EI64_V_M2_MF8_MASK }, // 4201
  { Intrinsic::riscv_vsoxseg5_mask, 0x40, 0x5, 0x2, PseudoVSOXSEG5EI64_V_M4_MF8_MASK }, // 4202
  { Intrinsic::riscv_vsoxseg5_mask, 0x40, 0x5, 0x3, PseudoVSOXSEG5EI64_V_M8_MF8_MASK }, // 4203
  { Intrinsic::riscv_vsoxseg5_mask, 0x40, 0x6, 0x0, PseudoVSOXSEG5EI64_V_M1_MF4_MASK }, // 4204
  { Intrinsic::riscv_vsoxseg5_mask, 0x40, 0x6, 0x1, PseudoVSOXSEG5EI64_V_M2_MF4_MASK }, // 4205
  { Intrinsic::riscv_vsoxseg5_mask, 0x40, 0x6, 0x2, PseudoVSOXSEG5EI64_V_M4_MF4_MASK }, // 4206
  { Intrinsic::riscv_vsoxseg5_mask, 0x40, 0x6, 0x3, PseudoVSOXSEG5EI64_V_M8_MF4_MASK }, // 4207
  { Intrinsic::riscv_vsoxseg5_mask, 0x40, 0x7, 0x0, PseudoVSOXSEG5EI64_V_M1_MF2_MASK }, // 4208
  { Intrinsic::riscv_vsoxseg5_mask, 0x40, 0x7, 0x1, PseudoVSOXSEG5EI64_V_M2_MF2_MASK }, // 4209
  { Intrinsic::riscv_vsoxseg5_mask, 0x40, 0x7, 0x2, PseudoVSOXSEG5EI64_V_M4_MF2_MASK }, // 4210
  { Intrinsic::riscv_vsoxseg5_mask, 0x40, 0x7, 0x3, PseudoVSOXSEG5EI64_V_M8_MF2_MASK }, // 4211
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x0, 0x0, PseudoVSOXSEG6EI8_V_M1_M1 }, // 4212
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x0, 0x1, PseudoVSOXSEG6EI8_V_M2_M1 }, // 4213
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x0, 0x2, PseudoVSOXSEG6EI8_V_M4_M1 }, // 4214
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x0, 0x3, PseudoVSOXSEG6EI8_V_M8_M1 }, // 4215
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x0, 0x5, PseudoVSOXSEG6EI8_V_MF8_M1 }, // 4216
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x0, 0x6, PseudoVSOXSEG6EI8_V_MF4_M1 }, // 4217
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x0, 0x7, PseudoVSOXSEG6EI8_V_MF2_M1 }, // 4218
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x5, 0x0, PseudoVSOXSEG6EI8_V_M1_MF8 }, // 4219
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x5, 0x1, PseudoVSOXSEG6EI8_V_M2_MF8 }, // 4220
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x5, 0x2, PseudoVSOXSEG6EI8_V_M4_MF8 }, // 4221
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x5, 0x3, PseudoVSOXSEG6EI8_V_M8_MF8 }, // 4222
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x5, 0x5, PseudoVSOXSEG6EI8_V_MF8_MF8 }, // 4223
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x5, 0x6, PseudoVSOXSEG6EI8_V_MF4_MF8 }, // 4224
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x5, 0x7, PseudoVSOXSEG6EI8_V_MF2_MF8 }, // 4225
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x6, 0x0, PseudoVSOXSEG6EI8_V_M1_MF4 }, // 4226
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x6, 0x1, PseudoVSOXSEG6EI8_V_M2_MF4 }, // 4227
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x6, 0x2, PseudoVSOXSEG6EI8_V_M4_MF4 }, // 4228
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x6, 0x3, PseudoVSOXSEG6EI8_V_M8_MF4 }, // 4229
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x6, 0x5, PseudoVSOXSEG6EI8_V_MF8_MF4 }, // 4230
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x6, 0x6, PseudoVSOXSEG6EI8_V_MF4_MF4 }, // 4231
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x6, 0x7, PseudoVSOXSEG6EI8_V_MF2_MF4 }, // 4232
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x7, 0x0, PseudoVSOXSEG6EI8_V_M1_MF2 }, // 4233
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x7, 0x1, PseudoVSOXSEG6EI8_V_M2_MF2 }, // 4234
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x7, 0x2, PseudoVSOXSEG6EI8_V_M4_MF2 }, // 4235
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x7, 0x3, PseudoVSOXSEG6EI8_V_M8_MF2 }, // 4236
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x7, 0x5, PseudoVSOXSEG6EI8_V_MF8_MF2 }, // 4237
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x7, 0x6, PseudoVSOXSEG6EI8_V_MF4_MF2 }, // 4238
  { Intrinsic::riscv_vsoxseg6, 0x8, 0x7, 0x7, PseudoVSOXSEG6EI8_V_MF2_MF2 }, // 4239
  { Intrinsic::riscv_vsoxseg6, 0x10, 0x0, 0x0, PseudoVSOXSEG6EI16_V_M1_M1 }, // 4240
  { Intrinsic::riscv_vsoxseg6, 0x10, 0x0, 0x1, PseudoVSOXSEG6EI16_V_M2_M1 }, // 4241
  { Intrinsic::riscv_vsoxseg6, 0x10, 0x0, 0x2, PseudoVSOXSEG6EI16_V_M4_M1 }, // 4242
  { Intrinsic::riscv_vsoxseg6, 0x10, 0x0, 0x3, PseudoVSOXSEG6EI16_V_M8_M1 }, // 4243
  { Intrinsic::riscv_vsoxseg6, 0x10, 0x0, 0x6, PseudoVSOXSEG6EI16_V_MF4_M1 }, // 4244
  { Intrinsic::riscv_vsoxseg6, 0x10, 0x0, 0x7, PseudoVSOXSEG6EI16_V_MF2_M1 }, // 4245
  { Intrinsic::riscv_vsoxseg6, 0x10, 0x5, 0x0, PseudoVSOXSEG6EI16_V_M1_MF8 }, // 4246
  { Intrinsic::riscv_vsoxseg6, 0x10, 0x5, 0x1, PseudoVSOXSEG6EI16_V_M2_MF8 }, // 4247
  { Intrinsic::riscv_vsoxseg6, 0x10, 0x5, 0x2, PseudoVSOXSEG6EI16_V_M4_MF8 }, // 4248
  { Intrinsic::riscv_vsoxseg6, 0x10, 0x5, 0x3, PseudoVSOXSEG6EI16_V_M8_MF8 }, // 4249
  { Intrinsic::riscv_vsoxseg6, 0x10, 0x5, 0x6, PseudoVSOXSEG6EI16_V_MF4_MF8 }, // 4250
  { Intrinsic::riscv_vsoxseg6, 0x10, 0x5, 0x7, PseudoVSOXSEG6EI16_V_MF2_MF8 }, // 4251
  { Intrinsic::riscv_vsoxseg6, 0x10, 0x6, 0x0, PseudoVSOXSEG6EI16_V_M1_MF4 }, // 4252
  { Intrinsic::riscv_vsoxseg6, 0x10, 0x6, 0x1, PseudoVSOXSEG6EI16_V_M2_MF4 }, // 4253
  { Intrinsic::riscv_vsoxseg6, 0x10, 0x6, 0x2, PseudoVSOXSEG6EI16_V_M4_MF4 }, // 4254
  { Intrinsic::riscv_vsoxseg6, 0x10, 0x6, 0x3, PseudoVSOXSEG6EI16_V_M8_MF4 }, // 4255
  { Intrinsic::riscv_vsoxseg6, 0x10, 0x6, 0x6, PseudoVSOXSEG6EI16_V_MF4_MF4 }, // 4256
  { Intrinsic::riscv_vsoxseg6, 0x10, 0x6, 0x7, PseudoVSOXSEG6EI16_V_MF2_MF4 }, // 4257
  { Intrinsic::riscv_vsoxseg6, 0x10, 0x7, 0x0, PseudoVSOXSEG6EI16_V_M1_MF2 }, // 4258
  { Intrinsic::riscv_vsoxseg6, 0x10, 0x7, 0x1, PseudoVSOXSEG6EI16_V_M2_MF2 }, // 4259
  { Intrinsic::riscv_vsoxseg6, 0x10, 0x7, 0x2, PseudoVSOXSEG6EI16_V_M4_MF2 }, // 4260
  { Intrinsic::riscv_vsoxseg6, 0x10, 0x7, 0x3, PseudoVSOXSEG6EI16_V_M8_MF2 }, // 4261
  { Intrinsic::riscv_vsoxseg6, 0x10, 0x7, 0x6, PseudoVSOXSEG6EI16_V_MF4_MF2 }, // 4262
  { Intrinsic::riscv_vsoxseg6, 0x10, 0x7, 0x7, PseudoVSOXSEG6EI16_V_MF2_MF2 }, // 4263
  { Intrinsic::riscv_vsoxseg6, 0x20, 0x0, 0x0, PseudoVSOXSEG6EI32_V_M1_M1 }, // 4264
  { Intrinsic::riscv_vsoxseg6, 0x20, 0x0, 0x1, PseudoVSOXSEG6EI32_V_M2_M1 }, // 4265
  { Intrinsic::riscv_vsoxseg6, 0x20, 0x0, 0x2, PseudoVSOXSEG6EI32_V_M4_M1 }, // 4266
  { Intrinsic::riscv_vsoxseg6, 0x20, 0x0, 0x3, PseudoVSOXSEG6EI32_V_M8_M1 }, // 4267
  { Intrinsic::riscv_vsoxseg6, 0x20, 0x0, 0x7, PseudoVSOXSEG6EI32_V_MF2_M1 }, // 4268
  { Intrinsic::riscv_vsoxseg6, 0x20, 0x5, 0x0, PseudoVSOXSEG6EI32_V_M1_MF8 }, // 4269
  { Intrinsic::riscv_vsoxseg6, 0x20, 0x5, 0x1, PseudoVSOXSEG6EI32_V_M2_MF8 }, // 4270
  { Intrinsic::riscv_vsoxseg6, 0x20, 0x5, 0x2, PseudoVSOXSEG6EI32_V_M4_MF8 }, // 4271
  { Intrinsic::riscv_vsoxseg6, 0x20, 0x5, 0x3, PseudoVSOXSEG6EI32_V_M8_MF8 }, // 4272
  { Intrinsic::riscv_vsoxseg6, 0x20, 0x5, 0x7, PseudoVSOXSEG6EI32_V_MF2_MF8 }, // 4273
  { Intrinsic::riscv_vsoxseg6, 0x20, 0x6, 0x0, PseudoVSOXSEG6EI32_V_M1_MF4 }, // 4274
  { Intrinsic::riscv_vsoxseg6, 0x20, 0x6, 0x1, PseudoVSOXSEG6EI32_V_M2_MF4 }, // 4275
  { Intrinsic::riscv_vsoxseg6, 0x20, 0x6, 0x2, PseudoVSOXSEG6EI32_V_M4_MF4 }, // 4276
  { Intrinsic::riscv_vsoxseg6, 0x20, 0x6, 0x3, PseudoVSOXSEG6EI32_V_M8_MF4 }, // 4277
  { Intrinsic::riscv_vsoxseg6, 0x20, 0x6, 0x7, PseudoVSOXSEG6EI32_V_MF2_MF4 }, // 4278
  { Intrinsic::riscv_vsoxseg6, 0x20, 0x7, 0x0, PseudoVSOXSEG6EI32_V_M1_MF2 }, // 4279
  { Intrinsic::riscv_vsoxseg6, 0x20, 0x7, 0x1, PseudoVSOXSEG6EI32_V_M2_MF2 }, // 4280
  { Intrinsic::riscv_vsoxseg6, 0x20, 0x7, 0x2, PseudoVSOXSEG6EI32_V_M4_MF2 }, // 4281
  { Intrinsic::riscv_vsoxseg6, 0x20, 0x7, 0x3, PseudoVSOXSEG6EI32_V_M8_MF2 }, // 4282
  { Intrinsic::riscv_vsoxseg6, 0x20, 0x7, 0x7, PseudoVSOXSEG6EI32_V_MF2_MF2 }, // 4283
  { Intrinsic::riscv_vsoxseg6, 0x40, 0x0, 0x0, PseudoVSOXSEG6EI64_V_M1_M1 }, // 4284
  { Intrinsic::riscv_vsoxseg6, 0x40, 0x0, 0x1, PseudoVSOXSEG6EI64_V_M2_M1 }, // 4285
  { Intrinsic::riscv_vsoxseg6, 0x40, 0x0, 0x2, PseudoVSOXSEG6EI64_V_M4_M1 }, // 4286
  { Intrinsic::riscv_vsoxseg6, 0x40, 0x0, 0x3, PseudoVSOXSEG6EI64_V_M8_M1 }, // 4287
  { Intrinsic::riscv_vsoxseg6, 0x40, 0x5, 0x0, PseudoVSOXSEG6EI64_V_M1_MF8 }, // 4288
  { Intrinsic::riscv_vsoxseg6, 0x40, 0x5, 0x1, PseudoVSOXSEG6EI64_V_M2_MF8 }, // 4289
  { Intrinsic::riscv_vsoxseg6, 0x40, 0x5, 0x2, PseudoVSOXSEG6EI64_V_M4_MF8 }, // 4290
  { Intrinsic::riscv_vsoxseg6, 0x40, 0x5, 0x3, PseudoVSOXSEG6EI64_V_M8_MF8 }, // 4291
  { Intrinsic::riscv_vsoxseg6, 0x40, 0x6, 0x0, PseudoVSOXSEG6EI64_V_M1_MF4 }, // 4292
  { Intrinsic::riscv_vsoxseg6, 0x40, 0x6, 0x1, PseudoVSOXSEG6EI64_V_M2_MF4 }, // 4293
  { Intrinsic::riscv_vsoxseg6, 0x40, 0x6, 0x2, PseudoVSOXSEG6EI64_V_M4_MF4 }, // 4294
  { Intrinsic::riscv_vsoxseg6, 0x40, 0x6, 0x3, PseudoVSOXSEG6EI64_V_M8_MF4 }, // 4295
  { Intrinsic::riscv_vsoxseg6, 0x40, 0x7, 0x0, PseudoVSOXSEG6EI64_V_M1_MF2 }, // 4296
  { Intrinsic::riscv_vsoxseg6, 0x40, 0x7, 0x1, PseudoVSOXSEG6EI64_V_M2_MF2 }, // 4297
  { Intrinsic::riscv_vsoxseg6, 0x40, 0x7, 0x2, PseudoVSOXSEG6EI64_V_M4_MF2 }, // 4298
  { Intrinsic::riscv_vsoxseg6, 0x40, 0x7, 0x3, PseudoVSOXSEG6EI64_V_M8_MF2 }, // 4299
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x0, 0x0, PseudoVSOXSEG6EI8_V_M1_M1_MASK }, // 4300
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x0, 0x1, PseudoVSOXSEG6EI8_V_M2_M1_MASK }, // 4301
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x0, 0x2, PseudoVSOXSEG6EI8_V_M4_M1_MASK }, // 4302
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x0, 0x3, PseudoVSOXSEG6EI8_V_M8_M1_MASK }, // 4303
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x0, 0x5, PseudoVSOXSEG6EI8_V_MF8_M1_MASK }, // 4304
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x0, 0x6, PseudoVSOXSEG6EI8_V_MF4_M1_MASK }, // 4305
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x0, 0x7, PseudoVSOXSEG6EI8_V_MF2_M1_MASK }, // 4306
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x5, 0x0, PseudoVSOXSEG6EI8_V_M1_MF8_MASK }, // 4307
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x5, 0x1, PseudoVSOXSEG6EI8_V_M2_MF8_MASK }, // 4308
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x5, 0x2, PseudoVSOXSEG6EI8_V_M4_MF8_MASK }, // 4309
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x5, 0x3, PseudoVSOXSEG6EI8_V_M8_MF8_MASK }, // 4310
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x5, 0x5, PseudoVSOXSEG6EI8_V_MF8_MF8_MASK }, // 4311
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x5, 0x6, PseudoVSOXSEG6EI8_V_MF4_MF8_MASK }, // 4312
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x5, 0x7, PseudoVSOXSEG6EI8_V_MF2_MF8_MASK }, // 4313
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x6, 0x0, PseudoVSOXSEG6EI8_V_M1_MF4_MASK }, // 4314
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x6, 0x1, PseudoVSOXSEG6EI8_V_M2_MF4_MASK }, // 4315
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x6, 0x2, PseudoVSOXSEG6EI8_V_M4_MF4_MASK }, // 4316
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x6, 0x3, PseudoVSOXSEG6EI8_V_M8_MF4_MASK }, // 4317
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x6, 0x5, PseudoVSOXSEG6EI8_V_MF8_MF4_MASK }, // 4318
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x6, 0x6, PseudoVSOXSEG6EI8_V_MF4_MF4_MASK }, // 4319
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x6, 0x7, PseudoVSOXSEG6EI8_V_MF2_MF4_MASK }, // 4320
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x7, 0x0, PseudoVSOXSEG6EI8_V_M1_MF2_MASK }, // 4321
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x7, 0x1, PseudoVSOXSEG6EI8_V_M2_MF2_MASK }, // 4322
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x7, 0x2, PseudoVSOXSEG6EI8_V_M4_MF2_MASK }, // 4323
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x7, 0x3, PseudoVSOXSEG6EI8_V_M8_MF2_MASK }, // 4324
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x7, 0x5, PseudoVSOXSEG6EI8_V_MF8_MF2_MASK }, // 4325
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x7, 0x6, PseudoVSOXSEG6EI8_V_MF4_MF2_MASK }, // 4326
  { Intrinsic::riscv_vsoxseg6_mask, 0x8, 0x7, 0x7, PseudoVSOXSEG6EI8_V_MF2_MF2_MASK }, // 4327
  { Intrinsic::riscv_vsoxseg6_mask, 0x10, 0x0, 0x0, PseudoVSOXSEG6EI16_V_M1_M1_MASK }, // 4328
  { Intrinsic::riscv_vsoxseg6_mask, 0x10, 0x0, 0x1, PseudoVSOXSEG6EI16_V_M2_M1_MASK }, // 4329
  { Intrinsic::riscv_vsoxseg6_mask, 0x10, 0x0, 0x2, PseudoVSOXSEG6EI16_V_M4_M1_MASK }, // 4330
  { Intrinsic::riscv_vsoxseg6_mask, 0x10, 0x0, 0x3, PseudoVSOXSEG6EI16_V_M8_M1_MASK }, // 4331
  { Intrinsic::riscv_vsoxseg6_mask, 0x10, 0x0, 0x6, PseudoVSOXSEG6EI16_V_MF4_M1_MASK }, // 4332
  { Intrinsic::riscv_vsoxseg6_mask, 0x10, 0x0, 0x7, PseudoVSOXSEG6EI16_V_MF2_M1_MASK }, // 4333
  { Intrinsic::riscv_vsoxseg6_mask, 0x10, 0x5, 0x0, PseudoVSOXSEG6EI16_V_M1_MF8_MASK }, // 4334
  { Intrinsic::riscv_vsoxseg6_mask, 0x10, 0x5, 0x1, PseudoVSOXSEG6EI16_V_M2_MF8_MASK }, // 4335
  { Intrinsic::riscv_vsoxseg6_mask, 0x10, 0x5, 0x2, PseudoVSOXSEG6EI16_V_M4_MF8_MASK }, // 4336
  { Intrinsic::riscv_vsoxseg6_mask, 0x10, 0x5, 0x3, PseudoVSOXSEG6EI16_V_M8_MF8_MASK }, // 4337
  { Intrinsic::riscv_vsoxseg6_mask, 0x10, 0x5, 0x6, PseudoVSOXSEG6EI16_V_MF4_MF8_MASK }, // 4338
  { Intrinsic::riscv_vsoxseg6_mask, 0x10, 0x5, 0x7, PseudoVSOXSEG6EI16_V_MF2_MF8_MASK }, // 4339
  { Intrinsic::riscv_vsoxseg6_mask, 0x10, 0x6, 0x0, PseudoVSOXSEG6EI16_V_M1_MF4_MASK }, // 4340
  { Intrinsic::riscv_vsoxseg6_mask, 0x10, 0x6, 0x1, PseudoVSOXSEG6EI16_V_M2_MF4_MASK }, // 4341
  { Intrinsic::riscv_vsoxseg6_mask, 0x10, 0x6, 0x2, PseudoVSOXSEG6EI16_V_M4_MF4_MASK }, // 4342
  { Intrinsic::riscv_vsoxseg6_mask, 0x10, 0x6, 0x3, PseudoVSOXSEG6EI16_V_M8_MF4_MASK }, // 4343
  { Intrinsic::riscv_vsoxseg6_mask, 0x10, 0x6, 0x6, PseudoVSOXSEG6EI16_V_MF4_MF4_MASK }, // 4344
  { Intrinsic::riscv_vsoxseg6_mask, 0x10, 0x6, 0x7, PseudoVSOXSEG6EI16_V_MF2_MF4_MASK }, // 4345
  { Intrinsic::riscv_vsoxseg6_mask, 0x10, 0x7, 0x0, PseudoVSOXSEG6EI16_V_M1_MF2_MASK }, // 4346
  { Intrinsic::riscv_vsoxseg6_mask, 0x10, 0x7, 0x1, PseudoVSOXSEG6EI16_V_M2_MF2_MASK }, // 4347
  { Intrinsic::riscv_vsoxseg6_mask, 0x10, 0x7, 0x2, PseudoVSOXSEG6EI16_V_M4_MF2_MASK }, // 4348
  { Intrinsic::riscv_vsoxseg6_mask, 0x10, 0x7, 0x3, PseudoVSOXSEG6EI16_V_M8_MF2_MASK }, // 4349
  { Intrinsic::riscv_vsoxseg6_mask, 0x10, 0x7, 0x6, PseudoVSOXSEG6EI16_V_MF4_MF2_MASK }, // 4350
  { Intrinsic::riscv_vsoxseg6_mask, 0x10, 0x7, 0x7, PseudoVSOXSEG6EI16_V_MF2_MF2_MASK }, // 4351
  { Intrinsic::riscv_vsoxseg6_mask, 0x20, 0x0, 0x0, PseudoVSOXSEG6EI32_V_M1_M1_MASK }, // 4352
  { Intrinsic::riscv_vsoxseg6_mask, 0x20, 0x0, 0x1, PseudoVSOXSEG6EI32_V_M2_M1_MASK }, // 4353
  { Intrinsic::riscv_vsoxseg6_mask, 0x20, 0x0, 0x2, PseudoVSOXSEG6EI32_V_M4_M1_MASK }, // 4354
  { Intrinsic::riscv_vsoxseg6_mask, 0x20, 0x0, 0x3, PseudoVSOXSEG6EI32_V_M8_M1_MASK }, // 4355
  { Intrinsic::riscv_vsoxseg6_mask, 0x20, 0x0, 0x7, PseudoVSOXSEG6EI32_V_MF2_M1_MASK }, // 4356
  { Intrinsic::riscv_vsoxseg6_mask, 0x20, 0x5, 0x0, PseudoVSOXSEG6EI32_V_M1_MF8_MASK }, // 4357
  { Intrinsic::riscv_vsoxseg6_mask, 0x20, 0x5, 0x1, PseudoVSOXSEG6EI32_V_M2_MF8_MASK }, // 4358
  { Intrinsic::riscv_vsoxseg6_mask, 0x20, 0x5, 0x2, PseudoVSOXSEG6EI32_V_M4_MF8_MASK }, // 4359
  { Intrinsic::riscv_vsoxseg6_mask, 0x20, 0x5, 0x3, PseudoVSOXSEG6EI32_V_M8_MF8_MASK }, // 4360
  { Intrinsic::riscv_vsoxseg6_mask, 0x20, 0x5, 0x7, PseudoVSOXSEG6EI32_V_MF2_MF8_MASK }, // 4361
  { Intrinsic::riscv_vsoxseg6_mask, 0x20, 0x6, 0x0, PseudoVSOXSEG6EI32_V_M1_MF4_MASK }, // 4362
  { Intrinsic::riscv_vsoxseg6_mask, 0x20, 0x6, 0x1, PseudoVSOXSEG6EI32_V_M2_MF4_MASK }, // 4363
  { Intrinsic::riscv_vsoxseg6_mask, 0x20, 0x6, 0x2, PseudoVSOXSEG6EI32_V_M4_MF4_MASK }, // 4364
  { Intrinsic::riscv_vsoxseg6_mask, 0x20, 0x6, 0x3, PseudoVSOXSEG6EI32_V_M8_MF4_MASK }, // 4365
  { Intrinsic::riscv_vsoxseg6_mask, 0x20, 0x6, 0x7, PseudoVSOXSEG6EI32_V_MF2_MF4_MASK }, // 4366
  { Intrinsic::riscv_vsoxseg6_mask, 0x20, 0x7, 0x0, PseudoVSOXSEG6EI32_V_M1_MF2_MASK }, // 4367
  { Intrinsic::riscv_vsoxseg6_mask, 0x20, 0x7, 0x1, PseudoVSOXSEG6EI32_V_M2_MF2_MASK }, // 4368
  { Intrinsic::riscv_vsoxseg6_mask, 0x20, 0x7, 0x2, PseudoVSOXSEG6EI32_V_M4_MF2_MASK }, // 4369
  { Intrinsic::riscv_vsoxseg6_mask, 0x20, 0x7, 0x3, PseudoVSOXSEG6EI32_V_M8_MF2_MASK }, // 4370
  { Intrinsic::riscv_vsoxseg6_mask, 0x20, 0x7, 0x7, PseudoVSOXSEG6EI32_V_MF2_MF2_MASK }, // 4371
  { Intrinsic::riscv_vsoxseg6_mask, 0x40, 0x0, 0x0, PseudoVSOXSEG6EI64_V_M1_M1_MASK }, // 4372
  { Intrinsic::riscv_vsoxseg6_mask, 0x40, 0x0, 0x1, PseudoVSOXSEG6EI64_V_M2_M1_MASK }, // 4373
  { Intrinsic::riscv_vsoxseg6_mask, 0x40, 0x0, 0x2, PseudoVSOXSEG6EI64_V_M4_M1_MASK }, // 4374
  { Intrinsic::riscv_vsoxseg6_mask, 0x40, 0x0, 0x3, PseudoVSOXSEG6EI64_V_M8_M1_MASK }, // 4375
  { Intrinsic::riscv_vsoxseg6_mask, 0x40, 0x5, 0x0, PseudoVSOXSEG6EI64_V_M1_MF8_MASK }, // 4376
  { Intrinsic::riscv_vsoxseg6_mask, 0x40, 0x5, 0x1, PseudoVSOXSEG6EI64_V_M2_MF8_MASK }, // 4377
  { Intrinsic::riscv_vsoxseg6_mask, 0x40, 0x5, 0x2, PseudoVSOXSEG6EI64_V_M4_MF8_MASK }, // 4378
  { Intrinsic::riscv_vsoxseg6_mask, 0x40, 0x5, 0x3, PseudoVSOXSEG6EI64_V_M8_MF8_MASK }, // 4379
  { Intrinsic::riscv_vsoxseg6_mask, 0x40, 0x6, 0x0, PseudoVSOXSEG6EI64_V_M1_MF4_MASK }, // 4380
  { Intrinsic::riscv_vsoxseg6_mask, 0x40, 0x6, 0x1, PseudoVSOXSEG6EI64_V_M2_MF4_MASK }, // 4381
  { Intrinsic::riscv_vsoxseg6_mask, 0x40, 0x6, 0x2, PseudoVSOXSEG6EI64_V_M4_MF4_MASK }, // 4382
  { Intrinsic::riscv_vsoxseg6_mask, 0x40, 0x6, 0x3, PseudoVSOXSEG6EI64_V_M8_MF4_MASK }, // 4383
  { Intrinsic::riscv_vsoxseg6_mask, 0x40, 0x7, 0x0, PseudoVSOXSEG6EI64_V_M1_MF2_MASK }, // 4384
  { Intrinsic::riscv_vsoxseg6_mask, 0x40, 0x7, 0x1, PseudoVSOXSEG6EI64_V_M2_MF2_MASK }, // 4385
  { Intrinsic::riscv_vsoxseg6_mask, 0x40, 0x7, 0x2, PseudoVSOXSEG6EI64_V_M4_MF2_MASK }, // 4386
  { Intrinsic::riscv_vsoxseg6_mask, 0x40, 0x7, 0x3, PseudoVSOXSEG6EI64_V_M8_MF2_MASK }, // 4387
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x0, 0x0, PseudoVSOXSEG7EI8_V_M1_M1 }, // 4388
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x0, 0x1, PseudoVSOXSEG7EI8_V_M2_M1 }, // 4389
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x0, 0x2, PseudoVSOXSEG7EI8_V_M4_M1 }, // 4390
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x0, 0x3, PseudoVSOXSEG7EI8_V_M8_M1 }, // 4391
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x0, 0x5, PseudoVSOXSEG7EI8_V_MF8_M1 }, // 4392
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x0, 0x6, PseudoVSOXSEG7EI8_V_MF4_M1 }, // 4393
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x0, 0x7, PseudoVSOXSEG7EI8_V_MF2_M1 }, // 4394
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x5, 0x0, PseudoVSOXSEG7EI8_V_M1_MF8 }, // 4395
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x5, 0x1, PseudoVSOXSEG7EI8_V_M2_MF8 }, // 4396
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x5, 0x2, PseudoVSOXSEG7EI8_V_M4_MF8 }, // 4397
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x5, 0x3, PseudoVSOXSEG7EI8_V_M8_MF8 }, // 4398
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x5, 0x5, PseudoVSOXSEG7EI8_V_MF8_MF8 }, // 4399
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x5, 0x6, PseudoVSOXSEG7EI8_V_MF4_MF8 }, // 4400
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x5, 0x7, PseudoVSOXSEG7EI8_V_MF2_MF8 }, // 4401
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x6, 0x0, PseudoVSOXSEG7EI8_V_M1_MF4 }, // 4402
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x6, 0x1, PseudoVSOXSEG7EI8_V_M2_MF4 }, // 4403
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x6, 0x2, PseudoVSOXSEG7EI8_V_M4_MF4 }, // 4404
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x6, 0x3, PseudoVSOXSEG7EI8_V_M8_MF4 }, // 4405
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x6, 0x5, PseudoVSOXSEG7EI8_V_MF8_MF4 }, // 4406
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x6, 0x6, PseudoVSOXSEG7EI8_V_MF4_MF4 }, // 4407
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x6, 0x7, PseudoVSOXSEG7EI8_V_MF2_MF4 }, // 4408
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x7, 0x0, PseudoVSOXSEG7EI8_V_M1_MF2 }, // 4409
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x7, 0x1, PseudoVSOXSEG7EI8_V_M2_MF2 }, // 4410
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x7, 0x2, PseudoVSOXSEG7EI8_V_M4_MF2 }, // 4411
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x7, 0x3, PseudoVSOXSEG7EI8_V_M8_MF2 }, // 4412
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x7, 0x5, PseudoVSOXSEG7EI8_V_MF8_MF2 }, // 4413
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x7, 0x6, PseudoVSOXSEG7EI8_V_MF4_MF2 }, // 4414
  { Intrinsic::riscv_vsoxseg7, 0x8, 0x7, 0x7, PseudoVSOXSEG7EI8_V_MF2_MF2 }, // 4415
  { Intrinsic::riscv_vsoxseg7, 0x10, 0x0, 0x0, PseudoVSOXSEG7EI16_V_M1_M1 }, // 4416
  { Intrinsic::riscv_vsoxseg7, 0x10, 0x0, 0x1, PseudoVSOXSEG7EI16_V_M2_M1 }, // 4417
  { Intrinsic::riscv_vsoxseg7, 0x10, 0x0, 0x2, PseudoVSOXSEG7EI16_V_M4_M1 }, // 4418
  { Intrinsic::riscv_vsoxseg7, 0x10, 0x0, 0x3, PseudoVSOXSEG7EI16_V_M8_M1 }, // 4419
  { Intrinsic::riscv_vsoxseg7, 0x10, 0x0, 0x6, PseudoVSOXSEG7EI16_V_MF4_M1 }, // 4420
  { Intrinsic::riscv_vsoxseg7, 0x10, 0x0, 0x7, PseudoVSOXSEG7EI16_V_MF2_M1 }, // 4421
  { Intrinsic::riscv_vsoxseg7, 0x10, 0x5, 0x0, PseudoVSOXSEG7EI16_V_M1_MF8 }, // 4422
  { Intrinsic::riscv_vsoxseg7, 0x10, 0x5, 0x1, PseudoVSOXSEG7EI16_V_M2_MF8 }, // 4423
  { Intrinsic::riscv_vsoxseg7, 0x10, 0x5, 0x2, PseudoVSOXSEG7EI16_V_M4_MF8 }, // 4424
  { Intrinsic::riscv_vsoxseg7, 0x10, 0x5, 0x3, PseudoVSOXSEG7EI16_V_M8_MF8 }, // 4425
  { Intrinsic::riscv_vsoxseg7, 0x10, 0x5, 0x6, PseudoVSOXSEG7EI16_V_MF4_MF8 }, // 4426
  { Intrinsic::riscv_vsoxseg7, 0x10, 0x5, 0x7, PseudoVSOXSEG7EI16_V_MF2_MF8 }, // 4427
  { Intrinsic::riscv_vsoxseg7, 0x10, 0x6, 0x0, PseudoVSOXSEG7EI16_V_M1_MF4 }, // 4428
  { Intrinsic::riscv_vsoxseg7, 0x10, 0x6, 0x1, PseudoVSOXSEG7EI16_V_M2_MF4 }, // 4429
  { Intrinsic::riscv_vsoxseg7, 0x10, 0x6, 0x2, PseudoVSOXSEG7EI16_V_M4_MF4 }, // 4430
  { Intrinsic::riscv_vsoxseg7, 0x10, 0x6, 0x3, PseudoVSOXSEG7EI16_V_M8_MF4 }, // 4431
  { Intrinsic::riscv_vsoxseg7, 0x10, 0x6, 0x6, PseudoVSOXSEG7EI16_V_MF4_MF4 }, // 4432
  { Intrinsic::riscv_vsoxseg7, 0x10, 0x6, 0x7, PseudoVSOXSEG7EI16_V_MF2_MF4 }, // 4433
  { Intrinsic::riscv_vsoxseg7, 0x10, 0x7, 0x0, PseudoVSOXSEG7EI16_V_M1_MF2 }, // 4434
  { Intrinsic::riscv_vsoxseg7, 0x10, 0x7, 0x1, PseudoVSOXSEG7EI16_V_M2_MF2 }, // 4435
  { Intrinsic::riscv_vsoxseg7, 0x10, 0x7, 0x2, PseudoVSOXSEG7EI16_V_M4_MF2 }, // 4436
  { Intrinsic::riscv_vsoxseg7, 0x10, 0x7, 0x3, PseudoVSOXSEG7EI16_V_M8_MF2 }, // 4437
  { Intrinsic::riscv_vsoxseg7, 0x10, 0x7, 0x6, PseudoVSOXSEG7EI16_V_MF4_MF2 }, // 4438
  { Intrinsic::riscv_vsoxseg7, 0x10, 0x7, 0x7, PseudoVSOXSEG7EI16_V_MF2_MF2 }, // 4439
  { Intrinsic::riscv_vsoxseg7, 0x20, 0x0, 0x0, PseudoVSOXSEG7EI32_V_M1_M1 }, // 4440
  { Intrinsic::riscv_vsoxseg7, 0x20, 0x0, 0x1, PseudoVSOXSEG7EI32_V_M2_M1 }, // 4441
  { Intrinsic::riscv_vsoxseg7, 0x20, 0x0, 0x2, PseudoVSOXSEG7EI32_V_M4_M1 }, // 4442
  { Intrinsic::riscv_vsoxseg7, 0x20, 0x0, 0x3, PseudoVSOXSEG7EI32_V_M8_M1 }, // 4443
  { Intrinsic::riscv_vsoxseg7, 0x20, 0x0, 0x7, PseudoVSOXSEG7EI32_V_MF2_M1 }, // 4444
  { Intrinsic::riscv_vsoxseg7, 0x20, 0x5, 0x0, PseudoVSOXSEG7EI32_V_M1_MF8 }, // 4445
  { Intrinsic::riscv_vsoxseg7, 0x20, 0x5, 0x1, PseudoVSOXSEG7EI32_V_M2_MF8 }, // 4446
  { Intrinsic::riscv_vsoxseg7, 0x20, 0x5, 0x2, PseudoVSOXSEG7EI32_V_M4_MF8 }, // 4447
  { Intrinsic::riscv_vsoxseg7, 0x20, 0x5, 0x3, PseudoVSOXSEG7EI32_V_M8_MF8 }, // 4448
  { Intrinsic::riscv_vsoxseg7, 0x20, 0x5, 0x7, PseudoVSOXSEG7EI32_V_MF2_MF8 }, // 4449
  { Intrinsic::riscv_vsoxseg7, 0x20, 0x6, 0x0, PseudoVSOXSEG7EI32_V_M1_MF4 }, // 4450
  { Intrinsic::riscv_vsoxseg7, 0x20, 0x6, 0x1, PseudoVSOXSEG7EI32_V_M2_MF4 }, // 4451
  { Intrinsic::riscv_vsoxseg7, 0x20, 0x6, 0x2, PseudoVSOXSEG7EI32_V_M4_MF4 }, // 4452
  { Intrinsic::riscv_vsoxseg7, 0x20, 0x6, 0x3, PseudoVSOXSEG7EI32_V_M8_MF4 }, // 4453
  { Intrinsic::riscv_vsoxseg7, 0x20, 0x6, 0x7, PseudoVSOXSEG7EI32_V_MF2_MF4 }, // 4454
  { Intrinsic::riscv_vsoxseg7, 0x20, 0x7, 0x0, PseudoVSOXSEG7EI32_V_M1_MF2 }, // 4455
  { Intrinsic::riscv_vsoxseg7, 0x20, 0x7, 0x1, PseudoVSOXSEG7EI32_V_M2_MF2 }, // 4456
  { Intrinsic::riscv_vsoxseg7, 0x20, 0x7, 0x2, PseudoVSOXSEG7EI32_V_M4_MF2 }, // 4457
  { Intrinsic::riscv_vsoxseg7, 0x20, 0x7, 0x3, PseudoVSOXSEG7EI32_V_M8_MF2 }, // 4458
  { Intrinsic::riscv_vsoxseg7, 0x20, 0x7, 0x7, PseudoVSOXSEG7EI32_V_MF2_MF2 }, // 4459
  { Intrinsic::riscv_vsoxseg7, 0x40, 0x0, 0x0, PseudoVSOXSEG7EI64_V_M1_M1 }, // 4460
  { Intrinsic::riscv_vsoxseg7, 0x40, 0x0, 0x1, PseudoVSOXSEG7EI64_V_M2_M1 }, // 4461
  { Intrinsic::riscv_vsoxseg7, 0x40, 0x0, 0x2, PseudoVSOXSEG7EI64_V_M4_M1 }, // 4462
  { Intrinsic::riscv_vsoxseg7, 0x40, 0x0, 0x3, PseudoVSOXSEG7EI64_V_M8_M1 }, // 4463
  { Intrinsic::riscv_vsoxseg7, 0x40, 0x5, 0x0, PseudoVSOXSEG7EI64_V_M1_MF8 }, // 4464
  { Intrinsic::riscv_vsoxseg7, 0x40, 0x5, 0x1, PseudoVSOXSEG7EI64_V_M2_MF8 }, // 4465
  { Intrinsic::riscv_vsoxseg7, 0x40, 0x5, 0x2, PseudoVSOXSEG7EI64_V_M4_MF8 }, // 4466
  { Intrinsic::riscv_vsoxseg7, 0x40, 0x5, 0x3, PseudoVSOXSEG7EI64_V_M8_MF8 }, // 4467
  { Intrinsic::riscv_vsoxseg7, 0x40, 0x6, 0x0, PseudoVSOXSEG7EI64_V_M1_MF4 }, // 4468
  { Intrinsic::riscv_vsoxseg7, 0x40, 0x6, 0x1, PseudoVSOXSEG7EI64_V_M2_MF4 }, // 4469
  { Intrinsic::riscv_vsoxseg7, 0x40, 0x6, 0x2, PseudoVSOXSEG7EI64_V_M4_MF4 }, // 4470
  { Intrinsic::riscv_vsoxseg7, 0x40, 0x6, 0x3, PseudoVSOXSEG7EI64_V_M8_MF4 }, // 4471
  { Intrinsic::riscv_vsoxseg7, 0x40, 0x7, 0x0, PseudoVSOXSEG7EI64_V_M1_MF2 }, // 4472
  { Intrinsic::riscv_vsoxseg7, 0x40, 0x7, 0x1, PseudoVSOXSEG7EI64_V_M2_MF2 }, // 4473
  { Intrinsic::riscv_vsoxseg7, 0x40, 0x7, 0x2, PseudoVSOXSEG7EI64_V_M4_MF2 }, // 4474
  { Intrinsic::riscv_vsoxseg7, 0x40, 0x7, 0x3, PseudoVSOXSEG7EI64_V_M8_MF2 }, // 4475
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x0, 0x0, PseudoVSOXSEG7EI8_V_M1_M1_MASK }, // 4476
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x0, 0x1, PseudoVSOXSEG7EI8_V_M2_M1_MASK }, // 4477
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x0, 0x2, PseudoVSOXSEG7EI8_V_M4_M1_MASK }, // 4478
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x0, 0x3, PseudoVSOXSEG7EI8_V_M8_M1_MASK }, // 4479
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x0, 0x5, PseudoVSOXSEG7EI8_V_MF8_M1_MASK }, // 4480
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x0, 0x6, PseudoVSOXSEG7EI8_V_MF4_M1_MASK }, // 4481
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x0, 0x7, PseudoVSOXSEG7EI8_V_MF2_M1_MASK }, // 4482
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x5, 0x0, PseudoVSOXSEG7EI8_V_M1_MF8_MASK }, // 4483
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x5, 0x1, PseudoVSOXSEG7EI8_V_M2_MF8_MASK }, // 4484
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x5, 0x2, PseudoVSOXSEG7EI8_V_M4_MF8_MASK }, // 4485
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x5, 0x3, PseudoVSOXSEG7EI8_V_M8_MF8_MASK }, // 4486
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x5, 0x5, PseudoVSOXSEG7EI8_V_MF8_MF8_MASK }, // 4487
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x5, 0x6, PseudoVSOXSEG7EI8_V_MF4_MF8_MASK }, // 4488
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x5, 0x7, PseudoVSOXSEG7EI8_V_MF2_MF8_MASK }, // 4489
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x6, 0x0, PseudoVSOXSEG7EI8_V_M1_MF4_MASK }, // 4490
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x6, 0x1, PseudoVSOXSEG7EI8_V_M2_MF4_MASK }, // 4491
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x6, 0x2, PseudoVSOXSEG7EI8_V_M4_MF4_MASK }, // 4492
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x6, 0x3, PseudoVSOXSEG7EI8_V_M8_MF4_MASK }, // 4493
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x6, 0x5, PseudoVSOXSEG7EI8_V_MF8_MF4_MASK }, // 4494
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x6, 0x6, PseudoVSOXSEG7EI8_V_MF4_MF4_MASK }, // 4495
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x6, 0x7, PseudoVSOXSEG7EI8_V_MF2_MF4_MASK }, // 4496
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x7, 0x0, PseudoVSOXSEG7EI8_V_M1_MF2_MASK }, // 4497
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x7, 0x1, PseudoVSOXSEG7EI8_V_M2_MF2_MASK }, // 4498
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x7, 0x2, PseudoVSOXSEG7EI8_V_M4_MF2_MASK }, // 4499
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x7, 0x3, PseudoVSOXSEG7EI8_V_M8_MF2_MASK }, // 4500
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x7, 0x5, PseudoVSOXSEG7EI8_V_MF8_MF2_MASK }, // 4501
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x7, 0x6, PseudoVSOXSEG7EI8_V_MF4_MF2_MASK }, // 4502
  { Intrinsic::riscv_vsoxseg7_mask, 0x8, 0x7, 0x7, PseudoVSOXSEG7EI8_V_MF2_MF2_MASK }, // 4503
  { Intrinsic::riscv_vsoxseg7_mask, 0x10, 0x0, 0x0, PseudoVSOXSEG7EI16_V_M1_M1_MASK }, // 4504
  { Intrinsic::riscv_vsoxseg7_mask, 0x10, 0x0, 0x1, PseudoVSOXSEG7EI16_V_M2_M1_MASK }, // 4505
  { Intrinsic::riscv_vsoxseg7_mask, 0x10, 0x0, 0x2, PseudoVSOXSEG7EI16_V_M4_M1_MASK }, // 4506
  { Intrinsic::riscv_vsoxseg7_mask, 0x10, 0x0, 0x3, PseudoVSOXSEG7EI16_V_M8_M1_MASK }, // 4507
  { Intrinsic::riscv_vsoxseg7_mask, 0x10, 0x0, 0x6, PseudoVSOXSEG7EI16_V_MF4_M1_MASK }, // 4508
  { Intrinsic::riscv_vsoxseg7_mask, 0x10, 0x0, 0x7, PseudoVSOXSEG7EI16_V_MF2_M1_MASK }, // 4509
  { Intrinsic::riscv_vsoxseg7_mask, 0x10, 0x5, 0x0, PseudoVSOXSEG7EI16_V_M1_MF8_MASK }, // 4510
  { Intrinsic::riscv_vsoxseg7_mask, 0x10, 0x5, 0x1, PseudoVSOXSEG7EI16_V_M2_MF8_MASK }, // 4511
  { Intrinsic::riscv_vsoxseg7_mask, 0x10, 0x5, 0x2, PseudoVSOXSEG7EI16_V_M4_MF8_MASK }, // 4512
  { Intrinsic::riscv_vsoxseg7_mask, 0x10, 0x5, 0x3, PseudoVSOXSEG7EI16_V_M8_MF8_MASK }, // 4513
  { Intrinsic::riscv_vsoxseg7_mask, 0x10, 0x5, 0x6, PseudoVSOXSEG7EI16_V_MF4_MF8_MASK }, // 4514
  { Intrinsic::riscv_vsoxseg7_mask, 0x10, 0x5, 0x7, PseudoVSOXSEG7EI16_V_MF2_MF8_MASK }, // 4515
  { Intrinsic::riscv_vsoxseg7_mask, 0x10, 0x6, 0x0, PseudoVSOXSEG7EI16_V_M1_MF4_MASK }, // 4516
  { Intrinsic::riscv_vsoxseg7_mask, 0x10, 0x6, 0x1, PseudoVSOXSEG7EI16_V_M2_MF4_MASK }, // 4517
  { Intrinsic::riscv_vsoxseg7_mask, 0x10, 0x6, 0x2, PseudoVSOXSEG7EI16_V_M4_MF4_MASK }, // 4518
  { Intrinsic::riscv_vsoxseg7_mask, 0x10, 0x6, 0x3, PseudoVSOXSEG7EI16_V_M8_MF4_MASK }, // 4519
  { Intrinsic::riscv_vsoxseg7_mask, 0x10, 0x6, 0x6, PseudoVSOXSEG7EI16_V_MF4_MF4_MASK }, // 4520
  { Intrinsic::riscv_vsoxseg7_mask, 0x10, 0x6, 0x7, PseudoVSOXSEG7EI16_V_MF2_MF4_MASK }, // 4521
  { Intrinsic::riscv_vsoxseg7_mask, 0x10, 0x7, 0x0, PseudoVSOXSEG7EI16_V_M1_MF2_MASK }, // 4522
  { Intrinsic::riscv_vsoxseg7_mask, 0x10, 0x7, 0x1, PseudoVSOXSEG7EI16_V_M2_MF2_MASK }, // 4523
  { Intrinsic::riscv_vsoxseg7_mask, 0x10, 0x7, 0x2, PseudoVSOXSEG7EI16_V_M4_MF2_MASK }, // 4524
  { Intrinsic::riscv_vsoxseg7_mask, 0x10, 0x7, 0x3, PseudoVSOXSEG7EI16_V_M8_MF2_MASK }, // 4525
  { Intrinsic::riscv_vsoxseg7_mask, 0x10, 0x7, 0x6, PseudoVSOXSEG7EI16_V_MF4_MF2_MASK }, // 4526
  { Intrinsic::riscv_vsoxseg7_mask, 0x10, 0x7, 0x7, PseudoVSOXSEG7EI16_V_MF2_MF2_MASK }, // 4527
  { Intrinsic::riscv_vsoxseg7_mask, 0x20, 0x0, 0x0, PseudoVSOXSEG7EI32_V_M1_M1_MASK }, // 4528
  { Intrinsic::riscv_vsoxseg7_mask, 0x20, 0x0, 0x1, PseudoVSOXSEG7EI32_V_M2_M1_MASK }, // 4529
  { Intrinsic::riscv_vsoxseg7_mask, 0x20, 0x0, 0x2, PseudoVSOXSEG7EI32_V_M4_M1_MASK }, // 4530
  { Intrinsic::riscv_vsoxseg7_mask, 0x20, 0x0, 0x3, PseudoVSOXSEG7EI32_V_M8_M1_MASK }, // 4531
  { Intrinsic::riscv_vsoxseg7_mask, 0x20, 0x0, 0x7, PseudoVSOXSEG7EI32_V_MF2_M1_MASK }, // 4532
  { Intrinsic::riscv_vsoxseg7_mask, 0x20, 0x5, 0x0, PseudoVSOXSEG7EI32_V_M1_MF8_MASK }, // 4533
  { Intrinsic::riscv_vsoxseg7_mask, 0x20, 0x5, 0x1, PseudoVSOXSEG7EI32_V_M2_MF8_MASK }, // 4534
  { Intrinsic::riscv_vsoxseg7_mask, 0x20, 0x5, 0x2, PseudoVSOXSEG7EI32_V_M4_MF8_MASK }, // 4535
  { Intrinsic::riscv_vsoxseg7_mask, 0x20, 0x5, 0x3, PseudoVSOXSEG7EI32_V_M8_MF8_MASK }, // 4536
  { Intrinsic::riscv_vsoxseg7_mask, 0x20, 0x5, 0x7, PseudoVSOXSEG7EI32_V_MF2_MF8_MASK }, // 4537
  { Intrinsic::riscv_vsoxseg7_mask, 0x20, 0x6, 0x0, PseudoVSOXSEG7EI32_V_M1_MF4_MASK }, // 4538
  { Intrinsic::riscv_vsoxseg7_mask, 0x20, 0x6, 0x1, PseudoVSOXSEG7EI32_V_M2_MF4_MASK }, // 4539
  { Intrinsic::riscv_vsoxseg7_mask, 0x20, 0x6, 0x2, PseudoVSOXSEG7EI32_V_M4_MF4_MASK }, // 4540
  { Intrinsic::riscv_vsoxseg7_mask, 0x20, 0x6, 0x3, PseudoVSOXSEG7EI32_V_M8_MF4_MASK }, // 4541
  { Intrinsic::riscv_vsoxseg7_mask, 0x20, 0x6, 0x7, PseudoVSOXSEG7EI32_V_MF2_MF4_MASK }, // 4542
  { Intrinsic::riscv_vsoxseg7_mask, 0x20, 0x7, 0x0, PseudoVSOXSEG7EI32_V_M1_MF2_MASK }, // 4543
  { Intrinsic::riscv_vsoxseg7_mask, 0x20, 0x7, 0x1, PseudoVSOXSEG7EI32_V_M2_MF2_MASK }, // 4544
  { Intrinsic::riscv_vsoxseg7_mask, 0x20, 0x7, 0x2, PseudoVSOXSEG7EI32_V_M4_MF2_MASK }, // 4545
  { Intrinsic::riscv_vsoxseg7_mask, 0x20, 0x7, 0x3, PseudoVSOXSEG7EI32_V_M8_MF2_MASK }, // 4546
  { Intrinsic::riscv_vsoxseg7_mask, 0x20, 0x7, 0x7, PseudoVSOXSEG7EI32_V_MF2_MF2_MASK }, // 4547
  { Intrinsic::riscv_vsoxseg7_mask, 0x40, 0x0, 0x0, PseudoVSOXSEG7EI64_V_M1_M1_MASK }, // 4548
  { Intrinsic::riscv_vsoxseg7_mask, 0x40, 0x0, 0x1, PseudoVSOXSEG7EI64_V_M2_M1_MASK }, // 4549
  { Intrinsic::riscv_vsoxseg7_mask, 0x40, 0x0, 0x2, PseudoVSOXSEG7EI64_V_M4_M1_MASK }, // 4550
  { Intrinsic::riscv_vsoxseg7_mask, 0x40, 0x0, 0x3, PseudoVSOXSEG7EI64_V_M8_M1_MASK }, // 4551
  { Intrinsic::riscv_vsoxseg7_mask, 0x40, 0x5, 0x0, PseudoVSOXSEG7EI64_V_M1_MF8_MASK }, // 4552
  { Intrinsic::riscv_vsoxseg7_mask, 0x40, 0x5, 0x1, PseudoVSOXSEG7EI64_V_M2_MF8_MASK }, // 4553
  { Intrinsic::riscv_vsoxseg7_mask, 0x40, 0x5, 0x2, PseudoVSOXSEG7EI64_V_M4_MF8_MASK }, // 4554
  { Intrinsic::riscv_vsoxseg7_mask, 0x40, 0x5, 0x3, PseudoVSOXSEG7EI64_V_M8_MF8_MASK }, // 4555
  { Intrinsic::riscv_vsoxseg7_mask, 0x40, 0x6, 0x0, PseudoVSOXSEG7EI64_V_M1_MF4_MASK }, // 4556
  { Intrinsic::riscv_vsoxseg7_mask, 0x40, 0x6, 0x1, PseudoVSOXSEG7EI64_V_M2_MF4_MASK }, // 4557
  { Intrinsic::riscv_vsoxseg7_mask, 0x40, 0x6, 0x2, PseudoVSOXSEG7EI64_V_M4_MF4_MASK }, // 4558
  { Intrinsic::riscv_vsoxseg7_mask, 0x40, 0x6, 0x3, PseudoVSOXSEG7EI64_V_M8_MF4_MASK }, // 4559
  { Intrinsic::riscv_vsoxseg7_mask, 0x40, 0x7, 0x0, PseudoVSOXSEG7EI64_V_M1_MF2_MASK }, // 4560
  { Intrinsic::riscv_vsoxseg7_mask, 0x40, 0x7, 0x1, PseudoVSOXSEG7EI64_V_M2_MF2_MASK }, // 4561
  { Intrinsic::riscv_vsoxseg7_mask, 0x40, 0x7, 0x2, PseudoVSOXSEG7EI64_V_M4_MF2_MASK }, // 4562
  { Intrinsic::riscv_vsoxseg7_mask, 0x40, 0x7, 0x3, PseudoVSOXSEG7EI64_V_M8_MF2_MASK }, // 4563
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x0, 0x0, PseudoVSOXSEG8EI8_V_M1_M1 }, // 4564
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x0, 0x1, PseudoVSOXSEG8EI8_V_M2_M1 }, // 4565
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x0, 0x2, PseudoVSOXSEG8EI8_V_M4_M1 }, // 4566
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x0, 0x3, PseudoVSOXSEG8EI8_V_M8_M1 }, // 4567
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x0, 0x5, PseudoVSOXSEG8EI8_V_MF8_M1 }, // 4568
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x0, 0x6, PseudoVSOXSEG8EI8_V_MF4_M1 }, // 4569
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x0, 0x7, PseudoVSOXSEG8EI8_V_MF2_M1 }, // 4570
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x5, 0x0, PseudoVSOXSEG8EI8_V_M1_MF8 }, // 4571
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x5, 0x1, PseudoVSOXSEG8EI8_V_M2_MF8 }, // 4572
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x5, 0x2, PseudoVSOXSEG8EI8_V_M4_MF8 }, // 4573
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x5, 0x3, PseudoVSOXSEG8EI8_V_M8_MF8 }, // 4574
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x5, 0x5, PseudoVSOXSEG8EI8_V_MF8_MF8 }, // 4575
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x5, 0x6, PseudoVSOXSEG8EI8_V_MF4_MF8 }, // 4576
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x5, 0x7, PseudoVSOXSEG8EI8_V_MF2_MF8 }, // 4577
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x6, 0x0, PseudoVSOXSEG8EI8_V_M1_MF4 }, // 4578
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x6, 0x1, PseudoVSOXSEG8EI8_V_M2_MF4 }, // 4579
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x6, 0x2, PseudoVSOXSEG8EI8_V_M4_MF4 }, // 4580
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x6, 0x3, PseudoVSOXSEG8EI8_V_M8_MF4 }, // 4581
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x6, 0x5, PseudoVSOXSEG8EI8_V_MF8_MF4 }, // 4582
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x6, 0x6, PseudoVSOXSEG8EI8_V_MF4_MF4 }, // 4583
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x6, 0x7, PseudoVSOXSEG8EI8_V_MF2_MF4 }, // 4584
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x7, 0x0, PseudoVSOXSEG8EI8_V_M1_MF2 }, // 4585
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x7, 0x1, PseudoVSOXSEG8EI8_V_M2_MF2 }, // 4586
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x7, 0x2, PseudoVSOXSEG8EI8_V_M4_MF2 }, // 4587
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x7, 0x3, PseudoVSOXSEG8EI8_V_M8_MF2 }, // 4588
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x7, 0x5, PseudoVSOXSEG8EI8_V_MF8_MF2 }, // 4589
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x7, 0x6, PseudoVSOXSEG8EI8_V_MF4_MF2 }, // 4590
  { Intrinsic::riscv_vsoxseg8, 0x8, 0x7, 0x7, PseudoVSOXSEG8EI8_V_MF2_MF2 }, // 4591
  { Intrinsic::riscv_vsoxseg8, 0x10, 0x0, 0x0, PseudoVSOXSEG8EI16_V_M1_M1 }, // 4592
  { Intrinsic::riscv_vsoxseg8, 0x10, 0x0, 0x1, PseudoVSOXSEG8EI16_V_M2_M1 }, // 4593
  { Intrinsic::riscv_vsoxseg8, 0x10, 0x0, 0x2, PseudoVSOXSEG8EI16_V_M4_M1 }, // 4594
  { Intrinsic::riscv_vsoxseg8, 0x10, 0x0, 0x3, PseudoVSOXSEG8EI16_V_M8_M1 }, // 4595
  { Intrinsic::riscv_vsoxseg8, 0x10, 0x0, 0x6, PseudoVSOXSEG8EI16_V_MF4_M1 }, // 4596
  { Intrinsic::riscv_vsoxseg8, 0x10, 0x0, 0x7, PseudoVSOXSEG8EI16_V_MF2_M1 }, // 4597
  { Intrinsic::riscv_vsoxseg8, 0x10, 0x5, 0x0, PseudoVSOXSEG8EI16_V_M1_MF8 }, // 4598
  { Intrinsic::riscv_vsoxseg8, 0x10, 0x5, 0x1, PseudoVSOXSEG8EI16_V_M2_MF8 }, // 4599
  { Intrinsic::riscv_vsoxseg8, 0x10, 0x5, 0x2, PseudoVSOXSEG8EI16_V_M4_MF8 }, // 4600
  { Intrinsic::riscv_vsoxseg8, 0x10, 0x5, 0x3, PseudoVSOXSEG8EI16_V_M8_MF8 }, // 4601
  { Intrinsic::riscv_vsoxseg8, 0x10, 0x5, 0x6, PseudoVSOXSEG8EI16_V_MF4_MF8 }, // 4602
  { Intrinsic::riscv_vsoxseg8, 0x10, 0x5, 0x7, PseudoVSOXSEG8EI16_V_MF2_MF8 }, // 4603
  { Intrinsic::riscv_vsoxseg8, 0x10, 0x6, 0x0, PseudoVSOXSEG8EI16_V_M1_MF4 }, // 4604
  { Intrinsic::riscv_vsoxseg8, 0x10, 0x6, 0x1, PseudoVSOXSEG8EI16_V_M2_MF4 }, // 4605
  { Intrinsic::riscv_vsoxseg8, 0x10, 0x6, 0x2, PseudoVSOXSEG8EI16_V_M4_MF4 }, // 4606
  { Intrinsic::riscv_vsoxseg8, 0x10, 0x6, 0x3, PseudoVSOXSEG8EI16_V_M8_MF4 }, // 4607
  { Intrinsic::riscv_vsoxseg8, 0x10, 0x6, 0x6, PseudoVSOXSEG8EI16_V_MF4_MF4 }, // 4608
  { Intrinsic::riscv_vsoxseg8, 0x10, 0x6, 0x7, PseudoVSOXSEG8EI16_V_MF2_MF4 }, // 4609
  { Intrinsic::riscv_vsoxseg8, 0x10, 0x7, 0x0, PseudoVSOXSEG8EI16_V_M1_MF2 }, // 4610
  { Intrinsic::riscv_vsoxseg8, 0x10, 0x7, 0x1, PseudoVSOXSEG8EI16_V_M2_MF2 }, // 4611
  { Intrinsic::riscv_vsoxseg8, 0x10, 0x7, 0x2, PseudoVSOXSEG8EI16_V_M4_MF2 }, // 4612
  { Intrinsic::riscv_vsoxseg8, 0x10, 0x7, 0x3, PseudoVSOXSEG8EI16_V_M8_MF2 }, // 4613
  { Intrinsic::riscv_vsoxseg8, 0x10, 0x7, 0x6, PseudoVSOXSEG8EI16_V_MF4_MF2 }, // 4614
  { Intrinsic::riscv_vsoxseg8, 0x10, 0x7, 0x7, PseudoVSOXSEG8EI16_V_MF2_MF2 }, // 4615
  { Intrinsic::riscv_vsoxseg8, 0x20, 0x0, 0x0, PseudoVSOXSEG8EI32_V_M1_M1 }, // 4616
  { Intrinsic::riscv_vsoxseg8, 0x20, 0x0, 0x1, PseudoVSOXSEG8EI32_V_M2_M1 }, // 4617
  { Intrinsic::riscv_vsoxseg8, 0x20, 0x0, 0x2, PseudoVSOXSEG8EI32_V_M4_M1 }, // 4618
  { Intrinsic::riscv_vsoxseg8, 0x20, 0x0, 0x3, PseudoVSOXSEG8EI32_V_M8_M1 }, // 4619
  { Intrinsic::riscv_vsoxseg8, 0x20, 0x0, 0x7, PseudoVSOXSEG8EI32_V_MF2_M1 }, // 4620
  { Intrinsic::riscv_vsoxseg8, 0x20, 0x5, 0x0, PseudoVSOXSEG8EI32_V_M1_MF8 }, // 4621
  { Intrinsic::riscv_vsoxseg8, 0x20, 0x5, 0x1, PseudoVSOXSEG8EI32_V_M2_MF8 }, // 4622
  { Intrinsic::riscv_vsoxseg8, 0x20, 0x5, 0x2, PseudoVSOXSEG8EI32_V_M4_MF8 }, // 4623
  { Intrinsic::riscv_vsoxseg8, 0x20, 0x5, 0x3, PseudoVSOXSEG8EI32_V_M8_MF8 }, // 4624
  { Intrinsic::riscv_vsoxseg8, 0x20, 0x5, 0x7, PseudoVSOXSEG8EI32_V_MF2_MF8 }, // 4625
  { Intrinsic::riscv_vsoxseg8, 0x20, 0x6, 0x0, PseudoVSOXSEG8EI32_V_M1_MF4 }, // 4626
  { Intrinsic::riscv_vsoxseg8, 0x20, 0x6, 0x1, PseudoVSOXSEG8EI32_V_M2_MF4 }, // 4627
  { Intrinsic::riscv_vsoxseg8, 0x20, 0x6, 0x2, PseudoVSOXSEG8EI32_V_M4_MF4 }, // 4628
  { Intrinsic::riscv_vsoxseg8, 0x20, 0x6, 0x3, PseudoVSOXSEG8EI32_V_M8_MF4 }, // 4629
  { Intrinsic::riscv_vsoxseg8, 0x20, 0x6, 0x7, PseudoVSOXSEG8EI32_V_MF2_MF4 }, // 4630
  { Intrinsic::riscv_vsoxseg8, 0x20, 0x7, 0x0, PseudoVSOXSEG8EI32_V_M1_MF2 }, // 4631
  { Intrinsic::riscv_vsoxseg8, 0x20, 0x7, 0x1, PseudoVSOXSEG8EI32_V_M2_MF2 }, // 4632
  { Intrinsic::riscv_vsoxseg8, 0x20, 0x7, 0x2, PseudoVSOXSEG8EI32_V_M4_MF2 }, // 4633
  { Intrinsic::riscv_vsoxseg8, 0x20, 0x7, 0x3, PseudoVSOXSEG8EI32_V_M8_MF2 }, // 4634
  { Intrinsic::riscv_vsoxseg8, 0x20, 0x7, 0x7, PseudoVSOXSEG8EI32_V_MF2_MF2 }, // 4635
  { Intrinsic::riscv_vsoxseg8, 0x40, 0x0, 0x0, PseudoVSOXSEG8EI64_V_M1_M1 }, // 4636
  { Intrinsic::riscv_vsoxseg8, 0x40, 0x0, 0x1, PseudoVSOXSEG8EI64_V_M2_M1 }, // 4637
  { Intrinsic::riscv_vsoxseg8, 0x40, 0x0, 0x2, PseudoVSOXSEG8EI64_V_M4_M1 }, // 4638
  { Intrinsic::riscv_vsoxseg8, 0x40, 0x0, 0x3, PseudoVSOXSEG8EI64_V_M8_M1 }, // 4639
  { Intrinsic::riscv_vsoxseg8, 0x40, 0x5, 0x0, PseudoVSOXSEG8EI64_V_M1_MF8 }, // 4640
  { Intrinsic::riscv_vsoxseg8, 0x40, 0x5, 0x1, PseudoVSOXSEG8EI64_V_M2_MF8 }, // 4641
  { Intrinsic::riscv_vsoxseg8, 0x40, 0x5, 0x2, PseudoVSOXSEG8EI64_V_M4_MF8 }, // 4642
  { Intrinsic::riscv_vsoxseg8, 0x40, 0x5, 0x3, PseudoVSOXSEG8EI64_V_M8_MF8 }, // 4643
  { Intrinsic::riscv_vsoxseg8, 0x40, 0x6, 0x0, PseudoVSOXSEG8EI64_V_M1_MF4 }, // 4644
  { Intrinsic::riscv_vsoxseg8, 0x40, 0x6, 0x1, PseudoVSOXSEG8EI64_V_M2_MF4 }, // 4645
  { Intrinsic::riscv_vsoxseg8, 0x40, 0x6, 0x2, PseudoVSOXSEG8EI64_V_M4_MF4 }, // 4646
  { Intrinsic::riscv_vsoxseg8, 0x40, 0x6, 0x3, PseudoVSOXSEG8EI64_V_M8_MF4 }, // 4647
  { Intrinsic::riscv_vsoxseg8, 0x40, 0x7, 0x0, PseudoVSOXSEG8EI64_V_M1_MF2 }, // 4648
  { Intrinsic::riscv_vsoxseg8, 0x40, 0x7, 0x1, PseudoVSOXSEG8EI64_V_M2_MF2 }, // 4649
  { Intrinsic::riscv_vsoxseg8, 0x40, 0x7, 0x2, PseudoVSOXSEG8EI64_V_M4_MF2 }, // 4650
  { Intrinsic::riscv_vsoxseg8, 0x40, 0x7, 0x3, PseudoVSOXSEG8EI64_V_M8_MF2 }, // 4651
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x0, 0x0, PseudoVSOXSEG8EI8_V_M1_M1_MASK }, // 4652
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x0, 0x1, PseudoVSOXSEG8EI8_V_M2_M1_MASK }, // 4653
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x0, 0x2, PseudoVSOXSEG8EI8_V_M4_M1_MASK }, // 4654
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x0, 0x3, PseudoVSOXSEG8EI8_V_M8_M1_MASK }, // 4655
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x0, 0x5, PseudoVSOXSEG8EI8_V_MF8_M1_MASK }, // 4656
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x0, 0x6, PseudoVSOXSEG8EI8_V_MF4_M1_MASK }, // 4657
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x0, 0x7, PseudoVSOXSEG8EI8_V_MF2_M1_MASK }, // 4658
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x5, 0x0, PseudoVSOXSEG8EI8_V_M1_MF8_MASK }, // 4659
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x5, 0x1, PseudoVSOXSEG8EI8_V_M2_MF8_MASK }, // 4660
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x5, 0x2, PseudoVSOXSEG8EI8_V_M4_MF8_MASK }, // 4661
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x5, 0x3, PseudoVSOXSEG8EI8_V_M8_MF8_MASK }, // 4662
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x5, 0x5, PseudoVSOXSEG8EI8_V_MF8_MF8_MASK }, // 4663
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x5, 0x6, PseudoVSOXSEG8EI8_V_MF4_MF8_MASK }, // 4664
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x5, 0x7, PseudoVSOXSEG8EI8_V_MF2_MF8_MASK }, // 4665
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x6, 0x0, PseudoVSOXSEG8EI8_V_M1_MF4_MASK }, // 4666
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x6, 0x1, PseudoVSOXSEG8EI8_V_M2_MF4_MASK }, // 4667
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x6, 0x2, PseudoVSOXSEG8EI8_V_M4_MF4_MASK }, // 4668
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x6, 0x3, PseudoVSOXSEG8EI8_V_M8_MF4_MASK }, // 4669
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x6, 0x5, PseudoVSOXSEG8EI8_V_MF8_MF4_MASK }, // 4670
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x6, 0x6, PseudoVSOXSEG8EI8_V_MF4_MF4_MASK }, // 4671
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x6, 0x7, PseudoVSOXSEG8EI8_V_MF2_MF4_MASK }, // 4672
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x7, 0x0, PseudoVSOXSEG8EI8_V_M1_MF2_MASK }, // 4673
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x7, 0x1, PseudoVSOXSEG8EI8_V_M2_MF2_MASK }, // 4674
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x7, 0x2, PseudoVSOXSEG8EI8_V_M4_MF2_MASK }, // 4675
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x7, 0x3, PseudoVSOXSEG8EI8_V_M8_MF2_MASK }, // 4676
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x7, 0x5, PseudoVSOXSEG8EI8_V_MF8_MF2_MASK }, // 4677
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x7, 0x6, PseudoVSOXSEG8EI8_V_MF4_MF2_MASK }, // 4678
  { Intrinsic::riscv_vsoxseg8_mask, 0x8, 0x7, 0x7, PseudoVSOXSEG8EI8_V_MF2_MF2_MASK }, // 4679
  { Intrinsic::riscv_vsoxseg8_mask, 0x10, 0x0, 0x0, PseudoVSOXSEG8EI16_V_M1_M1_MASK }, // 4680
  { Intrinsic::riscv_vsoxseg8_mask, 0x10, 0x0, 0x1, PseudoVSOXSEG8EI16_V_M2_M1_MASK }, // 4681
  { Intrinsic::riscv_vsoxseg8_mask, 0x10, 0x0, 0x2, PseudoVSOXSEG8EI16_V_M4_M1_MASK }, // 4682
  { Intrinsic::riscv_vsoxseg8_mask, 0x10, 0x0, 0x3, PseudoVSOXSEG8EI16_V_M8_M1_MASK }, // 4683
  { Intrinsic::riscv_vsoxseg8_mask, 0x10, 0x0, 0x6, PseudoVSOXSEG8EI16_V_MF4_M1_MASK }, // 4684
  { Intrinsic::riscv_vsoxseg8_mask, 0x10, 0x0, 0x7, PseudoVSOXSEG8EI16_V_MF2_M1_MASK }, // 4685
  { Intrinsic::riscv_vsoxseg8_mask, 0x10, 0x5, 0x0, PseudoVSOXSEG8EI16_V_M1_MF8_MASK }, // 4686
  { Intrinsic::riscv_vsoxseg8_mask, 0x10, 0x5, 0x1, PseudoVSOXSEG8EI16_V_M2_MF8_MASK }, // 4687
  { Intrinsic::riscv_vsoxseg8_mask, 0x10, 0x5, 0x2, PseudoVSOXSEG8EI16_V_M4_MF8_MASK }, // 4688
  { Intrinsic::riscv_vsoxseg8_mask, 0x10, 0x5, 0x3, PseudoVSOXSEG8EI16_V_M8_MF8_MASK }, // 4689
  { Intrinsic::riscv_vsoxseg8_mask, 0x10, 0x5, 0x6, PseudoVSOXSEG8EI16_V_MF4_MF8_MASK }, // 4690
  { Intrinsic::riscv_vsoxseg8_mask, 0x10, 0x5, 0x7, PseudoVSOXSEG8EI16_V_MF2_MF8_MASK }, // 4691
  { Intrinsic::riscv_vsoxseg8_mask, 0x10, 0x6, 0x0, PseudoVSOXSEG8EI16_V_M1_MF4_MASK }, // 4692
  { Intrinsic::riscv_vsoxseg8_mask, 0x10, 0x6, 0x1, PseudoVSOXSEG8EI16_V_M2_MF4_MASK }, // 4693
  { Intrinsic::riscv_vsoxseg8_mask, 0x10, 0x6, 0x2, PseudoVSOXSEG8EI16_V_M4_MF4_MASK }, // 4694
  { Intrinsic::riscv_vsoxseg8_mask, 0x10, 0x6, 0x3, PseudoVSOXSEG8EI16_V_M8_MF4_MASK }, // 4695
  { Intrinsic::riscv_vsoxseg8_mask, 0x10, 0x6, 0x6, PseudoVSOXSEG8EI16_V_MF4_MF4_MASK }, // 4696
  { Intrinsic::riscv_vsoxseg8_mask, 0x10, 0x6, 0x7, PseudoVSOXSEG8EI16_V_MF2_MF4_MASK }, // 4697
  { Intrinsic::riscv_vsoxseg8_mask, 0x10, 0x7, 0x0, PseudoVSOXSEG8EI16_V_M1_MF2_MASK }, // 4698
  { Intrinsic::riscv_vsoxseg8_mask, 0x10, 0x7, 0x1, PseudoVSOXSEG8EI16_V_M2_MF2_MASK }, // 4699
  { Intrinsic::riscv_vsoxseg8_mask, 0x10, 0x7, 0x2, PseudoVSOXSEG8EI16_V_M4_MF2_MASK }, // 4700
  { Intrinsic::riscv_vsoxseg8_mask, 0x10, 0x7, 0x3, PseudoVSOXSEG8EI16_V_M8_MF2_MASK }, // 4701
  { Intrinsic::riscv_vsoxseg8_mask, 0x10, 0x7, 0x6, PseudoVSOXSEG8EI16_V_MF4_MF2_MASK }, // 4702
  { Intrinsic::riscv_vsoxseg8_mask, 0x10, 0x7, 0x7, PseudoVSOXSEG8EI16_V_MF2_MF2_MASK }, // 4703
  { Intrinsic::riscv_vsoxseg8_mask, 0x20, 0x0, 0x0, PseudoVSOXSEG8EI32_V_M1_M1_MASK }, // 4704
  { Intrinsic::riscv_vsoxseg8_mask, 0x20, 0x0, 0x1, PseudoVSOXSEG8EI32_V_M2_M1_MASK }, // 4705
  { Intrinsic::riscv_vsoxseg8_mask, 0x20, 0x0, 0x2, PseudoVSOXSEG8EI32_V_M4_M1_MASK }, // 4706
  { Intrinsic::riscv_vsoxseg8_mask, 0x20, 0x0, 0x3, PseudoVSOXSEG8EI32_V_M8_M1_MASK }, // 4707
  { Intrinsic::riscv_vsoxseg8_mask, 0x20, 0x0, 0x7, PseudoVSOXSEG8EI32_V_MF2_M1_MASK }, // 4708
  { Intrinsic::riscv_vsoxseg8_mask, 0x20, 0x5, 0x0, PseudoVSOXSEG8EI32_V_M1_MF8_MASK }, // 4709
  { Intrinsic::riscv_vsoxseg8_mask, 0x20, 0x5, 0x1, PseudoVSOXSEG8EI32_V_M2_MF8_MASK }, // 4710
  { Intrinsic::riscv_vsoxseg8_mask, 0x20, 0x5, 0x2, PseudoVSOXSEG8EI32_V_M4_MF8_MASK }, // 4711
  { Intrinsic::riscv_vsoxseg8_mask, 0x20, 0x5, 0x3, PseudoVSOXSEG8EI32_V_M8_MF8_MASK }, // 4712
  { Intrinsic::riscv_vsoxseg8_mask, 0x20, 0x5, 0x7, PseudoVSOXSEG8EI32_V_MF2_MF8_MASK }, // 4713
  { Intrinsic::riscv_vsoxseg8_mask, 0x20, 0x6, 0x0, PseudoVSOXSEG8EI32_V_M1_MF4_MASK }, // 4714
  { Intrinsic::riscv_vsoxseg8_mask, 0x20, 0x6, 0x1, PseudoVSOXSEG8EI32_V_M2_MF4_MASK }, // 4715
  { Intrinsic::riscv_vsoxseg8_mask, 0x20, 0x6, 0x2, PseudoVSOXSEG8EI32_V_M4_MF4_MASK }, // 4716
  { Intrinsic::riscv_vsoxseg8_mask, 0x20, 0x6, 0x3, PseudoVSOXSEG8EI32_V_M8_MF4_MASK }, // 4717
  { Intrinsic::riscv_vsoxseg8_mask, 0x20, 0x6, 0x7, PseudoVSOXSEG8EI32_V_MF2_MF4_MASK }, // 4718
  { Intrinsic::riscv_vsoxseg8_mask, 0x20, 0x7, 0x0, PseudoVSOXSEG8EI32_V_M1_MF2_MASK }, // 4719
  { Intrinsic::riscv_vsoxseg8_mask, 0x20, 0x7, 0x1, PseudoVSOXSEG8EI32_V_M2_MF2_MASK }, // 4720
  { Intrinsic::riscv_vsoxseg8_mask, 0x20, 0x7, 0x2, PseudoVSOXSEG8EI32_V_M4_MF2_MASK }, // 4721
  { Intrinsic::riscv_vsoxseg8_mask, 0x20, 0x7, 0x3, PseudoVSOXSEG8EI32_V_M8_MF2_MASK }, // 4722
  { Intrinsic::riscv_vsoxseg8_mask, 0x20, 0x7, 0x7, PseudoVSOXSEG8EI32_V_MF2_MF2_MASK }, // 4723
  { Intrinsic::riscv_vsoxseg8_mask, 0x40, 0x0, 0x0, PseudoVSOXSEG8EI64_V_M1_M1_MASK }, // 4724
  { Intrinsic::riscv_vsoxseg8_mask, 0x40, 0x0, 0x1, PseudoVSOXSEG8EI64_V_M2_M1_MASK }, // 4725
  { Intrinsic::riscv_vsoxseg8_mask, 0x40, 0x0, 0x2, PseudoVSOXSEG8EI64_V_M4_M1_MASK }, // 4726
  { Intrinsic::riscv_vsoxseg8_mask, 0x40, 0x0, 0x3, PseudoVSOXSEG8EI64_V_M8_M1_MASK }, // 4727
  { Intrinsic::riscv_vsoxseg8_mask, 0x40, 0x5, 0x0, PseudoVSOXSEG8EI64_V_M1_MF8_MASK }, // 4728
  { Intrinsic::riscv_vsoxseg8_mask, 0x40, 0x5, 0x1, PseudoVSOXSEG8EI64_V_M2_MF8_MASK }, // 4729
  { Intrinsic::riscv_vsoxseg8_mask, 0x40, 0x5, 0x2, PseudoVSOXSEG8EI64_V_M4_MF8_MASK }, // 4730
  { Intrinsic::riscv_vsoxseg8_mask, 0x40, 0x5, 0x3, PseudoVSOXSEG8EI64_V_M8_MF8_MASK }, // 4731
  { Intrinsic::riscv_vsoxseg8_mask, 0x40, 0x6, 0x0, PseudoVSOXSEG8EI64_V_M1_MF4_MASK }, // 4732
  { Intrinsic::riscv_vsoxseg8_mask, 0x40, 0x6, 0x1, PseudoVSOXSEG8EI64_V_M2_MF4_MASK }, // 4733
  { Intrinsic::riscv_vsoxseg8_mask, 0x40, 0x6, 0x2, PseudoVSOXSEG8EI64_V_M4_MF4_MASK }, // 4734
  { Intrinsic::riscv_vsoxseg8_mask, 0x40, 0x6, 0x3, PseudoVSOXSEG8EI64_V_M8_MF4_MASK }, // 4735
  { Intrinsic::riscv_vsoxseg8_mask, 0x40, 0x7, 0x0, PseudoVSOXSEG8EI64_V_M1_MF2_MASK }, // 4736
  { Intrinsic::riscv_vsoxseg8_mask, 0x40, 0x7, 0x1, PseudoVSOXSEG8EI64_V_M2_MF2_MASK }, // 4737
  { Intrinsic::riscv_vsoxseg8_mask, 0x40, 0x7, 0x2, PseudoVSOXSEG8EI64_V_M4_MF2_MASK }, // 4738
  { Intrinsic::riscv_vsoxseg8_mask, 0x40, 0x7, 0x3, PseudoVSOXSEG8EI64_V_M8_MF2_MASK }, // 4739
  { Intrinsic::riscv_vsseg2, 0x8, 0x0, 0x0, PseudoVSSEG2E8_V_M1 }, // 4740
  { Intrinsic::riscv_vsseg2, 0x8, 0x1, 0x0, PseudoVSSEG2E8_V_M2 }, // 4741
  { Intrinsic::riscv_vsseg2, 0x8, 0x2, 0x0, PseudoVSSEG2E8_V_M4 }, // 4742
  { Intrinsic::riscv_vsseg2, 0x8, 0x5, 0x0, PseudoVSSEG2E8_V_MF8 }, // 4743
  { Intrinsic::riscv_vsseg2, 0x8, 0x6, 0x0, PseudoVSSEG2E8_V_MF4 }, // 4744
  { Intrinsic::riscv_vsseg2, 0x8, 0x7, 0x0, PseudoVSSEG2E8_V_MF2 }, // 4745
  { Intrinsic::riscv_vsseg2, 0x10, 0x0, 0x0, PseudoVSSEG2E16_V_M1 }, // 4746
  { Intrinsic::riscv_vsseg2, 0x10, 0x1, 0x0, PseudoVSSEG2E16_V_M2 }, // 4747
  { Intrinsic::riscv_vsseg2, 0x10, 0x2, 0x0, PseudoVSSEG2E16_V_M4 }, // 4748
  { Intrinsic::riscv_vsseg2, 0x10, 0x6, 0x0, PseudoVSSEG2E16_V_MF4 }, // 4749
  { Intrinsic::riscv_vsseg2, 0x10, 0x7, 0x0, PseudoVSSEG2E16_V_MF2 }, // 4750
  { Intrinsic::riscv_vsseg2, 0x20, 0x0, 0x0, PseudoVSSEG2E32_V_M1 }, // 4751
  { Intrinsic::riscv_vsseg2, 0x20, 0x1, 0x0, PseudoVSSEG2E32_V_M2 }, // 4752
  { Intrinsic::riscv_vsseg2, 0x20, 0x2, 0x0, PseudoVSSEG2E32_V_M4 }, // 4753
  { Intrinsic::riscv_vsseg2, 0x20, 0x7, 0x0, PseudoVSSEG2E32_V_MF2 }, // 4754
  { Intrinsic::riscv_vsseg2, 0x40, 0x0, 0x0, PseudoVSSEG2E64_V_M1 }, // 4755
  { Intrinsic::riscv_vsseg2, 0x40, 0x1, 0x0, PseudoVSSEG2E64_V_M2 }, // 4756
  { Intrinsic::riscv_vsseg2, 0x40, 0x2, 0x0, PseudoVSSEG2E64_V_M4 }, // 4757
  { Intrinsic::riscv_vsseg2_mask, 0x8, 0x0, 0x0, PseudoVSSEG2E8_V_M1_MASK }, // 4758
  { Intrinsic::riscv_vsseg2_mask, 0x8, 0x1, 0x0, PseudoVSSEG2E8_V_M2_MASK }, // 4759
  { Intrinsic::riscv_vsseg2_mask, 0x8, 0x2, 0x0, PseudoVSSEG2E8_V_M4_MASK }, // 4760
  { Intrinsic::riscv_vsseg2_mask, 0x8, 0x5, 0x0, PseudoVSSEG2E8_V_MF8_MASK }, // 4761
  { Intrinsic::riscv_vsseg2_mask, 0x8, 0x6, 0x0, PseudoVSSEG2E8_V_MF4_MASK }, // 4762
  { Intrinsic::riscv_vsseg2_mask, 0x8, 0x7, 0x0, PseudoVSSEG2E8_V_MF2_MASK }, // 4763
  { Intrinsic::riscv_vsseg2_mask, 0x10, 0x0, 0x0, PseudoVSSEG2E16_V_M1_MASK }, // 4764
  { Intrinsic::riscv_vsseg2_mask, 0x10, 0x1, 0x0, PseudoVSSEG2E16_V_M2_MASK }, // 4765
  { Intrinsic::riscv_vsseg2_mask, 0x10, 0x2, 0x0, PseudoVSSEG2E16_V_M4_MASK }, // 4766
  { Intrinsic::riscv_vsseg2_mask, 0x10, 0x6, 0x0, PseudoVSSEG2E16_V_MF4_MASK }, // 4767
  { Intrinsic::riscv_vsseg2_mask, 0x10, 0x7, 0x0, PseudoVSSEG2E16_V_MF2_MASK }, // 4768
  { Intrinsic::riscv_vsseg2_mask, 0x20, 0x0, 0x0, PseudoVSSEG2E32_V_M1_MASK }, // 4769
  { Intrinsic::riscv_vsseg2_mask, 0x20, 0x1, 0x0, PseudoVSSEG2E32_V_M2_MASK }, // 4770
  { Intrinsic::riscv_vsseg2_mask, 0x20, 0x2, 0x0, PseudoVSSEG2E32_V_M4_MASK }, // 4771
  { Intrinsic::riscv_vsseg2_mask, 0x20, 0x7, 0x0, PseudoVSSEG2E32_V_MF2_MASK }, // 4772
  { Intrinsic::riscv_vsseg2_mask, 0x40, 0x0, 0x0, PseudoVSSEG2E64_V_M1_MASK }, // 4773
  { Intrinsic::riscv_vsseg2_mask, 0x40, 0x1, 0x0, PseudoVSSEG2E64_V_M2_MASK }, // 4774
  { Intrinsic::riscv_vsseg2_mask, 0x40, 0x2, 0x0, PseudoVSSEG2E64_V_M4_MASK }, // 4775
  { Intrinsic::riscv_vsseg3, 0x8, 0x0, 0x0, PseudoVSSEG3E8_V_M1 }, // 4776
  { Intrinsic::riscv_vsseg3, 0x8, 0x1, 0x0, PseudoVSSEG3E8_V_M2 }, // 4777
  { Intrinsic::riscv_vsseg3, 0x8, 0x5, 0x0, PseudoVSSEG3E8_V_MF8 }, // 4778
  { Intrinsic::riscv_vsseg3, 0x8, 0x6, 0x0, PseudoVSSEG3E8_V_MF4 }, // 4779
  { Intrinsic::riscv_vsseg3, 0x8, 0x7, 0x0, PseudoVSSEG3E8_V_MF2 }, // 4780
  { Intrinsic::riscv_vsseg3, 0x10, 0x0, 0x0, PseudoVSSEG3E16_V_M1 }, // 4781
  { Intrinsic::riscv_vsseg3, 0x10, 0x1, 0x0, PseudoVSSEG3E16_V_M2 }, // 4782
  { Intrinsic::riscv_vsseg3, 0x10, 0x6, 0x0, PseudoVSSEG3E16_V_MF4 }, // 4783
  { Intrinsic::riscv_vsseg3, 0x10, 0x7, 0x0, PseudoVSSEG3E16_V_MF2 }, // 4784
  { Intrinsic::riscv_vsseg3, 0x20, 0x0, 0x0, PseudoVSSEG3E32_V_M1 }, // 4785
  { Intrinsic::riscv_vsseg3, 0x20, 0x1, 0x0, PseudoVSSEG3E32_V_M2 }, // 4786
  { Intrinsic::riscv_vsseg3, 0x20, 0x7, 0x0, PseudoVSSEG3E32_V_MF2 }, // 4787
  { Intrinsic::riscv_vsseg3, 0x40, 0x0, 0x0, PseudoVSSEG3E64_V_M1 }, // 4788
  { Intrinsic::riscv_vsseg3, 0x40, 0x1, 0x0, PseudoVSSEG3E64_V_M2 }, // 4789
  { Intrinsic::riscv_vsseg3_mask, 0x8, 0x0, 0x0, PseudoVSSEG3E8_V_M1_MASK }, // 4790
  { Intrinsic::riscv_vsseg3_mask, 0x8, 0x1, 0x0, PseudoVSSEG3E8_V_M2_MASK }, // 4791
  { Intrinsic::riscv_vsseg3_mask, 0x8, 0x5, 0x0, PseudoVSSEG3E8_V_MF8_MASK }, // 4792
  { Intrinsic::riscv_vsseg3_mask, 0x8, 0x6, 0x0, PseudoVSSEG3E8_V_MF4_MASK }, // 4793
  { Intrinsic::riscv_vsseg3_mask, 0x8, 0x7, 0x0, PseudoVSSEG3E8_V_MF2_MASK }, // 4794
  { Intrinsic::riscv_vsseg3_mask, 0x10, 0x0, 0x0, PseudoVSSEG3E16_V_M1_MASK }, // 4795
  { Intrinsic::riscv_vsseg3_mask, 0x10, 0x1, 0x0, PseudoVSSEG3E16_V_M2_MASK }, // 4796
  { Intrinsic::riscv_vsseg3_mask, 0x10, 0x6, 0x0, PseudoVSSEG3E16_V_MF4_MASK }, // 4797
  { Intrinsic::riscv_vsseg3_mask, 0x10, 0x7, 0x0, PseudoVSSEG3E16_V_MF2_MASK }, // 4798
  { Intrinsic::riscv_vsseg3_mask, 0x20, 0x0, 0x0, PseudoVSSEG3E32_V_M1_MASK }, // 4799
  { Intrinsic::riscv_vsseg3_mask, 0x20, 0x1, 0x0, PseudoVSSEG3E32_V_M2_MASK }, // 4800
  { Intrinsic::riscv_vsseg3_mask, 0x20, 0x7, 0x0, PseudoVSSEG3E32_V_MF2_MASK }, // 4801
  { Intrinsic::riscv_vsseg3_mask, 0x40, 0x0, 0x0, PseudoVSSEG3E64_V_M1_MASK }, // 4802
  { Intrinsic::riscv_vsseg3_mask, 0x40, 0x1, 0x0, PseudoVSSEG3E64_V_M2_MASK }, // 4803
  { Intrinsic::riscv_vsseg4, 0x8, 0x0, 0x0, PseudoVSSEG4E8_V_M1 }, // 4804
  { Intrinsic::riscv_vsseg4, 0x8, 0x1, 0x0, PseudoVSSEG4E8_V_M2 }, // 4805
  { Intrinsic::riscv_vsseg4, 0x8, 0x5, 0x0, PseudoVSSEG4E8_V_MF8 }, // 4806
  { Intrinsic::riscv_vsseg4, 0x8, 0x6, 0x0, PseudoVSSEG4E8_V_MF4 }, // 4807
  { Intrinsic::riscv_vsseg4, 0x8, 0x7, 0x0, PseudoVSSEG4E8_V_MF2 }, // 4808
  { Intrinsic::riscv_vsseg4, 0x10, 0x0, 0x0, PseudoVSSEG4E16_V_M1 }, // 4809
  { Intrinsic::riscv_vsseg4, 0x10, 0x1, 0x0, PseudoVSSEG4E16_V_M2 }, // 4810
  { Intrinsic::riscv_vsseg4, 0x10, 0x6, 0x0, PseudoVSSEG4E16_V_MF4 }, // 4811
  { Intrinsic::riscv_vsseg4, 0x10, 0x7, 0x0, PseudoVSSEG4E16_V_MF2 }, // 4812
  { Intrinsic::riscv_vsseg4, 0x20, 0x0, 0x0, PseudoVSSEG4E32_V_M1 }, // 4813
  { Intrinsic::riscv_vsseg4, 0x20, 0x1, 0x0, PseudoVSSEG4E32_V_M2 }, // 4814
  { Intrinsic::riscv_vsseg4, 0x20, 0x7, 0x0, PseudoVSSEG4E32_V_MF2 }, // 4815
  { Intrinsic::riscv_vsseg4, 0x40, 0x0, 0x0, PseudoVSSEG4E64_V_M1 }, // 4816
  { Intrinsic::riscv_vsseg4, 0x40, 0x1, 0x0, PseudoVSSEG4E64_V_M2 }, // 4817
  { Intrinsic::riscv_vsseg4_mask, 0x8, 0x0, 0x0, PseudoVSSEG4E8_V_M1_MASK }, // 4818
  { Intrinsic::riscv_vsseg4_mask, 0x8, 0x1, 0x0, PseudoVSSEG4E8_V_M2_MASK }, // 4819
  { Intrinsic::riscv_vsseg4_mask, 0x8, 0x5, 0x0, PseudoVSSEG4E8_V_MF8_MASK }, // 4820
  { Intrinsic::riscv_vsseg4_mask, 0x8, 0x6, 0x0, PseudoVSSEG4E8_V_MF4_MASK }, // 4821
  { Intrinsic::riscv_vsseg4_mask, 0x8, 0x7, 0x0, PseudoVSSEG4E8_V_MF2_MASK }, // 4822
  { Intrinsic::riscv_vsseg4_mask, 0x10, 0x0, 0x0, PseudoVSSEG4E16_V_M1_MASK }, // 4823
  { Intrinsic::riscv_vsseg4_mask, 0x10, 0x1, 0x0, PseudoVSSEG4E16_V_M2_MASK }, // 4824
  { Intrinsic::riscv_vsseg4_mask, 0x10, 0x6, 0x0, PseudoVSSEG4E16_V_MF4_MASK }, // 4825
  { Intrinsic::riscv_vsseg4_mask, 0x10, 0x7, 0x0, PseudoVSSEG4E16_V_MF2_MASK }, // 4826
  { Intrinsic::riscv_vsseg4_mask, 0x20, 0x0, 0x0, PseudoVSSEG4E32_V_M1_MASK }, // 4827
  { Intrinsic::riscv_vsseg4_mask, 0x20, 0x1, 0x0, PseudoVSSEG4E32_V_M2_MASK }, // 4828
  { Intrinsic::riscv_vsseg4_mask, 0x20, 0x7, 0x0, PseudoVSSEG4E32_V_MF2_MASK }, // 4829
  { Intrinsic::riscv_vsseg4_mask, 0x40, 0x0, 0x0, PseudoVSSEG4E64_V_M1_MASK }, // 4830
  { Intrinsic::riscv_vsseg4_mask, 0x40, 0x1, 0x0, PseudoVSSEG4E64_V_M2_MASK }, // 4831
  { Intrinsic::riscv_vsseg5, 0x8, 0x0, 0x0, PseudoVSSEG5E8_V_M1 }, // 4832
  { Intrinsic::riscv_vsseg5, 0x8, 0x5, 0x0, PseudoVSSEG5E8_V_MF8 }, // 4833
  { Intrinsic::riscv_vsseg5, 0x8, 0x6, 0x0, PseudoVSSEG5E8_V_MF4 }, // 4834
  { Intrinsic::riscv_vsseg5, 0x8, 0x7, 0x0, PseudoVSSEG5E8_V_MF2 }, // 4835
  { Intrinsic::riscv_vsseg5, 0x10, 0x0, 0x0, PseudoVSSEG5E16_V_M1 }, // 4836
  { Intrinsic::riscv_vsseg5, 0x10, 0x6, 0x0, PseudoVSSEG5E16_V_MF4 }, // 4837
  { Intrinsic::riscv_vsseg5, 0x10, 0x7, 0x0, PseudoVSSEG5E16_V_MF2 }, // 4838
  { Intrinsic::riscv_vsseg5, 0x20, 0x0, 0x0, PseudoVSSEG5E32_V_M1 }, // 4839
  { Intrinsic::riscv_vsseg5, 0x20, 0x7, 0x0, PseudoVSSEG5E32_V_MF2 }, // 4840
  { Intrinsic::riscv_vsseg5, 0x40, 0x0, 0x0, PseudoVSSEG5E64_V_M1 }, // 4841
  { Intrinsic::riscv_vsseg5_mask, 0x8, 0x0, 0x0, PseudoVSSEG5E8_V_M1_MASK }, // 4842
  { Intrinsic::riscv_vsseg5_mask, 0x8, 0x5, 0x0, PseudoVSSEG5E8_V_MF8_MASK }, // 4843
  { Intrinsic::riscv_vsseg5_mask, 0x8, 0x6, 0x0, PseudoVSSEG5E8_V_MF4_MASK }, // 4844
  { Intrinsic::riscv_vsseg5_mask, 0x8, 0x7, 0x0, PseudoVSSEG5E8_V_MF2_MASK }, // 4845
  { Intrinsic::riscv_vsseg5_mask, 0x10, 0x0, 0x0, PseudoVSSEG5E16_V_M1_MASK }, // 4846
  { Intrinsic::riscv_vsseg5_mask, 0x10, 0x6, 0x0, PseudoVSSEG5E16_V_MF4_MASK }, // 4847
  { Intrinsic::riscv_vsseg5_mask, 0x10, 0x7, 0x0, PseudoVSSEG5E16_V_MF2_MASK }, // 4848
  { Intrinsic::riscv_vsseg5_mask, 0x20, 0x0, 0x0, PseudoVSSEG5E32_V_M1_MASK }, // 4849
  { Intrinsic::riscv_vsseg5_mask, 0x20, 0x7, 0x0, PseudoVSSEG5E32_V_MF2_MASK }, // 4850
  { Intrinsic::riscv_vsseg5_mask, 0x40, 0x0, 0x0, PseudoVSSEG5E64_V_M1_MASK }, // 4851
  { Intrinsic::riscv_vsseg6, 0x8, 0x0, 0x0, PseudoVSSEG6E8_V_M1 }, // 4852
  { Intrinsic::riscv_vsseg6, 0x8, 0x5, 0x0, PseudoVSSEG6E8_V_MF8 }, // 4853
  { Intrinsic::riscv_vsseg6, 0x8, 0x6, 0x0, PseudoVSSEG6E8_V_MF4 }, // 4854
  { Intrinsic::riscv_vsseg6, 0x8, 0x7, 0x0, PseudoVSSEG6E8_V_MF2 }, // 4855
  { Intrinsic::riscv_vsseg6, 0x10, 0x0, 0x0, PseudoVSSEG6E16_V_M1 }, // 4856
  { Intrinsic::riscv_vsseg6, 0x10, 0x6, 0x0, PseudoVSSEG6E16_V_MF4 }, // 4857
  { Intrinsic::riscv_vsseg6, 0x10, 0x7, 0x0, PseudoVSSEG6E16_V_MF2 }, // 4858
  { Intrinsic::riscv_vsseg6, 0x20, 0x0, 0x0, PseudoVSSEG6E32_V_M1 }, // 4859
  { Intrinsic::riscv_vsseg6, 0x20, 0x7, 0x0, PseudoVSSEG6E32_V_MF2 }, // 4860
  { Intrinsic::riscv_vsseg6, 0x40, 0x0, 0x0, PseudoVSSEG6E64_V_M1 }, // 4861
  { Intrinsic::riscv_vsseg6_mask, 0x8, 0x0, 0x0, PseudoVSSEG6E8_V_M1_MASK }, // 4862
  { Intrinsic::riscv_vsseg6_mask, 0x8, 0x5, 0x0, PseudoVSSEG6E8_V_MF8_MASK }, // 4863
  { Intrinsic::riscv_vsseg6_mask, 0x8, 0x6, 0x0, PseudoVSSEG6E8_V_MF4_MASK }, // 4864
  { Intrinsic::riscv_vsseg6_mask, 0x8, 0x7, 0x0, PseudoVSSEG6E8_V_MF2_MASK }, // 4865
  { Intrinsic::riscv_vsseg6_mask, 0x10, 0x0, 0x0, PseudoVSSEG6E16_V_M1_MASK }, // 4866
  { Intrinsic::riscv_vsseg6_mask, 0x10, 0x6, 0x0, PseudoVSSEG6E16_V_MF4_MASK }, // 4867
  { Intrinsic::riscv_vsseg6_mask, 0x10, 0x7, 0x0, PseudoVSSEG6E16_V_MF2_MASK }, // 4868
  { Intrinsic::riscv_vsseg6_mask, 0x20, 0x0, 0x0, PseudoVSSEG6E32_V_M1_MASK }, // 4869
  { Intrinsic::riscv_vsseg6_mask, 0x20, 0x7, 0x0, PseudoVSSEG6E32_V_MF2_MASK }, // 4870
  { Intrinsic::riscv_vsseg6_mask, 0x40, 0x0, 0x0, PseudoVSSEG6E64_V_M1_MASK }, // 4871
  { Intrinsic::riscv_vsseg7, 0x8, 0x0, 0x0, PseudoVSSEG7E8_V_M1 }, // 4872
  { Intrinsic::riscv_vsseg7, 0x8, 0x5, 0x0, PseudoVSSEG7E8_V_MF8 }, // 4873
  { Intrinsic::riscv_vsseg7, 0x8, 0x6, 0x0, PseudoVSSEG7E8_V_MF4 }, // 4874
  { Intrinsic::riscv_vsseg7, 0x8, 0x7, 0x0, PseudoVSSEG7E8_V_MF2 }, // 4875
  { Intrinsic::riscv_vsseg7, 0x10, 0x0, 0x0, PseudoVSSEG7E16_V_M1 }, // 4876
  { Intrinsic::riscv_vsseg7, 0x10, 0x6, 0x0, PseudoVSSEG7E16_V_MF4 }, // 4877
  { Intrinsic::riscv_vsseg7, 0x10, 0x7, 0x0, PseudoVSSEG7E16_V_MF2 }, // 4878
  { Intrinsic::riscv_vsseg7, 0x20, 0x0, 0x0, PseudoVSSEG7E32_V_M1 }, // 4879
  { Intrinsic::riscv_vsseg7, 0x20, 0x7, 0x0, PseudoVSSEG7E32_V_MF2 }, // 4880
  { Intrinsic::riscv_vsseg7, 0x40, 0x0, 0x0, PseudoVSSEG7E64_V_M1 }, // 4881
  { Intrinsic::riscv_vsseg7_mask, 0x8, 0x0, 0x0, PseudoVSSEG7E8_V_M1_MASK }, // 4882
  { Intrinsic::riscv_vsseg7_mask, 0x8, 0x5, 0x0, PseudoVSSEG7E8_V_MF8_MASK }, // 4883
  { Intrinsic::riscv_vsseg7_mask, 0x8, 0x6, 0x0, PseudoVSSEG7E8_V_MF4_MASK }, // 4884
  { Intrinsic::riscv_vsseg7_mask, 0x8, 0x7, 0x0, PseudoVSSEG7E8_V_MF2_MASK }, // 4885
  { Intrinsic::riscv_vsseg7_mask, 0x10, 0x0, 0x0, PseudoVSSEG7E16_V_M1_MASK }, // 4886
  { Intrinsic::riscv_vsseg7_mask, 0x10, 0x6, 0x0, PseudoVSSEG7E16_V_MF4_MASK }, // 4887
  { Intrinsic::riscv_vsseg7_mask, 0x10, 0x7, 0x0, PseudoVSSEG7E16_V_MF2_MASK }, // 4888
  { Intrinsic::riscv_vsseg7_mask, 0x20, 0x0, 0x0, PseudoVSSEG7E32_V_M1_MASK }, // 4889
  { Intrinsic::riscv_vsseg7_mask, 0x20, 0x7, 0x0, PseudoVSSEG7E32_V_MF2_MASK }, // 4890
  { Intrinsic::riscv_vsseg7_mask, 0x40, 0x0, 0x0, PseudoVSSEG7E64_V_M1_MASK }, // 4891
  { Intrinsic::riscv_vsseg8, 0x8, 0x0, 0x0, PseudoVSSEG8E8_V_M1 }, // 4892
  { Intrinsic::riscv_vsseg8, 0x8, 0x5, 0x0, PseudoVSSEG8E8_V_MF8 }, // 4893
  { Intrinsic::riscv_vsseg8, 0x8, 0x6, 0x0, PseudoVSSEG8E8_V_MF4 }, // 4894
  { Intrinsic::riscv_vsseg8, 0x8, 0x7, 0x0, PseudoVSSEG8E8_V_MF2 }, // 4895
  { Intrinsic::riscv_vsseg8, 0x10, 0x0, 0x0, PseudoVSSEG8E16_V_M1 }, // 4896
  { Intrinsic::riscv_vsseg8, 0x10, 0x6, 0x0, PseudoVSSEG8E16_V_MF4 }, // 4897
  { Intrinsic::riscv_vsseg8, 0x10, 0x7, 0x0, PseudoVSSEG8E16_V_MF2 }, // 4898
  { Intrinsic::riscv_vsseg8, 0x20, 0x0, 0x0, PseudoVSSEG8E32_V_M1 }, // 4899
  { Intrinsic::riscv_vsseg8, 0x20, 0x7, 0x0, PseudoVSSEG8E32_V_MF2 }, // 4900
  { Intrinsic::riscv_vsseg8, 0x40, 0x0, 0x0, PseudoVSSEG8E64_V_M1 }, // 4901
  { Intrinsic::riscv_vsseg8_mask, 0x8, 0x0, 0x0, PseudoVSSEG8E8_V_M1_MASK }, // 4902
  { Intrinsic::riscv_vsseg8_mask, 0x8, 0x5, 0x0, PseudoVSSEG8E8_V_MF8_MASK }, // 4903
  { Intrinsic::riscv_vsseg8_mask, 0x8, 0x6, 0x0, PseudoVSSEG8E8_V_MF4_MASK }, // 4904
  { Intrinsic::riscv_vsseg8_mask, 0x8, 0x7, 0x0, PseudoVSSEG8E8_V_MF2_MASK }, // 4905
  { Intrinsic::riscv_vsseg8_mask, 0x10, 0x0, 0x0, PseudoVSSEG8E16_V_M1_MASK }, // 4906
  { Intrinsic::riscv_vsseg8_mask, 0x10, 0x6, 0x0, PseudoVSSEG8E16_V_MF4_MASK }, // 4907
  { Intrinsic::riscv_vsseg8_mask, 0x10, 0x7, 0x0, PseudoVSSEG8E16_V_MF2_MASK }, // 4908
  { Intrinsic::riscv_vsseg8_mask, 0x20, 0x0, 0x0, PseudoVSSEG8E32_V_M1_MASK }, // 4909
  { Intrinsic::riscv_vsseg8_mask, 0x20, 0x7, 0x0, PseudoVSSEG8E32_V_MF2_MASK }, // 4910
  { Intrinsic::riscv_vsseg8_mask, 0x40, 0x0, 0x0, PseudoVSSEG8E64_V_M1_MASK }, // 4911
  { Intrinsic::riscv_vssseg2, 0x8, 0x0, 0x0, PseudoVSSSEG2E8_V_M1 }, // 4912
  { Intrinsic::riscv_vssseg2, 0x8, 0x1, 0x0, PseudoVSSSEG2E8_V_M2 }, // 4913
  { Intrinsic::riscv_vssseg2, 0x8, 0x2, 0x0, PseudoVSSSEG2E8_V_M4 }, // 4914
  { Intrinsic::riscv_vssseg2, 0x8, 0x5, 0x0, PseudoVSSSEG2E8_V_MF8 }, // 4915
  { Intrinsic::riscv_vssseg2, 0x8, 0x6, 0x0, PseudoVSSSEG2E8_V_MF4 }, // 4916
  { Intrinsic::riscv_vssseg2, 0x8, 0x7, 0x0, PseudoVSSSEG2E8_V_MF2 }, // 4917
  { Intrinsic::riscv_vssseg2, 0x10, 0x0, 0x0, PseudoVSSSEG2E16_V_M1 }, // 4918
  { Intrinsic::riscv_vssseg2, 0x10, 0x1, 0x0, PseudoVSSSEG2E16_V_M2 }, // 4919
  { Intrinsic::riscv_vssseg2, 0x10, 0x2, 0x0, PseudoVSSSEG2E16_V_M4 }, // 4920
  { Intrinsic::riscv_vssseg2, 0x10, 0x6, 0x0, PseudoVSSSEG2E16_V_MF4 }, // 4921
  { Intrinsic::riscv_vssseg2, 0x10, 0x7, 0x0, PseudoVSSSEG2E16_V_MF2 }, // 4922
  { Intrinsic::riscv_vssseg2, 0x20, 0x0, 0x0, PseudoVSSSEG2E32_V_M1 }, // 4923
  { Intrinsic::riscv_vssseg2, 0x20, 0x1, 0x0, PseudoVSSSEG2E32_V_M2 }, // 4924
  { Intrinsic::riscv_vssseg2, 0x20, 0x2, 0x0, PseudoVSSSEG2E32_V_M4 }, // 4925
  { Intrinsic::riscv_vssseg2, 0x20, 0x7, 0x0, PseudoVSSSEG2E32_V_MF2 }, // 4926
  { Intrinsic::riscv_vssseg2, 0x40, 0x0, 0x0, PseudoVSSSEG2E64_V_M1 }, // 4927
  { Intrinsic::riscv_vssseg2, 0x40, 0x1, 0x0, PseudoVSSSEG2E64_V_M2 }, // 4928
  { Intrinsic::riscv_vssseg2, 0x40, 0x2, 0x0, PseudoVSSSEG2E64_V_M4 }, // 4929
  { Intrinsic::riscv_vssseg2_mask, 0x8, 0x0, 0x0, PseudoVSSSEG2E8_V_M1_MASK }, // 4930
  { Intrinsic::riscv_vssseg2_mask, 0x8, 0x1, 0x0, PseudoVSSSEG2E8_V_M2_MASK }, // 4931
  { Intrinsic::riscv_vssseg2_mask, 0x8, 0x2, 0x0, PseudoVSSSEG2E8_V_M4_MASK }, // 4932
  { Intrinsic::riscv_vssseg2_mask, 0x8, 0x5, 0x0, PseudoVSSSEG2E8_V_MF8_MASK }, // 4933
  { Intrinsic::riscv_vssseg2_mask, 0x8, 0x6, 0x0, PseudoVSSSEG2E8_V_MF4_MASK }, // 4934
  { Intrinsic::riscv_vssseg2_mask, 0x8, 0x7, 0x0, PseudoVSSSEG2E8_V_MF2_MASK }, // 4935
  { Intrinsic::riscv_vssseg2_mask, 0x10, 0x0, 0x0, PseudoVSSSEG2E16_V_M1_MASK }, // 4936
  { Intrinsic::riscv_vssseg2_mask, 0x10, 0x1, 0x0, PseudoVSSSEG2E16_V_M2_MASK }, // 4937
  { Intrinsic::riscv_vssseg2_mask, 0x10, 0x2, 0x0, PseudoVSSSEG2E16_V_M4_MASK }, // 4938
  { Intrinsic::riscv_vssseg2_mask, 0x10, 0x6, 0x0, PseudoVSSSEG2E16_V_MF4_MASK }, // 4939
  { Intrinsic::riscv_vssseg2_mask, 0x10, 0x7, 0x0, PseudoVSSSEG2E16_V_MF2_MASK }, // 4940
  { Intrinsic::riscv_vssseg2_mask, 0x20, 0x0, 0x0, PseudoVSSSEG2E32_V_M1_MASK }, // 4941
  { Intrinsic::riscv_vssseg2_mask, 0x20, 0x1, 0x0, PseudoVSSSEG2E32_V_M2_MASK }, // 4942
  { Intrinsic::riscv_vssseg2_mask, 0x20, 0x2, 0x0, PseudoVSSSEG2E32_V_M4_MASK }, // 4943
  { Intrinsic::riscv_vssseg2_mask, 0x20, 0x7, 0x0, PseudoVSSSEG2E32_V_MF2_MASK }, // 4944
  { Intrinsic::riscv_vssseg2_mask, 0x40, 0x0, 0x0, PseudoVSSSEG2E64_V_M1_MASK }, // 4945
  { Intrinsic::riscv_vssseg2_mask, 0x40, 0x1, 0x0, PseudoVSSSEG2E64_V_M2_MASK }, // 4946
  { Intrinsic::riscv_vssseg2_mask, 0x40, 0x2, 0x0, PseudoVSSSEG2E64_V_M4_MASK }, // 4947
  { Intrinsic::riscv_vssseg3, 0x8, 0x0, 0x0, PseudoVSSSEG3E8_V_M1 }, // 4948
  { Intrinsic::riscv_vssseg3, 0x8, 0x1, 0x0, PseudoVSSSEG3E8_V_M2 }, // 4949
  { Intrinsic::riscv_vssseg3, 0x8, 0x5, 0x0, PseudoVSSSEG3E8_V_MF8 }, // 4950
  { Intrinsic::riscv_vssseg3, 0x8, 0x6, 0x0, PseudoVSSSEG3E8_V_MF4 }, // 4951
  { Intrinsic::riscv_vssseg3, 0x8, 0x7, 0x0, PseudoVSSSEG3E8_V_MF2 }, // 4952
  { Intrinsic::riscv_vssseg3, 0x10, 0x0, 0x0, PseudoVSSSEG3E16_V_M1 }, // 4953
  { Intrinsic::riscv_vssseg3, 0x10, 0x1, 0x0, PseudoVSSSEG3E16_V_M2 }, // 4954
  { Intrinsic::riscv_vssseg3, 0x10, 0x6, 0x0, PseudoVSSSEG3E16_V_MF4 }, // 4955
  { Intrinsic::riscv_vssseg3, 0x10, 0x7, 0x0, PseudoVSSSEG3E16_V_MF2 }, // 4956
  { Intrinsic::riscv_vssseg3, 0x20, 0x0, 0x0, PseudoVSSSEG3E32_V_M1 }, // 4957
  { Intrinsic::riscv_vssseg3, 0x20, 0x1, 0x0, PseudoVSSSEG3E32_V_M2 }, // 4958
  { Intrinsic::riscv_vssseg3, 0x20, 0x7, 0x0, PseudoVSSSEG3E32_V_MF2 }, // 4959
  { Intrinsic::riscv_vssseg3, 0x40, 0x0, 0x0, PseudoVSSSEG3E64_V_M1 }, // 4960
  { Intrinsic::riscv_vssseg3, 0x40, 0x1, 0x0, PseudoVSSSEG3E64_V_M2 }, // 4961
  { Intrinsic::riscv_vssseg3_mask, 0x8, 0x0, 0x0, PseudoVSSSEG3E8_V_M1_MASK }, // 4962
  { Intrinsic::riscv_vssseg3_mask, 0x8, 0x1, 0x0, PseudoVSSSEG3E8_V_M2_MASK }, // 4963
  { Intrinsic::riscv_vssseg3_mask, 0x8, 0x5, 0x0, PseudoVSSSEG3E8_V_MF8_MASK }, // 4964
  { Intrinsic::riscv_vssseg3_mask, 0x8, 0x6, 0x0, PseudoVSSSEG3E8_V_MF4_MASK }, // 4965
  { Intrinsic::riscv_vssseg3_mask, 0x8, 0x7, 0x0, PseudoVSSSEG3E8_V_MF2_MASK }, // 4966
  { Intrinsic::riscv_vssseg3_mask, 0x10, 0x0, 0x0, PseudoVSSSEG3E16_V_M1_MASK }, // 4967
  { Intrinsic::riscv_vssseg3_mask, 0x10, 0x1, 0x0, PseudoVSSSEG3E16_V_M2_MASK }, // 4968
  { Intrinsic::riscv_vssseg3_mask, 0x10, 0x6, 0x0, PseudoVSSSEG3E16_V_MF4_MASK }, // 4969
  { Intrinsic::riscv_vssseg3_mask, 0x10, 0x7, 0x0, PseudoVSSSEG3E16_V_MF2_MASK }, // 4970
  { Intrinsic::riscv_vssseg3_mask, 0x20, 0x0, 0x0, PseudoVSSSEG3E32_V_M1_MASK }, // 4971
  { Intrinsic::riscv_vssseg3_mask, 0x20, 0x1, 0x0, PseudoVSSSEG3E32_V_M2_MASK }, // 4972
  { Intrinsic::riscv_vssseg3_mask, 0x20, 0x7, 0x0, PseudoVSSSEG3E32_V_MF2_MASK }, // 4973
  { Intrinsic::riscv_vssseg3_mask, 0x40, 0x0, 0x0, PseudoVSSSEG3E64_V_M1_MASK }, // 4974
  { Intrinsic::riscv_vssseg3_mask, 0x40, 0x1, 0x0, PseudoVSSSEG3E64_V_M2_MASK }, // 4975
  { Intrinsic::riscv_vssseg4, 0x8, 0x0, 0x0, PseudoVSSSEG4E8_V_M1 }, // 4976
  { Intrinsic::riscv_vssseg4, 0x8, 0x1, 0x0, PseudoVSSSEG4E8_V_M2 }, // 4977
  { Intrinsic::riscv_vssseg4, 0x8, 0x5, 0x0, PseudoVSSSEG4E8_V_MF8 }, // 4978
  { Intrinsic::riscv_vssseg4, 0x8, 0x6, 0x0, PseudoVSSSEG4E8_V_MF4 }, // 4979
  { Intrinsic::riscv_vssseg4, 0x8, 0x7, 0x0, PseudoVSSSEG4E8_V_MF2 }, // 4980
  { Intrinsic::riscv_vssseg4, 0x10, 0x0, 0x0, PseudoVSSSEG4E16_V_M1 }, // 4981
  { Intrinsic::riscv_vssseg4, 0x10, 0x1, 0x0, PseudoVSSSEG4E16_V_M2 }, // 4982
  { Intrinsic::riscv_vssseg4, 0x10, 0x6, 0x0, PseudoVSSSEG4E16_V_MF4 }, // 4983
  { Intrinsic::riscv_vssseg4, 0x10, 0x7, 0x0, PseudoVSSSEG4E16_V_MF2 }, // 4984
  { Intrinsic::riscv_vssseg4, 0x20, 0x0, 0x0, PseudoVSSSEG4E32_V_M1 }, // 4985
  { Intrinsic::riscv_vssseg4, 0x20, 0x1, 0x0, PseudoVSSSEG4E32_V_M2 }, // 4986
  { Intrinsic::riscv_vssseg4, 0x20, 0x7, 0x0, PseudoVSSSEG4E32_V_MF2 }, // 4987
  { Intrinsic::riscv_vssseg4, 0x40, 0x0, 0x0, PseudoVSSSEG4E64_V_M1 }, // 4988
  { Intrinsic::riscv_vssseg4, 0x40, 0x1, 0x0, PseudoVSSSEG4E64_V_M2 }, // 4989
  { Intrinsic::riscv_vssseg4_mask, 0x8, 0x0, 0x0, PseudoVSSSEG4E8_V_M1_MASK }, // 4990
  { Intrinsic::riscv_vssseg4_mask, 0x8, 0x1, 0x0, PseudoVSSSEG4E8_V_M2_MASK }, // 4991
  { Intrinsic::riscv_vssseg4_mask, 0x8, 0x5, 0x0, PseudoVSSSEG4E8_V_MF8_MASK }, // 4992
  { Intrinsic::riscv_vssseg4_mask, 0x8, 0x6, 0x0, PseudoVSSSEG4E8_V_MF4_MASK }, // 4993
  { Intrinsic::riscv_vssseg4_mask, 0x8, 0x7, 0x0, PseudoVSSSEG4E8_V_MF2_MASK }, // 4994
  { Intrinsic::riscv_vssseg4_mask, 0x10, 0x0, 0x0, PseudoVSSSEG4E16_V_M1_MASK }, // 4995
  { Intrinsic::riscv_vssseg4_mask, 0x10, 0x1, 0x0, PseudoVSSSEG4E16_V_M2_MASK }, // 4996
  { Intrinsic::riscv_vssseg4_mask, 0x10, 0x6, 0x0, PseudoVSSSEG4E16_V_MF4_MASK }, // 4997
  { Intrinsic::riscv_vssseg4_mask, 0x10, 0x7, 0x0, PseudoVSSSEG4E16_V_MF2_MASK }, // 4998
  { Intrinsic::riscv_vssseg4_mask, 0x20, 0x0, 0x0, PseudoVSSSEG4E32_V_M1_MASK }, // 4999
  { Intrinsic::riscv_vssseg4_mask, 0x20, 0x1, 0x0, PseudoVSSSEG4E32_V_M2_MASK }, // 5000
  { Intrinsic::riscv_vssseg4_mask, 0x20, 0x7, 0x0, PseudoVSSSEG4E32_V_MF2_MASK }, // 5001
  { Intrinsic::riscv_vssseg4_mask, 0x40, 0x0, 0x0, PseudoVSSSEG4E64_V_M1_MASK }, // 5002
  { Intrinsic::riscv_vssseg4_mask, 0x40, 0x1, 0x0, PseudoVSSSEG4E64_V_M2_MASK }, // 5003
  { Intrinsic::riscv_vssseg5, 0x8, 0x0, 0x0, PseudoVSSSEG5E8_V_M1 }, // 5004
  { Intrinsic::riscv_vssseg5, 0x8, 0x5, 0x0, PseudoVSSSEG5E8_V_MF8 }, // 5005
  { Intrinsic::riscv_vssseg5, 0x8, 0x6, 0x0, PseudoVSSSEG5E8_V_MF4 }, // 5006
  { Intrinsic::riscv_vssseg5, 0x8, 0x7, 0x0, PseudoVSSSEG5E8_V_MF2 }, // 5007
  { Intrinsic::riscv_vssseg5, 0x10, 0x0, 0x0, PseudoVSSSEG5E16_V_M1 }, // 5008
  { Intrinsic::riscv_vssseg5, 0x10, 0x6, 0x0, PseudoVSSSEG5E16_V_MF4 }, // 5009
  { Intrinsic::riscv_vssseg5, 0x10, 0x7, 0x0, PseudoVSSSEG5E16_V_MF2 }, // 5010
  { Intrinsic::riscv_vssseg5, 0x20, 0x0, 0x0, PseudoVSSSEG5E32_V_M1 }, // 5011
  { Intrinsic::riscv_vssseg5, 0x20, 0x7, 0x0, PseudoVSSSEG5E32_V_MF2 }, // 5012
  { Intrinsic::riscv_vssseg5, 0x40, 0x0, 0x0, PseudoVSSSEG5E64_V_M1 }, // 5013
  { Intrinsic::riscv_vssseg5_mask, 0x8, 0x0, 0x0, PseudoVSSSEG5E8_V_M1_MASK }, // 5014
  { Intrinsic::riscv_vssseg5_mask, 0x8, 0x5, 0x0, PseudoVSSSEG5E8_V_MF8_MASK }, // 5015
  { Intrinsic::riscv_vssseg5_mask, 0x8, 0x6, 0x0, PseudoVSSSEG5E8_V_MF4_MASK }, // 5016
  { Intrinsic::riscv_vssseg5_mask, 0x8, 0x7, 0x0, PseudoVSSSEG5E8_V_MF2_MASK }, // 5017
  { Intrinsic::riscv_vssseg5_mask, 0x10, 0x0, 0x0, PseudoVSSSEG5E16_V_M1_MASK }, // 5018
  { Intrinsic::riscv_vssseg5_mask, 0x10, 0x6, 0x0, PseudoVSSSEG5E16_V_MF4_MASK }, // 5019
  { Intrinsic::riscv_vssseg5_mask, 0x10, 0x7, 0x0, PseudoVSSSEG5E16_V_MF2_MASK }, // 5020
  { Intrinsic::riscv_vssseg5_mask, 0x20, 0x0, 0x0, PseudoVSSSEG5E32_V_M1_MASK }, // 5021
  { Intrinsic::riscv_vssseg5_mask, 0x20, 0x7, 0x0, PseudoVSSSEG5E32_V_MF2_MASK }, // 5022
  { Intrinsic::riscv_vssseg5_mask, 0x40, 0x0, 0x0, PseudoVSSSEG5E64_V_M1_MASK }, // 5023
  { Intrinsic::riscv_vssseg6, 0x8, 0x0, 0x0, PseudoVSSSEG6E8_V_M1 }, // 5024
  { Intrinsic::riscv_vssseg6, 0x8, 0x5, 0x0, PseudoVSSSEG6E8_V_MF8 }, // 5025
  { Intrinsic::riscv_vssseg6, 0x8, 0x6, 0x0, PseudoVSSSEG6E8_V_MF4 }, // 5026
  { Intrinsic::riscv_vssseg6, 0x8, 0x7, 0x0, PseudoVSSSEG6E8_V_MF2 }, // 5027
  { Intrinsic::riscv_vssseg6, 0x10, 0x0, 0x0, PseudoVSSSEG6E16_V_M1 }, // 5028
  { Intrinsic::riscv_vssseg6, 0x10, 0x6, 0x0, PseudoVSSSEG6E16_V_MF4 }, // 5029
  { Intrinsic::riscv_vssseg6, 0x10, 0x7, 0x0, PseudoVSSSEG6E16_V_MF2 }, // 5030
  { Intrinsic::riscv_vssseg6, 0x20, 0x0, 0x0, PseudoVSSSEG6E32_V_M1 }, // 5031
  { Intrinsic::riscv_vssseg6, 0x20, 0x7, 0x0, PseudoVSSSEG6E32_V_MF2 }, // 5032
  { Intrinsic::riscv_vssseg6, 0x40, 0x0, 0x0, PseudoVSSSEG6E64_V_M1 }, // 5033
  { Intrinsic::riscv_vssseg6_mask, 0x8, 0x0, 0x0, PseudoVSSSEG6E8_V_M1_MASK }, // 5034
  { Intrinsic::riscv_vssseg6_mask, 0x8, 0x5, 0x0, PseudoVSSSEG6E8_V_MF8_MASK }, // 5035
  { Intrinsic::riscv_vssseg6_mask, 0x8, 0x6, 0x0, PseudoVSSSEG6E8_V_MF4_MASK }, // 5036
  { Intrinsic::riscv_vssseg6_mask, 0x8, 0x7, 0x0, PseudoVSSSEG6E8_V_MF2_MASK }, // 5037
  { Intrinsic::riscv_vssseg6_mask, 0x10, 0x0, 0x0, PseudoVSSSEG6E16_V_M1_MASK }, // 5038
  { Intrinsic::riscv_vssseg6_mask, 0x10, 0x6, 0x0, PseudoVSSSEG6E16_V_MF4_MASK }, // 5039
  { Intrinsic::riscv_vssseg6_mask, 0x10, 0x7, 0x0, PseudoVSSSEG6E16_V_MF2_MASK }, // 5040
  { Intrinsic::riscv_vssseg6_mask, 0x20, 0x0, 0x0, PseudoVSSSEG6E32_V_M1_MASK }, // 5041
  { Intrinsic::riscv_vssseg6_mask, 0x20, 0x7, 0x0, PseudoVSSSEG6E32_V_MF2_MASK }, // 5042
  { Intrinsic::riscv_vssseg6_mask, 0x40, 0x0, 0x0, PseudoVSSSEG6E64_V_M1_MASK }, // 5043
  { Intrinsic::riscv_vssseg7, 0x8, 0x0, 0x0, PseudoVSSSEG7E8_V_M1 }, // 5044
  { Intrinsic::riscv_vssseg7, 0x8, 0x5, 0x0, PseudoVSSSEG7E8_V_MF8 }, // 5045
  { Intrinsic::riscv_vssseg7, 0x8, 0x6, 0x0, PseudoVSSSEG7E8_V_MF4 }, // 5046
  { Intrinsic::riscv_vssseg7, 0x8, 0x7, 0x0, PseudoVSSSEG7E8_V_MF2 }, // 5047
  { Intrinsic::riscv_vssseg7, 0x10, 0x0, 0x0, PseudoVSSSEG7E16_V_M1 }, // 5048
  { Intrinsic::riscv_vssseg7, 0x10, 0x6, 0x0, PseudoVSSSEG7E16_V_MF4 }, // 5049
  { Intrinsic::riscv_vssseg7, 0x10, 0x7, 0x0, PseudoVSSSEG7E16_V_MF2 }, // 5050
  { Intrinsic::riscv_vssseg7, 0x20, 0x0, 0x0, PseudoVSSSEG7E32_V_M1 }, // 5051
  { Intrinsic::riscv_vssseg7, 0x20, 0x7, 0x0, PseudoVSSSEG7E32_V_MF2 }, // 5052
  { Intrinsic::riscv_vssseg7, 0x40, 0x0, 0x0, PseudoVSSSEG7E64_V_M1 }, // 5053
  { Intrinsic::riscv_vssseg7_mask, 0x8, 0x0, 0x0, PseudoVSSSEG7E8_V_M1_MASK }, // 5054
  { Intrinsic::riscv_vssseg7_mask, 0x8, 0x5, 0x0, PseudoVSSSEG7E8_V_MF8_MASK }, // 5055
  { Intrinsic::riscv_vssseg7_mask, 0x8, 0x6, 0x0, PseudoVSSSEG7E8_V_MF4_MASK }, // 5056
  { Intrinsic::riscv_vssseg7_mask, 0x8, 0x7, 0x0, PseudoVSSSEG7E8_V_MF2_MASK }, // 5057
  { Intrinsic::riscv_vssseg7_mask, 0x10, 0x0, 0x0, PseudoVSSSEG7E16_V_M1_MASK }, // 5058
  { Intrinsic::riscv_vssseg7_mask, 0x10, 0x6, 0x0, PseudoVSSSEG7E16_V_MF4_MASK }, // 5059
  { Intrinsic::riscv_vssseg7_mask, 0x10, 0x7, 0x0, PseudoVSSSEG7E16_V_MF2_MASK }, // 5060
  { Intrinsic::riscv_vssseg7_mask, 0x20, 0x0, 0x0, PseudoVSSSEG7E32_V_M1_MASK }, // 5061
  { Intrinsic::riscv_vssseg7_mask, 0x20, 0x7, 0x0, PseudoVSSSEG7E32_V_MF2_MASK }, // 5062
  { Intrinsic::riscv_vssseg7_mask, 0x40, 0x0, 0x0, PseudoVSSSEG7E64_V_M1_MASK }, // 5063
  { Intrinsic::riscv_vssseg8, 0x8, 0x0, 0x0, PseudoVSSSEG8E8_V_M1 }, // 5064
  { Intrinsic::riscv_vssseg8, 0x8, 0x5, 0x0, PseudoVSSSEG8E8_V_MF8 }, // 5065
  { Intrinsic::riscv_vssseg8, 0x8, 0x6, 0x0, PseudoVSSSEG8E8_V_MF4 }, // 5066
  { Intrinsic::riscv_vssseg8, 0x8, 0x7, 0x0, PseudoVSSSEG8E8_V_MF2 }, // 5067
  { Intrinsic::riscv_vssseg8, 0x10, 0x0, 0x0, PseudoVSSSEG8E16_V_M1 }, // 5068
  { Intrinsic::riscv_vssseg8, 0x10, 0x6, 0x0, PseudoVSSSEG8E16_V_MF4 }, // 5069
  { Intrinsic::riscv_vssseg8, 0x10, 0x7, 0x0, PseudoVSSSEG8E16_V_MF2 }, // 5070
  { Intrinsic::riscv_vssseg8, 0x20, 0x0, 0x0, PseudoVSSSEG8E32_V_M1 }, // 5071
  { Intrinsic::riscv_vssseg8, 0x20, 0x7, 0x0, PseudoVSSSEG8E32_V_MF2 }, // 5072
  { Intrinsic::riscv_vssseg8, 0x40, 0x0, 0x0, PseudoVSSSEG8E64_V_M1 }, // 5073
  { Intrinsic::riscv_vssseg8_mask, 0x8, 0x0, 0x0, PseudoVSSSEG8E8_V_M1_MASK }, // 5074
  { Intrinsic::riscv_vssseg8_mask, 0x8, 0x5, 0x0, PseudoVSSSEG8E8_V_MF8_MASK }, // 5075
  { Intrinsic::riscv_vssseg8_mask, 0x8, 0x6, 0x0, PseudoVSSSEG8E8_V_MF4_MASK }, // 5076
  { Intrinsic::riscv_vssseg8_mask, 0x8, 0x7, 0x0, PseudoVSSSEG8E8_V_MF2_MASK }, // 5077
  { Intrinsic::riscv_vssseg8_mask, 0x10, 0x0, 0x0, PseudoVSSSEG8E16_V_M1_MASK }, // 5078
  { Intrinsic::riscv_vssseg8_mask, 0x10, 0x6, 0x0, PseudoVSSSEG8E16_V_MF4_MASK }, // 5079
  { Intrinsic::riscv_vssseg8_mask, 0x10, 0x7, 0x0, PseudoVSSSEG8E16_V_MF2_MASK }, // 5080
  { Intrinsic::riscv_vssseg8_mask, 0x20, 0x0, 0x0, PseudoVSSSEG8E32_V_M1_MASK }, // 5081
  { Intrinsic::riscv_vssseg8_mask, 0x20, 0x7, 0x0, PseudoVSSSEG8E32_V_MF2_MASK }, // 5082
  { Intrinsic::riscv_vssseg8_mask, 0x40, 0x0, 0x0, PseudoVSSSEG8E64_V_M1_MASK }, // 5083
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x0, 0x0, PseudoVSUXSEG2EI8_V_M1_M1 }, // 5084
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x0, 0x1, PseudoVSUXSEG2EI8_V_M2_M1 }, // 5085
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x0, 0x2, PseudoVSUXSEG2EI8_V_M4_M1 }, // 5086
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x0, 0x3, PseudoVSUXSEG2EI8_V_M8_M1 }, // 5087
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x0, 0x5, PseudoVSUXSEG2EI8_V_MF8_M1 }, // 5088
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x0, 0x6, PseudoVSUXSEG2EI8_V_MF4_M1 }, // 5089
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x0, 0x7, PseudoVSUXSEG2EI8_V_MF2_M1 }, // 5090
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x1, 0x0, PseudoVSUXSEG2EI8_V_M1_M2 }, // 5091
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x1, 0x1, PseudoVSUXSEG2EI8_V_M2_M2 }, // 5092
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x1, 0x2, PseudoVSUXSEG2EI8_V_M4_M2 }, // 5093
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x1, 0x3, PseudoVSUXSEG2EI8_V_M8_M2 }, // 5094
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x1, 0x5, PseudoVSUXSEG2EI8_V_MF8_M2 }, // 5095
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x1, 0x6, PseudoVSUXSEG2EI8_V_MF4_M2 }, // 5096
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x1, 0x7, PseudoVSUXSEG2EI8_V_MF2_M2 }, // 5097
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x2, 0x0, PseudoVSUXSEG2EI8_V_M1_M4 }, // 5098
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x2, 0x1, PseudoVSUXSEG2EI8_V_M2_M4 }, // 5099
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x2, 0x2, PseudoVSUXSEG2EI8_V_M4_M4 }, // 5100
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x2, 0x3, PseudoVSUXSEG2EI8_V_M8_M4 }, // 5101
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x2, 0x5, PseudoVSUXSEG2EI8_V_MF8_M4 }, // 5102
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x2, 0x6, PseudoVSUXSEG2EI8_V_MF4_M4 }, // 5103
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x2, 0x7, PseudoVSUXSEG2EI8_V_MF2_M4 }, // 5104
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x5, 0x0, PseudoVSUXSEG2EI8_V_M1_MF8 }, // 5105
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x5, 0x1, PseudoVSUXSEG2EI8_V_M2_MF8 }, // 5106
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x5, 0x2, PseudoVSUXSEG2EI8_V_M4_MF8 }, // 5107
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x5, 0x3, PseudoVSUXSEG2EI8_V_M8_MF8 }, // 5108
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x5, 0x5, PseudoVSUXSEG2EI8_V_MF8_MF8 }, // 5109
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x5, 0x6, PseudoVSUXSEG2EI8_V_MF4_MF8 }, // 5110
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x5, 0x7, PseudoVSUXSEG2EI8_V_MF2_MF8 }, // 5111
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x6, 0x0, PseudoVSUXSEG2EI8_V_M1_MF4 }, // 5112
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x6, 0x1, PseudoVSUXSEG2EI8_V_M2_MF4 }, // 5113
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x6, 0x2, PseudoVSUXSEG2EI8_V_M4_MF4 }, // 5114
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x6, 0x3, PseudoVSUXSEG2EI8_V_M8_MF4 }, // 5115
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x6, 0x5, PseudoVSUXSEG2EI8_V_MF8_MF4 }, // 5116
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x6, 0x6, PseudoVSUXSEG2EI8_V_MF4_MF4 }, // 5117
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x6, 0x7, PseudoVSUXSEG2EI8_V_MF2_MF4 }, // 5118
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x7, 0x0, PseudoVSUXSEG2EI8_V_M1_MF2 }, // 5119
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x7, 0x1, PseudoVSUXSEG2EI8_V_M2_MF2 }, // 5120
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x7, 0x2, PseudoVSUXSEG2EI8_V_M4_MF2 }, // 5121
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x7, 0x3, PseudoVSUXSEG2EI8_V_M8_MF2 }, // 5122
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x7, 0x5, PseudoVSUXSEG2EI8_V_MF8_MF2 }, // 5123
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x7, 0x6, PseudoVSUXSEG2EI8_V_MF4_MF2 }, // 5124
  { Intrinsic::riscv_vsuxseg2, 0x8, 0x7, 0x7, PseudoVSUXSEG2EI8_V_MF2_MF2 }, // 5125
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x0, 0x0, PseudoVSUXSEG2EI16_V_M1_M1 }, // 5126
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x0, 0x1, PseudoVSUXSEG2EI16_V_M2_M1 }, // 5127
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x0, 0x2, PseudoVSUXSEG2EI16_V_M4_M1 }, // 5128
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x0, 0x3, PseudoVSUXSEG2EI16_V_M8_M1 }, // 5129
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x0, 0x6, PseudoVSUXSEG2EI16_V_MF4_M1 }, // 5130
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x0, 0x7, PseudoVSUXSEG2EI16_V_MF2_M1 }, // 5131
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x1, 0x0, PseudoVSUXSEG2EI16_V_M1_M2 }, // 5132
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x1, 0x1, PseudoVSUXSEG2EI16_V_M2_M2 }, // 5133
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x1, 0x2, PseudoVSUXSEG2EI16_V_M4_M2 }, // 5134
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x1, 0x3, PseudoVSUXSEG2EI16_V_M8_M2 }, // 5135
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x1, 0x6, PseudoVSUXSEG2EI16_V_MF4_M2 }, // 5136
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x1, 0x7, PseudoVSUXSEG2EI16_V_MF2_M2 }, // 5137
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x2, 0x0, PseudoVSUXSEG2EI16_V_M1_M4 }, // 5138
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x2, 0x1, PseudoVSUXSEG2EI16_V_M2_M4 }, // 5139
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x2, 0x2, PseudoVSUXSEG2EI16_V_M4_M4 }, // 5140
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x2, 0x3, PseudoVSUXSEG2EI16_V_M8_M4 }, // 5141
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x2, 0x6, PseudoVSUXSEG2EI16_V_MF4_M4 }, // 5142
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x2, 0x7, PseudoVSUXSEG2EI16_V_MF2_M4 }, // 5143
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x5, 0x0, PseudoVSUXSEG2EI16_V_M1_MF8 }, // 5144
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x5, 0x1, PseudoVSUXSEG2EI16_V_M2_MF8 }, // 5145
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x5, 0x2, PseudoVSUXSEG2EI16_V_M4_MF8 }, // 5146
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x5, 0x3, PseudoVSUXSEG2EI16_V_M8_MF8 }, // 5147
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x5, 0x6, PseudoVSUXSEG2EI16_V_MF4_MF8 }, // 5148
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x5, 0x7, PseudoVSUXSEG2EI16_V_MF2_MF8 }, // 5149
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x6, 0x0, PseudoVSUXSEG2EI16_V_M1_MF4 }, // 5150
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x6, 0x1, PseudoVSUXSEG2EI16_V_M2_MF4 }, // 5151
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x6, 0x2, PseudoVSUXSEG2EI16_V_M4_MF4 }, // 5152
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x6, 0x3, PseudoVSUXSEG2EI16_V_M8_MF4 }, // 5153
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x6, 0x6, PseudoVSUXSEG2EI16_V_MF4_MF4 }, // 5154
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x6, 0x7, PseudoVSUXSEG2EI16_V_MF2_MF4 }, // 5155
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x7, 0x0, PseudoVSUXSEG2EI16_V_M1_MF2 }, // 5156
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x7, 0x1, PseudoVSUXSEG2EI16_V_M2_MF2 }, // 5157
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x7, 0x2, PseudoVSUXSEG2EI16_V_M4_MF2 }, // 5158
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x7, 0x3, PseudoVSUXSEG2EI16_V_M8_MF2 }, // 5159
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x7, 0x6, PseudoVSUXSEG2EI16_V_MF4_MF2 }, // 5160
  { Intrinsic::riscv_vsuxseg2, 0x10, 0x7, 0x7, PseudoVSUXSEG2EI16_V_MF2_MF2 }, // 5161
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x0, 0x0, PseudoVSUXSEG2EI32_V_M1_M1 }, // 5162
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x0, 0x1, PseudoVSUXSEG2EI32_V_M2_M1 }, // 5163
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x0, 0x2, PseudoVSUXSEG2EI32_V_M4_M1 }, // 5164
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x0, 0x3, PseudoVSUXSEG2EI32_V_M8_M1 }, // 5165
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x0, 0x7, PseudoVSUXSEG2EI32_V_MF2_M1 }, // 5166
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x1, 0x0, PseudoVSUXSEG2EI32_V_M1_M2 }, // 5167
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x1, 0x1, PseudoVSUXSEG2EI32_V_M2_M2 }, // 5168
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x1, 0x2, PseudoVSUXSEG2EI32_V_M4_M2 }, // 5169
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x1, 0x3, PseudoVSUXSEG2EI32_V_M8_M2 }, // 5170
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x1, 0x7, PseudoVSUXSEG2EI32_V_MF2_M2 }, // 5171
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x2, 0x0, PseudoVSUXSEG2EI32_V_M1_M4 }, // 5172
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x2, 0x1, PseudoVSUXSEG2EI32_V_M2_M4 }, // 5173
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x2, 0x2, PseudoVSUXSEG2EI32_V_M4_M4 }, // 5174
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x2, 0x3, PseudoVSUXSEG2EI32_V_M8_M4 }, // 5175
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x2, 0x7, PseudoVSUXSEG2EI32_V_MF2_M4 }, // 5176
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x5, 0x0, PseudoVSUXSEG2EI32_V_M1_MF8 }, // 5177
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x5, 0x1, PseudoVSUXSEG2EI32_V_M2_MF8 }, // 5178
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x5, 0x2, PseudoVSUXSEG2EI32_V_M4_MF8 }, // 5179
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x5, 0x3, PseudoVSUXSEG2EI32_V_M8_MF8 }, // 5180
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x5, 0x7, PseudoVSUXSEG2EI32_V_MF2_MF8 }, // 5181
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x6, 0x0, PseudoVSUXSEG2EI32_V_M1_MF4 }, // 5182
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x6, 0x1, PseudoVSUXSEG2EI32_V_M2_MF4 }, // 5183
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x6, 0x2, PseudoVSUXSEG2EI32_V_M4_MF4 }, // 5184
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x6, 0x3, PseudoVSUXSEG2EI32_V_M8_MF4 }, // 5185
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x6, 0x7, PseudoVSUXSEG2EI32_V_MF2_MF4 }, // 5186
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x7, 0x0, PseudoVSUXSEG2EI32_V_M1_MF2 }, // 5187
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x7, 0x1, PseudoVSUXSEG2EI32_V_M2_MF2 }, // 5188
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x7, 0x2, PseudoVSUXSEG2EI32_V_M4_MF2 }, // 5189
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x7, 0x3, PseudoVSUXSEG2EI32_V_M8_MF2 }, // 5190
  { Intrinsic::riscv_vsuxseg2, 0x20, 0x7, 0x7, PseudoVSUXSEG2EI32_V_MF2_MF2 }, // 5191
  { Intrinsic::riscv_vsuxseg2, 0x40, 0x0, 0x0, PseudoVSUXSEG2EI64_V_M1_M1 }, // 5192
  { Intrinsic::riscv_vsuxseg2, 0x40, 0x0, 0x1, PseudoVSUXSEG2EI64_V_M2_M1 }, // 5193
  { Intrinsic::riscv_vsuxseg2, 0x40, 0x0, 0x2, PseudoVSUXSEG2EI64_V_M4_M1 }, // 5194
  { Intrinsic::riscv_vsuxseg2, 0x40, 0x0, 0x3, PseudoVSUXSEG2EI64_V_M8_M1 }, // 5195
  { Intrinsic::riscv_vsuxseg2, 0x40, 0x1, 0x0, PseudoVSUXSEG2EI64_V_M1_M2 }, // 5196
  { Intrinsic::riscv_vsuxseg2, 0x40, 0x1, 0x1, PseudoVSUXSEG2EI64_V_M2_M2 }, // 5197
  { Intrinsic::riscv_vsuxseg2, 0x40, 0x1, 0x2, PseudoVSUXSEG2EI64_V_M4_M2 }, // 5198
  { Intrinsic::riscv_vsuxseg2, 0x40, 0x1, 0x3, PseudoVSUXSEG2EI64_V_M8_M2 }, // 5199
  { Intrinsic::riscv_vsuxseg2, 0x40, 0x2, 0x0, PseudoVSUXSEG2EI64_V_M1_M4 }, // 5200
  { Intrinsic::riscv_vsuxseg2, 0x40, 0x2, 0x1, PseudoVSUXSEG2EI64_V_M2_M4 }, // 5201
  { Intrinsic::riscv_vsuxseg2, 0x40, 0x2, 0x2, PseudoVSUXSEG2EI64_V_M4_M4 }, // 5202
  { Intrinsic::riscv_vsuxseg2, 0x40, 0x2, 0x3, PseudoVSUXSEG2EI64_V_M8_M4 }, // 5203
  { Intrinsic::riscv_vsuxseg2, 0x40, 0x5, 0x0, PseudoVSUXSEG2EI64_V_M1_MF8 }, // 5204
  { Intrinsic::riscv_vsuxseg2, 0x40, 0x5, 0x1, PseudoVSUXSEG2EI64_V_M2_MF8 }, // 5205
  { Intrinsic::riscv_vsuxseg2, 0x40, 0x5, 0x2, PseudoVSUXSEG2EI64_V_M4_MF8 }, // 5206
  { Intrinsic::riscv_vsuxseg2, 0x40, 0x5, 0x3, PseudoVSUXSEG2EI64_V_M8_MF8 }, // 5207
  { Intrinsic::riscv_vsuxseg2, 0x40, 0x6, 0x0, PseudoVSUXSEG2EI64_V_M1_MF4 }, // 5208
  { Intrinsic::riscv_vsuxseg2, 0x40, 0x6, 0x1, PseudoVSUXSEG2EI64_V_M2_MF4 }, // 5209
  { Intrinsic::riscv_vsuxseg2, 0x40, 0x6, 0x2, PseudoVSUXSEG2EI64_V_M4_MF4 }, // 5210
  { Intrinsic::riscv_vsuxseg2, 0x40, 0x6, 0x3, PseudoVSUXSEG2EI64_V_M8_MF4 }, // 5211
  { Intrinsic::riscv_vsuxseg2, 0x40, 0x7, 0x0, PseudoVSUXSEG2EI64_V_M1_MF2 }, // 5212
  { Intrinsic::riscv_vsuxseg2, 0x40, 0x7, 0x1, PseudoVSUXSEG2EI64_V_M2_MF2 }, // 5213
  { Intrinsic::riscv_vsuxseg2, 0x40, 0x7, 0x2, PseudoVSUXSEG2EI64_V_M4_MF2 }, // 5214
  { Intrinsic::riscv_vsuxseg2, 0x40, 0x7, 0x3, PseudoVSUXSEG2EI64_V_M8_MF2 }, // 5215
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x0, 0x0, PseudoVSUXSEG2EI8_V_M1_M1_MASK }, // 5216
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x0, 0x1, PseudoVSUXSEG2EI8_V_M2_M1_MASK }, // 5217
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x0, 0x2, PseudoVSUXSEG2EI8_V_M4_M1_MASK }, // 5218
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x0, 0x3, PseudoVSUXSEG2EI8_V_M8_M1_MASK }, // 5219
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x0, 0x5, PseudoVSUXSEG2EI8_V_MF8_M1_MASK }, // 5220
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x0, 0x6, PseudoVSUXSEG2EI8_V_MF4_M1_MASK }, // 5221
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x0, 0x7, PseudoVSUXSEG2EI8_V_MF2_M1_MASK }, // 5222
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x1, 0x0, PseudoVSUXSEG2EI8_V_M1_M2_MASK }, // 5223
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x1, 0x1, PseudoVSUXSEG2EI8_V_M2_M2_MASK }, // 5224
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x1, 0x2, PseudoVSUXSEG2EI8_V_M4_M2_MASK }, // 5225
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x1, 0x3, PseudoVSUXSEG2EI8_V_M8_M2_MASK }, // 5226
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x1, 0x5, PseudoVSUXSEG2EI8_V_MF8_M2_MASK }, // 5227
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x1, 0x6, PseudoVSUXSEG2EI8_V_MF4_M2_MASK }, // 5228
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x1, 0x7, PseudoVSUXSEG2EI8_V_MF2_M2_MASK }, // 5229
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x2, 0x0, PseudoVSUXSEG2EI8_V_M1_M4_MASK }, // 5230
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x2, 0x1, PseudoVSUXSEG2EI8_V_M2_M4_MASK }, // 5231
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x2, 0x2, PseudoVSUXSEG2EI8_V_M4_M4_MASK }, // 5232
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x2, 0x3, PseudoVSUXSEG2EI8_V_M8_M4_MASK }, // 5233
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x2, 0x5, PseudoVSUXSEG2EI8_V_MF8_M4_MASK }, // 5234
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x2, 0x6, PseudoVSUXSEG2EI8_V_MF4_M4_MASK }, // 5235
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x2, 0x7, PseudoVSUXSEG2EI8_V_MF2_M4_MASK }, // 5236
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x5, 0x0, PseudoVSUXSEG2EI8_V_M1_MF8_MASK }, // 5237
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x5, 0x1, PseudoVSUXSEG2EI8_V_M2_MF8_MASK }, // 5238
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x5, 0x2, PseudoVSUXSEG2EI8_V_M4_MF8_MASK }, // 5239
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x5, 0x3, PseudoVSUXSEG2EI8_V_M8_MF8_MASK }, // 5240
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x5, 0x5, PseudoVSUXSEG2EI8_V_MF8_MF8_MASK }, // 5241
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x5, 0x6, PseudoVSUXSEG2EI8_V_MF4_MF8_MASK }, // 5242
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x5, 0x7, PseudoVSUXSEG2EI8_V_MF2_MF8_MASK }, // 5243
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x6, 0x0, PseudoVSUXSEG2EI8_V_M1_MF4_MASK }, // 5244
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x6, 0x1, PseudoVSUXSEG2EI8_V_M2_MF4_MASK }, // 5245
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x6, 0x2, PseudoVSUXSEG2EI8_V_M4_MF4_MASK }, // 5246
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x6, 0x3, PseudoVSUXSEG2EI8_V_M8_MF4_MASK }, // 5247
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x6, 0x5, PseudoVSUXSEG2EI8_V_MF8_MF4_MASK }, // 5248
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x6, 0x6, PseudoVSUXSEG2EI8_V_MF4_MF4_MASK }, // 5249
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x6, 0x7, PseudoVSUXSEG2EI8_V_MF2_MF4_MASK }, // 5250
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x7, 0x0, PseudoVSUXSEG2EI8_V_M1_MF2_MASK }, // 5251
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x7, 0x1, PseudoVSUXSEG2EI8_V_M2_MF2_MASK }, // 5252
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x7, 0x2, PseudoVSUXSEG2EI8_V_M4_MF2_MASK }, // 5253
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x7, 0x3, PseudoVSUXSEG2EI8_V_M8_MF2_MASK }, // 5254
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x7, 0x5, PseudoVSUXSEG2EI8_V_MF8_MF2_MASK }, // 5255
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x7, 0x6, PseudoVSUXSEG2EI8_V_MF4_MF2_MASK }, // 5256
  { Intrinsic::riscv_vsuxseg2_mask, 0x8, 0x7, 0x7, PseudoVSUXSEG2EI8_V_MF2_MF2_MASK }, // 5257
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x0, 0x0, PseudoVSUXSEG2EI16_V_M1_M1_MASK }, // 5258
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x0, 0x1, PseudoVSUXSEG2EI16_V_M2_M1_MASK }, // 5259
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x0, 0x2, PseudoVSUXSEG2EI16_V_M4_M1_MASK }, // 5260
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x0, 0x3, PseudoVSUXSEG2EI16_V_M8_M1_MASK }, // 5261
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x0, 0x6, PseudoVSUXSEG2EI16_V_MF4_M1_MASK }, // 5262
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x0, 0x7, PseudoVSUXSEG2EI16_V_MF2_M1_MASK }, // 5263
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x1, 0x0, PseudoVSUXSEG2EI16_V_M1_M2_MASK }, // 5264
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x1, 0x1, PseudoVSUXSEG2EI16_V_M2_M2_MASK }, // 5265
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x1, 0x2, PseudoVSUXSEG2EI16_V_M4_M2_MASK }, // 5266
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x1, 0x3, PseudoVSUXSEG2EI16_V_M8_M2_MASK }, // 5267
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x1, 0x6, PseudoVSUXSEG2EI16_V_MF4_M2_MASK }, // 5268
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x1, 0x7, PseudoVSUXSEG2EI16_V_MF2_M2_MASK }, // 5269
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x2, 0x0, PseudoVSUXSEG2EI16_V_M1_M4_MASK }, // 5270
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x2, 0x1, PseudoVSUXSEG2EI16_V_M2_M4_MASK }, // 5271
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x2, 0x2, PseudoVSUXSEG2EI16_V_M4_M4_MASK }, // 5272
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x2, 0x3, PseudoVSUXSEG2EI16_V_M8_M4_MASK }, // 5273
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x2, 0x6, PseudoVSUXSEG2EI16_V_MF4_M4_MASK }, // 5274
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x2, 0x7, PseudoVSUXSEG2EI16_V_MF2_M4_MASK }, // 5275
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x5, 0x0, PseudoVSUXSEG2EI16_V_M1_MF8_MASK }, // 5276
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x5, 0x1, PseudoVSUXSEG2EI16_V_M2_MF8_MASK }, // 5277
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x5, 0x2, PseudoVSUXSEG2EI16_V_M4_MF8_MASK }, // 5278
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x5, 0x3, PseudoVSUXSEG2EI16_V_M8_MF8_MASK }, // 5279
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x5, 0x6, PseudoVSUXSEG2EI16_V_MF4_MF8_MASK }, // 5280
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x5, 0x7, PseudoVSUXSEG2EI16_V_MF2_MF8_MASK }, // 5281
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x6, 0x0, PseudoVSUXSEG2EI16_V_M1_MF4_MASK }, // 5282
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x6, 0x1, PseudoVSUXSEG2EI16_V_M2_MF4_MASK }, // 5283
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x6, 0x2, PseudoVSUXSEG2EI16_V_M4_MF4_MASK }, // 5284
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x6, 0x3, PseudoVSUXSEG2EI16_V_M8_MF4_MASK }, // 5285
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x6, 0x6, PseudoVSUXSEG2EI16_V_MF4_MF4_MASK }, // 5286
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x6, 0x7, PseudoVSUXSEG2EI16_V_MF2_MF4_MASK }, // 5287
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x7, 0x0, PseudoVSUXSEG2EI16_V_M1_MF2_MASK }, // 5288
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x7, 0x1, PseudoVSUXSEG2EI16_V_M2_MF2_MASK }, // 5289
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x7, 0x2, PseudoVSUXSEG2EI16_V_M4_MF2_MASK }, // 5290
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x7, 0x3, PseudoVSUXSEG2EI16_V_M8_MF2_MASK }, // 5291
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x7, 0x6, PseudoVSUXSEG2EI16_V_MF4_MF2_MASK }, // 5292
  { Intrinsic::riscv_vsuxseg2_mask, 0x10, 0x7, 0x7, PseudoVSUXSEG2EI16_V_MF2_MF2_MASK }, // 5293
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x0, 0x0, PseudoVSUXSEG2EI32_V_M1_M1_MASK }, // 5294
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x0, 0x1, PseudoVSUXSEG2EI32_V_M2_M1_MASK }, // 5295
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x0, 0x2, PseudoVSUXSEG2EI32_V_M4_M1_MASK }, // 5296
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x0, 0x3, PseudoVSUXSEG2EI32_V_M8_M1_MASK }, // 5297
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x0, 0x7, PseudoVSUXSEG2EI32_V_MF2_M1_MASK }, // 5298
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x1, 0x0, PseudoVSUXSEG2EI32_V_M1_M2_MASK }, // 5299
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x1, 0x1, PseudoVSUXSEG2EI32_V_M2_M2_MASK }, // 5300
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x1, 0x2, PseudoVSUXSEG2EI32_V_M4_M2_MASK }, // 5301
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x1, 0x3, PseudoVSUXSEG2EI32_V_M8_M2_MASK }, // 5302
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x1, 0x7, PseudoVSUXSEG2EI32_V_MF2_M2_MASK }, // 5303
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x2, 0x0, PseudoVSUXSEG2EI32_V_M1_M4_MASK }, // 5304
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x2, 0x1, PseudoVSUXSEG2EI32_V_M2_M4_MASK }, // 5305
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x2, 0x2, PseudoVSUXSEG2EI32_V_M4_M4_MASK }, // 5306
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x2, 0x3, PseudoVSUXSEG2EI32_V_M8_M4_MASK }, // 5307
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x2, 0x7, PseudoVSUXSEG2EI32_V_MF2_M4_MASK }, // 5308
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x5, 0x0, PseudoVSUXSEG2EI32_V_M1_MF8_MASK }, // 5309
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x5, 0x1, PseudoVSUXSEG2EI32_V_M2_MF8_MASK }, // 5310
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x5, 0x2, PseudoVSUXSEG2EI32_V_M4_MF8_MASK }, // 5311
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x5, 0x3, PseudoVSUXSEG2EI32_V_M8_MF8_MASK }, // 5312
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x5, 0x7, PseudoVSUXSEG2EI32_V_MF2_MF8_MASK }, // 5313
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x6, 0x0, PseudoVSUXSEG2EI32_V_M1_MF4_MASK }, // 5314
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x6, 0x1, PseudoVSUXSEG2EI32_V_M2_MF4_MASK }, // 5315
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x6, 0x2, PseudoVSUXSEG2EI32_V_M4_MF4_MASK }, // 5316
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x6, 0x3, PseudoVSUXSEG2EI32_V_M8_MF4_MASK }, // 5317
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x6, 0x7, PseudoVSUXSEG2EI32_V_MF2_MF4_MASK }, // 5318
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x7, 0x0, PseudoVSUXSEG2EI32_V_M1_MF2_MASK }, // 5319
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x7, 0x1, PseudoVSUXSEG2EI32_V_M2_MF2_MASK }, // 5320
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x7, 0x2, PseudoVSUXSEG2EI32_V_M4_MF2_MASK }, // 5321
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x7, 0x3, PseudoVSUXSEG2EI32_V_M8_MF2_MASK }, // 5322
  { Intrinsic::riscv_vsuxseg2_mask, 0x20, 0x7, 0x7, PseudoVSUXSEG2EI32_V_MF2_MF2_MASK }, // 5323
  { Intrinsic::riscv_vsuxseg2_mask, 0x40, 0x0, 0x0, PseudoVSUXSEG2EI64_V_M1_M1_MASK }, // 5324
  { Intrinsic::riscv_vsuxseg2_mask, 0x40, 0x0, 0x1, PseudoVSUXSEG2EI64_V_M2_M1_MASK }, // 5325
  { Intrinsic::riscv_vsuxseg2_mask, 0x40, 0x0, 0x2, PseudoVSUXSEG2EI64_V_M4_M1_MASK }, // 5326
  { Intrinsic::riscv_vsuxseg2_mask, 0x40, 0x0, 0x3, PseudoVSUXSEG2EI64_V_M8_M1_MASK }, // 5327
  { Intrinsic::riscv_vsuxseg2_mask, 0x40, 0x1, 0x0, PseudoVSUXSEG2EI64_V_M1_M2_MASK }, // 5328
  { Intrinsic::riscv_vsuxseg2_mask, 0x40, 0x1, 0x1, PseudoVSUXSEG2EI64_V_M2_M2_MASK }, // 5329
  { Intrinsic::riscv_vsuxseg2_mask, 0x40, 0x1, 0x2, PseudoVSUXSEG2EI64_V_M4_M2_MASK }, // 5330
  { Intrinsic::riscv_vsuxseg2_mask, 0x40, 0x1, 0x3, PseudoVSUXSEG2EI64_V_M8_M2_MASK }, // 5331
  { Intrinsic::riscv_vsuxseg2_mask, 0x40, 0x2, 0x0, PseudoVSUXSEG2EI64_V_M1_M4_MASK }, // 5332
  { Intrinsic::riscv_vsuxseg2_mask, 0x40, 0x2, 0x1, PseudoVSUXSEG2EI64_V_M2_M4_MASK }, // 5333
  { Intrinsic::riscv_vsuxseg2_mask, 0x40, 0x2, 0x2, PseudoVSUXSEG2EI64_V_M4_M4_MASK }, // 5334
  { Intrinsic::riscv_vsuxseg2_mask, 0x40, 0x2, 0x3, PseudoVSUXSEG2EI64_V_M8_M4_MASK }, // 5335
  { Intrinsic::riscv_vsuxseg2_mask, 0x40, 0x5, 0x0, PseudoVSUXSEG2EI64_V_M1_MF8_MASK }, // 5336
  { Intrinsic::riscv_vsuxseg2_mask, 0x40, 0x5, 0x1, PseudoVSUXSEG2EI64_V_M2_MF8_MASK }, // 5337
  { Intrinsic::riscv_vsuxseg2_mask, 0x40, 0x5, 0x2, PseudoVSUXSEG2EI64_V_M4_MF8_MASK }, // 5338
  { Intrinsic::riscv_vsuxseg2_mask, 0x40, 0x5, 0x3, PseudoVSUXSEG2EI64_V_M8_MF8_MASK }, // 5339
  { Intrinsic::riscv_vsuxseg2_mask, 0x40, 0x6, 0x0, PseudoVSUXSEG2EI64_V_M1_MF4_MASK }, // 5340
  { Intrinsic::riscv_vsuxseg2_mask, 0x40, 0x6, 0x1, PseudoVSUXSEG2EI64_V_M2_MF4_MASK }, // 5341
  { Intrinsic::riscv_vsuxseg2_mask, 0x40, 0x6, 0x2, PseudoVSUXSEG2EI64_V_M4_MF4_MASK }, // 5342
  { Intrinsic::riscv_vsuxseg2_mask, 0x40, 0x6, 0x3, PseudoVSUXSEG2EI64_V_M8_MF4_MASK }, // 5343
  { Intrinsic::riscv_vsuxseg2_mask, 0x40, 0x7, 0x0, PseudoVSUXSEG2EI64_V_M1_MF2_MASK }, // 5344
  { Intrinsic::riscv_vsuxseg2_mask, 0x40, 0x7, 0x1, PseudoVSUXSEG2EI64_V_M2_MF2_MASK }, // 5345
  { Intrinsic::riscv_vsuxseg2_mask, 0x40, 0x7, 0x2, PseudoVSUXSEG2EI64_V_M4_MF2_MASK }, // 5346
  { Intrinsic::riscv_vsuxseg2_mask, 0x40, 0x7, 0x3, PseudoVSUXSEG2EI64_V_M8_MF2_MASK }, // 5347
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x0, 0x0, PseudoVSUXSEG3EI8_V_M1_M1 }, // 5348
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x0, 0x1, PseudoVSUXSEG3EI8_V_M2_M1 }, // 5349
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x0, 0x2, PseudoVSUXSEG3EI8_V_M4_M1 }, // 5350
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x0, 0x3, PseudoVSUXSEG3EI8_V_M8_M1 }, // 5351
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x0, 0x5, PseudoVSUXSEG3EI8_V_MF8_M1 }, // 5352
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x0, 0x6, PseudoVSUXSEG3EI8_V_MF4_M1 }, // 5353
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x0, 0x7, PseudoVSUXSEG3EI8_V_MF2_M1 }, // 5354
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x1, 0x0, PseudoVSUXSEG3EI8_V_M1_M2 }, // 5355
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x1, 0x1, PseudoVSUXSEG3EI8_V_M2_M2 }, // 5356
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x1, 0x2, PseudoVSUXSEG3EI8_V_M4_M2 }, // 5357
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x1, 0x3, PseudoVSUXSEG3EI8_V_M8_M2 }, // 5358
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x1, 0x5, PseudoVSUXSEG3EI8_V_MF8_M2 }, // 5359
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x1, 0x6, PseudoVSUXSEG3EI8_V_MF4_M2 }, // 5360
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x1, 0x7, PseudoVSUXSEG3EI8_V_MF2_M2 }, // 5361
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x5, 0x0, PseudoVSUXSEG3EI8_V_M1_MF8 }, // 5362
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x5, 0x1, PseudoVSUXSEG3EI8_V_M2_MF8 }, // 5363
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x5, 0x2, PseudoVSUXSEG3EI8_V_M4_MF8 }, // 5364
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x5, 0x3, PseudoVSUXSEG3EI8_V_M8_MF8 }, // 5365
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x5, 0x5, PseudoVSUXSEG3EI8_V_MF8_MF8 }, // 5366
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x5, 0x6, PseudoVSUXSEG3EI8_V_MF4_MF8 }, // 5367
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x5, 0x7, PseudoVSUXSEG3EI8_V_MF2_MF8 }, // 5368
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x6, 0x0, PseudoVSUXSEG3EI8_V_M1_MF4 }, // 5369
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x6, 0x1, PseudoVSUXSEG3EI8_V_M2_MF4 }, // 5370
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x6, 0x2, PseudoVSUXSEG3EI8_V_M4_MF4 }, // 5371
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x6, 0x3, PseudoVSUXSEG3EI8_V_M8_MF4 }, // 5372
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x6, 0x5, PseudoVSUXSEG3EI8_V_MF8_MF4 }, // 5373
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x6, 0x6, PseudoVSUXSEG3EI8_V_MF4_MF4 }, // 5374
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x6, 0x7, PseudoVSUXSEG3EI8_V_MF2_MF4 }, // 5375
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x7, 0x0, PseudoVSUXSEG3EI8_V_M1_MF2 }, // 5376
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x7, 0x1, PseudoVSUXSEG3EI8_V_M2_MF2 }, // 5377
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x7, 0x2, PseudoVSUXSEG3EI8_V_M4_MF2 }, // 5378
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x7, 0x3, PseudoVSUXSEG3EI8_V_M8_MF2 }, // 5379
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x7, 0x5, PseudoVSUXSEG3EI8_V_MF8_MF2 }, // 5380
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x7, 0x6, PseudoVSUXSEG3EI8_V_MF4_MF2 }, // 5381
  { Intrinsic::riscv_vsuxseg3, 0x8, 0x7, 0x7, PseudoVSUXSEG3EI8_V_MF2_MF2 }, // 5382
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x0, 0x0, PseudoVSUXSEG3EI16_V_M1_M1 }, // 5383
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x0, 0x1, PseudoVSUXSEG3EI16_V_M2_M1 }, // 5384
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x0, 0x2, PseudoVSUXSEG3EI16_V_M4_M1 }, // 5385
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x0, 0x3, PseudoVSUXSEG3EI16_V_M8_M1 }, // 5386
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x0, 0x6, PseudoVSUXSEG3EI16_V_MF4_M1 }, // 5387
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x0, 0x7, PseudoVSUXSEG3EI16_V_MF2_M1 }, // 5388
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x1, 0x0, PseudoVSUXSEG3EI16_V_M1_M2 }, // 5389
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x1, 0x1, PseudoVSUXSEG3EI16_V_M2_M2 }, // 5390
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x1, 0x2, PseudoVSUXSEG3EI16_V_M4_M2 }, // 5391
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x1, 0x3, PseudoVSUXSEG3EI16_V_M8_M2 }, // 5392
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x1, 0x6, PseudoVSUXSEG3EI16_V_MF4_M2 }, // 5393
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x1, 0x7, PseudoVSUXSEG3EI16_V_MF2_M2 }, // 5394
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x5, 0x0, PseudoVSUXSEG3EI16_V_M1_MF8 }, // 5395
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x5, 0x1, PseudoVSUXSEG3EI16_V_M2_MF8 }, // 5396
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x5, 0x2, PseudoVSUXSEG3EI16_V_M4_MF8 }, // 5397
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x5, 0x3, PseudoVSUXSEG3EI16_V_M8_MF8 }, // 5398
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x5, 0x6, PseudoVSUXSEG3EI16_V_MF4_MF8 }, // 5399
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x5, 0x7, PseudoVSUXSEG3EI16_V_MF2_MF8 }, // 5400
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x6, 0x0, PseudoVSUXSEG3EI16_V_M1_MF4 }, // 5401
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x6, 0x1, PseudoVSUXSEG3EI16_V_M2_MF4 }, // 5402
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x6, 0x2, PseudoVSUXSEG3EI16_V_M4_MF4 }, // 5403
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x6, 0x3, PseudoVSUXSEG3EI16_V_M8_MF4 }, // 5404
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x6, 0x6, PseudoVSUXSEG3EI16_V_MF4_MF4 }, // 5405
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x6, 0x7, PseudoVSUXSEG3EI16_V_MF2_MF4 }, // 5406
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x7, 0x0, PseudoVSUXSEG3EI16_V_M1_MF2 }, // 5407
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x7, 0x1, PseudoVSUXSEG3EI16_V_M2_MF2 }, // 5408
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x7, 0x2, PseudoVSUXSEG3EI16_V_M4_MF2 }, // 5409
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x7, 0x3, PseudoVSUXSEG3EI16_V_M8_MF2 }, // 5410
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x7, 0x6, PseudoVSUXSEG3EI16_V_MF4_MF2 }, // 5411
  { Intrinsic::riscv_vsuxseg3, 0x10, 0x7, 0x7, PseudoVSUXSEG3EI16_V_MF2_MF2 }, // 5412
  { Intrinsic::riscv_vsuxseg3, 0x20, 0x0, 0x0, PseudoVSUXSEG3EI32_V_M1_M1 }, // 5413
  { Intrinsic::riscv_vsuxseg3, 0x20, 0x0, 0x1, PseudoVSUXSEG3EI32_V_M2_M1 }, // 5414
  { Intrinsic::riscv_vsuxseg3, 0x20, 0x0, 0x2, PseudoVSUXSEG3EI32_V_M4_M1 }, // 5415
  { Intrinsic::riscv_vsuxseg3, 0x20, 0x0, 0x3, PseudoVSUXSEG3EI32_V_M8_M1 }, // 5416
  { Intrinsic::riscv_vsuxseg3, 0x20, 0x0, 0x7, PseudoVSUXSEG3EI32_V_MF2_M1 }, // 5417
  { Intrinsic::riscv_vsuxseg3, 0x20, 0x1, 0x0, PseudoVSUXSEG3EI32_V_M1_M2 }, // 5418
  { Intrinsic::riscv_vsuxseg3, 0x20, 0x1, 0x1, PseudoVSUXSEG3EI32_V_M2_M2 }, // 5419
  { Intrinsic::riscv_vsuxseg3, 0x20, 0x1, 0x2, PseudoVSUXSEG3EI32_V_M4_M2 }, // 5420
  { Intrinsic::riscv_vsuxseg3, 0x20, 0x1, 0x3, PseudoVSUXSEG3EI32_V_M8_M2 }, // 5421
  { Intrinsic::riscv_vsuxseg3, 0x20, 0x1, 0x7, PseudoVSUXSEG3EI32_V_MF2_M2 }, // 5422
  { Intrinsic::riscv_vsuxseg3, 0x20, 0x5, 0x0, PseudoVSUXSEG3EI32_V_M1_MF8 }, // 5423
  { Intrinsic::riscv_vsuxseg3, 0x20, 0x5, 0x1, PseudoVSUXSEG3EI32_V_M2_MF8 }, // 5424
  { Intrinsic::riscv_vsuxseg3, 0x20, 0x5, 0x2, PseudoVSUXSEG3EI32_V_M4_MF8 }, // 5425
  { Intrinsic::riscv_vsuxseg3, 0x20, 0x5, 0x3, PseudoVSUXSEG3EI32_V_M8_MF8 }, // 5426
  { Intrinsic::riscv_vsuxseg3, 0x20, 0x5, 0x7, PseudoVSUXSEG3EI32_V_MF2_MF8 }, // 5427
  { Intrinsic::riscv_vsuxseg3, 0x20, 0x6, 0x0, PseudoVSUXSEG3EI32_V_M1_MF4 }, // 5428
  { Intrinsic::riscv_vsuxseg3, 0x20, 0x6, 0x1, PseudoVSUXSEG3EI32_V_M2_MF4 }, // 5429
  { Intrinsic::riscv_vsuxseg3, 0x20, 0x6, 0x2, PseudoVSUXSEG3EI32_V_M4_MF4 }, // 5430
  { Intrinsic::riscv_vsuxseg3, 0x20, 0x6, 0x3, PseudoVSUXSEG3EI32_V_M8_MF4 }, // 5431
  { Intrinsic::riscv_vsuxseg3, 0x20, 0x6, 0x7, PseudoVSUXSEG3EI32_V_MF2_MF4 }, // 5432
  { Intrinsic::riscv_vsuxseg3, 0x20, 0x7, 0x0, PseudoVSUXSEG3EI32_V_M1_MF2 }, // 5433
  { Intrinsic::riscv_vsuxseg3, 0x20, 0x7, 0x1, PseudoVSUXSEG3EI32_V_M2_MF2 }, // 5434
  { Intrinsic::riscv_vsuxseg3, 0x20, 0x7, 0x2, PseudoVSUXSEG3EI32_V_M4_MF2 }, // 5435
  { Intrinsic::riscv_vsuxseg3, 0x20, 0x7, 0x3, PseudoVSUXSEG3EI32_V_M8_MF2 }, // 5436
  { Intrinsic::riscv_vsuxseg3, 0x20, 0x7, 0x7, PseudoVSUXSEG3EI32_V_MF2_MF2 }, // 5437
  { Intrinsic::riscv_vsuxseg3, 0x40, 0x0, 0x0, PseudoVSUXSEG3EI64_V_M1_M1 }, // 5438
  { Intrinsic::riscv_vsuxseg3, 0x40, 0x0, 0x1, PseudoVSUXSEG3EI64_V_M2_M1 }, // 5439
  { Intrinsic::riscv_vsuxseg3, 0x40, 0x0, 0x2, PseudoVSUXSEG3EI64_V_M4_M1 }, // 5440
  { Intrinsic::riscv_vsuxseg3, 0x40, 0x0, 0x3, PseudoVSUXSEG3EI64_V_M8_M1 }, // 5441
  { Intrinsic::riscv_vsuxseg3, 0x40, 0x1, 0x0, PseudoVSUXSEG3EI64_V_M1_M2 }, // 5442
  { Intrinsic::riscv_vsuxseg3, 0x40, 0x1, 0x1, PseudoVSUXSEG3EI64_V_M2_M2 }, // 5443
  { Intrinsic::riscv_vsuxseg3, 0x40, 0x1, 0x2, PseudoVSUXSEG3EI64_V_M4_M2 }, // 5444
  { Intrinsic::riscv_vsuxseg3, 0x40, 0x1, 0x3, PseudoVSUXSEG3EI64_V_M8_M2 }, // 5445
  { Intrinsic::riscv_vsuxseg3, 0x40, 0x5, 0x0, PseudoVSUXSEG3EI64_V_M1_MF8 }, // 5446
  { Intrinsic::riscv_vsuxseg3, 0x40, 0x5, 0x1, PseudoVSUXSEG3EI64_V_M2_MF8 }, // 5447
  { Intrinsic::riscv_vsuxseg3, 0x40, 0x5, 0x2, PseudoVSUXSEG3EI64_V_M4_MF8 }, // 5448
  { Intrinsic::riscv_vsuxseg3, 0x40, 0x5, 0x3, PseudoVSUXSEG3EI64_V_M8_MF8 }, // 5449
  { Intrinsic::riscv_vsuxseg3, 0x40, 0x6, 0x0, PseudoVSUXSEG3EI64_V_M1_MF4 }, // 5450
  { Intrinsic::riscv_vsuxseg3, 0x40, 0x6, 0x1, PseudoVSUXSEG3EI64_V_M2_MF4 }, // 5451
  { Intrinsic::riscv_vsuxseg3, 0x40, 0x6, 0x2, PseudoVSUXSEG3EI64_V_M4_MF4 }, // 5452
  { Intrinsic::riscv_vsuxseg3, 0x40, 0x6, 0x3, PseudoVSUXSEG3EI64_V_M8_MF4 }, // 5453
  { Intrinsic::riscv_vsuxseg3, 0x40, 0x7, 0x0, PseudoVSUXSEG3EI64_V_M1_MF2 }, // 5454
  { Intrinsic::riscv_vsuxseg3, 0x40, 0x7, 0x1, PseudoVSUXSEG3EI64_V_M2_MF2 }, // 5455
  { Intrinsic::riscv_vsuxseg3, 0x40, 0x7, 0x2, PseudoVSUXSEG3EI64_V_M4_MF2 }, // 5456
  { Intrinsic::riscv_vsuxseg3, 0x40, 0x7, 0x3, PseudoVSUXSEG3EI64_V_M8_MF2 }, // 5457
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x0, 0x0, PseudoVSUXSEG3EI8_V_M1_M1_MASK }, // 5458
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x0, 0x1, PseudoVSUXSEG3EI8_V_M2_M1_MASK }, // 5459
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x0, 0x2, PseudoVSUXSEG3EI8_V_M4_M1_MASK }, // 5460
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x0, 0x3, PseudoVSUXSEG3EI8_V_M8_M1_MASK }, // 5461
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x0, 0x5, PseudoVSUXSEG3EI8_V_MF8_M1_MASK }, // 5462
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x0, 0x6, PseudoVSUXSEG3EI8_V_MF4_M1_MASK }, // 5463
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x0, 0x7, PseudoVSUXSEG3EI8_V_MF2_M1_MASK }, // 5464
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x1, 0x0, PseudoVSUXSEG3EI8_V_M1_M2_MASK }, // 5465
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x1, 0x1, PseudoVSUXSEG3EI8_V_M2_M2_MASK }, // 5466
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x1, 0x2, PseudoVSUXSEG3EI8_V_M4_M2_MASK }, // 5467
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x1, 0x3, PseudoVSUXSEG3EI8_V_M8_M2_MASK }, // 5468
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x1, 0x5, PseudoVSUXSEG3EI8_V_MF8_M2_MASK }, // 5469
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x1, 0x6, PseudoVSUXSEG3EI8_V_MF4_M2_MASK }, // 5470
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x1, 0x7, PseudoVSUXSEG3EI8_V_MF2_M2_MASK }, // 5471
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x5, 0x0, PseudoVSUXSEG3EI8_V_M1_MF8_MASK }, // 5472
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x5, 0x1, PseudoVSUXSEG3EI8_V_M2_MF8_MASK }, // 5473
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x5, 0x2, PseudoVSUXSEG3EI8_V_M4_MF8_MASK }, // 5474
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x5, 0x3, PseudoVSUXSEG3EI8_V_M8_MF8_MASK }, // 5475
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x5, 0x5, PseudoVSUXSEG3EI8_V_MF8_MF8_MASK }, // 5476
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x5, 0x6, PseudoVSUXSEG3EI8_V_MF4_MF8_MASK }, // 5477
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x5, 0x7, PseudoVSUXSEG3EI8_V_MF2_MF8_MASK }, // 5478
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x6, 0x0, PseudoVSUXSEG3EI8_V_M1_MF4_MASK }, // 5479
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x6, 0x1, PseudoVSUXSEG3EI8_V_M2_MF4_MASK }, // 5480
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x6, 0x2, PseudoVSUXSEG3EI8_V_M4_MF4_MASK }, // 5481
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x6, 0x3, PseudoVSUXSEG3EI8_V_M8_MF4_MASK }, // 5482
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x6, 0x5, PseudoVSUXSEG3EI8_V_MF8_MF4_MASK }, // 5483
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x6, 0x6, PseudoVSUXSEG3EI8_V_MF4_MF4_MASK }, // 5484
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x6, 0x7, PseudoVSUXSEG3EI8_V_MF2_MF4_MASK }, // 5485
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x7, 0x0, PseudoVSUXSEG3EI8_V_M1_MF2_MASK }, // 5486
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x7, 0x1, PseudoVSUXSEG3EI8_V_M2_MF2_MASK }, // 5487
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x7, 0x2, PseudoVSUXSEG3EI8_V_M4_MF2_MASK }, // 5488
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x7, 0x3, PseudoVSUXSEG3EI8_V_M8_MF2_MASK }, // 5489
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x7, 0x5, PseudoVSUXSEG3EI8_V_MF8_MF2_MASK }, // 5490
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x7, 0x6, PseudoVSUXSEG3EI8_V_MF4_MF2_MASK }, // 5491
  { Intrinsic::riscv_vsuxseg3_mask, 0x8, 0x7, 0x7, PseudoVSUXSEG3EI8_V_MF2_MF2_MASK }, // 5492
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x0, 0x0, PseudoVSUXSEG3EI16_V_M1_M1_MASK }, // 5493
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x0, 0x1, PseudoVSUXSEG3EI16_V_M2_M1_MASK }, // 5494
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x0, 0x2, PseudoVSUXSEG3EI16_V_M4_M1_MASK }, // 5495
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x0, 0x3, PseudoVSUXSEG3EI16_V_M8_M1_MASK }, // 5496
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x0, 0x6, PseudoVSUXSEG3EI16_V_MF4_M1_MASK }, // 5497
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x0, 0x7, PseudoVSUXSEG3EI16_V_MF2_M1_MASK }, // 5498
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x1, 0x0, PseudoVSUXSEG3EI16_V_M1_M2_MASK }, // 5499
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x1, 0x1, PseudoVSUXSEG3EI16_V_M2_M2_MASK }, // 5500
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x1, 0x2, PseudoVSUXSEG3EI16_V_M4_M2_MASK }, // 5501
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x1, 0x3, PseudoVSUXSEG3EI16_V_M8_M2_MASK }, // 5502
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x1, 0x6, PseudoVSUXSEG3EI16_V_MF4_M2_MASK }, // 5503
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x1, 0x7, PseudoVSUXSEG3EI16_V_MF2_M2_MASK }, // 5504
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x5, 0x0, PseudoVSUXSEG3EI16_V_M1_MF8_MASK }, // 5505
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x5, 0x1, PseudoVSUXSEG3EI16_V_M2_MF8_MASK }, // 5506
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x5, 0x2, PseudoVSUXSEG3EI16_V_M4_MF8_MASK }, // 5507
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x5, 0x3, PseudoVSUXSEG3EI16_V_M8_MF8_MASK }, // 5508
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x5, 0x6, PseudoVSUXSEG3EI16_V_MF4_MF8_MASK }, // 5509
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x5, 0x7, PseudoVSUXSEG3EI16_V_MF2_MF8_MASK }, // 5510
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x6, 0x0, PseudoVSUXSEG3EI16_V_M1_MF4_MASK }, // 5511
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x6, 0x1, PseudoVSUXSEG3EI16_V_M2_MF4_MASK }, // 5512
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x6, 0x2, PseudoVSUXSEG3EI16_V_M4_MF4_MASK }, // 5513
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x6, 0x3, PseudoVSUXSEG3EI16_V_M8_MF4_MASK }, // 5514
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x6, 0x6, PseudoVSUXSEG3EI16_V_MF4_MF4_MASK }, // 5515
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x6, 0x7, PseudoVSUXSEG3EI16_V_MF2_MF4_MASK }, // 5516
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x7, 0x0, PseudoVSUXSEG3EI16_V_M1_MF2_MASK }, // 5517
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x7, 0x1, PseudoVSUXSEG3EI16_V_M2_MF2_MASK }, // 5518
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x7, 0x2, PseudoVSUXSEG3EI16_V_M4_MF2_MASK }, // 5519
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x7, 0x3, PseudoVSUXSEG3EI16_V_M8_MF2_MASK }, // 5520
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x7, 0x6, PseudoVSUXSEG3EI16_V_MF4_MF2_MASK }, // 5521
  { Intrinsic::riscv_vsuxseg3_mask, 0x10, 0x7, 0x7, PseudoVSUXSEG3EI16_V_MF2_MF2_MASK }, // 5522
  { Intrinsic::riscv_vsuxseg3_mask, 0x20, 0x0, 0x0, PseudoVSUXSEG3EI32_V_M1_M1_MASK }, // 5523
  { Intrinsic::riscv_vsuxseg3_mask, 0x20, 0x0, 0x1, PseudoVSUXSEG3EI32_V_M2_M1_MASK }, // 5524
  { Intrinsic::riscv_vsuxseg3_mask, 0x20, 0x0, 0x2, PseudoVSUXSEG3EI32_V_M4_M1_MASK }, // 5525
  { Intrinsic::riscv_vsuxseg3_mask, 0x20, 0x0, 0x3, PseudoVSUXSEG3EI32_V_M8_M1_MASK }, // 5526
  { Intrinsic::riscv_vsuxseg3_mask, 0x20, 0x0, 0x7, PseudoVSUXSEG3EI32_V_MF2_M1_MASK }, // 5527
  { Intrinsic::riscv_vsuxseg3_mask, 0x20, 0x1, 0x0, PseudoVSUXSEG3EI32_V_M1_M2_MASK }, // 5528
  { Intrinsic::riscv_vsuxseg3_mask, 0x20, 0x1, 0x1, PseudoVSUXSEG3EI32_V_M2_M2_MASK }, // 5529
  { Intrinsic::riscv_vsuxseg3_mask, 0x20, 0x1, 0x2, PseudoVSUXSEG3EI32_V_M4_M2_MASK }, // 5530
  { Intrinsic::riscv_vsuxseg3_mask, 0x20, 0x1, 0x3, PseudoVSUXSEG3EI32_V_M8_M2_MASK }, // 5531
  { Intrinsic::riscv_vsuxseg3_mask, 0x20, 0x1, 0x7, PseudoVSUXSEG3EI32_V_MF2_M2_MASK }, // 5532
  { Intrinsic::riscv_vsuxseg3_mask, 0x20, 0x5, 0x0, PseudoVSUXSEG3EI32_V_M1_MF8_MASK }, // 5533
  { Intrinsic::riscv_vsuxseg3_mask, 0x20, 0x5, 0x1, PseudoVSUXSEG3EI32_V_M2_MF8_MASK }, // 5534
  { Intrinsic::riscv_vsuxseg3_mask, 0x20, 0x5, 0x2, PseudoVSUXSEG3EI32_V_M4_MF8_MASK }, // 5535
  { Intrinsic::riscv_vsuxseg3_mask, 0x20, 0x5, 0x3, PseudoVSUXSEG3EI32_V_M8_MF8_MASK }, // 5536
  { Intrinsic::riscv_vsuxseg3_mask, 0x20, 0x5, 0x7, PseudoVSUXSEG3EI32_V_MF2_MF8_MASK }, // 5537
  { Intrinsic::riscv_vsuxseg3_mask, 0x20, 0x6, 0x0, PseudoVSUXSEG3EI32_V_M1_MF4_MASK }, // 5538
  { Intrinsic::riscv_vsuxseg3_mask, 0x20, 0x6, 0x1, PseudoVSUXSEG3EI32_V_M2_MF4_MASK }, // 5539
  { Intrinsic::riscv_vsuxseg3_mask, 0x20, 0x6, 0x2, PseudoVSUXSEG3EI32_V_M4_MF4_MASK }, // 5540
  { Intrinsic::riscv_vsuxseg3_mask, 0x20, 0x6, 0x3, PseudoVSUXSEG3EI32_V_M8_MF4_MASK }, // 5541
  { Intrinsic::riscv_vsuxseg3_mask, 0x20, 0x6, 0x7, PseudoVSUXSEG3EI32_V_MF2_MF4_MASK }, // 5542
  { Intrinsic::riscv_vsuxseg3_mask, 0x20, 0x7, 0x0, PseudoVSUXSEG3EI32_V_M1_MF2_MASK }, // 5543
  { Intrinsic::riscv_vsuxseg3_mask, 0x20, 0x7, 0x1, PseudoVSUXSEG3EI32_V_M2_MF2_MASK }, // 5544
  { Intrinsic::riscv_vsuxseg3_mask, 0x20, 0x7, 0x2, PseudoVSUXSEG3EI32_V_M4_MF2_MASK }, // 5545
  { Intrinsic::riscv_vsuxseg3_mask, 0x20, 0x7, 0x3, PseudoVSUXSEG3EI32_V_M8_MF2_MASK }, // 5546
  { Intrinsic::riscv_vsuxseg3_mask, 0x20, 0x7, 0x7, PseudoVSUXSEG3EI32_V_MF2_MF2_MASK }, // 5547
  { Intrinsic::riscv_vsuxseg3_mask, 0x40, 0x0, 0x0, PseudoVSUXSEG3EI64_V_M1_M1_MASK }, // 5548
  { Intrinsic::riscv_vsuxseg3_mask, 0x40, 0x0, 0x1, PseudoVSUXSEG3EI64_V_M2_M1_MASK }, // 5549
  { Intrinsic::riscv_vsuxseg3_mask, 0x40, 0x0, 0x2, PseudoVSUXSEG3EI64_V_M4_M1_MASK }, // 5550
  { Intrinsic::riscv_vsuxseg3_mask, 0x40, 0x0, 0x3, PseudoVSUXSEG3EI64_V_M8_M1_MASK }, // 5551
  { Intrinsic::riscv_vsuxseg3_mask, 0x40, 0x1, 0x0, PseudoVSUXSEG3EI64_V_M1_M2_MASK }, // 5552
  { Intrinsic::riscv_vsuxseg3_mask, 0x40, 0x1, 0x1, PseudoVSUXSEG3EI64_V_M2_M2_MASK }, // 5553
  { Intrinsic::riscv_vsuxseg3_mask, 0x40, 0x1, 0x2, PseudoVSUXSEG3EI64_V_M4_M2_MASK }, // 5554
  { Intrinsic::riscv_vsuxseg3_mask, 0x40, 0x1, 0x3, PseudoVSUXSEG3EI64_V_M8_M2_MASK }, // 5555
  { Intrinsic::riscv_vsuxseg3_mask, 0x40, 0x5, 0x0, PseudoVSUXSEG3EI64_V_M1_MF8_MASK }, // 5556
  { Intrinsic::riscv_vsuxseg3_mask, 0x40, 0x5, 0x1, PseudoVSUXSEG3EI64_V_M2_MF8_MASK }, // 5557
  { Intrinsic::riscv_vsuxseg3_mask, 0x40, 0x5, 0x2, PseudoVSUXSEG3EI64_V_M4_MF8_MASK }, // 5558
  { Intrinsic::riscv_vsuxseg3_mask, 0x40, 0x5, 0x3, PseudoVSUXSEG3EI64_V_M8_MF8_MASK }, // 5559
  { Intrinsic::riscv_vsuxseg3_mask, 0x40, 0x6, 0x0, PseudoVSUXSEG3EI64_V_M1_MF4_MASK }, // 5560
  { Intrinsic::riscv_vsuxseg3_mask, 0x40, 0x6, 0x1, PseudoVSUXSEG3EI64_V_M2_MF4_MASK }, // 5561
  { Intrinsic::riscv_vsuxseg3_mask, 0x40, 0x6, 0x2, PseudoVSUXSEG3EI64_V_M4_MF4_MASK }, // 5562
  { Intrinsic::riscv_vsuxseg3_mask, 0x40, 0x6, 0x3, PseudoVSUXSEG3EI64_V_M8_MF4_MASK }, // 5563
  { Intrinsic::riscv_vsuxseg3_mask, 0x40, 0x7, 0x0, PseudoVSUXSEG3EI64_V_M1_MF2_MASK }, // 5564
  { Intrinsic::riscv_vsuxseg3_mask, 0x40, 0x7, 0x1, PseudoVSUXSEG3EI64_V_M2_MF2_MASK }, // 5565
  { Intrinsic::riscv_vsuxseg3_mask, 0x40, 0x7, 0x2, PseudoVSUXSEG3EI64_V_M4_MF2_MASK }, // 5566
  { Intrinsic::riscv_vsuxseg3_mask, 0x40, 0x7, 0x3, PseudoVSUXSEG3EI64_V_M8_MF2_MASK }, // 5567
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x0, 0x0, PseudoVSUXSEG4EI8_V_M1_M1 }, // 5568
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x0, 0x1, PseudoVSUXSEG4EI8_V_M2_M1 }, // 5569
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x0, 0x2, PseudoVSUXSEG4EI8_V_M4_M1 }, // 5570
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x0, 0x3, PseudoVSUXSEG4EI8_V_M8_M1 }, // 5571
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x0, 0x5, PseudoVSUXSEG4EI8_V_MF8_M1 }, // 5572
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x0, 0x6, PseudoVSUXSEG4EI8_V_MF4_M1 }, // 5573
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x0, 0x7, PseudoVSUXSEG4EI8_V_MF2_M1 }, // 5574
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x1, 0x0, PseudoVSUXSEG4EI8_V_M1_M2 }, // 5575
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x1, 0x1, PseudoVSUXSEG4EI8_V_M2_M2 }, // 5576
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x1, 0x2, PseudoVSUXSEG4EI8_V_M4_M2 }, // 5577
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x1, 0x3, PseudoVSUXSEG4EI8_V_M8_M2 }, // 5578
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x1, 0x5, PseudoVSUXSEG4EI8_V_MF8_M2 }, // 5579
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x1, 0x6, PseudoVSUXSEG4EI8_V_MF4_M2 }, // 5580
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x1, 0x7, PseudoVSUXSEG4EI8_V_MF2_M2 }, // 5581
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x5, 0x0, PseudoVSUXSEG4EI8_V_M1_MF8 }, // 5582
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x5, 0x1, PseudoVSUXSEG4EI8_V_M2_MF8 }, // 5583
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x5, 0x2, PseudoVSUXSEG4EI8_V_M4_MF8 }, // 5584
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x5, 0x3, PseudoVSUXSEG4EI8_V_M8_MF8 }, // 5585
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x5, 0x5, PseudoVSUXSEG4EI8_V_MF8_MF8 }, // 5586
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x5, 0x6, PseudoVSUXSEG4EI8_V_MF4_MF8 }, // 5587
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x5, 0x7, PseudoVSUXSEG4EI8_V_MF2_MF8 }, // 5588
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x6, 0x0, PseudoVSUXSEG4EI8_V_M1_MF4 }, // 5589
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x6, 0x1, PseudoVSUXSEG4EI8_V_M2_MF4 }, // 5590
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x6, 0x2, PseudoVSUXSEG4EI8_V_M4_MF4 }, // 5591
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x6, 0x3, PseudoVSUXSEG4EI8_V_M8_MF4 }, // 5592
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x6, 0x5, PseudoVSUXSEG4EI8_V_MF8_MF4 }, // 5593
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x6, 0x6, PseudoVSUXSEG4EI8_V_MF4_MF4 }, // 5594
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x6, 0x7, PseudoVSUXSEG4EI8_V_MF2_MF4 }, // 5595
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x7, 0x0, PseudoVSUXSEG4EI8_V_M1_MF2 }, // 5596
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x7, 0x1, PseudoVSUXSEG4EI8_V_M2_MF2 }, // 5597
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x7, 0x2, PseudoVSUXSEG4EI8_V_M4_MF2 }, // 5598
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x7, 0x3, PseudoVSUXSEG4EI8_V_M8_MF2 }, // 5599
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x7, 0x5, PseudoVSUXSEG4EI8_V_MF8_MF2 }, // 5600
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x7, 0x6, PseudoVSUXSEG4EI8_V_MF4_MF2 }, // 5601
  { Intrinsic::riscv_vsuxseg4, 0x8, 0x7, 0x7, PseudoVSUXSEG4EI8_V_MF2_MF2 }, // 5602
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x0, 0x0, PseudoVSUXSEG4EI16_V_M1_M1 }, // 5603
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x0, 0x1, PseudoVSUXSEG4EI16_V_M2_M1 }, // 5604
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x0, 0x2, PseudoVSUXSEG4EI16_V_M4_M1 }, // 5605
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x0, 0x3, PseudoVSUXSEG4EI16_V_M8_M1 }, // 5606
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x0, 0x6, PseudoVSUXSEG4EI16_V_MF4_M1 }, // 5607
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x0, 0x7, PseudoVSUXSEG4EI16_V_MF2_M1 }, // 5608
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x1, 0x0, PseudoVSUXSEG4EI16_V_M1_M2 }, // 5609
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x1, 0x1, PseudoVSUXSEG4EI16_V_M2_M2 }, // 5610
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x1, 0x2, PseudoVSUXSEG4EI16_V_M4_M2 }, // 5611
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x1, 0x3, PseudoVSUXSEG4EI16_V_M8_M2 }, // 5612
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x1, 0x6, PseudoVSUXSEG4EI16_V_MF4_M2 }, // 5613
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x1, 0x7, PseudoVSUXSEG4EI16_V_MF2_M2 }, // 5614
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x5, 0x0, PseudoVSUXSEG4EI16_V_M1_MF8 }, // 5615
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x5, 0x1, PseudoVSUXSEG4EI16_V_M2_MF8 }, // 5616
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x5, 0x2, PseudoVSUXSEG4EI16_V_M4_MF8 }, // 5617
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x5, 0x3, PseudoVSUXSEG4EI16_V_M8_MF8 }, // 5618
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x5, 0x6, PseudoVSUXSEG4EI16_V_MF4_MF8 }, // 5619
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x5, 0x7, PseudoVSUXSEG4EI16_V_MF2_MF8 }, // 5620
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x6, 0x0, PseudoVSUXSEG4EI16_V_M1_MF4 }, // 5621
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x6, 0x1, PseudoVSUXSEG4EI16_V_M2_MF4 }, // 5622
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x6, 0x2, PseudoVSUXSEG4EI16_V_M4_MF4 }, // 5623
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x6, 0x3, PseudoVSUXSEG4EI16_V_M8_MF4 }, // 5624
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x6, 0x6, PseudoVSUXSEG4EI16_V_MF4_MF4 }, // 5625
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x6, 0x7, PseudoVSUXSEG4EI16_V_MF2_MF4 }, // 5626
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x7, 0x0, PseudoVSUXSEG4EI16_V_M1_MF2 }, // 5627
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x7, 0x1, PseudoVSUXSEG4EI16_V_M2_MF2 }, // 5628
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x7, 0x2, PseudoVSUXSEG4EI16_V_M4_MF2 }, // 5629
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x7, 0x3, PseudoVSUXSEG4EI16_V_M8_MF2 }, // 5630
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x7, 0x6, PseudoVSUXSEG4EI16_V_MF4_MF2 }, // 5631
  { Intrinsic::riscv_vsuxseg4, 0x10, 0x7, 0x7, PseudoVSUXSEG4EI16_V_MF2_MF2 }, // 5632
  { Intrinsic::riscv_vsuxseg4, 0x20, 0x0, 0x0, PseudoVSUXSEG4EI32_V_M1_M1 }, // 5633
  { Intrinsic::riscv_vsuxseg4, 0x20, 0x0, 0x1, PseudoVSUXSEG4EI32_V_M2_M1 }, // 5634
  { Intrinsic::riscv_vsuxseg4, 0x20, 0x0, 0x2, PseudoVSUXSEG4EI32_V_M4_M1 }, // 5635
  { Intrinsic::riscv_vsuxseg4, 0x20, 0x0, 0x3, PseudoVSUXSEG4EI32_V_M8_M1 }, // 5636
  { Intrinsic::riscv_vsuxseg4, 0x20, 0x0, 0x7, PseudoVSUXSEG4EI32_V_MF2_M1 }, // 5637
  { Intrinsic::riscv_vsuxseg4, 0x20, 0x1, 0x0, PseudoVSUXSEG4EI32_V_M1_M2 }, // 5638
  { Intrinsic::riscv_vsuxseg4, 0x20, 0x1, 0x1, PseudoVSUXSEG4EI32_V_M2_M2 }, // 5639
  { Intrinsic::riscv_vsuxseg4, 0x20, 0x1, 0x2, PseudoVSUXSEG4EI32_V_M4_M2 }, // 5640
  { Intrinsic::riscv_vsuxseg4, 0x20, 0x1, 0x3, PseudoVSUXSEG4EI32_V_M8_M2 }, // 5641
  { Intrinsic::riscv_vsuxseg4, 0x20, 0x1, 0x7, PseudoVSUXSEG4EI32_V_MF2_M2 }, // 5642
  { Intrinsic::riscv_vsuxseg4, 0x20, 0x5, 0x0, PseudoVSUXSEG4EI32_V_M1_MF8 }, // 5643
  { Intrinsic::riscv_vsuxseg4, 0x20, 0x5, 0x1, PseudoVSUXSEG4EI32_V_M2_MF8 }, // 5644
  { Intrinsic::riscv_vsuxseg4, 0x20, 0x5, 0x2, PseudoVSUXSEG4EI32_V_M4_MF8 }, // 5645
  { Intrinsic::riscv_vsuxseg4, 0x20, 0x5, 0x3, PseudoVSUXSEG4EI32_V_M8_MF8 }, // 5646
  { Intrinsic::riscv_vsuxseg4, 0x20, 0x5, 0x7, PseudoVSUXSEG4EI32_V_MF2_MF8 }, // 5647
  { Intrinsic::riscv_vsuxseg4, 0x20, 0x6, 0x0, PseudoVSUXSEG4EI32_V_M1_MF4 }, // 5648
  { Intrinsic::riscv_vsuxseg4, 0x20, 0x6, 0x1, PseudoVSUXSEG4EI32_V_M2_MF4 }, // 5649
  { Intrinsic::riscv_vsuxseg4, 0x20, 0x6, 0x2, PseudoVSUXSEG4EI32_V_M4_MF4 }, // 5650
  { Intrinsic::riscv_vsuxseg4, 0x20, 0x6, 0x3, PseudoVSUXSEG4EI32_V_M8_MF4 }, // 5651
  { Intrinsic::riscv_vsuxseg4, 0x20, 0x6, 0x7, PseudoVSUXSEG4EI32_V_MF2_MF4 }, // 5652
  { Intrinsic::riscv_vsuxseg4, 0x20, 0x7, 0x0, PseudoVSUXSEG4EI32_V_M1_MF2 }, // 5653
  { Intrinsic::riscv_vsuxseg4, 0x20, 0x7, 0x1, PseudoVSUXSEG4EI32_V_M2_MF2 }, // 5654
  { Intrinsic::riscv_vsuxseg4, 0x20, 0x7, 0x2, PseudoVSUXSEG4EI32_V_M4_MF2 }, // 5655
  { Intrinsic::riscv_vsuxseg4, 0x20, 0x7, 0x3, PseudoVSUXSEG4EI32_V_M8_MF2 }, // 5656
  { Intrinsic::riscv_vsuxseg4, 0x20, 0x7, 0x7, PseudoVSUXSEG4EI32_V_MF2_MF2 }, // 5657
  { Intrinsic::riscv_vsuxseg4, 0x40, 0x0, 0x0, PseudoVSUXSEG4EI64_V_M1_M1 }, // 5658
  { Intrinsic::riscv_vsuxseg4, 0x40, 0x0, 0x1, PseudoVSUXSEG4EI64_V_M2_M1 }, // 5659
  { Intrinsic::riscv_vsuxseg4, 0x40, 0x0, 0x2, PseudoVSUXSEG4EI64_V_M4_M1 }, // 5660
  { Intrinsic::riscv_vsuxseg4, 0x40, 0x0, 0x3, PseudoVSUXSEG4EI64_V_M8_M1 }, // 5661
  { Intrinsic::riscv_vsuxseg4, 0x40, 0x1, 0x0, PseudoVSUXSEG4EI64_V_M1_M2 }, // 5662
  { Intrinsic::riscv_vsuxseg4, 0x40, 0x1, 0x1, PseudoVSUXSEG4EI64_V_M2_M2 }, // 5663
  { Intrinsic::riscv_vsuxseg4, 0x40, 0x1, 0x2, PseudoVSUXSEG4EI64_V_M4_M2 }, // 5664
  { Intrinsic::riscv_vsuxseg4, 0x40, 0x1, 0x3, PseudoVSUXSEG4EI64_V_M8_M2 }, // 5665
  { Intrinsic::riscv_vsuxseg4, 0x40, 0x5, 0x0, PseudoVSUXSEG4EI64_V_M1_MF8 }, // 5666
  { Intrinsic::riscv_vsuxseg4, 0x40, 0x5, 0x1, PseudoVSUXSEG4EI64_V_M2_MF8 }, // 5667
  { Intrinsic::riscv_vsuxseg4, 0x40, 0x5, 0x2, PseudoVSUXSEG4EI64_V_M4_MF8 }, // 5668
  { Intrinsic::riscv_vsuxseg4, 0x40, 0x5, 0x3, PseudoVSUXSEG4EI64_V_M8_MF8 }, // 5669
  { Intrinsic::riscv_vsuxseg4, 0x40, 0x6, 0x0, PseudoVSUXSEG4EI64_V_M1_MF4 }, // 5670
  { Intrinsic::riscv_vsuxseg4, 0x40, 0x6, 0x1, PseudoVSUXSEG4EI64_V_M2_MF4 }, // 5671
  { Intrinsic::riscv_vsuxseg4, 0x40, 0x6, 0x2, PseudoVSUXSEG4EI64_V_M4_MF4 }, // 5672
  { Intrinsic::riscv_vsuxseg4, 0x40, 0x6, 0x3, PseudoVSUXSEG4EI64_V_M8_MF4 }, // 5673
  { Intrinsic::riscv_vsuxseg4, 0x40, 0x7, 0x0, PseudoVSUXSEG4EI64_V_M1_MF2 }, // 5674
  { Intrinsic::riscv_vsuxseg4, 0x40, 0x7, 0x1, PseudoVSUXSEG4EI64_V_M2_MF2 }, // 5675
  { Intrinsic::riscv_vsuxseg4, 0x40, 0x7, 0x2, PseudoVSUXSEG4EI64_V_M4_MF2 }, // 5676
  { Intrinsic::riscv_vsuxseg4, 0x40, 0x7, 0x3, PseudoVSUXSEG4EI64_V_M8_MF2 }, // 5677
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x0, 0x0, PseudoVSUXSEG4EI8_V_M1_M1_MASK }, // 5678
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x0, 0x1, PseudoVSUXSEG4EI8_V_M2_M1_MASK }, // 5679
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x0, 0x2, PseudoVSUXSEG4EI8_V_M4_M1_MASK }, // 5680
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x0, 0x3, PseudoVSUXSEG4EI8_V_M8_M1_MASK }, // 5681
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x0, 0x5, PseudoVSUXSEG4EI8_V_MF8_M1_MASK }, // 5682
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x0, 0x6, PseudoVSUXSEG4EI8_V_MF4_M1_MASK }, // 5683
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x0, 0x7, PseudoVSUXSEG4EI8_V_MF2_M1_MASK }, // 5684
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x1, 0x0, PseudoVSUXSEG4EI8_V_M1_M2_MASK }, // 5685
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x1, 0x1, PseudoVSUXSEG4EI8_V_M2_M2_MASK }, // 5686
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x1, 0x2, PseudoVSUXSEG4EI8_V_M4_M2_MASK }, // 5687
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x1, 0x3, PseudoVSUXSEG4EI8_V_M8_M2_MASK }, // 5688
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x1, 0x5, PseudoVSUXSEG4EI8_V_MF8_M2_MASK }, // 5689
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x1, 0x6, PseudoVSUXSEG4EI8_V_MF4_M2_MASK }, // 5690
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x1, 0x7, PseudoVSUXSEG4EI8_V_MF2_M2_MASK }, // 5691
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x5, 0x0, PseudoVSUXSEG4EI8_V_M1_MF8_MASK }, // 5692
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x5, 0x1, PseudoVSUXSEG4EI8_V_M2_MF8_MASK }, // 5693
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x5, 0x2, PseudoVSUXSEG4EI8_V_M4_MF8_MASK }, // 5694
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x5, 0x3, PseudoVSUXSEG4EI8_V_M8_MF8_MASK }, // 5695
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x5, 0x5, PseudoVSUXSEG4EI8_V_MF8_MF8_MASK }, // 5696
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x5, 0x6, PseudoVSUXSEG4EI8_V_MF4_MF8_MASK }, // 5697
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x5, 0x7, PseudoVSUXSEG4EI8_V_MF2_MF8_MASK }, // 5698
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x6, 0x0, PseudoVSUXSEG4EI8_V_M1_MF4_MASK }, // 5699
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x6, 0x1, PseudoVSUXSEG4EI8_V_M2_MF4_MASK }, // 5700
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x6, 0x2, PseudoVSUXSEG4EI8_V_M4_MF4_MASK }, // 5701
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x6, 0x3, PseudoVSUXSEG4EI8_V_M8_MF4_MASK }, // 5702
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x6, 0x5, PseudoVSUXSEG4EI8_V_MF8_MF4_MASK }, // 5703
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x6, 0x6, PseudoVSUXSEG4EI8_V_MF4_MF4_MASK }, // 5704
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x6, 0x7, PseudoVSUXSEG4EI8_V_MF2_MF4_MASK }, // 5705
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x7, 0x0, PseudoVSUXSEG4EI8_V_M1_MF2_MASK }, // 5706
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x7, 0x1, PseudoVSUXSEG4EI8_V_M2_MF2_MASK }, // 5707
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x7, 0x2, PseudoVSUXSEG4EI8_V_M4_MF2_MASK }, // 5708
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x7, 0x3, PseudoVSUXSEG4EI8_V_M8_MF2_MASK }, // 5709
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x7, 0x5, PseudoVSUXSEG4EI8_V_MF8_MF2_MASK }, // 5710
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x7, 0x6, PseudoVSUXSEG4EI8_V_MF4_MF2_MASK }, // 5711
  { Intrinsic::riscv_vsuxseg4_mask, 0x8, 0x7, 0x7, PseudoVSUXSEG4EI8_V_MF2_MF2_MASK }, // 5712
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x0, 0x0, PseudoVSUXSEG4EI16_V_M1_M1_MASK }, // 5713
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x0, 0x1, PseudoVSUXSEG4EI16_V_M2_M1_MASK }, // 5714
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x0, 0x2, PseudoVSUXSEG4EI16_V_M4_M1_MASK }, // 5715
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x0, 0x3, PseudoVSUXSEG4EI16_V_M8_M1_MASK }, // 5716
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x0, 0x6, PseudoVSUXSEG4EI16_V_MF4_M1_MASK }, // 5717
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x0, 0x7, PseudoVSUXSEG4EI16_V_MF2_M1_MASK }, // 5718
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x1, 0x0, PseudoVSUXSEG4EI16_V_M1_M2_MASK }, // 5719
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x1, 0x1, PseudoVSUXSEG4EI16_V_M2_M2_MASK }, // 5720
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x1, 0x2, PseudoVSUXSEG4EI16_V_M4_M2_MASK }, // 5721
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x1, 0x3, PseudoVSUXSEG4EI16_V_M8_M2_MASK }, // 5722
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x1, 0x6, PseudoVSUXSEG4EI16_V_MF4_M2_MASK }, // 5723
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x1, 0x7, PseudoVSUXSEG4EI16_V_MF2_M2_MASK }, // 5724
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x5, 0x0, PseudoVSUXSEG4EI16_V_M1_MF8_MASK }, // 5725
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x5, 0x1, PseudoVSUXSEG4EI16_V_M2_MF8_MASK }, // 5726
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x5, 0x2, PseudoVSUXSEG4EI16_V_M4_MF8_MASK }, // 5727
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x5, 0x3, PseudoVSUXSEG4EI16_V_M8_MF8_MASK }, // 5728
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x5, 0x6, PseudoVSUXSEG4EI16_V_MF4_MF8_MASK }, // 5729
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x5, 0x7, PseudoVSUXSEG4EI16_V_MF2_MF8_MASK }, // 5730
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x6, 0x0, PseudoVSUXSEG4EI16_V_M1_MF4_MASK }, // 5731
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x6, 0x1, PseudoVSUXSEG4EI16_V_M2_MF4_MASK }, // 5732
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x6, 0x2, PseudoVSUXSEG4EI16_V_M4_MF4_MASK }, // 5733
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x6, 0x3, PseudoVSUXSEG4EI16_V_M8_MF4_MASK }, // 5734
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x6, 0x6, PseudoVSUXSEG4EI16_V_MF4_MF4_MASK }, // 5735
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x6, 0x7, PseudoVSUXSEG4EI16_V_MF2_MF4_MASK }, // 5736
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x7, 0x0, PseudoVSUXSEG4EI16_V_M1_MF2_MASK }, // 5737
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x7, 0x1, PseudoVSUXSEG4EI16_V_M2_MF2_MASK }, // 5738
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x7, 0x2, PseudoVSUXSEG4EI16_V_M4_MF2_MASK }, // 5739
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x7, 0x3, PseudoVSUXSEG4EI16_V_M8_MF2_MASK }, // 5740
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x7, 0x6, PseudoVSUXSEG4EI16_V_MF4_MF2_MASK }, // 5741
  { Intrinsic::riscv_vsuxseg4_mask, 0x10, 0x7, 0x7, PseudoVSUXSEG4EI16_V_MF2_MF2_MASK }, // 5742
  { Intrinsic::riscv_vsuxseg4_mask, 0x20, 0x0, 0x0, PseudoVSUXSEG4EI32_V_M1_M1_MASK }, // 5743
  { Intrinsic::riscv_vsuxseg4_mask, 0x20, 0x0, 0x1, PseudoVSUXSEG4EI32_V_M2_M1_MASK }, // 5744
  { Intrinsic::riscv_vsuxseg4_mask, 0x20, 0x0, 0x2, PseudoVSUXSEG4EI32_V_M4_M1_MASK }, // 5745
  { Intrinsic::riscv_vsuxseg4_mask, 0x20, 0x0, 0x3, PseudoVSUXSEG4EI32_V_M8_M1_MASK }, // 5746
  { Intrinsic::riscv_vsuxseg4_mask, 0x20, 0x0, 0x7, PseudoVSUXSEG4EI32_V_MF2_M1_MASK }, // 5747
  { Intrinsic::riscv_vsuxseg4_mask, 0x20, 0x1, 0x0, PseudoVSUXSEG4EI32_V_M1_M2_MASK }, // 5748
  { Intrinsic::riscv_vsuxseg4_mask, 0x20, 0x1, 0x1, PseudoVSUXSEG4EI32_V_M2_M2_MASK }, // 5749
  { Intrinsic::riscv_vsuxseg4_mask, 0x20, 0x1, 0x2, PseudoVSUXSEG4EI32_V_M4_M2_MASK }, // 5750
  { Intrinsic::riscv_vsuxseg4_mask, 0x20, 0x1, 0x3, PseudoVSUXSEG4EI32_V_M8_M2_MASK }, // 5751
  { Intrinsic::riscv_vsuxseg4_mask, 0x20, 0x1, 0x7, PseudoVSUXSEG4EI32_V_MF2_M2_MASK }, // 5752
  { Intrinsic::riscv_vsuxseg4_mask, 0x20, 0x5, 0x0, PseudoVSUXSEG4EI32_V_M1_MF8_MASK }, // 5753
  { Intrinsic::riscv_vsuxseg4_mask, 0x20, 0x5, 0x1, PseudoVSUXSEG4EI32_V_M2_MF8_MASK }, // 5754
  { Intrinsic::riscv_vsuxseg4_mask, 0x20, 0x5, 0x2, PseudoVSUXSEG4EI32_V_M4_MF8_MASK }, // 5755
  { Intrinsic::riscv_vsuxseg4_mask, 0x20, 0x5, 0x3, PseudoVSUXSEG4EI32_V_M8_MF8_MASK }, // 5756
  { Intrinsic::riscv_vsuxseg4_mask, 0x20, 0x5, 0x7, PseudoVSUXSEG4EI32_V_MF2_MF8_MASK }, // 5757
  { Intrinsic::riscv_vsuxseg4_mask, 0x20, 0x6, 0x0, PseudoVSUXSEG4EI32_V_M1_MF4_MASK }, // 5758
  { Intrinsic::riscv_vsuxseg4_mask, 0x20, 0x6, 0x1, PseudoVSUXSEG4EI32_V_M2_MF4_MASK }, // 5759
  { Intrinsic::riscv_vsuxseg4_mask, 0x20, 0x6, 0x2, PseudoVSUXSEG4EI32_V_M4_MF4_MASK }, // 5760
  { Intrinsic::riscv_vsuxseg4_mask, 0x20, 0x6, 0x3, PseudoVSUXSEG4EI32_V_M8_MF4_MASK }, // 5761
  { Intrinsic::riscv_vsuxseg4_mask, 0x20, 0x6, 0x7, PseudoVSUXSEG4EI32_V_MF2_MF4_MASK }, // 5762
  { Intrinsic::riscv_vsuxseg4_mask, 0x20, 0x7, 0x0, PseudoVSUXSEG4EI32_V_M1_MF2_MASK }, // 5763
  { Intrinsic::riscv_vsuxseg4_mask, 0x20, 0x7, 0x1, PseudoVSUXSEG4EI32_V_M2_MF2_MASK }, // 5764
  { Intrinsic::riscv_vsuxseg4_mask, 0x20, 0x7, 0x2, PseudoVSUXSEG4EI32_V_M4_MF2_MASK }, // 5765
  { Intrinsic::riscv_vsuxseg4_mask, 0x20, 0x7, 0x3, PseudoVSUXSEG4EI32_V_M8_MF2_MASK }, // 5766
  { Intrinsic::riscv_vsuxseg4_mask, 0x20, 0x7, 0x7, PseudoVSUXSEG4EI32_V_MF2_MF2_MASK }, // 5767
  { Intrinsic::riscv_vsuxseg4_mask, 0x40, 0x0, 0x0, PseudoVSUXSEG4EI64_V_M1_M1_MASK }, // 5768
  { Intrinsic::riscv_vsuxseg4_mask, 0x40, 0x0, 0x1, PseudoVSUXSEG4EI64_V_M2_M1_MASK }, // 5769
  { Intrinsic::riscv_vsuxseg4_mask, 0x40, 0x0, 0x2, PseudoVSUXSEG4EI64_V_M4_M1_MASK }, // 5770
  { Intrinsic::riscv_vsuxseg4_mask, 0x40, 0x0, 0x3, PseudoVSUXSEG4EI64_V_M8_M1_MASK }, // 5771
  { Intrinsic::riscv_vsuxseg4_mask, 0x40, 0x1, 0x0, PseudoVSUXSEG4EI64_V_M1_M2_MASK }, // 5772
  { Intrinsic::riscv_vsuxseg4_mask, 0x40, 0x1, 0x1, PseudoVSUXSEG4EI64_V_M2_M2_MASK }, // 5773
  { Intrinsic::riscv_vsuxseg4_mask, 0x40, 0x1, 0x2, PseudoVSUXSEG4EI64_V_M4_M2_MASK }, // 5774
  { Intrinsic::riscv_vsuxseg4_mask, 0x40, 0x1, 0x3, PseudoVSUXSEG4EI64_V_M8_M2_MASK }, // 5775
  { Intrinsic::riscv_vsuxseg4_mask, 0x40, 0x5, 0x0, PseudoVSUXSEG4EI64_V_M1_MF8_MASK }, // 5776
  { Intrinsic::riscv_vsuxseg4_mask, 0x40, 0x5, 0x1, PseudoVSUXSEG4EI64_V_M2_MF8_MASK }, // 5777
  { Intrinsic::riscv_vsuxseg4_mask, 0x40, 0x5, 0x2, PseudoVSUXSEG4EI64_V_M4_MF8_MASK }, // 5778
  { Intrinsic::riscv_vsuxseg4_mask, 0x40, 0x5, 0x3, PseudoVSUXSEG4EI64_V_M8_MF8_MASK }, // 5779
  { Intrinsic::riscv_vsuxseg4_mask, 0x40, 0x6, 0x0, PseudoVSUXSEG4EI64_V_M1_MF4_MASK }, // 5780
  { Intrinsic::riscv_vsuxseg4_mask, 0x40, 0x6, 0x1, PseudoVSUXSEG4EI64_V_M2_MF4_MASK }, // 5781
  { Intrinsic::riscv_vsuxseg4_mask, 0x40, 0x6, 0x2, PseudoVSUXSEG4EI64_V_M4_MF4_MASK }, // 5782
  { Intrinsic::riscv_vsuxseg4_mask, 0x40, 0x6, 0x3, PseudoVSUXSEG4EI64_V_M8_MF4_MASK }, // 5783
  { Intrinsic::riscv_vsuxseg4_mask, 0x40, 0x7, 0x0, PseudoVSUXSEG4EI64_V_M1_MF2_MASK }, // 5784
  { Intrinsic::riscv_vsuxseg4_mask, 0x40, 0x7, 0x1, PseudoVSUXSEG4EI64_V_M2_MF2_MASK }, // 5785
  { Intrinsic::riscv_vsuxseg4_mask, 0x40, 0x7, 0x2, PseudoVSUXSEG4EI64_V_M4_MF2_MASK }, // 5786
  { Intrinsic::riscv_vsuxseg4_mask, 0x40, 0x7, 0x3, PseudoVSUXSEG4EI64_V_M8_MF2_MASK }, // 5787
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x0, 0x0, PseudoVSUXSEG5EI8_V_M1_M1 }, // 5788
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x0, 0x1, PseudoVSUXSEG5EI8_V_M2_M1 }, // 5789
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x0, 0x2, PseudoVSUXSEG5EI8_V_M4_M1 }, // 5790
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x0, 0x3, PseudoVSUXSEG5EI8_V_M8_M1 }, // 5791
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x0, 0x5, PseudoVSUXSEG5EI8_V_MF8_M1 }, // 5792
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x0, 0x6, PseudoVSUXSEG5EI8_V_MF4_M1 }, // 5793
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x0, 0x7, PseudoVSUXSEG5EI8_V_MF2_M1 }, // 5794
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x5, 0x0, PseudoVSUXSEG5EI8_V_M1_MF8 }, // 5795
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x5, 0x1, PseudoVSUXSEG5EI8_V_M2_MF8 }, // 5796
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x5, 0x2, PseudoVSUXSEG5EI8_V_M4_MF8 }, // 5797
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x5, 0x3, PseudoVSUXSEG5EI8_V_M8_MF8 }, // 5798
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x5, 0x5, PseudoVSUXSEG5EI8_V_MF8_MF8 }, // 5799
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x5, 0x6, PseudoVSUXSEG5EI8_V_MF4_MF8 }, // 5800
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x5, 0x7, PseudoVSUXSEG5EI8_V_MF2_MF8 }, // 5801
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x6, 0x0, PseudoVSUXSEG5EI8_V_M1_MF4 }, // 5802
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x6, 0x1, PseudoVSUXSEG5EI8_V_M2_MF4 }, // 5803
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x6, 0x2, PseudoVSUXSEG5EI8_V_M4_MF4 }, // 5804
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x6, 0x3, PseudoVSUXSEG5EI8_V_M8_MF4 }, // 5805
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x6, 0x5, PseudoVSUXSEG5EI8_V_MF8_MF4 }, // 5806
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x6, 0x6, PseudoVSUXSEG5EI8_V_MF4_MF4 }, // 5807
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x6, 0x7, PseudoVSUXSEG5EI8_V_MF2_MF4 }, // 5808
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x7, 0x0, PseudoVSUXSEG5EI8_V_M1_MF2 }, // 5809
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x7, 0x1, PseudoVSUXSEG5EI8_V_M2_MF2 }, // 5810
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x7, 0x2, PseudoVSUXSEG5EI8_V_M4_MF2 }, // 5811
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x7, 0x3, PseudoVSUXSEG5EI8_V_M8_MF2 }, // 5812
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x7, 0x5, PseudoVSUXSEG5EI8_V_MF8_MF2 }, // 5813
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x7, 0x6, PseudoVSUXSEG5EI8_V_MF4_MF2 }, // 5814
  { Intrinsic::riscv_vsuxseg5, 0x8, 0x7, 0x7, PseudoVSUXSEG5EI8_V_MF2_MF2 }, // 5815
  { Intrinsic::riscv_vsuxseg5, 0x10, 0x0, 0x0, PseudoVSUXSEG5EI16_V_M1_M1 }, // 5816
  { Intrinsic::riscv_vsuxseg5, 0x10, 0x0, 0x1, PseudoVSUXSEG5EI16_V_M2_M1 }, // 5817
  { Intrinsic::riscv_vsuxseg5, 0x10, 0x0, 0x2, PseudoVSUXSEG5EI16_V_M4_M1 }, // 5818
  { Intrinsic::riscv_vsuxseg5, 0x10, 0x0, 0x3, PseudoVSUXSEG5EI16_V_M8_M1 }, // 5819
  { Intrinsic::riscv_vsuxseg5, 0x10, 0x0, 0x6, PseudoVSUXSEG5EI16_V_MF4_M1 }, // 5820
  { Intrinsic::riscv_vsuxseg5, 0x10, 0x0, 0x7, PseudoVSUXSEG5EI16_V_MF2_M1 }, // 5821
  { Intrinsic::riscv_vsuxseg5, 0x10, 0x5, 0x0, PseudoVSUXSEG5EI16_V_M1_MF8 }, // 5822
  { Intrinsic::riscv_vsuxseg5, 0x10, 0x5, 0x1, PseudoVSUXSEG5EI16_V_M2_MF8 }, // 5823
  { Intrinsic::riscv_vsuxseg5, 0x10, 0x5, 0x2, PseudoVSUXSEG5EI16_V_M4_MF8 }, // 5824
  { Intrinsic::riscv_vsuxseg5, 0x10, 0x5, 0x3, PseudoVSUXSEG5EI16_V_M8_MF8 }, // 5825
  { Intrinsic::riscv_vsuxseg5, 0x10, 0x5, 0x6, PseudoVSUXSEG5EI16_V_MF4_MF8 }, // 5826
  { Intrinsic::riscv_vsuxseg5, 0x10, 0x5, 0x7, PseudoVSUXSEG5EI16_V_MF2_MF8 }, // 5827
  { Intrinsic::riscv_vsuxseg5, 0x10, 0x6, 0x0, PseudoVSUXSEG5EI16_V_M1_MF4 }, // 5828
  { Intrinsic::riscv_vsuxseg5, 0x10, 0x6, 0x1, PseudoVSUXSEG5EI16_V_M2_MF4 }, // 5829
  { Intrinsic::riscv_vsuxseg5, 0x10, 0x6, 0x2, PseudoVSUXSEG5EI16_V_M4_MF4 }, // 5830
  { Intrinsic::riscv_vsuxseg5, 0x10, 0x6, 0x3, PseudoVSUXSEG5EI16_V_M8_MF4 }, // 5831
  { Intrinsic::riscv_vsuxseg5, 0x10, 0x6, 0x6, PseudoVSUXSEG5EI16_V_MF4_MF4 }, // 5832
  { Intrinsic::riscv_vsuxseg5, 0x10, 0x6, 0x7, PseudoVSUXSEG5EI16_V_MF2_MF4 }, // 5833
  { Intrinsic::riscv_vsuxseg5, 0x10, 0x7, 0x0, PseudoVSUXSEG5EI16_V_M1_MF2 }, // 5834
  { Intrinsic::riscv_vsuxseg5, 0x10, 0x7, 0x1, PseudoVSUXSEG5EI16_V_M2_MF2 }, // 5835
  { Intrinsic::riscv_vsuxseg5, 0x10, 0x7, 0x2, PseudoVSUXSEG5EI16_V_M4_MF2 }, // 5836
  { Intrinsic::riscv_vsuxseg5, 0x10, 0x7, 0x3, PseudoVSUXSEG5EI16_V_M8_MF2 }, // 5837
  { Intrinsic::riscv_vsuxseg5, 0x10, 0x7, 0x6, PseudoVSUXSEG5EI16_V_MF4_MF2 }, // 5838
  { Intrinsic::riscv_vsuxseg5, 0x10, 0x7, 0x7, PseudoVSUXSEG5EI16_V_MF2_MF2 }, // 5839
  { Intrinsic::riscv_vsuxseg5, 0x20, 0x0, 0x0, PseudoVSUXSEG5EI32_V_M1_M1 }, // 5840
  { Intrinsic::riscv_vsuxseg5, 0x20, 0x0, 0x1, PseudoVSUXSEG5EI32_V_M2_M1 }, // 5841
  { Intrinsic::riscv_vsuxseg5, 0x20, 0x0, 0x2, PseudoVSUXSEG5EI32_V_M4_M1 }, // 5842
  { Intrinsic::riscv_vsuxseg5, 0x20, 0x0, 0x3, PseudoVSUXSEG5EI32_V_M8_M1 }, // 5843
  { Intrinsic::riscv_vsuxseg5, 0x20, 0x0, 0x7, PseudoVSUXSEG5EI32_V_MF2_M1 }, // 5844
  { Intrinsic::riscv_vsuxseg5, 0x20, 0x5, 0x0, PseudoVSUXSEG5EI32_V_M1_MF8 }, // 5845
  { Intrinsic::riscv_vsuxseg5, 0x20, 0x5, 0x1, PseudoVSUXSEG5EI32_V_M2_MF8 }, // 5846
  { Intrinsic::riscv_vsuxseg5, 0x20, 0x5, 0x2, PseudoVSUXSEG5EI32_V_M4_MF8 }, // 5847
  { Intrinsic::riscv_vsuxseg5, 0x20, 0x5, 0x3, PseudoVSUXSEG5EI32_V_M8_MF8 }, // 5848
  { Intrinsic::riscv_vsuxseg5, 0x20, 0x5, 0x7, PseudoVSUXSEG5EI32_V_MF2_MF8 }, // 5849
  { Intrinsic::riscv_vsuxseg5, 0x20, 0x6, 0x0, PseudoVSUXSEG5EI32_V_M1_MF4 }, // 5850
  { Intrinsic::riscv_vsuxseg5, 0x20, 0x6, 0x1, PseudoVSUXSEG5EI32_V_M2_MF4 }, // 5851
  { Intrinsic::riscv_vsuxseg5, 0x20, 0x6, 0x2, PseudoVSUXSEG5EI32_V_M4_MF4 }, // 5852
  { Intrinsic::riscv_vsuxseg5, 0x20, 0x6, 0x3, PseudoVSUXSEG5EI32_V_M8_MF4 }, // 5853
  { Intrinsic::riscv_vsuxseg5, 0x20, 0x6, 0x7, PseudoVSUXSEG5EI32_V_MF2_MF4 }, // 5854
  { Intrinsic::riscv_vsuxseg5, 0x20, 0x7, 0x0, PseudoVSUXSEG5EI32_V_M1_MF2 }, // 5855
  { Intrinsic::riscv_vsuxseg5, 0x20, 0x7, 0x1, PseudoVSUXSEG5EI32_V_M2_MF2 }, // 5856
  { Intrinsic::riscv_vsuxseg5, 0x20, 0x7, 0x2, PseudoVSUXSEG5EI32_V_M4_MF2 }, // 5857
  { Intrinsic::riscv_vsuxseg5, 0x20, 0x7, 0x3, PseudoVSUXSEG5EI32_V_M8_MF2 }, // 5858
  { Intrinsic::riscv_vsuxseg5, 0x20, 0x7, 0x7, PseudoVSUXSEG5EI32_V_MF2_MF2 }, // 5859
  { Intrinsic::riscv_vsuxseg5, 0x40, 0x0, 0x0, PseudoVSUXSEG5EI64_V_M1_M1 }, // 5860
  { Intrinsic::riscv_vsuxseg5, 0x40, 0x0, 0x1, PseudoVSUXSEG5EI64_V_M2_M1 }, // 5861
  { Intrinsic::riscv_vsuxseg5, 0x40, 0x0, 0x2, PseudoVSUXSEG5EI64_V_M4_M1 }, // 5862
  { Intrinsic::riscv_vsuxseg5, 0x40, 0x0, 0x3, PseudoVSUXSEG5EI64_V_M8_M1 }, // 5863
  { Intrinsic::riscv_vsuxseg5, 0x40, 0x5, 0x0, PseudoVSUXSEG5EI64_V_M1_MF8 }, // 5864
  { Intrinsic::riscv_vsuxseg5, 0x40, 0x5, 0x1, PseudoVSUXSEG5EI64_V_M2_MF8 }, // 5865
  { Intrinsic::riscv_vsuxseg5, 0x40, 0x5, 0x2, PseudoVSUXSEG5EI64_V_M4_MF8 }, // 5866
  { Intrinsic::riscv_vsuxseg5, 0x40, 0x5, 0x3, PseudoVSUXSEG5EI64_V_M8_MF8 }, // 5867
  { Intrinsic::riscv_vsuxseg5, 0x40, 0x6, 0x0, PseudoVSUXSEG5EI64_V_M1_MF4 }, // 5868
  { Intrinsic::riscv_vsuxseg5, 0x40, 0x6, 0x1, PseudoVSUXSEG5EI64_V_M2_MF4 }, // 5869
  { Intrinsic::riscv_vsuxseg5, 0x40, 0x6, 0x2, PseudoVSUXSEG5EI64_V_M4_MF4 }, // 5870
  { Intrinsic::riscv_vsuxseg5, 0x40, 0x6, 0x3, PseudoVSUXSEG5EI64_V_M8_MF4 }, // 5871
  { Intrinsic::riscv_vsuxseg5, 0x40, 0x7, 0x0, PseudoVSUXSEG5EI64_V_M1_MF2 }, // 5872
  { Intrinsic::riscv_vsuxseg5, 0x40, 0x7, 0x1, PseudoVSUXSEG5EI64_V_M2_MF2 }, // 5873
  { Intrinsic::riscv_vsuxseg5, 0x40, 0x7, 0x2, PseudoVSUXSEG5EI64_V_M4_MF2 }, // 5874
  { Intrinsic::riscv_vsuxseg5, 0x40, 0x7, 0x3, PseudoVSUXSEG5EI64_V_M8_MF2 }, // 5875
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x0, 0x0, PseudoVSUXSEG5EI8_V_M1_M1_MASK }, // 5876
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x0, 0x1, PseudoVSUXSEG5EI8_V_M2_M1_MASK }, // 5877
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x0, 0x2, PseudoVSUXSEG5EI8_V_M4_M1_MASK }, // 5878
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x0, 0x3, PseudoVSUXSEG5EI8_V_M8_M1_MASK }, // 5879
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x0, 0x5, PseudoVSUXSEG5EI8_V_MF8_M1_MASK }, // 5880
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x0, 0x6, PseudoVSUXSEG5EI8_V_MF4_M1_MASK }, // 5881
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x0, 0x7, PseudoVSUXSEG5EI8_V_MF2_M1_MASK }, // 5882
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x5, 0x0, PseudoVSUXSEG5EI8_V_M1_MF8_MASK }, // 5883
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x5, 0x1, PseudoVSUXSEG5EI8_V_M2_MF8_MASK }, // 5884
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x5, 0x2, PseudoVSUXSEG5EI8_V_M4_MF8_MASK }, // 5885
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x5, 0x3, PseudoVSUXSEG5EI8_V_M8_MF8_MASK }, // 5886
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x5, 0x5, PseudoVSUXSEG5EI8_V_MF8_MF8_MASK }, // 5887
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x5, 0x6, PseudoVSUXSEG5EI8_V_MF4_MF8_MASK }, // 5888
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x5, 0x7, PseudoVSUXSEG5EI8_V_MF2_MF8_MASK }, // 5889
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x6, 0x0, PseudoVSUXSEG5EI8_V_M1_MF4_MASK }, // 5890
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x6, 0x1, PseudoVSUXSEG5EI8_V_M2_MF4_MASK }, // 5891
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x6, 0x2, PseudoVSUXSEG5EI8_V_M4_MF4_MASK }, // 5892
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x6, 0x3, PseudoVSUXSEG5EI8_V_M8_MF4_MASK }, // 5893
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x6, 0x5, PseudoVSUXSEG5EI8_V_MF8_MF4_MASK }, // 5894
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x6, 0x6, PseudoVSUXSEG5EI8_V_MF4_MF4_MASK }, // 5895
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x6, 0x7, PseudoVSUXSEG5EI8_V_MF2_MF4_MASK }, // 5896
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x7, 0x0, PseudoVSUXSEG5EI8_V_M1_MF2_MASK }, // 5897
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x7, 0x1, PseudoVSUXSEG5EI8_V_M2_MF2_MASK }, // 5898
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x7, 0x2, PseudoVSUXSEG5EI8_V_M4_MF2_MASK }, // 5899
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x7, 0x3, PseudoVSUXSEG5EI8_V_M8_MF2_MASK }, // 5900
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x7, 0x5, PseudoVSUXSEG5EI8_V_MF8_MF2_MASK }, // 5901
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x7, 0x6, PseudoVSUXSEG5EI8_V_MF4_MF2_MASK }, // 5902
  { Intrinsic::riscv_vsuxseg5_mask, 0x8, 0x7, 0x7, PseudoVSUXSEG5EI8_V_MF2_MF2_MASK }, // 5903
  { Intrinsic::riscv_vsuxseg5_mask, 0x10, 0x0, 0x0, PseudoVSUXSEG5EI16_V_M1_M1_MASK }, // 5904
  { Intrinsic::riscv_vsuxseg5_mask, 0x10, 0x0, 0x1, PseudoVSUXSEG5EI16_V_M2_M1_MASK }, // 5905
  { Intrinsic::riscv_vsuxseg5_mask, 0x10, 0x0, 0x2, PseudoVSUXSEG5EI16_V_M4_M1_MASK }, // 5906
  { Intrinsic::riscv_vsuxseg5_mask, 0x10, 0x0, 0x3, PseudoVSUXSEG5EI16_V_M8_M1_MASK }, // 5907
  { Intrinsic::riscv_vsuxseg5_mask, 0x10, 0x0, 0x6, PseudoVSUXSEG5EI16_V_MF4_M1_MASK }, // 5908
  { Intrinsic::riscv_vsuxseg5_mask, 0x10, 0x0, 0x7, PseudoVSUXSEG5EI16_V_MF2_M1_MASK }, // 5909
  { Intrinsic::riscv_vsuxseg5_mask, 0x10, 0x5, 0x0, PseudoVSUXSEG5EI16_V_M1_MF8_MASK }, // 5910
  { Intrinsic::riscv_vsuxseg5_mask, 0x10, 0x5, 0x1, PseudoVSUXSEG5EI16_V_M2_MF8_MASK }, // 5911
  { Intrinsic::riscv_vsuxseg5_mask, 0x10, 0x5, 0x2, PseudoVSUXSEG5EI16_V_M4_MF8_MASK }, // 5912
  { Intrinsic::riscv_vsuxseg5_mask, 0x10, 0x5, 0x3, PseudoVSUXSEG5EI16_V_M8_MF8_MASK }, // 5913
  { Intrinsic::riscv_vsuxseg5_mask, 0x10, 0x5, 0x6, PseudoVSUXSEG5EI16_V_MF4_MF8_MASK }, // 5914
  { Intrinsic::riscv_vsuxseg5_mask, 0x10, 0x5, 0x7, PseudoVSUXSEG5EI16_V_MF2_MF8_MASK }, // 5915
  { Intrinsic::riscv_vsuxseg5_mask, 0x10, 0x6, 0x0, PseudoVSUXSEG5EI16_V_M1_MF4_MASK }, // 5916
  { Intrinsic::riscv_vsuxseg5_mask, 0x10, 0x6, 0x1, PseudoVSUXSEG5EI16_V_M2_MF4_MASK }, // 5917
  { Intrinsic::riscv_vsuxseg5_mask, 0x10, 0x6, 0x2, PseudoVSUXSEG5EI16_V_M4_MF4_MASK }, // 5918
  { Intrinsic::riscv_vsuxseg5_mask, 0x10, 0x6, 0x3, PseudoVSUXSEG5EI16_V_M8_MF4_MASK }, // 5919
  { Intrinsic::riscv_vsuxseg5_mask, 0x10, 0x6, 0x6, PseudoVSUXSEG5EI16_V_MF4_MF4_MASK }, // 5920
  { Intrinsic::riscv_vsuxseg5_mask, 0x10, 0x6, 0x7, PseudoVSUXSEG5EI16_V_MF2_MF4_MASK }, // 5921
  { Intrinsic::riscv_vsuxseg5_mask, 0x10, 0x7, 0x0, PseudoVSUXSEG5EI16_V_M1_MF2_MASK }, // 5922
  { Intrinsic::riscv_vsuxseg5_mask, 0x10, 0x7, 0x1, PseudoVSUXSEG5EI16_V_M2_MF2_MASK }, // 5923
  { Intrinsic::riscv_vsuxseg5_mask, 0x10, 0x7, 0x2, PseudoVSUXSEG5EI16_V_M4_MF2_MASK }, // 5924
  { Intrinsic::riscv_vsuxseg5_mask, 0x10, 0x7, 0x3, PseudoVSUXSEG5EI16_V_M8_MF2_MASK }, // 5925
  { Intrinsic::riscv_vsuxseg5_mask, 0x10, 0x7, 0x6, PseudoVSUXSEG5EI16_V_MF4_MF2_MASK }, // 5926
  { Intrinsic::riscv_vsuxseg5_mask, 0x10, 0x7, 0x7, PseudoVSUXSEG5EI16_V_MF2_MF2_MASK }, // 5927
  { Intrinsic::riscv_vsuxseg5_mask, 0x20, 0x0, 0x0, PseudoVSUXSEG5EI32_V_M1_M1_MASK }, // 5928
  { Intrinsic::riscv_vsuxseg5_mask, 0x20, 0x0, 0x1, PseudoVSUXSEG5EI32_V_M2_M1_MASK }, // 5929
  { Intrinsic::riscv_vsuxseg5_mask, 0x20, 0x0, 0x2, PseudoVSUXSEG5EI32_V_M4_M1_MASK }, // 5930
  { Intrinsic::riscv_vsuxseg5_mask, 0x20, 0x0, 0x3, PseudoVSUXSEG5EI32_V_M8_M1_MASK }, // 5931
  { Intrinsic::riscv_vsuxseg5_mask, 0x20, 0x0, 0x7, PseudoVSUXSEG5EI32_V_MF2_M1_MASK }, // 5932
  { Intrinsic::riscv_vsuxseg5_mask, 0x20, 0x5, 0x0, PseudoVSUXSEG5EI32_V_M1_MF8_MASK }, // 5933
  { Intrinsic::riscv_vsuxseg5_mask, 0x20, 0x5, 0x1, PseudoVSUXSEG5EI32_V_M2_MF8_MASK }, // 5934
  { Intrinsic::riscv_vsuxseg5_mask, 0x20, 0x5, 0x2, PseudoVSUXSEG5EI32_V_M4_MF8_MASK }, // 5935
  { Intrinsic::riscv_vsuxseg5_mask, 0x20, 0x5, 0x3, PseudoVSUXSEG5EI32_V_M8_MF8_MASK }, // 5936
  { Intrinsic::riscv_vsuxseg5_mask, 0x20, 0x5, 0x7, PseudoVSUXSEG5EI32_V_MF2_MF8_MASK }, // 5937
  { Intrinsic::riscv_vsuxseg5_mask, 0x20, 0x6, 0x0, PseudoVSUXSEG5EI32_V_M1_MF4_MASK }, // 5938
  { Intrinsic::riscv_vsuxseg5_mask, 0x20, 0x6, 0x1, PseudoVSUXSEG5EI32_V_M2_MF4_MASK }, // 5939
  { Intrinsic::riscv_vsuxseg5_mask, 0x20, 0x6, 0x2, PseudoVSUXSEG5EI32_V_M4_MF4_MASK }, // 5940
  { Intrinsic::riscv_vsuxseg5_mask, 0x20, 0x6, 0x3, PseudoVSUXSEG5EI32_V_M8_MF4_MASK }, // 5941
  { Intrinsic::riscv_vsuxseg5_mask, 0x20, 0x6, 0x7, PseudoVSUXSEG5EI32_V_MF2_MF4_MASK }, // 5942
  { Intrinsic::riscv_vsuxseg5_mask, 0x20, 0x7, 0x0, PseudoVSUXSEG5EI32_V_M1_MF2_MASK }, // 5943
  { Intrinsic::riscv_vsuxseg5_mask, 0x20, 0x7, 0x1, PseudoVSUXSEG5EI32_V_M2_MF2_MASK }, // 5944
  { Intrinsic::riscv_vsuxseg5_mask, 0x20, 0x7, 0x2, PseudoVSUXSEG5EI32_V_M4_MF2_MASK }, // 5945
  { Intrinsic::riscv_vsuxseg5_mask, 0x20, 0x7, 0x3, PseudoVSUXSEG5EI32_V_M8_MF2_MASK }, // 5946
  { Intrinsic::riscv_vsuxseg5_mask, 0x20, 0x7, 0x7, PseudoVSUXSEG5EI32_V_MF2_MF2_MASK }, // 5947
  { Intrinsic::riscv_vsuxseg5_mask, 0x40, 0x0, 0x0, PseudoVSUXSEG5EI64_V_M1_M1_MASK }, // 5948
  { Intrinsic::riscv_vsuxseg5_mask, 0x40, 0x0, 0x1, PseudoVSUXSEG5EI64_V_M2_M1_MASK }, // 5949
  { Intrinsic::riscv_vsuxseg5_mask, 0x40, 0x0, 0x2, PseudoVSUXSEG5EI64_V_M4_M1_MASK }, // 5950
  { Intrinsic::riscv_vsuxseg5_mask, 0x40, 0x0, 0x3, PseudoVSUXSEG5EI64_V_M8_M1_MASK }, // 5951
  { Intrinsic::riscv_vsuxseg5_mask, 0x40, 0x5, 0x0, PseudoVSUXSEG5EI64_V_M1_MF8_MASK }, // 5952
  { Intrinsic::riscv_vsuxseg5_mask, 0x40, 0x5, 0x1, PseudoVSUXSEG5EI64_V_M2_MF8_MASK }, // 5953
  { Intrinsic::riscv_vsuxseg5_mask, 0x40, 0x5, 0x2, PseudoVSUXSEG5EI64_V_M4_MF8_MASK }, // 5954
  { Intrinsic::riscv_vsuxseg5_mask, 0x40, 0x5, 0x3, PseudoVSUXSEG5EI64_V_M8_MF8_MASK }, // 5955
  { Intrinsic::riscv_vsuxseg5_mask, 0x40, 0x6, 0x0, PseudoVSUXSEG5EI64_V_M1_MF4_MASK }, // 5956
  { Intrinsic::riscv_vsuxseg5_mask, 0x40, 0x6, 0x1, PseudoVSUXSEG5EI64_V_M2_MF4_MASK }, // 5957
  { Intrinsic::riscv_vsuxseg5_mask, 0x40, 0x6, 0x2, PseudoVSUXSEG5EI64_V_M4_MF4_MASK }, // 5958
  { Intrinsic::riscv_vsuxseg5_mask, 0x40, 0x6, 0x3, PseudoVSUXSEG5EI64_V_M8_MF4_MASK }, // 5959
  { Intrinsic::riscv_vsuxseg5_mask, 0x40, 0x7, 0x0, PseudoVSUXSEG5EI64_V_M1_MF2_MASK }, // 5960
  { Intrinsic::riscv_vsuxseg5_mask, 0x40, 0x7, 0x1, PseudoVSUXSEG5EI64_V_M2_MF2_MASK }, // 5961
  { Intrinsic::riscv_vsuxseg5_mask, 0x40, 0x7, 0x2, PseudoVSUXSEG5EI64_V_M4_MF2_MASK }, // 5962
  { Intrinsic::riscv_vsuxseg5_mask, 0x40, 0x7, 0x3, PseudoVSUXSEG5EI64_V_M8_MF2_MASK }, // 5963
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x0, 0x0, PseudoVSUXSEG6EI8_V_M1_M1 }, // 5964
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x0, 0x1, PseudoVSUXSEG6EI8_V_M2_M1 }, // 5965
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x0, 0x2, PseudoVSUXSEG6EI8_V_M4_M1 }, // 5966
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x0, 0x3, PseudoVSUXSEG6EI8_V_M8_M1 }, // 5967
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x0, 0x5, PseudoVSUXSEG6EI8_V_MF8_M1 }, // 5968
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x0, 0x6, PseudoVSUXSEG6EI8_V_MF4_M1 }, // 5969
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x0, 0x7, PseudoVSUXSEG6EI8_V_MF2_M1 }, // 5970
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x5, 0x0, PseudoVSUXSEG6EI8_V_M1_MF8 }, // 5971
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x5, 0x1, PseudoVSUXSEG6EI8_V_M2_MF8 }, // 5972
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x5, 0x2, PseudoVSUXSEG6EI8_V_M4_MF8 }, // 5973
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x5, 0x3, PseudoVSUXSEG6EI8_V_M8_MF8 }, // 5974
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x5, 0x5, PseudoVSUXSEG6EI8_V_MF8_MF8 }, // 5975
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x5, 0x6, PseudoVSUXSEG6EI8_V_MF4_MF8 }, // 5976
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x5, 0x7, PseudoVSUXSEG6EI8_V_MF2_MF8 }, // 5977
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x6, 0x0, PseudoVSUXSEG6EI8_V_M1_MF4 }, // 5978
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x6, 0x1, PseudoVSUXSEG6EI8_V_M2_MF4 }, // 5979
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x6, 0x2, PseudoVSUXSEG6EI8_V_M4_MF4 }, // 5980
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x6, 0x3, PseudoVSUXSEG6EI8_V_M8_MF4 }, // 5981
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x6, 0x5, PseudoVSUXSEG6EI8_V_MF8_MF4 }, // 5982
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x6, 0x6, PseudoVSUXSEG6EI8_V_MF4_MF4 }, // 5983
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x6, 0x7, PseudoVSUXSEG6EI8_V_MF2_MF4 }, // 5984
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x7, 0x0, PseudoVSUXSEG6EI8_V_M1_MF2 }, // 5985
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x7, 0x1, PseudoVSUXSEG6EI8_V_M2_MF2 }, // 5986
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x7, 0x2, PseudoVSUXSEG6EI8_V_M4_MF2 }, // 5987
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x7, 0x3, PseudoVSUXSEG6EI8_V_M8_MF2 }, // 5988
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x7, 0x5, PseudoVSUXSEG6EI8_V_MF8_MF2 }, // 5989
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x7, 0x6, PseudoVSUXSEG6EI8_V_MF4_MF2 }, // 5990
  { Intrinsic::riscv_vsuxseg6, 0x8, 0x7, 0x7, PseudoVSUXSEG6EI8_V_MF2_MF2 }, // 5991
  { Intrinsic::riscv_vsuxseg6, 0x10, 0x0, 0x0, PseudoVSUXSEG6EI16_V_M1_M1 }, // 5992
  { Intrinsic::riscv_vsuxseg6, 0x10, 0x0, 0x1, PseudoVSUXSEG6EI16_V_M2_M1 }, // 5993
  { Intrinsic::riscv_vsuxseg6, 0x10, 0x0, 0x2, PseudoVSUXSEG6EI16_V_M4_M1 }, // 5994
  { Intrinsic::riscv_vsuxseg6, 0x10, 0x0, 0x3, PseudoVSUXSEG6EI16_V_M8_M1 }, // 5995
  { Intrinsic::riscv_vsuxseg6, 0x10, 0x0, 0x6, PseudoVSUXSEG6EI16_V_MF4_M1 }, // 5996
  { Intrinsic::riscv_vsuxseg6, 0x10, 0x0, 0x7, PseudoVSUXSEG6EI16_V_MF2_M1 }, // 5997
  { Intrinsic::riscv_vsuxseg6, 0x10, 0x5, 0x0, PseudoVSUXSEG6EI16_V_M1_MF8 }, // 5998
  { Intrinsic::riscv_vsuxseg6, 0x10, 0x5, 0x1, PseudoVSUXSEG6EI16_V_M2_MF8 }, // 5999
  { Intrinsic::riscv_vsuxseg6, 0x10, 0x5, 0x2, PseudoVSUXSEG6EI16_V_M4_MF8 }, // 6000
  { Intrinsic::riscv_vsuxseg6, 0x10, 0x5, 0x3, PseudoVSUXSEG6EI16_V_M8_MF8 }, // 6001
  { Intrinsic::riscv_vsuxseg6, 0x10, 0x5, 0x6, PseudoVSUXSEG6EI16_V_MF4_MF8 }, // 6002
  { Intrinsic::riscv_vsuxseg6, 0x10, 0x5, 0x7, PseudoVSUXSEG6EI16_V_MF2_MF8 }, // 6003
  { Intrinsic::riscv_vsuxseg6, 0x10, 0x6, 0x0, PseudoVSUXSEG6EI16_V_M1_MF4 }, // 6004
  { Intrinsic::riscv_vsuxseg6, 0x10, 0x6, 0x1, PseudoVSUXSEG6EI16_V_M2_MF4 }, // 6005
  { Intrinsic::riscv_vsuxseg6, 0x10, 0x6, 0x2, PseudoVSUXSEG6EI16_V_M4_MF4 }, // 6006
  { Intrinsic::riscv_vsuxseg6, 0x10, 0x6, 0x3, PseudoVSUXSEG6EI16_V_M8_MF4 }, // 6007
  { Intrinsic::riscv_vsuxseg6, 0x10, 0x6, 0x6, PseudoVSUXSEG6EI16_V_MF4_MF4 }, // 6008
  { Intrinsic::riscv_vsuxseg6, 0x10, 0x6, 0x7, PseudoVSUXSEG6EI16_V_MF2_MF4 }, // 6009
  { Intrinsic::riscv_vsuxseg6, 0x10, 0x7, 0x0, PseudoVSUXSEG6EI16_V_M1_MF2 }, // 6010
  { Intrinsic::riscv_vsuxseg6, 0x10, 0x7, 0x1, PseudoVSUXSEG6EI16_V_M2_MF2 }, // 6011
  { Intrinsic::riscv_vsuxseg6, 0x10, 0x7, 0x2, PseudoVSUXSEG6EI16_V_M4_MF2 }, // 6012
  { Intrinsic::riscv_vsuxseg6, 0x10, 0x7, 0x3, PseudoVSUXSEG6EI16_V_M8_MF2 }, // 6013
  { Intrinsic::riscv_vsuxseg6, 0x10, 0x7, 0x6, PseudoVSUXSEG6EI16_V_MF4_MF2 }, // 6014
  { Intrinsic::riscv_vsuxseg6, 0x10, 0x7, 0x7, PseudoVSUXSEG6EI16_V_MF2_MF2 }, // 6015
  { Intrinsic::riscv_vsuxseg6, 0x20, 0x0, 0x0, PseudoVSUXSEG6EI32_V_M1_M1 }, // 6016
  { Intrinsic::riscv_vsuxseg6, 0x20, 0x0, 0x1, PseudoVSUXSEG6EI32_V_M2_M1 }, // 6017
  { Intrinsic::riscv_vsuxseg6, 0x20, 0x0, 0x2, PseudoVSUXSEG6EI32_V_M4_M1 }, // 6018
  { Intrinsic::riscv_vsuxseg6, 0x20, 0x0, 0x3, PseudoVSUXSEG6EI32_V_M8_M1 }, // 6019
  { Intrinsic::riscv_vsuxseg6, 0x20, 0x0, 0x7, PseudoVSUXSEG6EI32_V_MF2_M1 }, // 6020
  { Intrinsic::riscv_vsuxseg6, 0x20, 0x5, 0x0, PseudoVSUXSEG6EI32_V_M1_MF8 }, // 6021
  { Intrinsic::riscv_vsuxseg6, 0x20, 0x5, 0x1, PseudoVSUXSEG6EI32_V_M2_MF8 }, // 6022
  { Intrinsic::riscv_vsuxseg6, 0x20, 0x5, 0x2, PseudoVSUXSEG6EI32_V_M4_MF8 }, // 6023
  { Intrinsic::riscv_vsuxseg6, 0x20, 0x5, 0x3, PseudoVSUXSEG6EI32_V_M8_MF8 }, // 6024
  { Intrinsic::riscv_vsuxseg6, 0x20, 0x5, 0x7, PseudoVSUXSEG6EI32_V_MF2_MF8 }, // 6025
  { Intrinsic::riscv_vsuxseg6, 0x20, 0x6, 0x0, PseudoVSUXSEG6EI32_V_M1_MF4 }, // 6026
  { Intrinsic::riscv_vsuxseg6, 0x20, 0x6, 0x1, PseudoVSUXSEG6EI32_V_M2_MF4 }, // 6027
  { Intrinsic::riscv_vsuxseg6, 0x20, 0x6, 0x2, PseudoVSUXSEG6EI32_V_M4_MF4 }, // 6028
  { Intrinsic::riscv_vsuxseg6, 0x20, 0x6, 0x3, PseudoVSUXSEG6EI32_V_M8_MF4 }, // 6029
  { Intrinsic::riscv_vsuxseg6, 0x20, 0x6, 0x7, PseudoVSUXSEG6EI32_V_MF2_MF4 }, // 6030
  { Intrinsic::riscv_vsuxseg6, 0x20, 0x7, 0x0, PseudoVSUXSEG6EI32_V_M1_MF2 }, // 6031
  { Intrinsic::riscv_vsuxseg6, 0x20, 0x7, 0x1, PseudoVSUXSEG6EI32_V_M2_MF2 }, // 6032
  { Intrinsic::riscv_vsuxseg6, 0x20, 0x7, 0x2, PseudoVSUXSEG6EI32_V_M4_MF2 }, // 6033
  { Intrinsic::riscv_vsuxseg6, 0x20, 0x7, 0x3, PseudoVSUXSEG6EI32_V_M8_MF2 }, // 6034
  { Intrinsic::riscv_vsuxseg6, 0x20, 0x7, 0x7, PseudoVSUXSEG6EI32_V_MF2_MF2 }, // 6035
  { Intrinsic::riscv_vsuxseg6, 0x40, 0x0, 0x0, PseudoVSUXSEG6EI64_V_M1_M1 }, // 6036
  { Intrinsic::riscv_vsuxseg6, 0x40, 0x0, 0x1, PseudoVSUXSEG6EI64_V_M2_M1 }, // 6037
  { Intrinsic::riscv_vsuxseg6, 0x40, 0x0, 0x2, PseudoVSUXSEG6EI64_V_M4_M1 }, // 6038
  { Intrinsic::riscv_vsuxseg6, 0x40, 0x0, 0x3, PseudoVSUXSEG6EI64_V_M8_M1 }, // 6039
  { Intrinsic::riscv_vsuxseg6, 0x40, 0x5, 0x0, PseudoVSUXSEG6EI64_V_M1_MF8 }, // 6040
  { Intrinsic::riscv_vsuxseg6, 0x40, 0x5, 0x1, PseudoVSUXSEG6EI64_V_M2_MF8 }, // 6041
  { Intrinsic::riscv_vsuxseg6, 0x40, 0x5, 0x2, PseudoVSUXSEG6EI64_V_M4_MF8 }, // 6042
  { Intrinsic::riscv_vsuxseg6, 0x40, 0x5, 0x3, PseudoVSUXSEG6EI64_V_M8_MF8 }, // 6043
  { Intrinsic::riscv_vsuxseg6, 0x40, 0x6, 0x0, PseudoVSUXSEG6EI64_V_M1_MF4 }, // 6044
  { Intrinsic::riscv_vsuxseg6, 0x40, 0x6, 0x1, PseudoVSUXSEG6EI64_V_M2_MF4 }, // 6045
  { Intrinsic::riscv_vsuxseg6, 0x40, 0x6, 0x2, PseudoVSUXSEG6EI64_V_M4_MF4 }, // 6046
  { Intrinsic::riscv_vsuxseg6, 0x40, 0x6, 0x3, PseudoVSUXSEG6EI64_V_M8_MF4 }, // 6047
  { Intrinsic::riscv_vsuxseg6, 0x40, 0x7, 0x0, PseudoVSUXSEG6EI64_V_M1_MF2 }, // 6048
  { Intrinsic::riscv_vsuxseg6, 0x40, 0x7, 0x1, PseudoVSUXSEG6EI64_V_M2_MF2 }, // 6049
  { Intrinsic::riscv_vsuxseg6, 0x40, 0x7, 0x2, PseudoVSUXSEG6EI64_V_M4_MF2 }, // 6050
  { Intrinsic::riscv_vsuxseg6, 0x40, 0x7, 0x3, PseudoVSUXSEG6EI64_V_M8_MF2 }, // 6051
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x0, 0x0, PseudoVSUXSEG6EI8_V_M1_M1_MASK }, // 6052
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x0, 0x1, PseudoVSUXSEG6EI8_V_M2_M1_MASK }, // 6053
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x0, 0x2, PseudoVSUXSEG6EI8_V_M4_M1_MASK }, // 6054
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x0, 0x3, PseudoVSUXSEG6EI8_V_M8_M1_MASK }, // 6055
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x0, 0x5, PseudoVSUXSEG6EI8_V_MF8_M1_MASK }, // 6056
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x0, 0x6, PseudoVSUXSEG6EI8_V_MF4_M1_MASK }, // 6057
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x0, 0x7, PseudoVSUXSEG6EI8_V_MF2_M1_MASK }, // 6058
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x5, 0x0, PseudoVSUXSEG6EI8_V_M1_MF8_MASK }, // 6059
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x5, 0x1, PseudoVSUXSEG6EI8_V_M2_MF8_MASK }, // 6060
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x5, 0x2, PseudoVSUXSEG6EI8_V_M4_MF8_MASK }, // 6061
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x5, 0x3, PseudoVSUXSEG6EI8_V_M8_MF8_MASK }, // 6062
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x5, 0x5, PseudoVSUXSEG6EI8_V_MF8_MF8_MASK }, // 6063
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x5, 0x6, PseudoVSUXSEG6EI8_V_MF4_MF8_MASK }, // 6064
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x5, 0x7, PseudoVSUXSEG6EI8_V_MF2_MF8_MASK }, // 6065
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x6, 0x0, PseudoVSUXSEG6EI8_V_M1_MF4_MASK }, // 6066
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x6, 0x1, PseudoVSUXSEG6EI8_V_M2_MF4_MASK }, // 6067
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x6, 0x2, PseudoVSUXSEG6EI8_V_M4_MF4_MASK }, // 6068
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x6, 0x3, PseudoVSUXSEG6EI8_V_M8_MF4_MASK }, // 6069
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x6, 0x5, PseudoVSUXSEG6EI8_V_MF8_MF4_MASK }, // 6070
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x6, 0x6, PseudoVSUXSEG6EI8_V_MF4_MF4_MASK }, // 6071
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x6, 0x7, PseudoVSUXSEG6EI8_V_MF2_MF4_MASK }, // 6072
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x7, 0x0, PseudoVSUXSEG6EI8_V_M1_MF2_MASK }, // 6073
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x7, 0x1, PseudoVSUXSEG6EI8_V_M2_MF2_MASK }, // 6074
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x7, 0x2, PseudoVSUXSEG6EI8_V_M4_MF2_MASK }, // 6075
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x7, 0x3, PseudoVSUXSEG6EI8_V_M8_MF2_MASK }, // 6076
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x7, 0x5, PseudoVSUXSEG6EI8_V_MF8_MF2_MASK }, // 6077
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x7, 0x6, PseudoVSUXSEG6EI8_V_MF4_MF2_MASK }, // 6078
  { Intrinsic::riscv_vsuxseg6_mask, 0x8, 0x7, 0x7, PseudoVSUXSEG6EI8_V_MF2_MF2_MASK }, // 6079
  { Intrinsic::riscv_vsuxseg6_mask, 0x10, 0x0, 0x0, PseudoVSUXSEG6EI16_V_M1_M1_MASK }, // 6080
  { Intrinsic::riscv_vsuxseg6_mask, 0x10, 0x0, 0x1, PseudoVSUXSEG6EI16_V_M2_M1_MASK }, // 6081
  { Intrinsic::riscv_vsuxseg6_mask, 0x10, 0x0, 0x2, PseudoVSUXSEG6EI16_V_M4_M1_MASK }, // 6082
  { Intrinsic::riscv_vsuxseg6_mask, 0x10, 0x0, 0x3, PseudoVSUXSEG6EI16_V_M8_M1_MASK }, // 6083
  { Intrinsic::riscv_vsuxseg6_mask, 0x10, 0x0, 0x6, PseudoVSUXSEG6EI16_V_MF4_M1_MASK }, // 6084
  { Intrinsic::riscv_vsuxseg6_mask, 0x10, 0x0, 0x7, PseudoVSUXSEG6EI16_V_MF2_M1_MASK }, // 6085
  { Intrinsic::riscv_vsuxseg6_mask, 0x10, 0x5, 0x0, PseudoVSUXSEG6EI16_V_M1_MF8_MASK }, // 6086
  { Intrinsic::riscv_vsuxseg6_mask, 0x10, 0x5, 0x1, PseudoVSUXSEG6EI16_V_M2_MF8_MASK }, // 6087
  { Intrinsic::riscv_vsuxseg6_mask, 0x10, 0x5, 0x2, PseudoVSUXSEG6EI16_V_M4_MF8_MASK }, // 6088
  { Intrinsic::riscv_vsuxseg6_mask, 0x10, 0x5, 0x3, PseudoVSUXSEG6EI16_V_M8_MF8_MASK }, // 6089
  { Intrinsic::riscv_vsuxseg6_mask, 0x10, 0x5, 0x6, PseudoVSUXSEG6EI16_V_MF4_MF8_MASK }, // 6090
  { Intrinsic::riscv_vsuxseg6_mask, 0x10, 0x5, 0x7, PseudoVSUXSEG6EI16_V_MF2_MF8_MASK }, // 6091
  { Intrinsic::riscv_vsuxseg6_mask, 0x10, 0x6, 0x0, PseudoVSUXSEG6EI16_V_M1_MF4_MASK }, // 6092
  { Intrinsic::riscv_vsuxseg6_mask, 0x10, 0x6, 0x1, PseudoVSUXSEG6EI16_V_M2_MF4_MASK }, // 6093
  { Intrinsic::riscv_vsuxseg6_mask, 0x10, 0x6, 0x2, PseudoVSUXSEG6EI16_V_M4_MF4_MASK }, // 6094
  { Intrinsic::riscv_vsuxseg6_mask, 0x10, 0x6, 0x3, PseudoVSUXSEG6EI16_V_M8_MF4_MASK }, // 6095
  { Intrinsic::riscv_vsuxseg6_mask, 0x10, 0x6, 0x6, PseudoVSUXSEG6EI16_V_MF4_MF4_MASK }, // 6096
  { Intrinsic::riscv_vsuxseg6_mask, 0x10, 0x6, 0x7, PseudoVSUXSEG6EI16_V_MF2_MF4_MASK }, // 6097
  { Intrinsic::riscv_vsuxseg6_mask, 0x10, 0x7, 0x0, PseudoVSUXSEG6EI16_V_M1_MF2_MASK }, // 6098
  { Intrinsic::riscv_vsuxseg6_mask, 0x10, 0x7, 0x1, PseudoVSUXSEG6EI16_V_M2_MF2_MASK }, // 6099
  { Intrinsic::riscv_vsuxseg6_mask, 0x10, 0x7, 0x2, PseudoVSUXSEG6EI16_V_M4_MF2_MASK }, // 6100
  { Intrinsic::riscv_vsuxseg6_mask, 0x10, 0x7, 0x3, PseudoVSUXSEG6EI16_V_M8_MF2_MASK }, // 6101
  { Intrinsic::riscv_vsuxseg6_mask, 0x10, 0x7, 0x6, PseudoVSUXSEG6EI16_V_MF4_MF2_MASK }, // 6102
  { Intrinsic::riscv_vsuxseg6_mask, 0x10, 0x7, 0x7, PseudoVSUXSEG6EI16_V_MF2_MF2_MASK }, // 6103
  { Intrinsic::riscv_vsuxseg6_mask, 0x20, 0x0, 0x0, PseudoVSUXSEG6EI32_V_M1_M1_MASK }, // 6104
  { Intrinsic::riscv_vsuxseg6_mask, 0x20, 0x0, 0x1, PseudoVSUXSEG6EI32_V_M2_M1_MASK }, // 6105
  { Intrinsic::riscv_vsuxseg6_mask, 0x20, 0x0, 0x2, PseudoVSUXSEG6EI32_V_M4_M1_MASK }, // 6106
  { Intrinsic::riscv_vsuxseg6_mask, 0x20, 0x0, 0x3, PseudoVSUXSEG6EI32_V_M8_M1_MASK }, // 6107
  { Intrinsic::riscv_vsuxseg6_mask, 0x20, 0x0, 0x7, PseudoVSUXSEG6EI32_V_MF2_M1_MASK }, // 6108
  { Intrinsic::riscv_vsuxseg6_mask, 0x20, 0x5, 0x0, PseudoVSUXSEG6EI32_V_M1_MF8_MASK }, // 6109
  { Intrinsic::riscv_vsuxseg6_mask, 0x20, 0x5, 0x1, PseudoVSUXSEG6EI32_V_M2_MF8_MASK }, // 6110
  { Intrinsic::riscv_vsuxseg6_mask, 0x20, 0x5, 0x2, PseudoVSUXSEG6EI32_V_M4_MF8_MASK }, // 6111
  { Intrinsic::riscv_vsuxseg6_mask, 0x20, 0x5, 0x3, PseudoVSUXSEG6EI32_V_M8_MF8_MASK }, // 6112
  { Intrinsic::riscv_vsuxseg6_mask, 0x20, 0x5, 0x7, PseudoVSUXSEG6EI32_V_MF2_MF8_MASK }, // 6113
  { Intrinsic::riscv_vsuxseg6_mask, 0x20, 0x6, 0x0, PseudoVSUXSEG6EI32_V_M1_MF4_MASK }, // 6114
  { Intrinsic::riscv_vsuxseg6_mask, 0x20, 0x6, 0x1, PseudoVSUXSEG6EI32_V_M2_MF4_MASK }, // 6115
  { Intrinsic::riscv_vsuxseg6_mask, 0x20, 0x6, 0x2, PseudoVSUXSEG6EI32_V_M4_MF4_MASK }, // 6116
  { Intrinsic::riscv_vsuxseg6_mask, 0x20, 0x6, 0x3, PseudoVSUXSEG6EI32_V_M8_MF4_MASK }, // 6117
  { Intrinsic::riscv_vsuxseg6_mask, 0x20, 0x6, 0x7, PseudoVSUXSEG6EI32_V_MF2_MF4_MASK }, // 6118
  { Intrinsic::riscv_vsuxseg6_mask, 0x20, 0x7, 0x0, PseudoVSUXSEG6EI32_V_M1_MF2_MASK }, // 6119
  { Intrinsic::riscv_vsuxseg6_mask, 0x20, 0x7, 0x1, PseudoVSUXSEG6EI32_V_M2_MF2_MASK }, // 6120
  { Intrinsic::riscv_vsuxseg6_mask, 0x20, 0x7, 0x2, PseudoVSUXSEG6EI32_V_M4_MF2_MASK }, // 6121
  { Intrinsic::riscv_vsuxseg6_mask, 0x20, 0x7, 0x3, PseudoVSUXSEG6EI32_V_M8_MF2_MASK }, // 6122
  { Intrinsic::riscv_vsuxseg6_mask, 0x20, 0x7, 0x7, PseudoVSUXSEG6EI32_V_MF2_MF2_MASK }, // 6123
  { Intrinsic::riscv_vsuxseg6_mask, 0x40, 0x0, 0x0, PseudoVSUXSEG6EI64_V_M1_M1_MASK }, // 6124
  { Intrinsic::riscv_vsuxseg6_mask, 0x40, 0x0, 0x1, PseudoVSUXSEG6EI64_V_M2_M1_MASK }, // 6125
  { Intrinsic::riscv_vsuxseg6_mask, 0x40, 0x0, 0x2, PseudoVSUXSEG6EI64_V_M4_M1_MASK }, // 6126
  { Intrinsic::riscv_vsuxseg6_mask, 0x40, 0x0, 0x3, PseudoVSUXSEG6EI64_V_M8_M1_MASK }, // 6127
  { Intrinsic::riscv_vsuxseg6_mask, 0x40, 0x5, 0x0, PseudoVSUXSEG6EI64_V_M1_MF8_MASK }, // 6128
  { Intrinsic::riscv_vsuxseg6_mask, 0x40, 0x5, 0x1, PseudoVSUXSEG6EI64_V_M2_MF8_MASK }, // 6129
  { Intrinsic::riscv_vsuxseg6_mask, 0x40, 0x5, 0x2, PseudoVSUXSEG6EI64_V_M4_MF8_MASK }, // 6130
  { Intrinsic::riscv_vsuxseg6_mask, 0x40, 0x5, 0x3, PseudoVSUXSEG6EI64_V_M8_MF8_MASK }, // 6131
  { Intrinsic::riscv_vsuxseg6_mask, 0x40, 0x6, 0x0, PseudoVSUXSEG6EI64_V_M1_MF4_MASK }, // 6132
  { Intrinsic::riscv_vsuxseg6_mask, 0x40, 0x6, 0x1, PseudoVSUXSEG6EI64_V_M2_MF4_MASK }, // 6133
  { Intrinsic::riscv_vsuxseg6_mask, 0x40, 0x6, 0x2, PseudoVSUXSEG6EI64_V_M4_MF4_MASK }, // 6134
  { Intrinsic::riscv_vsuxseg6_mask, 0x40, 0x6, 0x3, PseudoVSUXSEG6EI64_V_M8_MF4_MASK }, // 6135
  { Intrinsic::riscv_vsuxseg6_mask, 0x40, 0x7, 0x0, PseudoVSUXSEG6EI64_V_M1_MF2_MASK }, // 6136
  { Intrinsic::riscv_vsuxseg6_mask, 0x40, 0x7, 0x1, PseudoVSUXSEG6EI64_V_M2_MF2_MASK }, // 6137
  { Intrinsic::riscv_vsuxseg6_mask, 0x40, 0x7, 0x2, PseudoVSUXSEG6EI64_V_M4_MF2_MASK }, // 6138
  { Intrinsic::riscv_vsuxseg6_mask, 0x40, 0x7, 0x3, PseudoVSUXSEG6EI64_V_M8_MF2_MASK }, // 6139
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x0, 0x0, PseudoVSUXSEG7EI8_V_M1_M1 }, // 6140
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x0, 0x1, PseudoVSUXSEG7EI8_V_M2_M1 }, // 6141
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x0, 0x2, PseudoVSUXSEG7EI8_V_M4_M1 }, // 6142
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x0, 0x3, PseudoVSUXSEG7EI8_V_M8_M1 }, // 6143
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x0, 0x5, PseudoVSUXSEG7EI8_V_MF8_M1 }, // 6144
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x0, 0x6, PseudoVSUXSEG7EI8_V_MF4_M1 }, // 6145
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x0, 0x7, PseudoVSUXSEG7EI8_V_MF2_M1 }, // 6146
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x5, 0x0, PseudoVSUXSEG7EI8_V_M1_MF8 }, // 6147
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x5, 0x1, PseudoVSUXSEG7EI8_V_M2_MF8 }, // 6148
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x5, 0x2, PseudoVSUXSEG7EI8_V_M4_MF8 }, // 6149
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x5, 0x3, PseudoVSUXSEG7EI8_V_M8_MF8 }, // 6150
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x5, 0x5, PseudoVSUXSEG7EI8_V_MF8_MF8 }, // 6151
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x5, 0x6, PseudoVSUXSEG7EI8_V_MF4_MF8 }, // 6152
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x5, 0x7, PseudoVSUXSEG7EI8_V_MF2_MF8 }, // 6153
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x6, 0x0, PseudoVSUXSEG7EI8_V_M1_MF4 }, // 6154
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x6, 0x1, PseudoVSUXSEG7EI8_V_M2_MF4 }, // 6155
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x6, 0x2, PseudoVSUXSEG7EI8_V_M4_MF4 }, // 6156
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x6, 0x3, PseudoVSUXSEG7EI8_V_M8_MF4 }, // 6157
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x6, 0x5, PseudoVSUXSEG7EI8_V_MF8_MF4 }, // 6158
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x6, 0x6, PseudoVSUXSEG7EI8_V_MF4_MF4 }, // 6159
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x6, 0x7, PseudoVSUXSEG7EI8_V_MF2_MF4 }, // 6160
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x7, 0x0, PseudoVSUXSEG7EI8_V_M1_MF2 }, // 6161
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x7, 0x1, PseudoVSUXSEG7EI8_V_M2_MF2 }, // 6162
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x7, 0x2, PseudoVSUXSEG7EI8_V_M4_MF2 }, // 6163
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x7, 0x3, PseudoVSUXSEG7EI8_V_M8_MF2 }, // 6164
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x7, 0x5, PseudoVSUXSEG7EI8_V_MF8_MF2 }, // 6165
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x7, 0x6, PseudoVSUXSEG7EI8_V_MF4_MF2 }, // 6166
  { Intrinsic::riscv_vsuxseg7, 0x8, 0x7, 0x7, PseudoVSUXSEG7EI8_V_MF2_MF2 }, // 6167
  { Intrinsic::riscv_vsuxseg7, 0x10, 0x0, 0x0, PseudoVSUXSEG7EI16_V_M1_M1 }, // 6168
  { Intrinsic::riscv_vsuxseg7, 0x10, 0x0, 0x1, PseudoVSUXSEG7EI16_V_M2_M1 }, // 6169
  { Intrinsic::riscv_vsuxseg7, 0x10, 0x0, 0x2, PseudoVSUXSEG7EI16_V_M4_M1 }, // 6170
  { Intrinsic::riscv_vsuxseg7, 0x10, 0x0, 0x3, PseudoVSUXSEG7EI16_V_M8_M1 }, // 6171
  { Intrinsic::riscv_vsuxseg7, 0x10, 0x0, 0x6, PseudoVSUXSEG7EI16_V_MF4_M1 }, // 6172
  { Intrinsic::riscv_vsuxseg7, 0x10, 0x0, 0x7, PseudoVSUXSEG7EI16_V_MF2_M1 }, // 6173
  { Intrinsic::riscv_vsuxseg7, 0x10, 0x5, 0x0, PseudoVSUXSEG7EI16_V_M1_MF8 }, // 6174
  { Intrinsic::riscv_vsuxseg7, 0x10, 0x5, 0x1, PseudoVSUXSEG7EI16_V_M2_MF8 }, // 6175
  { Intrinsic::riscv_vsuxseg7, 0x10, 0x5, 0x2, PseudoVSUXSEG7EI16_V_M4_MF8 }, // 6176
  { Intrinsic::riscv_vsuxseg7, 0x10, 0x5, 0x3, PseudoVSUXSEG7EI16_V_M8_MF8 }, // 6177
  { Intrinsic::riscv_vsuxseg7, 0x10, 0x5, 0x6, PseudoVSUXSEG7EI16_V_MF4_MF8 }, // 6178
  { Intrinsic::riscv_vsuxseg7, 0x10, 0x5, 0x7, PseudoVSUXSEG7EI16_V_MF2_MF8 }, // 6179
  { Intrinsic::riscv_vsuxseg7, 0x10, 0x6, 0x0, PseudoVSUXSEG7EI16_V_M1_MF4 }, // 6180
  { Intrinsic::riscv_vsuxseg7, 0x10, 0x6, 0x1, PseudoVSUXSEG7EI16_V_M2_MF4 }, // 6181
  { Intrinsic::riscv_vsuxseg7, 0x10, 0x6, 0x2, PseudoVSUXSEG7EI16_V_M4_MF4 }, // 6182
  { Intrinsic::riscv_vsuxseg7, 0x10, 0x6, 0x3, PseudoVSUXSEG7EI16_V_M8_MF4 }, // 6183
  { Intrinsic::riscv_vsuxseg7, 0x10, 0x6, 0x6, PseudoVSUXSEG7EI16_V_MF4_MF4 }, // 6184
  { Intrinsic::riscv_vsuxseg7, 0x10, 0x6, 0x7, PseudoVSUXSEG7EI16_V_MF2_MF4 }, // 6185
  { Intrinsic::riscv_vsuxseg7, 0x10, 0x7, 0x0, PseudoVSUXSEG7EI16_V_M1_MF2 }, // 6186
  { Intrinsic::riscv_vsuxseg7, 0x10, 0x7, 0x1, PseudoVSUXSEG7EI16_V_M2_MF2 }, // 6187
  { Intrinsic::riscv_vsuxseg7, 0x10, 0x7, 0x2, PseudoVSUXSEG7EI16_V_M4_MF2 }, // 6188
  { Intrinsic::riscv_vsuxseg7, 0x10, 0x7, 0x3, PseudoVSUXSEG7EI16_V_M8_MF2 }, // 6189
  { Intrinsic::riscv_vsuxseg7, 0x10, 0x7, 0x6, PseudoVSUXSEG7EI16_V_MF4_MF2 }, // 6190
  { Intrinsic::riscv_vsuxseg7, 0x10, 0x7, 0x7, PseudoVSUXSEG7EI16_V_MF2_MF2 }, // 6191
  { Intrinsic::riscv_vsuxseg7, 0x20, 0x0, 0x0, PseudoVSUXSEG7EI32_V_M1_M1 }, // 6192
  { Intrinsic::riscv_vsuxseg7, 0x20, 0x0, 0x1, PseudoVSUXSEG7EI32_V_M2_M1 }, // 6193
  { Intrinsic::riscv_vsuxseg7, 0x20, 0x0, 0x2, PseudoVSUXSEG7EI32_V_M4_M1 }, // 6194
  { Intrinsic::riscv_vsuxseg7, 0x20, 0x0, 0x3, PseudoVSUXSEG7EI32_V_M8_M1 }, // 6195
  { Intrinsic::riscv_vsuxseg7, 0x20, 0x0, 0x7, PseudoVSUXSEG7EI32_V_MF2_M1 }, // 6196
  { Intrinsic::riscv_vsuxseg7, 0x20, 0x5, 0x0, PseudoVSUXSEG7EI32_V_M1_MF8 }, // 6197
  { Intrinsic::riscv_vsuxseg7, 0x20, 0x5, 0x1, PseudoVSUXSEG7EI32_V_M2_MF8 }, // 6198
  { Intrinsic::riscv_vsuxseg7, 0x20, 0x5, 0x2, PseudoVSUXSEG7EI32_V_M4_MF8 }, // 6199
  { Intrinsic::riscv_vsuxseg7, 0x20, 0x5, 0x3, PseudoVSUXSEG7EI32_V_M8_MF8 }, // 6200
  { Intrinsic::riscv_vsuxseg7, 0x20, 0x5, 0x7, PseudoVSUXSEG7EI32_V_MF2_MF8 }, // 6201
  { Intrinsic::riscv_vsuxseg7, 0x20, 0x6, 0x0, PseudoVSUXSEG7EI32_V_M1_MF4 }, // 6202
  { Intrinsic::riscv_vsuxseg7, 0x20, 0x6, 0x1, PseudoVSUXSEG7EI32_V_M2_MF4 }, // 6203
  { Intrinsic::riscv_vsuxseg7, 0x20, 0x6, 0x2, PseudoVSUXSEG7EI32_V_M4_MF4 }, // 6204
  { Intrinsic::riscv_vsuxseg7, 0x20, 0x6, 0x3, PseudoVSUXSEG7EI32_V_M8_MF4 }, // 6205
  { Intrinsic::riscv_vsuxseg7, 0x20, 0x6, 0x7, PseudoVSUXSEG7EI32_V_MF2_MF4 }, // 6206
  { Intrinsic::riscv_vsuxseg7, 0x20, 0x7, 0x0, PseudoVSUXSEG7EI32_V_M1_MF2 }, // 6207
  { Intrinsic::riscv_vsuxseg7, 0x20, 0x7, 0x1, PseudoVSUXSEG7EI32_V_M2_MF2 }, // 6208
  { Intrinsic::riscv_vsuxseg7, 0x20, 0x7, 0x2, PseudoVSUXSEG7EI32_V_M4_MF2 }, // 6209
  { Intrinsic::riscv_vsuxseg7, 0x20, 0x7, 0x3, PseudoVSUXSEG7EI32_V_M8_MF2 }, // 6210
  { Intrinsic::riscv_vsuxseg7, 0x20, 0x7, 0x7, PseudoVSUXSEG7EI32_V_MF2_MF2 }, // 6211
  { Intrinsic::riscv_vsuxseg7, 0x40, 0x0, 0x0, PseudoVSUXSEG7EI64_V_M1_M1 }, // 6212
  { Intrinsic::riscv_vsuxseg7, 0x40, 0x0, 0x1, PseudoVSUXSEG7EI64_V_M2_M1 }, // 6213
  { Intrinsic::riscv_vsuxseg7, 0x40, 0x0, 0x2, PseudoVSUXSEG7EI64_V_M4_M1 }, // 6214
  { Intrinsic::riscv_vsuxseg7, 0x40, 0x0, 0x3, PseudoVSUXSEG7EI64_V_M8_M1 }, // 6215
  { Intrinsic::riscv_vsuxseg7, 0x40, 0x5, 0x0, PseudoVSUXSEG7EI64_V_M1_MF8 }, // 6216
  { Intrinsic::riscv_vsuxseg7, 0x40, 0x5, 0x1, PseudoVSUXSEG7EI64_V_M2_MF8 }, // 6217
  { Intrinsic::riscv_vsuxseg7, 0x40, 0x5, 0x2, PseudoVSUXSEG7EI64_V_M4_MF8 }, // 6218
  { Intrinsic::riscv_vsuxseg7, 0x40, 0x5, 0x3, PseudoVSUXSEG7EI64_V_M8_MF8 }, // 6219
  { Intrinsic::riscv_vsuxseg7, 0x40, 0x6, 0x0, PseudoVSUXSEG7EI64_V_M1_MF4 }, // 6220
  { Intrinsic::riscv_vsuxseg7, 0x40, 0x6, 0x1, PseudoVSUXSEG7EI64_V_M2_MF4 }, // 6221
  { Intrinsic::riscv_vsuxseg7, 0x40, 0x6, 0x2, PseudoVSUXSEG7EI64_V_M4_MF4 }, // 6222
  { Intrinsic::riscv_vsuxseg7, 0x40, 0x6, 0x3, PseudoVSUXSEG7EI64_V_M8_MF4 }, // 6223
  { Intrinsic::riscv_vsuxseg7, 0x40, 0x7, 0x0, PseudoVSUXSEG7EI64_V_M1_MF2 }, // 6224
  { Intrinsic::riscv_vsuxseg7, 0x40, 0x7, 0x1, PseudoVSUXSEG7EI64_V_M2_MF2 }, // 6225
  { Intrinsic::riscv_vsuxseg7, 0x40, 0x7, 0x2, PseudoVSUXSEG7EI64_V_M4_MF2 }, // 6226
  { Intrinsic::riscv_vsuxseg7, 0x40, 0x7, 0x3, PseudoVSUXSEG7EI64_V_M8_MF2 }, // 6227
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x0, 0x0, PseudoVSUXSEG7EI8_V_M1_M1_MASK }, // 6228
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x0, 0x1, PseudoVSUXSEG7EI8_V_M2_M1_MASK }, // 6229
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x0, 0x2, PseudoVSUXSEG7EI8_V_M4_M1_MASK }, // 6230
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x0, 0x3, PseudoVSUXSEG7EI8_V_M8_M1_MASK }, // 6231
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x0, 0x5, PseudoVSUXSEG7EI8_V_MF8_M1_MASK }, // 6232
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x0, 0x6, PseudoVSUXSEG7EI8_V_MF4_M1_MASK }, // 6233
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x0, 0x7, PseudoVSUXSEG7EI8_V_MF2_M1_MASK }, // 6234
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x5, 0x0, PseudoVSUXSEG7EI8_V_M1_MF8_MASK }, // 6235
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x5, 0x1, PseudoVSUXSEG7EI8_V_M2_MF8_MASK }, // 6236
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x5, 0x2, PseudoVSUXSEG7EI8_V_M4_MF8_MASK }, // 6237
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x5, 0x3, PseudoVSUXSEG7EI8_V_M8_MF8_MASK }, // 6238
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x5, 0x5, PseudoVSUXSEG7EI8_V_MF8_MF8_MASK }, // 6239
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x5, 0x6, PseudoVSUXSEG7EI8_V_MF4_MF8_MASK }, // 6240
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x5, 0x7, PseudoVSUXSEG7EI8_V_MF2_MF8_MASK }, // 6241
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x6, 0x0, PseudoVSUXSEG7EI8_V_M1_MF4_MASK }, // 6242
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x6, 0x1, PseudoVSUXSEG7EI8_V_M2_MF4_MASK }, // 6243
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x6, 0x2, PseudoVSUXSEG7EI8_V_M4_MF4_MASK }, // 6244
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x6, 0x3, PseudoVSUXSEG7EI8_V_M8_MF4_MASK }, // 6245
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x6, 0x5, PseudoVSUXSEG7EI8_V_MF8_MF4_MASK }, // 6246
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x6, 0x6, PseudoVSUXSEG7EI8_V_MF4_MF4_MASK }, // 6247
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x6, 0x7, PseudoVSUXSEG7EI8_V_MF2_MF4_MASK }, // 6248
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x7, 0x0, PseudoVSUXSEG7EI8_V_M1_MF2_MASK }, // 6249
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x7, 0x1, PseudoVSUXSEG7EI8_V_M2_MF2_MASK }, // 6250
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x7, 0x2, PseudoVSUXSEG7EI8_V_M4_MF2_MASK }, // 6251
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x7, 0x3, PseudoVSUXSEG7EI8_V_M8_MF2_MASK }, // 6252
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x7, 0x5, PseudoVSUXSEG7EI8_V_MF8_MF2_MASK }, // 6253
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x7, 0x6, PseudoVSUXSEG7EI8_V_MF4_MF2_MASK }, // 6254
  { Intrinsic::riscv_vsuxseg7_mask, 0x8, 0x7, 0x7, PseudoVSUXSEG7EI8_V_MF2_MF2_MASK }, // 6255
  { Intrinsic::riscv_vsuxseg7_mask, 0x10, 0x0, 0x0, PseudoVSUXSEG7EI16_V_M1_M1_MASK }, // 6256
  { Intrinsic::riscv_vsuxseg7_mask, 0x10, 0x0, 0x1, PseudoVSUXSEG7EI16_V_M2_M1_MASK }, // 6257
  { Intrinsic::riscv_vsuxseg7_mask, 0x10, 0x0, 0x2, PseudoVSUXSEG7EI16_V_M4_M1_MASK }, // 6258
  { Intrinsic::riscv_vsuxseg7_mask, 0x10, 0x0, 0x3, PseudoVSUXSEG7EI16_V_M8_M1_MASK }, // 6259
  { Intrinsic::riscv_vsuxseg7_mask, 0x10, 0x0, 0x6, PseudoVSUXSEG7EI16_V_MF4_M1_MASK }, // 6260
  { Intrinsic::riscv_vsuxseg7_mask, 0x10, 0x0, 0x7, PseudoVSUXSEG7EI16_V_MF2_M1_MASK }, // 6261
  { Intrinsic::riscv_vsuxseg7_mask, 0x10, 0x5, 0x0, PseudoVSUXSEG7EI16_V_M1_MF8_MASK }, // 6262
  { Intrinsic::riscv_vsuxseg7_mask, 0x10, 0x5, 0x1, PseudoVSUXSEG7EI16_V_M2_MF8_MASK }, // 6263
  { Intrinsic::riscv_vsuxseg7_mask, 0x10, 0x5, 0x2, PseudoVSUXSEG7EI16_V_M4_MF8_MASK }, // 6264
  { Intrinsic::riscv_vsuxseg7_mask, 0x10, 0x5, 0x3, PseudoVSUXSEG7EI16_V_M8_MF8_MASK }, // 6265
  { Intrinsic::riscv_vsuxseg7_mask, 0x10, 0x5, 0x6, PseudoVSUXSEG7EI16_V_MF4_MF8_MASK }, // 6266
  { Intrinsic::riscv_vsuxseg7_mask, 0x10, 0x5, 0x7, PseudoVSUXSEG7EI16_V_MF2_MF8_MASK }, // 6267
  { Intrinsic::riscv_vsuxseg7_mask, 0x10, 0x6, 0x0, PseudoVSUXSEG7EI16_V_M1_MF4_MASK }, // 6268
  { Intrinsic::riscv_vsuxseg7_mask, 0x10, 0x6, 0x1, PseudoVSUXSEG7EI16_V_M2_MF4_MASK }, // 6269
  { Intrinsic::riscv_vsuxseg7_mask, 0x10, 0x6, 0x2, PseudoVSUXSEG7EI16_V_M4_MF4_MASK }, // 6270
  { Intrinsic::riscv_vsuxseg7_mask, 0x10, 0x6, 0x3, PseudoVSUXSEG7EI16_V_M8_MF4_MASK }, // 6271
  { Intrinsic::riscv_vsuxseg7_mask, 0x10, 0x6, 0x6, PseudoVSUXSEG7EI16_V_MF4_MF4_MASK }, // 6272
  { Intrinsic::riscv_vsuxseg7_mask, 0x10, 0x6, 0x7, PseudoVSUXSEG7EI16_V_MF2_MF4_MASK }, // 6273
  { Intrinsic::riscv_vsuxseg7_mask, 0x10, 0x7, 0x0, PseudoVSUXSEG7EI16_V_M1_MF2_MASK }, // 6274
  { Intrinsic::riscv_vsuxseg7_mask, 0x10, 0x7, 0x1, PseudoVSUXSEG7EI16_V_M2_MF2_MASK }, // 6275
  { Intrinsic::riscv_vsuxseg7_mask, 0x10, 0x7, 0x2, PseudoVSUXSEG7EI16_V_M4_MF2_MASK }, // 6276
  { Intrinsic::riscv_vsuxseg7_mask, 0x10, 0x7, 0x3, PseudoVSUXSEG7EI16_V_M8_MF2_MASK }, // 6277
  { Intrinsic::riscv_vsuxseg7_mask, 0x10, 0x7, 0x6, PseudoVSUXSEG7EI16_V_MF4_MF2_MASK }, // 6278
  { Intrinsic::riscv_vsuxseg7_mask, 0x10, 0x7, 0x7, PseudoVSUXSEG7EI16_V_MF2_MF2_MASK }, // 6279
  { Intrinsic::riscv_vsuxseg7_mask, 0x20, 0x0, 0x0, PseudoVSUXSEG7EI32_V_M1_M1_MASK }, // 6280
  { Intrinsic::riscv_vsuxseg7_mask, 0x20, 0x0, 0x1, PseudoVSUXSEG7EI32_V_M2_M1_MASK }, // 6281
  { Intrinsic::riscv_vsuxseg7_mask, 0x20, 0x0, 0x2, PseudoVSUXSEG7EI32_V_M4_M1_MASK }, // 6282
  { Intrinsic::riscv_vsuxseg7_mask, 0x20, 0x0, 0x3, PseudoVSUXSEG7EI32_V_M8_M1_MASK }, // 6283
  { Intrinsic::riscv_vsuxseg7_mask, 0x20, 0x0, 0x7, PseudoVSUXSEG7EI32_V_MF2_M1_MASK }, // 6284
  { Intrinsic::riscv_vsuxseg7_mask, 0x20, 0x5, 0x0, PseudoVSUXSEG7EI32_V_M1_MF8_MASK }, // 6285
  { Intrinsic::riscv_vsuxseg7_mask, 0x20, 0x5, 0x1, PseudoVSUXSEG7EI32_V_M2_MF8_MASK }, // 6286
  { Intrinsic::riscv_vsuxseg7_mask, 0x20, 0x5, 0x2, PseudoVSUXSEG7EI32_V_M4_MF8_MASK }, // 6287
  { Intrinsic::riscv_vsuxseg7_mask, 0x20, 0x5, 0x3, PseudoVSUXSEG7EI32_V_M8_MF8_MASK }, // 6288
  { Intrinsic::riscv_vsuxseg7_mask, 0x20, 0x5, 0x7, PseudoVSUXSEG7EI32_V_MF2_MF8_MASK }, // 6289
  { Intrinsic::riscv_vsuxseg7_mask, 0x20, 0x6, 0x0, PseudoVSUXSEG7EI32_V_M1_MF4_MASK }, // 6290
  { Intrinsic::riscv_vsuxseg7_mask, 0x20, 0x6, 0x1, PseudoVSUXSEG7EI32_V_M2_MF4_MASK }, // 6291
  { Intrinsic::riscv_vsuxseg7_mask, 0x20, 0x6, 0x2, PseudoVSUXSEG7EI32_V_M4_MF4_MASK }, // 6292
  { Intrinsic::riscv_vsuxseg7_mask, 0x20, 0x6, 0x3, PseudoVSUXSEG7EI32_V_M8_MF4_MASK }, // 6293
  { Intrinsic::riscv_vsuxseg7_mask, 0x20, 0x6, 0x7, PseudoVSUXSEG7EI32_V_MF2_MF4_MASK }, // 6294
  { Intrinsic::riscv_vsuxseg7_mask, 0x20, 0x7, 0x0, PseudoVSUXSEG7EI32_V_M1_MF2_MASK }, // 6295
  { Intrinsic::riscv_vsuxseg7_mask, 0x20, 0x7, 0x1, PseudoVSUXSEG7EI32_V_M2_MF2_MASK }, // 6296
  { Intrinsic::riscv_vsuxseg7_mask, 0x20, 0x7, 0x2, PseudoVSUXSEG7EI32_V_M4_MF2_MASK }, // 6297
  { Intrinsic::riscv_vsuxseg7_mask, 0x20, 0x7, 0x3, PseudoVSUXSEG7EI32_V_M8_MF2_MASK }, // 6298
  { Intrinsic::riscv_vsuxseg7_mask, 0x20, 0x7, 0x7, PseudoVSUXSEG7EI32_V_MF2_MF2_MASK }, // 6299
  { Intrinsic::riscv_vsuxseg7_mask, 0x40, 0x0, 0x0, PseudoVSUXSEG7EI64_V_M1_M1_MASK }, // 6300
  { Intrinsic::riscv_vsuxseg7_mask, 0x40, 0x0, 0x1, PseudoVSUXSEG7EI64_V_M2_M1_MASK }, // 6301
  { Intrinsic::riscv_vsuxseg7_mask, 0x40, 0x0, 0x2, PseudoVSUXSEG7EI64_V_M4_M1_MASK }, // 6302
  { Intrinsic::riscv_vsuxseg7_mask, 0x40, 0x0, 0x3, PseudoVSUXSEG7EI64_V_M8_M1_MASK }, // 6303
  { Intrinsic::riscv_vsuxseg7_mask, 0x40, 0x5, 0x0, PseudoVSUXSEG7EI64_V_M1_MF8_MASK }, // 6304
  { Intrinsic::riscv_vsuxseg7_mask, 0x40, 0x5, 0x1, PseudoVSUXSEG7EI64_V_M2_MF8_MASK }, // 6305
  { Intrinsic::riscv_vsuxseg7_mask, 0x40, 0x5, 0x2, PseudoVSUXSEG7EI64_V_M4_MF8_MASK }, // 6306
  { Intrinsic::riscv_vsuxseg7_mask, 0x40, 0x5, 0x3, PseudoVSUXSEG7EI64_V_M8_MF8_MASK }, // 6307
  { Intrinsic::riscv_vsuxseg7_mask, 0x40, 0x6, 0x0, PseudoVSUXSEG7EI64_V_M1_MF4_MASK }, // 6308
  { Intrinsic::riscv_vsuxseg7_mask, 0x40, 0x6, 0x1, PseudoVSUXSEG7EI64_V_M2_MF4_MASK }, // 6309
  { Intrinsic::riscv_vsuxseg7_mask, 0x40, 0x6, 0x2, PseudoVSUXSEG7EI64_V_M4_MF4_MASK }, // 6310
  { Intrinsic::riscv_vsuxseg7_mask, 0x40, 0x6, 0x3, PseudoVSUXSEG7EI64_V_M8_MF4_MASK }, // 6311
  { Intrinsic::riscv_vsuxseg7_mask, 0x40, 0x7, 0x0, PseudoVSUXSEG7EI64_V_M1_MF2_MASK }, // 6312
  { Intrinsic::riscv_vsuxseg7_mask, 0x40, 0x7, 0x1, PseudoVSUXSEG7EI64_V_M2_MF2_MASK }, // 6313
  { Intrinsic::riscv_vsuxseg7_mask, 0x40, 0x7, 0x2, PseudoVSUXSEG7EI64_V_M4_MF2_MASK }, // 6314
  { Intrinsic::riscv_vsuxseg7_mask, 0x40, 0x7, 0x3, PseudoVSUXSEG7EI64_V_M8_MF2_MASK }, // 6315
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x0, 0x0, PseudoVSUXSEG8EI8_V_M1_M1 }, // 6316
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x0, 0x1, PseudoVSUXSEG8EI8_V_M2_M1 }, // 6317
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x0, 0x2, PseudoVSUXSEG8EI8_V_M4_M1 }, // 6318
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x0, 0x3, PseudoVSUXSEG8EI8_V_M8_M1 }, // 6319
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x0, 0x5, PseudoVSUXSEG8EI8_V_MF8_M1 }, // 6320
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x0, 0x6, PseudoVSUXSEG8EI8_V_MF4_M1 }, // 6321
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x0, 0x7, PseudoVSUXSEG8EI8_V_MF2_M1 }, // 6322
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x5, 0x0, PseudoVSUXSEG8EI8_V_M1_MF8 }, // 6323
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x5, 0x1, PseudoVSUXSEG8EI8_V_M2_MF8 }, // 6324
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x5, 0x2, PseudoVSUXSEG8EI8_V_M4_MF8 }, // 6325
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x5, 0x3, PseudoVSUXSEG8EI8_V_M8_MF8 }, // 6326
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x5, 0x5, PseudoVSUXSEG8EI8_V_MF8_MF8 }, // 6327
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x5, 0x6, PseudoVSUXSEG8EI8_V_MF4_MF8 }, // 6328
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x5, 0x7, PseudoVSUXSEG8EI8_V_MF2_MF8 }, // 6329
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x6, 0x0, PseudoVSUXSEG8EI8_V_M1_MF4 }, // 6330
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x6, 0x1, PseudoVSUXSEG8EI8_V_M2_MF4 }, // 6331
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x6, 0x2, PseudoVSUXSEG8EI8_V_M4_MF4 }, // 6332
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x6, 0x3, PseudoVSUXSEG8EI8_V_M8_MF4 }, // 6333
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x6, 0x5, PseudoVSUXSEG8EI8_V_MF8_MF4 }, // 6334
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x6, 0x6, PseudoVSUXSEG8EI8_V_MF4_MF4 }, // 6335
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x6, 0x7, PseudoVSUXSEG8EI8_V_MF2_MF4 }, // 6336
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x7, 0x0, PseudoVSUXSEG8EI8_V_M1_MF2 }, // 6337
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x7, 0x1, PseudoVSUXSEG8EI8_V_M2_MF2 }, // 6338
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x7, 0x2, PseudoVSUXSEG8EI8_V_M4_MF2 }, // 6339
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x7, 0x3, PseudoVSUXSEG8EI8_V_M8_MF2 }, // 6340
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x7, 0x5, PseudoVSUXSEG8EI8_V_MF8_MF2 }, // 6341
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x7, 0x6, PseudoVSUXSEG8EI8_V_MF4_MF2 }, // 6342
  { Intrinsic::riscv_vsuxseg8, 0x8, 0x7, 0x7, PseudoVSUXSEG8EI8_V_MF2_MF2 }, // 6343
  { Intrinsic::riscv_vsuxseg8, 0x10, 0x0, 0x0, PseudoVSUXSEG8EI16_V_M1_M1 }, // 6344
  { Intrinsic::riscv_vsuxseg8, 0x10, 0x0, 0x1, PseudoVSUXSEG8EI16_V_M2_M1 }, // 6345
  { Intrinsic::riscv_vsuxseg8, 0x10, 0x0, 0x2, PseudoVSUXSEG8EI16_V_M4_M1 }, // 6346
  { Intrinsic::riscv_vsuxseg8, 0x10, 0x0, 0x3, PseudoVSUXSEG8EI16_V_M8_M1 }, // 6347
  { Intrinsic::riscv_vsuxseg8, 0x10, 0x0, 0x6, PseudoVSUXSEG8EI16_V_MF4_M1 }, // 6348
  { Intrinsic::riscv_vsuxseg8, 0x10, 0x0, 0x7, PseudoVSUXSEG8EI16_V_MF2_M1 }, // 6349
  { Intrinsic::riscv_vsuxseg8, 0x10, 0x5, 0x0, PseudoVSUXSEG8EI16_V_M1_MF8 }, // 6350
  { Intrinsic::riscv_vsuxseg8, 0x10, 0x5, 0x1, PseudoVSUXSEG8EI16_V_M2_MF8 }, // 6351
  { Intrinsic::riscv_vsuxseg8, 0x10, 0x5, 0x2, PseudoVSUXSEG8EI16_V_M4_MF8 }, // 6352
  { Intrinsic::riscv_vsuxseg8, 0x10, 0x5, 0x3, PseudoVSUXSEG8EI16_V_M8_MF8 }, // 6353
  { Intrinsic::riscv_vsuxseg8, 0x10, 0x5, 0x6, PseudoVSUXSEG8EI16_V_MF4_MF8 }, // 6354
  { Intrinsic::riscv_vsuxseg8, 0x10, 0x5, 0x7, PseudoVSUXSEG8EI16_V_MF2_MF8 }, // 6355
  { Intrinsic::riscv_vsuxseg8, 0x10, 0x6, 0x0, PseudoVSUXSEG8EI16_V_M1_MF4 }, // 6356
  { Intrinsic::riscv_vsuxseg8, 0x10, 0x6, 0x1, PseudoVSUXSEG8EI16_V_M2_MF4 }, // 6357
  { Intrinsic::riscv_vsuxseg8, 0x10, 0x6, 0x2, PseudoVSUXSEG8EI16_V_M4_MF4 }, // 6358
  { Intrinsic::riscv_vsuxseg8, 0x10, 0x6, 0x3, PseudoVSUXSEG8EI16_V_M8_MF4 }, // 6359
  { Intrinsic::riscv_vsuxseg8, 0x10, 0x6, 0x6, PseudoVSUXSEG8EI16_V_MF4_MF4 }, // 6360
  { Intrinsic::riscv_vsuxseg8, 0x10, 0x6, 0x7, PseudoVSUXSEG8EI16_V_MF2_MF4 }, // 6361
  { Intrinsic::riscv_vsuxseg8, 0x10, 0x7, 0x0, PseudoVSUXSEG8EI16_V_M1_MF2 }, // 6362
  { Intrinsic::riscv_vsuxseg8, 0x10, 0x7, 0x1, PseudoVSUXSEG8EI16_V_M2_MF2 }, // 6363
  { Intrinsic::riscv_vsuxseg8, 0x10, 0x7, 0x2, PseudoVSUXSEG8EI16_V_M4_MF2 }, // 6364
  { Intrinsic::riscv_vsuxseg8, 0x10, 0x7, 0x3, PseudoVSUXSEG8EI16_V_M8_MF2 }, // 6365
  { Intrinsic::riscv_vsuxseg8, 0x10, 0x7, 0x6, PseudoVSUXSEG8EI16_V_MF4_MF2 }, // 6366
  { Intrinsic::riscv_vsuxseg8, 0x10, 0x7, 0x7, PseudoVSUXSEG8EI16_V_MF2_MF2 }, // 6367
  { Intrinsic::riscv_vsuxseg8, 0x20, 0x0, 0x0, PseudoVSUXSEG8EI32_V_M1_M1 }, // 6368
  { Intrinsic::riscv_vsuxseg8, 0x20, 0x0, 0x1, PseudoVSUXSEG8EI32_V_M2_M1 }, // 6369
  { Intrinsic::riscv_vsuxseg8, 0x20, 0x0, 0x2, PseudoVSUXSEG8EI32_V_M4_M1 }, // 6370
  { Intrinsic::riscv_vsuxseg8, 0x20, 0x0, 0x3, PseudoVSUXSEG8EI32_V_M8_M1 }, // 6371
  { Intrinsic::riscv_vsuxseg8, 0x20, 0x0, 0x7, PseudoVSUXSEG8EI32_V_MF2_M1 }, // 6372
  { Intrinsic::riscv_vsuxseg8, 0x20, 0x5, 0x0, PseudoVSUXSEG8EI32_V_M1_MF8 }, // 6373
  { Intrinsic::riscv_vsuxseg8, 0x20, 0x5, 0x1, PseudoVSUXSEG8EI32_V_M2_MF8 }, // 6374
  { Intrinsic::riscv_vsuxseg8, 0x20, 0x5, 0x2, PseudoVSUXSEG8EI32_V_M4_MF8 }, // 6375
  { Intrinsic::riscv_vsuxseg8, 0x20, 0x5, 0x3, PseudoVSUXSEG8EI32_V_M8_MF8 }, // 6376
  { Intrinsic::riscv_vsuxseg8, 0x20, 0x5, 0x7, PseudoVSUXSEG8EI32_V_MF2_MF8 }, // 6377
  { Intrinsic::riscv_vsuxseg8, 0x20, 0x6, 0x0, PseudoVSUXSEG8EI32_V_M1_MF4 }, // 6378
  { Intrinsic::riscv_vsuxseg8, 0x20, 0x6, 0x1, PseudoVSUXSEG8EI32_V_M2_MF4 }, // 6379
  { Intrinsic::riscv_vsuxseg8, 0x20, 0x6, 0x2, PseudoVSUXSEG8EI32_V_M4_MF4 }, // 6380
  { Intrinsic::riscv_vsuxseg8, 0x20, 0x6, 0x3, PseudoVSUXSEG8EI32_V_M8_MF4 }, // 6381
  { Intrinsic::riscv_vsuxseg8, 0x20, 0x6, 0x7, PseudoVSUXSEG8EI32_V_MF2_MF4 }, // 6382
  { Intrinsic::riscv_vsuxseg8, 0x20, 0x7, 0x0, PseudoVSUXSEG8EI32_V_M1_MF2 }, // 6383
  { Intrinsic::riscv_vsuxseg8, 0x20, 0x7, 0x1, PseudoVSUXSEG8EI32_V_M2_MF2 }, // 6384
  { Intrinsic::riscv_vsuxseg8, 0x20, 0x7, 0x2, PseudoVSUXSEG8EI32_V_M4_MF2 }, // 6385
  { Intrinsic::riscv_vsuxseg8, 0x20, 0x7, 0x3, PseudoVSUXSEG8EI32_V_M8_MF2 }, // 6386
  { Intrinsic::riscv_vsuxseg8, 0x20, 0x7, 0x7, PseudoVSUXSEG8EI32_V_MF2_MF2 }, // 6387
  { Intrinsic::riscv_vsuxseg8, 0x40, 0x0, 0x0, PseudoVSUXSEG8EI64_V_M1_M1 }, // 6388
  { Intrinsic::riscv_vsuxseg8, 0x40, 0x0, 0x1, PseudoVSUXSEG8EI64_V_M2_M1 }, // 6389
  { Intrinsic::riscv_vsuxseg8, 0x40, 0x0, 0x2, PseudoVSUXSEG8EI64_V_M4_M1 }, // 6390
  { Intrinsic::riscv_vsuxseg8, 0x40, 0x0, 0x3, PseudoVSUXSEG8EI64_V_M8_M1 }, // 6391
  { Intrinsic::riscv_vsuxseg8, 0x40, 0x5, 0x0, PseudoVSUXSEG8EI64_V_M1_MF8 }, // 6392
  { Intrinsic::riscv_vsuxseg8, 0x40, 0x5, 0x1, PseudoVSUXSEG8EI64_V_M2_MF8 }, // 6393
  { Intrinsic::riscv_vsuxseg8, 0x40, 0x5, 0x2, PseudoVSUXSEG8EI64_V_M4_MF8 }, // 6394
  { Intrinsic::riscv_vsuxseg8, 0x40, 0x5, 0x3, PseudoVSUXSEG8EI64_V_M8_MF8 }, // 6395
  { Intrinsic::riscv_vsuxseg8, 0x40, 0x6, 0x0, PseudoVSUXSEG8EI64_V_M1_MF4 }, // 6396
  { Intrinsic::riscv_vsuxseg8, 0x40, 0x6, 0x1, PseudoVSUXSEG8EI64_V_M2_MF4 }, // 6397
  { Intrinsic::riscv_vsuxseg8, 0x40, 0x6, 0x2, PseudoVSUXSEG8EI64_V_M4_MF4 }, // 6398
  { Intrinsic::riscv_vsuxseg8, 0x40, 0x6, 0x3, PseudoVSUXSEG8EI64_V_M8_MF4 }, // 6399
  { Intrinsic::riscv_vsuxseg8, 0x40, 0x7, 0x0, PseudoVSUXSEG8EI64_V_M1_MF2 }, // 6400
  { Intrinsic::riscv_vsuxseg8, 0x40, 0x7, 0x1, PseudoVSUXSEG8EI64_V_M2_MF2 }, // 6401
  { Intrinsic::riscv_vsuxseg8, 0x40, 0x7, 0x2, PseudoVSUXSEG8EI64_V_M4_MF2 }, // 6402
  { Intrinsic::riscv_vsuxseg8, 0x40, 0x7, 0x3, PseudoVSUXSEG8EI64_V_M8_MF2 }, // 6403
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x0, 0x0, PseudoVSUXSEG8EI8_V_M1_M1_MASK }, // 6404
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x0, 0x1, PseudoVSUXSEG8EI8_V_M2_M1_MASK }, // 6405
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x0, 0x2, PseudoVSUXSEG8EI8_V_M4_M1_MASK }, // 6406
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x0, 0x3, PseudoVSUXSEG8EI8_V_M8_M1_MASK }, // 6407
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x0, 0x5, PseudoVSUXSEG8EI8_V_MF8_M1_MASK }, // 6408
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x0, 0x6, PseudoVSUXSEG8EI8_V_MF4_M1_MASK }, // 6409
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x0, 0x7, PseudoVSUXSEG8EI8_V_MF2_M1_MASK }, // 6410
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x5, 0x0, PseudoVSUXSEG8EI8_V_M1_MF8_MASK }, // 6411
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x5, 0x1, PseudoVSUXSEG8EI8_V_M2_MF8_MASK }, // 6412
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x5, 0x2, PseudoVSUXSEG8EI8_V_M4_MF8_MASK }, // 6413
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x5, 0x3, PseudoVSUXSEG8EI8_V_M8_MF8_MASK }, // 6414
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x5, 0x5, PseudoVSUXSEG8EI8_V_MF8_MF8_MASK }, // 6415
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x5, 0x6, PseudoVSUXSEG8EI8_V_MF4_MF8_MASK }, // 6416
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x5, 0x7, PseudoVSUXSEG8EI8_V_MF2_MF8_MASK }, // 6417
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x6, 0x0, PseudoVSUXSEG8EI8_V_M1_MF4_MASK }, // 6418
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x6, 0x1, PseudoVSUXSEG8EI8_V_M2_MF4_MASK }, // 6419
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x6, 0x2, PseudoVSUXSEG8EI8_V_M4_MF4_MASK }, // 6420
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x6, 0x3, PseudoVSUXSEG8EI8_V_M8_MF4_MASK }, // 6421
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x6, 0x5, PseudoVSUXSEG8EI8_V_MF8_MF4_MASK }, // 6422
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x6, 0x6, PseudoVSUXSEG8EI8_V_MF4_MF4_MASK }, // 6423
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x6, 0x7, PseudoVSUXSEG8EI8_V_MF2_MF4_MASK }, // 6424
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x7, 0x0, PseudoVSUXSEG8EI8_V_M1_MF2_MASK }, // 6425
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x7, 0x1, PseudoVSUXSEG8EI8_V_M2_MF2_MASK }, // 6426
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x7, 0x2, PseudoVSUXSEG8EI8_V_M4_MF2_MASK }, // 6427
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x7, 0x3, PseudoVSUXSEG8EI8_V_M8_MF2_MASK }, // 6428
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x7, 0x5, PseudoVSUXSEG8EI8_V_MF8_MF2_MASK }, // 6429
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x7, 0x6, PseudoVSUXSEG8EI8_V_MF4_MF2_MASK }, // 6430
  { Intrinsic::riscv_vsuxseg8_mask, 0x8, 0x7, 0x7, PseudoVSUXSEG8EI8_V_MF2_MF2_MASK }, // 6431
  { Intrinsic::riscv_vsuxseg8_mask, 0x10, 0x0, 0x0, PseudoVSUXSEG8EI16_V_M1_M1_MASK }, // 6432
  { Intrinsic::riscv_vsuxseg8_mask, 0x10, 0x0, 0x1, PseudoVSUXSEG8EI16_V_M2_M1_MASK }, // 6433
  { Intrinsic::riscv_vsuxseg8_mask, 0x10, 0x0, 0x2, PseudoVSUXSEG8EI16_V_M4_M1_MASK }, // 6434
  { Intrinsic::riscv_vsuxseg8_mask, 0x10, 0x0, 0x3, PseudoVSUXSEG8EI16_V_M8_M1_MASK }, // 6435
  { Intrinsic::riscv_vsuxseg8_mask, 0x10, 0x0, 0x6, PseudoVSUXSEG8EI16_V_MF4_M1_MASK }, // 6436
  { Intrinsic::riscv_vsuxseg8_mask, 0x10, 0x0, 0x7, PseudoVSUXSEG8EI16_V_MF2_M1_MASK }, // 6437
  { Intrinsic::riscv_vsuxseg8_mask, 0x10, 0x5, 0x0, PseudoVSUXSEG8EI16_V_M1_MF8_MASK }, // 6438
  { Intrinsic::riscv_vsuxseg8_mask, 0x10, 0x5, 0x1, PseudoVSUXSEG8EI16_V_M2_MF8_MASK }, // 6439
  { Intrinsic::riscv_vsuxseg8_mask, 0x10, 0x5, 0x2, PseudoVSUXSEG8EI16_V_M4_MF8_MASK }, // 6440
  { Intrinsic::riscv_vsuxseg8_mask, 0x10, 0x5, 0x3, PseudoVSUXSEG8EI16_V_M8_MF8_MASK }, // 6441
  { Intrinsic::riscv_vsuxseg8_mask, 0x10, 0x5, 0x6, PseudoVSUXSEG8EI16_V_MF4_MF8_MASK }, // 6442
  { Intrinsic::riscv_vsuxseg8_mask, 0x10, 0x5, 0x7, PseudoVSUXSEG8EI16_V_MF2_MF8_MASK }, // 6443
  { Intrinsic::riscv_vsuxseg8_mask, 0x10, 0x6, 0x0, PseudoVSUXSEG8EI16_V_M1_MF4_MASK }, // 6444
  { Intrinsic::riscv_vsuxseg8_mask, 0x10, 0x6, 0x1, PseudoVSUXSEG8EI16_V_M2_MF4_MASK }, // 6445
  { Intrinsic::riscv_vsuxseg8_mask, 0x10, 0x6, 0x2, PseudoVSUXSEG8EI16_V_M4_MF4_MASK }, // 6446
  { Intrinsic::riscv_vsuxseg8_mask, 0x10, 0x6, 0x3, PseudoVSUXSEG8EI16_V_M8_MF4_MASK }, // 6447
  { Intrinsic::riscv_vsuxseg8_mask, 0x10, 0x6, 0x6, PseudoVSUXSEG8EI16_V_MF4_MF4_MASK }, // 6448
  { Intrinsic::riscv_vsuxseg8_mask, 0x10, 0x6, 0x7, PseudoVSUXSEG8EI16_V_MF2_MF4_MASK }, // 6449
  { Intrinsic::riscv_vsuxseg8_mask, 0x10, 0x7, 0x0, PseudoVSUXSEG8EI16_V_M1_MF2_MASK }, // 6450
  { Intrinsic::riscv_vsuxseg8_mask, 0x10, 0x7, 0x1, PseudoVSUXSEG8EI16_V_M2_MF2_MASK }, // 6451
  { Intrinsic::riscv_vsuxseg8_mask, 0x10, 0x7, 0x2, PseudoVSUXSEG8EI16_V_M4_MF2_MASK }, // 6452
  { Intrinsic::riscv_vsuxseg8_mask, 0x10, 0x7, 0x3, PseudoVSUXSEG8EI16_V_M8_MF2_MASK }, // 6453
  { Intrinsic::riscv_vsuxseg8_mask, 0x10, 0x7, 0x6, PseudoVSUXSEG8EI16_V_MF4_MF2_MASK }, // 6454
  { Intrinsic::riscv_vsuxseg8_mask, 0x10, 0x7, 0x7, PseudoVSUXSEG8EI16_V_MF2_MF2_MASK }, // 6455
  { Intrinsic::riscv_vsuxseg8_mask, 0x20, 0x0, 0x0, PseudoVSUXSEG8EI32_V_M1_M1_MASK }, // 6456
  { Intrinsic::riscv_vsuxseg8_mask, 0x20, 0x0, 0x1, PseudoVSUXSEG8EI32_V_M2_M1_MASK }, // 6457
  { Intrinsic::riscv_vsuxseg8_mask, 0x20, 0x0, 0x2, PseudoVSUXSEG8EI32_V_M4_M1_MASK }, // 6458
  { Intrinsic::riscv_vsuxseg8_mask, 0x20, 0x0, 0x3, PseudoVSUXSEG8EI32_V_M8_M1_MASK }, // 6459
  { Intrinsic::riscv_vsuxseg8_mask, 0x20, 0x0, 0x7, PseudoVSUXSEG8EI32_V_MF2_M1_MASK }, // 6460
  { Intrinsic::riscv_vsuxseg8_mask, 0x20, 0x5, 0x0, PseudoVSUXSEG8EI32_V_M1_MF8_MASK }, // 6461
  { Intrinsic::riscv_vsuxseg8_mask, 0x20, 0x5, 0x1, PseudoVSUXSEG8EI32_V_M2_MF8_MASK }, // 6462
  { Intrinsic::riscv_vsuxseg8_mask, 0x20, 0x5, 0x2, PseudoVSUXSEG8EI32_V_M4_MF8_MASK }, // 6463
  { Intrinsic::riscv_vsuxseg8_mask, 0x20, 0x5, 0x3, PseudoVSUXSEG8EI32_V_M8_MF8_MASK }, // 6464
  { Intrinsic::riscv_vsuxseg8_mask, 0x20, 0x5, 0x7, PseudoVSUXSEG8EI32_V_MF2_MF8_MASK }, // 6465
  { Intrinsic::riscv_vsuxseg8_mask, 0x20, 0x6, 0x0, PseudoVSUXSEG8EI32_V_M1_MF4_MASK }, // 6466
  { Intrinsic::riscv_vsuxseg8_mask, 0x20, 0x6, 0x1, PseudoVSUXSEG8EI32_V_M2_MF4_MASK }, // 6467
  { Intrinsic::riscv_vsuxseg8_mask, 0x20, 0x6, 0x2, PseudoVSUXSEG8EI32_V_M4_MF4_MASK }, // 6468
  { Intrinsic::riscv_vsuxseg8_mask, 0x20, 0x6, 0x3, PseudoVSUXSEG8EI32_V_M8_MF4_MASK }, // 6469
  { Intrinsic::riscv_vsuxseg8_mask, 0x20, 0x6, 0x7, PseudoVSUXSEG8EI32_V_MF2_MF4_MASK }, // 6470
  { Intrinsic::riscv_vsuxseg8_mask, 0x20, 0x7, 0x0, PseudoVSUXSEG8EI32_V_M1_MF2_MASK }, // 6471
  { Intrinsic::riscv_vsuxseg8_mask, 0x20, 0x7, 0x1, PseudoVSUXSEG8EI32_V_M2_MF2_MASK }, // 6472
  { Intrinsic::riscv_vsuxseg8_mask, 0x20, 0x7, 0x2, PseudoVSUXSEG8EI32_V_M4_MF2_MASK }, // 6473
  { Intrinsic::riscv_vsuxseg8_mask, 0x20, 0x7, 0x3, PseudoVSUXSEG8EI32_V_M8_MF2_MASK }, // 6474
  { Intrinsic::riscv_vsuxseg8_mask, 0x20, 0x7, 0x7, PseudoVSUXSEG8EI32_V_MF2_MF2_MASK }, // 6475
  { Intrinsic::riscv_vsuxseg8_mask, 0x40, 0x0, 0x0, PseudoVSUXSEG8EI64_V_M1_M1_MASK }, // 6476
  { Intrinsic::riscv_vsuxseg8_mask, 0x40, 0x0, 0x1, PseudoVSUXSEG8EI64_V_M2_M1_MASK }, // 6477
  { Intrinsic::riscv_vsuxseg8_mask, 0x40, 0x0, 0x2, PseudoVSUXSEG8EI64_V_M4_M1_MASK }, // 6478
  { Intrinsic::riscv_vsuxseg8_mask, 0x40, 0x0, 0x3, PseudoVSUXSEG8EI64_V_M8_M1_MASK }, // 6479
  { Intrinsic::riscv_vsuxseg8_mask, 0x40, 0x5, 0x0, PseudoVSUXSEG8EI64_V_M1_MF8_MASK }, // 6480
  { Intrinsic::riscv_vsuxseg8_mask, 0x40, 0x5, 0x1, PseudoVSUXSEG8EI64_V_M2_MF8_MASK }, // 6481
  { Intrinsic::riscv_vsuxseg8_mask, 0x40, 0x5, 0x2, PseudoVSUXSEG8EI64_V_M4_MF8_MASK }, // 6482
  { Intrinsic::riscv_vsuxseg8_mask, 0x40, 0x5, 0x3, PseudoVSUXSEG8EI64_V_M8_MF8_MASK }, // 6483
  { Intrinsic::riscv_vsuxseg8_mask, 0x40, 0x6, 0x0, PseudoVSUXSEG8EI64_V_M1_MF4_MASK }, // 6484
  { Intrinsic::riscv_vsuxseg8_mask, 0x40, 0x6, 0x1, PseudoVSUXSEG8EI64_V_M2_MF4_MASK }, // 6485
  { Intrinsic::riscv_vsuxseg8_mask, 0x40, 0x6, 0x2, PseudoVSUXSEG8EI64_V_M4_MF4_MASK }, // 6486
  { Intrinsic::riscv_vsuxseg8_mask, 0x40, 0x6, 0x3, PseudoVSUXSEG8EI64_V_M8_MF4_MASK }, // 6487
  { Intrinsic::riscv_vsuxseg8_mask, 0x40, 0x7, 0x0, PseudoVSUXSEG8EI64_V_M1_MF2_MASK }, // 6488
  { Intrinsic::riscv_vsuxseg8_mask, 0x40, 0x7, 0x1, PseudoVSUXSEG8EI64_V_M2_MF2_MASK }, // 6489
  { Intrinsic::riscv_vsuxseg8_mask, 0x40, 0x7, 0x2, PseudoVSUXSEG8EI64_V_M4_MF2_MASK }, // 6490
  { Intrinsic::riscv_vsuxseg8_mask, 0x40, 0x7, 0x3, PseudoVSUXSEG8EI64_V_M8_MF2_MASK }, // 6491
 };

const RISCVZvlsseg *getPseudo(unsigned IntrinsicID, uint16_t SEW, uint8_t LMUL, uint8_t IndexLMUL) {
  struct KeyType {
    unsigned IntrinsicID;
    uint16_t SEW;
    uint8_t LMUL;
    uint8_t IndexLMUL;
  };
  KeyType Key = {IntrinsicID, SEW, LMUL, IndexLMUL};
  auto Table = makeArrayRef(RISCVZvlssegTable);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const RISCVZvlsseg &LHS, const KeyType &RHS) {
      if (LHS.IntrinsicID < RHS.IntrinsicID)
        return true;
      if (LHS.IntrinsicID > RHS.IntrinsicID)
        return false;
      if (LHS.SEW < RHS.SEW)
        return true;
      if (LHS.SEW > RHS.SEW)
        return false;
      if (LHS.LMUL < RHS.LMUL)
        return true;
      if (LHS.LMUL > RHS.LMUL)
        return false;
      if (LHS.IndexLMUL < RHS.IndexLMUL)
        return true;
      if (LHS.IndexLMUL > RHS.IndexLMUL)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.IntrinsicID != Idx->IntrinsicID ||
      Key.SEW != Idx->SEW ||
      Key.LMUL != Idx->LMUL ||
      Key.IndexLMUL != Idx->IndexLMUL)
    return nullptr;
  return &*Idx;
}
#endif

#ifdef GET_SysRegsList_DECL
const SysReg *lookupSysRegByEncoding(uint16_t Encoding);
const SysReg *lookupSysRegByAltName(StringRef AltName);
const SysReg *lookupSysRegByName(StringRef Name);
#endif

#ifdef GET_SysRegsList_IMPL
constexpr SysReg SysRegsList[] = {
  { "ustatus", 0x0, "ustatus",  {} , false }, // 0
  { "fflags", 0x1, "fflags",  {} , false }, // 1
  { "frm", 0x2, "frm",  {} , false }, // 2
  { "fcsr", 0x3, "fcsr",  {} , false }, // 3
  { "uie", 0x4, "uie",  {} , false }, // 4
  { "utvec", 0x5, "utvec",  {} , false }, // 5
  { "vstart", 0x8, "vstart",  {} , false }, // 6
  { "vxsat", 0x9, "vxsat",  {} , false }, // 7
  { "vxrm", 0xA, "vxrm",  {} , false }, // 8
  { "uscratch", 0x40, "uscratch",  {} , false }, // 9
  { "uepc", 0x41, "uepc",  {} , false }, // 10
  { "ucause", 0x42, "ucause",  {} , false }, // 11
  { "utval", 0x43, "utval",  {} , false }, // 12
  { "uip", 0x44, "uip",  {} , false }, // 13
  { "sstatus", 0x100, "sstatus",  {} , false }, // 14
  { "sedeleg", 0x102, "sedeleg",  {} , false }, // 15
  { "sideleg", 0x103, "sideleg",  {} , false }, // 16
  { "sie", 0x104, "sie",  {} , false }, // 17
  { "stvec", 0x105, "stvec",  {} , false }, // 18
  { "scounteren", 0x106, "scounteren",  {} , false }, // 19
  { "sscratch", 0x140, "sscratch",  {} , false }, // 20
  { "sepc", 0x141, "sepc",  {} , false }, // 21
  { "scause", 0x142, "scause",  {} , false }, // 22
  { "stval", 0x143, "stval",  {} , false }, // 23
  { "sip", 0x144, "sip",  {} , false }, // 24
  { "satp", 0x180, "satp",  {} , false }, // 25
  { "mstatus", 0x300, "mstatus",  {} , false }, // 26
  { "misa", 0x301, "misa",  {} , false }, // 27
  { "medeleg", 0x302, "medeleg",  {} , false }, // 28
  { "mideleg", 0x303, "mideleg",  {} , false }, // 29
  { "mie", 0x304, "mie",  {} , false }, // 30
  { "mtvec", 0x305, "mtvec",  {} , false }, // 31
  { "mcounteren", 0x306, "mcounteren",  {} , false }, // 32
  { "mcountinhibit", 0x320, "mucounteren",  {} , false }, // 33
  { "mhpmevent3", 0x323, "mhpmevent3",  {} , false }, // 34
  { "mhpmevent4", 0x324, "mhpmevent4",  {} , false }, // 35
  { "mhpmevent5", 0x325, "mhpmevent5",  {} , false }, // 36
  { "mhpmevent6", 0x326, "mhpmevent6",  {} , false }, // 37
  { "mhpmevent7", 0x327, "mhpmevent7",  {} , false }, // 38
  { "mhpmevent8", 0x328, "mhpmevent8",  {} , false }, // 39
  { "mhpmevent9", 0x329, "mhpmevent9",  {} , false }, // 40
  { "mhpmevent10", 0x32A, "mhpmevent10",  {} , false }, // 41
  { "mhpmevent11", 0x32B, "mhpmevent11",  {} , false }, // 42
  { "mhpmevent12", 0x32C, "mhpmevent12",  {} , false }, // 43
  { "mhpmevent13", 0x32D, "mhpmevent13",  {} , false }, // 44
  { "mhpmevent14", 0x32E, "mhpmevent14",  {} , false }, // 45
  { "mhpmevent15", 0x32F, "mhpmevent15",  {} , false }, // 46
  { "mhpmevent16", 0x330, "mhpmevent16",  {} , false }, // 47
  { "mhpmevent17", 0x331, "mhpmevent17",  {} , false }, // 48
  { "mhpmevent18", 0x332, "mhpmevent18",  {} , false }, // 49
  { "mhpmevent19", 0x333, "mhpmevent19",  {} , false }, // 50
  { "mhpmevent20", 0x334, "mhpmevent20",  {} , false }, // 51
  { "mhpmevent21", 0x335, "mhpmevent21",  {} , false }, // 52
  { "mhpmevent22", 0x336, "mhpmevent22",  {} , false }, // 53
  { "mhpmevent23", 0x337, "mhpmevent23",  {} , false }, // 54
  { "mhpmevent24", 0x338, "mhpmevent24",  {} , false }, // 55
  { "mhpmevent25", 0x339, "mhpmevent25",  {} , false }, // 56
  { "mhpmevent26", 0x33A, "mhpmevent26",  {} , false }, // 57
  { "mhpmevent27", 0x33B, "mhpmevent27",  {} , false }, // 58
  { "mhpmevent28", 0x33C, "mhpmevent28",  {} , false }, // 59
  { "mhpmevent29", 0x33D, "mhpmevent29",  {} , false }, // 60
  { "mhpmevent30", 0x33E, "mhpmevent30",  {} , false }, // 61
  { "mhpmevent31", 0x33F, "mhpmevent31",  {} , false }, // 62
  { "mscratch", 0x340, "mscratch",  {} , false }, // 63
  { "mepc", 0x341, "mepc",  {} , false }, // 64
  { "mcause", 0x342, "mcause",  {} , false }, // 65
  { "mtval", 0x343, "mtval",  {} , false }, // 66
  { "mip", 0x344, "mip",  {} , false }, // 67
  { "pmpcfg0", 0x3A0, "pmpcfg0",  {} , false }, // 68
  { "pmpcfg1", 0x3A1, "pmpcfg1",  {} , true }, // 69
  { "pmpcfg2", 0x3A2, "pmpcfg2",  {} , false }, // 70
  { "pmpcfg3", 0x3A3, "pmpcfg3",  {} , true }, // 71
  { "pmpaddr0", 0x3B0, "pmpaddr0",  {} , false }, // 72
  { "pmpaddr1", 0x3B1, "pmpaddr1",  {} , false }, // 73
  { "pmpaddr2", 0x3B2, "pmpaddr2",  {} , false }, // 74
  { "pmpaddr3", 0x3B3, "pmpaddr3",  {} , false }, // 75
  { "pmpaddr4", 0x3B4, "pmpaddr4",  {} , false }, // 76
  { "pmpaddr5", 0x3B5, "pmpaddr5",  {} , false }, // 77
  { "pmpaddr6", 0x3B6, "pmpaddr6",  {} , false }, // 78
  { "pmpaddr7", 0x3B7, "pmpaddr7",  {} , false }, // 79
  { "pmpaddr8", 0x3B8, "pmpaddr8",  {} , false }, // 80
  { "pmpaddr9", 0x3B9, "pmpaddr9",  {} , false }, // 81
  { "pmpaddr10", 0x3BA, "pmpaddr10",  {} , false }, // 82
  { "pmpaddr11", 0x3BB, "pmpaddr11",  {} , false }, // 83
  { "pmpaddr12", 0x3BC, "pmpaddr12",  {} , false }, // 84
  { "pmpaddr13", 0x3BD, "pmpaddr13",  {} , false }, // 85
  { "pmpaddr14", 0x3BE, "pmpaddr14",  {} , false }, // 86
  { "pmpaddr15", 0x3BF, "pmpaddr15",  {} , false }, // 87
  { "tselect", 0x7A0, "tselect",  {} , false }, // 88
  { "tdata1", 0x7A1, "tdata1",  {} , false }, // 89
  { "tdata2", 0x7A2, "tdata2",  {} , false }, // 90
  { "tdata3", 0x7A3, "tdata3",  {} , false }, // 91
  { "dcsr", 0x7B0, "dcsr",  {} , false }, // 92
  { "dpc", 0x7B1, "dpc",  {} , false }, // 93
  { "dscratch0", 0x7B2, "dscratch",  {} , false }, // 94
  { "dscratch1", 0x7B3, "dscratch1",  {} , false }, // 95
  { "mcycle", 0xB00, "mcycle",  {} , false }, // 96
  { "minstret", 0xB02, "minstret",  {} , false }, // 97
  { "mhpmcounter3", 0xB03, "mhpmcounter3",  {} , false }, // 98
  { "mhpmcounter4", 0xB04, "mhpmcounter4",  {} , false }, // 99
  { "mhpmcounter5", 0xB05, "mhpmcounter5",  {} , false }, // 100
  { "mhpmcounter6", 0xB06, "mhpmcounter6",  {} , false }, // 101
  { "mhpmcounter7", 0xB07, "mhpmcounter7",  {} , false }, // 102
  { "mhpmcounter8", 0xB08, "mhpmcounter8",  {} , false }, // 103
  { "mhpmcounter9", 0xB09, "mhpmcounter9",  {} , false }, // 104
  { "mhpmcounter10", 0xB0A, "mhpmcounter10",  {} , false }, // 105
  { "mhpmcounter11", 0xB0B, "mhpmcounter11",  {} , false }, // 106
  { "mhpmcounter12", 0xB0C, "mhpmcounter12",  {} , false }, // 107
  { "mhpmcounter13", 0xB0D, "mhpmcounter13",  {} , false }, // 108
  { "mhpmcounter14", 0xB0E, "mhpmcounter14",  {} , false }, // 109
  { "mhpmcounter15", 0xB0F, "mhpmcounter15",  {} , false }, // 110
  { "mhpmcounter16", 0xB10, "mhpmcounter16",  {} , false }, // 111
  { "mhpmcounter17", 0xB11, "mhpmcounter17",  {} , false }, // 112
  { "mhpmcounter18", 0xB12, "mhpmcounter18",  {} , false }, // 113
  { "mhpmcounter19", 0xB13, "mhpmcounter19",  {} , false }, // 114
  { "mhpmcounter20", 0xB14, "mhpmcounter20",  {} , false }, // 115
  { "mhpmcounter21", 0xB15, "mhpmcounter21",  {} , false }, // 116
  { "mhpmcounter22", 0xB16, "mhpmcounter22",  {} , false }, // 117
  { "mhpmcounter23", 0xB17, "mhpmcounter23",  {} , false }, // 118
  { "mhpmcounter24", 0xB18, "mhpmcounter24",  {} , false }, // 119
  { "mhpmcounter25", 0xB19, "mhpmcounter25",  {} , false }, // 120
  { "mhpmcounter26", 0xB1A, "mhpmcounter26",  {} , false }, // 121
  { "mhpmcounter27", 0xB1B, "mhpmcounter27",  {} , false }, // 122
  { "mhpmcounter28", 0xB1C, "mhpmcounter28",  {} , false }, // 123
  { "mhpmcounter29", 0xB1D, "mhpmcounter29",  {} , false }, // 124
  { "mhpmcounter30", 0xB1E, "mhpmcounter30",  {} , false }, // 125
  { "mhpmcounter31", 0xB1F, "mhpmcounter31",  {} , false }, // 126
  { "mcycleh", 0xB80, "mcycleh",  {} , true }, // 127
  { "minstreth", 0xB82, "minstreth",  {} , true }, // 128
  { "mhpmcounter3h", 0xB83, "mhpmcounter3h",  {} , true }, // 129
  { "mhpmcounter4h", 0xB84, "mhpmcounter4h",  {} , true }, // 130
  { "mhpmcounter5h", 0xB85, "mhpmcounter5h",  {} , true }, // 131
  { "mhpmcounter6h", 0xB86, "mhpmcounter6h",  {} , true }, // 132
  { "mhpmcounter7h", 0xB87, "mhpmcounter7h",  {} , true }, // 133
  { "mhpmcounter8h", 0xB88, "mhpmcounter8h",  {} , true }, // 134
  { "mhpmcounter9h", 0xB89, "mhpmcounter9h",  {} , true }, // 135
  { "mhpmcounter10h", 0xB8A, "mhpmcounter10h",  {} , true }, // 136
  { "mhpmcounter11h", 0xB8B, "mhpmcounter11h",  {} , true }, // 137
  { "mhpmcounter12h", 0xB8C, "mhpmcounter12h",  {} , true }, // 138
  { "mhpmcounter13h", 0xB8D, "mhpmcounter13h",  {} , true }, // 139
  { "mhpmcounter14h", 0xB8E, "mhpmcounter14h",  {} , true }, // 140
  { "mhpmcounter15h", 0xB8F, "mhpmcounter15h",  {} , true }, // 141
  { "mhpmcounter16h", 0xB90, "mhpmcounter16h",  {} , true }, // 142
  { "mhpmcounter17h", 0xB91, "mhpmcounter17h",  {} , true }, // 143
  { "mhpmcounter18h", 0xB92, "mhpmcounter18h",  {} , true }, // 144
  { "mhpmcounter19h", 0xB93, "mhpmcounter19h",  {} , true }, // 145
  { "mhpmcounter20h", 0xB94, "mhpmcounter20h",  {} , true }, // 146
  { "mhpmcounter21h", 0xB95, "mhpmcounter21h",  {} , true }, // 147
  { "mhpmcounter22h", 0xB96, "mhpmcounter22h",  {} , true }, // 148
  { "mhpmcounter23h", 0xB97, "mhpmcounter23h",  {} , true }, // 149
  { "mhpmcounter24h", 0xB98, "mhpmcounter24h",  {} , true }, // 150
  { "mhpmcounter25h", 0xB99, "mhpmcounter25h",  {} , true }, // 151
  { "mhpmcounter26h", 0xB9A, "mhpmcounter26h",  {} , true }, // 152
  { "mhpmcounter27h", 0xB9B, "mhpmcounter27h",  {} , true }, // 153
  { "mhpmcounter28h", 0xB9C, "mhpmcounter28h",  {} , true }, // 154
  { "mhpmcounter29h", 0xB9D, "mhpmcounter29h",  {} , true }, // 155
  { "mhpmcounter30h", 0xB9E, "mhpmcounter30h",  {} , true }, // 156
  { "mhpmcounter31h", 0xB9F, "mhpmcounter31h",  {} , true }, // 157
  { "cycle", 0xC00, "cycle",  {} , false }, // 158
  { "time", 0xC01, "time",  {} , false }, // 159
  { "instret", 0xC02, "instret",  {} , false }, // 160
  { "hpmcounter3", 0xC03, "hpmcounter3",  {} , false }, // 161
  { "hpmcounter4", 0xC04, "hpmcounter4",  {} , false }, // 162
  { "hpmcounter5", 0xC05, "hpmcounter5",  {} , false }, // 163
  { "hpmcounter6", 0xC06, "hpmcounter6",  {} , false }, // 164
  { "hpmcounter7", 0xC07, "hpmcounter7",  {} , false }, // 165
  { "hpmcounter8", 0xC08, "hpmcounter8",  {} , false }, // 166
  { "hpmcounter9", 0xC09, "hpmcounter9",  {} , false }, // 167
  { "hpmcounter10", 0xC0A, "hpmcounter10",  {} , false }, // 168
  { "hpmcounter11", 0xC0B, "hpmcounter11",  {} , false }, // 169
  { "hpmcounter12", 0xC0C, "hpmcounter12",  {} , false }, // 170
  { "hpmcounter13", 0xC0D, "hpmcounter13",  {} , false }, // 171
  { "hpmcounter14", 0xC0E, "hpmcounter14",  {} , false }, // 172
  { "hpmcounter15", 0xC0F, "hpmcounter15",  {} , false }, // 173
  { "hpmcounter16", 0xC10, "hpmcounter16",  {} , false }, // 174
  { "hpmcounter17", 0xC11, "hpmcounter17",  {} , false }, // 175
  { "hpmcounter18", 0xC12, "hpmcounter18",  {} , false }, // 176
  { "hpmcounter19", 0xC13, "hpmcounter19",  {} , false }, // 177
  { "hpmcounter20", 0xC14, "hpmcounter20",  {} , false }, // 178
  { "hpmcounter21", 0xC15, "hpmcounter21",  {} , false }, // 179
  { "hpmcounter22", 0xC16, "hpmcounter22",  {} , false }, // 180
  { "hpmcounter23", 0xC17, "hpmcounter23",  {} , false }, // 181
  { "hpmcounter24", 0xC18, "hpmcounter24",  {} , false }, // 182
  { "hpmcounter25", 0xC19, "hpmcounter25",  {} , false }, // 183
  { "hpmcounter26", 0xC1A, "hpmcounter26",  {} , false }, // 184
  { "hpmcounter27", 0xC1B, "hpmcounter27",  {} , false }, // 185
  { "hpmcounter28", 0xC1C, "hpmcounter28",  {} , false }, // 186
  { "hpmcounter29", 0xC1D, "hpmcounter29",  {} , false }, // 187
  { "hpmcounter30", 0xC1E, "hpmcounter30",  {} , false }, // 188
  { "hpmcounter31", 0xC1F, "hpmcounter31",  {} , false }, // 189
  { "vl", 0xC20, "vl",  {} , false }, // 190
  { "vtype", 0xC21, "vtype",  {} , false }, // 191
  { "vlenb", 0xC22, "vlenb",  {} , false }, // 192
  { "cycleh", 0xC80, "cycleh",  {} , true }, // 193
  { "timeh", 0xC81, "timeh",  {} , true }, // 194
  { "instreth", 0xC82, "instreth",  {} , true }, // 195
  { "hpmcounter3h", 0xC83, "hpmcounter3h",  {} , true }, // 196
  { "hpmcounter4h", 0xC84, "hpmcounter4h",  {} , true }, // 197
  { "hpmcounter5h", 0xC85, "hpmcounter5h",  {} , true }, // 198
  { "hpmcounter6h", 0xC86, "hpmcounter6h",  {} , true }, // 199
  { "hpmcounter7h", 0xC87, "hpmcounter7h",  {} , true }, // 200
  { "hpmcounter8h", 0xC88, "hpmcounter8h",  {} , true }, // 201
  { "hpmcounter9h", 0xC89, "hpmcounter9h",  {} , true }, // 202
  { "hpmcounter10h", 0xC8A, "hpmcounter10h",  {} , true }, // 203
  { "hpmcounter11h", 0xC8B, "hpmcounter11h",  {} , true }, // 204
  { "hpmcounter12h", 0xC8C, "hpmcounter12h",  {} , true }, // 205
  { "hpmcounter13h", 0xC8D, "hpmcounter13h",  {} , true }, // 206
  { "hpmcounter14h", 0xC8E, "hpmcounter14h",  {} , true }, // 207
  { "hpmcounter15h", 0xC8F, "hpmcounter15h",  {} , true }, // 208
  { "hpmcounter16h", 0xC90, "hpmcounter16h",  {} , true }, // 209
  { "hpmcounter17h", 0xC91, "hpmcounter17h",  {} , true }, // 210
  { "hpmcounter18h", 0xC92, "hpmcounter18h",  {} , true }, // 211
  { "hpmcounter19h", 0xC93, "hpmcounter19h",  {} , true }, // 212
  { "hpmcounter20h", 0xC94, "hpmcounter20h",  {} , true }, // 213
  { "hpmcounter21h", 0xC95, "hpmcounter21h",  {} , true }, // 214
  { "hpmcounter22h", 0xC96, "hpmcounter22h",  {} , true }, // 215
  { "hpmcounter23h", 0xC97, "hpmcounter23h",  {} , true }, // 216
  { "hpmcounter24h", 0xC98, "hpmcounter24h",  {} , true }, // 217
  { "hpmcounter25h", 0xC99, "hpmcounter25h",  {} , true }, // 218
  { "hpmcounter26h", 0xC9A, "hpmcounter26h",  {} , true }, // 219
  { "hpmcounter27h", 0xC9B, "hpmcounter27h",  {} , true }, // 220
  { "hpmcounter28h", 0xC9C, "hpmcounter28h",  {} , true }, // 221
  { "hpmcounter29h", 0xC9D, "hpmcounter29h",  {} , true }, // 222
  { "hpmcounter30h", 0xC9E, "hpmcounter30h",  {} , true }, // 223
  { "hpmcounter31h", 0xC9F, "hpmcounter31h",  {} , true }, // 224
  { "mvendorid", 0xF11, "mvendorid",  {} , false }, // 225
  { "marchid", 0xF12, "marchid",  {} , false }, // 226
  { "mimpid", 0xF13, "mimpid",  {} , false }, // 227
  { "mhartid", 0xF14, "mhartid",  {} , false }, // 228
 };

const SysReg *lookupSysRegByEncoding(uint16_t Encoding) {
  struct KeyType {
    uint16_t Encoding;
  };
  KeyType Key = {Encoding};
  auto Table = makeArrayRef(SysRegsList);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const SysReg &LHS, const KeyType &RHS) {
      if (LHS.Encoding < RHS.Encoding)
        return true;
      if (LHS.Encoding > RHS.Encoding)
        return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Encoding != Idx->Encoding)
    return nullptr;
  return &*Idx;
}

const SysReg *lookupSysRegByAltName(StringRef AltName) {
  struct IndexType {
    const char * AltName;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { "CYCLE", 158 },
    { "CYCLEH", 193 },
    { "DCSR", 92 },
    { "DPC", 93 },
    { "DSCRATCH", 94 },
    { "DSCRATCH1", 95 },
    { "FCSR", 3 },
    { "FFLAGS", 1 },
    { "FRM", 2 },
    { "HPMCOUNTER10", 168 },
    { "HPMCOUNTER10H", 203 },
    { "HPMCOUNTER11", 169 },
    { "HPMCOUNTER11H", 204 },
    { "HPMCOUNTER12", 170 },
    { "HPMCOUNTER12H", 205 },
    { "HPMCOUNTER13", 171 },
    { "HPMCOUNTER13H", 206 },
    { "HPMCOUNTER14", 172 },
    { "HPMCOUNTER14H", 207 },
    { "HPMCOUNTER15", 173 },
    { "HPMCOUNTER15H", 208 },
    { "HPMCOUNTER16", 174 },
    { "HPMCOUNTER16H", 209 },
    { "HPMCOUNTER17", 175 },
    { "HPMCOUNTER17H", 210 },
    { "HPMCOUNTER18", 176 },
    { "HPMCOUNTER18H", 211 },
    { "HPMCOUNTER19", 177 },
    { "HPMCOUNTER19H", 212 },
    { "HPMCOUNTER20", 178 },
    { "HPMCOUNTER20H", 213 },
    { "HPMCOUNTER21", 179 },
    { "HPMCOUNTER21H", 214 },
    { "HPMCOUNTER22", 180 },
    { "HPMCOUNTER22H", 215 },
    { "HPMCOUNTER23", 181 },
    { "HPMCOUNTER23H", 216 },
    { "HPMCOUNTER24", 182 },
    { "HPMCOUNTER24H", 217 },
    { "HPMCOUNTER25", 183 },
    { "HPMCOUNTER25H", 218 },
    { "HPMCOUNTER26", 184 },
    { "HPMCOUNTER26H", 219 },
    { "HPMCOUNTER27", 185 },
    { "HPMCOUNTER27H", 220 },
    { "HPMCOUNTER28", 186 },
    { "HPMCOUNTER28H", 221 },
    { "HPMCOUNTER29", 187 },
    { "HPMCOUNTER29H", 222 },
    { "HPMCOUNTER3", 161 },
    { "HPMCOUNTER30", 188 },
    { "HPMCOUNTER30H", 223 },
    { "HPMCOUNTER31", 189 },
    { "HPMCOUNTER31H", 224 },
    { "HPMCOUNTER3H", 196 },
    { "HPMCOUNTER4", 162 },
    { "HPMCOUNTER4H", 197 },
    { "HPMCOUNTER5", 163 },
    { "HPMCOUNTER5H", 198 },
    { "HPMCOUNTER6", 164 },
    { "HPMCOUNTER6H", 199 },
    { "HPMCOUNTER7", 165 },
    { "HPMCOUNTER7H", 200 },
    { "HPMCOUNTER8", 166 },
    { "HPMCOUNTER8H", 201 },
    { "HPMCOUNTER9", 167 },
    { "HPMCOUNTER9H", 202 },
    { "INSTRET", 160 },
    { "INSTRETH", 195 },
    { "MARCHID", 226 },
    { "MCAUSE", 65 },
    { "MCOUNTEREN", 32 },
    { "MCYCLE", 96 },
    { "MCYCLEH", 127 },
    { "MEDELEG", 28 },
    { "MEPC", 64 },
    { "MHARTID", 228 },
    { "MHPMCOUNTER10", 105 },
    { "MHPMCOUNTER10H", 136 },
    { "MHPMCOUNTER11", 106 },
    { "MHPMCOUNTER11H", 137 },
    { "MHPMCOUNTER12", 107 },
    { "MHPMCOUNTER12H", 138 },
    { "MHPMCOUNTER13", 108 },
    { "MHPMCOUNTER13H", 139 },
    { "MHPMCOUNTER14", 109 },
    { "MHPMCOUNTER14H", 140 },
    { "MHPMCOUNTER15", 110 },
    { "MHPMCOUNTER15H", 141 },
    { "MHPMCOUNTER16", 111 },
    { "MHPMCOUNTER16H", 142 },
    { "MHPMCOUNTER17", 112 },
    { "MHPMCOUNTER17H", 143 },
    { "MHPMCOUNTER18", 113 },
    { "MHPMCOUNTER18H", 144 },
    { "MHPMCOUNTER19", 114 },
    { "MHPMCOUNTER19H", 145 },
    { "MHPMCOUNTER20", 115 },
    { "MHPMCOUNTER20H", 146 },
    { "MHPMCOUNTER21", 116 },
    { "MHPMCOUNTER21H", 147 },
    { "MHPMCOUNTER22", 117 },
    { "MHPMCOUNTER22H", 148 },
    { "MHPMCOUNTER23", 118 },
    { "MHPMCOUNTER23H", 149 },
    { "MHPMCOUNTER24", 119 },
    { "MHPMCOUNTER24H", 150 },
    { "MHPMCOUNTER25", 120 },
    { "MHPMCOUNTER25H", 151 },
    { "MHPMCOUNTER26", 121 },
    { "MHPMCOUNTER26H", 152 },
    { "MHPMCOUNTER27", 122 },
    { "MHPMCOUNTER27H", 153 },
    { "MHPMCOUNTER28", 123 },
    { "MHPMCOUNTER28H", 154 },
    { "MHPMCOUNTER29", 124 },
    { "MHPMCOUNTER29H", 155 },
    { "MHPMCOUNTER3", 98 },
    { "MHPMCOUNTER30", 125 },
    { "MHPMCOUNTER30H", 156 },
    { "MHPMCOUNTER31", 126 },
    { "MHPMCOUNTER31H", 157 },
    { "MHPMCOUNTER3H", 129 },
    { "MHPMCOUNTER4", 99 },
    { "MHPMCOUNTER4H", 130 },
    { "MHPMCOUNTER5", 100 },
    { "MHPMCOUNTER5H", 131 },
    { "MHPMCOUNTER6", 101 },
    { "MHPMCOUNTER6H", 132 },
    { "MHPMCOUNTER7", 102 },
    { "MHPMCOUNTER7H", 133 },
    { "MHPMCOUNTER8", 103 },
    { "MHPMCOUNTER8H", 134 },
    { "MHPMCOUNTER9", 104 },
    { "MHPMCOUNTER9H", 135 },
    { "MHPMEVENT10", 41 },
    { "MHPMEVENT11", 42 },
    { "MHPMEVENT12", 43 },
    { "MHPMEVENT13", 44 },
    { "MHPMEVENT14", 45 },
    { "MHPMEVENT15", 46 },
    { "MHPMEVENT16", 47 },
    { "MHPMEVENT17", 48 },
    { "MHPMEVENT18", 49 },
    { "MHPMEVENT19", 50 },
    { "MHPMEVENT20", 51 },
    { "MHPMEVENT21", 52 },
    { "MHPMEVENT22", 53 },
    { "MHPMEVENT23", 54 },
    { "MHPMEVENT24", 55 },
    { "MHPMEVENT25", 56 },
    { "MHPMEVENT26", 57 },
    { "MHPMEVENT27", 58 },
    { "MHPMEVENT28", 59 },
    { "MHPMEVENT29", 60 },
    { "MHPMEVENT3", 34 },
    { "MHPMEVENT30", 61 },
    { "MHPMEVENT31", 62 },
    { "MHPMEVENT4", 35 },
    { "MHPMEVENT5", 36 },
    { "MHPMEVENT6", 37 },
    { "MHPMEVENT7", 38 },
    { "MHPMEVENT8", 39 },
    { "MHPMEVENT9", 40 },
    { "MIDELEG", 29 },
    { "MIE", 30 },
    { "MIMPID", 227 },
    { "MINSTRET", 97 },
    { "MINSTRETH", 128 },
    { "MIP", 67 },
    { "MISA", 27 },
    { "MSCRATCH", 63 },
    { "MSTATUS", 26 },
    { "MTVAL", 66 },
    { "MTVEC", 31 },
    { "MUCOUNTEREN", 33 },
    { "MVENDORID", 225 },
    { "PMPADDR0", 72 },
    { "PMPADDR1", 73 },
    { "PMPADDR10", 82 },
    { "PMPADDR11", 83 },
    { "PMPADDR12", 84 },
    { "PMPADDR13", 85 },
    { "PMPADDR14", 86 },
    { "PMPADDR15", 87 },
    { "PMPADDR2", 74 },
    { "PMPADDR3", 75 },
    { "PMPADDR4", 76 },
    { "PMPADDR5", 77 },
    { "PMPADDR6", 78 },
    { "PMPADDR7", 79 },
    { "PMPADDR8", 80 },
    { "PMPADDR9", 81 },
    { "PMPCFG0", 68 },
    { "PMPCFG1", 69 },
    { "PMPCFG2", 70 },
    { "PMPCFG3", 71 },
    { "SATP", 25 },
    { "SCAUSE", 22 },
    { "SCOUNTEREN", 19 },
    { "SEDELEG", 15 },
    { "SEPC", 21 },
    { "SIDELEG", 16 },
    { "SIE", 17 },
    { "SIP", 24 },
    { "SSCRATCH", 20 },
    { "SSTATUS", 14 },
    { "STVAL", 23 },
    { "STVEC", 18 },
    { "TDATA1", 89 },
    { "TDATA2", 90 },
    { "TDATA3", 91 },
    { "TIME", 159 },
    { "TIMEH", 194 },
    { "TSELECT", 88 },
    { "UCAUSE", 11 },
    { "UEPC", 10 },
    { "UIE", 4 },
    { "UIP", 13 },
    { "USCRATCH", 9 },
    { "USTATUS", 0 },
    { "UTVAL", 12 },
    { "UTVEC", 5 },
    { "VL", 190 },
    { "VLENB", 192 },
    { "VSTART", 6 },
    { "VTYPE", 191 },
    { "VXRM", 8 },
    { "VXSAT", 7 },
  };

  struct KeyType {
    std::string AltName;
  };
  KeyType Key = {AltName.upper()};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      int CmpAltName = StringRef(LHS.AltName).compare(RHS.AltName);
      if (CmpAltName < 0) return true;
      if (CmpAltName > 0) return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.AltName != Idx->AltName)
    return nullptr;
  return &SysRegsList[Idx->_index];
}

const SysReg *lookupSysRegByName(StringRef Name) {
  struct IndexType {
    const char * Name;
    unsigned _index;
  };
  static const struct IndexType Index[] = {
    { "CYCLE", 158 },
    { "CYCLEH", 193 },
    { "DCSR", 92 },
    { "DPC", 93 },
    { "DSCRATCH0", 94 },
    { "DSCRATCH1", 95 },
    { "FCSR", 3 },
    { "FFLAGS", 1 },
    { "FRM", 2 },
    { "HPMCOUNTER10", 168 },
    { "HPMCOUNTER10H", 203 },
    { "HPMCOUNTER11", 169 },
    { "HPMCOUNTER11H", 204 },
    { "HPMCOUNTER12", 170 },
    { "HPMCOUNTER12H", 205 },
    { "HPMCOUNTER13", 171 },
    { "HPMCOUNTER13H", 206 },
    { "HPMCOUNTER14", 172 },
    { "HPMCOUNTER14H", 207 },
    { "HPMCOUNTER15", 173 },
    { "HPMCOUNTER15H", 208 },
    { "HPMCOUNTER16", 174 },
    { "HPMCOUNTER16H", 209 },
    { "HPMCOUNTER17", 175 },
    { "HPMCOUNTER17H", 210 },
    { "HPMCOUNTER18", 176 },
    { "HPMCOUNTER18H", 211 },
    { "HPMCOUNTER19", 177 },
    { "HPMCOUNTER19H", 212 },
    { "HPMCOUNTER20", 178 },
    { "HPMCOUNTER20H", 213 },
    { "HPMCOUNTER21", 179 },
    { "HPMCOUNTER21H", 214 },
    { "HPMCOUNTER22", 180 },
    { "HPMCOUNTER22H", 215 },
    { "HPMCOUNTER23", 181 },
    { "HPMCOUNTER23H", 216 },
    { "HPMCOUNTER24", 182 },
    { "HPMCOUNTER24H", 217 },
    { "HPMCOUNTER25", 183 },
    { "HPMCOUNTER25H", 218 },
    { "HPMCOUNTER26", 184 },
    { "HPMCOUNTER26H", 219 },
    { "HPMCOUNTER27", 185 },
    { "HPMCOUNTER27H", 220 },
    { "HPMCOUNTER28", 186 },
    { "HPMCOUNTER28H", 221 },
    { "HPMCOUNTER29", 187 },
    { "HPMCOUNTER29H", 222 },
    { "HPMCOUNTER3", 161 },
    { "HPMCOUNTER30", 188 },
    { "HPMCOUNTER30H", 223 },
    { "HPMCOUNTER31", 189 },
    { "HPMCOUNTER31H", 224 },
    { "HPMCOUNTER3H", 196 },
    { "HPMCOUNTER4", 162 },
    { "HPMCOUNTER4H", 197 },
    { "HPMCOUNTER5", 163 },
    { "HPMCOUNTER5H", 198 },
    { "HPMCOUNTER6", 164 },
    { "HPMCOUNTER6H", 199 },
    { "HPMCOUNTER7", 165 },
    { "HPMCOUNTER7H", 200 },
    { "HPMCOUNTER8", 166 },
    { "HPMCOUNTER8H", 201 },
    { "HPMCOUNTER9", 167 },
    { "HPMCOUNTER9H", 202 },
    { "INSTRET", 160 },
    { "INSTRETH", 195 },
    { "MARCHID", 226 },
    { "MCAUSE", 65 },
    { "MCOUNTEREN", 32 },
    { "MCOUNTINHIBIT", 33 },
    { "MCYCLE", 96 },
    { "MCYCLEH", 127 },
    { "MEDELEG", 28 },
    { "MEPC", 64 },
    { "MHARTID", 228 },
    { "MHPMCOUNTER10", 105 },
    { "MHPMCOUNTER10H", 136 },
    { "MHPMCOUNTER11", 106 },
    { "MHPMCOUNTER11H", 137 },
    { "MHPMCOUNTER12", 107 },
    { "MHPMCOUNTER12H", 138 },
    { "MHPMCOUNTER13", 108 },
    { "MHPMCOUNTER13H", 139 },
    { "MHPMCOUNTER14", 109 },
    { "MHPMCOUNTER14H", 140 },
    { "MHPMCOUNTER15", 110 },
    { "MHPMCOUNTER15H", 141 },
    { "MHPMCOUNTER16", 111 },
    { "MHPMCOUNTER16H", 142 },
    { "MHPMCOUNTER17", 112 },
    { "MHPMCOUNTER17H", 143 },
    { "MHPMCOUNTER18", 113 },
    { "MHPMCOUNTER18H", 144 },
    { "MHPMCOUNTER19", 114 },
    { "MHPMCOUNTER19H", 145 },
    { "MHPMCOUNTER20", 115 },
    { "MHPMCOUNTER20H", 146 },
    { "MHPMCOUNTER21", 116 },
    { "MHPMCOUNTER21H", 147 },
    { "MHPMCOUNTER22", 117 },
    { "MHPMCOUNTER22H", 148 },
    { "MHPMCOUNTER23", 118 },
    { "MHPMCOUNTER23H", 149 },
    { "MHPMCOUNTER24", 119 },
    { "MHPMCOUNTER24H", 150 },
    { "MHPMCOUNTER25", 120 },
    { "MHPMCOUNTER25H", 151 },
    { "MHPMCOUNTER26", 121 },
    { "MHPMCOUNTER26H", 152 },
    { "MHPMCOUNTER27", 122 },
    { "MHPMCOUNTER27H", 153 },
    { "MHPMCOUNTER28", 123 },
    { "MHPMCOUNTER28H", 154 },
    { "MHPMCOUNTER29", 124 },
    { "MHPMCOUNTER29H", 155 },
    { "MHPMCOUNTER3", 98 },
    { "MHPMCOUNTER30", 125 },
    { "MHPMCOUNTER30H", 156 },
    { "MHPMCOUNTER31", 126 },
    { "MHPMCOUNTER31H", 157 },
    { "MHPMCOUNTER3H", 129 },
    { "MHPMCOUNTER4", 99 },
    { "MHPMCOUNTER4H", 130 },
    { "MHPMCOUNTER5", 100 },
    { "MHPMCOUNTER5H", 131 },
    { "MHPMCOUNTER6", 101 },
    { "MHPMCOUNTER6H", 132 },
    { "MHPMCOUNTER7", 102 },
    { "MHPMCOUNTER7H", 133 },
    { "MHPMCOUNTER8", 103 },
    { "MHPMCOUNTER8H", 134 },
    { "MHPMCOUNTER9", 104 },
    { "MHPMCOUNTER9H", 135 },
    { "MHPMEVENT10", 41 },
    { "MHPMEVENT11", 42 },
    { "MHPMEVENT12", 43 },
    { "MHPMEVENT13", 44 },
    { "MHPMEVENT14", 45 },
    { "MHPMEVENT15", 46 },
    { "MHPMEVENT16", 47 },
    { "MHPMEVENT17", 48 },
    { "MHPMEVENT18", 49 },
    { "MHPMEVENT19", 50 },
    { "MHPMEVENT20", 51 },
    { "MHPMEVENT21", 52 },
    { "MHPMEVENT22", 53 },
    { "MHPMEVENT23", 54 },
    { "MHPMEVENT24", 55 },
    { "MHPMEVENT25", 56 },
    { "MHPMEVENT26", 57 },
    { "MHPMEVENT27", 58 },
    { "MHPMEVENT28", 59 },
    { "MHPMEVENT29", 60 },
    { "MHPMEVENT3", 34 },
    { "MHPMEVENT30", 61 },
    { "MHPMEVENT31", 62 },
    { "MHPMEVENT4", 35 },
    { "MHPMEVENT5", 36 },
    { "MHPMEVENT6", 37 },
    { "MHPMEVENT7", 38 },
    { "MHPMEVENT8", 39 },
    { "MHPMEVENT9", 40 },
    { "MIDELEG", 29 },
    { "MIE", 30 },
    { "MIMPID", 227 },
    { "MINSTRET", 97 },
    { "MINSTRETH", 128 },
    { "MIP", 67 },
    { "MISA", 27 },
    { "MSCRATCH", 63 },
    { "MSTATUS", 26 },
    { "MTVAL", 66 },
    { "MTVEC", 31 },
    { "MVENDORID", 225 },
    { "PMPADDR0", 72 },
    { "PMPADDR1", 73 },
    { "PMPADDR10", 82 },
    { "PMPADDR11", 83 },
    { "PMPADDR12", 84 },
    { "PMPADDR13", 85 },
    { "PMPADDR14", 86 },
    { "PMPADDR15", 87 },
    { "PMPADDR2", 74 },
    { "PMPADDR3", 75 },
    { "PMPADDR4", 76 },
    { "PMPADDR5", 77 },
    { "PMPADDR6", 78 },
    { "PMPADDR7", 79 },
    { "PMPADDR8", 80 },
    { "PMPADDR9", 81 },
    { "PMPCFG0", 68 },
    { "PMPCFG1", 69 },
    { "PMPCFG2", 70 },
    { "PMPCFG3", 71 },
    { "SATP", 25 },
    { "SCAUSE", 22 },
    { "SCOUNTEREN", 19 },
    { "SEDELEG", 15 },
    { "SEPC", 21 },
    { "SIDELEG", 16 },
    { "SIE", 17 },
    { "SIP", 24 },
    { "SSCRATCH", 20 },
    { "SSTATUS", 14 },
    { "STVAL", 23 },
    { "STVEC", 18 },
    { "TDATA1", 89 },
    { "TDATA2", 90 },
    { "TDATA3", 91 },
    { "TIME", 159 },
    { "TIMEH", 194 },
    { "TSELECT", 88 },
    { "UCAUSE", 11 },
    { "UEPC", 10 },
    { "UIE", 4 },
    { "UIP", 13 },
    { "USCRATCH", 9 },
    { "USTATUS", 0 },
    { "UTVAL", 12 },
    { "UTVEC", 5 },
    { "VL", 190 },
    { "VLENB", 192 },
    { "VSTART", 6 },
    { "VTYPE", 191 },
    { "VXRM", 8 },
    { "VXSAT", 7 },
  };

  struct KeyType {
    std::string Name;
  };
  KeyType Key = {Name.upper()};
  auto Table = makeArrayRef(Index);
  auto Idx = std::lower_bound(Table.begin(), Table.end(), Key,
    [](const IndexType &LHS, const KeyType &RHS) {
      int CmpName = StringRef(LHS.Name).compare(RHS.Name);
      if (CmpName < 0) return true;
      if (CmpName > 0) return false;
      return false;
    });

  if (Idx == Table.end() ||
      Key.Name != Idx->Name)
    return nullptr;
  return &SysRegsList[Idx->_index];
}
#endif

#undef GET_RISCVVIntrinsicsTable_DECL
#undef GET_RISCVVIntrinsicsTable_IMPL
#undef GET_RISCVVPseudosTable_DECL
#undef GET_RISCVVPseudosTable_IMPL
#undef GET_RISCVZvlssegTable_DECL
#undef GET_RISCVZvlssegTable_IMPL
#undef GET_SysRegsList_DECL
#undef GET_SysRegsList_IMPL
